/* 
+----------------------------------------------------------------------------- 
|  Project :  
|  Modul   :  display
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  
+----------------------------------------------------------------------------- 
History:

   Nov 24, 2006 Ref OMAPS00092906, x0039928(sumanth)
   Description : CT-GCF[34.3]-Some broadcasted charcters not dispayed correctly in MMI
   Solution     : A new font bitmap is added for Escape sequence character

    Nov 10, 2006  ER: OMAPS00099966  x0pleela
    Description : Larger Fonts in BMI required for Test Automation of application and conformance
       	         tests
    Solution     : Supporting ENDURANCE font 

    10 Jul 2006, Ref OMAPS00077654, R.Prabakar(a0393213)
    Description : Cyrillic character support in MMI to pass GCF/PTCRB  UCS2 TC (SATK)
    Solution     : As part of the implementation, cyrillic characters are added in this file


     May 12, 2006 DR: OMAPS00075405 x0035544
     Description: Cyrillic character support in MMI to pass GCF/PTCRB  UCS2 TC (SATK)
     Solution	: Provided support for Cyrillic character set(UCS2 support) from the fix 
	                given for OMAPS00062881.

 	
*********************************************************************************************** 	
*/ 

#include "stddefs.h"
#include "font_bitmaps.h"

/********************************8 BITMAP DATABASE ********************************************/




/********************************8 BITMAP DATABASE ********************************************/
/*
GW Removed duplicate chars and replaced with 'rubbish'
GW Removed chinese alphabet to chinese_bitmaps.c to prevent the chinese 
   character set being delivered when it should not be. 
MC, SPR 1434 removed CHINESE_MMI definition
GW SPR#1732 14/02/03-	Added some missing chinese characters. 
						Corrected order of some characters (4EE3 and 4EE5 )
						Changed definitions from char to unsigned char (for compilation on PC)
GW SPR#1840 25/03/03- changed conditional compilation to from COLOURDISPLAY to LSCREEN
*/

#ifndef LSCREEN
const unsigned char uc2_0000[] = { 0x00,0x00,0x00,0x00, 0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 0*/
const unsigned char uc2_0001[] = { 0x00,0x00,0x00,0x00,0x00,0x90,0x60,0x90,0x90,0x60,0x90,0x00}; /* 1*/
const unsigned char uc2_0002[] = { 0x00,0x00,0x00,0x00,0x30,0x48,0x94,0xa4,0xc4,0x48,0x30,0x00}; /* 2*/
const unsigned char uc2_0003[] = { 0x00,0x00,0x00,0x00,0x30,0x48,0x94,0xa4,0xc4,0x48,0x30,0x00}; /* 3*/
const unsigned char uc2_0004[] = { 0x00,0x00,0x00,0x00,0x00,0x20,0x50,0x50,0x88,0x88,0xf8,0x00}; /* 4*/
const unsigned char uc2_0005[] = { 0x00,0x00,0x00,0x00,0x00,0xa8,0xa8,0x70,0x20,0x20,0x20,0x00}; /* 5*/
const unsigned char uc2_0006[] = { 0x00,0x00,0x00,0x00,0x60,0x80,0x60,0x90,0x60,0x10,0x60,0x00}; /* 6*/
const unsigned char uc2_0007[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x48,0x68,0x48,0x30,0x00}; /* 7*/
const unsigned char uc2_0008[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 8*/
const unsigned char uc2_0009[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 9*/
const unsigned char uc2_000A[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}; /* 10 LF */
const unsigned char uc2_000B[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 11*/
const unsigned char uc2_000C[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 12*/
const unsigned char uc2_000D[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}; /* 13 CR */
const unsigned char uc2_000E[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 14*/
const unsigned char uc2_000F[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 15*/
const unsigned char uc2_0010[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 16*/
const unsigned char uc2_0011[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 17*/
const unsigned char uc2_0012[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 18*/
const unsigned char uc2_0013[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 19*/
const unsigned char uc2_0014[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 20*/
const unsigned char uc2_0015[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 21*/
const unsigned char uc2_0016[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 22*/
const unsigned char uc2_0017[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 23*/
const unsigned char uc2_0018[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 24*/
const unsigned char uc2_0019[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 25*/
const unsigned char uc2_001A[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 26*/
const unsigned char uc2_001B[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 27*/
const unsigned char uc2_001C[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 28*/
const unsigned char uc2_001D[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 29*/
const unsigned char uc2_001E[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 30*/
const unsigned char uc2_001F[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 31*/
const unsigned char uc2_0020[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}; /* 32*/
const unsigned char uc2_0021[] = { 0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x20,0x00,0x00,0x20,0x00}; /* 33*/
const unsigned char uc2_0022[] = { 0x00,0x00,0x00,0x00,0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00}; /* 34*/
const unsigned char uc2_0023[] = { 0x00,0x00,0x00,0x00,0x50,0x50,0xf8,0x50,0xf8,0x50,0x50,0x00}; /* 35*/
const unsigned char uc2_0024[] = { 0x00,0x00,0x00,0x00,0x20,0x78,0xa0,0x70,0x28,0xf0,0x20,0x00}; /* 36*/
const unsigned char uc2_0025[] = { 0x00,0x00,0x00,0x00,0xc0,0xc8,0x10,0x20,0x40,0x98,0x18,0x00}; /* 37*/
const unsigned char uc2_0026[] = { 0x00,0x00,0x00,0x00,0x60,0x90,0xa0,0x40,0xa8,0x90,0x68,0x00}; /* 38*/
const unsigned char uc2_0027[] = { 0x00,0x00,0x00,0x00,0x60,0x20,0x40,0x00,0x00,0x00,0x00,0x00}; /* 39*/
const unsigned char uc2_0028[] = { 0x00,0x00,0x00,0x00,0x10,0x20,0x40,0x40,0x40,0x20,0x10,0x00}; /* 40*/
const unsigned char uc2_0029[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x10,0x10,0x10,0x20,0x40,0x00}; /* 41*/
const unsigned char uc2_002A[] = { 0x00,0x00,0x00,0x00,0x00,0x20,0xa8,0x70,0xa8,0x20,0x00,0x00}; /* 42*/
const unsigned char uc2_002B[] = { 0x00,0x00,0x00,0x00,0x00,0x20,0x20,0xf8,0x20,0x20,0x00,0x00}; /* 43*/
const unsigned char uc2_002C[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x20,0x40,0x00}; /* 44*/
const unsigned char uc2_002D[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x00,0x00}; /* 45*/
const unsigned char uc2_002E[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00}; /* 46*/
const unsigned char uc2_002F[] = { 0x00,0x00,0x00,0x00,0x00,0x08,0x10,0x20,0x40,0x80,0x00,0x00}; /* 47*/
const unsigned char uc2_0030[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x98,0xa8,0xc8,0x88,0x70,0x00}; /* 48*/
const unsigned char uc2_0031[] = { 0x00,0x00,0x00,0x00,0x20,0x60,0x20,0x20,0x20,0x20,0x70,0x00}; /* 49*/
const unsigned char uc2_0032[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x08,0x10,0x20,0x40,0xf8,0x00}; /* 50*/
const unsigned char uc2_0033[] = { 0x00,0x00,0x00,0x00,0xf8,0x10,0x20,0x10,0x08,0x88,0x70,0x00}; /* 51*/
const unsigned char uc2_0034[] = { 0x00,0x00,0x00,0x00,0x10,0x30,0x50,0x90,0xf8,0x10,0x10,0x00}; /* 52*/
const unsigned char uc2_0035[] = { 0x00,0x00,0x00,0x00,0xf8,0x80,0xf0,0x08,0x08,0x88,0x70,0x00}; /* 53*/
const unsigned char uc2_0036[] = { 0x00,0x00,0x00,0x00,0x30,0x40,0x80,0xf0,0x88,0x88,0x70,0x00}; /* 54*/
const unsigned char uc2_0037[] = { 0x00,0x00,0x00,0x00,0xf8,0x08,0x10,0x20,0x40,0x40,0x40,0x00}; /* 55*/
const unsigned char uc2_0038[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x70,0x88,0x88,0x70,0x00}; /* 56*/
const unsigned char uc2_0039[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x78,0x08,0x10,0x60,0x00}; /* 57*/
const unsigned char uc2_003A[] = { 0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x60,0x00,0x00}; /* 58*/
const unsigned char uc2_003B[] = { 0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x00,0x60,0x20,0x40,0x00}; /* 59*/
const unsigned char uc2_003C[] = { 0x00,0x00,0x00,0x00,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x00}; /* 60*/
const unsigned char uc2_003D[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00,0xf8,0x00,0x00,0x00}; /* 61*/
const unsigned char uc2_003E[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x00}; /* 62*/
const unsigned char uc2_003F[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x08,0x10,0x20,0x00,0x20,0x00}; /* 63*/
const unsigned char uc2_0040[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0xb8,0xa8,0xb8,0x80,0x70,0x00}; /* 64*/
const unsigned char uc2_0041[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x88,0xf8,0x88,0x88,0x00}; /* 65*/
const unsigned char uc2_0042[] = { 0x00,0x00,0x00,0x00,0xf0,0x88,0x88,0xf0,0x88,0x88,0xf0,0x00}; /* 66*/
const unsigned char uc2_0043[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x00}; /* 67*/
const unsigned char uc2_0044[] = { 0x00,0x00,0x00,0x00,0xe0,0x90,0x88,0x88,0x88,0x90,0xe0,0x00}; /* 68*/
const unsigned char uc2_0045[] = { 0x00,0x00,0x00,0x00,0xf8,0x80,0x80,0xf0,0x80,0x80,0xf8,0x00}; /* 69*/
const unsigned char uc2_0046[] = { 0x00,0x00,0x00,0x00,0xf8,0x80,0x80,0xf0,0x80,0x80,0x80,0x00}; /* 70*/
const unsigned char uc2_0047[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x80,0xb8,0x88,0x88,0x70,0x00}; /* 71*/
const unsigned char uc2_0048[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x88,0xf8,0x88,0x88,0x88,0x00}; /* 72*/
const unsigned char uc2_0049[] = { 0x00,0x00,0x00,0x00,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00}; /* 73*/
const unsigned char uc2_004A[] = { 0x00,0x00,0x00,0x00,0x38,0x10,0x10,0x10,0x10,0x90,0x60,0x00}; /* 74*/
const unsigned char uc2_004B[] = { 0x00,0x00,0x00,0x00,0x88,0x90,0xa0,0xc0,0xa0,0x90,0x88,0x00}; /* 75*/
const unsigned char uc2_004C[] = { 0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xf8,0x00}; /* 76*/
const unsigned char uc2_004D[] = { 0x00,0x00,0x00,0x00,0x88,0xd8,0xa8,0x88,0x88,0x88,0x88,0x00}; /* 77*/
const unsigned char uc2_004E[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0xc8,0xa8,0x98,0x88,0x88,0x00}; /* 78*/
const unsigned char uc2_004F[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00}; /* 79*/
const unsigned char uc2_0050[] = { 0x00,0x00,0x00,0x00,0xf0,0x88,0x88,0xf0,0x80,0x80,0x80,0x00}; /* 80*/
const unsigned char uc2_0051[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x88,0xa8,0x90,0x68,0x00}; /* 81*/
const unsigned char uc2_0052[] = { 0x00,0x00,0x00,0x00,0xf0,0x88,0x88,0xf0,0xa0,0x90,0x88,0x00}; /* 82*/
const unsigned char uc2_0053[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x80,0x70,0x08,0x88,0x70,0x00}; /* 83*/
const unsigned char uc2_0054[] = { 0x00,0x00,0x00,0x00,0xf8,0x20,0x20,0x20,0x20,0x20,0x20,0x00}; /* 84*/
const unsigned char uc2_0055[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00}; /* 85*/
const unsigned char uc2_0056[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x88,0x88,0x88,0x50,0x20,0x00}; /* 86*/
const unsigned char uc2_0057[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x88,0xa8,0xa8,0xa8,0x50,0x00}; /* 87*/
const unsigned char uc2_0058[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00}; /* 88*/
const unsigned char uc2_0059[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x00}; /* 89*/
const unsigned char uc2_005A[] = { 0x00,0x00,0x00,0x00,0xf8,0x08,0x10,0x20,0x40,0x80,0xf8,0x00}; /* 90*/
const unsigned char uc2_005B[] = { 0x00,0x00,0x00,0x00,0x70,0x40,0x40,0x40,0x40,0x40,0x70,0x00}; /* 91*/
const unsigned char uc2_005C[] = { 0x00,0x00,0x00,0x00,0x00,0x80,0x40,0x20,0x10,0x08,0x00,0x00}; /* 92*/
const unsigned char uc2_005D[] = { 0x00,0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x70,0x00}; /* 93*/
const unsigned char uc2_005E[] = { 0x00,0x00,0x00,0x00,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00}; /* 94*/
const unsigned char uc2_005F[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x00}; /* 95*/
const unsigned char uc2_0060[] = { 0x00,0x00,0x00,0x00,0x30,0x20,0x10,0x00,0x00,0x00,0x00,0x00}; /* 96*/
const unsigned char uc2_0061[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x08,0x78,0x88,0x78,0x00}; /* 97*/
const unsigned char uc2_0062[] = { 0x00,0x00,0x00,0x00,0x80,0x80,0xf0,0x88,0x88,0x88,0xf0,0x00}; /* 98*/
const unsigned char uc2_0063[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x80,0x80,0x80,0x78,0x00}; /* 99*/
const unsigned char uc2_0064[] = { 0x00,0x00,0x00,0x00,0x08,0x08,0x78,0x88,0x88,0x88,0x78,0x00}; /* 100*/
const unsigned char uc2_0065[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x88,0xf8,0x80,0x70,0x00}; /* 101*/
const unsigned char uc2_0066[] = { 0x00,0x00,0x00,0x00,0x30,0x40,0x40,0xf0,0x40,0x40,0x40,0x00}; /* 102*/
const unsigned char uc2_0067[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x88,0x78,0x08,0x70,0x00}; /* 103*/
const unsigned char uc2_0068[] = { 0x00,0x00,0x00,0x00,0x80,0x80,0xb0,0xc8,0x88,0x88,0x88,0x00}; /* 104*/
const unsigned char uc2_0069[] = { 0x00,0x00,0x00,0x00,0x20,0x00,0x60,0x20,0x20,0x20,0x70,0x00}; /* 105*/
const unsigned char uc2_006A[] = { 0x00,0x00,0x00,0x00,0x10,0x00,0x30,0x10,0x10,0x90,0x60,0x00}; /* 106*/
const unsigned char uc2_006B[] = { 0x00,0x00,0x00,0x00,0x80,0x80,0x90,0xa0,0xc0,0xa0,0x90,0x00}; /* 107*/
const unsigned char uc2_006C[] = { 0x00,0x00,0x00,0x00,0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00}; /* 108*/
const unsigned char uc2_006D[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xd0,0xa8,0xa8,0xa8,0xa8,0x00}; /* 109*/
const unsigned char uc2_006E[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xb0,0xc8,0x88,0x88,0x88,0x00}; /* 110*/
const unsigned char uc2_006F[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x70,0x00}; /* 111*/
const unsigned char uc2_0070[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0x88,0xf0,0x80,0x80,0x00}; /* 112*/
const unsigned char uc2_0071[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x88,0x78,0x08,0x08,0x00}; /* 113*/
const unsigned char uc2_0072[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xb0,0xc0,0x80,0x80,0x80,0x00}; /* 114*/
const unsigned char uc2_0073[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x80,0x70,0x08,0xf0,0x00}; /* 115*/
const unsigned char uc2_0074[] = { 0x00,0x00,0x00,0x00,0x40,0x40,0xf0,0x40,0x40,0x40,0x30,0x00}; /* 116*/
const unsigned char uc2_0075[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x88,0x88,0x88,0x98,0x68,0x00}; /* 117*/
const unsigned char uc2_0076[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x88,0x88,0x88,0x50,0x20,0x00}; /* 118*/
const unsigned char uc2_0077[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x88,0x88,0xa8,0xa8,0x50,0x00}; /* 119*/
const unsigned char uc2_0078[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x88,0x50,0x20,0x50,0x88,0x00}; /* 120*/
const unsigned char uc2_0079[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x88,0x88,0x78,0x08,0x70,0x00}; /* 121*/
const unsigned char uc2_007A[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x10,0x20,0x40,0xf8,0x00}; /* 122*/
const unsigned char uc2_007B[] = { 0x00,0x00,0x00,0x00,0x30,0x40,0x40,0x80,0x40,0x40,0x30,0x00}; /* 123*/
const unsigned char uc2_007C[] = { 0x00,0x00,0x00,0x00,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00}; /* 124*/
const unsigned char uc2_007D[] = { 0x00,0x00,0x00,0x00,0x60,0x10,0x10,0x08,0x10,0x10,0x60,0x00}; /* 125*/
const unsigned char uc2_007E[] = { 0x00,0x00,0x00,0x00,0x40,0xa8,0x10,0x00,0x00,0x00,0x00,0x00}; /* 126*/
const unsigned char uc2_007F[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 127*/
const unsigned char uc2_0080[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x40}; /* 128*/
const unsigned char uc2_0081[] = { 0x00,0x00,0x00,0x00,0x00,0x50,0x00,0x88,0x88,0x88,0x78,0x00}; /* 129*/
const unsigned char uc2_0082[] = { 0x00,0x00,0x00,0x00,0x00,0x10,0x70,0x88,0xf8,0x80,0x70,0x00}; /* 130*/
const unsigned char uc2_0083[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 131*/
const unsigned char uc2_0084[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x70,0x08,0x78,0x88,0x78,0x00}; /* 132*/
const unsigned char uc2_0085[] = { 0x00,0x00,0x00,0x00,0x00,0x40,0x70,0x08,0x78,0x88,0x78,0x00}; /* 133*/
const unsigned char uc2_0086[] = { 0x00,0x00,0x00,0x00,0x30,0x30,0x70,0x08,0x78,0x88,0x78,0x00}; /* 134*/
const unsigned char uc2_0087[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 135*/
const unsigned char uc2_0088[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 136*/
const unsigned char uc2_0089[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 137*/
const unsigned char uc2_008A[] = { 0x00,0x00,0x00,0x00,0x00,0x40,0x70,0x88,0xf8,0x80,0x70,0x00}; /* 138*/
const unsigned char uc2_008B[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 139*/
const unsigned char uc2_008C[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 140*/
const unsigned char uc2_008D[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x00,0x60,0x20,0x20,0x70,0x00}; /* 141*/
const unsigned char uc2_008E[] = { 0x00,0x00,0x00,0x00,0x88,0x70,0x88,0x88,0xf8,0x88,0x88,0x00}; /* 142*/
const unsigned char uc2_008F[] = { 0x00,0x00,0x00,0x00,0x20,0x70,0xa8,0x88,0xf8,0x88,0x88,0x00}; /* 143*/
const unsigned char uc2_0090[] = { 0x00,0x00,0x00,0x00,0x10,0xf8,0x80,0xf0,0x80,0x80,0xf8,0x00}; /* 144 E with dot*/
const unsigned char uc2_0091[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xa0,0xf0,0xa0,0xb8,0x00}; /* 145*/
const unsigned char uc2_0092[] = { 0x00,0x00,0x00,0x00,0x78,0xa0,0xa0,0xf0,0xa0,0xa0,0xb8,0x00}; /* 146*/
const unsigned char uc2_0093[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 147*/
const unsigned char uc2_0094[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x70,0x88,0x88,0x88,0x70,0x00}; /* 148*/
const unsigned char uc2_0095[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x70,0x88,0x88,0x88,0x70,0x00}; /* 149*/
const unsigned char uc2_0096[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 150*/
const unsigned char uc2_0097[] = { 0x00,0x00,0x00,0x00,0x20,0x10,0x88,0x88,0x88,0x98,0x68,0x00}; /* 151*/
const unsigned char uc2_0098[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 152*/
const unsigned char uc2_0099[] = { 0x00,0x00,0x00,0x00,0x88,0x70,0x88,0x88,0x88,0x88,0x70,0x00}; /* 153*/
const unsigned char uc2_009A[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x88,0x88,0x88,0x88,0x70,0x00}; /* 154*/
const unsigned char uc2_009B[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 155*/
const unsigned char uc2_009C[] = { 0x00,0x00,0x00,0x00,0x30,0x48,0x40,0xE0,0x40,0x40,0xf8,0x00}; /* 156 */ //sbh - was backwards!
const unsigned char uc2_009D[] = { 0x00,0x00,0x00,0x00,0x88,0x50,0x20,0x70,0x20,0x70,0x20,0x00}; /* 157*/
const unsigned char uc2_009E[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 158*/
const unsigned char uc2_009F[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 159*/
const unsigned char uc2_00A0[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 160*/
const unsigned char uc2_00A1[] = { 0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x20,0x20,0x20,0x20,0x00}; /* 161*/ 
const unsigned char uc2_00A2[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 162*/
const unsigned char uc2_00A3[] = { 0x00,0x00,0x00,0x00,0x30,0x48,0x40,0xE0,0x40,0x40,0xF8,0x00}; /* 163*/ 
const unsigned char uc2_00A4[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0xA8,0x50,0x88,0x50,0xA8,0x00}; /* 164*/
const unsigned char uc2_00A5[] = { 0x00,0x00,0x00,0x00,0x88,0x88,0x50,0xF8,0x20,0xF8,0x20,0x00}; /* 165*/
const unsigned char uc2_00A6[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 166*/
const unsigned char uc2_00A7[] = { 0x00,0x00,0x00,0x00,0x78,0x80,0x70,0x88,0x70,0x08,0xf0,0x00}; /* 167*/ 
const unsigned char uc2_00A8[] = { 0x00,0x00,0x00,0x00,0x10,0x00,0x10,0x70,0x80,0x80,0x70,0x00}; /* 168*/
const unsigned char uc2_00A9[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 169*/
const unsigned char uc2_00AA[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 170*/
const unsigned char uc2_00AB[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 171*/
const unsigned char uc2_00AC[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 172*/
const unsigned char uc2_00AD[] = { 0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x00}; /* 173*/
const unsigned char uc2_00AE[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 174*/
const unsigned char uc2_00AF[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 175*/
const unsigned char uc2_00B0[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 176*/
const unsigned char uc2_00B1[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 177*/
const unsigned char uc2_00B2[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 178*/
const unsigned char uc2_00B3[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 179*/
const unsigned char uc2_00B4[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 180*/
const unsigned char uc2_00B5[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 181*/
const unsigned char uc2_00B6[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 182*/
const unsigned char uc2_00B7[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 183*/
const unsigned char uc2_00B8[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 184*/
const unsigned char uc2_00B9[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 185*/
const unsigned char uc2_00BA[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 186*/
const unsigned char uc2_00BB[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 187*/
const unsigned char uc2_00BC[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 188*/
const unsigned char uc2_00BD[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 189*/
const unsigned char uc2_00BE[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 190*/
const unsigned char uc2_00BF[] = { 0x00,0x00,0x00,0x00,0x20,0x00,0x20,0x40,0x80,0x88,0x70,0x00}; /* 191*/ 
const unsigned char uc2_00C0[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 192*/
const unsigned char uc2_00C1[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 193*/
const unsigned char uc2_00C2[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 194*/
const unsigned char uc2_00C3[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 195*/
const unsigned char uc2_00C4[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x70,0x88,0xf8,0x88,0x88,0x00}; /* 196*/ 
const unsigned char uc2_00C5[] = { 0x00,0x00,0x00,0x00,0x20,0x00,0x70,0x88,0xf8,0x88,0x88,0x00}; /* 197*/ 
const unsigned char uc2_00C6[] = { 0x00,0x00,0x00,0x00,0x78,0xA0,0xA0,0xB8,0xE0,0xA0,0xB8,0x00}; /* 198*/ 
const unsigned char uc2_00C7[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x80,0x80,0x88,0x70,0x20,0x00}; /* 199*/ 
const unsigned char uc2_00C8[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 200*/
const unsigned char uc2_00C9[] = { 0x00,0x00,0x00,0x00,0x10,0x20,0xf8,0x80,0xf0,0x80,0xf8,0x00}; /* 201*/ 
const unsigned char uc2_00CA[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 202*/
const unsigned char uc2_00CB[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 203*/
const unsigned char uc2_00CC[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 204*/
const unsigned char uc2_00CD[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 205*/
const unsigned char uc2_00CE[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 206*/
const unsigned char uc2_00CF[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 207*/
const unsigned char uc2_00D0[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 208*/
const unsigned char uc2_00D1[] = { 0x00,0x00,0x00,0x00,0x70,0x00,0x88,0xC8,0xA8,0x98,0x88,0x00}; /* 209*/ 
const unsigned char uc2_00D2[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 210*/
const unsigned char uc2_00D3[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 211*/
const unsigned char uc2_00D4[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 212*/
const unsigned char uc2_00D5[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 213*/
const unsigned char uc2_00D6[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x70,0x88,0x88,0x88,0x70,0x00}; /* 214*/ 
const unsigned char uc2_00D7[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 215*/
const unsigned char uc2_00D8[] = { 0x00,0x00,0x00,0x00,0x28,0x50,0x98,0xA8,0xC8,0x50,0xA0,0x00}; /* 216*/ 
const unsigned char uc2_00D9[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 217*/
const unsigned char uc2_00DA[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 218*/
const unsigned char uc2_00DB[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 219*/
const unsigned char uc2_00DC[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x88,0x88,0x88,0x88,0x70,0x00}; /* 220*/ 
const unsigned char uc2_00DD[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 221*/
const unsigned char uc2_00DE[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 222*/
const unsigned char uc2_00DF[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0xf0,0x88,0x88,0xB0,0x00}; /* 223*/
const unsigned char uc2_00E0[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x70,0x08,0x78,0x88,0x78,0x00}; /* 224*/
const unsigned char uc2_00E1[] = { 0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x90,0x88,0x88,0x90,0x80}; /*  225 ss*/
const unsigned char uc2_00E2[] = { 0x00,0x00,0x00,0x00,0x00,0xf0,0x80,0x80,0x80,0x80,0x80,0x00}; /* 226*/
const unsigned char uc2_00E3[] = { 0x00,0x00,0x00,0x00,0x00,0xf0,0x90,0x90,0x90,0x90,0x90,0x00}; /* 227*/
const unsigned char uc2_00E4[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x70,0x08,0x78,0x88,0x78,0x00}; /* 228*/
const unsigned char uc2_00E5[] = { 0x00,0x00,0x00,0x00,0x20,0x00,0x70,0x08,0x78,0x88,0x78,0x00}; /* 229*/
const unsigned char uc2_00E6[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x70,0xA8,0xB8,0xA0,0x70,0x00}; /* 230*/
const unsigned char uc2_00E7[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 231*/
const unsigned char uc2_00E8[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x70,0x88,0xf8,0x80,0x70,0x00}; /* 232*/
const unsigned char uc2_00E9[] = { 0x00,0x00,0x00,0x00,0x10,0x20,0x70,0x88,0xf8,0x80,0x70,0x00}; /* 233*/
const unsigned char uc2_00EA[] = { 0x00,0x00,0x00,0x00,0x00,0x70,0x88,0x88,0x88,0x50,0xd8,0x00}; /* 234*/
const unsigned char uc2_00EB[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 235*/
const unsigned char uc2_00EC[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x00,0x60,0x20,0x20,0x70,0x00}; /* 236*/
const unsigned char uc2_00ED[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 237*/
const unsigned char uc2_00EE[] = { 0x00,0x00,0x00,0x00,0x00,0x20,0x50,0x50,0x88,0x88,0x88,0x00}; /* 238*/
const unsigned char uc2_00EF[] = { 0x00,0x00,0x00,0x00,0x00,0x20,0x50,0x50,0x88,0x88,0x88,0x00}; /* 239*/
const unsigned char uc2_00F0[] = { 0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x70,0x00,0x00,0xf8,0x00}; /* 240*/
const unsigned char uc2_00F1[] = { 0x00,0x00,0x00,0x00,0x70,0x00,0xb0,0xc8,0x88,0x88,0x88,0x00}; /* 241*/
const unsigned char uc2_00F2[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x70,0x88,0x88,0x88,0x70,0x00}; /* 242*/
const unsigned char uc2_00F3[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 243*/
const unsigned char uc2_00F4[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 244*/
const unsigned char uc2_00F5[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 245*/
const unsigned char uc2_00F6[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x70,0x88,0x88,0x88,0x70,0x00}; /* 246*/
const unsigned char uc2_00F7[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 247*/
const unsigned char uc2_00F8[] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x28,0x50,0xA8,0x50,0xA0,0x00}; /* 248*/
const unsigned char uc2_00F9[] = { 0x00,0x00,0x00,0x00,0x40,0x20,0x88,0x88,0x88,0x98,0x68,0x00}; /* 249*/
const unsigned char uc2_00FA[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 250*/
const unsigned char uc2_00FB[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 251*/
const unsigned char uc2_00FC[] = { 0x00,0x00,0x00,0x00,0x50,0x00,0x88,0x88,0x88,0x98,0x68,0x00}; /* 252*/
const unsigned char uc2_00FD[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 253*/
const unsigned char uc2_00FE[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 254*/
const unsigned char uc2_00FF[] = { 0x00,0x00,0x00,0x00,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0xf8,0x00}; /* 255*/

#endif
const unsigned char uc2_rubbish[] = {0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0};


/* Marcus: 2002/12/12: Start: Adding Greek characters */
const unsigned char uc2_0393[]  = { 0x00,0x00,0x00,0x00,0xF8,0x80,0x80,0x80,0x80,0x80,0x80,0x00}; /* Gamma */
const unsigned char uc2_0394[]  = { 0x00,0x00,0x00,0x00,0x20,0x20,0x50,0x50,0x88,0x88,0xf8,0x00}; /* Delta */
const unsigned char uc2_0398[]  = { 0x00,0x00,0x00,0x00,0x20,0x50,0x88,0xA8,0x88,0x50,0x20,0x00}; /* Theta */
const unsigned char uc2_039B[]  = { 0x00,0x00,0x00,0x00,0x20,0x20,0x70,0x50,0xE8,0x88,0x88,0x00}; /* Lambda */
const unsigned char uc2_039E[]  = { 0x00,0x00,0x00,0x00,0xf8,0x00,0x00,0x70,0x00,0x00,0xf8,0x00}; /* Xi */
const unsigned char uc2_03A0[]  = { 0x00,0x00,0x00,0x00,0xF8,0x88,0x88,0x88,0x88,0x88,0x88,0x00}; /* Pi */
const unsigned char uc2_03A3[]  = { 0x00,0x00,0x00,0x00,0xF8,0x40,0x20,0x10,0x20,0x40,0xF8,0x00}; /* Sigma */
const unsigned char uc2_03A6[]  = { 0x00,0x00,0x00,0x00,0x20,0x70,0xA8,0xA8,0xA8,0x70,0x20,0x00}; /* Phi */
const unsigned char uc2_03A8[]  = { 0x00,0x00,0x00,0x00,0x00,0xa8,0xa8,0x70,0x20,0x20,0x20,0x00}; /* Psi */
const unsigned char uc2_03A9[]  = { 0x00,0x00,0x00,0x00,0x20,0x50,0x88,0x88,0x88,0x50,0x88,0x00}; /* Omega */
/* Marcus: 2002/12/12: End: Adding Greek characters */

#ifdef CHINESE_MMI

const unsigned char  uc2_4E00 [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }; /*4E00*/
const unsigned char  uc2_4E01 [] = {0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4E01*/
const unsigned char  uc2_4E03 [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x07, 0xF0, 0x7C, 0x00, 0x04, 0x00, 0x04, 0x20, 0x04, 0x20, 0x04, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*4E03*/
const unsigned char  uc2_4E07 [] = {0x7F, 0xF0, 0x08, 0x00, 0x08, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x10, 0x40, 0x10, 0x40, 0x20, 0x80, 0x47, 0x00, 0x00, 0x00 }; /*4E07*/
const unsigned char  uc2_4E08 [] = {0x01, 0x00, 0x01, 0x00, 0x7F, 0xE0, 0x01, 0x00, 0x11, 0x00, 0x12, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x11, 0x80, 0x60, 0x70, 0x00, 0x00 }; /*4E08*/
const unsigned char  uc2_4E09 [] = {0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*4E09*/
const unsigned char  uc2_4E0A [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x03, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E0A*/
const unsigned char  uc2_4E0B [] = {0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x03, 0x80, 0x02, 0x40, 0x02, 0x20, 0x02, 0x20, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E0B*/
const unsigned char  uc2_4E0C [] = {0x3F, 0xF0, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*4E0C*/
const unsigned char  uc2_4E0D [] = {0x7F, 0xF0, 0x01, 0x00, 0x02, 0x00, 0x06, 0xC0, 0x0A, 0x20, 0x12, 0x10, 0x62, 0x10, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E0D*/
const unsigned char  uc2_4E0E [] = {0x08, 0x00, 0x0F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x00, 0x20, 0x7F, 0xA0, 0x00, 0x20, 0x00, 0x40, 0x07, 0x80, 0x00, 0x00 }; /*4E0E*/
const unsigned char  uc2_4E10 [] = {0x7F, 0xF0, 0x02, 0x00, 0x12, 0x00, 0x13, 0xE0, 0x22, 0x00, 0x22, 0x00, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x07, 0xC0, 0x00, 0x00 }; /*4E10*/
const unsigned char  uc2_4E11 [] = {0x3F, 0xE0, 0x04, 0x20, 0x04, 0x20, 0x04, 0x20, 0x04, 0x20, 0x3F, 0xC0, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*4E11*/
const unsigned char  uc2_4E13 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x0F, 0xC0, 0x00, 0x40, 0x0D, 0x80, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*4E13*/
const unsigned char  uc2_4E14 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*4E14*/
const unsigned char  uc2_4E15 [] = {0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x06, 0xC0, 0x1A, 0x20, 0x62, 0x10, 0x02, 0x10, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E15*/
const unsigned char  uc2_4E16 [] = {0x02, 0x40, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x13, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*4E16*/
const unsigned char  uc2_4E18 [] = {0x00, 0xE0, 0x1F, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E18*/
const unsigned char  uc2_4E19 [] = {0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x25, 0x20, 0x24, 0xA0, 0x38, 0xA0, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*4E19*/
const unsigned char  uc2_4E1A [] = {0x05, 0x00, 0x05, 0x00, 0x05, 0x00, 0x45, 0x20, 0x25, 0x20, 0x25, 0x40, 0x15, 0x40, 0x15, 0x80, 0x05, 0x00, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E1A*/
const unsigned char  uc2_4E1B [] = {0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x28, 0x80, 0x25, 0x40, 0x25, 0x40, 0x42, 0x20, 0x0C, 0x10, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E1B*/
const unsigned char  uc2_4E1C [] = {0x04, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x12, 0x00, 0x22, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x22, 0x40, 0x22, 0x20, 0x42, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*4E1C*/
const unsigned char  uc2_4E1D [] = {0x10, 0x80, 0x10, 0x80, 0x14, 0xA0, 0x25, 0x20, 0x39, 0xC0, 0x10, 0x80, 0x21, 0x00, 0x3D, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E1D*/
const unsigned char  uc2_4E1E [] = {0x1F, 0x80, 0x00, 0x80, 0x01, 0x20, 0x3A, 0x20, 0x0B, 0x40, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E1E*/
const unsigned char  uc2_4E22 [] = {0x01, 0xE0, 0x3E, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x04, 0x80, 0x08, 0x40, 0x11, 0xE0, 0x1E, 0x20, 0x00, 0x00 }; /*4E22*/
const unsigned char  uc2_4E24 [] = {0x7F, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x2B, 0xA0, 0x29, 0x60, 0x32, 0x20, 0x24, 0x20, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*4E24*/
const unsigned char  uc2_4E25 [] = {0x3F, 0xF0, 0x12, 0x90, 0x0A, 0x90, 0x0A, 0xA0, 0x3F, 0xF0, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*4E25*/
const unsigned char  uc2_4E27 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x12, 0x80, 0x11, 0x00, 0x14, 0xC0, 0x18, 0x30, 0x00, 0x00 }; /*4E27*/
const unsigned char  uc2_4E2A [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E2A*/
const unsigned char  uc2_4E2B [] = {0x10, 0x20, 0x08, 0x20, 0x04, 0x40, 0x04, 0x80, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E2B*/
const unsigned char  uc2_4E2D [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E2D*/
const unsigned char  uc2_4E30 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E30*/
const unsigned char  uc2_4E32 [] = {0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E32*/
const unsigned char  uc2_4E34 [] = {0x12, 0x00, 0x13, 0xF0, 0x52, 0x80, 0x54, 0x40, 0x50, 0x40, 0x50, 0x00, 0x57, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*4E34*/
const unsigned char  uc2_4E36 [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x06, 0x00, 0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00 }; /*4E36*//*SPR 1299*/
const unsigned char  uc2_4E38 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x02, 0x40, 0x1A, 0x40, 0x06, 0x40, 0x02, 0x40, 0x05, 0x50, 0x05, 0x50, 0x08, 0x50, 0x70, 0x70, 0x00, 0x00 }; /*4E38*/
const unsigned char  uc2_4E39 [] = {0x1F, 0xC0, 0x10, 0x40, 0x14, 0x40, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x20, 0x40, 0x43, 0x80, 0x00, 0x00 }; /*4E39*/
const unsigned char  uc2_4E3A [] = {0x12, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x3F, 0xF0, 0x02, 0x10, 0x02, 0x90, 0x02, 0x50, 0x04, 0x50, 0x04, 0x10, 0x08, 0x10, 0x70, 0x60, 0x00, 0x00 }; /*4E3A*/
const unsigned char  uc2_4E3B [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E3B*/
const unsigned char  uc2_4E3D [] = {0x7F, 0xF0, 0x00, 0x00, 0x3D, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x35, 0xA0, 0x2D, 0x60, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x29, 0x40, 0x00, 0x00 }; /*4E3D*/
const unsigned char  uc2_4E3E [] = {0x24, 0x20, 0x12, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4E3E*/
const unsigned char  uc2_4E3F [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x06, 0x00, 0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x18, 0x00, 0x00, 0x00 }; /*4E3E*//*SPR 1299*/
const unsigned char  uc2_4E43 [] = {0x3F, 0xC0, 0x04, 0x40, 0x04, 0x80, 0x05, 0x00, 0x05, 0xF0, 0x04, 0x10, 0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0x10, 0x20, 0x61, 0xC0, 0x00, 0x00 }; /*4E43*/
const unsigned char  uc2_4E45 [] = {0x08, 0x00, 0x08, 0x00, 0x0F, 0x80, 0x10, 0x80, 0x11, 0x00, 0x21, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*4E45*/
const unsigned char  uc2_4E47 [] = {0x01, 0xE0, 0x3E, 0x00, 0x02, 0x00, 0x02, 0x00, 0x03, 0xF0, 0x7E, 0x00, 0x02, 0x00, 0x02, 0x10, 0x02, 0x10, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*4E47*/
const unsigned char  uc2_4E48 [] = {0x02, 0x00, 0x02, 0x40, 0x04, 0x40, 0x08, 0x80, 0x30, 0x80, 0x01, 0x00, 0x02, 0x40, 0x04, 0x20, 0x08, 0x60, 0x0F, 0x90, 0x00, 0x10, 0x00, 0x00 }; /*4E48*/
const unsigned char  uc2_4E49 [] = {0x04, 0x00, 0x12, 0x40, 0x12, 0x40, 0x08, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*4E49*/
const unsigned char  uc2_4E4B [] = {0x04, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x30, 0x00, 0x4E, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*4E4B*/
const unsigned char  uc2_4E4C [] = {0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x13, 0x80, 0x10, 0x00, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0xD0, 0x00, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*4E4C*/
const unsigned char  uc2_4E4D [] = {0x08, 0x00, 0x08, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x24, 0x00, 0x47, 0xC0, 0x04, 0x00, 0x07, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*4E4D*/
const unsigned char  uc2_4E4E [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x40, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4E4E*/
const unsigned char  uc2_4E4F [] = {0x01, 0xE0, 0x7E, 0x00, 0x04, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x01, 0x80, 0x02, 0x00, 0x1C, 0x00, 0x23, 0x00, 0x40, 0xF0, 0x00, 0x00 }; /*4E4F*/
const unsigned char  uc2_4E50 [] = {0x00, 0xE0, 0x1F, 0x00, 0x10, 0x00, 0x11, 0x00, 0x21, 0x00, 0x3F, 0xF0, 0x01, 0x00, 0x11, 0x20, 0x11, 0x10, 0x61, 0x10, 0x06, 0x00, 0x00, 0x00 }; /*4E50*/
const unsigned char  uc2_4E52 [] = {0x01, 0xC0, 0x1E, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x18, 0x00, 0x60, 0x00, 0x00, 0x00 }; /*4E52*/
const unsigned char  uc2_4E53 [] = {0x01, 0xC0, 0x1E, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x7F, 0xF0, 0x00, 0x40, 0x00, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*4E53*/
const unsigned char  uc2_4E54 [] = {0x01, 0xC0, 0x3E, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*4E54*/
const unsigned char  uc2_4E56 [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0A, 0x90, 0x7A, 0xE0, 0x0A, 0x90, 0x1A, 0x90, 0x6A, 0x60, 0x02, 0x00, 0x00, 0x00 }; /*4E56*/
const unsigned char  uc2_4E58 [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x90, 0x7A, 0xE0, 0x1A, 0x90, 0x6A, 0x60, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x00, 0x00 }; /*4E58*/
const unsigned char  uc2_4E59 [] = {0x7F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x03, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x3F, 0xE0, 0x00, 0x00 }; /*4E59*/
const unsigned char  uc2_4E5C [] = {0x10, 0x00, 0x10, 0x00, 0x10, 0xE0, 0x13, 0x20, 0x1C, 0x20, 0x70, 0x20, 0x11, 0xC0, 0x10, 0x00, 0x10, 0x10, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*4E5C*/
const unsigned char  uc2_4E5D [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x08, 0x90, 0x08, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*4E5D*/
const unsigned char  uc2_4E5E [] = {0x08, 0x00, 0x0F, 0xF0, 0x10, 0x00, 0x60, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x01, 0x80, 0x06, 0x10, 0x08, 0x10, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*4E5E*/
const unsigned char  uc2_4E5F [] = {0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x40, 0x1E, 0x40, 0x72, 0x40, 0x12, 0x80, 0x12, 0x10, 0x10, 0x10, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*4E5F*/
const unsigned char  uc2_4E60 [] = {0x3F, 0xF0, 0x00, 0x10, 0x04, 0x10, 0x02, 0x10, 0x02, 0x10, 0x00, 0x50, 0x01, 0x90, 0x06, 0x10, 0x38, 0x10, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*4E60*/
const unsigned char  uc2_4E61 [] = {0x01, 0x00, 0x02, 0x00, 0x04, 0x80, 0x07, 0x20, 0x02, 0x20, 0x04, 0xC0, 0x07, 0x40, 0x00, 0x80, 0x01, 0x00, 0x06, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*4E61*/
const unsigned char  uc2_4E66 [] = {0x04, 0xC0, 0x04, 0x20, 0x3F, 0xC0, 0x04, 0x40, 0x04, 0x80, 0x7F, 0xF0, 0x04, 0x10, 0x04, 0x10, 0x04, 0xE0, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*4E66*/
const unsigned char  uc2_4E69 [] = {0x10, 0x80, 0x10, 0x80, 0x1E, 0x80, 0x10, 0x80, 0x10, 0x80, 0x7E, 0x80, 0x42, 0x80, 0x42, 0x90, 0x42, 0x90, 0x7E, 0x90, 0x42, 0x60, 0x00, 0x00 }; /*4E69*/
const unsigned char  uc2_4E70 [] = {0x3F, 0xF0, 0x00, 0x10, 0x19, 0x20, 0x05, 0x00, 0x31, 0x00, 0x09, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x02, 0xC0, 0x0C, 0x20, 0x70, 0x10, 0x00, 0x00 }; /*4E70*/
const unsigned char  uc2_4E71 [] = {0x06, 0x80, 0x38, 0x80, 0x08, 0x80, 0x7F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x3E, 0x80, 0x22, 0x90, 0x22, 0x90, 0x3E, 0x90, 0x22, 0x60, 0x00, 0x00 }; /*4E71*/
const unsigned char  uc2_4E73 [] = {0x06, 0x80, 0x7C, 0x80, 0x54, 0x80, 0x28, 0x80, 0x7C, 0x80, 0x04, 0x80, 0x08, 0x80, 0x0F, 0x90, 0x78, 0x90, 0x08, 0x90, 0x30, 0x60, 0x00, 0x00 }; /*4E73*/
const unsigned char  uc2_4E7E [] = {0x08, 0x80, 0x3E, 0xF0, 0x08, 0x80, 0x3F, 0x00, 0x22, 0xE0, 0x3E, 0x20, 0x22, 0x40, 0x3E, 0x80, 0x09, 0x10, 0x7F, 0x10, 0x08, 0xE0, 0x00, 0x00 }; /*4E7E*/
const unsigned char  uc2_4E86 [] = {0x1F, 0xE0, 0x00, 0x20, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*4E86*/
const unsigned char  uc2_4E88 [] = {0x0F, 0xC0, 0x00, 0x40, 0x06, 0x80, 0x01, 0x00, 0x3F, 0xF0, 0x01, 0x10, 0x01, 0x20, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*4E88*/
const unsigned char  uc2_4E89 [] = {0x10, 0x00, 0x1F, 0x80, 0x60, 0x80, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xF0, 0x02, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4E89*/
const unsigned char  uc2_4E8B [] = {0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xF0, 0x02, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4E8B*/
const unsigned char  uc2_4E8C [] = {0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*4E8C*/
const unsigned char  uc2_4E8D [] = {0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4E8D*/
const unsigned char  uc2_4E8E [] = {0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4E8E*/
const unsigned char  uc2_4E8F [] = {0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x10, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x00, 0x80, 0x07, 0x00, 0x00, 0x00 }; /*4E8F*/
const unsigned char  uc2_4E91 [] = {0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x08, 0x80, 0x10, 0x40, 0x23, 0xC0, 0x3C, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*4E91*/
const unsigned char  uc2_4E92 [] = {0x3F, 0xE0, 0x04, 0x00, 0x04, 0x00, 0x07, 0x80, 0x08, 0x80, 0x08, 0x80, 0x11, 0x00, 0x1F, 0x00, 0x01, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E92*/
const unsigned char  uc2_4E93 [] = {0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*4E93*/
const unsigned char  uc2_4E94 [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x04, 0x40, 0x04, 0x40, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*4E94*/
const unsigned char  uc2_4E95 [] = {0x08, 0x80, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*4E95*/
const unsigned char  uc2_4E98 [] = {0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E98*/
const unsigned char  uc2_4E9A [] = {0x00, 0x00, 0x3F, 0xE0, 0x05, 0x00, 0x45, 0x10, 0x25, 0x10, 0x25, 0x20, 0x15, 0x20, 0x15, 0x40, 0x05, 0x00, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E9A*/
const unsigned char  uc2_4E9B [] = {0x08, 0x80, 0x28, 0xA0, 0x2E, 0xC0, 0x28, 0x80, 0x28, 0x90, 0x2E, 0x90, 0x70, 0x60, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E9B*/
const unsigned char  uc2_4E9F [] = {0x1F, 0x80, 0x00, 0x80, 0x01, 0xF0, 0x3A, 0x10, 0x2A, 0xD0, 0x2A, 0x20, 0x3A, 0x50, 0x03, 0x90, 0x0C, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4E9F*/
const unsigned char  uc2_4EA1 [] = {0x06, 0x00, 0x01, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x0F, 0xE0, 0x00, 0x00 }; /*4EA1*/
const unsigned char  uc2_4EA2 [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*4EA2*/
const unsigned char  uc2_4EA4 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x68, 0xA0, 0x08, 0xA0, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*4EA4*/
const unsigned char  uc2_4EA5 [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x08, 0x80, 0x0F, 0x00, 0x02, 0x40, 0x0C, 0x80, 0x31, 0x40, 0x06, 0x20, 0x78, 0x20, 0x00, 0x00 }; /*4EA5*/
const unsigned char  uc2_4EA6 [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x04, 0x80, 0x14, 0x80, 0x14, 0xA0, 0x24, 0x90, 0x44, 0x90, 0x08, 0x90, 0x08, 0x80, 0x33, 0x00, 0x00, 0x00 }; /*4EA6*/
const unsigned char  uc2_4EA7 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x05, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*4EA7*/
const unsigned char  uc2_4EA8 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x01, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*4EA8*/
const unsigned char  uc2_4EA9 [] = {0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*4EA9*/
const unsigned char  uc2_4EAB [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*4EAB*/
const unsigned char  uc2_4EAC [] = {0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x22, 0x40, 0x22, 0x20, 0x42, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*4EAC*/
const unsigned char  uc2_4EAD [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*4EAD*/
const unsigned char  uc2_4EAE [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x0F, 0x80, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*4EAE*/
const unsigned char  uc2_4EB2 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0xC0, 0x12, 0x20, 0x2C, 0x20, 0x00, 0x00 }; /*4EB2*/
const unsigned char  uc2_4EB3 [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x7F, 0xF0, 0x40, 0x10, 0x41, 0xD0, 0x1E, 0x00, 0x03, 0xE0, 0x7E, 0x00, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*4EB3*/
const unsigned char  uc2_4EB5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x11, 0x00, 0x7F, 0xC0, 0x15, 0x40, 0x7B, 0x40, 0x11, 0xD0, 0x66, 0x50, 0x0A, 0xA0, 0x75, 0x80, 0x18, 0x70, 0x00, 0x00 }; /*4EB5*/
const unsigned char  uc2_4EBA [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*4EBA*/
const unsigned char  uc2_4EBF [] = {0x08, 0x00, 0x0B, 0xE0, 0x10, 0x20, 0x10, 0x40, 0x70, 0x80, 0x11, 0x00, 0x12, 0x00, 0x12, 0x00, 0x14, 0x10, 0x14, 0x10, 0x13, 0xE0, 0x00, 0x00 }; /*4EBF*/
const unsigned char  uc2_4EC0 [] = {0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x10, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4EC0*/
const unsigned char  uc2_4EC1 [] = {0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x0B, 0xE0, 0x18, 0x00, 0x68, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x0F, 0xF0, 0x08, 0x00, 0x00, 0x00 }; /*4EC1*/
const unsigned char  uc2_4EC2 [] = {0x04, 0x80, 0x04, 0x80, 0x0B, 0xF0, 0x08, 0x90, 0x18, 0x90, 0x68, 0x90, 0x08, 0x90, 0x08, 0x90, 0x09, 0x10, 0x09, 0x10, 0x0A, 0x60, 0x00, 0x00 }; /*4EC2*/
const unsigned char  uc2_4EC3 [] = {0x10, 0x00, 0x17, 0xF0, 0x20, 0x80, 0x60, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x27, 0x00, 0x00, 0x00 }; /*4EC3*/
const unsigned char  uc2_4EC4 [] = {0x3F, 0xF0, 0x20, 0x00, 0x21, 0x00, 0x21, 0x00, 0x21, 0x00, 0x21, 0x00, 0x22, 0x80, 0x22, 0x80, 0x24, 0x40, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*4EC4*/
const unsigned char  uc2_4EC5 [] = {0x10, 0x00, 0x17, 0xE0, 0x12, 0x20, 0x22, 0x20, 0x62, 0x20, 0x21, 0x40, 0x21, 0x40, 0x20, 0x80, 0x21, 0x40, 0x22, 0x20, 0x2C, 0x10, 0x00, 0x00 }; /*4EC5*/
const unsigned char  uc2_4EC6 [] = {0x04, 0x80, 0x04, 0x80, 0x08, 0x80, 0x08, 0x80, 0x18, 0xC0, 0x68, 0xA0, 0x08, 0x90, 0x08, 0x90, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*4EC6*/
const unsigned char  uc2_4EC7 [] = {0x09, 0x00, 0x09, 0x00, 0x17, 0xC0, 0x11, 0x40, 0x31, 0x40, 0x51, 0x40, 0x11, 0x40, 0x12, 0x50, 0x12, 0x50, 0x14, 0x50, 0x18, 0x20, 0x00, 0x00 }; /*4EC7*/
const unsigned char  uc2_4EC9 [] = {0x08, 0x00, 0x0B, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x32, 0x40, 0x52, 0x40, 0x12, 0x40, 0x12, 0x50, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*4EC9*/
const unsigned char  uc2_4ECA [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x16, 0x40, 0x61, 0x30, 0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*4ECA*/
const unsigned char  uc2_4ECB [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x68, 0xB0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*4ECB*/
const unsigned char  uc2_4ECD [] = {0x08, 0x00, 0x0F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x32, 0x80, 0x52, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x14, 0x10, 0x14, 0x20, 0x19, 0xC0, 0x00, 0x00 }; /*4ECD*/
const unsigned char  uc2_4ECE [] = {0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x15, 0x40, 0x15, 0x40, 0x15, 0x40, 0x22, 0x20, 0x22, 0x20, 0x44, 0x10, 0x00, 0x00 }; /*4ECE*/
const unsigned char  uc2_4ED1 [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x08, 0x00, 0x08, 0xC0, 0x0F, 0x00, 0x08, 0x10, 0x08, 0x10, 0x07, 0xE0, 0x00, 0x00 }; /*4ED1*/
const unsigned char  uc2_4ED3 [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x0B, 0x10, 0x08, 0x10, 0x07, 0xE0, 0x00, 0x00 }; /*4ED3*/
const unsigned char  uc2_4ED4 [] = {0x08, 0x00, 0x0B, 0xE0, 0x10, 0x20, 0x10, 0x40, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*4ED4*/
const unsigned char  uc2_4ED5 [] = {0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x10, 0x80, 0x37, 0xF0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x00, 0x00, 0x00 }; /*4ED5*/
const unsigned char  uc2_4ED6 [] = {0x08, 0x80, 0x0A, 0x80, 0x12, 0xE0, 0x33, 0xA0, 0x56, 0xA0, 0x12, 0xA0, 0x12, 0xC0, 0x12, 0x90, 0x12, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*4ED6*/
const unsigned char  uc2_4ED7 [] = {0x08, 0x40, 0x08, 0x40, 0x17, 0xF0, 0x30, 0x40, 0x52, 0x40, 0x12, 0x40, 0x11, 0x80, 0x10, 0x80, 0x11, 0x40, 0x12, 0x40, 0x1C, 0x30, 0x00, 0x00 }; /*4ED7*/
const unsigned char  uc2_4ED8 [] = {0x08, 0x40, 0x08, 0x40, 0x17, 0xF0, 0x10, 0x40, 0x70, 0x40, 0x12, 0x40, 0x11, 0x40, 0x11, 0x40, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*4ED8*/
const unsigned char  uc2_4ED9 [] = {0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x14, 0x90, 0x34, 0x90, 0x54, 0x90, 0x14, 0x90, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*4ED9*/
const unsigned char  uc2_4EDD [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00 }; /*4EDD*/
const unsigned char  uc2_4EDE [] = {0x08, 0x00, 0x0B, 0xF0, 0x10, 0x90, 0x10, 0x90, 0x32, 0x90, 0x52, 0x90, 0x14, 0x90, 0x10, 0x90, 0x11, 0x10, 0x11, 0x10, 0x16, 0xE0, 0x00, 0x00 }; /*4EDE*/
const unsigned char  uc2_4EDF [] = {0x08, 0x60, 0x0B, 0x80, 0x10, 0x80, 0x10, 0x80, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4EDF*/
const unsigned char  uc2_4EE1 [] = {0x09, 0x00, 0x09, 0xF0, 0x16, 0x00, 0x10, 0x00, 0x33, 0xE0, 0x50, 0x20, 0x10, 0x40, 0x10, 0x80, 0x11, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*4EE1*/
const unsigned char  uc2_4EE3 [] = {0x09, 0x40, 0x09, 0x20, 0x11, 0x00, 0x11, 0x70, 0x3F, 0x80, 0x51, 0x00, 0x11, 0x00, 0x10, 0x80, 0x10, 0x90, 0x10, 0x50, 0x10, 0x20, 0x00, 0x00 }; /*4EE3*/
const unsigned char  uc2_4EE4 [] = {0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x66, 0x30, 0x01, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x0C, 0x80, 0x03, 0x00, 0x00, 0x80, 0x00, 0x00 }; /*4EE4*/
const unsigned char  uc2_4EE5 [] = {0x00, 0x80, 0x20, 0x80, 0x28, 0x80, 0x24, 0x80, 0x24, 0x80, 0x20, 0x80, 0x25, 0x40, 0x39, 0x20, 0x02, 0x20, 0x04, 0x10, 0x18, 0x10, 0x00, 0x00 }; /*4EE5*/
const unsigned char  uc2_4EE8 [] = {0x08, 0x00, 0x0F, 0xE0, 0x10, 0x00, 0x30, 0x00, 0x50, 0x00, 0x13, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*4EE8*/
const unsigned char  uc2_4EEA [] = {0x09, 0x00, 0x0A, 0xA0, 0x12, 0xA0, 0x12, 0x20, 0x32, 0x20, 0x51, 0x40, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x12, 0x40, 0x1C, 0x30, 0x00, 0x00 }; /*4EEA*/
const unsigned char  uc2_4EEB [] = {0x08, 0x80, 0x08, 0xA0, 0x11, 0x20, 0x11, 0x20, 0x32, 0x40, 0x54, 0x40, 0x10, 0x80, 0x11, 0x20, 0x12, 0x60, 0x13, 0x90, 0x10, 0x10, 0x00, 0x00 }; /*4EEB*/
const unsigned char  uc2_4EEC [] = {0x0A, 0x00, 0x09, 0x70, 0x11, 0x10, 0x12, 0x10, 0x32, 0x10, 0x52, 0x10, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*4EEC*/
const unsigned char  uc2_4EF0 [] = {0x08, 0x00, 0x09, 0x00, 0x16, 0xF0, 0x14, 0x90, 0x34, 0x90, 0x54, 0x90, 0x14, 0x90, 0x15, 0x90, 0x16, 0xA0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4EF0*/
const unsigned char  uc2_4EF2 [] = {0x08, 0x80, 0x08, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x34, 0x90, 0x57, 0xF0, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4EF2*/
const unsigned char  uc2_4EF3 [] = {0x14, 0x80, 0x14, 0x80, 0x24, 0x80, 0x24, 0x90, 0x67, 0xE0, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x25, 0x90, 0x26, 0x90, 0x24, 0x60, 0x00, 0x00 }; /*4EF3*/
const unsigned char  uc2_4EF5 [] = {0x0A, 0x00, 0x0B, 0xE0, 0x12, 0x80, 0x14, 0x80, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4EF5*/
const unsigned char  uc2_4EF6 [] = {0x08, 0x80, 0x08, 0x80, 0x12, 0x80, 0x13, 0xE0, 0x32, 0x80, 0x54, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4EF6*/
const unsigned char  uc2_4EF7 [] = {0x09, 0x00, 0x09, 0x00, 0x12, 0x80, 0x34, 0x40, 0x58, 0x30, 0x12, 0x80, 0x12, 0x80, 0x12, 0x80, 0x12, 0x80, 0x14, 0x80, 0x18, 0x80, 0x00, 0x00 }; /*4EF7*/
const unsigned char  uc2_4EFB [] = {0x08, 0x00, 0x08, 0x60, 0x13, 0x80, 0x10, 0x80, 0x30, 0x80, 0x50, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*4EFB*/
const unsigned char  uc2_4EFD [] = {0x08, 0x40, 0x0A, 0x40, 0x12, 0x20, 0x14, 0x20, 0x38, 0x10, 0x57, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x11, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*4EFD*/
const unsigned char  uc2_4EFF [] = {0x09, 0x80, 0x08, 0x40, 0x17, 0xF0, 0x11, 0x00, 0x31, 0x00, 0x51, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x12, 0x20, 0x14, 0x20, 0x18, 0xC0, 0x00, 0x00 }; /*4EFF*/
const unsigned char  uc2_4F01 [] = {0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x62, 0x30, 0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*4F01*/
const unsigned char  uc2_4F09 [] = {0x11, 0x00, 0x10, 0x80, 0x2F, 0xF0, 0x60, 0x00, 0x23, 0xC0, 0x22, 0x40, 0x22, 0x40, 0x22, 0x40, 0x24, 0x50, 0x24, 0x50, 0x28, 0x20, 0x00, 0x00 }; /*4F09*/
const unsigned char  uc2_4F0A [] = {0x08, 0x00, 0x0B, 0xE0, 0x10, 0xA0, 0x37, 0xF0, 0x50, 0xA0, 0x13, 0xE0, 0x10, 0xA0, 0x10, 0x80, 0x10, 0x80, 0x11, 0x00, 0x16, 0x00, 0x00, 0x00 }; /*4F0A*/
const unsigned char  uc2_4F0D [] = {0x10, 0x00, 0x17, 0xF0, 0x20, 0x80, 0x60, 0x80, 0x23, 0xE0, 0x21, 0x20, 0x21, 0x20, 0x21, 0x20, 0x21, 0x20, 0x27, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*4F0D*/
const unsigned char  uc2_4F0E [] = {0x10, 0x80, 0x10, 0x80, 0x27, 0xF0, 0x60, 0x80, 0x20, 0x80, 0x23, 0xC0, 0x21, 0x40, 0x21, 0x40, 0x20, 0x80, 0x21, 0x40, 0x2E, 0x30, 0x00, 0x00 }; /*4F0E*/
const unsigned char  uc2_4F0F [] = {0x08, 0x80, 0x08, 0xC0, 0x10, 0xA0, 0x37, 0xF0, 0x50, 0x80, 0x11, 0x40, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*4F0F*/
const unsigned char  uc2_4F10 [] = {0x11, 0x40, 0x11, 0x20, 0x21, 0x70, 0x6F, 0x80, 0x21, 0x20, 0x21, 0x20, 0x21, 0x40, 0x20, 0x80, 0x21, 0x90, 0x2E, 0x50, 0x20, 0x20, 0x00, 0x00 }; /*4F10*/
const unsigned char  uc2_4F11 [] = {0x08, 0x80, 0x08, 0x80, 0x17, 0xF0, 0x30, 0x80, 0x51, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4F11*/
const unsigned char  uc2_4F17 [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x08, 0x40, 0x08, 0x40, 0x14, 0x40, 0x14, 0xA0, 0x20, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*4F17*/
const unsigned char  uc2_4F18 [] = {0x12, 0x80, 0x12, 0x40, 0x22, 0x40, 0x6F, 0xE0, 0x22, 0x80, 0x22, 0x80, 0x22, 0x80, 0x24, 0x80, 0x24, 0x90, 0x28, 0x90, 0x30, 0x60, 0x00, 0x00 }; /*4F18*/
const unsigned char  uc2_4F19 [] = {0x08, 0x80, 0x08, 0x80, 0x12, 0x90, 0x32, 0x90, 0x54, 0xA0, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*4F19*/
const unsigned char  uc2_4F1A [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x04, 0x80, 0x09, 0x40, 0x0E, 0x40, 0x00, 0x00 }; /*4F1A*/
const unsigned char  uc2_4F1B [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x00, 0x64, 0x20, 0x25, 0xA0, 0x24, 0x40, 0x24, 0x40, 0x24, 0xA0, 0x27, 0x20, 0x24, 0x00, 0x27, 0xF0, 0x00, 0x00 }; /*4F1B*/
const unsigned char  uc2_4F1E [] = {0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x12, 0x40, 0x62, 0x30, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*4F1E*/
const unsigned char  uc2_4F1F [] = {0x10, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x63, 0xE0, 0x20, 0x80, 0x27, 0xF0, 0x20, 0x90, 0x20, 0x90, 0x20, 0xE0, 0x20, 0x80, 0x20, 0x80, 0x00, 0x00 }; /*4F1F*/
const unsigned char  uc2_4F20 [] = {0x08, 0x80, 0x08, 0x80, 0x13, 0xE0, 0x30, 0x80, 0x57, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x12, 0x20, 0x11, 0xA0, 0x10, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*4F20*/
const unsigned char  uc2_4F22 [] = {0x10, 0x00, 0x17, 0xE0, 0x22, 0x40, 0x64, 0x40, 0x27, 0xF0, 0x21, 0x40, 0x21, 0x40, 0x22, 0x40, 0x22, 0x40, 0x2C, 0x40, 0x21, 0x80, 0x00, 0x00 }; /*4F22*/
const unsigned char  uc2_4F24 [] = {0x0A, 0x00, 0x0B, 0xF0, 0x14, 0x80, 0x30, 0x80, 0x53, 0xF0, 0x10, 0x90, 0x10, 0x90, 0x10, 0x90, 0x11, 0x10, 0x11, 0x10, 0x16, 0x60, 0x00, 0x00 }; /*4F24*/
const unsigned char  uc2_4F25 [] = {0x0A, 0x00, 0x0A, 0x60, 0x13, 0x80, 0x32, 0x00, 0x5F, 0xF0, 0x12, 0x80, 0x12, 0x80, 0x12, 0x40, 0x12, 0xC0, 0x13, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*4F25*/
const unsigned char  uc2_4F26 [] = {0x08, 0x80, 0x08, 0x80, 0x11, 0x40, 0x32, 0x20, 0x54, 0x10, 0x11, 0x00, 0x11, 0x20, 0x11, 0xC0, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*4F26*/
const unsigned char  uc2_4F27 [] = {0x11, 0x00, 0x12, 0x80, 0x24, 0x40, 0x78, 0x30, 0x27, 0xC0, 0x24, 0x40, 0x24, 0x40, 0x25, 0x80, 0x24, 0x20, 0x24, 0x20, 0x23, 0xC0, 0x00, 0x00 }; /*4F27*/
const unsigned char  uc2_4F2A [] = {0x10, 0x80, 0x14, 0x80, 0x22, 0x80, 0x67, 0xF0, 0x20, 0x90, 0x20, 0x90, 0x20, 0xD0, 0x21, 0x30, 0x21, 0x10, 0x22, 0x10, 0x2C, 0xE0, 0x00, 0x00 }; /*4F2A*/
const unsigned char  uc2_4F2B [] = {0x09, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x34, 0x10, 0x54, 0x10, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*4F2B*/
const unsigned char  uc2_4F2F [] = {0x08, 0x40, 0x08, 0x80, 0x13, 0xF0, 0x32, 0x10, 0x52, 0x10, 0x13, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x13, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*4F2F*/
const unsigned char  uc2_4F30 [] = {0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x37, 0xF0, 0x50, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*4F30*/
const unsigned char  uc2_4F32 [] = {0x17, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x37, 0xE0, 0x54, 0x00, 0x15, 0x00, 0x15, 0x20, 0x15, 0xC0, 0x15, 0x10, 0x15, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*4F32*/
const unsigned char  uc2_4F34 [] = {0x08, 0x80, 0x0A, 0xA0, 0x11, 0xC0, 0x30, 0x80, 0x53, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4F34*/
const unsigned char  uc2_4F36 [] = {0x08, 0x80, 0x08, 0x80, 0x11, 0x40, 0x36, 0x30, 0x51, 0x80, 0x10, 0x40, 0x13, 0xE0, 0x10, 0x20, 0x13, 0x40, 0x10, 0x80, 0x10, 0x40, 0x00, 0x00 }; /*4F36*/
const unsigned char  uc2_4F38 [] = {0x08, 0x80, 0x08, 0x80, 0x17, 0xF0, 0x34, 0x90, 0x57, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4F38*/
const unsigned char  uc2_4F3A [] = {0x08, 0x00, 0x0B, 0xF0, 0x10, 0x10, 0x37, 0xD0, 0x50, 0x10, 0x13, 0xD0, 0x12, 0x50, 0x13, 0xD0, 0x12, 0x50, 0x10, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*4F3A*/
const unsigned char  uc2_4F3C [] = {0x10, 0x40, 0x14, 0x40, 0x24, 0x40, 0x66, 0x40, 0x25, 0x40, 0x24, 0x40, 0x25, 0x40, 0x26, 0x40, 0x24, 0xA0, 0x21, 0x10, 0x26, 0x10, 0x00, 0x00 }; /*4F3C*/
const unsigned char  uc2_4F3D [] = {0x14, 0x00, 0x14, 0x70, 0x2F, 0x50, 0x65, 0x50, 0x25, 0x50, 0x25, 0x50, 0x25, 0x50, 0x25, 0x50, 0x25, 0x50, 0x25, 0x70, 0x2A, 0x50, 0x00, 0x00 }; /*4F3D*/
const unsigned char  uc2_4F43 [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x90, 0x64, 0x90, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x10, 0x00, 0x00 }; /*4F43*/
const unsigned char  uc2_4F46 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x32, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*4F46*/
const unsigned char  uc2_4F4D [] = {0x0B, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x30, 0x00, 0x52, 0x20, 0x11, 0x20, 0x11, 0x40, 0x10, 0x40, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*4F4D*/
const unsigned char  uc2_4F4E [] = {0x10, 0x60, 0x17, 0x80, 0x24, 0x80, 0x24, 0x80, 0x67, 0xF0, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x25, 0x50, 0x26, 0x50, 0x21, 0x20, 0x00, 0x00 }; /*4F4E*/
const unsigned char  uc2_4F4F [] = {0x0B, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x30, 0x80, 0x50, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*4F4F*/
const unsigned char  uc2_4F50 [] = {0x11, 0x00, 0x11, 0x00, 0x27, 0xF0, 0x61, 0x00, 0x22, 0x00, 0x23, 0xE0, 0x2C, 0x80, 0x20, 0x80, 0x20, 0x80, 0x27, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*4F50*/
const unsigned char  uc2_4F51 [] = {0x11, 0x00, 0x11, 0x00, 0x2F, 0xF0, 0x61, 0x00, 0x21, 0x00, 0x22, 0x00, 0x27, 0xE0, 0x2A, 0x20, 0x22, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x00, 0x00 }; /*4F51*/
const unsigned char  uc2_4F53 [] = {0x11, 0x00, 0x11, 0x00, 0x2F, 0xE0, 0x61, 0x00, 0x23, 0x80, 0x25, 0x40, 0x25, 0x40, 0x29, 0x20, 0x27, 0xC0, 0x21, 0x00, 0x21, 0x00, 0x00, 0x00 }; /*4F53*/
const unsigned char  uc2_4F55 [] = {0x10, 0x00, 0x17, 0xF0, 0x20, 0x20, 0x67, 0xA0, 0x24, 0xA0, 0x24, 0xA0, 0x27, 0xA0, 0x24, 0xA0, 0x20, 0x20, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*4F55*/
const unsigned char  uc2_4F57 [] = {0x09, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x34, 0x10, 0x55, 0x10, 0x11, 0x20, 0x11, 0xC0, 0x11, 0x00, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*4F57*/
const unsigned char  uc2_4F58 [] = {0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x60, 0x62, 0x10, 0x0C, 0x00, 0x00, 0x00 }; /*4F58*/
const unsigned char  uc2_4F59 [] = {0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x0F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x60, 0x62, 0x10, 0x0C, 0x00, 0x00, 0x00 }; /*4F59*/
const unsigned char  uc2_4F5A [] = {0x0A, 0x80, 0x0A, 0x80, 0x13, 0xE0, 0x34, 0x80, 0x50, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x1C, 0x10, 0x00, 0x00 }; /*4F5A*/
const unsigned char  uc2_4F5B [] = {0x12, 0x80, 0x12, 0x80, 0x2F, 0xE0, 0x62, 0xA0, 0x27, 0xE0, 0x2A, 0x80, 0x2F, 0xF0, 0x22, 0x90, 0x22, 0xE0, 0x24, 0x80, 0x28, 0x80, 0x00, 0x00 }; /*4F5B*/
const unsigned char  uc2_4F5C [] = {0x09, 0x00, 0x09, 0x00, 0x11, 0xF0, 0x33, 0x00, 0x55, 0x00, 0x11, 0xE0, 0x11, 0x00, 0x11, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x00, 0x00 }; /*4F5C*/
const unsigned char  uc2_4F5D [] = {0x09, 0x00, 0x09, 0x00, 0x13, 0xF0, 0x34, 0x10, 0x5B, 0xD0, 0x12, 0x50, 0x12, 0x50, 0x13, 0xD0, 0x10, 0x10, 0x10, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*4F5D*/
const unsigned char  uc2_4F5E [] = {0x08, 0x00, 0x0B, 0xE0, 0x10, 0x00, 0x37, 0xF0, 0x50, 0x80, 0x17, 0xF0, 0x11, 0x40, 0x12, 0x40, 0x13, 0x80, 0x11, 0x60, 0x16, 0x10, 0x00, 0x00 }; /*4F5E*/
const unsigned char  uc2_4F5F [] = {0x09, 0x00, 0x09, 0xE0, 0x12, 0x20, 0x35, 0x40, 0x50, 0x80, 0x11, 0x40, 0x16, 0x30, 0x11, 0x80, 0x10, 0x40, 0x13, 0x80, 0x10, 0x40, 0x00, 0x00 }; /*4F5F*/
const unsigned char  uc2_4F60 [] = {0x12, 0x00, 0x12, 0x00, 0x23, 0xF0, 0x64, 0x90, 0x28, 0xA0, 0x20, 0x80, 0x22, 0xA0, 0x22, 0x90, 0x24, 0x90, 0x20, 0x80, 0x23, 0x00, 0x00, 0x00 }; /*4F60*/
const unsigned char  uc2_4F63 [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x90, 0x64, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x24, 0x90, 0x28, 0x60, 0x00, 0x00 }; /*4F63*/
const unsigned char  uc2_4F64 [] = {0x10, 0x00, 0x17, 0xF0, 0x21, 0x00, 0x61, 0x00, 0x21, 0xE0, 0x22, 0x20, 0x23, 0x20, 0x22, 0xC0, 0x24, 0x50, 0x25, 0x50, 0x26, 0x30, 0x00, 0x00 }; /*4F64*/
const unsigned char  uc2_4F65 [] = {0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x00, 0x00, 0x14, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x01, 0x00, 0x3F, 0xE0, 0x00, 0x00 }; /*4F65*/
const unsigned char  uc2_4F67 [] = {0x08, 0x80, 0x08, 0xE0, 0x10, 0x80, 0x37, 0xF0, 0x50, 0x00, 0x10, 0x80, 0x10, 0xE0, 0x10, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4F67*/
const unsigned char  uc2_4F69 [] = {0x10, 0x00, 0x1F, 0xE0, 0x28, 0x20, 0x6F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x2D, 0x60, 0x2D, 0x60, 0x2D, 0xA0, 0x29, 0x20, 0x31, 0x10, 0x00, 0x00 }; /*4F69*/
const unsigned char  uc2_4F6C [] = {0x09, 0x00, 0x09, 0x20, 0x17, 0xE0, 0x31, 0x40, 0x51, 0x80, 0x1F, 0xF0, 0x12, 0x00, 0x16, 0x60, 0x1B, 0x90, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*4F6C*/
const unsigned char  uc2_4F6F [] = {0x0A, 0x20, 0x09, 0x40, 0x13, 0xE0, 0x30, 0x80, 0x51, 0xC0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4F6F*/
const unsigned char  uc2_4F70 [] = {0x1F, 0xF0, 0x10, 0x80, 0x21, 0x00, 0x67, 0xE0, 0x24, 0x20, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x00, 0x00 }; /*4F70*/
const unsigned char  uc2_4F73 [] = {0x08, 0x80, 0x08, 0x80, 0x13, 0xE0, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x00, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*4F73*/
const unsigned char  uc2_4F74 [] = {0x10, 0x00, 0x1F, 0xE0, 0x24, 0x40, 0x67, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x25, 0xF0, 0x3E, 0x40, 0x20, 0x40, 0x20, 0x40, 0x00, 0x00 }; /*4F74*/
const unsigned char  uc2_4F76 [] = {0x08, 0x80, 0x08, 0x80, 0x17, 0xF0, 0x30, 0x80, 0x53, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*4F76*/
const unsigned char  uc2_4F7B [] = {0x12, 0x80, 0x12, 0x80, 0x2A, 0xA0, 0x66, 0xC0, 0x22, 0x80, 0x22, 0xC0, 0x26, 0xA0, 0x3A, 0xA0, 0x22, 0x90, 0x24, 0x90, 0x38, 0x60, 0x00, 0x00 }; /*4F7B*/
const unsigned char  uc2_4F7C [] = {0x09, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x31, 0x40, 0x52, 0x20, 0x14, 0x10, 0x11, 0x40, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*4F7C*/
const unsigned char  uc2_4F7E [] = {0x09, 0x40, 0x09, 0x40, 0x12, 0x20, 0x37, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*4F7E*/
const unsigned char  uc2_4F7F [] = {0x10, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x63, 0xE0, 0x22, 0xA0, 0x22, 0xA0, 0x23, 0xE0, 0x24, 0x80, 0x22, 0x80, 0x21, 0x80, 0x2E, 0x70, 0x00, 0x00 }; /*4F7F*/
const unsigned char  uc2_4F83 [] = {0x10, 0x00, 0x17, 0xC0, 0x24, 0x40, 0x64, 0x40, 0x27, 0xC0, 0x20, 0x00, 0x25, 0x40, 0x25, 0x40, 0x25, 0x50, 0x29, 0x50, 0x30, 0x20, 0x00, 0x00 }; /*4F83*/
const unsigned char  uc2_4F84 [] = {0x08, 0x00, 0x0F, 0xF0, 0x11, 0x40, 0x32, 0x20, 0x57, 0xD0, 0x10, 0x90, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*4F84*/
const unsigned char  uc2_4F88 [] = {0x08, 0x80, 0x08, 0xE0, 0x13, 0x20, 0x30, 0xC0, 0x51, 0x80, 0x16, 0x40, 0x10, 0x70, 0x13, 0x90, 0x10, 0x60, 0x10, 0xC0, 0x17, 0x00, 0x00, 0x00 }; /*4F88*/
const unsigned char  uc2_4F89 [] = {0x10, 0x80, 0x17, 0xF0, 0x21, 0x40, 0x66, 0x30, 0x21, 0xC0, 0x20, 0x00, 0x27, 0xF0, 0x21, 0x00, 0x23, 0xE0, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*4F89*/
const unsigned char  uc2_4F8B [] = {0x10, 0x10, 0x1F, 0x10, 0x24, 0x50, 0x67, 0x50, 0x25, 0x50, 0x29, 0x50, 0x2D, 0x50, 0x32, 0x50, 0x22, 0x10, 0x24, 0x10, 0x38, 0x60, 0x00, 0x00 }; /*4F8B*/
const unsigned char  uc2_4F8D [] = {0x08, 0x80, 0x0B, 0xE0, 0x10, 0x80, 0x37, 0xF0, 0x50, 0x00, 0x10, 0x40, 0x13, 0xE0, 0x12, 0x40, 0x11, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*4F8D*/
const unsigned char  uc2_4F8F [] = {0x08, 0x80, 0x0A, 0x80, 0x13, 0xE0, 0x34, 0x80, 0x50, 0x80, 0x17, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*4F8F*/
const unsigned char  uc2_4F91 [] = {0x10, 0x80, 0x1F, 0xF0, 0x21, 0x00, 0x63, 0xE0, 0x2E, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*4F91*/
const unsigned char  uc2_4F94 [] = {0x09, 0x00, 0x09, 0x40, 0x12, 0x60, 0x33, 0xA0, 0x50, 0x00, 0x12, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*4F94*/
const unsigned char  uc2_4F97 [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x10, 0x67, 0xF0, 0x24, 0x10, 0x25, 0xD0, 0x25, 0x50, 0x25, 0xD0, 0x24, 0x10, 0x24, 0x10, 0x24, 0xE0, 0x00, 0x00 }; /*4F97*/
const unsigned char  uc2_4F98 [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x60, 0x60, 0x23, 0x80, 0x20, 0x80, 0x20, 0xF0, 0x27, 0x80, 0x20, 0x90, 0x20, 0x90, 0x20, 0x60, 0x00, 0x00 }; /*4F98*/
const unsigned char  uc2_4F9B [] = {0x12, 0x40, 0x12, 0x40, 0x27, 0xE0, 0x62, 0x40, 0x22, 0x40, 0x22, 0x40, 0x2F, 0xF0, 0x20, 0x00, 0x22, 0x40, 0x22, 0x20, 0x24, 0x20, 0x00, 0x00 }; /*4F9B*/
const unsigned char  uc2_4F9D [] = {0x13, 0x00, 0x10, 0x80, 0x27, 0xF0, 0x61, 0x00, 0x22, 0x80, 0x26, 0xA0, 0x2A, 0xA0, 0x22, 0x40, 0x22, 0x40, 0x22, 0xA0, 0x23, 0x10, 0x00, 0x00 }; /*4F9D*/
const unsigned char  uc2_4FA0 [] = {0x11, 0x00, 0x11, 0x00, 0x2F, 0xE0, 0x61, 0x00, 0x25, 0x40, 0x25, 0x40, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x24, 0x40, 0x38, 0x30, 0x00, 0x00 }; /*4FA0*/
const unsigned char  uc2_4FA3 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x32, 0x20, 0x53, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*4FA3*/
const unsigned char  uc2_4FA5 [] = {0x09, 0x60, 0x09, 0x80, 0x17, 0x60, 0x30, 0x90, 0x57, 0x60, 0x10, 0x00, 0x17, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*4FA5*/
const unsigned char  uc2_4FA6 [] = {0x08, 0x80, 0x08, 0xF0, 0x10, 0x80, 0x33, 0xE0, 0x52, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x11, 0x40, 0x11, 0x20, 0x16, 0x20, 0x00, 0x00 }; /*4FA6*/
const unsigned char  uc2_4FA7 [] = {0x10, 0x10, 0x1F, 0x10, 0x29, 0x50, 0x69, 0x50, 0x2B, 0x50, 0x2B, 0x50, 0x2D, 0x50, 0x24, 0x50, 0x26, 0x10, 0x29, 0x10, 0x31, 0x60, 0x00, 0x00 }; /*4FA7*/
const unsigned char  uc2_4FA8 [] = {0x08, 0x60, 0x0B, 0x80, 0x10, 0x80, 0x37, 0xF0, 0x51, 0x40, 0x16, 0x30, 0x11, 0x40, 0x11, 0x40, 0x11, 0x40, 0x12, 0x40, 0x1C, 0x40, 0x00, 0x00 }; /*4FA8*/
const unsigned char  uc2_4FA9 [] = {0x08, 0x80, 0x08, 0x80, 0x11, 0x40, 0x36, 0x30, 0x51, 0xC0, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x20, 0x12, 0x50, 0x13, 0x90, 0x00, 0x00 }; /*4FA9*/
const unsigned char  uc2_4FAA [] = {0x08, 0x80, 0x0F, 0xF0, 0x12, 0x20, 0x31, 0x40, 0x50, 0x80, 0x11, 0x40, 0x16, 0x30, 0x11, 0x40, 0x11, 0x40, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*4FAA*/
const unsigned char  uc2_4FAC [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x90, 0x64, 0x90, 0x21, 0x00, 0x22, 0x90, 0x26, 0x60, 0x2A, 0x40, 0x22, 0xA0, 0x23, 0x20, 0x22, 0x10, 0x00, 0x00 }; /*4FAC*/
const unsigned char  uc2_4FAE [] = {0x0A, 0x00, 0x0B, 0xF0, 0x14, 0x00, 0x33, 0xE0, 0x52, 0xA0, 0x1F, 0xF0, 0x15, 0x20, 0x14, 0xA0, 0x17, 0xF0, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*4FAE*/
const unsigned char  uc2_4FAF [] = {0x0B, 0xC0, 0x08, 0x40, 0x10, 0x80, 0x37, 0xF0, 0x52, 0x00, 0x13, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*4FAF*/
const unsigned char  uc2_4FB5 [] = {0x0B, 0xC0, 0x08, 0x40, 0x11, 0xC0, 0x30, 0x40, 0x57, 0xE0, 0x14, 0x20, 0x13, 0xC0, 0x11, 0x40, 0x11, 0x40, 0x10, 0x80, 0x17, 0x70, 0x00, 0x00 }; /*4FB5*/
const unsigned char  uc2_4FBF [] = {0x10, 0x00, 0x17, 0xF0, 0x20, 0x80, 0x63, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x24, 0x80, 0x23, 0x00, 0x2C, 0xF0, 0x00, 0x00 }; /*4FBF*/
const unsigned char  uc2_4FC3 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x32, 0x20, 0x53, 0xE0, 0x10, 0x80, 0x12, 0x80, 0x12, 0xE0, 0x12, 0x80, 0x15, 0x80, 0x18, 0x70, 0x00, 0x00 }; /*4FC3*/
const unsigned char  uc2_4FC4 [] = {0x08, 0xC0, 0x0B, 0x60, 0x11, 0x50, 0x37, 0xF0, 0x51, 0x40, 0x11, 0x50, 0x11, 0xD0, 0x17, 0x60, 0x11, 0x50, 0x11, 0x50, 0x16, 0xA0, 0x00, 0x00 }; /*4FC4*/
const unsigned char  uc2_4FC5 [] = {0x08, 0xC0, 0x08, 0xA0, 0x17, 0xF0, 0x30, 0x80, 0x54, 0x90, 0x12, 0xD0, 0x10, 0xA0, 0x12, 0xA0, 0x1C, 0xA0, 0x10, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*4FC5*/
const unsigned char  uc2_4FCA [] = {0x09, 0x00, 0x0A, 0x20, 0x13, 0xD0, 0x31, 0x20, 0x56, 0x10, 0x11, 0x10, 0x11, 0xC0, 0x16, 0x40, 0x11, 0x80, 0x12, 0x40, 0x1C, 0x30, 0x00, 0x00 }; /*4FCA*/
const unsigned char  uc2_4FCE [] = {0x10, 0x00, 0x11, 0xE0, 0x19, 0x20, 0x15, 0x20, 0x25, 0xE0, 0x51, 0x20, 0x11, 0x20, 0x19, 0xE0, 0x15, 0x20, 0x21, 0x20, 0x43, 0xF0, 0x00, 0x00 }; /*4FCE*/
const unsigned char  uc2_4FCF [] = {0x10, 0x90, 0x1C, 0x90, 0x22, 0xA0, 0x67, 0xF0, 0x24, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x24, 0x10, 0x24, 0x60, 0x00, 0x00 }; /*4FCF*/
const unsigned char  uc2_4FD0 [] = {0x11, 0x90, 0x1E, 0x10, 0x22, 0x50, 0x62, 0x50, 0x2F, 0xD0, 0x26, 0x50, 0x2B, 0x50, 0x2A, 0x90, 0x32, 0x10, 0x22, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*4FD0*/
const unsigned char  uc2_4FD1 [] = {0x17, 0xE0, 0x11, 0x20, 0x20, 0xC0, 0x67, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x24, 0x60, 0x00, 0x00 }; /*4FD1*/
const unsigned char  uc2_4FD7 [] = {0x09, 0x40, 0x09, 0x20, 0x12, 0xA0, 0x30, 0x80, 0x51, 0x40, 0x16, 0x30, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*4FD7*/
const unsigned char  uc2_4FD8 [] = {0x10, 0xF0, 0x1F, 0x20, 0x2A, 0x20, 0x65, 0x40, 0x27, 0xC0, 0x20, 0x40, 0x20, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x27, 0x00, 0x00, 0x00 }; /*4FD8*/
const unsigned char  uc2_4FDA [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0xA0, 0x33, 0xE0, 0x52, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*4FDA*/
const unsigned char  uc2_4FDC [] = {0x08, 0x80, 0x0B, 0xE0, 0x12, 0xA0, 0x33, 0xE0, 0x52, 0xA0, 0x17, 0xF0, 0x11, 0x00, 0x13, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*4FDC*/
const unsigned char  uc2_4FDD [] = {0x0B, 0xE0, 0x0A, 0x20, 0x12, 0x20, 0x33, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*4FDD*/
const unsigned char  uc2_4FDE [] = {0x07, 0x00, 0x18, 0xC0, 0x67, 0x30, 0x00, 0x00, 0x3C, 0x20, 0x25, 0x20, 0x3D, 0x20, 0x25, 0x20, 0x3D, 0x20, 0x24, 0x20, 0x2C, 0xC0, 0x00, 0x00 }; /*4FDE*/
const unsigned char  uc2_4FDF [] = {0x08, 0x80, 0x09, 0x20, 0x12, 0x50, 0x33, 0x90, 0x52, 0x00, 0x13, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*4FDF*/
const unsigned char  uc2_4FE1 [] = {0x08, 0x80, 0x0F, 0xF0, 0x10, 0x00, 0x33, 0xE0, 0x50, 0x00, 0x13, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*4FE1*/
const unsigned char  uc2_4FE3 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x33, 0xE0, 0x50, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*4FE3*/
const unsigned char  uc2_4FE6 [] = {0x11, 0x00, 0x1F, 0xE0, 0x21, 0x00, 0x67, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x40, 0x27, 0xE0, 0x3A, 0x40, 0x21, 0x40, 0x21, 0x80, 0x00, 0x00 }; /*4FE6*/
const unsigned char  uc2_4FE8 [] = {0x10, 0x00, 0x1F, 0xF0, 0x25, 0x50, 0x63, 0x60, 0x21, 0x40, 0x27, 0xF0, 0x24, 0x00, 0x24, 0x00, 0x24, 0x00, 0x28, 0x00, 0x30, 0x00, 0x00, 0x00 }; /*4FE8*/
const unsigned char  uc2_4FE9 [] = {0x10, 0x00, 0x1F, 0xF0, 0x22, 0x80, 0x62, 0x80, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2D, 0x60, 0x2A, 0x20, 0x28, 0x20, 0x28, 0xC0, 0x00, 0x00 }; /*4FE9*/
const unsigned char  uc2_4FEA [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x6E, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2E, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2C, 0xC0, 0x00, 0x00 }; /*4FEA*/
const unsigned char  uc2_4FED [] = {0x11, 0x00, 0x12, 0x80, 0x24, 0x40, 0x78, 0x30, 0x27, 0xC0, 0x20, 0x00, 0x2A, 0x40, 0x25, 0x40, 0x20, 0x80, 0x3F, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*4FED*/
const unsigned char  uc2_4FEE [] = {0x11, 0x00, 0x11, 0xE0, 0x2B, 0x20, 0x68, 0xC0, 0x29, 0x40, 0x2E, 0xB0, 0x29, 0x40, 0x28, 0x90, 0x23, 0x20, 0x20, 0xC0, 0x27, 0x00, 0x00, 0x00 }; /*4FEE*/
const unsigned char  uc2_4FEF [] = {0x11, 0x00, 0x1F, 0xF0, 0x29, 0x20, 0x69, 0x20, 0x2B, 0xF0, 0x2E, 0x20, 0x2B, 0x20, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0x20, 0x32, 0xC0, 0x00, 0x00 }; /*4FEF*/
const unsigned char  uc2_4FF1 [] = {0x0B, 0xC0, 0x0A, 0x40, 0x13, 0xC0, 0x32, 0x40, 0x53, 0xC0, 0x12, 0x40, 0x13, 0xC0, 0x12, 0x40, 0x1F, 0xF0, 0x12, 0x40, 0x14, 0x20, 0x00, 0x00 }; /*4FF1*/
const unsigned char  uc2_4FF3 [] = {0x12, 0x80, 0x12, 0x80, 0x3E, 0xF0, 0x62, 0x80, 0x22, 0x80, 0x2E, 0xE0, 0x22, 0x80, 0x22, 0x80, 0x3E, 0xF0, 0x22, 0x80, 0x22, 0x80, 0x00, 0x00 }; /*4FF3*/
const unsigned char  uc2_4FF8 [] = {0x08, 0x80, 0x0F, 0xF0, 0x10, 0x80, 0x33, 0xE0, 0x51, 0x00, 0x17, 0xF0, 0x12, 0xA0, 0x1D, 0xD0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*4FF8*/
const unsigned char  uc2_4FFA [] = {0x10, 0x80, 0x17, 0xF0, 0x21, 0x40, 0x66, 0xB0, 0x23, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x20, 0x90, 0x20, 0x60, 0x00, 0x00 }; /*4FFA*/
const unsigned char  uc2_4FFE [] = {0x09, 0x00, 0x0B, 0xE0, 0x12, 0xA0, 0x33, 0xE0, 0x52, 0xA0, 0x13, 0xE0, 0x11, 0x00, 0x12, 0x40, 0x17, 0xF0, 0x10, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*4FFE*/
const unsigned char  uc2_500C [] = {0x10, 0x80, 0x1F, 0xF0, 0x28, 0x10, 0x6B, 0xD0, 0x22, 0x40, 0x23, 0xC0, 0x22, 0x00, 0x23, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x00, 0x00 }; /*500C*/
const unsigned char  uc2_500D [] = {0x16, 0x00, 0x11, 0x00, 0x2F, 0xE0, 0x64, 0x40, 0x22, 0x80, 0x3F, 0xF0, 0x20, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x00, 0x00 }; /*500D*/
const unsigned char  uc2_500F [] = {0x11, 0x00, 0x11, 0xE0, 0x23, 0x20, 0x68, 0xC0, 0x2B, 0x30, 0x28, 0xC0, 0x28, 0xA0, 0x2B, 0xF0, 0x20, 0x80, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*500F*/
const unsigned char  uc2_5012 [] = {0x10, 0x10, 0x1F, 0x50, 0x22, 0x50, 0x65, 0x50, 0x2E, 0xD0, 0x22, 0x50, 0x2F, 0x50, 0x22, 0x50, 0x23, 0x90, 0x2C, 0x10, 0x20, 0x60, 0x00, 0x00 }; /*5012*/
const unsigned char  uc2_5014 [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x10, 0x67, 0xF0, 0x24, 0x40, 0x25, 0x50, 0x25, 0xF0, 0x24, 0x40, 0x25, 0x50, 0x29, 0xF0, 0x28, 0x10, 0x00, 0x00 }; /*5014*/
const unsigned char  uc2_5018 [] = {0x10, 0x80, 0x14, 0x90, 0x22, 0x90, 0x62, 0xA0, 0x27, 0xF0, 0x24, 0x10, 0x25, 0xD0, 0x25, 0x50, 0x25, 0xD0, 0x24, 0x10, 0x24, 0x60, 0x00, 0x00 }; /*5018*/
const unsigned char  uc2_5019 [] = {0x10, 0x00, 0x13, 0xC0, 0x20, 0x40, 0x67, 0xF0, 0x2A, 0x00, 0x2B, 0xE0, 0x2C, 0x80, 0x2B, 0xF0, 0x28, 0x80, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*5019*/
const unsigned char  uc2_501A [] = {0x11, 0x00, 0x17, 0xE0, 0x22, 0x80, 0x64, 0x40, 0x2F, 0xF0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x25, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*501A*/
const unsigned char  uc2_501C [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x90, 0x65, 0xD0, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x10, 0x25, 0xD0, 0x25, 0x50, 0x29, 0xD0, 0x30, 0x60, 0x00, 0x00 }; /*501C*/
const unsigned char  uc2_501F [] = {0x09, 0x40, 0x0B, 0xE0, 0x11, 0x40, 0x37, 0xF0, 0x50, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*501F*/
const unsigned char  uc2_5021 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x33, 0xE0, 0x52, 0x20, 0x17, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*5021*/
const unsigned char  uc2_5025 [] = {0x09, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x34, 0x10, 0x51, 0x60, 0x16, 0x10, 0x10, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*5025*/
const unsigned char  uc2_5026 [] = {0x14, 0x90, 0x12, 0xA0, 0x27, 0xF0, 0x60, 0x80, 0x27, 0xF0, 0x21, 0x40, 0x23, 0xF0, 0x2E, 0x20, 0x22, 0xD0, 0x22, 0x10, 0x21, 0xE0, 0x00, 0x00 }; /*5026*/
const unsigned char  uc2_5028 [] = {0x10, 0x00, 0x17, 0xE0, 0x24, 0x20, 0x67, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x24, 0x80, 0x27, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x32, 0x20, 0x00, 0x00 }; /*5028*/
const unsigned char  uc2_5029 [] = {0x11, 0x00, 0x1F, 0xE0, 0x21, 0x00, 0x67, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x27, 0x40, 0x24, 0xC0, 0x00, 0x00 }; /*5029*/
const unsigned char  uc2_502A [] = {0x11, 0x00, 0x16, 0x70, 0x24, 0x10, 0x67, 0x70, 0x24, 0x10, 0x27, 0xF0, 0x21, 0x40, 0x21, 0x40, 0x22, 0x50, 0x22, 0x50, 0x2C, 0x20, 0x00, 0x00 }; /*502A*/
const unsigned char  uc2_502C [] = {0x11, 0x00, 0x11, 0xE0, 0x21, 0x00, 0x67, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x00, 0x00 }; /*502C*/
const unsigned char  uc2_502D [] = {0x08, 0x30, 0x0B, 0xC0, 0x10, 0x80, 0x37, 0xF0, 0x52, 0xA0, 0x14, 0x90, 0x11, 0x00, 0x17, 0xF0, 0x12, 0x20, 0x11, 0xC0, 0x16, 0x20, 0x00, 0x00 }; /*502D*/
const unsigned char  uc2_502E [] = {0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x6F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x23, 0x80, 0x25, 0x40, 0x39, 0x30, 0x21, 0x00, 0x00, 0x00 }; /*502E*/
const unsigned char  uc2_503A [] = {0x10, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x63, 0xE0, 0x20, 0x80, 0x27, 0xF0, 0x22, 0x20, 0x22, 0xA0, 0x22, 0xA0, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*503A*/
const unsigned char  uc2_503C [] = {0x08, 0x80, 0x08, 0x80, 0x17, 0xF0, 0x31, 0x00, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x00, 0x00 }; /*503C*/
const unsigned char  uc2_503E [] = {0x10, 0x00, 0x19, 0xF0, 0x28, 0x40, 0x6E, 0x80, 0x29, 0xF0, 0x29, 0x50, 0x2B, 0x50, 0x2D, 0x50, 0x28, 0xA0, 0x20, 0x90, 0x23, 0x10, 0x00, 0x00 }; /*503E*/
const unsigned char  uc2_5043 [] = {0x17, 0xF0, 0x15, 0x20, 0x25, 0xE0, 0x65, 0x20, 0x25, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x25, 0x20, 0x24, 0xC0, 0x25, 0x20, 0x27, 0xF0, 0x00, 0x00 }; /*5043*/
const unsigned char  uc2_5047 [] = {0x10, 0x00, 0x1E, 0xE0, 0x2A, 0x20, 0x6A, 0x20, 0x2E, 0xE0, 0x28, 0x00, 0x2F, 0xE0, 0x28, 0xA0, 0x2E, 0xA0, 0x28, 0x40, 0x29, 0xB0, 0x00, 0x00 }; /*5047*/
const unsigned char  uc2_5048 [] = {0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x24, 0x20, 0x67, 0xE0, 0x22, 0x00, 0x23, 0xF0, 0x2C, 0x90, 0x25, 0x50, 0x27, 0xD0, 0x20, 0x60, 0x00, 0x00 }; /*5048*/
const unsigned char  uc2_504C [] = {0x12, 0x20, 0x17, 0xF0, 0x22, 0x20, 0x61, 0x00, 0x27, 0xF0, 0x21, 0x00, 0x23, 0xE0, 0x26, 0x20, 0x2A, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x00, 0x00 }; /*504C*/
const unsigned char  uc2_504E [] = {0x0B, 0xE0, 0x0A, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x33, 0xE0, 0x50, 0x00, 0x17, 0xF0, 0x12, 0x90, 0x12, 0xA0, 0x13, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*504E*/
const unsigned char  uc2_504F [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x67, 0xF0, 0x24, 0x00, 0x27, 0xF0, 0x25, 0x50, 0x27, 0xF0, 0x25, 0x50, 0x28, 0x20, 0x00, 0x00 }; /*504F*/
const unsigned char  uc2_5055 [] = {0x14, 0x90, 0x17, 0xE0, 0x24, 0x90, 0x67, 0x60, 0x21, 0x00, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x00, 0x00 }; /*5055*/
const unsigned char  uc2_505A [] = {0x14, 0x80, 0x14, 0xF0, 0x2E, 0xA0, 0x65, 0xA0, 0x24, 0xA0, 0x2E, 0xA0, 0x2A, 0x40, 0x2A, 0x40, 0x2E, 0xA0, 0x2A, 0xA0, 0x21, 0x10, 0x00, 0x00 }; /*505A*/
const unsigned char  uc2_505C [] = {0x13, 0x00, 0x10, 0x80, 0x2F, 0xF0, 0x64, 0x20, 0x27, 0xE0, 0x20, 0x00, 0x2F, 0xF0, 0x28, 0x10, 0x27, 0xE0, 0x20, 0x80, 0x23, 0x00, 0x00, 0x00 }; /*505C*/
const unsigned char  uc2_5065 [] = {0x10, 0x80, 0x1D, 0xE0, 0x24, 0xA0, 0x67, 0xF0, 0x28, 0xA0, 0x2D, 0xE0, 0x24, 0xA0, 0x37, 0xC0, 0x2C, 0xA0, 0x2B, 0x40, 0x31, 0xF0, 0x00, 0x00 }; /*5065*/
const unsigned char  uc2_506C [] = {0x14, 0x00, 0x17, 0xF0, 0x29, 0x50, 0x63, 0x50, 0x24, 0x90, 0x23, 0x60, 0x20, 0x80, 0x2A, 0xA0, 0x2A, 0x50, 0x32, 0x50, 0x21, 0x80, 0x00, 0x00 }; /*506C*/
const unsigned char  uc2_5076 [] = {0x0B, 0xE0, 0x0A, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x33, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x14, 0xD0, 0x17, 0xB0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*5076*/
const unsigned char  uc2_5077 [] = {0x11, 0x80, 0x12, 0x40, 0x2D, 0xB0, 0x60, 0x00, 0x27, 0x10, 0x25, 0x50, 0x27, 0x50, 0x25, 0x50, 0x27, 0x50, 0x25, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*5077*/
const unsigned char  uc2_507B [] = {0x19, 0x20, 0x15, 0x40, 0x2F, 0xF0, 0x65, 0x40, 0x28, 0x30, 0x21, 0x00, 0x2F, 0xF0, 0x22, 0x40, 0x26, 0x80, 0x21, 0x40, 0x2E, 0x20, 0x00, 0x00 }; /*507B*/
const unsigned char  uc2_507E [] = {0x10, 0x80, 0x17, 0xF0, 0x22, 0xA0, 0x67, 0xF0, 0x22, 0x20, 0x27, 0xF0, 0x24, 0x10, 0x24, 0x90, 0x24, 0x80, 0x21, 0x60, 0x26, 0x10, 0x00, 0x00 }; /*507E*/
const unsigned char  uc2_507F [] = {0x19, 0x20, 0x15, 0x20, 0x25, 0x40, 0x6F, 0xF0, 0x28, 0x10, 0x2B, 0xD0, 0x20, 0x00, 0x2F, 0xF0, 0x22, 0x40, 0x24, 0xA0, 0x27, 0x10, 0x00, 0x00 }; /*507F*/
const unsigned char  uc2_5080 [] = {0x11, 0x00, 0x12, 0x00, 0x2F, 0xE0, 0x69, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x40, 0x22, 0xB0, 0x24, 0xD0, 0x38, 0x60, 0x00, 0x00 }; /*5080*/
const unsigned char  uc2_5085 [] = {0x11, 0x40, 0x1F, 0xE0, 0x25, 0x40, 0x67, 0xC0, 0x25, 0x40, 0x27, 0xC0, 0x25, 0x40, 0x2F, 0xE0, 0x24, 0x40, 0x22, 0x40, 0x21, 0x80, 0x00, 0x00 }; /*5085*/
const unsigned char  uc2_5088 [] = {0x17, 0xF0, 0x11, 0x40, 0x27, 0xF0, 0x65, 0x50, 0x27, 0xF0, 0x20, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x21, 0xC0, 0x26, 0xB0, 0x20, 0x80, 0x00, 0x00 }; /*5088*/
const unsigned char  uc2_508D [] = {0x08, 0x80, 0x0F, 0xF0, 0x11, 0x40, 0x37, 0xF0, 0x54, 0x90, 0x10, 0x40, 0x17, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x12, 0x20, 0x1C, 0xC0, 0x00, 0x00 }; /*508D*/
const unsigned char  uc2_50A3 [] = {0x11, 0x00, 0x1F, 0xE0, 0x21, 0x00, 0x67, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x22, 0x40, 0x2D, 0x70, 0x23, 0x80, 0x2D, 0x40, 0x23, 0x40, 0x00, 0x00 }; /*50A3*/
const unsigned char  uc2_50A5 [] = {0x11, 0x00, 0x19, 0x20, 0x25, 0x40, 0x6F, 0xE0, 0x28, 0x20, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x22, 0x90, 0x24, 0x90, 0x38, 0x60, 0x00, 0x00 }; /*50A5*/
const unsigned char  uc2_50A7 [] = {0x12, 0x00, 0x11, 0x00, 0x2F, 0xE0, 0x68, 0xA0, 0x27, 0x00, 0x24, 0x00, 0x27, 0xE0, 0x24, 0x80, 0x2F, 0xF0, 0x22, 0x40, 0x2C, 0x20, 0x00, 0x00 }; /*50A7*/
const unsigned char  uc2_50A8 [] = {0x10, 0x80, 0x19, 0xD0, 0x28, 0xA0, 0x63, 0xF0, 0x38, 0x80, 0x29, 0xE0, 0x2B, 0x20, 0x29, 0xE0, 0x2D, 0x20, 0x29, 0xE0, 0x21, 0x20, 0x00, 0x00 }; /*50A8*/
const unsigned char  uc2_50A9 [] = {0x20, 0x80, 0x2C, 0xC0, 0x45, 0x20, 0x27, 0xF0, 0x35, 0x40, 0x29, 0xE0, 0x29, 0x40, 0x35, 0xE0, 0x35, 0x40, 0x21, 0xF0, 0x21, 0x00, 0x00, 0x00 }; /*50A9*/
const unsigned char  uc2_50AC [] = {0x10, 0x80, 0x14, 0xA0, 0x27, 0xE0, 0x62, 0x80, 0x27, 0xF0, 0x2C, 0x80, 0x27, 0xE0, 0x24, 0x80, 0x27, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x00, 0x00 }; /*50AC*/
const unsigned char  uc2_50B2 [] = {0x14, 0x80, 0x1E, 0xF0, 0x25, 0xA0, 0x6E, 0xA0, 0x24, 0xA0, 0x3F, 0xA0, 0x28, 0x40, 0x2E, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x37, 0x10, 0x00, 0x00 }; /*50B2*/
const unsigned char  uc2_50BA [] = {0x14, 0x80, 0x16, 0xE0, 0x2A, 0xA0, 0x66, 0xC0, 0x24, 0x40, 0x3B, 0xA0, 0x20, 0x10, 0x27, 0xE0, 0x25, 0x40, 0x29, 0x20, 0x23, 0x00, 0x00, 0x00 }; /*50BA*/
const unsigned char  uc2_50BB [] = {0x11, 0x00, 0x17, 0xF0, 0x25, 0x50, 0x64, 0x90, 0x25, 0x50, 0x27, 0xF0, 0x25, 0x20, 0x39, 0xD0, 0x23, 0x50, 0x20, 0x80, 0x27, 0x70, 0x00, 0x00 }; /*50BB*/
const unsigned char  uc2_50CF [] = {0x13, 0x80, 0x14, 0x80, 0x2F, 0xE0, 0x65, 0x20, 0x27, 0xE0, 0x22, 0x00, 0x2D, 0x20, 0x22, 0xC0, 0x2D, 0xA0, 0x22, 0x90, 0x25, 0x00, 0x00, 0x00 }; /*50CF*/
const unsigned char  uc2_50D6 [] = {0x08, 0x80, 0x0F, 0xF0, 0x10, 0x80, 0x37, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x11, 0x40, 0x17, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*50D6*/
const unsigned char  uc2_50DA [] = {0x11, 0x00, 0x1F, 0xE0, 0x2A, 0xA0, 0x64, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x25, 0x40, 0x2B, 0x20, 0x00, 0x00 }; /*50DA*/
const unsigned char  uc2_50E6 [] = {0x14, 0xA0, 0x1E, 0x90, 0x21, 0xF0, 0x6E, 0xA0, 0x2A, 0xA0, 0x2E, 0xA0, 0x24, 0xA0, 0x2E, 0xA0, 0x35, 0xA0, 0x25, 0x20, 0x2A, 0x10, 0x00, 0x00 }; /*50E6*/
const unsigned char  uc2_50E7 [] = {0x0A, 0x20, 0x09, 0x40, 0x17, 0xF0, 0x36, 0xB0, 0x55, 0xD0, 0x14, 0x90, 0x17, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*50E7*/
const unsigned char  uc2_50EC [] = {0x12, 0x80, 0x13, 0xF0, 0x24, 0x80, 0x6F, 0xE0, 0x24, 0x80, 0x27, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x22, 0xA0, 0x25, 0x50, 0x29, 0x50, 0x00, 0x00 }; /*50EC*/
const unsigned char  uc2_50ED [] = {0x17, 0xE0, 0x29, 0x40, 0x6F, 0xF0, 0x22, 0x40, 0x25, 0x50, 0x2A, 0xA0, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x00, 0x00 }; /*50ED*/
const unsigned char  uc2_50EE [] = {0x09, 0x80, 0x08, 0x40, 0x17, 0xF0, 0x31, 0x40, 0x57, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*50EE*/
const unsigned char  uc2_50F3 [] = {0x1F, 0xE0, 0x12, 0x80, 0x2F, 0xE0, 0x6A, 0xA0, 0x2F, 0xE0, 0x29, 0x20, 0x25, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x39, 0x30, 0x21, 0x00, 0x00, 0x00 }; /*50F3*/
const unsigned char  uc2_50F5 [] = {0x0F, 0xF0, 0x0A, 0xA0, 0x13, 0xE0, 0x32, 0xA0, 0x57, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x17, 0xF0, 0x00, 0x00 }; /*50F5*/
const unsigned char  uc2_50FB [] = {0x2E, 0x40, 0x2B, 0xF0, 0x2A, 0xA0, 0x2E, 0xA0, 0x68, 0x40, 0x29, 0xF0, 0x2E, 0x40, 0x2A, 0xE0, 0x3A, 0x40, 0x2E, 0x40, 0x2A, 0x40, 0x00, 0x00 }; /*50FB*/
const unsigned char  uc2_5106 [] = {0x15, 0x40, 0x1F, 0xC0, 0x25, 0x70, 0x68, 0xD0, 0x2F, 0x50, 0x31, 0x50, 0x2D, 0x50, 0x2B, 0x20, 0x2D, 0x20, 0x29, 0x50, 0x26, 0x50, 0x00, 0x00 }; /*5106*/
const unsigned char  uc2_5107 [] = {0x1F, 0xE0, 0x2A, 0xA0, 0x6F, 0xF0, 0x20, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x22, 0x80, 0x2C, 0xA0, 0x25, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*5107*/
const unsigned char  uc2_510B [] = {0x11, 0x00, 0x11, 0xC0, 0x22, 0x40, 0x6F, 0xF0, 0x25, 0x20, 0x26, 0x90, 0x25, 0xF0, 0x24, 0xA0, 0x25, 0xE0, 0x25, 0x20, 0x29, 0xE0, 0x00, 0x00 }; /*510B*/
const unsigned char  uc2_5112 [] = {0x17, 0xF0, 0x10, 0x80, 0x27, 0xF0, 0x64, 0x90, 0x22, 0xA0, 0x20, 0x00, 0x27, 0xF0, 0x20, 0x80, 0x27, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x00, 0x00 }; /*5112*/
const unsigned char  uc2_5121 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0xA0, 0x73, 0xE0, 0x12, 0xA0, 0x17, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x14, 0x90, 0x00, 0x00 }; /*5121*/
const unsigned char  uc2_513F [] = {0x00, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*513F*/
const unsigned char  uc2_5140 [] = {0x00, 0x00, 0x3F, 0xF0, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x08, 0x90, 0x08, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*5140*/
const unsigned char  uc2_5141 [] = {0x04, 0x00, 0x04, 0x80, 0x08, 0x40, 0x11, 0xA0, 0x1E, 0xA0, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*5141*/
const unsigned char  uc2_5143 [] = {0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xE0, 0x09, 0x00, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5143*/
const unsigned char  uc2_5144 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x05, 0x00, 0x05, 0x00, 0x09, 0x10, 0x09, 0x10, 0x10, 0xE0, 0x60, 0x00, 0x00, 0x00 }; /*5144*/
const unsigned char  uc2_5145 [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x08, 0x80, 0x10, 0xC0, 0x1F, 0x40, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5145*/
const unsigned char  uc2_5146 [] = {0x05, 0x00, 0x25, 0x20, 0x15, 0x20, 0x15, 0x40, 0x05, 0x00, 0x15, 0x40, 0x15, 0x20, 0x65, 0x20, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5146*/
const unsigned char  uc2_5148 [] = {0x02, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x62, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5148*/
const unsigned char  uc2_5149 [] = {0x02, 0x00, 0x32, 0x20, 0x0A, 0x20, 0x0A, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5149*/
const unsigned char  uc2_514B [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*514B*/
const unsigned char  uc2_514D [] = {0x08, 0x00, 0x0F, 0x00, 0x11, 0x00, 0x3F, 0xC0, 0x52, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x03, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*514D*/
const unsigned char  uc2_5151 [] = {0x30, 0x80, 0x08, 0x80, 0x09, 0x00, 0x3F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x3F, 0xC0, 0x09, 0x10, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5151*/
const unsigned char  uc2_5154 [] = {0x08, 0x00, 0x0F, 0x00, 0x11, 0x00, 0x3F, 0xC0, 0x52, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x03, 0x00, 0x05, 0x90, 0x09, 0x50, 0x70, 0xE0, 0x00, 0x00 }; /*5154*/
const unsigned char  uc2_5155 [] = {0x00, 0x00, 0x3D, 0xE0, 0x25, 0x20, 0x27, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5155*/
const unsigned char  uc2_5156 [] = {0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x12, 0x60, 0x64, 0x90, 0x08, 0xC0, 0x0F, 0x40, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5156*/
const unsigned char  uc2_515A [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x4F, 0x90, 0x08, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*515A*/
const unsigned char  uc2_515C [] = {0x01, 0x00, 0x0A, 0x00, 0x37, 0xB0, 0x24, 0x90, 0x27, 0x90, 0x2C, 0x90, 0x37, 0xB0, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*515C*/
const unsigned char  uc2_5162 [] = {0x10, 0x80, 0x7D, 0xE0, 0x10, 0x80, 0x7D, 0xE0, 0x45, 0x20, 0x7D, 0xE0, 0x29, 0x40, 0x29, 0x40, 0x2D, 0x50, 0x49, 0x50, 0x42, 0x60, 0x00, 0x00 }; /*5162*/
const unsigned char  uc2_5165 [] = {0x18, 0x00, 0x04, 0x00, 0x04, 0x00, 0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*5165*/
const unsigned char  uc2_5168 [] = {0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x0F, 0x80, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5168*/
const unsigned char  uc2_516B [] = {0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x20, 0x20, 0x20, 0x20, 0x40, 0x10, 0x00, 0x00 }; /*516B*/
const unsigned char  uc2_516C [] = {0x00, 0x80, 0x08, 0x80, 0x08, 0x40, 0x12, 0x40, 0x12, 0x20, 0x64, 0x10, 0x04, 0x80, 0x08, 0x80, 0x11, 0x40, 0x1E, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*516C*/
const unsigned char  uc2_516D [] = {0x0C, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x08, 0x80, 0x08, 0x40, 0x10, 0x40, 0x10, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*516D*/
const unsigned char  uc2_516E [] = {0x08, 0x80, 0x08, 0x80, 0x08, 0x40, 0x10, 0x20, 0x6F, 0xD0, 0x04, 0x00, 0x08, 0x00, 0x0F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*516E*/
const unsigned char  uc2_5170 [] = {0x10, 0x40, 0x08, 0x40, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5170*/
const unsigned char  uc2_5171 [] = {0x08, 0x80, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x08, 0xC0, 0x10, 0x20, 0x60, 0x10, 0x00, 0x00 }; /*5171*/
const unsigned char  uc2_5173 [] = {0x18, 0x80, 0x05, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*5173*/
const unsigned char  uc2_5174 [] = {0x04, 0x20, 0x22, 0x20, 0x12, 0x40, 0x10, 0x80, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x08, 0x80, 0x08, 0x40, 0x10, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*5174*/
const unsigned char  uc2_5175 [] = {0x00, 0x60, 0x0F, 0x80, 0x08, 0x00, 0x0F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x08, 0xC0, 0x10, 0x20, 0x60, 0x10, 0x00, 0x00 }; /*5175*/
const unsigned char  uc2_5176 [] = {0x08, 0x80, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x30, 0x40, 0x00, 0x00 }; /*5176*/
const unsigned char  uc2_5177 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x30, 0x20, 0x00, 0x00 }; /*5177*/
const unsigned char  uc2_5178 [] = {0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x08, 0x40, 0x10, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*5178*/
const unsigned char  uc2_5179 [] = {0x10, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x49, 0x20, 0x71, 0xC0, 0x10, 0x40, 0x28, 0xA0, 0x49, 0x20, 0x75, 0xD0, 0x00, 0x00 }; /*5179*/
const unsigned char  uc2_517B [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x65, 0x30, 0x09, 0x00, 0x31, 0x00, 0x00, 0x00 }; /*517B*/
const unsigned char  uc2_517C [] = {0x08, 0x80, 0x3F, 0xE0, 0x05, 0x00, 0x1F, 0xC0, 0x05, 0x40, 0x7F, 0xF0, 0x05, 0x40, 0x1F, 0xC0, 0x0D, 0x80, 0x75, 0x70, 0x05, 0x00, 0x00, 0x00 }; /*517C*/
const unsigned char  uc2_517D [] = {0x08, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*517D*/
const unsigned char  uc2_5180 [] = {0x08, 0x80, 0x38, 0xE0, 0x08, 0x90, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x00, 0x00 }; /*5180*/
const unsigned char  uc2_5181 [] = {0x47, 0xE0, 0x28, 0x20, 0x7F, 0xE0, 0x55, 0x40, 0x7F, 0xE0, 0x55, 0x40, 0x7F, 0xF0, 0x15, 0x50, 0x7D, 0x20, 0x15, 0xA0, 0x19, 0x10, 0x00, 0x00 }; /*5181*/
const unsigned char  uc2_5185 [] = {0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x42, 0x10, 0x45, 0x90, 0x48, 0x50, 0x70, 0x50, 0x40, 0x10, 0x40, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*5185*/
const unsigned char  uc2_5188 [] = {0x7F, 0xF0, 0x40, 0x10, 0x40, 0x90, 0x58, 0x90, 0x45, 0x10, 0x42, 0x10, 0x45, 0x10, 0x48, 0x90, 0x50, 0x90, 0x40, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*5188*/
const unsigned char  uc2_5189 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x7F, 0xF0, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*5189*/
const unsigned char  uc2_518C [] = {0x3D, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x2D, 0x20, 0x42, 0xC0, 0x00, 0x00 }; /*518C*/
const unsigned char  uc2_518D [] = {0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*518D*/
const unsigned char  uc2_5192 [] = {0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x20, 0x20, 0x2F, 0xA0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*5192*/
const unsigned char  uc2_5195 [] = {0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x20, 0x20, 0x2F, 0xA0, 0x11, 0x00, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x03, 0x10, 0x7C, 0xE0, 0x00, 0x00 }; /*5195*/
const unsigned char  uc2_5197 [] = {0x7F, 0xE0, 0x40, 0x20, 0x40, 0x20, 0x0F, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5197*/
const unsigned char  uc2_5199 [] = {0x3F, 0xF0, 0x20, 0x10, 0x28, 0x10, 0x0F, 0xC0, 0x08, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x7F, 0x20, 0x00, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*5199*/
const unsigned char  uc2_519B [] = {0x7F, 0xF0, 0x40, 0x10, 0x44, 0x10, 0x3F, 0xE0, 0x08, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*519B*/
const unsigned char  uc2_519C [] = {0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x44, 0x10, 0x06, 0x00, 0x09, 0x20, 0x19, 0x20, 0x68, 0xC0, 0x0A, 0x80, 0x0C, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*519C*/
const unsigned char  uc2_51A0 [] = {0x7F, 0xF0, 0x40, 0x10, 0x40, 0x50, 0x1D, 0xE0, 0x00, 0x40, 0x3E, 0x40, 0x15, 0x40, 0x14, 0x40, 0x25, 0x90, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*51A0*/
const unsigned char  uc2_51A2 [] = {0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x02, 0x00, 0x0D, 0x20, 0x73, 0xA0, 0x0D, 0x40, 0x7B, 0x40, 0x0D, 0x20, 0x71, 0x10, 0x06, 0x00, 0x00, 0x00 }; /*51A2*/
const unsigned char  uc2_51A4 [] = {0x7F, 0xF0, 0x48, 0x10, 0x4F, 0x10, 0x11, 0x00, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x03, 0x00, 0x05, 0x90, 0x19, 0x50, 0x60, 0xE0, 0x00, 0x00 }; /*51A4*/
const unsigned char  uc2_51A5 [] = {0x7F, 0xF0, 0x50, 0x50, 0x5F, 0xD0, 0x10, 0x40, 0x1F, 0xC0, 0x04, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x08, 0xC0, 0x70, 0x30, 0x00, 0x00 }; /*51A5*/
const unsigned char  uc2_51AC [] = {0x08, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x35, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x66, 0x30, 0x01, 0x80, 0x1E, 0x00, 0x01, 0x80, 0x00, 0x00 }; /*51AC*/
const unsigned char  uc2_51AF [] = {0x07, 0xE0, 0x40, 0x20, 0x22, 0x20, 0x22, 0x20, 0x04, 0x40, 0x17, 0xF0, 0x10, 0x10, 0x2F, 0xD0, 0x20, 0x10, 0x40, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*51AF*/
const unsigned char  uc2_51B0 [] = {0x01, 0x00, 0x41, 0x00, 0x21, 0x10, 0x3D, 0xA0, 0x05, 0x40, 0x25, 0x40, 0x25, 0x40, 0x29, 0x20, 0x49, 0x10, 0x51, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*51B0*/
const unsigned char  uc2_51B1 [] = {0x4F, 0xF0, 0x22, 0x00, 0x22, 0x00, 0x23, 0xE0, 0x02, 0x20, 0x14, 0x20, 0x14, 0x40, 0x27, 0xC0, 0x20, 0x40, 0x40, 0x40, 0x0F, 0xF0, 0x00, 0x00 }; /*51B1*/
const unsigned char  uc2_51B2 [] = {0x00, 0x80, 0x60, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x04, 0x90, 0x04, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x20, 0x80, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*51B2*/
const unsigned char  uc2_51B3 [] = {0x01, 0x00, 0x41, 0x00, 0x27, 0xC0, 0x21, 0x40, 0x01, 0x40, 0x01, 0x40, 0x2F, 0xF0, 0x21, 0x00, 0x22, 0x80, 0x44, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*51B3*/
const unsigned char  uc2_51B5 [] = {0x00, 0x00, 0x27, 0xC0, 0x14, 0x40, 0x14, 0x40, 0x04, 0x40, 0x17, 0xC0, 0x12, 0x80, 0x22, 0x80, 0x22, 0x90, 0x44, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*51B5*/
const unsigned char  uc2_51B6 [] = {0x01, 0x00, 0x42, 0x40, 0x24, 0x20, 0x28, 0xD0, 0x0F, 0x10, 0x00, 0x00, 0x27, 0xE0, 0x24, 0x20, 0x24, 0x20, 0x47, 0xE0, 0x04, 0x20, 0x00, 0x00 }; /*51B6*/
const unsigned char  uc2_51B7 [] = {0x01, 0x00, 0x42, 0x80, 0x24, 0x40, 0x3A, 0x30, 0x01, 0x00, 0x0F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x26, 0x80, 0x41, 0x00, 0x40, 0x80, 0x00, 0x00 }; /*51B7*/
const unsigned char  uc2_51BB [] = {0x01, 0x00, 0x4F, 0xF0, 0x22, 0x00, 0x22, 0x80, 0x04, 0x80, 0x07, 0xF0, 0x20, 0x80, 0x24, 0xA0, 0x24, 0x90, 0x48, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*51BB*/
const unsigned char  uc2_51BC [] = {0x01, 0x00, 0x45, 0x00, 0x27, 0xE0, 0x29, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x22, 0x80, 0x22, 0x90, 0x22, 0x90, 0x44, 0x90, 0x58, 0x60, 0x00, 0x00 }; /*51BC*/
const unsigned char  uc2_51BD [] = {0x1F, 0x90, 0x44, 0x50, 0x24, 0x50, 0x27, 0x50, 0x05, 0x50, 0x25, 0x50, 0x2B, 0x50, 0x21, 0x50, 0x42, 0x50, 0x44, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*51BD*/
const unsigned char  uc2_51C0 [] = {0x04, 0x00, 0x47, 0x80, 0x28, 0x80, 0x27, 0xE0, 0x01, 0x20, 0x1F, 0xF0, 0x21, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x41, 0x00, 0x46, 0x00, 0x00, 0x00 }; /*51C0*/
const unsigned char  uc2_51C4 [] = {0x41, 0x00, 0x2F, 0xF0, 0x21, 0x20, 0x1F, 0xF0, 0x01, 0x20, 0x0F, 0xE0, 0x21, 0x00, 0x2F, 0xF0, 0x24, 0x40, 0x43, 0xA0, 0x5C, 0x10, 0x00, 0x00 }; /*51C4*/
const unsigned char  uc2_51C6 [] = {0x03, 0x00, 0x42, 0x80, 0x24, 0x80, 0x27, 0xF0, 0x0C, 0x80, 0x07, 0xE0, 0x14, 0x80, 0x17, 0xE0, 0x24, 0x80, 0x47, 0xF0, 0x04, 0x00, 0x00, 0x00 }; /*51C6*/
const unsigned char  uc2_51C7 [] = {0x44, 0xA0, 0x24, 0xA0, 0x3F, 0xA0, 0x24, 0x90, 0x05, 0x50, 0x06, 0x40, 0x2D, 0x40, 0x34, 0xA0, 0x25, 0x20, 0x45, 0xD0, 0x44, 0x10, 0x00, 0x00 }; /*51C7*/
const unsigned char  uc2_51C9 [] = {0x43, 0x00, 0x20, 0x80, 0x2F, 0xE0, 0x00, 0x00, 0x07, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x45, 0x60, 0x59, 0x10, 0x06, 0x00, 0x00, 0x00 }; /*51C9*/
const unsigned char  uc2_51CB [] = {0x47, 0xF0, 0x24, 0x90, 0x25, 0xD0, 0x24, 0x90, 0x07, 0xF0, 0x04, 0x10, 0x25, 0xD0, 0x25, 0x50, 0x29, 0xD0, 0x48, 0x10, 0x50, 0x60, 0x00, 0x00 }; /*51CB*/
const unsigned char  uc2_51CC [] = {0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x1F, 0xF0, 0x04, 0x20, 0x1A, 0x10, 0x23, 0xD0, 0x2E, 0x40, 0x21, 0x80, 0x42, 0x40, 0x5C, 0x30, 0x00, 0x00 }; /*51CC*/
const unsigned char  uc2_51CF [] = {0x40, 0xC0, 0x20, 0xA0, 0x2F, 0xF0, 0x08, 0x80, 0x0F, 0xA0, 0x08, 0xA0, 0x2E, 0xA0, 0x2A, 0xC0, 0x2E, 0x90, 0x49, 0x50, 0x56, 0x20, 0x00, 0x00 }; /*51CF*/
const unsigned char  uc2_51D1 [] = {0x01, 0x00, 0x4F, 0xE0, 0x21, 0x00, 0x27, 0xC0, 0x02, 0x00, 0x1F, 0xF0, 0x28, 0x20, 0x37, 0xD0, 0x21, 0x00, 0x5F, 0xF0, 0x04, 0x40, 0x00, 0x00 }; /*51D1*/
const unsigned char  uc2_51DB [] = {0x01, 0x00, 0x5F, 0xF0, 0x2A, 0xA0, 0x2B, 0xA0, 0x08, 0x20, 0x0F, 0xE0, 0x20, 0x00, 0x3F, 0xF0, 0x29, 0x40, 0x49, 0x20, 0x53, 0x20, 0x00, 0x00 }; /*51DB*/
const unsigned char  uc2_51DD [] = {0x4A, 0xE0, 0x2C, 0x20, 0x28, 0xC0, 0x06, 0x20, 0x09, 0xF0, 0x2E, 0x50, 0x35, 0x50, 0x2F, 0x60, 0x25, 0x40, 0x4B, 0xC0, 0x12, 0x30, 0x00, 0x00 }; /*51DD*/
const unsigned char  uc2_51E0 [] = {0x00, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x90, 0x10, 0x90, 0x20, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*51E0*/
const unsigned char  uc2_51E1 [] = {0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x0C, 0x80, 0x0A, 0x80, 0x0A, 0x80, 0x0A, 0x80, 0x10, 0x90, 0x10, 0x90, 0x20, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*51E1*/
const unsigned char  uc2_51E4 [] = {0x3F, 0xC0, 0x20, 0x40, 0x2F, 0x40, 0x21, 0x40, 0x2D, 0x40, 0x22, 0x40, 0x25, 0x40, 0x29, 0x40, 0x30, 0x50, 0x40, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*51E4*/
const unsigned char  uc2_51EB [] = {0x04, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x2C, 0x80, 0x23, 0x00, 0x3F, 0xE0, 0x00, 0x20, 0x1F, 0x20, 0x11, 0x50, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*51EB*/
const unsigned char  uc2_51ED [] = {0x08, 0x60, 0x0B, 0x80, 0x10, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x00, 0x07, 0x80, 0x04, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*51ED*/
const unsigned char  uc2_51EF [] = {0x10, 0x00, 0x55, 0xC0, 0x55, 0x40, 0x7D, 0x40, 0x01, 0x40, 0x7D, 0x40, 0x05, 0x40, 0x7D, 0x50, 0x41, 0x50, 0x4D, 0x50, 0x72, 0x20, 0x00, 0x00 }; /*51EF*/
const unsigned char  uc2_51F0 [] = {0x1F, 0xC0, 0x12, 0x40, 0x17, 0x40, 0x15, 0x40, 0x17, 0x40, 0x15, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x27, 0x50, 0x22, 0x50, 0x4F, 0xA0, 0x00, 0x00 }; /*51F0*/
const unsigned char  uc2_51F3 [] = {0x3C, 0xA0, 0x04, 0xC0, 0x2F, 0x90, 0x10, 0x60, 0x6F, 0xA0, 0x08, 0x90, 0x0F, 0x80, 0x05, 0x00, 0x3F, 0xE0, 0x05, 0x10, 0x78, 0xE0, 0x00, 0x00 }; /*51F3*/
const unsigned char  uc2_51F6 [] = {0x00, 0x40, 0x58, 0x50, 0x44, 0x90, 0x42, 0x90, 0x41, 0x10, 0x42, 0x90, 0x44, 0x50, 0x58, 0x50, 0x40, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*51F6*/
const unsigned char  uc2_51F8 [] = {0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x78, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*51F8*/
const unsigned char  uc2_51F9 [] = {0x78, 0xF0, 0x48, 0x90, 0x48, 0x90, 0x48, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*51F9*/
const unsigned char  uc2_51FA [] = {0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*51FA*/
const unsigned char  uc2_51FB [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*51FB*/
const unsigned char  uc2_51FC [] = {0x02, 0x00, 0x42, 0x10, 0x42, 0x50, 0x7B, 0x90, 0x4A, 0x90, 0x52, 0x50, 0x62, 0x50, 0x4C, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*51FC*/
const unsigned char  uc2_51FD [] = {0x0F, 0x00, 0x01, 0x40, 0x42, 0x50, 0x5A, 0x90, 0x46, 0x10, 0x4A, 0x90, 0x72, 0x50, 0x4C, 0x50, 0x40, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*51FD*/
const unsigned char  uc2_51FF [] = {0x25, 0x20, 0x15, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x25, 0x20, 0x2F, 0xA0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*51FF*/
const unsigned char  uc2_5200 [] = {0x3F, 0xF0, 0x02, 0x10, 0x02, 0x10, 0x02, 0x10, 0x02, 0x10, 0x02, 0x10, 0x04, 0x10, 0x04, 0x10, 0x08, 0x10, 0x10, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5200*/
const unsigned char  uc2_5201 [] = {0x3F, 0xF0, 0x00, 0x10, 0x00, 0x10, 0x00, 0x50, 0x00, 0x90, 0x03, 0x10, 0x0C, 0x10, 0x70, 0x10, 0x00, 0x10, 0x00, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*5201*/
const unsigned char  uc2_5203 [] = {0x1F, 0xF0, 0x01, 0x10, 0x01, 0x10, 0x09, 0x10, 0x09, 0x10, 0x11, 0x10, 0x22, 0x10, 0x02, 0x10, 0x04, 0x10, 0x18, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5203*/
const unsigned char  uc2_5206 [] = {0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x1F, 0xC0, 0x04, 0x40, 0x04, 0x40, 0x08, 0x40, 0x08, 0x40, 0x10, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*5206*/
const unsigned char  uc2_5207 [] = {0x10, 0x00, 0x13, 0xF0, 0x10, 0x90, 0x1C, 0x90, 0x70, 0x90, 0x10, 0x90, 0x10, 0x90, 0x15, 0x10, 0x19, 0x10, 0x02, 0x10, 0x0C, 0xE0, 0x00, 0x00 }; /*5207*/
const unsigned char  uc2_5208 [] = {0x02, 0x10, 0x02, 0x10, 0x62, 0x90, 0x12, 0x90, 0x0C, 0x90, 0x04, 0x90, 0x04, 0x90, 0x0A, 0x90, 0x09, 0x10, 0x11, 0x10, 0x60, 0x60, 0x00, 0x00 }; /*5208*/
const unsigned char  uc2_520A [] = {0x00, 0x10, 0x3E, 0x10, 0x08, 0x90, 0x08, 0x90, 0x08, 0x90, 0x7F, 0x90, 0x08, 0x90, 0x08, 0x90, 0x08, 0x90, 0x08, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*520A*/
const unsigned char  uc2_520D [] = {0x04, 0x00, 0x07, 0xC0, 0x04, 0x40, 0x08, 0x80, 0x1F, 0xF0, 0x60, 0x10, 0x0F, 0xF0, 0x00, 0x10, 0x00, 0x10, 0x1F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*520D*/
const unsigned char  uc2_520E [] = {0x20, 0x10, 0x20, 0x50, 0x3F, 0x50, 0x55, 0x50, 0x15, 0x50, 0x15, 0x50, 0x25, 0x50, 0x49, 0x50, 0x11, 0x50, 0x62, 0x10, 0x0C, 0x60, 0x00, 0x00 }; /*520E*/
const unsigned char  uc2_5211 [] = {0x00, 0x10, 0x3F, 0x10, 0x12, 0x50, 0x12, 0x50, 0x12, 0x50, 0x7F, 0xD0, 0x12, 0x50, 0x12, 0x50, 0x22, 0x50, 0x22, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*5211*/
const unsigned char  uc2_5212 [] = {0x10, 0x10, 0x14, 0x50, 0x12, 0x50, 0x17, 0x50, 0x78, 0x50, 0x12, 0x50, 0x12, 0x50, 0x0A, 0x50, 0x0C, 0x90, 0x74, 0x90, 0x03, 0x60, 0x00, 0x00 }; /*5212*/
const unsigned char  uc2_5216 [] = {0x00, 0x10, 0x1E, 0x10, 0x12, 0x50, 0x12, 0x50, 0x1E, 0x50, 0x12, 0x50, 0x1E, 0x50, 0x12, 0x50, 0x22, 0x10, 0x22, 0x10, 0x4C, 0x60, 0x00, 0x00 }; /*5216*/
const unsigned char  uc2_5217 [] = {0x00, 0x10, 0x3F, 0x10, 0x08, 0x90, 0x08, 0x90, 0x0E, 0x90, 0x12, 0x90, 0x6A, 0x90, 0x04, 0x90, 0x04, 0x90, 0x18, 0x10, 0x60, 0x60, 0x00, 0x00 }; /*5217*/
const unsigned char  uc2_5218 [] = {0x30, 0x10, 0x08, 0x10, 0x00, 0x90, 0x7E, 0x90, 0x04, 0x90, 0x64, 0x90, 0x18, 0x90, 0x0C, 0x90, 0x12, 0x10, 0x22, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*5218*/
const unsigned char  uc2_5219 [] = {0x00, 0x10, 0x3E, 0x10, 0x22, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x14, 0x10, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*5219*/
const unsigned char  uc2_521A [] = {0x00, 0x10, 0x7F, 0x10, 0x41, 0x50, 0x65, 0x50, 0x55, 0x50, 0x49, 0x50, 0x55, 0x50, 0x65, 0x50, 0x41, 0x10, 0x41, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*521A*/
const unsigned char  uc2_521B [] = {0x08, 0x10, 0x0C, 0x10, 0x12, 0x50, 0x21, 0x50, 0x41, 0x50, 0x3E, 0x50, 0x22, 0x50, 0x22, 0x50, 0x2D, 0x10, 0x21, 0x10, 0x1E, 0x60, 0x00, 0x00 }; /*521B*/
const unsigned char  uc2_521D [] = {0x60, 0x00, 0x13, 0xF0, 0x78, 0x90, 0x08, 0x90, 0x14, 0x90, 0x38, 0x90, 0x54, 0x90, 0x15, 0x10, 0x11, 0x10, 0x12, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*521D*/
const unsigned char  uc2_5220 [] = {0x00, 0x10, 0x36, 0x10, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x7F, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x4A, 0x10, 0x54, 0x60, 0x00, 0x00 }; /*5220*/
const unsigned char  uc2_5224 [] = {0x49, 0x10, 0x29, 0x10, 0x2A, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x08, 0x50, 0x10, 0x10, 0x60, 0x60, 0x00, 0x00 }; /*5224*/
const unsigned char  uc2_5228 [] = {0x20, 0x10, 0x20, 0x10, 0x3E, 0x50, 0x42, 0x50, 0x3A, 0x50, 0x2A, 0x50, 0x3A, 0x50, 0x22, 0x50, 0x2D, 0x10, 0x21, 0x10, 0x1E, 0x60, 0x00, 0x00 }; /*5228*/
const unsigned char  uc2_5229 [] = {0x06, 0x10, 0x38, 0x10, 0x08, 0x90, 0x08, 0x90, 0x7E, 0x90, 0x08, 0x90, 0x1C, 0x90, 0x2A, 0x90, 0x2A, 0x10, 0x48, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*5229*/
const unsigned char  uc2_522B [] = {0x00, 0x10, 0x1F, 0x10, 0x11, 0x50, 0x11, 0x50, 0x1F, 0x50, 0x04, 0x50, 0x3F, 0x50, 0x05, 0x50, 0x09, 0x50, 0x11, 0x10, 0x66, 0x60, 0x00, 0x00 }; /*522B*/
const unsigned char  uc2_522D [] = {0x3E, 0x10, 0x02, 0x50, 0x04, 0x50, 0x1A, 0x50, 0x61, 0x50, 0x00, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x08, 0x10, 0x0F, 0x10, 0x70, 0x60, 0x00, 0x00 }; /*522D*/
const unsigned char  uc2_522E [] = {0x06, 0x10, 0x38, 0x10, 0x08, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x22, 0x50, 0x22, 0x10, 0x3E, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*522E*/
const unsigned char  uc2_5230 [] = {0x00, 0x10, 0x7F, 0x10, 0x08, 0x50, 0x12, 0x50, 0x23, 0x50, 0x3D, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x0F, 0x10, 0x70, 0x60, 0x00, 0x00 }; /*5230*/
const unsigned char  uc2_5233 [] = {0x08, 0x10, 0x7F, 0x10, 0x14, 0x50, 0x62, 0x50, 0x3E, 0x50, 0x00, 0x50, 0x7F, 0x50, 0x10, 0x50, 0x3E, 0x10, 0x02, 0x10, 0x1C, 0x60, 0x00, 0x00 }; /*5233*/
const unsigned char  uc2_5236 [] = {0x28, 0x10, 0x3E, 0x10, 0x28, 0x50, 0x48, 0x50, 0x7F, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x2A, 0x10, 0x2E, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*5236*/
const unsigned char  uc2_5237 [] = {0x00, 0x10, 0x3F, 0x10, 0x21, 0x50, 0x3F, 0x50, 0x24, 0x50, 0x24, 0x50, 0x5F, 0x50, 0x55, 0x50, 0x55, 0x10, 0x56, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*5237*/
const unsigned char  uc2_5238 [] = {0x12, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x04, 0x80, 0x08, 0x80, 0x73, 0x00, 0x00, 0x00 }; /*5238*/
const unsigned char  uc2_5239 [] = {0x02, 0x10, 0x72, 0x10, 0x0C, 0x50, 0x12, 0x50, 0x6A, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x2A, 0x50, 0x29, 0x50, 0x49, 0x10, 0x30, 0x60, 0x00, 0x00 }; /*5239*/
const unsigned char  uc2_523A [] = {0x08, 0x10, 0x7F, 0x10, 0x08, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x1C, 0x50, 0x2A, 0x10, 0x4A, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*523A*/
const unsigned char  uc2_523B [] = {0x18, 0x10, 0x04, 0x10, 0x3F, 0x50, 0x08, 0x50, 0x12, 0x50, 0x1C, 0x50, 0x09, 0x50, 0x72, 0x50, 0x06, 0x10, 0x19, 0x10, 0x61, 0x60, 0x00, 0x00 }; /*523B*/
const unsigned char  uc2_523D [] = {0x08, 0x10, 0x0C, 0x10, 0x12, 0x50, 0x61, 0x50, 0x1D, 0x50, 0x00, 0x50, 0x3F, 0x50, 0x12, 0x50, 0x26, 0x10, 0x39, 0x10, 0x01, 0x60, 0x00, 0x00 }; /*523D*/
const unsigned char  uc2_523F [] = {0x08, 0x10, 0x49, 0x10, 0x49, 0x50, 0x7F, 0x50, 0x10, 0x50, 0x1E, 0x50, 0x12, 0x50, 0x6A, 0x50, 0x04, 0x10, 0x08, 0x10, 0x70, 0x60, 0x00, 0x00 }; /*523F*/
const unsigned char  uc2_5240 [] = {0x08, 0x10, 0x2A, 0x10, 0x2A, 0x90, 0x3E, 0x90, 0x00, 0x90, 0x7E, 0x90, 0x02, 0x90, 0x3E, 0x90, 0x20, 0x10, 0x2E, 0x10, 0x30, 0x60, 0x00, 0x00 }; /*5240*/
const unsigned char  uc2_5241 [] = {0x1C, 0x10, 0x14, 0x10, 0x14, 0x50, 0x63, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x08, 0x50, 0x1C, 0x50, 0x2A, 0x50, 0x2A, 0x10, 0x48, 0x60, 0x00, 0x00 }; /*5241*/
const unsigned char  uc2_5242 [] = {0x10, 0x10, 0x08, 0x10, 0x7F, 0x50, 0x02, 0x50, 0x34, 0x50, 0x0C, 0x50, 0x32, 0x50, 0x55, 0x50, 0x14, 0x10, 0x14, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*5242*/
const unsigned char  uc2_5243 [] = {0x22, 0x10, 0x14, 0x50, 0x7F, 0x50, 0x09, 0x50, 0x3F, 0x50, 0x48, 0x50, 0x7F, 0x50, 0x19, 0x50, 0x29, 0x50, 0x2A, 0x10, 0x48, 0x60, 0x00, 0x00 }; /*5243*/
const unsigned char  uc2_524A [] = {0x49, 0x10, 0x29, 0x50, 0x2A, 0x50, 0x08, 0x50, 0x3F, 0x50, 0x21, 0x50, 0x3F, 0x50, 0x21, 0x50, 0x3F, 0x50, 0x21, 0x10, 0x26, 0x60, 0x00, 0x00 }; /*524A*/
const unsigned char  uc2_524C [] = {0x08, 0x10, 0x7F, 0x10, 0x08, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x3E, 0x50, 0x18, 0x50, 0x2C, 0x50, 0x2A, 0x10, 0x4A, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*524C*/
const unsigned char  uc2_524D [] = {0x30, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x3C, 0x20, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0x20, 0x28, 0xC0, 0x00, 0x00 }; /*524D*/
const unsigned char  uc2_5250 [] = {0x3E, 0x10, 0x22, 0x10, 0x22, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x49, 0x50, 0x4D, 0x50, 0x73, 0x10, 0x41, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*5250*/
const unsigned char  uc2_5251 [] = {0x04, 0x10, 0x06, 0x10, 0x09, 0x50, 0x11, 0x50, 0x6E, 0x50, 0x01, 0x50, 0x29, 0x50, 0x15, 0x50, 0x16, 0x10, 0x03, 0x10, 0x7C, 0x60, 0x00, 0x00 }; /*5251*/
const unsigned char  uc2_5254 [] = {0x3E, 0x10, 0x22, 0x10, 0x3E, 0x50, 0x22, 0x50, 0x3E, 0x50, 0x10, 0x50, 0x3F, 0x50, 0x55, 0x50, 0x25, 0x50, 0x49, 0x10, 0x36, 0x60, 0x00, 0x00 }; /*5254*/
const unsigned char  uc2_5256 [] = {0x18, 0x10, 0x04, 0x10, 0x3E, 0x50, 0x14, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x00, 0x50, 0x3E, 0x50, 0x22, 0x10, 0x3E, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*5256*/
const unsigned char  uc2_525C [] = {0x08, 0x10, 0x7F, 0x10, 0x41, 0x50, 0x61, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x56, 0x50, 0x14, 0x10, 0x25, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*525C*/
const unsigned char  uc2_525E [] = {0x08, 0x10, 0x3F, 0x10, 0x14, 0x50, 0x22, 0x50, 0x7F, 0x50, 0x02, 0x50, 0x3A, 0x50, 0x2A, 0x50, 0x3A, 0x50, 0x02, 0x10, 0x0C, 0x60, 0x00, 0x00 }; /*525E*/
const unsigned char  uc2_5261 [] = {0x2A, 0x10, 0x2A, 0x10, 0x4C, 0x50, 0x12, 0x50, 0x62, 0x50, 0x08, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x4C, 0x10, 0x12, 0x10, 0x61, 0x60, 0x00, 0x00 }; /*5261*/
const unsigned char  uc2_5265 [] = {0x3E, 0x10, 0x02, 0x50, 0x1E, 0x50, 0x04, 0x50, 0x7F, 0x50, 0x09, 0x50, 0x2A, 0x50, 0x18, 0x50, 0x6A, 0x10, 0x09, 0x10, 0x31, 0x60, 0x00, 0x00 }; /*5265*/
const unsigned char  uc2_5267 [] = {0x00, 0x10, 0x3F, 0x10, 0x21, 0x50, 0x3F, 0x50, 0x24, 0x50, 0x3F, 0x50, 0x24, 0x50, 0x3F, 0x50, 0x31, 0x10, 0x5F, 0x10, 0x51, 0x60, 0x00, 0x00 }; /*5267*/
const unsigned char  uc2_5269 [] = {0x07, 0x10, 0x78, 0x10, 0x08, 0x50, 0x7F, 0x50, 0x2A, 0xD0, 0x6B, 0x50, 0x2A, 0xD0, 0x49, 0x50, 0x1C, 0x50, 0x6A, 0x10, 0x0A, 0x60, 0x00, 0x00 }; /*5269*/
const unsigned char  uc2_526A [] = {0x08, 0x80, 0x7F, 0xF0, 0x22, 0x20, 0x3E, 0xA0, 0x22, 0xA0, 0x3A, 0xA0, 0x26, 0x60, 0x00, 0x00, 0x3F, 0xE0, 0x04, 0x20, 0x79, 0xC0, 0x00, 0x00 }; /*526A*/
const unsigned char  uc2_526F [] = {0x00, 0x10, 0x7F, 0x10, 0x00, 0x10, 0x3E, 0x50, 0x22, 0x50, 0x7F, 0x50, 0x49, 0x50, 0x7F, 0x50, 0x49, 0x10, 0x7F, 0x10, 0x41, 0x60, 0x00, 0x00 }; /*526F*/
const unsigned char  uc2_5272 [] = {0x08, 0x10, 0x7F, 0x10, 0x49, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x22, 0x10, 0x3E, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*5272*/
const unsigned char  uc2_527D [] = {0x7F, 0x10, 0x14, 0x10, 0x7F, 0x50, 0x55, 0x50, 0x7F, 0x50, 0x00, 0x50, 0x3E, 0x50, 0x00, 0x50, 0x7F, 0x10, 0x2A, 0x10, 0x59, 0x60, 0x00, 0x00 }; /*527D*/
const unsigned char  uc2_527F [] = {0x2A, 0x10, 0x54, 0x10, 0x2A, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x7F, 0x50, 0x1C, 0x10, 0x6A, 0x10, 0x0A, 0x60, 0x00, 0x00 }; /*527F*/
const unsigned char  uc2_5281 [] = {0x14, 0x10, 0x1F, 0x50, 0x24, 0x50, 0x7F, 0x50, 0x24, 0x50, 0x3F, 0x50, 0x24, 0x50, 0x3F, 0x50, 0x15, 0x10, 0x2A, 0x90, 0x4A, 0xA0, 0x00, 0x00 }; /*5281*/
const unsigned char  uc2_5282 [] = {0x3F, 0xD0, 0x20, 0x10, 0x35, 0x10, 0x29, 0x50, 0x3E, 0xD0, 0x28, 0x50, 0x2B, 0x50, 0x3D, 0x50, 0x29, 0x10, 0x4A, 0x90, 0x54, 0xA0, 0x00, 0x00 }; /*5282*/
const unsigned char  uc2_5288 [] = {0x1E, 0x40, 0x13, 0xF0, 0x1E, 0xA0, 0x11, 0xF0, 0x1E, 0x40, 0x2A, 0xE0, 0x4E, 0x40, 0x00, 0x00, 0x3F, 0xF0, 0x04, 0x10, 0x38, 0xE0, 0x00, 0x00 }; /*5288*/
const unsigned char  uc2_5290 [] = {0x12, 0x10, 0x7F, 0x90, 0x12, 0x50, 0x1F, 0xD0, 0x64, 0x50, 0x3F, 0x50, 0x24, 0x50, 0x3F, 0xD0, 0x11, 0x50, 0x0E, 0x10, 0x71, 0x60, 0x00, 0x00 }; /*5290*/
const unsigned char  uc2_5293 [] = {0x08, 0x10, 0x1E, 0x10, 0x12, 0x50, 0x3F, 0x50, 0x25, 0x50, 0x3F, 0x50, 0x25, 0x50, 0x7F, 0xD0, 0x12, 0x10, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*5293*/
const unsigned char  uc2_529B [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xF0, 0x02, 0x10, 0x02, 0x10, 0x04, 0x10, 0x04, 0x10, 0x08, 0x10, 0x10, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*529B*/
const unsigned char  uc2_529D [] = {0x00, 0x40, 0x7C, 0x40, 0x05, 0xF0, 0x24, 0x50, 0x18, 0x50, 0x08, 0x50, 0x14, 0x50, 0x24, 0x90, 0x40, 0x90, 0x01, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*529D*/
const unsigned char  uc2_529E [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x02, 0x40, 0x12, 0x60, 0x12, 0x50, 0x24, 0x50, 0x44, 0x50, 0x08, 0x40, 0x10, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*529E*/
const unsigned char  uc2_529F [] = {0x00, 0x80, 0x00, 0x80, 0x7C, 0x80, 0x13, 0xF0, 0x10, 0x90, 0x10, 0x90, 0x10, 0x90, 0x1D, 0x10, 0x61, 0x10, 0x02, 0x10, 0x0C, 0xE0, 0x00, 0x00 }; /*529F*/
const unsigned char  uc2_52A0 [] = {0x10, 0x00, 0x10, 0xF0, 0x7E, 0x90, 0x12, 0x90, 0x12, 0x90, 0x12, 0x90, 0x12, 0x90, 0x12, 0x90, 0x22, 0x90, 0x22, 0xF0, 0x4C, 0x90, 0x00, 0x00 }; /*52A0*/
const unsigned char  uc2_52A1 [] = {0x08, 0x00, 0x0F, 0x80, 0x18, 0x80, 0x29, 0x00, 0x06, 0x00, 0x19, 0x80, 0x64, 0x70, 0x1F, 0x80, 0x04, 0x80, 0x08, 0x80, 0x33, 0x00, 0x00, 0x00 }; /*52A1*/
const unsigned char  uc2_52A2 [] = {0x00, 0x80, 0x7E, 0x80, 0x10, 0x80, 0x13, 0xF0, 0x1C, 0x90, 0x14, 0x90, 0x14, 0x90, 0x14, 0x90, 0x25, 0x10, 0x25, 0x10, 0x5A, 0x60, 0x00, 0x00 }; /*52A2*/
const unsigned char  uc2_52A3 [] = {0x12, 0x40, 0x12, 0x20, 0x22, 0x90, 0x40, 0x90, 0x03, 0x00, 0x7C, 0x00, 0x02, 0x00, 0x3F, 0xF0, 0x02, 0x10, 0x0C, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*52A3*/
const unsigned char  uc2_52A8 [] = {0x00, 0x80, 0x3C, 0x80, 0x03, 0xF0, 0x00, 0x90, 0x7E, 0x90, 0x10, 0x90, 0x10, 0x90, 0x24, 0x90, 0x4F, 0x10, 0x71, 0x10, 0x06, 0x60, 0x00, 0x00 }; /*52A8*/
const unsigned char  uc2_52A9 [] = {0x00, 0x80, 0x3C, 0x80, 0x24, 0x80, 0x3D, 0xF0, 0x24, 0x90, 0x3C, 0x90, 0x24, 0x90, 0x24, 0x90, 0x3E, 0x90, 0x61, 0x10, 0x06, 0x60, 0x00, 0x00 }; /*52A9*/
const unsigned char  uc2_52AA [] = {0x08, 0x00, 0x7D, 0xE0, 0x14, 0xA0, 0x34, 0xA0, 0x08, 0x40, 0x35, 0xB0, 0x02, 0x00, 0x3F, 0xE0, 0x04, 0x20, 0x08, 0x20, 0x71, 0xC0, 0x00, 0x00 }; /*52AA*/
const unsigned char  uc2_52AB [] = {0x08, 0x40, 0x08, 0x40, 0x3E, 0xF0, 0x08, 0x50, 0x08, 0x50, 0x7F, 0x50, 0x08, 0x50, 0x12, 0x50, 0x27, 0x50, 0x38, 0x90, 0x03, 0x60, 0x00, 0x00 }; /*52AB*/
const unsigned char  uc2_52AC [] = {0x20, 0x40, 0x3E, 0x40, 0x22, 0xF0, 0x42, 0x50, 0x3A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x3A, 0x50, 0x2A, 0x90, 0x02, 0x90, 0x1D, 0x20, 0x00, 0x00 }; /*52AC*/
const unsigned char  uc2_52AD [] = {0x00, 0x40, 0x7E, 0x40, 0x12, 0xF0, 0x12, 0x50, 0x2C, 0x50, 0x40, 0x50, 0x3E, 0x50, 0x22, 0x50, 0x22, 0x90, 0x3E, 0x90, 0x21, 0x60, 0x00, 0x00 }; /*52AD*/
const unsigned char  uc2_52B1 [] = {0x00, 0x40, 0x3F, 0x40, 0x20, 0x40, 0x3F, 0xF0, 0x28, 0x50, 0x2E, 0x50, 0x2A, 0x50, 0x2A, 0x90, 0x2A, 0x90, 0x55, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*52B1*/
const unsigned char  uc2_52B2 [] = {0x3E, 0x40, 0x02, 0x40, 0x05, 0xF0, 0x1A, 0x50, 0x61, 0x50, 0x01, 0x50, 0x3E, 0x50, 0x08, 0x50, 0x0E, 0x50, 0x70, 0x90, 0x03, 0x60, 0x00, 0x00 }; /*52B2*/
const unsigned char  uc2_52B3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x22, 0x20, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x40, 0x18, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*52B3*/
const unsigned char  uc2_52BE [] = {0x08, 0x40, 0x7F, 0x40, 0x10, 0xF0, 0x24, 0x50, 0x38, 0x50, 0x0A, 0x50, 0x12, 0x50, 0x64, 0x50, 0x0A, 0x90, 0x11, 0x10, 0x66, 0x60, 0x00, 0x00 }; /*52BE*/
const unsigned char  uc2_52BF [] = {0x11, 0x00, 0x7F, 0xC0, 0x11, 0x40, 0x1D, 0x40, 0x73, 0x50, 0x14, 0xD0, 0x68, 0xA0, 0x04, 0x00, 0x7F, 0xE0, 0x08, 0x20, 0x70, 0xC0, 0x00, 0x00 }; /*52BF*/
const unsigned char  uc2_52C3 [] = {0x08, 0x40, 0x3E, 0x40, 0x08, 0x40, 0x7F, 0xF0, 0x41, 0x50, 0x3C, 0x50, 0x04, 0x50, 0x0F, 0x50, 0x78, 0x90, 0x08, 0x90, 0x31, 0x20, 0x00, 0x00 }; /*52C3*/
const unsigned char  uc2_52C7 [] = {0x1F, 0x80, 0x04, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xF0, 0x08, 0x10, 0x70, 0x60, 0x00, 0x00 }; /*52C7*/
const unsigned char  uc2_52C9 [] = {0x20, 0x40, 0x3C, 0x40, 0x24, 0xF0, 0x7E, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x3E, 0x50, 0x0C, 0x90, 0x15, 0x60, 0x14, 0x10, 0x63, 0xE0, 0x00, 0x00 }; /*52C9*/
const unsigned char  uc2_52CB [] = {0x38, 0x80, 0x28, 0x80, 0x3B, 0xF0, 0x00, 0x90, 0x7C, 0x90, 0x54, 0x90, 0x54, 0x90, 0x54, 0x90, 0x19, 0x10, 0x25, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*52CB*/
const unsigned char  uc2_52D0 [] = {0x3E, 0x40, 0x04, 0x40, 0x08, 0xF0, 0x7F, 0x50, 0x08, 0x50, 0x18, 0x50, 0x00, 0x50, 0x3E, 0x50, 0x2A, 0x90, 0x2E, 0x90, 0x71, 0x30, 0x00, 0x00 }; /*52D0*/
const unsigned char  uc2_52D2 [] = {0x14, 0x40, 0x7F, 0x40, 0x14, 0x40, 0x1C, 0xF0, 0x08, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x3E, 0x50, 0x08, 0x90, 0x7E, 0x90, 0x09, 0x60, 0x00, 0x00 }; /*52D2*/
const unsigned char  uc2_52D4 [] = {0x7F, 0x40, 0x08, 0x40, 0x10, 0x40, 0x7F, 0xF0, 0x55, 0x50, 0x5D, 0x50, 0x55, 0x50, 0x5D, 0x50, 0x55, 0x50, 0x7F, 0x90, 0x41, 0x60, 0x00, 0x00 }; /*52D4*/
const unsigned char  uc2_52D6 [] = {0x7F, 0x40, 0x41, 0x40, 0x5D, 0xF0, 0x41, 0x50, 0x5D, 0x50, 0x00, 0x50, 0x3E, 0x50, 0x22, 0x50, 0x3E, 0x90, 0x22, 0x90, 0x3F, 0x60, 0x00, 0x00 }; /*52D6*/
const unsigned char  uc2_52D8 [] = {0x12, 0x40, 0x3F, 0x40, 0x12, 0x40, 0x1E, 0xF0, 0x12, 0x50, 0x1E, 0x50, 0x12, 0x50, 0x7F, 0x50, 0x2A, 0x50, 0x31, 0x50, 0x1F, 0xA0, 0x00, 0x00 }; /*52D8*/
const unsigned char  uc2_52DF [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x74, 0x70, 0x1F, 0xC0, 0x08, 0x40, 0x71, 0x80, 0x00, 0x00 }; /*52DF*/
const unsigned char  uc2_52E4 [] = {0x14, 0x40, 0x7F, 0x40, 0x14, 0x40, 0x14, 0xF0, 0x3E, 0x50, 0x2A, 0x50, 0x7F, 0x50, 0x08, 0x50, 0x3E, 0x90, 0x09, 0x10, 0x7E, 0x60, 0x00, 0x00 }; /*52E4*/
const unsigned char  uc2_52F0 [] = {0x11, 0xF0, 0x7D, 0x50, 0x15, 0xF0, 0x15, 0x50, 0x69, 0xF0, 0x28, 0x80, 0x7E, 0x40, 0x2A, 0xA0, 0x2B, 0x90, 0x2A, 0xA0, 0x54, 0x40, 0x00, 0x00 }; /*52F0*/
const unsigned char  uc2_52FA [] = {0x10, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x20, 0x10, 0x4C, 0x10, 0x02, 0x10, 0x01, 0x10, 0x01, 0x10, 0x00, 0x10, 0x00, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*52FA*/
const unsigned char  uc2_52FE [] = {0x08, 0x00, 0x0F, 0xF0, 0x08, 0x10, 0x12, 0x10, 0x62, 0x10, 0x04, 0x90, 0x08, 0x90, 0x0F, 0x50, 0x00, 0x50, 0x00, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*52FE*/
const unsigned char  uc2_52FF [] = {0x08, 0x00, 0x08, 0x00, 0x0F, 0xF0, 0x12, 0x90, 0x62, 0x90, 0x04, 0x90, 0x09, 0x10, 0x31, 0x10, 0x02, 0x10, 0x0C, 0x10, 0x30, 0xE0, 0x00, 0x00 }; /*52FF*/
const unsigned char  uc2_5300 [] = {0x08, 0x00, 0x0F, 0xF0, 0x08, 0x10, 0x10, 0x10, 0x66, 0x10, 0x01, 0x10, 0x00, 0x10, 0x01, 0x90, 0x1E, 0x10, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*5300*/
const unsigned char  uc2_5305 [] = {0x08, 0x00, 0x0F, 0xE0, 0x08, 0x20, 0x10, 0x20, 0x6F, 0x20, 0x09, 0x20, 0x0F, 0x20, 0x08, 0xC0, 0x08, 0x10, 0x08, 0x10, 0x07, 0xE0, 0x00, 0x00 }; /*5305*/
const unsigned char  uc2_5306 [] = {0x08, 0x00, 0x0F, 0xF0, 0x0A, 0x90, 0x12, 0x90, 0x6C, 0x90, 0x06, 0x90, 0x09, 0x10, 0x71, 0x90, 0x02, 0x90, 0x1C, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5306*/
const unsigned char  uc2_5308 [] = {0x08, 0x00, 0x0F, 0xF0, 0x10, 0x10, 0x65, 0x10, 0x12, 0x50, 0x1D, 0x50, 0x11, 0x50, 0x1F, 0xD0, 0x00, 0x50, 0x00, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*5308*/
const unsigned char  uc2_530D [] = {0x10, 0x00, 0x1F, 0xF0, 0x22, 0x90, 0x5F, 0xD0, 0x02, 0x10, 0x0F, 0x90, 0x0A, 0x90, 0x0F, 0x90, 0x0A, 0x90, 0x0F, 0x90, 0x0A, 0xE0, 0x00, 0x00 }; /*530D*/
const unsigned char  uc2_530F [] = {0x10, 0x80, 0x7C, 0x80, 0x10, 0xF0, 0x2B, 0x10, 0x7D, 0xD0, 0x01, 0x50, 0x7D, 0xD0, 0x21, 0x10, 0x7D, 0x60, 0x05, 0x10, 0x38, 0xE0, 0x00, 0x00 }; /*530F*/
const unsigned char  uc2_5310 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x10, 0x5F, 0xD0, 0x08, 0x90, 0x1F, 0xD0, 0x12, 0x50, 0x1F, 0xD0, 0x12, 0x50, 0x1F, 0xD0, 0x10, 0x20, 0x00, 0x00 }; /*5310*/
const unsigned char  uc2_5315 [] = {0x20, 0x00, 0x20, 0x00, 0x20, 0x20, 0x20, 0xC0, 0x23, 0x00, 0x3C, 0x00, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*5315*/
const unsigned char  uc2_5316 [] = {0x09, 0x00, 0x09, 0x00, 0x11, 0x10, 0x11, 0x10, 0x31, 0x20, 0x51, 0xC0, 0x17, 0x00, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*5316*/
const unsigned char  uc2_5317 [] = {0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x79, 0x30, 0x09, 0xC0, 0x09, 0x00, 0x09, 0x00, 0x09, 0x10, 0x19, 0x10, 0x69, 0x10, 0x08, 0xE0, 0x00, 0x00 }; /*5317*/
const unsigned char  uc2_5319 [] = {0x1E, 0x00, 0x12, 0x80, 0x1E, 0x90, 0x12, 0x90, 0x1E, 0xE0, 0x00, 0x80, 0x3F, 0x90, 0x04, 0x90, 0x17, 0x60, 0x1C, 0x00, 0x63, 0xF0, 0x00, 0x00 }; /*5319*/
const unsigned char  uc2_531D [] = {0x7F, 0xF0, 0x40, 0x00, 0x41, 0x00, 0x4F, 0xE0, 0x49, 0x20, 0x49, 0x20, 0x49, 0x20, 0x49, 0x40, 0x41, 0x00, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*531D*/
const unsigned char  uc2_5320 [] = {0x7F, 0xF0, 0x40, 0x00, 0x40, 0xE0, 0x4F, 0x00, 0x48, 0x00, 0x4F, 0xF0, 0x48, 0x80, 0x48, 0x80, 0x50, 0x80, 0x60, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5320*/
const unsigned char  uc2_5321 [] = {0x7F, 0xE0, 0x40, 0x00, 0x5F, 0xC0, 0x42, 0x00, 0x42, 0x00, 0x4F, 0x80, 0x42, 0x00, 0x42, 0x00, 0x5F, 0xC0, 0x40, 0x00, 0x7F, 0xE0, 0x00, 0x00 }; /*5321*/
const unsigned char  uc2_5323 [] = {0x7F, 0xE0, 0x40, 0x00, 0x5F, 0xC0, 0x52, 0x40, 0x5F, 0xC0, 0x52, 0x40, 0x5F, 0xC0, 0x42, 0x00, 0x42, 0x00, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5323*/
const unsigned char  uc2_5326 [] = {0x7F, 0xF0, 0x49, 0x00, 0x7D, 0x00, 0x53, 0xC0, 0x69, 0x40, 0x7F, 0x40, 0x49, 0x50, 0x7E, 0x50, 0x48, 0x20, 0x48, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5326*/
const unsigned char  uc2_532A [] = {0x7F, 0xF0, 0x40, 0x00, 0x45, 0x00, 0x7D, 0xE0, 0x45, 0x00, 0x5D, 0xC0, 0x45, 0x00, 0x7D, 0xE0, 0x45, 0x00, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*532A*/
const unsigned char  uc2_532E [] = {0x7F, 0xF0, 0x41, 0x00, 0x4F, 0xE0, 0x49, 0x20, 0x5F, 0xF0, 0x48, 0x20, 0x49, 0x20, 0x49, 0x20, 0x42, 0xC0, 0x4C, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*532E*/
const unsigned char  uc2_5339 [] = {0x7F, 0xF0, 0x44, 0x80, 0x44, 0x80, 0x44, 0x80, 0x44, 0x80, 0x44, 0x90, 0x48, 0x90, 0x48, 0x90, 0x70, 0x60, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5339*/
const unsigned char  uc2_533A [] = {0x7F, 0xF0, 0x40, 0x00, 0x40, 0x40, 0x58, 0x40, 0x46, 0x80, 0x41, 0x00, 0x42, 0x80, 0x44, 0x40, 0x58, 0x20, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*533A*/
const unsigned char  uc2_533B [] = {0x7F, 0xF0, 0x44, 0x00, 0x47, 0xC0, 0x59, 0x00, 0x41, 0x00, 0x5F, 0xE0, 0x42, 0x00, 0x44, 0xC0, 0x58, 0x20, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*533B*/
const unsigned char  uc2_533E [] = {0x7F, 0xF0, 0x42, 0x00, 0x5F, 0xE0, 0x50, 0x20, 0x5F, 0xE0, 0x50, 0x00, 0x5F, 0xE0, 0x5A, 0xA0, 0x6F, 0xE0, 0x4A, 0xA0, 0x7F, 0xF0, 0x00, 0x00 }; /*533E*/
const unsigned char  uc2_533F [] = {0x7F, 0xF0, 0x44, 0x80, 0x5F, 0xE0, 0x44, 0x80, 0x42, 0x00, 0x7F, 0xE0, 0x44, 0x00, 0x4F, 0xC0, 0x74, 0x40, 0x44, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*533F*/
const unsigned char  uc2_5341 [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5341*/
const unsigned char  uc2_5343 [] = {0x01, 0xE0, 0x3E, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5343*/
const unsigned char  uc2_5345 [] = {0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x22, 0x40, 0x22, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*5345*/
const unsigned char  uc2_5347 [] = {0x03, 0x40, 0x1C, 0x40, 0x04, 0x40, 0x04, 0x40, 0x04, 0x40, 0x3F, 0xF0, 0x04, 0x40, 0x04, 0x40, 0x08, 0x40, 0x10, 0x40, 0x60, 0x40, 0x00, 0x00 }; /*5347*/
const unsigned char  uc2_5348 [] = {0x10, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x22, 0x00, 0x42, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5348*/
const unsigned char  uc2_5349 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x0A, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5349*/
const unsigned char  uc2_534A [] = {0x02, 0x00, 0x32, 0x20, 0x0A, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*534A*/
const unsigned char  uc2_534E [] = {0x09, 0x00, 0x11, 0x30, 0x71, 0xC0, 0x17, 0x10, 0x11, 0x10, 0x12, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*534E*/
const unsigned char  uc2_534F [] = {0x21, 0x00, 0x21, 0x00, 0x27, 0xC0, 0x71, 0x40, 0x21, 0x60, 0x25, 0x50, 0x25, 0x50, 0x29, 0x50, 0x22, 0x40, 0x24, 0x40, 0x29, 0x80, 0x00, 0x00 }; /*534F*/
const unsigned char  uc2_5351 [] = {0x04, 0x00, 0x08, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x24, 0x20, 0x3F, 0xE0, 0x12, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5351*/
const unsigned char  uc2_5352 [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x14, 0xC0, 0x63, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5352*/
const unsigned char  uc2_5353 [] = {0x02, 0x00, 0x03, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*5353*/
const unsigned char  uc2_5355 [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5355*/
const unsigned char  uc2_5356 [] = {0x04, 0x00, 0x3F, 0xC0, 0x04, 0x00, 0x7F, 0xE0, 0x10, 0x20, 0x2A, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x04, 0x00, 0x19, 0xC0, 0x60, 0x20, 0x00, 0x00 }; /*5356*/
const unsigned char  uc2_5357 [] = {0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x3F, 0xE0, 0x28, 0xA0, 0x25, 0x20, 0x2F, 0xA0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*5357*/
const unsigned char  uc2_535A [] = {0x10, 0xA0, 0x17, 0xF0, 0x12, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x17, 0xF0, 0x12, 0x20, 0x11, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*535A*/
const unsigned char  uc2_535C [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 0x00, 0x05, 0x00, 0x04, 0x80, 0x04, 0x40, 0x04, 0x40, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*535C*/
const unsigned char  uc2_535E [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x04, 0x00, 0x07, 0x00, 0x04, 0x80, 0x04, 0x40, 0x04, 0x40, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*535E*/
const unsigned char  uc2_535F [] = {0x00, 0x80, 0x00, 0x80, 0x3C, 0x80, 0x24, 0xC0, 0x24, 0xA0, 0x24, 0x90, 0x24, 0x90, 0x3C, 0x80, 0x24, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*535F*/
const unsigned char  uc2_5360 [] = {0x04, 0x00, 0x04, 0x00, 0x07, 0xF0, 0x04, 0x00, 0x04, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*5360*/
const unsigned char  uc2_5361 [] = {0x04, 0x00, 0x07, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x04, 0x00, 0x07, 0x00, 0x04, 0xC0, 0x04, 0x20, 0x04, 0x00, 0x00, 0x00 }; /*5361*/
const unsigned char  uc2_5362 [] = {0x02, 0x00, 0x03, 0xF0, 0x02, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*5362*/
const unsigned char  uc2_5363 [] = {0x04, 0x00, 0x07, 0xF0, 0x04, 0x00, 0x7F, 0xE0, 0x40, 0x20, 0x7F, 0x20, 0x41, 0x20, 0x7F, 0x20, 0x40, 0x20, 0x7F, 0xE0, 0x40, 0x20, 0x00, 0x00 }; /*5363*/
const unsigned char  uc2_5364 [] = {0x04, 0x00, 0x07, 0xF0, 0x04, 0x00, 0x7F, 0xE0, 0x40, 0xA0, 0x5D, 0x20, 0x43, 0x20, 0x5C, 0xA0, 0x40, 0x20, 0x7F, 0xE0, 0x40, 0x20, 0x00, 0x00 }; /*5364*/
const unsigned char  uc2_5366 [] = {0x08, 0x40, 0x08, 0x40, 0x3E, 0x40, 0x08, 0x40, 0x7F, 0x60, 0x00, 0x50, 0x08, 0x50, 0x3E, 0x40, 0x08, 0x40, 0x0F, 0x40, 0x70, 0x40, 0x00, 0x00 }; /*5366*/
const unsigned char  uc2_5367 [] = {0x00, 0x80, 0x7E, 0x80, 0x48, 0x80, 0x48, 0xC0, 0x7E, 0xA0, 0x42, 0x90, 0x7E, 0x90, 0x48, 0x80, 0x48, 0x80, 0x7E, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5367*/
const unsigned char  uc2_536B [] = {0x3F, 0xE0, 0x04, 0x20, 0x04, 0x20, 0x04, 0x20, 0x04, 0x20, 0x05, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*536B*/
const unsigned char  uc2_536E [] = {0x00, 0xE0, 0x1F, 0x00, 0x10, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xC0, 0x14, 0x40, 0x14, 0x40, 0x25, 0x90, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*536E*/
const unsigned char  uc2_536F [] = {0x19, 0xF0, 0x61, 0x10, 0x45, 0x10, 0x45, 0x10, 0x45, 0x10, 0x4D, 0x10, 0x75, 0x10, 0x05, 0x60, 0x09, 0x00, 0x11, 0x00, 0x61, 0x00, 0x00, 0x00 }; /*536F*/
const unsigned char  uc2_5370 [] = {0x0D, 0xF0, 0x71, 0x10, 0x41, 0x10, 0x41, 0x10, 0x7D, 0x10, 0x41, 0x10, 0x41, 0x10, 0x5D, 0x60, 0x61, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*5370*/
const unsigned char  uc2_5371 [] = {0x08, 0x00, 0x0F, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x00, 0x17, 0xC0, 0x14, 0x40, 0x14, 0x40, 0x25, 0x90, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*5371*/
const unsigned char  uc2_5373 [] = {0x7D, 0xF0, 0x45, 0x10, 0x7D, 0x10, 0x45, 0x10, 0x45, 0x10, 0x7D, 0x10, 0x51, 0x10, 0x49, 0x60, 0x55, 0x00, 0x65, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*5373*/
const unsigned char  uc2_5374 [] = {0x08, 0x00, 0x08, 0xF0, 0x3E, 0x90, 0x08, 0x90, 0x08, 0x90, 0x7F, 0x90, 0x10, 0x90, 0x14, 0x90, 0x24, 0xA0, 0x3A, 0x80, 0x02, 0x80, 0x00, 0x00 }; /*5374*/
const unsigned char  uc2_5375 [] = {0x0C, 0x00, 0x71, 0xF0, 0x45, 0x10, 0x65, 0x90, 0x55, 0x50, 0x4D, 0x50, 0x75, 0x10, 0x05, 0x60, 0x09, 0x00, 0x11, 0x00, 0x61, 0x00, 0x00, 0x00 }; /*5375*/
const unsigned char  uc2_5377 [] = {0x19, 0x20, 0x05, 0x40, 0x1F, 0xE0, 0x02, 0x00, 0x3F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x40, 0x0B, 0x90, 0x08, 0x10, 0x07, 0xE0, 0x00, 0x00 }; /*5377*/
const unsigned char  uc2_5378 [] = {0x20, 0xF0, 0x3E, 0x90, 0x48, 0x90, 0x08, 0x90, 0x7F, 0x90, 0x08, 0x90, 0x2E, 0x90, 0x28, 0xE0, 0x2F, 0x80, 0x70, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5378*/
const unsigned char  uc2_537A [] = {0x1F, 0x00, 0x01, 0x20, 0x72, 0x40, 0x13, 0x80, 0x6C, 0x70, 0x00, 0x00, 0x7F, 0xF0, 0x20, 0x80, 0x27, 0x20, 0x20, 0x20, 0x1F, 0xC0, 0x00, 0x00 }; /*537A*/
const unsigned char  uc2_537F [] = {0x17, 0x70, 0x65, 0x50, 0x47, 0x50, 0x55, 0x50, 0x57, 0x50, 0x54, 0x50, 0x76, 0x50, 0x55, 0x60, 0x15, 0x40, 0x26, 0xC0, 0x40, 0x40, 0x00, 0x00 }; /*537F*/
const unsigned char  uc2_5382 [] = {0x1F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*5382*/
const unsigned char  uc2_5384 [] = {0x1F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x17, 0xC0, 0x14, 0x40, 0x14, 0x40, 0x14, 0x40, 0x15, 0x90, 0x24, 0x10, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*5384*/
const unsigned char  uc2_5385 [] = {0x1F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x20, 0x80, 0x20, 0x80, 0x47, 0x00, 0x00, 0x00 }; /*5385*/
const unsigned char  uc2_5386 [] = {0x1F, 0xF0, 0x10, 0x00, 0x11, 0x00, 0x11, 0x00, 0x1F, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x12, 0x20, 0x22, 0x20, 0x24, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*5386*/
const unsigned char  uc2_5389 [] = {0x1F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x11, 0x00, 0x11, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x12, 0x20, 0x22, 0x20, 0x24, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*5389*/
const unsigned char  uc2_538B [] = {0x1F, 0xF0, 0x10, 0x00, 0x11, 0x00, 0x11, 0x00, 0x17, 0xE0, 0x11, 0x00, 0x11, 0x40, 0x11, 0x20, 0x21, 0x20, 0x2F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*538B*/
const unsigned char  uc2_538C [] = {0x1F, 0xF0, 0x10, 0x00, 0x11, 0x40, 0x11, 0x20, 0x1F, 0xF0, 0x11, 0x00, 0x11, 0x00, 0x12, 0x80, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*538C*/
const unsigned char  uc2_538D [] = {0x1F, 0xF0, 0x10, 0x00, 0x11, 0x00, 0x17, 0xE0, 0x12, 0x00, 0x14, 0x80, 0x17, 0xE0, 0x10, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*538D*/
const unsigned char  uc2_5395 [] = {0x1F, 0xF0, 0x10, 0x00, 0x1F, 0x10, 0x11, 0x50, 0x15, 0x50, 0x15, 0x50, 0x15, 0x50, 0x15, 0x50, 0x26, 0x10, 0x29, 0x10, 0x51, 0x60, 0x00, 0x00 }; /*5395*/
const unsigned char  uc2_5398 [] = {0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x2F, 0xE0, 0x41, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*5398*/
const unsigned char  uc2_539A [] = {0x1F, 0xF0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x10, 0x00, 0x13, 0xC0, 0x10, 0x40, 0x2F, 0xF0, 0x20, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*539A*/
const unsigned char  uc2_539D [] = {0x3F, 0xF0, 0x20, 0x00, 0x22, 0x40, 0x27, 0xE0, 0x22, 0x40, 0x2F, 0xF0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x47, 0xE0, 0x44, 0x20, 0x00, 0x00 }; /*539D*/
const unsigned char  uc2_539F [] = {0x3F, 0xF0, 0x22, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x25, 0x60, 0x59, 0x10, 0x46, 0x00, 0x00, 0x00 }; /*539F*/
const unsigned char  uc2_53A2 [] = {0x3F, 0xF0, 0x24, 0x00, 0x24, 0xF0, 0x3F, 0x90, 0x24, 0x90, 0x26, 0xF0, 0x2D, 0x90, 0x34, 0xF0, 0x24, 0x90, 0x44, 0xF0, 0x44, 0x90, 0x00, 0x00 }; /*53A2*/
const unsigned char  uc2_53A3 [] = {0x3F, 0xF0, 0x21, 0x40, 0x2F, 0xE0, 0x22, 0x80, 0x27, 0xC0, 0x2D, 0x60, 0x27, 0xC0, 0x25, 0x40, 0x27, 0xC0, 0x25, 0x40, 0x41, 0x00, 0x00, 0x00 }; /*53A3*/
const unsigned char  uc2_53A5 [] = {0x3F, 0xF0, 0x31, 0x40, 0x2A, 0x40, 0x3F, 0xF0, 0x25, 0x50, 0x35, 0x90, 0x2F, 0x20, 0x24, 0x20, 0x24, 0x20, 0x24, 0x50, 0x49, 0x90, 0x00, 0x00 }; /*53A5*/
const unsigned char  uc2_53A6 [] = {0x3F, 0xF0, 0x20, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x2A, 0x80, 0x51, 0x00, 0x4E, 0xF0, 0x00, 0x00 }; /*53A6*/
const unsigned char  uc2_53A8 [] = {0x3F, 0xF0, 0x20, 0x20, 0x3F, 0xA0, 0x20, 0x70, 0x2F, 0xA0, 0x29, 0x60, 0x2F, 0x60, 0x29, 0x20, 0x25, 0xA0, 0x5E, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*53A8*/
const unsigned char  uc2_53A9 [] = {0x3F, 0xF0, 0x20, 0x00, 0x2E, 0xF0, 0x2A, 0x20, 0x2E, 0xA0, 0x2A, 0xA0, 0x2E, 0xF0, 0x28, 0x40, 0x2A, 0x50, 0x4B, 0xD0, 0x4D, 0x30, 0x00, 0x00 }; /*53A9*/
const unsigned char  uc2_53AE [] = {0x3F, 0xF0, 0x2A, 0x00, 0x3F, 0x30, 0x2A, 0xC0, 0x2E, 0x80, 0x2A, 0xF0, 0x2E, 0xA0, 0x2A, 0xA0, 0x3F, 0xA0, 0x4A, 0xA0, 0x51, 0x20, 0x00, 0x00 }; /*53AE*/
const unsigned char  uc2_53BB [] = {0x02, 0x00, 0x02, 0x00, 0x1F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xF0, 0x02, 0x00, 0x04, 0x80, 0x08, 0x40, 0x11, 0xA0, 0x1E, 0x20, 0x00, 0x00 }; /*53BB*/
const unsigned char  uc2_53BF [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0xC0, 0x1E, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*53BF*/
const unsigned char  uc2_53C1 [] = {0x04, 0x80, 0x08, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x7F, 0xF0, 0x10, 0x40, 0x6F, 0xB0, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00 }; /*53C1*/
const unsigned char  uc2_53C2 [] = {0x09, 0x00, 0x10, 0x80, 0x3F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x12, 0x80, 0x6D, 0x70, 0x02, 0x00, 0x1C, 0x80, 0x03, 0x00, 0x3C, 0x00, 0x00, 0x00 }; /*53C2*/
const unsigned char  uc2_53C8 [] = {0x3F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x08, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*53C8*/
const unsigned char  uc2_53C9 [] = {0x3F, 0xC0, 0x14, 0x40, 0x12, 0x40, 0x0A, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*53C9*/
const unsigned char  uc2_53CA [] = {0x3F, 0x80, 0x08, 0x80, 0x09, 0x00, 0x09, 0xC0, 0x08, 0x40, 0x0C, 0x40, 0x0A, 0x80, 0x11, 0x00, 0x12, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*53CA*/
const unsigned char  uc2_53CB [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0xF0, 0x04, 0x00, 0x07, 0xC0, 0x08, 0x40, 0x14, 0x40, 0x62, 0x80, 0x01, 0x00, 0x06, 0xC0, 0x38, 0x30, 0x00, 0x00 }; /*53CB*/
const unsigned char  uc2_53CC [] = {0x03, 0xF0, 0x7D, 0x10, 0x05, 0x10, 0x65, 0x10, 0x14, 0xA0, 0x08, 0xA0, 0x08, 0x40, 0x14, 0xA0, 0x24, 0xA0, 0x21, 0x20, 0x46, 0x10, 0x00, 0x00 }; /*53CC*/
const unsigned char  uc2_53CD [] = {0x00, 0xF0, 0x1F, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x12, 0x40, 0x12, 0x40, 0x21, 0x80, 0x22, 0x40, 0x4C, 0x30, 0x00, 0x00 }; /*53CD*/
const unsigned char  uc2_53D0 [] = {0x01, 0xE0, 0x3E, 0x00, 0x08, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x16, 0x80, 0x11, 0x00, 0x62, 0x80, 0x1C, 0x70, 0x00, 0x00 }; /*53D0*/
const unsigned char  uc2_53D1 [] = {0x12, 0xC0, 0x12, 0x20, 0x22, 0x00, 0x3F, 0xF0, 0x04, 0x00, 0x07, 0xC0, 0x0C, 0x40, 0x12, 0x80, 0x61, 0x00, 0x06, 0xC0, 0x18, 0x30, 0x00, 0x00 }; /*53D1*/
const unsigned char  uc2_53D4 [] = {0x08, 0x00, 0x09, 0xE0, 0x0E, 0xA0, 0x08, 0xA0, 0x7F, 0xA0, 0x00, 0xA0, 0x2C, 0x40, 0x2A, 0x40, 0x4A, 0xA0, 0x08, 0xA0, 0x31, 0x10, 0x00, 0x00 }; /*53D4*/
const unsigned char  uc2_53D6 [] = {0x7E, 0x00, 0x25, 0xE0, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0x40, 0x2E, 0x40, 0x74, 0xA0, 0x04, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*53D6*/
const unsigned char  uc2_53D7 [] = {0x01, 0xE0, 0x3E, 0x40, 0x24, 0x40, 0x12, 0x80, 0x7F, 0xE0, 0x40, 0x20, 0x1F, 0x80, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*53D7*/
const unsigned char  uc2_53D8 [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x15, 0x60, 0x65, 0x10, 0x00, 0x00, 0x1F, 0xC0, 0x08, 0x40, 0x07, 0x80, 0x78, 0x70, 0x00, 0x00 }; /*53D8*/
const unsigned char  uc2_53D9 [] = {0x08, 0x00, 0x15, 0xE0, 0x22, 0xA0, 0x40, 0xA0, 0x3E, 0xA0, 0x08, 0xA0, 0x7F, 0x40, 0x28, 0x40, 0x2A, 0xA0, 0x4A, 0xA0, 0x31, 0x10, 0x00, 0x00 }; /*53D9*/
const unsigned char  uc2_53DB [] = {0x10, 0x60, 0x57, 0x80, 0x3A, 0x00, 0x12, 0x00, 0x7F, 0xE0, 0x12, 0xA0, 0x7E, 0xA0, 0x12, 0x40, 0x24, 0x40, 0x24, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*53DB*/
const unsigned char  uc2_53DF [] = {0x0A, 0x00, 0x32, 0xE0, 0x22, 0x20, 0x3A, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xC0, 0x10, 0x40, 0x0F, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*53DF*/
const unsigned char  uc2_53E0 [] = {0x0F, 0x00, 0x05, 0x00, 0x7A, 0xE0, 0x25, 0x20, 0x18, 0xC0, 0x25, 0x20, 0x7F, 0xF0, 0x50, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*53E0*/
const unsigned char  uc2_53E3 [] = {0x7F, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*53E3*/
const unsigned char  uc2_53E4 [] = {0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*53E4*/
const unsigned char  uc2_53E5 [] = {0x08, 0x00, 0x0F, 0xF0, 0x10, 0x10, 0x60, 0x10, 0x0F, 0x90, 0x08, 0x90, 0x08, 0x90, 0x0F, 0x90, 0x08, 0x90, 0x00, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*53E5*/
const unsigned char  uc2_53E6 [] = {0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x10, 0x04, 0x10, 0x18, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*53E6*/
const unsigned char  uc2_53E8 [] = {0x07, 0xF0, 0x79, 0x10, 0x49, 0x10, 0x49, 0x10, 0x49, 0x10, 0x49, 0x10, 0x49, 0x10, 0x79, 0x10, 0x4A, 0x10, 0x04, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*53E8*/
const unsigned char  uc2_53E9 [] = {0x01, 0xF0, 0x79, 0x10, 0x49, 0x10, 0x49, 0x10, 0x49, 0x10, 0x49, 0x10, 0x49, 0x10, 0x79, 0x60, 0x49, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*53E9*/
const unsigned char  uc2_53EA [] = {0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x00, 0x00, 0x08, 0xC0, 0x08, 0x20, 0x10, 0x10, 0x60, 0x10, 0x00, 0x00 }; /*53EA*/
const unsigned char  uc2_53EB [] = {0x00, 0x20, 0x7A, 0x20, 0x4A, 0x20, 0x4A, 0x20, 0x4A, 0x20, 0x4A, 0x20, 0x4A, 0xE0, 0x7B, 0x20, 0x48, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*53EB*/
const unsigned char  uc2_53EC [] = {0x3F, 0xF0, 0x02, 0x10, 0x02, 0x10, 0x02, 0x10, 0x04, 0xE0, 0x18, 0x00, 0x6F, 0xF0, 0x08, 0x10, 0x08, 0x10, 0x0F, 0xF0, 0x08, 0x10, 0x00, 0x00 }; /*53EC*/
const unsigned char  uc2_53ED [] = {0x02, 0x40, 0x72, 0x40, 0x52, 0x40, 0x52, 0x40, 0x52, 0x40, 0x52, 0x40, 0x72, 0x40, 0x54, 0x40, 0x04, 0x20, 0x08, 0x20, 0x10, 0x10, 0x00, 0x00 }; /*53ED*/
const unsigned char  uc2_53EE [] = {0x07, 0xF0, 0x78, 0x80, 0x48, 0x80, 0x48, 0x80, 0x48, 0x80, 0x48, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*53EE*/
const unsigned char  uc2_53EF [] = {0x7F, 0xF0, 0x00, 0x40, 0x00, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x12, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x00, 0x40, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*53EF*/
const unsigned char  uc2_53F0 [] = {0x04, 0x00, 0x04, 0x40, 0x08, 0x20, 0x11, 0xE0, 0x1E, 0x10, 0x00, 0x10, 0x0F, 0xE0, 0x08, 0x20, 0x08, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x00, 0x00 }; /*53F0*/
const unsigned char  uc2_53F1 [] = {0x01, 0x00, 0x79, 0x10, 0x49, 0x10, 0x49, 0x20, 0x49, 0x40, 0x4B, 0x80, 0x49, 0x10, 0x49, 0x10, 0x79, 0x10, 0x49, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*53F1*/
const unsigned char  uc2_53F2 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x32, 0x00, 0x0C, 0x00, 0x13, 0x00, 0x60, 0xF0, 0x00, 0x00 }; /*53F2*/
const unsigned char  uc2_53F3 [] = {0x04, 0x00, 0x04, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x08, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x08, 0x40, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x00, 0x00 }; /*53F3*/
const unsigned char  uc2_53F5 [] = {0x7F, 0xF0, 0x40, 0x00, 0x40, 0x00, 0x4F, 0xC0, 0x48, 0x40, 0x48, 0x40, 0x48, 0x40, 0x4F, 0xC0, 0x40, 0x00, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*53F5*/
const unsigned char  uc2_53F6 [] = {0x00, 0x80, 0x78, 0x80, 0x48, 0x80, 0x48, 0x80, 0x4F, 0xF0, 0x48, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*53F6*/
const unsigned char  uc2_53F7 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x10, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*53F7*/
const unsigned char  uc2_53F8 [] = {0x3F, 0xF0, 0x00, 0x10, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x10, 0x1F, 0x10, 0x11, 0x10, 0x11, 0x10, 0x1F, 0x10, 0x11, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*53F8*/
const unsigned char  uc2_53F9 [] = {0x07, 0xE0, 0x7A, 0x20, 0x4A, 0x20, 0x4A, 0x20, 0x49, 0x40, 0x49, 0x40, 0x48, 0x80, 0x79, 0x40, 0x49, 0x40, 0x02, 0x20, 0x04, 0x10, 0x00, 0x00 }; /*53F9*/
const unsigned char  uc2_53FB [] = {0x00, 0x80, 0x78, 0x80, 0x4B, 0xF0, 0x48, 0x90, 0x48, 0x90, 0x48, 0x90, 0x48, 0x90, 0x79, 0x10, 0x49, 0x10, 0x02, 0x10, 0x0C, 0xE0, 0x00, 0x00 }; /*53FB*/
const unsigned char  uc2_53FC [] = {0x03, 0xF0, 0x78, 0x10, 0x48, 0x10, 0x48, 0x50, 0x48, 0x90, 0x48, 0x90, 0x49, 0x10, 0x79, 0x10, 0x4A, 0x10, 0x02, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*53FC*/
const unsigned char  uc2_53FD [] = {0x03, 0xC0, 0x7A, 0x40, 0x4A, 0x40, 0x4A, 0x40, 0x4A, 0x40, 0x4A, 0x40, 0x4A, 0x40, 0x7A, 0x50, 0x4A, 0x50, 0x04, 0x50, 0x18, 0x20, 0x00, 0x00 }; /*53FD*/
const unsigned char  uc2_5401 [] = {0x03, 0xE0, 0x70, 0x80, 0x50, 0x80, 0x50, 0x80, 0x50, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x70, 0x80, 0x50, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*5401*/
const unsigned char  uc2_5403 [] = {0x02, 0x00, 0x73, 0xF0, 0x52, 0x00, 0x54, 0x00, 0x5B, 0xE0, 0x50, 0x20, 0x50, 0x40, 0x70, 0x80, 0x51, 0x10, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*5403*/
const unsigned char  uc2_5404 [] = {0x08, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x35, 0x00, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x70, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*5404*/
const unsigned char  uc2_5406 [] = {0x01, 0x00, 0x71, 0x00, 0x51, 0x20, 0x52, 0x20, 0x54, 0x40, 0x57, 0x80, 0x51, 0x40, 0x72, 0x20, 0x54, 0xE0, 0x07, 0x10, 0x00, 0x10, 0x00, 0x00 }; /*5406*/
const unsigned char  uc2_5408 [] = {0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5408*/
const unsigned char  uc2_5409 [] = {0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5409*/
const unsigned char  uc2_540A [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*540A*/
const unsigned char  uc2_540C [] = {0x7F, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x5F, 0xD0, 0x40, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*540C*/
const unsigned char  uc2_540D [] = {0x02, 0x00, 0x03, 0xF0, 0x0C, 0x10, 0x36, 0x60, 0x01, 0x80, 0x06, 0x00, 0x1F, 0xF0, 0x68, 0x10, 0x08, 0x10, 0x0F, 0xF0, 0x08, 0x10, 0x00, 0x00 }; /*540D*/
const unsigned char  uc2_540E [] = {0x01, 0xE0, 0x1E, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x24, 0x20, 0x27, 0xE0, 0x44, 0x20, 0x00, 0x00 }; /*540E*/
const unsigned char  uc2_540F [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x00, 0x1A, 0x00, 0x04, 0x00, 0x1B, 0x80, 0x60, 0x70, 0x00, 0x00 }; /*540F*/
const unsigned char  uc2_5410 [] = {0x00, 0x80, 0x70, 0x80, 0x50, 0x80, 0x53, 0xE0, 0x50, 0x80, 0x50, 0x80, 0x50, 0x80, 0x70, 0x80, 0x50, 0x80, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5410*/
const unsigned char  uc2_5411 [] = {0x04, 0x00, 0x08, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*5411*/
const unsigned char  uc2_5412 [] = {0x00, 0xE0, 0x0F, 0x00, 0x71, 0x00, 0x51, 0x00, 0x51, 0x70, 0x5F, 0x80, 0x51, 0x00, 0x51, 0x10, 0x71, 0x10, 0x51, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5412*/
const unsigned char  uc2_5413 [] = {0x0F, 0xF0, 0x71, 0x00, 0x51, 0x00, 0x51, 0x80, 0x51, 0x40, 0x51, 0x40, 0x51, 0x20, 0x71, 0x20, 0x51, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*5413*/
const unsigned char  uc2_5415 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*5415*/
const unsigned char  uc2_5416 [] = {0x04, 0x10, 0x02, 0x10, 0x79, 0x20, 0x49, 0x40, 0x48, 0x80, 0x48, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5416*/
const unsigned char  uc2_5417 [] = {0x07, 0xE0, 0x70, 0x20, 0x52, 0x20, 0x52, 0x20, 0x54, 0x40, 0x57, 0xF0, 0x50, 0x10, 0x70, 0x10, 0x57, 0xD0, 0x00, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5417*/
const unsigned char  uc2_541B [] = {0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x04, 0x00, 0x0F, 0xE0, 0x78, 0x20, 0x08, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x00, 0x00 }; /*541B*/
const unsigned char  uc2_541D [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x70, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*541D*/
const unsigned char  uc2_541E [] = {0x3F, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xE0, 0x08, 0x80, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*541E*/
const unsigned char  uc2_541F [] = {0x01, 0x00, 0x71, 0x80, 0x52, 0x40, 0x5C, 0x30, 0x51, 0x00, 0x50, 0x80, 0x57, 0xE0, 0x70, 0x20, 0x50, 0x40, 0x00, 0x80, 0x01, 0x00, 0x00, 0x00 }; /*541F*/
const unsigned char  uc2_5420 [] = {0x01, 0x00, 0x71, 0x40, 0x51, 0x20, 0x51, 0x00, 0x5F, 0xF0, 0x51, 0x00, 0x52, 0x80, 0x72, 0x80, 0x54, 0x40, 0x04, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*5420*/
const unsigned char  uc2_5421 [] = {0x04, 0x80, 0x74, 0x80, 0x54, 0x80, 0x54, 0x90, 0x57, 0xE0, 0x54, 0x80, 0x54, 0x80, 0x74, 0x90, 0x55, 0x90, 0x06, 0x90, 0x04, 0x60, 0x00, 0x00 }; /*5421*/
const unsigned char  uc2_5423 [] = {0x00, 0x80, 0x00, 0x40, 0x71, 0x40, 0x51, 0x40, 0x55, 0x00, 0x55, 0x20, 0x55, 0x10, 0x59, 0x50, 0x71, 0x50, 0x51, 0x40, 0x00, 0x80, 0x00, 0x00 }; /*5423*/
const unsigned char  uc2_5426 [] = {0x3F, 0xF0, 0x01, 0x00, 0x02, 0x00, 0x06, 0xC0, 0x1A, 0x20, 0x62, 0x10, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*5426*/
const unsigned char  uc2_5427 [] = {0x03, 0xE0, 0x72, 0xA0, 0x52, 0xA0, 0x52, 0xA0, 0x52, 0xA0, 0x53, 0xE0, 0x52, 0x20, 0x72, 0x00, 0x52, 0x10, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*5427*/
const unsigned char  uc2_5428 [] = {0x00, 0x80, 0x70, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x52, 0xA0, 0x52, 0xA0, 0x53, 0xE0, 0x70, 0xA0, 0x50, 0x90, 0x00, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*5428*/
const unsigned char  uc2_5429 [] = {0x02, 0x80, 0x72, 0x80, 0x54, 0x40, 0x54, 0x40, 0x58, 0x30, 0x57, 0xC0, 0x51, 0x40, 0x71, 0x40, 0x52, 0x40, 0x02, 0x40, 0x0D, 0x80, 0x00, 0x00 }; /*5429*/
const unsigned char  uc2_542B [] = {0x06, 0x00, 0x09, 0x00, 0x14, 0xC0, 0x62, 0x30, 0x1F, 0x80, 0x00, 0x80, 0x03, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*542B*/
const unsigned char  uc2_542C [] = {0x00, 0x60, 0x77, 0x80, 0x54, 0x00, 0x54, 0x00, 0x57, 0xF0, 0x54, 0x80, 0x54, 0x80, 0x74, 0x80, 0x54, 0x80, 0x08, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*542C*/
const unsigned char  uc2_542D [] = {0x03, 0x00, 0x70, 0x80, 0x5F, 0xF0, 0x50, 0x00, 0x53, 0xC0, 0x52, 0x40, 0x52, 0x40, 0x72, 0x50, 0x54, 0x50, 0x04, 0x50, 0x18, 0x20, 0x00, 0x00 }; /*542D*/
const unsigned char  uc2_542E [] = {0x01, 0x00, 0x71, 0x00, 0x52, 0x40, 0x54, 0x60, 0x57, 0xA0, 0x52, 0x80, 0x52, 0x80, 0x72, 0x90, 0x54, 0x90, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*542E*/
const unsigned char  uc2_542F [] = {0x06, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x24, 0x10, 0x27, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*542F*/
const unsigned char  uc2_5431 [] = {0x00, 0x80, 0x70, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x50, 0x80, 0x57, 0xE0, 0x52, 0x20, 0x71, 0x40, 0x50, 0x80, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*5431*/
const unsigned char  uc2_5432 [] = {0x07, 0x90, 0x70, 0x90, 0x50, 0x90, 0x53, 0x90, 0x52, 0x10, 0x54, 0x10, 0x57, 0x90, 0x70, 0x90, 0x50, 0x90, 0x00, 0x90, 0x03, 0x10, 0x00, 0x00 }; /*5432*/
const unsigned char  uc2_5434 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*5434*/
const unsigned char  uc2_5435 [] = {0x01, 0x00, 0x71, 0x00, 0x55, 0x20, 0x55, 0x10, 0x55, 0x10, 0x59, 0x40, 0x51, 0x40, 0x70, 0x80, 0x51, 0x00, 0x06, 0x00, 0x18, 0x00, 0x00, 0x00 }; /*5435*/
const unsigned char  uc2_5438 [] = {0x07, 0xC0, 0x72, 0x40, 0x52, 0x40, 0x52, 0x80, 0x52, 0xE0, 0x52, 0x20, 0x52, 0x20, 0x75, 0x40, 0x54, 0x80, 0x09, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*5438*/
const unsigned char  uc2_5439 [] = {0x04, 0x00, 0x77, 0xE0, 0x54, 0x20, 0x55, 0x20, 0x59, 0x40, 0x51, 0x00, 0x52, 0x80, 0x72, 0x80, 0x52, 0x40, 0x04, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*5439*/
const unsigned char  uc2_543B [] = {0x04, 0x00, 0x07, 0xF0, 0x75, 0x50, 0x59, 0x50, 0x51, 0x50, 0x52, 0x50, 0x5C, 0x90, 0x50, 0x90, 0x71, 0x10, 0x46, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*543B*/
const unsigned char  uc2_543C [] = {0x0F, 0x40, 0x71, 0x40, 0x51, 0x40, 0x52, 0x40, 0x52, 0x40, 0x53, 0xC0, 0x5E, 0x40, 0x72, 0x50, 0x52, 0x50, 0x02, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*543C*/
const unsigned char  uc2_543E [] = {0x3F, 0xE0, 0x04, 0x00, 0x1F, 0xC0, 0x04, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*543E*/
const unsigned char  uc2_5440 [] = {0x07, 0xE0, 0x70, 0x40, 0x52, 0x40, 0x54, 0x40, 0x57, 0xF0, 0x51, 0x40, 0x51, 0x40, 0x72, 0x40, 0x52, 0x40, 0x0C, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*5440*/
const unsigned char  uc2_5443 [] = {0x07, 0xF0, 0x74, 0x00, 0x54, 0x00, 0x55, 0xE0, 0x55, 0x20, 0x55, 0x20, 0x75, 0x20, 0x55, 0x40, 0x09, 0x10, 0x09, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*5443*/
const unsigned char  uc2_5446 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x07, 0x00, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*5446*/
const unsigned char  uc2_5448 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5448*/
const unsigned char  uc2_544A [] = {0x12, 0x00, 0x12, 0x00, 0x1F, 0xE0, 0x22, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*544A*/
const unsigned char  uc2_544B [] = {0x01, 0x00, 0x71, 0x00, 0x57, 0xC0, 0x51, 0x00, 0x51, 0x00, 0x5F, 0xE0, 0x51, 0x00, 0x72, 0x80, 0x52, 0x80, 0x04, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*544B*/
const unsigned char  uc2_5450 [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x54, 0x90, 0x55, 0x50, 0x55, 0x50, 0x76, 0x50, 0x54, 0x10, 0x04, 0x10, 0x04, 0xE0, 0x00, 0x00 }; /*5450*/
const unsigned char  uc2_5452 [] = {0x07, 0xE0, 0x71, 0x00, 0x51, 0x00, 0x51, 0x00, 0x5F, 0xF0, 0x51, 0x40, 0x51, 0x40, 0x72, 0x50, 0x52, 0x50, 0x04, 0x50, 0x18, 0x60, 0x00, 0x00 }; /*5452*/
const unsigned char  uc2_5453 [] = {0x02, 0x40, 0x0F, 0xF0, 0x72, 0x40, 0x50, 0x00, 0x57, 0xC0, 0x50, 0x40, 0x50, 0x80, 0x51, 0x00, 0x72, 0x10, 0x54, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*5453*/
const unsigned char  uc2_5454 [] = {0x01, 0x00, 0x71, 0x00, 0x5F, 0xF0, 0x51, 0x00, 0x51, 0x00, 0x52, 0x80, 0x52, 0x80, 0x74, 0x40, 0x56, 0x40, 0x09, 0x20, 0x11, 0x10, 0x00, 0x00 }; /*5454*/
const unsigned char  uc2_5455 [] = {0x07, 0xF0, 0x74, 0x00, 0x55, 0x20, 0x54, 0xA0, 0x54, 0xA0, 0x54, 0x40, 0x54, 0xA0, 0x74, 0xA0, 0x55, 0x20, 0x04, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*5455*/
const unsigned char  uc2_5456 [] = {0x07, 0xF0, 0x74, 0x00, 0x54, 0x40, 0x54, 0x40, 0x55, 0xF0, 0x54, 0x50, 0x54, 0x50, 0x74, 0x90, 0x54, 0x90, 0x09, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*5456*/
const unsigned char  uc2_5457 [] = {0x07, 0xE0, 0x74, 0x20, 0x54, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x71, 0x00, 0x51, 0x60, 0x02, 0x10, 0x0C, 0x10, 0x00, 0x00 }; /*5457*/
const unsigned char  uc2_5458 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x22, 0x20, 0x22, 0x20, 0x05, 0x80, 0x18, 0x60, 0x60, 0x10, 0x00, 0x00 }; /*5458*/
const unsigned char  uc2_5459 [] = {0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x45, 0x90, 0x58, 0x50, 0x40, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*5459*/
const unsigned char  uc2_545B [] = {0x01, 0x00, 0x72, 0x80, 0x54, 0x40, 0x58, 0x30, 0x57, 0xC0, 0x54, 0x40, 0x54, 0x40, 0x75, 0x90, 0x54, 0x10, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*545B*/
const unsigned char  uc2_545C [] = {0x01, 0x00, 0x77, 0xC0, 0x54, 0x40, 0x54, 0x40, 0x55, 0x80, 0x54, 0x00, 0x57, 0xF0, 0x70, 0x10, 0x4F, 0xD0, 0x00, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*545C*/
const unsigned char  uc2_5462 [] = {0x07, 0xE0, 0x74, 0x20, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x00, 0x55, 0x20, 0x55, 0x20, 0x75, 0xC0, 0x55, 0x10, 0x09, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*5462*/
const unsigned char  uc2_5464 [] = {0x01, 0x00, 0x72, 0x80, 0x54, 0x40, 0x59, 0x30, 0x50, 0x80, 0x50, 0x00, 0x57, 0xE0, 0x70, 0x20, 0x53, 0x40, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5464*/
const unsigned char  uc2_5466 [] = {0x02, 0x40, 0x72, 0x40, 0x55, 0xF0, 0x55, 0x50, 0x57, 0x50, 0x52, 0x50, 0x52, 0x50, 0x55, 0x50, 0x75, 0x50, 0x56, 0x90, 0x01, 0x60, 0x00, 0x00 }; /*5466*/
const unsigned char  uc2_5468 [] = {0x3F, 0xE0, 0x20, 0x20, 0x22, 0x20, 0x27, 0x20, 0x22, 0x20, 0x2F, 0xA0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*5468*/
const unsigned char  uc2_5471 [] = {0x00, 0xE0, 0x77, 0x40, 0x55, 0x40, 0x55, 0x40, 0x55, 0x40, 0x55, 0x40, 0x55, 0x20, 0x75, 0xA0, 0x59, 0x60, 0x09, 0xD0, 0x10, 0x50, 0x00, 0x00 }; /*5471*/
const unsigned char  uc2_5472 [] = {0x01, 0x40, 0x75, 0x40, 0x55, 0x50, 0x55, 0xD0, 0x55, 0x60, 0x55, 0x40, 0x55, 0x40, 0x75, 0x50, 0x55, 0xD0, 0x0E, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*5472*/
const unsigned char  uc2_5473 [] = {0x01, 0x00, 0x71, 0x00, 0x57, 0xE0, 0x51, 0x00, 0x51, 0x00, 0x5F, 0xF0, 0x53, 0x80, 0x75, 0x40, 0x55, 0x40, 0x09, 0x30, 0x01, 0x00, 0x00, 0x00 }; /*5473*/
const unsigned char  uc2_5475 [] = {0x0F, 0xF0, 0x70, 0x20, 0x50, 0x20, 0x57, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x57, 0xA0, 0x74, 0xA0, 0x50, 0x20, 0x00, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*5475*/
const unsigned char  uc2_5476 [] = {0x04, 0x00, 0x74, 0xF0, 0x5F, 0x50, 0x55, 0x50, 0x55, 0x50, 0x5D, 0x50, 0x52, 0x50, 0x72, 0x20, 0x55, 0x20, 0x09, 0x60, 0x10, 0x90, 0x00, 0x00 }; /*5476*/
const unsigned char  uc2_5477 [] = {0x07, 0xF0, 0x74, 0x90, 0x54, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x57, 0xF0, 0x74, 0x90, 0x50, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5477*/
const unsigned char  uc2_5478 [] = {0x0F, 0xF0, 0x70, 0x80, 0x50, 0x80, 0x51, 0x00, 0x51, 0x40, 0x53, 0x20, 0x75, 0x10, 0x49, 0x10, 0x01, 0x00, 0x00, 0x00, 0x0F, 0xF0, 0x00, 0x00 }; /*5478*/
const unsigned char  uc2_547B [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x77, 0xF0, 0x54, 0x90, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*547B*/
const unsigned char  uc2_547C [] = {0x00, 0x60, 0x77, 0x80, 0x54, 0xA0, 0x52, 0xA0, 0x52, 0xC0, 0x50, 0x80, 0x5F, 0xF0, 0x70, 0x80, 0x50, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*547C*/
const unsigned char  uc2_547D [] = {0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x00, 0x3D, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3D, 0x20, 0x25, 0x40, 0x01, 0x00, 0x00, 0x00 }; /*547D*/
const unsigned char  uc2_5480 [] = {0x07, 0xE0, 0x74, 0x20, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x54, 0x20, 0x57, 0xE0, 0x74, 0x20, 0x54, 0x20, 0x0F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5480*/
const unsigned char  uc2_5482 [] = {0x07, 0xF0, 0x74, 0x00, 0x54, 0x40, 0x55, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x55, 0x50, 0x75, 0x60, 0x54, 0x40, 0x04, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*5482*/
const unsigned char  uc2_5484 [] = {0x00, 0x80, 0x74, 0x90, 0x54, 0x90, 0x54, 0x90, 0x57, 0xF0, 0x50, 0x80, 0x54, 0x90, 0x74, 0x90, 0x54, 0x90, 0x07, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*5484*/
const unsigned char  uc2_5486 [] = {0x04, 0x00, 0x77, 0xE0, 0x58, 0x20, 0x57, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x57, 0xA0, 0x74, 0x40, 0x55, 0x90, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*5486*/
const unsigned char  uc2_548B [] = {0x04, 0x00, 0x77, 0xF0, 0x5A, 0x00, 0x52, 0x00, 0x53, 0xE0, 0x52, 0x00, 0x52, 0x00, 0x73, 0xE0, 0x52, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*548B*/
const unsigned char  uc2_548C [] = {0x06, 0x00, 0x38, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x7E, 0x90, 0x08, 0x90, 0x1C, 0x90, 0x2A, 0x90, 0x2A, 0xF0, 0x48, 0x90, 0x08, 0x00, 0x00, 0x00 }; /*548C*/
const unsigned char  uc2_548E [] = {0x10, 0x80, 0x1E, 0x80, 0x22, 0xE0, 0x54, 0x90, 0x0C, 0x80, 0x13, 0x80, 0x60, 0x70, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*548E*/
const unsigned char  uc2_548F [] = {0x01, 0x80, 0x70, 0x40, 0x53, 0x80, 0x50, 0x80, 0x56, 0x90, 0x52, 0xD0, 0x52, 0xA0, 0x72, 0xA0, 0x54, 0x90, 0x08, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*548F*/
const unsigned char  uc2_5490 [] = {0x02, 0x20, 0x72, 0x20, 0x55, 0xF0, 0x54, 0x20, 0x5D, 0x20, 0x54, 0xA0, 0x54, 0xA0, 0x74, 0xA0, 0x54, 0x20, 0x04, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*5490*/
const unsigned char  uc2_5492 [] = {0x3D, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3D, 0xE0, 0x00, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x08, 0x90, 0x10, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*5492*/
const unsigned char  uc2_5494 [] = {0x01, 0x00, 0x71, 0xE0, 0x51, 0x00, 0x5F, 0xF0, 0x50, 0x00, 0x51, 0x00, 0x51, 0x00, 0x71, 0xC0, 0x51, 0x20, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*5494*/
const unsigned char  uc2_5495 [] = {0x00, 0x80, 0x70, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x50, 0x80, 0x53, 0xE0, 0x52, 0x20, 0x72, 0x20, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5495*/
const unsigned char  uc2_5496 [] = {0x01, 0x00, 0x71, 0x70, 0x57, 0xD0, 0x51, 0x50, 0x51, 0x50, 0x51, 0x50, 0x51, 0x50, 0x72, 0x50, 0x52, 0x70, 0x04, 0x50, 0x19, 0x80, 0x00, 0x00 }; /*5496*/
const unsigned char  uc2_5499 [] = {0x02, 0xC0, 0x72, 0x20, 0x5F, 0xF0, 0x52, 0x80, 0x52, 0xA0, 0x52, 0xC0, 0x52, 0x80, 0x74, 0x90, 0x55, 0x90, 0x0A, 0x90, 0x10, 0x60, 0x00, 0x00 }; /*5499*/
const unsigned char  uc2_549A [] = {0x02, 0x00, 0x73, 0xE0, 0x52, 0x20, 0x55, 0x40, 0x50, 0x80, 0x53, 0x40, 0x5C, 0x30, 0x71, 0x80, 0x50, 0x40, 0x03, 0x00, 0x00, 0x80, 0x00, 0x00 }; /*549A*/
const unsigned char  uc2_549B [] = {0x01, 0x00, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x10, 0x50, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x70, 0x80, 0x50, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*549B*/
const unsigned char  uc2_549D [] = {0x01, 0x20, 0x71, 0x20, 0x52, 0x40, 0x54, 0x90, 0x57, 0xF0, 0x51, 0x20, 0x52, 0x40, 0x54, 0x80, 0x77, 0x70, 0x40, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*549D*/
const unsigned char  uc2_54A3 [] = {0x01, 0x00, 0x09, 0x20, 0x75, 0x20, 0x55, 0x40, 0x51, 0x00, 0x5F, 0xF0, 0x52, 0x80, 0x72, 0x80, 0x54, 0x90, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*54A3*/
const unsigned char  uc2_54A4 [] = {0x01, 0x00, 0x0F, 0xE0, 0x78, 0x20, 0x50, 0xC0, 0x57, 0x00, 0x51, 0x00, 0x51, 0x60, 0x53, 0x80, 0x7D, 0x10, 0x51, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*54A4*/
const unsigned char  uc2_54A6 [] = {0x01, 0x00, 0x0F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x51, 0x40, 0x53, 0xC0, 0x55, 0x00, 0x57, 0xE0, 0x71, 0x20, 0x52, 0xC0, 0x0C, 0x30, 0x00, 0x00 }; /*54A6*/
const unsigned char  uc2_54A7 [] = {0x0F, 0x10, 0x74, 0x10, 0x54, 0x50, 0x57, 0x50, 0x55, 0x50, 0x59, 0x50, 0x55, 0x50, 0x72, 0x50, 0x52, 0x10, 0x04, 0x10, 0x18, 0x60, 0x00, 0x00 }; /*54A7*/
const unsigned char  uc2_54A8 [] = {0x02, 0x00, 0x63, 0xE0, 0x14, 0x20, 0x01, 0x40, 0x12, 0x80, 0x6C, 0x70, 0x00, 0x00, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x00, 0x00 }; /*54A8*/
const unsigned char  uc2_54A9 [] = {0x02, 0x20, 0x71, 0x40, 0x57, 0xF0, 0x50, 0x80, 0x50, 0x80, 0x53, 0xE0, 0x50, 0x80, 0x50, 0x80, 0x77, 0xF0, 0x50, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*54A9*/
const unsigned char  uc2_54AA [] = {0x00, 0x80, 0x74, 0x90, 0x52, 0x90, 0x52, 0xA0, 0x57, 0xF0, 0x50, 0x80, 0x51, 0xC0, 0x72, 0xA0, 0x52, 0xA0, 0x04, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*54AA*/
const unsigned char  uc2_54AB [] = {0x3C, 0x00, 0x25, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3D, 0x20, 0x29, 0xE0, 0x28, 0x40, 0x25, 0x20, 0x25, 0x20, 0x42, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*54AB*/
const unsigned char  uc2_54AC [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xE0, 0x52, 0x40, 0x5C, 0x20, 0x52, 0xA0, 0x52, 0x80, 0x51, 0x00, 0x71, 0x00, 0x52, 0x80, 0x0C, 0x60, 0x00, 0x00 }; /*54AC*/
const unsigned char  uc2_54AD [] = {0x00, 0x80, 0x70, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x50, 0x00, 0x53, 0xE0, 0x72, 0x20, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*54AD*/
const unsigned char  uc2_54AF [] = {0x02, 0x00, 0x03, 0xC0, 0x72, 0x40, 0x56, 0x40, 0x51, 0x80, 0x5E, 0x70, 0x50, 0x00, 0x73, 0xC0, 0x52, 0x40, 0x03, 0xC0, 0x02, 0x40, 0x00, 0x00 }; /*54AF*/
const unsigned char  uc2_54B1 [] = {0x00, 0x40, 0x00, 0x80, 0x7B, 0xF0, 0x4A, 0x10, 0x4B, 0xF0, 0x4A, 0x10, 0x4B, 0xF0, 0x7A, 0x10, 0x4A, 0x10, 0x03, 0xF0, 0x02, 0x10, 0x00, 0x00 }; /*54B1*/
const unsigned char  uc2_54B3 [] = {0x03, 0x00, 0x00, 0x80, 0x77, 0xF0, 0x51, 0x00, 0x52, 0x20, 0x53, 0xC0, 0x50, 0x90, 0x77, 0x20, 0x50, 0x40, 0x01, 0xA0, 0x0E, 0x10, 0x00, 0x00 }; /*54B3*/
const unsigned char  uc2_54B4 [] = {0x02, 0x00, 0x77, 0xF0, 0x52, 0x00, 0x52, 0x80, 0x54, 0xA0, 0x55, 0xA0, 0x5A, 0xC0, 0x70, 0x80, 0x51, 0x40, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*54B4*/
const unsigned char  uc2_54B8 [] = {0x00, 0xA0, 0x3F, 0xF0, 0x20, 0x80, 0x2E, 0xA0, 0x20, 0xA0, 0x2E, 0xA0, 0x2A, 0xA0, 0x2E, 0x40, 0x2A, 0xD0, 0x41, 0x50, 0x42, 0x20, 0x00, 0x00 }; /*54B8*/
const unsigned char  uc2_54BB [] = {0x02, 0x80, 0x72, 0x80, 0x57, 0xE0, 0x5C, 0x80, 0x54, 0xC0, 0x55, 0xA0, 0x56, 0xA0, 0x74, 0x90, 0x54, 0x80, 0x04, 0x80, 0x04, 0x80, 0x00, 0x00 }; /*54BB*/
const unsigned char  uc2_54BD [] = {0x07, 0xF0, 0x74, 0x10, 0x54, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x54, 0xD0, 0x55, 0x30, 0x76, 0x30, 0x54, 0x10, 0x07, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*54BD*/
const unsigned char  uc2_54BF [] = {0x02, 0x00, 0x73, 0xE0, 0x54, 0xA0, 0x5D, 0xF0, 0x54, 0xA0, 0x55, 0xE0, 0x74, 0xA0, 0x54, 0x80, 0x04, 0x80, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00 }; /*54BF*/
const unsigned char  uc2_54C0 [] = {0x02, 0x00, 0x7F, 0xE0, 0x00, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x04, 0x20, 0x0A, 0xC0, 0x71, 0x00, 0x14, 0xC0, 0x18, 0x30, 0x00, 0x00 }; /*54C0*/
const unsigned char  uc2_54C1 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7D, 0xF0, 0x45, 0x10, 0x45, 0x10, 0x7D, 0xF0, 0x45, 0x10, 0x00, 0x00 }; /*54C1*/
const unsigned char  uc2_54C2 [] = {0x07, 0xF0, 0x71, 0x40, 0x51, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x55, 0x70, 0x76, 0x10, 0x54, 0x10, 0x07, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*54C2*/
const unsigned char  uc2_54C4 [] = {0x02, 0x40, 0x72, 0x40, 0x57, 0xE0, 0x52, 0x40, 0x52, 0x40, 0x5F, 0xF0, 0x50, 0x00, 0x72, 0x40, 0x52, 0x20, 0x04, 0x20, 0x08, 0x20, 0x00, 0x00 }; /*54C4*/
const unsigned char  uc2_54C6 [] = {0x01, 0x00, 0x71, 0xE0, 0x56, 0x20, 0x51, 0x40, 0x51, 0x80, 0x5E, 0x40, 0x50, 0xF0, 0x77, 0x10, 0x50, 0xA0, 0x00, 0xC0, 0x0F, 0x00, 0x00, 0x00 }; /*54C6*/
const unsigned char  uc2_54C7 [] = {0x00, 0x80, 0x73, 0xE0, 0x50, 0x80, 0x50, 0x80, 0x57, 0xF0, 0x50, 0x00, 0x50, 0x80, 0x73, 0xE0, 0x50, 0x80, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*54C7*/
const unsigned char  uc2_54C8 [] = {0x01, 0x00, 0x71, 0x00, 0x52, 0x80, 0x54, 0x40, 0x5B, 0xB0, 0x50, 0x00, 0x57, 0xC0, 0x74, 0x40, 0x54, 0x40, 0x07, 0xC0, 0x04, 0x40, 0x00, 0x00 }; /*54C8*/
const unsigned char  uc2_54C9 [] = {0x09, 0x40, 0x3D, 0x20, 0x09, 0x20, 0x7F, 0xF0, 0x01, 0x00, 0x3D, 0x20, 0x25, 0x20, 0x25, 0x40, 0x3C, 0x90, 0x21, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*54C9*/
const unsigned char  uc2_54CC [] = {0x00, 0x70, 0x77, 0x80, 0x54, 0x30, 0x55, 0xC0, 0x55, 0x50, 0x55, 0x50, 0x75, 0x60, 0x55, 0x40, 0x09, 0x20, 0x09, 0x60, 0x11, 0x90, 0x00, 0x00 }; /*54CC*/
const unsigned char  uc2_54CD [] = {0x00, 0x80, 0x71, 0x00, 0x57, 0xF0, 0x54, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x55, 0x50, 0x75, 0xD0, 0x54, 0x10, 0x04, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*54CD*/
const unsigned char  uc2_54CE [] = {0x02, 0x40, 0x0F, 0xF0, 0x72, 0x40, 0x50, 0x00, 0x52, 0x40, 0x52, 0x40, 0x52, 0x40, 0x71, 0x80, 0x51, 0x80, 0x02, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*54CE*/
const unsigned char  uc2_54CF [] = {0x07, 0xE0, 0x74, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x90, 0x54, 0x90, 0x74, 0x60, 0x54, 0x40, 0x05, 0x20, 0x06, 0x10, 0x00, 0x00 }; /*54CF*/
const unsigned char  uc2_54D0 [] = {0x07, 0xF0, 0x74, 0x00, 0x55, 0xF0, 0x54, 0x40, 0x54, 0x40, 0x54, 0xE0, 0x54, 0x40, 0x54, 0x40, 0x75, 0xF0, 0x54, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*54D0*/
const unsigned char  uc2_54D1 [] = {0x07, 0xF0, 0x71, 0x40, 0x51, 0x40, 0x59, 0x50, 0x55, 0x50, 0x55, 0x50, 0x55, 0x60, 0x71, 0x40, 0x51, 0x40, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*54D1*/
const unsigned char  uc2_54D2 [] = {0x08, 0x40, 0x74, 0x40, 0x55, 0xF0, 0x50, 0x40, 0x5C, 0x40, 0x54, 0xA0, 0x54, 0x90, 0x75, 0x10, 0x54, 0x00, 0x0B, 0x00, 0x10, 0xF0, 0x00, 0x00 }; /*54D2*/
const unsigned char  uc2_54D3 [] = {0x02, 0x00, 0x72, 0xE0, 0x5F, 0x00, 0x52, 0x50, 0x51, 0x90, 0x56, 0x60, 0x50, 0x00, 0x7F, 0xF0, 0x52, 0x80, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*54D3*/
const unsigned char  uc2_54D4 [] = {0x04, 0x80, 0x74, 0xA0, 0x57, 0xC0, 0x54, 0x90, 0x55, 0x90, 0x56, 0x60, 0x51, 0x00, 0x7F, 0xF0, 0x41, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*54D4*/
const unsigned char  uc2_54D5 [] = {0x00, 0x80, 0x74, 0x90, 0x54, 0x90, 0x57, 0xF0, 0x51, 0x00, 0x51, 0xE0, 0x51, 0x20, 0x76, 0xA0, 0x40, 0x40, 0x01, 0x80, 0x1E, 0x00, 0x00, 0x00 }; /*54D5*/
const unsigned char  uc2_54D7 [] = {0x02, 0x80, 0x72, 0xA0, 0x54, 0xC0, 0x5D, 0x90, 0x54, 0x90, 0x54, 0x60, 0x71, 0x00, 0x4F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*54D7*/
const unsigned char  uc2_54D9 [] = {0x01, 0x00, 0x71, 0x80, 0x52, 0x40, 0x5C, 0x30, 0x53, 0xC0, 0x50, 0x00, 0x57, 0xE0, 0x71, 0x00, 0x52, 0x40, 0x07, 0xA0, 0x00, 0x20, 0x00, 0x00 }; /*54D9*/
const unsigned char  uc2_54DA [] = {0x03, 0x80, 0x72, 0x80, 0x52, 0x80, 0x52, 0x80, 0x54, 0x60, 0x59, 0x00, 0x57, 0xE0, 0x71, 0x80, 0x53, 0x40, 0x0D, 0x30, 0x01, 0x00, 0x00, 0x00 }; /*54DA*/
const unsigned char  uc2_54DC [] = {0x01, 0x80, 0x00, 0x40, 0x77, 0xF0, 0x51, 0x40, 0x50, 0x80, 0x51, 0x40, 0x56, 0x30, 0x71, 0x40, 0x51, 0x40, 0x02, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*54DC*/
const unsigned char  uc2_54DD [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x51, 0x00, 0x52, 0x90, 0x5E, 0x90, 0x72, 0x60, 0x52, 0x40, 0x03, 0x20, 0x02, 0x10, 0x00, 0x00 }; /*54DD*/
const unsigned char  uc2_54DE [] = {0x01, 0x00, 0x72, 0x20, 0x53, 0xD0, 0x50, 0x90, 0x52, 0x80, 0x53, 0xE0, 0x54, 0x80, 0x70, 0x80, 0x57, 0xF0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*54DE*/
const unsigned char  uc2_54DF [] = {0x02, 0x40, 0x72, 0x70, 0x55, 0x50, 0x55, 0x50, 0x52, 0x90, 0x55, 0x50, 0x56, 0x50, 0x70, 0x10, 0x53, 0x10, 0x0C, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*54DF*/
const unsigned char  uc2_54E5 [] = {0x00, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x1E, 0x40, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x1E, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*54E5*/
const unsigned char  uc2_54E6 [] = {0x01, 0x00, 0x76, 0xA0, 0x52, 0x90, 0x5F, 0xF0, 0x52, 0x80, 0x52, 0xA0, 0x53, 0xA0, 0x76, 0x40, 0x52, 0x50, 0x02, 0xD0, 0x0D, 0x20, 0x00, 0x00 }; /*54E6*/
const unsigned char  uc2_54E7 [] = {0x00, 0x80, 0x73, 0xE0, 0x50, 0x80, 0x50, 0x80, 0x57, 0xF0, 0x51, 0x40, 0x55, 0x60, 0x75, 0x50, 0x5A, 0x50, 0x02, 0x40, 0x0D, 0x80, 0x00, 0x00 }; /*54E7*/
const unsigned char  uc2_54E8 [] = {0x04, 0xA0, 0x02, 0xA0, 0x72, 0xC0, 0x57, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x77, 0xE0, 0x54, 0x20, 0x04, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*54E8*/
const unsigned char  uc2_54E9 [] = {0x00, 0x00, 0x03, 0xE0, 0x3A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x28, 0x80, 0x3B, 0xE0, 0x28, 0x80, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*54E9*/
const unsigned char  uc2_54EA [] = {0x0F, 0x70, 0x75, 0x50, 0x55, 0x50, 0x5F, 0x50, 0x55, 0x60, 0x55, 0x50, 0x5F, 0x50, 0x75, 0x50, 0x55, 0x60, 0x09, 0x40, 0x12, 0x40, 0x00, 0x00 }; /*54EA*/
const unsigned char  uc2_54ED [] = {0x3D, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3D, 0xE0, 0x02, 0x40, 0x02, 0x20, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*54ED*/
const unsigned char  uc2_54EE [] = {0x01, 0x10, 0x77, 0xD0, 0x51, 0x20, 0x5F, 0xF0, 0x50, 0x80, 0x57, 0xE0, 0x52, 0x20, 0x7C, 0x40, 0x43, 0xF0, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*54EE*/
const unsigned char  uc2_54F2 [] = {0x10, 0x60, 0x7D, 0x80, 0x11, 0x00, 0x1D, 0xF0, 0x71, 0x40, 0x16, 0x40, 0x60, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*54F2*/
const unsigned char  uc2_54F3 [] = {0x04, 0x10, 0x74, 0xE0, 0x5E, 0x80, 0x54, 0x80, 0x54, 0xF0, 0x56, 0xA0, 0x5C, 0xA0, 0x74, 0xA0, 0x55, 0x20, 0x05, 0x20, 0x0A, 0x20, 0x00, 0x00 }; /*54F3*/
const unsigned char  uc2_54FA [] = {0x00, 0xA0, 0x77, 0xF0, 0x50, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x77, 0xF0, 0x54, 0x90, 0x04, 0x90, 0x04, 0x60, 0x00, 0x00 }; /*54FA*/
const unsigned char  uc2_54FC [] = {0x00, 0x80, 0x77, 0xF0, 0x52, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x53, 0xE0, 0x50, 0x20, 0x70, 0xC0, 0x50, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*54FC*/
const unsigned char  uc2_54FD [] = {0x07, 0xF0, 0x70, 0x80, 0x53, 0xE0, 0x52, 0xA0, 0x53, 0xE0, 0x52, 0xA0, 0x53, 0xE0, 0x70, 0x80, 0x56, 0x80, 0x01, 0xC0, 0x0E, 0x30, 0x00, 0x00 }; /*54FD*/
const unsigned char  uc2_54FF [] = {0x10, 0x00, 0x7D, 0xE0, 0x15, 0x20, 0x6D, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x3C, 0x40, 0x25, 0x80, 0x00, 0x00 }; /*54FF*/
const unsigned char  uc2_5501 [] = {0x00, 0x80, 0x77, 0xF0, 0x50, 0x00, 0x53, 0xE0, 0x50, 0x00, 0x53, 0xE0, 0x50, 0x00, 0x73, 0xE0, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5501*/
const unsigned char  uc2_5506 [] = {0x02, 0x40, 0x74, 0x20, 0x57, 0xD0, 0x52, 0x20, 0x5D, 0x10, 0x51, 0xD0, 0x56, 0x40, 0x71, 0x40, 0x50, 0x80, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*5506*/
const unsigned char  uc2_5507 [] = {0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xC0, 0x20, 0x00, 0x3F, 0xF0, 0x24, 0xA0, 0x26, 0x40, 0x24, 0x30, 0x2F, 0xE0, 0x48, 0x20, 0x4F, 0xE0, 0x00, 0x00 }; /*5507*/
const unsigned char  uc2_5509 [] = {0x01, 0x00, 0x72, 0x20, 0x57, 0xD0, 0x52, 0x00, 0x53, 0xE0, 0x54, 0x80, 0x50, 0x80, 0x7F, 0xF0, 0x51, 0x40, 0x02, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*5509*/
const unsigned char  uc2_550F [] = {0x06, 0x40, 0x71, 0x80, 0x56, 0x40, 0x51, 0x40, 0x5F, 0xF0, 0x52, 0x80, 0x57, 0xE0, 0x7A, 0xA0, 0x52, 0xA0, 0x02, 0xC0, 0x00, 0x80, 0x00, 0x00 }; /*550F*/
const unsigned char  uc2_5510 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x20, 0x1F, 0xF0, 0x11, 0x20, 0x17, 0xE0, 0x11, 0x00, 0x17, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x44, 0x20, 0x00, 0x00 }; /*5510*/
const unsigned char  uc2_5511 [] = {0x00, 0x80, 0x72, 0xA0, 0x52, 0xA0, 0x52, 0xA0, 0x55, 0xD0, 0x58, 0x90, 0x50, 0x80, 0x73, 0xE0, 0x50, 0x80, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*5511*/
const unsigned char  uc2_5514 [] = {0x07, 0xF0, 0x70, 0x80, 0x53, 0xE0, 0x50, 0xA0, 0x51, 0x20, 0x57, 0xF0, 0x50, 0x00, 0x73, 0xE0, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5514*/
const unsigned char  uc2_551B [] = {0x01, 0x00, 0x0F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x51, 0x00, 0x5F, 0xF0, 0x52, 0x00, 0x77, 0xC0, 0x4A, 0x40, 0x01, 0x80, 0x0E, 0x70, 0x00, 0x00 }; /*551B*/
const unsigned char  uc2_5520 [] = {0x01, 0x40, 0x77, 0xF0, 0x51, 0x40, 0x50, 0x00, 0x57, 0xF0, 0x54, 0x10, 0x51, 0x00, 0x77, 0xE0, 0x51, 0x20, 0x02, 0x20, 0x0C, 0xC0, 0x00, 0x00 }; /*5520*/
const unsigned char  uc2_5522 [] = {0x04, 0x90, 0x72, 0xA0, 0x50, 0x80, 0x53, 0xE0, 0x52, 0x20, 0x52, 0xA0, 0x52, 0xA0, 0x72, 0xA0, 0x50, 0x80, 0x01, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*5522*/
const unsigned char  uc2_5523 [] = {0x01, 0x00, 0x77, 0xC0, 0x54, 0x40, 0x57, 0xC0, 0x54, 0x40, 0x57, 0xC0, 0x51, 0x00, 0x71, 0xE0, 0x57, 0x10, 0x01, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5523*/
const unsigned char  uc2_5524 [] = {0x01, 0x00, 0x01, 0xC0, 0x72, 0x40, 0x57, 0xE0, 0x52, 0xA0, 0x52, 0xA0, 0x57, 0xF0, 0x70, 0x80, 0x41, 0x40, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*5524*/
const unsigned char  uc2_5527 [] = {0x07, 0x70, 0x75, 0x50, 0x57, 0x50, 0x55, 0x50, 0x57, 0x50, 0x54, 0x50, 0x56, 0x50, 0x75, 0x60, 0x57, 0x40, 0x05, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*5527*/
const unsigned char  uc2_552A [] = {0x01, 0x00, 0x0F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x52, 0x00, 0x5F, 0xF0, 0x55, 0x40, 0x5B, 0xB0, 0x71, 0x00, 0x5F, 0xE0, 0x01, 0x00, 0x00, 0x00 }; /*552A*/
const unsigned char  uc2_552C [] = {0x00, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x54, 0xE0, 0x57, 0x90, 0x74, 0xF0, 0x54, 0x00, 0x09, 0xC0, 0x09, 0x50, 0x16, 0x30, 0x00, 0x00 }; /*552C*/
const unsigned char  uc2_552E [] = {0x09, 0x00, 0x0F, 0xF0, 0x11, 0x00, 0x7F, 0xE0, 0x11, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*552E*/
const unsigned char  uc2_552F [] = {0x02, 0x80, 0x72, 0x40, 0x57, 0xF0, 0x5C, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x57, 0xE0, 0x74, 0x80, 0x54, 0x80, 0x07, 0xF0, 0x04, 0x00, 0x00, 0x00 }; /*552F*/
const unsigned char  uc2_5530 [] = {0x1F, 0x10, 0x71, 0x10, 0x5F, 0x50, 0x54, 0x50, 0x5F, 0x50, 0x55, 0x50, 0x55, 0x50, 0x75, 0x50, 0x56, 0x10, 0x14, 0x10, 0x24, 0x60, 0x00, 0x00 }; /*5530*/
const unsigned char  uc2_5531 [] = {0x03, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x57, 0xF0, 0x54, 0x10, 0x57, 0xF0, 0x74, 0x10, 0x54, 0x10, 0x07, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*5531*/
const unsigned char  uc2_5533 [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x10, 0x57, 0xF0, 0x54, 0xA0, 0x54, 0x90, 0x57, 0xF0, 0x74, 0x80, 0x55, 0x40, 0x0A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*5533*/
const unsigned char  uc2_5537 [] = {0x03, 0x00, 0x00, 0x80, 0x77, 0xF0, 0x52, 0x20, 0x57, 0xD0, 0x52, 0x20, 0x53, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x02, 0x20, 0x02, 0xC0, 0x00, 0x00 }; /*5537*/
const unsigned char  uc2_553C [] = {0x03, 0x00, 0x00, 0x80, 0x77, 0xF0, 0x52, 0x20, 0x51, 0x40, 0x57, 0xF0, 0x51, 0x00, 0x57, 0xF0, 0x72, 0x40, 0x51, 0xE0, 0x0E, 0x10, 0x00, 0x00 }; /*553C*/
const unsigned char  uc2_553E [] = {0x00, 0xE0, 0x0F, 0x00, 0x71, 0x00, 0x5F, 0xE0, 0x55, 0x40, 0x5F, 0xF0, 0x55, 0x40, 0x75, 0x40, 0x5F, 0xE0, 0x01, 0x00, 0x07, 0xC0, 0x00, 0x00 }; /*553E*/
const unsigned char  uc2_553F [] = {0x02, 0x00, 0x73, 0xF0, 0x55, 0x50, 0x52, 0x50, 0x54, 0x90, 0x53, 0x60, 0x70, 0x00, 0x51, 0x00, 0x0A, 0xA0, 0x0A, 0x50, 0x11, 0x90, 0x00, 0x00 }; /*553F*/
const unsigned char  uc2_5541 [] = {0x07, 0xF0, 0x74, 0x10, 0x54, 0x90, 0x55, 0xD0, 0x54, 0x90, 0x55, 0xD0, 0x54, 0x10, 0x75, 0xD0, 0x55, 0x50, 0x05, 0xD0, 0x08, 0x20, 0x00, 0x00 }; /*5541*/
const unsigned char  uc2_5543 [] = {0x01, 0x00, 0x05, 0xE0, 0x75, 0x00, 0x5F, 0xF0, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x77, 0xE0, 0x54, 0x20, 0x04, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*5543*/
const unsigned char  uc2_5544 [] = {0x0F, 0xF0, 0x71, 0x00, 0x51, 0x20, 0x56, 0xA0, 0x52, 0xC0, 0x57, 0xA0, 0x52, 0xA0, 0x71, 0xA0, 0x56, 0x90, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*5544*/
const unsigned char  uc2_5546 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x38, 0xA0, 0x27, 0xA0, 0x25, 0x20, 0x27, 0x20, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*5546*/
const unsigned char  uc2_5549 [] = {0x02, 0x40, 0x0F, 0xF0, 0x72, 0x40, 0x52, 0x40, 0x53, 0x60, 0x56, 0xE0, 0x5B, 0x50, 0x52, 0x40, 0x72, 0x40, 0x52, 0x40, 0x02, 0x40, 0x00, 0x00 }; /*5549*/
const unsigned char  uc2_554A [] = {0x1D, 0xF0, 0x74, 0x20, 0x54, 0x20, 0x55, 0xE0, 0x59, 0x20, 0x55, 0x20, 0x55, 0xE0, 0x75, 0x20, 0x58, 0x20, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*554A*/
const unsigned char  uc2_5550 [] = {0x03, 0x00, 0x00, 0x80, 0x77, 0xF0, 0x51, 0x40, 0x51, 0x60, 0x56, 0x90, 0x50, 0x80, 0x77, 0xF0, 0x50, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5550*/
const unsigned char  uc2_5555 [] = {0x04, 0x00, 0x77, 0xF0, 0x5A, 0x10, 0x53, 0xD0, 0x55, 0x10, 0x5F, 0xF0, 0x51, 0x10, 0x75, 0x50, 0x57, 0xD0, 0x00, 0x50, 0x00, 0xE0, 0x00, 0x00 }; /*5555*/
const unsigned char  uc2_5556 [] = {0x00, 0xA0, 0x72, 0xA0, 0x52, 0xC0, 0x55, 0x20, 0x52, 0x20, 0x5C, 0x80, 0x52, 0xA0, 0x72, 0xA0, 0x54, 0xC0, 0x01, 0x20, 0x0E, 0x10, 0x00, 0x00 }; /*5556*/
const unsigned char  uc2_555C [] = {0x0F, 0x70, 0x75, 0x50, 0x52, 0x20, 0x5D, 0xD0, 0x50, 0x00, 0x5F, 0xF0, 0x51, 0x50, 0x75, 0x50, 0x52, 0x20, 0x05, 0x60, 0x09, 0x90, 0x00, 0x00 }; /*555C*/
const unsigned char  uc2_5561 [] = {0x01, 0x40, 0x71, 0x40, 0x57, 0x70, 0x51, 0x40, 0x51, 0x40, 0x53, 0x60, 0x51, 0x40, 0x71, 0x40, 0x47, 0x70, 0x01, 0x40, 0x01, 0x40, 0x00, 0x00 }; /*5561*/
const unsigned char  uc2_5564 [] = {0x01, 0x00, 0x77, 0xE0, 0x55, 0x20, 0x57, 0xE0, 0x55, 0x20, 0x57, 0xE0, 0x51, 0x00, 0x52, 0x80, 0x7F, 0xF0, 0x50, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5564*/
const unsigned char  uc2_5565 [] = {0x00, 0x80, 0x71, 0x40, 0x56, 0x30, 0x51, 0xC0, 0x50, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x73, 0xE0, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5565*/
const unsigned char  uc2_5566 [] = {0x02, 0x20, 0x72, 0xF0, 0x5F, 0x00, 0x52, 0x90, 0x52, 0x50, 0x53, 0x50, 0x56, 0x50, 0x7A, 0x50, 0x52, 0x20, 0x02, 0x20, 0x0C, 0xF0, 0x00, 0x00 }; /*5566*/
const unsigned char  uc2_5567 [] = {0x00, 0x80, 0x77, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x52, 0x20, 0x72, 0xA0, 0x52, 0xA0, 0x01, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*5567*/
const unsigned char  uc2_556A [] = {0x02, 0x20, 0x72, 0x40, 0x5F, 0xF0, 0x52, 0x90, 0x52, 0x90, 0x52, 0xF0, 0x53, 0x90, 0x76, 0x90, 0x52, 0x90, 0x02, 0xF0, 0x0C, 0x90, 0x00, 0x00 }; /*556A*/
const unsigned char  uc2_556C [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x28, 0xA0, 0x2F, 0xA0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*556C*/
const unsigned char  uc2_556D [] = {0x02, 0x20, 0x72, 0x20, 0x5F, 0x70, 0x54, 0x20, 0x5A, 0x20, 0x5F, 0xF0, 0x52, 0x40, 0x73, 0x70, 0x4E, 0x10, 0x02, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*556D*/
const unsigned char  uc2_556E [] = {0x00, 0x80, 0x74, 0xE0, 0x54, 0x80, 0x5F, 0xF0, 0x50, 0x00, 0x54, 0xA0, 0x54, 0xA0, 0x77, 0x60, 0x54, 0x20, 0x07, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*556E*/
const unsigned char  uc2_5575 [] = {0x08, 0x40, 0x04, 0x40, 0x73, 0xF0, 0x52, 0x50, 0x5A, 0x50, 0x57, 0xE0, 0x72, 0xA0, 0x52, 0xA0, 0x0A, 0x40, 0x0A, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*5575*/
const unsigned char  uc2_5576 [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x10, 0x50, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x52, 0x80, 0x72, 0xE0, 0x52, 0x80, 0x05, 0x80, 0x08, 0x70, 0x00, 0x00 }; /*5576*/
const unsigned char  uc2_5577 [] = {0x02, 0x00, 0x77, 0x70, 0x55, 0x50, 0x57, 0x50, 0x55, 0x60, 0x57, 0x50, 0x54, 0x50, 0x76, 0x50, 0x55, 0x60, 0x07, 0x40, 0x05, 0x40, 0x00, 0x00 }; /*5577*/
const unsigned char  uc2_5578 [] = {0x01, 0x00, 0x77, 0xE0, 0x51, 0x20, 0x5F, 0xF0, 0x51, 0x20, 0x57, 0xE0, 0x51, 0x00, 0x75, 0xA0, 0x57, 0x60, 0x05, 0x60, 0x09, 0x20, 0x00, 0x00 }; /*5578*/
const unsigned char  uc2_557B [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x3F, 0xE0, 0x22, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*557B*/
const unsigned char  uc2_557C [] = {0x01, 0x80, 0x00, 0x40, 0x77, 0xF0, 0x51, 0x40, 0x57, 0xF0, 0x54, 0x90, 0x53, 0xE0, 0x72, 0xA0, 0x52, 0xA0, 0x02, 0xC0, 0x00, 0x80, 0x00, 0x00 }; /*557C*/
const unsigned char  uc2_557E [] = {0x02, 0x40, 0x0C, 0x40, 0x74, 0x50, 0x55, 0x50, 0x5E, 0x60, 0x54, 0x40, 0x56, 0x40, 0x5D, 0x40, 0x74, 0xA0, 0x54, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*557E*/
const unsigned char  uc2_5580 [] = {0x00, 0x80, 0x77, 0xF0, 0x55, 0x10, 0x51, 0xE0, 0x56, 0x20, 0x51, 0xC0, 0x56, 0x30, 0x73, 0xE0, 0x42, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5580*/
const unsigned char  uc2_5581 [] = {0x03, 0xE0, 0x72, 0xA0, 0x53, 0xE0, 0x52, 0xA0, 0x53, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x74, 0x90, 0x54, 0xD0, 0x07, 0x30, 0x04, 0x60, 0x00, 0x00 }; /*5581*/
const unsigned char  uc2_5582 [] = {0x03, 0xE0, 0x72, 0xA0, 0x53, 0xE0, 0x52, 0xA0, 0x53, 0xE0, 0x50, 0x00, 0x57, 0xF0, 0x72, 0xA0, 0x52, 0x40, 0x02, 0xC0, 0x03, 0x30, 0x00, 0x00 }; /*5582*/
const unsigned char  uc2_5583 [] = {0x00, 0x80, 0x77, 0xF0, 0x51, 0x00, 0x57, 0xF0, 0x55, 0x50, 0x54, 0x90, 0x55, 0xD0, 0x74, 0x90, 0x57, 0xF0, 0x04, 0x90, 0x04, 0x20, 0x00, 0x00 }; /*5583*/
const unsigned char  uc2_5584 [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5584*/
const unsigned char  uc2_5587 [] = {0x02, 0x10, 0x0F, 0x90, 0x72, 0x50, 0x57, 0x50, 0x5A, 0xD0, 0x57, 0x50, 0x52, 0x50, 0x73, 0x50, 0x56, 0xD0, 0x0A, 0x90, 0x02, 0x60, 0x00, 0x00 }; /*5587*/
const unsigned char  uc2_5588 [] = {0x04, 0xA0, 0x76, 0xC0, 0x54, 0x90, 0x57, 0x60, 0x51, 0x00, 0x57, 0xE0, 0x54, 0x20, 0x77, 0xE0, 0x54, 0x20, 0x07, 0xE0, 0x04, 0x20, 0x00, 0x00 }; /*5588*/
const unsigned char  uc2_5589 [] = {0x02, 0xE0, 0x72, 0x20, 0x55, 0xF0, 0x5C, 0x80, 0x54, 0xF0, 0x55, 0x40, 0x54, 0x40, 0x77, 0xF0, 0x54, 0x40, 0x04, 0xA0, 0x07, 0x10, 0x00, 0x00 }; /*5589*/
const unsigned char  uc2_558A [] = {0x00, 0x50, 0x77, 0xF0, 0x54, 0x40, 0x57, 0xC0, 0x54, 0x50, 0x57, 0x50, 0x55, 0x60, 0x77, 0x40, 0x54, 0xD0, 0x09, 0x50, 0x12, 0x20, 0x00, 0x00 }; /*558A*/
const unsigned char  uc2_558B [] = {0x05, 0x40, 0x0F, 0xF0, 0x75, 0x40, 0x55, 0xC0, 0x54, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x7F, 0xF0, 0x52, 0xA0, 0x0C, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*558B*/
const unsigned char  uc2_558F [] = {0x02, 0x20, 0x77, 0xF0, 0x52, 0x20, 0x50, 0x80, 0x57, 0xF0, 0x51, 0x00, 0x53, 0xE0, 0x7E, 0x20, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*558F*/
const unsigned char  uc2_5591 [] = {0x01, 0x80, 0x00, 0x40, 0x77, 0xF0, 0x52, 0x20, 0x51, 0x40, 0x57, 0xF0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5591*/
const unsigned char  uc2_5594 [] = {0x07, 0xE0, 0x74, 0x20, 0x57, 0xE0, 0x54, 0x00, 0x57, 0xE0, 0x55, 0x40, 0x57, 0xE0, 0x74, 0x80, 0x4B, 0xE0, 0x08, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*5594*/
const unsigned char  uc2_5598 [] = {0x00, 0x80, 0x74, 0x90, 0x57, 0xF0, 0x50, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x57, 0xF0, 0x75, 0x50, 0x55, 0x50, 0x05, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*5598*/
const unsigned char  uc2_5599 [] = {0x03, 0xC0, 0x74, 0x40, 0x57, 0x80, 0x50, 0x80, 0x5F, 0xF0, 0x52, 0x00, 0x5D, 0x20, 0x72, 0xC0, 0x4D, 0xA0, 0x02, 0x90, 0x0D, 0x00, 0x00, 0x00 }; /*5599*/
const unsigned char  uc2_559C [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*559C*/
const unsigned char  uc2_559D [] = {0x07, 0xE0, 0x74, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x52, 0x00, 0x53, 0xF0, 0x7C, 0x90, 0x45, 0x50, 0x07, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*559D*/
const unsigned char  uc2_559F [] = {0x07, 0xF0, 0x74, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x57, 0xF0, 0x52, 0x20, 0x53, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x02, 0x20, 0x02, 0xC0, 0x00, 0x00 }; /*559F*/
const unsigned char  uc2_55A7 [] = {0x00, 0x80, 0x07, 0xF0, 0x74, 0x10, 0x53, 0xE0, 0x50, 0x00, 0x53, 0xE0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*55A7*/
const unsigned char  uc2_55B1 [] = {0x07, 0xF0, 0x74, 0x00, 0x57, 0xE0, 0x54, 0xA0, 0x57, 0xE0, 0x54, 0xA0, 0x57, 0xE0, 0x74, 0x80, 0x57, 0xE0, 0x08, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*55B1*/
const unsigned char  uc2_55B3 [] = {0x00, 0x80, 0x77, 0xF0, 0x51, 0xC0, 0x56, 0xB0, 0x53, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x00, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*55B3*/
const unsigned char  uc2_55B5 [] = {0x02, 0x40, 0x72, 0x40, 0x5F, 0xF0, 0x52, 0x40, 0x50, 0x00, 0x57, 0xF0, 0x54, 0x90, 0x77, 0xF0, 0x54, 0x90, 0x07, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*55B5*/
const unsigned char  uc2_55B7 [] = {0x00, 0x80, 0x77, 0xF0, 0x52, 0xA0, 0x57, 0xF0, 0x52, 0x20, 0x57, 0xF0, 0x54, 0x10, 0x74, 0x90, 0x54, 0x90, 0x01, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*55B7*/
const unsigned char  uc2_55B9 [] = {0x01, 0x00, 0x0F, 0xE0, 0x74, 0x40, 0x59, 0x30, 0x57, 0xC0, 0x51, 0x00, 0x5F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x01, 0x00, 0x0F, 0xE0, 0x00, 0x00 }; /*55B9*/
const unsigned char  uc2_55BB [] = {0x01, 0x80, 0x72, 0x40, 0x5D, 0xB0, 0x50, 0x00, 0x57, 0x10, 0x55, 0x50, 0x57, 0x50, 0x55, 0x50, 0x77, 0x50, 0x55, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*55BB*/
const unsigned char  uc2_55BD [] = {0x04, 0x90, 0x72, 0xA0, 0x57, 0xF0, 0x52, 0xA0, 0x54, 0x90, 0x51, 0x00, 0x5F, 0xF0, 0x72, 0x20, 0x56, 0x40, 0x01, 0xE0, 0x0E, 0x10, 0x00, 0x00 }; /*55BD*/
const unsigned char  uc2_55BE [] = {0x12, 0x40, 0x7F, 0xF0, 0x52, 0x10, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*55BE*/
const unsigned char  uc2_55C4 [] = {0x0F, 0xF0, 0x01, 0x00, 0x77, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x72, 0x40, 0x56, 0x40, 0x01, 0x80, 0x0E, 0x70, 0x00, 0x00 }; /*55C4*/
const unsigned char  uc2_55C5 [] = {0x01, 0x00, 0x77, 0xC0, 0x54, 0x40, 0x57, 0xC0, 0x54, 0x40, 0x57, 0xC0, 0x51, 0x20, 0x7F, 0xF0, 0x52, 0x80, 0x04, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*55C5*/
const unsigned char  uc2_55C9 [] = {0x01, 0x00, 0x7F, 0xE0, 0x51, 0x00, 0x57, 0xC0, 0x51, 0x00, 0x5F, 0xF0, 0x75, 0x00, 0x52, 0x40, 0x0F, 0xA0, 0x05, 0x40, 0x0B, 0x20, 0x00, 0x00 }; /*55C9*/
const unsigned char  uc2_55CC [] = {0x04, 0x40, 0x72, 0x80, 0x5F, 0xF0, 0x50, 0x00, 0x52, 0xC0, 0x5C, 0x20, 0x70, 0x00, 0x5F, 0xE0, 0x0A, 0xA0, 0x0A, 0xA0, 0x1F, 0xF0, 0x00, 0x00 }; /*55CC*/
const unsigned char  uc2_55CD [] = {0x0A, 0x70, 0x74, 0x50, 0x5F, 0x50, 0x54, 0x70, 0x55, 0x50, 0x55, 0x50, 0x5F, 0x70, 0x74, 0x50, 0x54, 0x90, 0x04, 0x90, 0x09, 0x20, 0x00, 0x00 }; /*55CD*/
const unsigned char  uc2_55D1 [] = {0x01, 0x00, 0x77, 0xC0, 0x51, 0x00, 0x5F, 0xF0, 0x52, 0x40, 0x57, 0xA0, 0x70, 0x20, 0x5F, 0xE0, 0x0A, 0xA0, 0x0A, 0xA0, 0x1F, 0xF0, 0x00, 0x00 }; /*55D1*/
const unsigned char  uc2_55D2 [] = {0x02, 0x40, 0x0F, 0xF0, 0x72, 0x40, 0x51, 0x80, 0x5E, 0x70, 0x53, 0xC0, 0x50, 0x00, 0x77, 0xE0, 0x54, 0x20, 0x07, 0xE0, 0x04, 0x20, 0x00, 0x00 }; /*55D2*/
const unsigned char  uc2_55D3 [] = {0x03, 0xC0, 0x71, 0x40, 0x50, 0x80, 0x5F, 0x70, 0x55, 0x50, 0x52, 0x20, 0x55, 0x50, 0x70, 0x80, 0x57, 0xF0, 0x01, 0xC0, 0x0E, 0xB0, 0x00, 0x00 }; /*55D3*/
const unsigned char  uc2_55D4 [] = {0x00, 0x80, 0x07, 0xF0, 0x71, 0x00, 0x53, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x0F, 0xF0, 0x04, 0x20, 0x00, 0x00 }; /*55D4*/
const unsigned char  uc2_55D6 [] = {0x01, 0x80, 0x06, 0xB0, 0x74, 0x90, 0x56, 0xB0, 0x54, 0x90, 0x57, 0xF0, 0x50, 0x80, 0x77, 0xE0, 0x52, 0x20, 0x01, 0xC0, 0x06, 0x30, 0x00, 0x00 }; /*55D6*/
const unsigned char  uc2_55DC [] = {0x01, 0x20, 0x77, 0xA0, 0x51, 0x40, 0x5F, 0xE0, 0x53, 0x40, 0x5D, 0x90, 0x53, 0xE0, 0x74, 0x20, 0x57, 0xE0, 0x04, 0x20, 0x07, 0xE0, 0x00, 0x00 }; /*55DC*/
const unsigned char  uc2_55DD [] = {0x07, 0xF0, 0x72, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x57, 0xF0, 0x55, 0x50, 0x54, 0x90, 0x77, 0xF0, 0x54, 0x90, 0x04, 0x90, 0x04, 0x20, 0x00, 0x00 }; /*55DD*/
const unsigned char  uc2_55DF [] = {0x04, 0x40, 0x02, 0x80, 0x0F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x51, 0x00, 0x5F, 0xF0, 0x52, 0x00, 0x77, 0xE0, 0x58, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*55DF*/
const unsigned char  uc2_55E1 [] = {0x02, 0x60, 0x0D, 0x10, 0x72, 0x40, 0x53, 0xA0, 0x50, 0x00, 0x57, 0x70, 0x55, 0x50, 0x73, 0x30, 0x55, 0x50, 0x01, 0x10, 0x06, 0x60, 0x00, 0x00 }; /*55E1*/
const unsigned char  uc2_55E3 [] = {0x3E, 0xF0, 0x22, 0x10, 0x3E, 0xD0, 0x00, 0x10, 0x7F, 0xD0, 0x55, 0x50, 0x7F, 0x50, 0x55, 0xD0, 0x55, 0x50, 0x41, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*55E3*/
const unsigned char  uc2_55E4 [] = {0x00, 0x80, 0x72, 0xA0, 0x53, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x72, 0xA0, 0x53, 0xE0, 0x00, 0xA0, 0x07, 0xD0, 0x00, 0x00 }; /*55E4*/
const unsigned char  uc2_55E5 [] = {0x01, 0x00, 0x77, 0xC0, 0x54, 0x40, 0x57, 0xC0, 0x54, 0x40, 0x57, 0xC0, 0x71, 0x00, 0x5F, 0xF0, 0x05, 0x40, 0x1B, 0xB0, 0x01, 0x00, 0x00, 0x00 }; /*55E5*/
const unsigned char  uc2_55E6 [] = {0x00, 0x80, 0x03, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x55, 0x50, 0x52, 0x80, 0x51, 0x20, 0x77, 0xD0, 0x50, 0x80, 0x02, 0xA0, 0x0D, 0x90, 0x00, 0x00 }; /*55E6*/
const unsigned char  uc2_55E8 [] = {0x09, 0x00, 0x75, 0xF0, 0x52, 0x00, 0x59, 0xE0, 0x55, 0x20, 0x52, 0xA0, 0x73, 0xF0, 0x52, 0xA0, 0x0B, 0xF0, 0x10, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*55E8*/
const unsigned char  uc2_55EA [] = {0x01, 0x00, 0x0F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x52, 0x00, 0x5F, 0xF0, 0x54, 0xC0, 0x7B, 0x30, 0x51, 0x00, 0x0F, 0xE0, 0x05, 0x40, 0x00, 0x00 }; /*55EA*/
const unsigned char  uc2_55EB [] = {0x0F, 0xE0, 0x74, 0x40, 0x57, 0xC0, 0x54, 0x70, 0x5F, 0xC0, 0x50, 0x40, 0x50, 0x00, 0x7F, 0xE0, 0x4A, 0xA0, 0x04, 0x40, 0x1A, 0xB0, 0x00, 0x00 }; /*55EB*/
const unsigned char  uc2_55EC [] = {0x02, 0x40, 0x77, 0xF0, 0x52, 0x40, 0x55, 0xF0, 0x5C, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x75, 0xE0, 0x55, 0x20, 0x04, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*55EC*/
const unsigned char  uc2_55EF [] = {0x07, 0xF0, 0x74, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x55, 0x50, 0x57, 0xF0, 0x70, 0x00, 0x51, 0x00, 0x0A, 0xA0, 0x0A, 0x50, 0x11, 0x90, 0x00, 0x00 }; /*55EF*/
const unsigned char  uc2_55F2 [] = {0x01, 0x40, 0x76, 0x30, 0x51, 0xC0, 0x56, 0x30, 0x51, 0xC0, 0x56, 0x40, 0x51, 0x80, 0x76, 0x70, 0x51, 0x90, 0x00, 0x60, 0x07, 0x80, 0x00, 0x00 }; /*55F2*/
const unsigned char  uc2_55F3 [] = {0x00, 0x30, 0x77, 0xD0, 0x52, 0xA0, 0x57, 0xF0, 0x54, 0x90, 0x53, 0xE0, 0x51, 0x00, 0x73, 0xE0, 0x4D, 0x20, 0x00, 0xC0, 0x07, 0x30, 0x00, 0x00 }; /*55F3*/
const unsigned char  uc2_55F5 [] = {0x09, 0xE0, 0x74, 0xA0, 0x54, 0x40, 0x51, 0xF0, 0x5D, 0x50, 0x55, 0xF0, 0x55, 0x50, 0x75, 0xF0, 0x55, 0x50, 0x0A, 0x20, 0x11, 0xF0, 0x00, 0x00 }; /*55F5*/
const unsigned char  uc2_55F7 [] = {0x02, 0x40, 0x7F, 0x40, 0x52, 0x70, 0x57, 0x50, 0x52, 0xD0, 0x5F, 0x50, 0x54, 0x50, 0x77, 0x20, 0x55, 0x20, 0x05, 0x60, 0x0B, 0x90, 0x00, 0x00 }; /*55F7*/
const unsigned char  uc2_55FD [] = {0x04, 0x80, 0x1F, 0xF0, 0x74, 0x90, 0x5F, 0x50, 0x55, 0x60, 0x5F, 0x40, 0x54, 0x40, 0x5E, 0x40, 0x75, 0xA0, 0x54, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*55FD*/
const unsigned char  uc2_55FE [] = {0x0C, 0x40, 0x72, 0x70, 0x5F, 0x80, 0x54, 0x40, 0x54, 0x70, 0x57, 0xA0, 0x55, 0x20, 0x75, 0x70, 0x55, 0x20, 0x09, 0x60, 0x12, 0x90, 0x00, 0x00 }; /*55FE*/
const unsigned char  uc2_5600 [] = {0x00, 0x80, 0x07, 0xF0, 0x71, 0x40, 0x57, 0xF0, 0x54, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x75, 0xD0, 0x55, 0x50, 0x05, 0xD0, 0x04, 0x20, 0x00, 0x00 }; /*5600*/
const unsigned char  uc2_5601 [] = {0x00, 0xA0, 0x1F, 0xF0, 0x70, 0x80, 0x54, 0x80, 0x56, 0x80, 0x54, 0xA0, 0x5F, 0xA0, 0x74, 0xA0, 0x5E, 0x50, 0x25, 0x50, 0x58, 0xA0, 0x00, 0x00 }; /*5601*/
const unsigned char  uc2_5608 [] = {0x01, 0x40, 0x0F, 0xF0, 0x75, 0x50, 0x57, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5608*/
const unsigned char  uc2_5609 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x00, 0x7D, 0xE0, 0x15, 0x20, 0x25, 0xE0, 0x49, 0x20, 0x00, 0x00 }; /*5609*/
const unsigned char  uc2_560C [] = {0x07, 0xF0, 0x71, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x50, 0x00, 0x53, 0xE0, 0x70, 0x00, 0x57, 0xF0, 0x02, 0xA0, 0x05, 0x90, 0x00, 0x00 }; /*560C*/
const unsigned char  uc2_560E [] = {0x0F, 0xF0, 0x74, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x52, 0x40, 0x52, 0xF0, 0x7F, 0x00, 0x41, 0x60, 0x01, 0x90, 0x1E, 0x70, 0x00, 0x00 }; /*560E*/
const unsigned char  uc2_560F [] = {0x27, 0x70, 0x25, 0x10, 0x75, 0x10, 0x27, 0x70, 0x24, 0x00, 0x74, 0xF0, 0x57, 0x50, 0x54, 0x50, 0x77, 0x20, 0x54, 0x60, 0x04, 0x90, 0x00, 0x00 }; /*560F*/
const unsigned char  uc2_5618 [] = {0x01, 0xE0, 0x71, 0x00, 0x57, 0xF0, 0x55, 0x10, 0x55, 0xC0, 0x57, 0x20, 0x74, 0xE0, 0x55, 0x50, 0x0B, 0x60, 0x09, 0x40, 0x17, 0xF0, 0x00, 0x00 }; /*5618*/
const unsigned char  uc2_561B [] = {0x01, 0x00, 0x1F, 0xF0, 0x72, 0x40, 0x52, 0x40, 0x5F, 0xE0, 0x52, 0x40, 0x56, 0xE0, 0x7B, 0x60, 0x52, 0x50, 0x22, 0x40, 0x42, 0x40, 0x00, 0x00 }; /*561B*/
const unsigned char  uc2_561E [] = {0x0A, 0x40, 0x1F, 0x40, 0x0A, 0x40, 0x7E, 0xF0, 0x54, 0x50, 0x5F, 0x50, 0x55, 0x50, 0x7F, 0x50, 0x44, 0x50, 0x1F, 0x90, 0x04, 0xA0, 0x00, 0x00 }; /*561E*/
const unsigned char  uc2_561F [] = {0x02, 0x00, 0x77, 0x70, 0x52, 0xD0, 0x5F, 0xD0, 0x52, 0x60, 0x57, 0x50, 0x5D, 0x50, 0x77, 0x50, 0x55, 0x60, 0x07, 0x40, 0x05, 0x40, 0x00, 0x00 }; /*561F*/
const unsigned char  uc2_5623 [] = {0x00, 0x80, 0x04, 0x90, 0x77, 0xF0, 0x50, 0x00, 0x57, 0x70, 0x55, 0x50, 0x57, 0x70, 0x75, 0x50, 0x57, 0x70, 0x09, 0x50, 0x12, 0xA0, 0x00, 0x00 }; /*5623*/
const unsigned char  uc2_5624 [] = {0x1F, 0xF0, 0x71, 0x10, 0x55, 0x50, 0x55, 0x50, 0x56, 0xA0, 0x59, 0x10, 0x72, 0x00, 0x5F, 0xF0, 0x04, 0x40, 0x03, 0xE0, 0x1C, 0x10, 0x00, 0x00 }; /*5624*/
const unsigned char  uc2_5627 [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x90, 0x52, 0x40, 0x56, 0xB0, 0x59, 0xD0, 0x56, 0x00, 0x70, 0x80, 0x54, 0x90, 0x07, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*5627*/
const unsigned char  uc2_562C [] = {0x03, 0xE0, 0x02, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x5F, 0xF0, 0x55, 0x00, 0x57, 0xF0, 0x75, 0x50, 0x57, 0xA0, 0x0D, 0x20, 0x01, 0x50, 0x00, 0x00 }; /*562C*/
const unsigned char  uc2_562D [] = {0x01, 0x10, 0x0F, 0xD0, 0x71, 0x20, 0x57, 0xA0, 0x50, 0x50, 0x57, 0x90, 0x54, 0xA0, 0x77, 0x90, 0x52, 0xD0, 0x07, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*562D*/
const unsigned char  uc2_5631 [] = {0x07, 0xE0, 0x74, 0x20, 0x57, 0xE0, 0x54, 0x80, 0x57, 0xE0, 0x54, 0xA0, 0x57, 0xF0, 0x74, 0x90, 0x54, 0xD0, 0x0D, 0x30, 0x14, 0x60, 0x00, 0x00 }; /*5631*/
const unsigned char  uc2_5632 [] = {0x02, 0x70, 0x7F, 0xD0, 0x52, 0x50, 0x57, 0x50, 0x55, 0x70, 0x57, 0x50, 0x55, 0x50, 0x77, 0x70, 0x42, 0x50, 0x0F, 0x50, 0x02, 0xA0, 0x00, 0x00 }; /*5632*/
const unsigned char  uc2_5634 [] = {0x01, 0x50, 0x75, 0xE0, 0x55, 0x50, 0x5F, 0xE0, 0x51, 0x40, 0x53, 0xF0, 0x5C, 0x90, 0x77, 0xF0, 0x54, 0x90, 0x07, 0xF0, 0x04, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*5634*/
const unsigned char  uc2_5636 [] = {0x05, 0x30, 0x75, 0x40, 0x5F, 0xC0, 0x55, 0x40, 0x57, 0x70, 0x55, 0x50, 0x57, 0x50, 0x75, 0x50, 0x4F, 0xD0, 0x05, 0x50, 0x18, 0x90, 0x00, 0x00 }; /*5636*/
const unsigned char  uc2_5639 [] = {0x00, 0x80, 0x07, 0xF0, 0x75, 0x50, 0x52, 0x20, 0x57, 0xF0, 0x52, 0x20, 0x53, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x04, 0x90, 0x09, 0x90, 0x00, 0x00 }; /*5639*/
const unsigned char  uc2_563B [] = {0x00, 0x80, 0x07, 0xF0, 0x70, 0x80, 0x53, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x51, 0x40, 0x77, 0xF0, 0x52, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*563B*/
const unsigned char  uc2_563F [] = {0x07, 0xF0, 0x76, 0xB0, 0x55, 0xD0, 0x54, 0x90, 0x57, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x02, 0xA0, 0x05, 0x50, 0x00, 0x00 }; /*563F*/
const unsigned char  uc2_564C [] = {0x02, 0x20, 0x01, 0x40, 0x77, 0xF0, 0x56, 0xB0, 0x55, 0xD0, 0x54, 0x90, 0x57, 0xF0, 0x72, 0x20, 0x53, 0xE0, 0x02, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*564C*/
const unsigned char  uc2_564D [] = {0x02, 0x80, 0x73, 0xF0, 0x54, 0x80, 0x5F, 0xE0, 0x54, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x77, 0xF0, 0x50, 0x00, 0x06, 0xA0, 0x19, 0x50, 0x00, 0x00 }; /*564D*/
const unsigned char  uc2_564E [] = {0x00, 0x80, 0x07, 0xF0, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x10, 0x53, 0xE0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x01, 0x40, 0x07, 0xF0, 0x00, 0x00 }; /*564E*/
const unsigned char  uc2_5654 [] = {0x00, 0x40, 0x07, 0x60, 0x71, 0x40, 0x56, 0x30, 0x53, 0xE0, 0x5C, 0x10, 0x53, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x01, 0x40, 0x0F, 0xF0, 0x00, 0x00 }; /*5654*/
const unsigned char  uc2_5657 [] = {0x05, 0x50, 0x73, 0x60, 0x57, 0xF0, 0x52, 0x20, 0x57, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*5657*/
const unsigned char  uc2_5658 [] = {0x1F, 0xF0, 0x75, 0x40, 0x52, 0x40, 0x5F, 0x70, 0x54, 0x90, 0x55, 0x20, 0x7F, 0x40, 0x54, 0x40, 0x14, 0xA0, 0x24, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*5658*/
const unsigned char  uc2_5659 [] = {0x01, 0x80, 0x72, 0x40, 0x5C, 0xB0, 0x53, 0xC0, 0x55, 0x60, 0x54, 0xA0, 0x77, 0xE0, 0x51, 0x00, 0x0F, 0xF0, 0x0A, 0x90, 0x0B, 0x60, 0x00, 0x00 }; /*5659*/
const unsigned char  uc2_565C [] = {0x01, 0xC0, 0x72, 0x40, 0x57, 0xE0, 0x52, 0xA0, 0x53, 0xE0, 0x52, 0xA0, 0x57, 0xF0, 0x72, 0x20, 0x53, 0xE0, 0x02, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*565C*/
const unsigned char  uc2_5662 [] = {0x01, 0x00, 0x77, 0xF0, 0x54, 0x90, 0x56, 0xB0, 0x57, 0xF0, 0x55, 0xD0, 0x76, 0xB0, 0x51, 0x00, 0x0F, 0xF0, 0x02, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*5662*/
const unsigned char  uc2_5664 [] = {0x02, 0x40, 0x0F, 0xF0, 0x73, 0x60, 0x56, 0xD0, 0x5A, 0x50, 0x57, 0xE0, 0x50, 0x00, 0x7F, 0xF0, 0x50, 0x80, 0x02, 0xA0, 0x0D, 0x10, 0x00, 0x00 }; /*5664*/
const unsigned char  uc2_5668 [] = {0x3D, 0xE0, 0x25, 0x20, 0x3D, 0xE0, 0x02, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x60, 0x30, 0x3D, 0xE0, 0x25, 0x20, 0x3D, 0xE0, 0x25, 0x20, 0x00, 0x00 }; /*5668*/
const unsigned char  uc2_5669 [] = {0x7F, 0xF0, 0x2A, 0xA0, 0x3A, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3A, 0xE0, 0x2A, 0xA0, 0x3A, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5669*/
const unsigned char  uc2_566A [] = {0x03, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x57, 0x70, 0x55, 0x50, 0x57, 0x70, 0x70, 0x80, 0x57, 0xF0, 0x02, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*566A*/
const unsigned char  uc2_566B [] = {0x01, 0x00, 0x0F, 0xE0, 0x72, 0x80, 0x5F, 0xF0, 0x54, 0x40, 0x57, 0xC0, 0x54, 0x40, 0x77, 0xC0, 0x5A, 0xA0, 0x0A, 0x50, 0x11, 0x90, 0x00, 0x00 }; /*566B*/
const unsigned char  uc2_566C [] = {0x04, 0x40, 0x77, 0x70, 0x5A, 0xA0, 0x50, 0x00, 0x5F, 0xE0, 0x55, 0x40, 0x75, 0x40, 0x57, 0xA0, 0x09, 0x20, 0x01, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*566C*/
const unsigned char  uc2_5671 [] = {0x00, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x55, 0xE0, 0x54, 0x90, 0x57, 0xF0, 0x75, 0x20, 0x5A, 0xC0, 0x09, 0x60, 0x16, 0xD0, 0x00, 0x00 }; /*5671*/
const unsigned char  uc2_5676 [] = {0x02, 0x40, 0x7F, 0xF0, 0x52, 0x40, 0x57, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x77, 0xF0, 0x49, 0x10, 0x1A, 0x90, 0x0F, 0x60, 0x00, 0x00 }; /*5676*/
const unsigned char  uc2_567B [] = {0x00, 0x80, 0x77, 0xF0, 0x55, 0x50, 0x53, 0xE0, 0x51, 0x40, 0x53, 0xE0, 0x51, 0x40, 0x76, 0xB0, 0x53, 0xE0, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*567B*/
const unsigned char  uc2_567C [] = {0x07, 0x40, 0x75, 0xF0, 0x55, 0x20, 0x55, 0xA0, 0x57, 0x40, 0x54, 0xE0, 0x57, 0x40, 0x75, 0xF0, 0x4D, 0x40, 0x17, 0x40, 0x25, 0x40, 0x00, 0x00 }; /*567C*/
const unsigned char  uc2_5685 [] = {0x03, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x53, 0x60, 0x50, 0x00, 0x57, 0xF0, 0x70, 0x80, 0x57, 0xF0, 0x05, 0x50, 0x05, 0x50, 0x00, 0x00 }; /*5685*/
const unsigned char  uc2_5686 [] = {0x02, 0x20, 0x07, 0xF0, 0x72, 0xA0, 0x5F, 0xF0, 0x51, 0x40, 0x57, 0xF0, 0x54, 0x10, 0x75, 0xD0, 0x55, 0x50, 0x05, 0xD0, 0x04, 0x60, 0x00, 0x00 }; /*5686*/
const unsigned char  uc2_568E [] = {0x00, 0x80, 0x77, 0xF0, 0x52, 0x20, 0x57, 0xF0, 0x54, 0x10, 0x53, 0xE0, 0x51, 0x00, 0x76, 0x90, 0x51, 0x60, 0x0E, 0x50, 0x01, 0x80, 0x00, 0x00 }; /*568E*/
const unsigned char  uc2_568F [] = {0x01, 0x00, 0x0F, 0xE0, 0x71, 0x00, 0x5F, 0xF0, 0x55, 0x50, 0x57, 0xC0, 0x55, 0x40, 0x7F, 0x20, 0x55, 0xC0, 0x07, 0x00, 0x18, 0xF0, 0x00, 0x00 }; /*568F*/
const unsigned char  uc2_5693 [] = {0x01, 0x00, 0x0F, 0xF0, 0x74, 0x90, 0x57, 0xE0, 0x5D, 0xA0, 0x52, 0x40, 0x5D, 0xB0, 0x70, 0x00, 0x57, 0xF0, 0x02, 0xA0, 0x0D, 0x90, 0x00, 0x00 }; /*5693*/
const unsigned char  uc2_56A3 [] = {0x3D, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x0D, 0xC0, 0x70, 0x20, 0x3D, 0xE0, 0x25, 0x20, 0x3D, 0xE0, 0x00, 0x00 }; /*56A3*/
const unsigned char  uc2_56AF [] = {0x03, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x52, 0xA0, 0x51, 0x40, 0x53, 0xF0, 0x7E, 0x40, 0x53, 0xE0, 0x02, 0x40, 0x03, 0xF0, 0x00, 0x00 }; /*56AF*/
const unsigned char  uc2_56B7 [] = {0x01, 0x00, 0x0F, 0xE0, 0x75, 0x40, 0x5F, 0xE0, 0x52, 0x80, 0x57, 0xC0, 0x72, 0x80, 0x5F, 0xF0, 0x02, 0xA0, 0x1C, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*56B7*/
const unsigned char  uc2_56BC [] = {0x1F, 0xF0, 0x0A, 0x40, 0x1F, 0xE0, 0x74, 0xA0, 0x5F, 0xE0, 0x52, 0x20, 0x5F, 0xF0, 0x72, 0x20, 0x5E, 0xE0, 0x14, 0x20, 0x1A, 0xC0, 0x00, 0x00 }; /*56BC*/
const unsigned char  uc2_56CA [] = {0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x55, 0x50, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x18, 0xA0, 0x6E, 0x70, 0x00, 0x00 }; /*56CA*/
const unsigned char  uc2_56D4 [] = {0x00, 0x80, 0x07, 0xF0, 0x72, 0xA0, 0x57, 0xF0, 0x55, 0x50, 0x52, 0x20, 0x77, 0xF0, 0x52, 0x20, 0x0F, 0xF0, 0x06, 0xA0, 0x1B, 0x70, 0x00, 0x00 }; /*56D4*/
const unsigned char  uc2_56D7 [] = {0x7F, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56D7*/
const unsigned char  uc2_56DA [] = {0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x45, 0x10, 0x44, 0x90, 0x58, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56DA*/
const unsigned char  uc2_56DB [] = {0x3F, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x24, 0x90, 0x24, 0x90, 0x28, 0x70, 0x30, 0x10, 0x20, 0x10, 0x20, 0x10, 0x3F, 0xF0, 0x20, 0x10, 0x00, 0x00 }; /*56DB*/
const unsigned char  uc2_56DD [] = {0x7F, 0xF0, 0x40, 0x10, 0x4F, 0x90, 0x40, 0x90, 0x41, 0x10, 0x5F, 0xD0, 0x41, 0x10, 0x46, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56DD*/
const unsigned char  uc2_56DE [] = {0x7F, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56DE*/
const unsigned char  uc2_56DF [] = {0x04, 0x00, 0x08, 0x00, 0x7F, 0xE0, 0x40, 0x20, 0x4D, 0x20, 0x42, 0x20, 0x45, 0x20, 0x59, 0x20, 0x40, 0x20, 0x7F, 0xE0, 0x40, 0x20, 0x00, 0x00 }; /*56DF*/
const unsigned char  uc2_56E0 [] = {0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x43, 0x10, 0x44, 0x90, 0x58, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56E0*/
const unsigned char  uc2_56E1 [] = {0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x44, 0x90, 0x4D, 0x10, 0x43, 0x90, 0x5C, 0x50, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56E1*/
const unsigned char  uc2_56E2 [] = {0x7F, 0xF0, 0x40, 0x10, 0x41, 0x10, 0x5F, 0xD0, 0x45, 0x10, 0x45, 0x10, 0x59, 0x10, 0x46, 0x10, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56E2*/
const unsigned char  uc2_56E4 [] = {0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4A, 0x90, 0x4F, 0x90, 0x42, 0x50, 0x43, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56E4*/
const unsigned char  uc2_56EB [] = {0x7F, 0xF0, 0x48, 0x10, 0x4F, 0xD0, 0x75, 0x50, 0x45, 0x50, 0x5A, 0x50, 0x44, 0x50, 0x59, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56EB*/
const unsigned char  uc2_56ED [] = {0x7F, 0xE0, 0x40, 0x20, 0x4F, 0x20, 0x40, 0x20, 0x5F, 0xA0, 0x4A, 0x20, 0x4A, 0xA0, 0x51, 0x20, 0x40, 0x20, 0x7F, 0xE0, 0x40, 0x20, 0x00, 0x00 }; /*56ED*/
const unsigned char  uc2_56F0 [] = {0x7F, 0xF0, 0x42, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x46, 0x10, 0x4A, 0x90, 0x4A, 0x50, 0x52, 0x50, 0x42, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56F0*/
const unsigned char  uc2_56F1 [] = {0x08, 0x00, 0x10, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x47, 0x90, 0x4C, 0x90, 0x43, 0x10, 0x5C, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56F1*/
const unsigned char  uc2_56F4 [] = {0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x50, 0x42, 0x90, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56F4*/
const unsigned char  uc2_56F5 [] = {0x7F, 0xF0, 0x42, 0x10, 0x4D, 0x90, 0x70, 0x70, 0x48, 0x90, 0x4F, 0x10, 0x48, 0x50, 0x47, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56F5*/
const unsigned char  uc2_56F9 [] = {0x7F, 0xF0, 0x42, 0x10, 0x4D, 0x90, 0x74, 0x70, 0x42, 0x10, 0x4F, 0x90, 0x40, 0x90, 0x45, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56F9*/
const unsigned char  uc2_56FA [] = {0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56FA*/
const unsigned char  uc2_56FD [] = {0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x42, 0x90, 0x42, 0x50, 0x5F, 0xD0, 0x40, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*56FD*/
const unsigned char  uc2_56FE [] = {0x7F, 0xF0, 0x44, 0x10, 0x47, 0x90, 0x58, 0x90, 0x47, 0x10, 0x48, 0x90, 0x72, 0x70, 0x41, 0x10, 0x44, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x00 }; /*56FE*/
const unsigned char  uc2_56FF [] = {0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x44, 0x10, 0x4F, 0x90, 0x54, 0x90, 0x47, 0x90, 0x44, 0x90, 0x47, 0x90, 0x44, 0x90, 0x7F, 0xF0, 0x00, 0x00 }; /*56FF*/
const unsigned char  uc2_5703 [] = {0x7F, 0xF0, 0x42, 0x90, 0x7F, 0xF0, 0x52, 0x50, 0x5F, 0xD0, 0x52, 0x50, 0x5F, 0xD0, 0x52, 0x50, 0x40, 0x90, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5703*/
const unsigned char  uc2_5704 [] = {0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x44, 0x90, 0x7F, 0xF0, 0x48, 0x90, 0x48, 0x90, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5704*/
const unsigned char  uc2_5706 [] = {0x7F, 0xF0, 0x45, 0x10, 0x45, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x4A, 0x90, 0x4A, 0x10, 0x45, 0x90, 0x58, 0x50, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5706*/
const unsigned char  uc2_5708 [] = {0x7F, 0xF0, 0x4A, 0x90, 0x5F, 0xD0, 0x44, 0x10, 0x7F, 0xD0, 0x59, 0x90, 0x6E, 0x70, 0x48, 0x90, 0x47, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5708*/
const unsigned char  uc2_5709 [] = {0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x7F, 0xF0, 0x45, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x7F, 0xF0, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x00 }; /*5709*/
const unsigned char  uc2_570A [] = {0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x42, 0x10, 0x7F, 0xF0, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x90, 0x7F, 0xF0, 0x00, 0x00 }; /*570A*/
const unsigned char  uc2_571C [] = {0x7F, 0xF0, 0x55, 0x50, 0x5F, 0xD0, 0x40, 0x10, 0x5F, 0xD0, 0x48, 0x90, 0x4F, 0x90, 0x45, 0x50, 0x5D, 0x90, 0x46, 0x50, 0x7F, 0xF0, 0x00, 0x00 }; /*571C*/
const unsigned char  uc2_571F [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*571F*/
const unsigned char  uc2_5723 [] = {0x3F, 0xC0, 0x10, 0x40, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x62, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5723*/
const unsigned char  uc2_5728 [] = {0x04, 0x00, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x10, 0x80, 0x30, 0x80, 0x53, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*5728*/
const unsigned char  uc2_5729 [] = {0x10, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x7C, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x1C, 0x80, 0x60, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*5729*/
const unsigned char  uc2_572A [] = {0x11, 0x00, 0x11, 0x00, 0x11, 0xF0, 0x7A, 0x00, 0x15, 0xE0, 0x10, 0x20, 0x10, 0x40, 0x19, 0x80, 0x62, 0x10, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*572A*/
const unsigned char  uc2_572C [] = {0x10, 0x00, 0x13, 0xE0, 0x10, 0x00, 0x78, 0x00, 0x17, 0xF0, 0x11, 0x00, 0x12, 0x00, 0x1B, 0xE0, 0x60, 0x20, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*572C*/
const unsigned char  uc2_572D [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*572D*/
const unsigned char  uc2_572E [] = {0x10, 0x00, 0x17, 0xE0, 0x10, 0x20, 0x78, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x00, 0x1A, 0x10, 0x62, 0x10, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*572E*/
const unsigned char  uc2_572F [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x10, 0x1A, 0x10, 0x62, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*572F*/
const unsigned char  uc2_5730 [] = {0x10, 0x80, 0x10, 0x80, 0x12, 0x80, 0x7A, 0xE0, 0x13, 0xA0, 0x16, 0xA0, 0x12, 0xA0, 0x12, 0xD0, 0x1A, 0x90, 0x62, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*5730*/
const unsigned char  uc2_5733 [] = {0x11, 0x10, 0x11, 0x50, 0x11, 0x50, 0x7D, 0x50, 0x11, 0x50, 0x11, 0x50, 0x15, 0x50, 0x19, 0x50, 0x62, 0x50, 0x02, 0x50, 0x0C, 0x10, 0x00, 0x00 }; /*5733*/
const unsigned char  uc2_5739 [] = {0x10, 0x80, 0x10, 0x40, 0x13, 0xF0, 0x7A, 0x00, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x1A, 0x00, 0x64, 0x00, 0x04, 0x00, 0x08, 0x00, 0x00, 0x00 }; /*5739*/
const unsigned char  uc2_573A [] = {0x10, 0x00, 0x13, 0xC0, 0x10, 0x40, 0x78, 0x80, 0x11, 0x00, 0x13, 0xF0, 0x11, 0x50, 0x19, 0x50, 0x62, 0x90, 0x0D, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*573A*/
const unsigned char  uc2_573B [] = {0x10, 0x60, 0x13, 0x80, 0x12, 0x00, 0x7A, 0x00, 0x13, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x1A, 0x40, 0x64, 0x40, 0x04, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*573B*/
const unsigned char  uc2_573E [] = {0x10, 0x00, 0x17, 0xC0, 0x12, 0x40, 0x7A, 0x80, 0x12, 0xE0, 0x12, 0x20, 0x12, 0x40, 0x1B, 0x40, 0x64, 0x80, 0x09, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*573E*/
const unsigned char  uc2_5740 [] = {0x10, 0x80, 0x10, 0x80, 0x12, 0x80, 0x7A, 0x80, 0x12, 0xE0, 0x12, 0x80, 0x12, 0x80, 0x1A, 0x80, 0x62, 0x80, 0x0F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5740*/
const unsigned char  uc2_5742 [] = {0x10, 0x30, 0x13, 0xC0, 0x12, 0x00, 0x7A, 0x00, 0x13, 0xE0, 0x12, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x64, 0x40, 0x04, 0xA0, 0x0B, 0x10, 0x00, 0x00 }; /*5742*/
const unsigned char  uc2_5747 [] = {0x12, 0x00, 0x12, 0x00, 0x13, 0xF0, 0x7A, 0x10, 0x15, 0x90, 0x10, 0x50, 0x10, 0x10, 0x18, 0xD0, 0x63, 0x10, 0x00, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5747*/
const unsigned char  uc2_574A [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x79, 0x00, 0x11, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x1A, 0x20, 0x62, 0x20, 0x04, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*574A*/
const unsigned char  uc2_574C [] = {0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x02, 0x80, 0x04, 0x80, 0x39, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*574C*/
const unsigned char  uc2_574D [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7B, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x17, 0xF0, 0x1A, 0x20, 0x62, 0x20, 0x04, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*574D*/
const unsigned char  uc2_574E [] = {0x11, 0x00, 0x11, 0x00, 0x11, 0xF0, 0x7A, 0x10, 0x12, 0xA0, 0x14, 0x80, 0x10, 0x80, 0x19, 0x40, 0x61, 0x40, 0x02, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*574E*/
const unsigned char  uc2_574F [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x78, 0x80, 0x11, 0x00, 0x11, 0xA0, 0x12, 0x90, 0x1A, 0x90, 0x64, 0x80, 0x08, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*574F*/
const unsigned char  uc2_5750 [] = {0x02, 0x00, 0x12, 0x40, 0x12, 0x40, 0x12, 0x60, 0x2A, 0x90, 0x47, 0x10, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5750*/
const unsigned char  uc2_5751 [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x78, 0x00, 0x10, 0x00, 0x13, 0xC0, 0x12, 0x40, 0x1A, 0x40, 0x64, 0x50, 0x04, 0x50, 0x08, 0x20, 0x00, 0x00 }; /*5751*/
const unsigned char  uc2_5757 [] = {0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x78, 0xA0, 0x10, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x19, 0x40, 0x61, 0x40, 0x02, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*5757*/
const unsigned char  uc2_575A [] = {0x08, 0x00, 0x2B, 0xE0, 0x29, 0x20, 0x29, 0x20, 0x28, 0xC0, 0x2B, 0x30, 0x08, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*575A*/
const unsigned char  uc2_575B [] = {0x10, 0x00, 0x11, 0xE0, 0x10, 0x00, 0x7C, 0x00, 0x10, 0x00, 0x13, 0xF0, 0x10, 0x80, 0x1C, 0xA0, 0x61, 0x20, 0x02, 0x50, 0x03, 0x90, 0x00, 0x00 }; /*575B*/
const unsigned char  uc2_575C [] = {0x10, 0x00, 0x13, 0xF0, 0x12, 0x00, 0x7A, 0x40, 0x12, 0x40, 0x12, 0xF0, 0x12, 0x50, 0x1A, 0x50, 0x64, 0x90, 0x04, 0x90, 0x09, 0x60, 0x00, 0x00 }; /*575C*/
const unsigned char  uc2_575D [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7A, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x18, 0x80, 0x61, 0x60, 0x02, 0x10, 0x0C, 0x10, 0x00, 0x00 }; /*575D*/
const unsigned char  uc2_575E [] = {0x10, 0x80, 0x11, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x12, 0x40, 0x12, 0x00, 0x13, 0xF0, 0x18, 0x10, 0x67, 0xD0, 0x00, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*575E*/
const unsigned char  uc2_575F [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x7A, 0x20, 0x12, 0x20, 0x11, 0x40, 0x11, 0x40, 0x18, 0x80, 0x61, 0x40, 0x02, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*575F*/
const unsigned char  uc2_5760 [] = {0x3C, 0x80, 0x24, 0x80, 0x28, 0x80, 0x25, 0x40, 0x39, 0x40, 0x22, 0x20, 0x2C, 0x10, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5760*/
const unsigned char  uc2_5761 [] = {0x20, 0x80, 0x27, 0xF0, 0x24, 0x90, 0x74, 0xA0, 0x24, 0x80, 0x27, 0xE0, 0x25, 0x20, 0x35, 0x20, 0x64, 0xC0, 0x09, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*5761*/
const unsigned char  uc2_5764 [] = {0x10, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x7C, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x1F, 0xF0, 0x64, 0x90, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5764*/
const unsigned char  uc2_5766 [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*5766*/
const unsigned char  uc2_5768 [] = {0x11, 0x80, 0x10, 0x40, 0x17, 0xF0, 0x14, 0x10, 0x78, 0x10, 0x11, 0x00, 0x11, 0x20, 0x19, 0xC0, 0x61, 0x10, 0x01, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5768*/
const unsigned char  uc2_5769 [] = {0x12, 0x20, 0x12, 0x20, 0x17, 0xF0, 0x7A, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1A, 0x20, 0x62, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5769*/
const unsigned char  uc2_576A [] = {0x10, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x7C, 0x90, 0x12, 0x90, 0x12, 0xA0, 0x17, 0xF0, 0x18, 0x80, 0x60, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*576A*/
const unsigned char  uc2_576B [] = {0x11, 0x00, 0x11, 0x00, 0x11, 0xF0, 0x79, 0x00, 0x11, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x1C, 0x20, 0x64, 0x20, 0x07, 0xE0, 0x04, 0x20, 0x00, 0x00 }; /*576B*/
const unsigned char  uc2_576D [] = {0x20, 0x00, 0x27, 0xE0, 0x24, 0x20, 0x74, 0x20, 0x27, 0xE0, 0x24, 0x00, 0x25, 0x20, 0x35, 0xC0, 0x69, 0x10, 0x09, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*576D*/
const unsigned char  uc2_576F [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x78, 0x80, 0x11, 0x00, 0x11, 0xA0, 0x12, 0x90, 0x14, 0x90, 0x18, 0x80, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*576F*/
const unsigned char  uc2_5773 [] = {0x22, 0x40, 0x22, 0x40, 0x22, 0x40, 0x75, 0xF0, 0x29, 0x50, 0x2E, 0x50, 0x22, 0x50, 0x34, 0x50, 0x6B, 0x90, 0x0C, 0x90, 0x01, 0x60, 0x00, 0x00 }; /*5773*/
const unsigned char  uc2_5776 [] = {0x20, 0x00, 0x23, 0xE0, 0x23, 0x20, 0x72, 0xA0, 0x2F, 0xF0, 0x22, 0x20, 0x25, 0x40, 0x35, 0x40, 0x67, 0xF0, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*5776*/
const unsigned char  uc2_5777 [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x20, 0x78, 0x20, 0x13, 0xA0, 0x12, 0xA0, 0x13, 0xA0, 0x1A, 0xA0, 0x60, 0x20, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*5777*/
const unsigned char  uc2_5779 [] = {0x23, 0x00, 0x20, 0x80, 0x27, 0xF0, 0x74, 0x10, 0x20, 0x00, 0x21, 0x40, 0x21, 0x40, 0x31, 0x40, 0x62, 0x20, 0x02, 0x20, 0x04, 0x10, 0x00, 0x00 }; /*5779*/
const unsigned char  uc2_577B [] = {0x20, 0x60, 0x27, 0x80, 0x24, 0x80, 0x74, 0x80, 0x27, 0xF0, 0x24, 0x80, 0x24, 0x80, 0x35, 0x50, 0x46, 0x50, 0x05, 0x50, 0x01, 0x20, 0x00, 0x00 }; /*577B*/
const unsigned char  uc2_577C [] = {0x10, 0x60, 0x13, 0x80, 0x12, 0x00, 0x7A, 0x00, 0x13, 0xF0, 0x12, 0x40, 0x12, 0xE0, 0x1A, 0x50, 0x64, 0x50, 0x04, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*577C*/
const unsigned char  uc2_5782 [] = {0x01, 0xC0, 0x1E, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x00, 0x00 }; /*5782*/
const unsigned char  uc2_5783 [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x78, 0x00, 0x12, 0x20, 0x11, 0x20, 0x11, 0x20, 0x19, 0x40, 0x60, 0x40, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*5783*/
const unsigned char  uc2_5784 [] = {0x08, 0x80, 0x3F, 0xF0, 0x0A, 0x00, 0x0A, 0x90, 0x13, 0x10, 0x65, 0xE0, 0x18, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5784*/
const unsigned char  uc2_5785 [] = {0x12, 0xC0, 0x12, 0x20, 0x7A, 0x00, 0x17, 0xF0, 0x12, 0x80, 0x12, 0xA0, 0x1A, 0xA0, 0x64, 0xC0, 0x04, 0x90, 0x09, 0x90, 0x12, 0x60, 0x00, 0x00 }; /*5785*/
const unsigned char  uc2_5786 [] = {0x10, 0x80, 0x10, 0xF0, 0x10, 0x80, 0x7B, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0x00, 0x62, 0x00, 0x04, 0x00, 0x08, 0x00, 0x00, 0x00 }; /*5786*/
const unsigned char  uc2_578B [] = {0x00, 0x10, 0x3E, 0x50, 0x14, 0x50, 0x7F, 0x50, 0x14, 0x50, 0x14, 0x10, 0x64, 0x60, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*578B*/
const unsigned char  uc2_578C [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x7F, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x1D, 0xD0, 0x64, 0x10, 0x04, 0x10, 0x04, 0xE0, 0x00, 0x00 }; /*578C*/
const unsigned char  uc2_5792 [] = {0x08, 0x80, 0x10, 0x40, 0x3F, 0xA0, 0x10, 0x80, 0x29, 0x20, 0x49, 0xD0, 0x74, 0x10, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5792*/
const unsigned char  uc2_5793 [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x79, 0x00, 0x11, 0x40, 0x12, 0x40, 0x13, 0xA0, 0x19, 0x20, 0x66, 0x40, 0x00, 0xA0, 0x07, 0x10, 0x00, 0x00 }; /*5793*/
const unsigned char  uc2_579B [] = {0x10, 0x00, 0x11, 0xC0, 0x11, 0x40, 0x79, 0x40, 0x12, 0x30, 0x14, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x61, 0xC0, 0x06, 0xB0, 0x00, 0x80, 0x00, 0x00 }; /*579B*/
const unsigned char  uc2_57A0 [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x90, 0x1A, 0xA0, 0x62, 0x40, 0x02, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*57A0*/
const unsigned char  uc2_57A1 [] = {0x0A, 0x80, 0x0A, 0x40, 0x12, 0xF0, 0x77, 0x00, 0x11, 0x40, 0x11, 0x90, 0x16, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*57A1*/
const unsigned char  uc2_57A2 [] = {0x20, 0x60, 0x27, 0x80, 0x24, 0x00, 0x74, 0x00, 0x27, 0xF0, 0x24, 0x00, 0x35, 0xE0, 0x65, 0x20, 0x09, 0x20, 0x09, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*57A2*/
const unsigned char  uc2_57A3 [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x60, 0x00, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*57A3*/
const unsigned char  uc2_57A4 [] = {0x10, 0x00, 0x13, 0xF0, 0x10, 0x80, 0x79, 0x00, 0x12, 0x20, 0x13, 0xD0, 0x10, 0x90, 0x18, 0x80, 0x63, 0xE0, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*57A4*/
const unsigned char  uc2_57A6 [] = {0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x21, 0x20, 0x2C, 0xC0, 0x32, 0x30, 0x0F, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*57A6*/
const unsigned char  uc2_57A7 [] = {0x10, 0x80, 0x11, 0x00, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x15, 0x50, 0x1D, 0xD0, 0x64, 0x10, 0x04, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*57A7*/
const unsigned char  uc2_57A9 [] = {0x3F, 0xE0, 0x05, 0x00, 0x25, 0x20, 0x15, 0x40, 0x7F, 0xF0, 0x00, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*57A9*/
const unsigned char  uc2_57AB [] = {0x11, 0x00, 0x7B, 0xC0, 0x15, 0x40, 0x7B, 0x50, 0x11, 0x50, 0x66, 0xA0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*57AB*/
const unsigned char  uc2_57AD [] = {0x10, 0x00, 0x17, 0xF0, 0x11, 0x40, 0x79, 0x40, 0x11, 0x40, 0x15, 0x50, 0x13, 0x50, 0x1B, 0x60, 0x61, 0x40, 0x01, 0x40, 0x07, 0xF0, 0x00, 0x00 }; /*57AD*/
const unsigned char  uc2_57AE [] = {0x20, 0x80, 0x27, 0xF0, 0x21, 0x40, 0x72, 0x20, 0x25, 0xD0, 0x20, 0x00, 0x27, 0xF0, 0x31, 0x00, 0x63, 0xE0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*57AE*/
const unsigned char  uc2_57B2 [] = {0x10, 0x80, 0x12, 0xA0, 0x12, 0xA0, 0x7B, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x10, 0x20, 0x1B, 0xE0, 0x62, 0x10, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*57B2*/
const unsigned char  uc2_57B4 [] = {0x23, 0x00, 0x20, 0x80, 0x2F, 0xF0, 0x70, 0x00, 0x22, 0x40, 0x25, 0x60, 0x24, 0xA0, 0x37, 0x60, 0x64, 0x20, 0x07, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*57B4*/
const unsigned char  uc2_57B8 [] = {0x06, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x77, 0xC0, 0x20, 0x00, 0x2F, 0xE0, 0x32, 0x80, 0x62, 0x90, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*57B8*/
const unsigned char  uc2_57C2 [] = {0x17, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x7A, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x1A, 0x80, 0x61, 0x80, 0x02, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*57C2*/
const unsigned char  uc2_57C3 [] = {0x21, 0x00, 0x21, 0x40, 0x22, 0x60, 0x73, 0xA0, 0x22, 0x00, 0x23, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x30, 0x80, 0x41, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*57C3*/
const unsigned char  uc2_57CB [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*57CB*/
const unsigned char  uc2_57CE [] = {0x20, 0xC0, 0x20, 0xA0, 0x2F, 0xF0, 0x78, 0x80, 0x28, 0x80, 0x2E, 0x90, 0x2A, 0x90, 0x3A, 0xA0, 0x4C, 0x50, 0x08, 0xD0, 0x13, 0x20, 0x00, 0x00 }; /*57CE*/
const unsigned char  uc2_57CF [] = {0x20, 0x10, 0x2E, 0xE0, 0x22, 0x20, 0x72, 0xA0, 0x24, 0xB0, 0x2E, 0xA0, 0x22, 0xA0, 0x3A, 0xF0, 0x66, 0x00, 0x05, 0x80, 0x18, 0x70, 0x00, 0x00 }; /*57CF*/
const unsigned char  uc2_57D2 [] = {0x20, 0x70, 0x2F, 0x80, 0x21, 0x20, 0x74, 0xA0, 0x22, 0x00, 0x20, 0x40, 0x2F, 0xF0, 0x34, 0x40, 0x42, 0x40, 0x02, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*57D2*/
const unsigned char  uc2_57D4 [] = {0x21, 0x40, 0x21, 0x20, 0x2F, 0xF0, 0x71, 0x00, 0x27, 0xE0, 0x25, 0x20, 0x27, 0xE0, 0x35, 0x20, 0x47, 0xE0, 0x05, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*57D4*/
const unsigned char  uc2_57D5 [] = {0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x7B, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x19, 0xC0, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*57D5*/
const unsigned char  uc2_57D7 [] = {0x20, 0x80, 0x22, 0xE0, 0x22, 0x80, 0x77, 0xF0, 0x20, 0x00, 0x20, 0x80, 0x22, 0xA0, 0x32, 0xA0, 0x44, 0x40, 0x01, 0x80, 0x0E, 0x00, 0x00, 0x00 }; /*57D7*/
const unsigned char  uc2_57D8 [] = {0x20, 0x20, 0x2E, 0x20, 0x2A, 0x20, 0x7A, 0xF0, 0x2F, 0x20, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0x20, 0x4E, 0x20, 0x0A, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*57D8*/
const unsigned char  uc2_57D9 [] = {0x11, 0xE0, 0x11, 0x20, 0x79, 0xE0, 0x10, 0x00, 0x13, 0xF0, 0x12, 0x10, 0x12, 0x90, 0x1A, 0x90, 0x60, 0xC0, 0x01, 0x20, 0x06, 0x10, 0x00, 0x00 }; /*57D9*/
const unsigned char  uc2_57DA [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x1D, 0x50, 0x66, 0x30, 0x04, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*57DA*/
const unsigned char  uc2_57DD [] = {0x20, 0x80, 0x21, 0x40, 0x26, 0xB0, 0x70, 0x80, 0x23, 0xE0, 0x20, 0x20, 0x21, 0x40, 0x30, 0x80, 0x66, 0xA0, 0x0A, 0x50, 0x01, 0x90, 0x00, 0x00 }; /*57DD*/
const unsigned char  uc2_57DF [] = {0x20, 0xC0, 0x20, 0xA0, 0x2F, 0xF0, 0x70, 0x80, 0x2E, 0x90, 0x2A, 0x90, 0x2E, 0x90, 0x30, 0x60, 0x43, 0x40, 0x0C, 0xD0, 0x03, 0x20, 0x00, 0x00 }; /*57DF*/
const unsigned char  uc2_57E0 [] = {0x10, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x80, 0x00, 0x00 }; /*57E0*/
const unsigned char  uc2_57E4 [] = {0x21, 0x00, 0x22, 0x00, 0x27, 0xE0, 0x75, 0x20, 0x27, 0xE0, 0x25, 0x20, 0x27, 0xE0, 0x32, 0x00, 0x44, 0x80, 0x0F, 0xF0, 0x00, 0x80, 0x00, 0x00 }; /*57E4*/
const unsigned char  uc2_57ED [] = {0x20, 0x80, 0x23, 0xE0, 0x20, 0xA0, 0x77, 0xF0, 0x20, 0xA0, 0x23, 0xE0, 0x24, 0x90, 0x32, 0xA0, 0x42, 0xE0, 0x0C, 0x90, 0x03, 0x10, 0x00, 0x00 }; /*57ED*/
const unsigned char  uc2_57EF [] = {0x20, 0x80, 0x27, 0xF0, 0x21, 0x40, 0x72, 0xA0, 0x27, 0xF0, 0x22, 0xA0, 0x23, 0xE0, 0x32, 0xA0, 0x43, 0xE0, 0x00, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*57EF*/
const unsigned char  uc2_57F4 [] = {0x20, 0x80, 0x27, 0xF0, 0x21, 0x00, 0x73, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x33, 0xE0, 0x62, 0x20, 0x0F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*57F4*/
const unsigned char  uc2_57F8 [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x11, 0x00, 0x1B, 0xF0, 0x65, 0x50, 0x02, 0x50, 0x0C, 0x90, 0x03, 0x60, 0x00, 0x00 }; /*57F8*/
const unsigned char  uc2_57F9 [] = {0x11, 0x80, 0x10, 0x40, 0x13, 0xE0, 0x7A, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x10, 0x00, 0x1B, 0xE0, 0x62, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*57F9*/
const unsigned char  uc2_57FA [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*57FA*/
const unsigned char  uc2_57FD [] = {0x13, 0xE0, 0x10, 0x20, 0x13, 0xE0, 0x78, 0x20, 0x17, 0xF0, 0x14, 0x90, 0x13, 0xE0, 0x1A, 0xA0, 0x62, 0xA0, 0x02, 0xC0, 0x00, 0x80, 0x00, 0x00 }; /*57FD*/
const unsigned char  uc2_5800 [] = {0x20, 0x00, 0x27, 0xF0, 0x24, 0x10, 0x77, 0xF0, 0x24, 0x40, 0x25, 0x50, 0x25, 0xF0, 0x34, 0x40, 0x49, 0x50, 0x09, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*5800*/
const unsigned char  uc2_5802 [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5802*/
const unsigned char  uc2_5806 [] = {0x11, 0x00, 0x11, 0x40, 0x12, 0x20, 0x7B, 0xF0, 0x16, 0x40, 0x13, 0xE0, 0x12, 0x40, 0x1B, 0xE0, 0x62, 0x40, 0x03, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*5806*/
const unsigned char  uc2_5807 [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5807*/
const unsigned char  uc2_580B [] = {0x27, 0x70, 0x25, 0x50, 0x25, 0x50, 0x77, 0x70, 0x25, 0x50, 0x25, 0x50, 0x27, 0x70, 0x35, 0x50, 0x45, 0x50, 0x05, 0x50, 0x0A, 0xA0, 0x00, 0x00 }; /*580B*/
const unsigned char  uc2_580D [] = {0x22, 0x00, 0x23, 0x80, 0x22, 0x80, 0x77, 0xE0, 0x2D, 0x20, 0x25, 0x20, 0x27, 0xE0, 0x31, 0x80, 0x42, 0xD0, 0x02, 0xB0, 0x0C, 0x60, 0x00, 0x00 }; /*580D*/
const unsigned char  uc2_5811 [] = {0x10, 0x30, 0x7E, 0xC0, 0x28, 0x80, 0x7C, 0xF0, 0x0A, 0xA0, 0x7D, 0x20, 0x0A, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5811*/
const unsigned char  uc2_5815 [] = {0x38, 0x80, 0x2B, 0xF0, 0x29, 0x20, 0x33, 0xE0, 0x29, 0x20, 0x29, 0xE0, 0x39, 0x20, 0x22, 0x60, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5815*/
const unsigned char  uc2_5819 [] = {0x20, 0x00, 0x27, 0xF0, 0x21, 0x40, 0x77, 0xF0, 0x25, 0x50, 0x27, 0xF0, 0x20, 0x80, 0x33, 0xE0, 0x40, 0x80, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*5819*/
const unsigned char  uc2_581E [] = {0x25, 0x40, 0x2F, 0xF0, 0x25, 0x40, 0x75, 0xC0, 0x24, 0x00, 0x27, 0xE0, 0x20, 0x80, 0x37, 0xF0, 0x62, 0xA0, 0x02, 0xA0, 0x0C, 0x90, 0x00, 0x00 }; /*581E*/
const unsigned char  uc2_5820 [] = {0x22, 0x00, 0x22, 0xE0, 0x22, 0x20, 0x75, 0xF0, 0x2C, 0x80, 0x24, 0xE0, 0x25, 0x40, 0x35, 0xF0, 0x64, 0x40, 0x04, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*5820*/
const unsigned char  uc2_5821 [] = {0x0B, 0xE0, 0x0A, 0x20, 0x13, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x14, 0x90, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5821*/
const unsigned char  uc2_5824 [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x10, 0x80, 0x1A, 0xE0, 0x62, 0x80, 0x05, 0x80, 0x08, 0x70, 0x00, 0x00 }; /*5824*/
const unsigned char  uc2_582A [] = {0x22, 0x40, 0x27, 0xE0, 0x22, 0x40, 0x73, 0xC0, 0x22, 0x40, 0x23, 0xC0, 0x32, 0x40, 0x6F, 0xF0, 0x04, 0x80, 0x05, 0x40, 0x03, 0xE0, 0x00, 0x00 }; /*582A*/
const unsigned char  uc2_5830 [] = {0x27, 0xF0, 0x25, 0x20, 0x25, 0xE0, 0x75, 0x20, 0x25, 0xE0, 0x24, 0x40, 0x27, 0xF0, 0x35, 0x20, 0x44, 0xC0, 0x05, 0x20, 0x07, 0xF0, 0x00, 0x00 }; /*5830*/
const unsigned char  uc2_5835 [] = {0x20, 0x80, 0x23, 0xD0, 0x20, 0xA0, 0x77, 0xF0, 0x20, 0x80, 0x23, 0xE0, 0x2E, 0x20, 0x33, 0xE0, 0x42, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5835*/
const unsigned char  uc2_583E [] = {0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x77, 0xC0, 0x22, 0x00, 0x2F, 0xF0, 0x34, 0x40, 0x4F, 0xE0, 0x14, 0x50, 0x07, 0xC0, 0x04, 0x40, 0x00, 0x00 }; /*583E*/
const unsigned char  uc2_5844 [] = {0x20, 0x00, 0x27, 0xF0, 0x25, 0x50, 0x77, 0xF0, 0x20, 0x80, 0x27, 0xF0, 0x21, 0x00, 0x31, 0xE0, 0x41, 0x20, 0x02, 0x20, 0x0C, 0xC0, 0x00, 0x00 }; /*5844*/
const unsigned char  uc2_584C [] = {0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x7A, 0x20, 0x17, 0xF0, 0x10, 0x90, 0x16, 0xD0, 0x19, 0xB0, 0x62, 0xB0, 0x0C, 0xD0, 0x01, 0x20, 0x00, 0x00 }; /*584C*/
const unsigned char  uc2_584D [] = {0x04, 0x90, 0x72, 0xA0, 0x57, 0xF0, 0x50, 0x80, 0x77, 0xF0, 0x51, 0x40, 0x72, 0xA0, 0x54, 0x90, 0x53, 0xE0, 0x50, 0x80, 0x27, 0xF0, 0x00, 0x00 }; /*584D*/
const unsigned char  uc2_5851 [] = {0x14, 0xE0, 0x7F, 0xA0, 0x08, 0xE0, 0x2A, 0xA0, 0x3E, 0xE0, 0x10, 0xA0, 0x61, 0x40, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5851*/
const unsigned char  uc2_5854 [] = {0x12, 0x20, 0x17, 0xF0, 0x12, 0xA0, 0x79, 0x40, 0x12, 0x20, 0x15, 0xD0, 0x10, 0x00, 0x1B, 0xE0, 0x62, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*5854*/
const unsigned char  uc2_5858 [] = {0x20, 0x80, 0x27, 0xF0, 0x24, 0xA0, 0x77, 0xF0, 0x24, 0xA0, 0x27, 0xE0, 0x24, 0x80, 0x37, 0xE0, 0x6A, 0x20, 0x0B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*5858*/
const unsigned char  uc2_585E [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x62, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*585E*/
const unsigned char  uc2_5865 [] = {0x27, 0xF0, 0x20, 0x00, 0x23, 0xE0, 0x72, 0x20, 0x23, 0xE0, 0x20, 0x00, 0x27, 0xF0, 0x35, 0x50, 0x47, 0xF0, 0x04, 0x90, 0x04, 0x20, 0x00, 0x00 }; /*5865*/
const unsigned char  uc2_586B [] = {0x21, 0x00, 0x2F, 0xE0, 0x22, 0x00, 0x77, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x37, 0xC0, 0x44, 0x40, 0x1F, 0xF0, 0x08, 0x20, 0x00, 0x00 }; /*586B*/
const unsigned char  uc2_586C [] = {0x27, 0xF0, 0x24, 0x40, 0x25, 0xF0, 0x75, 0x10, 0x25, 0xF0, 0x25, 0x10, 0x25, 0xF0, 0x34, 0x40, 0x49, 0x60, 0x09, 0x50, 0x12, 0xD0, 0x00, 0x00 }; /*586C*/
const unsigned char  uc2_587E [] = {0x11, 0x00, 0x7F, 0xC0, 0x29, 0x40, 0x3B, 0x40, 0x15, 0x40, 0x7A, 0xD0, 0x14, 0x20, 0x22, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*587E*/
const unsigned char  uc2_5880 [] = {0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x7A, 0xA0, 0x29, 0xC0, 0x2E, 0xA0, 0x2A, 0xA0, 0x3B, 0xE0, 0x4C, 0x80, 0x0B, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*5880*/
const unsigned char  uc2_5881 [] = {0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x7A, 0x20, 0x17, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x17, 0xF0, 0x1A, 0x20, 0x61, 0xC0, 0x06, 0x30, 0x00, 0x00 }; /*5881*/
const unsigned char  uc2_5883 [] = {0x00, 0x80, 0x13, 0xE0, 0x11, 0x40, 0x17, 0xF0, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x61, 0x50, 0x01, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*5883*/
const unsigned char  uc2_5885 [] = {0x7D, 0xE0, 0x54, 0xA0, 0x7C, 0x40, 0x55, 0xF0, 0x7C, 0x50, 0x10, 0x40, 0x7C, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5885*/
const unsigned char  uc2_5889 [] = {0x20, 0x80, 0x27, 0xF0, 0x24, 0xA0, 0x77, 0xF0, 0x24, 0xA0, 0x27, 0xE0, 0x26, 0xA0, 0x3B, 0xE0, 0x4A, 0xA0, 0x0B, 0xE0, 0x12, 0xA0, 0x00, 0x00 }; /*5889*/
const unsigned char  uc2_5892 [] = {0x20, 0x80, 0x27, 0xF0, 0x21, 0x40, 0x77, 0xF0, 0x25, 0x50, 0x26, 0x30, 0x25, 0xD0, 0x35, 0x50, 0x45, 0xD0, 0x04, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*5892*/
const unsigned char  uc2_5893 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x62, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5893*/
const unsigned char  uc2_5899 [] = {0x21, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x75, 0x40, 0x2F, 0xF0, 0x20, 0x00, 0x2F, 0xE0, 0x3A, 0xA0, 0x4B, 0xA0, 0x08, 0x20, 0x0F, 0xE0, 0x00, 0x00 }; /*5899*/
const unsigned char  uc2_589A [] = {0x28, 0x00, 0x25, 0xE0, 0x2A, 0xA0, 0x75, 0xB0, 0x25, 0x20, 0x2A, 0xC0, 0x21, 0x00, 0x2F, 0xF0, 0x33, 0x80, 0x45, 0x40, 0x19, 0x30, 0x00, 0x00 }; /*589A*/
const unsigned char  uc2_589E [] = {0x22, 0x20, 0x21, 0x40, 0x27, 0xF0, 0x74, 0xB0, 0x26, 0xD0, 0x25, 0x90, 0x27, 0xF0, 0x32, 0x20, 0x43, 0xE0, 0x02, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*589E*/
const unsigned char  uc2_589F [] = {0x21, 0xE0, 0x21, 0x00, 0x2F, 0xF0, 0x79, 0x10, 0x29, 0xC0, 0x2F, 0x20, 0x29, 0xE0, 0x3D, 0x50, 0x4B, 0x60, 0x09, 0x40, 0x17, 0xF0, 0x00, 0x00 }; /*589F*/
const unsigned char  uc2_58A8 [] = {0x3F, 0xE0, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x2A, 0xA0, 0x5F, 0xD0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*58A8*/
const unsigned char  uc2_58A9 [] = {0x22, 0x40, 0x2F, 0xC0, 0x25, 0x70, 0x77, 0x50, 0x20, 0xD0, 0x27, 0x50, 0x21, 0x20, 0x32, 0xA0, 0x4F, 0x20, 0x02, 0x60, 0x04, 0x90, 0x00, 0x00 }; /*58A9*/
const unsigned char  uc2_58BC [] = {0x08, 0xE0, 0x7F, 0xA0, 0x2B, 0x10, 0x3E, 0xE0, 0x2A, 0xA0, 0x7F, 0x40, 0x08, 0xB0, 0x2A, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*58BC*/
const unsigned char  uc2_58C1 [] = {0x3C, 0x40, 0x25, 0xF0, 0x3C, 0xA0, 0x21, 0xF0, 0x3C, 0x40, 0x54, 0xE0, 0x1C, 0x40, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*58C1*/
const unsigned char  uc2_58C5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x11, 0x00, 0x2A, 0x80, 0x77, 0xE0, 0x2A, 0x80, 0x7B, 0xE0, 0x12, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*58C5*/
const unsigned char  uc2_58D1 [] = {0x0E, 0x00, 0x08, 0xF0, 0x7F, 0x50, 0x41, 0x50, 0x2A, 0x50, 0x14, 0x20, 0x7E, 0x50, 0x24, 0x90, 0x3F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*58D1*/
const unsigned char  uc2_58D5 [] = {0x20, 0x80, 0x27, 0xF0, 0x21, 0x40, 0x77, 0xF0, 0x24, 0x10, 0x23, 0xE0, 0x22, 0x80, 0x35, 0x50, 0x42, 0xE0, 0x01, 0x50, 0x06, 0xC0, 0x00, 0x00 }; /*58D5*/
const unsigned char  uc2_58E4 [] = {0x21, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x7E, 0xE0, 0x24, 0x40, 0x2F, 0xE0, 0x35, 0x40, 0x4F, 0xF0, 0x02, 0xA0, 0x1D, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*58E4*/
const unsigned char  uc2_58EB [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*58EB*/
const unsigned char  uc2_58EC [] = {0x01, 0xC0, 0x3E, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*58EC*/
const unsigned char  uc2_58EE [] = {0x10, 0x80, 0x10, 0x80, 0x50, 0x80, 0x30, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x30, 0x80, 0x50, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x00, 0x00, 0x00 }; /*58EE*/
const unsigned char  uc2_58F0 [] = {0x01, 0x00, 0x3F, 0xF0, 0x01, 0x00, 0x1F, 0xE0, 0x00, 0x00, 0x1F, 0xE0, 0x11, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*58F0*/
const unsigned char  uc2_58F3 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x0F, 0x80, 0x08, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*58F3*/
const unsigned char  uc2_58F6 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x25, 0x40, 0x15, 0x40, 0x15, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*58F6*/
const unsigned char  uc2_58F9 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x08, 0x80, 0x0F, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*58F9*/
const unsigned char  uc2_5904 [] = {0x10, 0x40, 0x10, 0x40, 0x1E, 0x40, 0x12, 0x60, 0x22, 0x50, 0x54, 0x50, 0x14, 0x50, 0x08, 0x40, 0x14, 0x40, 0x13, 0x00, 0x60, 0xF0, 0x00, 0x00 }; /*5904*/
const unsigned char  uc2_5907 [] = {0x08, 0x00, 0x0F, 0x80, 0x18, 0x80, 0x27, 0x00, 0x08, 0x80, 0x1F, 0xC0, 0x72, 0x70, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5907*/
const unsigned char  uc2_590D [] = {0x08, 0x00, 0x0F, 0xE0, 0x70, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x00, 0x0F, 0xC0, 0x38, 0x40, 0x07, 0x80, 0x78, 0x70, 0x00, 0x00 }; /*590D*/
const unsigned char  uc2_590F [] = {0x7F, 0xF0, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x80, 0x68, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*590F*/
const unsigned char  uc2_5914 [] = {0x08, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x17, 0xE0, 0x5C, 0xA0, 0x57, 0xE0, 0x5C, 0x90, 0x67, 0xF0, 0x28, 0xA0, 0x47, 0x10, 0x38, 0xE0, 0x00, 0x00 }; /*5914*/
const unsigned char  uc2_5915 [] = {0x04, 0x00, 0x07, 0xE0, 0x04, 0x20, 0x08, 0x20, 0x10, 0x20, 0x66, 0x40, 0x01, 0x40, 0x00, 0x80, 0x03, 0x00, 0x0C, 0x00, 0x70, 0x00, 0x00, 0x00 }; /*5915*/
const unsigned char  uc2_5916 [] = {0x10, 0x80, 0x10, 0x80, 0x1E, 0x80, 0x22, 0xC0, 0x22, 0xA0, 0x52, 0x90, 0x0C, 0x90, 0x04, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5916*/
const unsigned char  uc2_5919 [] = {0x3F, 0xC0, 0x20, 0x40, 0x2F, 0x40, 0x24, 0x40, 0x27, 0x40, 0x25, 0x40, 0x3B, 0x40, 0x21, 0x40, 0x22, 0x50, 0x2C, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*5919*/
const unsigned char  uc2_591A [] = {0x04, 0x00, 0x07, 0xC0, 0x08, 0x40, 0x35, 0x80, 0x02, 0x80, 0x7C, 0xF0, 0x03, 0x10, 0x1D, 0x20, 0x01, 0xC0, 0x07, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*591A*/
const unsigned char  uc2_591C [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x04, 0x80, 0x08, 0xE0, 0x11, 0x20, 0x71, 0xA0, 0x16, 0x40, 0x11, 0x40, 0x10, 0x80, 0x17, 0x70, 0x00, 0x00 }; /*591C*/
const unsigned char  uc2_591F [] = {0x20, 0x80, 0x3E, 0xF0, 0x23, 0x10, 0x42, 0xA0, 0x3A, 0x40, 0x2B, 0xC0, 0x2A, 0x70, 0x3B, 0x90, 0x2A, 0x50, 0x02, 0x60, 0x0D, 0x80, 0x00, 0x00 }; /*591F*/
const unsigned char  uc2_5924 [] = {0x07, 0x80, 0x38, 0x80, 0x0B, 0x00, 0x7C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xE0, 0x60, 0x20, 0x00, 0x00 }; /*5924*/
const unsigned char  uc2_5925 [] = {0x7C, 0x80, 0x54, 0xF0, 0x7D, 0x10, 0x54, 0xA0, 0x7C, 0xC0, 0x13, 0x40, 0x7C, 0x70, 0x11, 0x90, 0x38, 0x60, 0x54, 0x40, 0x13, 0x80, 0x00, 0x00 }; /*5925*/
const unsigned char  uc2_5927 [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*5927*/
const unsigned char  uc2_5929 [] = {0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*5929*/
const unsigned char  uc2_592A [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x0C, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*592A*/
const unsigned char  uc2_592B [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*592B*/
const unsigned char  uc2_592D [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*592D*/
const unsigned char  uc2_592E [] = {0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*592E*/
const unsigned char  uc2_592F [] = {0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x12, 0x40, 0x62, 0x30, 0x1F, 0xC0, 0x04, 0x40, 0x08, 0x40, 0x73, 0x80, 0x00, 0x00 }; /*592F*/
const unsigned char  uc2_5931 [] = {0x02, 0x00, 0x12, 0x00, 0x12, 0x00, 0x1F, 0xE0, 0x62, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*5931*/
const unsigned char  uc2_5934 [] = {0x01, 0x00, 0x19, 0x00, 0x05, 0x00, 0x31, 0x00, 0x09, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0xC0, 0x18, 0x20, 0x60, 0x10, 0x00, 0x00 }; /*5934*/
const unsigned char  uc2_5937 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x20, 0x1F, 0xE0, 0x22, 0x00, 0x3F, 0xF0, 0x02, 0x10, 0x0D, 0xA0, 0x70, 0x70, 0x00, 0x00 }; /*5937*/
const unsigned char  uc2_5938 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x00, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x07, 0xC0, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*5938*/
const unsigned char  uc2_5939 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*5939*/
const unsigned char  uc2_593A [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x61, 0x30, 0x01, 0x00, 0x3F, 0xE0, 0x11, 0x00, 0x09, 0x00, 0x09, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*593A*/
const unsigned char  uc2_593C [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x22, 0x40, 0x22, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*593C*/
const unsigned char  uc2_5941 [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x1F, 0xC0, 0x10, 0x80, 0x16, 0x80, 0x11, 0x00, 0x12, 0x80, 0x1F, 0xE0, 0x00, 0x00 }; /*5941*/
const unsigned char  uc2_5942 [] = {0x08, 0x00, 0x0F, 0x80, 0x10, 0x80, 0x61, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*5942*/
const unsigned char  uc2_5944 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xD0, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*5944*/
const unsigned char  uc2_5947 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x05, 0x80, 0x18, 0x40, 0x7F, 0xF0, 0x00, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x1E, 0x40, 0x13, 0x80, 0x00, 0x00 }; /*5947*/
const unsigned char  uc2_5948 [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0xC0, 0x62, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*5948*/
const unsigned char  uc2_5949 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x77, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x00, 0x00 }; /*5949*/
const unsigned char  uc2_594B [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*594B*/
const unsigned char  uc2_594E [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*594E*/
const unsigned char  uc2_594F [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x10, 0xC0, 0x6F, 0x30, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x00, 0x00 }; /*594F*/
const unsigned char  uc2_5951 [] = {0x08, 0xF0, 0x7F, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x08, 0x90, 0x7F, 0x10, 0x08, 0x60, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*5951*/
const unsigned char  uc2_5954 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5954*/
const unsigned char  uc2_5955 [] = {0x02, 0x00, 0x7F, 0xF0, 0x04, 0x80, 0x24, 0xA0, 0x48, 0x90, 0x33, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*5955*/
const unsigned char  uc2_5956 [] = {0x08, 0x80, 0x68, 0xF0, 0x09, 0x10, 0x1A, 0xA0, 0x68, 0x40, 0x0B, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*5956*/
const unsigned char  uc2_5957 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x68, 0x30, 0x0F, 0x00, 0x08, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x40, 0x1E, 0x40, 0x00, 0x00 }; /*5957*/
const unsigned char  uc2_5958 [] = {0x28, 0x80, 0x38, 0x80, 0x0F, 0xF0, 0x78, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x48, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*5958*/
const unsigned char  uc2_595A [] = {0x01, 0xF0, 0x7E, 0x40, 0x14, 0x40, 0x0A, 0x80, 0x1E, 0x00, 0x08, 0x80, 0x1F, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*595A*/
const unsigned char  uc2_5960 [] = {0x08, 0x80, 0x7F, 0xF0, 0x25, 0x20, 0x38, 0xE0, 0x27, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*5960*/
const unsigned char  uc2_5962 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x72, 0x70, 0x1F, 0xC0, 0x02, 0x80, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*5962*/
const unsigned char  uc2_5965 [] = {0x04, 0x00, 0x3F, 0xE0, 0x32, 0xA0, 0x2B, 0x20, 0x3F, 0xE0, 0x2A, 0xA0, 0x30, 0x60, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*5965*/
const unsigned char  uc2_5973 [] = {0x02, 0x00, 0x02, 0x00, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x11, 0x00, 0x19, 0x00, 0x06, 0xC0, 0x18, 0x20, 0x60, 0x10, 0x00, 0x00 }; /*5973*/
const unsigned char  uc2_5974 [] = {0x20, 0x00, 0x27, 0xE0, 0x7A, 0x20, 0x2A, 0x20, 0x2A, 0x20, 0x49, 0x40, 0x71, 0x40, 0x10, 0x80, 0x29, 0x40, 0x29, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*5974*/
const unsigned char  uc2_5976 [] = {0x20, 0x00, 0x23, 0xE0, 0x79, 0x20, 0x29, 0x20, 0x29, 0x40, 0x49, 0x70, 0x71, 0x10, 0x11, 0x10, 0x2A, 0x10, 0x22, 0x10, 0x44, 0xE0, 0x00, 0x00 }; /*5976*/
const unsigned char  uc2_5978 [] = {0x20, 0x00, 0x23, 0xE0, 0x78, 0x80, 0x28, 0x80, 0x28, 0x80, 0x4F, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x28, 0x80, 0x28, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*5978*/
const unsigned char  uc2_5979 [] = {0x20, 0x80, 0x20, 0x80, 0x7A, 0x80, 0x2A, 0xE0, 0x2B, 0xA0, 0x4E, 0xA0, 0x72, 0xA0, 0x12, 0xC0, 0x2A, 0x90, 0x2A, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*5979*/
const unsigned char  uc2_597D [] = {0x20, 0x00, 0x23, 0xE0, 0x78, 0x20, 0x28, 0x40, 0x28, 0x80, 0x4F, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x28, 0x80, 0x28, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*597D*/
const unsigned char  uc2_5981 [] = {0x21, 0x00, 0x21, 0x00, 0x79, 0xF0, 0x2A, 0x10, 0x2C, 0x10, 0x49, 0x10, 0x70, 0x90, 0x10, 0x90, 0x28, 0x10, 0x28, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*5981*/
const unsigned char  uc2_5982 [] = {0x10, 0x00, 0x11, 0xE0, 0x7D, 0x20, 0x25, 0x20, 0x25, 0x20, 0x45, 0x20, 0x69, 0x20, 0x19, 0x20, 0x15, 0xE0, 0x25, 0x20, 0x40, 0x00, 0x00, 0x00 }; /*5982*/
const unsigned char  uc2_5983 [] = {0x20, 0x00, 0x27, 0xE0, 0x78, 0x20, 0x28, 0x20, 0x2B, 0xE0, 0x4A, 0x20, 0x72, 0x00, 0x12, 0x10, 0x2A, 0x10, 0x2A, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*5983*/
const unsigned char  uc2_5984 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x0F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x00, 0x0E, 0xC0, 0x30, 0x20, 0x00, 0x00 }; /*5984*/
const unsigned char  uc2_5986 [] = {0x10, 0x80, 0x10, 0x80, 0x50, 0x80, 0x37, 0xF0, 0x11, 0x20, 0x11, 0x20, 0x32, 0x40, 0x53, 0x40, 0x10, 0xA0, 0x11, 0x10, 0x16, 0x10, 0x00, 0x00 }; /*5986*/
const unsigned char  uc2_5987 [] = {0x20, 0x00, 0x23, 0xF0, 0x78, 0x10, 0x28, 0x10, 0x28, 0x10, 0x49, 0xF0, 0x70, 0x10, 0x10, 0x10, 0x28, 0x10, 0x2B, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5987*/
const unsigned char  uc2_5988 [] = {0x20, 0x00, 0x27, 0xE0, 0x78, 0x20, 0x29, 0x20, 0x2A, 0x40, 0x4B, 0xF0, 0x70, 0x10, 0x17, 0xD0, 0x28, 0x10, 0x28, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*5988*/
const unsigned char  uc2_598A [] = {0x20, 0x00, 0x20, 0x60, 0x7B, 0x80, 0x28, 0x80, 0x28, 0x80, 0x4F, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x40, 0x00, 0x00, 0x00 }; /*598A*/
const unsigned char  uc2_598D [] = {0x20, 0x00, 0x23, 0xE0, 0x79, 0x40, 0x29, 0x40, 0x29, 0x40, 0x4F, 0xF0, 0x71, 0x40, 0x11, 0x40, 0x29, 0x40, 0x2A, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*598D*/
const unsigned char  uc2_5992 [] = {0x20, 0x80, 0x20, 0x40, 0x79, 0xF0, 0x29, 0x10, 0x29, 0x10, 0x49, 0xF0, 0x71, 0x10, 0x11, 0x00, 0x2A, 0x00, 0x2A, 0x00, 0x44, 0x00, 0x00, 0x00 }; /*5992*/
const unsigned char  uc2_5993 [] = {0x20, 0x80, 0x20, 0x80, 0x7F, 0xF0, 0x28, 0x80, 0x28, 0x80, 0x4B, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x28, 0xC0, 0x29, 0x20, 0x42, 0x10, 0x00, 0x00 }; /*5993*/
const unsigned char  uc2_5996 [] = {0x20, 0x60, 0x23, 0x80, 0x78, 0x80, 0x28, 0x80, 0x28, 0x80, 0x4F, 0xF0, 0x70, 0x80, 0x11, 0x40, 0x29, 0x40, 0x2A, 0x20, 0x44, 0x10, 0x00, 0x00 }; /*5996*/
const unsigned char  uc2_5997 [] = {0x20, 0x80, 0x20, 0x80, 0x79, 0x40, 0x2E, 0x30, 0x29, 0x00, 0x48, 0x80, 0x73, 0xE0, 0x10, 0x20, 0x28, 0x20, 0x28, 0x40, 0x41, 0x80, 0x00, 0x00 }; /*5997*/
const unsigned char  uc2_5999 [] = {0x20, 0x80, 0x20, 0x80, 0x7A, 0xA0, 0x2A, 0x90, 0x2C, 0x90, 0x48, 0x80, 0x70, 0xA0, 0x10, 0x20, 0x28, 0x40, 0x29, 0x80, 0x46, 0x00, 0x00, 0x00 }; /*5999*/
const unsigned char  uc2_599E [] = {0x20, 0x00, 0x27, 0xE0, 0x79, 0x20, 0x29, 0x20, 0x29, 0x20, 0x4F, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x2A, 0x40, 0x22, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*599E*/
const unsigned char  uc2_59A3 [] = {0x22, 0x40, 0x22, 0x40, 0x7A, 0x40, 0x2A, 0x50, 0x2B, 0x60, 0x4A, 0x40, 0x72, 0x40, 0x12, 0x40, 0x2A, 0x50, 0x2A, 0xD0, 0x43, 0x20, 0x00, 0x00 }; /*59A3*/
const unsigned char  uc2_59A4 [] = {0x23, 0xE0, 0x20, 0x20, 0x79, 0xC0, 0x28, 0x40, 0x2F, 0xF0, 0x48, 0x90, 0x70, 0xA0, 0x10, 0x80, 0x28, 0x80, 0x28, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*59A4*/
const unsigned char  uc2_59A5 [] = {0x01, 0xE0, 0x7E, 0x40, 0x24, 0x40, 0x12, 0x80, 0x04, 0x00, 0x7F, 0xF0, 0x04, 0x80, 0x08, 0x80, 0x11, 0x00, 0x0E, 0xC0, 0x70, 0x20, 0x00, 0x00 }; /*59A5*/
const unsigned char  uc2_59A8 [] = {0x21, 0x80, 0x20, 0x40, 0x7F, 0xF0, 0x29, 0x00, 0x29, 0x00, 0x49, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x2A, 0x20, 0x2A, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*59A8*/
const unsigned char  uc2_59A9 [] = {0x20, 0x00, 0x23, 0xE0, 0x78, 0x80, 0x28, 0x80, 0x2B, 0xF0, 0x48, 0x80, 0x70, 0x80, 0x11, 0x40, 0x29, 0x50, 0x2A, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*59A9*/
const unsigned char  uc2_59AA [] = {0x20, 0x00, 0x23, 0xF0, 0x7A, 0x00, 0x2A, 0x20, 0x2B, 0xA0, 0x4A, 0x40, 0x72, 0x40, 0x12, 0xA0, 0x2B, 0x20, 0x2A, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*59AA*/
const unsigned char  uc2_59AB [] = {0x22, 0x40, 0x21, 0x40, 0x79, 0x40, 0x2B, 0xF0, 0x28, 0x50, 0x48, 0x90, 0x70, 0x90, 0x11, 0x50, 0x29, 0x50, 0x2A, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*59AB*/
const unsigned char  uc2_59AE [] = {0x20, 0x00, 0x23, 0xE0, 0x7A, 0x20, 0x2A, 0x20, 0x2B, 0xE0, 0x4A, 0x00, 0x72, 0x90, 0x12, 0xE0, 0x2A, 0x90, 0x2A, 0x90, 0x44, 0x60, 0x00, 0x00 }; /*59AE*/
const unsigned char  uc2_59AF [] = {0x20, 0x80, 0x20, 0x80, 0x78, 0x80, 0x2B, 0xE0, 0x2A, 0xA0, 0x4A, 0xA0, 0x73, 0xE0, 0x12, 0xA0, 0x2A, 0xA0, 0x2B, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*59AF*/
const unsigned char  uc2_59B2 [] = {0x20, 0x00, 0x23, 0xE0, 0x7A, 0x20, 0x2A, 0x20, 0x2B, 0xE0, 0x4A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x2A, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*59B2*/
const unsigned char  uc2_59B9 [] = {0x20, 0x80, 0x20, 0x80, 0x7B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x4F, 0xF0, 0x70, 0x80, 0x11, 0xC0, 0x2A, 0xA0, 0x2A, 0xA0, 0x44, 0x90, 0x00, 0x00 }; /*59B9*/
const unsigned char  uc2_59BB [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x62, 0x70, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*59BB*/
const unsigned char  uc2_59BE [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x04, 0x80, 0x09, 0x00, 0x06, 0xC0, 0x38, 0x20, 0x00, 0x00 }; /*59BE*/
const unsigned char  uc2_59C6 [] = {0x20, 0x00, 0x21, 0xE0, 0x79, 0xA0, 0x29, 0x60, 0x29, 0x20, 0x4F, 0xF0, 0x72, 0xA0, 0x12, 0x60, 0x2B, 0xF0, 0x28, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*59C6*/
const unsigned char  uc2_59CA [] = {0x20, 0xA0, 0x20, 0xC0, 0x79, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x4B, 0xF0, 0x70, 0x90, 0x11, 0x90, 0x2A, 0xA0, 0x2C, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*59CA*/
const unsigned char  uc2_59CB [] = {0x20, 0x80, 0x20, 0x80, 0x79, 0x20, 0x2A, 0x30, 0x2B, 0xD0, 0x48, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x2A, 0x20, 0x2B, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*59CB*/
const unsigned char  uc2_59D0 [] = {0x20, 0x00, 0x23, 0xE0, 0x7A, 0x20, 0x2A, 0x20, 0x2B, 0xE0, 0x4A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*59D0*/
const unsigned char  uc2_59D1 [] = {0x20, 0x80, 0x20, 0x80, 0x78, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x48, 0x80, 0x73, 0xE0, 0x12, 0x20, 0x2A, 0x20, 0x2B, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*59D1*/
const unsigned char  uc2_59D2 [] = {0x22, 0x20, 0x23, 0x20, 0x7A, 0xA0, 0x2A, 0xA0, 0x2A, 0x20, 0x4A, 0x20, 0x72, 0x20, 0x13, 0x40, 0x2A, 0x60, 0x28, 0x90, 0x41, 0x10, 0x00, 0x00 }; /*59D2*/
const unsigned char  uc2_59D3 [] = {0x20, 0x80, 0x22, 0x80, 0x7A, 0x80, 0x2B, 0xE0, 0x2A, 0x80, 0x4C, 0x80, 0x70, 0x80, 0x13, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*59D3*/
const unsigned char  uc2_59D4 [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*59D4*/
const unsigned char  uc2_59D7 [] = {0x20, 0x00, 0x2E, 0xE0, 0x7A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x4F, 0xF0, 0x7A, 0xA0, 0x12, 0xA0, 0x2A, 0xA0, 0x2A, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*59D7*/
const unsigned char  uc2_59D8 [] = {0x22, 0x20, 0x21, 0x40, 0x7B, 0xE0, 0x29, 0x40, 0x29, 0x40, 0x4F, 0xF0, 0x71, 0x40, 0x11, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*59D8*/
const unsigned char  uc2_59DA [] = {0x21, 0x40, 0x21, 0x40, 0x75, 0x50, 0x2B, 0x60, 0x29, 0x40, 0x49, 0x40, 0x73, 0x60, 0x15, 0x50, 0x29, 0x40, 0x2A, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*59DA*/
const unsigned char  uc2_59DC [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0xC0, 0x38, 0x20, 0x00, 0x00 }; /*59DC*/
const unsigned char  uc2_59DD [] = {0x20, 0x80, 0x22, 0x80, 0x7B, 0xE0, 0x2C, 0x80, 0x28, 0x80, 0x4F, 0xF0, 0x70, 0x80, 0x11, 0xC0, 0x2A, 0xA0, 0x2C, 0x90, 0x40, 0x80, 0x00, 0x00 }; /*59DD*/
const unsigned char  uc2_59E3 [] = {0x20, 0x80, 0x27, 0xF0, 0x78, 0x00, 0x2A, 0x20, 0x2A, 0x10, 0x4D, 0x50, 0x71, 0x40, 0x10, 0x80, 0x29, 0x40, 0x2A, 0x20, 0x44, 0x10, 0x00, 0x00 }; /*59E3*/
const unsigned char  uc2_59E5 [] = {0x21, 0x00, 0x23, 0xD0, 0x79, 0x10, 0x29, 0x20, 0x2F, 0xF0, 0x48, 0x40, 0x71, 0x80, 0x17, 0x20, 0x29, 0xD0, 0x29, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*59E5*/
const unsigned char  uc2_59E8 [] = {0x20, 0x80, 0x27, 0xF0, 0x78, 0x80, 0x2B, 0xE0, 0x28, 0xA0, 0x49, 0xE0, 0x72, 0x80, 0x13, 0xF0, 0x28, 0x90, 0x29, 0x60, 0x46, 0x30, 0x00, 0x00 }; /*59E8*/
const unsigned char  uc2_59EB [] = {0x20, 0x00, 0x23, 0xF0, 0x7A, 0x80, 0x2A, 0x80, 0x2B, 0xE0, 0x4A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x2A, 0x80, 0x2A, 0x80, 0x43, 0xF0, 0x00, 0x00 }; /*59EB*/
const unsigned char  uc2_59EC [] = {0x20, 0x00, 0x23, 0xF0, 0x7A, 0x40, 0x2A, 0x40, 0x2A, 0xE0, 0x4A, 0xA0, 0x72, 0xA0, 0x12, 0xE0, 0x2A, 0x40, 0x2A, 0x40, 0x43, 0xF0, 0x00, 0x00 }; /*59EC*/
const unsigned char  uc2_59F9 [] = {0x20, 0x80, 0x23, 0xF0, 0x7A, 0x50, 0x28, 0x80, 0x2B, 0x80, 0x48, 0x80, 0x70, 0xF0, 0x17, 0x80, 0x28, 0x90, 0x28, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*59F9*/
const unsigned char  uc2_59FB [] = {0x20, 0x00, 0x23, 0xF0, 0x7A, 0x50, 0x2A, 0x50, 0x2B, 0xF0, 0x4A, 0x50, 0x72, 0xB0, 0x13, 0x30, 0x2A, 0x10, 0x2B, 0xF0, 0x42, 0x10, 0x00, 0x00 }; /*59FB*/
const unsigned char  uc2_59FF [] = {0x62, 0x00, 0x13, 0xF0, 0x04, 0x90, 0x10, 0xC0, 0x63, 0x30, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x09, 0x00, 0x07, 0xC0, 0x38, 0x20, 0x00, 0x00 }; /*59FF*/
const unsigned char  uc2_5A01 [] = {0x00, 0xA0, 0x3F, 0xF0, 0x20, 0x80, 0x3E, 0x90, 0x28, 0x90, 0x3E, 0xA0, 0x2A, 0xA0, 0x32, 0x40, 0x2C, 0xD0, 0x4B, 0x50, 0x52, 0x20, 0x00, 0x00 }; /*5A01*/
const unsigned char  uc2_5A03 [] = {0x20, 0x80, 0x20, 0x80, 0x7B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x48, 0x00, 0x50, 0x80, 0x33, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*5A03*/
const unsigned char  uc2_5A04 [] = {0x32, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x62, 0x30, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x09, 0x00, 0x07, 0xC0, 0x38, 0x20, 0x00, 0x00 }; /*5A04*/
const unsigned char  uc2_5A05 [] = {0x20, 0x00, 0x27, 0xF0, 0x79, 0x40, 0x29, 0x40, 0x29, 0x50, 0x4D, 0x50, 0x53, 0x60, 0x31, 0x40, 0x29, 0x40, 0x29, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*5A05*/
const unsigned char  uc2_5A06 [] = {0x21, 0x00, 0x21, 0x70, 0x7B, 0x80, 0x29, 0x50, 0x28, 0x90, 0x4B, 0x60, 0x50, 0x00, 0x37, 0xF0, 0x29, 0x40, 0x29, 0x50, 0x42, 0x20, 0x00, 0x00 }; /*5A06*/
const unsigned char  uc2_5A07 [] = {0x20, 0x60, 0x23, 0x80, 0x78, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x4A, 0x30, 0x55, 0x40, 0x31, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*5A07*/
const unsigned char  uc2_5A08 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x15, 0x40, 0x65, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x09, 0x00, 0x07, 0xC0, 0x38, 0x20, 0x00, 0x00 }; /*5A08*/
const unsigned char  uc2_5A09 [] = {0x20, 0x80, 0x23, 0xE0, 0x7A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x4F, 0xF0, 0x51, 0x00, 0x33, 0xE0, 0x28, 0x20, 0x28, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*5A09*/
const unsigned char  uc2_5A0C [] = {0x20, 0x00, 0x23, 0xE0, 0x7A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x4B, 0xE0, 0x50, 0x80, 0x33, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*5A0C*/
const unsigned char  uc2_5A11 [] = {0x30, 0x80, 0x0A, 0xA0, 0x64, 0x90, 0x10, 0x40, 0x6F, 0x80, 0x02, 0x00, 0x3F, 0xF0, 0x04, 0x40, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*5A11*/
const unsigned char  uc2_5A13 [] = {0x23, 0xF0, 0x22, 0x10, 0x7B, 0xF0, 0x2A, 0x40, 0x2B, 0x80, 0x4A, 0xA0, 0x53, 0xC0, 0x32, 0xA0, 0x2B, 0xD0, 0x2A, 0x90, 0x44, 0x60, 0x00, 0x00 }; /*5A13*/
const unsigned char  uc2_5A18 [] = {0x23, 0x00, 0x20, 0x80, 0x7B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x4A, 0x20, 0x53, 0xE0, 0x32, 0x90, 0x2A, 0x60, 0x2A, 0xC0, 0x43, 0x30, 0x00, 0x00 }; /*5A18*/
const unsigned char  uc2_5A1C [] = {0x20, 0x00, 0x27, 0xF0, 0x79, 0x50, 0x29, 0x50, 0x2B, 0xE0, 0x49, 0x50, 0x51, 0x50, 0x33, 0xD0, 0x29, 0x60, 0x2A, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*5A1C*/
const unsigned char  uc2_5A1F [] = {0x21, 0xE0, 0x21, 0x20, 0x79, 0xE0, 0x28, 0x00, 0x2B, 0xF0, 0x4A, 0x10, 0x53, 0xF0, 0x32, 0x10, 0x2B, 0xF0, 0x2A, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*5A1F*/
const unsigned char  uc2_5A20 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x00, 0x15, 0xE0, 0x14, 0x00, 0x27, 0xF0, 0x2D, 0x40, 0x19, 0x50, 0x15, 0x20, 0x25, 0x60, 0x41, 0x90, 0x00, 0x00 }; /*5A20*/
const unsigned char  uc2_5A23 [] = {0x22, 0x20, 0x21, 0x40, 0x7F, 0xE0, 0x28, 0xA0, 0x29, 0xE0, 0x4A, 0x80, 0x53, 0xF0, 0x30, 0x90, 0x29, 0xA0, 0x2E, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*5A23*/
const unsigned char  uc2_5A25 [] = {0x21, 0x80, 0x26, 0xC0, 0x7A, 0xA0, 0x2A, 0x80, 0x2F, 0xF0, 0x4A, 0x80, 0x53, 0xA0, 0x36, 0x50, 0x2A, 0xD0, 0x2B, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*5A25*/
const unsigned char  uc2_5A29 [] = {0x21, 0x00, 0x21, 0xC0, 0x7A, 0x40, 0x2F, 0xE0, 0x2A, 0xA0, 0x4A, 0xA0, 0x53, 0xE0, 0x30, 0xC0, 0x29, 0x50, 0x29, 0x50, 0x46, 0x20, 0x00, 0x00 }; /*5A29*/
const unsigned char  uc2_5A31 [] = {0x20, 0x00, 0x23, 0xE0, 0x7A, 0x20, 0x2B, 0xE0, 0x28, 0x00, 0x4B, 0xE0, 0x50, 0x80, 0x37, 0xF0, 0x28, 0x80, 0x29, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*5A31*/
const unsigned char  uc2_5A32 [] = {0x21, 0xE0, 0x21, 0x20, 0x79, 0x20, 0x29, 0xE0, 0x28, 0x40, 0x4B, 0xF0, 0x52, 0x50, 0x32, 0xB0, 0x2B, 0x30, 0x2A, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*5A32*/
const unsigned char  uc2_5A34 [] = {0x22, 0x00, 0x21, 0x70, 0x7A, 0x10, 0x2A, 0x50, 0x2B, 0xF0, 0x4A, 0x50, 0x52, 0xD0, 0x33, 0x70, 0x2A, 0x50, 0x2A, 0x50, 0x42, 0x20, 0x00, 0x00 }; /*5A34*/
const unsigned char  uc2_5A36 [] = {0x7E, 0x00, 0x25, 0xE0, 0x3C, 0xA0, 0x24, 0xA0, 0x7E, 0x40, 0x05, 0xB0, 0x08, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x0F, 0x80, 0x30, 0x60, 0x00, 0x00 }; /*5A36*/
const unsigned char  uc2_5A3C [] = {0x20, 0x00, 0x21, 0xE0, 0x79, 0x20, 0x29, 0xE0, 0x29, 0x20, 0x4B, 0xF0, 0x52, 0x10, 0x33, 0xF0, 0x2A, 0x10, 0x2B, 0xF0, 0x42, 0x10, 0x00, 0x00 }; /*5A3C*/
const unsigned char  uc2_5A40 [] = {0x20, 0x00, 0x2E, 0xF0, 0x7A, 0x20, 0x2A, 0xA0, 0x2D, 0x60, 0x4B, 0x60, 0x5A, 0xA0, 0x32, 0x20, 0x2C, 0x20, 0x28, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*5A40*/
const unsigned char  uc2_5A46 [] = {0x30, 0x80, 0x0F, 0xF0, 0x64, 0x90, 0x17, 0xE0, 0x05, 0x20, 0x14, 0xC0, 0x6B, 0x30, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0x60, 0x00, 0x00 }; /*5A46*/
const unsigned char  uc2_5A49 [] = {0x23, 0x00, 0x20, 0x80, 0x7B, 0xF0, 0x2C, 0x10, 0x2A, 0xE0, 0x4B, 0xA0, 0x52, 0xA0, 0x32, 0xA0, 0x2D, 0xD0, 0x22, 0x90, 0x4C, 0x60, 0x00, 0x00 }; /*5A49*/
const unsigned char  uc2_5A4A [] = {0x20, 0x80, 0x23, 0xE0, 0x78, 0x80, 0x29, 0xC0, 0x28, 0x80, 0x4F, 0xF0, 0x51, 0x40, 0x36, 0x50, 0x2A, 0x20, 0x2A, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*5A4A*/
const unsigned char  uc2_5A55 [] = {0x20, 0x80, 0x20, 0x80, 0x7F, 0xF0, 0x28, 0xA0, 0x2F, 0xF0, 0x48, 0xA0, 0x53, 0xE0, 0x30, 0x80, 0x2A, 0xF0, 0x2B, 0x80, 0x44, 0x70, 0x00, 0x00 }; /*5A55*/
const unsigned char  uc2_5A5A [] = {0x20, 0x60, 0x23, 0x80, 0x7A, 0x80, 0x2B, 0xF0, 0x2A, 0x80, 0x4A, 0x50, 0x53, 0xF0, 0x32, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x43, 0xE0, 0x00, 0x00 }; /*5A5A*/
const unsigned char  uc2_5A62 [] = {0x20, 0x80, 0x21, 0x00, 0x7B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x4A, 0xA0, 0x53, 0xE0, 0x31, 0x00, 0x2A, 0x80, 0x27, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*5A62*/
const unsigned char  uc2_5A67 [] = {0x20, 0x80, 0x23, 0xE0, 0x78, 0x80, 0x29, 0xC0, 0x28, 0x80, 0x4F, 0xF0, 0x52, 0x20, 0x33, 0xE0, 0x2A, 0x20, 0x2B, 0xA0, 0x42, 0x60, 0x00, 0x00 }; /*5A67*/
const unsigned char  uc2_5A6A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1D, 0xC0, 0x6A, 0xB0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*5A6A*/
const unsigned char  uc2_5A74 [] = {0x3D, 0xF0, 0x23, 0x10, 0x2B, 0x50, 0x2B, 0x50, 0x28, 0x40, 0x14, 0xA0, 0x25, 0x10, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*5A74*/
const unsigned char  uc2_5A75 [] = {0x22, 0x20, 0x21, 0x40, 0x7B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x4A, 0xA0, 0x53, 0xE0, 0x30, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*5A75*/
const unsigned char  uc2_5A76 [] = {0x23, 0x00, 0x20, 0x80, 0x27, 0xF0, 0x7C, 0x90, 0x2B, 0xE0, 0x4A, 0xA0, 0x53, 0xE0, 0x32, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x40, 0x80, 0x00, 0x00 }; /*5A76*/
const unsigned char  uc2_5A77 [] = {0x23, 0x00, 0x20, 0x80, 0x7F, 0xF0, 0x29, 0x40, 0x29, 0x40, 0x4F, 0xF0, 0x54, 0x10, 0x33, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*5A77*/
const unsigned char  uc2_5A7A [] = {0x3C, 0x80, 0x14, 0xF0, 0x7F, 0x20, 0x2A, 0xA0, 0x48, 0x40, 0x11, 0xB0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*5A7A*/
const unsigned char  uc2_5A7F [] = {0x27, 0xF0, 0x20, 0x90, 0x7A, 0xE0, 0x2B, 0x80, 0x2C, 0x70, 0x4B, 0xE0, 0x52, 0x20, 0x33, 0xE0, 0x2A, 0x20, 0x2B, 0xA0, 0x42, 0x60, 0x00, 0x00 }; /*5A7F*/
const unsigned char  uc2_5A92 [] = {0x22, 0x20, 0x27, 0xF0, 0x7A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x4B, 0xE0, 0x50, 0x80, 0x37, 0xF0, 0x29, 0xC0, 0x22, 0xA0, 0x44, 0x90, 0x00, 0x00 }; /*5A92*/
const unsigned char  uc2_5A96 [] = {0x21, 0x40, 0x27, 0xF0, 0x79, 0x40, 0x28, 0x80, 0x2B, 0xE0, 0x4A, 0xA0, 0x52, 0xA0, 0x37, 0xF0, 0x28, 0x80, 0x29, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*5A96*/
const unsigned char  uc2_5A9A [] = {0x23, 0xF0, 0x22, 0x50, 0x7B, 0xF0, 0x2A, 0x00, 0x2A, 0xF0, 0x4A, 0x90, 0x52, 0xF0, 0x32, 0x90, 0x2A, 0xF0, 0x2A, 0x90, 0x44, 0xF0, 0x00, 0x00 }; /*5A9A*/
const unsigned char  uc2_5A9B [] = {0x20, 0x30, 0x27, 0xD0, 0x7A, 0xA0, 0x2B, 0xF0, 0x28, 0x80, 0x4B, 0xF0, 0x51, 0x00, 0x31, 0xE0, 0x2E, 0xA0, 0x28, 0x40, 0x43, 0xB0, 0x00, 0x00 }; /*5A9B*/
const unsigned char  uc2_5AAA [] = {0x10, 0x00, 0x13, 0xC0, 0x12, 0x40, 0x7B, 0xC0, 0x2A, 0x40, 0x2B, 0xC0, 0x28, 0x00, 0x37, 0xE0, 0x1A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*5AAA*/
const unsigned char  uc2_5AB2 [] = {0x20, 0x80, 0x23, 0xE0, 0x7B, 0x60, 0x2A, 0xA0, 0x2B, 0x60, 0x4B, 0xE0, 0x52, 0x50, 0x33, 0x60, 0x2A, 0x50, 0x2A, 0xD0, 0x43, 0x20, 0x00, 0x00 }; /*5AB2*/
const unsigned char  uc2_5AB3 [] = {0x21, 0x00, 0x23, 0xE0, 0x7A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x13, 0xE0, 0x28, 0x80, 0x46, 0x50, 0x0B, 0xD0, 0x00, 0x00 }; /*5AB3*/
const unsigned char  uc2_5AB5 [] = {0x3A, 0xA0, 0x29, 0x40, 0x2B, 0xE0, 0x38, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x2E, 0xB0, 0x3B, 0xE0, 0x29, 0x40, 0x28, 0xC0, 0x53, 0x20, 0x00, 0x00 }; /*5AB5*/
const unsigned char  uc2_5AB8 [] = {0x20, 0x80, 0x22, 0xA0, 0x7B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x48, 0x80, 0x53, 0xE0, 0x32, 0xA0, 0x2B, 0xE0, 0x28, 0xA0, 0x47, 0xD0, 0x00, 0x00 }; /*5AB8*/
const unsigned char  uc2_5ABE [] = {0x21, 0x40, 0x27, 0xF0, 0x79, 0x40, 0x2B, 0xE0, 0x29, 0x40, 0x4F, 0xF0, 0x52, 0xA0, 0x33, 0xE0, 0x2A, 0xA0, 0x27, 0xF0, 0x42, 0x40, 0x00, 0x00 }; /*5ABE*/
const unsigned char  uc2_5AC1 [] = {0x23, 0x00, 0x20, 0x80, 0x7B, 0xF0, 0x2C, 0x10, 0x2B, 0xE0, 0x49, 0x00, 0x56, 0x90, 0x31, 0x60, 0x2E, 0xD0, 0x29, 0x40, 0x46, 0x80, 0x00, 0x00 }; /*5AC1*/
const unsigned char  uc2_5AC2 [] = {0x21, 0x40, 0x22, 0x70, 0x7A, 0x50, 0x2B, 0x70, 0x2A, 0x50, 0x4B, 0xF0, 0x50, 0x40, 0x33, 0xF0, 0x29, 0x10, 0x28, 0xE0, 0x43, 0x10, 0x00, 0x00 }; /*5AC2*/
const unsigned char  uc2_5AC9 [] = {0x20, 0x40, 0x23, 0xF0, 0x7A, 0x80, 0x2E, 0xF0, 0x2B, 0x40, 0x4A, 0x40, 0x56, 0xF0, 0x32, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x45, 0x10, 0x00, 0x00 }; /*5AC9*/
const unsigned char  uc2_5ACC [] = {0x22, 0x40, 0x27, 0xF0, 0x7A, 0x80, 0x2F, 0xE0, 0x2A, 0xA0, 0x4F, 0xF0, 0x52, 0xA0, 0x37, 0xE0, 0x2A, 0xC0, 0x2E, 0xB0, 0x42, 0x80, 0x00, 0x00 }; /*5ACC*/
const unsigned char  uc2_5AD2 [] = {0x20, 0x30, 0x27, 0xD0, 0x7A, 0xA0, 0x2B, 0xF0, 0x2C, 0x90, 0x4B, 0xE0, 0x51, 0x00, 0x33, 0xE0, 0x2D, 0x20, 0x28, 0xC0, 0x43, 0x30, 0x00, 0x00 }; /*5AD2*/
const unsigned char  uc2_5AD4 [] = {0x21, 0x80, 0x20, 0x40, 0x7B, 0xF0, 0x2A, 0x10, 0x29, 0xE0, 0x49, 0x00, 0x51, 0xE0, 0x31, 0x40, 0x2B, 0xF0, 0x29, 0x20, 0x42, 0x10, 0x00, 0x00 }; /*5AD4*/
const unsigned char  uc2_5AD6 [] = {0x27, 0xF0, 0x21, 0x40, 0x77, 0xF0, 0x35, 0x50, 0x57, 0xF0, 0x50, 0x00, 0x53, 0xE0, 0x20, 0x00, 0x27, 0xF0, 0x52, 0xA0, 0x55, 0x10, 0x00, 0x00 }; /*5AD6*/
const unsigned char  uc2_5AD8 [] = {0x23, 0xE0, 0x22, 0xA0, 0x7B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x49, 0x40, 0x53, 0x80, 0x31, 0x20, 0x2B, 0xD0, 0x2A, 0xA0, 0x45, 0x90, 0x00, 0x00 }; /*5AD8*/
const unsigned char  uc2_5ADC [] = {0x20, 0x80, 0x23, 0xE0, 0x79, 0x40, 0x2F, 0xF0, 0x2A, 0x20, 0x4B, 0xE0, 0x52, 0x20, 0x33, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*5ADC*/
const unsigned char  uc2_5AE0 [] = {0x08, 0x80, 0x3E, 0xF0, 0x09, 0x20, 0x7E, 0xA0, 0x2C, 0x40, 0x4A, 0xA0, 0x3F, 0xF0, 0x22, 0x00, 0x3F, 0xF0, 0x44, 0x80, 0x5F, 0x60, 0x00, 0x00 }; /*5AE0*/
const unsigned char  uc2_5AE1 [] = {0x20, 0x80, 0x27, 0xF0, 0x71, 0x40, 0x37, 0xF0, 0x54, 0x90, 0x57, 0xF0, 0x64, 0x90, 0x25, 0xD0, 0x25, 0x50, 0x55, 0xD0, 0x54, 0x60, 0x00, 0x00 }; /*5AE1*/
const unsigned char  uc2_5AE3 [] = {0x27, 0xF0, 0x20, 0x80, 0x72, 0xE0, 0x32, 0x80, 0x57, 0xF0, 0x52, 0x00, 0x63, 0xF0, 0x22, 0x00, 0x57, 0xF0, 0x55, 0x50, 0x4A, 0xA0, 0x00, 0x00 }; /*5AE3*/
const unsigned char  uc2_5AE6 [] = {0x24, 0x90, 0x22, 0xA0, 0x7B, 0xF0, 0x2D, 0x50, 0x29, 0xC0, 0x48, 0x80, 0x53, 0xE0, 0x32, 0xA0, 0x2A, 0xA0, 0x2A, 0xC0, 0x40, 0x80, 0x00, 0x00 }; /*5AE6*/
const unsigned char  uc2_5AE9 [] = {0x24, 0x40, 0x2F, 0x40, 0x74, 0x70, 0x3F, 0xD0, 0x55, 0x50, 0x5F, 0x50, 0x54, 0x20, 0x2E, 0x20, 0x25, 0x50, 0x55, 0x50, 0x54, 0x90, 0x00, 0x00 }; /*5AE9*/
const unsigned char  uc2_5AEB [] = {0x21, 0x40, 0x27, 0xF0, 0x79, 0x40, 0x2B, 0xE0, 0x2A, 0x20, 0x4B, 0xE0, 0x52, 0x20, 0x33, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x42, 0x20, 0x00, 0x00 }; /*5AEB*/
const unsigned char  uc2_5AF1 [] = {0x20, 0x80, 0x27, 0xF0, 0x72, 0xA0, 0x31, 0xC0, 0x5F, 0xF0, 0x54, 0x10, 0x65, 0xD0, 0x25, 0x50, 0x55, 0x50, 0x57, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*5AF1*/
const unsigned char  uc2_5B09 [] = {0x20, 0x80, 0x27, 0xF0, 0x70, 0x80, 0x33, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x61, 0x40, 0x27, 0xF0, 0x32, 0x20, 0x53, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*5B09*/
const unsigned char  uc2_5B16 [] = {0x3C, 0x40, 0x25, 0xF0, 0x38, 0xA0, 0x35, 0xF0, 0x54, 0x40, 0x5C, 0xE0, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*5B16*/
const unsigned char  uc2_5B17 [] = {0x21, 0x00, 0x2F, 0xF0, 0x75, 0xA0, 0x36, 0x60, 0x55, 0xA0, 0x54, 0x20, 0x67, 0xE0, 0x22, 0x40, 0x33, 0xC0, 0x52, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*5B17*/
const unsigned char  uc2_5B32 [] = {0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x05, 0x00, 0x25, 0x40, 0x7A, 0xF0, 0x2A, 0x50, 0x2D, 0x50, 0x59, 0xB0, 0x00, 0x00 }; /*5B32*/
const unsigned char  uc2_5B34 [] = {0x02, 0x00, 0x7F, 0xF0, 0x20, 0x00, 0x1F, 0xE0, 0x10, 0x40, 0x7F, 0xE0, 0x52, 0xA0, 0x7F, 0xE0, 0x55, 0xA0, 0x72, 0xB0, 0x5D, 0x20, 0x00, 0x00 }; /*5B34*/
const unsigned char  uc2_5B37 [] = {0x20, 0x40, 0x27, 0xF0, 0x75, 0x40, 0x37, 0xF0, 0x55, 0x40, 0x57, 0xE0, 0x65, 0x50, 0x24, 0x80, 0x35, 0x40, 0x56, 0xA0, 0x48, 0xD0, 0x00, 0x00 }; /*5B37*/
const unsigned char  uc2_5B40 [] = {0x2F, 0xE0, 0x21, 0x00, 0x7F, 0xF0, 0x35, 0x50, 0x51, 0x00, 0x54, 0xE0, 0x6E, 0xA0, 0x24, 0xE0, 0x3E, 0xA0, 0x55, 0xE0, 0x44, 0xA0, 0x00, 0x00 }; /*5B40*/
const unsigned char  uc2_5B50 [] = {0x1F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5B50*/
const unsigned char  uc2_5B51 [] = {0x1F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x02, 0x70, 0x0F, 0x80, 0x72, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5B51*/
const unsigned char  uc2_5B53 [] = {0x1F, 0xC0, 0x00, 0x40, 0x40, 0x80, 0x21, 0x00, 0x12, 0x00, 0x0A, 0x00, 0x06, 0x00, 0x03, 0x80, 0x02, 0x70, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5B53*/
const unsigned char  uc2_5B54 [] = {0x01, 0x00, 0x7D, 0x00, 0x05, 0x00, 0x09, 0x00, 0x11, 0x00, 0x1D, 0x00, 0x71, 0x00, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5B54*/
const unsigned char  uc2_5B55 [] = {0x1F, 0xC0, 0x08, 0x40, 0x08, 0x80, 0x10, 0xF0, 0x10, 0x10, 0x67, 0x90, 0x00, 0xA0, 0x01, 0x00, 0x3F, 0xF0, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*5B55*/
const unsigned char  uc2_5B57 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x00, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*5B57*/
const unsigned char  uc2_5B58 [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0xF0, 0x08, 0x00, 0x13, 0xC0, 0x30, 0x40, 0x50, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*5B58*/
const unsigned char  uc2_5B59 [] = {0x00, 0x80, 0x7C, 0x80, 0x04, 0x80, 0x08, 0x80, 0x12, 0xA0, 0x1E, 0xA0, 0x72, 0x90, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*5B59*/
const unsigned char  uc2_5B5A [] = {0x00, 0x60, 0x3F, 0x80, 0x12, 0x20, 0x09, 0x40, 0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*5B5A*/
const unsigned char  uc2_5B5B [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x0F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*5B5B*/
const unsigned char  uc2_5B5C [] = {0x00, 0x80, 0x7C, 0x80, 0x04, 0xF0, 0x09, 0xA0, 0x12, 0xA0, 0x10, 0xA0, 0x1C, 0x40, 0x70, 0x40, 0x10, 0xA0, 0x10, 0xA0, 0x61, 0x10, 0x00, 0x00 }; /*5B5C*/
const unsigned char  uc2_5B5D [] = {0x02, 0x00, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x01, 0x00, 0x0F, 0x80, 0x78, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*5B5D*/
const unsigned char  uc2_5B5F [] = {0x0F, 0x80, 0x00, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x15, 0x40, 0x15, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*5B5F*/
const unsigned char  uc2_5B62 [] = {0x02, 0x00, 0x7A, 0x00, 0x0B, 0xE0, 0x0C, 0x20, 0x13, 0xA0, 0x1E, 0xA0, 0x73, 0xA0, 0x12, 0xC0, 0x12, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*5B62*/
const unsigned char  uc2_5B63 [] = {0x00, 0xC0, 0x1F, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x72, 0x70, 0x0F, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5B63*/
const unsigned char  uc2_5B64 [] = {0x00, 0x30, 0x7B, 0xC0, 0x0A, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x15, 0x50, 0x15, 0xB0, 0x68, 0x10, 0x00, 0x00 }; /*5B64*/
const unsigned char  uc2_5B65 [] = {0x09, 0xE0, 0x7E, 0xA0, 0x12, 0xA0, 0x34, 0x40, 0x0A, 0xA0, 0x71, 0x10, 0x0F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*5B65*/
const unsigned char  uc2_5B66 [] = {0x14, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x00, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*5B66*/
const unsigned char  uc2_5B69 [] = {0x03, 0x00, 0x70, 0x80, 0x1F, 0xF0, 0x11, 0x40, 0x22, 0x40, 0x33, 0xA0, 0x61, 0x20, 0x22, 0x40, 0x2C, 0x80, 0x23, 0x60, 0x4C, 0x10, 0x00, 0x00 }; /*5B69*/
const unsigned char  uc2_5B6A [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x15, 0x60, 0x65, 0x10, 0x1F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*5B6A*/
const unsigned char  uc2_5B6C [] = {0x7F, 0xF0, 0x02, 0x00, 0x0E, 0xC0, 0x72, 0x20, 0x02, 0x10, 0x11, 0xE0, 0x7C, 0x20, 0x24, 0x40, 0x3B, 0xF0, 0x14, 0x40, 0x65, 0x80, 0x00, 0x00 }; /*5B6C*/
const unsigned char  uc2_5B70 [] = {0x11, 0x00, 0x7D, 0x00, 0x29, 0x00, 0x3B, 0xC0, 0x01, 0x40, 0x39, 0x40, 0x0B, 0x40, 0x11, 0x40, 0x7A, 0xD0, 0x12, 0x50, 0x24, 0x20, 0x00, 0x00 }; /*5B70*/
const unsigned char  uc2_5B71 [] = {0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x80, 0x2F, 0xF0, 0x21, 0x00, 0x2E, 0xE0, 0x22, 0x20, 0x3F, 0xF0, 0x44, 0x40, 0x48, 0x80, 0x00, 0x00 }; /*5B71*/
const unsigned char  uc2_5B73 [] = {0x08, 0x80, 0x7F, 0xF0, 0x14, 0xA0, 0x39, 0xC0, 0x14, 0xA0, 0x39, 0xD0, 0x0F, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*5B73*/
const unsigned char  uc2_5B75 [] = {0x10, 0x30, 0x66, 0xC0, 0x55, 0x50, 0x55, 0x50, 0x77, 0xE0, 0x55, 0x20, 0x55, 0x40, 0x77, 0xF0, 0x14, 0x40, 0x24, 0x40, 0x44, 0x80, 0x00, 0x00 }; /*5B75*/
const unsigned char  uc2_5B7A [] = {0x03, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x24, 0x90, 0x22, 0xA0, 0x30, 0x00, 0x67, 0xF0, 0x21, 0x00, 0x27, 0xF0, 0x25, 0x50, 0x45, 0x50, 0x00, 0x00 }; /*5B7A*/
const unsigned char  uc2_5B7D [] = {0x08, 0x40, 0x7F, 0xF8, 0x14, 0xA0, 0x25, 0xF0, 0x3C, 0x40, 0x23, 0xF0, 0x3E, 0x40, 0x01, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*5B7D*/
const unsigned char  uc2_5B81 [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5B81*/
const unsigned char  uc2_5B83 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x40, 0x10, 0x10, 0x80, 0x13, 0x00, 0x1C, 0x10, 0x10, 0x10, 0x10, 0x20, 0x0F, 0xC0, 0x00, 0x00 }; /*5B83*/
const unsigned char  uc2_5B84 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xE0, 0x40, 0x20, 0x44, 0x20, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x80, 0x08, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*5B84*/
const unsigned char  uc2_5B85 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x90, 0x03, 0x00, 0x3C, 0x00, 0x04, 0x60, 0x07, 0x80, 0x7C, 0x10, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*5B85*/
const unsigned char  uc2_5B87 [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5B87*/
const unsigned char  uc2_5B88 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x10, 0x00, 0x80, 0x3F, 0xF0, 0x00, 0x80, 0x18, 0x80, 0x04, 0x80, 0x00, 0x80, 0x07, 0x00, 0x00, 0x00 }; /*5B88*/
const unsigned char  uc2_5B89 [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x24, 0x20, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x00, 0x0E, 0xC0, 0x70, 0x20, 0x00, 0x00 }; /*5B89*/
const unsigned char  uc2_5B8B [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*5B8B*/
const unsigned char  uc2_5B8C [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5B8C*/
const unsigned char  uc2_5B8F [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x04, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x09, 0x00, 0x12, 0x40, 0x64, 0xE0, 0x07, 0x20, 0x00, 0x00 }; /*5B8F*/
const unsigned char  uc2_5B91 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xE0, 0x40, 0x20, 0x09, 0x00, 0x3F, 0xC0, 0x09, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x11, 0x00, 0x61, 0x00, 0x00, 0x00 }; /*5B91*/
const unsigned char  uc2_5B93 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x42, 0x10, 0x02, 0x80, 0x28, 0x80, 0x29, 0x20, 0x4E, 0x50, 0x18, 0x50, 0x67, 0x80, 0x00, 0x00 }; /*5B93*/
const unsigned char  uc2_5B95 [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x04, 0x00, 0x08, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x00, 0x00 }; /*5B95*/
const unsigned char  uc2_5B97 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x12, 0x60, 0x62, 0x10, 0x0C, 0x00, 0x00, 0x00 }; /*5B97*/
const unsigned char  uc2_5B98 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0x90, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5B98*/
const unsigned char  uc2_5B99 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*5B99*/
const unsigned char  uc2_5B9A [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x2E, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*5B9A*/
const unsigned char  uc2_5B9B [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x50, 0x10, 0x11, 0xE0, 0x1D, 0x20, 0x65, 0x20, 0x15, 0x50, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5B9B*/
const unsigned char  uc2_5B9C [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x4F, 0x90, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*5B9C*/
const unsigned char  uc2_5B9D [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x80, 0x02, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*5B9D*/
const unsigned char  uc2_5B9E [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x48, 0x10, 0x25, 0x10, 0x15, 0x00, 0x11, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0C, 0xE0, 0x70, 0x10, 0x00, 0x00 }; /*5B9E*/
const unsigned char  uc2_5BA0 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xE0, 0x40, 0x20, 0x4B, 0x20, 0x08, 0x80, 0x7F, 0xE0, 0x0A, 0x40, 0x13, 0x90, 0x66, 0x10, 0x19, 0xE0, 0x00, 0x00 }; /*5BA0*/
const unsigned char  uc2_5BA1 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x02, 0x00, 0x00, 0x00 }; /*5BA1*/
const unsigned char  uc2_5BA2 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x10, 0x4F, 0xD0, 0x30, 0x40, 0x0F, 0x80, 0x70, 0x70, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5BA2*/
const unsigned char  uc2_5BA3 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x00, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*5BA3*/
const unsigned char  uc2_5BA4 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x7F, 0xD0, 0x08, 0x80, 0x1F, 0x40, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5BA4*/
const unsigned char  uc2_5BA5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x04, 0x00, 0x3F, 0xE0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x08, 0xC0, 0x00, 0x00 }; /*5BA5*/
const unsigned char  uc2_5BA6 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x12, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x12, 0x00, 0x1F, 0xE0, 0x00, 0x00 }; /*5BA6*/
const unsigned char  uc2_5BAA [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x52, 0x10, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*5BAA*/
const unsigned char  uc2_5BAB [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x4F, 0x90, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*5BAB*/
const unsigned char  uc2_5BB0 [] = {0x02, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x42, 0x10, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x00, 0x00 }; /*5BB0*/
const unsigned char  uc2_5BB3 [] = {0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*5BB3*/
const unsigned char  uc2_5BB4 [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x5F, 0xD0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x40, 0x38, 0x20, 0x00, 0x00 }; /*5BB4*/
const unsigned char  uc2_5BB5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x0A, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*5BB5*/
const unsigned char  uc2_5BB6 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0xE0, 0x04, 0x00, 0x7A, 0x20, 0x05, 0x40, 0x79, 0xA0, 0x06, 0xA0, 0x78, 0x90, 0x07, 0x00, 0x00, 0x00 }; /*5BB6*/
const unsigned char  uc2_5BB8 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xE0, 0x10, 0x00, 0x17, 0xC0, 0x10, 0x00, 0x1F, 0xF0, 0x28, 0xA0, 0x2E, 0x40, 0x48, 0x30, 0x00, 0x00 }; /*5BB8*/
const unsigned char  uc2_5BB9 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x32, 0x20, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*5BB9*/
const unsigned char  uc2_5BBD [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x50, 0x05, 0x10, 0x78, 0xE0, 0x00, 0x00 }; /*5BBD*/
const unsigned char  uc2_5BBE [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x90, 0x1F, 0x00, 0x10, 0x00, 0x1F, 0xC0, 0x11, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x18, 0xE0, 0x60, 0x10, 0x00, 0x00 }; /*5BBE*/
const unsigned char  uc2_5BBF [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x10, 0x4F, 0xE0, 0x11, 0x00, 0x37, 0xE0, 0x54, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x00, 0x00 }; /*5BBF*/
const unsigned char  uc2_5BC2 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x48, 0x10, 0x0E, 0x00, 0x09, 0xF0, 0x7E, 0x90, 0x00, 0xA0, 0x2C, 0x40, 0x4A, 0xA0, 0x11, 0x10, 0x00, 0x00 }; /*5BC2*/
const unsigned char  uc2_5BC4 [] = {0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x05, 0x00, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*5BC4*/
const unsigned char  uc2_5BC5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xE0, 0x60, 0x10, 0x00, 0x00 }; /*5BC5*/
const unsigned char  uc2_5BC6 [] = {0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x49, 0x10, 0x29, 0x20, 0x2A, 0x50, 0x4C, 0x50, 0x17, 0x80, 0x62, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*5BC6*/
const unsigned char  uc2_5BC7 [] = {0x04, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x41, 0x10, 0x39, 0xE0, 0x01, 0x00, 0x7F, 0xC0, 0x2A, 0x40, 0x29, 0x90, 0x4A, 0x50, 0x47, 0xE0, 0x00, 0x00 }; /*5BC7*/
const unsigned char  uc2_5BCC [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x7F, 0xF0, 0x10, 0x40, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*5BCC*/
const unsigned char  uc2_5BD0 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x0F, 0xF0, 0x78, 0x80, 0x29, 0xC0, 0x2E, 0xB0, 0x48, 0x80, 0x00, 0x00 }; /*5BD0*/
const unsigned char  uc2_5BD2 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x16, 0x40, 0x61, 0x30, 0x06, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*5BD2*/
const unsigned char  uc2_5BD3 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x2C, 0x40, 0x00, 0x00 }; /*5BD3*/
const unsigned char  uc2_5BDD [] = {0x01, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x13, 0xE0, 0x50, 0x20, 0x33, 0xE0, 0x10, 0x20, 0x17, 0xF0, 0x35, 0x50, 0x50, 0x80, 0x17, 0x70, 0x00, 0x00 }; /*5BDD*/
const unsigned char  uc2_5BDE [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x00, 0x00 }; /*5BDE*/
const unsigned char  uc2_5BDF [] = {0x02, 0x00, 0x7F, 0xF0, 0x51, 0x10, 0x1D, 0x60, 0x25, 0x20, 0x58, 0xA0, 0x17, 0x40, 0x60, 0x30, 0x1F, 0xC0, 0x12, 0x40, 0x24, 0x20, 0x00, 0x00 }; /*5BDF*/
const unsigned char  uc2_5BE1 [] = {0x02, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x6F, 0xB0, 0x18, 0x80, 0x00, 0x00 }; /*5BE1*/
const unsigned char  uc2_5BE4 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x2B, 0xE0, 0x28, 0x80, 0x3B, 0xE0, 0x09, 0x20, 0x7F, 0xF0, 0x2A, 0x20, 0x2B, 0xE0, 0x4A, 0x20, 0x00, 0x00 }; /*5BE4*/
const unsigned char  uc2_5BE5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x0C, 0xC0, 0x17, 0x40, 0x08, 0x80, 0x72, 0x70, 0x1D, 0x00, 0x06, 0x40, 0x01, 0x80, 0x3E, 0x00, 0x00, 0x00 }; /*5BE5*/
const unsigned char  uc2_5BE8 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x12, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*5BE8*/
const unsigned char  uc2_5BEE [] = {0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x1F, 0xC0, 0x28, 0xA0, 0x1F, 0xC0, 0x68, 0xB0, 0x0F, 0x80, 0x12, 0x40, 0x22, 0x20, 0x06, 0x00, 0x00, 0x00 }; /*5BEE*/
const unsigned char  uc2_5BF0 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x15, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x09, 0x20, 0x70, 0xC0, 0x1C, 0x30, 0x00, 0x00 }; /*5BF0*/
const unsigned char  uc2_5BF8 [] = {0x00, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x00, 0x80, 0x00, 0x80, 0x38, 0x80, 0x04, 0x80, 0x04, 0x80, 0x00, 0x80, 0x00, 0x80, 0x07, 0x00, 0x00, 0x00 }; /*5BF8*/
const unsigned char  uc2_5BF9 [] = {0x00, 0x20, 0x78, 0x20, 0x0B, 0xF0, 0x08, 0x20, 0x49, 0x20, 0x28, 0xA0, 0x10, 0xA0, 0x18, 0x20, 0x24, 0x20, 0x24, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*5BF9*/
const unsigned char  uc2_5BFA [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x80, 0x3F, 0xE0, 0x00, 0x80, 0x18, 0x80, 0x04, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*5BFA*/
const unsigned char  uc2_5BFB [] = {0x3F, 0xC0, 0x00, 0x40, 0x1F, 0xC0, 0x00, 0x40, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x80, 0x7F, 0xF0, 0x00, 0x80, 0x30, 0x80, 0x0B, 0x00, 0x00, 0x00 }; /*5BFB*/
const unsigned char  uc2_5BFC [] = {0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x20, 0x0F, 0xC0, 0x00, 0x80, 0x7F, 0xF0, 0x00, 0x80, 0x30, 0x80, 0x08, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*5BFC*/
const unsigned char  uc2_5BFF [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x17, 0xF0, 0x64, 0x40, 0x02, 0x40, 0x00, 0x80, 0x00, 0x00 }; /*5BFF*/
const unsigned char  uc2_5C01 [] = {0x08, 0x20, 0x3E, 0x20, 0x09, 0xF0, 0x7E, 0x20, 0x00, 0x20, 0x09, 0x20, 0x3E, 0xA0, 0x08, 0xA0, 0x0E, 0x20, 0x70, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*5C01*/
const unsigned char  uc2_5C04 [] = {0x08, 0x20, 0x3E, 0x20, 0x22, 0xF0, 0x3E, 0x20, 0x23, 0x20, 0x3E, 0xA0, 0x22, 0xA0, 0x7E, 0xA0, 0x0A, 0x20, 0x72, 0x20, 0x0C, 0xC0, 0x00, 0x00 }; /*5C04*/
const unsigned char  uc2_5C06 [] = {0x08, 0x80, 0x48, 0xF0, 0x2B, 0x90, 0x28, 0xE0, 0x0B, 0x80, 0x18, 0x20, 0x6B, 0xF0, 0x09, 0x20, 0x08, 0xA0, 0x08, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*5C06*/
const unsigned char  uc2_5C09 [] = {0x3F, 0x20, 0x21, 0x20, 0x3F, 0x20, 0x20, 0xF0, 0x2E, 0x20, 0x20, 0xA0, 0x3F, 0x60, 0x24, 0x20, 0x2E, 0x20, 0x35, 0x20, 0x4C, 0x40, 0x00, 0x00 }; /*5C09*/
const unsigned char  uc2_5C0A [] = {0x10, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x28, 0xA0, 0x37, 0x60, 0x20, 0x20, 0x7F, 0xF0, 0x00, 0x40, 0x18, 0x40, 0x05, 0x80, 0x00, 0x00 }; /*5C0A*/
const unsigned char  uc2_5C0F [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x12, 0x40, 0x12, 0x20, 0x22, 0x20, 0x22, 0x10, 0x42, 0x10, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5C0F*/
const unsigned char  uc2_5C11 [] = {0x02, 0x00, 0x12, 0x40, 0x12, 0x20, 0x22, 0x20, 0x22, 0x10, 0x42, 0x50, 0x02, 0x40, 0x00, 0x80, 0x03, 0x00, 0x0C, 0x00, 0x70, 0x00, 0x00, 0x00 }; /*5C11*/
const unsigned char  uc2_5C14 [] = {0x10, 0x00, 0x1F, 0xE0, 0x20, 0x20, 0x22, 0x40, 0x42, 0x00, 0x12, 0x80, 0x12, 0x40, 0x22, 0x20, 0x42, 0x20, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*5C14*/
const unsigned char  uc2_5C15 [] = {0x3F, 0x80, 0x08, 0x80, 0x09, 0xF0, 0x10, 0x10, 0x62, 0x60, 0x02, 0x00, 0x0A, 0xC0, 0x12, 0x20, 0x62, 0x10, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*5C15*/
const unsigned char  uc2_5C16 [] = {0x02, 0x00, 0x0A, 0xC0, 0x12, 0x20, 0x62, 0x10, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*5C16*/
const unsigned char  uc2_5C18 [] = {0x02, 0x00, 0x0A, 0xC0, 0x12, 0x20, 0x62, 0x10, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5C18*/
const unsigned char  uc2_5C1A [] = {0x22, 0x20, 0x12, 0x20, 0x12, 0x40, 0x3F, 0xE0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*5C1A*/
const unsigned char  uc2_5C1C [] = {0x02, 0x00, 0x0A, 0xE0, 0x72, 0x10, 0x00, 0x00, 0x02, 0x00, 0x7F, 0xF8, 0x08, 0x80, 0x72, 0x70, 0x02, 0x00, 0x12, 0xC0, 0x6C, 0x20, 0x00, 0x00 }; /*5C1C*/
const unsigned char  uc2_5C1D [] = {0x12, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x00, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x08, 0x80, 0x11, 0xC0, 0x1E, 0x40, 0x00, 0x00 }; /*5C1D*/
const unsigned char  uc2_5C22 [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x3F, 0xE0, 0x05, 0x00, 0x05, 0x00, 0x05, 0x00, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5C22*/
const unsigned char  uc2_5C24 [] = {0x04, 0x00, 0x05, 0x80, 0x04, 0x40, 0x3F, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x05, 0x00, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5C24*/
const unsigned char  uc2_5C25 [] = {0x21, 0x00, 0x21, 0x00, 0x7D, 0xE0, 0x29, 0x20, 0x2A, 0x20, 0x29, 0x20, 0x29, 0x20, 0x28, 0x20, 0x28, 0xD0, 0x48, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*5C25*/
const unsigned char  uc2_5C27 [] = {0x04, 0xE0, 0x3F, 0x00, 0x04, 0x80, 0x03, 0x20, 0x1C, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x05, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*5C27*/
const unsigned char  uc2_5C2C [] = {0x20, 0x80, 0x21, 0x40, 0x7E, 0x30, 0x29, 0x40, 0x29, 0x40, 0x29, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x28, 0x10, 0x48, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*5C2C*/
const unsigned char  uc2_5C31 [] = {0x11, 0x40, 0x7D, 0x20, 0x01, 0x00, 0x3B, 0xF0, 0x29, 0x40, 0x39, 0x40, 0x11, 0x40, 0x39, 0x40, 0x55, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*5C31*/
const unsigned char  uc2_5C34 [] = {0x25, 0x40, 0x25, 0x70, 0x7D, 0xA0, 0x29, 0x10, 0x28, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2F, 0xF0, 0x28, 0x10, 0x48, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*5C34*/
const unsigned char  uc2_5C38 [] = {0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*5C38*/
const unsigned char  uc2_5C39 [] = {0x1F, 0xC0, 0x02, 0x40, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x02, 0x40, 0x1F, 0xC0, 0x04, 0x40, 0x04, 0x00, 0x08, 0x00, 0x70, 0x00, 0x00, 0x00 }; /*5C39*/
const unsigned char  uc2_5C3A [] = {0x0F, 0xE0, 0x08, 0x20, 0x08, 0x20, 0x08, 0x20, 0x0F, 0xE0, 0x09, 0x00, 0x09, 0x00, 0x10, 0x80, 0x10, 0x80, 0x20, 0x40, 0x40, 0x30, 0x00, 0x00 }; /*5C3A*/
const unsigned char  uc2_5C3B [] = {0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x22, 0x50, 0x24, 0x50, 0x58, 0x20, 0x00, 0x00 }; /*5C3B*/
const unsigned char  uc2_5C3C [] = {0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x14, 0x20, 0x14, 0xC0, 0x17, 0x10, 0x24, 0x10, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*5C3C*/
const unsigned char  uc2_5C3D [] = {0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x11, 0x00, 0x10, 0x80, 0x16, 0x40, 0x21, 0x30, 0x2C, 0x80, 0x43, 0x00, 0x00, 0x80, 0x00, 0x00 }; /*5C3D*/
const unsigned char  uc2_5C3E [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x40, 0x17, 0x80, 0x11, 0x20, 0x17, 0xC0, 0x11, 0x30, 0x2F, 0xC0, 0x21, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*5C3E*/
const unsigned char  uc2_5C3F [] = {0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x10, 0x90, 0x16, 0x90, 0x12, 0xE0, 0x12, 0xA0, 0x24, 0xA0, 0x28, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*5C3F*/
const unsigned char  uc2_5C40 [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x17, 0x90, 0x14, 0x90, 0x27, 0x90, 0x24, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*5C40*/
const unsigned char  uc2_5C41 [] = {0x1F, 0xF0, 0x10, 0x10, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x14, 0x80, 0x14, 0x90, 0x17, 0xE0, 0x24, 0x90, 0x25, 0x90, 0x46, 0x60, 0x00, 0x00 }; /*5C41*/
const unsigned char  uc2_5C42 [] = {0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x13, 0xC0, 0x10, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x22, 0x20, 0x24, 0xD0, 0x47, 0x10, 0x00, 0x00 }; /*5C42*/
const unsigned char  uc2_5C45 [] = {0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*5C45*/
const unsigned char  uc2_5C48 [] = {0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x80, 0x12, 0xA0, 0x12, 0xA0, 0x13, 0xE0, 0x14, 0x90, 0x24, 0x90, 0x27, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5C48*/
const unsigned char  uc2_5C49 [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x11, 0x40, 0x15, 0x40, 0x1F, 0xF0, 0x15, 0x40, 0x25, 0xC0, 0x24, 0x00, 0x47, 0xE0, 0x00, 0x00 }; /*5C49*/
const unsigned char  uc2_5C4A [] = {0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*5C4A*/
const unsigned char  uc2_5C4B [] = {0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x11, 0x40, 0x13, 0xA0, 0x10, 0x80, 0x23, 0xE0, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*5C4B*/
const unsigned char  uc2_5C4E [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x20, 0x00, 0x29, 0x20, 0x25, 0x40, 0x3F, 0xF0, 0x23, 0x80, 0x25, 0x40, 0x59, 0x30, 0x41, 0x00, 0x00, 0x00 }; /*5C4E*/
const unsigned char  uc2_5C4F [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x24, 0x20, 0x22, 0x40, 0x27, 0xE0, 0x22, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x44, 0x40, 0x48, 0x40, 0x00, 0x00 }; /*5C4F*/
const unsigned char  uc2_5C50 [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x24, 0x80, 0x3B, 0xF0, 0x24, 0x80, 0x3B, 0xE0, 0x2A, 0x20, 0x29, 0x40, 0x48, 0x80, 0x4B, 0x70, 0x00, 0x00 }; /*5C50*/
const unsigned char  uc2_5C51 [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x25, 0x40, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*5C51*/
const unsigned char  uc2_5C55 [] = {0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x12, 0x40, 0x17, 0xE0, 0x12, 0x40, 0x1F, 0xF0, 0x14, 0xA0, 0x24, 0xA0, 0x25, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*5C55*/
const unsigned char  uc2_5C59 [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xF0, 0x2A, 0x20, 0x2D, 0xA0, 0x2A, 0xA0, 0x2B, 0xA0, 0x4E, 0xA0, 0x48, 0x40, 0x00, 0x00 }; /*5C59*/
const unsigned char  uc2_5C5E [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x20, 0x20, 0x2F, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x3F, 0xF0, 0x51, 0x50, 0x57, 0xD0, 0x00, 0x00 }; /*5C5E*/
const unsigned char  uc2_5C60 [] = {0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x21, 0x20, 0x27, 0xA0, 0x21, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x2F, 0xC0, 0x54, 0x40, 0x47, 0xC0, 0x00, 0x00 }; /*5C60*/
const unsigned char  uc2_5C61 [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x25, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x29, 0x20, 0x3F, 0xF0, 0x24, 0x40, 0x43, 0xA0, 0x5C, 0x10, 0x00, 0x00 }; /*5C61*/
const unsigned char  uc2_5C63 [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x28, 0x40, 0x29, 0x60, 0x35, 0x40, 0x2B, 0xF0, 0x39, 0x40, 0x29, 0x60, 0x4A, 0xC0, 0x4C, 0x70, 0x00, 0x00 }; /*5C63*/
const unsigned char  uc2_5C65 [] = {0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xF0, 0x29, 0x20, 0x33, 0xE0, 0x25, 0x20, 0x39, 0xE0, 0x29, 0x20, 0x2A, 0xA0, 0x48, 0xC0, 0x4B, 0x30, 0x00, 0x00 }; /*5C65*/
const unsigned char  uc2_5C66 [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x2A, 0xA0, 0x2F, 0xF0, 0x32, 0xA0, 0x2C, 0x90, 0x3F, 0xF0, 0x2A, 0x20, 0x49, 0xC0, 0x4E, 0x30, 0x00, 0x00 }; /*5C66*/
const unsigned char  uc2_5C6F [] = {0x04, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x90, 0x04, 0x90, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*5C6F*/
const unsigned char  uc2_5C71 [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*5C71*/
const unsigned char  uc2_5C79 [] = {0x10, 0x80, 0x10, 0xF0, 0x55, 0x00, 0x56, 0x00, 0x55, 0xE0, 0x54, 0x20, 0x54, 0x40, 0x5C, 0x80, 0x65, 0x10, 0x01, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5C79*/
const unsigned char  uc2_5C7A [] = {0x13, 0xE0, 0x10, 0x20, 0x54, 0x20, 0x54, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x55, 0x00, 0x5D, 0x10, 0x65, 0x10, 0x01, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5C7A*/
const unsigned char  uc2_5C7F [] = {0x10, 0x80, 0x10, 0x80, 0x54, 0xF0, 0x54, 0x80, 0x55, 0x00, 0x55, 0xF0, 0x54, 0x10, 0x57, 0xD0, 0x5C, 0x10, 0x64, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5C7F*/
const unsigned char  uc2_5C80 [] = {0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*5C80*/
const unsigned char  uc2_5C81 [] = {0x01, 0x00, 0x11, 0x10, 0x11, 0x10, 0x1F, 0xF0, 0x02, 0x00, 0x03, 0xE0, 0x04, 0x20, 0x3A, 0x40, 0x01, 0x80, 0x06, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*5C81*/
const unsigned char  uc2_5C82 [] = {0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xC0, 0x00, 0x40, 0x3F, 0xC0, 0x20, 0x50, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*5C82*/
const unsigned char  uc2_5C88 [] = {0x11, 0xF0, 0x10, 0xA0, 0x54, 0xA0, 0x55, 0x20, 0x55, 0xF0, 0x54, 0x60, 0x54, 0xA0, 0x5C, 0xA0, 0x65, 0x20, 0x02, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*5C88*/
const unsigned char  uc2_5C8C [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x3F, 0x80, 0x08, 0x80, 0x09, 0xE0, 0x0C, 0x20, 0x12, 0x40, 0x61, 0x80, 0x1E, 0x70, 0x00, 0x00 }; /*5C8C*/
const unsigned char  uc2_5C8D [] = {0x10, 0x00, 0x13, 0xE0, 0x55, 0x40, 0x55, 0x40, 0x55, 0x40, 0x57, 0xF0, 0x55, 0x40, 0x5D, 0x40, 0x65, 0x40, 0x02, 0x40, 0x0C, 0x40, 0x00, 0x00 }; /*5C8D*/
const unsigned char  uc2_5C90 [] = {0x10, 0x40, 0x13, 0xF0, 0x54, 0x40, 0x54, 0x40, 0x55, 0xE0, 0x54, 0xA0, 0x54, 0xA0, 0x5C, 0x40, 0x64, 0xA0, 0x00, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*5C90*/
const unsigned char  uc2_5C91 [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x05, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x1F, 0xC0, 0x00, 0x40, 0x01, 0x80, 0x0E, 0x00, 0x00, 0x00 }; /*5C91*/
const unsigned char  uc2_5C94 [] = {0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x04, 0x80, 0x08, 0x80, 0x33, 0x00, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*5C94*/
const unsigned char  uc2_5C96 [] = {0x11, 0xF0, 0x11, 0x00, 0x55, 0x90, 0x55, 0x50, 0x55, 0x50, 0x55, 0x20, 0x55, 0x50, 0x5D, 0x50, 0x65, 0x90, 0x01, 0x00, 0x01, 0xF0, 0x00, 0x00 }; /*5C96*/
const unsigned char  uc2_5C97 [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x2D, 0x20, 0x22, 0x20, 0x25, 0x20, 0x39, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*5C97*/
const unsigned char  uc2_5C98 [] = {0x11, 0xF0, 0x11, 0x10, 0x55, 0x50, 0x55, 0x50, 0x55, 0x50, 0x55, 0x50, 0x5D, 0x50, 0x64, 0xC0, 0x00, 0xD0, 0x03, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*5C98*/
const unsigned char  uc2_5C99 [] = {0x00, 0xC0, 0x1F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x70, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*5C99*/
const unsigned char  uc2_5C9A [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x15, 0x40, 0x12, 0x40, 0x25, 0x50, 0x29, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*5C9A*/
const unsigned char  uc2_5C9B [] = {0x04, 0x00, 0x08, 0x00, 0x3F, 0xC0, 0x20, 0x40, 0x2C, 0x40, 0x22, 0x80, 0x3F, 0xF0, 0x08, 0x10, 0x49, 0x10, 0x7F, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*5C9B*/
const unsigned char  uc2_5C9C [] = {0x02, 0x00, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*5C9C*/
const unsigned char  uc2_5CA2 [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x20, 0x1F, 0x20, 0x11, 0x20, 0x1F, 0x20, 0x11, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*5CA2*/
const unsigned char  uc2_5CA3 [] = {0x11, 0x00, 0x11, 0x00, 0x55, 0xF0, 0x56, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x55, 0x50, 0x5D, 0xD0, 0x65, 0x50, 0x00, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*5CA3*/
const unsigned char  uc2_5CA9 [] = {0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x00, 0x00 }; /*5CA9*/
const unsigned char  uc2_5CAB [] = {0x10, 0x40, 0x10, 0x40, 0x54, 0x40, 0x55, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x55, 0xF0, 0x5D, 0x50, 0x65, 0x50, 0x01, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*5CAB*/
const unsigned char  uc2_5CAC [] = {0x10, 0x00, 0x11, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x55, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x5D, 0xF0, 0x65, 0x50, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*5CAC*/
const unsigned char  uc2_5CAD [] = {0x10, 0x40, 0x10, 0x40, 0x54, 0xA0, 0x57, 0x10, 0x54, 0xC0, 0x54, 0x20, 0x55, 0xF0, 0x54, 0x10, 0x5D, 0xA0, 0x64, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*5CAD*/
const unsigned char  uc2_5CB1 [] = {0x12, 0x80, 0x12, 0x40, 0x21, 0xF0, 0x6F, 0x00, 0x20, 0x90, 0x20, 0x60, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*5CB1*/
const unsigned char  uc2_5CB3 [] = {0x00, 0xE0, 0x3F, 0x00, 0x20, 0x00, 0x3F, 0xE0, 0x21, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*5CB3*/
const unsigned char  uc2_5CB5 [] = {0x10, 0x80, 0x10, 0x80, 0x54, 0x80, 0x57, 0xF0, 0x54, 0x80, 0x54, 0x80, 0x55, 0xE0, 0x5D, 0x20, 0x65, 0x20, 0x01, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*5CB5*/
const unsigned char  uc2_5CB7 [] = {0x11, 0xF0, 0x11, 0x10, 0x55, 0x10, 0x55, 0xF0, 0x55, 0x40, 0x55, 0x40, 0x55, 0xF0, 0x5D, 0x40, 0x65, 0x50, 0x01, 0xD0, 0x01, 0x20, 0x00, 0x00 }; /*5CB7*/
const unsigned char  uc2_5CB8 [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x41, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*5CB8*/
const unsigned char  uc2_5CBD [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x12, 0xC0, 0x6C, 0x20, 0x00, 0x00 }; /*5CBD*/
const unsigned char  uc2_5CBF [] = {0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x0B, 0xF0, 0x48, 0x10, 0x49, 0xF0, 0x48, 0x10, 0x13, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*5CBF*/
const unsigned char  uc2_5CC1 [] = {0x02, 0x00, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x00, 0x0C, 0x00, 0x71, 0xF0, 0x45, 0x10, 0x4D, 0x10, 0x75, 0x60, 0x09, 0x00, 0x71, 0x00, 0x00, 0x00 }; /*5CC1*/
const unsigned char  uc2_5CC4 [] = {0x13, 0xE0, 0x11, 0x20, 0x54, 0xC0, 0x57, 0x30, 0x54, 0x80, 0x54, 0x80, 0x55, 0xE0, 0x5C, 0x80, 0x67, 0xF0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*5CC4*/
const unsigned char  uc2_5CCB [] = {0x11, 0x00, 0x11, 0xF0, 0x56, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x55, 0xD0, 0x5D, 0x50, 0x65, 0xD0, 0x05, 0x50, 0x00, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*5CCB*/
const unsigned char  uc2_5CD2 [] = {0x11, 0xF0, 0x11, 0x10, 0x55, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x55, 0x50, 0x55, 0xB0, 0x5D, 0xB0, 0x65, 0x50, 0x01, 0x10, 0x01, 0x20, 0x00, 0x00 }; /*5CD2*/
const unsigned char  uc2_5CD9 [] = {0x10, 0x80, 0x11, 0xE0, 0x54, 0x80, 0x57, 0xF0, 0x54, 0x00, 0x54, 0x40, 0x55, 0xE0, 0x5D, 0x40, 0x64, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x00, 0x00 }; /*5CD9*/
const unsigned char  uc2_5CE1 [] = {0x10, 0x80, 0x11, 0xE0, 0x54, 0x80, 0x56, 0xA0, 0x55, 0xA0, 0x54, 0xC0, 0x57, 0xF0, 0x5C, 0x80, 0x65, 0x40, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*5CE1*/
const unsigned char  uc2_5CE4 [] = {0x10, 0x60, 0x13, 0x80, 0x54, 0x80, 0x57, 0xF0, 0x54, 0x80, 0x55, 0x40, 0x56, 0x30, 0x5D, 0x40, 0x65, 0x40, 0x02, 0x40, 0x0C, 0x40, 0x00, 0x00 }; /*5CE4*/
const unsigned char  uc2_5CE5 [] = {0x11, 0x00, 0x11, 0xE0, 0x55, 0x20, 0x56, 0x40, 0x55, 0xE0, 0x54, 0xA0, 0x57, 0xF0, 0x5C, 0xA0, 0x65, 0xE0, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*5CE5*/
const unsigned char  uc2_5CE6 [] = {0x02, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x29, 0x20, 0x29, 0x10, 0x49, 0x10, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*5CE6*/
const unsigned char  uc2_5CE8 [] = {0x10, 0x80, 0x13, 0x60, 0x55, 0x50, 0x55, 0x40, 0x57, 0xF0, 0x55, 0x40, 0x55, 0xD0, 0x57, 0x50, 0x5D, 0x60, 0x65, 0x50, 0x02, 0xA0, 0x00, 0x00 }; /*5CE8*/
const unsigned char  uc2_5CEA [] = {0x10, 0x20, 0x11, 0x20, 0x55, 0x10, 0x56, 0x10, 0x54, 0xC0, 0x55, 0x20, 0x56, 0x10, 0x5D, 0xE0, 0x65, 0x20, 0x01, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*5CEA*/
const unsigned char  uc2_5CED [] = {0x12, 0x50, 0x11, 0x50, 0x54, 0x60, 0x55, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x5D, 0xF0, 0x65, 0x10, 0x01, 0x10, 0x01, 0x60, 0x00, 0x00 }; /*5CED*/
const unsigned char  uc2_5CF0 [] = {0x11, 0xE0, 0x13, 0x20, 0x54, 0xC0, 0x57, 0x30, 0x54, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x5D, 0xC0, 0x64, 0x80, 0x07, 0xF0, 0x00, 0x80, 0x00, 0x00 }; /*5CF0*/
const unsigned char  uc2_5CFB [] = {0x10, 0x80, 0x10, 0xA0, 0x55, 0x30, 0x55, 0xD0, 0x54, 0xA0, 0x57, 0x10, 0x54, 0x90, 0x5C, 0xE0, 0x65, 0xA0, 0x00, 0x40, 0x03, 0xB0, 0x00, 0x00 }; /*5CFB*/
const unsigned char  uc2_5D02 [] = {0x11, 0x20, 0x13, 0xF0, 0x55, 0x20, 0x57, 0xF0, 0x54, 0x10, 0x54, 0x80, 0x57, 0xE0, 0x5C, 0xA0, 0x65, 0x20, 0x01, 0x20, 0x06, 0xC0, 0x00, 0x00 }; /*5D02*/
const unsigned char  uc2_5D03 [] = {0x10, 0x80, 0x13, 0xF0, 0x54, 0xA0, 0x56, 0xA0, 0x55, 0xC0, 0x57, 0xF0, 0x54, 0x80, 0x5D, 0xC0, 0x66, 0xA0, 0x02, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*5D03*/
const unsigned char  uc2_5D06 [] = {0x10, 0x80, 0x10, 0x40, 0x55, 0xF0, 0x55, 0x10, 0x54, 0xA0, 0x54, 0x90, 0x55, 0x10, 0x5C, 0xE0, 0x64, 0x40, 0x00, 0x40, 0x01, 0xF0, 0x00, 0x00 }; /*5D06*/
const unsigned char  uc2_5D07 [] = {0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x1F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x60, 0x6C, 0x10, 0x00, 0x00 }; /*5D07*/
const unsigned char  uc2_5D0E [] = {0x10, 0x40, 0x13, 0xF0, 0x54, 0xA0, 0x55, 0x10, 0x57, 0xF0, 0x54, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x5D, 0xD0, 0x65, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*5D0E*/
const unsigned char  uc2_5D14 [] = {0x22, 0x20, 0x3F, 0xE0, 0x12, 0x00, 0x3F, 0xF0, 0x62, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*5D14*/
const unsigned char  uc2_5D16 [] = {0x11, 0x20, 0x11, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x41, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*5D16*/
const unsigned char  uc2_5D1B [] = {0x10, 0x00, 0x17, 0xF0, 0x54, 0x10, 0x57, 0xF0, 0x54, 0x40, 0x55, 0x50, 0x55, 0xF0, 0x5C, 0x40, 0x65, 0x50, 0x09, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*5D1B*/
const unsigned char  uc2_5D1E [] = {0x10, 0x40, 0x13, 0xF0, 0x55, 0x20, 0x55, 0xE0, 0x54, 0x00, 0x55, 0xE0, 0x54, 0x20, 0x5C, 0x40, 0x67, 0xF0, 0x00, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*5D1E*/
const unsigned char  uc2_5D24 [] = {0x11, 0x20, 0x10, 0xC0, 0x55, 0x20, 0x54, 0x80, 0x57, 0xF0, 0x55, 0x00, 0x57, 0xE0, 0x5D, 0x20, 0x65, 0xE0, 0x01, 0x20, 0x01, 0x60, 0x00, 0x00 }; /*5D24*/
const unsigned char  uc2_5D26 [] = {0x11, 0x00, 0x1F, 0xE0, 0x12, 0x80, 0x55, 0x40, 0x57, 0xF0, 0x55, 0x40, 0x57, 0xC0, 0x5D, 0x40, 0x67, 0xC0, 0x01, 0x10, 0x00, 0xF0, 0x00, 0x00 }; /*5D26*/
const unsigned char  uc2_5D27 [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x11, 0x20, 0x7D, 0x10, 0x12, 0x90, 0x38, 0x80, 0x55, 0x20, 0x12, 0x50, 0x13, 0x90, 0x00, 0x00 }; /*5D27*/
const unsigned char  uc2_5D29 [] = {0x01, 0x00, 0x11, 0x10, 0x1F, 0xF0, 0x00, 0x00, 0x1E, 0xF0, 0x12, 0x90, 0x1E, 0xF0, 0x12, 0x90, 0x1E, 0xF0, 0x22, 0x90, 0x4D, 0x60, 0x00, 0x00 }; /*5D29*/
const unsigned char  uc2_5D2D [] = {0x21, 0x10, 0x3F, 0xF0, 0x08, 0x00, 0x7C, 0x30, 0x10, 0xC0, 0x28, 0x80, 0x3C, 0xF0, 0x08, 0xA0, 0x1E, 0xA0, 0x69, 0x20, 0x09, 0x20, 0x00, 0x00 }; /*5D2D*/
const unsigned char  uc2_5D2E [] = {0x42, 0x10, 0x7F, 0xF0, 0x00, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*5D2E*/
const unsigned char  uc2_5D34 [] = {0x21, 0x10, 0x3F, 0xF0, 0x00, 0xA0, 0x3F, 0xF0, 0x20, 0x80, 0x3E, 0x80, 0x28, 0xA0, 0x3E, 0xA0, 0x2A, 0x50, 0x44, 0x50, 0x5A, 0xA0, 0x00, 0x00 }; /*5D34*/
const unsigned char  uc2_5D3D [] = {0x42, 0x10, 0x7F, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x04, 0x00, 0x52, 0x50, 0x4F, 0x90, 0x00, 0x00 }; /*5D3D*/
const unsigned char  uc2_5D3E [] = {0x17, 0xF0, 0x11, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x54, 0x80, 0x57, 0xF0, 0x5D, 0x20, 0x64, 0xC0, 0x01, 0x20, 0x06, 0x10, 0x00, 0x00 }; /*5D3E*/
const unsigned char  uc2_5D47 [] = {0x0C, 0xA0, 0x73, 0xF0, 0x10, 0xC0, 0x7D, 0x50, 0x11, 0x50, 0x32, 0x20, 0x38, 0x80, 0x56, 0xA0, 0x52, 0xA0, 0x13, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*5D47*/
const unsigned char  uc2_5D4A [] = {0x10, 0x20, 0x13, 0xC0, 0x54, 0x80, 0x57, 0xF0, 0x54, 0xA0, 0x56, 0xB0, 0x55, 0xA0, 0x5E, 0xB0, 0x65, 0xC0, 0x02, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*5D4A*/
const unsigned char  uc2_5D4B [] = {0x11, 0xF0, 0x11, 0x50, 0x55, 0xF0, 0x55, 0x00, 0x55, 0x70, 0x55, 0x50, 0x55, 0x70, 0x5D, 0x50, 0x65, 0x70, 0x02, 0x50, 0x02, 0x70, 0x00, 0x00 }; /*5D4B*/
const unsigned char  uc2_5D4C [] = {0x22, 0x10, 0x3F, 0xF0, 0x00, 0x00, 0x24, 0x80, 0x7E, 0xF0, 0x25, 0x10, 0x26, 0x50, 0x3C, 0x40, 0x24, 0xA0, 0x3C, 0xA0, 0x23, 0x10, 0x00, 0x00 }; /*5D4C*/
const unsigned char  uc2_5D58 [] = {0x11, 0x20, 0x13, 0xF0, 0x55, 0x20, 0x57, 0xF0, 0x54, 0x10, 0x54, 0x40, 0x57, 0xF0, 0x5C, 0x40, 0x64, 0xE0, 0x03, 0x50, 0x00, 0x40, 0x00, 0x00 }; /*5D58*/
const unsigned char  uc2_5D5B [] = {0x42, 0x10, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x00, 0x3E, 0x20, 0x22, 0xA0, 0x3E, 0xA0, 0x22, 0xA0, 0x26, 0x60, 0x00, 0x00 }; /*5D5B*/
const unsigned char  uc2_5D5D [] = {0x10, 0x00, 0x14, 0x90, 0x52, 0xA0, 0x57, 0xF0, 0x52, 0xA0, 0x54, 0x90, 0x51, 0x00, 0x5F, 0xF0, 0x62, 0x20, 0x01, 0xC0, 0x06, 0x30, 0x00, 0x00 }; /*5D5D*/
const unsigned char  uc2_5D69 [] = {0x42, 0x10, 0x7F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*5D69*/
const unsigned char  uc2_5D6B [] = {0x12, 0x10, 0x11, 0x20, 0x13, 0xF0, 0x54, 0x00, 0x55, 0x20, 0x56, 0xD0, 0x55, 0x20, 0x5D, 0x20, 0x66, 0xD0, 0x03, 0x70, 0x00, 0x10, 0x00, 0x00 }; /*5D6B*/
const unsigned char  uc2_5D6C [] = {0x42, 0x20, 0x7F, 0xE0, 0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0xC0, 0x3F, 0xA0, 0x06, 0xD0, 0x1A, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*5D6C*/
const unsigned char  uc2_5D6F [] = {0x12, 0x20, 0x11, 0x40, 0x57, 0xF0, 0x54, 0x80, 0x55, 0xE0, 0x54, 0x80, 0x57, 0xF0, 0x5D, 0x00, 0x66, 0xE0, 0x04, 0x40, 0x03, 0xF0, 0x00, 0x00 }; /*5D6F*/
const unsigned char  uc2_5D74 [] = {0x12, 0xA0, 0x12, 0xB0, 0x55, 0x40, 0x56, 0x30, 0x55, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x5D, 0x20, 0x65, 0xE0, 0x01, 0x20, 0x01, 0x40, 0x00, 0x00 }; /*5D74*/
const unsigned char  uc2_5D82 [] = {0x10, 0x40, 0x11, 0xF0, 0x54, 0xA0, 0x57, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x5D, 0xF0, 0x64, 0x40, 0x01, 0xF0, 0x00, 0x40, 0x00, 0x00 }; /*5D82*/
const unsigned char  uc2_5D99 [] = {0x11, 0x50, 0x13, 0xF0, 0x55, 0x60, 0x55, 0x50, 0x56, 0x40, 0x55, 0x20, 0x55, 0xF0, 0x5E, 0xA0, 0x65, 0xA0, 0x02, 0xF0, 0x0C, 0x20, 0x00, 0x00 }; /*5D99*/
const unsigned char  uc2_5D9D [] = {0x10, 0x20, 0x13, 0xB0, 0x54, 0xA0, 0x57, 0x30, 0x55, 0xE0, 0x56, 0x10, 0x55, 0xE0, 0x5D, 0x20, 0x65, 0xE0, 0x00, 0xA0, 0x03, 0xF0, 0x00, 0x00 }; /*5D9D*/
const unsigned char  uc2_5DB7 [] = {0x42, 0x10, 0x7F, 0xF0, 0x20, 0x00, 0x39, 0xE0, 0x24, 0xA0, 0x18, 0x40, 0x23, 0xF0, 0x3C, 0x50, 0x51, 0x60, 0x7D, 0xC0, 0x2A, 0x30, 0x00, 0x00 }; /*5DB7*/
const unsigned char  uc2_5DC5 [] = {0x42, 0x10, 0x7F, 0xF0, 0x08, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x3D, 0xF0, 0x2D, 0x10, 0x35, 0x50, 0x7F, 0x50, 0x24, 0xA0, 0x43, 0x20, 0x00, 0x00 }; /*5DC5*/
const unsigned char  uc2_5DCD [] = {0x42, 0x20, 0x7F, 0xE0, 0x05, 0x00, 0x3B, 0xE0, 0x12, 0xA0, 0x7F, 0xE0, 0x2A, 0xA0, 0x57, 0xD0, 0x7D, 0x60, 0x29, 0x50, 0x76, 0x20, 0x00, 0x00 }; /*5DCD*/
const unsigned char  uc2_5DDD [] = {0x10, 0x10, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x21, 0x10, 0x20, 0x10, 0x40, 0x10, 0x00, 0x00 }; /*5DDD*/
const unsigned char  uc2_5DDE [] = {0x10, 0x10, 0x11, 0x10, 0x11, 0x10, 0x39, 0x90, 0x55, 0x50, 0x55, 0x50, 0x55, 0x50, 0x11, 0x10, 0x21, 0x10, 0x21, 0x10, 0x40, 0x10, 0x00, 0x00 }; /*5DDE*/
const unsigned char  uc2_5DE1 [] = {0x21, 0x50, 0x11, 0x50, 0x12, 0xA0, 0x02, 0xA0, 0x75, 0x40, 0x12, 0xA0, 0x12, 0xA0, 0x11, 0x50, 0x11, 0x50, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*5DE1*/
const unsigned char  uc2_5DE2 [] = {0x12, 0x40, 0x24, 0x80, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*5DE2*/
const unsigned char  uc2_5DE5 [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5DE5*/
const unsigned char  uc2_5DE6 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xF0, 0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x0F, 0xE0, 0x11, 0x00, 0x61, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*5DE6*/
const unsigned char  uc2_5DE7 [] = {0x07, 0xF0, 0x01, 0x00, 0x7D, 0x00, 0x11, 0x00, 0x12, 0x00, 0x13, 0xE0, 0x10, 0x20, 0x1C, 0x20, 0x60, 0x20, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*5DE7*/
const unsigned char  uc2_5DE8 [] = {0x00, 0x00, 0x7F, 0xE0, 0x40, 0x00, 0x40, 0x00, 0x7F, 0xC0, 0x40, 0x40, 0x40, 0x40, 0x7F, 0xC0, 0x40, 0x00, 0x40, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5DE8*/
const unsigned char  uc2_5DE9 [] = {0x03, 0xC0, 0x02, 0x40, 0x7A, 0x40, 0x13, 0x40, 0x12, 0xC0, 0x12, 0xC0, 0x1A, 0x40, 0x62, 0x50, 0x04, 0x50, 0x04, 0x50, 0x08, 0x20, 0x00, 0x00 }; /*5DE9*/
const unsigned char  uc2_5DEB [] = {0x7F, 0xF0, 0x02, 0x00, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x2A, 0xA0, 0x2A, 0x90, 0x43, 0x10, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*5DEB*/
const unsigned char  uc2_5DEE [] = {0x08, 0x40, 0x04, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x6F, 0xC0, 0x02, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*5DEE*/
const unsigned char  uc2_5DEF [] = {0x00, 0x80, 0x77, 0xF0, 0x11, 0x40, 0x2A, 0x60, 0x4B, 0xA0, 0x00, 0x00, 0x7A, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x62, 0xA0, 0x04, 0x10, 0x00, 0x00 }; /*5DEF*/
const unsigned char  uc2_5DF1 [] = {0x7F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x20, 0x00, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*5DF1*/
const unsigned char  uc2_5DF2 [] = {0x7F, 0xC0, 0x00, 0x40, 0x20, 0x40, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x20, 0x00, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*5DF2*/
const unsigned char  uc2_5DF3 [] = {0x3F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x20, 0x00, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*5DF3*/
const unsigned char  uc2_5DF4 [] = {0x00, 0x00, 0x7F, 0xC0, 0x44, 0x40, 0x44, 0x40, 0x44, 0x40, 0x7F, 0xC0, 0x40, 0x40, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x3F, 0xE0, 0x00, 0x00 }; /*5DF4*/
const unsigned char  uc2_5DF7 [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x08, 0x80, 0x0F, 0x90, 0x08, 0x10, 0x07, 0xE0, 0x00, 0x00 }; /*5DF7*/
const unsigned char  uc2_5DFD [] = {0x79, 0xE0, 0x49, 0x20, 0x79, 0xE0, 0x45, 0x10, 0x38, 0xE0, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x60, 0x20, 0x00, 0x00 }; /*5DFD*/
const unsigned char  uc2_5DFE [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5DFE*/
const unsigned char  uc2_5E01 [] = {0x01, 0xF0, 0x7E, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5E01*/
const unsigned char  uc2_5E02 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5E02*/
const unsigned char  uc2_5E03 [] = {0x02, 0x00, 0x3F, 0xF0, 0x04, 0x00, 0x09, 0x00, 0x1F, 0xE0, 0x69, 0x20, 0x09, 0x20, 0x09, 0x20, 0x09, 0x40, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*5E03*/
const unsigned char  uc2_5E05 [] = {0x10, 0x80, 0x10, 0x80, 0x50, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x54, 0x90, 0x14, 0xA0, 0x20, 0x80, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*5E05*/
const unsigned char  uc2_5E06 [] = {0x10, 0x00, 0x11, 0xC0, 0x7D, 0x40, 0x55, 0x40, 0x55, 0x40, 0x55, 0xC0, 0x55, 0x40, 0x59, 0x50, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*5E06*/
const unsigned char  uc2_5E08 [] = {0x10, 0x00, 0x17, 0xF0, 0x50, 0x80, 0x50, 0x80, 0x53, 0xE0, 0x52, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x22, 0xC0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*5E08*/
const unsigned char  uc2_5E0C [] = {0x0C, 0x40, 0x03, 0x80, 0x1C, 0x40, 0x04, 0x00, 0x3F, 0xF0, 0x09, 0x00, 0x1F, 0xE0, 0x69, 0x20, 0x09, 0x20, 0x09, 0x40, 0x01, 0x00, 0x00, 0x00 }; /*5E0C*/
const unsigned char  uc2_5E0F [] = {0x10, 0x40, 0x11, 0xF0, 0x7C, 0x40, 0x54, 0xE0, 0x54, 0x40, 0x55, 0xF0, 0x54, 0x50, 0x58, 0x50, 0x10, 0x60, 0x10, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*5E0F*/
const unsigned char  uc2_5E10 [] = {0x11, 0x20, 0x11, 0x20, 0x7D, 0x40, 0x55, 0x80, 0x57, 0xF0, 0x55, 0x40, 0x55, 0x40, 0x59, 0x40, 0x11, 0x20, 0x11, 0x60, 0x11, 0x90, 0x00, 0x00 }; /*5E10*/
const unsigned char  uc2_5E11 [] = {0x08, 0x00, 0x7D, 0xE0, 0x14, 0xA0, 0x38, 0xA0, 0x14, 0x40, 0x61, 0xB0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*5E11*/
const unsigned char  uc2_5E14 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x90, 0x54, 0x80, 0x57, 0xE0, 0x55, 0x20, 0x55, 0x20, 0x5D, 0x40, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*5E14*/
const unsigned char  uc2_5E15 [] = {0x10, 0x40, 0x10, 0x80, 0x7D, 0xF0, 0x55, 0x10, 0x55, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x59, 0x10, 0x11, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*5E15*/
const unsigned char  uc2_5E16 [] = {0x10, 0x40, 0x10, 0x40, 0x7C, 0x70, 0x54, 0x40, 0x54, 0x40, 0x55, 0xF0, 0x55, 0x10, 0x5D, 0x10, 0x11, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*5E16*/
const unsigned char  uc2_5E18 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x30, 0x40, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*5E18*/
const unsigned char  uc2_5E19 [] = {0x10, 0x40, 0x11, 0x40, 0x7D, 0xE0, 0x55, 0x40, 0x56, 0x40, 0x55, 0xF0, 0x54, 0x40, 0x58, 0xA0, 0x10, 0xA0, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*5E19*/
const unsigned char  uc2_5E1A [] = {0x1F, 0xC0, 0x00, 0x40, 0x0F, 0xC0, 0x00, 0x40, 0x7F, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x80, 0x02, 0x00, 0x00, 0x00 }; /*5E1A*/
const unsigned char  uc2_5E1B [] = {0x04, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x42, 0x60, 0x02, 0x00, 0x00, 0x00 }; /*5E1B*/
const unsigned char  uc2_5E1C [] = {0x10, 0x00, 0x11, 0xE0, 0x7D, 0x20, 0x55, 0x20, 0x55, 0x20, 0x55, 0x20, 0x55, 0xE0, 0x58, 0x00, 0x11, 0x20, 0x11, 0x10, 0x16, 0x10, 0x00, 0x00 }; /*5E1C*/
const unsigned char  uc2_5E1D [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x80, 0x02, 0x00, 0x00, 0x00 }; /*5E1D*/
const unsigned char  uc2_5E26 [] = {0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*5E26*/
const unsigned char  uc2_5E27 [] = {0x10, 0x40, 0x10, 0x70, 0x7C, 0x40, 0x55, 0xF0, 0x55, 0x10, 0x55, 0x50, 0x55, 0x50, 0x59, 0x40, 0x10, 0x60, 0x10, 0x90, 0x13, 0x10, 0x00, 0x00 }; /*5E27*/
const unsigned char  uc2_5E2D [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x29, 0x40, 0x41, 0x00, 0x00, 0x00 }; /*5E2D*/
const unsigned char  uc2_5E2E [] = {0x08, 0x00, 0x7E, 0xF0, 0x08, 0x90, 0x3E, 0xA0, 0x08, 0x90, 0x7E, 0x90, 0x12, 0xA0, 0x7F, 0xE0, 0x12, 0x20, 0x12, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*5E2E*/
const unsigned char  uc2_5E31 [] = {0x10, 0x80, 0x13, 0xE0, 0x7C, 0x80, 0x55, 0xC0, 0x54, 0x80, 0x57, 0xF0, 0x55, 0x20, 0x5B, 0xF0, 0x15, 0x20, 0x10, 0xA0, 0x10, 0xC0, 0x00, 0x00 }; /*5E31*/
const unsigned char  uc2_5E37 [] = {0x11, 0x80, 0x11, 0x40, 0x7D, 0xF0, 0x57, 0x40, 0x55, 0xE0, 0x55, 0x40, 0x55, 0x40, 0x59, 0xE0, 0x11, 0x40, 0x11, 0xF0, 0x11, 0x00, 0x00, 0x00 }; /*5E37*/
const unsigned char  uc2_5E38 [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x48, 0x90, 0x0F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*5E38*/
const unsigned char  uc2_5E3B [] = {0x10, 0x40, 0x11, 0xF0, 0x7C, 0x40, 0x54, 0xE0, 0x54, 0x40, 0x55, 0xF0, 0x55, 0x10, 0x59, 0x50, 0x11, 0x50, 0x10, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*5E3B*/
const unsigned char  uc2_5E3C [] = {0x17, 0xF0, 0x14, 0x10, 0x7F, 0xF0, 0x54, 0x90, 0x55, 0xD0, 0x54, 0xD0, 0x54, 0xB0, 0x5F, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*5E3C*/
const unsigned char  uc2_5E3D [] = {0x13, 0xF0, 0x12, 0x10, 0x12, 0xD0, 0x7E, 0x10, 0x55, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x5D, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x11, 0xE0, 0x00, 0x00 }; /*5E3D*/
const unsigned char  uc2_5E42 [] = {0x7F, 0xF0, 0x50, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x3F, 0xE0, 0x52, 0x50, 0x12, 0xC0, 0x00, 0x00 }; /*5E42*/
const unsigned char  uc2_5E44 [] = {0x17, 0xF0, 0x14, 0x10, 0x7F, 0xF0, 0x54, 0x00, 0x57, 0xF0, 0x55, 0x20, 0x57, 0xD0, 0x5C, 0x80, 0x17, 0xE0, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*5E44*/
const unsigned char  uc2_5E45 [] = {0x10, 0x00, 0x11, 0xF0, 0x7C, 0x00, 0x54, 0xE0, 0x54, 0xA0, 0x55, 0xF0, 0x55, 0x50, 0x59, 0xF0, 0x11, 0x50, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*5E45*/
const unsigned char  uc2_5E4C [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x57, 0xE0, 0x56, 0x20, 0x57, 0xE0, 0x5A, 0xA0, 0x17, 0xF0, 0x11, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x00, 0x00 }; /*5E4C*/
const unsigned char  uc2_5E54 [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x56, 0x20, 0x57, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x5A, 0x20, 0x11, 0x40, 0x10, 0x80, 0x17, 0x70, 0x00, 0x00 }; /*5E54*/
const unsigned char  uc2_5E55 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x22, 0x20, 0x5F, 0xD0, 0x12, 0x40, 0x00, 0x00 }; /*5E55*/
const unsigned char  uc2_5E5B [] = {0x10, 0x80, 0x13, 0xE0, 0x7D, 0x40, 0x57, 0xF0, 0x54, 0x20, 0x57, 0xE0, 0x54, 0x20, 0x5B, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*5E5B*/
const unsigned char  uc2_5E5E [] = {0x11, 0x40, 0x15, 0x50, 0x7F, 0xF0, 0x55, 0x40, 0x57, 0xE0, 0x54, 0x80, 0x55, 0xC0, 0x58, 0x80, 0x17, 0xF0, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*5E5E*/
const unsigned char  uc2_5E61 [] = {0x10, 0x20, 0x13, 0xC0, 0x7A, 0xA0, 0x57, 0xF0, 0x55, 0x40, 0x56, 0xA0, 0x57, 0xE0, 0x5A, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x00, 0x00 }; /*5E61*/
const unsigned char  uc2_5E62 [] = {0x10, 0x80, 0x13, 0xE0, 0x7D, 0x40, 0x54, 0x80, 0x57, 0xF0, 0x56, 0xA0, 0x57, 0xE0, 0x5A, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*5E62*/
const unsigned char  uc2_5E72 [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5E72*/
const unsigned char  uc2_5E73 [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x40, 0x0A, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5E73*/
const unsigned char  uc2_5E74 [] = {0x10, 0x00, 0x1F, 0xE0, 0x62, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5E74*/
const unsigned char  uc2_5E76 [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5E76*/
const unsigned char  uc2_5E78 [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x05, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*5E78*/
const unsigned char  uc2_5E7A [] = {0x04, 0x00, 0x04, 0x80, 0x08, 0x80, 0x11, 0x00, 0x1F, 0x00, 0x02, 0x00, 0x04, 0x00, 0x08, 0x80, 0x13, 0x40, 0x1C, 0x40, 0x00, 0x00, 0x00, 0x00 }; /*5E7A*/
const unsigned char  uc2_5E7B [] = {0x10, 0x00, 0x13, 0xF0, 0x24, 0x10, 0x44, 0x10, 0x78, 0x10, 0x08, 0x10, 0x14, 0x10, 0x22, 0x10, 0x4E, 0x10, 0x72, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*5E7B*/
const unsigned char  uc2_5E7C [] = {0x10, 0x40, 0x10, 0x40, 0x25, 0xF0, 0x44, 0x50, 0x78, 0x50, 0x08, 0x50, 0x14, 0x50, 0x26, 0x90, 0x4A, 0x90, 0x71, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*5E7C*/
const unsigned char  uc2_5E7D [] = {0x08, 0x40, 0x4A, 0x50, 0x52, 0x90, 0x56, 0xB0, 0x7B, 0xD0, 0x52, 0x90, 0x6B, 0x50, 0x77, 0xB0, 0x42, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*5E7D*/
const unsigned char  uc2_5E7F [] = {0x02, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*5E7F*/
const unsigned char  uc2_5E80 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x24, 0x00, 0x24, 0x60, 0x27, 0x80, 0x24, 0x00, 0x24, 0x10, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*5E80*/
const unsigned char  uc2_5E84 [] = {0x03, 0x00, 0x00, 0x80, 0x1F, 0xF0, 0x10, 0x00, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x20, 0x80, 0x27, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*5E84*/
const unsigned char  uc2_5E86 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x22, 0x80, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*5E86*/
const unsigned char  uc2_5E87 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x28, 0x80, 0x28, 0x90, 0x2E, 0xE0, 0x28, 0x80, 0x28, 0x90, 0x2A, 0x90, 0x4C, 0x60, 0x00, 0x00 }; /*5E87*/
const unsigned char  uc2_5E8A [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x3F, 0xF0, 0x23, 0x80, 0x25, 0x40, 0x25, 0x40, 0x39, 0x30, 0x41, 0x00, 0x00, 0x00 }; /*5E8A*/
const unsigned char  uc2_5E8B [] = {0x06, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x1F, 0xF0, 0x10, 0x80, 0x17, 0xE0, 0x12, 0x20, 0x21, 0x40, 0x20, 0x80, 0x4F, 0x70, 0x00, 0x00 }; /*5E8B*/
const unsigned char  uc2_5E8F [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x27, 0xC0, 0x21, 0x40, 0x2F, 0xF0, 0x20, 0x90, 0x20, 0xA0, 0x20, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*5E8F*/
const unsigned char  uc2_5E90 [] = {0x06, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x22, 0x00, 0x24, 0x00, 0x48, 0x00, 0x00, 0x00 }; /*5E90*/
const unsigned char  uc2_5E91 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xC0, 0x22, 0x00, 0x3F, 0xE0, 0x22, 0x80, 0x22, 0x90, 0x24, 0x90, 0x58, 0x60, 0x00, 0x00 }; /*5E91*/
const unsigned char  uc2_5E93 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0xF0, 0x22, 0x80, 0x27, 0xE0, 0x20, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*5E93*/
const unsigned char  uc2_5E94 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x22, 0x20, 0x29, 0x20, 0x25, 0x40, 0x24, 0x40, 0x20, 0x80, 0x2F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*5E94*/
const unsigned char  uc2_5E95 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x20, 0x2F, 0xC0, 0x29, 0x00, 0x2F, 0xF0, 0x29, 0x00, 0x2B, 0x10, 0x2C, 0x90, 0x43, 0x60, 0x00, 0x00 }; /*5E95*/
const unsigned char  uc2_5E96 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x24, 0x00, 0x27, 0xE0, 0x38, 0x20, 0x27, 0xA0, 0x24, 0xA0, 0x27, 0xA0, 0x24, 0x50, 0x43, 0xE0, 0x00, 0x00 }; /*5E96*/
const unsigned char  uc2_5E97 [] = {0x06, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x11, 0x00, 0x11, 0xF0, 0x11, 0x00, 0x17, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x44, 0x20, 0x00, 0x00 }; /*5E97*/
const unsigned char  uc2_5E99 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*5E99*/
const unsigned char  uc2_5E9A [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x27, 0xC0, 0x21, 0x40, 0x2F, 0xE0, 0x21, 0x40, 0x27, 0xC0, 0x22, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*5E9A*/
const unsigned char  uc2_5E9C [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x22, 0x20, 0x22, 0x20, 0x25, 0xF0, 0x2C, 0x20, 0x25, 0x20, 0x24, 0xA0, 0x24, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*5E9C*/
const unsigned char  uc2_5E9E [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x22, 0x40, 0x2F, 0xF0, 0x22, 0x80, 0x22, 0xA0, 0x22, 0xD0, 0x24, 0x90, 0x5B, 0x60, 0x00, 0x00 }; /*5E9E*/
const unsigned char  uc2_5E9F [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x29, 0x40, 0x2F, 0xE0, 0x22, 0x00, 0x23, 0xC0, 0x2E, 0x40, 0x21, 0x80, 0x4E, 0x60, 0x00, 0x00 }; /*5E9F*/
const unsigned char  uc2_5EA0 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x21, 0x00, 0x27, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*5EA0*/
const unsigned char  uc2_5EA5 [] = {0x06, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x15, 0xF0, 0x1C, 0x40, 0x14, 0xE0, 0x25, 0x50, 0x24, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*5EA5*/
const unsigned char  uc2_5EA6 [] = {0x01, 0x00, 0x3F, 0xF0, 0x22, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x23, 0xC0, 0x20, 0x00, 0x27, 0xE0, 0x22, 0x20, 0x21, 0xC0, 0x4E, 0x30, 0x00, 0x00 }; /*5EA6*/
const unsigned char  uc2_5EA7 [] = {0x02, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x25, 0x40, 0x25, 0x40, 0x2B, 0xA0, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*5EA7*/
const unsigned char  uc2_5EAD [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x20, 0x20, 0x2C, 0xC0, 0x24, 0x40, 0x28, 0xE0, 0x34, 0x40, 0x2D, 0xF0, 0x24, 0x00, 0x5B, 0xF0, 0x00, 0x00 }; /*5EAD*/
const unsigned char  uc2_5EB3 [] = {0x01, 0x00, 0x3F, 0xF0, 0x22, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x2A, 0x20, 0x2F, 0xE0, 0x39, 0x00, 0x2F, 0xF0, 0x41, 0x00, 0x00, 0x00 }; /*5EB3*/
const unsigned char  uc2_5EB5 [] = {0x02, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x3F, 0xF0, 0x25, 0x40, 0x2F, 0xE0, 0x35, 0x50, 0x27, 0xC0, 0x25, 0x50, 0x27, 0xD0, 0x40, 0xF0, 0x00, 0x00 }; /*5EB5*/
const unsigned char  uc2_5EB6 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x20, 0x00, 0x2A, 0xA0, 0x29, 0x50, 0x51, 0x50, 0x00, 0x00 }; /*5EB6*/
const unsigned char  uc2_5EB7 [] = {0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x27, 0xC0, 0x21, 0x40, 0x2F, 0xE0, 0x21, 0x40, 0x27, 0xC0, 0x29, 0x20, 0x25, 0x40, 0x5B, 0x30, 0x00, 0x00 }; /*5EB7*/
const unsigned char  uc2_5EB8 [] = {0x01, 0x00, 0x3F, 0xF0, 0x21, 0x40, 0x3F, 0xF0, 0x21, 0x40, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x49, 0x20, 0x00, 0x00 }; /*5EB8*/
const unsigned char  uc2_5EB9 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x22, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*5EB9*/
const unsigned char  uc2_5EBE [] = {0x01, 0x00, 0x3F, 0xF0, 0x25, 0x00, 0x29, 0x60, 0x29, 0x20, 0x2D, 0x60, 0x29, 0x20, 0x2F, 0xE0, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*5EBE*/
const unsigned char  uc2_5EC9 [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x40, 0x1F, 0xF0, 0x12, 0xA0, 0x1F, 0xF0, 0x12, 0xA0, 0x1F, 0xE0, 0x26, 0xC0, 0x3A, 0xB0, 0x42, 0x80, 0x00, 0x00 }; /*5EC9*/
const unsigned char  uc2_5ECA [] = {0x01, 0x00, 0x3F, 0xF0, 0x22, 0x00, 0x2F, 0x70, 0x29, 0x50, 0x2F, 0x60, 0x29, 0x50, 0x2F, 0x50, 0x2A, 0x60, 0x2B, 0x40, 0x4D, 0x40, 0x00, 0x00 }; /*5ECA*/
const unsigned char  uc2_5ED1 [] = {0x01, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x3F, 0xF0, 0x26, 0xC0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*5ED1*/
const unsigned char  uc2_5ED2 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0x70, 0x24, 0xD0, 0x2E, 0x50, 0x24, 0x50, 0x3F, 0x20, 0x2A, 0x20, 0x29, 0x50, 0x56, 0x90, 0x00, 0x00 }; /*5ED2*/
const unsigned char  uc2_5ED3 [] = {0x06, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x25, 0x50, 0x27, 0x60, 0x20, 0x50, 0x27, 0x50, 0x21, 0x50, 0x2F, 0xE0, 0x22, 0x40, 0x4C, 0x40, 0x00, 0x00 }; /*5ED3*/
const unsigned char  uc2_5ED6 [] = {0x01, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x26, 0x60, 0x2B, 0xA0, 0x24, 0xC0, 0x3A, 0x30, 0x25, 0x00, 0x22, 0x40, 0x21, 0x80, 0x4E, 0x00, 0x00, 0x00 }; /*5ED6*/
const unsigned char  uc2_5EDB [] = {0x01, 0x00, 0x3F, 0xF0, 0x25, 0x40, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x39, 0x30, 0x27, 0xC0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*5EDB*/
const unsigned char  uc2_5EE8 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x00, 0x4E, 0xF0, 0x52, 0x50, 0x7F, 0xB0, 0x55, 0x60, 0x5F, 0x70, 0x55, 0xA0, 0x5F, 0x70, 0x65, 0x20, 0x00, 0x00 }; /*5EE8*/
const unsigned char  uc2_5EEA [] = {0x01, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x2B, 0xA0, 0x28, 0x20, 0x2F, 0xE0, 0x20, 0x00, 0x3F, 0xF0, 0x25, 0x40, 0x29, 0x20, 0x46, 0x00, 0x00, 0x00 }; /*5EEA*/
const unsigned char  uc2_5EF6 [] = {0x00, 0x20, 0x3B, 0xC0, 0x08, 0x80, 0x12, 0x80, 0x3A, 0xE0, 0x0A, 0x80, 0x2A, 0x80, 0x2B, 0xE0, 0x28, 0x00, 0x18, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*5EF6*/
const unsigned char  uc2_5EF7 [] = {0x00, 0x60, 0x3B, 0x80, 0x08, 0x80, 0x10, 0x80, 0x3B, 0xE0, 0x08, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x28, 0x00, 0x18, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*5EF7*/
const unsigned char  uc2_5EFA [] = {0x00, 0x80, 0x3B, 0xE0, 0x08, 0xA0, 0x17, 0xF0, 0x38, 0xA0, 0x0B, 0xE0, 0x28, 0xC0, 0x29, 0x80, 0x2F, 0xF0, 0x18, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*5EFA*/
const unsigned char  uc2_5EFF [] = {0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*5EFF*/
const unsigned char  uc2_5F00 [] = {0x00, 0x00, 0x1F, 0xE0, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x3F, 0xF0, 0x04, 0x80, 0x04, 0x80, 0x04, 0x80, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*5F00*/
const unsigned char  uc2_5F01 [] = {0x04, 0x00, 0x08, 0x80, 0x13, 0xC0, 0x1C, 0x40, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5F01*/
const unsigned char  uc2_5F02 [] = {0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xD0, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5F02*/
const unsigned char  uc2_5F03 [] = {0x04, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x40, 0x1E, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*5F03*/
const unsigned char  uc2_5F04 [] = {0x1F, 0xC0, 0x02, 0x00, 0x0F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5F04*/
const unsigned char  uc2_5F08 [] = {0x02, 0x00, 0x7F, 0xF0, 0x15, 0x40, 0x65, 0x20, 0x09, 0x00, 0x72, 0x00, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*5F08*/
const unsigned char  uc2_5F0A [] = {0x55, 0x00, 0x7D, 0xF0, 0x57, 0x20, 0x7D, 0x20, 0x54, 0xC0, 0x47, 0x30, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*5F0A*/
const unsigned char  uc2_5F0B [] = {0x09, 0x80, 0x08, 0x40, 0x08, 0x00, 0x08, 0xF0, 0x07, 0x00, 0x7C, 0x00, 0x02, 0x00, 0x02, 0x10, 0x01, 0x10, 0x00, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*5F0B*/
const unsigned char  uc2_5F0D [] = {0x01, 0x60, 0x01, 0x10, 0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x3D, 0x00, 0x01, 0x00, 0x00, 0x80, 0x0E, 0x90, 0x70, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*5F0D*/
const unsigned char  uc2_5F0F [] = {0x01, 0x40, 0x01, 0x20, 0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x3D, 0x00, 0x09, 0x00, 0x08, 0x90, 0x0E, 0x90, 0x70, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*5F0F*/
const unsigned char  uc2_5F11 [] = {0x00, 0x60, 0x68, 0x50, 0x13, 0xF0, 0x68, 0x40, 0x10, 0x40, 0x7F, 0xC0, 0x11, 0x40, 0x19, 0x50, 0x35, 0xD0, 0x56, 0x50, 0x30, 0x20, 0x00, 0x00 }; /*5F11*/
const unsigned char  uc2_5F13 [] = {0x3F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x0F, 0xC0, 0x08, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x07, 0xC0, 0x00, 0x00 }; /*5F13*/
const unsigned char  uc2_5F15 [] = {0x00, 0x20, 0x3E, 0x20, 0x02, 0x20, 0x02, 0x20, 0x1E, 0x20, 0x10, 0x20, 0x20, 0x20, 0x3F, 0x20, 0x01, 0x20, 0x01, 0x20, 0x1E, 0x20, 0x00, 0x00 }; /*5F15*/
const unsigned char  uc2_5F17 [] = {0x09, 0x00, 0x09, 0x00, 0x7F, 0xE0, 0x09, 0x20, 0x3F, 0xE0, 0x49, 0x00, 0x7F, 0xF0, 0x09, 0x10, 0x09, 0x10, 0x11, 0x60, 0x61, 0x00, 0x00, 0x00 }; /*5F17*/
const unsigned char  uc2_5F18 [] = {0x00, 0x40, 0x7C, 0x40, 0x04, 0x40, 0x3C, 0x40, 0x40, 0x40, 0x7C, 0x40, 0x04, 0xA0, 0x04, 0x90, 0x05, 0x30, 0x05, 0xD0, 0x38, 0x10, 0x00, 0x00 }; /*5F18*/
const unsigned char  uc2_5F1B [] = {0x00, 0x80, 0x7A, 0x80, 0x0A, 0xE0, 0x3B, 0xA0, 0x46, 0xA0, 0x7A, 0xA0, 0x0A, 0xC0, 0x0A, 0x80, 0x0A, 0x90, 0x0A, 0x10, 0x71, 0xE0, 0x00, 0x00 }; /*5F1B*/
const unsigned char  uc2_5F1F [] = {0x04, 0x40, 0x02, 0x80, 0x1F, 0xE0, 0x01, 0x20, 0x0F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x03, 0x10, 0x05, 0x10, 0x39, 0x60, 0x01, 0x00, 0x00, 0x00 }; /*5F1F*/
const unsigned char  uc2_5F20 [] = {0x02, 0x00, 0x7A, 0x20, 0x0A, 0x40, 0x3B, 0x80, 0x22, 0x00, 0x47, 0xF0, 0x7A, 0x40, 0x0A, 0x40, 0x0A, 0x20, 0x0A, 0xA0, 0x73, 0x10, 0x00, 0x00 }; /*5F20*/
const unsigned char  uc2_5F25 [] = {0x01, 0x00, 0x79, 0xF0, 0x09, 0x10, 0x39, 0x10, 0x42, 0x40, 0x78, 0x40, 0x09, 0x60, 0x09, 0x50, 0x0A, 0x50, 0x08, 0x40, 0x71, 0x80, 0x00, 0x00 }; /*5F25*/
const unsigned char  uc2_5F26 [] = {0x01, 0x00, 0x78, 0x80, 0x0F, 0xF0, 0x38, 0x80, 0x41, 0x20, 0x7A, 0x20, 0x0B, 0xC0, 0x08, 0x80, 0x09, 0x20, 0x0A, 0x50, 0x73, 0x90, 0x00, 0x00 }; /*5F26*/
const unsigned char  uc2_5F27 [] = {0x00, 0x10, 0x7B, 0xE0, 0x0A, 0xA0, 0x3A, 0xA0, 0x42, 0xA0, 0x7A, 0xA0, 0x0A, 0xA0, 0x0A, 0xA0, 0x0B, 0x60, 0x0D, 0xD0, 0x74, 0x10, 0x00, 0x00 }; /*5F27*/
const unsigned char  uc2_5F29 [] = {0x11, 0xE0, 0x7C, 0xA0, 0x24, 0x40, 0x18, 0xB0, 0x6F, 0xC0, 0x00, 0x40, 0x0F, 0xC0, 0x10, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*5F29*/
const unsigned char  uc2_5F2A [] = {0x00, 0x00, 0x7B, 0xC0, 0x08, 0x40, 0x38, 0x80, 0x41, 0x60, 0x7E, 0x10, 0x08, 0x00, 0x0B, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x77, 0xF0, 0x00, 0x00 }; /*5F2A*/
const unsigned char  uc2_5F2D [] = {0x00, 0x00, 0x7B, 0xF0, 0x09, 0x20, 0x39, 0xE0, 0x41, 0x20, 0x79, 0xE0, 0x09, 0x20, 0x09, 0x70, 0x0B, 0xA0, 0x08, 0x20, 0x70, 0x20, 0x00, 0x00 }; /*5F2D*/
const unsigned char  uc2_5F2F [] = {0x02, 0x00, 0x7F, 0xF0, 0x15, 0x40, 0x65, 0x20, 0x1F, 0xC0, 0x00, 0x40, 0x0F, 0xC0, 0x10, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*5F2F*/
const unsigned char  uc2_5F31 [] = {0x00, 0x00, 0x7D, 0xF0, 0x04, 0x10, 0x3C, 0xF0, 0x41, 0x00, 0x7D, 0xF0, 0x04, 0x10, 0x24, 0x90, 0x14, 0x50, 0x65, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*5F31*/
const unsigned char  uc2_5F39 [] = {0x02, 0x20, 0x79, 0x40, 0x0B, 0xE0, 0x3A, 0xA0, 0x43, 0xE0, 0x7A, 0xA0, 0x0B, 0xE0, 0x08, 0x80, 0x0F, 0xF0, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*5F39*/
const unsigned char  uc2_5F3A [] = {0x01, 0xC0, 0x79, 0x40, 0x09, 0xC0, 0x38, 0x80, 0x43, 0xE0, 0x7A, 0xA0, 0x0B, 0xE0, 0x0A, 0xA0, 0x08, 0x80, 0x08, 0xA0, 0x77, 0xD0, 0x00, 0x00 }; /*5F3A*/
const unsigned char  uc2_5F3C [] = {0x00, 0x00, 0x7F, 0xF0, 0x12, 0x10, 0x37, 0x30, 0x45, 0x40, 0x75, 0x70, 0x17, 0x10, 0x15, 0x10, 0x15, 0x10, 0x17, 0x10, 0x65, 0x60, 0x00, 0x00 }; /*5F3C*/
const unsigned char  uc2_5F40 [] = {0x7C, 0xE0, 0x10, 0xA0, 0x7C, 0xA0, 0x45, 0x10, 0x3A, 0x00, 0x05, 0xE0, 0x3C, 0xA0, 0x40, 0xA0, 0x7C, 0x40, 0x04, 0xA0, 0x3B, 0x10, 0x00, 0x00 }; /*5F40*/
const unsigned char  uc2_5F52 [] = {0x08, 0x00, 0x0B, 0xF0, 0x28, 0x10, 0x28, 0x10, 0x28, 0x10, 0x29, 0xF0, 0x28, 0x10, 0x08, 0x10, 0x10, 0x10, 0x17, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*5F52*/
const unsigned char  uc2_5F53 [] = {0x02, 0x00, 0x22, 0x40, 0x12, 0x80, 0x7F, 0xE0, 0x00, 0x20, 0x00, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x20, 0x7F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*5F53*/
const unsigned char  uc2_5F55 [] = {0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x0F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x02, 0x20, 0x33, 0x40, 0x0A, 0x80, 0x72, 0x70, 0x0C, 0x00, 0x00, 0x00 }; /*5F55*/
const unsigned char  uc2_5F56 [] = {0x04, 0x00, 0x07, 0xC0, 0x08, 0x40, 0x0F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x0A, 0x20, 0x35, 0xC0, 0x0B, 0x40, 0x05, 0x30, 0x3B, 0x00, 0x00, 0x00 }; /*5F56*/
const unsigned char  uc2_5F57 [] = {0x10, 0x40, 0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x20, 0x1F, 0xE0, 0x00, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*5F57*/
const unsigned char  uc2_5F58 [] = {0x04, 0x00, 0x07, 0x80, 0x08, 0x80, 0x0F, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x24, 0x40, 0x27, 0x50, 0x3A, 0x60, 0x2F, 0xD0, 0x35, 0x20, 0x00, 0x00 }; /*5F58*/
const unsigned char  uc2_5F5D [] = {0x04, 0x00, 0x07, 0x00, 0x08, 0x80, 0x7F, 0xF0, 0x2A, 0x20, 0x7F, 0x50, 0x1C, 0xA0, 0x6A, 0x70, 0x04, 0xA0, 0x7F, 0xF0, 0x10, 0x40, 0x00, 0x00 }; /*5F5D*/
const unsigned char  uc2_5F62 [] = {0x00, 0x20, 0x3E, 0x20, 0x14, 0x40, 0x14, 0x90, 0x14, 0x10, 0x7F, 0x20, 0x14, 0xC0, 0x14, 0x10, 0x14, 0x10, 0x24, 0x20, 0x45, 0xC0, 0x00, 0x00 }; /*5F62*/
const unsigned char  uc2_5F64 [] = {0x00, 0x20, 0x3C, 0x20, 0x34, 0x50, 0x2D, 0x90, 0x24, 0x20, 0x7E, 0x40, 0x25, 0x90, 0x24, 0x10, 0x24, 0x20, 0x24, 0x40, 0x49, 0x80, 0x00, 0x00 }; /*5F64*/
const unsigned char  uc2_5F66 [] = {0x01, 0x00, 0x3F, 0xF0, 0x04, 0x40, 0x02, 0x80, 0x3F, 0xF0, 0x20, 0x80, 0x23, 0x00, 0x20, 0x40, 0x27, 0x90, 0x20, 0x20, 0x4F, 0xC0, 0x00, 0x00 }; /*5F66*/
const unsigned char  uc2_5F69 [] = {0x06, 0x10, 0x78, 0x10, 0x52, 0x20, 0x2C, 0xD0, 0x08, 0x10, 0x7F, 0x20, 0x08, 0xC0, 0x1C, 0x10, 0x2A, 0x10, 0x48, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*5F69*/
const unsigned char  uc2_5F6A [] = {0x0F, 0x10, 0x08, 0x20, 0x3F, 0x40, 0x29, 0x10, 0x3C, 0x20, 0x2A, 0x40, 0x2E, 0x10, 0x20, 0x20, 0x2E, 0xC0, 0x2A, 0x10, 0x51, 0xF0, 0x00, 0x00 }; /*5F6A*/
const unsigned char  uc2_5F6C [] = {0x12, 0x10, 0x12, 0x10, 0x7F, 0xA0, 0x12, 0x10, 0x12, 0x10, 0x3B, 0x20, 0x36, 0xC0, 0x5A, 0x10, 0x12, 0x10, 0x12, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*5F6C*/
const unsigned char  uc2_5F6D [] = {0x08, 0x10, 0x7F, 0x10, 0x08, 0x20, 0x3E, 0xC0, 0x00, 0x10, 0x3E, 0x10, 0x22, 0x20, 0x3E, 0xC0, 0x14, 0x10, 0x0F, 0x20, 0x70, 0xC0, 0x00, 0x00 }; /*5F6D*/
const unsigned char  uc2_5F70 [] = {0x08, 0x10, 0x3E, 0x10, 0x14, 0x20, 0x7F, 0xD0, 0x22, 0x10, 0x3E, 0x20, 0x22, 0xC0, 0x3E, 0x10, 0x08, 0x10, 0x7F, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*5F70*/
const unsigned char  uc2_5F71 [] = {0x3E, 0x20, 0x22, 0x20, 0x3E, 0x40, 0x22, 0x90, 0x3E, 0x10, 0x08, 0x20, 0x7F, 0x40, 0x22, 0x10, 0x3E, 0x10, 0x2A, 0x20, 0x59, 0x40, 0x00, 0x00 }; /*5F71*/
const unsigned char  uc2_5F77 [] = {0x09, 0x00, 0x08, 0x80, 0x17, 0xF0, 0x69, 0x00, 0x09, 0x00, 0x11, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x12, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*5F77*/
const unsigned char  uc2_5F79 [] = {0x08, 0x00, 0x09, 0xC0, 0x11, 0x40, 0x69, 0x40, 0x0E, 0x30, 0x10, 0x00, 0x73, 0xC0, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*5F79*/
const unsigned char  uc2_5F7B [] = {0x14, 0x00, 0x15, 0xF0, 0x24, 0x50, 0x5F, 0x50, 0x14, 0x50, 0x24, 0x50, 0x65, 0x50, 0x26, 0x50, 0x24, 0x90, 0x21, 0x10, 0x26, 0x60, 0x00, 0x00 }; /*5F7B*/
const unsigned char  uc2_5F7C [] = {0x08, 0x40, 0x0B, 0xF0, 0x12, 0x50, 0x6A, 0x40, 0x0B, 0xE0, 0x12, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x12, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*5F7C*/
const unsigned char  uc2_5F80 [] = {0x11, 0x00, 0x10, 0x80, 0x23, 0xE0, 0x50, 0x80, 0x10, 0x80, 0x20, 0x80, 0x61, 0xC0, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x27, 0xF0, 0x00, 0x00 }; /*5F80*/
const unsigned char  uc2_5F81 [] = {0x10, 0x00, 0x17, 0xF0, 0x20, 0x80, 0x50, 0x80, 0x12, 0x80, 0x22, 0xE0, 0x62, 0x80, 0x22, 0x80, 0x22, 0x80, 0x2F, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*5F81*/
const unsigned char  uc2_5F82 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x6A, 0x20, 0x0B, 0xE0, 0x12, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x17, 0xF0, 0x00, 0x00 }; /*5F82*/
const unsigned char  uc2_5F84 [] = {0x08, 0x00, 0x0B, 0xC0, 0x10, 0x40, 0x68, 0x80, 0x09, 0x60, 0x16, 0x10, 0x73, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*5F84*/
const unsigned char  uc2_5F85 [] = {0x08, 0x80, 0x0B, 0xE0, 0x10, 0x80, 0x6F, 0xF0, 0x08, 0x40, 0x17, 0xF0, 0x70, 0x40, 0x12, 0x40, 0x11, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*5F85*/
const unsigned char  uc2_5F87 [] = {0x12, 0x00, 0x13, 0xF0, 0x24, 0x10, 0x53, 0xD0, 0x12, 0x50, 0x23, 0xD0, 0x62, 0x50, 0x23, 0xD0, 0x22, 0x50, 0x20, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*5F87*/
const unsigned char  uc2_5F88 [] = {0x08, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x6B, 0xE0, 0x0A, 0x20, 0x13, 0xE0, 0x72, 0x50, 0x12, 0x60, 0x12, 0xC0, 0x13, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*5F88*/
const unsigned char  uc2_5F89 [] = {0x12, 0x20, 0x11, 0x40, 0x27, 0xF0, 0x50, 0x80, 0x10, 0x80, 0x23, 0xE0, 0x60, 0x80, 0x20, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x00, 0x00 }; /*5F89*/
const unsigned char  uc2_5F8A [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x10, 0x55, 0xD0, 0x15, 0x50, 0x25, 0x50, 0x65, 0x50, 0x25, 0xD0, 0x24, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x00, 0x00 }; /*5F8A*/
const unsigned char  uc2_5F8B [] = {0x10, 0x80, 0x13, 0xE0, 0x20, 0xA0, 0x57, 0xF0, 0x10, 0xA0, 0x23, 0xE0, 0x60, 0x80, 0x23, 0xE0, 0x20, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x00, 0x00 }; /*5F8B*/
const unsigned char  uc2_5F8C [] = {0x08, 0x80, 0x09, 0x20, 0x11, 0xC0, 0x68, 0x80, 0x09, 0x20, 0x11, 0xD0, 0x71, 0x00, 0x11, 0xE0, 0x13, 0x20, 0x10, 0xC0, 0x17, 0x30, 0x00, 0x00 }; /*5F8C*/
const unsigned char  uc2_5F90 [] = {0x10, 0x80, 0x10, 0x80, 0x21, 0x40, 0x56, 0x30, 0x11, 0xC0, 0x20, 0x80, 0x67, 0xF0, 0x20, 0x80, 0x22, 0xA0, 0x22, 0x90, 0x25, 0x10, 0x00, 0x00 }; /*5F90*/
const unsigned char  uc2_5F92 [] = {0x10, 0x80, 0x10, 0x80, 0x23, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x60, 0x80, 0x22, 0xE0, 0x22, 0x80, 0x22, 0x80, 0x25, 0xF0, 0x00, 0x00 }; /*5F92*/
const unsigned char  uc2_5F95 [] = {0x10, 0x80, 0x17, 0xF0, 0x22, 0xA0, 0x51, 0xC0, 0x10, 0x80, 0x27, 0xF0, 0x61, 0xC0, 0x22, 0xA0, 0x22, 0xA0, 0x24, 0x90, 0x20, 0x80, 0x00, 0x00 }; /*5F95*/
const unsigned char  uc2_5F97 [] = {0x17, 0xE0, 0x14, 0x20, 0x27, 0xE0, 0x54, 0x20, 0x17, 0xE0, 0x20, 0x40, 0x6F, 0xF0, 0x24, 0x40, 0x22, 0x40, 0x20, 0x40, 0x21, 0x80, 0x00, 0x00 }; /*5F97*/
const unsigned char  uc2_5F98 [] = {0x11, 0x40, 0x11, 0x40, 0x27, 0x70, 0x51, 0x40, 0x11, 0x40, 0x23, 0x60, 0x61, 0x40, 0x21, 0x40, 0x27, 0x70, 0x21, 0x40, 0x21, 0x40, 0x00, 0x00 }; /*5F98*/
const unsigned char  uc2_5F99 [] = {0x10, 0x80, 0x10, 0x80, 0x22, 0xE0, 0x52, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x62, 0x80, 0x22, 0xE0, 0x22, 0x80, 0x23, 0x80, 0x2C, 0x70, 0x00, 0x00 }; /*5F99*/
const unsigned char  uc2_5F9C [] = {0x10, 0x80, 0x14, 0x90, 0x22, 0xA0, 0x57, 0xF0, 0x14, 0x10, 0x25, 0xD0, 0x65, 0x50, 0x25, 0x50, 0x25, 0xD0, 0x24, 0x10, 0x24, 0x60, 0x00, 0x00 }; /*5F9C*/
const unsigned char  uc2_5FA1 [] = {0x14, 0x00, 0x17, 0x70, 0x2A, 0x50, 0x52, 0x50, 0x1F, 0xD0, 0x22, 0x50, 0x6B, 0x50, 0x2A, 0x50, 0x2B, 0x60, 0x3C, 0x40, 0x20, 0x40, 0x00, 0x00 }; /*5FA1*/
const unsigned char  uc2_5FA8 [] = {0x08, 0x80, 0x0B, 0xE0, 0x12, 0x20, 0x6B, 0xE0, 0x0A, 0x20, 0x17, 0xF0, 0x70, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*5FA8*/
const unsigned char  uc2_5FAA [] = {0x08, 0x30, 0x0B, 0xC0, 0x12, 0x20, 0x6B, 0xF0, 0x0A, 0x40, 0x12, 0xA0, 0x72, 0xE0, 0x12, 0xA0, 0x12, 0xE0, 0x12, 0xA0, 0x14, 0xE0, 0x00, 0x00 }; /*5FAA*/
const unsigned char  uc2_5FAD [] = {0x10, 0x30, 0x17, 0xC0, 0x25, 0x10, 0x52, 0xA0, 0x12, 0x00, 0x23, 0xE0, 0x64, 0x80, 0x2F, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x20, 0x10, 0x00, 0x00 }; /*5FAD*/
const unsigned char  uc2_5FAE [] = {0x12, 0x40, 0x15, 0x70, 0x27, 0x50, 0x50, 0xD0, 0x17, 0x50, 0x20, 0x50, 0x67, 0x50, 0x25, 0x20, 0x25, 0xA0, 0x25, 0x50, 0x28, 0x90, 0x00, 0x00 }; /*5FAE*/
const unsigned char  uc2_5FB5 [] = {0x12, 0x40, 0x15, 0x70, 0x27, 0x50, 0x50, 0xD0, 0x17, 0x50, 0x20, 0x50, 0x6F, 0xD0, 0x22, 0x20, 0x27, 0x20, 0x22, 0x60, 0x2F, 0x90, 0x00, 0x00 }; /*5FB5*/
const unsigned char  uc2_5FB7 [] = {0x10, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x57, 0xF0, 0x15, 0x50, 0x27, 0xF0, 0x60, 0x00, 0x27, 0xF0, 0x20, 0x80, 0x22, 0x20, 0x25, 0xD0, 0x00, 0x00 }; /*5FB7*/
const unsigned char  uc2_5FBC [] = {0x12, 0x40, 0x17, 0x40, 0x25, 0x70, 0x57, 0xD0, 0x15, 0x50, 0x22, 0x50, 0x6F, 0x50, 0x24, 0x20, 0x27, 0x20, 0x25, 0x50, 0x2A, 0x90, 0x00, 0x00 }; /*5FBC*/
const unsigned char  uc2_5FBD [] = {0x24, 0x40, 0x35, 0x40, 0x55, 0x70, 0x1F, 0x50, 0x24, 0xD0, 0x6A, 0x50, 0x24, 0x20, 0x2A, 0x20, 0x2F, 0x50, 0x35, 0x50, 0x2C, 0x90, 0x00, 0x00 }; /*5FBD*/
const unsigned char  uc2_5FC3 [] = {0x04, 0x00, 0x02, 0x00, 0x01, 0x00, 0x09, 0x00, 0x28, 0x20, 0x28, 0x10, 0x28, 0x50, 0x48, 0x50, 0x08, 0x40, 0x07, 0x80, 0x00, 0x00, 0x00, 0x00 }; /*5FC3*/
const unsigned char  uc2_5FC5 [] = {0x0C, 0x20, 0x02, 0x20, 0x01, 0x20, 0x08, 0x40, 0x28, 0x40, 0x28, 0xA0, 0x49, 0x10, 0x0A, 0x50, 0x0C, 0x40, 0x77, 0x80, 0x00, 0x00, 0x00, 0x00 }; /*5FC5*/
const unsigned char  uc2_5FC6 [] = {0x10, 0x00, 0x13, 0xE0, 0x10, 0x20, 0x18, 0x40, 0x34, 0x80, 0x51, 0x00, 0x11, 0x00, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*5FC6*/
const unsigned char  uc2_5FC9 [] = {0x10, 0x00, 0x10, 0x00, 0x13, 0xF0, 0x18, 0x90, 0x34, 0x90, 0x50, 0x90, 0x10, 0x90, 0x11, 0x10, 0x11, 0x10, 0x12, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*5FC9*/
const unsigned char  uc2_5FCC [] = {0x3F, 0x80, 0x00, 0x80, 0x1F, 0x80, 0x10, 0xA0, 0x10, 0x20, 0x0F, 0xC0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FCC*/
const unsigned char  uc2_5FCD [] = {0x00, 0x00, 0x3F, 0xE0, 0x0A, 0x20, 0x12, 0x20, 0x04, 0x20, 0x78, 0xC0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FCD*/
const unsigned char  uc2_5FCF [] = {0x10, 0x60, 0x13, 0x80, 0x10, 0x80, 0x18, 0x80, 0x34, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*5FCF*/
const unsigned char  uc2_5FD0 [] = {0x04, 0x00, 0x07, 0xE0, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x01, 0x00, 0x29, 0x20, 0x28, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FD0*/
const unsigned char  uc2_5FD1 [] = {0x7F, 0xF0, 0x02, 0x00, 0x03, 0xC0, 0x02, 0x20, 0x02, 0x00, 0x00, 0x00, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FD1*/
const unsigned char  uc2_5FD2 [] = {0x00, 0xC0, 0x00, 0xA0, 0x7F, 0xF0, 0x00, 0x80, 0x10, 0x80, 0x08, 0x80, 0x12, 0x80, 0x35, 0x90, 0x54, 0x50, 0x08, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*5FD2*/
const unsigned char  uc2_5FD6 [] = {0x10, 0x40, 0x10, 0x40, 0x17, 0xF0, 0x18, 0x40, 0x34, 0x40, 0x52, 0x40, 0x11, 0x40, 0x11, 0x40, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*5FD6*/
const unsigned char  uc2_5FD7 [] = {0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FD7*/
const unsigned char  uc2_5FD8 [] = {0x06, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x0F, 0xE0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FD8*/
const unsigned char  uc2_5FD9 [] = {0x11, 0x80, 0x10, 0x40, 0x10, 0x00, 0x1B, 0xF0, 0x35, 0x00, 0x51, 0x00, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x10, 0xE0, 0x10, 0x00, 0x00, 0x00 }; /*5FD9*/
const unsigned char  uc2_5FDD [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0A, 0xA0, 0x12, 0x50, 0x62, 0x50, 0x0C, 0x00, 0x00, 0x00 }; /*5FDD*/
const unsigned char  uc2_5FE0 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x02, 0x00, 0x02, 0x20, 0x29, 0x50, 0x48, 0x40, 0x07, 0x80, 0x00, 0x00 }; /*5FE0*/
const unsigned char  uc2_5FE1 [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x1C, 0x90, 0x34, 0x90, 0x54, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*5FE1*/
const unsigned char  uc2_5FE4 [] = {0x12, 0x00, 0x13, 0xE0, 0x12, 0x80, 0x1C, 0x80, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*5FE4*/
const unsigned char  uc2_5FE7 [] = {0x10, 0x80, 0x10, 0xC0, 0x10, 0xA0, 0x1B, 0xF0, 0x34, 0x80, 0x50, 0x80, 0x10, 0x80, 0x11, 0x50, 0x11, 0x50, 0x11, 0x50, 0x12, 0x20, 0x00, 0x00 }; /*5FE7*/
const unsigned char  uc2_5FEA [] = {0x10, 0x40, 0x11, 0x40, 0x11, 0x40, 0x1A, 0x20, 0x32, 0xA0, 0x54, 0x90, 0x11, 0x00, 0x11, 0x40, 0x12, 0x60, 0x13, 0xA0, 0x10, 0x00, 0x00, 0x00 }; /*5FEA*/
const unsigned char  uc2_5FEB [] = {0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x18, 0xA0, 0x34, 0xA0, 0x57, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x1C, 0x10, 0x00, 0x00 }; /*5FEB*/
const unsigned char  uc2_5FED [] = {0x11, 0x00, 0x10, 0x80, 0x10, 0x00, 0x1B, 0xF0, 0x34, 0x80, 0x50, 0xC0, 0x10, 0xA0, 0x10, 0xA0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*5FED*/
const unsigned char  uc2_5FEE [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x30, 0x80, 0x57, 0xE0, 0x12, 0x20, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*5FEE*/
const unsigned char  uc2_5FF1 [] = {0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x1A, 0xA0, 0x36, 0xA0, 0x50, 0x80, 0x11, 0x40, 0x11, 0x50, 0x11, 0x50, 0x11, 0x50, 0x16, 0x20, 0x00, 0x00 }; /*5FF1*/
const unsigned char  uc2_5FF5 [] = {0x06, 0x00, 0x09, 0x00, 0x14, 0xC0, 0x62, 0x30, 0x1F, 0x80, 0x00, 0x80, 0x01, 0x00, 0x06, 0x20, 0x29, 0x10, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*5FF5*/
const unsigned char  uc2_5FF8 [] = {0x10, 0x00, 0x13, 0xF0, 0x10, 0x90, 0x18, 0x90, 0x34, 0x90, 0x53, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x11, 0x20, 0x11, 0x20, 0x17, 0xF0, 0x00, 0x00 }; /*5FF8*/
const unsigned char  uc2_5FFB [] = {0x10, 0x60, 0x13, 0x80, 0x12, 0x00, 0x1A, 0x00, 0x37, 0xF0, 0x52, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*5FFB*/
const unsigned char  uc2_5FFD [] = {0x10, 0x00, 0x1F, 0xE0, 0x65, 0x20, 0x09, 0x20, 0x32, 0x20, 0x0D, 0xC0, 0x00, 0x00, 0x2A, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FFD*/
const unsigned char  uc2_5FFE [] = {0x11, 0x00, 0x11, 0xE0, 0x12, 0x00, 0x1D, 0xC0, 0x30, 0x00, 0x53, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x50, 0x10, 0x50, 0x10, 0x20, 0x00, 0x00 }; /*5FFE*/
const unsigned char  uc2_5FFF [] = {0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x02, 0x80, 0x04, 0x80, 0x19, 0x00, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x48, 0x50, 0x07, 0x80, 0x00, 0x00 }; /*5FFF*/
const unsigned char  uc2_6000 [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x55, 0x80, 0x52, 0xA0, 0x12, 0x90, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6000*/
const unsigned char  uc2_6001 [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x08, 0x80, 0x16, 0x40, 0x61, 0x30, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*6001*/
const unsigned char  uc2_6002 [] = {0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x14, 0x60, 0x14, 0x90, 0x63, 0x10, 0x00, 0x00, 0x06, 0x20, 0x29, 0x10, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*6002*/
const unsigned char  uc2_6003 [] = {0x10, 0x00, 0x13, 0xE0, 0x38, 0x80, 0x54, 0x80, 0x50, 0x80, 0x57, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*6003*/
const unsigned char  uc2_6004 [] = {0x10, 0x00, 0x13, 0xF0, 0x12, 0x00, 0x3B, 0x20, 0x56, 0xA0, 0x52, 0x40, 0x12, 0x40, 0x12, 0xA0, 0x13, 0x20, 0x12, 0x00, 0x13, 0xF0, 0x00, 0x00 }; /*6004*/
const unsigned char  uc2_6005 [] = {0x11, 0x00, 0x11, 0x20, 0x31, 0x20, 0x59, 0x40, 0x57, 0xF0, 0x51, 0x80, 0x11, 0x40, 0x11, 0x40, 0x11, 0x20, 0x11, 0x60, 0x11, 0x90, 0x00, 0x00 }; /*6005*/
const unsigned char  uc2_6006 [] = {0x10, 0x80, 0x10, 0x80, 0x31, 0x40, 0x59, 0x40, 0x56, 0x30, 0x53, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x12, 0xD0, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*6006*/
const unsigned char  uc2_600A [] = {0x10, 0x00, 0x13, 0xF0, 0x10, 0x90, 0x39, 0x10, 0x56, 0x60, 0x50, 0x00, 0x51, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*600A*/
const unsigned char  uc2_600D [] = {0x12, 0x00, 0x12, 0x00, 0x3B, 0xF0, 0x55, 0x00, 0x55, 0x00, 0x51, 0xE0, 0x11, 0x00, 0x11, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x00, 0x00 }; /*600D*/
const unsigned char  uc2_600E [] = {0x20, 0x00, 0x3F, 0xE0, 0x28, 0x00, 0x2F, 0xC0, 0x48, 0x00, 0x4F, 0xC0, 0x08, 0x00, 0x06, 0x20, 0x29, 0x50, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*600E*/
const unsigned char  uc2_600F [] = {0x10, 0x80, 0x10, 0x80, 0x33, 0xE0, 0x5A, 0xA0, 0x52, 0xA0, 0x57, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*600F*/
const unsigned char  uc2_6012 [] = {0x08, 0x00, 0x7D, 0xE0, 0x14, 0xA0, 0x14, 0xA0, 0x08, 0x40, 0x14, 0xA0, 0x25, 0x10, 0x02, 0x00, 0x2A, 0x20, 0x28, 0x90, 0x47, 0x90, 0x00, 0x00 }; /*6012*/
const unsigned char  uc2_6014 [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x52, 0x80, 0x52, 0xE0, 0x12, 0x80, 0x12, 0x80, 0x12, 0x80, 0x12, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*6014*/
const unsigned char  uc2_6015 [] = {0x10, 0x40, 0x10, 0x80, 0x13, 0xF0, 0x3A, 0x10, 0x56, 0x10, 0x53, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x13, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*6015*/
const unsigned char  uc2_6016 [] = {0x11, 0x00, 0x17, 0xF0, 0x11, 0x00, 0x3A, 0x80, 0x57, 0xE0, 0x5A, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x12, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6016*/
const unsigned char  uc2_6019 [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x38, 0x80, 0x50, 0x80, 0x53, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*6019*/
const unsigned char  uc2_601B [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x3A, 0x20, 0x57, 0xE0, 0x52, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x10, 0x00, 0x17, 0xF0, 0x00, 0x00 }; /*601B*/
const unsigned char  uc2_601C [] = {0x10, 0x80, 0x10, 0x80, 0x11, 0x40, 0x39, 0x40, 0x56, 0xB0, 0x50, 0x40, 0x13, 0xE0, 0x10, 0x20, 0x13, 0x40, 0x10, 0x80, 0x10, 0x40, 0x00, 0x00 }; /*601C*/
const unsigned char  uc2_601D [] = {0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x29, 0x50, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*601D*/
const unsigned char  uc2_6020 [] = {0x08, 0x80, 0x10, 0x40, 0x1F, 0xA0, 0x00, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x04, 0x00, 0x2A, 0xA0, 0x28, 0x90, 0x47, 0x10, 0x00, 0x00 }; /*6020*/
const unsigned char  uc2_6021 [] = {0x10, 0x80, 0x10, 0x80, 0x39, 0x20, 0x56, 0x30, 0x53, 0xD0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*6021*/
const unsigned char  uc2_6025 [] = {0x04, 0x00, 0x07, 0xC0, 0x08, 0x40, 0x1F, 0xE0, 0x60, 0x20, 0x0F, 0xE0, 0x00, 0x20, 0x1F, 0xE0, 0x22, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6025*/
const unsigned char  uc2_6026 [] = {0x20, 0x00, 0x2F, 0xE0, 0x31, 0x00, 0x69, 0x20, 0x25, 0x20, 0x25, 0x40, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x21, 0x00, 0x21, 0x00, 0x00, 0x00 }; /*6026*/
const unsigned char  uc2_6027 [] = {0x10, 0x80, 0x14, 0x80, 0x14, 0x80, 0x37, 0xF0, 0x58, 0x80, 0x50, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*6027*/
const unsigned char  uc2_6028 [] = {0x10, 0x00, 0x1D, 0xE0, 0x15, 0x20, 0x65, 0x20, 0x19, 0xC0, 0x09, 0x10, 0x70, 0xE0, 0x04, 0x00, 0x2A, 0xA0, 0x28, 0x90, 0x47, 0x10, 0x00, 0x00 }; /*6028*/
const unsigned char  uc2_6029 [] = {0x10, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x3F, 0xE0, 0x54, 0x00, 0x55, 0x00, 0x15, 0x20, 0x15, 0xC0, 0x15, 0x10, 0x15, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*6029*/
const unsigned char  uc2_602A [] = {0x10, 0x00, 0x17, 0xE0, 0x12, 0x20, 0x39, 0xC0, 0x56, 0x30, 0x50, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*602A*/
const unsigned char  uc2_602B [] = {0x22, 0x80, 0x22, 0x80, 0x2F, 0xE0, 0x32, 0xA0, 0x67, 0xE0, 0x2A, 0x80, 0x2F, 0xF0, 0x22, 0x90, 0x24, 0xE0, 0x24, 0x80, 0x28, 0x80, 0x00, 0x00 }; /*602B*/
const unsigned char  uc2_602F [] = {0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x50, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x11, 0x20, 0x12, 0x60, 0x13, 0x90, 0x10, 0x10, 0x00, 0x00 }; /*602F*/
const unsigned char  uc2_6031 [] = {0x08, 0x00, 0x0F, 0xF0, 0x15, 0x50, 0x62, 0x50, 0x0D, 0x90, 0x33, 0x10, 0x0D, 0x60, 0x02, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6031*/
const unsigned char  uc2_6035 [] = {0x10, 0x80, 0x10, 0xC0, 0x10, 0xA0, 0x37, 0xF0, 0x5A, 0xC0, 0x52, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*6035*/
const unsigned char  uc2_603B [] = {0x10, 0x40, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*603B*/
const unsigned char  uc2_603C [] = {0x3C, 0x20, 0x05, 0xF0, 0x34, 0x20, 0x09, 0x20, 0x14, 0xA0, 0x14, 0x20, 0x60, 0xC0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*603C*/
const unsigned char  uc2_603F [] = {0x10, 0x00, 0x17, 0xE0, 0x12, 0x20, 0x39, 0xC0, 0x56, 0x30, 0x50, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*603F*/
const unsigned char  uc2_6041 [] = {0x08, 0x60, 0x0B, 0x80, 0x10, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x00, 0x06, 0x20, 0x29, 0x50, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*6041*/
const unsigned char  uc2_6042 [] = {0x12, 0x00, 0x13, 0xF0, 0x34, 0x10, 0x5B, 0xD0, 0x52, 0x50, 0x13, 0xD0, 0x12, 0x50, 0x13, 0xD0, 0x12, 0x50, 0x10, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*6042*/
const unsigned char  uc2_6043 [] = {0x10, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x57, 0xF0, 0x50, 0x00, 0x50, 0x40, 0x13, 0xE0, 0x12, 0x40, 0x11, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*6043*/
const unsigned char  uc2_604B [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x15, 0x60, 0x15, 0x10, 0x65, 0x10, 0x02, 0x00, 0x2A, 0xA0, 0x28, 0x90, 0x47, 0x10, 0x00, 0x00 }; /*604B*/
const unsigned char  uc2_604D [] = {0x10, 0x80, 0x14, 0x90, 0x12, 0x90, 0x3A, 0xA0, 0x50, 0x80, 0x57, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x11, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x00, 0x00 }; /*604D*/
const unsigned char  uc2_6050 [] = {0x03, 0xC0, 0x7E, 0x40, 0x13, 0x40, 0x12, 0xC0, 0x1E, 0x50, 0x62, 0x50, 0x0C, 0x20, 0x02, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6050*/
const unsigned char  uc2_6052 [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x3B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*6052*/
const unsigned char  uc2_6055 [] = {0x08, 0x00, 0x7D, 0xE0, 0x15, 0x20, 0x25, 0x20, 0x39, 0x20, 0x15, 0xE0, 0x65, 0x20, 0x02, 0x00, 0x2A, 0xA0, 0x28, 0x90, 0x47, 0x10, 0x00, 0x00 }; /*6055*/
const unsigned char  uc2_6059 [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6059*/
const unsigned char  uc2_605A [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*605A*/
const unsigned char  uc2_605D [] = {0x10, 0x00, 0x7D, 0xF0, 0x10, 0x90, 0x38, 0x90, 0x10, 0x90, 0x7D, 0x10, 0x12, 0x60, 0x04, 0x00, 0x2B, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*605D*/
const unsigned char  uc2_6062 [] = {0x24, 0x00, 0x24, 0x00, 0x2F, 0xF0, 0x34, 0x00, 0x64, 0x80, 0x25, 0xA0, 0x26, 0xA0, 0x28, 0x80, 0x29, 0x40, 0x32, 0x40, 0x2C, 0x30, 0x00, 0x00 }; /*6062*/
const unsigned char  uc2_6063 [] = {0x62, 0x00, 0x13, 0xF0, 0x02, 0x10, 0x14, 0xA0, 0x10, 0x80, 0x21, 0x40, 0x46, 0x30, 0x01, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6063*/
const unsigned char  uc2_6064 [] = {0x21, 0x00, 0x22, 0x00, 0x2F, 0xE0, 0x3A, 0xA0, 0x6A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3F, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*6064*/
const unsigned char  uc2_6067 [] = {0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x20, 0xC0, 0x06, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6067*/
const unsigned char  uc2_6068 [] = {0x10, 0x00, 0x17, 0xE0, 0x34, 0x20, 0x5F, 0xE0, 0x54, 0x20, 0x57, 0xE0, 0x14, 0x90, 0x14, 0xA0, 0x14, 0x40, 0x15, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*6068*/
const unsigned char  uc2_6069 [] = {0x3F, 0xE0, 0x22, 0x20, 0x2F, 0xA0, 0x22, 0x20, 0x25, 0x20, 0x28, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x29, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6069*/
const unsigned char  uc2_606A [] = {0x11, 0x00, 0x11, 0xE0, 0x36, 0x20, 0x59, 0xC0, 0x51, 0x40, 0x16, 0x30, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*606A*/
const unsigned char  uc2_606B [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x3D, 0xD0, 0x54, 0x10, 0x55, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*606B*/
const unsigned char  uc2_606C [] = {0x10, 0x30, 0x17, 0xC0, 0x10, 0x80, 0x38, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*606C*/
const unsigned char  uc2_606D [] = {0x05, 0x00, 0x3F, 0xE0, 0x05, 0x00, 0x05, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x62, 0x30, 0x13, 0x40, 0x12, 0xA0, 0x2C, 0xA0, 0x00, 0x00 }; /*606D*/
const unsigned char  uc2_606F [] = {0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*606F*/
const unsigned char  uc2_6070 [] = {0x10, 0x80, 0x10, 0x80, 0x39, 0x40, 0x56, 0x30, 0x51, 0xC0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*6070*/
const unsigned char  uc2_6073 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x11, 0x20, 0x1C, 0xC0, 0x02, 0x30, 0x2A, 0x00, 0x28, 0xA0, 0x47, 0x90, 0x00, 0x00 }; /*6073*/
const unsigned char  uc2_6076 [] = {0x3F, 0xE0, 0x05, 0x00, 0x25, 0x20, 0x15, 0x20, 0x15, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x09, 0x20, 0x29, 0x10, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*6076*/
const unsigned char  uc2_6078 [] = {0x20, 0x40, 0x20, 0x40, 0x2E, 0x40, 0x30, 0xF0, 0x60, 0x50, 0x3F, 0x50, 0x24, 0x50, 0x2A, 0x90, 0x2E, 0x90, 0x21, 0x10, 0x26, 0x60, 0x00, 0x00 }; /*6078*/
const unsigned char  uc2_6079 [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x80, 0x3C, 0xC0, 0x54, 0xA0, 0x57, 0xF0, 0x14, 0x80, 0x15, 0x40, 0x15, 0x40, 0x15, 0x20, 0x1A, 0x10, 0x00, 0x00 }; /*6079*/
const unsigned char  uc2_607A [] = {0x10, 0x80, 0x12, 0xA0, 0x12, 0xA0, 0x3B, 0xE0, 0x54, 0x00, 0x53, 0xC0, 0x10, 0x40, 0x13, 0xC0, 0x12, 0x50, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*607A*/
const unsigned char  uc2_607B [] = {0x20, 0x10, 0x2F, 0x10, 0x29, 0x10, 0x79, 0x50, 0x2B, 0x50, 0x2B, 0x50, 0x25, 0x50, 0x26, 0x50, 0x29, 0x10, 0x29, 0x10, 0x30, 0x60, 0x00, 0x00 }; /*607B*/
const unsigned char  uc2_607C [] = {0x21, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x34, 0x80, 0x6A, 0xA0, 0x29, 0x20, 0x2A, 0xA0, 0x2C, 0xA0, 0x28, 0x20, 0x2F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*607C*/
const unsigned char  uc2_607D [] = {0x20, 0x00, 0x2F, 0xF0, 0x29, 0x10, 0x37, 0xE0, 0x62, 0x00, 0x24, 0x80, 0x27, 0xE0, 0x20, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x00, 0x00 }; /*607D*/
const unsigned char  uc2_607F [] = {0x3F, 0xC0, 0x04, 0x40, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x06, 0x60, 0x29, 0x10, 0x4F, 0xD0, 0x00, 0x00 }; /*607F*/
const unsigned char  uc2_6083 [] = {0x17, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x3F, 0xF0, 0x54, 0x90, 0x55, 0xD0, 0x16, 0xB0, 0x14, 0x90, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*6083*/
const unsigned char  uc2_6084 [] = {0x10, 0x80, 0x14, 0x90, 0x12, 0x90, 0x3A, 0xA0, 0x57, 0xF0, 0x54, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x14, 0xE0, 0x00, 0x00 }; /*6084*/
const unsigned char  uc2_6089 [] = {0x00, 0x60, 0x3F, 0x80, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x04, 0x00, 0x2B, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6089*/
const unsigned char  uc2_608C [] = {0x12, 0x20, 0x11, 0x40, 0x17, 0xE0, 0x38, 0xA0, 0x53, 0xE0, 0x54, 0x80, 0x17, 0xF0, 0x12, 0x90, 0x12, 0xE0, 0x1C, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*608C*/
const unsigned char  uc2_608D [] = {0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x50, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*608D*/
const unsigned char  uc2_6092 [] = {0x20, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x37, 0xC0, 0x60, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x28, 0x10, 0x28, 0x10, 0x27, 0xE0, 0x00, 0x00 }; /*6092*/
const unsigned char  uc2_6094 [] = {0x22, 0x00, 0x23, 0xF0, 0x34, 0x00, 0x6B, 0xE0, 0x22, 0xA0, 0x2F, 0xF0, 0x25, 0x20, 0x24, 0xA0, 0x27, 0xF0, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*6094*/
const unsigned char  uc2_6096 [] = {0x10, 0x80, 0x17, 0xF0, 0x38, 0x80, 0x57, 0xF0, 0x54, 0x10, 0x15, 0xD0, 0x10, 0x40, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x11, 0x00, 0x00, 0x00 }; /*6096*/
const unsigned char  uc2_609A [] = {0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x33, 0xE0, 0x5A, 0xA0, 0x53, 0xE0, 0x10, 0x80, 0x11, 0xC0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*609A*/
const unsigned char  uc2_609B [] = {0x11, 0x00, 0x12, 0x40, 0x13, 0xA0, 0x3A, 0x40, 0x52, 0x20, 0x55, 0x20, 0x11, 0xC0, 0x11, 0x40, 0x16, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*609B*/
const unsigned char  uc2_609D [] = {0x10, 0x00, 0x13, 0xE0, 0x3A, 0xA0, 0x57, 0xE0, 0x52, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*609D*/
const unsigned char  uc2_609F [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x3B, 0xE0, 0x51, 0x20, 0x57, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*609F*/
const unsigned char  uc2_60A0 [] = {0x12, 0x00, 0x13, 0xE0, 0x6A, 0x40, 0x2D, 0x40, 0x28, 0x80, 0x29, 0x40, 0x26, 0x30, 0x00, 0x00, 0x2B, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60A0*/
const unsigned char  uc2_60A3 [] = {0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x0A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60A3*/
const unsigned char  uc2_60A6 [] = {0x12, 0x20, 0x11, 0x40, 0x13, 0xE0, 0x3A, 0x20, 0x56, 0x20, 0x53, 0xE0, 0x11, 0x40, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x00, 0x00 }; /*60A6*/
const unsigned char  uc2_60A8 [] = {0x12, 0x00, 0x13, 0xF0, 0x64, 0x10, 0x28, 0xA0, 0x22, 0xC0, 0x2C, 0xA0, 0x23, 0x20, 0x02, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60A8*/
const unsigned char  uc2_60AB [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x08, 0xA0, 0x30, 0x40, 0x06, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60AB*/
const unsigned char  uc2_60AC [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x04, 0x00, 0x08, 0x40, 0x1F, 0xA0, 0x0A, 0x00, 0x29, 0x60, 0x47, 0x90, 0x00, 0x00 }; /*60AC*/
const unsigned char  uc2_60AD [] = {0x22, 0x00, 0x2B, 0xE0, 0x3A, 0xA0, 0x6A, 0x40, 0x2B, 0xB0, 0x22, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x21, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*60AD*/
const unsigned char  uc2_60AF [] = {0x14, 0x00, 0x13, 0xF0, 0x35, 0x10, 0x5C, 0x90, 0x57, 0xF0, 0x14, 0x50, 0x15, 0x50, 0x14, 0x90, 0x17, 0x50, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*60AF*/
const unsigned char  uc2_60B1 [] = {0x11, 0x40, 0x11, 0x40, 0x17, 0x70, 0x31, 0x40, 0x59, 0x40, 0x53, 0x60, 0x11, 0x40, 0x11, 0x40, 0x17, 0x70, 0x11, 0x40, 0x11, 0x40, 0x00, 0x00 }; /*60B1*/
const unsigned char  uc2_60B2 [] = {0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x1D, 0xC0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x02, 0x20, 0x29, 0x50, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*60B2*/
const unsigned char  uc2_60B4 [] = {0x22, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x34, 0x40, 0x64, 0x40, 0x2A, 0xA0, 0x31, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x21, 0x00, 0x00, 0x00 }; /*60B4*/
const unsigned char  uc2_60B8 [] = {0x10, 0x60, 0x13, 0x80, 0x38, 0x80, 0x57, 0xF0, 0x52, 0xA0, 0x1C, 0x90, 0x13, 0xC0, 0x10, 0x40, 0x17, 0xF0, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*60B8*/
const unsigned char  uc2_60BB [] = {0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x37, 0xF0, 0x5A, 0x20, 0x51, 0x40, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*60BB*/
const unsigned char  uc2_60BC [] = {0x10, 0x80, 0x10, 0xF0, 0x30, 0x80, 0x5B, 0xE0, 0x56, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*60BC*/
const unsigned char  uc2_60C5 [] = {0x10, 0x80, 0x17, 0xF0, 0x30, 0x80, 0x5B, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xA0, 0x12, 0x60, 0x00, 0x00 }; /*60C5*/
const unsigned char  uc2_60C6 [] = {0x17, 0xF0, 0x14, 0x90, 0x3D, 0xD0, 0x54, 0x90, 0x57, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x18, 0x60, 0x00, 0x00 }; /*60C6*/
const unsigned char  uc2_60CA [] = {0x10, 0x80, 0x17, 0xF0, 0x30, 0x00, 0x5B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x10, 0x80, 0x12, 0xA0, 0x12, 0x90, 0x14, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*60CA*/
const unsigned char  uc2_60CB [] = {0x23, 0x00, 0x20, 0x80, 0x2F, 0xF0, 0x38, 0x10, 0x64, 0x00, 0x26, 0xE0, 0x25, 0xA0, 0x2E, 0xA0, 0x22, 0xD0, 0x24, 0x90, 0x38, 0x60, 0x00, 0x00 }; /*60CB*/
const unsigned char  uc2_60D1 [] = {0x01, 0x20, 0x7F, 0xF0, 0x01, 0x00, 0x3D, 0x20, 0x24, 0xA0, 0x3C, 0x50, 0x06, 0xD0, 0x79, 0x20, 0x26, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60D1*/
const unsigned char  uc2_60D5 [] = {0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x51, 0x00, 0x13, 0xF0, 0x15, 0x50, 0x11, 0x50, 0x12, 0x90, 0x11, 0x60, 0x00, 0x00 }; /*60D5*/
const unsigned char  uc2_60D8 [] = {0x17, 0xF0, 0x15, 0x50, 0x3C, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x17, 0xF0, 0x15, 0x10, 0x15, 0x10, 0x14, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*60D8*/
const unsigned char  uc2_60DA [] = {0x12, 0x00, 0x13, 0xF0, 0x35, 0x50, 0x59, 0x50, 0x56, 0x90, 0x51, 0x60, 0x10, 0x00, 0x15, 0x20, 0x1A, 0x90, 0x12, 0x50, 0x11, 0x80, 0x00, 0x00 }; /*60DA*/
const unsigned char  uc2_60DC [] = {0x11, 0x40, 0x13, 0xE0, 0x39, 0x40, 0x57, 0xF0, 0x50, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*60DC*/
const unsigned char  uc2_60DD [] = {0x10, 0x80, 0x14, 0x90, 0x3A, 0x90, 0x52, 0xA0, 0x57, 0xF0, 0x54, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*60DD*/
const unsigned char  uc2_60DF [] = {0x12, 0x80, 0x12, 0x40, 0x34, 0x40, 0x5F, 0xF0, 0x54, 0x80, 0x57, 0xE0, 0x14, 0x80, 0x17, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x14, 0x00, 0x00, 0x00 }; /*60DF*/
const unsigned char  uc2_60E0 [] = {0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x40, 0x3F, 0xE0, 0x02, 0x10, 0x29, 0x60, 0x47, 0xD0, 0x00, 0x00 }; /*60E0*/
const unsigned char  uc2_60E6 [] = {0x23, 0x00, 0x20, 0x80, 0x37, 0xF0, 0x6C, 0x80, 0x24, 0xF0, 0x24, 0x80, 0x27, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x33, 0xE0, 0x22, 0x20, 0x00, 0x00 }; /*60E6*/
const unsigned char  uc2_60E7 [] = {0x13, 0xE0, 0x12, 0x20, 0x3B, 0xE0, 0x56, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*60E7*/
const unsigned char  uc2_60E8 [] = {0x11, 0x80, 0x12, 0x20, 0x33, 0xD0, 0x58, 0x80, 0x57, 0xF0, 0x51, 0x40, 0x16, 0xB0, 0x11, 0x40, 0x10, 0x90, 0x11, 0x60, 0x17, 0x80, 0x00, 0x00 }; /*60E8*/
const unsigned char  uc2_60E9 [] = {0x08, 0x00, 0x17, 0xF0, 0x60, 0x80, 0x0A, 0xE0, 0x72, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x06, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60E9*/
const unsigned char  uc2_60EB [] = {0x08, 0x00, 0x0F, 0x80, 0x18, 0x80, 0x27, 0x00, 0x1A, 0xC0, 0x6F, 0xB0, 0x0A, 0x80, 0x0F, 0x80, 0x20, 0x20, 0x2A, 0x90, 0x4F, 0x90, 0x00, 0x00 }; /*60EB*/
const unsigned char  uc2_60EC [] = {0x2F, 0xF0, 0x28, 0x80, 0x3B, 0xE0, 0x6C, 0x90, 0x2A, 0xA0, 0x2F, 0xF0, 0x28, 0x80, 0x29, 0x40, 0x29, 0x20, 0x2A, 0x20, 0x2F, 0xF0, 0x00, 0x00 }; /*60EC*/
const unsigned char  uc2_60ED [] = {0x24, 0x30, 0x24, 0xC0, 0x2F, 0x80, 0x34, 0x80, 0x6A, 0xF0, 0x2F, 0xA0, 0x22, 0xA0, 0x23, 0xA0, 0x2E, 0xA0, 0x22, 0xA0, 0x23, 0x20, 0x00, 0x00 }; /*60ED*/
const unsigned char  uc2_60EE [] = {0x12, 0x20, 0x11, 0x40, 0x3B, 0xE0, 0x56, 0xA0, 0x53, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*60EE*/
const unsigned char  uc2_60EF [] = {0x23, 0xE0, 0x22, 0xA0, 0x2F, 0xF0, 0x35, 0x40, 0x67, 0xC0, 0x24, 0x40, 0x25, 0x40, 0x25, 0x40, 0x21, 0x00, 0x22, 0xC0, 0x2C, 0x20, 0x00, 0x00 }; /*60EF*/
const unsigned char  uc2_60F0 [] = {0x21, 0x00, 0x2F, 0xF0, 0x22, 0x00, 0x33, 0xE0, 0x64, 0x80, 0x2F, 0xF0, 0x22, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x23, 0xA0, 0x22, 0x60, 0x00, 0x00 }; /*60F0*/
const unsigned char  uc2_60F3 [] = {0x09, 0xE0, 0x3F, 0x20, 0x09, 0xE0, 0x1D, 0x20, 0x2B, 0xE0, 0x29, 0x20, 0x49, 0xE0, 0x02, 0x00, 0x2A, 0xA0, 0x28, 0x90, 0x47, 0x10, 0x00, 0x00 }; /*60F3*/
const unsigned char  uc2_60F4 [] = {0x10, 0x80, 0x14, 0x90, 0x14, 0x90, 0x37, 0xF0, 0x58, 0x00, 0x57, 0xF0, 0x11, 0x00, 0x17, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*60F4*/
const unsigned char  uc2_60F6 [] = {0x10, 0x80, 0x11, 0x00, 0x33, 0xE0, 0x5A, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*60F6*/
const unsigned char  uc2_60F9 [] = {0x08, 0x80, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x04, 0x00, 0x0F, 0xC0, 0x78, 0x40, 0x0F, 0xC0, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*60F9*/
const unsigned char  uc2_60FA [] = {0x13, 0xE0, 0x12, 0x20, 0x3B, 0xE0, 0x56, 0x20, 0x53, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*60FA*/
const unsigned char  uc2_6100 [] = {0x22, 0x40, 0x2C, 0x40, 0x65, 0x50, 0x75, 0x50, 0x2E, 0x60, 0x24, 0x40, 0x2E, 0x40, 0x35, 0x40, 0x25, 0x40, 0x24, 0xA0, 0x25, 0x10, 0x00, 0x00 }; /*6100*/
const unsigned char  uc2_6101 [] = {0x06, 0x40, 0x39, 0x50, 0x09, 0x50, 0x7E, 0x40, 0x2C, 0xA0, 0x2A, 0xA0, 0x4B, 0x10, 0x08, 0x10, 0x22, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6101*/
const unsigned char  uc2_6106 [] = {0x14, 0xE0, 0x62, 0x00, 0x0D, 0xF0, 0x12, 0x40, 0x70, 0x40, 0x16, 0x40, 0x11, 0x80, 0x02, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6106*/
const unsigned char  uc2_6108 [] = {0x02, 0x00, 0x0D, 0x80, 0x77, 0x70, 0x00, 0x00, 0x1D, 0x40, 0x15, 0x40, 0x1D, 0x40, 0x14, 0xC0, 0x0A, 0x20, 0x28, 0x90, 0x47, 0x90, 0x00, 0x00 }; /*6108*/
const unsigned char  uc2_6109 [] = {0x21, 0x80, 0x22, 0x40, 0x2D, 0xB0, 0x30, 0x00, 0x67, 0x10, 0x25, 0x50, 0x27, 0x50, 0x25, 0x50, 0x27, 0x50, 0x25, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*6109*/
const unsigned char  uc2_610D [] = {0x7E, 0x80, 0x42, 0xF0, 0x7E, 0xA0, 0x49, 0xA0, 0x7E, 0x40, 0x48, 0xA0, 0x6A, 0xA0, 0x45, 0x10, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*610D*/
const unsigned char  uc2_610E [] = {0x12, 0x00, 0x13, 0xF0, 0x16, 0x20, 0x3B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x11, 0x00, 0x13, 0xE0, 0x15, 0x20, 0x10, 0xC0, 0x17, 0x30, 0x00, 0x00 }; /*610E*/
const unsigned char  uc2_610F [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*610F*/
const unsigned char  uc2_6115 [] = {0x17, 0x70, 0x15, 0x50, 0x17, 0x70, 0x30, 0x00, 0x59, 0xC0, 0x50, 0x00, 0x17, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*6115*/
const unsigned char  uc2_611A [] = {0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x42, 0x90, 0x5F, 0x50, 0x40, 0x20, 0x22, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*611A*/
const unsigned char  uc2_611F [] = {0x01, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0x20, 0x20, 0xA0, 0x2E, 0xA0, 0x2A, 0x50, 0x2E, 0x50, 0x42, 0xA0, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*611F*/
const unsigned char  uc2_6120 [] = {0x27, 0xC0, 0x24, 0x40, 0x37, 0xC0, 0x6C, 0x40, 0x27, 0xC0, 0x20, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3F, 0xF0, 0x20, 0x00, 0x00, 0x00 }; /*6120*/
const unsigned char  uc2_6123 [] = {0x10, 0x00, 0x17, 0xF0, 0x35, 0x50, 0x5F, 0xF0, 0x50, 0x80, 0x17, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*6123*/
const unsigned char  uc2_6124 [] = {0x10, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x51, 0x40, 0x57, 0xF0, 0x11, 0x40, 0x13, 0xE0, 0x12, 0x20, 0x12, 0xA0, 0x11, 0x40, 0x16, 0x20, 0x00, 0x00 }; /*6124*/
const unsigned char  uc2_6126 [] = {0x10, 0x80, 0x13, 0xE0, 0x12, 0xA0, 0x3B, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x12, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x11, 0x40, 0x16, 0x20, 0x00, 0x00 }; /*6126*/
const unsigned char  uc2_6127 [] = {0x11, 0x00, 0x12, 0x00, 0x17, 0xC0, 0x3D, 0x40, 0x57, 0xC0, 0x15, 0x40, 0x17, 0xE0, 0x11, 0x50, 0x12, 0xA0, 0x12, 0x90, 0x14, 0x60, 0x00, 0x00 }; /*6127*/
const unsigned char  uc2_612B [] = {0x10, 0x80, 0x13, 0xE0, 0x30, 0x80, 0x59, 0xC0, 0x50, 0x80, 0x17, 0xF0, 0x12, 0x80, 0x11, 0x20, 0x17, 0xD0, 0x12, 0xA0, 0x15, 0x90, 0x00, 0x00 }; /*612B*/
const unsigned char  uc2_613F [] = {0x3F, 0xF0, 0x22, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x33, 0x10, 0x20, 0x00, 0x29, 0x20, 0x54, 0x50, 0x47, 0xD0, 0x00, 0x00 }; /*613F*/
const unsigned char  uc2_6148 [] = {0x08, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x25, 0x20, 0x39, 0xC0, 0x10, 0x80, 0x25, 0x20, 0x39, 0xC0, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6148*/
const unsigned char  uc2_614A [] = {0x24, 0x40, 0x2F, 0xF0, 0x72, 0x80, 0x67, 0xE0, 0x22, 0xA0, 0x2F, 0xF0, 0x22, 0xA0, 0x27, 0xE0, 0x26, 0xC0, 0x3A, 0xB0, 0x22, 0x80, 0x00, 0x00 }; /*614A*/
const unsigned char  uc2_614C [] = {0x24, 0x40, 0x2F, 0xE0, 0x74, 0x40, 0x61, 0x00, 0x2F, 0xE0, 0x24, 0x00, 0x23, 0xC0, 0x20, 0x00, 0x25, 0x40, 0x25, 0x50, 0x28, 0x20, 0x00, 0x00 }; /*614C*/
const unsigned char  uc2_614E [] = {0x10, 0x80, 0x17, 0xE0, 0x11, 0x00, 0x3B, 0xC0, 0x56, 0x40, 0x53, 0xC0, 0x12, 0x40, 0x13, 0xC0, 0x12, 0x40, 0x1F, 0xF0, 0x14, 0x20, 0x00, 0x00 }; /*614E*/
const unsigned char  uc2_6151 [] = {0x2F, 0xF0, 0x22, 0x40, 0x33, 0xC0, 0x6A, 0x70, 0x2F, 0xC0, 0x20, 0x40, 0x2F, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x22, 0x20, 0x2D, 0x50, 0x00, 0x00 }; /*6151*/
const unsigned char  uc2_6155 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x22, 0x20, 0x53, 0x50, 0x26, 0xA0, 0x00, 0x00 }; /*6155*/
const unsigned char  uc2_615D [] = {0x3F, 0xF0, 0x24, 0x40, 0x2F, 0xE0, 0x25, 0x40, 0x3F, 0xF0, 0x26, 0x20, 0x2A, 0x20, 0x3F, 0xF0, 0x0A, 0x00, 0x29, 0x60, 0x47, 0xD0, 0x00, 0x00 }; /*615D*/
const unsigned char  uc2_6162 [] = {0x10, 0x00, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x52, 0x20, 0x17, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x12, 0x20, 0x11, 0xC0, 0x16, 0x30, 0x00, 0x00 }; /*6162*/
const unsigned char  uc2_6167 [] = {0x3D, 0xE0, 0x08, 0x80, 0x1D, 0xC0, 0x08, 0x80, 0x3F, 0xE0, 0x00, 0x40, 0x1F, 0xC0, 0x00, 0x40, 0x3F, 0xC0, 0x2A, 0xA0, 0x47, 0x90, 0x00, 0x00 }; /*6167*/
const unsigned char  uc2_6168 [] = {0x20, 0x00, 0x2E, 0xF0, 0x2A, 0x40, 0x3E, 0xC0, 0x6B, 0x40, 0x2E, 0xF0, 0x28, 0x40, 0x2A, 0x40, 0x2B, 0x50, 0x2C, 0xD0, 0x23, 0x20, 0x00, 0x00 }; /*6168*/
const unsigned char  uc2_6170 [] = {0x3E, 0x20, 0x22, 0xF0, 0x3E, 0x20, 0x20, 0xA0, 0x3F, 0x60, 0x24, 0x20, 0x55, 0x20, 0x48, 0x40, 0x22, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*6170*/
const unsigned char  uc2_6175 [] = {0x20, 0x80, 0x2F, 0xF0, 0x78, 0xA0, 0x6F, 0xF0, 0x28, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x32, 0x40, 0x00, 0x00 }; /*6175*/
const unsigned char  uc2_6177 [] = {0x20, 0x80, 0x2F, 0xF0, 0x28, 0xA0, 0x6F, 0xF0, 0x38, 0xA0, 0x2B, 0xE0, 0x28, 0x80, 0x2A, 0xD0, 0x29, 0xA0, 0x2E, 0xA0, 0x31, 0x90, 0x00, 0x00 }; /*6177*/
const unsigned char  uc2_618B [] = {0x2A, 0x80, 0x14, 0xF0, 0x3F, 0xA0, 0x2A, 0xA0, 0x2E, 0x40, 0x3A, 0xA0, 0x2A, 0xA0, 0x05, 0x10, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*618B*/
const unsigned char  uc2_618E [] = {0x12, 0x20, 0x11, 0x40, 0x37, 0xF0, 0x5E, 0xB0, 0x55, 0xD0, 0x14, 0x90, 0x17, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*618E*/
const unsigned char  uc2_6194 [] = {0x11, 0x40, 0x13, 0xF0, 0x36, 0x40, 0x5B, 0xE0, 0x52, 0x40, 0x13, 0xE0, 0x12, 0x40, 0x13, 0xF0, 0x12, 0xA0, 0x15, 0x50, 0x19, 0x50, 0x00, 0x00 }; /*6194*/
const unsigned char  uc2_619D [] = {0x10, 0x80, 0x7E, 0xF0, 0x25, 0x20, 0x3C, 0xA0, 0x04, 0xA0, 0x7E, 0x40, 0x11, 0xB0, 0x32, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*619D*/
const unsigned char  uc2_61A7 [] = {0x10, 0x80, 0x17, 0xF0, 0x3A, 0x20, 0x51, 0x40, 0x57, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*61A7*/
const unsigned char  uc2_61A8 [] = {0x38, 0x80, 0x08, 0xF0, 0x7E, 0xA0, 0x25, 0xA0, 0x3C, 0x40, 0x26, 0xA0, 0x7C, 0xA0, 0x05, 0x10, 0x12, 0x20, 0x50, 0x50, 0x4F, 0xD0, 0x00, 0x00 }; /*61A8*/
const unsigned char  uc2_61A9 [] = {0x04, 0x80, 0x39, 0xE0, 0x09, 0x20, 0x7F, 0xE0, 0x09, 0x20, 0x3D, 0xE0, 0x23, 0x20, 0x3D, 0xE0, 0x22, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*61A9*/
const unsigned char  uc2_61AC [] = {0x13, 0xE0, 0x12, 0x20, 0x33, 0xE0, 0x58, 0x80, 0x57, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0xA0, 0x15, 0x90, 0x00, 0x00 }; /*61AC*/
const unsigned char  uc2_61B6 [] = {0x21, 0x00, 0x27, 0xC0, 0x32, 0x80, 0x6F, 0xE0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x2D, 0x20, 0x34, 0x50, 0x23, 0x90, 0x00, 0x00 }; /*61B6*/
const unsigned char  uc2_61B7 [] = {0x22, 0x40, 0x2F, 0xF0, 0x23, 0x60, 0x36, 0xD0, 0x6A, 0x40, 0x2F, 0xF0, 0x20, 0x90, 0x22, 0x80, 0x22, 0xE0, 0x22, 0x80, 0x2D, 0xF0, 0x00, 0x00 }; /*61B7*/
const unsigned char  uc2_61BE [] = {0x20, 0xA0, 0x2F, 0xF0, 0x78, 0x80, 0x6F, 0xA0, 0x2A, 0xA0, 0x2E, 0xC0, 0x28, 0x90, 0x33, 0x60, 0x29, 0x20, 0x34, 0x50, 0x23, 0x90, 0x00, 0x00 }; /*61BE*/
const unsigned char  uc2_61C2 [] = {0x11, 0x40, 0x17, 0xF0, 0x39, 0x40, 0x50, 0x80, 0x57, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*61C2*/
const unsigned char  uc2_61C8 [] = {0x24, 0x00, 0x26, 0xF0, 0x2A, 0x50, 0x3F, 0xD0, 0x6A, 0xB0, 0x2F, 0xA0, 0x2A, 0xF0, 0x2F, 0xA0, 0x2A, 0xF0, 0x2A, 0xA0, 0x31, 0xA0, 0x00, 0x00 }; /*61C8*/
const unsigned char  uc2_61CA [] = {0x22, 0x00, 0x2F, 0xE0, 0x6D, 0x60, 0x7A, 0xA0, 0x2F, 0xE0, 0x2A, 0xA0, 0x2D, 0x60, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x2C, 0x60, 0x00, 0x00 }; /*61CA*/
const unsigned char  uc2_61CB [] = {0x17, 0xA0, 0x7A, 0xF0, 0x19, 0x20, 0x37, 0xB0, 0x53, 0x60, 0x1D, 0xA0, 0x11, 0x20, 0x06, 0x00, 0x29, 0x20, 0x28, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*61CB*/
const unsigned char  uc2_61D1 [] = {0x62, 0x20, 0x17, 0xF0, 0x61, 0x40, 0x17, 0xF0, 0x05, 0x50, 0x16, 0xB0, 0x64, 0x10, 0x02, 0x60, 0x29, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*61D1*/
const unsigned char  uc2_61D2 [] = {0x24, 0x40, 0x3F, 0x60, 0x64, 0xA0, 0x7F, 0xF0, 0x25, 0x10, 0x3F, 0x50, 0x25, 0x50, 0x2F, 0x50, 0x35, 0x50, 0x24, 0xA0, 0x25, 0x10, 0x00, 0x00 }; /*61D2*/
const unsigned char  uc2_61D4 [] = {0x21, 0x00, 0x3F, 0xF0, 0x6A, 0xA0, 0x39, 0x20, 0x2F, 0xE0, 0x20, 0x00, 0x27, 0xC0, 0x20, 0x00, 0x3F, 0xF0, 0x25, 0x40, 0x2A, 0x20, 0x00, 0x00 }; /*61D4*/
const unsigned char  uc2_61E6 [] = {0x13, 0xE0, 0x38, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x12, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x17, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x15, 0x20, 0x00, 0x00 }; /*61E6*/
const unsigned char  uc2_61F5 [] = {0x24, 0x40, 0x2F, 0xE0, 0x34, 0x40, 0x6F, 0xE0, 0x2A, 0xA0, 0x3F, 0xF0, 0x34, 0x50, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x00, 0x00 }; /*61F5*/
const unsigned char  uc2_61FF [] = {0x12, 0x40, 0x7D, 0x70, 0x10, 0x90, 0x7C, 0x40, 0x45, 0x40, 0x3A, 0xA0, 0x29, 0x10, 0x38, 0x80, 0x2B, 0x20, 0x15, 0x50, 0x79, 0xC0, 0x00, 0x00 }; /*61FF*/
const unsigned char  uc2_6206 [] = {0x08, 0x80, 0x3E, 0xF0, 0x15, 0x10, 0x7E, 0xE0, 0x23, 0x50, 0x3E, 0xE0, 0x08, 0xA0, 0x7E, 0xE0, 0x09, 0x10, 0x12, 0x40, 0x5F, 0xD0, 0x00, 0x00 }; /*6206*/
const unsigned char  uc2_6208 [] = {0x04, 0x80, 0x04, 0x40, 0x04, 0x40, 0x7F, 0xF0, 0x04, 0x00, 0x02, 0x40, 0x02, 0x40, 0x03, 0x90, 0x05, 0x10, 0x18, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*6208*/
const unsigned char  uc2_620A [] = {0x02, 0xC0, 0x02, 0x20, 0x3F, 0xF0, 0x22, 0x00, 0x22, 0x20, 0x21, 0x20, 0x20, 0xC0, 0x21, 0x90, 0x26, 0x90, 0x58, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*620A*/
const unsigned char  uc2_620B [] = {0x05, 0x00, 0x04, 0x80, 0x04, 0xE0, 0x3F, 0x00, 0x04, 0x70, 0x05, 0x80, 0x7E, 0x40, 0x02, 0x90, 0x07, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*620B*/
const unsigned char  uc2_620C [] = {0x02, 0xC0, 0x02, 0x20, 0x3F, 0xF0, 0x22, 0x00, 0x22, 0x20, 0x21, 0x20, 0x3D, 0x40, 0x21, 0x90, 0x22, 0x50, 0x2C, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*620C*/
const unsigned char  uc2_620D [] = {0x02, 0xC0, 0x02, 0x20, 0x3F, 0xF0, 0x22, 0x00, 0x22, 0x20, 0x31, 0x20, 0x29, 0x40, 0x2B, 0x90, 0x24, 0x90, 0x38, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*620D*/
const unsigned char  uc2_620E [] = {0x01, 0x40, 0x01, 0x20, 0x7F, 0xF0, 0x01, 0x00, 0x11, 0x20, 0x11, 0x20, 0x7D, 0x40, 0x11, 0x90, 0x22, 0x50, 0x2C, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*620E*/
const unsigned char  uc2_620F [] = {0x01, 0x40, 0x79, 0x20, 0x09, 0x20, 0x49, 0xF0, 0x2F, 0x00, 0x11, 0x20, 0x28, 0xC0, 0x28, 0x90, 0x49, 0x90, 0x42, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*620F*/
const unsigned char  uc2_6210 [] = {0x01, 0x40, 0x01, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x20, 0x3D, 0x20, 0x25, 0x40, 0x24, 0x80, 0x29, 0x90, 0x22, 0x50, 0x4C, 0x20, 0x00, 0x00 }; /*6210*/
const unsigned char  uc2_6211 [] = {0x06, 0xC0, 0x38, 0xA0, 0x08, 0xA0, 0x7F, 0xF0, 0x08, 0x80, 0x0E, 0xA0, 0x18, 0xA0, 0x68, 0x50, 0x08, 0xD0, 0x09, 0x50, 0x36, 0x20, 0x00, 0x00 }; /*6211*/
const unsigned char  uc2_6212 [] = {0x01, 0x40, 0x01, 0x20, 0x7F, 0xF0, 0x01, 0x00, 0x15, 0x20, 0x14, 0xA0, 0x7E, 0xA0, 0x14, 0x40, 0x14, 0x50, 0x24, 0xD0, 0x43, 0x20, 0x00, 0x00 }; /*6212*/
const unsigned char  uc2_6215 [] = {0x09, 0x40, 0x29, 0x20, 0x29, 0x20, 0x29, 0x70, 0x3F, 0x80, 0x09, 0x20, 0x78, 0xC0, 0x28, 0x90, 0x29, 0x50, 0x2E, 0x50, 0x48, 0x20, 0x00, 0x00 }; /*6215*/
const unsigned char  uc2_6216 [] = {0x01, 0x40, 0x01, 0x20, 0x7F, 0xF0, 0x01, 0x00, 0x39, 0x20, 0x29, 0x20, 0x39, 0x40, 0x00, 0x90, 0x0C, 0x90, 0x71, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*6216*/
const unsigned char  uc2_6217 [] = {0x08, 0x80, 0x08, 0xC0, 0x14, 0xA0, 0x12, 0xF0, 0x3F, 0x80, 0x54, 0x90, 0x14, 0xA0, 0x18, 0x40, 0x12, 0xD0, 0x13, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*6217*/
const unsigned char  uc2_6218 [] = {0x10, 0x80, 0x10, 0xC0, 0x1C, 0xA0, 0x10, 0xF0, 0x13, 0x80, 0x7C, 0xA0, 0x44, 0xA0, 0x44, 0x50, 0x7C, 0xD0, 0x41, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*6218*/
const unsigned char  uc2_621A [] = {0x00, 0xA0, 0x3F, 0xF0, 0x24, 0x80, 0x27, 0x90, 0x24, 0x90, 0x3F, 0xA0, 0x20, 0xA0, 0x2E, 0x40, 0x35, 0x50, 0x24, 0xD0, 0x49, 0x20, 0x00, 0x00 }; /*621A*/
const unsigned char  uc2_621B [] = {0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x04, 0x20, 0x05, 0xF0, 0x7E, 0x40, 0x04, 0x80, 0x03, 0x10, 0x7C, 0xF0, 0x00, 0x00 }; /*621B*/
const unsigned char  uc2_621F [] = {0x11, 0x40, 0x7D, 0x20, 0x11, 0x00, 0x7D, 0x70, 0x47, 0x80, 0x7D, 0x20, 0x45, 0x40, 0x7C, 0x80, 0x10, 0x90, 0x7D, 0x50, 0x12, 0x30, 0x00, 0x00 }; /*621F*/
const unsigned char  uc2_6221 [] = {0x14, 0x80, 0x3E, 0xC0, 0x14, 0xA0, 0x1C, 0xF0, 0x17, 0x80, 0x1C, 0xA0, 0x76, 0xA0, 0x28, 0x40, 0x36, 0xD0, 0x21, 0x50, 0x1E, 0x20, 0x00, 0x00 }; /*6221*/
const unsigned char  uc2_6222 [] = {0x3C, 0x80, 0x24, 0xA0, 0x3C, 0x90, 0x00, 0x80, 0x7F, 0xF0, 0x24, 0x80, 0x3C, 0xA0, 0x24, 0xA0, 0x2E, 0x50, 0x74, 0xD0, 0x05, 0x30, 0x00, 0x00 }; /*6222*/
const unsigned char  uc2_6224 [] = {0x7C, 0x40, 0x24, 0x60, 0x3F, 0x50, 0x35, 0x70, 0x2D, 0xC0, 0x2B, 0x40, 0x52, 0x50, 0x3F, 0xD0, 0x2A, 0xA0, 0x2F, 0xE0, 0x70, 0xB0, 0x00, 0x00 }; /*6224*/
const unsigned char  uc2_6225 [] = {0x3E, 0xA0, 0x22, 0x90, 0x3E, 0x90, 0x22, 0xE0, 0x3F, 0x90, 0x28, 0x90, 0x3E, 0xA0, 0x48, 0xA0, 0x5C, 0x40, 0x0A, 0xD0, 0x7D, 0x20, 0x00, 0x00 }; /*6225*/
const unsigned char  uc2_622A [] = {0x08, 0xA0, 0x3E, 0x90, 0x08, 0x80, 0x7F, 0xF0, 0x14, 0x80, 0x3F, 0xA0, 0x64, 0xA0, 0x3F, 0x40, 0x24, 0x50, 0x3F, 0x50, 0x20, 0xB0, 0x00, 0x00 }; /*622A*/
const unsigned char  uc2_622C [] = {0x3E, 0x60, 0x14, 0x50, 0x55, 0x70, 0x36, 0xC0, 0x14, 0x50, 0x7F, 0x50, 0x22, 0x60, 0x3E, 0x40, 0x22, 0xC0, 0x3F, 0x50, 0x20, 0x20, 0x00, 0x00 }; /*622C*/
const unsigned char  uc2_622E [] = {0x7F, 0x60, 0x2D, 0x50, 0x1B, 0x40, 0x6D, 0xF0, 0x12, 0x40, 0x65, 0x50, 0x1A, 0x50, 0x04, 0x60, 0x19, 0x40, 0x06, 0xD0, 0x39, 0x30, 0x00, 0x00 }; /*622E*/
const unsigned char  uc2_6233 [] = {0x77, 0x60, 0x55, 0x50, 0x33, 0x40, 0x55, 0xF0, 0x28, 0x40, 0x3F, 0x50, 0x64, 0x50, 0x3F, 0x60, 0x24, 0x50, 0x3F, 0x50, 0x21, 0xB0, 0x00, 0x00 }; /*6233*/
const unsigned char  uc2_6234 [] = {0x08, 0xC0, 0x3E, 0xA0, 0x08, 0x80, 0x7F, 0xF0, 0x2A, 0x80, 0x3E, 0xA0, 0x2A, 0xA0, 0x3E, 0xA0, 0x14, 0x40, 0x7F, 0x50, 0x22, 0xB0, 0x00, 0x00 }; /*6234*/
const unsigned char  uc2_6237 [] = {0x03, 0x00, 0x00, 0x80, 0x1F, 0xF0, 0x10, 0x10, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x10, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*6237*/
const unsigned char  uc2_623D [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x12, 0x40, 0x11, 0x40, 0x14, 0x40, 0x12, 0x70, 0x2F, 0xC0, 0x20, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*623D*/
const unsigned char  uc2_623E [] = {0x06, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x11, 0x40, 0x11, 0x20, 0x1F, 0xF0, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*623E*/
const unsigned char  uc2_623F [] = {0x01, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x13, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x4C, 0xC0, 0x00, 0x00 }; /*623F*/
const unsigned char  uc2_6240 [] = {0x06, 0x30, 0x18, 0xC0, 0x10, 0x80, 0x1E, 0x80, 0x12, 0xF0, 0x12, 0xA0, 0x1E, 0xA0, 0x10, 0xA0, 0x21, 0x20, 0x21, 0x20, 0x42, 0x20, 0x00, 0x00 }; /*6240*/
const unsigned char  uc2_6241 [] = {0x01, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*6241*/
const unsigned char  uc2_6243 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x25, 0xD0, 0x44, 0x20, 0x00, 0x00 }; /*6243*/
const unsigned char  uc2_6247 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x1E, 0xF0, 0x15, 0x50, 0x13, 0x30, 0x2D, 0xD0, 0x21, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*6247*/
const unsigned char  uc2_6248 [] = {0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x24, 0x80, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x28, 0x10, 0x48, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*6248*/
const unsigned char  uc2_6249 [] = {0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x22, 0x80, 0x3E, 0xF0, 0x22, 0x80, 0x2E, 0xE0, 0x22, 0x80, 0x5E, 0xF0, 0x42, 0x80, 0x00, 0x00 }; /*6249*/
const unsigned char  uc2_624B [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*624B*/
const unsigned char  uc2_624D [] = {0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x3F, 0xF0, 0x01, 0x80, 0x02, 0x80, 0x04, 0x80, 0x18, 0x80, 0x60, 0x80, 0x00, 0x80, 0x07, 0x00, 0x00, 0x00 }; /*624D*/
const unsigned char  uc2_624E [] = {0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x7D, 0x00, 0x11, 0x00, 0x11, 0x00, 0x1D, 0x00, 0x71, 0x10, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*624E*/
const unsigned char  uc2_6251 [] = {0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x7D, 0x00, 0x11, 0xC0, 0x1D, 0x20, 0x71, 0x10, 0x11, 0x10, 0x11, 0x00, 0x11, 0x00, 0x61, 0x00, 0x00, 0x00 }; /*6251*/
const unsigned char  uc2_6252 [] = {0x10, 0x00, 0x11, 0x40, 0x11, 0x40, 0x7D, 0x40, 0x11, 0x40, 0x1D, 0x40, 0x71, 0x40, 0x12, 0x20, 0x12, 0x20, 0x12, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*6252*/
const unsigned char  uc2_6253 [] = {0x10, 0x00, 0x17, 0xF0, 0x78, 0x80, 0x10, 0x80, 0x10, 0x80, 0x18, 0x80, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*6253*/
const unsigned char  uc2_6254 [] = {0x10, 0x00, 0x13, 0xE0, 0x7D, 0x20, 0x11, 0x20, 0x11, 0x40, 0x1D, 0x70, 0x71, 0x10, 0x12, 0x10, 0x12, 0x10, 0x14, 0x20, 0x68, 0xC0, 0x00, 0x00 }; /*6254*/
const unsigned char  uc2_6258 [] = {0x10, 0x00, 0x10, 0x60, 0x13, 0x80, 0x7C, 0x80, 0x10, 0x80, 0x1C, 0xE0, 0x73, 0x80, 0x10, 0x80, 0x10, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*6258*/
const unsigned char  uc2_625B [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0x80, 0x10, 0x80, 0x10, 0x80, 0x1C, 0x80, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*625B*/
const unsigned char  uc2_6263 [] = {0x08, 0x00, 0x08, 0xF0, 0x7E, 0x90, 0x08, 0x90, 0x08, 0x90, 0x0E, 0x90, 0x18, 0x90, 0x68, 0x90, 0x08, 0x90, 0x08, 0xF0, 0x30, 0x90, 0x00, 0x00 }; /*6263*/
const unsigned char  uc2_6266 [] = {0x10, 0x60, 0x13, 0x80, 0x78, 0x80, 0x10, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6266*/
const unsigned char  uc2_6267 [] = {0x11, 0x00, 0x11, 0x00, 0x79, 0x00, 0x17, 0xC0, 0x11, 0x40, 0x17, 0x40, 0x19, 0x40, 0x72, 0xC0, 0x12, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*6267*/
const unsigned char  uc2_6269 [] = {0x11, 0x80, 0x10, 0x40, 0x7B, 0xF0, 0x12, 0x00, 0x12, 0x00, 0x1A, 0x00, 0x72, 0x00, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x64, 0x00, 0x00, 0x00 }; /*6269*/
const unsigned char  uc2_626A [] = {0x12, 0x00, 0x11, 0x00, 0x7D, 0x70, 0x12, 0x10, 0x12, 0x10, 0x1A, 0x10, 0x72, 0x10, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*626A*/
const unsigned char  uc2_626B [] = {0x10, 0x00, 0x13, 0xF0, 0x7C, 0x10, 0x10, 0x10, 0x10, 0x10, 0x1D, 0xF0, 0x70, 0x10, 0x10, 0x10, 0x10, 0x10, 0x13, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*626B*/
const unsigned char  uc2_626C [] = {0x10, 0x00, 0x13, 0xC0, 0x78, 0x40, 0x10, 0x80, 0x1B, 0xF0, 0x11, 0x50, 0x72, 0x50, 0x1C, 0x90, 0x11, 0x10, 0x12, 0x20, 0x6C, 0xC0, 0x00, 0x00 }; /*626C*/
const unsigned char  uc2_626D [] = {0x10, 0x00, 0x17, 0xE0, 0x79, 0x20, 0x11, 0x20, 0x19, 0x20, 0x17, 0xE0, 0x71, 0x20, 0x12, 0x20, 0x12, 0x20, 0x1F, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*626D*/
const unsigned char  uc2_626E [] = {0x11, 0x40, 0x11, 0x40, 0x79, 0x20, 0x12, 0x20, 0x14, 0x10, 0x1B, 0xE0, 0x11, 0x20, 0x71, 0x20, 0x12, 0x20, 0x12, 0x20, 0x64, 0xC0, 0x00, 0x00 }; /*626E*/
const unsigned char  uc2_626F [] = {0x10, 0x80, 0x10, 0x80, 0x78, 0x80, 0x12, 0x80, 0x12, 0xE0, 0x1A, 0x80, 0x72, 0x80, 0x12, 0x80, 0x12, 0x80, 0x1F, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*626F*/
const unsigned char  uc2_6270 [] = {0x11, 0x40, 0x11, 0x20, 0x79, 0x20, 0x17, 0xF0, 0x11, 0x40, 0x19, 0x40, 0x72, 0x40, 0x12, 0x50, 0x12, 0x50, 0x14, 0x50, 0x68, 0x20, 0x00, 0x00 }; /*6270*/
const unsigned char  uc2_6273 [] = {0x10, 0x30, 0x13, 0xC0, 0x7A, 0x00, 0x12, 0x00, 0x13, 0xE0, 0x1A, 0xA0, 0x72, 0xA0, 0x12, 0x40, 0x12, 0xA0, 0x14, 0xA0, 0x69, 0x10, 0x00, 0x00 }; /*6273*/
const unsigned char  uc2_6276 [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x18, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*6276*/
const unsigned char  uc2_6279 [] = {0x12, 0x40, 0x12, 0x40, 0x7A, 0x40, 0x12, 0x50, 0x13, 0xE0, 0x1A, 0x40, 0x72, 0x40, 0x12, 0x50, 0x12, 0x50, 0x12, 0xD0, 0x63, 0x20, 0x00, 0x00 }; /*6279*/
const unsigned char  uc2_627C [] = {0x10, 0x00, 0x13, 0xF0, 0x7A, 0x00, 0x12, 0xE0, 0x12, 0xA0, 0x1A, 0xA0, 0x72, 0xA0, 0x12, 0xC0, 0x14, 0x90, 0x14, 0x90, 0x68, 0x60, 0x00, 0x00 }; /*627C*/
const unsigned char  uc2_627E [] = {0x10, 0x80, 0x10, 0xC0, 0x7C, 0xA0, 0x10, 0xF0, 0x13, 0x80, 0x1C, 0xA0, 0x70, 0xA0, 0x10, 0xC0, 0x11, 0x50, 0x16, 0x50, 0x60, 0x20, 0x00, 0x00 }; /*627E*/
const unsigned char  uc2_627F [] = {0x1F, 0x00, 0x01, 0x00, 0x72, 0x50, 0x1F, 0xD0, 0x12, 0x60, 0x17, 0x40, 0x12, 0x40, 0x2F, 0xA0, 0x22, 0x20, 0x42, 0x10, 0x0C, 0x00, 0x00, 0x00 }; /*627F*/
const unsigned char  uc2_6280 [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x10, 0x80, 0x17, 0xE0, 0x1A, 0x20, 0x71, 0x40, 0x10, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6280*/
const unsigned char  uc2_6284 [] = {0x10, 0x80, 0x10, 0x80, 0x12, 0xA0, 0x7A, 0x90, 0x14, 0x90, 0x10, 0x80, 0x18, 0xA0, 0x70, 0xA0, 0x10, 0x40, 0x11, 0x80, 0x6E, 0x00, 0x00, 0x00 }; /*6284*/
const unsigned char  uc2_6289 [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0xA0, 0x18, 0xA0, 0x77, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x12, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*6289*/
const unsigned char  uc2_628A [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1B, 0xE0, 0x72, 0x00, 0x12, 0x10, 0x12, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*628A*/
const unsigned char  uc2_6291 [] = {0x11, 0x00, 0x16, 0xF0, 0x7C, 0x90, 0x14, 0x90, 0x14, 0x90, 0x1C, 0x90, 0x75, 0x90, 0x16, 0xA0, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6291*/
const unsigned char  uc2_6292 [] = {0x10, 0x00, 0x13, 0xE0, 0x78, 0xA0, 0x10, 0x40, 0x13, 0xF0, 0x18, 0x50, 0x70, 0x50, 0x10, 0x60, 0x10, 0x40, 0x10, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*6292*/
const unsigned char  uc2_6293 [] = {0x10, 0x70, 0x13, 0xA0, 0x7A, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x14, 0xA0, 0x14, 0x90, 0x68, 0x90, 0x00, 0x00 }; /*6293*/
const unsigned char  uc2_6295 [] = {0x13, 0xC0, 0x12, 0x40, 0x7A, 0x40, 0x12, 0x40, 0x14, 0x20, 0x1B, 0xC0, 0x71, 0x40, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6295*/
const unsigned char  uc2_6296 [] = {0x12, 0x40, 0x11, 0x40, 0x79, 0x40, 0x12, 0x40, 0x11, 0x40, 0x19, 0x40, 0x70, 0xF0, 0x17, 0x40, 0x10, 0x40, 0x10, 0x40, 0x60, 0x40, 0x00, 0x00 }; /*6296*/
const unsigned char  uc2_6297 [] = {0x13, 0x00, 0x10, 0x80, 0x7B, 0xF0, 0x10, 0x00, 0x19, 0xC0, 0x11, 0x40, 0x71, 0x40, 0x12, 0x50, 0x12, 0x50, 0x14, 0x50, 0x68, 0x20, 0x00, 0x00 }; /*6297*/
const unsigned char  uc2_6298 [] = {0x10, 0x30, 0x13, 0xC0, 0x7E, 0x00, 0x12, 0x00, 0x13, 0xF0, 0x1A, 0x40, 0x72, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*6298*/
const unsigned char  uc2_629A [] = {0x10, 0x00, 0x13, 0xE0, 0x78, 0x80, 0x10, 0x80, 0x10, 0x80, 0x1F, 0xF0, 0x70, 0xC0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*629A*/
const unsigned char  uc2_629B [] = {0x24, 0x40, 0x24, 0x40, 0x74, 0xF0, 0x2F, 0x50, 0x25, 0x50, 0x35, 0x50, 0x65, 0x50, 0x25, 0x90, 0x29, 0x60, 0x29, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*629B*/
const unsigned char  uc2_629F [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x19, 0x00, 0x73, 0xE0, 0x10, 0x20, 0x11, 0xC0, 0x10, 0x40, 0x60, 0x40, 0x00, 0x00 }; /*629F*/
const unsigned char  uc2_62A0 [] = {0x10, 0x00, 0x13, 0xF0, 0x7A, 0x00, 0x13, 0x20, 0x12, 0xA0, 0x1A, 0x40, 0x72, 0xA0, 0x12, 0xA0, 0x13, 0x20, 0x12, 0x00, 0x63, 0xF0, 0x00, 0x00 }; /*62A0*/
const unsigned char  uc2_62A1 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x11, 0x40, 0x16, 0x30, 0x19, 0x00, 0x71, 0x20, 0x11, 0xC0, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*62A1*/
const unsigned char  uc2_62A2 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x10, 0x00, 0x1B, 0xE0, 0x72, 0x20, 0x12, 0x20, 0x12, 0xD0, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*62A2*/
const unsigned char  uc2_62A4 [] = {0x10, 0x80, 0x13, 0xF0, 0x7A, 0x10, 0x12, 0x10, 0x13, 0xF0, 0x1A, 0x10, 0x72, 0x00, 0x12, 0x00, 0x14, 0x00, 0x14, 0x00, 0x68, 0x00, 0x00, 0x00 }; /*62A4*/
const unsigned char  uc2_62A5 [] = {0x13, 0xE0, 0x12, 0x20, 0x7A, 0x20, 0x12, 0xC0, 0x12, 0x00, 0x1B, 0xE0, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x12, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*62A5*/
const unsigned char  uc2_62A8 [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0xA0, 0x12, 0xA0, 0x12, 0xC0, 0x18, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*62A8*/
const unsigned char  uc2_62AB [] = {0x10, 0x40, 0x10, 0x40, 0x13, 0xF0, 0x7A, 0x50, 0x12, 0x50, 0x13, 0xE0, 0x1A, 0xA0, 0x72, 0xA0, 0x14, 0x40, 0x14, 0xA0, 0x6B, 0x10, 0x00, 0x00 }; /*62AB*/
const unsigned char  uc2_62AC [] = {0x10, 0x80, 0x10, 0x80, 0x7D, 0x20, 0x12, 0x30, 0x13, 0xD0, 0x1C, 0x00, 0x71, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x61, 0x20, 0x00, 0x00 }; /*62AC*/
const unsigned char  uc2_62B1 [] = {0x11, 0x00, 0x11, 0xE0, 0x7A, 0x20, 0x14, 0x20, 0x13, 0xA0, 0x1A, 0xA0, 0x73, 0xA0, 0x12, 0x20, 0x12, 0xD0, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*62B1*/
const unsigned char  uc2_62B5 [] = {0x10, 0x60, 0x17, 0x80, 0x7C, 0x80, 0x14, 0x80, 0x17, 0xF0, 0x1C, 0x80, 0x74, 0x80, 0x15, 0x50, 0x16, 0x50, 0x11, 0x50, 0x61, 0x20, 0x00, 0x00 }; /*62B5*/
const unsigned char  uc2_62B9 [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x10, 0x80, 0x1B, 0xE0, 0x71, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x60, 0x80, 0x00, 0x00 }; /*62B9*/
const unsigned char  uc2_62BB [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x1C, 0x90, 0x74, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*62BB*/
const unsigned char  uc2_62BC [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x1C, 0x90, 0x74, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*62BC*/
const unsigned char  uc2_62BD [] = {0x10, 0x80, 0x10, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x1C, 0x90, 0x77, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*62BD*/
const unsigned char  uc2_62BF [] = {0x10, 0x00, 0x17, 0xE0, 0x7C, 0x20, 0x17, 0xE0, 0x1C, 0x80, 0x77, 0xF0, 0x14, 0x80, 0x14, 0x80, 0x14, 0x50, 0x15, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*62BF*/
const unsigned char  uc2_62C2 [] = {0x11, 0x40, 0x11, 0x40, 0x17, 0xF0, 0x79, 0x50, 0x13, 0xF0, 0x15, 0x40, 0x1F, 0xF0, 0x71, 0x50, 0x12, 0x60, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*62C2*/
const unsigned char  uc2_62C4 [] = {0x13, 0x00, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x18, 0x80, 0x71, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*62C4*/
const unsigned char  uc2_62C5 [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x10, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*62C5*/
const unsigned char  uc2_62C6 [] = {0x10, 0x60, 0x13, 0x80, 0x7A, 0x00, 0x12, 0x00, 0x13, 0xF0, 0x1A, 0x40, 0x72, 0xC0, 0x12, 0x60, 0x12, 0x50, 0x12, 0x50, 0x64, 0x40, 0x00, 0x00 }; /*62C6*/
const unsigned char  uc2_62C7 [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0x20, 0x12, 0xA0, 0x1F, 0xF0, 0x75, 0x20, 0x14, 0xA0, 0x17, 0xF0, 0x10, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*62C7*/
const unsigned char  uc2_62C8 [] = {0x10, 0x80, 0x10, 0x80, 0x7C, 0x80, 0x10, 0xF0, 0x10, 0x80, 0x1C, 0x80, 0x73, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*62C8*/
const unsigned char  uc2_62C9 [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x78, 0x00, 0x12, 0x20, 0x19, 0x20, 0x71, 0x40, 0x10, 0x40, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*62C9*/
const unsigned char  uc2_62CA [] = {0x11, 0x20, 0x11, 0x20, 0x79, 0x20, 0x12, 0xF0, 0x16, 0x20, 0x1A, 0xA0, 0x72, 0x60, 0x12, 0x20, 0x12, 0x20, 0x12, 0x20, 0x62, 0xC0, 0x00, 0x00 }; /*62CA*/
const unsigned char  uc2_62CC [] = {0x10, 0x80, 0x14, 0xA0, 0x7A, 0xA0, 0x12, 0xC0, 0x13, 0xE0, 0x18, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*62CC*/
const unsigned char  uc2_62CD [] = {0x10, 0x80, 0x13, 0xF0, 0x7A, 0x10, 0x12, 0x10, 0x12, 0x10, 0x1B, 0xF0, 0x72, 0x10, 0x12, 0x10, 0x12, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*62CD*/
const unsigned char  uc2_62CE [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x12, 0x40, 0x1D, 0x30, 0x10, 0x80, 0x1B, 0xE0, 0x70, 0x20, 0x13, 0x40, 0x10, 0x80, 0x60, 0x40, 0x00, 0x00 }; /*62CE*/
const unsigned char  uc2_62D0 [] = {0x10, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x7D, 0x20, 0x11, 0xE0, 0x1C, 0x80, 0x73, 0xF0, 0x10, 0x90, 0x11, 0x10, 0x11, 0x10, 0x66, 0x60, 0x00, 0x00 }; /*62D0*/
const unsigned char  uc2_62D2 [] = {0x10, 0x00, 0x13, 0xF0, 0x7A, 0x00, 0x12, 0x00, 0x13, 0xE0, 0x1A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x00, 0x12, 0x00, 0x63, 0xF0, 0x00, 0x00 }; /*62D2*/
const unsigned char  uc2_62D3 [] = {0x10, 0x00, 0x13, 0xF0, 0x78, 0x40, 0x10, 0x80, 0x10, 0x80, 0x19, 0xE0, 0x73, 0x20, 0x15, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x61, 0x20, 0x00, 0x00 }; /*62D3*/
const unsigned char  uc2_62D4 [] = {0x11, 0x40, 0x11, 0x20, 0x7F, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x1A, 0xA0, 0x72, 0xA0, 0x12, 0x40, 0x14, 0xA0, 0x14, 0xA0, 0x6B, 0x10, 0x00, 0x00 }; /*62D4*/
const unsigned char  uc2_62D6 [] = {0x11, 0x00, 0x11, 0xE0, 0x7A, 0x00, 0x14, 0x80, 0x12, 0xE0, 0x1B, 0xA0, 0x76, 0xA0, 0x12, 0xC0, 0x12, 0x90, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*62D6*/
const unsigned char  uc2_62D7 [] = {0x22, 0x40, 0x22, 0x40, 0x75, 0xF0, 0x25, 0x50, 0x26, 0x50, 0x32, 0x50, 0x65, 0x50, 0x26, 0x90, 0x20, 0x90, 0x21, 0x20, 0x46, 0xC0, 0x00, 0x00 }; /*62D7*/
const unsigned char  uc2_62D8 [] = {0x11, 0x00, 0x11, 0xF0, 0x79, 0x10, 0x16, 0x10, 0x11, 0xD0, 0x19, 0x50, 0x71, 0x50, 0x11, 0xD0, 0x11, 0x50, 0x10, 0x10, 0x60, 0x60, 0x00, 0x00 }; /*62D8*/
const unsigned char  uc2_62D9 [] = {0x10, 0x80, 0x10, 0x80, 0x14, 0x90, 0x7C, 0x90, 0x17, 0xF0, 0x18, 0x80, 0x74, 0x90, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*62D9*/
const unsigned char  uc2_62DA [] = {0x21, 0x00, 0x22, 0x00, 0x74, 0x40, 0x27, 0xA0, 0x20, 0x20, 0x32, 0x40, 0x6F, 0xF0, 0x22, 0x40, 0x24, 0x40, 0x24, 0x40, 0x68, 0x40, 0x00, 0x00 }; /*62DA*/
const unsigned char  uc2_62DB [] = {0x10, 0x00, 0x13, 0xF0, 0x78, 0x90, 0x11, 0x10, 0x16, 0x60, 0x18, 0x00, 0x73, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*62DB*/
const unsigned char  uc2_62DC [] = {0x08, 0x00, 0x77, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x78, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x7B, 0xF0, 0x10, 0x80, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*62DC*/
const unsigned char  uc2_62DF [] = {0x10, 0x40, 0x12, 0x40, 0x79, 0x40, 0x15, 0x40, 0x14, 0x40, 0x1C, 0x40, 0x75, 0x40, 0x16, 0x40, 0x10, 0xA0, 0x13, 0x10, 0x6C, 0x10, 0x00, 0x00 }; /*62DF*/
const unsigned char  uc2_62E2 [] = {0x22, 0x00, 0x22, 0x40, 0x72, 0x20, 0x2F, 0xF0, 0x22, 0x80, 0x32, 0xA0, 0x62, 0xA0, 0x24, 0xC0, 0x24, 0x90, 0x29, 0x90, 0x56, 0x60, 0x00, 0x00 }; /*62E2*/
const unsigned char  uc2_62E3 [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x79, 0x00, 0x17, 0x80, 0x12, 0x80, 0x1B, 0xE0, 0x70, 0x80, 0x12, 0xA0, 0x14, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*62E3*/
const unsigned char  uc2_62E5 [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x90, 0x7C, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x1C, 0x90, 0x77, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x68, 0x60, 0x00, 0x00 }; /*62E5*/
const unsigned char  uc2_62E6 [] = {0x12, 0x20, 0x11, 0x20, 0x79, 0x40, 0x13, 0xE0, 0x10, 0x00, 0x18, 0x00, 0x71, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x17, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*62E6*/
const unsigned char  uc2_62E7 [] = {0x13, 0x00, 0x10, 0x80, 0x7B, 0xF0, 0x14, 0x10, 0x14, 0x10, 0x1B, 0xE0, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*62E7*/
const unsigned char  uc2_62E8 [] = {0x10, 0x80, 0x12, 0xA0, 0x7C, 0x90, 0x17, 0xF0, 0x11, 0x00, 0x19, 0xE0, 0x71, 0x20, 0x12, 0xA0, 0x1C, 0x40, 0x10, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*62E8*/
const unsigned char  uc2_62E9 [] = {0x10, 0x00, 0x17, 0xE0, 0x7A, 0x20, 0x11, 0xC0, 0x16, 0x30, 0x18, 0x80, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*62E9*/
const unsigned char  uc2_62EC [] = {0x10, 0x30, 0x17, 0xC0, 0x78, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x73, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*62EC*/
const unsigned char  uc2_62ED [] = {0x10, 0x60, 0x10, 0x50, 0x17, 0xF0, 0x78, 0x40, 0x17, 0x40, 0x12, 0x40, 0x1A, 0x40, 0x72, 0x50, 0x13, 0xD0, 0x1C, 0x50, 0x60, 0x20, 0x00, 0x00 }; /*62ED*/
const unsigned char  uc2_62EE [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x10, 0x00, 0x1B, 0xE0, 0x72, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*62EE*/
const unsigned char  uc2_62EF [] = {0x10, 0x00, 0x17, 0xC0, 0x10, 0x40, 0x78, 0xA0, 0x16, 0xA0, 0x1A, 0xC0, 0x72, 0xA0, 0x14, 0xA0, 0x1B, 0x10, 0x10, 0x00, 0x6F, 0xF0, 0x00, 0x00 }; /*62EF*/
const unsigned char  uc2_62F1 [] = {0x11, 0x40, 0x11, 0x40, 0x7B, 0xE0, 0x11, 0x40, 0x11, 0x40, 0x19, 0x40, 0x77, 0xF0, 0x10, 0x00, 0x11, 0x40, 0x11, 0x20, 0x66, 0x20, 0x00, 0x00 }; /*62F1*/
const unsigned char  uc2_62F3 [] = {0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x16, 0x40, 0x62, 0x30, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x06, 0x00, 0x00, 0x00 }; /*62F3*/
const unsigned char  uc2_62F4 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x13, 0xE0, 0x18, 0x80, 0x70, 0x80, 0x11, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*62F4*/
const unsigned char  uc2_62F6 [] = {0x11, 0x50, 0x11, 0x50, 0x7A, 0xA0, 0x11, 0x50, 0x10, 0x80, 0x18, 0xF0, 0x71, 0x10, 0x16, 0xA0, 0x10, 0x40, 0x11, 0x80, 0x66, 0x00, 0x00, 0x00 }; /*62F6*/
const unsigned char  uc2_62F7 [] = {0x10, 0x90, 0x13, 0xD0, 0x78, 0xA0, 0x17, 0xF0, 0x11, 0x00, 0x1B, 0xF0, 0x74, 0x80, 0x19, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*62F7*/
const unsigned char  uc2_62FC [] = {0x12, 0x20, 0x11, 0x20, 0x79, 0x40, 0x13, 0xE0, 0x19, 0x40, 0x71, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x12, 0x40, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*62FC*/
const unsigned char  uc2_62FD [] = {0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x7A, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x1B, 0xE0, 0x70, 0xA0, 0x10, 0xD0, 0x11, 0x90, 0x66, 0x60, 0x00, 0x00 }; /*62FD*/
const unsigned char  uc2_62FE [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x11, 0xC0, 0x18, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*62FE*/
const unsigned char  uc2_62FF [] = {0x02, 0x00, 0x0D, 0x80, 0x77, 0x70, 0x08, 0xC0, 0x3F, 0x80, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*62FF*/
const unsigned char  uc2_6301 [] = {0x10, 0x80, 0x13, 0xE0, 0x78, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x18, 0x40, 0x73, 0xE0, 0x12, 0x40, 0x11, 0x40, 0x10, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*6301*/
const unsigned char  uc2_6302 [] = {0x10, 0x80, 0x13, 0xE0, 0x78, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x00, 0x70, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6302*/
const unsigned char  uc2_6307 [] = {0x11, 0x20, 0x11, 0xC0, 0x7D, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x1C, 0x00, 0x71, 0xF0, 0x11, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x61, 0xF0, 0x00, 0x00 }; /*6307*/
const unsigned char  uc2_6308 [] = {0x10, 0x00, 0x7D, 0xE0, 0x10, 0xA0, 0x38, 0xA0, 0x11, 0x20, 0x7E, 0x40, 0x12, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7B, 0xF0, 0x04, 0x00, 0x00, 0x00 }; /*6308*/
const unsigned char  uc2_6309 [] = {0x11, 0x80, 0x10, 0x40, 0x13, 0xF0, 0x7A, 0x10, 0x10, 0x80, 0x13, 0xF0, 0x19, 0x20, 0x71, 0x20, 0x10, 0xC0, 0x11, 0x20, 0x66, 0x20, 0x00, 0x00 }; /*6309*/
const unsigned char  uc2_630E [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x12, 0x20, 0x1D, 0xD0, 0x10, 0x00, 0x77, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x10, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*630E*/
const unsigned char  uc2_6311 [] = {0x11, 0x40, 0x11, 0x40, 0x15, 0x50, 0x7B, 0x60, 0x11, 0x40, 0x1B, 0x60, 0x75, 0x50, 0x11, 0x40, 0x12, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*6311*/
const unsigned char  uc2_6316 [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x50, 0x11, 0x20, 0x12, 0x20, 0x19, 0xC0, 0x70, 0x40, 0x10, 0x80, 0x11, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*6316*/
const unsigned char  uc2_631A [] = {0x11, 0x00, 0x7B, 0xC0, 0x11, 0x50, 0x79, 0x50, 0x16, 0xA0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*631A*/
const unsigned char  uc2_631B [] = {0x02, 0x00, 0x7F, 0xF0, 0x25, 0x20, 0x25, 0x10, 0x5F, 0xD0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*631B*/
const unsigned char  uc2_631D [] = {0x14, 0x20, 0x12, 0x20, 0x7A, 0xF0, 0x10, 0x20, 0x16, 0xA0, 0x1A, 0x60, 0x72, 0x20, 0x12, 0x20, 0x12, 0xC0, 0x15, 0x00, 0x68, 0xF0, 0x00, 0x00 }; /*631D*/
const unsigned char  uc2_631E [] = {0x20, 0x40, 0x28, 0x40, 0x74, 0x40, 0x25, 0xF0, 0x30, 0x40, 0x6C, 0x40, 0x24, 0xA0, 0x24, 0x90, 0x25, 0x10, 0x2A, 0x00, 0x71, 0xF0, 0x00, 0x00 }; /*631E*/
const unsigned char  uc2_631F [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x12, 0xA0, 0x17, 0xF0, 0x18, 0x80, 0x71, 0x40, 0x11, 0x40, 0x12, 0x20, 0x6C, 0x10, 0x00, 0x00 }; /*631F*/
const unsigned char  uc2_6320 [] = {0x11, 0x60, 0x17, 0x80, 0x79, 0x60, 0x11, 0x90, 0x16, 0x60, 0x18, 0x00, 0x77, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x6C, 0x20, 0x00, 0x00 }; /*6320*/
const unsigned char  uc2_6321 [] = {0x10, 0x80, 0x14, 0x90, 0x7A, 0xA0, 0x17, 0xF0, 0x10, 0x10, 0x18, 0x10, 0x77, 0xF0, 0x10, 0x10, 0x10, 0x10, 0x17, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*6321*/
const unsigned char  uc2_6322 [] = {0x10, 0x60, 0x13, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x11, 0x40, 0x1A, 0x20, 0x75, 0x50, 0x11, 0x40, 0x12, 0x40, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*6322*/
const unsigned char  uc2_6323 [] = {0x11, 0x00, 0x11, 0xC0, 0x7A, 0x40, 0x13, 0xE0, 0x10, 0xA0, 0x1F, 0xF0, 0x70, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*6323*/
const unsigned char  uc2_6324 [] = {0x11, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x10, 0x80, 0x19, 0x40, 0x76, 0x30, 0x11, 0x40, 0x11, 0x40, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*6324*/
const unsigned char  uc2_6325 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x90, 0x13, 0xE0, 0x11, 0x00, 0x1A, 0x80, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6325*/
const unsigned char  uc2_6328 [] = {0x11, 0x00, 0x11, 0x40, 0x7A, 0x60, 0x13, 0xA0, 0x12, 0x00, 0x1B, 0xE0, 0x74, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6328*/
const unsigned char  uc2_632A [] = {0x20, 0x00, 0x2F, 0x70, 0x75, 0x50, 0x25, 0x50, 0x2F, 0x60, 0x35, 0x50, 0x65, 0x50, 0x2F, 0x50, 0x25, 0x60, 0x29, 0x40, 0x6A, 0x40, 0x00, 0x00 }; /*632A*/
const unsigned char  uc2_632B [] = {0x21, 0x00, 0x25, 0x40, 0x75, 0x40, 0x25, 0x40, 0x2B, 0xA0, 0x31, 0x20, 0x61, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*632B*/
const unsigned char  uc2_632F [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x00, 0x15, 0xE0, 0x1C, 0x00, 0x77, 0xF0, 0x15, 0x40, 0x15, 0x50, 0x15, 0x20, 0x15, 0x60, 0x69, 0x90, 0x00, 0x00 }; /*632F*/
const unsigned char  uc2_6332 [] = {0x30, 0x80, 0x0A, 0xA0, 0x62, 0x90, 0x14, 0xA0, 0x17, 0x40, 0x62, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*6332*/
const unsigned char  uc2_6339 [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x18, 0x00, 0x77, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x00, 0x14, 0x10, 0x63, 0xE0, 0x00, 0x00 }; /*6339*/
const unsigned char  uc2_633A [] = {0x20, 0x20, 0x2E, 0xC0, 0x72, 0x40, 0x22, 0x40, 0x24, 0xE0, 0x36, 0x40, 0x62, 0x40, 0x2B, 0xF0, 0x24, 0x00, 0x2A, 0x00, 0x51, 0xF0, 0x00, 0x00 }; /*633A*/
const unsigned char  uc2_633D [] = {0x11, 0x00, 0x11, 0xC0, 0x79, 0x40, 0x12, 0x80, 0x1B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x10, 0xC0, 0x11, 0x50, 0x12, 0x50, 0x6C, 0x20, 0x00, 0x00 }; /*633D*/
const unsigned char  uc2_6342 [] = {0x10, 0x00, 0x13, 0xE0, 0x78, 0x80, 0x13, 0xE0, 0x11, 0x20, 0x1F, 0xF0, 0x70, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*6342*/
const unsigned char  uc2_6343 [] = {0x10, 0x00, 0x17, 0xE0, 0x79, 0x20, 0x17, 0xF0, 0x19, 0x20, 0x77, 0xE0, 0x12, 0x00, 0x17, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*6343*/
const unsigned char  uc2_6345 [] = {0x13, 0xE0, 0x11, 0x20, 0x78, 0xC0, 0x17, 0xF0, 0x14, 0x90, 0x1F, 0xF0, 0x74, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x64, 0x60, 0x00, 0x00 }; /*6345*/
const unsigned char  uc2_6346 [] = {0x17, 0xF0, 0x14, 0x10, 0x7C, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x1D, 0xD0, 0x76, 0xB0, 0x14, 0x90, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6346*/
const unsigned char  uc2_6349 [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x18, 0x80, 0x72, 0xE0, 0x12, 0x80, 0x12, 0x80, 0x15, 0x80, 0x68, 0x70, 0x00, 0x00 }; /*6349*/
const unsigned char  uc2_634B [] = {0x10, 0x30, 0x17, 0xD0, 0x7A, 0x90, 0x11, 0x60, 0x10, 0x20, 0x1B, 0xF0, 0x70, 0x20, 0x13, 0x20, 0x10, 0xA0, 0x10, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*634B*/
const unsigned char  uc2_634C [] = {0x20, 0x10, 0x2F, 0x10, 0x79, 0x50, 0x2F, 0x50, 0x24, 0x50, 0x3F, 0x50, 0x65, 0x50, 0x25, 0x50, 0x29, 0x10, 0x29, 0x10, 0x76, 0x60, 0x00, 0x00 }; /*634C*/
const unsigned char  uc2_634D [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x18, 0x00, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*634D*/
const unsigned char  uc2_634E [] = {0x14, 0x90, 0x12, 0x90, 0x7A, 0xA0, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x62, 0x40, 0x00, 0x00 }; /*634E*/
const unsigned char  uc2_634F [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x70, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*634F*/
const unsigned char  uc2_6350 [] = {0x11, 0xE0, 0x11, 0x20, 0x7D, 0xE0, 0x10, 0x00, 0x13, 0xF0, 0x1E, 0x10, 0x73, 0xF0, 0x12, 0x10, 0x13, 0xF0, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*6350*/
const unsigned char  uc2_6355 [] = {0x10, 0xC0, 0x10, 0xA0, 0x7F, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x1A, 0xA0, 0x73, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x62, 0x40, 0x00, 0x00 }; /*6355*/
const unsigned char  uc2_635E [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x18, 0x80, 0x73, 0xE0, 0x10, 0xA0, 0x11, 0x20, 0x66, 0x40, 0x00, 0x00 }; /*635E*/
const unsigned char  uc2_635F [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x18, 0x00, 0x77, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x11, 0x60, 0x12, 0x10, 0x6C, 0x10, 0x00, 0x00 }; /*635F*/
const unsigned char  uc2_6361 [] = {0x10, 0x80, 0x11, 0x40, 0x79, 0x40, 0x12, 0x20, 0x15, 0xD0, 0x19, 0x00, 0x74, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x10, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*6361*/
const unsigned char  uc2_6362 [] = {0x12, 0x00, 0x13, 0xC0, 0x7A, 0x40, 0x14, 0x80, 0x17, 0xE0, 0x1A, 0xA0, 0x12, 0xA0, 0x77, 0xF0, 0x11, 0x40, 0x12, 0x20, 0x6C, 0x10, 0x00, 0x00 }; /*6362*/
const unsigned char  uc2_6363 [] = {0x11, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x12, 0xA0, 0x12, 0x40, 0x1B, 0xF0, 0x71, 0x10, 0x15, 0x50, 0x17, 0xD0, 0x10, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*6363*/
const unsigned char  uc2_6367 [] = {0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x7B, 0xC0, 0x11, 0x00, 0x17, 0xF0, 0x1A, 0xA0, 0x75, 0xD0, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*6367*/
const unsigned char  uc2_6369 [] = {0x10, 0x80, 0x17, 0xE0, 0x7C, 0x20, 0x17, 0xE0, 0x14, 0x40, 0x1C, 0xA0, 0x77, 0xF0, 0x14, 0x80, 0x15, 0x40, 0x15, 0x40, 0x6A, 0x30, 0x00, 0x00 }; /*6369*/
const unsigned char  uc2_636D [] = {0x12, 0x00, 0x17, 0xE0, 0x7C, 0xA0, 0x17, 0xE0, 0x15, 0x20, 0x1F, 0xE0, 0x72, 0x00, 0x14, 0x80, 0x1F, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*636D*/
const unsigned char  uc2_636E [] = {0x10, 0x00, 0x13, 0xF0, 0x12, 0x10, 0x7B, 0xF0, 0x12, 0x40, 0x13, 0xF0, 0x1A, 0x40, 0x73, 0xF0, 0x15, 0x10, 0x15, 0xF0, 0x69, 0x10, 0x00, 0x00 }; /*636E*/
const unsigned char  uc2_6371 [] = {0x10, 0x00, 0x13, 0xF0, 0x7A, 0x40, 0x12, 0xE0, 0x12, 0x40, 0x1B, 0xF0, 0x72, 0x00, 0x12, 0x40, 0x14, 0xE0, 0x14, 0x40, 0x69, 0xF0, 0x00, 0x00 }; /*6371*/
const unsigned char  uc2_6376 [] = {0x10, 0x30, 0x17, 0xC0, 0x78, 0x80, 0x17, 0xF0, 0x1A, 0xA0, 0x77, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x63, 0xE0, 0x00, 0x00 }; /*6376*/
const unsigned char  uc2_6377 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0xA0, 0x17, 0xE0, 0x18, 0xB0, 0x73, 0xE0, 0x10, 0x80, 0x12, 0xE0, 0x12, 0x80, 0x15, 0x80, 0x68, 0x70, 0x00, 0x00 }; /*6377*/
const unsigned char  uc2_637A [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x16, 0x30, 0x11, 0xC0, 0x18, 0x00, 0x77, 0xF0, 0x10, 0x80, 0x12, 0xA0, 0x12, 0x90, 0x65, 0x10, 0x00, 0x00 }; /*637A*/
const unsigned char  uc2_637B [] = {0x10, 0x80, 0x11, 0x40, 0x7E, 0xB0, 0x10, 0x40, 0x13, 0xE0, 0x18, 0x20, 0x71, 0x40, 0x12, 0xA0, 0x16, 0x90, 0x1A, 0x50, 0x61, 0x80, 0x00, 0x00 }; /*637B*/
const unsigned char  uc2_6380 [] = {0x23, 0x00, 0x2C, 0x80, 0x78, 0xF0, 0x28, 0x90, 0x2F, 0x50, 0x3A, 0x60, 0x6A, 0x40, 0x2A, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*6380*/
const unsigned char  uc2_6382 [] = {0x11, 0x80, 0x10, 0x40, 0x7B, 0xF0, 0x12, 0x80, 0x12, 0xF0, 0x1A, 0x80, 0x75, 0xE0, 0x15, 0x20, 0x15, 0x20, 0x15, 0xE0, 0x69, 0x20, 0x00, 0x00 }; /*6382*/
const unsigned char  uc2_6387 [] = {0x27, 0x70, 0x21, 0x10, 0x75, 0x50, 0x22, 0x20, 0x25, 0xD0, 0x30, 0x00, 0x67, 0xF0, 0x21, 0x50, 0x25, 0x50, 0x22, 0x20, 0x6D, 0x50, 0x00, 0x00 }; /*6387*/
const unsigned char  uc2_6388 [] = {0x10, 0x30, 0x17, 0xC0, 0x7A, 0x90, 0x11, 0x60, 0x17, 0xF0, 0x1C, 0x10, 0x73, 0xE0, 0x11, 0x20, 0x10, 0xC0, 0x11, 0x20, 0x36, 0x10, 0x00, 0x00 }; /*6388*/
const unsigned char  uc2_6389 [] = {0x10, 0xB0, 0x10, 0xC0, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6389*/
const unsigned char  uc2_638A [] = {0x10, 0x80, 0x13, 0xE0, 0x7A, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x18, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*638A*/
const unsigned char  uc2_638C [] = {0x12, 0x40, 0x7F, 0xF0, 0x48, 0x90, 0x48, 0xD0, 0x1F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*638C*/
const unsigned char  uc2_638E [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x12, 0x20, 0x17, 0xF0, 0x18, 0x20, 0x73, 0xA0, 0x12, 0xA0, 0x13, 0xA0, 0x12, 0xA0, 0x60, 0x40, 0x00, 0x00 }; /*638E*/
const unsigned char  uc2_638F [] = {0x22, 0x00, 0x23, 0xF0, 0x74, 0x10, 0x26, 0x10, 0x2B, 0xD0, 0x35, 0x10, 0x6F, 0xF0, 0x25, 0x50, 0x27, 0xD0, 0x20, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*638F*/
const unsigned char  uc2_6390 [] = {0x11, 0x00, 0x11, 0xE0, 0x7A, 0x20, 0x14, 0x40, 0x12, 0x80, 0x1C, 0x70, 0x74, 0x10, 0x17, 0x70, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6390*/
const unsigned char  uc2_6392 [] = {0x11, 0x40, 0x11, 0x40, 0x7F, 0x70, 0x11, 0x40, 0x11, 0x40, 0x1B, 0x60, 0x71, 0x40, 0x11, 0x40, 0x17, 0x70, 0x11, 0x40, 0x61, 0x40, 0x00, 0x00 }; /*6392*/
const unsigned char  uc2_6396 [] = {0x20, 0x80, 0x2F, 0xF0, 0x72, 0x80, 0x22, 0xE0, 0x25, 0x20, 0x3E, 0xA0, 0x65, 0x40, 0x24, 0x80, 0x24, 0x80, 0x25, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6396*/
const unsigned char  uc2_6398 [] = {0x20, 0x00, 0x27, 0xF0, 0x24, 0x10, 0x77, 0xF0, 0x24, 0x40, 0x35, 0x50, 0x65, 0xF0, 0x24, 0x40, 0x25, 0x50, 0x25, 0xF0, 0x68, 0x10, 0x00, 0x00 }; /*6398*/
const unsigned char  uc2_63A0 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x70, 0x80, 0x12, 0xA0, 0x12, 0x90, 0x14, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*63A0*/
const unsigned char  uc2_63A2 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x10, 0x11, 0x60, 0x16, 0x10, 0x18, 0x80, 0x77, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*63A2*/
const unsigned char  uc2_63A3 [] = {0x28, 0x20, 0x3E, 0xA0, 0x48, 0xA0, 0x3E, 0xA0, 0x2B, 0x20, 0x02, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*63A3*/
const unsigned char  uc2_63A5 [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x19, 0x00, 0x77, 0xF0, 0x12, 0x20, 0x13, 0xC0, 0x10, 0xA0, 0x67, 0x10, 0x00, 0x00 }; /*63A5*/
const unsigned char  uc2_63A7 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0x50, 0x11, 0x20, 0x1A, 0x20, 0x73, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*63A7*/
const unsigned char  uc2_63A8 [] = {0x22, 0x80, 0x22, 0x40, 0x74, 0x40, 0x27, 0xF0, 0x2C, 0x80, 0x37, 0xE0, 0x64, 0x80, 0x27, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x64, 0x00, 0x00, 0x00 }; /*63A8*/
const unsigned char  uc2_63A9 [] = {0x21, 0x00, 0x2F, 0xE0, 0x72, 0x80, 0x2D, 0x60, 0x27, 0xC0, 0x35, 0x40, 0x67, 0xC0, 0x25, 0x40, 0x27, 0xD0, 0x21, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*63A9*/
const unsigned char  uc2_63AA [] = {0x11, 0x40, 0x13, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x10, 0x00, 0x1B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*63AA*/
const unsigned char  uc2_63AC [] = {0x12, 0x00, 0x13, 0xF0, 0x7A, 0x90, 0x14, 0x90, 0x12, 0xB0, 0x19, 0xD0, 0x77, 0xF0, 0x10, 0x90, 0x11, 0xD0, 0x12, 0xB0, 0x64, 0xA0, 0x00, 0x00 }; /*63AC*/
const unsigned char  uc2_63AD [] = {0x2F, 0xE0, 0x21, 0x00, 0x7F, 0xF0, 0x22, 0x80, 0x2C, 0x70, 0x31, 0x00, 0x65, 0xA0, 0x25, 0x50, 0x29, 0x50, 0x21, 0x00, 0x66, 0x00, 0x00, 0x00 }; /*63AD*/
const unsigned char  uc2_63AE [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x17, 0xF0, 0x14, 0x00, 0x1D, 0xF0, 0x75, 0x10, 0x15, 0xF0, 0x15, 0x10, 0x15, 0xD0, 0x69, 0x30, 0x00, 0x00 }; /*63AE*/
const unsigned char  uc2_63B0 [] = {0x11, 0x10, 0x65, 0x60, 0x24, 0xA0, 0x78, 0xF0, 0x2F, 0x20, 0x25, 0x20, 0x7D, 0x70, 0x25, 0x20, 0x25, 0x20, 0x29, 0x20, 0x56, 0x40, 0x00, 0x00 }; /*63B0*/
const unsigned char  uc2_63B3 [] = {0x20, 0xF0, 0x20, 0x80, 0x77, 0xF0, 0x24, 0x90, 0x25, 0xC0, 0x34, 0x90, 0x64, 0xF0, 0x24, 0x40, 0x25, 0xF0, 0x24, 0x90, 0x6B, 0x30, 0x00, 0x00 }; /*63B3*/
const unsigned char  uc2_63B4 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x14, 0x90, 0x1D, 0xD0, 0x74, 0xB0, 0x15, 0xD0, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*63B4*/
const unsigned char  uc2_63B7 [] = {0x29, 0x00, 0x25, 0x70, 0x74, 0x50, 0x27, 0x50, 0x22, 0x60, 0x32, 0x50, 0x67, 0x50, 0x22, 0x50, 0x25, 0x60, 0x25, 0x40, 0x68, 0x40, 0x00, 0x00 }; /*63B7*/
const unsigned char  uc2_63B8 [] = {0x12, 0x20, 0x11, 0x40, 0x7B, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x1A, 0xA0, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*63B8*/
const unsigned char  uc2_63BA [] = {0x11, 0x40, 0x12, 0x60, 0x7B, 0xA0, 0x10, 0x80, 0x17, 0xF0, 0x1A, 0x20, 0x74, 0x90, 0x13, 0x40, 0x10, 0x90, 0x10, 0x60, 0x37, 0x80, 0x00, 0x00 }; /*63BA*/
const unsigned char  uc2_63BC [] = {0x13, 0xE0, 0x12, 0xA0, 0x7F, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x18, 0x00, 0x73, 0xE0, 0x12, 0xA0, 0x12, 0xA0, 0x11, 0x60, 0x76, 0x10, 0x00, 0x00 }; /*63BC*/
const unsigned char  uc2_63BE [] = {0x23, 0xC0, 0x24, 0x40, 0x77, 0x80, 0x20, 0x80, 0x2F, 0xE0, 0x33, 0x00, 0x6D, 0xA0, 0x22, 0xC0, 0x2D, 0xA0, 0x22, 0xA0, 0x6D, 0x10, 0x00, 0x00 }; /*63BE*/
const unsigned char  uc2_63C4 [] = {0x10, 0x80, 0x11, 0x40, 0x7E, 0x30, 0x11, 0xC0, 0x17, 0x10, 0x1D, 0x50, 0x77, 0x50, 0x15, 0x50, 0x17, 0x50, 0x15, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*63C4*/
const unsigned char  uc2_63C6 [] = {0x20, 0xA0, 0x2E, 0xC0, 0x72, 0x90, 0x2A, 0x60, 0x34, 0x40, 0x6B, 0xB0, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x22, 0xC0, 0x4C, 0x30, 0x00, 0x00 }; /*63C6*/
const unsigned char  uc2_63C9 [] = {0x13, 0xC0, 0x11, 0x40, 0x78, 0x80, 0x17, 0xF0, 0x11, 0x90, 0x16, 0xA0, 0x18, 0x80, 0x77, 0xF0, 0x12, 0xC0, 0x12, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*63C9*/
const unsigned char  uc2_63CD [] = {0x21, 0x00, 0x2F, 0xE0, 0x71, 0x00, 0x27, 0xC0, 0x22, 0x00, 0x3F, 0xF0, 0x64, 0x40, 0x2B, 0xB0, 0x21, 0x00, 0x2F, 0xE0, 0x64, 0x40, 0x00, 0x00 }; /*63CD*/
const unsigned char  uc2_63CE [] = {0x11, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x10, 0x13, 0xE0, 0x18, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*63CE*/
const unsigned char  uc2_63CF [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x17, 0xF0, 0x14, 0x90, 0x1C, 0x90, 0x77, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*63CF*/
const unsigned char  uc2_63D0 [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x18, 0x00, 0x77, 0xF0, 0x10, 0x80, 0x12, 0xE0, 0x12, 0x80, 0x6D, 0xF0, 0x00, 0x00 }; /*63D0*/
const unsigned char  uc2_63D2 [] = {0x10, 0x30, 0x17, 0xC0, 0x78, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x1A, 0xB0, 0x74, 0x90, 0x16, 0xB0, 0x14, 0x90, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*63D2*/
const unsigned char  uc2_63D6 [] = {0x13, 0xE0, 0x12, 0x20, 0x7F, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xF0, 0x16, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*63D6*/
const unsigned char  uc2_63DE [] = {0x21, 0x00, 0x27, 0xE0, 0x72, 0x40, 0x2F, 0xF0, 0x20, 0x00, 0x37, 0xE0, 0x64, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x64, 0x20, 0x00, 0x00 }; /*63DE*/
const unsigned char  uc2_63E0 [] = {0x2F, 0xF0, 0x2A, 0x20, 0x7B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x39, 0x00, 0x6F, 0xF0, 0x2A, 0x20, 0x29, 0xC0, 0x2A, 0x20, 0x6F, 0xF0, 0x00, 0x00 }; /*63E0*/
const unsigned char  uc2_63E1 [] = {0x27, 0xE0, 0x24, 0x20, 0x77, 0xE0, 0x24, 0x00, 0x27, 0xE0, 0x35, 0x40, 0x65, 0xA0, 0x24, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x77, 0xF0, 0x00, 0x00 }; /*63E1*/
const unsigned char  uc2_63E3 [] = {0x10, 0x80, 0x14, 0x90, 0x7F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x18, 0x80, 0x77, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x15, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*63E3*/
const unsigned char  uc2_63E9 [] = {0x24, 0x80, 0x24, 0xA0, 0x76, 0xC0, 0x25, 0x90, 0x26, 0x70, 0x31, 0x00, 0x67, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x67, 0xE0, 0x00, 0x00 }; /*63E9*/
const unsigned char  uc2_63EA [] = {0x23, 0x40, 0x2C, 0x40, 0x74, 0x40, 0x25, 0x50, 0x2F, 0x50, 0x35, 0x60, 0x66, 0x40, 0x2D, 0x40, 0x34, 0xA0, 0x24, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*63EA*/
const unsigned char  uc2_63ED [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x19, 0x00, 0x73, 0xF0, 0x1C, 0x90, 0x15, 0x50, 0x17, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*63ED*/
const unsigned char  uc2_63F2 [] = {0x25, 0x20, 0x2F, 0xF0, 0x75, 0x20, 0x25, 0xE0, 0x24, 0x00, 0x37, 0xF0, 0x60, 0x80, 0x27, 0xF0, 0x21, 0xC0, 0x22, 0xA0, 0x6C, 0x90, 0x00, 0x00 }; /*63F2*/
const unsigned char  uc2_63F4 [] = {0x20, 0x30, 0x2F, 0xD0, 0x72, 0xA0, 0x27, 0xE0, 0x31, 0x00, 0x6F, 0xF0, 0x22, 0x00, 0x27, 0xC0, 0x3A, 0x40, 0x21, 0x80, 0x6E, 0x70, 0x00, 0x00 }; /*63F4*/
const unsigned char  uc2_63F6 [] = {0x20, 0x00, 0x2F, 0xF0, 0x75, 0x50, 0x27, 0x50, 0x25, 0x60, 0x37, 0x50, 0x65, 0x50, 0x27, 0xD0, 0x2D, 0x60, 0x21, 0x40, 0x61, 0x40, 0x00, 0x00 }; /*63F6*/
const unsigned char  uc2_63F8 [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0xC0, 0x16, 0xB0, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*63F8*/
const unsigned char  uc2_63FD [] = {0x11, 0x40, 0x15, 0x70, 0x7D, 0x40, 0x15, 0xA0, 0x11, 0x10, 0x1B, 0xE0, 0x72, 0x20, 0x12, 0xA0, 0x10, 0x90, 0x11, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*63FD*/
const unsigned char  uc2_63FF [] = {0x24, 0x40, 0x27, 0x40, 0x78, 0x70, 0x2E, 0x90, 0x24, 0x50, 0x34, 0x60, 0x6F, 0x40, 0x24, 0x40, 0x25, 0xA0, 0x26, 0xA0, 0x41, 0x10, 0x00, 0x00 }; /*63FF*/
const unsigned char  uc2_6400 [] = {0x11, 0xC0, 0x12, 0x40, 0x7F, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x19, 0x50, 0x76, 0x30, 0x11, 0x80, 0x10, 0x40, 0x13, 0x80, 0x60, 0x40, 0x00, 0x00 }; /*6400*/
const unsigned char  uc2_6401 [] = {0x15, 0xF0, 0x12, 0x90, 0x79, 0xD0, 0x17, 0x50, 0x14, 0x90, 0x1F, 0x70, 0x75, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x15, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*6401*/
const unsigned char  uc2_6402 [] = {0x14, 0x90, 0x12, 0xA0, 0x17, 0xF0, 0x79, 0xC0, 0x16, 0xB0, 0x18, 0x80, 0x77, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x10, 0xA0, 0x67, 0x10, 0x00, 0x00 }; /*6402*/
const unsigned char  uc2_6405 [] = {0x15, 0x10, 0x12, 0xA0, 0x7F, 0xF0, 0x14, 0x10, 0x13, 0xE0, 0x1A, 0x20, 0x72, 0xA0, 0x12, 0xA0, 0x11, 0x50, 0x11, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*6405*/
const unsigned char  uc2_640B [] = {0x20, 0x70, 0x2F, 0x80, 0x78, 0x80, 0x2B, 0xF0, 0x2A, 0x80, 0x3B, 0xE0, 0x6A, 0x90, 0x2A, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x75, 0x30, 0x00, 0x00 }; /*640B*/
const unsigned char  uc2_640C [] = {0x27, 0xE0, 0x24, 0x20, 0x77, 0xE0, 0x25, 0x40, 0x27, 0xE0, 0x35, 0x40, 0x67, 0xF0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0x40, 0x73, 0x30, 0x00, 0x00 }; /*640C*/
const unsigned char  uc2_640F [] = {0x10, 0xA0, 0x17, 0xF0, 0x7A, 0xA0, 0x13, 0xE0, 0x1A, 0xA0, 0x73, 0xE0, 0x12, 0xA0, 0x10, 0x40, 0x17, 0xF0, 0x12, 0x40, 0x60, 0xC0, 0x00, 0x00 }; /*640F*/
const unsigned char  uc2_6410 [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x20, 0x13, 0xC0, 0x11, 0x20, 0x1F, 0xF0, 0x72, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*6410*/
const unsigned char  uc2_6413 [] = {0x12, 0x20, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x77, 0xF0, 0x11, 0x00, 0x13, 0xE0, 0x1C, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6413*/
const unsigned char  uc2_6414 [] = {0x17, 0xE0, 0x12, 0xA0, 0x79, 0x40, 0x11, 0xC0, 0x16, 0x30, 0x18, 0x80, 0x73, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x10, 0xA0, 0x67, 0xD0, 0x00, 0x00 }; /*6414*/
const unsigned char  uc2_641B [] = {0x24, 0x40, 0x7F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x32, 0xA0, 0x6F, 0xF0, 0x22, 0xA0, 0x2F, 0xE0, 0x26, 0xC0, 0x3A, 0xB0, 0x62, 0x80, 0x00, 0x00 }; /*641B*/
const unsigned char  uc2_641C [] = {0x22, 0x80, 0x24, 0xB0, 0x74, 0x90, 0x26, 0xB0, 0x24, 0x90, 0x37, 0xF0, 0x60, 0x80, 0x27, 0xE0, 0x22, 0x20, 0x21, 0xC0, 0x6E, 0x30, 0x00, 0x00 }; /*641C*/
const unsigned char  uc2_641E [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x1F, 0xF0, 0x74, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x64, 0x20, 0x00, 0x00 }; /*641E*/
const unsigned char  uc2_6420 [] = {0x28, 0x80, 0x25, 0x70, 0x7F, 0xD0, 0x22, 0x50, 0x2A, 0x70, 0x3A, 0xD0, 0x6F, 0x70, 0x22, 0x50, 0x22, 0x90, 0x24, 0x90, 0x59, 0x20, 0x00, 0x00 }; /*6420*/
const unsigned char  uc2_6421 [] = {0x23, 0xC0, 0x21, 0x40, 0x70, 0x80, 0x21, 0x40, 0x2F, 0xF0, 0x35, 0x50, 0x62, 0x20, 0x25, 0x50, 0x27, 0xF0, 0x22, 0xA0, 0x6C, 0x90, 0x00, 0x00 }; /*6421*/
const unsigned char  uc2_6426 [] = {0x20, 0x00, 0x2E, 0xF0, 0x71, 0x10, 0x27, 0x70, 0x28, 0x80, 0x36, 0xF0, 0x65, 0x50, 0x23, 0x30, 0x2D, 0xD0, 0x21, 0x10, 0x66, 0x60, 0x00, 0x00 }; /*6426*/
const unsigned char  uc2_642A [] = {0x20, 0x80, 0x27, 0xF0, 0x74, 0xA0, 0x27, 0xF0, 0x24, 0xA0, 0x37, 0xE0, 0x64, 0x80, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*642A*/
const unsigned char  uc2_642C [] = {0x24, 0x00, 0x2E, 0xE0, 0x7A, 0xA0, 0x2E, 0xA0, 0x2B, 0x10, 0x3F, 0xE0, 0x6A, 0xA0, 0x2E, 0xA0, 0x2A, 0x40, 0x2A, 0xA0, 0x55, 0x10, 0x00, 0x00 }; /*642C*/
const unsigned char  uc2_642D [] = {0x12, 0x20, 0x17, 0xF0, 0x7A, 0xA0, 0x11, 0x40, 0x16, 0x30, 0x19, 0xC0, 0x70, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*642D*/
const unsigned char  uc2_6434 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x7B, 0xF0, 0x06, 0x00, 0x00, 0x00 }; /*6434*/
const unsigned char  uc2_643A [] = {0x11, 0x00, 0x11, 0x40, 0x7B, 0xF0, 0x16, 0x40, 0x13, 0xF0, 0x1A, 0x40, 0x77, 0xF0, 0x11, 0x40, 0x11, 0x70, 0x12, 0x10, 0x6C, 0x70, 0x00, 0x00 }; /*643A*/
const unsigned char  uc2_643D [] = {0x12, 0x20, 0x17, 0xF0, 0x7A, 0x20, 0x10, 0x80, 0x11, 0x40, 0x1E, 0x30, 0x70, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x12, 0x90, 0x65, 0x90, 0x00, 0x00 }; /*643D*/
const unsigned char  uc2_643F [] = {0x0A, 0x10, 0x73, 0x60, 0x14, 0xA0, 0x78, 0xF0, 0x17, 0x20, 0x10, 0x20, 0x7A, 0xF0, 0x15, 0x20, 0x27, 0x20, 0x25, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*643F*/
const unsigned char  uc2_6441 [] = {0x27, 0xC0, 0x25, 0x40, 0x77, 0xC0, 0x25, 0x40, 0x26, 0xC0, 0x34, 0x40, 0x67, 0xC0, 0x21, 0x20, 0x2A, 0x90, 0x2A, 0x50, 0x71, 0x80, 0x00, 0x00 }; /*6441*/
const unsigned char  uc2_6444 [] = {0x17, 0xE0, 0x12, 0x40, 0x7B, 0xC0, 0x12, 0x70, 0x1F, 0xC0, 0x70, 0x40, 0x1F, 0xF0, 0x15, 0x50, 0x12, 0x20, 0x12, 0x20, 0x6D, 0x50, 0x00, 0x00 }; /*6444*/
const unsigned char  uc2_6445 [] = {0x21, 0x60, 0x21, 0x80, 0x7F, 0xF0, 0x29, 0x50, 0x2F, 0x80, 0x39, 0x20, 0x68, 0xC0, 0x29, 0x00, 0x2A, 0xA0, 0x36, 0x50, 0x69, 0x90, 0x00, 0x00 }; /*6445*/
const unsigned char  uc2_6446 [] = {0x10, 0x00, 0x17, 0xF0, 0x7D, 0x50, 0x17, 0xF0, 0x10, 0x80, 0x1B, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x11, 0x20, 0x12, 0x50, 0x63, 0x90, 0x00, 0x00 }; /*6446*/
const unsigned char  uc2_6447 [] = {0x10, 0x30, 0x17, 0xD0, 0x7A, 0xA0, 0x12, 0x00, 0x1B, 0xE0, 0x74, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x14, 0x90, 0x17, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*6447*/
const unsigned char  uc2_6448 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x50, 0x17, 0x90, 0x12, 0x00, 0x1B, 0xE0, 0x72, 0x40, 0x12, 0x40, 0x17, 0xF0, 0x12, 0x20, 0x6C, 0x10, 0x00, 0x00 }; /*6448*/
const unsigned char  uc2_644A [] = {0x20, 0x40, 0x2E, 0xA0, 0x72, 0xA0, 0x2B, 0xF0, 0x2A, 0xA0, 0x34, 0xF0, 0x64, 0xA0, 0x2A, 0xF0, 0x2A, 0xA0, 0x30, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*644A*/
const unsigned char  uc2_6452 [] = {0x20, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x7F, 0xE0, 0x29, 0x40, 0x3B, 0xE0, 0x69, 0x40, 0x2F, 0xF0, 0x29, 0x40, 0x2A, 0x40, 0x74, 0x40, 0x00, 0x00 }; /*6452*/
const unsigned char  uc2_6454 [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0x80, 0x15, 0x50, 0x13, 0xA0, 0x1D, 0x50, 0x75, 0xD0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6454*/
const unsigned char  uc2_6458 [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x17, 0xF0, 0x14, 0x90, 0x1F, 0xF0, 0x74, 0x90, 0x15, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x64, 0x60, 0x00, 0x00 }; /*6458*/
const unsigned char  uc2_645E [] = {0x17, 0xF0, 0x14, 0x90, 0x7F, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x19, 0x40, 0x73, 0x80, 0x11, 0x20, 0x17, 0xD0, 0x14, 0xA0, 0x6B, 0x10, 0x00, 0x00 }; /*645E*/
const unsigned char  uc2_6467 [] = {0x14, 0x90, 0x17, 0xF0, 0x7A, 0x80, 0x17, 0xF0, 0x14, 0x80, 0x1F, 0xE0, 0x74, 0x80, 0x17, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x64, 0x00, 0x00, 0x00 }; /*6467*/
const unsigned char  uc2_6469 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x46, 0x00, 0x00, 0x00 }; /*6469*/
const unsigned char  uc2_646D [] = {0x20, 0x80, 0x27, 0xF0, 0x74, 0x00, 0x25, 0x20, 0x27, 0xF0, 0x35, 0x20, 0x65, 0xE0, 0x24, 0x00, 0x2A, 0xA0, 0x2D, 0x50, 0x55, 0x50, 0x00, 0x00 }; /*646D*/
const unsigned char  uc2_6478 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x13, 0xE0, 0x1A, 0x20, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x62, 0x20, 0x00, 0x00 }; /*6478*/
const unsigned char  uc2_6479 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x3B, 0xE0, 0x06, 0x00, 0x00, 0x00 }; /*6479*/
const unsigned char  uc2_647A [] = {0x2F, 0xF0, 0x25, 0x50, 0x73, 0x30, 0x2D, 0xD0, 0x22, 0x00, 0x37, 0xE0, 0x64, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x64, 0x20, 0x00, 0x00 }; /*647A*/
const unsigned char  uc2_6482 [] = {0x13, 0xE0, 0x12, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x19, 0x00, 0x73, 0xE0, 0x16, 0x20, 0x11, 0xC0, 0x16, 0x30, 0x63, 0xE0, 0x00, 0x00 }; /*6482*/
const unsigned char  uc2_6484 [] = {0x27, 0x70, 0x25, 0x50, 0x77, 0x70, 0x25, 0x50, 0x32, 0x20, 0x65, 0x50, 0x2F, 0xF0, 0x22, 0x20, 0x23, 0xC0, 0x21, 0x20, 0x6E, 0x10, 0x00, 0x00 }; /*6484*/
const unsigned char  uc2_6485 [] = {0x20, 0x00, 0x2F, 0xF0, 0x7A, 0xA0, 0x2F, 0xB0, 0x29, 0x50, 0x3D, 0x50, 0x6B, 0xA0, 0x29, 0x20, 0x29, 0x20, 0x2A, 0x50, 0x54, 0x90, 0x00, 0x00 }; /*6485*/
const unsigned char  uc2_6487 [] = {0x22, 0x40, 0x2A, 0xC0, 0x77, 0x70, 0x22, 0xA0, 0x2F, 0xA0, 0x3A, 0xA0, 0x6E, 0xA0, 0x2B, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x6B, 0x10, 0x00, 0x00 }; /*6487*/
const unsigned char  uc2_6491 [] = {0x12, 0xA0, 0x17, 0xF0, 0x7C, 0x90, 0x11, 0x60, 0x13, 0x80, 0x18, 0x80, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*6491*/
const unsigned char  uc2_6492 [] = {0x2A, 0x80, 0x3F, 0x80, 0x2A, 0xF0, 0x7F, 0xA0, 0x24, 0xA0, 0x3A, 0xA0, 0x6E, 0x40, 0x2A, 0x40, 0x2E, 0xA0, 0x2A, 0xA0, 0x6D, 0x10, 0x00, 0x00 }; /*6492*/
const unsigned char  uc2_6495 [] = {0x2A, 0x30, 0x2F, 0xC0, 0x7A, 0x80, 0x2E, 0xF0, 0x2A, 0xA0, 0x3E, 0xA0, 0x6A, 0xA0, 0x3F, 0xA0, 0x2A, 0xA0, 0x29, 0x20, 0x71, 0x20, 0x00, 0x00 }; /*6495*/
const unsigned char  uc2_6496 [] = {0x2E, 0x80, 0x24, 0xF0, 0x7F, 0xA0, 0x2A, 0xA0, 0x2F, 0xA0, 0x3A, 0xC0, 0x6E, 0x40, 0x2B, 0x40, 0x3E, 0xA0, 0x22, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*6496*/
const unsigned char  uc2_6499 [] = {0x11, 0x40, 0x17, 0xF0, 0x7A, 0xA0, 0x13, 0x60, 0x13, 0xE0, 0x1A, 0x20, 0x73, 0xE0, 0x10, 0x40, 0x17, 0xF0, 0x12, 0x40, 0x60, 0xC0, 0x00, 0x00 }; /*6499*/
const unsigned char  uc2_649E [] = {0x10, 0x80, 0x13, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x12, 0xA0, 0x1B, 0xE0, 0x72, 0xA0, 0x11, 0x40, 0x13, 0xE0, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*649E*/
const unsigned char  uc2_64A4 [] = {0x24, 0x80, 0x2E, 0x80, 0x74, 0xF0, 0x2B, 0xA0, 0x2E, 0xA0, 0x3A, 0xA0, 0x6E, 0x40, 0x2A, 0x40, 0x2E, 0xA0, 0x2A, 0xA0, 0x67, 0x10, 0x00, 0x00 }; /*64A4*/
const unsigned char  uc2_64A9 [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x50, 0x12, 0x20, 0x17, 0xF0, 0x1A, 0x20, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0xA0, 0x65, 0x90, 0x00, 0x00 }; /*64A9*/
const unsigned char  uc2_64AC [] = {0x27, 0xC0, 0x21, 0x00, 0x77, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x31, 0x10, 0x6E, 0xF0, 0x24, 0x40, 0x2E, 0xE0, 0x25, 0x50, 0x67, 0x70, 0x00, 0x00 }; /*64AC*/
const unsigned char  uc2_64AD [] = {0x20, 0x60, 0x2F, 0xA0, 0x75, 0x40, 0x2F, 0xE0, 0x25, 0x40, 0x39, 0x30, 0x67, 0xC0, 0x25, 0x40, 0x27, 0xC0, 0x25, 0x40, 0x67, 0xC0, 0x00, 0x00 }; /*64AD*/
const unsigned char  uc2_64AE [] = {0x23, 0xE0, 0x22, 0x20, 0x73, 0xE0, 0x22, 0x20, 0x2F, 0xF0, 0x35, 0x00, 0x67, 0xF0, 0x25, 0x50, 0x27, 0xA0, 0x2D, 0x20, 0x61, 0x50, 0x00, 0x00 }; /*64AE*/
const unsigned char  uc2_64B0 [] = {0x2E, 0xE0, 0x2A, 0xA0, 0x7E, 0xE0, 0x28, 0x90, 0x27, 0x60, 0x32, 0x40, 0x67, 0xE0, 0x22, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x6C, 0x20, 0x00, 0x00 }; /*64B0*/
const unsigned char  uc2_64B5 [] = {0x11, 0x40, 0x13, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x12, 0xA0, 0x1F, 0xF0, 0x72, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*64B5*/
const unsigned char  uc2_64B7 [] = {0x25, 0xF0, 0x2E, 0x80, 0x75, 0xF0, 0x2F, 0x10, 0x21, 0x50, 0x3D, 0x50, 0x6B, 0x50, 0x2A, 0x40, 0x2E, 0xA0, 0x2A, 0x90, 0x61, 0x10, 0x00, 0x00 }; /*64B7*/
const unsigned char  uc2_64B8 [] = {0x13, 0xC0, 0x14, 0x40, 0x7F, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x1C, 0x90, 0x77, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x63, 0xE0, 0x00, 0x00 }; /*64B8*/
const unsigned char  uc2_64BA [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x50, 0x12, 0xA0, 0x13, 0xE0, 0x1A, 0xA0, 0x77, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x60, 0x80, 0x00, 0x00 }; /*64BA*/
const unsigned char  uc2_64BC [] = {0x20, 0xA0, 0x2F, 0xF0, 0x78, 0x80, 0x2F, 0xA0, 0x2A, 0x50, 0x3A, 0x50, 0x6E, 0xA0, 0x29, 0x00, 0x2A, 0xA0, 0x36, 0x50, 0x69, 0x90, 0x00, 0x00 }; /*64BC*/
const unsigned char  uc2_64C0 [] = {0x24, 0x40, 0x7F, 0x40, 0x24, 0xA0, 0x2B, 0x10, 0x2E, 0xE0, 0x3A, 0x40, 0x6F, 0xF0, 0x24, 0x40, 0x3F, 0x40, 0x24, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*64C0*/
const unsigned char  uc2_64C2 [] = {0x17, 0xF0, 0x10, 0x80, 0x7F, 0xF0, 0x15, 0x50, 0x12, 0xA0, 0x1B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*64C2*/
const unsigned char  uc2_64C5 [] = {0x22, 0x00, 0x21, 0x00, 0x7F, 0xF0, 0x2A, 0xA0, 0x2B, 0xA0, 0x38, 0x20, 0x6F, 0xE0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x5F, 0xF0, 0x00, 0x00 }; /*64C5*/
const unsigned char  uc2_64CD [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x10, 0x00, 0x17, 0x70, 0x1D, 0x50, 0x77, 0x70, 0x10, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*64CD*/
const unsigned char  uc2_64CE [] = {0x14, 0x80, 0x7F, 0xF0, 0x15, 0x20, 0x3E, 0xA0, 0x6A, 0x40, 0x3B, 0xB0, 0x06, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7B, 0xF0, 0x06, 0x00, 0x00, 0x00 }; /*64CE*/
const unsigned char  uc2_64D0 [] = {0x10, 0x00, 0x17, 0xF0, 0x7D, 0x50, 0x17, 0xF0, 0x12, 0x20, 0x1B, 0xE0, 0x71, 0x40, 0x13, 0x50, 0x1D, 0x20, 0x11, 0x60, 0x61, 0x90, 0x00, 0x00 }; /*64D0*/
const unsigned char  uc2_64D2 [] = {0x11, 0xC0, 0x12, 0xA0, 0x7D, 0xD0, 0x11, 0x40, 0x12, 0xA0, 0x1B, 0x60, 0x77, 0xF0, 0x14, 0x90, 0x15, 0x50, 0x15, 0xD0, 0x64, 0x60, 0x00, 0x00 }; /*64D2*/
const unsigned char  uc2_64D7 [] = {0x20, 0x80, 0x2E, 0x40, 0x7B, 0xF0, 0x2A, 0xA0, 0x2E, 0x40, 0x39, 0xF0, 0x6E, 0x40, 0x2A, 0xE0, 0x2A, 0x40, 0x3E, 0x40, 0x6A, 0x40, 0x00, 0x00 }; /*64D7*/
const unsigned char  uc2_64D8 [] = {0x3C, 0x40, 0x25, 0xF0, 0x38, 0xA0, 0x2B, 0xF0, 0x54, 0x40, 0x5F, 0xE0, 0x02, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7B, 0xF0, 0x06, 0x00, 0x00, 0x00 }; /*64D8*/
const unsigned char  uc2_64DE [] = {0x22, 0x40, 0x2B, 0x40, 0x76, 0x70, 0x2F, 0xD0, 0x2B, 0x50, 0x32, 0xD0, 0x64, 0x50, 0x2F, 0x20, 0x25, 0x50, 0x23, 0x50, 0x6C, 0x90, 0x00, 0x00 }; /*64DE*/
const unsigned char  uc2_64E2 [] = {0x2F, 0xF0, 0x25, 0x50, 0x73, 0x30, 0x2D, 0x50, 0x22, 0x80, 0x33, 0xF0, 0x64, 0x80, 0x2F, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x64, 0x00, 0x00, 0x00 }; /*64E2*/
const unsigned char  uc2_64E4 [] = {0x22, 0x00, 0x27, 0xC0, 0x74, 0x40, 0x27, 0xC0, 0x34, 0x40, 0x6F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x3F, 0xF0, 0x64, 0x40, 0x00, 0x00 }; /*64E4*/
const unsigned char  uc2_64E6 [] = {0x20, 0x80, 0x27, 0xF0, 0x74, 0x10, 0x23, 0x60, 0x35, 0x50, 0x63, 0xF0, 0x2C, 0x10, 0x23, 0xE0, 0x20, 0xA0, 0x22, 0x90, 0x6D, 0x10, 0x00, 0x00 }; /*64E6*/
const unsigned char  uc2_6500 [] = {0x15, 0x40, 0x7A, 0xF0, 0x35, 0x60, 0x50, 0x50, 0x7F, 0xF0, 0x12, 0x40, 0x2F, 0xA0, 0x42, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*6500*/
const unsigned char  uc2_6509 [] = {0x13, 0xE0, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x12, 0xA0, 0x19, 0x40, 0x73, 0xF0, 0x16, 0x40, 0x13, 0xE0, 0x12, 0x40, 0x63, 0xF0, 0x00, 0x00 }; /*6509*/
const unsigned char  uc2_6512 [] = {0x2A, 0xA0, 0x2F, 0xF0, 0x72, 0xA0, 0x2F, 0xF0, 0x35, 0x60, 0x69, 0x90, 0x27, 0xF0, 0x24, 0x10, 0x24, 0x90, 0x21, 0x60, 0x46, 0x10, 0x00, 0x00 }; /*6512*/
const unsigned char  uc2_6518 [] = {0x20, 0x80, 0x2F, 0xF0, 0x7A, 0xA0, 0x2E, 0xE0, 0x24, 0x40, 0x3F, 0xF0, 0x64, 0x40, 0x3F, 0xF0, 0x22, 0xA0, 0x2C, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6518*/
const unsigned char  uc2_6525 [] = {0x24, 0x40, 0x27, 0xF0, 0x2A, 0x20, 0x73, 0xE0, 0x22, 0x20, 0x2F, 0xF0, 0x35, 0x60, 0x6A, 0x90, 0x23, 0xE0, 0x24, 0x90, 0x65, 0x90, 0x00, 0x00 }; /*6525*/
const unsigned char  uc2_652B [] = {0x27, 0x70, 0x25, 0x50, 0x75, 0x50, 0x27, 0xF0, 0x2C, 0x80, 0x37, 0xE0, 0x64, 0x80, 0x27, 0xF0, 0x22, 0x20, 0x21, 0xC0, 0x6E, 0x30, 0x00, 0x00 }; /*652B*/
const unsigned char  uc2_652E [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0xA0, 0x17, 0xF0, 0x15, 0x50, 0x1B, 0xE0, 0x71, 0x40, 0x17, 0xF0, 0x13, 0x50, 0x1D, 0xA0, 0x61, 0x10, 0x00, 0x00 }; /*652E*/
const unsigned char  uc2_652F [] = {0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x10, 0x40, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*652F*/
const unsigned char  uc2_6534 [] = {0x02, 0x00, 0x02, 0x00, 0x03, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x10, 0x40, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*6534*/
const unsigned char  uc2_6536 [] = {0x12, 0x00, 0x12, 0x00, 0x53, 0xE0, 0x52, 0x40, 0x5D, 0x40, 0x51, 0x40, 0x51, 0x40, 0x70, 0x80, 0x11, 0x40, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*6536*/
const unsigned char  uc2_6538 [] = {0x11, 0x00, 0x11, 0x00, 0x2B, 0xE0, 0x2A, 0x40, 0x6D, 0x40, 0x29, 0x40, 0x29, 0x40, 0x28, 0x80, 0x29, 0x40, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*6538*/
const unsigned char  uc2_6539 [] = {0x01, 0x00, 0x79, 0x00, 0x0B, 0xF0, 0x0A, 0x20, 0x7D, 0x20, 0x49, 0x40, 0x41, 0x40, 0x48, 0x80, 0x71, 0x40, 0x41, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*6539*/
const unsigned char  uc2_653B [] = {0x01, 0x00, 0x01, 0x00, 0x3B, 0xF0, 0x12, 0x20, 0x15, 0x20, 0x11, 0x40, 0x11, 0x40, 0x10, 0x80, 0x1D, 0x40, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*653B*/
const unsigned char  uc2_653E [] = {0x21, 0x00, 0x11, 0x00, 0x7D, 0xF0, 0x22, 0x20, 0x3D, 0x20, 0x29, 0x40, 0x29, 0x40, 0x28, 0x80, 0x29, 0x40, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*653E*/
const unsigned char  uc2_653F [] = {0x00, 0x80, 0x3E, 0x80, 0x09, 0xF0, 0x09, 0x20, 0x2A, 0xA0, 0x2E, 0xA0, 0x28, 0xA0, 0x28, 0x40, 0x2E, 0xA0, 0x70, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*653F*/
const unsigned char  uc2_6545 [] = {0x11, 0x00, 0x11, 0xF0, 0x7D, 0x20, 0x12, 0x20, 0x11, 0x20, 0x39, 0x40, 0x29, 0x40, 0x28, 0x80, 0x39, 0x40, 0x21, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*6545*/
const unsigned char  uc2_6548 [] = {0x10, 0x80, 0x7C, 0x80, 0x29, 0xF0, 0x25, 0x20, 0x46, 0xA0, 0x08, 0xA0, 0x68, 0xA0, 0x10, 0x40, 0x28, 0xA0, 0x28, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*6548*/
const unsigned char  uc2_6549 [] = {0x2A, 0x80, 0x2A, 0xF0, 0x1C, 0xA0, 0x08, 0xA0, 0x7F, 0xA0, 0x18, 0xA0, 0x2C, 0xA0, 0x2A, 0x40, 0x4A, 0xA0, 0x08, 0xA0, 0x09, 0x10, 0x00, 0x00 }; /*6549*/
const unsigned char  uc2_654C [] = {0x0C, 0x80, 0x70, 0xF0, 0x11, 0x20, 0x7D, 0x20, 0x12, 0xA0, 0x10, 0xA0, 0x38, 0xA0, 0x28, 0x40, 0x28, 0xA0, 0x38, 0xA0, 0x2B, 0x10, 0x00, 0x00 }; /*654C*/
const unsigned char  uc2_654F [] = {0x20, 0x80, 0x3E, 0x80, 0x41, 0xF0, 0x3D, 0x20, 0x56, 0xA0, 0x54, 0xA0, 0x7E, 0xA0, 0x54, 0x40, 0x7E, 0xA0, 0x04, 0xA0, 0x1B, 0x10, 0x00, 0x00 }; /*654F*/
const unsigned char  uc2_6551 [] = {0x19, 0x00, 0x15, 0xF0, 0x7D, 0x20, 0x12, 0x20, 0x55, 0x20, 0x39, 0x40, 0x11, 0x40, 0x38, 0x80, 0x55, 0x40, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6551*/
const unsigned char  uc2_6555 [] = {0x08, 0x80, 0x3E, 0x80, 0x08, 0xF0, 0x3F, 0x20, 0x2A, 0xA0, 0x3E, 0xA0, 0x08, 0xA0, 0x1C, 0x40, 0x2A, 0xA0, 0x4A, 0xA0, 0x09, 0x10, 0x00, 0x00 }; /*6555*/
const unsigned char  uc2_6556 [] = {0x11, 0x00, 0x7D, 0xE0, 0x12, 0x40, 0x3A, 0x40, 0x11, 0x40, 0x7D, 0x40, 0x21, 0x40, 0x38, 0x80, 0x29, 0x40, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*6556*/
const unsigned char  uc2_6559 [] = {0x10, 0x80, 0x38, 0xF0, 0x15, 0x20, 0x7D, 0x20, 0x0A, 0xA0, 0x3C, 0xA0, 0x64, 0xA0, 0x1E, 0x40, 0x68, 0xA0, 0x08, 0xA0, 0x33, 0x10, 0x00, 0x00 }; /*6559*/
const unsigned char  uc2_655B [] = {0x10, 0x80, 0x18, 0x80, 0x25, 0xF0, 0x5D, 0x20, 0x22, 0xA0, 0x54, 0xA0, 0x24, 0x40, 0x28, 0x40, 0x0C, 0xA0, 0x70, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*655B*/
const unsigned char  uc2_655D [] = {0x10, 0x80, 0x54, 0x80, 0x29, 0xF0, 0x7D, 0x20, 0x56, 0xA0, 0x54, 0xA0, 0x5C, 0xA0, 0x74, 0x40, 0x54, 0xA0, 0x54, 0xA0, 0x5B, 0x10, 0x00, 0x00 }; /*655D*/
const unsigned char  uc2_655E [] = {0x49, 0x40, 0x29, 0x40, 0x2A, 0x70, 0x7F, 0x90, 0x41, 0x50, 0x5D, 0x50, 0x55, 0x50, 0x55, 0x20, 0x5D, 0x50, 0x41, 0x50, 0x46, 0x90, 0x00, 0x00 }; /*655E*/
const unsigned char  uc2_6562 [] = {0x38, 0x80, 0x08, 0xF0, 0x7F, 0x20, 0x25, 0x20, 0x3E, 0xA0, 0x24, 0xA0, 0x3C, 0xA0, 0x26, 0x40, 0x3C, 0xA0, 0x64, 0xA0, 0x07, 0x10, 0x00, 0x00 }; /*6562*/
const unsigned char  uc2_6563 [] = {0x14, 0x80, 0x3E, 0x80, 0x14, 0xF0, 0x7F, 0xA0, 0x22, 0xA0, 0x3E, 0xA0, 0x22, 0xA0, 0x3E, 0x40, 0x22, 0xA0, 0x22, 0xA0, 0x27, 0x10, 0x00, 0x00 }; /*6563*/
const unsigned char  uc2_6566 [] = {0x10, 0x80, 0x7E, 0xF0, 0x25, 0x20, 0x3D, 0x20, 0x02, 0xA0, 0x3C, 0xA0, 0x04, 0xA0, 0x1E, 0x40, 0x68, 0xA0, 0x08, 0xA0, 0x33, 0x10, 0x00, 0x00 }; /*6566*/
const unsigned char  uc2_656B [] = {0x10, 0x80, 0x3C, 0x80, 0x24, 0xF0, 0x3C, 0xA0, 0x25, 0xA0, 0x3C, 0xA0, 0x08, 0xA0, 0x7E, 0x40, 0x10, 0xA0, 0x1C, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*656B*/
const unsigned char  uc2_656C [] = {0x24, 0x80, 0x7E, 0xF0, 0x24, 0xA0, 0x3F, 0x20, 0x42, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x3A, 0x40, 0x2A, 0xA0, 0x02, 0xA0, 0x0D, 0x10, 0x00, 0x00 }; /*656C*/
const unsigned char  uc2_6570 [] = {0x49, 0x80, 0x2A, 0x80, 0x7F, 0xF0, 0x1C, 0xA0, 0x2A, 0xA0, 0x49, 0xA0, 0x08, 0xA0, 0x3E, 0x40, 0x12, 0xA0, 0x0C, 0xA0, 0x73, 0x10, 0x00, 0x00 }; /*6570*/
const unsigned char  uc2_6572 [] = {0x08, 0x20, 0x7F, 0x30, 0x22, 0x20, 0x3E, 0xF0, 0x00, 0x50, 0x7F, 0x50, 0x55, 0x50, 0x55, 0x20, 0x5D, 0x50, 0x41, 0x50, 0x46, 0x90, 0x00, 0x00 }; /*6572*/
const unsigned char  uc2_6574 [] = {0x08, 0x80, 0x7E, 0xF0, 0x2B, 0xA0, 0x3E, 0x40, 0x2A, 0xA0, 0x49, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*6574*/
const unsigned char  uc2_6577 [] = {0x0A, 0x40, 0x7F, 0x40, 0x2A, 0x70, 0x3E, 0xA0, 0x2B, 0xA0, 0x3E, 0xA0, 0x2A, 0x40, 0x7F, 0x40, 0x10, 0xA0, 0x1E, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*6577*/
const unsigned char  uc2_6587 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x08, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*6587*/
const unsigned char  uc2_658B [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*658B*/
const unsigned char  uc2_658C [] = {0x20, 0x40, 0x13, 0x60, 0x78, 0x50, 0x17, 0xF0, 0x10, 0x40, 0x51, 0x40, 0x25, 0xC0, 0x25, 0x40, 0x55, 0xD0, 0x4E, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*658C*/
const unsigned char  uc2_6590 [] = {0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*6590*/
const unsigned char  uc2_6591 [] = {0x75, 0xF0, 0x2E, 0x40, 0x20, 0x40, 0x22, 0x40, 0x7A, 0x40, 0x26, 0xE0, 0x22, 0x40, 0x25, 0x40, 0x35, 0x40, 0x68, 0x40, 0x01, 0xF0, 0x00, 0x00 }; /*6591*/
const unsigned char  uc2_6593 [] = {0x42, 0xF0, 0x25, 0x10, 0x7C, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x55, 0xD0, 0x26, 0xB0, 0x25, 0xD0, 0x56, 0xB0, 0x54, 0x90, 0x04, 0x60, 0x00, 0x00 }; /*6593*/
const unsigned char  uc2_6597 [] = {0x00, 0x80, 0x18, 0x80, 0x04, 0x80, 0x00, 0x80, 0x30, 0x80, 0x08, 0x80, 0x00, 0xF0, 0x7F, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*6597*/
const unsigned char  uc2_6599 [] = {0x10, 0x20, 0x55, 0x20, 0x34, 0xA0, 0x18, 0xA0, 0x7D, 0x20, 0x10, 0xA0, 0x38, 0xA0, 0x54, 0x70, 0x55, 0xA0, 0x50, 0x20, 0x10, 0x20, 0x00, 0x00 }; /*6599*/
const unsigned char  uc2_659B [] = {0x10, 0x20, 0x1D, 0x20, 0x24, 0xA0, 0x3E, 0xA0, 0x6B, 0x20, 0x3E, 0xA0, 0x2A, 0xB0, 0x3E, 0x60, 0x2B, 0xA0, 0x2A, 0x20, 0x44, 0x20, 0x00, 0x00 }; /*659B*/
const unsigned char  uc2_659C [] = {0x08, 0x20, 0x0D, 0x20, 0x12, 0xA0, 0x7E, 0xA0, 0x09, 0x20, 0x3E, 0xA0, 0x08, 0xB0, 0x2C, 0xE0, 0x2B, 0x20, 0x4A, 0x20, 0x30, 0x20, 0x00, 0x00 }; /*659C*/
const unsigned char  uc2_659F [] = {0x12, 0x20, 0x3F, 0x20, 0x12, 0xA0, 0x1E, 0xA0, 0x13, 0x20, 0x1E, 0xA0, 0x12, 0xA0, 0x7F, 0x30, 0x2A, 0x60, 0x31, 0xA0, 0x1F, 0x20, 0x00, 0x00 }; /*659F*/
const unsigned char  uc2_65A1 [] = {0x10, 0x80, 0x7D, 0x40, 0x12, 0x30, 0x38, 0x40, 0x29, 0x40, 0x38, 0xC0, 0x2A, 0x40, 0x39, 0x70, 0x13, 0xC0, 0x7C, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*65A1*/
const unsigned char  uc2_65A4 [] = {0x01, 0xE0, 0x1E, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*65A4*/
const unsigned char  uc2_65A5 [] = {0x00, 0xE0, 0x1F, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x17, 0x00, 0x11, 0xC0, 0x21, 0x20, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*65A5*/
const unsigned char  uc2_65A7 [] = {0x05, 0xC0, 0x38, 0xA0, 0x07, 0x00, 0x78, 0xF0, 0x01, 0x80, 0x3E, 0x00, 0x20, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*65A7*/
const unsigned char  uc2_65A9 [] = {0x10, 0x30, 0x7E, 0xC0, 0x20, 0x80, 0x28, 0x80, 0x48, 0xF0, 0x7E, 0xA0, 0x08, 0xA0, 0x1E, 0xA0, 0x69, 0x20, 0x09, 0x20, 0x0A, 0x20, 0x00, 0x00 }; /*65A9*/
const unsigned char  uc2_65AB [] = {0x00, 0x30, 0x7E, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x20, 0xF0, 0x7C, 0xA0, 0x24, 0xA0, 0x24, 0xA0, 0x3D, 0x20, 0x25, 0x20, 0x02, 0x20, 0x00, 0x00 }; /*65AB*/
const unsigned char  uc2_65AD [] = {0x08, 0x10, 0x6A, 0xE0, 0x5C, 0x80, 0x48, 0x80, 0x7E, 0xF0, 0x4C, 0xA0, 0x5A, 0xA0, 0x6A, 0xA0, 0x48, 0xA0, 0x7E, 0xA0, 0x01, 0x20, 0x00, 0x00 }; /*65AD*/
const unsigned char  uc2_65AF [] = {0x24, 0x30, 0x7E, 0xC0, 0x24, 0x80, 0x3C, 0xF0, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x7E, 0xA0, 0x24, 0xA0, 0x22, 0xA0, 0x43, 0x20, 0x00, 0x00 }; /*65AF*/
const unsigned char  uc2_65B0 [] = {0x08, 0x30, 0x3E, 0xC0, 0x22, 0x80, 0x14, 0x80, 0x7E, 0xF0, 0x08, 0xA0, 0x3E, 0xA0, 0x2C, 0xA0, 0x2A, 0xA0, 0x4A, 0xA0, 0x31, 0x20, 0x00, 0x00 }; /*65B0*/
const unsigned char  uc2_65B9 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x08, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x10, 0x40, 0x10, 0x40, 0x20, 0x80, 0x47, 0x00, 0x00, 0x00 }; /*65B9*/
const unsigned char  uc2_65BC [] = {0x20, 0x80, 0x10, 0x80, 0x79, 0x40, 0x26, 0x30, 0x21, 0x80, 0x38, 0x40, 0x28, 0x40, 0x28, 0x00, 0x29, 0x80, 0x28, 0x40, 0x50, 0x40, 0x00, 0x00 }; /*65BC*/
const unsigned char  uc2_65BD [] = {0x22, 0x00, 0x13, 0xE0, 0x7A, 0x00, 0x24, 0x80, 0x3A, 0xE0, 0x2B, 0xA0, 0x2E, 0xA0, 0x2A, 0xC0, 0x2A, 0x90, 0x2A, 0x10, 0x51, 0xE0, 0x00, 0x00 }; /*65BD*/
const unsigned char  uc2_65C1 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x3F, 0xE0, 0x08, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x10, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*65C1*/
const unsigned char  uc2_65C3 [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x00, 0x23, 0xE0, 0x3A, 0x20, 0x2A, 0xA0, 0x2F, 0xF0, 0x2A, 0x20, 0x2A, 0x20, 0x2A, 0x20, 0x54, 0xC0, 0x00, 0x00 }; /*65C3*/
const unsigned char  uc2_65C4 [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x00, 0x20, 0x60, 0x3B, 0x80, 0x28, 0xE0, 0x2B, 0x80, 0x28, 0xF0, 0x2B, 0x80, 0x28, 0x90, 0x50, 0x60, 0x00, 0x00 }; /*65C4*/
const unsigned char  uc2_65C5 [] = {0x22, 0x00, 0x13, 0xF0, 0x7A, 0x00, 0x24, 0x60, 0x3B, 0x80, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x60, 0x2A, 0x20, 0x2A, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*65C5*/
const unsigned char  uc2_65C6 [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x00, 0x20, 0x80, 0x3B, 0xE0, 0x28, 0x80, 0x2B, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xC0, 0x50, 0x80, 0x00, 0x00 }; /*65C6*/
const unsigned char  uc2_65CB [] = {0x22, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x24, 0x00, 0x23, 0xF0, 0x38, 0x90, 0x2A, 0x80, 0x2A, 0xE0, 0x2A, 0x80, 0x2B, 0x80, 0x54, 0x70, 0x00, 0x00 }; /*65CB*/
const unsigned char  uc2_65CC [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x00, 0x22, 0x80, 0x3B, 0xF0, 0x2C, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*65CC*/
const unsigned char  uc2_65CE [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x00, 0x23, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x2A, 0x90, 0x2A, 0xE0, 0x2A, 0x90, 0x2A, 0x90, 0x54, 0x60, 0x00, 0x00 }; /*65CE*/
const unsigned char  uc2_65CF [] = {0x22, 0x00, 0x13, 0xF0, 0x7D, 0x00, 0x21, 0xE0, 0x3A, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x29, 0x40, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*65CF*/
const unsigned char  uc2_65D2 [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x40, 0x23, 0xF0, 0x39, 0x20, 0x29, 0xD0, 0x28, 0x10, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x54, 0xB0, 0x00, 0x00 }; /*65D2*/
const unsigned char  uc2_65D6 [] = {0x22, 0x00, 0x13, 0xF0, 0x7C, 0x80, 0x23, 0xE0, 0x39, 0x40, 0x2F, 0xF0, 0x28, 0x20, 0x2B, 0xA0, 0x2A, 0xA0, 0x2B, 0xA0, 0x52, 0x60, 0x00, 0x00 }; /*65D6*/
const unsigned char  uc2_65D7 [] = {0x22, 0x00, 0x13, 0xF0, 0x7D, 0x20, 0x23, 0xF0, 0x39, 0x20, 0x29, 0xE0, 0x29, 0x20, 0x29, 0xE0, 0x29, 0x20, 0x2F, 0xF0, 0x5A, 0x20, 0x00, 0x00 }; /*65D7*/
const unsigned char  uc2_65E0 [] = {0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*65E0*/
const unsigned char  uc2_65E2 [] = {0x7B, 0xE0, 0x48, 0x40, 0x79, 0x40, 0x4A, 0x40, 0x7B, 0xF0, 0x40, 0x80, 0x50, 0xC0, 0x49, 0x50, 0x59, 0x50, 0x6A, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*65E2*/
const unsigned char  uc2_65E5 [] = {0x00, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*65E5*/
const unsigned char  uc2_65E6 [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*65E6*/
const unsigned char  uc2_65E7 [] = {0x20, 0x00, 0x27, 0xF0, 0x24, 0x10, 0x24, 0x10, 0x24, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x24, 0x10, 0x24, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x00, 0x00 }; /*65E7*/
const unsigned char  uc2_65E8 [] = {0x21, 0xC0, 0x3E, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*65E8*/
const unsigned char  uc2_65E9 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*65E9*/
const unsigned char  uc2_65EC [] = {0x08, 0x00, 0x0F, 0xF0, 0x10, 0x10, 0x6F, 0x90, 0x08, 0x90, 0x0F, 0x90, 0x08, 0x90, 0x0F, 0x90, 0x08, 0x90, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*65EC*/
const unsigned char  uc2_65ED [] = {0x10, 0x00, 0x11, 0xC0, 0x7D, 0x40, 0x15, 0x40, 0x15, 0xC0, 0x15, 0x40, 0x15, 0x40, 0x25, 0xD0, 0x25, 0x50, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*65ED*/
const unsigned char  uc2_65EE [] = {0x04, 0x00, 0x3F, 0xC0, 0x04, 0x50, 0x08, 0x90, 0x70, 0x60, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*65EE*/
const unsigned char  uc2_65EF [] = {0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x40, 0x08, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*65EF*/
const unsigned char  uc2_65F0 [] = {0x03, 0xE0, 0x78, 0x80, 0x48, 0x80, 0x48, 0x80, 0x7F, 0xF0, 0x48, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*65F0*/
const unsigned char  uc2_65F1 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*65F1*/
const unsigned char  uc2_65F6 [] = {0x00, 0x40, 0x70, 0x40, 0x57, 0xF0, 0x50, 0x40, 0x70, 0x40, 0x52, 0x40, 0x51, 0x40, 0x71, 0x40, 0x50, 0x40, 0x00, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*65F6*/
const unsigned char  uc2_65F7 [] = {0x01, 0x00, 0x38, 0x80, 0x2B, 0xF0, 0x2A, 0x00, 0x3A, 0x00, 0x2A, 0x00, 0x2A, 0x00, 0x3A, 0x00, 0x2A, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*65F7*/
const unsigned char  uc2_65FA [] = {0x07, 0xF0, 0x78, 0x80, 0x48, 0x80, 0x48, 0x80, 0x78, 0x80, 0x4B, 0xE0, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x00, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*65FA*/
const unsigned char  uc2_6600 [] = {0x02, 0x00, 0x73, 0xF0, 0x54, 0x10, 0x58, 0x10, 0x73, 0x10, 0x50, 0x90, 0x50, 0xD0, 0x77, 0x10, 0x50, 0x10, 0x00, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*6600*/
const unsigned char  uc2_6602 [] = {0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x04, 0x00, 0x79, 0xF0, 0x41, 0x10, 0x4D, 0x10, 0x71, 0x60, 0x01, 0x00, 0x00, 0x00 }; /*6602*/
const unsigned char  uc2_6603 [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x22, 0x80, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*6603*/
const unsigned char  uc2_6606 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x21, 0x00, 0x21, 0x30, 0x3D, 0xC0, 0x21, 0x10, 0x25, 0x10, 0x38, 0xE0, 0x00, 0x00 }; /*6606*/
const unsigned char  uc2_660A [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*660A*/
const unsigned char  uc2_660C [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*660C*/
const unsigned char  uc2_660E [] = {0x01, 0xF0, 0x79, 0x10, 0x49, 0x10, 0x49, 0xF0, 0x79, 0x10, 0x49, 0x10, 0x49, 0xF0, 0x79, 0x10, 0x4A, 0x10, 0x02, 0x10, 0x0C, 0x60, 0x00, 0x00 }; /*660E*/
const unsigned char  uc2_660F [] = {0x01, 0xC0, 0x7E, 0x00, 0x42, 0x00, 0x7F, 0xE0, 0x41, 0x10, 0x7F, 0xE0, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x00, 0x00 }; /*660F*/
const unsigned char  uc2_6613 [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x08, 0x00, 0x0F, 0xF0, 0x32, 0x50, 0x0C, 0x90, 0x73, 0x20, 0x0C, 0xC0, 0x00, 0x00 }; /*6613*/
const unsigned char  uc2_6614 [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*6614*/
const unsigned char  uc2_6615 [] = {0x00, 0x60, 0x7B, 0x80, 0x4A, 0x00, 0x4A, 0x00, 0x7B, 0xF0, 0x4A, 0x40, 0x4A, 0x40, 0x7A, 0x40, 0x4A, 0x40, 0x04, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*6615*/
const unsigned char  uc2_6619 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xA0, 0x00, 0x00 }; /*6619*/
const unsigned char  uc2_661D [] = {0x10, 0x80, 0x1C, 0xC0, 0x64, 0xA0, 0x18, 0xA0, 0x24, 0x00, 0x5F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*661D*/
const unsigned char  uc2_661F [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x12, 0x00, 0x1F, 0xE0, 0x62, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*661F*/
const unsigned char  uc2_6620 [] = {0x00, 0x80, 0x78, 0x80, 0x4B, 0xE0, 0x4A, 0xA0, 0x7A, 0xA0, 0x4A, 0xA0, 0x4F, 0xF0, 0x78, 0x80, 0x49, 0x40, 0x01, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*6620*/
const unsigned char  uc2_6625 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x0D, 0x80, 0x18, 0xC0, 0x6F, 0xB0, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x00 }; /*6625*/
const unsigned char  uc2_6627 [] = {0x00, 0x80, 0x73, 0xE0, 0x50, 0x80, 0x50, 0x80, 0x77, 0xF0, 0x51, 0xC0, 0x52, 0xA0, 0x72, 0xA0, 0x42, 0xA0, 0x04, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*6627*/
const unsigned char  uc2_6628 [] = {0x02, 0x00, 0x73, 0xF0, 0x55, 0x00, 0x55, 0x00, 0x79, 0xE0, 0x51, 0x00, 0x51, 0x00, 0x71, 0xE0, 0x51, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*6628*/
const unsigned char  uc2_662D [] = {0x07, 0xF0, 0x71, 0x10, 0x51, 0x10, 0x52, 0x10, 0x72, 0xE0, 0x5C, 0x00, 0x53, 0xF0, 0x72, 0x10, 0x52, 0x10, 0x03, 0xF0, 0x02, 0x10, 0x00, 0x00 }; /*662D*/
const unsigned char  uc2_662F [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x1E, 0x00, 0x61, 0xF0, 0x00, 0x00 }; /*662F*/
const unsigned char  uc2_6631 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x04, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*6631*/
const unsigned char  uc2_6634 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x00, 0x75, 0xF0, 0x4D, 0x10, 0x75, 0x10, 0x09, 0x60, 0x71, 0x00, 0x00, 0x00 }; /*6634*/
const unsigned char  uc2_6635 [] = {0x07, 0xE0, 0x74, 0x20, 0x54, 0x20, 0x57, 0xE0, 0x74, 0x00, 0x55, 0x00, 0x55, 0x60, 0x75, 0x80, 0x55, 0x10, 0x09, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*6635*/
const unsigned char  uc2_6636 [] = {0x08, 0x00, 0x1C, 0x70, 0x05, 0x50, 0x75, 0x50, 0x15, 0x70, 0x16, 0x50, 0x25, 0x50, 0x25, 0x70, 0x44, 0x80, 0x04, 0x70, 0x18, 0x00, 0x00, 0x00 }; /*6636*/
const unsigned char  uc2_663C [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x80, 0x1F, 0xC0, 0x28, 0x60, 0x2F, 0xD0, 0x48, 0x40, 0x0F, 0xC0, 0x00, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*663C*/
const unsigned char  uc2_663E [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x25, 0x20, 0x15, 0x20, 0x15, 0x40, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*663E*/
const unsigned char  uc2_6641 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x20, 0x35, 0x20, 0x0D, 0xC0, 0x35, 0x20, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*6641*/
const unsigned char  uc2_6643 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*6643*/
const unsigned char  uc2_664B [] = {0x3F, 0xE0, 0x05, 0x40, 0x15, 0x40, 0x0D, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*664B*/
const unsigned char  uc2_664C [] = {0x01, 0x00, 0x77, 0xF0, 0x54, 0x10, 0x55, 0xD0, 0x75, 0x50, 0x55, 0x50, 0x55, 0xD0, 0x75, 0x50, 0x54, 0x10, 0x04, 0x10, 0x04, 0xE0, 0x00, 0x00 }; /*664C*/
const unsigned char  uc2_664F [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x44, 0x10, 0x08, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x00, 0x38, 0xE0, 0x00, 0x00 }; /*664F*/
const unsigned char  uc2_6652 [] = {0x07, 0xF0, 0x71, 0x40, 0x51, 0x40, 0x57, 0xF0, 0x75, 0x50, 0x55, 0x50, 0x55, 0x30, 0x76, 0x10, 0x54, 0x10, 0x07, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*6652*/
const unsigned char  uc2_6653 [] = {0x02, 0x00, 0x72, 0xC0, 0x5F, 0x20, 0x52, 0x40, 0x71, 0x90, 0x56, 0xE0, 0x50, 0x00, 0x7F, 0xE0, 0x52, 0x90, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*6653*/
const unsigned char  uc2_6654 [] = {0x02, 0x80, 0x72, 0xA0, 0x54, 0xC0, 0x5D, 0x90, 0x74, 0x90, 0x54, 0x60, 0x51, 0x00, 0x7F, 0xF0, 0x51, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*6654*/
const unsigned char  uc2_6655 [] = {0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x44, 0x10, 0x3F, 0xE0, 0x0A, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*6655*/
const unsigned char  uc2_6656 [] = {0x0F, 0xF0, 0x78, 0x10, 0x51, 0x00, 0x57, 0xE0, 0x71, 0x00, 0x52, 0x80, 0x53, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*6656*/
const unsigned char  uc2_6657 [] = {0x00, 0x80, 0x79, 0x40, 0x4E, 0xB0, 0x48, 0x40, 0x7B, 0xE0, 0x48, 0x20, 0x48, 0x40, 0x7B, 0xE0, 0x4A, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*6657*/
const unsigned char  uc2_665A [] = {0x02, 0x00, 0x73, 0xC0, 0x54, 0x40, 0x5F, 0xE0, 0x74, 0xA0, 0x55, 0x20, 0x57, 0xE0, 0x71, 0x40, 0x51, 0x50, 0x02, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*665A*/
const unsigned char  uc2_665F [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x01, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x3D, 0x40, 0x24, 0x90, 0x4D, 0x70, 0x00, 0x00 }; /*665F*/
const unsigned char  uc2_6661 [] = {0x00, 0xA0, 0x77, 0xF0, 0x50, 0x80, 0x57, 0xF0, 0x74, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x77, 0xF0, 0x54, 0x90, 0x04, 0x90, 0x04, 0x60, 0x00, 0x00 }; /*6661*/
const unsigned char  uc2_6664 [] = {0x0F, 0xE0, 0x71, 0x00, 0x57, 0xC0, 0x52, 0x40, 0x7F, 0xF0, 0x50, 0x00, 0x57, 0xC0, 0x74, 0x40, 0x54, 0x40, 0x07, 0xC0, 0x04, 0x40, 0x00, 0x00 }; /*6664*/
const unsigned char  uc2_6666 [] = {0x02, 0x00, 0x73, 0xF0, 0x54, 0x00, 0x5B, 0xE0, 0x72, 0xA0, 0x5F, 0xF0, 0x55, 0x20, 0x74, 0xA0, 0x57, 0xF0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*6666*/
const unsigned char  uc2_6668 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x20, 0x00, 0x2F, 0xC0, 0x20, 0x00, 0x3F, 0xE0, 0x29, 0x40, 0x4C, 0xF0, 0x00, 0x00 }; /*6668*/
const unsigned char  uc2_666E [] = {0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x15, 0x40, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*666E*/
const unsigned char  uc2_666F [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x46, 0x10, 0x00, 0x00 }; /*666F*/
const unsigned char  uc2_6670 [] = {0x04, 0x30, 0x74, 0xC0, 0x5E, 0x80, 0x54, 0x80, 0x76, 0xF0, 0x5D, 0xA0, 0x54, 0xA0, 0x74, 0xA0, 0x55, 0x20, 0x05, 0x20, 0x06, 0x20, 0x00, 0x00 }; /*6670*/
const unsigned char  uc2_6674 [] = {0x00, 0x80, 0x77, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x03, 0xA0, 0x02, 0x60, 0x00, 0x00 }; /*6674*/
const unsigned char  uc2_6676 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7D, 0xF0, 0x45, 0x10, 0x7D, 0xF0, 0x45, 0x10, 0x7D, 0xF0, 0x00, 0x00 }; /*6676*/
const unsigned char  uc2_6677 [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x12, 0x40, 0x6C, 0x60, 0x12, 0x50, 0x7F, 0xF0, 0x10, 0x20, 0x1F, 0xE0, 0x00, 0x00 }; /*6677*/
const unsigned char  uc2_667A [] = {0x10, 0x00, 0x1E, 0xF0, 0x24, 0x90, 0x3F, 0x90, 0x0A, 0xF0, 0x11, 0x00, 0x6F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*667A*/
const unsigned char  uc2_667E [] = {0x00, 0x80, 0x77, 0xF0, 0x50, 0x00, 0x53, 0xE0, 0x72, 0x20, 0x52, 0x20, 0x53, 0xE0, 0x70, 0x80, 0x54, 0xA0, 0x04, 0x90, 0x0B, 0x10, 0x00, 0x00 }; /*667E*/
const unsigned char  uc2_6682 [] = {0x7C, 0x30, 0x29, 0xC0, 0x3D, 0x00, 0x0B, 0xF0, 0x7D, 0x40, 0x0A, 0x40, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*6682*/
const unsigned char  uc2_6684 [] = {0x00, 0x80, 0x77, 0xF0, 0x54, 0x10, 0x53, 0xE0, 0x70, 0x00, 0x53, 0xE0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*6684*/
const unsigned char  uc2_6687 [] = {0x07, 0x70, 0x75, 0x10, 0x55, 0x10, 0x57, 0x70, 0x74, 0x00, 0x57, 0xF0, 0x54, 0x50, 0x77, 0x50, 0x54, 0x20, 0x04, 0x20, 0x04, 0xD0, 0x00, 0x00 }; /*6687*/
const unsigned char  uc2_668C [] = {0x07, 0x40, 0x71, 0x50, 0x55, 0x60, 0x52, 0x50, 0x74, 0x20, 0x5B, 0xD0, 0x50, 0x80, 0x77, 0xF0, 0x50, 0x80, 0x01, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*668C*/
const unsigned char  uc2_6691 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x20, 0x1F, 0xE0, 0x68, 0x20, 0x0F, 0xE0, 0x00, 0x00 }; /*6691*/
const unsigned char  uc2_6696 [] = {0x00, 0x30, 0x77, 0xC0, 0x52, 0xA0, 0x57, 0xE0, 0x71, 0x00, 0x57, 0xF0, 0x52, 0x00, 0x75, 0xE0, 0x55, 0x20, 0x08, 0xC0, 0x07, 0x30, 0x00, 0x00 }; /*6696*/
const unsigned char  uc2_6697 [] = {0x01, 0x00, 0x77, 0xE0, 0x52, 0x40, 0x5F, 0xF0, 0x70, 0x00, 0x57, 0xE0, 0x54, 0x20, 0x77, 0xE0, 0x54, 0x20, 0x07, 0xE0, 0x04, 0x20, 0x00, 0x00 }; /*6697*/
const unsigned char  uc2_669D [] = {0x07, 0xF0, 0x74, 0x10, 0x53, 0xE0, 0x52, 0x20, 0x73, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x02, 0x20, 0x04, 0x10, 0x00, 0x00 }; /*669D*/
const unsigned char  uc2_66A7 [] = {0x00, 0x70, 0x7F, 0xA0, 0x55, 0x40, 0x57, 0xF0, 0x79, 0x10, 0x57, 0xE0, 0x52, 0x00, 0x77, 0xC0, 0x5A, 0x40, 0x01, 0x80, 0x0E, 0x70, 0x00, 0x00 }; /*66A7*/
const unsigned char  uc2_66A8 [] = {0x7B, 0xE0, 0x4A, 0x80, 0x7B, 0xF0, 0x50, 0xC0, 0x59, 0x50, 0x6A, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*66A8*/
const unsigned char  uc2_66AE [] = {0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x68, 0xB0, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x00 }; /*66AE*/
const unsigned char  uc2_66B4 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x2A, 0x60, 0x47, 0x90, 0x1A, 0x40, 0x06, 0x00, 0x00, 0x00 }; /*66B4*/
const unsigned char  uc2_66B9 [] = {0x47, 0xE0, 0x24, 0x20, 0x27, 0xE0, 0x04, 0x20, 0x67, 0xE0, 0x22, 0x80, 0x27, 0xF0, 0x2C, 0x80, 0x27, 0xE0, 0x54, 0x80, 0x4F, 0xF0, 0x00, 0x00 }; /*66B9*/
const unsigned char  uc2_66BE [] = {0x02, 0x40, 0x7F, 0xC0, 0x55, 0x70, 0x57, 0x50, 0x70, 0x90, 0x57, 0x50, 0x51, 0x50, 0x73, 0xA0, 0x5E, 0x50, 0x02, 0x50, 0x06, 0x90, 0x00, 0x00 }; /*66BE*/
const unsigned char  uc2_66D9 [] = {0x0F, 0xE0, 0x7A, 0xA0, 0x5F, 0xE0, 0x51, 0x00, 0x77, 0xA0, 0x51, 0x40, 0x5F, 0xF0, 0x72, 0x40, 0x57, 0xC0, 0x0A, 0x40, 0x03, 0xC0, 0x00, 0x00 }; /*66D9*/
const unsigned char  uc2_66DB [] = {0x07, 0xF0, 0x70, 0x80, 0x57, 0xF0, 0x5D, 0x50, 0x77, 0xF0, 0x50, 0x80, 0x57, 0xF0, 0x70, 0x80, 0x5F, 0xF0, 0x0A, 0xA0, 0x11, 0x50, 0x00, 0x00 }; /*66DB*/
const unsigned char  uc2_66DC [] = {0x0F, 0xF0, 0x75, 0x50, 0x53, 0x30, 0x55, 0x50, 0x72, 0x80, 0x57, 0xF0, 0x5C, 0x80, 0x77, 0xE0, 0x54, 0x80, 0x07, 0xF0, 0x04, 0x00, 0x00, 0x00 }; /*66DC*/
const unsigned char  uc2_66DD [] = {0x03, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x51, 0x40, 0x77, 0xF0, 0x51, 0x40, 0x5F, 0xF0, 0x72, 0xA0, 0x5C, 0x90, 0x02, 0xA0, 0x05, 0x90, 0x00, 0x00 }; /*66DD*/
const unsigned char  uc2_66E6 [] = {0x01, 0x40, 0x77, 0xF0, 0x50, 0x80, 0x53, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x52, 0x40, 0x77, 0x50, 0x52, 0x60, 0x07, 0xD0, 0x01, 0x30, 0x00, 0x00 }; /*66E6*/
const unsigned char  uc2_66E9 [] = {0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x25, 0x20, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x29, 0x40, 0x4C, 0xF0, 0x00, 0x00 }; /*66E9*/
const unsigned char  uc2_66EF [] = {0x1F, 0xF0, 0x70, 0x10, 0x5F, 0xF0, 0x55, 0x40, 0x7F, 0xE0, 0x5A, 0xA0, 0x57, 0xF0, 0x7D, 0x50, 0x57, 0xD0, 0x11, 0x50, 0x2F, 0xB0, 0x00, 0x00 }; /*66EF*/
const unsigned char  uc2_66F0 [] = {0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xA0, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*66F0*/
const unsigned char  uc2_66F2 [] = {0x05, 0x00, 0x05, 0x00, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*66F2*/
const unsigned char  uc2_66F3 [] = {0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0xA0, 0x02, 0xD0, 0x0F, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*66F3*/
const unsigned char  uc2_66F4 [] = {0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x12, 0x00, 0x0C, 0x00, 0x0B, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*66F4*/
const unsigned char  uc2_66F7 [] = {0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x08, 0x00, 0x1F, 0xF0, 0x62, 0x10, 0x25, 0x10, 0x3F, 0xD0, 0x00, 0x60, 0x00, 0x00 }; /*66F7*/
const unsigned char  uc2_66F9 [] = {0x05, 0x00, 0x05, 0x00, 0x7F, 0xF0, 0x25, 0x20, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*66F9*/
const unsigned char  uc2_66FC [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x48, 0x90, 0x7F, 0xF0, 0x10, 0x40, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*66FC*/
const unsigned char  uc2_66FE [] = {0x10, 0x40, 0x3F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x25, 0x20, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*66FE*/
const unsigned char  uc2_66FF [] = {0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x7D, 0xF0, 0x28, 0xA0, 0x45, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*66FF*/
const unsigned char  uc2_6700 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x24, 0x00, 0x3D, 0xE0, 0x24, 0xA0, 0x3E, 0xA0, 0x64, 0x40, 0x05, 0xB0, 0x00, 0x00 }; /*6700*/
const unsigned char  uc2_6708 [] = {0x0F, 0xE0, 0x08, 0x20, 0x08, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x08, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x08, 0x20, 0x10, 0x20, 0x61, 0xC0, 0x00, 0x00 }; /*6708*/
const unsigned char  uc2_6709 [] = {0x04, 0x00, 0x3F, 0xF0, 0x04, 0x00, 0x0F, 0xC0, 0x18, 0x40, 0x6F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x08, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*6709*/
const unsigned char  uc2_670A [] = {0x38, 0x00, 0x2B, 0xE0, 0x28, 0x00, 0x38, 0x00, 0x2F, 0xF0, 0x29, 0x40, 0x39, 0x40, 0x29, 0x40, 0x2A, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*670A*/
const unsigned char  uc2_670B [] = {0x1E, 0xF0, 0x12, 0x90, 0x12, 0x90, 0x1E, 0xF0, 0x12, 0x90, 0x12, 0x90, 0x1E, 0xF0, 0x12, 0x90, 0x22, 0x90, 0x22, 0x90, 0x4D, 0x60, 0x00, 0x00 }; /*670B*/
const unsigned char  uc2_670D [] = {0x3B, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x3A, 0xC0, 0x2A, 0x00, 0x2B, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0x40, 0x2A, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*670D*/
const unsigned char  uc2_6710 [] = {0x39, 0x00, 0x29, 0xF0, 0x2A, 0x10, 0x3A, 0x10, 0x2D, 0xD0, 0x29, 0x50, 0x39, 0x50, 0x29, 0xD0, 0x29, 0x50, 0x28, 0x10, 0x50, 0xE0, 0x00, 0x00 }; /*6710*/
const unsigned char  uc2_6714 [] = {0x22, 0xF0, 0x14, 0x90, 0x7F, 0x90, 0x08, 0xF0, 0x2A, 0x90, 0x2A, 0x90, 0x2A, 0xF0, 0x3E, 0x90, 0x09, 0x10, 0x11, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*6714*/
const unsigned char  uc2_6715 [] = {0x3A, 0x20, 0x29, 0x40, 0x2B, 0xE0, 0x38, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x29, 0x40, 0x29, 0x40, 0x2A, 0x20, 0x54, 0x10, 0x00, 0x00 }; /*6715*/
const unsigned char  uc2_6717 [] = {0x10, 0x00, 0x08, 0xF0, 0x3E, 0x90, 0x22, 0x90, 0x3E, 0xF0, 0x22, 0x90, 0x3E, 0x90, 0x20, 0xF0, 0x24, 0x90, 0x2A, 0x90, 0x33, 0x60, 0x00, 0x00 }; /*6717*/
const unsigned char  uc2_671B [] = {0x08, 0xF0, 0x7E, 0x90, 0x20, 0xF0, 0x26, 0x90, 0x38, 0xF0, 0x01, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*671B*/
const unsigned char  uc2_671D [] = {0x08, 0xF0, 0x7F, 0x90, 0x08, 0x90, 0x3E, 0xF0, 0x22, 0x90, 0x3E, 0x90, 0x22, 0xF0, 0x3E, 0x90, 0x08, 0x90, 0x7F, 0x10, 0x09, 0x30, 0x00, 0x00 }; /*671D*/
const unsigned char  uc2_671F [] = {0x24, 0xF0, 0x7E, 0x90, 0x24, 0x90, 0x3C, 0xF0, 0x24, 0x90, 0x3C, 0x90, 0x24, 0xF0, 0x7F, 0x90, 0x24, 0x90, 0x22, 0x90, 0x43, 0x60, 0x00, 0x00 }; /*671F*/
const unsigned char  uc2_6726 [] = {0x39, 0x20, 0x2F, 0xF0, 0x29, 0x20, 0x3B, 0xF0, 0x2A, 0x90, 0x28, 0x40, 0x3B, 0xF0, 0x2D, 0x90, 0x2A, 0xE0, 0x29, 0x50, 0x56, 0xD0, 0x00, 0x00 }; /*6726*/
const unsigned char  uc2_6728 [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x07, 0x00, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*6728*/
const unsigned char  uc2_672A [] = {0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x07, 0x00, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*672A*/
const unsigned char  uc2_672B [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x07, 0x00, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*672B*/
const unsigned char  uc2_672C [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x0B, 0x00, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*672C*/
const unsigned char  uc2_672D [] = {0x08, 0x80, 0x08, 0x80, 0x3E, 0x80, 0x18, 0x80, 0x2C, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x48, 0x80, 0x48, 0x90, 0x08, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*672D*/
const unsigned char  uc2_672F [] = {0x02, 0x80, 0x02, 0x40, 0x3F, 0xE0, 0x07, 0x00, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x12, 0x40, 0x12, 0x20, 0x62, 0x10, 0x02, 0x00, 0x00, 0x00 }; /*672F*/
const unsigned char  uc2_6731 [] = {0x02, 0x00, 0x12, 0x00, 0x1F, 0xE0, 0x62, 0x00, 0x02, 0x00, 0x3F, 0xF0, 0x07, 0x00, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*6731*/
const unsigned char  uc2_6734 [] = {0x08, 0x80, 0x08, 0x80, 0x3E, 0x80, 0x08, 0xC0, 0x1C, 0xA0, 0x2A, 0x90, 0x2A, 0x90, 0x28, 0x80, 0x48, 0x80, 0x08, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*6734*/
const unsigned char  uc2_6735 [] = {0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x22, 0x60, 0x02, 0x00, 0x3F, 0xE0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*6735*/
const unsigned char  uc2_673A [] = {0x10, 0x00, 0x11, 0xC0, 0x7D, 0x40, 0x11, 0x40, 0x39, 0x40, 0x55, 0x40, 0x55, 0x40, 0x51, 0x40, 0x11, 0x50, 0x11, 0x50, 0x16, 0x20, 0x00, 0x00 }; /*673A*/
const unsigned char  uc2_673D [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x00, 0x11, 0x00, 0x32, 0x00, 0x5B, 0xE0, 0x54, 0x20, 0x50, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*673D*/
const unsigned char  uc2_6740 [] = {0x00, 0x40, 0x38, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x62, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x12, 0x20, 0x22, 0x10, 0x4C, 0x10, 0x00, 0x00 }; /*6740*/
const unsigned char  uc2_6742 [] = {0x04, 0x00, 0x07, 0x80, 0x7C, 0x90, 0x08, 0x90, 0x72, 0x60, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x80, 0x12, 0x40, 0x22, 0x20, 0x4C, 0x20, 0x00, 0x00 }; /*6742*/
const unsigned char  uc2_6743 [] = {0x10, 0x00, 0x13, 0xF0, 0x7D, 0x10, 0x11, 0x10, 0x38, 0x90, 0x54, 0xA0, 0x54, 0x40, 0x50, 0xA0, 0x10, 0xA0, 0x11, 0x10, 0x12, 0x10, 0x00, 0x00 }; /*6743*/
const unsigned char  uc2_6746 [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0x80, 0x10, 0x80, 0x38, 0x80, 0x57, 0xF0, 0x54, 0x80, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6746*/
const unsigned char  uc2_6748 [] = {0x10, 0x00, 0x13, 0xF0, 0x79, 0x10, 0x11, 0x90, 0x39, 0x60, 0x54, 0xA0, 0x54, 0x40, 0x50, 0x40, 0x10, 0xA0, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*6748*/
const unsigned char  uc2_6749 [] = {0x10, 0x20, 0x10, 0x20, 0x7C, 0x40, 0x11, 0x90, 0x38, 0x20, 0x54, 0x40, 0x55, 0x80, 0x50, 0x10, 0x10, 0x20, 0x10, 0xC0, 0x13, 0x00, 0x00, 0x00 }; /*6749*/
const unsigned char  uc2_674C [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x40, 0x11, 0x40, 0x39, 0x40, 0x55, 0x40, 0x55, 0x40, 0x51, 0x40, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*674C*/
const unsigned char  uc2_674E [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x1F, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x01, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*674E*/
const unsigned char  uc2_674F [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*674F*/
const unsigned char  uc2_6750 [] = {0x10, 0x40, 0x10, 0x40, 0x7B, 0xF0, 0x10, 0x40, 0x38, 0xC0, 0x55, 0x40, 0x55, 0x40, 0x51, 0x40, 0x12, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*6750*/
const unsigned char  uc2_6751 [] = {0x10, 0x40, 0x10, 0x40, 0x7B, 0xF0, 0x10, 0x40, 0x3A, 0x40, 0x55, 0x40, 0x55, 0x40, 0x50, 0x40, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*6751*/
const unsigned char  uc2_6753 [] = {0x10, 0x80, 0x10, 0xF0, 0x7D, 0x10, 0x12, 0x10, 0x38, 0x90, 0x54, 0x50, 0x54, 0x50, 0x50, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x60, 0x00, 0x00 }; /*6753*/
const unsigned char  uc2_6756 [] = {0x10, 0x40, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x3A, 0x40, 0x55, 0x40, 0x55, 0x40, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*6756*/
const unsigned char  uc2_675C [] = {0x10, 0x80, 0x10, 0x80, 0x78, 0x80, 0x10, 0x80, 0x3B, 0xE0, 0x54, 0x80, 0x50, 0x80, 0x50, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*675C*/
const unsigned char  uc2_675E [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0x20, 0x10, 0x20, 0x38, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x51, 0x10, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*675E*/
const unsigned char  uc2_675F [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*675F*/
const unsigned char  uc2_6760 [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0x80, 0x10, 0x80, 0x38, 0x80, 0x54, 0x80, 0x54, 0x80, 0x50, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*6760*/
const unsigned char  uc2_6761 [] = {0x08, 0x00, 0x0F, 0x80, 0x18, 0x80, 0x25, 0x00, 0x07, 0x00, 0x78, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x40, 0x12, 0x20, 0x6C, 0x20, 0x00, 0x00 }; /*6761*/
const unsigned char  uc2_6765 [] = {0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*6765*/
const unsigned char  uc2_6768 [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0x20, 0x10, 0xC0, 0x39, 0x00, 0x57, 0xF0, 0x51, 0x50, 0x52, 0x50, 0x14, 0x90, 0x11, 0x10, 0x16, 0x60, 0x00, 0x00 }; /*6768*/
const unsigned char  uc2_6769 [] = {0x10, 0x00, 0x13, 0xE0, 0x79, 0x20, 0x11, 0x20, 0x3A, 0x40, 0x53, 0xF0, 0x50, 0x10, 0x17, 0xD0, 0x10, 0x10, 0x10, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*6769*/
const unsigned char  uc2_676A [] = {0x10, 0x80, 0x10, 0x80, 0x7E, 0xA0, 0x12, 0x90, 0x3A, 0x90, 0x54, 0x80, 0x54, 0xA0, 0x50, 0x20, 0x10, 0x40, 0x11, 0x80, 0x16, 0x00, 0x00, 0x00 }; /*676A*/
const unsigned char  uc2_676D [] = {0x13, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x00, 0x39, 0xC0, 0x55, 0x40, 0x51, 0x40, 0x11, 0x50, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*676D*/
const unsigned char  uc2_676F [] = {0x10, 0x00, 0x13, 0xF0, 0x7C, 0x40, 0x10, 0x40, 0x38, 0x80, 0x55, 0xA0, 0x56, 0x90, 0x10, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*676F*/
const unsigned char  uc2_6770 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x29, 0x20, 0x24, 0x90, 0x44, 0x90, 0x00, 0x00 }; /*6770*/
const unsigned char  uc2_6772 [] = {0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*6772*/
const unsigned char  uc2_6773 [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*6773*/
const unsigned char  uc2_6775 [] = {0x12, 0x00, 0x13, 0xE0, 0x7A, 0x80, 0x14, 0x80, 0x38, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6775*/
const unsigned char  uc2_6777 [] = {0x10, 0x00, 0x13, 0xE0, 0x7E, 0xA0, 0x12, 0xA0, 0x3A, 0xA0, 0x57, 0xE0, 0x52, 0x00, 0x52, 0x00, 0x12, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*6777*/
const unsigned char  uc2_677C [] = {0x10, 0x00, 0x17, 0xE0, 0x79, 0x20, 0x10, 0xC0, 0x37, 0xF0, 0x58, 0x90, 0x54, 0xA0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*677C*/
const unsigned char  uc2_677E [] = {0x11, 0x40, 0x11, 0x40, 0x7D, 0x20, 0x12, 0x20, 0x3A, 0xA0, 0x54, 0x90, 0x55, 0x00, 0x51, 0x20, 0x12, 0x60, 0x13, 0x90, 0x10, 0x10, 0x00, 0x00 }; /*677E*/
const unsigned char  uc2_677F [] = {0x10, 0x30, 0x13, 0xC0, 0x7A, 0x00, 0x12, 0x00, 0x3B, 0xE0, 0x56, 0xA0, 0x52, 0xA0, 0x12, 0x40, 0x14, 0xA0, 0x14, 0xA0, 0x1B, 0x10, 0x00, 0x00 }; /*677F*/
const unsigned char  uc2_6781 [] = {0x10, 0x00, 0x13, 0xE0, 0x7D, 0x20, 0x11, 0x20, 0x39, 0x40, 0x55, 0x60, 0x55, 0x20, 0x12, 0xA0, 0x12, 0x40, 0x14, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*6781*/
const unsigned char  uc2_6784 [] = {0x11, 0x00, 0x11, 0xF0, 0x7D, 0x10, 0x12, 0x90, 0x38, 0x90, 0x55, 0x10, 0x52, 0x50, 0x13, 0xB0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x60, 0x00, 0x00 }; /*6784*/
const unsigned char  uc2_6787 [] = {0x12, 0x40, 0x12, 0x40, 0x7E, 0x40, 0x12, 0x50, 0x3B, 0x60, 0x56, 0x40, 0x52, 0x40, 0x52, 0x40, 0x12, 0xD0, 0x13, 0x50, 0x12, 0x20, 0x00, 0x00 }; /*6787*/
const unsigned char  uc2_6789 [] = {0x10, 0x00, 0x17, 0xF0, 0x78, 0x80, 0x10, 0x80, 0x38, 0x80, 0x53, 0xE0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*6789*/
const unsigned char  uc2_678B [] = {0x11, 0x80, 0x10, 0x40, 0x7B, 0xF0, 0x11, 0x00, 0x39, 0x00, 0x55, 0xE0, 0x55, 0x20, 0x51, 0x20, 0x12, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*678B*/
const unsigned char  uc2_6790 [] = {0x10, 0x30, 0x13, 0xC0, 0x7E, 0x00, 0x12, 0x00, 0x3B, 0xF0, 0x56, 0x40, 0x52, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*6790*/
const unsigned char  uc2_6795 [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x38, 0x80, 0x54, 0x80, 0x55, 0x40, 0x51, 0x40, 0x11, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*6795*/
const unsigned char  uc2_6797 [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x38, 0xC0, 0x55, 0xA0, 0x52, 0xA0, 0x52, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6797*/
const unsigned char  uc2_6798 [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x3C, 0x90, 0x54, 0x90, 0x55, 0x50, 0x15, 0x50, 0x16, 0x10, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*6798*/
const unsigned char  uc2_679A [] = {0x11, 0x00, 0x11, 0xF0, 0x7D, 0x20, 0x11, 0x20, 0x3A, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x10, 0x40, 0x10, 0xA0, 0x10, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*679A*/
const unsigned char  uc2_679C [] = {0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*679C*/
const unsigned char  uc2_679D [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x57, 0xE0, 0x52, 0x20, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*679D*/
const unsigned char  uc2_679E [] = {0x12, 0x40, 0x12, 0x40, 0x7A, 0x40, 0x12, 0x40, 0x3A, 0x40, 0x52, 0x40, 0x55, 0xA0, 0x14, 0xA0, 0x14, 0xA0, 0x19, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*679E*/
const unsigned char  uc2_67A2 [] = {0x10, 0x00, 0x13, 0xF0, 0x7E, 0x00, 0x13, 0x20, 0x3A, 0xA0, 0x56, 0x40, 0x52, 0xA0, 0x12, 0x90, 0x13, 0x10, 0x12, 0x00, 0x13, 0xF0, 0x00, 0x00 }; /*67A2*/
const unsigned char  uc2_67A3 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x27, 0x20, 0x1A, 0xC0, 0x66, 0x30, 0x01, 0x00, 0x06, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*67A3*/
const unsigned char  uc2_67A5 [] = {0x10, 0x00, 0x13, 0xF0, 0x7E, 0x00, 0x12, 0x40, 0x3A, 0xF0, 0x56, 0x50, 0x52, 0x50, 0x52, 0x50, 0x14, 0x90, 0x14, 0x90, 0x19, 0x60, 0x00, 0x00 }; /*67A5*/
const unsigned char  uc2_67A7 [] = {0x10, 0x00, 0x13, 0xE0, 0x7E, 0x20, 0x12, 0xA0, 0x3A, 0xA0, 0x56, 0xA0, 0x52, 0xA0, 0x50, 0x80, 0x11, 0x50, 0x11, 0x50, 0x16, 0x20, 0x00, 0x00 }; /*67A7*/
const unsigned char  uc2_67A8 [] = {0x11, 0x20, 0x11, 0x20, 0x7D, 0xC0, 0x11, 0x00, 0x3B, 0xF0, 0x55, 0x40, 0x51, 0x40, 0x51, 0x20, 0x11, 0x20, 0x11, 0xA0, 0x11, 0x10, 0x00, 0x00 }; /*67A8*/
const unsigned char  uc2_67AA [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x39, 0xC0, 0x55, 0x20, 0x51, 0x20, 0x51, 0x40, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*67AA*/
const unsigned char  uc2_67AB [] = {0x10, 0x00, 0x17, 0xC0, 0x7C, 0x40, 0x14, 0x40, 0x3E, 0xC0, 0x55, 0x40, 0x55, 0x40, 0x16, 0xC0, 0x14, 0x50, 0x14, 0x50, 0x18, 0x20, 0x00, 0x00 }; /*67AB*/
const unsigned char  uc2_67AD [] = {0x04, 0x00, 0x3F, 0x80, 0x28, 0x80, 0x25, 0x00, 0x20, 0x00, 0x3F, 0xF0, 0x04, 0x10, 0x7F, 0x90, 0x0E, 0x60, 0x15, 0x80, 0x64, 0x60, 0x00, 0x00 }; /*67AD*/
const unsigned char  uc2_67AF [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x57, 0xE0, 0x52, 0x20, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*67AF*/
const unsigned char  uc2_67B0 [] = {0x10, 0x00, 0x13, 0xE0, 0x78, 0x80, 0x12, 0xA0, 0x39, 0xA0, 0x54, 0xC0, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*67B0*/
const unsigned char  uc2_67B3 [] = {0x10, 0x00, 0x13, 0xE0, 0x7E, 0x20, 0x12, 0x20, 0x3A, 0x20, 0x56, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x12, 0x60, 0x12, 0x10, 0x14, 0x10, 0x00, 0x00 }; /*67B3*/
const unsigned char  uc2_67B5 [] = {0x10, 0x00, 0x11, 0xE0, 0x7D, 0x20, 0x11, 0xE0, 0x38, 0x00, 0x57, 0xF0, 0x51, 0x00, 0x11, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*67B5*/
const unsigned char  uc2_67B6 [] = {0x10, 0x00, 0x3D, 0xE0, 0x15, 0x20, 0x15, 0x20, 0x25, 0xE0, 0x59, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*67B6*/
const unsigned char  uc2_67B7 [] = {0x14, 0x00, 0x14, 0x70, 0x7F, 0x50, 0x15, 0x50, 0x3D, 0x50, 0x55, 0x50, 0x55, 0x50, 0x15, 0x50, 0x15, 0x50, 0x15, 0x70, 0x1B, 0x50, 0x00, 0x00 }; /*67B7*/
const unsigned char  uc2_67B8 [] = {0x11, 0x00, 0x11, 0xF0, 0x7D, 0x10, 0x12, 0x10, 0x39, 0xD0, 0x55, 0x50, 0x55, 0x50, 0x11, 0xD0, 0x11, 0x50, 0x10, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*67B8*/
const unsigned char  uc2_67C1 [] = {0x11, 0x00, 0x10, 0x80, 0x7B, 0xF0, 0x12, 0x10, 0x39, 0x00, 0x55, 0x20, 0x55, 0xC0, 0x51, 0x00, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*67C1*/
const unsigned char  uc2_67C3 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x11, 0x20, 0x3A, 0x90, 0x54, 0x40, 0x53, 0xE0, 0x50, 0x20, 0x11, 0x40, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*67C3*/
const unsigned char  uc2_67C4 [] = {0x10, 0x00, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x3A, 0xA0, 0x56, 0xA0, 0x52, 0xA0, 0x53, 0x60, 0x12, 0x20, 0x12, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*67C4*/
const unsigned char  uc2_67CF [] = {0x10, 0x40, 0x10, 0x80, 0x7D, 0xF0, 0x11, 0x10, 0x39, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x51, 0x10, 0x11, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*67CF*/
const unsigned char  uc2_67D0 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*67D0*/
const unsigned char  uc2_67D1 [] = {0x11, 0x20, 0x11, 0x20, 0x7F, 0xF0, 0x11, 0x20, 0x39, 0x20, 0x55, 0xE0, 0x51, 0x20, 0x11, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*67D1*/
const unsigned char  uc2_67D2 [] = {0x31, 0x00, 0x09, 0x30, 0x69, 0xC0, 0x17, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*67D2*/
const unsigned char  uc2_67D3 [] = {0x31, 0x00, 0x0B, 0xC0, 0x61, 0x40, 0x11, 0x50, 0x0A, 0x50, 0x74, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*67D3*/
const unsigned char  uc2_67D4 [] = {0x1F, 0xC0, 0x06, 0x40, 0x01, 0x80, 0x7F, 0xF0, 0x05, 0x10, 0x19, 0x20, 0x66, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*67D4*/
const unsigned char  uc2_67D8 [] = {0x10, 0x00, 0x13, 0xF0, 0x7C, 0x80, 0x10, 0x80, 0x39, 0x00, 0x55, 0xE0, 0x57, 0x20, 0x11, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*67D8*/
const unsigned char  uc2_67D9 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x90, 0x17, 0xF0, 0x3C, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*67D9*/
const unsigned char  uc2_67DA [] = {0x10, 0x80, 0x10, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x3C, 0x90, 0x54, 0x90, 0x57, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*67DA*/
const unsigned char  uc2_67DC [] = {0x10, 0x00, 0x13, 0xF0, 0x7E, 0x00, 0x12, 0x00, 0x3B, 0xE0, 0x56, 0x20, 0x52, 0x20, 0x53, 0xE0, 0x12, 0x00, 0x12, 0x00, 0x13, 0xF0, 0x00, 0x00 }; /*67DC*/
const unsigned char  uc2_67DD [] = {0x10, 0x70, 0x13, 0x80, 0x7E, 0x00, 0x12, 0x00, 0x3B, 0xF0, 0x56, 0x40, 0x52, 0xE0, 0x12, 0x50, 0x12, 0x50, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*67DD*/
const unsigned char  uc2_67DE [] = {0x11, 0x00, 0x11, 0xF0, 0x7B, 0x00, 0x15, 0x00, 0x39, 0xE0, 0x55, 0x00, 0x51, 0x00, 0x11, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x00, 0x00 }; /*67DE*/
const unsigned char  uc2_67E0 [] = {0x13, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x10, 0x34, 0x10, 0x5B, 0xE0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*67E0*/
const unsigned char  uc2_67E2 [] = {0x10, 0x30, 0x17, 0xC0, 0x7C, 0x80, 0x14, 0x80, 0x3F, 0xF0, 0x54, 0x80, 0x54, 0x80, 0x15, 0x40, 0x16, 0x50, 0x15, 0x50, 0x10, 0xA0, 0x00, 0x00 }; /*67E2*/
const unsigned char  uc2_67E5 [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*67E5*/
const unsigned char  uc2_67E9 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x80, 0x14, 0xE0, 0x3C, 0xA0, 0x57, 0x20, 0x54, 0x40, 0x14, 0xA0, 0x17, 0x20, 0x14, 0x00, 0x17, 0xF0, 0x00, 0x00 }; /*67E9*/
const unsigned char  uc2_67EC [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x32, 0x60, 0x2A, 0xA0, 0x3F, 0xE0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*67EC*/
const unsigned char  uc2_67EE [] = {0x10, 0x40, 0x10, 0x40, 0x7D, 0x50, 0x11, 0x50, 0x39, 0xF0, 0x54, 0x40, 0x54, 0x40, 0x11, 0x50, 0x11, 0x50, 0x11, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*67EE*/
const unsigned char  uc2_67EF [] = {0x10, 0x00, 0x17, 0xF0, 0x78, 0x20, 0x10, 0x20, 0x3B, 0xA0, 0x56, 0xA0, 0x52, 0xA0, 0x13, 0xA0, 0x12, 0xA0, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*67EF*/
const unsigned char  uc2_67F0 [] = {0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x60, 0x30, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x12, 0x20, 0x6C, 0x20, 0x00, 0x00 }; /*67F0*/
const unsigned char  uc2_67F1 [] = {0x13, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x54, 0x80, 0x53, 0xE0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*67F1*/
const unsigned char  uc2_67F3 [] = {0x13, 0x00, 0x14, 0x70, 0x7D, 0x50, 0x15, 0x50, 0x35, 0x50, 0x5D, 0x50, 0x57, 0x50, 0x15, 0x60, 0x11, 0x40, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*67F3*/
const unsigned char  uc2_67F4 [] = {0x09, 0x00, 0x09, 0x30, 0x2D, 0xC0, 0x29, 0x10, 0x2F, 0x10, 0x70, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*67F4*/
const unsigned char  uc2_67FD [] = {0x10, 0x00, 0x17, 0xE0, 0x7A, 0x20, 0x11, 0x40, 0x38, 0x80, 0x51, 0x40, 0x56, 0xB0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*67FD*/
const unsigned char  uc2_67FF [] = {0x11, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x3B, 0xE0, 0x56, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x12, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*67FF*/
const unsigned char  uc2_6800 [] = {0x10, 0x70, 0x17, 0x80, 0x7C, 0x00, 0x17, 0xF0, 0x34, 0x00, 0x5D, 0xE0, 0x55, 0x20, 0x55, 0x20, 0x15, 0x50, 0x15, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*6800*/
const unsigned char  uc2_6805 [] = {0x20, 0x00, 0x2E, 0xE0, 0x7A, 0xA0, 0x2A, 0xA0, 0x6A, 0xA0, 0x3F, 0xF0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x35, 0x40, 0x00, 0x00 }; /*6805*/
const unsigned char  uc2_6807 [] = {0x10, 0x00, 0x13, 0xE0, 0x78, 0x00, 0x10, 0x00, 0x37, 0xF0, 0x58, 0x80, 0x52, 0xC0, 0x12, 0xA0, 0x14, 0xA0, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*6807*/
const unsigned char  uc2_6808 [] = {0x10, 0xA0, 0x10, 0x90, 0x7C, 0xF0, 0x13, 0x80, 0x38, 0x80, 0x54, 0xF0, 0x53, 0x90, 0x10, 0xA0, 0x10, 0x50, 0x10, 0xD0, 0x17, 0x20, 0x00, 0x00 }; /*6808*/
const unsigned char  uc2_6809 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x10, 0x00, 0x3B, 0xF0, 0x54, 0x90, 0x50, 0x90, 0x10, 0x90, 0x10, 0xA0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6809*/
const unsigned char  uc2_680A [] = {0x12, 0x00, 0x12, 0xC0, 0x7A, 0x20, 0x17, 0xF0, 0x3A, 0x80, 0x56, 0xA0, 0x52, 0xA0, 0x52, 0xC0, 0x14, 0x90, 0x15, 0x90, 0x1A, 0x60, 0x00, 0x00 }; /*680A*/
const unsigned char  uc2_680B [] = {0x11, 0x00, 0x17, 0xE0, 0x7A, 0x00, 0x12, 0x80, 0x3C, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x14, 0xA0, 0x14, 0x90, 0x18, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*680B*/
const unsigned char  uc2_680C [] = {0x10, 0x80, 0x10, 0xF0, 0x7C, 0x80, 0x13, 0xF0, 0x3A, 0x10, 0x57, 0xF0, 0x52, 0x00, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x14, 0x00, 0x00, 0x00 }; /*680C*/
const unsigned char  uc2_680E [] = {0x10, 0x60, 0x13, 0x80, 0x7A, 0x00, 0x12, 0x80, 0x3C, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x14, 0xA0, 0x14, 0x90, 0x18, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*680E*/
const unsigned char  uc2_680F [] = {0x12, 0x20, 0x11, 0x20, 0x79, 0x40, 0x17, 0xF0, 0x38, 0x00, 0x54, 0x00, 0x53, 0xE0, 0x50, 0x00, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*680F*/
const unsigned char  uc2_6811 [] = {0x20, 0x20, 0x2F, 0x20, 0x71, 0xF0, 0x25, 0x20, 0x35, 0x20, 0x6A, 0xA0, 0x22, 0x60, 0x25, 0x20, 0x39, 0x20, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*6811*/
const unsigned char  uc2_6813 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x3B, 0xE0, 0x54, 0x80, 0x54, 0x80, 0x11, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*6813*/
const unsigned char  uc2_6816 [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x40, 0x17, 0xF0, 0x35, 0x50, 0x5D, 0x50, 0x55, 0x30, 0x16, 0x10, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*6816*/
const unsigned char  uc2_6817 [] = {0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*6817*/
const unsigned char  uc2_681D [] = {0x10, 0x60, 0x13, 0x80, 0x7C, 0x80, 0x10, 0x80, 0x3B, 0xF0, 0x54, 0x80, 0x50, 0x80, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*681D*/
const unsigned char  uc2_6821 [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0x20, 0x12, 0x10, 0x35, 0x50, 0x59, 0x40, 0x51, 0x40, 0x50, 0x80, 0x11, 0x40, 0x12, 0x20, 0x1C, 0x10, 0x00, 0x00 }; /*6821*/
const unsigned char  uc2_6829 [] = {0x10, 0x00, 0x17, 0x70, 0x79, 0x10, 0x15, 0x50, 0x3B, 0x30, 0x51, 0x10, 0x53, 0x30, 0x1D, 0xD0, 0x11, 0x10, 0x11, 0x10, 0x16, 0x60, 0x00, 0x00 }; /*6829*/
const unsigned char  uc2_682A [] = {0x20, 0x80, 0x22, 0x80, 0x73, 0xE0, 0x24, 0x80, 0x70, 0x80, 0x2F, 0xF0, 0x29, 0xC0, 0x22, 0xA0, 0x22, 0xA0, 0x24, 0x90, 0x20, 0x80, 0x00, 0x00 }; /*682A*/
const unsigned char  uc2_6832 [] = {0x11, 0x20, 0x13, 0xA0, 0x79, 0x40, 0x17, 0xF0, 0x38, 0x80, 0x55, 0x80, 0x52, 0xF0, 0x5D, 0x00, 0x11, 0xE0, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*6832*/
const unsigned char  uc2_6833 [] = {0x10, 0x80, 0x10, 0x90, 0x79, 0xD0, 0x10, 0xA0, 0x3B, 0xF0, 0x55, 0x00, 0x53, 0x30, 0x5D, 0xC0, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*6833*/
const unsigned char  uc2_6837 [] = {0x12, 0x20, 0x11, 0x40, 0x7F, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x53, 0xE0, 0x50, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6837*/
const unsigned char  uc2_6838 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x11, 0x10, 0x3A, 0x20, 0x57, 0x40, 0x50, 0x90, 0x13, 0x20, 0x10, 0x60, 0x11, 0x90, 0x16, 0x10, 0x00, 0x00 }; /*6838*/
const unsigned char  uc2_6839 [] = {0x10, 0x00, 0x13, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x52, 0x50, 0x52, 0x50, 0x12, 0x20, 0x12, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*6839*/
const unsigned char  uc2_683C [] = {0x11, 0x00, 0x11, 0xE0, 0x7A, 0x20, 0x15, 0x40, 0x30, 0x80, 0x5B, 0x70, 0x54, 0x00, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*683C*/
const unsigned char  uc2_683D [] = {0x08, 0x80, 0x3E, 0xC0, 0x08, 0xA0, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xA0, 0x2C, 0xA0, 0x2A, 0x40, 0x2A, 0x50, 0x48, 0xD0, 0x03, 0x20, 0x00, 0x00 }; /*683D*/
const unsigned char  uc2_683E [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x15, 0x40, 0x65, 0x20, 0x05, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*683E*/
const unsigned char  uc2_6840 [] = {0x10, 0x40, 0x1D, 0xE0, 0x64, 0x40, 0x16, 0x40, 0x1B, 0xF0, 0x60, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*6840*/
const unsigned char  uc2_6841 [] = {0x22, 0x00, 0x22, 0xE0, 0x74, 0x00, 0x2A, 0x00, 0x33, 0xF0, 0x64, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x24, 0x40, 0x24, 0x40, 0x25, 0x80, 0x00, 0x00 }; /*6841*/
const unsigned char  uc2_6842 [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x38, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*6842*/
const unsigned char  uc2_6843 [] = {0x11, 0x40, 0x11, 0x50, 0x7D, 0x50, 0x13, 0x60, 0x39, 0x40, 0x55, 0x60, 0x53, 0x50, 0x1D, 0x50, 0x11, 0x40, 0x11, 0x50, 0x16, 0x20, 0x00, 0x00 }; /*6843*/
const unsigned char  uc2_6844 [] = {0x10, 0x80, 0x14, 0x90, 0x7A, 0x90, 0x12, 0xA0, 0x37, 0xF0, 0x59, 0x40, 0x51, 0x40, 0x11, 0x40, 0x12, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x00, 0x00 }; /*6844*/
const unsigned char  uc2_6845 [] = {0x21, 0x00, 0x21, 0xC0, 0x72, 0x40, 0x27, 0xF0, 0x6C, 0x00, 0x35, 0xE0, 0x25, 0x20, 0x25, 0xC0, 0x25, 0x10, 0x25, 0x10, 0x28, 0xE0, 0x00, 0x00 }; /*6845*/
const unsigned char  uc2_6846 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x00, 0x17, 0xE0, 0x3C, 0x80, 0x55, 0xC0, 0x54, 0x80, 0x14, 0x80, 0x17, 0xE0, 0x14, 0x00, 0x17, 0xF0, 0x00, 0x00 }; /*6846*/
const unsigned char  uc2_6848 [] = {0x02, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x3F, 0xE0, 0x08, 0x80, 0x07, 0x00, 0x38, 0xC0, 0x02, 0x20, 0x3F, 0xE0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6848*/
const unsigned char  uc2_6849 [] = {0x20, 0x80, 0x27, 0xF0, 0x7C, 0x10, 0x24, 0x90, 0x70, 0x80, 0x2F, 0xF0, 0x29, 0x20, 0x22, 0x40, 0x23, 0xE0, 0x21, 0x10, 0x2E, 0x10, 0x00, 0x00 }; /*6849*/
const unsigned char  uc2_684A [] = {0x12, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6F, 0xB0, 0x07, 0x00, 0x0A, 0xC0, 0x32, 0x20, 0x02, 0x20, 0x00, 0x00 }; /*684A*/
const unsigned char  uc2_684C [] = {0x07, 0xC0, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*684C*/
const unsigned char  uc2_684E [] = {0x10, 0x00, 0x17, 0xE0, 0x79, 0x00, 0x12, 0x40, 0x3C, 0xE0, 0x57, 0x20, 0x51, 0x00, 0x17, 0xC0, 0x11, 0x00, 0x11, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*684E*/
const unsigned char  uc2_6850 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x34, 0x10, 0x5D, 0xD0, 0x55, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*6850*/
const unsigned char  uc2_6851 [] = {0x1F, 0x80, 0x08, 0x80, 0x07, 0x00, 0x08, 0x80, 0x7D, 0xE0, 0x25, 0x20, 0x18, 0xC0, 0x25, 0x20, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6851*/
const unsigned char  uc2_6853 [] = {0x10, 0x00, 0x13, 0xF0, 0x7C, 0x00, 0x11, 0xE0, 0x39, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x51, 0xE0, 0x10, 0x00, 0x13, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*6853*/
const unsigned char  uc2_6854 [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x3B, 0xE0, 0x54, 0x00, 0x53, 0xE0, 0x52, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*6854*/
const unsigned char  uc2_6855 [] = {0x08, 0x40, 0x09, 0xB0, 0x3F, 0x10, 0x09, 0x10, 0x1D, 0x10, 0x2B, 0xB0, 0x29, 0x10, 0x49, 0x10, 0x09, 0x10, 0x09, 0xF0, 0x09, 0x10, 0x00, 0x00 }; /*6855*/
const unsigned char  uc2_6860 [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x40, 0x11, 0x40, 0x39, 0x50, 0x55, 0x50, 0x55, 0x60, 0x11, 0x40, 0x11, 0x40, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*6860*/
const unsigned char  uc2_6861 [] = {0x11, 0x60, 0x17, 0x80, 0x79, 0x20, 0x10, 0xD0, 0x3B, 0x50, 0x50, 0x20, 0x57, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x00, 0x00 }; /*6861*/
const unsigned char  uc2_6862 [] = {0x10, 0x80, 0x10, 0xF0, 0x7C, 0x80, 0x13, 0xE0, 0x3A, 0x20, 0x56, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x11, 0x40, 0x11, 0x20, 0x16, 0x20, 0x00, 0x00 }; /*6862*/
const unsigned char  uc2_6863 [] = {0x12, 0x50, 0x11, 0x50, 0x79, 0x60, 0x13, 0xF0, 0x38, 0x10, 0x54, 0x10, 0x51, 0xF0, 0x10, 0x10, 0x10, 0x10, 0x13, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*6863*/
const unsigned char  uc2_6864 [] = {0x10, 0x80, 0x14, 0x90, 0x7F, 0xF0, 0x10, 0x00, 0x37, 0xE0, 0x58, 0x20, 0x57, 0xE0, 0x52, 0x20, 0x12, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*6864*/
const unsigned char  uc2_6865 [] = {0x10, 0x60, 0x13, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x30, 0x80, 0x59, 0x40, 0x56, 0x30, 0x51, 0x40, 0x11, 0x40, 0x12, 0x40, 0x1C, 0x40, 0x00, 0x00 }; /*6865*/
const unsigned char  uc2_6866 [] = {0x11, 0x40, 0x11, 0x50, 0x7A, 0x60, 0x17, 0xC0, 0x3A, 0x50, 0x52, 0x50, 0x52, 0xA0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6866*/
const unsigned char  uc2_6867 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x39, 0xC0, 0x54, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x11, 0x20, 0x12, 0x60, 0x13, 0x90, 0x00, 0x00 }; /*6867*/
const unsigned char  uc2_6868 [] = {0x09, 0x00, 0x69, 0xE0, 0x1A, 0x20, 0x0D, 0x40, 0x18, 0x80, 0x6B, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*6868*/
const unsigned char  uc2_6869 [] = {0x13, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x00, 0x34, 0x80, 0x5C, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x14, 0x80, 0x14, 0x80, 0x1B, 0xF0, 0x00, 0x00 }; /*6869*/
const unsigned char  uc2_686B [] = {0x14, 0x40, 0x12, 0x40, 0x7A, 0x60, 0x11, 0x50, 0x35, 0x50, 0x5A, 0x40, 0x52, 0x50, 0x54, 0x50, 0x14, 0x20, 0x18, 0xC0, 0x13, 0x00, 0x00, 0x00 }; /*686B*/
const unsigned char  uc2_6874 [] = {0x10, 0x70, 0x17, 0x80, 0x79, 0x20, 0x14, 0xA0, 0x3A, 0x40, 0x53, 0xC0, 0x50, 0x40, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*6874*/
const unsigned char  uc2_6876 [] = {0x10, 0x00, 0x17, 0xE0, 0x79, 0x20, 0x10, 0xC0, 0x37, 0xF0, 0x5C, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x14, 0x60, 0x00, 0x00 }; /*6876*/
const unsigned char  uc2_6877 [] = {0x10, 0x80, 0x10, 0xE0, 0x7D, 0x20, 0x11, 0xF0, 0x3B, 0x50, 0x55, 0xF0, 0x51, 0x50, 0x11, 0xF0, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*6877*/
const unsigned char  uc2_6881 [] = {0x37, 0xC0, 0x09, 0x40, 0x65, 0x60, 0x15, 0x50, 0x0A, 0x50, 0x75, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*6881*/
const unsigned char  uc2_6883 [] = {0x10, 0x10, 0x17, 0x60, 0x79, 0x20, 0x11, 0x20, 0x3A, 0x70, 0x57, 0x20, 0x51, 0x20, 0x55, 0x20, 0x12, 0xF0, 0x13, 0x00, 0x14, 0xF0, 0x00, 0x00 }; /*6883*/
const unsigned char  uc2_6885 [] = {0x12, 0x00, 0x13, 0xF0, 0x7A, 0x00, 0x17, 0xE0, 0x3A, 0xA0, 0x57, 0xF0, 0x53, 0x20, 0x14, 0xA0, 0x17, 0xF0, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*6885*/
const unsigned char  uc2_6886 [] = {0x12, 0x00, 0x7F, 0xF0, 0x12, 0x50, 0x3A, 0x50, 0x57, 0x60, 0x52, 0x50, 0x52, 0x50, 0x1F, 0xD0, 0x12, 0x60, 0x12, 0x40, 0x1C, 0x40, 0x00, 0x00 }; /*6886*/
const unsigned char  uc2_688F [] = {0x10, 0x80, 0x12, 0x80, 0x7B, 0xE0, 0x14, 0x80, 0x37, 0xF0, 0x58, 0x00, 0x53, 0xE0, 0x52, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*688F*/
const unsigned char  uc2_6893 [] = {0x10, 0x80, 0x13, 0xE0, 0x7D, 0x40, 0x11, 0x40, 0x38, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6893*/
const unsigned char  uc2_6897 [] = {0x17, 0xF0, 0x10, 0x80, 0x7F, 0xE0, 0x12, 0xA0, 0x3B, 0xE0, 0x56, 0xA0, 0x53, 0xE0, 0x14, 0x80, 0x12, 0x80, 0x11, 0x80, 0x16, 0x70, 0x00, 0x00 }; /*6897*/
const unsigned char  uc2_68A2 [] = {0x10, 0x80, 0x14, 0x90, 0x7A, 0xA0, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*68A2*/
const unsigned char  uc2_68A6 [] = {0x10, 0x40, 0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x55, 0x50, 0x14, 0x40, 0x07, 0x80, 0x38, 0x80, 0x05, 0x00, 0x06, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*68A6*/
const unsigned char  uc2_68A7 [] = {0x13, 0xE0, 0x10, 0x80, 0x7F, 0xE0, 0x11, 0x20, 0x39, 0x40, 0x57, 0xF0, 0x54, 0x00, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*68A7*/
const unsigned char  uc2_68A8 [] = {0x06, 0x20, 0x38, 0xA0, 0x08, 0xA0, 0x7F, 0xA0, 0x2C, 0xA0, 0x2A, 0x20, 0x4A, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*68A8*/
const unsigned char  uc2_68AD [] = {0x11, 0x40, 0x12, 0x20, 0x7B, 0xD0, 0x11, 0x50, 0x36, 0x20, 0x59, 0x20, 0x51, 0xC0, 0x16, 0x40, 0x11, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*68AD*/
const unsigned char  uc2_68AF [] = {0x14, 0x40, 0x12, 0x80, 0x7F, 0xE0, 0x11, 0x20, 0x3B, 0xE0, 0x55, 0x00, 0x57, 0xF0, 0x13, 0x10, 0x15, 0x60, 0x19, 0x00, 0x11, 0x00, 0x00, 0x00 }; /*68AF*/
const unsigned char  uc2_68B0 [] = {0x10, 0xA0, 0x10, 0x90, 0x7F, 0xF0, 0x10, 0x80, 0x35, 0x50, 0x3F, 0xD0, 0x55, 0x50, 0x15, 0x60, 0x18, 0xD0, 0x11, 0x50, 0x10, 0x20, 0x00, 0x00 }; /*68B0*/
const unsigned char  uc2_68B3 [] = {0x21, 0x00, 0x2F, 0xF0, 0x72, 0x40, 0x24, 0x60, 0x37, 0x90, 0x60, 0x10, 0x25, 0x40, 0x25, 0x40, 0x25, 0x50, 0x25, 0x50, 0x38, 0x20, 0x00, 0x00 }; /*68B3*/
const unsigned char  uc2_68B5 [] = {0x10, 0x40, 0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x55, 0x50, 0x10, 0x40, 0x0F, 0x80, 0x08, 0x80, 0x0C, 0x90, 0x12, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*68B5*/
const unsigned char  uc2_68C0 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x16, 0x30, 0x31, 0xC0, 0x59, 0x00, 0x54, 0xA0, 0x12, 0xA0, 0x12, 0x20, 0x10, 0x40, 0x17, 0xF0, 0x00, 0x00 }; /*68C0*/
const unsigned char  uc2_68C2 [] = {0x13, 0xE0, 0x10, 0x20, 0x79, 0xE0, 0x10, 0x20, 0x3B, 0xE0, 0x54, 0x00, 0x52, 0xA0, 0x12, 0xA0, 0x15, 0x40, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*68C2*/
const unsigned char  uc2_68C9 [] = {0x10, 0x80, 0x13, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x14, 0xB0, 0x10, 0x80, 0x00, 0x00 }; /*68C9*/
const unsigned char  uc2_68CB [] = {0x12, 0x40, 0x17, 0xE0, 0x7A, 0x40, 0x13, 0xC0, 0x3A, 0x40, 0x53, 0xC0, 0x52, 0x40, 0x1F, 0xF0, 0x12, 0x40, 0x12, 0x20, 0x14, 0x20, 0x00, 0x00 }; /*68CB*/
const unsigned char  uc2_68CD [] = {0x17, 0xE0, 0x14, 0x20, 0x7F, 0xE0, 0x14, 0x20, 0x37, 0xE0, 0x58, 0x00, 0x54, 0xA0, 0x16, 0xC0, 0x14, 0x90, 0x15, 0x90, 0x16, 0x60, 0x00, 0x00 }; /*68CD*/
const unsigned char  uc2_68D2 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x31, 0x00, 0x5F, 0xF0, 0x54, 0xA0, 0x5B, 0xF0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*68D2*/
const unsigned char  uc2_68D5 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x13, 0xE0, 0x38, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x54, 0xA0, 0x14, 0x90, 0x18, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*68D5*/
const unsigned char  uc2_68D8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2E, 0xE0, 0x08, 0x80, 0x1D, 0xC0, 0x6A, 0xB0, 0x08, 0x80, 0x00, 0x00 }; /*68D8*/
const unsigned char  uc2_68DA [] = {0x17, 0x70, 0x15, 0x50, 0x7D, 0x50, 0x17, 0x70, 0x35, 0x50, 0x5D, 0x50, 0x57, 0x70, 0x55, 0x50, 0x15, 0x50, 0x15, 0x50, 0x1A, 0xA0, 0x00, 0x00 }; /*68DA*/
const unsigned char  uc2_68E0 [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*68E0*/
const unsigned char  uc2_68E3 [] = {0x10, 0x80, 0x13, 0xE0, 0x78, 0xA0, 0x17, 0xF0, 0x38, 0xA0, 0x53, 0xE0, 0x50, 0x90, 0x16, 0xD0, 0x12, 0xA0, 0x1C, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*68E3*/
const unsigned char  uc2_68EE [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x10, 0x40, 0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x55, 0x50, 0x10, 0x40, 0x00, 0x00 }; /*68EE*/
const unsigned char  uc2_68F0 [] = {0x10, 0x60, 0x13, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x3A, 0xA0, 0x57, 0xF0, 0x52, 0xA0, 0x12, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*68F0*/
const unsigned char  uc2_68F1 [] = {0x10, 0x80, 0x13, 0xE0, 0x78, 0x80, 0x17, 0xF0, 0x39, 0x00, 0x56, 0x60, 0x51, 0x10, 0x51, 0xE0, 0x16, 0x20, 0x11, 0xC0, 0x16, 0x30, 0x00, 0x00 }; /*68F1*/
const unsigned char  uc2_68F5 [] = {0x13, 0xE0, 0x12, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x3B, 0xE0, 0x54, 0x80, 0x57, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*68F5*/
const unsigned char  uc2_68F9 [] = {0x10, 0xF0, 0x10, 0x80, 0x7F, 0xE0, 0x12, 0x20, 0x3B, 0xE0, 0x56, 0x20, 0x53, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*68F9*/
const unsigned char  uc2_68FA [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x39, 0x40, 0x55, 0xC0, 0x51, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*68FA*/
const unsigned char  uc2_68FC [] = {0x10, 0x40, 0x7D, 0xF0, 0x38, 0xE0, 0x55, 0x50, 0x10, 0x40, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x04, 0x80, 0x08, 0x80, 0x33, 0x00, 0x00, 0x00 }; /*68FC*/
const unsigned char  uc2_6901 [] = {0x11, 0x80, 0x10, 0x40, 0x7F, 0xF0, 0x11, 0x20, 0x39, 0xE0, 0x54, 0x00, 0x55, 0xE0, 0x50, 0x20, 0x13, 0xF0, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*6901*/
const unsigned char  uc2_6905 [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x12, 0x20, 0x37, 0xF0, 0x58, 0x20, 0x53, 0xA0, 0x52, 0xA0, 0x13, 0xA0, 0x12, 0xA0, 0x10, 0x40, 0x00, 0x00 }; /*6905*/
const unsigned char  uc2_690B [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x00, 0x13, 0xE0, 0x32, 0x20, 0x5A, 0x20, 0x53, 0xE0, 0x50, 0x80, 0x12, 0xA0, 0x14, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*690B*/
const unsigned char  uc2_690D [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x00, 0x13, 0xE0, 0x32, 0x20, 0x5B, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1F, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*690D*/
const unsigned char  uc2_690E [] = {0x11, 0x00, 0x11, 0x80, 0x7A, 0x40, 0x13, 0xF0, 0x36, 0x40, 0x5B, 0xE0, 0x52, 0x40, 0x53, 0xE0, 0x12, 0x40, 0x13, 0xF0, 0x12, 0x00, 0x00, 0x00 }; /*690E*/
const unsigned char  uc2_6910 [] = {0x10, 0x00, 0x13, 0xF0, 0x7A, 0x10, 0x13, 0xF0, 0x32, 0x40, 0x5B, 0xF0, 0x52, 0x40, 0x55, 0xF0, 0x15, 0x10, 0x15, 0xF0, 0x15, 0x10, 0x00, 0x00 }; /*6910*/
const unsigned char  uc2_6912 [] = {0x12, 0x00, 0x12, 0xF0, 0x7B, 0x50, 0x12, 0x50, 0x1F, 0xD0, 0x30, 0x50, 0x5A, 0x20, 0x57, 0x20, 0x1A, 0xE0, 0x12, 0x50, 0x1C, 0x90, 0x00, 0x00 }; /*6912*/
const unsigned char  uc2_691F [] = {0x10, 0x80, 0x11, 0xE0, 0x78, 0x80, 0x17, 0xF0, 0x31, 0x10, 0x5A, 0xA0, 0x51, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x11, 0x60, 0x16, 0x10, 0x00, 0x00 }; /*691F*/
const unsigned char  uc2_6920 [] = {0x10, 0x60, 0x7D, 0x80, 0x29, 0x00, 0x3D, 0xF0, 0x09, 0x40, 0x7D, 0x40, 0x0A, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6920*/
const unsigned char  uc2_6924 [] = {0x17, 0xF0, 0x15, 0x50, 0x7D, 0x50, 0x17, 0xF0, 0x31, 0x00, 0x59, 0xE0, 0x55, 0x20, 0x52, 0xA0, 0x14, 0x40, 0x11, 0x80, 0x16, 0x00, 0x00, 0x00 }; /*6924*/
const unsigned char  uc2_692D [] = {0x20, 0x20, 0x27, 0xF0, 0x75, 0x40, 0x25, 0xF0, 0x36, 0x50, 0x6D, 0x70, 0x25, 0x50, 0x25, 0x70, 0x26, 0x50, 0x24, 0x50, 0x24, 0x60, 0x00, 0x00 }; /*692D*/
const unsigned char  uc2_6930 [] = {0x20, 0x00, 0x2F, 0xF0, 0x75, 0x50, 0x27, 0x50, 0x35, 0x60, 0x6D, 0x50, 0x27, 0x50, 0x25, 0x50, 0x25, 0xE0, 0x2F, 0x40, 0x21, 0x40, 0x00, 0x00 }; /*6930*/
const unsigned char  uc2_6934 [] = {0x21, 0x00, 0x26, 0xE0, 0x74, 0xA0, 0x26, 0xA0, 0x25, 0x10, 0x76, 0x00, 0x25, 0xE0, 0x26, 0xA0, 0x2C, 0xA0, 0x24, 0x40, 0x25, 0xB0, 0x00, 0x00 }; /*6934*/
const unsigned char  uc2_6939 [] = {0x12, 0x40, 0x17, 0xE0, 0x7A, 0x40, 0x13, 0xC0, 0x32, 0x40, 0x5B, 0xC0, 0x52, 0x40, 0x5F, 0xF0, 0x14, 0x80, 0x15, 0x40, 0x13, 0xF0, 0x00, 0x00 }; /*6939*/
const unsigned char  uc2_693D [] = {0x22, 0x00, 0x23, 0xC0, 0x74, 0x40, 0x27, 0xC0, 0x30, 0x80, 0x6F, 0xF0, 0x22, 0x20, 0x2D, 0x40, 0x22, 0xA0, 0x2D, 0xA0, 0x22, 0x90, 0x00, 0x00 }; /*693D*/
const unsigned char  uc2_693F [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x39, 0x00, 0x57, 0xF0, 0x52, 0x20, 0x57, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*693F*/
const unsigned char  uc2_6942 [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0xA0, 0x14, 0x90, 0x33, 0xE0, 0x5A, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x00, 0x00 }; /*6942*/
const unsigned char  uc2_6954 [] = {0x12, 0x00, 0x17, 0xF0, 0x7A, 0x50, 0x17, 0x50, 0x3A, 0x50, 0x57, 0x50, 0x52, 0xA0, 0x50, 0x80, 0x17, 0xF0, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*6954*/
const unsigned char  uc2_6957 [] = {0x20, 0x40, 0x2E, 0xF0, 0x72, 0x50, 0x24, 0xF0, 0x34, 0x50, 0x62, 0xE0, 0x2A, 0x40, 0x24, 0xF0, 0x22, 0x40, 0x25, 0x80, 0x28, 0x70, 0x00, 0x00 }; /*6957*/
const unsigned char  uc2_695A [] = {0x08, 0x80, 0x7F, 0xF0, 0x18, 0xC0, 0x2D, 0xA0, 0x4A, 0x90, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x20, 0x13, 0x80, 0x1A, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*695A*/
const unsigned char  uc2_695D [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x33, 0x60, 0x5A, 0xA0, 0x53, 0xE0, 0x50, 0x80, 0x11, 0xC0, 0x16, 0xB0, 0x10, 0x80, 0x00, 0x00 }; /*695D*/
const unsigned char  uc2_695E [] = {0x10, 0x00, 0x17, 0xF0, 0x7D, 0x50, 0x17, 0xF0, 0x30, 0x80, 0x5B, 0xF0, 0x55, 0x00, 0x51, 0xE0, 0x11, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*695E*/
const unsigned char  uc2_6960 [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x00, 0x17, 0xF0, 0x35, 0x50, 0x5C, 0x90, 0x55, 0xD0, 0x54, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x14, 0x60, 0x00, 0x00 }; /*6960*/
const unsigned char  uc2_6963 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x90, 0x17, 0xF0, 0x35, 0x20, 0x5D, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x15, 0x20, 0x15, 0xE0, 0x19, 0x20, 0x00, 0x00 }; /*6963*/
const unsigned char  uc2_6966 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x13, 0xE0, 0x30, 0x00, 0x5B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*6966*/
const unsigned char  uc2_696B [] = {0x13, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x10, 0x00, 0x37, 0xF0, 0x5A, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x12, 0xF0, 0x17, 0x20, 0x10, 0x20, 0x00, 0x00 }; /*696B*/
const unsigned char  uc2_696E [] = {0x10, 0x90, 0x13, 0xD0, 0x78, 0xA0, 0x17, 0xF0, 0x30, 0x80, 0x59, 0xE0, 0x57, 0x20, 0x51, 0xE0, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*696E*/
const unsigned char  uc2_6971 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x39, 0x00, 0x57, 0xF0, 0x55, 0x60, 0x58, 0x90, 0x17, 0xE0, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*6971*/
const unsigned char  uc2_6977 [] = {0x14, 0x80, 0x16, 0xE0, 0x7C, 0x80, 0x16, 0x90, 0x34, 0x60, 0x5A, 0x00, 0x57, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x00, 0x00 }; /*6977*/
const unsigned char  uc2_6978 [] = {0x23, 0x40, 0x2C, 0x40, 0x75, 0x50, 0x25, 0x50, 0x3F, 0x50, 0x64, 0x60, 0x2E, 0x40, 0x35, 0x40, 0x24, 0xA0, 0x24, 0xA0, 0x25, 0x10, 0x00, 0x00 }; /*6978*/
const unsigned char  uc2_6979 [] = {0x27, 0xC0, 0x22, 0x40, 0x72, 0x80, 0x24, 0xE0, 0x77, 0xA0, 0x2A, 0xA0, 0x21, 0x20, 0x22, 0xC0, 0x2F, 0xE0, 0x2A, 0xA0, 0x3F, 0xF0, 0x00, 0x00 }; /*6979*/
const unsigned char  uc2_697C [] = {0x14, 0x90, 0x12, 0xA0, 0x7F, 0xF0, 0x11, 0xC0, 0x3A, 0xA0, 0x54, 0x90, 0x51, 0x00, 0x1F, 0xF0, 0x12, 0x40, 0x11, 0xE0, 0x16, 0x10, 0x00, 0x00 }; /*697C*/
const unsigned char  uc2_6980 [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x12, 0x20, 0x3B, 0xE0, 0x50, 0x00, 0x57, 0x70, 0x15, 0x50, 0x15, 0x50, 0x17, 0x70, 0x15, 0x50, 0x00, 0x00 }; /*6980*/
const unsigned char  uc2_6982 [] = {0x20, 0x00, 0x2E, 0xF0, 0x7A, 0x20, 0x2E, 0xA0, 0x6A, 0xA0, 0x3E, 0xF0, 0x28, 0x20, 0x2A, 0x20, 0x2B, 0x60, 0x2C, 0xA0, 0x23, 0x30, 0x00, 0x00 }; /*6982*/
const unsigned char  uc2_6984 [] = {0x22, 0x80, 0x2A, 0xF0, 0x7A, 0xA0, 0x2B, 0x10, 0x32, 0x10, 0x6F, 0xC0, 0x24, 0x40, 0x25, 0x40, 0x25, 0x50, 0x22, 0x90, 0x2C, 0x60, 0x00, 0x00 }; /*6984*/
const unsigned char  uc2_6986 [] = {0x21, 0x80, 0x72, 0x40, 0x2D, 0xB0, 0x20, 0x00, 0x37, 0x10, 0x6D, 0x50, 0x27, 0x50, 0x25, 0x50, 0x27, 0x50, 0x25, 0x10, 0x26, 0x60, 0x00, 0x00 }; /*6986*/
const unsigned char  uc2_6987 [] = {0x10, 0x80, 0x13, 0xE0, 0x7A, 0x20, 0x11, 0x40, 0x37, 0xF0, 0x58, 0x80, 0x53, 0xE0, 0x10, 0x80, 0x12, 0xA0, 0x14, 0xA0, 0x13, 0x00, 0x00, 0x00 }; /*6987*/
const unsigned char  uc2_6988 [] = {0x14, 0xF0, 0x12, 0x10, 0x79, 0xD0, 0x15, 0x50, 0x3D, 0xD0, 0x54, 0x10, 0x55, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*6988*/
const unsigned char  uc2_6989 [] = {0x15, 0x10, 0x12, 0x90, 0x7A, 0xA0, 0x17, 0xF0, 0x39, 0x40, 0x52, 0xA0, 0x55, 0xD0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*6989*/
const unsigned char  uc2_698D [] = {0x17, 0xF0, 0x14, 0x10, 0x7F, 0xF0, 0x15, 0x50, 0x34, 0xE0, 0x5D, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x15, 0x10, 0x15, 0xD0, 0x19, 0x30, 0x00, 0x00 }; /*698D*/
const unsigned char  uc2_6994 [] = {0x24, 0x00, 0x2F, 0x70, 0x79, 0x50, 0x2F, 0x50, 0x39, 0x60, 0x6F, 0x50, 0x28, 0x50, 0x2A, 0x50, 0x2D, 0x60, 0x29, 0x40, 0x20, 0x40, 0x00, 0x00 }; /*6994*/
const unsigned char  uc2_6995 [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x50, 0x12, 0x20, 0x3C, 0xA0, 0x51, 0x40, 0x56, 0x30, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*6995*/
const unsigned char  uc2_6998 [] = {0x21, 0xF0, 0x3D, 0x00, 0x29, 0xE0, 0x49, 0x20, 0x3F, 0xE0, 0x15, 0x00, 0x65, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6998*/
const unsigned char  uc2_699B [] = {0x21, 0x00, 0x2F, 0xE0, 0x71, 0x00, 0x27, 0xC0, 0x62, 0x00, 0x3F, 0xE0, 0x24, 0xC0, 0x3B, 0x30, 0x21, 0x00, 0x2F, 0xE0, 0x25, 0x40, 0x00, 0x00 }; /*699B*/
const unsigned char  uc2_699C [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x17, 0xF0, 0x35, 0x10, 0x58, 0x80, 0x57, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x12, 0x20, 0x1C, 0xC0, 0x00, 0x00 }; /*699C*/
const unsigned char  uc2_69A7 [] = {0x2F, 0xF0, 0x28, 0x00, 0x79, 0x40, 0x2F, 0x70, 0x69, 0x40, 0x3B, 0x60, 0x29, 0x40, 0x2F, 0x70, 0x29, 0x40, 0x28, 0x00, 0x2F, 0xF0, 0x00, 0x00 }; /*69A7*/
const unsigned char  uc2_69A8 [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x50, 0x12, 0x20, 0x31, 0x00, 0x59, 0xF0, 0x57, 0x00, 0x51, 0xE0, 0x11, 0x00, 0x11, 0xE0, 0x11, 0x00, 0x00, 0x00 }; /*69A8*/
const unsigned char  uc2_69AB [] = {0x11, 0x40, 0x13, 0xF0, 0x7A, 0x40, 0x17, 0xF0, 0x3A, 0x40, 0x53, 0xF0, 0x52, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*69AB*/
const unsigned char  uc2_69AD [] = {0x22, 0x20, 0x27, 0x20, 0x75, 0xF0, 0x27, 0x20, 0x35, 0x20, 0x6F, 0xA0, 0x25, 0x60, 0x2F, 0x20, 0x25, 0x20, 0x39, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*69AD*/
const unsigned char  uc2_69B1 [] = {0x10, 0x80, 0x7F, 0xF0, 0x12, 0x20, 0x37, 0xF0, 0x5A, 0x20, 0x53, 0xE0, 0x51, 0x10, 0x12, 0xA0, 0x1E, 0x40, 0x12, 0xB0, 0x13, 0x00, 0x00, 0x00 }; /*69B1*/
const unsigned char  uc2_69B4 [] = {0x23, 0x00, 0x2C, 0xF0, 0x7A, 0x50, 0x2A, 0x50, 0x3D, 0xB0, 0x68, 0x00, 0x27, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x00, 0x00 }; /*69B4*/
const unsigned char  uc2_69B7 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x90, 0x11, 0x40, 0x3B, 0xF0, 0x56, 0x40, 0x53, 0xF0, 0x12, 0x40, 0x13, 0xF0, 0x12, 0x40, 0x13, 0xF0, 0x00, 0x00 }; /*69B7*/
const unsigned char  uc2_69BB [] = {0x27, 0xE0, 0x24, 0x20, 0x77, 0xE0, 0x24, 0x20, 0x37, 0xE0, 0x68, 0x00, 0x2F, 0xF0, 0x25, 0x50, 0x23, 0x30, 0x2D, 0xD0, 0x23, 0x30, 0x00, 0x00 }; /*69BB*/
const unsigned char  uc2_69C1 [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0x20, 0x13, 0xE0, 0x38, 0x00, 0x57, 0xF0, 0x55, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*69C1*/
const unsigned char  uc2_69CA [] = {0x28, 0xF0, 0x7C, 0x90, 0x10, 0xF0, 0x54, 0x90, 0x54, 0xF0, 0x7C, 0x90, 0x13, 0x60, 0x22, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*69CA*/
const unsigned char  uc2_69CC [] = {0x28, 0x40, 0x24, 0x80, 0x75, 0xE0, 0x21, 0x20, 0x6D, 0xE0, 0x35, 0x00, 0x25, 0xE0, 0x25, 0x20, 0x25, 0xE0, 0x2A, 0x00, 0x29, 0xF0, 0x00, 0x00 }; /*69CC*/
const unsigned char  uc2_69CE [] = {0x12, 0x20, 0x11, 0x40, 0x7F, 0xF0, 0x10, 0x80, 0x3B, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x51, 0x00, 0x13, 0xE0, 0x1C, 0x80, 0x13, 0xF0, 0x00, 0x00 }; /*69CE*/
const unsigned char  uc2_69D0 [] = {0x12, 0x00, 0x17, 0xC0, 0x7D, 0x40, 0x17, 0xC0, 0x3D, 0x40, 0x57, 0xC0, 0x51, 0x20, 0x51, 0x50, 0x12, 0xE0, 0x12, 0x90, 0x1C, 0x60, 0x00, 0x00 }; /*69D0*/
const unsigned char  uc2_69D4 [] = {0x11, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x32, 0x20, 0x5B, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x1D, 0xD0, 0x10, 0x80, 0x00, 0x00 }; /*69D4*/
const unsigned char  uc2_69DB [] = {0x22, 0x80, 0x2A, 0xF0, 0x7A, 0x80, 0x2B, 0x40, 0x72, 0x20, 0x2A, 0x20, 0x20, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3F, 0xF0, 0x00, 0x00 }; /*69DB*/
const unsigned char  uc2_69DF [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x50, 0x15, 0x90, 0x39, 0x00, 0x55, 0xE0, 0x51, 0x40, 0x11, 0x40, 0x17, 0xF0, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*69DF*/
const unsigned char  uc2_69E0 [] = {0x28, 0x40, 0x24, 0xF0, 0x70, 0x50, 0x2D, 0xE0, 0x34, 0x40, 0x6C, 0xF0, 0x27, 0x90, 0x24, 0xF0, 0x25, 0x90, 0x26, 0xF0, 0x24, 0x90, 0x00, 0x00 }; /*69E0*/
const unsigned char  uc2_69ED [] = {0x20, 0xA0, 0x2F, 0xF0, 0x7A, 0x80, 0x2B, 0xA0, 0x7A, 0xA0, 0x2F, 0xA0, 0x2A, 0xA0, 0x2B, 0xA0, 0x2E, 0xD0, 0x2A, 0x50, 0x34, 0xA0, 0x00, 0x00 }; /*69ED*/
const unsigned char  uc2_69F2 [] = {0x24, 0x20, 0x27, 0x20, 0x79, 0x60, 0x2F, 0xA0, 0x3A, 0xE0, 0x6F, 0xA0, 0x2A, 0xB0, 0x2F, 0xA0, 0x2A, 0xE0, 0x2A, 0xA0, 0x31, 0x20, 0x00, 0x00 }; /*69F2*/
const unsigned char  uc2_69FD [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x17, 0xF0, 0x3D, 0x50, 0x57, 0xF0, 0x55, 0x50, 0x17, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*69FD*/
const unsigned char  uc2_69FF [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x10, 0x80, 0x3B, 0xE0, 0x52, 0xA0, 0x57, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*69FF*/
const unsigned char  uc2_6A0A [] = {0x11, 0x40, 0x7D, 0xF0, 0x12, 0x40, 0x3D, 0xE0, 0x55, 0x50, 0x12, 0x50, 0x15, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*6A0A*/
const unsigned char  uc2_6A17 [] = {0x13, 0xE0, 0x10, 0x80, 0x7F, 0xF0, 0x15, 0x50, 0x13, 0xE0, 0x38, 0x00, 0x57, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x10, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*6A17*/
const unsigned char  uc2_6A18 [] = {0x12, 0xA0, 0x11, 0x40, 0x7F, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x39, 0x40, 0x51, 0xC0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*6A18*/
const unsigned char  uc2_6A1F [] = {0x10, 0x80, 0x13, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x12, 0x20, 0x3B, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*6A1F*/
const unsigned char  uc2_6A21 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x13, 0xE0, 0x12, 0x20, 0x3B, 0xE0, 0x52, 0x20, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*6A21*/
const unsigned char  uc2_6A28 [] = {0x17, 0xF0, 0x14, 0x10, 0x7F, 0xF0, 0x15, 0x50, 0x14, 0xE0, 0x3D, 0x50, 0x55, 0x40, 0x15, 0xE0, 0x16, 0x40, 0x17, 0xF0, 0x18, 0x40, 0x00, 0x00 }; /*6A28*/
const unsigned char  uc2_6A2A [] = {0x11, 0x40, 0x13, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x10, 0x80, 0x3B, 0xE0, 0x52, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x14, 0x10, 0x00, 0x00 }; /*6A2A*/
const unsigned char  uc2_6A2F [] = {0x10, 0x80, 0x13, 0xE0, 0x7C, 0x90, 0x12, 0xA0, 0x37, 0xF0, 0x58, 0x00, 0x57, 0xF0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x17, 0xF0, 0x00, 0x00 }; /*6A2F*/
const unsigned char  uc2_6A31 [] = {0x20, 0x00, 0x27, 0x70, 0x75, 0x50, 0x25, 0x50, 0x22, 0x20, 0x35, 0x50, 0x69, 0x90, 0x2F, 0xF0, 0x22, 0x40, 0x21, 0x80, 0x2E, 0x70, 0x00, 0x00 }; /*6A31*/
const unsigned char  uc2_6A35 [] = {0x22, 0x80, 0x22, 0x40, 0x77, 0xF0, 0x2C, 0x80, 0x27, 0xE0, 0x34, 0x80, 0x67, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x2A, 0xA0, 0x29, 0x50, 0x00, 0x00 }; /*6A35*/
const unsigned char  uc2_6A3D [] = {0x24, 0x40, 0x2F, 0xE0, 0x72, 0x80, 0x2F, 0xE0, 0x3A, 0xA0, 0x6C, 0x60, 0x2F, 0xE0, 0x28, 0x20, 0x3F, 0xF0, 0x24, 0x40, 0x22, 0xC0, 0x00, 0x00 }; /*6A3D*/
const unsigned char  uc2_6A3E [] = {0x24, 0x50, 0x2F, 0xF0, 0x75, 0x40, 0x25, 0x50, 0x3F, 0x50, 0x65, 0x50, 0x27, 0xE0, 0x2C, 0x50, 0x29, 0xA0, 0x2C, 0x00, 0x33, 0xF0, 0x00, 0x00 }; /*6A3E*/
const unsigned char  uc2_6A44 [] = {0x2C, 0x80, 0x24, 0x80, 0x7F, 0xF0, 0x2A, 0xA0, 0x3E, 0xA0, 0x6A, 0xA0, 0x2E, 0xA0, 0x2B, 0x40, 0x2E, 0x40, 0x32, 0xA0, 0x23, 0x10, 0x00, 0x00 }; /*6A44*/
const unsigned char  uc2_6A47 [] = {0x20, 0x40, 0x23, 0x80, 0x70, 0xC0, 0x23, 0xA0, 0x32, 0xC0, 0x6D, 0x90, 0x26, 0x60, 0x2C, 0xC0, 0x26, 0x60, 0x2C, 0xD0, 0x23, 0x20, 0x00, 0x00 }; /*6A47*/
const unsigned char  uc2_6A50 [] = {0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x44, 0x10, 0x3F, 0xC0, 0x08, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x02, 0x00, 0x00, 0x00 }; /*6A50*/
const unsigned char  uc2_6A58 [] = {0x23, 0xE0, 0x20, 0xA0, 0x77, 0xF0, 0x21, 0x50, 0x36, 0x80, 0x67, 0xF0, 0x25, 0x50, 0x27, 0xF0, 0x25, 0x50, 0x25, 0xD0, 0x24, 0x60, 0x00, 0x00 }; /*6A58*/
const unsigned char  uc2_6A59 [] = {0x20, 0x50, 0x23, 0x60, 0x75, 0x50, 0x22, 0x20, 0x35, 0xD0, 0x68, 0x00, 0x23, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x21, 0x40, 0x27, 0xF0, 0x00, 0x00 }; /*6A59*/
const unsigned char  uc2_6A5B [] = {0x2F, 0xF0, 0x2D, 0x40, 0x7A, 0x40, 0x2F, 0xF0, 0x2A, 0x50, 0x3A, 0x90, 0x6F, 0xA0, 0x2A, 0x20, 0x2A, 0x20, 0x2A, 0x50, 0x34, 0x90, 0x00, 0x00 }; /*6A5B*/
const unsigned char  uc2_6A61 [] = {0x22, 0x00, 0x23, 0xC0, 0x74, 0x40, 0x27, 0xE0, 0x35, 0x20, 0x67, 0xE0, 0x2D, 0x20, 0x22, 0xC0, 0x2D, 0xA0, 0x22, 0xA0, 0x2D, 0x10, 0x00, 0x00 }; /*6A61*/
const unsigned char  uc2_6A65 [] = {0x08, 0x80, 0x69, 0xD0, 0x10, 0xA0, 0x6B, 0xF0, 0x19, 0x20, 0x6F, 0xE0, 0x19, 0x20, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6A65*/
const unsigned char  uc2_6A71 [] = {0x2F, 0xF0, 0x28, 0x00, 0x7F, 0xA0, 0x28, 0x20, 0x3F, 0x70, 0x69, 0x20, 0x2F, 0x60, 0x29, 0x20, 0x2D, 0x20, 0x2B, 0xA0, 0x34, 0x40, 0x00, 0x00 }; /*6A71*/
const unsigned char  uc2_6A79 [] = {0x11, 0xC0, 0x11, 0x40, 0x7B, 0xE0, 0x16, 0xA0, 0x13, 0xE0, 0x3A, 0xA0, 0x57, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*6A79*/
const unsigned char  uc2_6A7C [] = {0x24, 0x80, 0x2A, 0xE0, 0x7A, 0xA0, 0x25, 0xF0, 0x38, 0x80, 0x6B, 0x50, 0x2C, 0xE0, 0x23, 0x50, 0x24, 0xD0, 0x3B, 0x40, 0x20, 0x80, 0x00, 0x00 }; /*6A7C*/
const unsigned char  uc2_6A80 [] = {0x10, 0x80, 0x17, 0xF0, 0x12, 0x20, 0x7E, 0xA0, 0x12, 0x20, 0x3B, 0xE0, 0x55, 0x40, 0x11, 0xC0, 0x11, 0x40, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*6A80*/
const unsigned char  uc2_6A84 [] = {0x24, 0x80, 0x2E, 0x80, 0x7A, 0xF0, 0x2F, 0xA0, 0x3A, 0xA0, 0x64, 0xA0, 0x3F, 0x40, 0x28, 0x40, 0x2E, 0xA0, 0x2A, 0xA0, 0x35, 0x10, 0x00, 0x00 }; /*6A84*/
const unsigned char  uc2_6A8E [] = {0x10, 0x80, 0x11, 0x40, 0x7E, 0xB0, 0x13, 0xE0, 0x31, 0x40, 0x5A, 0xA0, 0x53, 0x60, 0x17, 0xF0, 0x14, 0x90, 0x15, 0x50, 0x15, 0xB0, 0x00, 0x00 }; /*6A8E*/
const unsigned char  uc2_6A90 [] = {0x23, 0xC0, 0x24, 0x40, 0x77, 0xF0, 0x2A, 0xA0, 0x2D, 0xD0, 0x38, 0x10, 0x6B, 0xE0, 0x28, 0x00, 0x2B, 0xE0, 0x2A, 0x20, 0x33, 0xE0, 0x00, 0x00 }; /*6A90*/
const unsigned char  uc2_6A91 [] = {0x13, 0xE0, 0x10, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x1B, 0x60, 0x30, 0x00, 0x53, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x00, 0x00 }; /*6A91*/
const unsigned char  uc2_6A97 [] = {0x3E, 0x40, 0x23, 0xF0, 0x3E, 0xA0, 0x21, 0xF0, 0x2E, 0x40, 0x2A, 0xE0, 0x4E, 0x40, 0x02, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6A97*/
const unsigned char  uc2_6AA0 [] = {0x24, 0x80, 0x7E, 0xF0, 0x25, 0x20, 0x3E, 0x20, 0x6A, 0xC0, 0x3A, 0x60, 0x0D, 0x90, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6AA0*/
const unsigned char  uc2_6AA9 [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0xA0, 0x13, 0x60, 0x1A, 0xA0, 0x33, 0xE0, 0x50, 0x00, 0x17, 0xF0, 0x12, 0xA0, 0x1C, 0x90, 0x13, 0x10, 0x00, 0x00 }; /*6AA9*/
const unsigned char  uc2_6AAB [] = {0x20, 0x80, 0x27, 0xF0, 0x74, 0x10, 0x23, 0x60, 0x35, 0x50, 0x6A, 0x20, 0x2D, 0xD0, 0x20, 0x00, 0x27, 0xF0, 0x22, 0xA0, 0x25, 0x90, 0x00, 0x00 }; /*6AAB*/
const unsigned char  uc2_6AAC [] = {0x22, 0x40, 0x2F, 0xF0, 0x72, 0x40, 0x27, 0xE0, 0x35, 0x20, 0x63, 0xC0, 0x2D, 0x00, 0x22, 0xD0, 0x2D, 0xA0, 0x22, 0xA0, 0x2D, 0x10, 0x00, 0x00 }; /*6AAC*/
const unsigned char  uc2_6B20 [] = {0x08, 0x00, 0x08, 0x00, 0x0F, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*6B20*/
const unsigned char  uc2_6B21 [] = {0x42, 0x00, 0x23, 0xF0, 0x22, 0x10, 0x2C, 0x90, 0x00, 0xA0, 0x10, 0x80, 0x10, 0x80, 0x11, 0x40, 0x21, 0x40, 0x22, 0x20, 0x4C, 0x10, 0x00, 0x00 }; /*6B21*/
const unsigned char  uc2_6B22 [] = {0x02, 0x00, 0x7B, 0xE0, 0x0A, 0x20, 0x4A, 0xA0, 0x2C, 0x80, 0x10, 0x80, 0x10, 0x80, 0x28, 0x80, 0x29, 0x40, 0x41, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*6B22*/
const unsigned char  uc2_6B23 [] = {0x0D, 0x00, 0x31, 0xE0, 0x21, 0x20, 0x22, 0xA0, 0x3C, 0x80, 0x28, 0x80, 0x28, 0x80, 0x29, 0x40, 0x29, 0x40, 0x2A, 0x20, 0x4C, 0x10, 0x00, 0x00 }; /*6B23*/
const unsigned char  uc2_6B24 [] = {0x10, 0x80, 0x10, 0xF0, 0x1E, 0x90, 0x21, 0x50, 0x20, 0x40, 0x3E, 0x40, 0x02, 0x40, 0x1A, 0x40, 0x62, 0xA0, 0x04, 0xA0, 0x3B, 0x10, 0x00, 0x00 }; /*6B24*/
const unsigned char  uc2_6B27 [] = {0x7C, 0x80, 0x40, 0xF0, 0x64, 0x90, 0x55, 0x50, 0x48, 0x60, 0x54, 0x40, 0x54, 0x40, 0x64, 0x40, 0x40, 0xA0, 0x7C, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*6B27*/
const unsigned char  uc2_6B32 [] = {0x28, 0x80, 0x24, 0xF0, 0x54, 0x90, 0x19, 0x50, 0x24, 0x60, 0x44, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x24, 0xA0, 0x3C, 0xA0, 0x21, 0x10, 0x00, 0x00 }; /*6B32*/
const unsigned char  uc2_6B37 [] = {0x32, 0x80, 0x0C, 0xF0, 0x72, 0x90, 0x0B, 0x50, 0x7E, 0x60, 0x28, 0x40, 0x7E, 0x40, 0x2A, 0x40, 0x2A, 0xA0, 0x2C, 0xA0, 0x09, 0x10, 0x00, 0x00 }; /*6B37*/
const unsigned char  uc2_6B39 [] = {0x08, 0x80, 0x7E, 0xF0, 0x14, 0x90, 0x25, 0x40, 0x7F, 0x40, 0x02, 0x40, 0x3A, 0x40, 0x2A, 0x40, 0x3A, 0xA0, 0x2A, 0xA0, 0x0D, 0x10, 0x00, 0x00 }; /*6B39*/
const unsigned char  uc2_6B3A [] = {0x24, 0x80, 0x7E, 0xF0, 0x24, 0x90, 0x3D, 0x50, 0x26, 0x60, 0x3C, 0x40, 0x24, 0x40, 0x7E, 0x40, 0x24, 0xA0, 0x22, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*6B3A*/
const unsigned char  uc2_6B3E [] = {0x08, 0x80, 0x3E, 0xF0, 0x08, 0x90, 0x1D, 0x50, 0x00, 0x60, 0x1C, 0x40, 0x00, 0x40, 0x3E, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x59, 0x10, 0x00, 0x00 }; /*6B3E*/
const unsigned char  uc2_6B43 [] = {0x06, 0x80, 0x78, 0x80, 0x08, 0xF0, 0x7F, 0x10, 0x18, 0x50, 0x6B, 0x40, 0x49, 0x40, 0x6B, 0x40, 0x49, 0x40, 0x7F, 0xA0, 0x41, 0x10, 0x00, 0x00 }; /*6B43*/
const unsigned char  uc2_6B46 [] = {0x08, 0x80, 0x3E, 0xF0, 0x00, 0x90, 0x23, 0x50, 0x14, 0x60, 0x7F, 0x40, 0x22, 0x40, 0x3E, 0x40, 0x22, 0xA0, 0x3E, 0xA0, 0x23, 0x10, 0x00, 0x00 }; /*6B46*/
const unsigned char  uc2_6B47 [] = {0x3E, 0x80, 0x22, 0xF0, 0x3E, 0x90, 0x23, 0x40, 0x3E, 0x40, 0x10, 0x40, 0x3F, 0x40, 0x69, 0x40, 0x35, 0x40, 0x3D, 0x40, 0x06, 0xB0, 0x00, 0x00 }; /*6B47*/
const unsigned char  uc2_6B49 [] = {0x28, 0x80, 0x7F, 0xF0, 0x28, 0x90, 0x7F, 0x50, 0x2A, 0x60, 0x7F, 0x40, 0x2A, 0x40, 0x7E, 0x40, 0x28, 0xA0, 0x6C, 0xA0, 0x2B, 0x10, 0x00, 0x00 }; /*6B49*/
const unsigned char  uc2_6B4C [] = {0x7F, 0x40, 0x2A, 0x70, 0x3A, 0x50, 0x00, 0x90, 0x7F, 0x20, 0x02, 0x20, 0x3A, 0x20, 0x2A, 0x20, 0x3A, 0x50, 0x22, 0x50, 0x0D, 0x90, 0x00, 0x00 }; /*6B4C*/
const unsigned char  uc2_6B59 [] = {0x0C, 0x80, 0x12, 0xF0, 0x6E, 0x90, 0x01, 0x20, 0x1E, 0x40, 0x12, 0x40, 0x7F, 0x40, 0x2D, 0x40, 0x1B, 0x40, 0x6D, 0x60, 0x12, 0x90, 0x00, 0x00 }; /*6B59*/
const unsigned char  uc2_6B62 [] = {0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0xE0, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*6B62*/
const unsigned char  uc2_6B63 [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*6B63*/
const unsigned char  uc2_6B64 [] = {0x08, 0x80, 0x08, 0x80, 0x28, 0x80, 0x28, 0x90, 0x2E, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x28, 0x90, 0x2E, 0x90, 0x70, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*6B64*/
const unsigned char  uc2_6B65 [] = {0x01, 0x00, 0x09, 0xE0, 0x09, 0x00, 0x09, 0x00, 0x3F, 0xF0, 0x00, 0x00, 0x09, 0x20, 0x31, 0x20, 0x00, 0x40, 0x01, 0x80, 0x7E, 0x00, 0x00, 0x00 }; /*6B65*/
const unsigned char  uc2_6B66 [] = {0x00, 0x80, 0x3E, 0xC0, 0x00, 0xA0, 0x7F, 0xF0, 0x00, 0x80, 0x08, 0x80, 0x2E, 0x80, 0x28, 0x90, 0x28, 0x50, 0x2E, 0x50, 0x70, 0x20, 0x00, 0x00 }; /*6B66*/
const unsigned char  uc2_6B67 [] = {0x08, 0x80, 0x08, 0x80, 0x0B, 0xE0, 0x2C, 0x80, 0x28, 0x80, 0x2B, 0xC0, 0x29, 0x40, 0x29, 0x40, 0x2C, 0x80, 0x31, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*6B67*/
const unsigned char  uc2_6B6A [] = {0x3F, 0xE0, 0x06, 0x00, 0x0A, 0xC0, 0x32, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*6B6A*/
const unsigned char  uc2_6B79 [] = {0x7F, 0xF0, 0x04, 0x00, 0x04, 0x00, 0x07, 0xC0, 0x08, 0x40, 0x34, 0x40, 0x02, 0x80, 0x01, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x70, 0x00, 0x00, 0x00 }; /*6B79*/
const unsigned char  uc2_6B7B [] = {0x00, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x1E, 0x90, 0x12, 0xE0, 0x32, 0x80, 0x4C, 0x90, 0x04, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*6B7B*/
const unsigned char  uc2_6B7C [] = {0x00, 0x60, 0x7B, 0x80, 0x20, 0x80, 0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x58, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6B7C*/
const unsigned char  uc2_6B81 [] = {0x01, 0xC0, 0x79, 0x40, 0x21, 0x40, 0x3A, 0x20, 0x28, 0x00, 0x2B, 0xC0, 0x59, 0x40, 0x09, 0x40, 0x08, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6B81*/
const unsigned char  uc2_6B82 [] = {0x00, 0x00, 0x3D, 0xE0, 0x11, 0x20, 0x1D, 0x20, 0x15, 0xE0, 0x15, 0x20, 0x6D, 0x20, 0x05, 0xE0, 0x05, 0x20, 0x09, 0x20, 0x33, 0xF0, 0x00, 0x00 }; /*6B82*/
const unsigned char  uc2_6B83 [] = {0x00, 0x80, 0x78, 0x80, 0x23, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x08, 0x80, 0x09, 0x40, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6B83*/
const unsigned char  uc2_6B84 [] = {0x00, 0x80, 0x78, 0x80, 0x21, 0x40, 0x3E, 0x30, 0x28, 0xC0, 0x2B, 0x00, 0x58, 0xC0, 0x0B, 0x00, 0x08, 0x20, 0x10, 0xC0, 0x67, 0x00, 0x00, 0x00 }; /*6B84*/
const unsigned char  uc2_6B86 [] = {0x00, 0x80, 0x78, 0x80, 0x21, 0x20, 0x3A, 0x60, 0x2B, 0x90, 0x28, 0x10, 0x59, 0xE0, 0x09, 0x20, 0x09, 0x20, 0x11, 0xE0, 0x61, 0x20, 0x00, 0x00 }; /*6B86*/
const unsigned char  uc2_6B87 [] = {0x02, 0x00, 0x7B, 0xF0, 0x22, 0x00, 0x3D, 0xC0, 0x28, 0x40, 0x28, 0x80, 0x5B, 0xF0, 0x09, 0x50, 0x09, 0x50, 0x16, 0x90, 0x61, 0x60, 0x00, 0x00 }; /*6B87*/
const unsigned char  uc2_6B89 [] = {0x02, 0x00, 0x7B, 0xF0, 0x24, 0x10, 0x3B, 0xD0, 0x2A, 0x50, 0x2B, 0xD0, 0x5A, 0x50, 0x0B, 0xD0, 0x0A, 0x50, 0x10, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*6B89*/
const unsigned char  uc2_6B8A [] = {0x00, 0x80, 0x7A, 0x80, 0x23, 0xE0, 0x3A, 0x80, 0x2C, 0x80, 0x2F, 0xF0, 0x59, 0xC0, 0x0A, 0xA0, 0x0A, 0xA0, 0x14, 0x90, 0x60, 0x80, 0x00, 0x00 }; /*6B8A*/
const unsigned char  uc2_6B8B [] = {0x01, 0x00, 0x79, 0x40, 0x21, 0xE0, 0x3F, 0x00, 0x29, 0x60, 0x2F, 0x80, 0x58, 0xA0, 0x08, 0xA0, 0x08, 0x50, 0x10, 0xD0, 0x67, 0x20, 0x00, 0x00 }; /*6B8B*/
const unsigned char  uc2_6B8D [] = {0x00, 0x70, 0x7F, 0x80, 0x22, 0x90, 0x39, 0x50, 0x2B, 0xE0, 0x28, 0x20, 0x58, 0x40, 0x0F, 0xF0, 0x08, 0x40, 0x10, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*6B8D*/
const unsigned char  uc2_6B92 [] = {0x01, 0xC0, 0x79, 0x40, 0x21, 0xC0, 0x38, 0x00, 0x2B, 0xE0, 0x2A, 0x20, 0x5A, 0xA0, 0x0A, 0xA0, 0x08, 0x80, 0x11, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*6B92*/
const unsigned char  uc2_6B93 [] = {0x00, 0x80, 0x79, 0x40, 0x26, 0x30, 0x38, 0x00, 0x2B, 0xE0, 0x28, 0x00, 0x5D, 0x10, 0x0A, 0x90, 0x0A, 0xA0, 0x10, 0x40, 0x67, 0xF0, 0x00, 0x00 }; /*6B93*/
const unsigned char  uc2_6B96 [] = {0x00, 0x80, 0x78, 0x80, 0x27, 0xF0, 0x39, 0x00, 0x2B, 0xE0, 0x2A, 0x20, 0x5B, 0xE0, 0x0A, 0x20, 0x0B, 0xE0, 0x12, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*6B96*/
const unsigned char  uc2_6B9A [] = {0x02, 0x20, 0x79, 0x40, 0x23, 0xE0, 0x3A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x5B, 0xE0, 0x08, 0x80, 0x0F, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6B9A*/
const unsigned char  uc2_6B9B [] = {0x07, 0xC0, 0x78, 0x40, 0x20, 0x80, 0x3E, 0xF0, 0x2A, 0x90, 0x2A, 0xD0, 0x5E, 0xA0, 0x08, 0xD0, 0x0B, 0x10, 0x10, 0x00, 0x6F, 0xF0, 0x00, 0x00 }; /*6B9B*/
const unsigned char  uc2_6BA1 [] = {0x00, 0x80, 0x7F, 0xF0, 0x24, 0x10, 0x38, 0x60, 0x2B, 0x80, 0x2A, 0x00, 0x5B, 0xE0, 0x0A, 0x40, 0x0F, 0xF0, 0x11, 0x20, 0x66, 0x10, 0x00, 0x00 }; /*6BA1*/
const unsigned char  uc2_6BAA [] = {0x00, 0x80, 0x7F, 0xF0, 0x20, 0x80, 0x3B, 0xF0, 0x2C, 0x10, 0x2B, 0xE0, 0x59, 0x40, 0x09, 0xC0, 0x09, 0x40, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6BAA*/
const unsigned char  uc2_6BB3 [] = {0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x70, 0x1F, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*6BB3*/
const unsigned char  uc2_6BB4 [] = {0x7E, 0xE0, 0x40, 0xA0, 0x64, 0xA0, 0x55, 0x10, 0x55, 0xE0, 0x48, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x64, 0x40, 0x40, 0xA0, 0x7F, 0x10, 0x00, 0x00 }; /*6BB4*/
const unsigned char  uc2_6BB5 [] = {0x0D, 0xC0, 0x31, 0x40, 0x21, 0x40, 0x3A, 0x30, 0x20, 0x00, 0x3B, 0xC0, 0x21, 0x40, 0x2D, 0x40, 0x70, 0x80, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*6BB5*/
const unsigned char  uc2_6BB7 [] = {0x18, 0xE0, 0x20, 0xA0, 0x3C, 0xA0, 0x24, 0x90, 0x3D, 0x00, 0x25, 0xE0, 0x38, 0xA0, 0x24, 0xA0, 0x24, 0x40, 0x24, 0xA0, 0x4B, 0x10, 0x00, 0x00 }; /*6BB7*/
const unsigned char  uc2_6BBF [] = {0x00, 0x00, 0x7E, 0xE0, 0x42, 0xA0, 0x7E, 0xA0, 0x55, 0x10, 0x7F, 0xE0, 0x54, 0xA0, 0x7E, 0xA0, 0x54, 0x40, 0x52, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*6BBF*/
const unsigned char  uc2_6BC1 [] = {0x08, 0x00, 0x36, 0xE0, 0x22, 0xA0, 0x36, 0xA0, 0x23, 0x10, 0x3F, 0xE0, 0x00, 0xA0, 0x3E, 0xA0, 0x08, 0x40, 0x0E, 0xA0, 0x71, 0x10, 0x00, 0x00 }; /*6BC1*/
const unsigned char  uc2_6BC2 [] = {0x08, 0x00, 0x7F, 0xE0, 0x08, 0xA0, 0x7F, 0xA0, 0x49, 0x10, 0x7F, 0xE0, 0x28, 0xA0, 0x3E, 0xA0, 0x08, 0x40, 0x7E, 0xA0, 0x09, 0x10, 0x00, 0x00 }; /*6BC2*/
const unsigned char  uc2_6BC5 [] = {0x08, 0xE0, 0x3E, 0xA0, 0x14, 0xA0, 0x7F, 0x10, 0x10, 0x00, 0x6B, 0xE0, 0x14, 0xA0, 0x6E, 0xA0, 0x15, 0x40, 0x64, 0xA0, 0x19, 0x10, 0x00, 0x00 }; /*6BC5*/
const unsigned char  uc2_6BCB [] = {0x1F, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x11, 0x20, 0x7F, 0xF0, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xF0, 0x04, 0x40, 0x39, 0x80, 0x00, 0x00 }; /*6BCB*/
const unsigned char  uc2_6BCD [] = {0x1F, 0xC0, 0x14, 0x40, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x24, 0x40, 0x22, 0x40, 0x22, 0x40, 0x3F, 0xE0, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*6BCD*/
const unsigned char  uc2_6BCF [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x5F, 0xE0, 0x11, 0x20, 0x7F, 0xF0, 0x22, 0x20, 0x21, 0x20, 0x3F, 0xF0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*6BCF*/
const unsigned char  uc2_6BD2 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x14, 0x40, 0x7F, 0xF0, 0x22, 0x40, 0x3F, 0xE0, 0x00, 0x80, 0x00, 0x00 }; /*6BD2*/
const unsigned char  uc2_6BD3 [] = {0x20, 0x80, 0x3F, 0xF0, 0x60, 0x80, 0x39, 0x20, 0x2B, 0xF0, 0x7C, 0x00, 0x2A, 0xA0, 0x2A, 0xA0, 0x7E, 0xA0, 0x0A, 0xA0, 0x14, 0x10, 0x00, 0x00 }; /*6BD3*/
const unsigned char  uc2_6BD4 [] = {0x41, 0x00, 0x41, 0x00, 0x41, 0x00, 0x41, 0x10, 0x7D, 0xE0, 0x41, 0x00, 0x41, 0x00, 0x41, 0x10, 0x4D, 0x10, 0x71, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*6BD4*/
const unsigned char  uc2_6BD5 [] = {0x21, 0x00, 0x3D, 0x30, 0x21, 0xC0, 0x25, 0x10, 0x29, 0x10, 0x32, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*6BD5*/
const unsigned char  uc2_6BD6 [] = {0x21, 0x00, 0x3D, 0x30, 0x21, 0xC0, 0x2D, 0x10, 0x31, 0x10, 0x24, 0xE0, 0x02, 0x00, 0x29, 0x60, 0x4A, 0x10, 0x0C, 0x40, 0x37, 0x80, 0x00, 0x00 }; /*6BD6*/
const unsigned char  uc2_6BD7 [] = {0x04, 0x40, 0x04, 0x40, 0x7C, 0x40, 0x54, 0x50, 0x57, 0x60, 0x7C, 0x40, 0x54, 0x40, 0x54, 0x40, 0x7D, 0x50, 0x46, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*6BD7*/
const unsigned char  uc2_6BD9 [] = {0x21, 0x20, 0x3D, 0xC0, 0x21, 0x10, 0x3C, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x1E, 0x90, 0x6A, 0xE0, 0x0C, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*6BD9*/
const unsigned char  uc2_6BDB [] = {0x03, 0x80, 0x3C, 0x00, 0x04, 0x00, 0x07, 0x80, 0x3C, 0x00, 0x04, 0x00, 0x07, 0xE0, 0x7C, 0x00, 0x04, 0x10, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*6BDB*/
const unsigned char  uc2_6BE1 [] = {0x0D, 0x00, 0x71, 0x00, 0x11, 0xE0, 0x1D, 0x00, 0x71, 0x00, 0x13, 0xC0, 0x1E, 0x40, 0x72, 0x40, 0x13, 0xD0, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*6BE1*/
const unsigned char  uc2_6BEA [] = {0x0C, 0x80, 0x70, 0xA0, 0x11, 0x20, 0x1D, 0xD0, 0x72, 0x80, 0x13, 0xE0, 0x1C, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x10, 0x90, 0x0F, 0xE0, 0x00, 0x00 }; /*6BEA*/
const unsigned char  uc2_6BEB [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x41, 0x10, 0x5E, 0x10, 0x03, 0xC0, 0x1E, 0x00, 0x03, 0xE0, 0x3E, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*6BEB*/
const unsigned char  uc2_6BEF [] = {0x0C, 0x50, 0x71, 0x50, 0x12, 0x60, 0x1C, 0x90, 0x73, 0x10, 0x10, 0x40, 0x1D, 0x50, 0x70, 0xA0, 0x13, 0x20, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*6BEF*/
const unsigned char  uc2_6BF3 [] = {0x01, 0xC0, 0x1E, 0x00, 0x03, 0xC0, 0x1E, 0x00, 0x03, 0xE0, 0x1E, 0x10, 0x71, 0xE0, 0x10, 0x90, 0x7D, 0xE0, 0x10, 0x90, 0x6F, 0x60, 0x00, 0x00 }; /*6BF3*/
const unsigned char  uc2_6BF5 [] = {0x08, 0x30, 0x12, 0xC0, 0x3E, 0x40, 0x08, 0x70, 0x7F, 0xC0, 0x14, 0x40, 0x67, 0x70, 0x08, 0xC0, 0x32, 0x50, 0x04, 0x50, 0x38, 0x20, 0x00, 0x00 }; /*6BF5*/
const unsigned char  uc2_6BF9 [] = {0x08, 0x30, 0x16, 0xC0, 0x61, 0x40, 0x1E, 0x70, 0x71, 0xC0, 0x55, 0x40, 0x75, 0x70, 0x55, 0xC0, 0x75, 0x50, 0x51, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*6BF9*/
const unsigned char  uc2_6BFD [] = {0x11, 0xE0, 0x6C, 0xA0, 0x27, 0xF0, 0x28, 0xA0, 0x3D, 0xE0, 0x64, 0x80, 0x2F, 0xE0, 0x34, 0x80, 0x6B, 0xF0, 0x20, 0x10, 0x1F, 0xF0, 0x00, 0x00 }; /*6BFD*/
const unsigned char  uc2_6C05 [] = {0x2A, 0x40, 0x7F, 0x70, 0x55, 0xD0, 0x5E, 0x20, 0x01, 0xD0, 0x3E, 0x00, 0x03, 0x80, 0x1E, 0x00, 0x03, 0xD0, 0x7E, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*6C05*/
const unsigned char  uc2_6C06 [] = {0x1A, 0x20, 0x67, 0xF0, 0x25, 0x50, 0x3B, 0x60, 0x67, 0xF0, 0x22, 0x20, 0x3B, 0xE0, 0x62, 0x20, 0x23, 0xE0, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*6C06*/
const unsigned char  uc2_6C07 [] = {0x19, 0xC0, 0x66, 0x40, 0x23, 0xE0, 0x3A, 0xA0, 0x63, 0xE0, 0x22, 0xA0, 0x3F, 0xF0, 0x61, 0x40, 0x21, 0xD0, 0x21, 0x50, 0x1F, 0xE0, 0x00, 0x00 }; /*6C07*/
const unsigned char  uc2_6C0D [] = {0x77, 0x30, 0x55, 0xC0, 0x77, 0x40, 0x55, 0x70, 0x77, 0xC0, 0x28, 0x70, 0x3E, 0xC0, 0x68, 0x40, 0x3E, 0x50, 0x28, 0x50, 0x3F, 0x30, 0x00, 0x00 }; /*6C0D*/
const unsigned char  uc2_6C0F [] = {0x01, 0xE0, 0x7E, 0x00, 0x42, 0x00, 0x42, 0x00, 0x7F, 0xE0, 0x42, 0x00, 0x41, 0x00, 0x41, 0x10, 0x4C, 0x90, 0x70, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*6C0F*/
const unsigned char  uc2_6C10 [] = {0x01, 0xE0, 0x7E, 0x00, 0x42, 0x00, 0x42, 0x00, 0x7F, 0xF0, 0x42, 0x00, 0x41, 0x00, 0x49, 0x10, 0x74, 0x90, 0x42, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*6C10*/
const unsigned char  uc2_6C11 [] = {0x7F, 0xE0, 0x40, 0x20, 0x40, 0x20, 0x7F, 0xE0, 0x42, 0x00, 0x42, 0x00, 0x7F, 0xF0, 0x41, 0x00, 0x4D, 0x10, 0x70, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*6C11*/
const unsigned char  uc2_6C13 [] = {0x33, 0xF0, 0x0A, 0x10, 0x7F, 0xF0, 0x22, 0x40, 0x22, 0x40, 0x23, 0xF0, 0x22, 0x40, 0x22, 0x40, 0x1A, 0x50, 0x02, 0xB0, 0x03, 0x10, 0x00, 0x00 }; /*6C13*/
const unsigned char  uc2_6C14 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x2F, 0xC0, 0x40, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x90, 0x00, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*6C14*/
const unsigned char  uc2_6C15 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x2F, 0xC0, 0x40, 0x00, 0x1F, 0x80, 0x04, 0x80, 0x04, 0x80, 0x08, 0x90, 0x10, 0x50, 0x60, 0x20, 0x00, 0x00 }; /*6C15*/
const unsigned char  uc2_6C16 [] = {0x1F, 0xF0, 0x10, 0x00, 0x2F, 0xC0, 0x20, 0x00, 0x5F, 0xC0, 0x00, 0x40, 0x3E, 0x40, 0x12, 0x40, 0x13, 0x50, 0x21, 0x30, 0x4E, 0x10, 0x00, 0x00 }; /*6C16*/
const unsigned char  uc2_6C18 [] = {0x20, 0x00, 0x3F, 0xF0, 0x40, 0x00, 0x5F, 0xC0, 0x00, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x12, 0x50, 0x12, 0x50, 0x12, 0x30, 0x62, 0x10, 0x00, 0x00 }; /*6C18*/
const unsigned char  uc2_6C19 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x3F, 0xE0, 0x40, 0x00, 0x3F, 0xC0, 0x08, 0x40, 0x49, 0x50, 0x49, 0x50, 0x7F, 0x30, 0x01, 0x10, 0x00, 0x00 }; /*6C19*/
const unsigned char  uc2_6C1A [] = {0x10, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x3F, 0xC0, 0x40, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x11, 0x50, 0x15, 0x50, 0x15, 0x30, 0x61, 0x10, 0x00, 0x00 }; /*6C1A*/
const unsigned char  uc2_6C1B [] = {0x1F, 0xF0, 0x10, 0x00, 0x2F, 0xE0, 0x40, 0x00, 0x3F, 0xC0, 0x11, 0x40, 0x60, 0xC0, 0x1F, 0x50, 0x09, 0x50, 0x11, 0x30, 0x63, 0x10, 0x00, 0x00 }; /*6C1B*/
const unsigned char  uc2_6C1F [] = {0x20, 0x00, 0x3F, 0xF0, 0x54, 0x00, 0x3F, 0xC0, 0x15, 0x40, 0x3F, 0x40, 0x54, 0x40, 0x7F, 0x50, 0x15, 0x50, 0x17, 0x30, 0x64, 0x10, 0x00, 0x00 }; /*6C1F*/
const unsigned char  uc2_6C21 [] = {0x3F, 0xF0, 0x20, 0x00, 0x5F, 0xE0, 0x00, 0x00, 0x3F, 0xC0, 0x10, 0x40, 0x1E, 0x40, 0x62, 0x40, 0x1C, 0x50, 0x63, 0x50, 0x14, 0x30, 0x00, 0x00 }; /*6C21*/
const unsigned char  uc2_6C22 [] = {0x20, 0x00, 0x3F, 0xF0, 0x40, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x3E, 0x40, 0x06, 0x40, 0x19, 0x50, 0x6E, 0xD0, 0x04, 0x30, 0x3F, 0x90, 0x00, 0x00 }; /*6C22*/
const unsigned char  uc2_6C24 [] = {0x3F, 0xF0, 0x20, 0x00, 0x5F, 0xE0, 0x00, 0x00, 0x7F, 0xC0, 0x49, 0x40, 0x7F, 0x40, 0x49, 0x50, 0x55, 0x50, 0x7F, 0x30, 0x41, 0x10, 0x00, 0x00 }; /*6C24*/
const unsigned char  uc2_6C26 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x5F, 0xC0, 0x08, 0x40, 0x7F, 0x40, 0x14, 0x40, 0x39, 0x50, 0x12, 0x50, 0x66, 0x30, 0x19, 0x10, 0x00, 0x00 }; /*6C26*/
const unsigned char  uc2_6C27 [] = {0x20, 0x00, 0x3F, 0xF0, 0x40, 0x00, 0x3F, 0xC0, 0x0A, 0x40, 0x3F, 0xC0, 0x04, 0x40, 0x1F, 0x50, 0x04, 0x50, 0x7F, 0xB0, 0x04, 0x10, 0x00, 0x00 }; /*6C27*/
const unsigned char  uc2_6C28 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x5F, 0xC0, 0x08, 0x40, 0x7F, 0x40, 0x49, 0x40, 0x7F, 0xC0, 0x12, 0x50, 0x0C, 0x30, 0x72, 0x10, 0x00, 0x00 }; /*6C28*/
const unsigned char  uc2_6C29 [] = {0x20, 0x00, 0x3F, 0xE0, 0x40, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x7F, 0x40, 0x14, 0x40, 0x55, 0x50, 0x36, 0x50, 0x14, 0x30, 0x7F, 0x10, 0x00, 0x00 }; /*6C29*/
const unsigned char  uc2_6C2A [] = {0x1F, 0xE0, 0x20, 0x00, 0x5F, 0xC0, 0x08, 0x00, 0x7F, 0xC0, 0x08, 0x40, 0x3E, 0x40, 0x22, 0x50, 0x3E, 0x50, 0x14, 0xB0, 0x63, 0x90, 0x00, 0x00 }; /*6C2A*/
const unsigned char  uc2_6C2E [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x5F, 0xC0, 0x29, 0x40, 0x0E, 0x40, 0x71, 0x40, 0x08, 0x50, 0x29, 0x50, 0x16, 0x30, 0x61, 0x10, 0x00, 0x00 }; /*6C2E*/
const unsigned char  uc2_6C2F [] = {0x3F, 0xF0, 0x20, 0x00, 0x5F, 0xC0, 0x02, 0x40, 0x1E, 0x40, 0x02, 0x40, 0x7F, 0xC0, 0x15, 0x50, 0x0E, 0x50, 0x35, 0x30, 0x0C, 0x90, 0x00, 0x00 }; /*6C2F*/
const unsigned char  uc2_6C30 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x00, 0x5F, 0xC0, 0x04, 0x40, 0x1F, 0x40, 0x04, 0x40, 0x3F, 0xD0, 0x11, 0x50, 0x1D, 0x30, 0x13, 0x10, 0x00, 0x00 }; /*6C30*/
const unsigned char  uc2_6C32 [] = {0x20, 0x00, 0x3F, 0xF0, 0x40, 0x00, 0x3F, 0xC0, 0x11, 0x40, 0x1F, 0x40, 0x11, 0x40, 0x3F, 0xC0, 0x2A, 0xD0, 0x2A, 0xB0, 0x7F, 0xD0, 0x00, 0x00 }; /*6C32*/
const unsigned char  uc2_6C34 [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x20, 0x3B, 0x20, 0x0B, 0x40, 0x0A, 0x80, 0x12, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*6C34*/
const unsigned char  uc2_6C38 [] = {0x0E, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x02, 0x20, 0x3A, 0x20, 0x0B, 0x40, 0x0A, 0x80, 0x12, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00 }; /*6C38*/
const unsigned char  uc2_6C3D [] = {0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x3B, 0x20, 0x0A, 0xC0, 0x12, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00 }; /*6C3D*/
const unsigned char  uc2_6C40 [] = {0x30, 0x00, 0x0F, 0xF0, 0x08, 0x80, 0x60, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*6C40*/
const unsigned char  uc2_6C41 [] = {0x30, 0x80, 0x08, 0x80, 0x08, 0x80, 0x67, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6C41*/
const unsigned char  uc2_6C42 [] = {0x02, 0xC0, 0x02, 0x20, 0x7F, 0xF0, 0x02, 0x00, 0x32, 0x20, 0x0B, 0x20, 0x02, 0xC0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00 }; /*6C42*/
const unsigned char  uc2_6C46 [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x62, 0x30, 0x02, 0x40, 0x3B, 0x40, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00 }; /*6C46*/
const unsigned char  uc2_6C47 [] = {0x30, 0x00, 0x0B, 0xF0, 0x0A, 0x00, 0x62, 0x00, 0x12, 0x00, 0x12, 0x00, 0x02, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x63, 0xF0, 0x00, 0x00 }; /*6C47*/
const unsigned char  uc2_6C49 [] = {0x30, 0x00, 0x0B, 0xF0, 0x09, 0x10, 0x61, 0x10, 0x10, 0xA0, 0x10, 0xA0, 0x00, 0x40, 0x08, 0xA0, 0x08, 0xA0, 0x11, 0x20, 0x66, 0x10, 0x00, 0x00 }; /*6C49*/
const unsigned char  uc2_6C4A [] = {0x33, 0xF0, 0x09, 0x10, 0x09, 0x90, 0x61, 0x50, 0x11, 0x50, 0x10, 0xA0, 0x00, 0xA0, 0x08, 0x40, 0x08, 0xA0, 0x11, 0x20, 0x66, 0x10, 0x00, 0x00 }; /*6C4A*/
const unsigned char  uc2_6C50 [] = {0x30, 0x80, 0x08, 0xF0, 0x09, 0x10, 0x66, 0x10, 0x11, 0x90, 0x10, 0x60, 0x00, 0x20, 0x08, 0x40, 0x08, 0x80, 0x13, 0x00, 0x6C, 0x00, 0x00, 0x00 }; /*6C50*/
const unsigned char  uc2_6C54 [] = {0x31, 0x00, 0x09, 0xF0, 0x0A, 0x00, 0x64, 0x00, 0x13, 0xE0, 0x10, 0x20, 0x00, 0xC0, 0x09, 0x10, 0x0A, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*6C54*/
const unsigned char  uc2_6C55 [] = {0x20, 0x80, 0x10, 0x80, 0x10, 0x80, 0x44, 0x90, 0x24, 0x90, 0x24, 0x90, 0x04, 0x90, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*6C55*/
const unsigned char  uc2_6C57 [] = {0x30, 0x00, 0x0B, 0xE0, 0x08, 0x80, 0x60, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6C57*/
const unsigned char  uc2_6C5B [] = {0x60, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x42, 0x40, 0x22, 0x40, 0x2F, 0x40, 0x02, 0x40, 0x12, 0x50, 0x12, 0x50, 0x12, 0x30, 0x62, 0x10, 0x00, 0x00 }; /*6C5B*/
const unsigned char  uc2_6C5C [] = {0x30, 0x00, 0x0B, 0xE0, 0x0A, 0x20, 0x62, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x0A, 0x00, 0x0A, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*6C5C*/
const unsigned char  uc2_6C5D [] = {0x30, 0x80, 0x08, 0x80, 0x08, 0x80, 0x67, 0xF0, 0x11, 0x20, 0x11, 0x20, 0x02, 0x20, 0x13, 0x40, 0x10, 0xA0, 0x11, 0x10, 0x66, 0x10, 0x00, 0x00 }; /*6C5D*/
const unsigned char  uc2_6C5E [] = {0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x20, 0x7B, 0x40, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00 }; /*6C5E*/
const unsigned char  uc2_6C5F [] = {0x60, 0x00, 0x10, 0x00, 0x1F, 0xE0, 0x41, 0x00, 0x21, 0x00, 0x21, 0x00, 0x01, 0x00, 0x11, 0x00, 0x11, 0x00, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6C5F*/
const unsigned char  uc2_6C60 [] = {0x41, 0x00, 0x21, 0x00, 0x29, 0xE0, 0x0F, 0x20, 0x59, 0x20, 0x29, 0x20, 0x29, 0xC0, 0x09, 0x00, 0x28, 0x10, 0x28, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*6C60*/
const unsigned char  uc2_6C61 [] = {0x40, 0x00, 0x27, 0xC0, 0x20, 0x00, 0x1F, 0xF0, 0x42, 0x00, 0x24, 0x00, 0x27, 0xE0, 0x00, 0x20, 0x10, 0x20, 0x10, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*6C61*/
const unsigned char  uc2_6C64 [] = {0x33, 0xC0, 0x08, 0x40, 0x08, 0x80, 0x61, 0x00, 0x13, 0xF0, 0x11, 0x50, 0x01, 0x50, 0x12, 0x50, 0x14, 0x90, 0x11, 0x10, 0x62, 0xE0, 0x00, 0x00 }; /*6C64*/
const unsigned char  uc2_6C68 [] = {0x30, 0x00, 0x0B, 0xF0, 0x0A, 0x10, 0x62, 0x10, 0x12, 0x10, 0x13, 0xF0, 0x02, 0x10, 0x0A, 0x10, 0x0A, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*6C68*/
const unsigned char  uc2_6C69 [] = {0x30, 0x00, 0x0B, 0xF0, 0x0A, 0x10, 0x62, 0x10, 0x12, 0x10, 0x13, 0xD0, 0x02, 0x10, 0x0A, 0x10, 0x0A, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*6C69*/
const unsigned char  uc2_6C6A [] = {0x60, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x00, 0x80, 0x60, 0x80, 0x13, 0xE0, 0x00, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6C6A*/
const unsigned char  uc2_6C70 [] = {0x60, 0x80, 0x10, 0x80, 0x10, 0x80, 0x47, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x01, 0x40, 0x11, 0x40, 0x12, 0x20, 0x23, 0x20, 0x4C, 0x90, 0x00, 0x00 }; /*6C70*/
const unsigned char  uc2_6C72 [] = {0x37, 0xE0, 0x0A, 0x20, 0x0A, 0x40, 0x62, 0x40, 0x12, 0x70, 0x13, 0x10, 0x02, 0xA0, 0x14, 0xA0, 0x14, 0x40, 0x14, 0xA0, 0x6B, 0x10, 0x00, 0x00 }; /*6C72*/
const unsigned char  uc2_6C74 [] = {0x61, 0x80, 0x10, 0x40, 0x17, 0xF0, 0x40, 0x80, 0x20, 0x80, 0x20, 0xE0, 0x00, 0x90, 0x10, 0x90, 0x10, 0x80, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*6C74*/
const unsigned char  uc2_6C76 [] = {0x21, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x42, 0x20, 0x21, 0x40, 0x21, 0x40, 0x00, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x6C, 0x10, 0x00, 0x00 }; /*6C76*/
const unsigned char  uc2_6C79 [] = {0x60, 0x20, 0x12, 0x20, 0x11, 0x40, 0x45, 0x50, 0x24, 0x90, 0x25, 0x50, 0x05, 0x50, 0x16, 0x50, 0x14, 0x10, 0x17, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*6C79*/
const unsigned char  uc2_6C7D [] = {0x22, 0x00, 0x13, 0xF0, 0x14, 0x00, 0x4B, 0xC0, 0x20, 0x00, 0x27, 0xC0, 0x00, 0x40, 0x10, 0x40, 0x10, 0x50, 0x10, 0x50, 0x60, 0x20, 0x00, 0x00 }; /*6C7D*/
const unsigned char  uc2_6C7E [] = {0x31, 0x40, 0x09, 0x40, 0x0A, 0x20, 0x62, 0x20, 0x14, 0x10, 0x13, 0xE0, 0x01, 0x20, 0x11, 0x20, 0x11, 0x20, 0x12, 0x20, 0x6C, 0xC0, 0x00, 0x00 }; /*6C7E*/
const unsigned char  uc2_6C81 [] = {0x30, 0x80, 0x08, 0x40, 0x08, 0x40, 0x61, 0x00, 0x11, 0x20, 0x15, 0x10, 0x05, 0x10, 0x19, 0x20, 0x11, 0x20, 0x11, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*6C81*/
const unsigned char  uc2_6C82 [] = {0x60, 0x70, 0x13, 0x80, 0x12, 0x00, 0x42, 0x00, 0x23, 0xF0, 0x22, 0x40, 0x02, 0x40, 0x12, 0x40, 0x14, 0x40, 0x14, 0x40, 0x68, 0x40, 0x00, 0x00 }; /*6C82*/
const unsigned char  uc2_6C83 [] = {0x60, 0x60, 0x13, 0x80, 0x10, 0x80, 0x40, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x00, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*6C83*/
const unsigned char  uc2_6C85 [] = {0x60, 0x00, 0x17, 0xC0, 0x10, 0x00, 0x40, 0x00, 0x2F, 0xE0, 0x22, 0x80, 0x02, 0x80, 0x22, 0x80, 0x22, 0x90, 0x24, 0x90, 0x58, 0x60, 0x00, 0x00 }; /*6C85*/
const unsigned char  uc2_6C86 [] = {0x63, 0x00, 0x10, 0x80, 0x1F, 0xF0, 0x00, 0x00, 0x63, 0xC0, 0x12, 0x40, 0x02, 0x40, 0x12, 0x50, 0x12, 0x50, 0x12, 0x50, 0x6C, 0x20, 0x00, 0x00 }; /*6C86*/
const unsigned char  uc2_6C88 [] = {0x61, 0x00, 0x11, 0x00, 0x0F, 0xE0, 0x49, 0x20, 0x29, 0x20, 0x21, 0x00, 0x02, 0x80, 0x22, 0x90, 0x22, 0x90, 0x24, 0x90, 0x58, 0x60, 0x00, 0x00 }; /*6C88*/
const unsigned char  uc2_6C89 [] = {0x60, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x04, 0x10, 0x61, 0xC0, 0x11, 0x40, 0x01, 0x40, 0x11, 0x50, 0x11, 0x50, 0x12, 0x50, 0x6C, 0x20, 0x00, 0x00 }; /*6C89*/
const unsigned char  uc2_6C8C [] = {0x60, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x80, 0x62, 0xA0, 0x12, 0xA0, 0x03, 0xE0, 0x10, 0xA0, 0x10, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*6C8C*/
const unsigned char  uc2_6C8F [] = {0x45, 0xF0, 0x24, 0x50, 0x27, 0x50, 0x1C, 0x50, 0x44, 0x50, 0x24, 0x50, 0x25, 0x50, 0x06, 0x90, 0x24, 0x90, 0x21, 0x10, 0x46, 0x60, 0x00, 0x00 }; /*6C8F*/
const unsigned char  uc2_6C90 [] = {0x30, 0x80, 0x08, 0x80, 0x08, 0x80, 0x07, 0xF0, 0x60, 0x80, 0x11, 0xC0, 0x12, 0xA0, 0x02, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x60, 0x80, 0x00, 0x00 }; /*6C90*/
const unsigned char  uc2_6C92 [] = {0x21, 0x00, 0x11, 0xE0, 0x12, 0x20, 0x4C, 0x40, 0x20, 0x80, 0x27, 0xE0, 0x12, 0x20, 0x11, 0x40, 0x20, 0x80, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*6C92*/
const unsigned char  uc2_6C93 [] = {0x02, 0x20, 0x7B, 0x20, 0x0A, 0xC0, 0x12, 0x40, 0x62, 0x30, 0x04, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*6C93*/
const unsigned char  uc2_6C94 [] = {0x6F, 0xF0, 0x11, 0x00, 0x15, 0x00, 0x45, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x07, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x63, 0xC0, 0x00, 0x00 }; /*6C94*/
const unsigned char  uc2_6C99 [] = {0x30, 0x80, 0x08, 0x80, 0x0A, 0xA0, 0x62, 0x90, 0x12, 0x90, 0x14, 0xA0, 0x00, 0xA0, 0x10, 0x40, 0x10, 0x80, 0x23, 0x00, 0x5C, 0x00, 0x00, 0x00 }; /*6C99*/
const unsigned char  uc2_6C9B [] = {0x61, 0x00, 0x11, 0x00, 0x1F, 0xF0, 0x41, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x09, 0x20, 0x29, 0xC0, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6C9B*/
const unsigned char  uc2_6C9F [] = {0x62, 0x00, 0x13, 0xF0, 0x04, 0x10, 0x6A, 0x10, 0x12, 0x10, 0x14, 0x90, 0x05, 0x90, 0x16, 0x50, 0x10, 0x50, 0x10, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*6C9F*/
const unsigned char  uc2_6CA1 [] = {0x63, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x4C, 0x30, 0x20, 0x00, 0x27, 0xE0, 0x02, 0x20, 0x11, 0x40, 0x10, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6CA1*/
const unsigned char  uc2_6CA3 [] = {0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x01, 0x00, 0x47, 0xC0, 0x21, 0x00, 0x21, 0x00, 0x1F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6CA3*/
const unsigned char  uc2_6CA4 [] = {0x67, 0xF0, 0x14, 0x00, 0x14, 0x40, 0x06, 0x40, 0x65, 0x40, 0x14, 0x80, 0x05, 0x40, 0x15, 0x20, 0x16, 0x20, 0x14, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*6CA4*/
const unsigned char  uc2_6CA5 [] = {0x67, 0xF0, 0x14, 0x00, 0x14, 0x80, 0x64, 0x80, 0x17, 0xF0, 0x04, 0x90, 0x14, 0x90, 0x14, 0x90, 0x29, 0x10, 0x29, 0x20, 0x56, 0xC0, 0x00, 0x00 }; /*6CA5*/
const unsigned char  uc2_6CA6 [] = {0x30, 0x80, 0x08, 0x80, 0x09, 0x40, 0x66, 0x30, 0x10, 0x00, 0x11, 0x20, 0x01, 0xC0, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*6CA6*/
const unsigned char  uc2_6CA7 [] = {0x30, 0x80, 0x08, 0x80, 0x09, 0x40, 0x66, 0x30, 0x11, 0xE0, 0x11, 0x20, 0x01, 0x20, 0x09, 0x40, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*6CA7*/
const unsigned char  uc2_6CA9 [] = {0x60, 0x80, 0x14, 0x80, 0x12, 0x80, 0x67, 0xF0, 0x11, 0x10, 0x01, 0x90, 0x11, 0x50, 0x12, 0x50, 0x22, 0x10, 0x24, 0x20, 0x59, 0xC0, 0x00, 0x00 }; /*6CA9*/
const unsigned char  uc2_6CAA [] = {0x63, 0x00, 0x10, 0x80, 0x07, 0xF0, 0x64, 0x10, 0x14, 0x10, 0x07, 0xF0, 0x14, 0x10, 0x14, 0x00, 0x24, 0x00, 0x24, 0x00, 0x58, 0x00, 0x00, 0x00 }; /*6CAA*/
const unsigned char  uc2_6CAB [] = {0x60, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x40, 0x80, 0x20, 0x80, 0x23, 0xE0, 0x00, 0x80, 0x11, 0xC0, 0x12, 0xA0, 0x2C, 0x90, 0x40, 0x80, 0x00, 0x00 }; /*6CAB*/
const unsigned char  uc2_6CAD [] = {0x60, 0xA0, 0x10, 0x90, 0x00, 0x80, 0x67, 0xF0, 0x10, 0x80, 0x11, 0xC0, 0x02, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*6CAD*/
const unsigned char  uc2_6CAE [] = {0x67, 0xC0, 0x14, 0x40, 0x14, 0x40, 0x47, 0xC0, 0x24, 0x40, 0x24, 0x40, 0x07, 0xC0, 0x14, 0x40, 0x14, 0x40, 0x24, 0x40, 0x5F, 0xF0, 0x00, 0x00 }; /*6CAE*/
const unsigned char  uc2_6CB1 [] = {0x63, 0x00, 0x10, 0x80, 0x0F, 0xF0, 0x68, 0x10, 0x12, 0x00, 0x12, 0x60, 0x03, 0x80, 0x12, 0x00, 0x12, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*6CB1*/
const unsigned char  uc2_6CB2 [] = {0x62, 0x00, 0x13, 0xF0, 0x14, 0x00, 0x00, 0x80, 0x62, 0xE0, 0x17, 0xA0, 0x12, 0xA0, 0x02, 0xC0, 0x12, 0x90, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*6CB2*/
const unsigned char  uc2_6CB3 [] = {0x6F, 0xF0, 0x10, 0x40, 0x00, 0x40, 0x47, 0x40, 0x25, 0x40, 0x25, 0x40, 0x07, 0x40, 0x15, 0x40, 0x10, 0x40, 0x20, 0x40, 0x41, 0x80, 0x00, 0x00 }; /*6CB3*/
const unsigned char  uc2_6CB8 [] = {0x42, 0x80, 0x22, 0x80, 0x2F, 0xE0, 0x42, 0xA0, 0x27, 0xE0, 0x2A, 0x80, 0x0F, 0xF0, 0x22, 0x90, 0x22, 0x90, 0x24, 0xA0, 0x58, 0x80, 0x00, 0x00 }; /*6CB8*/
const unsigned char  uc2_6CB9 [] = {0x30, 0x80, 0x08, 0x80, 0x08, 0x80, 0x67, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x07, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6CB9*/
const unsigned char  uc2_6CBB [] = {0x61, 0x00, 0x11, 0x40, 0x12, 0x20, 0x44, 0xE0, 0x27, 0x10, 0x20, 0x10, 0x07, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x17, 0xE0, 0x64, 0x20, 0x00, 0x00 }; /*6CBB*/
const unsigned char  uc2_6CBC [] = {0x33, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x61, 0x10, 0x16, 0x60, 0x10, 0x00, 0x03, 0xF0, 0x0A, 0x10, 0x0A, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*6CBC*/
const unsigned char  uc2_6CBD [] = {0x60, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x80, 0x60, 0x80, 0x13, 0xE0, 0x02, 0x20, 0x0A, 0x20, 0x0A, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*6CBD*/
const unsigned char  uc2_6CBE [] = {0x31, 0x00, 0x09, 0x00, 0x09, 0xF0, 0x61, 0x00, 0x11, 0x00, 0x07, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x24, 0x20, 0x27, 0xE0, 0x44, 0x20, 0x00, 0x00 }; /*6CBE*/
const unsigned char  uc2_6CBF [] = {0x63, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x42, 0x40, 0x2C, 0x30, 0x20, 0x00, 0x07, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x17, 0xE0, 0x64, 0x20, 0x00, 0x00 }; /*6CBF*/
const unsigned char  uc2_6CC4 [] = {0x41, 0x40, 0x25, 0x40, 0x25, 0x40, 0x05, 0x40, 0x5F, 0xF0, 0x25, 0x40, 0x25, 0x40, 0x05, 0x40, 0x25, 0xC0, 0x24, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*6CC4*/
const unsigned char  uc2_6CC5 [] = {0x67, 0xF0, 0x14, 0x10, 0x04, 0x90, 0x64, 0x90, 0x14, 0x90, 0x15, 0x50, 0x05, 0x50, 0x16, 0x50, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6CC5*/
const unsigned char  uc2_6CC9 [] = {0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x7A, 0x20, 0x0B, 0x40, 0x12, 0x80, 0x6C, 0x70, 0x00, 0x00 }; /*6CC9*/
const unsigned char  uc2_6CCA [] = {0x30, 0x80, 0x08, 0x80, 0x09, 0x00, 0x63, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x03, 0xF0, 0x0A, 0x10, 0x0A, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*6CCA*/
const unsigned char  uc2_6CCC [] = {0x41, 0x00, 0x20, 0xA0, 0x22, 0xA0, 0x0A, 0x40, 0x4A, 0x40, 0x2A, 0xA0, 0x2A, 0x90, 0x12, 0x90, 0x23, 0x20, 0x26, 0x20, 0x59, 0xC0, 0x00, 0x00 }; /*6CCC*/
const unsigned char  uc2_6CD0 [] = {0x4E, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x0C, 0xF0, 0x4A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x0A, 0x50, 0x2C, 0x90, 0x28, 0x90, 0x4B, 0x60, 0x00, 0x00 }; /*6CD0*/
const unsigned char  uc2_6CD3 [] = {0x4E, 0x40, 0x22, 0x40, 0x22, 0x40, 0x46, 0x40, 0x28, 0x40, 0x2E, 0x40, 0x02, 0x80, 0x22, 0xA0, 0x22, 0xA0, 0x23, 0x50, 0x4D, 0x90, 0x00, 0x00 }; /*6CD3*/
const unsigned char  uc2_6CD4 [] = {0x62, 0x40, 0x12, 0x40, 0x12, 0x40, 0x0F, 0xF0, 0x62, 0x40, 0x12, 0x40, 0x03, 0xC0, 0x0A, 0x40, 0x0A, 0x40, 0x13, 0xC0, 0x62, 0x40, 0x00, 0x00 }; /*6CD4*/
const unsigned char  uc2_6CD5 [] = {0x30, 0x80, 0x08, 0x80, 0x0B, 0xE0, 0x60, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x01, 0x00, 0x11, 0x20, 0x12, 0x60, 0x13, 0x90, 0x60, 0x10, 0x00, 0x00 }; /*6CD5*/
const unsigned char  uc2_6CD6 [] = {0x61, 0x70, 0x16, 0x50, 0x15, 0x50, 0x65, 0x50, 0x15, 0x50, 0x15, 0x50, 0x05, 0x50, 0x17, 0x60, 0x11, 0x40, 0x12, 0x40, 0x6C, 0x40, 0x00, 0x00 }; /*6CD6*/
const unsigned char  uc2_6CD7 [] = {0x67, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x45, 0x50, 0x25, 0x50, 0x25, 0x50, 0x05, 0x30, 0x16, 0x10, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6CD7*/
const unsigned char  uc2_6CDB [] = {0x60, 0x70, 0x17, 0x80, 0x11, 0x00, 0x60, 0x80, 0x13, 0xE0, 0x10, 0x20, 0x00, 0x40, 0x10, 0x80, 0x13, 0x00, 0x15, 0x00, 0x64, 0xF0, 0x00, 0x00 }; /*6CDB*/
const unsigned char  uc2_6CDE [] = {0x60, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00, 0x67, 0xF0, 0x10, 0x80, 0x00, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*6CDE*/
const unsigned char  uc2_6CE0 [] = {0x61, 0x00, 0x11, 0x00, 0x12, 0x80, 0x44, 0x40, 0x3B, 0x30, 0x20, 0x80, 0x07, 0xE0, 0x20, 0x20, 0x23, 0x40, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*6CE0*/
const unsigned char  uc2_6CE1 [] = {0x61, 0x00, 0x13, 0xE0, 0x1C, 0x20, 0x63, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x03, 0xA0, 0x12, 0x40, 0x12, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*6CE1*/
const unsigned char  uc2_6CE2 [] = {0x40, 0x80, 0x20, 0x80, 0x2F, 0xF0, 0x48, 0x90, 0x28, 0xA0, 0x2F, 0xE0, 0x0A, 0x20, 0x29, 0x40, 0x28, 0x80, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*6CE2*/
const unsigned char  uc2_6CE3 [] = {0x63, 0x00, 0x10, 0x80, 0x07, 0xF0, 0x60, 0x20, 0x12, 0x20, 0x11, 0x20, 0x01, 0x40, 0x11, 0x40, 0x10, 0x40, 0x10, 0x80, 0x6F, 0xF0, 0x00, 0x00 }; /*6CE3*/
const unsigned char  uc2_6CE5 [] = {0x67, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x07, 0xE0, 0x64, 0x00, 0x15, 0x00, 0x15, 0x30, 0x05, 0xC0, 0x15, 0x10, 0x15, 0x10, 0x68, 0xE0, 0x00, 0x00 }; /*6CE5*/
const unsigned char  uc2_6CE8 [] = {0x63, 0x00, 0x10, 0x80, 0x07, 0xF0, 0x60, 0x80, 0x10, 0x80, 0x10, 0x80, 0x03, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6CE8*/
const unsigned char  uc2_6CEA [] = {0x33, 0xF0, 0x0A, 0x10, 0x0A, 0x10, 0x63, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x03, 0xF0, 0x0A, 0x10, 0x0A, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*6CEA*/
const unsigned char  uc2_6CEB [] = {0x61, 0x00, 0x1F, 0xF0, 0x01, 0x40, 0x62, 0x40, 0x14, 0x80, 0x17, 0x80, 0x01, 0x00, 0x12, 0x40, 0x14, 0xC0, 0x27, 0x20, 0x40, 0x20, 0x00, 0x00 }; /*6CEB*/
const unsigned char  uc2_6CEE [] = {0x41, 0x00, 0x29, 0x20, 0x25, 0x20, 0x05, 0x40, 0x4F, 0xE0, 0x21, 0x00, 0x21, 0x00, 0x1F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6CEE*/
const unsigned char  uc2_6CEF [] = {0x4F, 0xE0, 0x28, 0x20, 0x28, 0x20, 0x0F, 0xE0, 0x48, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x08, 0x80, 0x29, 0x50, 0x2E, 0x50, 0x48, 0x20, 0x00, 0x00 }; /*6CEF*/
const unsigned char  uc2_6CF0 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6A, 0xB0, 0x07, 0x00, 0x0A, 0xC0, 0x36, 0x20, 0x00, 0x00 }; /*6CF0*/
const unsigned char  uc2_6CF1 [] = {0x30, 0x80, 0x08, 0x80, 0x0B, 0xE0, 0x62, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x07, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x12, 0x40, 0x6C, 0x30, 0x00, 0x00 }; /*6CF1*/
const unsigned char  uc2_6CF3 [] = {0x63, 0x00, 0x10, 0x80, 0x07, 0x80, 0x60, 0x80, 0x10, 0x90, 0x16, 0xD0, 0x02, 0xA0, 0x12, 0xA0, 0x14, 0xA0, 0x28, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*6CF3*/
const unsigned char  uc2_6CF5 [] = {0x7F, 0xF0, 0x04, 0x00, 0x0F, 0xC0, 0x18, 0x40, 0x6F, 0xC0, 0x01, 0x00, 0x3D, 0x20, 0x05, 0xA0, 0x09, 0x40, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6CF5*/
const unsigned char  uc2_6CF6 [] = {0x24, 0x20, 0x12, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x3A, 0x40, 0x0B, 0x40, 0x12, 0x80, 0x62, 0x70, 0x0C, 0x00, 0x00, 0x00 }; /*6CF6*/
const unsigned char  uc2_6CF7 [] = {0x62, 0xC0, 0x12, 0x20, 0x1F, 0xF0, 0x62, 0x80, 0x12, 0x80, 0x12, 0xA0, 0x04, 0xA0, 0x24, 0xC0, 0x29, 0x90, 0x2A, 0x90, 0x54, 0x60, 0x00, 0x00 }; /*6CF7*/
const unsigned char  uc2_6CF8 [] = {0x61, 0x00, 0x11, 0xF0, 0x01, 0x00, 0x67, 0xE0, 0x14, 0x20, 0x14, 0x20, 0x07, 0xE0, 0x14, 0x00, 0x14, 0x00, 0x24, 0x00, 0x58, 0x00, 0x00, 0x00 }; /*6CF8*/
const unsigned char  uc2_6CFA [] = {0x40, 0x60, 0x27, 0x80, 0x24, 0x00, 0x04, 0x80, 0x48, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x04, 0xA0, 0x24, 0x90, 0x28, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*6CFA*/
const unsigned char  uc2_6CFB [] = {0x67, 0xF0, 0x14, 0x10, 0x15, 0x10, 0x01, 0xE0, 0x62, 0x00, 0x13, 0xF0, 0x00, 0x10, 0x17, 0xD0, 0x10, 0x10, 0x20, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*6CFB*/
const unsigned char  uc2_6CFC [] = {0x45, 0x40, 0x29, 0x20, 0x2F, 0xF0, 0x41, 0x00, 0x23, 0xE0, 0x22, 0x20, 0x05, 0x40, 0x25, 0x40, 0x28, 0x80, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*6CFC*/
const unsigned char  uc2_6CFD [] = {0x67, 0xE0, 0x12, 0x20, 0x11, 0x40, 0x41, 0xC0, 0x26, 0x30, 0x20, 0x80, 0x03, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*6CFD*/
const unsigned char  uc2_6CFE [] = {0x60, 0x00, 0x17, 0xC0, 0x10, 0x40, 0x00, 0x80, 0x61, 0x60, 0x16, 0x10, 0x00, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6CFE*/
const unsigned char  uc2_6D01 [] = {0x30, 0x80, 0x08, 0x80, 0x07, 0xF0, 0x60, 0x80, 0x13, 0xE0, 0x00, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x22, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*6D01*/
const unsigned char  uc2_6D04 [] = {0x67, 0xF0, 0x14, 0x10, 0x04, 0x10, 0x65, 0xD0, 0x15, 0x50, 0x15, 0x50, 0x05, 0xD0, 0x14, 0x10, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6D04*/
const unsigned char  uc2_6D07 [] = {0x67, 0xF0, 0x14, 0x10, 0x14, 0x90, 0x47, 0xF0, 0x24, 0x90, 0x25, 0x50, 0x05, 0x50, 0x16, 0x50, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6D07*/
const unsigned char  uc2_6D0B [] = {0x62, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x00, 0x80, 0x60, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x00, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*6D0B*/
const unsigned char  uc2_6D0C [] = {0x4F, 0x90, 0x24, 0x10, 0x24, 0x50, 0x47, 0x50, 0x25, 0x50, 0x2D, 0x50, 0x0B, 0x50, 0x12, 0x50, 0x22, 0x50, 0x24, 0x10, 0x58, 0x60, 0x00, 0x00 }; /*6D0C*/
const unsigned char  uc2_6D0E [] = {0x61, 0x00, 0x17, 0xF0, 0x04, 0x10, 0x64, 0x10, 0x17, 0xF0, 0x04, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x24, 0x10, 0x27, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*6D0E*/
const unsigned char  uc2_6D12 [] = {0x5F, 0xF0, 0x22, 0x80, 0x22, 0x80, 0x4F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x0A, 0xA0, 0x2C, 0x60, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*6D12*/
const unsigned char  uc2_6D17 [] = {0x60, 0x80, 0x12, 0x80, 0x03, 0xE0, 0x62, 0x80, 0x14, 0x80, 0x17, 0xF0, 0x01, 0x40, 0x09, 0x40, 0x09, 0x50, 0x11, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*6D17*/
const unsigned char  uc2_6D19 [] = {0x20, 0x80, 0x12, 0x80, 0x13, 0xE0, 0x44, 0x80, 0x20, 0x80, 0x27, 0xF0, 0x01, 0xC0, 0x22, 0xA0, 0x22, 0xA0, 0x24, 0x90, 0x40, 0x80, 0x00, 0x00 }; /*6D19*/
const unsigned char  uc2_6D1A [] = {0x44, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x1A, 0x80, 0x41, 0x00, 0x26, 0xC0, 0x39, 0x30, 0x07, 0xC0, 0x29, 0x00, 0x2F, 0xE0, 0x41, 0x00, 0x00, 0x00 }; /*6D1A*/
const unsigned char  uc2_6D1B [] = {0x44, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x4A, 0x80, 0x21, 0x00, 0x26, 0xC0, 0x18, 0x30, 0x27, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x44, 0x40, 0x00, 0x00 }; /*6D1B*/
const unsigned char  uc2_6D1E [] = {0x67, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x44, 0x10, 0x25, 0xD0, 0x25, 0x50, 0x05, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x24, 0x10, 0x44, 0xE0, 0x00, 0x00 }; /*6D1E*/
const unsigned char  uc2_6D25 [] = {0x41, 0x00, 0x27, 0xC0, 0x21, 0x40, 0x0F, 0xF0, 0x41, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x07, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x41, 0x00, 0x00, 0x00 }; /*6D25*/
const unsigned char  uc2_6D27 [] = {0x60, 0x80, 0x17, 0xF0, 0x11, 0x00, 0x67, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x62, 0xC0, 0x00, 0x00 }; /*6D27*/
const unsigned char  uc2_6D2A [] = {0x62, 0x40, 0x12, 0x40, 0x07, 0xE0, 0x42, 0x40, 0x22, 0x40, 0x22, 0x40, 0x0F, 0xF0, 0x20, 0x00, 0x22, 0x60, 0x22, 0x10, 0x4C, 0x10, 0x00, 0x00 }; /*6D2A*/
const unsigned char  uc2_6D2B [] = {0x41, 0x00, 0x22, 0x00, 0x2F, 0xE0, 0x4A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x0A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*6D2B*/
const unsigned char  uc2_6D2E [] = {0x61, 0x40, 0x11, 0x50, 0x1D, 0x50, 0x43, 0x60, 0x21, 0x40, 0x21, 0x60, 0x03, 0x50, 0x2D, 0x40, 0x21, 0x50, 0x22, 0x50, 0x4C, 0x20, 0x00, 0x00 }; /*6D2E*/
const unsigned char  uc2_6D31 [] = {0x5F, 0xF0, 0x24, 0x40, 0x24, 0x40, 0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x04, 0x40, 0x24, 0x70, 0x27, 0xC0, 0x38, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*6D31*/
const unsigned char  uc2_6D32 [] = {0x44, 0x10, 0x24, 0x90, 0x24, 0x90, 0x14, 0x90, 0x56, 0xD0, 0x25, 0xB0, 0x24, 0x90, 0x04, 0x90, 0x28, 0x90, 0x28, 0x90, 0x50, 0x10, 0x00, 0x00 }; /*6D32*/
const unsigned char  uc2_6D33 [] = {0x42, 0x00, 0x22, 0x70, 0x2F, 0x50, 0x45, 0x50, 0x25, 0x50, 0x29, 0x50, 0x0D, 0x50, 0x22, 0x50, 0x25, 0x50, 0x25, 0x70, 0x58, 0x50, 0x00, 0x00 }; /*6D33*/
const unsigned char  uc2_6D35 [] = {0x44, 0x00, 0x27, 0xF0, 0x28, 0x10, 0x57, 0x90, 0x24, 0x90, 0x27, 0x90, 0x04, 0x90, 0x27, 0x90, 0x24, 0x90, 0x20, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*6D35*/
const unsigned char  uc2_6D39 [] = {0x6F, 0xF0, 0x10, 0x00, 0x13, 0xC0, 0x62, 0x40, 0x12, 0x40, 0x13, 0xC0, 0x02, 0x40, 0x12, 0x40, 0x13, 0xC0, 0x10, 0x00, 0x6F, 0xF0, 0x00, 0x00 }; /*6D39*/
const unsigned char  uc2_6D3B [] = {0x60, 0x60, 0x13, 0x80, 0x00, 0x80, 0x67, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x03, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*6D3B*/
const unsigned char  uc2_6D3C [] = {0x60, 0x80, 0x13, 0xE0, 0x00, 0x80, 0x60, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*6D3C*/
const unsigned char  uc2_6D3D [] = {0x41, 0x00, 0x21, 0x00, 0x22, 0x80, 0x04, 0x40, 0x5B, 0xB0, 0x20, 0x00, 0x27, 0xC0, 0x04, 0x40, 0x24, 0x40, 0x27, 0xC0, 0x44, 0x40, 0x00, 0x00 }; /*6D3D*/
const unsigned char  uc2_6D3E [] = {0x40, 0x70, 0x2F, 0x80, 0x28, 0x30, 0x4B, 0xC0, 0x2A, 0x90, 0x2A, 0x90, 0x0A, 0xA0, 0x2A, 0x40, 0x2A, 0x20, 0x2B, 0xA0, 0x52, 0x10, 0x00, 0x00 }; /*6D3E*/
const unsigned char  uc2_6D41 [] = {0x41, 0x00, 0x2F, 0xF0, 0x22, 0x20, 0x44, 0xE0, 0x27, 0x10, 0x20, 0x10, 0x05, 0x40, 0x25, 0x40, 0x25, 0x50, 0x25, 0x50, 0x59, 0x20, 0x00, 0x00 }; /*6D41*/
const unsigned char  uc2_6D43 [] = {0x41, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x01, 0x00, 0x49, 0x20, 0x25, 0x40, 0x2F, 0xF0, 0x01, 0x00, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*6D43*/
const unsigned char  uc2_6D45 [] = {0x62, 0x80, 0x12, 0x40, 0x13, 0xE0, 0x0E, 0x00, 0x62, 0x00, 0x12, 0xE0, 0x1F, 0x20, 0x01, 0x40, 0x10, 0x90, 0x11, 0x90, 0x6E, 0x60, 0x00, 0x00 }; /*6D45*/
const unsigned char  uc2_6D46 [] = {0x04, 0x40, 0x34, 0x70, 0x0D, 0xD0, 0x14, 0x60, 0x65, 0x80, 0x04, 0x00, 0x01, 0x20, 0x3D, 0xA0, 0x05, 0x40, 0x09, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*6D46*/
const unsigned char  uc2_6D47 [] = {0x62, 0x60, 0x13, 0x80, 0x0E, 0x50, 0x61, 0x90, 0x16, 0x60, 0x10, 0x00, 0x07, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x6C, 0x20, 0x00, 0x00 }; /*6D47*/
const unsigned char  uc2_6D48 [] = {0x31, 0x00, 0x09, 0xF0, 0x09, 0x00, 0x67, 0xE0, 0x14, 0x20, 0x15, 0x20, 0x05, 0x20, 0x15, 0xA0, 0x11, 0x40, 0x12, 0x20, 0x6C, 0x20, 0x00, 0x00 }; /*6D48*/
const unsigned char  uc2_6D4A [] = {0x41, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x49, 0x20, 0x29, 0x20, 0x2F, 0xE0, 0x01, 0x00, 0x21, 0x20, 0x21, 0xE0, 0x3E, 0x10, 0x40, 0x10, 0x00, 0x00 }; /*6D4A*/
const unsigned char  uc2_6D4B [] = {0x5F, 0x10, 0x31, 0x10, 0x11, 0x50, 0x55, 0x50, 0x35, 0x50, 0x15, 0x50, 0x14, 0x50, 0x2A, 0x50, 0x29, 0x10, 0x51, 0x10, 0x20, 0x60, 0x00, 0x00 }; /*6D4B*/
const unsigned char  uc2_6D4D [] = {0x61, 0x00, 0x11, 0x00, 0x12, 0x80, 0x44, 0x40, 0x3B, 0xB0, 0x20, 0x00, 0x0F, 0xE0, 0x22, 0x40, 0x24, 0xC0, 0x27, 0x20, 0x40, 0x20, 0x00, 0x00 }; /*6D4D*/
const unsigned char  uc2_6D4E [] = {0x60, 0x80, 0x17, 0xF0, 0x01, 0x40, 0x60, 0x80, 0x11, 0x40, 0x16, 0x30, 0x01, 0x40, 0x11, 0x40, 0x11, 0x40, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*6D4E*/
const unsigned char  uc2_6D4F [] = {0x48, 0x10, 0x24, 0x10, 0x3F, 0x50, 0x42, 0x50, 0x22, 0x50, 0x2A, 0x50, 0x04, 0x50, 0x2A, 0x50, 0x2A, 0x10, 0x30, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*6D4F*/
const unsigned char  uc2_6D51 [] = {0x4F, 0xF0, 0x28, 0x10, 0x21, 0x00, 0x0F, 0xF0, 0x41, 0x00, 0x22, 0x80, 0x23, 0xE0, 0x00, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*6D51*/
const unsigned char  uc2_6D52 [] = {0x41, 0x00, 0x29, 0xE0, 0x25, 0x40, 0x02, 0x40, 0x4C, 0x40, 0x25, 0xF0, 0x24, 0x40, 0x04, 0x40, 0x16, 0x40, 0x14, 0x40, 0x60, 0x40, 0x00, 0x00 }; /*6D52*/
const unsigned char  uc2_6D53 [] = {0x40, 0x80, 0x2F, 0xF0, 0x28, 0x90, 0x09, 0x10, 0x41, 0x00, 0x22, 0xA0, 0x2C, 0xA0, 0x02, 0x40, 0x22, 0x40, 0x22, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*6D53*/
const unsigned char  uc2_6D54 [] = {0x67, 0xE0, 0x10, 0x20, 0x13, 0xE0, 0x00, 0x20, 0x67, 0xE0, 0x10, 0x40, 0x0F, 0xF0, 0x14, 0x40, 0x12, 0x40, 0x12, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*6D54*/
const unsigned char  uc2_6D59 [] = {0x44, 0x30, 0x24, 0xC0, 0x2E, 0x80, 0x04, 0x80, 0x44, 0xF0, 0x24, 0xA0, 0x26, 0xA0, 0x1C, 0xA0, 0x24, 0xA0, 0x24, 0xA0, 0x59, 0x20, 0x00, 0x00 }; /*6D59*/
const unsigned char  uc2_6D5A [] = {0x61, 0x20, 0x12, 0x60, 0x13, 0x90, 0x41, 0x50, 0x22, 0x20, 0x2D, 0x10, 0x01, 0xD0, 0x17, 0x40, 0x10, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*6D5A*/
const unsigned char  uc2_6D5C [] = {0x60, 0xE0, 0x17, 0x00, 0x14, 0x00, 0x47, 0xE0, 0x24, 0x80, 0x24, 0x80, 0x04, 0x80, 0x1F, 0xF0, 0x22, 0x40, 0x24, 0x20, 0x58, 0x20, 0x00, 0x00 }; /*6D5C*/
const unsigned char  uc2_6D5E [] = {0x47, 0xE0, 0x24, 0x20, 0x24, 0x20, 0x47, 0xE0, 0x21, 0x00, 0x21, 0x00, 0x05, 0xE0, 0x25, 0x00, 0x25, 0x00, 0x2B, 0x00, 0x50, 0xF0, 0x00, 0x00 }; /*6D5E*/
const unsigned char  uc2_6D60 [] = {0x46, 0x40, 0x21, 0x80, 0x22, 0x40, 0x0F, 0xF0, 0x42, 0x00, 0x24, 0x80, 0x3B, 0xE0, 0x02, 0xA0, 0x22, 0xA0, 0x22, 0xC0, 0x40, 0x80, 0x00, 0x00 }; /*6D60*/
const unsigned char  uc2_6D63 [] = {0x41, 0x00, 0x2F, 0xF0, 0x28, 0x10, 0x08, 0x10, 0x43, 0xC0, 0x20, 0x00, 0x2F, 0xF0, 0x02, 0x40, 0x22, 0x50, 0x24, 0x50, 0x58, 0x20, 0x00, 0x00 }; /*6D63*/
const unsigned char  uc2_6D66 [] = {0x41, 0x20, 0x3F, 0xF0, 0x21, 0x00, 0x4F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x09, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x29, 0x20, 0x49, 0xC0, 0x00, 0x00 }; /*6D66*/
const unsigned char  uc2_6D69 [] = {0x20, 0x80, 0x12, 0x80, 0x13, 0xE0, 0x44, 0x80, 0x28, 0x80, 0x27, 0xF0, 0x00, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*6D69*/
const unsigned char  uc2_6D6A [] = {0x41, 0x00, 0x2F, 0xC0, 0x28, 0x40, 0x0F, 0xC0, 0x48, 0x40, 0x2F, 0xC0, 0x29, 0x20, 0x09, 0x20, 0x28, 0xC0, 0x2A, 0x40, 0x4C, 0x30, 0x00, 0x00 }; /*6D6A*/
const unsigned char  uc2_6D6E [] = {0x40, 0x70, 0x3F, 0x80, 0x25, 0x20, 0x42, 0xA0, 0x27, 0xC0, 0x20, 0x40, 0x00, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x47, 0x00, 0x00, 0x00 }; /*6D6E*/
const unsigned char  uc2_6D6F [] = {0x4F, 0xE0, 0x21, 0x00, 0x27, 0xC0, 0x42, 0x40, 0x22, 0x40, 0x2F, 0xF0, 0x00, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x24, 0x40, 0x47, 0xC0, 0x00, 0x00 }; /*6D6F*/
const unsigned char  uc2_6D74 [] = {0x44, 0x40, 0x24, 0x20, 0x29, 0x20, 0x42, 0x80, 0x24, 0x40, 0x38, 0x30, 0x07, 0xC0, 0x24, 0x40, 0x24, 0x40, 0x27, 0xC0, 0x44, 0x40, 0x00, 0x00 }; /*6D74*/
const unsigned char  uc2_6D77 [] = {0x44, 0x00, 0x27, 0xF0, 0x28, 0x00, 0x53, 0xE0, 0x23, 0x20, 0x22, 0xA0, 0x0F, 0xF0, 0x25, 0x20, 0x27, 0xF0, 0x20, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*6D77*/
const unsigned char  uc2_6D78 [] = {0x4F, 0xC0, 0x20, 0x40, 0x27, 0xC0, 0x00, 0x40, 0x5F, 0xF0, 0x30, 0x10, 0x1F, 0xD0, 0x04, 0x40, 0x22, 0x80, 0x23, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*6D78*/
const unsigned char  uc2_6D7C [] = {0x61, 0x00, 0x11, 0xE0, 0x12, 0x20, 0x4C, 0x40, 0x27, 0xF0, 0x24, 0x90, 0x07, 0xF0, 0x10, 0x80, 0x11, 0x50, 0x22, 0x50, 0x4C, 0x20, 0x00, 0x00 }; /*6D7C*/
const unsigned char  uc2_6D82 [] = {0x41, 0x00, 0x22, 0x80, 0x24, 0x40, 0x1B, 0xB0, 0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x05, 0x40, 0x25, 0x20, 0x29, 0x20, 0x46, 0x00, 0x00, 0x00 }; /*6D82*/
const unsigned char  uc2_6D85 [] = {0x40, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x01, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6D85*/
const unsigned char  uc2_6D88 [] = {0x64, 0x90, 0x12, 0x90, 0x02, 0xA0, 0x67, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x04, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x14, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*6D88*/
const unsigned char  uc2_6D89 [] = {0x41, 0x00, 0x25, 0xC0, 0x25, 0x00, 0x1F, 0xF0, 0x40, 0x00, 0x25, 0x20, 0x25, 0x20, 0x09, 0x40, 0x20, 0x80, 0x23, 0x00, 0x5C, 0x00, 0x00, 0x00 }; /*6D89*/
const unsigned char  uc2_6D8C [] = {0x67, 0xE0, 0x12, 0x20, 0x01, 0x40, 0x67, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x04, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x24, 0x90, 0x44, 0xE0, 0x00, 0x00 }; /*6D8C*/
const unsigned char  uc2_6D8E [] = {0x4C, 0x30, 0x25, 0xC0, 0x24, 0x40, 0x49, 0x40, 0x2D, 0x70, 0x25, 0x40, 0x15, 0x40, 0x2D, 0xF0, 0x24, 0x00, 0x2B, 0x00, 0x50, 0xF0, 0x00, 0x00 }; /*6D8E*/
const unsigned char  uc2_6D91 [] = {0x41, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x4F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x01, 0x00, 0x23, 0x80, 0x25, 0x40, 0x39, 0x30, 0x41, 0x00, 0x00, 0x00 }; /*6D91*/
const unsigned char  uc2_6D93 [] = {0x33, 0xE0, 0x0A, 0x20, 0x03, 0xE0, 0x60, 0x00, 0x17, 0xF0, 0x04, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*6D93*/
const unsigned char  uc2_6D94 [] = {0x60, 0x80, 0x14, 0x90, 0x07, 0xF0, 0x60, 0x80, 0x11, 0x40, 0x16, 0xB0, 0x00, 0x40, 0x13, 0xE0, 0x10, 0x20, 0x10, 0x40, 0x60, 0x80, 0x00, 0x00 }; /*6D94*/
const unsigned char  uc2_6D95 [] = {0x44, 0x40, 0x22, 0x80, 0x2F, 0xE0, 0x41, 0x20, 0x27, 0xE0, 0x29, 0x00, 0x0F, 0xF0, 0x25, 0x10, 0x25, 0x10, 0x39, 0x60, 0x41, 0x00, 0x00, 0x00 }; /*6D95*/
const unsigned char  uc2_6D9B [] = {0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x47, 0xC0, 0x22, 0x00, 0x3F, 0xF0, 0x02, 0x40, 0x27, 0xE0, 0x3A, 0x40, 0x22, 0x40, 0x41, 0x80, 0x00, 0x00 }; /*6D9B*/
const unsigned char  uc2_6D9D [] = {0x42, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x40, 0x00, 0x2F, 0xF0, 0x28, 0x10, 0x09, 0x10, 0x27, 0xE0, 0x21, 0x20, 0x22, 0x20, 0x4C, 0xC0, 0x00, 0x00 }; /*6D9D*/
const unsigned char  uc2_6D9E [] = {0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x09, 0x20, 0x45, 0x40, 0x3F, 0xF0, 0x21, 0x00, 0x03, 0x80, 0x25, 0x40, 0x39, 0x30, 0x41, 0x00, 0x00, 0x00 }; /*6D9E*/
const unsigned char  uc2_6D9F [] = {0x48, 0x80, 0x25, 0xF0, 0x24, 0x80, 0x41, 0x40, 0x2D, 0xF0, 0x24, 0x40, 0x05, 0xF0, 0x24, 0x40, 0x24, 0x40, 0x2B, 0x00, 0x50, 0xF0, 0x00, 0x00 }; /*6D9F*/
const unsigned char  uc2_6DA0 [] = {0x67, 0xF0, 0x14, 0x90, 0x07, 0xF0, 0x64, 0x90, 0x15, 0xD0, 0x14, 0x90, 0x07, 0xF0, 0x14, 0xB0, 0x14, 0xD0, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6DA0*/
const unsigned char  uc2_6DA1 [] = {0x33, 0xE0, 0x0A, 0x20, 0x0A, 0x20, 0x63, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x04, 0x90, 0x15, 0x50, 0x15, 0x50, 0x16, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*6DA1*/
const unsigned char  uc2_6DA3 [] = {0x42, 0x00, 0x23, 0xC0, 0x24, 0x40, 0x18, 0x80, 0x4F, 0xE0, 0x29, 0x20, 0x29, 0x20, 0x1F, 0xF0, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*6DA3*/
const unsigned char  uc2_6DA4 [] = {0x42, 0x00, 0x23, 0xE0, 0x2E, 0x20, 0x01, 0xC0, 0x4E, 0x30, 0x20, 0x80, 0x27, 0xF0, 0x00, 0x80, 0x24, 0xA0, 0x24, 0x90, 0x4B, 0x10, 0x00, 0x00 }; /*6DA4*/
const unsigned char  uc2_6DA6 [] = {0x66, 0xF0, 0x11, 0x10, 0x15, 0xD0, 0x64, 0x90, 0x14, 0x90, 0x15, 0xD0, 0x04, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*6DA6*/
const unsigned char  uc2_6DA7 [] = {0x4D, 0xF0, 0x22, 0x10, 0x28, 0x10, 0x0B, 0xD0, 0x4A, 0x50, 0x2B, 0xD0, 0x2A, 0x50, 0x0B, 0xD0, 0x2A, 0x50, 0x28, 0x10, 0x48, 0x60, 0x00, 0x00 }; /*6DA7*/
const unsigned char  uc2_6DA8 [] = {0x4E, 0x80, 0x22, 0x90, 0x22, 0xE0, 0x4E, 0x80, 0x29, 0xF0, 0x2E, 0xA0, 0x02, 0xA0, 0x22, 0xA0, 0x22, 0xA0, 0x22, 0xD0, 0x4C, 0x90, 0x00, 0x00 }; /*6DA8*/
const unsigned char  uc2_6DA9 [] = {0x6F, 0xE0, 0x11, 0x20, 0x15, 0x20, 0x45, 0x20, 0x2A, 0x20, 0x22, 0xC0, 0x0D, 0x00, 0x21, 0x00, 0x25, 0xE0, 0x25, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6DA9*/
const unsigned char  uc2_6DAA [] = {0x41, 0x00, 0x2F, 0xE0, 0x24, 0x40, 0x02, 0x40, 0x42, 0x80, 0x3F, 0xF0, 0x20, 0x00, 0x07, 0xC0, 0x24, 0x40, 0x24, 0x40, 0x47, 0xC0, 0x00, 0x00 }; /*6DAA*/
const unsigned char  uc2_6DAB [] = {0x41, 0x00, 0x3F, 0xF0, 0x10, 0x10, 0x57, 0xD0, 0x24, 0x40, 0x27, 0xC0, 0x04, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x27, 0xE0, 0x44, 0x20, 0x00, 0x00 }; /*6DAB*/
const unsigned char  uc2_6DAE [] = {0x4F, 0x90, 0x28, 0x90, 0x2F, 0x50, 0x4A, 0x50, 0x2A, 0x50, 0x2F, 0x50, 0x0A, 0xD0, 0x2A, 0x90, 0x2B, 0x90, 0x32, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*6DAE*/
const unsigned char  uc2_6DAF [] = {0x4F, 0xF0, 0x28, 0x00, 0x28, 0x80, 0x4B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x08, 0x00, 0x28, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*6DAF*/
const unsigned char  uc2_6DB2 [] = {0x40, 0x80, 0x2F, 0xF0, 0x22, 0x80, 0x42, 0xE0, 0x24, 0xA0, 0x2C, 0xE0, 0x15, 0x20, 0x06, 0xC0, 0x24, 0x40, 0x24, 0xA0, 0x45, 0x10, 0x00, 0x00 }; /*6DB2*/
const unsigned char  uc2_6DB5 [] = {0x63, 0xC0, 0x10, 0x40, 0x00, 0x80, 0x62, 0xA0, 0x15, 0xD0, 0x16, 0xB0, 0x04, 0x90, 0x15, 0x10, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6DB5*/
const unsigned char  uc2_6DB8 [] = {0x67, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x07, 0xF0, 0x64, 0x90, 0x15, 0xD0, 0x05, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6DB8*/
const unsigned char  uc2_6DBF [] = {0x4F, 0xF0, 0x21, 0x00, 0x23, 0x20, 0x4D, 0xA0, 0x2A, 0xC0, 0x24, 0xA0, 0x1A, 0xA0, 0x21, 0xA0, 0x26, 0xA0, 0x38, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*6DBF*/
const unsigned char  uc2_6DC0 [] = {0x41, 0x00, 0x3F, 0xF0, 0x10, 0x10, 0x50, 0x10, 0x2F, 0xE0, 0x21, 0x00, 0x05, 0x00, 0x25, 0xE0, 0x25, 0x00, 0x2B, 0x00, 0x50, 0xF0, 0x00, 0x00 }; /*6DC0*/
const unsigned char  uc2_6DC4 [] = {0x64, 0x90, 0x14, 0x90, 0x09, 0x20, 0x64, 0x90, 0x14, 0x90, 0x17, 0xF0, 0x04, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*6DC4*/
const unsigned char  uc2_6DC5 [] = {0x44, 0x30, 0x24, 0xC0, 0x3F, 0x80, 0x44, 0xF0, 0x24, 0xA0, 0x2E, 0xA0, 0x15, 0xA0, 0x14, 0xA0, 0x24, 0xA0, 0x24, 0xA0, 0x45, 0x20, 0x00, 0x00 }; /*6DC5*/
const unsigned char  uc2_6DC6 [] = {0x63, 0x60, 0x10, 0x80, 0x13, 0x60, 0x41, 0x00, 0x2F, 0xF0, 0x22, 0x00, 0x07, 0xE0, 0x2A, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x42, 0x60, 0x00, 0x00 }; /*6DC6*/
const unsigned char  uc2_6DC7 [] = {0x44, 0x40, 0x24, 0x40, 0x2F, 0xE0, 0x44, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x07, 0xC0, 0x24, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x58, 0x20, 0x00, 0x00 }; /*6DC7*/
const unsigned char  uc2_6DCB [] = {0x44, 0x40, 0x24, 0x40, 0x3F, 0xF0, 0x44, 0x40, 0x26, 0xC0, 0x2D, 0x60, 0x15, 0x50, 0x25, 0x50, 0x26, 0x40, 0x24, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*6DCB*/
const unsigned char  uc2_6DCC [] = {0x60, 0x80, 0x14, 0x90, 0x12, 0x90, 0x42, 0xA0, 0x27, 0xF0, 0x24, 0x10, 0x05, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*6DCC*/
const unsigned char  uc2_6DD1 [] = {0x22, 0xF0, 0x12, 0x50, 0x13, 0xD0, 0x42, 0x50, 0x2F, 0xD0, 0x22, 0x50, 0x0B, 0x50, 0x2A, 0xA0, 0x32, 0xA0, 0x22, 0x50, 0x4D, 0x90, 0x00, 0x00 }; /*6DD1*/
const unsigned char  uc2_6DD6 [] = {0x61, 0x00, 0x11, 0xE0, 0x01, 0x00, 0x67, 0xC0, 0x14, 0x40, 0x07, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x5F, 0xF0, 0x41, 0x00, 0x00, 0x00 }; /*6DD6*/
const unsigned char  uc2_6DD8 [] = {0x64, 0x00, 0x17, 0xF0, 0x1A, 0x10, 0x43, 0xD0, 0x25, 0x10, 0x2F, 0xF0, 0x01, 0x10, 0x25, 0x50, 0x27, 0xD0, 0x20, 0x50, 0x40, 0x60, 0x00, 0x00 }; /*6DD8*/
const unsigned char  uc2_6DD9 [] = {0x60, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x44, 0x10, 0x23, 0xE0, 0x20, 0x00, 0x07, 0xF0, 0x12, 0xA0, 0x12, 0x90, 0x14, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*6DD9*/
const unsigned char  uc2_6DDD [] = {0x4F, 0x00, 0x29, 0xF0, 0x29, 0x50, 0x4F, 0x50, 0x29, 0x50, 0x29, 0xF0, 0x0F, 0x00, 0x29, 0x10, 0x29, 0x10, 0x29, 0x10, 0x56, 0xE0, 0x00, 0x00 }; /*6DDD*/
const unsigned char  uc2_6DDE [] = {0x44, 0xA0, 0x24, 0xA0, 0x3E, 0xA0, 0x05, 0x10, 0x4D, 0x50, 0x36, 0x50, 0x24, 0x80, 0x04, 0xA0, 0x25, 0x20, 0x25, 0xD0, 0x44, 0x10, 0x00, 0x00 }; /*6DDE*/
const unsigned char  uc2_6DE0 [] = {0x4F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x49, 0x20, 0x2F, 0xE0, 0x20, 0x00, 0x1F, 0xF0, 0x24, 0x40, 0x24, 0x40, 0x28, 0x40, 0x50, 0x40, 0x00, 0x00 }; /*6DE0*/
const unsigned char  uc2_6DE1 [] = {0x41, 0x00, 0x25, 0x40, 0x25, 0x40, 0x49, 0x80, 0x22, 0x40, 0x2C, 0x20, 0x01, 0x20, 0x25, 0x40, 0x29, 0x40, 0x22, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*6DE1*/
const unsigned char  uc2_6DE4 [] = {0x48, 0x40, 0x24, 0x40, 0x3F, 0xA0, 0x48, 0xA0, 0x2F, 0x10, 0x2A, 0xC0, 0x0A, 0x20, 0x2A, 0x20, 0x2A, 0xC0, 0x2A, 0x20, 0x54, 0x20, 0x00, 0x00 }; /*6DE4*/
const unsigned char  uc2_6DE6 [] = {0x41, 0x00, 0x21, 0x00, 0x22, 0x80, 0x44, 0x40, 0x3B, 0xB0, 0x21, 0x00, 0x0F, 0xE0, 0x29, 0x40, 0x25, 0x40, 0x25, 0x80, 0x5F, 0xF0, 0x00, 0x00 }; /*6DE6*/
const unsigned char  uc2_6DEB [] = {0x40, 0x60, 0x3F, 0x80, 0x2A, 0x20, 0x45, 0x40, 0x25, 0x60, 0x2F, 0x80, 0x01, 0x00, 0x1F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x4F, 0xE0, 0x00, 0x00 }; /*6DEB*/
const unsigned char  uc2_6DEC [] = {0x41, 0x00, 0x2F, 0xE0, 0x24, 0x40, 0x44, 0x40, 0x2A, 0xA0, 0x33, 0x20, 0x01, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6DEC*/
const unsigned char  uc2_6DEE [] = {0x45, 0x00, 0x24, 0x80, 0x2F, 0xF0, 0x54, 0x80, 0x27, 0xE0, 0x24, 0x80, 0x07, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x24, 0x00, 0x44, 0x00, 0x00, 0x00 }; /*6DEE*/
const unsigned char  uc2_6DF1 [] = {0x67, 0xF0, 0x14, 0x10, 0x15, 0x50, 0x61, 0x20, 0x12, 0xA0, 0x10, 0x80, 0x07, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x24, 0x90, 0x40, 0x80, 0x00, 0x00 }; /*6DF1*/
const unsigned char  uc2_6DF3 [] = {0x41, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x47, 0xC0, 0x20, 0x00, 0x27, 0xC0, 0x00, 0x40, 0x2F, 0xF0, 0x20, 0x80, 0x20, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*6DF3*/
const unsigned char  uc2_6DF7 [] = {0x4F, 0xC0, 0x28, 0x40, 0x2F, 0xC0, 0x48, 0x40, 0x2F, 0xC0, 0x20, 0x00, 0x08, 0xA0, 0x2E, 0xC0, 0x29, 0x90, 0x2E, 0x90, 0x48, 0x60, 0x00, 0x00 }; /*6DF7*/
const unsigned char  uc2_6DF9 [] = {0x41, 0x00, 0x3F, 0xF0, 0x04, 0x40, 0x59, 0x30, 0x27, 0xC0, 0x25, 0x40, 0x07, 0xC0, 0x25, 0x40, 0x27, 0xD0, 0x21, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*6DF9*/
const unsigned char  uc2_6DFB [] = {0x40, 0x00, 0x27, 0xC0, 0x21, 0x00, 0x4F, 0xE0, 0x22, 0x80, 0x2C, 0x60, 0x01, 0x00, 0x25, 0xA0, 0x25, 0x50, 0x29, 0x50, 0x46, 0x00, 0x00, 0x00 }; /*6DFB*/
const unsigned char  uc2_6DFC [] = {0x02, 0x20, 0x3A, 0x40, 0x0B, 0x80, 0x12, 0x40, 0x66, 0x30, 0x10, 0x40, 0x10, 0x40, 0x75, 0xD0, 0x38, 0xE0, 0x55, 0x50, 0x32, 0x90, 0x00, 0x00 }; /*6DFC*/
const unsigned char  uc2_6E05 [] = {0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x47, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x04, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x27, 0x40, 0x44, 0xC0, 0x00, 0x00 }; /*6E05*/
const unsigned char  uc2_6E0A [] = {0x64, 0x90, 0x16, 0x90, 0x15, 0xB0, 0x64, 0xD0, 0x17, 0xF0, 0x14, 0x90, 0x05, 0xD0, 0x16, 0xB0, 0x14, 0x90, 0x14, 0x90, 0x68, 0x10, 0x00, 0x00 }; /*6E0A*/
const unsigned char  uc2_6E0C [] = {0x67, 0xE0, 0x10, 0x20, 0x13, 0xC0, 0x40, 0x40, 0x2F, 0xF0, 0x24, 0xA0, 0x02, 0xA0, 0x20, 0xC0, 0x22, 0xA0, 0x2C, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*6E0C*/
const unsigned char  uc2_6E0D [] = {0x41, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x47, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x04, 0x40, 0x25, 0x40, 0x25, 0x00, 0x22, 0xC0, 0x4C, 0x20, 0x00, 0x00 }; /*6E0D*/
const unsigned char  uc2_6E0E [] = {0x40, 0x80, 0x27, 0xE0, 0x00, 0x80, 0x4F, 0xF0, 0x22, 0x10, 0x29, 0x40, 0x04, 0x40, 0x2F, 0xF0, 0x20, 0xA0, 0x23, 0x10, 0x4C, 0x10, 0x00, 0x00 }; /*6E0E*/
const unsigned char  uc2_6E10 [] = {0x42, 0x30, 0x22, 0xC0, 0x2F, 0x80, 0x44, 0x80, 0x2A, 0xF0, 0x2F, 0xA0, 0x02, 0xA0, 0x23, 0xA0, 0x2E, 0xA0, 0x22, 0xA0, 0x43, 0x20, 0x00, 0x00 }; /*6E10*/
const unsigned char  uc2_6E11 [] = {0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x41, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x0F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*6E11*/
const unsigned char  uc2_6E14 [] = {0x42, 0x00, 0x23, 0xC0, 0x0C, 0x40, 0x40, 0x80, 0x2F, 0xE0, 0x29, 0x20, 0x0F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x20, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6E14*/
const unsigned char  uc2_6E16 [] = {0x46, 0x00, 0x21, 0x00, 0x1F, 0xF0, 0x51, 0x10, 0x2F, 0xE0, 0x29, 0x20, 0x0F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6E16*/
const unsigned char  uc2_6E17 [] = {0x42, 0x00, 0x24, 0x40, 0x0F, 0xE0, 0x41, 0x00, 0x3F, 0xF0, 0x24, 0xC0, 0x1B, 0x30, 0x21, 0x80, 0x2E, 0x60, 0x21, 0x80, 0x4E, 0x00, 0x00, 0x00 }; /*6E17*/
const unsigned char  uc2_6E1A [] = {0x41, 0x00, 0x27, 0xD0, 0x21, 0x20, 0x4F, 0xF0, 0x21, 0x00, 0x23, 0xE0, 0x06, 0x20, 0x3B, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*6E1A*/
const unsigned char  uc2_6E1D [] = {0x43, 0x80, 0x24, 0x40, 0x3B, 0xB0, 0x40, 0x00, 0x2E, 0x20, 0x2A, 0xA0, 0x0E, 0xA0, 0x2A, 0xA0, 0x2E, 0xA0, 0x2A, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*6E1D*/
const unsigned char  uc2_6E20 [] = {0x37, 0xF0, 0x0C, 0x00, 0x67, 0xE0, 0x14, 0x20, 0x0F, 0xE0, 0x14, 0x00, 0x67, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*6E20*/
const unsigned char  uc2_6E21 [] = {0x40, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x4F, 0xF0, 0x29, 0x40, 0x29, 0xC0, 0x08, 0x00, 0x2B, 0xC0, 0x29, 0x40, 0x28, 0x80, 0x57, 0x70, 0x00, 0x00 }; /*6E21*/
const unsigned char  uc2_6E23 [] = {0x41, 0x00, 0x2F, 0xE0, 0x05, 0x40, 0x59, 0x30, 0x27, 0xC0, 0x24, 0x40, 0x07, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x40, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6E23*/
const unsigned char  uc2_6E24 [] = {0x44, 0x40, 0x3F, 0x40, 0x24, 0xF0, 0x5F, 0x50, 0x31, 0x50, 0x1E, 0x50, 0x02, 0x50, 0x27, 0x50, 0x3C, 0x90, 0x24, 0x90, 0x5B, 0x60, 0x00, 0x00 }; /*6E24*/
const unsigned char  uc2_6E25 [] = {0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x00, 0x2B, 0xF0, 0x29, 0x20, 0x0B, 0xD0, 0x28, 0x90, 0x2B, 0xE0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*6E25*/
const unsigned char  uc2_6E29 [] = {0x60, 0x00, 0x17, 0xC0, 0x14, 0x40, 0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x00, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*6E29*/
const unsigned char  uc2_6E2B [] = {0x41, 0x40, 0x25, 0x40, 0x3F, 0xF0, 0x45, 0x40, 0x25, 0xC0, 0x24, 0x00, 0x07, 0xF0, 0x20, 0x80, 0x2F, 0xF0, 0x22, 0xA0, 0x4C, 0x90, 0x00, 0x00 }; /*6E2B*/
const unsigned char  uc2_6E2D [] = {0x67, 0xF0, 0x14, 0x90, 0x07, 0xF0, 0x64, 0x90, 0x17, 0xF0, 0x12, 0x20, 0x03, 0xE0, 0x0A, 0x20, 0x0B, 0xE0, 0x12, 0x20, 0x62, 0x60, 0x00, 0x00 }; /*6E2D*/
const unsigned char  uc2_6E2F [] = {0x42, 0x40, 0x27, 0xE0, 0x02, 0x40, 0x4F, 0xF0, 0x24, 0x20, 0x2B, 0xD0, 0x02, 0x40, 0x23, 0xC0, 0x22, 0x10, 0x22, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*6E2F*/
const unsigned char  uc2_6E32 [] = {0x41, 0x00, 0x2F, 0xE0, 0x08, 0x20, 0x40, 0x00, 0x27, 0xC0, 0x20, 0x00, 0x07, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x5F, 0xF0, 0x00, 0x00 }; /*6E32*/
const unsigned char  uc2_6E34 [] = {0x67, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x44, 0x20, 0x27, 0xE0, 0x22, 0x00, 0x07, 0xF0, 0x39, 0x10, 0x2A, 0x90, 0x2F, 0xD0, 0x40, 0x60, 0x00, 0x00 }; /*6E34*/
const unsigned char  uc2_6E38 [] = {0x58, 0x80, 0x24, 0xF0, 0x3F, 0x00, 0x48, 0xE0, 0x2E, 0x20, 0x2A, 0x40, 0x0B, 0xF0, 0x2A, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x54, 0x80, 0x00, 0x00 }; /*6E38*/
const unsigned char  uc2_6E3A [] = {0x40, 0x40, 0x2E, 0x60, 0x2A, 0x50, 0x4E, 0xD0, 0x2B, 0x40, 0x2E, 0x50, 0x0A, 0x50, 0x2E, 0x20, 0x2A, 0x40, 0x21, 0x80, 0x46, 0x00, 0x00, 0x00 }; /*6E3A*/
const unsigned char  uc2_6E43 [] = {0x42, 0x00, 0x2D, 0xF0, 0x04, 0x40, 0x4E, 0xE0, 0x24, 0x40, 0x24, 0xE0, 0x1E, 0x40, 0x25, 0xF0, 0x24, 0x40, 0x24, 0x40, 0x48, 0x40, 0x00, 0x00 }; /*6E43*/
const unsigned char  uc2_6E44 [] = {0x67, 0xF0, 0x14, 0x90, 0x07, 0xF0, 0x64, 0x00, 0x15, 0xF0, 0x15, 0x10, 0x05, 0xF0, 0x15, 0x10, 0x15, 0xF0, 0x15, 0x10, 0x69, 0xF0, 0x00, 0x00 }; /*6E44*/
const unsigned char  uc2_6E4D [] = {0x41, 0x00, 0x29, 0x20, 0x2F, 0xE0, 0x40, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x0F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*6E4D*/
const unsigned char  uc2_6E4E [] = {0x40, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x4F, 0xE0, 0x2A, 0xA0, 0x2B, 0xA0, 0x0A, 0xA0, 0x2B, 0xA0, 0x2A, 0xA0, 0x2F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*6E4E*/
const unsigned char  uc2_6E53 [] = {0x44, 0x40, 0x28, 0x30, 0x37, 0xC0, 0x42, 0x40, 0x22, 0x40, 0x2D, 0x80, 0x00, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*6E53*/
const unsigned char  uc2_6E54 [] = {0x44, 0x40, 0x22, 0x80, 0x3F, 0xF0, 0x40, 0x00, 0x2E, 0x20, 0x2A, 0xA0, 0x0E, 0xA0, 0x2A, 0xA0, 0x2E, 0xA0, 0x2A, 0x20, 0x4C, 0xC0, 0x00, 0x00 }; /*6E54*/
const unsigned char  uc2_6E56 [] = {0x44, 0xF0, 0x24, 0x90, 0x3F, 0x90, 0x44, 0xF0, 0x24, 0x90, 0x2E, 0x90, 0x0A, 0xF0, 0x2A, 0x90, 0x2E, 0x90, 0x29, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*6E56*/
const unsigned char  uc2_6E58 [] = {0x44, 0xF0, 0x24, 0x90, 0x3F, 0x90, 0x44, 0xF0, 0x2E, 0x90, 0x2D, 0x90, 0x14, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x24, 0xF0, 0x44, 0x90, 0x00, 0x00 }; /*6E58*/
const unsigned char  uc2_6E5B [] = {0x44, 0x40, 0x2F, 0xE0, 0x24, 0x40, 0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x04, 0x40, 0x1F, 0xF0, 0x29, 0x40, 0x2A, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*6E5B*/
const unsigned char  uc2_6E5F [] = {0x41, 0x00, 0x22, 0x00, 0x27, 0xC0, 0x44, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x0F, 0xE0, 0x21, 0x00, 0x27, 0xC0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6E5F*/
const unsigned char  uc2_6E6B [] = {0x42, 0x40, 0x2C, 0x40, 0x05, 0x50, 0x45, 0x50, 0x3F, 0x60, 0x25, 0x40, 0x0E, 0x40, 0x35, 0x40, 0x24, 0xA0, 0x24, 0xA0, 0x45, 0x10, 0x00, 0x00 }; /*6E6B*/
const unsigned char  uc2_6E6E [] = {0x5F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x4A, 0xA0, 0x2A, 0xA0, 0x2F, 0xE0, 0x00, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6E6E*/
const unsigned char  uc2_6E7E [] = {0x41, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x52, 0x90, 0x2F, 0xE0, 0x20, 0x20, 0x07, 0xE0, 0x28, 0x00, 0x2F, 0xF0, 0x20, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*6E7E*/
const unsigned char  uc2_6E7F [] = {0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x2F, 0xE0, 0x20, 0x00, 0x12, 0xA0, 0x2A, 0xA0, 0x2A, 0xC0, 0x22, 0x80, 0x5F, 0xF0, 0x00, 0x00 }; /*6E7F*/
const unsigned char  uc2_6E83 [] = {0x41, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x4F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x08, 0x20, 0x29, 0x20, 0x29, 0x20, 0x22, 0xC0, 0x4C, 0x20, 0x00, 0x00 }; /*6E83*/
const unsigned char  uc2_6E85 [] = {0x5F, 0x60, 0x31, 0x50, 0x15, 0xE0, 0x55, 0x40, 0x35, 0x70, 0x15, 0xC0, 0x15, 0x50, 0x2A, 0x60, 0x29, 0x50, 0x28, 0xD0, 0x53, 0x20, 0x00, 0x00 }; /*6E85*/
const unsigned char  uc2_6E86 [] = {0x44, 0x00, 0x2A, 0xF0, 0x11, 0x50, 0x4E, 0x50, 0x24, 0x50, 0x3F, 0x50, 0x04, 0x50, 0x2E, 0x20, 0x35, 0x20, 0x25, 0x60, 0x4C, 0x90, 0x00, 0x00 }; /*6E86*/
const unsigned char  uc2_6E89 [] = {0x4E, 0xF0, 0x2A, 0x20, 0x2E, 0xA0, 0x4A, 0xA0, 0x2E, 0xA0, 0x2C, 0xF0, 0x0A, 0x20, 0x2F, 0x60, 0x29, 0x60, 0x20, 0xA0, 0x43, 0x30, 0x00, 0x00 }; /*6E89*/
const unsigned char  uc2_6E8F [] = {0x40, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x4B, 0xE0, 0x28, 0xA0, 0x2F, 0xF0, 0x08, 0xA0, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*6E8F*/
const unsigned char  uc2_6E90 [] = {0x4F, 0xF0, 0x28, 0x80, 0x2B, 0xE0, 0x4A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x0B, 0xE0, 0x2A, 0xA0, 0x2A, 0x90, 0x2C, 0x90, 0x53, 0x00, 0x00, 0x00 }; /*6E90*/
const unsigned char  uc2_6E98 [] = {0x41, 0x00, 0x27, 0xC0, 0x01, 0x00, 0x5F, 0xF0, 0x24, 0x40, 0x2F, 0xA0, 0x00, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*6E98*/
const unsigned char  uc2_6E9C [] = {0x21, 0x00, 0x16, 0xF0, 0x14, 0x50, 0x45, 0x50, 0x26, 0xB0, 0x20, 0x00, 0x07, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x24, 0x90, 0x47, 0xF0, 0x00, 0x00 }; /*6E9C*/
const unsigned char  uc2_6E9F [] = {0x5F, 0xF0, 0x50, 0x10, 0x17, 0xD0, 0x44, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x07, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x58, 0x20, 0x00, 0x00 }; /*6E9F*/
const unsigned char  uc2_6EA2 [] = {0x44, 0x40, 0x22, 0x80, 0x3F, 0xF0, 0x40, 0x00, 0x22, 0xC0, 0x2C, 0x20, 0x00, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*6EA2*/
const unsigned char  uc2_6EA5 [] = {0x41, 0x20, 0x3F, 0xF0, 0x29, 0x20, 0x4F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x09, 0x20, 0x20, 0x40, 0x3F, 0xF0, 0x28, 0x40, 0x45, 0x80, 0x00, 0x00 }; /*6EA5*/
const unsigned char  uc2_6EA7 [] = {0x5F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x4A, 0xA0, 0x2A, 0xA0, 0x2F, 0xE0, 0x01, 0x00, 0x3F, 0xF0, 0x23, 0x80, 0x25, 0x40, 0x59, 0x30, 0x00, 0x00 }; /*6EA7*/
const unsigned char  uc2_6EAA [] = {0x40, 0x70, 0x2F, 0xA0, 0x25, 0x20, 0x4A, 0x40, 0x25, 0xA0, 0x22, 0x30, 0x07, 0xD0, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x4C, 0x70, 0x00, 0x00 }; /*6EAA*/
const unsigned char  uc2_6EAF [] = {0x51, 0x70, 0x2A, 0x50, 0x3F, 0xD0, 0x04, 0x70, 0x55, 0x50, 0x35, 0x50, 0x1F, 0x70, 0x04, 0x50, 0x24, 0x50, 0x28, 0x90, 0x53, 0x60, 0x00, 0x00 }; /*6EAF*/
const unsigned char  uc2_6EB1 [] = {0x41, 0x00, 0x2F, 0xE0, 0x01, 0x00, 0x47, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x04, 0xC0, 0x39, 0x30, 0x27, 0xC0, 0x25, 0x40, 0x49, 0x20, 0x00, 0x00 }; /*6EB1*/
const unsigned char  uc2_6EB2 [] = {0x42, 0x00, 0x2D, 0x60, 0x29, 0x20, 0x4D, 0x60, 0x29, 0x20, 0x2F, 0xE0, 0x01, 0x00, 0x2F, 0xC0, 0x24, 0x40, 0x23, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*6EB2*/
const unsigned char  uc2_6EB4 [] = {0x42, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x01, 0x40, 0x3F, 0xF0, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*6EB4*/
const unsigned char  uc2_6EB6 [] = {0x60, 0x80, 0x17, 0xF0, 0x04, 0x10, 0x61, 0x60, 0x16, 0x90, 0x11, 0x40, 0x06, 0x30, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*6EB6*/
const unsigned char  uc2_6EB7 [] = {0x4F, 0xF0, 0x28, 0x10, 0x2F, 0xF0, 0x4A, 0xB0, 0x2D, 0xD0, 0x2A, 0x90, 0x0D, 0xD0, 0x2A, 0xB0, 0x2C, 0x90, 0x2B, 0x10, 0x4F, 0xF0, 0x00, 0x00 }; /*6EB7*/
const unsigned char  uc2_6EBA [] = {0x40, 0x00, 0x3E, 0xF0, 0x22, 0x10, 0x4E, 0x70, 0x28, 0x40, 0x2E, 0x70, 0x0A, 0x50, 0x26, 0x30, 0x3A, 0xD0, 0x22, 0x10, 0x4C, 0x60, 0x00, 0x00 }; /*6EBA*/
const unsigned char  uc2_6EBB [] = {0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x2F, 0xE0, 0x20, 0x00, 0x1E, 0xF0, 0x2A, 0x50, 0x26, 0x30, 0x3A, 0xD0, 0x46, 0x30, 0x00, 0x00 }; /*6EBB*/
const unsigned char  uc2_6EBD [] = {0x4F, 0xF0, 0x28, 0x00, 0x2B, 0xE0, 0x48, 0x00, 0x2F, 0xF0, 0x2A, 0xA0, 0x0B, 0x70, 0x28, 0x40, 0x2F, 0xF0, 0x2A, 0x40, 0x50, 0xC0, 0x00, 0x00 }; /*6EBD*/
const unsigned char  uc2_6EC1 [] = {0x4E, 0x40, 0x2A, 0xA0, 0x2B, 0x10, 0x4C, 0xE0, 0x2A, 0x40, 0x2B, 0xF0, 0x0A, 0x40, 0x2D, 0x60, 0x29, 0x50, 0x2A, 0x50, 0x49, 0x80, 0x00, 0x00 }; /*6EC1*/
const unsigned char  uc2_6EC2 [] = {0x41, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x42, 0x80, 0x3F, 0xF0, 0x11, 0x10, 0x0F, 0xE0, 0x22, 0x00, 0x23, 0xE0, 0x24, 0x20, 0x59, 0xC0, 0x00, 0x00 }; /*6EC2*/
const unsigned char  uc2_6EC7 [] = {0x41, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x42, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x07, 0xC0, 0x24, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x48, 0x20, 0x00, 0x00 }; /*6EC7*/
const unsigned char  uc2_6ECB [] = {0x44, 0x40, 0x22, 0x80, 0x3F, 0xF0, 0x44, 0x40, 0x24, 0x40, 0x2A, 0xA0, 0x0E, 0xE0, 0x24, 0x40, 0x2A, 0xA0, 0x4A, 0xA0, 0x4D, 0x50, 0x00, 0x00 }; /*6ECB*/
const unsigned char  uc2_6ECF [] = {0x42, 0xE0, 0x2E, 0x50, 0x21, 0x80, 0x46, 0x60, 0x38, 0x10, 0x27, 0xC0, 0x01, 0x00, 0x2F, 0xE0, 0x25, 0x40, 0x22, 0x80, 0x5F, 0xF0, 0x00, 0x00 }; /*6ECF*/
const unsigned char  uc2_6ED1 [] = {0x47, 0xC0, 0x24, 0x40, 0x07, 0x40, 0x45, 0x40, 0x3F, 0xF0, 0x14, 0x50, 0x17, 0xD0, 0x04, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x44, 0xC0, 0x00, 0x00 }; /*6ED1*/
const unsigned char  uc2_6ED3 [] = {0x41, 0x00, 0x5F, 0xF0, 0x11, 0x10, 0x4F, 0xE0, 0x24, 0x40, 0x22, 0x80, 0x1F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6ED3*/
const unsigned char  uc2_6ED4 [] = {0x40, 0x70, 0x3F, 0x80, 0x2A, 0x40, 0x45, 0x40, 0x22, 0x80, 0x2C, 0xE0, 0x08, 0x20, 0x2E, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*6ED4*/
const unsigned char  uc2_6ED5 [] = {0x3A, 0xA0, 0x29, 0x40, 0x2B, 0xE0, 0x38, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x3A, 0xB0, 0x2E, 0xA0, 0x29, 0xC0, 0x2E, 0xA0, 0x51, 0x10, 0x00, 0x00 }; /*6ED5*/
const unsigned char  uc2_6ED7 [] = {0x44, 0x40, 0x27, 0x70, 0x2A, 0xA0, 0x49, 0x10, 0x20, 0xE0, 0x2F, 0x00, 0x01, 0xC0, 0x27, 0x00, 0x21, 0xE0, 0x2F, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*6ED7*/
const unsigned char  uc2_6EDA [] = {0x41, 0x00, 0x2F, 0xF0, 0x24, 0x20, 0x49, 0x10, 0x22, 0x40, 0x27, 0xA0, 0x01, 0x00, 0x22, 0xA0, 0x26, 0xA0, 0x2A, 0x40, 0x43, 0x30, 0x00, 0x00 }; /*6EDA*/
const unsigned char  uc2_6EDE [] = {0x41, 0x00, 0x25, 0x40, 0x3F, 0xF0, 0x45, 0x40, 0x20, 0x00, 0x2F, 0xE0, 0x09, 0x20, 0x27, 0xC0, 0x25, 0x40, 0x25, 0xC0, 0x41, 0x00, 0x00, 0x00 }; /*6EDE*/
const unsigned char  uc2_6EDF [] = {0x48, 0x80, 0x28, 0xE0, 0x3D, 0x20, 0x4B, 0xF0, 0x29, 0x50, 0x3D, 0x50, 0x09, 0xF0, 0x29, 0x00, 0x3D, 0x10, 0x29, 0x10, 0x48, 0xE0, 0x00, 0x00 }; /*6EDF*/
const unsigned char  uc2_6EE0 [] = {0x4F, 0xE0, 0x24, 0x40, 0x27, 0xC0, 0x44, 0x40, 0x3F, 0xF0, 0x20, 0x40, 0x1E, 0xF0, 0x2A, 0x50, 0x2A, 0x50, 0x24, 0x20, 0x5A, 0xD0, 0x00, 0x00 }; /*6EE0*/
const unsigned char  uc2_6EE1 [] = {0x44, 0x40, 0x2F, 0xE0, 0x04, 0x40, 0x5F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x0A, 0xA0, 0x2A, 0xA0, 0x2D, 0x60, 0x28, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*6EE1*/
const unsigned char  uc2_6EE2 [] = {0x44, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x40, 0x00, 0x3F, 0xF0, 0x10, 0x10, 0x0F, 0xE0, 0x21, 0x00, 0x27, 0xC0, 0x21, 0x20, 0x5F, 0xF0, 0x00, 0x00 }; /*6EE2*/
const unsigned char  uc2_6EE4 [] = {0x41, 0xC0, 0x21, 0x00, 0x2F, 0xF0, 0x49, 0x10, 0x2F, 0xC0, 0x29, 0x20, 0x08, 0xE0, 0x28, 0x00, 0x2A, 0xA0, 0x2A, 0x50, 0x55, 0xD0, 0x00, 0x00 }; /*6EE4*/
const unsigned char  uc2_6EE5 [] = {0x42, 0x40, 0x2A, 0x40, 0x2A, 0x70, 0x4A, 0xA0, 0x2B, 0x90, 0x22, 0x10, 0x00, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*6EE5*/
const unsigned char  uc2_6EE6 [] = {0x41, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x46, 0xC0, 0x2A, 0xA0, 0x22, 0x80, 0x01, 0x00, 0x3F, 0xF0, 0x23, 0x80, 0x25, 0x40, 0x59, 0x30, 0x00, 0x00 }; /*6EE6*/
const unsigned char  uc2_6EE8 [] = {0x41, 0x00, 0x3F, 0xF0, 0x10, 0x50, 0x57, 0x90, 0x24, 0x00, 0x27, 0xE0, 0x04, 0x80, 0x3F, 0xF0, 0x22, 0x40, 0x24, 0x20, 0x58, 0x20, 0x00, 0x00 }; /*6EE8*/
const unsigned char  uc2_6EE9 [] = {0x40, 0x40, 0x20, 0x40, 0x2E, 0xA0, 0x43, 0xF0, 0x2A, 0xA0, 0x24, 0xF0, 0x04, 0xA0, 0x2A, 0xF0, 0x2A, 0xA0, 0x30, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*6EE9*/
const unsigned char  uc2_6EF4 [] = {0x41, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x4F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x09, 0x20, 0x2B, 0xA0, 0x2A, 0xA0, 0x2B, 0xA0, 0x48, 0xC0, 0x00, 0x00 }; /*6EF4*/
const unsigned char  uc2_6EF9 [] = {0x41, 0xE0, 0x21, 0x00, 0x2F, 0xF0, 0x49, 0x10, 0x2F, 0xC0, 0x29, 0x20, 0x0F, 0xC0, 0x2A, 0xA0, 0x2F, 0xF0, 0x28, 0x80, 0x53, 0x80, 0x00, 0x00 }; /*6EF9*/
const unsigned char  uc2_6F02 [] = {0x5F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x4A, 0xA0, 0x2F, 0xE0, 0x20, 0x00, 0x0F, 0xE0, 0x20, 0x00, 0x3F, 0xF0, 0x25, 0x40, 0x4B, 0x20, 0x00, 0x00 }; /*6F02*/
const unsigned char  uc2_6F06 [] = {0x41, 0x00, 0x3F, 0xF0, 0x23, 0x00, 0x45, 0x60, 0x39, 0x10, 0x26, 0xC0, 0x19, 0x30, 0x25, 0x40, 0x21, 0x00, 0x25, 0x60, 0x5A, 0x10, 0x00, 0x00 }; /*6F06*/
const unsigned char  uc2_6F09 [] = {0x41, 0x00, 0x2F, 0xF0, 0x2A, 0x80, 0x4F, 0xE0, 0x2A, 0xA0, 0x2F, 0xE0, 0x0A, 0x90, 0x2B, 0xE0, 0x2A, 0x90, 0x2B, 0x90, 0x52, 0x60, 0x00, 0x00 }; /*6F09*/
const unsigned char  uc2_6F0F [] = {0x67, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x64, 0x00, 0x17, 0xF0, 0x14, 0x80, 0x07, 0xF0, 0x15, 0xB0, 0x16, 0xD0, 0x15, 0x90, 0x68, 0xA0, 0x00, 0x00 }; /*6F0F*/
const unsigned char  uc2_6F13 [] = {0x41, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x49, 0x20, 0x2A, 0xA0, 0x2F, 0xE0, 0x01, 0x00, 0x1F, 0xF0, 0x32, 0xD0, 0x57, 0x50, 0x50, 0x60, 0x00, 0x00 }; /*6F13*/
const unsigned char  uc2_6F14 [] = {0x20, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x45, 0xD0, 0x20, 0x80, 0x23, 0xE0, 0x02, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x23, 0xF0, 0x46, 0x10, 0x00, 0x00 }; /*6F14*/
const unsigned char  uc2_6F15 [] = {0x42, 0x40, 0x2F, 0xF0, 0x02, 0x40, 0x4F, 0xF0, 0x2A, 0x50, 0x2A, 0x50, 0x0F, 0xF0, 0x24, 0x20, 0x27, 0xE0, 0x24, 0x20, 0x47, 0xE0, 0x00, 0x00 }; /*6F15*/
const unsigned char  uc2_6F20 [] = {0x44, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x08, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x44, 0x40, 0x00, 0x00 }; /*6F20*/
const unsigned char  uc2_6F24 [] = {0x44, 0x40, 0x2E, 0xE0, 0x24, 0x40, 0x4E, 0xE0, 0x35, 0x50, 0x24, 0x40, 0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x23, 0xC0, 0x5C, 0x20, 0x00, 0x00 }; /*6F24*/
const unsigned char  uc2_6F29 [] = {0x51, 0x00, 0x29, 0x00, 0x3F, 0xF0, 0x12, 0x00, 0x5D, 0xF0, 0x34, 0x50, 0x14, 0x40, 0x35, 0x60, 0x55, 0x40, 0x55, 0xC0, 0x2A, 0x30, 0x00, 0x00 }; /*6F29*/
const unsigned char  uc2_6F2A [] = {0x54, 0x80, 0x2B, 0xF0, 0x29, 0x40, 0x4A, 0x20, 0x2F, 0xF0, 0x18, 0x20, 0x2B, 0xA0, 0x0A, 0xA0, 0x2B, 0xA0, 0x2A, 0xA0, 0x50, 0x40, 0x00, 0x00 }; /*6F2A*/
const unsigned char  uc2_6F2B [] = {0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x44, 0x40, 0x2F, 0xE0, 0x2A, 0xA0, 0x0F, 0xE0, 0x24, 0x40, 0x23, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*6F2B*/
const unsigned char  uc2_6F2D [] = {0x44, 0x40, 0x2F, 0xE0, 0x24, 0x40, 0x41, 0x20, 0x3F, 0xF0, 0x24, 0x40, 0x1A, 0xB0, 0x22, 0x80, 0x2F, 0xE0, 0x22, 0x80, 0x4C, 0x80, 0x00, 0x00 }; /*6F2D*/
const unsigned char  uc2_6F2F [] = {0x27, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x44, 0x90, 0x27, 0xF0, 0x21, 0x40, 0x03, 0xA0, 0x11, 0x70, 0x17, 0x90, 0x24, 0xA0, 0x49, 0x90, 0x00, 0x00 }; /*6F2F*/
const unsigned char  uc2_6F31 [] = {0x42, 0x20, 0x3F, 0xE0, 0x22, 0x30, 0x4F, 0xD0, 0x2A, 0x90, 0x2F, 0xA0, 0x02, 0x20, 0x27, 0x20, 0x3A, 0xD0, 0x22, 0x50, 0x42, 0x90, 0x00, 0x00 }; /*6F31*/
const unsigned char  uc2_6F33 [] = {0x41, 0x00, 0x2F, 0xE0, 0x02, 0x80, 0x5F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x04, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x41, 0x00, 0x00, 0x00 }; /*6F33*/
const unsigned char  uc2_6F36 [] = {0x41, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x4F, 0xE0, 0x21, 0x00, 0x2F, 0xE0, 0x09, 0x20, 0x2F, 0xE0, 0x25, 0x00, 0x2C, 0xA0, 0x53, 0xD0, 0x00, 0x00 }; /*6F36*/
const unsigned char  uc2_6F3E [] = {0x22, 0x20, 0x17, 0xF0, 0x10, 0x80, 0x43, 0xE0, 0x20, 0x80, 0x27, 0xF0, 0x01, 0x00, 0x11, 0x80, 0x16, 0xD0, 0x22, 0xA0, 0x4D, 0x90, 0x00, 0x00 }; /*6F3E*/
const unsigned char  uc2_6F46 [] = {0x42, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x4F, 0xF0, 0x2A, 0x90, 0x27, 0x20, 0x02, 0xF0, 0x2F, 0x10, 0x24, 0xA0, 0x24, 0x90, 0x4B, 0x10, 0x00, 0x00 }; /*6F46*/
const unsigned char  uc2_6F47 [] = {0x44, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x4F, 0xE0, 0x35, 0x70, 0x2A, 0xA0, 0x0F, 0xE0, 0x29, 0x20, 0x2B, 0xA0, 0x2D, 0x60, 0x51, 0x20, 0x00, 0x00 }; /*6F47*/
const unsigned char  uc2_6F4B [] = {0x44, 0x80, 0x24, 0x80, 0x0A, 0xF0, 0x51, 0xA0, 0x2E, 0xA0, 0x20, 0xA0, 0x15, 0xA0, 0x2A, 0x40, 0x2A, 0xA0, 0x22, 0xA0, 0x5F, 0x10, 0x00, 0x00 }; /*6F4B*/
const unsigned char  uc2_6F4D [] = {0x44, 0x80, 0x25, 0x40, 0x29, 0xF0, 0x4B, 0x40, 0x2D, 0xE0, 0x25, 0x40, 0x0B, 0xE0, 0x2D, 0x40, 0x21, 0x40, 0x23, 0xF0, 0x4D, 0x00, 0x00, 0x00 }; /*6F4D*/
const unsigned char  uc2_6F58 [] = {0x40, 0x20, 0x2F, 0xC0, 0x05, 0x40, 0x5F, 0xF0, 0x25, 0x40, 0x29, 0x20, 0x1F, 0xF0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x4F, 0xE0, 0x00, 0x00 }; /*6F58*/
const unsigned char  uc2_6F5C [] = {0x44, 0x40, 0x2E, 0xE0, 0x04, 0x40, 0x5E, 0xF0, 0x2A, 0xA0, 0x31, 0x10, 0x0F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x4F, 0xE0, 0x00, 0x00 }; /*6F5C*/
const unsigned char  uc2_6F5E [] = {0x4E, 0x80, 0x2A, 0xE0, 0x2B, 0x20, 0x4A, 0xA0, 0x2E, 0x40, 0x25, 0xB0, 0x16, 0x00, 0x34, 0xE0, 0x57, 0xA0, 0x58, 0xE0, 0x20, 0xA0, 0x00, 0x00 }; /*6F5E*/
const unsigned char  uc2_6F62 [] = {0x44, 0x40, 0x2F, 0xE0, 0x04, 0x40, 0x5F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x09, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x58, 0x10, 0x00, 0x00 }; /*6F62*/
const unsigned char  uc2_6F66 [] = {0x41, 0x00, 0x3F, 0xF0, 0x0A, 0xA0, 0x44, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x07, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x29, 0x20, 0x53, 0x10, 0x00, 0x00 }; /*6F66*/
const unsigned char  uc2_6F6D [] = {0x5F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x4A, 0xA0, 0x2F, 0xE0, 0x25, 0x40, 0x07, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*6F6D*/
const unsigned char  uc2_6F6E [] = {0x62, 0x70, 0x1F, 0xD0, 0x12, 0x50, 0x65, 0x70, 0x17, 0x50, 0x15, 0x50, 0x07, 0x70, 0x12, 0x50, 0x1F, 0xD0, 0x12, 0x50, 0x62, 0xA0, 0x00, 0x00 }; /*6F6E*/
const unsigned char  uc2_6F72 [] = {0x42, 0x40, 0x2D, 0x50, 0x04, 0xA0, 0x45, 0xF0, 0x3F, 0x10, 0x25, 0xF0, 0x0D, 0x10, 0x37, 0xF0, 0x25, 0x10, 0x25, 0x10, 0x45, 0x60, 0x00, 0x00 }; /*6F72*/
const unsigned char  uc2_6F74 [] = {0x4A, 0x90, 0x25, 0xD0, 0x2C, 0xA0, 0x57, 0xF0, 0x24, 0x40, 0x2D, 0xE0, 0x17, 0x20, 0x25, 0xE0, 0x25, 0x20, 0x25, 0xE0, 0x59, 0x20, 0x00, 0x00 }; /*6F74*/
const unsigned char  uc2_6F78 [] = {0x44, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x15, 0x50, 0x4F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x08, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x48, 0xE0, 0x00, 0x00 }; /*6F78*/
const unsigned char  uc2_6F7A [] = {0x4F, 0xF0, 0x28, 0x10, 0x2F, 0xF0, 0x48, 0x40, 0x2B, 0xF0, 0x28, 0x80, 0x0F, 0xF0, 0x28, 0x90, 0x2F, 0xF0, 0x29, 0x20, 0x56, 0xC0, 0x00, 0x00 }; /*6F7A*/
const unsigned char  uc2_6F7C [] = {0x41, 0x00, 0x2F, 0xE0, 0x24, 0x40, 0x42, 0x80, 0x3F, 0xF0, 0x29, 0x20, 0x0F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6F7C*/
const unsigned char  uc2_6F84 [] = {0x4F, 0x40, 0x2A, 0xA0, 0x24, 0x40, 0x4B, 0xB0, 0x30, 0x00, 0x27, 0xC0, 0x04, 0x40, 0x27, 0xC0, 0x22, 0x80, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6F84*/
const unsigned char  uc2_6F88 [] = {0x44, 0x40, 0x3F, 0xC0, 0x2A, 0x70, 0x45, 0xD0, 0x2F, 0x50, 0x29, 0x50, 0x0F, 0x20, 0x29, 0x20, 0x2F, 0x50, 0x29, 0x50, 0x4A, 0x90, 0x00, 0x00 }; /*6F88*/
const unsigned char  uc2_6F89 [] = {0x4E, 0x80, 0x22, 0x80, 0x04, 0xF0, 0x5F, 0xA0, 0x2A, 0xA0, 0x2E, 0xA0, 0x0A, 0xA0, 0x2E, 0x40, 0x2A, 0xA0, 0x2E, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*6F89*/
const unsigned char  uc2_6F8C [] = {0x4A, 0x30, 0x3F, 0xC0, 0x2A, 0x80, 0x4E, 0xF0, 0x2A, 0xA0, 0x2E, 0xA0, 0x0A, 0xA0, 0x3F, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x51, 0x20, 0x00, 0x00 }; /*6F8C*/
const unsigned char  uc2_6F8D [] = {0x44, 0x20, 0x3F, 0x20, 0x24, 0x20, 0x4E, 0xF0, 0x20, 0x20, 0x2E, 0x20, 0x0A, 0xA0, 0x2E, 0x60, 0x2A, 0x20, 0x2F, 0x20, 0x58, 0xC0, 0x00, 0x00 }; /*6F8D*/
const unsigned char  uc2_6F8E [] = {0x44, 0x10, 0x3F, 0x10, 0x24, 0x20, 0x4E, 0xC0, 0x20, 0x10, 0x2E, 0x20, 0x0A, 0xC0, 0x2E, 0x10, 0x2A, 0x10, 0x27, 0x20, 0x58, 0xC0, 0x00, 0x00 }; /*6F8E*/
const unsigned char  uc2_6F9C [] = {0x4B, 0xF0, 0x24, 0x10, 0x11, 0x10, 0x5F, 0xF0, 0x35, 0x50, 0x17, 0xD0, 0x15, 0x50, 0x17, 0xD0, 0x33, 0x90, 0x55, 0x50, 0x59, 0x70, 0x00, 0x00 }; /*6F9C*/
const unsigned char  uc2_6FA1 [] = {0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x40, 0x00, 0x2E, 0xE0, 0x2A, 0xA0, 0x0E, 0xE0, 0x21, 0x00, 0x2F, 0xE0, 0x25, 0x40, 0x59, 0x30, 0x00, 0x00 }; /*6FA1*/
const unsigned char  uc2_6FA7 [] = {0x42, 0x80, 0x2F, 0xE0, 0x2A, 0xA0, 0x4F, 0xE0, 0x2A, 0xA0, 0x3F, 0xF0, 0x04, 0x40, 0x27, 0xC0, 0x24, 0x40, 0x22, 0x80, 0x5F, 0xF0, 0x00, 0x00 }; /*6FA7*/
const unsigned char  uc2_6FB3 [] = {0x42, 0x00, 0x2F, 0xE0, 0x2D, 0x60, 0x4B, 0xA0, 0x2B, 0xA0, 0x2D, 0x60, 0x08, 0x20, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*6FB3*/
const unsigned char  uc2_6FB6 [] = {0x41, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x49, 0x20, 0x2F, 0xE0, 0x24, 0x40, 0x07, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x20, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*6FB6*/
const unsigned char  uc2_6FB9 [] = {0x43, 0xC0, 0x24, 0x40, 0x0F, 0xF0, 0x4A, 0xA0, 0x2D, 0xD0, 0x28, 0x00, 0x0B, 0xE0, 0x28, 0x00, 0x2B, 0xE0, 0x2A, 0x20, 0x53, 0xE0, 0x00, 0x00 }; /*6FB9*/
const unsigned char  uc2_6FC0 [] = {0x44, 0x80, 0x2E, 0x80, 0x2A, 0xF0, 0x4F, 0xA0, 0x2A, 0xA0, 0x24, 0xA0, 0x1F, 0xA0, 0x28, 0x40, 0x2E, 0xA0, 0x2A, 0xA0, 0x55, 0x10, 0x00, 0x00 }; /*6FC0*/
const unsigned char  uc2_6FC2 [] = {0x40, 0x80, 0x2F, 0xF0, 0x2A, 0x20, 0x4F, 0xF0, 0x29, 0x40, 0x2B, 0xE0, 0x0D, 0x50, 0x2B, 0xE0, 0x29, 0x40, 0x2B, 0x60, 0x55, 0x50, 0x00, 0x00 }; /*6FC2*/
const unsigned char  uc2_6FC9 [] = {0x40, 0x40, 0x2E, 0xA0, 0x2B, 0xF0, 0x4A, 0xA0, 0x2E, 0xF0, 0x2A, 0xA0, 0x0E, 0xF0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2E, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*6FC9*/
const unsigned char  uc2_6FD1 [] = {0x44, 0x80, 0x3F, 0xE0, 0x24, 0xA0, 0x1F, 0xF0, 0x55, 0x10, 0x3F, 0x50, 0x25, 0x50, 0x0F, 0x50, 0x35, 0x50, 0x24, 0xA0, 0x45, 0x10, 0x00, 0x00 }; /*6FD1*/
const unsigned char  uc2_6FD2 [] = {0x49, 0xF0, 0x2E, 0x40, 0x09, 0xF0, 0x5F, 0x10, 0x21, 0x50, 0x09, 0x50, 0x2D, 0x50, 0x2A, 0x50, 0x44, 0xA0, 0x48, 0x90, 0x53, 0x10, 0x00, 0x00 }; /*6FD2*/
const unsigned char  uc2_6FDE [] = {0x41, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x47, 0xC0, 0x24, 0x40, 0x2F, 0xE0, 0x09, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x3F, 0xF0, 0x44, 0x40, 0x00, 0x00 }; /*6FDE*/
const unsigned char  uc2_6FE0 [] = {0x40, 0x80, 0x27, 0xE0, 0x22, 0x40, 0x4F, 0xF0, 0x28, 0x10, 0x27, 0xE0, 0x01, 0x00, 0x2E, 0xA0, 0x21, 0xC0, 0x2E, 0xB0, 0x43, 0x80, 0x00, 0x00 }; /*6FE0*/
const unsigned char  uc2_6FE1 [] = {0x4F, 0xE0, 0x21, 0x00, 0x0F, 0xE0, 0x49, 0x20, 0x25, 0x40, 0x20, 0x00, 0x1F, 0xF0, 0x22, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x4A, 0xA0, 0x00, 0x00 }; /*6FE1*/
const unsigned char  uc2_6FEE [] = {0x44, 0x90, 0x2A, 0xA0, 0x0F, 0xF0, 0x59, 0x40, 0x2F, 0xF0, 0x28, 0x80, 0x0B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x4E, 0x30, 0x00, 0x00 }; /*6FEE*/
const unsigned char  uc2_6FEF [] = {0x5E, 0xF0, 0x22, 0x10, 0x1A, 0xD0, 0x46, 0x30, 0x2A, 0xD0, 0x04, 0x80, 0x0F, 0xF0, 0x38, 0x80, 0x2F, 0xE0, 0x28, 0x80, 0x4F, 0xF0, 0x00, 0x00 }; /*6FEF*/
const unsigned char  uc2_7011 [] = {0x47, 0xC0, 0x24, 0x40, 0x07, 0xC0, 0x44, 0x40, 0x2F, 0xE0, 0x02, 0x80, 0x3F, 0xF0, 0x25, 0x40, 0x3B, 0xB0, 0x25, 0x40, 0x4B, 0x20, 0x00, 0x00 }; /*7011*/
const unsigned char  uc2_701A [] = {0x48, 0x40, 0x3E, 0xA0, 0x09, 0x10, 0x5D, 0xB0, 0x34, 0x90, 0x1D, 0xB0, 0x14, 0x90, 0x5D, 0xB0, 0x48, 0x90, 0x7E, 0x90, 0x4B, 0x60, 0x00, 0x00 }; /*701A*/
const unsigned char  uc2_701B [] = {0x41, 0x00, 0x5F, 0xF0, 0x08, 0x00, 0x47, 0xE0, 0x44, 0x20, 0x1F, 0xF0, 0x55, 0x50, 0x5F, 0xF0, 0x55, 0x50, 0x5D, 0xD0, 0x66, 0x50, 0x00, 0x00 }; /*701B*/
const unsigned char  uc2_7023 [] = {0x45, 0xE0, 0x36, 0xA0, 0x1A, 0x40, 0x55, 0xA0, 0x3A, 0xA0, 0x06, 0xC0, 0x2A, 0xA0, 0x26, 0xC0, 0x2A, 0xA0, 0x26, 0xC0, 0x5F, 0xF0, 0x00, 0x00 }; /*7023*/
const unsigned char  uc2_7035 [] = {0x45, 0x40, 0x3F, 0xF0, 0x09, 0x20, 0x1F, 0xF0, 0x49, 0x20, 0x2F, 0xE0, 0x09, 0x20, 0x2F, 0xE0, 0x24, 0x40, 0x5F, 0xF0, 0x48, 0x20, 0x00, 0x00 }; /*7035*/
const unsigned char  uc2_7039 [] = {0x41, 0x80, 0x22, 0x40, 0x0D, 0xB0, 0x40, 0x00, 0x2D, 0xB0, 0x0A, 0x50, 0x25, 0xA0, 0x2F, 0xF0, 0x2A, 0x50, 0x2F, 0xF0, 0x4A, 0x50, 0x00, 0x00 }; /*7039*/
const unsigned char  uc2_704C [] = {0x44, 0x40, 0x3F, 0xF0, 0x04, 0x40, 0x4A, 0xA0, 0x2E, 0xE0, 0x05, 0x00, 0x2F, 0xF0, 0x38, 0x80, 0x2F, 0xE0, 0x28, 0x80, 0x4F, 0xF0, 0x00, 0x00 }; /*704C*/
const unsigned char  uc2_704F [] = {0x40, 0x00, 0x5D, 0xF0, 0x14, 0x40, 0x49, 0xF0, 0x7F, 0x10, 0x15, 0x50, 0x5D, 0x50, 0x49, 0x50, 0x5C, 0xA0, 0x6A, 0x90, 0x51, 0x10, 0x00, 0x00 }; /*704F*/
const unsigned char  uc2_705E [] = {0x4F, 0xE0, 0x41, 0x00, 0x1F, 0xF0, 0x55, 0x50, 0x4B, 0xA0, 0x0A, 0x70, 0x7F, 0xD0, 0x4A, 0x70, 0x55, 0x50, 0x7F, 0xF0, 0x44, 0x50, 0x00, 0x00 }; /*705E*/
const unsigned char  uc2_706B [] = {0x02, 0x00, 0x02, 0x00, 0x12, 0x20, 0x12, 0x20, 0x22, 0x40, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*706B*/
const unsigned char  uc2_706D [] = {0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x02, 0x00, 0x12, 0x20, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*706D*/
const unsigned char  uc2_706F [] = {0x10, 0x00, 0x13, 0xF0, 0x14, 0x40, 0x54, 0x40, 0x58, 0x40, 0x50, 0x40, 0x18, 0x40, 0x14, 0x40, 0x24, 0x40, 0x20, 0x40, 0x41, 0x80, 0x00, 0x00 }; /*706F*/
const unsigned char  uc2_7070 [] = {0x10, 0x00, 0x10, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x11, 0x00, 0x15, 0x20, 0x15, 0x20, 0x29, 0x40, 0x22, 0x80, 0x44, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*7070*/
const unsigned char  uc2_7075 [] = {0x1F, 0xC0, 0x00, 0x40, 0x0F, 0xC0, 0x00, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7075*/
const unsigned char  uc2_7076 [] = {0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x54, 0x80, 0x5B, 0xE0, 0x50, 0x80, 0x18, 0x80, 0x14, 0x80, 0x24, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*7076*/
const unsigned char  uc2_7078 [] = {0x04, 0x00, 0x07, 0x80, 0x38, 0x80, 0x03, 0x00, 0x0C, 0xE0, 0x72, 0x10, 0x0A, 0x40, 0x12, 0x80, 0x05, 0x00, 0x08, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*7078*/
const unsigned char  uc2_707C [] = {0x11, 0x00, 0x11, 0xF0, 0x15, 0x10, 0x56, 0x10, 0x58, 0x90, 0x50, 0x50, 0x18, 0x50, 0x14, 0x10, 0x24, 0x10, 0x20, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*707C*/
const unsigned char  uc2_707E [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x02, 0x00, 0x12, 0x20, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*707E*/
const unsigned char  uc2_707F [] = {0x10, 0x40, 0x10, 0x40, 0x14, 0x40, 0x55, 0x50, 0x59, 0x50, 0x51, 0x50, 0x19, 0x50, 0x15, 0x50, 0x25, 0x50, 0x21, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*707F*/
const unsigned char  uc2_7080 [] = {0x10, 0x00, 0x13, 0xC0, 0x14, 0x40, 0x54, 0x80, 0x5B, 0xF0, 0x51, 0x50, 0x19, 0x50, 0x15, 0x50, 0x25, 0x50, 0x22, 0x90, 0x41, 0x60, 0x00, 0x00 }; /*7080*/
const unsigned char  uc2_7085 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7085*/
const unsigned char  uc2_7089 [] = {0x10, 0x80, 0x10, 0x40, 0x15, 0xF0, 0x55, 0x10, 0x59, 0x10, 0x51, 0xF0, 0x19, 0x10, 0x15, 0x00, 0x25, 0x00, 0x22, 0x00, 0x44, 0x00, 0x00, 0x00 }; /*7089*/
const unsigned char  uc2_708A [] = {0x12, 0x00, 0x13, 0xF0, 0x12, 0x10, 0x54, 0x90, 0x58, 0xA0, 0x50, 0x80, 0x18, 0x80, 0x15, 0x40, 0x25, 0x40, 0x22, 0x20, 0x4C, 0x10, 0x00, 0x00 }; /*708A*/
const unsigned char  uc2_708E [] = {0x02, 0x00, 0x12, 0x20, 0x22, 0x40, 0x05, 0x80, 0x18, 0x60, 0x62, 0x10, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*708E*/
const unsigned char  uc2_7092 [] = {0x10, 0x40, 0x10, 0x40, 0x15, 0x60, 0x55, 0x50, 0x5A, 0x50, 0x50, 0x40, 0x18, 0x50, 0x14, 0x10, 0x24, 0x20, 0x20, 0xC0, 0x43, 0x00, 0x00, 0x00 }; /*7092*/
const unsigned char  uc2_7094 [] = {0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x54, 0xA0, 0x58, 0xA0, 0x57, 0xF0, 0x10, 0x80, 0x19, 0x40, 0x25, 0x40, 0x22, 0x20, 0x4C, 0x10, 0x00, 0x00 }; /*7094*/
const unsigned char  uc2_7095 [] = {0x11, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x54, 0x00, 0x59, 0xC0, 0x51, 0x40, 0x19, 0x40, 0x15, 0x40, 0x25, 0x50, 0x22, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*7095*/
const unsigned char  uc2_7096 [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x54, 0x80, 0x5A, 0xA0, 0x52, 0xA0, 0x1B, 0xE0, 0x14, 0xA0, 0x24, 0x90, 0x20, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*7096*/
const unsigned char  uc2_7099 [] = {0x04, 0x00, 0x07, 0xC0, 0x3A, 0x40, 0x09, 0x80, 0x7E, 0x00, 0x02, 0x00, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7099*/
const unsigned char  uc2_709C [] = {0x10, 0x80, 0x17, 0xF0, 0x14, 0x80, 0x5B, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x18, 0x90, 0x14, 0x90, 0x24, 0xE0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*709C*/
const unsigned char  uc2_709D [] = {0x10, 0x80, 0x10, 0x80, 0x15, 0x40, 0x56, 0x30, 0x59, 0xC0, 0x51, 0x40, 0x19, 0x40, 0x15, 0x80, 0x25, 0x10, 0x21, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*709D*/
const unsigned char  uc2_70AB [] = {0x10, 0x80, 0x10, 0x40, 0x15, 0xF0, 0x54, 0x40, 0x58, 0x80, 0x51, 0x20, 0x19, 0xC0, 0x14, 0x80, 0x25, 0x20, 0x23, 0xD0, 0x40, 0x10, 0x00, 0x00 }; /*70AB*/
const unsigned char  uc2_70AC [] = {0x10, 0x00, 0x11, 0xF0, 0x15, 0x00, 0x55, 0x00, 0x59, 0xE0, 0x51, 0x20, 0x19, 0x20, 0x15, 0xE0, 0x25, 0x00, 0x21, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*70AC*/
const unsigned char  uc2_70AD [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x10, 0x00, 0x7F, 0xF0, 0x11, 0x00, 0x15, 0x20, 0x29, 0x40, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*70AD*/
const unsigned char  uc2_70AE [] = {0x11, 0x00, 0x11, 0xF0, 0x16, 0x10, 0x55, 0xD0, 0x59, 0x50, 0x51, 0x50, 0x19, 0xD0, 0x15, 0x20, 0x25, 0x10, 0x21, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*70AE*/
const unsigned char  uc2_70AF [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x5C, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x2C, 0x10, 0x24, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*70AF*/
const unsigned char  uc2_70B1 [] = {0x08, 0x40, 0x11, 0xA0, 0x3E, 0x20, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x12, 0x20, 0x22, 0x40, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*70B1*/
const unsigned char  uc2_70B3 [] = {0x10, 0x00, 0x11, 0xF0, 0x14, 0x40, 0x55, 0xF0, 0x59, 0x50, 0x51, 0x50, 0x19, 0x70, 0x15, 0xB0, 0x25, 0x10, 0x21, 0x10, 0x41, 0x20, 0x00, 0x00 }; /*70B3*/
const unsigned char  uc2_70B7 [] = {0x13, 0x00, 0x10, 0x80, 0x17, 0xF0, 0x54, 0x80, 0x58, 0x80, 0x50, 0x80, 0x1B, 0xE0, 0x14, 0x80, 0x24, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*70B7*/
const unsigned char  uc2_70B8 [] = {0x11, 0x00, 0x11, 0x00, 0x15, 0xF0, 0x56, 0x80, 0x58, 0x80, 0x50, 0xE0, 0x18, 0x80, 0x14, 0x80, 0x24, 0xE0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*70B8*/
const unsigned char  uc2_70B9 [] = {0x02, 0x00, 0x03, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x29, 0x20, 0x24, 0x90, 0x44, 0x90, 0x00, 0x00 }; /*70B9*/
const unsigned char  uc2_70BB [] = {0x10, 0x00, 0x17, 0xF0, 0x10, 0x80, 0x54, 0x80, 0x59, 0x00, 0x53, 0xE0, 0x15, 0x20, 0x19, 0x20, 0x25, 0x20, 0x21, 0xE0, 0x41, 0x20, 0x00, 0x00 }; /*70BB*/
const unsigned char  uc2_70BC [] = {0x10, 0x40, 0x13, 0xF0, 0x14, 0x80, 0x5B, 0xC0, 0x51, 0x40, 0x51, 0xF0, 0x18, 0x40, 0x15, 0x60, 0x25, 0x50, 0x22, 0x50, 0x41, 0x80, 0x00, 0x00 }; /*70BC*/
const unsigned char  uc2_70BD [] = {0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x56, 0x20, 0x5A, 0x20, 0x53, 0xE0, 0x18, 0x00, 0x15, 0x40, 0x25, 0x20, 0x22, 0x10, 0x44, 0x10, 0x00, 0x00 }; /*70BD*/
const unsigned char  uc2_70C0 [] = {0x10, 0x60, 0x13, 0x80, 0x14, 0xA0, 0x56, 0xA0, 0x59, 0xC0, 0x50, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x28, 0x80, 0x28, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*70C0*/
const unsigned char  uc2_70C1 [] = {0x10, 0x60, 0x11, 0x80, 0x15, 0x00, 0x55, 0x40, 0x5A, 0x40, 0x53, 0xF0, 0x18, 0x40, 0x15, 0x60, 0x25, 0x50, 0x22, 0x50, 0x41, 0x80, 0x00, 0x00 }; /*70C1*/
const unsigned char  uc2_70C2 [] = {0x12, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x54, 0x00, 0x58, 0x00, 0x50, 0x00, 0x19, 0xE0, 0x14, 0x00, 0x24, 0x00, 0x20, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*70C2*/
const unsigned char  uc2_70C3 [] = {0x10, 0x00, 0x13, 0xC0, 0x14, 0x40, 0x54, 0x80, 0x59, 0x60, 0x56, 0x10, 0x18, 0x00, 0x17, 0xE0, 0x24, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*70C3*/
const unsigned char  uc2_70C8 [] = {0x00, 0x10, 0x3F, 0x50, 0x08, 0x50, 0x0E, 0x50, 0x12, 0x50, 0x6A, 0x50, 0x0C, 0x10, 0x70, 0x60, 0x29, 0x20, 0x24, 0x90, 0x44, 0x90, 0x00, 0x00 }; /*70C8*/
const unsigned char  uc2_70CA [] = {0x12, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x54, 0x80, 0x58, 0x80, 0x53, 0xE0, 0x18, 0x80, 0x14, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*70CA*/
const unsigned char  uc2_70D8 [] = {0x11, 0x40, 0x11, 0x40, 0x17, 0xE0, 0x59, 0x40, 0x51, 0x40, 0x51, 0x40, 0x17, 0xF0, 0x18, 0x00, 0x25, 0x40, 0x21, 0x20, 0x46, 0x20, 0x00, 0x00 }; /*70D8*/
const unsigned char  uc2_70D9 [] = {0x11, 0x00, 0x11, 0xE0, 0x16, 0x20, 0x59, 0x40, 0x50, 0x80, 0x51, 0x40, 0x16, 0x30, 0x1B, 0xE0, 0x26, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*70D9*/
const unsigned char  uc2_70DB [] = {0x10, 0x80, 0x10, 0x80, 0x17, 0xE0, 0x5A, 0xA0, 0x52, 0xA0, 0x52, 0xA0, 0x1B, 0xE0, 0x14, 0x80, 0x24, 0xA0, 0x20, 0xF0, 0x47, 0x10, 0x00, 0x00 }; /*70DB*/
const unsigned char  uc2_70DF [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x5C, 0x90, 0x55, 0xD0, 0x54, 0x90, 0x15, 0x50, 0x16, 0x50, 0x2C, 0x10, 0x27, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*70DF*/
const unsigned char  uc2_70E4 [] = {0x10, 0x90, 0x13, 0xD0, 0x14, 0xA0, 0x57, 0xF0, 0x58, 0x80, 0x51, 0xF0, 0x17, 0x00, 0x19, 0xE0, 0x24, 0x20, 0x20, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*70E4*/
const unsigned char  uc2_70E6 [] = {0x10, 0x00, 0x17, 0xF0, 0x14, 0x80, 0x5B, 0xE0, 0x52, 0x20, 0x52, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x25, 0x40, 0x21, 0x20, 0x46, 0x20, 0x00, 0x00 }; /*70E6*/
const unsigned char  uc2_70E7 [] = {0x11, 0x00, 0x11, 0xE0, 0x17, 0x40, 0x58, 0x90, 0x57, 0x60, 0x50, 0x00, 0x17, 0xF0, 0x19, 0x40, 0x25, 0x50, 0x22, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*70E7*/
const unsigned char  uc2_70E8 [] = {0x10, 0xC0, 0x11, 0x50, 0x17, 0x60, 0x55, 0xD0, 0x59, 0x50, 0x51, 0x20, 0x18, 0x40, 0x15, 0xF0, 0x24, 0x40, 0x20, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*70E8*/
const unsigned char  uc2_70E9 [] = {0x10, 0x80, 0x10, 0x80, 0x15, 0x40, 0x56, 0x30, 0x5B, 0xE0, 0x50, 0x00, 0x17, 0xF0, 0x18, 0x80, 0x25, 0x40, 0x22, 0x60, 0x43, 0xA0, 0x00, 0x00 }; /*70E9*/
const unsigned char  uc2_70EB [] = {0x33, 0xC0, 0x08, 0x80, 0x63, 0xF0, 0x11, 0x50, 0x06, 0x90, 0x11, 0x60, 0x62, 0x00, 0x12, 0x20, 0x25, 0x40, 0x08, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*70EB*/
const unsigned char  uc2_70EC [] = {0x10, 0x00, 0x11, 0xE0, 0x15, 0x20, 0x55, 0xE0, 0x59, 0x40, 0x51, 0x20, 0x1A, 0x90, 0x14, 0x40, 0x25, 0xA0, 0x20, 0x40, 0x40, 0x20, 0x00, 0x00 }; /*70EC*/
const unsigned char  uc2_70ED [] = {0x11, 0x00, 0x7B, 0xC0, 0x11, 0x40, 0x1B, 0x40, 0x71, 0xD0, 0x11, 0x50, 0x66, 0x20, 0x00, 0x00, 0x29, 0x20, 0x24, 0x90, 0x44, 0x90, 0x00, 0x00 }; /*70ED*/
const unsigned char  uc2_70EF [] = {0x11, 0x20, 0x10, 0xC0, 0x15, 0x20, 0x54, 0x80, 0x5B, 0xF0, 0x51, 0x40, 0x17, 0xF0, 0x19, 0x50, 0x25, 0x60, 0x20, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*70EF*/
const unsigned char  uc2_70F7 [] = {0x20, 0x80, 0x27, 0xF0, 0x24, 0x10, 0x6C, 0x10, 0x33, 0xE0, 0x20, 0x00, 0x27, 0xF0, 0x31, 0x40, 0x29, 0x50, 0x22, 0x50, 0x4C, 0x20, 0x00, 0x00 }; /*70F7*/
const unsigned char  uc2_70F9 [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x80, 0x01, 0x00, 0x06, 0x00, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*70F9*/
const unsigned char  uc2_70FD [] = {0x11, 0x00, 0x11, 0xC0, 0x17, 0x40, 0x59, 0xC0, 0x56, 0xB0, 0x53, 0xE0, 0x10, 0x80, 0x1B, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*70FD*/
const unsigned char  uc2_7109 [] = {0x1F, 0xE0, 0x02, 0x00, 0x0B, 0xC0, 0x0A, 0x00, 0x3F, 0xF0, 0x08, 0x00, 0x0F, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x15, 0x10, 0x6A, 0xA0, 0x00, 0x00 }; /*7109*/
const unsigned char  uc2_710A [] = {0x13, 0xE0, 0x12, 0x20, 0x17, 0xE0, 0x5A, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x13, 0xE0, 0x18, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*710A*/
const unsigned char  uc2_7110 [] = {0x10, 0x00, 0x13, 0xF0, 0x14, 0x40, 0x59, 0xE0, 0x50, 0xA0, 0x53, 0xF0, 0x10, 0x00, 0x19, 0xE0, 0x25, 0x20, 0x21, 0xE0, 0x41, 0x20, 0x00, 0x00 }; /*7110*/
const unsigned char  uc2_7113 [] = {0x10, 0x80, 0x10, 0x80, 0x15, 0x40, 0x56, 0x30, 0x58, 0x80, 0x53, 0xE0, 0x10, 0x40, 0x13, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*7113*/
const unsigned char  uc2_7115 [] = {0x11, 0x00, 0x11, 0xC0, 0x16, 0x40, 0x5B, 0xE0, 0x52, 0xA0, 0x52, 0xA0, 0x17, 0xF0, 0x18, 0x80, 0x25, 0x40, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*7115*/
const unsigned char  uc2_7116 [] = {0x16, 0x00, 0x11, 0x70, 0x14, 0x10, 0x5C, 0x90, 0x54, 0x90, 0x55, 0x10, 0x17, 0x70, 0x1D, 0x50, 0x24, 0x90, 0x24, 0x10, 0x44, 0x20, 0x00, 0x00 }; /*7116*/
const unsigned char  uc2_7118 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xF0, 0x62, 0x40, 0x01, 0x80, 0x48, 0x90, 0x00, 0x00 }; /*7118*/
const unsigned char  uc2_7119 [] = {0x11, 0x00, 0x10, 0x80, 0x17, 0xE0, 0x59, 0x40, 0x57, 0xF0, 0x50, 0x00, 0x13, 0xE0, 0x1A, 0x20, 0x26, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*7119*/
const unsigned char  uc2_711A [] = {0x08, 0x80, 0x7F, 0xF0, 0x0C, 0xC0, 0x1B, 0xA0, 0x6C, 0xA0, 0x08, 0x80, 0x12, 0x20, 0x22, 0x40, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*711A*/
const unsigned char  uc2_7126 [] = {0x09, 0x00, 0x1F, 0xF0, 0x71, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*7126*/
const unsigned char  uc2_712F [] = {0x10, 0x80, 0x10, 0xF0, 0x14, 0x80, 0x5B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x28, 0x80, 0x27, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*712F*/
const unsigned char  uc2_7130 [] = {0x10, 0x80, 0x10, 0xF0, 0x15, 0x10, 0x5A, 0x20, 0x50, 0x40, 0x51, 0xB0, 0x11, 0x10, 0x19, 0xB0, 0x25, 0x10, 0x21, 0xF0, 0x41, 0x10, 0x00, 0x00 }; /*7130*/
const unsigned char  uc2_7131 [] = {0x02, 0x00, 0x12, 0x40, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00, 0x08, 0x80, 0x2A, 0xA0, 0x2A, 0xA0, 0x08, 0x80, 0x15, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*7131*/
const unsigned char  uc2_7136 [] = {0x10, 0xC0, 0x1C, 0xA0, 0x27, 0xF0, 0x54, 0x80, 0x29, 0x40, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00, 0x29, 0x20, 0x24, 0x90, 0x44, 0x90, 0x00, 0x00 }; /*7136*/
const unsigned char  uc2_7145 [] = {0x12, 0x00, 0x14, 0xE0, 0x14, 0xA0, 0x5F, 0x10, 0x55, 0xE0, 0x56, 0xA0, 0x14, 0xA0, 0x16, 0x40, 0x2C, 0xA0, 0x24, 0xA0, 0x45, 0x10, 0x00, 0x00 }; /*7145*/
const unsigned char  uc2_714A [] = {0x11, 0x00, 0x10, 0x80, 0x57, 0xF0, 0x54, 0x10, 0x5B, 0xE0, 0x50, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*714A*/
const unsigned char  uc2_714C [] = {0x10, 0x80, 0x13, 0xE0, 0x56, 0x20, 0x5B, 0xE0, 0x52, 0x20, 0x57, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*714C*/
const unsigned char  uc2_714E [] = {0x10, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x24, 0x20, 0x3C, 0xA0, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0x20, 0x28, 0x40, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*714E*/
const unsigned char  uc2_715C [] = {0x13, 0xE0, 0x12, 0x20, 0x17, 0xE0, 0x5A, 0x20, 0x53, 0xE0, 0x50, 0x80, 0x13, 0xE0, 0x18, 0x40, 0x25, 0x40, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*715C*/
const unsigned char  uc2_715E [] = {0x10, 0x80, 0x1C, 0xF0, 0x25, 0x20, 0x7E, 0xA0, 0x02, 0xA0, 0x3E, 0x40, 0x02, 0xA0, 0x7E, 0xA0, 0x01, 0x10, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*715E*/
const unsigned char  uc2_7164 [] = {0x12, 0x20, 0x17, 0xF0, 0x52, 0x20, 0x57, 0xE0, 0x5A, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x2F, 0xF0, 0x29, 0xC0, 0x22, 0xA0, 0x44, 0x90, 0x00, 0x00 }; /*7164*/
const unsigned char  uc2_7166 [] = {0x02, 0x00, 0x3B, 0xE0, 0x2C, 0x20, 0x3B, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2B, 0xA0, 0x00, 0x20, 0x00, 0xC0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*7166*/
const unsigned char  uc2_7167 [] = {0x03, 0xF0, 0x3C, 0x90, 0x25, 0x10, 0x3E, 0x20, 0x25, 0xF0, 0x3D, 0x10, 0x25, 0xF0, 0x01, 0x10, 0x00, 0x00, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*7167*/
const unsigned char  uc2_7168 [] = {0x10, 0x00, 0x13, 0xE0, 0x16, 0xA0, 0x5B, 0xE0, 0x52, 0xA0, 0x57, 0xF0, 0x12, 0x40, 0x1A, 0x50, 0x26, 0xA0, 0x23, 0x20, 0x42, 0x10, 0x00, 0x00 }; /*7168*/
const unsigned char  uc2_716E [] = {0x02, 0x20, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x0F, 0xC0, 0x78, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x2F, 0xD0, 0x44, 0x90, 0x00, 0x00 }; /*716E*/
const unsigned char  uc2_7172 [] = {0x09, 0xC0, 0x11, 0x40, 0x70, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x1C, 0x90, 0x10, 0x80, 0x0A, 0x40, 0x12, 0x80, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*7172*/
const unsigned char  uc2_7173 [] = {0x12, 0x00, 0x12, 0x70, 0x1F, 0xD0, 0x52, 0x70, 0x52, 0x50, 0x57, 0x50, 0x15, 0x70, 0x1D, 0x50, 0x27, 0x50, 0x25, 0x50, 0x40, 0xA0, 0x00, 0x00 }; /*7173*/
const unsigned char  uc2_7178 [] = {0x10, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x5F, 0xF0, 0x54, 0x00, 0x57, 0xF0, 0x15, 0x50, 0x1F, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x48, 0x60, 0x00, 0x00 }; /*7178*/
const unsigned char  uc2_717A [] = {0x14, 0x00, 0x12, 0xF0, 0x18, 0xD0, 0x56, 0xB0, 0x52, 0xE0, 0x52, 0x90, 0x12, 0xE0, 0x1A, 0x90, 0x26, 0xD0, 0x25, 0x00, 0x48, 0xF0, 0x00, 0x00 }; /*717A*/
const unsigned char  uc2_717D [] = {0x10, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x5F, 0xF0, 0x54, 0x00, 0x57, 0xF0, 0x14, 0x90, 0x1E, 0xD0, 0x25, 0xB0, 0x26, 0xD0, 0x49, 0x20, 0x00, 0x00 }; /*717D*/
const unsigned char  uc2_7184 [] = {0x10, 0x80, 0x13, 0xE0, 0x16, 0x20, 0x5B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x29, 0x40, 0x25, 0x20, 0x48, 0xD0, 0x00, 0x00 }; /*7184*/
const unsigned char  uc2_718A [] = {0x10, 0x90, 0x22, 0xE0, 0x7D, 0x90, 0x22, 0x70, 0x3E, 0x00, 0x22, 0x90, 0x3E, 0xE0, 0x22, 0x90, 0x04, 0x70, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*718A*/
const unsigned char  uc2_718F [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*718F*/
const unsigned char  uc2_7194 [] = {0x10, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x59, 0x60, 0x56, 0x90, 0x51, 0x40, 0x16, 0x30, 0x1B, 0xE0, 0x26, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*7194*/
const unsigned char  uc2_7198 [] = {0x13, 0x00, 0x14, 0xF0, 0x15, 0x50, 0x5F, 0x50, 0x55, 0xA0, 0x50, 0x00, 0x17, 0xF0, 0x1C, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x47, 0xF0, 0x00, 0x00 }; /*7198*/
const unsigned char  uc2_7199 [] = {0x7D, 0xE0, 0x49, 0x20, 0x5D, 0x20, 0x55, 0xE0, 0x55, 0x00, 0x5D, 0x10, 0x49, 0x10, 0x7E, 0xE0, 0x00, 0x00, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*7199*/
const unsigned char  uc2_719F [] = {0x10, 0x80, 0x7C, 0x80, 0x2B, 0xE0, 0x38, 0xA0, 0x01, 0xA0, 0x38, 0xA0, 0x10, 0xE0, 0x7D, 0x20, 0x11, 0x10, 0x22, 0x00, 0x6D, 0xB0, 0x00, 0x00 }; /*719F*/
const unsigned char  uc2_71A0 [] = {0x17, 0x70, 0x15, 0x50, 0x1B, 0x30, 0x55, 0x50, 0x50, 0x80, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*71A0*/
const unsigned char  uc2_71A8 [] = {0x3E, 0x20, 0x22, 0x20, 0x3E, 0xF0, 0x28, 0xA0, 0x3E, 0x60, 0x24, 0x20, 0x55, 0x20, 0x0A, 0xC0, 0x25, 0x20, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*71A8*/
const unsigned char  uc2_71AC [] = {0x08, 0x80, 0x3E, 0xF0, 0x08, 0xA0, 0x1D, 0xA0, 0x08, 0xA0, 0x7F, 0x40, 0x14, 0xA0, 0x6D, 0x10, 0x00, 0x00, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*71AC*/
const unsigned char  uc2_71B3 [] = {0x13, 0xE0, 0x12, 0x20, 0x57, 0xE0, 0x5A, 0x20, 0x57, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x2A, 0x20, 0x29, 0xC0, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*71B3*/
const unsigned char  uc2_71B5 [] = {0x10, 0x80, 0x17, 0xF0, 0x19, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x56, 0x30, 0x15, 0xD0, 0x1D, 0x50, 0x25, 0xD0, 0x24, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*71B5*/
const unsigned char  uc2_71B9 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xE0, 0x64, 0x90, 0x00, 0x00 }; /*71B9*/
const unsigned char  uc2_71C3 [] = {0x24, 0x60, 0x27, 0x50, 0x25, 0xF0, 0x3B, 0x40, 0x65, 0x40, 0x22, 0xA0, 0x2D, 0x10, 0x20, 0x00, 0x32, 0xA0, 0x25, 0x50, 0x49, 0x50, 0x00, 0x00 }; /*71C3*/
const unsigned char  uc2_71CE [] = {0x10, 0x80, 0x17, 0xF0, 0x15, 0x50, 0x5A, 0x20, 0x57, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x2B, 0xE0, 0x2A, 0xA0, 0x45, 0x90, 0x00, 0x00 }; /*71CE*/
const unsigned char  uc2_71D4 [] = {0x10, 0x60, 0x13, 0x80, 0x1A, 0xA0, 0x57, 0xF0, 0x51, 0x40, 0x56, 0xB0, 0x13, 0xE0, 0x1A, 0xA0, 0x2B, 0xE0, 0x22, 0xA0, 0x43, 0xE0, 0x00, 0x00 }; /*71D4*/
const unsigned char  uc2_71D5 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x0F, 0x80, 0x10, 0x50, 0x77, 0x60, 0x15, 0x50, 0x77, 0x20, 0x10, 0x00, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*71D5*/
const unsigned char  uc2_71E0 [] = {0x11, 0x00, 0x17, 0xF0, 0x54, 0x90, 0x56, 0xB0, 0x5F, 0xF0, 0x55, 0xD0, 0x16, 0xB0, 0x10, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*71E0*/
const unsigned char  uc2_71E5 [] = {0x13, 0xE0, 0x12, 0x20, 0x57, 0xE0, 0x58, 0x00, 0x57, 0x70, 0x15, 0x50, 0x17, 0x70, 0x28, 0x80, 0x2F, 0xF0, 0x22, 0xA0, 0x44, 0x90, 0x00, 0x00 }; /*71E5*/
const unsigned char  uc2_71E7 [] = {0x24, 0xA0, 0x23, 0xF0, 0x20, 0x80, 0x37, 0x50, 0x62, 0xE0, 0x23, 0x40, 0x22, 0xE0, 0x23, 0x50, 0x32, 0x40, 0x25, 0x80, 0x48, 0x70, 0x00, 0x00 }; /*71E7*/
const unsigned char  uc2_71EE [] = {0x12, 0x40, 0x57, 0x50, 0x12, 0x40, 0x15, 0x40, 0x2F, 0xA0, 0x45, 0x10, 0x1F, 0x80, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*71EE*/
const unsigned char  uc2_71F9 [] = {0x7D, 0xF0, 0x12, 0x40, 0x6D, 0xA0, 0x18, 0x70, 0x6D, 0xA0, 0x1A, 0x70, 0x69, 0xA0, 0x32, 0x40, 0x12, 0x40, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*71F9*/
const unsigned char  uc2_7206 [] = {0x13, 0xE0, 0x12, 0x20, 0x57, 0xE0, 0x59, 0x40, 0x53, 0xE0, 0x11, 0x40, 0x17, 0xF0, 0x12, 0xA0, 0x2D, 0xD0, 0x2A, 0xA0, 0x41, 0x80, 0x00, 0x00 }; /*7206*/
const unsigned char  uc2_721D [] = {0x2F, 0xF0, 0x25, 0x20, 0x2F, 0xF0, 0x3A, 0x50, 0x6F, 0xF0, 0x2A, 0x20, 0x2E, 0xF0, 0x3A, 0x20, 0x2E, 0xA0, 0x2A, 0x20, 0x4D, 0x40, 0x00, 0x00 }; /*721D*/
const unsigned char  uc2_7228 [] = {0x0F, 0x80, 0x38, 0xE0, 0x2F, 0xA0, 0x38, 0xE0, 0x2A, 0xA0, 0x7F, 0xF0, 0x50, 0x50, 0x3F, 0xE0, 0x12, 0x40, 0x6A, 0xB0, 0x1D, 0xC0, 0x00, 0x00 }; /*7228*/
const unsigned char  uc2_722A [] = {0x01, 0xE0, 0x1E, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x20, 0x22, 0x20, 0x22, 0x20, 0x42, 0x10, 0x00, 0x00 }; /*722A*/
const unsigned char  uc2_722C [] = {0x02, 0x00, 0x0D, 0xF0, 0x75, 0x50, 0x55, 0x50, 0x55, 0xF0, 0x55, 0x00, 0x55, 0x10, 0x55, 0x10, 0x52, 0xE0, 0x51, 0x00, 0x10, 0xF0, 0x00, 0x00 }; /*722C*/
const unsigned char  uc2_7230 [] = {0x00, 0x70, 0x3F, 0xA0, 0x09, 0x40, 0x1F, 0xE0, 0x04, 0x00, 0x3F, 0xF0, 0x04, 0x00, 0x07, 0xC0, 0x0A, 0x40, 0x09, 0x80, 0x36, 0x70, 0x00, 0x00 }; /*7230*/
const unsigned char  uc2_7231 [] = {0x01, 0xE0, 0x3E, 0x40, 0x12, 0x80, 0x7F, 0xF0, 0x48, 0x10, 0x3F, 0xE0, 0x08, 0x00, 0x0F, 0xC0, 0x14, 0x40, 0x63, 0x80, 0x1C, 0x70, 0x00, 0x00 }; /*7231*/
const unsigned char  uc2_7235 [] = {0x7F, 0xF0, 0x12, 0x40, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x24, 0x20, 0x3D, 0xF0, 0x24, 0xA0, 0x3C, 0x60, 0x28, 0x20, 0x34, 0xC0, 0x00, 0x00 }; /*7235*/
const unsigned char  uc2_7236 [] = {0x08, 0x80, 0x08, 0x40, 0x10, 0x20, 0x28, 0xA0, 0x08, 0x80, 0x05, 0x00, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7236*/
const unsigned char  uc2_7237 [] = {0x18, 0xC0, 0x60, 0x20, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x1F, 0xC0, 0x04, 0x40, 0x04, 0x40, 0x05, 0x80, 0x04, 0x00, 0x00, 0x00 }; /*7237*/
const unsigned char  uc2_7238 [] = {0x08, 0xC0, 0x35, 0x20, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xD0, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*7238*/
const unsigned char  uc2_7239 [] = {0x18, 0xC0, 0x65, 0x20, 0x02, 0x00, 0x7D, 0xF0, 0x02, 0x00, 0x1F, 0x00, 0x05, 0x00, 0x3E, 0xE0, 0x02, 0x40, 0x03, 0x80, 0x7C, 0x00, 0x00, 0x00 }; /*7239*/
const unsigned char  uc2_723B [] = {0x38, 0xE0, 0x07, 0x00, 0x08, 0xC0, 0x70, 0x20, 0x08, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*723B*/
const unsigned char  uc2_723D [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x2A, 0xA0, 0x12, 0x40, 0x2A, 0xA0, 0x12, 0x40, 0x2A, 0xA0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*723D*/
const unsigned char  uc2_723F [] = {0x00, 0x40, 0x08, 0x40, 0x08, 0x40, 0x0F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x3F, 0xC0, 0x04, 0x40, 0x04, 0x40, 0x08, 0x40, 0x30, 0x40, 0x00, 0x00 }; /*723F*/
const unsigned char  uc2_7247 [] = {0x01, 0x00, 0x09, 0x00, 0x09, 0x00, 0x0F, 0xF0, 0x08, 0x00, 0x08, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x10, 0x40, 0x10, 0x40, 0x60, 0x40, 0x00, 0x00 }; /*7247*/
const unsigned char  uc2_7248 [] = {0x08, 0x30, 0x2B, 0xC0, 0x2A, 0x00, 0x3E, 0x00, 0x23, 0xE0, 0x22, 0xA0, 0x3A, 0xA0, 0x2A, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x4D, 0x10, 0x00, 0x00 }; /*7248*/
const unsigned char  uc2_724C [] = {0x08, 0x80, 0x2B, 0xE0, 0x2A, 0xA0, 0x3F, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x39, 0x00, 0x2A, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x48, 0x80, 0x00, 0x00 }; /*724C*/
const unsigned char  uc2_724D [] = {0x08, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x2B, 0xF0, 0x3D, 0x10, 0x22, 0xA0, 0x38, 0x80, 0x2B, 0xF0, 0x28, 0x80, 0x29, 0x60, 0x4E, 0x10, 0x00, 0x00 }; /*724D*/
const unsigned char  uc2_7252 [] = {0x12, 0xA0, 0x57, 0xF0, 0x52, 0xA0, 0x7A, 0xE0, 0x42, 0x00, 0x43, 0xF0, 0x70, 0x80, 0x57, 0xF0, 0x51, 0xC0, 0x52, 0xA0, 0x54, 0x90, 0x00, 0x00 }; /*7252*/
const unsigned char  uc2_7256 [] = {0x08, 0x80, 0x2B, 0xF0, 0x2A, 0x10, 0x3F, 0xF0, 0x22, 0xA0, 0x23, 0xF0, 0x3A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x4C, 0xA0, 0x00, 0x00 }; /*7256*/
const unsigned char  uc2_7259 [] = {0x1F, 0xE0, 0x00, 0x80, 0x08, 0x80, 0x10, 0x80, 0x3F, 0xF0, 0x04, 0x80, 0x04, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x07, 0x00, 0x00, 0x00 }; /*7259*/
const unsigned char  uc2_725B [] = {0x02, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x12, 0x00, 0x22, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*725B*/
const unsigned char  uc2_725D [] = {0x08, 0x80, 0x28, 0x80, 0x28, 0x90, 0x3E, 0x90, 0x28, 0xA0, 0x4A, 0xC0, 0x0C, 0x80, 0x18, 0x90, 0x68, 0x90, 0x08, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*725D*/
const unsigned char  uc2_725F [] = {0x08, 0x80, 0x10, 0x40, 0x3F, 0xA0, 0x02, 0x20, 0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*725F*/
const unsigned char  uc2_7261 [] = {0x08, 0x80, 0x28, 0x80, 0x28, 0x80, 0x3C, 0x80, 0x2B, 0xE0, 0x48, 0x80, 0x0C, 0x80, 0x18, 0x80, 0x68, 0x80, 0x0F, 0xF0, 0x08, 0x00, 0x00, 0x00 }; /*7261*/
const unsigned char  uc2_7262 [] = {0x0C, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x52, 0x10, 0x1F, 0xC0, 0x22, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7262*/
const unsigned char  uc2_7266 [] = {0x08, 0x60, 0x2B, 0x80, 0x28, 0x80, 0x3C, 0xE0, 0x2B, 0x80, 0x48, 0x80, 0x0C, 0xF0, 0x1B, 0x80, 0x68, 0x90, 0x08, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*7266*/
const unsigned char  uc2_7267 [] = {0x08, 0x80, 0x28, 0x80, 0x28, 0xF0, 0x3D, 0x20, 0x29, 0x20, 0x4A, 0xA0, 0x0C, 0x40, 0x18, 0x40, 0x68, 0xA0, 0x08, 0xA0, 0x09, 0x10, 0x00, 0x00 }; /*7267*/
const unsigned char  uc2_7269 [] = {0x0A, 0x00, 0x2A, 0x00, 0x2B, 0xF0, 0x3D, 0x50, 0x29, 0x50, 0x49, 0x50, 0x0D, 0x50, 0x1A, 0x90, 0x68, 0x90, 0x09, 0x10, 0x0A, 0x60, 0x00, 0x00 }; /*7269*/
const unsigned char  uc2_726E [] = {0x0A, 0x80, 0x12, 0x60, 0x71, 0x80, 0x17, 0x10, 0x10, 0x90, 0x10, 0x60, 0x0A, 0x00, 0x0F, 0xC0, 0x12, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*726E*/
const unsigned char  uc2_726F [] = {0x08, 0x80, 0x28, 0x80, 0x28, 0x80, 0x3F, 0xF0, 0x28, 0x80, 0x48, 0x80, 0x0B, 0xE0, 0x1E, 0x20, 0x6A, 0x20, 0x0B, 0xE0, 0x0A, 0x20, 0x00, 0x00 }; /*726F*/
const unsigned char  uc2_7272 [] = {0x08, 0x40, 0x29, 0x40, 0x29, 0x40, 0x3D, 0xF0, 0x2A, 0x40, 0x48, 0x40, 0x08, 0xE0, 0x1C, 0x40, 0x68, 0x40, 0x08, 0x40, 0x09, 0xF0, 0x00, 0x00 }; /*7272*/
const unsigned char  uc2_7275 [] = {0x02, 0x00, 0x3F, 0xF0, 0x04, 0x80, 0x08, 0x40, 0x3F, 0xF0, 0x20, 0x10, 0x29, 0x10, 0x0F, 0xE0, 0x11, 0x00, 0x3F, 0xF0, 0x01, 0x00, 0x00, 0x00 }; /*7275*/
const unsigned char  uc2_7279 [] = {0x10, 0x80, 0x53, 0xE0, 0x78, 0x80, 0x57, 0xF0, 0x10, 0x00, 0x18, 0x40, 0x73, 0xE0, 0x12, 0x40, 0x11, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*7279*/
const unsigned char  uc2_727A [] = {0x10, 0x00, 0x57, 0xF0, 0x79, 0x40, 0x51, 0x40, 0x57, 0xF0, 0x15, 0x50, 0x1D, 0x30, 0x76, 0x10, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*727A*/
const unsigned char  uc2_727E [] = {0x08, 0x00, 0x2B, 0xE0, 0x3C, 0x80, 0x2B, 0xE0, 0x49, 0x20, 0x0B, 0xF0, 0x0C, 0x00, 0x1B, 0xE0, 0x6A, 0x20, 0x0B, 0xE0, 0x0A, 0x20, 0x00, 0x00 }; /*727E*/
const unsigned char  uc2_727F [] = {0x10, 0x80, 0x52, 0x80, 0x7B, 0xE0, 0x54, 0x80, 0x50, 0x80, 0x17, 0xF0, 0x18, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*727F*/
const unsigned char  uc2_7280 [] = {0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x29, 0x20, 0x25, 0x40, 0x29, 0x20, 0x2F, 0xE0, 0x31, 0x00, 0x2F, 0xF0, 0x41, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*7280*/
const unsigned char  uc2_7281 [] = {0x3E, 0x10, 0x08, 0x50, 0x7F, 0x50, 0x1A, 0x50, 0x69, 0x10, 0x0A, 0x60, 0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7281*/
const unsigned char  uc2_7284 [] = {0x10, 0x80, 0x57, 0xF0, 0x79, 0x40, 0x52, 0x20, 0x57, 0xF0, 0x10, 0x20, 0x1B, 0xA0, 0x72, 0xA0, 0x13, 0xA0, 0x12, 0xA0, 0x10, 0xC0, 0x00, 0x00 }; /*7284*/
const unsigned char  uc2_7287 [] = {0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x51, 0x40, 0x7D, 0xF0, 0x52, 0x40, 0x1D, 0xF0, 0x70, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*7287*/
const unsigned char  uc2_728A [] = {0x10, 0x80, 0x53, 0xE0, 0x78, 0x80, 0x57, 0xF0, 0x10, 0x10, 0x1A, 0xA0, 0x35, 0x80, 0x52, 0x80, 0x17, 0xF0, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*728A*/
const unsigned char  uc2_728B [] = {0x13, 0xE0, 0x52, 0x20, 0x7B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x1A, 0x20, 0x33, 0xE0, 0x52, 0x20, 0x17, 0xF0, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*728B*/
const unsigned char  uc2_728D [] = {0x10, 0x40, 0x56, 0xF0, 0x7A, 0x50, 0x54, 0xF0, 0x16, 0x50, 0x1A, 0xF0, 0x32, 0x40, 0x56, 0xF0, 0x12, 0x40, 0x15, 0x00, 0x18, 0xF0, 0x00, 0x00 }; /*728D*/
const unsigned char  uc2_728F [] = {0x10, 0x80, 0x57, 0xF0, 0x7C, 0x10, 0x57, 0xF0, 0x54, 0x00, 0x17, 0xF0, 0x1D, 0x50, 0x77, 0xF0, 0x15, 0x50, 0x15, 0x10, 0x18, 0x60, 0x00, 0x00 }; /*728F*/
const unsigned char  uc2_7292 [] = {0x10, 0x80, 0x57, 0xF0, 0x7A, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x17, 0xF0, 0x1C, 0x10, 0x75, 0xD0, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x60, 0x00, 0x00 }; /*7292*/
const unsigned char  uc2_729F [] = {0x79, 0xC0, 0x09, 0x40, 0x3B, 0xE0, 0x42, 0xA0, 0x7B, 0xE0, 0x0A, 0xA0, 0x3F, 0xD0, 0x12, 0x00, 0x7F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*729F*/
const unsigned char  uc2_72AC [] = {0x02, 0x00, 0x02, 0xC0, 0x02, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x60, 0x30, 0x00, 0x00 }; /*72AC*/
const unsigned char  uc2_72AF [] = {0x08, 0x00, 0x6B, 0xE0, 0x12, 0x20, 0x32, 0x20, 0x4A, 0x20, 0x0A, 0x20, 0x1A, 0xC0, 0x6A, 0x00, 0x0A, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*72AF*/
const unsigned char  uc2_72B0 [] = {0x09, 0x00, 0x69, 0x00, 0x17, 0xC0, 0x31, 0x40, 0x49, 0x40, 0x09, 0x40, 0x19, 0x40, 0x69, 0x40, 0x0A, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*72B0*/
const unsigned char  uc2_72B4 [] = {0x08, 0x00, 0x6B, 0xE0, 0x10, 0x80, 0x30, 0x80, 0x48, 0x80, 0x0F, 0xF0, 0x18, 0x80, 0x68, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*72B4*/
const unsigned char  uc2_72B6 [] = {0x10, 0x80, 0x10, 0xC0, 0x50, 0xA0, 0x37, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x31, 0x40, 0x51, 0x40, 0x12, 0x20, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*72B6*/
const unsigned char  uc2_72B7 [] = {0x09, 0x80, 0x68, 0x40, 0x13, 0xF0, 0x32, 0x00, 0x4A, 0x00, 0x0A, 0x00, 0x1A, 0x00, 0x6A, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x64, 0x00, 0x00, 0x00 }; /*72B7*/
const unsigned char  uc2_72B8 [] = {0x08, 0x00, 0x6B, 0xE0, 0x10, 0x20, 0x31, 0x20, 0x49, 0x20, 0x0A, 0x40, 0x1B, 0xF0, 0x68, 0x10, 0x0F, 0xD0, 0x10, 0x20, 0x61, 0xC0, 0x00, 0x00 }; /*72B8*/
const unsigned char  uc2_72B9 [] = {0x09, 0x00, 0x69, 0x40, 0x11, 0x20, 0x37, 0xF0, 0x49, 0x40, 0x09, 0x40, 0x19, 0x40, 0x69, 0x50, 0x0A, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*72B9*/
const unsigned char  uc2_72C1 [] = {0x09, 0x00, 0x69, 0x40, 0x12, 0x20, 0x37, 0xD0, 0x49, 0x50, 0x09, 0x40, 0x19, 0x40, 0x69, 0x50, 0x0A, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*72C1*/
const unsigned char  uc2_72C2 [] = {0x08, 0x00, 0x6F, 0xF0, 0x10, 0x80, 0x30, 0x80, 0x48, 0x80, 0x0B, 0xE0, 0x18, 0x80, 0x68, 0x80, 0x08, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*72C2*/
const unsigned char  uc2_72C3 [] = {0x08, 0x00, 0x6B, 0xF0, 0x10, 0x90, 0x30, 0x90, 0x48, 0x90, 0x0B, 0xE0, 0x19, 0x20, 0x69, 0x20, 0x09, 0x20, 0x11, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*72C3*/
const unsigned char  uc2_72C4 [] = {0x08, 0x80, 0x68, 0x80, 0x12, 0x90, 0x32, 0x90, 0x4A, 0xA0, 0x0C, 0x80, 0x19, 0x40, 0x69, 0x40, 0x09, 0x20, 0x12, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*72C4*/
const unsigned char  uc2_72C8 [] = {0x08, 0x00, 0x6B, 0xE0, 0x12, 0x20, 0x32, 0xA0, 0x4A, 0xA0, 0x0A, 0xA0, 0x1A, 0xA0, 0x68, 0x80, 0x08, 0xA0, 0x11, 0x10, 0x66, 0x10, 0x00, 0x00 }; /*72C8*/
const unsigned char  uc2_72CD [] = {0x0A, 0x00, 0x6B, 0xE0, 0x12, 0x20, 0x34, 0x20, 0x4B, 0xA0, 0x0A, 0xA0, 0x1B, 0xA0, 0x6A, 0x20, 0x0A, 0xC0, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*72CD*/
const unsigned char  uc2_72CE [] = {0x6B, 0xE0, 0x12, 0xA0, 0x32, 0xA0, 0x4B, 0xE0, 0x0A, 0xA0, 0x1A, 0xA0, 0x2B, 0xE0, 0x4A, 0xA0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*72CE*/
const unsigned char  uc2_72D0 [] = {0x08, 0x30, 0x6B, 0xE0, 0x12, 0xA0, 0x32, 0xA0, 0x4A, 0xA0, 0x0A, 0xA0, 0x1A, 0xA0, 0x6A, 0xA0, 0x0A, 0x90, 0x15, 0x50, 0x64, 0x90, 0x00, 0x00 }; /*72D0*/
const unsigned char  uc2_72D2 [] = {0x09, 0x40, 0x69, 0x40, 0x17, 0xF0, 0x31, 0x50, 0x4F, 0xF0, 0x09, 0x40, 0x1F, 0xF0, 0x69, 0x50, 0x0A, 0x60, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*72D2*/
const unsigned char  uc2_72D7 [] = {0x09, 0x00, 0x69, 0xF0, 0x11, 0x10, 0x36, 0x10, 0x49, 0xD0, 0x09, 0x50, 0x19, 0x50, 0x69, 0xD0, 0x09, 0x50, 0x10, 0x10, 0x60, 0x60, 0x00, 0x00 }; /*72D7*/
const unsigned char  uc2_72D9 [] = {0x08, 0x00, 0x6B, 0xE0, 0x12, 0x20, 0x32, 0x20, 0x4B, 0xE0, 0x0A, 0x20, 0x1A, 0x20, 0x6B, 0xE0, 0x0A, 0x20, 0x12, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*72D9*/
const unsigned char  uc2_72DE [] = {0x0B, 0x00, 0x68, 0x80, 0x17, 0xF0, 0x34, 0x10, 0x48, 0x00, 0x0F, 0xF0, 0x18, 0x80, 0x68, 0x80, 0x08, 0x80, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*72DE*/
const unsigned char  uc2_72E0 [] = {0x08, 0x00, 0x6B, 0xE0, 0x12, 0x20, 0x33, 0xE0, 0x4A, 0x20, 0x0B, 0xE0, 0x1A, 0x90, 0x6A, 0xA0, 0x0A, 0x40, 0x13, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*72E0*/
const unsigned char  uc2_72E1 [] = {0x0B, 0x00, 0x68, 0x80, 0x17, 0xF0, 0x31, 0x40, 0x49, 0x20, 0x0A, 0x20, 0x19, 0x40, 0x69, 0x40, 0x08, 0x80, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*72E1*/
const unsigned char  uc2_72E8 [] = {0x08, 0xC0, 0x68, 0xA0, 0x17, 0xF0, 0x32, 0x80, 0x4A, 0x90, 0x0F, 0x90, 0x1A, 0xA0, 0x6A, 0x40, 0x0C, 0xD0, 0x13, 0x50, 0x60, 0x20, 0x00, 0x00 }; /*72E8*/
const unsigned char  uc2_72E9 [] = {0x09, 0x80, 0x68, 0x40, 0x13, 0xF0, 0x32, 0x10, 0x48, 0x20, 0x0B, 0xF0, 0x19, 0x20, 0x68, 0xA0, 0x08, 0xA0, 0x10, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*72E9*/
const unsigned char  uc2_72EC [] = {0x08, 0x80, 0x68, 0x80, 0x10, 0x80, 0x33, 0xE0, 0x4A, 0xA0, 0x0A, 0xA0, 0x1A, 0xA0, 0x6B, 0xE0, 0x08, 0xA0, 0x10, 0xD0, 0x67, 0x10, 0x00, 0x00 }; /*72EC*/
const unsigned char  uc2_72ED [] = {0x48, 0x80, 0x28, 0x80, 0x13, 0xE0, 0x14, 0xA0, 0x6A, 0xA0, 0x0A, 0xC0, 0x1F, 0xF0, 0x68, 0x80, 0x09, 0x40, 0x11, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*72ED*/
const unsigned char  uc2_72EE [] = {0x13, 0xF0, 0x51, 0x40, 0x25, 0xF0, 0x25, 0x50, 0x55, 0x50, 0x15, 0x50, 0x35, 0x50, 0x51, 0x60, 0x12, 0x40, 0x12, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*72EE*/
const unsigned char  uc2_72EF [] = {0x10, 0x80, 0x51, 0x40, 0x26, 0x30, 0x20, 0x00, 0x53, 0xE0, 0x10, 0x00, 0x37, 0xF0, 0x50, 0x80, 0x11, 0x20, 0x13, 0xD0, 0x60, 0x10, 0x00, 0x00 }; /*72EF*/
const unsigned char  uc2_72F0 [] = {0x12, 0x00, 0x53, 0xC0, 0x24, 0x40, 0x27, 0xE0, 0x51, 0x20, 0x1F, 0xF0, 0x31, 0x20, 0x57, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x66, 0x00, 0x00, 0x00 }; /*72F0*/
const unsigned char  uc2_72F1 [] = {0x18, 0x80, 0x54, 0xC0, 0x24, 0xA0, 0x23, 0xF0, 0x5C, 0x80, 0x14, 0x80, 0x35, 0x40, 0x57, 0x40, 0x15, 0x20, 0x12, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*72F1*/
const unsigned char  uc2_72F2 [] = {0x10, 0x40, 0x5E, 0x40, 0x22, 0x40, 0x24, 0x40, 0x55, 0x60, 0x17, 0x50, 0x3D, 0x50, 0x56, 0x50, 0x14, 0x40, 0x14, 0x40, 0x69, 0x80, 0x00, 0x00 }; /*72F2*/
const unsigned char  uc2_72F3 [] = {0x10, 0x80, 0x51, 0x40, 0x26, 0x30, 0x20, 0x00, 0x53, 0xE0, 0x10, 0x80, 0x37, 0xF0, 0x50, 0x80, 0x12, 0xA0, 0x14, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*72F3*/
const unsigned char  uc2_72F4 [] = {0x14, 0x40, 0x54, 0x50, 0x27, 0x60, 0x24, 0x50, 0x57, 0x50, 0x14, 0x20, 0x30, 0x80, 0x53, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*72F4*/
const unsigned char  uc2_72F7 [] = {0x13, 0xE0, 0x52, 0x20, 0x23, 0xE0, 0x20, 0x00, 0x57, 0xF0, 0x14, 0x10, 0x37, 0xF0, 0x54, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*72F7*/
const unsigned char  uc2_72F8 [] = {0x68, 0x00, 0x13, 0xE0, 0x32, 0xA0, 0x4B, 0xE0, 0x0A, 0xA0, 0x1B, 0xE0, 0x28, 0x80, 0x4B, 0xE0, 0x08, 0x80, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*72F8*/
const unsigned char  uc2_72FA [] = {0x68, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x6B, 0xE0, 0x08, 0x00, 0x0B, 0xE0, 0x18, 0x00, 0x6B, 0xE0, 0x0A, 0x20, 0x0B, 0xE0, 0x32, 0x20, 0x00, 0x00 }; /*72FA*/
const unsigned char  uc2_72FB [] = {0x11, 0x00, 0x52, 0x40, 0x27, 0xA0, 0x20, 0x20, 0x52, 0x40, 0x15, 0x20, 0x31, 0xC0, 0x56, 0x40, 0x11, 0x40, 0x10, 0x80, 0x67, 0x70, 0x00, 0x00 }; /*72FB*/
const unsigned char  uc2_72FC [] = {0x69, 0x80, 0x10, 0x40, 0x33, 0xE0, 0x4A, 0x20, 0x0B, 0xE0, 0x1A, 0x20, 0x2B, 0xE0, 0x4A, 0x90, 0x0A, 0xA0, 0x13, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*72FC*/
const unsigned char  uc2_7301 [] = {0x11, 0x10, 0x56, 0x10, 0x22, 0x50, 0x2F, 0xD0, 0x52, 0x50, 0x17, 0x50, 0x3A, 0xD0, 0x52, 0x50, 0x12, 0x10, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*7301*/
const unsigned char  uc2_7303 [] = {0x10, 0x80, 0x51, 0x40, 0x26, 0x30, 0x20, 0x00, 0x53, 0xE0, 0x10, 0x00, 0x35, 0x20, 0x52, 0xA0, 0x10, 0x40, 0x17, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*7303*/
const unsigned char  uc2_730A [] = {0x10, 0x80, 0x53, 0x60, 0x22, 0x20, 0x23, 0x60, 0x52, 0x20, 0x13, 0xE0, 0x31, 0x40, 0x51, 0x40, 0x12, 0x50, 0x12, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*730A*/
const unsigned char  uc2_730E [] = {0x11, 0x40, 0x53, 0xE0, 0x21, 0x40, 0x27, 0xF0, 0x50, 0x00, 0x13, 0xE0, 0x32, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*730E*/
const unsigned char  uc2_7313 [] = {0x13, 0xE0, 0x52, 0xA0, 0x23, 0xE0, 0x22, 0xA0, 0x53, 0xE0, 0x10, 0x80, 0x37, 0xF0, 0x51, 0xC0, 0x12, 0xA0, 0x14, 0x90, 0x60, 0x80, 0x00, 0x00 }; /*7313*/
const unsigned char  uc2_7315 [] = {0x16, 0x80, 0x52, 0xF0, 0x23, 0x10, 0x26, 0x40, 0x54, 0x40, 0x14, 0xE0, 0x37, 0x50, 0x52, 0x50, 0x12, 0x40, 0x12, 0x40, 0x6D, 0x80, 0x00, 0x00 }; /*7315*/
const unsigned char  uc2_7316 [] = {0x13, 0xE0, 0x52, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x53, 0xE0, 0x10, 0x00, 0x37, 0xF0, 0x54, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x67, 0xF0, 0x00, 0x00 }; /*7316*/
const unsigned char  uc2_7317 [] = {0x10, 0x80, 0x57, 0xF0, 0x21, 0x40, 0x22, 0x20, 0x57, 0xF0, 0x10, 0x20, 0x33, 0xA0, 0x52, 0xA0, 0x13, 0xA0, 0x12, 0xA0, 0x60, 0x40, 0x00, 0x00 }; /*7317*/
const unsigned char  uc2_731B [] = {0x13, 0xC0, 0x50, 0x40, 0x20, 0x80, 0x27, 0xF0, 0x50, 0x80, 0x13, 0x80, 0x30, 0x00, 0x57, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x6F, 0xF0, 0x00, 0x00 }; /*731B*/
const unsigned char  uc2_731C [] = {0x10, 0x80, 0x57, 0xF0, 0x20, 0x80, 0x23, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x32, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xA0, 0x62, 0x60, 0x00, 0x00 }; /*731C*/
const unsigned char  uc2_731D [] = {0x10, 0x80, 0x57, 0xF0, 0x20, 0x00, 0x22, 0x20, 0x52, 0x20, 0x15, 0x50, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*731D*/
const unsigned char  uc2_731E [] = {0x10, 0x80, 0x51, 0x40, 0x26, 0x30, 0x23, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x30, 0x80, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*731E*/
const unsigned char  uc2_7321 [] = {0x10, 0x00, 0x57, 0xF0, 0x25, 0x50, 0x27, 0xF0, 0x51, 0x00, 0x11, 0xE0, 0x31, 0x20, 0x56, 0xC0, 0x10, 0x40, 0x11, 0x80, 0x6E, 0x00, 0x00, 0x00 }; /*7321*/
const unsigned char  uc2_7322 [] = {0x12, 0x00, 0x52, 0x70, 0x2F, 0xD0, 0x22, 0x50, 0x52, 0x70, 0x17, 0x50, 0x35, 0x70, 0x55, 0x50, 0x17, 0x50, 0x14, 0x50, 0x60, 0xA0, 0x00, 0x00 }; /*7322*/
const unsigned char  uc2_7325 [] = {0x10, 0x00, 0x53, 0xE0, 0x22, 0xA0, 0x23, 0xE0, 0x52, 0xA0, 0x17, 0xF0, 0x32, 0x80, 0x52, 0xA0, 0x12, 0x40, 0x13, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*7325*/
const unsigned char  uc2_7329 [] = {0x13, 0xE0, 0x52, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x53, 0xE0, 0x12, 0x80, 0x33, 0xE0, 0x54, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*7329*/
const unsigned char  uc2_732A [] = {0x11, 0x20, 0x57, 0xA0, 0x21, 0x40, 0x2F, 0xF0, 0x51, 0x00, 0x13, 0xC0, 0x36, 0x40, 0x5B, 0xC0, 0x12, 0x40, 0x13, 0xC0, 0x62, 0x40, 0x00, 0x00 }; /*732A*/
const unsigned char  uc2_732B [] = {0x11, 0x40, 0x51, 0x40, 0x27, 0xF0, 0x21, 0x40, 0x50, 0x00, 0x13, 0xE0, 0x32, 0xA0, 0x53, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*732B*/
const unsigned char  uc2_732C [] = {0x17, 0xF0, 0x54, 0x90, 0x27, 0xF0, 0x24, 0x90, 0x57, 0xF0, 0x12, 0x20, 0x33, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x62, 0xC0, 0x00, 0x00 }; /*732C*/
const unsigned char  uc2_732E [] = {0x08, 0x60, 0x7F, 0x50, 0x10, 0xF0, 0x3E, 0x40, 0x36, 0x40, 0x2A, 0x40, 0x3E, 0xA0, 0x2A, 0xA0, 0x3E, 0xA0, 0x2A, 0xA0, 0x25, 0x10, 0x00, 0x00 }; /*732E*/
const unsigned char  uc2_7331 [] = {0x13, 0xC0, 0x51, 0x40, 0x27, 0xE0, 0x22, 0xA0, 0x55, 0x00, 0x10, 0x80, 0x37, 0xF0, 0x52, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x60, 0x80, 0x00, 0x00 }; /*7331*/
const unsigned char  uc2_7334 [] = {0x12, 0xE0, 0x52, 0x20, 0x25, 0xF0, 0x2C, 0x80, 0x54, 0xE0, 0x15, 0x40, 0x35, 0xF0, 0x54, 0x40, 0x14, 0xA0, 0x14, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*7334*/
const unsigned char  uc2_7337 [] = {0x24, 0x60, 0x7E, 0x50, 0x25, 0xF0, 0x7E, 0x40, 0x5A, 0x40, 0x66, 0xA0, 0x42, 0xA0, 0x7E, 0xA0, 0x42, 0xA0, 0x7E, 0xA0, 0x41, 0x10, 0x00, 0x00 }; /*7337*/
const unsigned char  uc2_7338 [] = {0x17, 0xF0, 0x54, 0x90, 0x27, 0xF0, 0x24, 0x00, 0x55, 0xF0, 0x15, 0x10, 0x35, 0xF0, 0x55, 0x10, 0x15, 0xF0, 0x15, 0x10, 0x69, 0xF0, 0x00, 0x00 }; /*7338*/
const unsigned char  uc2_7339 [] = {0x10, 0x80, 0x57, 0xF0, 0x22, 0xA0, 0x24, 0x90, 0x53, 0xE0, 0x12, 0x20, 0x33, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*7339*/
const unsigned char  uc2_733E [] = {0x13, 0xE0, 0x52, 0x20, 0x23, 0xA0, 0x22, 0xA0, 0x57, 0xF0, 0x14, 0x10, 0x33, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x62, 0xE0, 0x00, 0x00 }; /*733E*/
const unsigned char  uc2_733F [] = {0x10, 0x80, 0x53, 0xE0, 0x20, 0x80, 0x27, 0xF0, 0x50, 0x00, 0x13, 0xE0, 0x32, 0x20, 0x53, 0xE0, 0x11, 0x50, 0x16, 0x60, 0x63, 0x30, 0x00, 0x00 }; /*733F*/
const unsigned char  uc2_734D [] = {0x10, 0x80, 0x53, 0xE0, 0x21, 0x40, 0x27, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x32, 0x20, 0x53, 0xE0, 0x11, 0x50, 0x11, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*734D*/
const unsigned char  uc2_7350 [] = {0x10, 0x80, 0x53, 0xE0, 0x21, 0x40, 0x27, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x32, 0x20, 0x53, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*7350*/
const unsigned char  uc2_7352 [] = {0x08, 0x80, 0x7E, 0xF0, 0x09, 0xA0, 0x7E, 0xA0, 0x14, 0x40, 0x24, 0xA0, 0x49, 0x10, 0x02, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*7352*/
const unsigned char  uc2_7357 [] = {0x17, 0xF0, 0x56, 0xC0, 0x25, 0x40, 0x27, 0xF0, 0x55, 0x10, 0x15, 0x60, 0x37, 0xA0, 0x55, 0x20, 0x15, 0x20, 0x15, 0x50, 0x6A, 0x90, 0x00, 0x00 }; /*7357*/
const unsigned char  uc2_7360 [] = {0x10, 0x80, 0x57, 0xF0, 0x25, 0x50, 0x22, 0x20, 0x57, 0xF0, 0x12, 0x20, 0x33, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0xA0, 0x65, 0x90, 0x00, 0x00 }; /*7360*/
const unsigned char  uc2_736C [] = {0x48, 0xF0, 0x2E, 0x50, 0x32, 0x50, 0x5F, 0xA0, 0x15, 0x20, 0x1F, 0x70, 0x35, 0xA0, 0x5F, 0x20, 0x15, 0xF0, 0x15, 0x20, 0x62, 0x20, 0x00, 0x00 }; /*736C*/
const unsigned char  uc2_736D [] = {0x14, 0x80, 0x5F, 0xE0, 0x25, 0x20, 0x3F, 0xF0, 0x55, 0x10, 0x15, 0x50, 0x3F, 0x50, 0x55, 0x50, 0x1E, 0xA0, 0x14, 0x90, 0x65, 0x10, 0x00, 0x00 }; /*736D*/
const unsigned char  uc2_736F [] = {0x13, 0xE0, 0x50, 0x80, 0x27, 0xF0, 0x23, 0x60, 0x52, 0xA0, 0x13, 0xE0, 0x30, 0x80, 0x53, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x65, 0x50, 0x00, 0x00 }; /*736F*/
const unsigned char  uc2_737E [] = {0x12, 0x20, 0x5F, 0xF0, 0x25, 0x50, 0x22, 0xA0, 0x57, 0xF0, 0x1C, 0x80, 0x37, 0xE0, 0x54, 0x80, 0x17, 0xE0, 0x14, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*737E*/
const unsigned char  uc2_7384 [] = {0x04, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x08, 0x80, 0x1F, 0x00, 0x02, 0x00, 0x0C, 0x40, 0x10, 0xC0, 0x3F, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*7384*/
const unsigned char  uc2_7387 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x65, 0x10, 0x16, 0x60, 0x02, 0x00, 0x15, 0x60, 0x67, 0x10, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7387*/
const unsigned char  uc2_7389 [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0xC0, 0x02, 0x20, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*7389*/
const unsigned char  uc2_738B [] = {0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*738B*/
const unsigned char  uc2_738E [] = {0x00, 0x00, 0x03, 0xF0, 0x7C, 0x40, 0x10, 0x40, 0x10, 0x40, 0x38, 0x40, 0x10, 0x40, 0x10, 0x40, 0x1C, 0x40, 0x60, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*738E*/
const unsigned char  uc2_7391 [] = {0x00, 0x00, 0x01, 0xC0, 0x7D, 0x40, 0x11, 0x40, 0x11, 0x40, 0x39, 0x40, 0x11, 0x40, 0x11, 0x40, 0x1D, 0x50, 0x62, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*7391*/
const unsigned char  uc2_7396 [] = {0x01, 0x00, 0x01, 0x00, 0x7D, 0xC0, 0x11, 0x40, 0x11, 0x40, 0x3A, 0x40, 0x10, 0x80, 0x10, 0x80, 0x1D, 0x40, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*7396*/
const unsigned char  uc2_739B [] = {0x03, 0xE0, 0x7C, 0x20, 0x11, 0x20, 0x11, 0x20, 0x3A, 0x40, 0x13, 0xF0, 0x10, 0x10, 0x1C, 0x10, 0x63, 0xD0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*739B*/
const unsigned char  uc2_739F [] = {0x01, 0x00, 0x00, 0x80, 0x7F, 0xF0, 0x12, 0x20, 0x12, 0x20, 0x39, 0x40, 0x11, 0x40, 0x10, 0x80, 0x1D, 0x40, 0x62, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*739F*/
const unsigned char  uc2_73A2 [] = {0x00, 0x40, 0x01, 0x40, 0x7D, 0x20, 0x12, 0x10, 0x10, 0x00, 0x39, 0xE0, 0x10, 0xA0, 0x10, 0xA0, 0x1C, 0xA0, 0x61, 0x20, 0x06, 0xC0, 0x00, 0x00 }; /*73A2*/
const unsigned char  uc2_73A9 [] = {0x00, 0x00, 0x7D, 0xE0, 0x10, 0x00, 0x10, 0x00, 0x3B, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x1D, 0x40, 0x62, 0x50, 0x02, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*73A9*/
const unsigned char  uc2_73AB [] = {0x00, 0x80, 0x00, 0x80, 0x7C, 0xF0, 0x11, 0xA0, 0x12, 0xA0, 0x38, 0xA0, 0x10, 0x40, 0x10, 0x40, 0x1C, 0xA0, 0x60, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*73AB*/
const unsigned char  uc2_73AE [] = {0x00, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x17, 0xF0, 0x10, 0x90, 0x1C, 0x90, 0x60, 0xE0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*73AE*/
const unsigned char  uc2_73AF [] = {0x00, 0x00, 0x03, 0xF0, 0x7C, 0x40, 0x10, 0x40, 0x10, 0x80, 0x39, 0xA0, 0x16, 0x90, 0x10, 0x90, 0x1C, 0x80, 0x60, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*73AF*/
const unsigned char  uc2_73B0 [] = {0x00, 0x00, 0x03, 0xE0, 0x7E, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x3A, 0xA0, 0x12, 0xA0, 0x11, 0x40, 0x1D, 0x50, 0x62, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*73B0*/
const unsigned char  uc2_73B1 [] = {0x00, 0x80, 0x00, 0x80, 0x7D, 0x40, 0x12, 0x30, 0x11, 0xC0, 0x39, 0x40, 0x11, 0x40, 0x11, 0x80, 0x1D, 0x20, 0x61, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*73B1*/
const unsigned char  uc2_73B2 [] = {0x00, 0x80, 0x00, 0x80, 0x7D, 0x40, 0x12, 0x30, 0x10, 0x80, 0x38, 0x40, 0x13, 0xE0, 0x10, 0x20, 0x1D, 0x40, 0x60, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*73B2*/
const unsigned char  uc2_73B3 [] = {0x01, 0x40, 0x7D, 0x60, 0x12, 0x50, 0x16, 0x70, 0x3B, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x1E, 0x50, 0x62, 0x50, 0x02, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*73B3*/
const unsigned char  uc2_73B7 [] = {0x00, 0x80, 0x00, 0x80, 0x7C, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x3B, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x1E, 0x20, 0x63, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*73B7*/
const unsigned char  uc2_73BA [] = {0x10, 0x00, 0x1F, 0xE0, 0x62, 0x20, 0x0A, 0xC0, 0x32, 0x20, 0x04, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*73BA*/
const unsigned char  uc2_73BB [] = {0x00, 0x40, 0x03, 0xF0, 0x7E, 0x50, 0x12, 0x40, 0x13, 0xE0, 0x3A, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1E, 0x40, 0x62, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*73BB*/
const unsigned char  uc2_73C0 [] = {0x00, 0x40, 0x00, 0x40, 0x7C, 0x80, 0x11, 0xF0, 0x11, 0x10, 0x39, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x1D, 0x10, 0x61, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*73C0*/
const unsigned char  uc2_73C2 [] = {0x00, 0x00, 0x03, 0xF0, 0x7C, 0x20, 0x13, 0xA0, 0x12, 0xA0, 0x3A, 0xA0, 0x13, 0xA0, 0x12, 0xA0, 0x1C, 0x20, 0x60, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*73C2*/
const unsigned char  uc2_73C8 [] = {0x04, 0x00, 0x04, 0x70, 0x7F, 0x50, 0x25, 0x50, 0x25, 0x50, 0x75, 0x50, 0x25, 0x50, 0x25, 0x50, 0x35, 0x50, 0x45, 0x70, 0x0A, 0x50, 0x00, 0x00 }; /*73C8*/
const unsigned char  uc2_73C9 [] = {0x00, 0x00, 0x03, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x12, 0x40, 0x3B, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x1E, 0xD0, 0x63, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*73C9*/
const unsigned char  uc2_73CA [] = {0x00, 0x00, 0x0E, 0xE0, 0x7A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x7F, 0xF0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x4A, 0xA0, 0x15, 0x40, 0x00, 0x00 }; /*73CA*/
const unsigned char  uc2_73CD [] = {0x00, 0x80, 0x00, 0x80, 0x79, 0x40, 0x16, 0x30, 0x10, 0xC0, 0x3B, 0x20, 0x10, 0xC0, 0x13, 0x10, 0x18, 0x20, 0x60, 0xC0, 0x07, 0x00, 0x00, 0x00 }; /*73CD*/
const unsigned char  uc2_73CF [] = {0x00, 0x00, 0x01, 0xF0, 0x7C, 0x40, 0x10, 0x40, 0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x10, 0x60, 0x1C, 0x50, 0x61, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*73CF*/
const unsigned char  uc2_73D0 [] = {0x00, 0x80, 0x7C, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x38, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x1D, 0x40, 0x62, 0x20, 0x03, 0xD0, 0x00, 0x10, 0x00, 0x00 }; /*73D0*/
const unsigned char  uc2_73D1 [] = {0x01, 0x40, 0x01, 0x20, 0x7F, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x39, 0x50, 0x11, 0x50, 0x11, 0x60, 0x1D, 0x50, 0x62, 0xD0, 0x05, 0x20, 0x00, 0x00 }; /*73D1*/
const unsigned char  uc2_73D9 [] = {0x01, 0x40, 0x01, 0x40, 0x7B, 0xE0, 0x11, 0x40, 0x11, 0x40, 0x39, 0x40, 0x17, 0xF0, 0x10, 0x00, 0x1D, 0x40, 0x61, 0x20, 0x02, 0x20, 0x00, 0x00 }; /*73D9*/
const unsigned char  uc2_73DE [] = {0x01, 0x00, 0x79, 0xE0, 0x16, 0x20, 0x11, 0x40, 0x38, 0x80, 0x17, 0x70, 0x10, 0x00, 0x1B, 0xE0, 0x62, 0x20, 0x03, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*73DE*/
const unsigned char  uc2_73E0 [] = {0x00, 0x80, 0x02, 0x80, 0x73, 0xE0, 0x24, 0x80, 0x20, 0x80, 0x77, 0xF0, 0x21, 0xC0, 0x22, 0xA0, 0x32, 0xA0, 0x44, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*73E0*/
const unsigned char  uc2_73E5 [] = {0x00, 0x00, 0x03, 0xF0, 0x7D, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x39, 0xE0, 0x11, 0x20, 0x11, 0xF0, 0x1E, 0x20, 0x60, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*73E5*/
const unsigned char  uc2_73E7 [] = {0x01, 0x40, 0x79, 0x40, 0x15, 0x50, 0x13, 0x60, 0x39, 0x40, 0x13, 0x60, 0x15, 0x50, 0x19, 0x40, 0x62, 0x50, 0x02, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*73E7*/
const unsigned char  uc2_73E9 [] = {0x02, 0x00, 0x02, 0x60, 0x7D, 0x00, 0x11, 0x00, 0x16, 0xF0, 0x3A, 0x20, 0x12, 0x20, 0x12, 0x20, 0x1E, 0x20, 0x62, 0x20, 0x02, 0xC0, 0x00, 0x00 }; /*73E9*/
const unsigned char  uc2_73ED [] = {0x01, 0x00, 0x71, 0xF0, 0x21, 0x40, 0x25, 0x40, 0x25, 0x40, 0x75, 0xE0, 0x29, 0x40, 0x21, 0x40, 0x22, 0x40, 0x32, 0x40, 0x45, 0xF0, 0x00, 0x00 }; /*73ED*/
const unsigned char  uc2_73F2 [] = {0x03, 0xF0, 0x7A, 0x10, 0x10, 0x80, 0x13, 0xE0, 0x39, 0x00, 0x12, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x67, 0xF0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*73F2*/
const unsigned char  uc2_7403 [] = {0x00, 0xC0, 0x78, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x38, 0x80, 0x12, 0xB0, 0x11, 0xC0, 0x1E, 0xA0, 0x62, 0xA0, 0x04, 0x90, 0x03, 0x00, 0x00, 0x00 }; /*7403*/
const unsigned char  uc2_7405 [] = {0x00, 0x80, 0x7F, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x13, 0xE0, 0x12, 0x50, 0x1E, 0x60, 0x62, 0x40, 0x02, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*7405*/
const unsigned char  uc2_7406 [] = {0x00, 0x00, 0x03, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x3B, 0xE0, 0x10, 0x80, 0x13, 0xE0, 0x1C, 0x80, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*7406*/
const unsigned char  uc2_7409 [] = {0x01, 0x00, 0x0F, 0xE0, 0x72, 0x00, 0x24, 0x40, 0x27, 0xA0, 0x70, 0x20, 0x25, 0x40, 0x25, 0x40, 0x35, 0x50, 0x45, 0x50, 0x09, 0x20, 0x00, 0x00 }; /*7409*/
const unsigned char  uc2_740A [] = {0x00, 0x00, 0x07, 0xF0, 0x79, 0x50, 0x15, 0x50, 0x15, 0x60, 0x3F, 0xD0, 0x13, 0x50, 0x15, 0x50, 0x1D, 0x60, 0x65, 0x40, 0x0A, 0x40, 0x00, 0x00 }; /*740A*/
const unsigned char  uc2_740F [] = {0x04, 0x40, 0x02, 0xF0, 0x78, 0x40, 0x16, 0xA0, 0x12, 0xA0, 0x3A, 0xF0, 0x12, 0x20, 0x12, 0xF0, 0x1A, 0x20, 0x65, 0xA0, 0x08, 0x70, 0x00, 0x00 }; /*740F*/
const unsigned char  uc2_7410 [] = {0x00, 0x40, 0x01, 0x50, 0x7C, 0xA0, 0x11, 0xF0, 0x11, 0x10, 0x39, 0x50, 0x11, 0x50, 0x11, 0x50, 0x1C, 0xA0, 0x61, 0x10, 0x06, 0x10, 0x00, 0x00 }; /*7410*/
const unsigned char  uc2_741A [] = {0x00, 0x00, 0x7F, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x3A, 0x40, 0x13, 0xF0, 0x12, 0x40, 0x1E, 0xE0, 0x62, 0xA0, 0x04, 0xE0, 0x04, 0xA0, 0x00, 0x00 }; /*741A*/
const unsigned char  uc2_741B [] = {0x07, 0xF0, 0x74, 0x10, 0x21, 0x60, 0x26, 0x10, 0x70, 0x80, 0x27, 0xF0, 0x21, 0xC0, 0x32, 0xA0, 0x42, 0xA0, 0x04, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*741B*/
const unsigned char  uc2_7422 [] = {0x03, 0xF0, 0x78, 0x80, 0x10, 0x90, 0x13, 0x50, 0x3A, 0xE0, 0x11, 0x40, 0x17, 0x60, 0x18, 0xD0, 0x67, 0x50, 0x00, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*7422*/
const unsigned char  uc2_7425 [] = {0x01, 0x60, 0x79, 0x80, 0x17, 0xF0, 0x15, 0x10, 0x3D, 0xC0, 0x17, 0x20, 0x14, 0xC0, 0x1C, 0x00, 0x65, 0xD0, 0x05, 0x50, 0x0A, 0x20, 0x00, 0x00 }; /*7425*/
const unsigned char  uc2_7426 [] = {0x00, 0x80, 0x7F, 0xF0, 0x11, 0x40, 0x12, 0x20, 0x3F, 0xF0, 0x10, 0x20, 0x13, 0xA0, 0x1E, 0xA0, 0x63, 0xA0, 0x02, 0xA0, 0x00, 0x40, 0x00, 0x00 }; /*7426*/
const unsigned char  uc2_7428 [] = {0x03, 0xE0, 0x02, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x38, 0x00, 0x12, 0x50, 0x13, 0xE0, 0x1A, 0x50, 0x62, 0xD0, 0x03, 0x20, 0x00, 0x00 }; /*7428*/
const unsigned char  uc2_742A [] = {0x02, 0x40, 0x7F, 0xE0, 0x12, 0x40, 0x13, 0xC0, 0x3A, 0x40, 0x13, 0xC0, 0x12, 0x40, 0x1F, 0xF0, 0x62, 0x40, 0x02, 0x20, 0x04, 0x20, 0x00, 0x00 }; /*742A*/
const unsigned char  uc2_742C [] = {0x00, 0x80, 0x07, 0xF0, 0x7C, 0x10, 0x12, 0x00, 0x13, 0x70, 0x3D, 0x50, 0x15, 0x50, 0x17, 0x60, 0x19, 0x50, 0x62, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*742C*/
const unsigned char  uc2_742E [] = {0x00, 0x80, 0x07, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x10, 0x00, 0x3F, 0xF0, 0x10, 0x80, 0x12, 0xA0, 0x1A, 0x90, 0x64, 0x90, 0x03, 0x00, 0x00, 0x00 }; /*742E*/
const unsigned char  uc2_7430 [] = {0x00, 0x40, 0x01, 0x50, 0x7D, 0x50, 0x10, 0xA0, 0x13, 0x10, 0x38, 0x40, 0x11, 0x50, 0x11, 0x50, 0x1C, 0xA0, 0x60, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*7430*/
const unsigned char  uc2_7433 [] = {0x02, 0x40, 0x72, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x77, 0x60, 0x26, 0xE0, 0x2B, 0x50, 0x32, 0x40, 0x42, 0x40, 0x02, 0x40, 0x02, 0x40, 0x00, 0x00 }; /*7433*/
const unsigned char  uc2_7434 [] = {0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x7D, 0xF0, 0x02, 0x00, 0x0D, 0x80, 0x72, 0x70, 0x0F, 0x80, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*7434*/
const unsigned char  uc2_7435 [] = {0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x7D, 0xF0, 0x00, 0x00, 0x21, 0x20, 0x3D, 0xC0, 0x21, 0x10, 0x2D, 0x10, 0x30, 0xE0, 0x00, 0x00 }; /*7435*/
const unsigned char  uc2_7436 [] = {0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x7D, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*7436*/
const unsigned char  uc2_743C [] = {0x00, 0x80, 0x7F, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x3A, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x1A, 0xA0, 0x62, 0x90, 0x04, 0x90, 0x03, 0x00, 0x00, 0x00 }; /*743C*/
const unsigned char  uc2_7441 [] = {0x07, 0xF0, 0x04, 0x10, 0x75, 0xD0, 0x24, 0x10, 0x25, 0xD0, 0x70, 0x00, 0x23, 0xE0, 0x22, 0x20, 0x33, 0xE0, 0x42, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*7441*/
const unsigned char  uc2_7455 [] = {0x07, 0x70, 0x7D, 0x10, 0x15, 0x10, 0x17, 0x70, 0x3C, 0x00, 0x17, 0xF0, 0x14, 0x50, 0x1F, 0x50, 0x64, 0x20, 0x04, 0x50, 0x05, 0x90, 0x00, 0x00 }; /*7455*/
const unsigned char  uc2_7457 [] = {0x00, 0x70, 0x07, 0x90, 0x7A, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x3F, 0xF0, 0x11, 0x00, 0x11, 0xE0, 0x1A, 0xA0, 0x62, 0x40, 0x05, 0xB0, 0x00, 0x00 }; /*7457*/
const unsigned char  uc2_7459 [] = {0x02, 0xA0, 0x7D, 0x40, 0x15, 0x40, 0x12, 0xA0, 0x39, 0x00, 0x17, 0xF0, 0x15, 0x50, 0x1C, 0x90, 0x65, 0x50, 0x07, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*7459*/
const unsigned char  uc2_745A [] = {0x02, 0x00, 0x02, 0x70, 0x7F, 0xD0, 0x22, 0x50, 0x22, 0x70, 0x77, 0x50, 0x25, 0x70, 0x25, 0x50, 0x37, 0x50, 0x44, 0x90, 0x00, 0xA0, 0x00, 0x00 }; /*745A*/
const unsigned char  uc2_745B [] = {0x01, 0x40, 0x07, 0xF0, 0x79, 0x40, 0x10, 0x80, 0x13, 0xE0, 0x3A, 0xA0, 0x12, 0xA0, 0x17, 0xF0, 0x18, 0x80, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*745B*/
const unsigned char  uc2_745C [] = {0x00, 0x80, 0x79, 0x40, 0x16, 0x30, 0x11, 0xC0, 0x3E, 0x10, 0x15, 0x50, 0x17, 0x50, 0x1D, 0x50, 0x67, 0x50, 0x05, 0x10, 0x06, 0x60, 0x00, 0x00 }; /*745C*/
const unsigned char  uc2_745E [] = {0x00, 0x80, 0x04, 0x90, 0x7F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x38, 0x80, 0x17, 0xF0, 0x15, 0x50, 0x1D, 0x50, 0x65, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*745E*/
const unsigned char  uc2_745F [] = {0x7D, 0xF0, 0x10, 0x40, 0x38, 0xE0, 0x10, 0x40, 0x7D, 0xF0, 0x04, 0x00, 0x22, 0x40, 0x28, 0xA0, 0x4B, 0x50, 0x0C, 0x50, 0x77, 0x80, 0x00, 0x00 }; /*745F*/
const unsigned char  uc2_746D [] = {0x00, 0x80, 0x07, 0xF0, 0x7C, 0xA0, 0x17, 0xF0, 0x14, 0xA0, 0x3D, 0xE0, 0x14, 0x80, 0x15, 0xE0, 0x1D, 0x20, 0x65, 0xE0, 0x09, 0x20, 0x00, 0x00 }; /*746D*/
const unsigned char  uc2_7470 [] = {0x01, 0x00, 0x02, 0x00, 0x7F, 0xC0, 0x15, 0x40, 0x17, 0xC0, 0x3D, 0x40, 0x17, 0xC0, 0x11, 0xA0, 0x1A, 0xD0, 0x62, 0x90, 0x0C, 0x60, 0x00, 0x00 }; /*7470*/
const unsigned char  uc2_7476 [] = {0x00, 0x60, 0x07, 0xA0, 0x7D, 0x40, 0x12, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x1E, 0xA0, 0x63, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*7476*/
const unsigned char  uc2_7477 [] = {0x00, 0x30, 0x07, 0xD0, 0x7A, 0xA0, 0x17, 0xF0, 0x15, 0x10, 0x3B, 0xE0, 0x11, 0x00, 0x11, 0xE0, 0x1A, 0xA0, 0x64, 0x40, 0x03, 0xB0, 0x00, 0x00 }; /*7477*/
const unsigned char  uc2_747E [] = {0x01, 0x40, 0x7F, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x38, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x1B, 0xE0, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*747E*/
const unsigned char  uc2_7480 [] = {0x02, 0xA0, 0x03, 0xE0, 0x79, 0x40, 0x11, 0xF0, 0x16, 0x40, 0x3B, 0xF0, 0x12, 0x40, 0x13, 0xF0, 0x1A, 0x40, 0x63, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7480*/
const unsigned char  uc2_7481 [] = {0x01, 0x00, 0x7F, 0xF0, 0x15, 0x10, 0x15, 0xD0, 0x3F, 0x50, 0x14, 0x90, 0x15, 0x50, 0x1F, 0xF0, 0x66, 0x80, 0x0A, 0x50, 0x01, 0xD0, 0x00, 0x00 }; /*7481*/
const unsigned char  uc2_7483 [] = {0x00, 0x80, 0x07, 0xF0, 0x79, 0x40, 0x12, 0xA0, 0x13, 0x60, 0x3A, 0x20, 0x17, 0xF0, 0x14, 0x90, 0x1D, 0x50, 0x65, 0xD0, 0x04, 0x20, 0x00, 0x00 }; /*7483*/
const unsigned char  uc2_7487 [] = {0x04, 0x40, 0x7F, 0x70, 0x28, 0x80, 0x28, 0xF0, 0x7E, 0x10, 0x2A, 0xA0, 0x2A, 0xB0, 0x2A, 0xA0, 0x3A, 0xA0, 0x4A, 0xE0, 0x15, 0x10, 0x00, 0x00 }; /*7487*/
const unsigned char  uc2_748B [] = {0x00, 0x80, 0x03, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x12, 0x20, 0x3B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x18, 0x80, 0x67, 0xF0, 0x00, 0x80, 0x00, 0x00 }; /*748B*/
const unsigned char  uc2_748E [] = {0x1F, 0xF0, 0x71, 0x10, 0x35, 0x50, 0x25, 0x50, 0x74, 0x40, 0x2A, 0xA0, 0x2F, 0xF0, 0x22, 0x40, 0x36, 0x40, 0x41, 0xC0, 0x06, 0x30, 0x00, 0x00 }; /*748E*/
const unsigned char  uc2_7490 [] = {0x00, 0x40, 0x07, 0x70, 0x75, 0xD0, 0x25, 0x50, 0x27, 0x20, 0x72, 0x50, 0x2B, 0x00, 0x2A, 0x70, 0x3A, 0x50, 0x4B, 0xF0, 0x1C, 0x50, 0x00, 0x00 }; /*7490*/
const unsigned char  uc2_749C [] = {0x01, 0x40, 0x03, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x10, 0x80, 0x3B, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x1A, 0xA0, 0x63, 0xE0, 0x04, 0x10, 0x00, 0x00 }; /*749C*/
const unsigned char  uc2_749E [] = {0x05, 0x50, 0x03, 0x60, 0x7F, 0xF0, 0x12, 0x20, 0x17, 0xF0, 0x38, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x1F, 0xF0, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*749E*/
const unsigned char  uc2_74A7 [] = {0x3C, 0x40, 0x25, 0xF0, 0x3C, 0xA0, 0x21, 0xF0, 0x5C, 0xA0, 0x54, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*74A7*/
const unsigned char  uc2_74A8 [] = {0x03, 0x00, 0x02, 0xF0, 0x77, 0x50, 0x2D, 0x20, 0x22, 0x50, 0x7C, 0x90, 0x22, 0xA0, 0x27, 0xF0, 0x32, 0xA0, 0x44, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*74A8*/
const unsigned char  uc2_74A9 [] = {0x01, 0xC0, 0x01, 0x00, 0x7F, 0xF0, 0x29, 0x10, 0x2F, 0xC0, 0x79, 0x20, 0x2F, 0xF0, 0x29, 0x90, 0x3A, 0xE0, 0x49, 0x50, 0x16, 0xD0, 0x00, 0x00 }; /*74A9*/
const unsigned char  uc2_74BA [] = {0x1F, 0xE0, 0x28, 0xA0, 0x3F, 0xE0, 0x28, 0xA0, 0x3A, 0xE0, 0x28, 0xA0, 0x7F, 0xF0, 0x42, 0x10, 0x3F, 0xE0, 0x02, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*74BA*/
const unsigned char  uc2_74D2 [] = {0x06, 0xA0, 0x77, 0xF0, 0x2A, 0xA0, 0x2F, 0xF0, 0x72, 0x20, 0x2D, 0x50, 0x23, 0xE0, 0x22, 0xA0, 0x32, 0xA0, 0x41, 0x40, 0x06, 0x20, 0x00, 0x00 }; /*74D2*/
const unsigned char  uc2_74DC [] = {0x00, 0x60, 0x03, 0x80, 0x3C, 0x80, 0x24, 0x80, 0x24, 0x80, 0x24, 0x40, 0x24, 0x40, 0x25, 0x40, 0x24, 0xA0, 0x25, 0xA0, 0x46, 0x90, 0x00, 0x00 }; /*74DC*/
const unsigned char  uc2_74DE [] = {0x07, 0x20, 0x3A, 0xA0, 0x2A, 0xF0, 0x2B, 0x20, 0x2A, 0xF0, 0x2A, 0x20, 0x2A, 0x50, 0x2B, 0x90, 0x2D, 0x00, 0x2A, 0x80, 0x4D, 0x70, 0x00, 0x00 }; /*74DE*/
const unsigned char  uc2_74E0 [] = {0x10, 0x10, 0x7F, 0xE0, 0x12, 0xA0, 0x2A, 0xA0, 0x46, 0xA0, 0x3A, 0xA0, 0x02, 0xA0, 0x7E, 0xA0, 0x12, 0xD0, 0x0A, 0xB0, 0x34, 0xD0, 0x00, 0x00 }; /*74E0*/
const unsigned char  uc2_74E2 [] = {0x7C, 0x30, 0x2B, 0xE0, 0x7E, 0xA0, 0x52, 0xA0, 0x7E, 0xA0, 0x02, 0xA0, 0x3A, 0xA0, 0x02, 0xA0, 0x7E, 0xD0, 0x5A, 0xB0, 0x34, 0xD0, 0x00, 0x00 }; /*74E2*/
const unsigned char  uc2_74E3 [] = {0x40, 0xC0, 0x2F, 0xA0, 0x7A, 0xF0, 0x5A, 0xD0, 0x2A, 0xA0, 0x7A, 0xF0, 0x2A, 0xA0, 0x7A, 0xF0, 0x2B, 0xA0, 0x32, 0xA0, 0x53, 0x60, 0x00, 0x00 }; /*74E3*/
const unsigned char  uc2_74E4 [] = {0x10, 0x30, 0x7F, 0xE0, 0x2A, 0xA0, 0x7E, 0xA0, 0x2A, 0xA0, 0x7E, 0xA0, 0x2A, 0xA0, 0x7E, 0xA0, 0x2E, 0xD0, 0x6A, 0xB0, 0x34, 0xD0, 0x00, 0x00 }; /*74E4*/
const unsigned char  uc2_74E6 [] = {0x00, 0x00, 0x7F, 0xE0, 0x08, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x0E, 0x80, 0x11, 0x80, 0x10, 0x90, 0x13, 0x90, 0x1C, 0x90, 0x10, 0x60, 0x00, 0x00 }; /*74E6*/
const unsigned char  uc2_74E9 [] = {0x00, 0x20, 0x7E, 0xC0, 0x10, 0x40, 0x1C, 0x40, 0x15, 0xF0, 0x1C, 0x40, 0x24, 0x40, 0x28, 0x40, 0x28, 0x50, 0x34, 0x10, 0x23, 0xE0, 0x00, 0x00 }; /*74E9*/
const unsigned char  uc2_74EE [] = {0x08, 0x80, 0x14, 0x40, 0x68, 0xB0, 0x0F, 0x40, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x0F, 0x80, 0x14, 0x90, 0x1D, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*74EE*/
const unsigned char  uc2_74EF [] = {0x00, 0x00, 0x7D, 0xF0, 0x40, 0x80, 0x64, 0x80, 0x54, 0xE0, 0x48, 0xA0, 0x48, 0xE0, 0x55, 0x50, 0x65, 0x50, 0x41, 0xD0, 0x7D, 0x20, 0x00, 0x00 }; /*74EF*/
const unsigned char  uc2_74F4 [] = {0x10, 0x00, 0x13, 0xF0, 0x29, 0x00, 0x45, 0x00, 0x31, 0xE0, 0x09, 0x20, 0x79, 0xA0, 0x0A, 0x50, 0x32, 0x50, 0x0B, 0xD0, 0x0A, 0x20, 0x00, 0x00 }; /*74F4*/
const unsigned char  uc2_74F6 [] = {0x22, 0x00, 0x15, 0xF0, 0x3E, 0x80, 0x14, 0x80, 0x14, 0xE0, 0x7F, 0xA0, 0x14, 0xE0, 0x15, 0x50, 0x25, 0x50, 0x25, 0xD0, 0x45, 0x20, 0x00, 0x00 }; /*74F6*/
const unsigned char  uc2_74F7 [] = {0x64, 0x00, 0x17, 0xE0, 0x09, 0x20, 0x12, 0x80, 0x6C, 0x70, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x0F, 0x90, 0x14, 0x90, 0x1D, 0xE0, 0x00, 0x00 }; /*74F7*/
const unsigned char  uc2_74FF [] = {0x20, 0x00, 0x13, 0xF0, 0x7D, 0x00, 0x29, 0x00, 0x7D, 0xE0, 0x01, 0x20, 0x39, 0xA0, 0x2A, 0x50, 0x2A, 0x50, 0x3B, 0xD0, 0x2A, 0x20, 0x00, 0x00 }; /*74FF*/
const unsigned char  uc2_7504 [] = {0x00, 0x00, 0x7D, 0xF0, 0x28, 0x80, 0x7C, 0x80, 0x54, 0xE0, 0x7C, 0xA0, 0x10, 0xE0, 0x7D, 0x50, 0x11, 0x50, 0x1D, 0xD0, 0x61, 0x20, 0x00, 0x00 }; /*7504*/
const unsigned char  uc2_750D [] = {0x08, 0x80, 0x7F, 0xF0, 0x25, 0x20, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x08, 0x00, 0x0F, 0x80, 0x14, 0x90, 0x1D, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*750D*/
const unsigned char  uc2_750F [] = {0x08, 0x10, 0x7F, 0x60, 0x22, 0x10, 0x3E, 0x60, 0x15, 0x90, 0x7E, 0x60, 0x00, 0x00, 0x7F, 0xF0, 0x0C, 0x80, 0x12, 0x90, 0x1D, 0xE0, 0x00, 0x00 }; /*750F*/
const unsigned char  uc2_7511 [] = {0x24, 0x00, 0x7F, 0xF0, 0x6A, 0x80, 0x56, 0x80, 0x7E, 0xE0, 0x00, 0xA0, 0x3C, 0xE0, 0x25, 0x50, 0x3D, 0x50, 0x25, 0xD0, 0x3D, 0x20, 0x00, 0x00 }; /*7511*/
const unsigned char  uc2_7513 [] = {0x3C, 0x40, 0x25, 0xF0, 0x3C, 0xA0, 0x21, 0xF0, 0x5C, 0xA0, 0x14, 0x40, 0x7F, 0xF0, 0x08, 0x00, 0x0F, 0x80, 0x14, 0x90, 0x1D, 0xE0, 0x00, 0x00 }; /*7513*/
const unsigned char  uc2_7518 [] = {0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*7518*/
const unsigned char  uc2_7519 [] = {0x00, 0xC0, 0x00, 0xA0, 0x7F, 0xF0, 0x00, 0x80, 0x14, 0x80, 0x7E, 0x80, 0x14, 0x80, 0x1C, 0x90, 0x14, 0x50, 0x1C, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*7519*/
const unsigned char  uc2_751A [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x80, 0x14, 0x40, 0x0F, 0xE0, 0x00, 0x00 }; /*751A*/
const unsigned char  uc2_751C [] = {0x06, 0xA0, 0x38, 0xA0, 0x09, 0xF0, 0x08, 0xA0, 0x7F, 0xA0, 0x08, 0xE0, 0x3E, 0xA0, 0x22, 0xA0, 0x22, 0xA0, 0x3E, 0xE0, 0x22, 0xA0, 0x00, 0x00 }; /*751C*/
const unsigned char  uc2_751F [] = {0x02, 0x00, 0x12, 0x00, 0x12, 0x00, 0x1F, 0xE0, 0x22, 0x00, 0x42, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*751F*/
const unsigned char  uc2_7525 [] = {0x13, 0xE0, 0x52, 0xA0, 0x7F, 0xE0, 0x52, 0xA0, 0x13, 0xE0, 0x38, 0x80, 0x17, 0xF0, 0x10, 0x90, 0x1C, 0x90, 0x61, 0x10, 0x06, 0x60, 0x00, 0x00 }; /*7525*/
const unsigned char  uc2_7528 [] = {0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*7528*/
const unsigned char  uc2_7529 [] = {0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0xC0, 0x22, 0x10, 0x22, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*7529*/
const unsigned char  uc2_752B [] = {0x02, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*752B*/
const unsigned char  uc2_752C [] = {0x3F, 0x80, 0x04, 0x80, 0x03, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*752C*/
const unsigned char  uc2_752D [] = {0x7F, 0xF0, 0x06, 0x00, 0x1A, 0xE0, 0x62, 0x10, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x42, 0x40, 0x00, 0x00 }; /*752D*/
const unsigned char  uc2_752F [] = {0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x50, 0x37, 0xA0, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x40, 0x00, 0x00 }; /*752F*/
const unsigned char  uc2_7530 [] = {0x00, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x42, 0x10, 0x42, 0x10, 0x42, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*7530*/
const unsigned char  uc2_7531 [] = {0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*7531*/
const unsigned char  uc2_7532 [] = {0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7532*/
const unsigned char  uc2_7533 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7533*/
const unsigned char  uc2_7535 [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x90, 0x04, 0x10, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*7535*/
const unsigned char  uc2_7537 [] = {0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x02, 0x00, 0x7F, 0xE0, 0x04, 0x20, 0x08, 0x20, 0x70, 0xC0, 0x00, 0x00 }; /*7537*/
const unsigned char  uc2_7538 [] = {0x10, 0x00, 0x1F, 0xF0, 0x60, 0x10, 0x1F, 0xD0, 0x12, 0x50, 0x1F, 0xD0, 0x12, 0x50, 0x1F, 0xD0, 0x10, 0x50, 0x00, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*7538*/
const unsigned char  uc2_753A [] = {0x00, 0x00, 0x03, 0xF0, 0x7C, 0x40, 0x54, 0x40, 0x54, 0x40, 0x7C, 0x40, 0x54, 0x40, 0x54, 0x40, 0x7C, 0x40, 0x44, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*753A*/
const unsigned char  uc2_753B [] = {0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x5F, 0xD0, 0x52, 0x50, 0x5F, 0xD0, 0x40, 0x10, 0x7F, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*753B*/
const unsigned char  uc2_753E [] = {0x12, 0x40, 0x24, 0x80, 0x12, 0x40, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*753E*/
const unsigned char  uc2_7540 [] = {0x00, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7540*/
const unsigned char  uc2_7545 [] = {0x13, 0xC0, 0x10, 0x40, 0x7C, 0x80, 0x57, 0xF0, 0x7D, 0x50, 0x55, 0x50, 0x7D, 0x50, 0x55, 0x50, 0x16, 0x90, 0x10, 0x90, 0x13, 0x60, 0x00, 0x00 }; /*7545*/
const unsigned char  uc2_7548 [] = {0x00, 0x30, 0x01, 0xC0, 0x7D, 0x00, 0x55, 0xF0, 0x55, 0x50, 0x7D, 0x50, 0x55, 0x50, 0x55, 0x50, 0x7D, 0x20, 0x45, 0x50, 0x02, 0x90, 0x00, 0x00 }; /*7548*/
const unsigned char  uc2_754B [] = {0x00, 0x80, 0x00, 0x80, 0x7C, 0xF0, 0x55, 0xA0, 0x56, 0xA0, 0x7C, 0xA0, 0x54, 0x40, 0x54, 0x40, 0x7C, 0xA0, 0x44, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*754B*/
const unsigned char  uc2_754C [] = {0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x05, 0x00, 0x18, 0xC0, 0x68, 0xB0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*754C*/
const unsigned char  uc2_754E [] = {0x00, 0x80, 0x00, 0xC0, 0x7C, 0xA0, 0x57, 0xF0, 0x54, 0x80, 0x7C, 0x80, 0x55, 0x40, 0x55, 0x40, 0x7D, 0x20, 0x42, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*754E*/
const unsigned char  uc2_754F [] = {0x00, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x00, 0x11, 0x20, 0x15, 0x40, 0x18, 0xC0, 0x10, 0x30, 0x00, 0x00 }; /*754F*/
const unsigned char  uc2_7554 [] = {0x00, 0x80, 0x02, 0xA0, 0x7D, 0xC0, 0x54, 0x80, 0x57, 0xE0, 0x7C, 0x80, 0x54, 0x80, 0x57, 0xF0, 0x7C, 0x80, 0x44, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7554*/
const unsigned char  uc2_7559 [] = {0x0C, 0x00, 0x33, 0xE0, 0x28, 0xA0, 0x2C, 0xA0, 0x35, 0x20, 0x22, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7559*/
const unsigned char  uc2_755A [] = {0x04, 0x00, 0x08, 0x80, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x72, 0x70, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*755A*/
const unsigned char  uc2_755B [] = {0x00, 0x80, 0x00, 0x80, 0x7D, 0x40, 0x56, 0x30, 0x54, 0xC0, 0x7D, 0x20, 0x54, 0x40, 0x55, 0x90, 0x7C, 0x20, 0x44, 0xC0, 0x03, 0x00, 0x00, 0x00 }; /*755B*/
const unsigned char  uc2_755C [] = {0x02, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x06, 0x40, 0x19, 0xA0, 0x06, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*755C*/
const unsigned char  uc2_7565 [] = {0x01, 0x00, 0x01, 0xE0, 0x7E, 0x20, 0x55, 0x20, 0x54, 0xC0, 0x7F, 0x30, 0x54, 0x00, 0x55, 0xE0, 0x7D, 0x20, 0x45, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*7565*/
const unsigned char  uc2_7566 [] = {0x00, 0x40, 0x00, 0xE0, 0x7C, 0x40, 0x54, 0x40, 0x55, 0xF0, 0x7C, 0x00, 0x54, 0x40, 0x54, 0xE0, 0x7C, 0x40, 0x44, 0x40, 0x01, 0xF0, 0x00, 0x00 }; /*7566*/
const unsigned char  uc2_756A [] = {0x00, 0x60, 0x3F, 0x80, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*756A*/
const unsigned char  uc2_7572 [] = {0x07, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*7572*/
const unsigned char  uc2_7574 [] = {0x00, 0x40, 0x01, 0xF0, 0x7C, 0x40, 0x54, 0xE0, 0x54, 0x40, 0x7D, 0xF0, 0x54, 0xA0, 0x55, 0xF0, 0x7E, 0x20, 0x44, 0xA0, 0x00, 0x40, 0x00, 0x00 }; /*7574*/
const unsigned char  uc2_7578 [] = {0x00, 0x40, 0x01, 0xF0, 0x7C, 0xA0, 0x55, 0x10, 0x57, 0xF0, 0x7C, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x7D, 0xD0, 0x45, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*7578*/
const unsigned char  uc2_7579 [] = {0x00, 0x40, 0x03, 0xF0, 0x7E, 0x10, 0x55, 0x00, 0x55, 0xF0, 0x7D, 0x50, 0x55, 0x50, 0x56, 0xE0, 0x7C, 0x50, 0x44, 0xD0, 0x03, 0x20, 0x00, 0x00 }; /*7579*/
const unsigned char  uc2_757F [] = {0x09, 0x20, 0x15, 0x50, 0x09, 0x20, 0x15, 0x50, 0x09, 0x60, 0x7F, 0xF0, 0x2A, 0x80, 0x3E, 0xA0, 0x2A, 0xA0, 0x3E, 0xD0, 0x21, 0x60, 0x00, 0x00 }; /*757F*/
const unsigned char  uc2_7583 [] = {0x01, 0x00, 0x00, 0x80, 0x7F, 0xE0, 0x55, 0x40, 0x57, 0xF0, 0x7C, 0xA0, 0x57, 0xE0, 0x54, 0xA0, 0x7F, 0xF0, 0x40, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*7583*/
const unsigned char  uc2_7586 [] = {0x7F, 0xF0, 0x0A, 0xA0, 0x7B, 0xE0, 0x42, 0xA0, 0x7F, 0xF0, 0x28, 0x00, 0x7B, 0xE0, 0x2A, 0xA0, 0x3B, 0xE0, 0x4A, 0xA0, 0x37, 0xF0, 0x00, 0x00 }; /*7586*/
const unsigned char  uc2_758B [] = {0x00, 0x00, 0x7F, 0xF0, 0x02, 0x10, 0x02, 0x20, 0x12, 0x00, 0x13, 0xE0, 0x12, 0x00, 0x12, 0x00, 0x2A, 0x00, 0x26, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*758B*/
const unsigned char  uc2_758F [] = {0x00, 0x80, 0x7F, 0xF0, 0x09, 0x00, 0x12, 0x20, 0x17, 0xD0, 0x58, 0x10, 0x52, 0xA0, 0x52, 0xA0, 0x5A, 0xA0, 0x64, 0xA0, 0x08, 0x90, 0x00, 0x00 }; /*758F*/
const unsigned char  uc2_7591 [] = {0x28, 0x00, 0x31, 0xE0, 0x24, 0xA0, 0x18, 0x40, 0x23, 0xF0, 0x38, 0x50, 0x51, 0x40, 0x7D, 0x60, 0x11, 0x40, 0x2A, 0xC0, 0x44, 0x30, 0x00, 0x00 }; /*7591*/
const unsigned char  uc2_7594 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x50, 0x00, 0x37, 0xF0, 0x10, 0x80, 0x30, 0x80, 0x50, 0x80, 0x10, 0x80, 0x20, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*7594*/
const unsigned char  uc2_7596 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xE0, 0x31, 0x20, 0x11, 0x20, 0x31, 0x20, 0x51, 0x40, 0x11, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*7596*/
const unsigned char  uc2_7597 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xE0, 0x30, 0x20, 0x10, 0x40, 0x30, 0x80, 0x50, 0x80, 0x10, 0x80, 0x20, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*7597*/
const unsigned char  uc2_7599 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x53, 0xE0, 0x3C, 0x00, 0x13, 0xC0, 0x30, 0x40, 0x50, 0x80, 0x11, 0x10, 0x22, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*7599*/
const unsigned char  uc2_759A [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x51, 0x00, 0x31, 0xC0, 0x11, 0x40, 0x36, 0x40, 0x50, 0x80, 0x11, 0x40, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*759A*/
const unsigned char  uc2_759D [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x50, 0x80, 0x30, 0x80, 0x14, 0x90, 0x34, 0x90, 0x54, 0x90, 0x14, 0x90, 0x27, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*759D*/
const unsigned char  uc2_759F [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xE0, 0x32, 0x00, 0x12, 0x00, 0x3F, 0xF0, 0x52, 0x00, 0x12, 0x00, 0x23, 0xE0, 0x40, 0x00, 0x00, 0x00 }; /*759F*/
const unsigned char  uc2_75A0 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x50, 0x00, 0x37, 0xF0, 0x11, 0x00, 0x31, 0xE0, 0x51, 0x20, 0x12, 0x20, 0x22, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*75A0*/
const unsigned char  uc2_75A1 [] = {0x01, 0x00, 0x1F, 0xF0, 0x50, 0x00, 0x37, 0x80, 0x10, 0x80, 0x31, 0x00, 0x57, 0xE0, 0x12, 0xA0, 0x2C, 0xA0, 0x21, 0x20, 0x46, 0xC0, 0x00, 0x00 }; /*75A1*/
const unsigned char  uc2_75A3 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x52, 0x80, 0x32, 0x40, 0x17, 0xE0, 0x32, 0x80, 0x52, 0x80, 0x14, 0x90, 0x24, 0x90, 0x48, 0x60, 0x00, 0x00 }; /*75A3*/
const unsigned char  uc2_75A4 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xC0, 0x35, 0x40, 0x15, 0x40, 0x37, 0xC0, 0x54, 0x10, 0x14, 0x10, 0x23, 0xE0, 0x40, 0x00, 0x00, 0x00 }; /*75A4*/
const unsigned char  uc2_75A5 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x50, 0x80, 0x31, 0x40, 0x16, 0x30, 0x31, 0x40, 0x51, 0x40, 0x11, 0x40, 0x22, 0x40, 0x4C, 0x40, 0x00, 0x00 }; /*75A5*/
const unsigned char  uc2_75AB [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x51, 0xC0, 0x31, 0x40, 0x16, 0x30, 0x33, 0xE0, 0x51, 0x20, 0x10, 0xC0, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*75AB*/
const unsigned char  uc2_75AC [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xF0, 0x32, 0x00, 0x12, 0x40, 0x32, 0xF0, 0x52, 0x50, 0x14, 0x50, 0x24, 0x90, 0x49, 0x60, 0x00, 0x00 }; /*75AC*/
const unsigned char  uc2_75AE [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x52, 0x80, 0x3C, 0x60, 0x13, 0xC0, 0x32, 0x40, 0x52, 0x40, 0x12, 0x90, 0x22, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*75AE*/
const unsigned char  uc2_75AF [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xC0, 0x34, 0x40, 0x16, 0xC0, 0x35, 0x40, 0x56, 0xC0, 0x14, 0x50, 0x24, 0x50, 0x48, 0x20, 0x00, 0x00 }; /*75AF*/
const unsigned char  uc2_75B0 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x57, 0xF0, 0x30, 0x80, 0x10, 0x80, 0x33, 0xE0, 0x50, 0x80, 0x10, 0x80, 0x27, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*75B0*/
const unsigned char  uc2_75B1 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x53, 0xE0, 0x34, 0x20, 0x1B, 0xA0, 0x32, 0xA0, 0x53, 0xA0, 0x12, 0x50, 0x22, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*75B1*/
const unsigned char  uc2_75B2 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x40, 0x53, 0xF0, 0x32, 0x50, 0x13, 0xE0, 0x32, 0xA0, 0x52, 0xA0, 0x14, 0x40, 0x24, 0xA0, 0x4B, 0x10, 0x00, 0x00 }; /*75B2*/
const unsigned char  uc2_75B3 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x40, 0x5F, 0xF0, 0x32, 0x40, 0x12, 0x40, 0x33, 0xC0, 0x52, 0x40, 0x12, 0x40, 0x23, 0xC0, 0x42, 0x40, 0x00, 0x00 }; /*75B3*/
const unsigned char  uc2_75B4 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x30, 0x20, 0x13, 0xA0, 0x32, 0xA0, 0x53, 0xA0, 0x12, 0xA0, 0x20, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*75B4*/
const unsigned char  uc2_75B5 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x51, 0x40, 0x35, 0x50, 0x15, 0xE0, 0x35, 0x40, 0x55, 0x40, 0x15, 0xD0, 0x2E, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*75B5*/
const unsigned char  uc2_75B8 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xC0, 0x32, 0x40, 0x13, 0xC0, 0x32, 0x40, 0x53, 0xC0, 0x10, 0x00, 0x2F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*75B8*/
const unsigned char  uc2_75B9 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x50, 0x80, 0x31, 0x40, 0x16, 0xB0, 0x31, 0x40, 0x50, 0x80, 0x13, 0x20, 0x20, 0xC0, 0x43, 0x00, 0x00, 0x00 }; /*75B9*/
const unsigned char  uc2_75BC [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x53, 0xC0, 0x36, 0x40, 0x11, 0x80, 0x3E, 0x70, 0x51, 0x80, 0x10, 0x40, 0x21, 0x80, 0x40, 0x40, 0x00, 0x00 }; /*75BC*/
const unsigned char  uc2_75BD [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xC0, 0x32, 0x40, 0x13, 0xC0, 0x32, 0x40, 0x53, 0xC0, 0x12, 0x40, 0x2F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*75BD*/
const unsigned char  uc2_75BE [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x51, 0xE0, 0x36, 0x80, 0x10, 0x80, 0x37, 0xF0, 0x50, 0x80, 0x11, 0x40, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*75BE*/
const unsigned char  uc2_75C2 [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x00, 0x54, 0x70, 0x3F, 0x50, 0x15, 0x50, 0x35, 0x50, 0x55, 0x50, 0x15, 0x50, 0x25, 0x70, 0x4A, 0x50, 0x00, 0x00 }; /*75C2*/
const unsigned char  uc2_75C3 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x57, 0xF0, 0x31, 0x00, 0x12, 0x40, 0x33, 0x80, 0x51, 0x20, 0x12, 0x60, 0x23, 0x90, 0x40, 0x10, 0x00, 0x00 }; /*75C3*/
const unsigned char  uc2_75C4 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x53, 0xF0, 0x35, 0x00, 0x15, 0xC0, 0x39, 0x00, 0x51, 0xE0, 0x11, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*75C4*/
const unsigned char  uc2_75C5 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x30, 0x80, 0x17, 0xF0, 0x34, 0x90, 0x55, 0x50, 0x16, 0x50, 0x24, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*75C5*/
const unsigned char  uc2_75C7 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xE0, 0x30, 0x80, 0x12, 0x80, 0x32, 0xC0, 0x52, 0x80, 0x12, 0x80, 0x2F, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*75C7*/
const unsigned char  uc2_75C8 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x34, 0x90, 0x17, 0xF0, 0x34, 0x90, 0x57, 0xF0, 0x14, 0x90, 0x24, 0x90, 0x48, 0xA0, 0x00, 0x00 }; /*75C8*/
const unsigned char  uc2_75C9 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xC0, 0x30, 0x40, 0x11, 0xA0, 0x36, 0x10, 0x53, 0xE0, 0x10, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*75C9*/
const unsigned char  uc2_75CA [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x51, 0x40, 0x36, 0x30, 0x13, 0xE0, 0x30, 0x80, 0x51, 0xC0, 0x10, 0x80, 0x27, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*75CA*/
const unsigned char  uc2_75CD [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x5F, 0xF0, 0x31, 0x40, 0x17, 0xC0, 0x35, 0x00, 0x57, 0xE0, 0x11, 0x20, 0x22, 0xC0, 0x4C, 0x60, 0x00, 0x00 }; /*75CD*/
const unsigned char  uc2_75D2 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x20, 0x51, 0x40, 0x33, 0xE0, 0x10, 0x80, 0x31, 0xC0, 0x50, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*75D2*/
const unsigned char  uc2_75D4 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x53, 0xE0, 0x30, 0x80, 0x17, 0xF0, 0x30, 0x40, 0x53, 0xE0, 0x11, 0x40, 0x20, 0x40, 0x41, 0x80, 0x00, 0x00 }; /*75D4*/
const unsigned char  uc2_75D5 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xC0, 0x34, 0x40, 0x17, 0xC0, 0x34, 0x40, 0x57, 0xD0, 0x14, 0xA0, 0x25, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*75D5*/
const unsigned char  uc2_75D6 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x31, 0x40, 0x15, 0x50, 0x33, 0x50, 0x53, 0x60, 0x11, 0x40, 0x27, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*75D6*/
const unsigned char  uc2_75D8 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x30, 0x00, 0x13, 0xE0, 0x32, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x21, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*75D8*/
const unsigned char  uc2_75DB [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xC0, 0x31, 0x40, 0x17, 0xF0, 0x34, 0x90, 0x57, 0xF0, 0x14, 0x90, 0x27, 0xF0, 0x44, 0xA0, 0x00, 0x00 }; /*75DB*/
const unsigned char  uc2_75DE [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x31, 0x80, 0x16, 0xA0, 0x30, 0x90, 0x53, 0xE0, 0x12, 0x20, 0x23, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*75DE*/
const unsigned char  uc2_75E2 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0x10, 0x32, 0x50, 0x1F, 0xD0, 0x33, 0x50, 0x56, 0xD0, 0x1A, 0x50, 0x22, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*75E2*/
const unsigned char  uc2_75E3 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x50, 0x80, 0x37, 0xF0, 0x10, 0x80, 0x33, 0xE0, 0x51, 0x20, 0x16, 0x90, 0x2A, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*75E3*/
const unsigned char  uc2_75E4 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x52, 0xA0, 0x32, 0xA0, 0x15, 0xD0, 0x30, 0x80, 0x53, 0xE0, 0x10, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*75E4*/
const unsigned char  uc2_75E6 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xE0, 0x31, 0x00, 0x13, 0xC0, 0x31, 0x40, 0x5F, 0xF0, 0x12, 0x40, 0x23, 0xC0, 0x42, 0x40, 0x00, 0x00 }; /*75E6*/
const unsigned char  uc2_75E7 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x40, 0x5C, 0x60, 0x32, 0xD0, 0x1D, 0x50, 0x32, 0x40, 0x50, 0x20, 0x12, 0x20, 0x24, 0x40, 0x49, 0x80, 0x00, 0x00 }; /*75E7*/
const unsigned char  uc2_75E8 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x40, 0x57, 0xF0, 0x31, 0x40, 0x17, 0xF0, 0x34, 0x90, 0x53, 0xE0, 0x10, 0xA0, 0x21, 0x20, 0x46, 0xC0, 0x00, 0x00 }; /*75E8*/
const unsigned char  uc2_75EA [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x51, 0xC0, 0x32, 0x40, 0x17, 0xE0, 0x32, 0xA0, 0x57, 0xF0, 0x10, 0x80, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*75EA*/
const unsigned char  uc2_75EB [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x51, 0x70, 0x34, 0x90, 0x17, 0xF0, 0x34, 0x90, 0x55, 0xD0, 0x16, 0xB0, 0x24, 0x90, 0x44, 0xA0, 0x00, 0x00 }; /*75EB*/
const unsigned char  uc2_75F0 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x52, 0xA0, 0x31, 0x40, 0x16, 0x20, 0x30, 0x80, 0x52, 0xA0, 0x10, 0x80, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*75F0*/
const unsigned char  uc2_75F1 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x51, 0x40, 0x37, 0x70, 0x11, 0x40, 0x33, 0x60, 0x51, 0x40, 0x17, 0x70, 0x21, 0x40, 0x41, 0x40, 0x00, 0x00 }; /*75F1*/
const unsigned char  uc2_75F4 [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x00, 0x57, 0x70, 0x3A, 0x50, 0x12, 0x50, 0x3F, 0xD0, 0x52, 0x50, 0x15, 0x50, 0x25, 0x70, 0x48, 0x50, 0x00, 0x00 }; /*75F4*/
const unsigned char  uc2_75F9 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xE0, 0x32, 0xA0, 0x13, 0xE0, 0x32, 0xA0, 0x57, 0xF0, 0x11, 0x40, 0x21, 0x40, 0x46, 0x40, 0x00, 0x00 }; /*75F9*/
const unsigned char  uc2_75FC [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x34, 0x90, 0x17, 0xF0, 0x34, 0x90, 0x55, 0x50, 0x15, 0xD0, 0x24, 0x10, 0x47, 0xF0, 0x00, 0x00 }; /*75FC*/
const unsigned char  uc2_75FF [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x20, 0x53, 0xC0, 0x30, 0x80, 0x17, 0xF0, 0x32, 0xA0, 0x54, 0x90, 0x17, 0xF0, 0x22, 0x20, 0x47, 0xD0, 0x00, 0x00 }; /*75FF*/
const unsigned char  uc2_7600 [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x20, 0x52, 0x20, 0x3F, 0x50, 0x14, 0x00, 0x37, 0x20, 0x55, 0x10, 0x15, 0x50, 0x25, 0x20, 0x4A, 0x20, 0x00, 0x00 }; /*7600*/
const unsigned char  uc2_7601 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x57, 0xF0, 0x32, 0x20, 0x12, 0x20, 0x35, 0x50, 0x50, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*7601*/
const unsigned char  uc2_7603 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xF0, 0x31, 0x00, 0x16, 0x90, 0x31, 0x50, 0x56, 0xE0, 0x11, 0x50, 0x26, 0x40, 0x41, 0x80, 0x00, 0x00 }; /*7603*/
const unsigned char  uc2_7605 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x40, 0x53, 0xE0, 0x32, 0xA0, 0x13, 0xE0, 0x32, 0xA0, 0x53, 0xE0, 0x10, 0x80, 0x27, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*7605*/
const unsigned char  uc2_760A [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x80, 0x52, 0x40, 0x35, 0xF0, 0x1C, 0x80, 0x34, 0xE0, 0x55, 0x40, 0x15, 0xF0, 0x24, 0x40, 0x45, 0xB0, 0x00, 0x00 }; /*760A*/
const unsigned char  uc2_760C [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x00, 0x5F, 0x10, 0x34, 0x50, 0x1F, 0x50, 0x35, 0x50, 0x5F, 0x50, 0x24, 0x50, 0x2E, 0x10, 0x55, 0x60, 0x00, 0x00 }; /*760C*/
const unsigned char  uc2_7610 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x80, 0x56, 0xB0, 0x34, 0x90, 0x16, 0xB0, 0x34, 0x90, 0x57, 0xF0, 0x11, 0x40, 0x22, 0x20, 0x4C, 0x10, 0x00, 0x00 }; /*7610*/
const unsigned char  uc2_7615 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0x70, 0x35, 0x10, 0x17, 0x70, 0x34, 0x00, 0x56, 0xF0, 0x14, 0x50, 0x27, 0x20, 0x44, 0xD0, 0x00, 0x00 }; /*7615*/
const unsigned char  uc2_7617 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x57, 0xF0, 0x32, 0xA0, 0x17, 0xF0, 0x31, 0x40, 0x56, 0xB0, 0x11, 0xC0, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*7617*/
const unsigned char  uc2_7618 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x52, 0xA0, 0x37, 0xF0, 0x12, 0xA0, 0x34, 0x90, 0x57, 0xF0, 0x11, 0x20, 0x20, 0xC0, 0x47, 0x20, 0x00, 0x00 }; /*7618*/
const unsigned char  uc2_7619 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x57, 0xE0, 0x32, 0xA0, 0x11, 0xC0, 0x3E, 0xB0, 0x53, 0xE0, 0x12, 0xA0, 0x22, 0xA0, 0x47, 0xD0, 0x00, 0x00 }; /*7619*/
const unsigned char  uc2_761B [] = {0x01, 0x00, 0x1F, 0xF0, 0x13, 0x00, 0x56, 0xF0, 0x33, 0x50, 0x16, 0x50, 0x33, 0x50, 0x56, 0xA0, 0x12, 0xA0, 0x26, 0x50, 0x49, 0x90, 0x00, 0x00 }; /*761B*/
const unsigned char  uc2_761F [] = {0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x67, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x64, 0x40, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*761F*/
const unsigned char  uc2_7620 [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x90, 0x52, 0xA0, 0x34, 0x90, 0x11, 0x40, 0x37, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x22, 0x20, 0x42, 0xE0, 0x00, 0x00 }; /*7620*/
const unsigned char  uc2_7622 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x00, 0x6E, 0xE0, 0x2A, 0xA0, 0x2F, 0x10, 0x3A, 0x00, 0x6F, 0xE0, 0x2A, 0xA0, 0x2A, 0x40, 0x55, 0xB0, 0x00, 0x00 }; /*7622*/
const unsigned char  uc2_7624 [] = {0x00, 0x80, 0x1F, 0xF0, 0x11, 0x00, 0x56, 0xF0, 0x35, 0x50, 0x16, 0xA0, 0x37, 0xF0, 0x54, 0x90, 0x17, 0xF0, 0x24, 0x90, 0x47, 0xF0, 0x00, 0x00 }; /*7624*/
const unsigned char  uc2_7625 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x40, 0x53, 0xE0, 0x30, 0x80, 0x11, 0x40, 0x37, 0xF0, 0x52, 0x00, 0x15, 0xC0, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*7625*/
const unsigned char  uc2_7626 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x52, 0xE0, 0x32, 0xA0, 0x13, 0xE0, 0x32, 0xA0, 0x57, 0xE0, 0x12, 0x20, 0x21, 0xC0, 0x4E, 0x30, 0x00, 0x00 }; /*7626*/
const unsigned char  uc2_7629 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x20, 0x57, 0xF0, 0x32, 0xA0, 0x11, 0x40, 0x33, 0xE0, 0x54, 0x10, 0x13, 0xE0, 0x22, 0x20, 0x43, 0xE0, 0x00, 0x00 }; /*7629*/
const unsigned char  uc2_762A [] = {0x01, 0x00, 0x1F, 0xF0, 0x14, 0x20, 0x57, 0xE0, 0x34, 0x20, 0x17, 0xE0, 0x31, 0x80, 0x5E, 0x70, 0x27, 0x80, 0x24, 0x20, 0x47, 0xE0, 0x00, 0x00 }; /*762A*/
const unsigned char  uc2_762B [] = {0x01, 0x00, 0x3F, 0xF0, 0x20, 0xA0, 0x6E, 0xF0, 0x23, 0xA0, 0x2A, 0xF0, 0x64, 0xA0, 0x2A, 0xF0, 0x32, 0xA0, 0x20, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*762B*/
const unsigned char  uc2_762D [] = {0x00, 0x80, 0x1F, 0xF0, 0x11, 0x40, 0x57, 0xF0, 0x35, 0x50, 0x17, 0xF0, 0x30, 0x00, 0x57, 0xF0, 0x10, 0x80, 0x22, 0xA0, 0x45, 0x90, 0x00, 0x00 }; /*762D*/
const unsigned char  uc2_7630 [] = {0x01, 0x00, 0x3F, 0xF0, 0x29, 0x20, 0x2F, 0xE0, 0x69, 0x20, 0x2F, 0xE0, 0x22, 0x40, 0x67, 0x80, 0x22, 0x20, 0x4F, 0xD0, 0x51, 0x20, 0x00, 0x00 }; /*7630*/
const unsigned char  uc2_7633 [] = {0x01, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x66, 0x60, 0x2B, 0xA0, 0x25, 0x40, 0x3A, 0xB0, 0x61, 0x00, 0x26, 0x40, 0x21, 0x80, 0x46, 0x00, 0x00, 0x00 }; /*7633*/
const unsigned char  uc2_7634 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x80, 0x53, 0xE0, 0x31, 0x40, 0x17, 0xF0, 0x31, 0x40, 0x51, 0xC0, 0x11, 0x40, 0x27, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*7634*/
const unsigned char  uc2_7635 [] = {0x01, 0x00, 0x3F, 0xF0, 0x28, 0x80, 0x6E, 0xE0, 0x2A, 0xA0, 0x34, 0x40, 0x6B, 0xB0, 0x30, 0x00, 0x2F, 0xE0, 0x25, 0x40, 0x4A, 0x20, 0x00, 0x00 }; /*7635*/
const unsigned char  uc2_7638 [] = {0x01, 0x00, 0x1F, 0xF0, 0x12, 0x00, 0x5F, 0x70, 0x35, 0x50, 0x1B, 0x70, 0x30, 0x80, 0x57, 0xF0, 0x15, 0x50, 0x24, 0x90, 0x45, 0x70, 0x00, 0x00 }; /*7638*/
const unsigned char  uc2_763C [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x40, 0x57, 0xF0, 0x32, 0x20, 0x13, 0xE0, 0x30, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*763C*/
const unsigned char  uc2_763E [] = {0x02, 0x00, 0x3F, 0xF0, 0x21, 0x40, 0x6F, 0xE0, 0x2A, 0x20, 0x2C, 0xE0, 0x6A, 0x20, 0x2B, 0xE0, 0x2C, 0x80, 0x29, 0x20, 0x4A, 0xD0, 0x00, 0x00 }; /*763E*/
const unsigned char  uc2_763F [] = {0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x6E, 0xE0, 0x2A, 0xA0, 0x24, 0x40, 0x6A, 0xA0, 0x3F, 0xF0, 0x24, 0x40, 0x23, 0xC0, 0x4C, 0x20, 0x00, 0x00 }; /*763F*/
const unsigned char  uc2_7640 [] = {0x01, 0x00, 0x1F, 0xF0, 0x11, 0x40, 0x53, 0xE0, 0x31, 0x40, 0x17, 0xF0, 0x32, 0xA0, 0x53, 0xE0, 0x12, 0xA0, 0x23, 0xE0, 0x44, 0x10, 0x00, 0x00 }; /*7640*/
const unsigned char  uc2_7643 [] = {0x02, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x6C, 0x40, 0x2B, 0xB0, 0x2A, 0xE0, 0x6A, 0x40, 0x2C, 0xF0, 0x29, 0x60, 0x28, 0xC0, 0x49, 0xF0, 0x00, 0x00 }; /*7643*/
const unsigned char  uc2_764C [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x53, 0xE0, 0x32, 0x20, 0x17, 0xF0, 0x35, 0x50, 0x57, 0x70, 0x10, 0x80, 0x24, 0x90, 0x47, 0xF0, 0x00, 0x00 }; /*764C*/
const unsigned char  uc2_764D [] = {0x01, 0x00, 0x1F, 0xF0, 0x50, 0x80, 0x3F, 0xF0, 0x15, 0x20, 0x15, 0x20, 0x3F, 0xF0, 0x54, 0xA0, 0x16, 0xA0, 0x2D, 0x70, 0x42, 0x40, 0x00, 0x00 }; /*764D*/
const unsigned char  uc2_7654 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x7F, 0xF0, 0x28, 0x20, 0x2F, 0xE0, 0x68, 0x20, 0x2F, 0xE0, 0x21, 0x00, 0x54, 0x50, 0x57, 0xD0, 0x00, 0x00 }; /*7654*/
const unsigned char  uc2_7656 [] = {0x02, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x6E, 0x40, 0x2B, 0xF0, 0x2E, 0xA0, 0x69, 0xF0, 0x2E, 0x40, 0x2A, 0xE0, 0x2E, 0x40, 0x52, 0x40, 0x00, 0x00 }; /*7656*/
const unsigned char  uc2_765C [] = {0x01, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x6F, 0x70, 0x29, 0x50, 0x2F, 0x50, 0x6A, 0x80, 0x2F, 0x70, 0x2A, 0x50, 0x5F, 0xA0, 0x55, 0x50, 0x00, 0x00 }; /*765C*/
const unsigned char  uc2_765E [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x7F, 0x70, 0x24, 0x90, 0x2F, 0x70, 0x75, 0x50, 0x2F, 0x50, 0x2E, 0x20, 0x35, 0x50, 0x44, 0x90, 0x00, 0x00 }; /*765E*/
const unsigned char  uc2_7663 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x50, 0x6F, 0x20, 0x31, 0x70, 0x2F, 0xA0, 0x6A, 0xF0, 0x2F, 0xA0, 0x2A, 0xF0, 0x2F, 0xA0, 0x58, 0x20, 0x00, 0x00 }; /*7663*/
const unsigned char  uc2_766B [] = {0x01, 0x00, 0x3F, 0xF0, 0x22, 0x00, 0x7F, 0xF0, 0x24, 0x20, 0x2F, 0x70, 0x6B, 0x50, 0x2D, 0x50, 0x3F, 0xA0, 0x29, 0x50, 0x50, 0x90, 0x00, 0x00 }; /*766B*/
const unsigned char  uc2_766F [] = {0x01, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x6A, 0xA0, 0x2E, 0xE0, 0x24, 0x80, 0x6F, 0xF0, 0x38, 0x80, 0x2F, 0xE0, 0x28, 0x80, 0x4F, 0xF0, 0x00, 0x00 }; /*766F*/
const unsigned char  uc2_7678 [] = {0x01, 0x40, 0x3D, 0x80, 0x05, 0x20, 0x18, 0xC0, 0x08, 0x80, 0x77, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x04, 0x80, 0x08, 0x40, 0x70, 0x40, 0x00, 0x00 }; /*7678*/
const unsigned char  uc2_767B [] = {0x01, 0x40, 0x3D, 0x80, 0x15, 0x20, 0x08, 0xC0, 0x77, 0x30, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*767B*/
const unsigned char  uc2_767D [] = {0x02, 0x00, 0x02, 0x00, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*767D*/
const unsigned char  uc2_767E [] = {0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*767E*/
const unsigned char  uc2_7682 [] = {0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x04, 0x00, 0x04, 0xE0, 0x7F, 0x10, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*7682*/
const unsigned char  uc2_7684 [] = {0x10, 0x80, 0x10, 0x80, 0x20, 0xF0, 0x7D, 0x10, 0x46, 0x10, 0x44, 0x90, 0x7C, 0x50, 0x44, 0x50, 0x44, 0x10, 0x7C, 0x10, 0x44, 0xE0, 0x00, 0x00 }; /*7684*/
const unsigned char  uc2_7686 [] = {0x21, 0x20, 0x39, 0xD0, 0x25, 0x10, 0x3A, 0xE0, 0x24, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*7686*/
const unsigned char  uc2_7687 [] = {0x02, 0x00, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7687*/
const unsigned char  uc2_7688 [] = {0x10, 0x60, 0x13, 0x80, 0x22, 0x00, 0x7A, 0x00, 0x4B, 0xE0, 0x4A, 0xA0, 0x7A, 0xA0, 0x4A, 0xA0, 0x4A, 0x40, 0x7A, 0xA0, 0x4D, 0x10, 0x00, 0x00 }; /*7688*/
const unsigned char  uc2_768B [] = {0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*768B*/
const unsigned char  uc2_768E [] = {0x10, 0x80, 0x27, 0xF0, 0x79, 0x20, 0x4E, 0x10, 0x49, 0x50, 0x79, 0x40, 0x49, 0x40, 0x48, 0x80, 0x79, 0x40, 0x49, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*768E*/
const unsigned char  uc2_7691 [] = {0x10, 0x80, 0x22, 0xA0, 0x7B, 0xE0, 0x48, 0x00, 0x4B, 0xE0, 0x78, 0x20, 0x4B, 0xE0, 0x4A, 0x20, 0x7A, 0x10, 0x4A, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*7691*/
const unsigned char  uc2_7693 [] = {0x10, 0x80, 0x22, 0x80, 0x7B, 0xE0, 0x4C, 0x80, 0x4F, 0xF0, 0x78, 0x00, 0x4B, 0xE0, 0x4A, 0x20, 0x7A, 0x20, 0x4B, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*7693*/
const unsigned char  uc2_7696 [] = {0x11, 0x00, 0x20, 0x80, 0x7B, 0xE0, 0x4A, 0x20, 0x49, 0xC0, 0x78, 0x00, 0x4B, 0xE0, 0x49, 0x40, 0x79, 0x50, 0x4A, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*7696*/
const unsigned char  uc2_7699 [] = {0x11, 0xE0, 0x7D, 0x00, 0x11, 0xF0, 0x39, 0x40, 0x55, 0x40, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7699*/
const unsigned char  uc2_76A4 [] = {0x10, 0x30, 0x27, 0xC0, 0x7A, 0xA0, 0x4F, 0xF0, 0x4A, 0xA0, 0x7C, 0x90, 0x4B, 0xE0, 0x4A, 0xA0, 0x7B, 0xE0, 0x4A, 0xA0, 0x03, 0xE0, 0x00, 0x00 }; /*76A4*/
const unsigned char  uc2_76AE [] = {0x01, 0x00, 0x01, 0x00, 0x1F, 0xF0, 0x11, 0x10, 0x11, 0x20, 0x1F, 0xC0, 0x14, 0x40, 0x12, 0x80, 0x21, 0x00, 0x26, 0xC0, 0x58, 0x30, 0x00, 0x00 }; /*76AE*/
const unsigned char  uc2_76B1 [] = {0x20, 0x40, 0x3B, 0xF0, 0x2A, 0x50, 0x52, 0x50, 0x7B, 0xE0, 0x0A, 0xA0, 0x7A, 0xA0, 0x0A, 0xA0, 0x7A, 0x40, 0x0A, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*76B1*/
const unsigned char  uc2_76B2 [] = {0x00, 0x40, 0x7E, 0x40, 0x53, 0xF0, 0x3E, 0x50, 0x13, 0xE0, 0x2A, 0xA0, 0x3E, 0xA0, 0x0A, 0xA0, 0x1E, 0x40, 0x6A, 0xA0, 0x0D, 0x10, 0x00, 0x00 }; /*76B2*/
const unsigned char  uc2_76B4 [] = {0x10, 0x40, 0x2B, 0xF0, 0x7E, 0x50, 0x2A, 0x40, 0x47, 0xE0, 0x22, 0xA0, 0x3A, 0xA0, 0x6A, 0xA0, 0x12, 0x40, 0x2A, 0xA0, 0x4D, 0x10, 0x00, 0x00 }; /*76B4*/
const unsigned char  uc2_76BF [] = {0x00, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x15, 0x40, 0x15, 0x40, 0x15, 0x40, 0x15, 0x40, 0x15, 0x40, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }; /*76BF*/
const unsigned char  uc2_76C2 [] = {0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76C2*/
const unsigned char  uc2_76C5 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76C5*/
const unsigned char  uc2_76C6 [] = {0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x02, 0x80, 0x04, 0x80, 0x1B, 0x00, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76C6*/
const unsigned char  uc2_76C8 [] = {0x3F, 0xC0, 0x08, 0x40, 0x0F, 0x70, 0x09, 0x10, 0x15, 0x10, 0x22, 0x10, 0x4D, 0x60, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76C8*/
const unsigned char  uc2_76CA [] = {0x10, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x08, 0xC0, 0x30, 0x20, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76CA*/
const unsigned char  uc2_76CD [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xA0, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76CD*/
const unsigned char  uc2_76CE [] = {0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76CE*/
const unsigned char  uc2_76CF [] = {0x04, 0x80, 0x3F, 0xC0, 0x04, 0x00, 0x7F, 0xE0, 0x02, 0x80, 0x3F, 0x20, 0x00, 0xC0, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76CF*/
const unsigned char  uc2_76D0 [] = {0x08, 0x80, 0x08, 0x80, 0x3E, 0xC0, 0x08, 0xA0, 0x0E, 0xA0, 0x70, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D0*/
const unsigned char  uc2_76D1 [] = {0x09, 0x00, 0x29, 0x00, 0x29, 0xF0, 0x2A, 0x00, 0x2C, 0xC0, 0x08, 0x20, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D1*/
const unsigned char  uc2_76D2 [] = {0x02, 0x00, 0x05, 0x00, 0x1F, 0xC0, 0x60, 0x30, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D2*/
const unsigned char  uc2_76D4 [] = {0x10, 0x00, 0x7F, 0xF0, 0x11, 0x00, 0x15, 0x40, 0x22, 0x80, 0x24, 0x40, 0x58, 0x30, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D4*/
const unsigned char  uc2_76D6 [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D6*/
const unsigned char  uc2_76D7 [] = {0x02, 0x00, 0x33, 0xE0, 0x0A, 0x20, 0x04, 0xA0, 0x10, 0x80, 0x61, 0x40, 0x0E, 0x30, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D7*/
const unsigned char  uc2_76D8 [] = {0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x12, 0x40, 0x20, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76D8*/
const unsigned char  uc2_76DB [] = {0x01, 0x40, 0x3F, 0xE0, 0x21, 0x00, 0x3D, 0x40, 0x25, 0x50, 0x28, 0x90, 0x47, 0x60, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76DB*/
const unsigned char  uc2_76DF [] = {0x01, 0xE0, 0x3D, 0x20, 0x25, 0xE0, 0x3D, 0x20, 0x25, 0xE0, 0x3D, 0x20, 0x22, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76DF*/
const unsigned char  uc2_76E5 [] = {0x22, 0x80, 0x5B, 0x30, 0x4A, 0x10, 0x6B, 0x30, 0x52, 0x90, 0x6C, 0xB0, 0x40, 0x10, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*76E5*/
const unsigned char  uc2_76EE [] = {0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*76EE*/
const unsigned char  uc2_76EF [] = {0x00, 0x00, 0x07, 0xF0, 0x78, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*76EF*/
const unsigned char  uc2_76F1 [] = {0x00, 0x00, 0x03, 0xE0, 0x78, 0x80, 0x48, 0x80, 0x7F, 0xF0, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x78, 0x80, 0x48, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*76F1*/
const unsigned char  uc2_76F2 [] = {0x02, 0x00, 0x7F, 0xF0, 0x20, 0x00, 0x1F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*76F2*/
const unsigned char  uc2_76F4 [] = {0x02, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*76F4*/
const unsigned char  uc2_76F8 [] = {0x08, 0xF0, 0x08, 0x90, 0x3E, 0x90, 0x08, 0xF0, 0x1C, 0x90, 0x2A, 0x90, 0x2A, 0xF0, 0x2A, 0x90, 0x48, 0x90, 0x08, 0xF0, 0x08, 0x90, 0x00, 0x00 }; /*76F8*/
const unsigned char  uc2_76F9 [] = {0x00, 0x80, 0x00, 0x80, 0x7F, 0xF0, 0x48, 0x80, 0x7A, 0xA0, 0x4A, 0xA0, 0x7B, 0xE0, 0x48, 0xA0, 0x78, 0x90, 0x48, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*76F9*/
const unsigned char  uc2_76FC [] = {0x01, 0x40, 0x01, 0x40, 0x7A, 0x20, 0x4C, 0x10, 0x7B, 0xE0, 0x48, 0xA0, 0x78, 0xA0, 0x49, 0x20, 0x79, 0x20, 0x4A, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*76FC*/
const unsigned char  uc2_76FE [] = {0x3F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x4F, 0xE0, 0x00, 0x00 }; /*76FE*/
const unsigned char  uc2_7701 [] = {0x02, 0x00, 0x12, 0x60, 0x62, 0x90, 0x01, 0x00, 0x1F, 0xC0, 0x70, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7701*/
const unsigned char  uc2_7704 [] = {0x00, 0x00, 0x03, 0xF0, 0x78, 0x80, 0x4A, 0x80, 0x7A, 0xF0, 0x4A, 0x90, 0x7B, 0xF0, 0x48, 0x10, 0x78, 0x10, 0x48, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*7704*/
const unsigned char  uc2_7707 [] = {0x00, 0x80, 0x00, 0x80, 0x7A, 0xA0, 0x4A, 0x90, 0x7C, 0x90, 0x48, 0x80, 0x78, 0x90, 0x48, 0x20, 0x78, 0x40, 0x49, 0x80, 0x06, 0x00, 0x00, 0x00 }; /*7707*/
const unsigned char  uc2_7708 [] = {0x00, 0x80, 0x00, 0x80, 0x77, 0xF0, 0x54, 0x90, 0x74, 0x90, 0x50, 0x80, 0x71, 0x40, 0x51, 0x50, 0x71, 0x50, 0x52, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*7708*/
const unsigned char  uc2_7709 [] = {0x1F, 0xF0, 0x11, 0x10, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x27, 0xF0, 0x24, 0x10, 0x47, 0xF0, 0x00, 0x00 }; /*7709*/
const unsigned char  uc2_770B [] = {0x1F, 0xC0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*770B*/
const unsigned char  uc2_770D [] = {0x00, 0x00, 0x03, 0xF0, 0x7A, 0x00, 0x4B, 0x20, 0x7A, 0xA0, 0x4A, 0x40, 0x7A, 0x40, 0x4A, 0xA0, 0x7B, 0x20, 0x4A, 0x00, 0x03, 0xF0, 0x00, 0x00 }; /*770D*/
const unsigned char  uc2_7719 [] = {0x00, 0x80, 0x00, 0x80, 0x79, 0x20, 0x4A, 0x20, 0x7B, 0xD0, 0x48, 0x10, 0x79, 0xE0, 0x49, 0x20, 0x79, 0x20, 0x49, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*7719*/
const unsigned char  uc2_771A [] = {0x22, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x5F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*771A*/
const unsigned char  uc2_771F [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x20, 0x20, 0x00, 0x00 }; /*771F*/
const unsigned char  uc2_7720 [] = {0x00, 0x00, 0x03, 0xE0, 0x7A, 0x20, 0x4B, 0xE0, 0x7A, 0x80, 0x4B, 0xF0, 0x7A, 0x80, 0x4A, 0x80, 0x7A, 0x50, 0x4B, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*7720*/
const unsigned char  uc2_7722 [] = {0x10, 0x00, 0x1D, 0xE0, 0x15, 0x20, 0x6D, 0x50, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*7722*/
const unsigned char  uc2_7726 [] = {0x01, 0x40, 0x01, 0x40, 0x75, 0x40, 0x55, 0x50, 0x75, 0xE0, 0x55, 0x40, 0x75, 0x40, 0x55, 0x50, 0x75, 0x50, 0x55, 0xD0, 0x0E, 0x20, 0x00, 0x00 }; /*7726*/
const unsigned char  uc2_7728 [] = {0x00, 0x30, 0x03, 0xC0, 0x78, 0x80, 0x48, 0x40, 0x7B, 0xE0, 0x48, 0x20, 0x78, 0x40, 0x48, 0x80, 0x79, 0x00, 0x4B, 0x80, 0x04, 0x70, 0x00, 0x00 }; /*7728*/
const unsigned char  uc2_7729 [] = {0x00, 0x80, 0x07, 0xF0, 0x78, 0x80, 0x49, 0x20, 0x7A, 0x20, 0x4B, 0xC0, 0x78, 0x80, 0x49, 0x20, 0x7A, 0x20, 0x4B, 0xD0, 0x00, 0x10, 0x00, 0x00 }; /*7729*/
const unsigned char  uc2_772D [] = {0x00, 0x80, 0x00, 0x80, 0x7B, 0xE0, 0x48, 0x80, 0x7F, 0xF0, 0x48, 0x00, 0x78, 0x80, 0x48, 0x80, 0x7B, 0xE0, 0x48, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*772D*/
const unsigned char  uc2_772F [] = {0x00, 0x80, 0x7A, 0xA0, 0x4A, 0xA0, 0x79, 0xC0, 0x4F, 0xF0, 0x78, 0x80, 0x49, 0xC0, 0x7A, 0xA0, 0x4A, 0xA0, 0x04, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*772F*/
const unsigned char  uc2_7735 [] = {0x00, 0x80, 0x00, 0xE0, 0x79, 0x20, 0x4A, 0xA0, 0x78, 0xC0, 0x4B, 0x70, 0x78, 0x90, 0x4B, 0xA0, 0x78, 0x40, 0x49, 0x80, 0x06, 0x00, 0x00, 0x00 }; /*7735*/
const unsigned char  uc2_7736 [] = {0x00, 0x00, 0x07, 0xF0, 0x74, 0x00, 0x57, 0xE0, 0x74, 0x80, 0x55, 0xC0, 0x74, 0x80, 0x54, 0x80, 0x77, 0xE0, 0x54, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*7736*/
const unsigned char  uc2_7737 [] = {0x12, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x50, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7737*/
const unsigned char  uc2_7738 [] = {0x01, 0x40, 0x02, 0x60, 0x7B, 0xA0, 0x48, 0x80, 0x7A, 0x80, 0x4B, 0xE0, 0x7C, 0x80, 0x4F, 0xF0, 0x78, 0x80, 0x48, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7738*/
const unsigned char  uc2_773A [] = {0x01, 0x40, 0x01, 0x40, 0x75, 0x50, 0x53, 0x60, 0x71, 0x40, 0x53, 0x60, 0x75, 0x50, 0x51, 0x40, 0x71, 0x50, 0x52, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*773A*/
const unsigned char  uc2_773C [] = {0x00, 0x00, 0x03, 0xE0, 0x7A, 0x20, 0x4B, 0xE0, 0x7A, 0x20, 0x4B, 0xE0, 0x7A, 0x40, 0x4A, 0x50, 0x7A, 0xA0, 0x4B, 0x20, 0x02, 0x10, 0x00, 0x00 }; /*773C*/
const unsigned char  uc2_7740 [] = {0x04, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x00, 0x00 }; /*7740*/
const unsigned char  uc2_7741 [] = {0x01, 0x00, 0x01, 0xC0, 0x7E, 0x40, 0x4B, 0xE0, 0x78, 0xA0, 0x4F, 0xF0, 0x78, 0xA0, 0x4B, 0xE0, 0x78, 0x80, 0x48, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*7741*/
const unsigned char  uc2_7743 [] = {0x01, 0x40, 0x02, 0x20, 0x77, 0xD0, 0x50, 0x10, 0x72, 0x60, 0x5D, 0x10, 0x71, 0xC0, 0x53, 0x40, 0x71, 0x40, 0x50, 0x80, 0x07, 0x70, 0x00, 0x00 }; /*7743*/
const unsigned char  uc2_7747 [] = {0x01, 0x40, 0x03, 0xE0, 0x70, 0xA0, 0x53, 0xE0, 0x74, 0x80, 0x57, 0xF0, 0x71, 0x90, 0x52, 0x90, 0x72, 0xE0, 0x54, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7747*/
const unsigned char  uc2_7750 [] = {0x00, 0x80, 0x7F, 0xF0, 0x48, 0x80, 0x7A, 0xA0, 0x49, 0xC0, 0x7F, 0xF0, 0x48, 0x80, 0x79, 0xC0, 0x4A, 0xA0, 0x04, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*7750*/
const unsigned char  uc2_7751 [] = {0x01, 0x00, 0x02, 0x80, 0x74, 0x40, 0x58, 0x30, 0x77, 0xC0, 0x50, 0x00, 0x7A, 0x40, 0x55, 0x40, 0x75, 0x40, 0x50, 0x80, 0x0F, 0xE0, 0x00, 0x00 }; /*7751*/
const unsigned char  uc2_775A [] = {0x03, 0xF0, 0x02, 0x00, 0x72, 0x40, 0x52, 0xE0, 0x72, 0x40, 0x53, 0xF0, 0x72, 0x00, 0x52, 0x40, 0x74, 0xE0, 0x54, 0x40, 0x09, 0xF0, 0x00, 0x00 }; /*775A*/
const unsigned char  uc2_775B [] = {0x00, 0x80, 0x07, 0xF0, 0x78, 0x80, 0x4B, 0xE0, 0x78, 0x80, 0x4F, 0xF0, 0x7A, 0x20, 0x4B, 0xE0, 0x7A, 0x20, 0x4B, 0xA0, 0x02, 0x60, 0x00, 0x00 }; /*775B*/
const unsigned char  uc2_7761 [] = {0x00, 0x60, 0x03, 0x80, 0x70, 0x80, 0x57, 0xF0, 0x72, 0xA0, 0x57, 0xF0, 0x72, 0xA0, 0x52, 0xA0, 0x77, 0xF0, 0x50, 0x80, 0x03, 0xE0, 0x00, 0x00 }; /*7761*/
const unsigned char  uc2_7762 [] = {0x03, 0x00, 0x02, 0x80, 0x77, 0xF0, 0x5C, 0x80, 0x77, 0xE0, 0x54, 0x80, 0x77, 0xE0, 0x54, 0x80, 0x74, 0x80, 0x57, 0xF0, 0x04, 0x00, 0x00, 0x00 }; /*7762*/
const unsigned char  uc2_7763 [] = {0x10, 0x00, 0x1D, 0xE0, 0x10, 0xA0, 0x7C, 0xA0, 0x38, 0x40, 0x54, 0xB0, 0x3F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7763*/
const unsigned char  uc2_7765 [] = {0x01, 0x00, 0x03, 0xE0, 0x7A, 0xA0, 0x4B, 0xE0, 0x7A, 0xA0, 0x4B, 0xE0, 0x79, 0x00, 0x4A, 0x80, 0x7F, 0xF0, 0x48, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7765*/
const unsigned char  uc2_7766 [] = {0x00, 0x80, 0x03, 0xE0, 0x78, 0x80, 0x4F, 0xF0, 0x7A, 0x20, 0x4A, 0x10, 0x7C, 0x90, 0x48, 0x80, 0x7B, 0xE0, 0x48, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*7766*/
const unsigned char  uc2_7768 [] = {0x01, 0x80, 0x02, 0x60, 0x7A, 0x20, 0x4B, 0x60, 0x7A, 0x20, 0x4B, 0xE0, 0x79, 0x40, 0x49, 0x40, 0x79, 0x50, 0x4A, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*7768*/
const unsigned char  uc2_776B [] = {0x00, 0x80, 0x07, 0xF0, 0x70, 0xA0, 0x57, 0xF0, 0x70, 0xA0, 0x53, 0xE0, 0x70, 0x80, 0x52, 0xE0, 0x72, 0x80, 0x55, 0x80, 0x08, 0xF0, 0x00, 0x00 }; /*776B*/
const unsigned char  uc2_776C [] = {0x00, 0x70, 0x07, 0x90, 0x75, 0x10, 0x52, 0xA0, 0x70, 0x80, 0x57, 0xF0, 0x71, 0xC0, 0x52, 0xA0, 0x72, 0xA0, 0x54, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*776C*/
const unsigned char  uc2_7779 [] = {0x00, 0x90, 0x03, 0xF0, 0x78, 0xA0, 0x4F, 0xF0, 0x78, 0x80, 0x49, 0xE0, 0x7F, 0x20, 0x49, 0xE0, 0x79, 0x20, 0x49, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*7779*/
const unsigned char  uc2_777D [] = {0x07, 0x50, 0x05, 0x60, 0x72, 0x50, 0x52, 0x20, 0x7D, 0xD0, 0x50, 0x80, 0x77, 0xF0, 0x50, 0x80, 0x71, 0x60, 0x51, 0x10, 0x06, 0x10, 0x00, 0x00 }; /*777D*/
const unsigned char  uc2_777E [] = {0x02, 0x00, 0x1F, 0xC0, 0x15, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*777E*/
const unsigned char  uc2_777F [] = {0x03, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x22, 0x20, 0x1D, 0xC0, 0x70, 0x70, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*777F*/
const unsigned char  uc2_7780 [] = {0x3C, 0x80, 0x15, 0xF0, 0x7E, 0xA0, 0x2A, 0x40, 0x49, 0xB0, 0x30, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x00, 0x00 }; /*7780*/
const unsigned char  uc2_7784 [] = {0x01, 0x40, 0x07, 0xF0, 0x79, 0x40, 0x4B, 0xE0, 0x7A, 0xA0, 0x4A, 0xA0, 0x7B, 0xE0, 0x4A, 0xA0, 0x7A, 0xA0, 0x4B, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*7784*/
const unsigned char  uc2_7785 [] = {0x02, 0x40, 0x0C, 0x40, 0x75, 0x50, 0x5F, 0x50, 0x74, 0x40, 0x56, 0x40, 0x7D, 0x40, 0x54, 0xA0, 0x74, 0xA0, 0x54, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*7785*/
const unsigned char  uc2_778C [] = {0x00, 0x80, 0x03, 0xE0, 0x70, 0x80, 0x57, 0xF0, 0x71, 0x40, 0x53, 0xE0, 0x70, 0x20, 0x57, 0xF0, 0x75, 0x50, 0x55, 0x50, 0x0F, 0xF0, 0x00, 0x00 }; /*778C*/
const unsigned char  uc2_778D [] = {0x00, 0x80, 0x01, 0x80, 0x76, 0xF0, 0x54, 0x90, 0x76, 0xB0, 0x54, 0x90, 0x77, 0xF0, 0x52, 0x20, 0x71, 0x40, 0x50, 0x80, 0x07, 0x70, 0x00, 0x00 }; /*778D*/
const unsigned char  uc2_778E [] = {0x00, 0x80, 0x07, 0xF0, 0x7C, 0x90, 0x4B, 0xE0, 0x78, 0x80, 0x4B, 0xE0, 0x78, 0x80, 0x4F, 0xF0, 0x7A, 0x20, 0x4B, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*778E*/
const unsigned char  uc2_7791 [] = {0x07, 0xF0, 0x04, 0x10, 0x7B, 0xE0, 0x4A, 0x20, 0x7B, 0xE0, 0x4A, 0x20, 0x7B, 0xE0, 0x48, 0x80, 0x7F, 0xF0, 0x49, 0x20, 0x06, 0x10, 0x00, 0x00 }; /*7791*/
const unsigned char  uc2_7792 [] = {0x01, 0x40, 0x73, 0xE0, 0x51, 0x40, 0x70, 0x00, 0x57, 0xF0, 0x71, 0x40, 0x57, 0xF0, 0x75, 0x50, 0x56, 0xB0, 0x04, 0x10, 0x04, 0xE0, 0x00, 0x00 }; /*7792*/
const unsigned char  uc2_779F [] = {0x07, 0xF0, 0x71, 0x40, 0x57, 0xF0, 0x75, 0x50, 0x57, 0xF0, 0x70, 0x00, 0x53, 0xE0, 0x70, 0x00, 0x57, 0xF0, 0x02, 0xA0, 0x05, 0x90, 0x00, 0x00 }; /*779F*/
const unsigned char  uc2_77A0 [] = {0x04, 0x90, 0x02, 0xA0, 0x77, 0xF0, 0x54, 0x10, 0x75, 0xD0, 0x51, 0x40, 0x71, 0xC0, 0x50, 0x80, 0x73, 0xE0, 0x50, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*77A0*/
const unsigned char  uc2_77A2 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x50, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*77A2*/
const unsigned char  uc2_77A5 [] = {0x2A, 0x40, 0x7F, 0x70, 0x49, 0xA0, 0x5D, 0x40, 0x6B, 0xB0, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*77A5*/
const unsigned char  uc2_77A7 [] = {0x02, 0x80, 0x73, 0xF0, 0x5C, 0x80, 0x77, 0xE0, 0x54, 0x80, 0x77, 0xE0, 0x54, 0x80, 0x77, 0xF0, 0x50, 0x00, 0x02, 0xA0, 0x0D, 0x50, 0x00, 0x00 }; /*77A7*/
const unsigned char  uc2_77A9 [] = {0x07, 0xE0, 0x04, 0x20, 0x77, 0xE0, 0x54, 0x80, 0x75, 0xE0, 0x56, 0xA0, 0x77, 0xF0, 0x54, 0x90, 0x75, 0x50, 0x55, 0xD0, 0x08, 0x20, 0x00, 0x00 }; /*77A9*/
const unsigned char  uc2_77AA [] = {0x07, 0x50, 0x01, 0x60, 0x76, 0x50, 0x53, 0xE0, 0x74, 0x20, 0x5B, 0xD0, 0x72, 0x40, 0x53, 0xC0, 0x72, 0x40, 0x51, 0x80, 0x0F, 0xF0, 0x00, 0x00 }; /*77AA*/
const unsigned char  uc2_77AC [] = {0x00, 0x70, 0x07, 0x90, 0x72, 0xA0, 0x57, 0xF0, 0x74, 0x10, 0x52, 0x20, 0x73, 0xF0, 0x52, 0xA0, 0x77, 0xF0, 0x51, 0x20, 0x0E, 0x20, 0x00, 0x00 }; /*77AC*/
const unsigned char  uc2_77B0 [] = {0x06, 0x40, 0x02, 0x70, 0x7F, 0xD0, 0x55, 0x50, 0x77, 0x50, 0x55, 0x50, 0x77, 0x50, 0x55, 0x20, 0x77, 0xA0, 0x5D, 0x50, 0x01, 0x90, 0x00, 0x00 }; /*77B0*/
const unsigned char  uc2_77B3 [] = {0x00, 0x80, 0x03, 0xE0, 0x79, 0x40, 0x4F, 0xF0, 0x7B, 0x60, 0x4A, 0xA0, 0x7B, 0xE0, 0x48, 0x80, 0x7B, 0xE0, 0x48, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*77B3*/
const unsigned char  uc2_77B5 [] = {0x00, 0x80, 0x02, 0xA0, 0x77, 0xF0, 0x52, 0xA0, 0x74, 0x90, 0x52, 0x20, 0x73, 0xF0, 0x52, 0xA0, 0x75, 0xF0, 0x51, 0x20, 0x06, 0x20, 0x00, 0x00 }; /*77B5*/
const unsigned char  uc2_77BB [] = {0x01, 0xC0, 0x72, 0x40, 0x57, 0xF0, 0x75, 0x20, 0x57, 0xF0, 0x74, 0x00, 0x55, 0xE0, 0x74, 0x00, 0x55, 0xE0, 0x05, 0x20, 0x09, 0xE0, 0x00, 0x00 }; /*77BB*/
const unsigned char  uc2_77BD [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x7F, 0xE0, 0x22, 0xA0, 0x3E, 0x40, 0x14, 0xB0, 0x7F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*77BD*/
const unsigned char  uc2_77BF [] = {0x1E, 0xF0, 0x12, 0x90, 0x1E, 0xF0, 0x12, 0x90, 0x1E, 0xF0, 0x09, 0x00, 0x1F, 0xF0, 0x31, 0x00, 0x5F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*77BF*/
const unsigned char  uc2_77CD [] = {0x3D, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x3F, 0xF0, 0x62, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x3F, 0xF0, 0x28, 0x40, 0x07, 0x80, 0x78, 0x70, 0x00, 0x00 }; /*77CD*/
const unsigned char  uc2_77D7 [] = {0x02, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x7D, 0xF0, 0x28, 0xA0, 0x2C, 0xA0, 0x71, 0xF0, 0x00, 0x00 }; /*77D7*/
const unsigned char  uc2_77DB [] = {0x0F, 0x80, 0x00, 0x80, 0x07, 0x00, 0x01, 0x00, 0x3F, 0xF0, 0x05, 0x10, 0x09, 0x20, 0x11, 0x00, 0x61, 0x00, 0x01, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*77DB*/
const unsigned char  uc2_77DC [] = {0x3C, 0x40, 0x14, 0x40, 0x08, 0xA0, 0x7F, 0x10, 0x1A, 0xC0, 0x2A, 0x20, 0x2D, 0xF0, 0x48, 0x10, 0x08, 0x10, 0x08, 0x20, 0x30, 0xC0, 0x00, 0x00 }; /*77DC*/
const unsigned char  uc2_77E2 [] = {0x10, 0x00, 0x1F, 0xC0, 0x12, 0x00, 0x22, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x05, 0x00, 0x05, 0x00, 0x08, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*77E2*/
const unsigned char  uc2_77E3 [] = {0x08, 0x80, 0x10, 0x40, 0x3F, 0xA0, 0x10, 0x20, 0x1F, 0xC0, 0x62, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*77E3*/
const unsigned char  uc2_77E5 [] = {0x20, 0x00, 0x20, 0x00, 0x3E, 0xF0, 0x48, 0x90, 0x08, 0x90, 0x7F, 0x90, 0x08, 0x90, 0x14, 0x90, 0x12, 0xF0, 0x22, 0x90, 0x40, 0x00, 0x00, 0x00 }; /*77E5*/
const unsigned char  uc2_77E7 [] = {0x20, 0x10, 0x23, 0xD0, 0x3C, 0x50, 0x49, 0xD0, 0x09, 0x10, 0x7F, 0xD0, 0x08, 0x50, 0x14, 0x50, 0x12, 0x50, 0x22, 0x50, 0x41, 0x90, 0x00, 0x00 }; /*77E7*/
const unsigned char  uc2_77E9 [] = {0x20, 0x00, 0x21, 0xF0, 0x3F, 0x00, 0x29, 0x00, 0x49, 0xF0, 0x7F, 0x10, 0x09, 0x10, 0x15, 0xF0, 0x13, 0x00, 0x21, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*77E9*/
const unsigned char  uc2_77EB [] = {0x20, 0x20, 0x20, 0xC0, 0x3E, 0x40, 0x29, 0xF0, 0x48, 0xA0, 0x7F, 0x10, 0x08, 0xA0, 0x14, 0xA0, 0x12, 0xA0, 0x21, 0x20, 0x42, 0x20, 0x00, 0x00 }; /*77EB*/
const unsigned char  uc2_77EC [] = {0x20, 0x80, 0x20, 0x80, 0x3A, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x7D, 0xD0, 0x10, 0x80, 0x2B, 0xE0, 0x24, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*77EC*/
const unsigned char  uc2_77ED [] = {0x20, 0x00, 0x23, 0xF0, 0x38, 0x00, 0x51, 0xE0, 0x11, 0x20, 0x7D, 0x20, 0x11, 0xE0, 0x28, 0x00, 0x25, 0x20, 0x20, 0xC0, 0x43, 0xF0, 0x00, 0x00 }; /*77ED*/
const unsigned char  uc2_77EE [] = {0x20, 0x20, 0x21, 0xC0, 0x3C, 0x40, 0x53, 0xF0, 0x11, 0x60, 0x7E, 0x50, 0x10, 0x80, 0x13, 0xF0, 0x29, 0x20, 0x28, 0xE0, 0x4B, 0x10, 0x00, 0x00 }; /*77EE*/
const unsigned char  uc2_77F3 [] = {0x00, 0x00, 0x3F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x04, 0x00, 0x0F, 0xE0, 0x18, 0x20, 0x68, 0x20, 0x08, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x00, 0x00 }; /*77F3*/
const unsigned char  uc2_77F6 [] = {0x00, 0x00, 0x01, 0xC0, 0x7F, 0x40, 0x09, 0x40, 0x11, 0x40, 0x1D, 0x40, 0x75, 0x40, 0x15, 0x50, 0x1D, 0x50, 0x12, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*77F6*/
const unsigned char  uc2_77F8 [] = {0x00, 0x00, 0x03, 0xE0, 0x7C, 0x80, 0x10, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x68, 0x80, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*77F8*/
const unsigned char  uc2_77FD [] = {0x00, 0x80, 0x00, 0x80, 0x3E, 0xF0, 0x08, 0x90, 0x10, 0x90, 0x1D, 0x50, 0x75, 0x50, 0x16, 0x20, 0x1C, 0x20, 0x14, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*77FD*/
const unsigned char  uc2_77FE [] = {0x00, 0x00, 0x03, 0xC0, 0x7E, 0x40, 0x12, 0x40, 0x23, 0x40, 0x3A, 0xC0, 0x6A, 0x40, 0x2A, 0x40, 0x3A, 0x50, 0x24, 0x50, 0x08, 0x20, 0x00, 0x00 }; /*77FE*/
const unsigned char  uc2_77FF [] = {0x01, 0x80, 0x00, 0x40, 0x7F, 0xF0, 0x12, 0x00, 0x22, 0x00, 0x3A, 0x00, 0x6A, 0x00, 0x2A, 0x00, 0x3A, 0x00, 0x24, 0x00, 0x08, 0x00, 0x00, 0x00 }; /*77FF*/
const unsigned char  uc2_7800 [] = {0x03, 0xC0, 0x78, 0x40, 0x11, 0x80, 0x22, 0x00, 0x3B, 0xF0, 0x69, 0x50, 0x29, 0x50, 0x2A, 0x90, 0x38, 0x90, 0x21, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*7800*/
const unsigned char  uc2_7801 [] = {0x03, 0xE0, 0x78, 0x20, 0x11, 0x20, 0x22, 0x40, 0x3B, 0xF0, 0x68, 0x10, 0x28, 0x10, 0x2B, 0xD0, 0x38, 0x10, 0x28, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*7801*/
const unsigned char  uc2_7802 [] = {0x00, 0x80, 0x78, 0x80, 0x12, 0xA0, 0x22, 0x90, 0x3C, 0x90, 0x68, 0xA0, 0x28, 0xA0, 0x28, 0x40, 0x38, 0x40, 0x28, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*7802*/
const unsigned char  uc2_7809 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x00, 0x1F, 0xE0, 0x70, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*7809*/
const unsigned char  uc2_780C [] = {0x02, 0x00, 0x7A, 0xF0, 0x12, 0x50, 0x23, 0xD0, 0x3E, 0x50, 0x6A, 0x50, 0x2A, 0xD0, 0x2B, 0x50, 0x38, 0x90, 0x28, 0x90, 0x01, 0x60, 0x00, 0x00 }; /*780C*/
const unsigned char  uc2_780D [] = {0x01, 0x00, 0x79, 0xF0, 0x11, 0x10, 0x22, 0xA0, 0x38, 0x80, 0x68, 0x80, 0x29, 0x40, 0x29, 0x40, 0x3A, 0x20, 0x2A, 0x20, 0x04, 0x10, 0x00, 0x00 }; /*780D*/
const unsigned char  uc2_7811 [] = {0x00, 0x00, 0x7B, 0xE0, 0x11, 0x40, 0x22, 0x40, 0x3B, 0xF0, 0x68, 0xC0, 0x29, 0x40, 0x29, 0x40, 0x3A, 0x40, 0x2C, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*7811*/
const unsigned char  uc2_7812 [] = {0x02, 0x40, 0x7A, 0x40, 0x12, 0x40, 0x22, 0x50, 0x3B, 0xE0, 0x6A, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x3A, 0x50, 0x2A, 0xD0, 0x03, 0x20, 0x00, 0x00 }; /*7812*/
const unsigned char  uc2_7814 [] = {0x00, 0x00, 0x7B, 0xE0, 0x11, 0x40, 0x21, 0x40, 0x3F, 0xF0, 0x69, 0x40, 0x29, 0x40, 0x29, 0x40, 0x3A, 0x40, 0x2A, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*7814*/
const unsigned char  uc2_7816 [] = {0x00, 0x80, 0x78, 0x80, 0x13, 0xE0, 0x20, 0x80, 0x3F, 0xF0, 0x69, 0x00, 0x2B, 0xE0, 0x28, 0x20, 0x3B, 0x40, 0x28, 0x80, 0x00, 0x40, 0x00, 0x00 }; /*7816*/
const unsigned char  uc2_7817 [] = {0x00, 0x80, 0x7B, 0xE0, 0x11, 0x00, 0x21, 0x00, 0x3A, 0x80, 0x6B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x28, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7817*/
const unsigned char  uc2_7818 [] = {0x00, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x20, 0x80, 0x3A, 0xA0, 0x6A, 0xA0, 0x2B, 0xE0, 0x28, 0xA0, 0x38, 0x90, 0x28, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*7818*/
const unsigned char  uc2_781A [] = {0x03, 0xE0, 0x7A, 0x20, 0x12, 0xA0, 0x22, 0xA0, 0x3A, 0xA0, 0x6A, 0xA0, 0x28, 0x80, 0x29, 0x40, 0x39, 0x50, 0x2A, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*781A*/
const unsigned char  uc2_781C [] = {0x07, 0xC0, 0x7C, 0x40, 0x14, 0xC0, 0x25, 0x40, 0x3D, 0x40, 0x67, 0x40, 0x25, 0xC0, 0x25, 0x40, 0x3E, 0x50, 0x24, 0x50, 0x08, 0x20, 0x00, 0x00 }; /*781C*/
const unsigned char  uc2_781D [] = {0x00, 0x80, 0x78, 0x80, 0x13, 0xE0, 0x20, 0x80, 0x38, 0x80, 0x6F, 0xF0, 0x28, 0x80, 0x29, 0x20, 0x3A, 0x60, 0x2B, 0x90, 0x00, 0x10, 0x00, 0x00 }; /*781D*/
const unsigned char  uc2_781F [] = {0x01, 0x00, 0x7D, 0x00, 0x11, 0xF0, 0x23, 0x00, 0x3D, 0x00, 0x69, 0xC0, 0x29, 0x00, 0x29, 0x00, 0x39, 0xE0, 0x29, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*781F*/
const unsigned char  uc2_7823 [] = {0x00, 0x80, 0x7F, 0xF0, 0x14, 0x10, 0x24, 0x10, 0x39, 0x00, 0x69, 0x20, 0x29, 0xC0, 0x29, 0x10, 0x39, 0x10, 0x29, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*7823*/
const unsigned char  uc2_7825 [] = {0x00, 0x30, 0x7B, 0xC0, 0x12, 0x40, 0x22, 0x40, 0x3B, 0xF0, 0x6A, 0x40, 0x2A, 0x40, 0x2A, 0xC0, 0x3B, 0x50, 0x29, 0x50, 0x00, 0xA0, 0x00, 0x00 }; /*7825*/
const unsigned char  uc2_7826 [] = {0x08, 0x80, 0x2E, 0xA0, 0x28, 0xC0, 0x2E, 0x90, 0x30, 0x90, 0x7F, 0xE0, 0x04, 0x00, 0x1F, 0xE0, 0x70, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*7826*/
const unsigned char  uc2_7827 [] = {0x00, 0x80, 0x78, 0x80, 0x10, 0xF0, 0x20, 0x80, 0x38, 0x80, 0x6B, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x3A, 0x20, 0x2B, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*7827*/
const unsigned char  uc2_7829 [] = {0x01, 0x40, 0x7F, 0xF0, 0x11, 0x50, 0x23, 0xF0, 0x3D, 0x40, 0x6F, 0xF0, 0x29, 0x50, 0x29, 0x50, 0x3A, 0x60, 0x2A, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*7829*/
const unsigned char  uc2_782C [] = {0x01, 0x80, 0x78, 0x40, 0x17, 0xF0, 0x20, 0x00, 0x3A, 0x20, 0x69, 0x20, 0x29, 0x20, 0x29, 0x40, 0x38, 0x40, 0x20, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*782C*/
const unsigned char  uc2_782D [] = {0x00, 0x60, 0x7B, 0x80, 0x11, 0x00, 0x20, 0x80, 0x3B, 0xE0, 0x68, 0x20, 0x28, 0x40, 0x28, 0x80, 0x39, 0x00, 0x2B, 0x80, 0x04, 0x70, 0x00, 0x00 }; /*782D*/
const unsigned char  uc2_7830 [] = {0x00, 0x00, 0x7B, 0xE0, 0x10, 0x80, 0x22, 0xA0, 0x39, 0xC0, 0x68, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7830*/
const unsigned char  uc2_7834 [] = {0x00, 0x40, 0x7B, 0xF0, 0x12, 0x50, 0x22, 0x50, 0x3B, 0xE0, 0x6A, 0xA0, 0x2A, 0xA0, 0x2A, 0x40, 0x3A, 0xA0, 0x22, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*7834*/
const unsigned char  uc2_7837 [] = {0x00, 0x80, 0x78, 0x80, 0x13, 0xE0, 0x22, 0xA0, 0x3B, 0xE0, 0x6A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x38, 0x80, 0x28, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7837*/
const unsigned char  uc2_7838 [] = {0x07, 0xF0, 0x7C, 0x00, 0x14, 0x40, 0x25, 0xF0, 0x3D, 0x50, 0x65, 0x50, 0x25, 0x50, 0x25, 0x60, 0x3C, 0x40, 0x24, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*7838*/
const unsigned char  uc2_7839 [] = {0x02, 0x20, 0x7F, 0xF0, 0x12, 0x20, 0x20, 0x00, 0x3A, 0x20, 0x6A, 0x20, 0x29, 0x40, 0x29, 0x40, 0x38, 0x80, 0x29, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*7839*/
const unsigned char  uc2_783A [] = {0x03, 0xF0, 0x7A, 0x00, 0x13, 0xF0, 0x22, 0x80, 0x3A, 0xE0, 0x6A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x22, 0xA0, 0x05, 0x40, 0x00, 0x00 }; /*783A*/
const unsigned char  uc2_783B [] = {0x04, 0x40, 0x3F, 0xF0, 0x0A, 0x80, 0x13, 0x10, 0x6D, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xE0, 0x68, 0x20, 0x0F, 0xE0, 0x00, 0x00 }; /*783B*/
const unsigned char  uc2_783C [] = {0x00, 0x80, 0x78, 0x80, 0x11, 0x40, 0x26, 0x30, 0x38, 0x00, 0x6B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*783C*/
const unsigned char  uc2_783E [] = {0x00, 0x30, 0x7D, 0xC0, 0x11, 0x00, 0x21, 0x40, 0x39, 0x40, 0x69, 0xF0, 0x28, 0x40, 0x29, 0x60, 0x39, 0x50, 0x22, 0x50, 0x01, 0x80, 0x00, 0x00 }; /*783E*/
const unsigned char  uc2_7840 [] = {0x00, 0x80, 0x7A, 0xA0, 0x12, 0xA0, 0x22, 0xA0, 0x3B, 0xE0, 0x68, 0x80, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2B, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*7840*/
const unsigned char  uc2_7845 [] = {0x00, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x68, 0x00, 0x28, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x28, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*7845*/
const unsigned char  uc2_7847 [] = {0x00, 0x80, 0x7B, 0xF0, 0x12, 0x10, 0x22, 0x50, 0x3B, 0x50, 0x6A, 0x90, 0x2B, 0x50, 0x2A, 0x50, 0x3A, 0x10, 0x2B, 0xF0, 0x02, 0x10, 0x00, 0x00 }; /*7847*/
const unsigned char  uc2_784C [] = {0x01, 0x00, 0x79, 0xC0, 0x11, 0x40, 0x22, 0x80, 0x39, 0x40, 0x6E, 0x30, 0x29, 0xC0, 0x29, 0x40, 0x39, 0x40, 0x29, 0xC0, 0x01, 0x40, 0x00, 0x00 }; /*784C*/
const unsigned char  uc2_784E [] = {0x00, 0x10, 0x7F, 0x90, 0x25, 0x50, 0x45, 0x50, 0x7F, 0xD0, 0x55, 0x50, 0x55, 0x50, 0x55, 0x50, 0x75, 0x50, 0x55, 0x10, 0x09, 0x60, 0x00, 0x00 }; /*784E*/
const unsigned char  uc2_7850 [] = {0x07, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x24, 0x10, 0x3D, 0xD0, 0x65, 0x50, 0x25, 0x50, 0x25, 0xD0, 0x3C, 0x10, 0x24, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*7850*/
const unsigned char  uc2_7852 [] = {0x07, 0xF0, 0x79, 0x40, 0x11, 0x40, 0x27, 0xF0, 0x3D, 0x50, 0x65, 0x50, 0x25, 0x30, 0x26, 0x10, 0x3C, 0x10, 0x27, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*7852*/
const unsigned char  uc2_7855 [] = {0x07, 0xF0, 0x78, 0x80, 0x11, 0x00, 0x23, 0xE0, 0x3A, 0x20, 0x6A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x39, 0x00, 0x29, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*7855*/
const unsigned char  uc2_7856 [] = {0x00, 0x80, 0x78, 0x80, 0x13, 0xE0, 0x20, 0x80, 0x3A, 0xA0, 0x69, 0xC0, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x29, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*7856*/
const unsigned char  uc2_7857 [] = {0x01, 0x60, 0x7B, 0x80, 0x10, 0xE0, 0x23, 0x90, 0x38, 0x60, 0x68, 0x00, 0x2F, 0xF0, 0x29, 0x40, 0x39, 0x50, 0x2A, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*7857*/
const unsigned char  uc2_785D [] = {0x00, 0x80, 0x7A, 0x90, 0x11, 0xA0, 0x23, 0xF0, 0x3A, 0x10, 0x6B, 0xF0, 0x2A, 0x10, 0x2B, 0xF0, 0x3A, 0x10, 0x2A, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*785D*/
const unsigned char  uc2_786A [] = {0x01, 0x80, 0x7E, 0xC0, 0x12, 0xA0, 0x27, 0xF0, 0x3A, 0x80, 0x6B, 0xA0, 0x2A, 0xA0, 0x2E, 0x40, 0x3A, 0x50, 0x2A, 0xD0, 0x05, 0x20, 0x00, 0x00 }; /*786A*/
const unsigned char  uc2_786B [] = {0x01, 0x00, 0x78, 0x80, 0x17, 0xF0, 0x21, 0x00, 0x7A, 0x20, 0x2B, 0xD0, 0x28, 0x00, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*786B*/
const unsigned char  uc2_786C [] = {0x07, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x22, 0xA0, 0x3B, 0xE0, 0x6A, 0xA0, 0x2B, 0xE0, 0x2C, 0x80, 0x3B, 0x00, 0x29, 0x80, 0x06, 0x70, 0x00, 0x00 }; /*786C*/
const unsigned char  uc2_786D [] = {0x02, 0x20, 0x7F, 0xF0, 0x12, 0x20, 0x21, 0x00, 0x38, 0x80, 0x6F, 0xF0, 0x2A, 0x00, 0x2A, 0x00, 0x3A, 0x00, 0x2A, 0x00, 0x01, 0xE0, 0x00, 0x00 }; /*786D*/
const unsigned char  uc2_786E [] = {0x02, 0x00, 0x7B, 0xC0, 0x14, 0x40, 0x27, 0xF0, 0x3C, 0x90, 0x67, 0xF0, 0x24, 0x90, 0x27, 0xF0, 0x3C, 0x90, 0x24, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*786E*/
const unsigned char  uc2_7877 [] = {0x00, 0x80, 0x79, 0x40, 0x16, 0x30, 0x20, 0x00, 0x3B, 0xE0, 0x69, 0x00, 0x2C, 0xA0, 0x2A, 0xA0, 0x3A, 0x40, 0x20, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*7877*/
const unsigned char  uc2_787C [] = {0x07, 0x70, 0x7D, 0x50, 0x15, 0x50, 0x27, 0x70, 0x3D, 0x50, 0x65, 0x50, 0x27, 0x70, 0x25, 0x50, 0x3D, 0x50, 0x25, 0x50, 0x0A, 0xA0, 0x00, 0x00 }; /*787C*/
const unsigned char  uc2_7887 [] = {0x00, 0x80, 0x7F, 0xF0, 0x14, 0x10, 0x20, 0x00, 0x3B, 0xE0, 0x68, 0x80, 0x2A, 0x80, 0x2A, 0xE0, 0x3A, 0x80, 0x2B, 0x80, 0x04, 0x70, 0x00, 0x00 }; /*7887*/
const unsigned char  uc2_7889 [] = {0x07, 0xF0, 0x7C, 0x90, 0x15, 0xD0, 0x24, 0x90, 0x3D, 0xD0, 0x64, 0x10, 0x25, 0xD0, 0x25, 0x50, 0x3D, 0xD0, 0x24, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*7889*/
const unsigned char  uc2_788C [] = {0x03, 0xE0, 0x78, 0x20, 0x11, 0xC0, 0x20, 0x40, 0x3F, 0xF0, 0x68, 0x80, 0x2E, 0xD0, 0x29, 0xA0, 0x3E, 0xA0, 0x20, 0x90, 0x03, 0x00, 0x00, 0x00 }; /*788C*/
const unsigned char  uc2_788D [] = {0x03, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x22, 0x20, 0x3B, 0xE0, 0x68, 0x00, 0x2B, 0xE0, 0x28, 0x40, 0x3F, 0xF0, 0x2A, 0x40, 0x00, 0xC0, 0x00, 0x00 }; /*788D*/
const unsigned char  uc2_788E [] = {0x00, 0x80, 0x7F, 0xF0, 0x12, 0x20, 0x22, 0x20, 0x3D, 0x50, 0x68, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x28, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*788E*/
const unsigned char  uc2_7891 [] = {0x00, 0x80, 0x7B, 0xE0, 0x12, 0xA0, 0x23, 0xE0, 0x3A, 0xA0, 0x6B, 0xE0, 0x29, 0x00, 0x2A, 0x80, 0x3F, 0xF0, 0x28, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*7891*/
const unsigned char  uc2_7893 [] = {0x02, 0x80, 0x7A, 0x40, 0x13, 0xF0, 0x26, 0x40, 0x3B, 0xE0, 0x6A, 0x40, 0x2B, 0xE0, 0x2A, 0x40, 0x3A, 0x40, 0x2B, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7893*/
const unsigned char  uc2_7897 [] = {0x00, 0x80, 0x7F, 0xF0, 0x14, 0x10, 0x22, 0x00, 0x3B, 0x70, 0x6D, 0x50, 0x2B, 0x50, 0x29, 0x60, 0x3A, 0x50, 0x2A, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*7897*/
const unsigned char  uc2_7898 [] = {0x01, 0x40, 0x77, 0xF0, 0x25, 0x50, 0x45, 0x50, 0x77, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x5F, 0xF0, 0x70, 0x00, 0x51, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*7898*/
const unsigned char  uc2_789A [] = {0x00, 0x80, 0x7B, 0xE0, 0x12, 0x20, 0x21, 0x40, 0x3F, 0xF0, 0x68, 0x00, 0x2B, 0xE0, 0x2A, 0x20, 0x3A, 0x20, 0x2B, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*789A*/
const unsigned char  uc2_789B [] = {0x00, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x23, 0xE0, 0x38, 0x80, 0x6F, 0xF0, 0x2A, 0x20, 0x2A, 0xA0, 0x38, 0x80, 0x29, 0x20, 0x06, 0x10, 0x00, 0x00 }; /*789B*/
const unsigned char  uc2_789C [] = {0x01, 0x20, 0x7B, 0xD0, 0x10, 0x80, 0x27, 0xF0, 0x39, 0x40, 0x6E, 0xB0, 0x29, 0x40, 0x28, 0x90, 0x3B, 0x20, 0x20, 0xC0, 0x03, 0x00, 0x00, 0x00 }; /*789C*/
const unsigned char  uc2_789F [] = {0x02, 0xA0, 0x7F, 0xF0, 0x12, 0xA0, 0x22, 0xE0, 0x3A, 0x00, 0x6B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x3A, 0xA0, 0x2C, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*789F*/
const unsigned char  uc2_78A1 [] = {0x00, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x23, 0xE0, 0x38, 0x80, 0x6F, 0xF0, 0x2A, 0xA0, 0x2F, 0xF0, 0x3A, 0xA0, 0x2B, 0xF0, 0x00, 0x40, 0x00, 0x00 }; /*78A1*/
const unsigned char  uc2_78A3 [] = {0x03, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x22, 0x20, 0x3B, 0xE0, 0x69, 0x00, 0x2B, 0xF0, 0x2E, 0x90, 0x3B, 0x50, 0x2B, 0xD0, 0x00, 0x60, 0x00, 0x00 }; /*78A3*/
const unsigned char  uc2_78A5 [] = {0x00, 0x80, 0x7F, 0xF0, 0x14, 0x10, 0x27, 0xF0, 0x3C, 0x00, 0x67, 0xF0, 0x25, 0x50, 0x27, 0xF0, 0x3D, 0x50, 0x25, 0x50, 0x09, 0x20, 0x00, 0x00 }; /*78A5*/
const unsigned char  uc2_78A7 [] = {0x00, 0x80, 0x7D, 0xE0, 0x11, 0x20, 0x39, 0xE0, 0x11, 0x20, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xE0, 0x68, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x00, 0x00 }; /*78A7*/
const unsigned char  uc2_78B0 [] = {0x02, 0x20, 0x79, 0x40, 0x17, 0xF0, 0x21, 0x40, 0x39, 0x50, 0x6D, 0x50, 0x2B, 0x50, 0x29, 0x60, 0x39, 0x40, 0x29, 0x40, 0x07, 0xF0, 0x00, 0x00 }; /*78B0*/
const unsigned char  uc2_78B1 [] = {0x00, 0x50, 0x7F, 0xF0, 0x14, 0x40, 0x27, 0xC0, 0x3C, 0x50, 0x67, 0x50, 0x25, 0x50, 0x27, 0x60, 0x3C, 0x50, 0x25, 0xD0, 0x08, 0x20, 0x00, 0x00 }; /*78B1*/
const unsigned char  uc2_78B2 [] = {0x00, 0x80, 0x7F, 0xF0, 0x11, 0x40, 0x27, 0xF0, 0x3C, 0x90, 0x6B, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xC0, 0x00, 0x80, 0x00, 0x00 }; /*78B2*/
const unsigned char  uc2_78B3 [] = {0x00, 0x80, 0x7A, 0xA0, 0x13, 0xE0, 0x22, 0x00, 0x3F, 0xF0, 0x6A, 0x40, 0x2A, 0xD0, 0x2B, 0x50, 0x3A, 0xA0, 0x22, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*78B3*/
const unsigned char  uc2_78B4 [] = {0x00, 0x80, 0x07, 0xF0, 0x79, 0xC0, 0x12, 0xA0, 0x24, 0x90, 0x38, 0x00, 0x6B, 0xE0, 0x2A, 0x20, 0x3B, 0xE0, 0x2A, 0x20, 0x07, 0xF0, 0x00, 0x00 }; /*78B4*/
const unsigned char  uc2_78B9 [] = {0x01, 0x00, 0x78, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x3B, 0xE0, 0x68, 0x00, 0x2B, 0xE0, 0x2A, 0x20, 0x3B, 0xE0, 0x2A, 0x20, 0x07, 0xF0, 0x00, 0x00 }; /*78B9*/
const unsigned char  uc2_78BE [] = {0x0F, 0xE0, 0x78, 0x20, 0x2F, 0xE0, 0x29, 0x40, 0x3B, 0xE0, 0x69, 0x40, 0x2F, 0xF0, 0x2A, 0xA0, 0x3A, 0x40, 0x2B, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*78BE*/
const unsigned char  uc2_78C1 [] = {0x01, 0x40, 0x7F, 0xF0, 0x12, 0x20, 0x24, 0x40, 0x3D, 0x50, 0x6B, 0x70, 0x2A, 0x20, 0x2D, 0x50, 0x3D, 0x50, 0x27, 0x70, 0x01, 0x10, 0x00, 0x00 }; /*78C1*/
const unsigned char  uc2_78C5 [] = {0x00, 0x80, 0x7F, 0xF0, 0x11, 0x40, 0x27, 0xF0, 0x3C, 0x90, 0x6B, 0xE0, 0x29, 0x00, 0x29, 0xE0, 0x39, 0x20, 0x2A, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*78C5*/
const unsigned char  uc2_78C9 [] = {0x03, 0xC0, 0x79, 0x40, 0x10, 0x80, 0x27, 0x70, 0x3D, 0x50, 0x6A, 0x20, 0x2D, 0x50, 0x28, 0x80, 0x3F, 0xF0, 0x29, 0xC0, 0x06, 0xB0, 0x00, 0x00 }; /*78C9*/
const unsigned char  uc2_78CA [] = {0x3F, 0xE0, 0x04, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x00, 0x00, 0x7D, 0xF0, 0x10, 0x40, 0x3C, 0xF0, 0x65, 0x90, 0x3C, 0xF0, 0x00, 0x00 }; /*78CA*/
const unsigned char  uc2_78CB [] = {0x01, 0x40, 0x7F, 0xF0, 0x10, 0x80, 0x23, 0xE0, 0x38, 0x80, 0x6F, 0xF0, 0x29, 0x00, 0x29, 0xE0, 0x3A, 0x40, 0x24, 0x40, 0x03, 0xF0, 0x00, 0x00 }; /*78CB*/
const unsigned char  uc2_78D0 [] = {0x10, 0xE0, 0x3E, 0xA0, 0x2B, 0xF0, 0x7E, 0xA0, 0x2A, 0x40, 0x44, 0xA0, 0x7F, 0xF0, 0x04, 0x00, 0x1F, 0xE0, 0x68, 0x20, 0x0F, 0xE0, 0x00, 0x00 }; /*78D0*/
const unsigned char  uc2_78D4 [] = {0x02, 0x20, 0x7B, 0xF0, 0x12, 0xA0, 0x25, 0xF0, 0x39, 0x20, 0x6A, 0x80, 0x2F, 0xF0, 0x29, 0xC0, 0x3A, 0xA0, 0x2A, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*78D4*/
const unsigned char  uc2_78D5 [] = {0x00, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x27, 0xF0, 0x39, 0x20, 0x6B, 0xD0, 0x28, 0x00, 0x2F, 0xF0, 0x3D, 0x50, 0x25, 0x50, 0x0F, 0xF0, 0x00, 0x00 }; /*78D5*/
const unsigned char  uc2_78D9 [] = {0x00, 0x80, 0x7B, 0xF0, 0x11, 0x20, 0x26, 0x90, 0x79, 0x20, 0x29, 0xD0, 0x28, 0x80, 0x29, 0x50, 0x3F, 0x20, 0x29, 0xA0, 0x01, 0x10, 0x00, 0x00 }; /*78D9*/
const unsigned char  uc2_78E8 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x3F, 0xF0, 0x22, 0x00, 0x27, 0xE0, 0x5C, 0x20, 0x47, 0xE0, 0x00, 0x00 }; /*78E8*/
const unsigned char  uc2_78EC [] = {0x08, 0xE0, 0x7E, 0xA0, 0x2B, 0x30, 0x3E, 0xE0, 0x20, 0xA0, 0x40, 0x40, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xE0, 0x70, 0x20, 0x1F, 0xE0, 0x00, 0x00 }; /*78EC*/
const unsigned char  uc2_78F2 [] = {0x06, 0xF0, 0x79, 0x80, 0x16, 0xE0, 0x21, 0xA0, 0x3A, 0xC0, 0x6C, 0xF0, 0x28, 0x80, 0x2F, 0xF0, 0x3A, 0xA0, 0x2C, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*78F2*/
const unsigned char  uc2_78F4 [] = {0x03, 0x50, 0x79, 0x60, 0x15, 0x50, 0x23, 0xE0, 0x3C, 0x10, 0x6B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x3A, 0x20, 0x29, 0x40, 0x07, 0xF0, 0x00, 0x00 }; /*78F4*/
const unsigned char  uc2_78F7 [] = {0x04, 0x90, 0x7A, 0xA0, 0x17, 0xF0, 0x22, 0xA0, 0x3C, 0x90, 0x6A, 0x20, 0x2B, 0x70, 0x2D, 0x20, 0x3A, 0xA0, 0x2A, 0xF0, 0x04, 0x20, 0x00, 0x00 }; /*78F7*/
const unsigned char  uc2_78FA [] = {0x01, 0x40, 0x7B, 0xE0, 0x11, 0x40, 0x27, 0xF0, 0x38, 0x80, 0x6B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x3A, 0xA0, 0x23, 0xE0, 0x04, 0x10, 0x00, 0x00 }; /*78FA*/
const unsigned char  uc2_7901 [] = {0x01, 0x40, 0x7B, 0xF0, 0x12, 0x40, 0x27, 0xE0, 0x3A, 0x40, 0x6B, 0xE0, 0x2A, 0x40, 0x2B, 0xF0, 0x3A, 0xA0, 0x2B, 0x50, 0x05, 0x50, 0x00, 0x00 }; /*7901*/
const unsigned char  uc2_7905 [] = {0x02, 0x40, 0x7F, 0xF0, 0x15, 0x50, 0x27, 0x50, 0x38, 0x90, 0x6F, 0x50, 0x29, 0x50, 0x2A, 0x20, 0x3F, 0xA0, 0x2A, 0x50, 0x06, 0x90, 0x00, 0x00 }; /*7905*/
const unsigned char  uc2_7913 [] = {0x07, 0xF0, 0x7A, 0xA0, 0x13, 0xE0, 0x22, 0xA0, 0x3F, 0xF0, 0x6A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x3B, 0xE0, 0x20, 0x00, 0x07, 0xF0, 0x00, 0x00 }; /*7913*/
const unsigned char  uc2_791E [] = {0x02, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x27, 0xF0, 0x3C, 0x10, 0x6B, 0xE0, 0x29, 0x00, 0x2E, 0xA0, 0x39, 0xC0, 0x2E, 0xB0, 0x01, 0x80, 0x00, 0x00 }; /*791E*/
const unsigned char  uc2_7924 [] = {0x02, 0x20, 0x7F, 0xF0, 0x12, 0x20, 0x23, 0x70, 0x3D, 0x50, 0x6A, 0x20, 0x2D, 0xD0, 0x28, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x05, 0x90, 0x00, 0x00 }; /*7924*/
const unsigned char  uc2_7934 [] = {0x02, 0x40, 0x7F, 0xF0, 0x22, 0x40, 0x48, 0xA0, 0x77, 0xF0, 0x52, 0xA0, 0x5B, 0xE0, 0x56, 0xA0, 0x70, 0x40, 0x57, 0xF0, 0x09, 0x40, 0x00, 0x00 }; /*7934*/
const unsigned char  uc2_793A [] = {0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x12, 0x40, 0x12, 0x20, 0x22, 0x10, 0x42, 0x10, 0x1C, 0x00, 0x00, 0x00 }; /*793A*/
const unsigned char  uc2_793C [] = {0x20, 0x80, 0x10, 0x80, 0x78, 0x80, 0x08, 0x80, 0x10, 0x80, 0x34, 0x80, 0x52, 0x80, 0x12, 0x90, 0x10, 0x90, 0x10, 0x90, 0x10, 0x60, 0x00, 0x00 }; /*793C*/
const unsigned char  uc2_793E [] = {0x20, 0x80, 0x10, 0x80, 0x78, 0x80, 0x0B, 0xE0, 0x10, 0x80, 0x18, 0x80, 0x34, 0x80, 0x54, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*793E*/
const unsigned char  uc2_7940 [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0A, 0x20, 0x12, 0x20, 0x1B, 0xE0, 0x36, 0x20, 0x52, 0x00, 0x12, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*7940*/
const unsigned char  uc2_7941 [] = {0x20, 0x00, 0x11, 0xE0, 0x79, 0x20, 0x09, 0x40, 0x11, 0x40, 0x19, 0x20, 0x35, 0x10, 0x55, 0x10, 0x11, 0x60, 0x11, 0x00, 0x11, 0x00, 0x00, 0x00 }; /*7941*/
const unsigned char  uc2_7946 [] = {0x20, 0x00, 0x13, 0xE0, 0x78, 0x80, 0x08, 0x80, 0x10, 0x80, 0x1F, 0xF0, 0x34, 0x80, 0x55, 0x40, 0x11, 0x40, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*7946*/
const unsigned char  uc2_7948 [] = {0x20, 0x60, 0x13, 0x80, 0x7A, 0x00, 0x0A, 0x00, 0x13, 0xF0, 0x1A, 0x40, 0x36, 0x40, 0x52, 0x40, 0x12, 0x40, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*7948*/
const unsigned char  uc2_7949 [] = {0x20, 0x40, 0x10, 0x40, 0x78, 0x40, 0x09, 0x40, 0x11, 0x40, 0x19, 0x70, 0x35, 0x40, 0x55, 0x40, 0x11, 0x40, 0x11, 0x40, 0x13, 0xF0, 0x00, 0x00 }; /*7949*/
const unsigned char  uc2_7953 [] = {0x21, 0x40, 0x11, 0x20, 0x7F, 0xF0, 0x09, 0x00, 0x11, 0xE0, 0x19, 0x20, 0x36, 0xA0, 0x52, 0xA0, 0x12, 0x40, 0x14, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*7953*/
const unsigned char  uc2_7956 [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0A, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x36, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x17, 0xF0, 0x00, 0x00 }; /*7956*/
const unsigned char  uc2_7957 [] = {0x20, 0x30, 0x13, 0xC0, 0x7A, 0x40, 0x0A, 0x40, 0x13, 0xF0, 0x1A, 0x40, 0x36, 0x40, 0x52, 0x50, 0x12, 0xD0, 0x13, 0x30, 0x12, 0x90, 0x00, 0x00 }; /*7957*/
const unsigned char  uc2_795A [] = {0x21, 0x00, 0x11, 0xF0, 0x7A, 0x80, 0x0A, 0x80, 0x14, 0xE0, 0x18, 0x80, 0x34, 0x80, 0x54, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*795A*/
const unsigned char  uc2_795B [] = {0x20, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x08, 0x80, 0x10, 0x80, 0x1F, 0xF0, 0x34, 0x80, 0x55, 0x20, 0x12, 0x20, 0x13, 0xD0, 0x10, 0x10, 0x00, 0x00 }; /*795B*/
const unsigned char  uc2_795C [] = {0x20, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x1B, 0xE0, 0x36, 0x20, 0x52, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*795C*/
const unsigned char  uc2_795D [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0A, 0x20, 0x12, 0x20, 0x1B, 0xE0, 0x35, 0x40, 0x55, 0x40, 0x12, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*795D*/
const unsigned char  uc2_795E [] = {0x10, 0x40, 0x08, 0x40, 0x3D, 0xF0, 0x05, 0x50, 0x09, 0xF0, 0x0D, 0x50, 0x1B, 0xF0, 0x6A, 0x40, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*795E*/
const unsigned char  uc2_795F [] = {0x12, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x20, 0x62, 0x10, 0x0C, 0x00, 0x00, 0x00 }; /*795F*/
const unsigned char  uc2_7960 [] = {0x20, 0x00, 0x13, 0xF0, 0x78, 0x10, 0x0B, 0xD0, 0x10, 0x10, 0x19, 0xD0, 0x35, 0x50, 0x51, 0xD0, 0x11, 0x50, 0x10, 0x10, 0x10, 0x60, 0x00, 0x00 }; /*7960*/
const unsigned char  uc2_7962 [] = {0x21, 0x00, 0x11, 0xF0, 0x79, 0x10, 0x0A, 0x50, 0x10, 0x40, 0x19, 0x60, 0x35, 0x50, 0x56, 0x50, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*7962*/
const unsigned char  uc2_7965 [] = {0x22, 0x20, 0x11, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x37, 0xF0, 0x54, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*7965*/
const unsigned char  uc2_7967 [] = {0x21, 0x40, 0x11, 0x40, 0x7D, 0x50, 0x0B, 0x60, 0x11, 0x40, 0x1B, 0x60, 0x35, 0x50, 0x55, 0x40, 0x11, 0x50, 0x12, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*7967*/
const unsigned char  uc2_7968 [] = {0x3F, 0xE0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6C, 0x20, 0x00, 0x00 }; /*7968*/
const unsigned char  uc2_796D [] = {0x11, 0x00, 0x1D, 0x60, 0x15, 0x20, 0x68, 0xC0, 0x10, 0x40, 0x6F, 0xB0, 0x00, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x62, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*796D*/
const unsigned char  uc2_796F [] = {0x20, 0x80, 0x10, 0xF0, 0x78, 0x80, 0x0B, 0xE0, 0x12, 0x20, 0x1A, 0xA0, 0x36, 0xA0, 0x52, 0xA0, 0x11, 0x40, 0x11, 0x20, 0x16, 0x20, 0x00, 0x00 }; /*796F*/
const unsigned char  uc2_7977 [] = {0x20, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x0B, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x35, 0x20, 0x51, 0xF0, 0x12, 0xA0, 0x14, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*7977*/
const unsigned char  uc2_7978 [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0B, 0xE0, 0x10, 0x80, 0x1F, 0xF0, 0x34, 0x90, 0x55, 0x50, 0x16, 0x50, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*7978*/
const unsigned char  uc2_797A [] = {0x21, 0x20, 0x13, 0xF0, 0x79, 0x20, 0x09, 0xE0, 0x11, 0x20, 0x19, 0xE0, 0x35, 0x20, 0x57, 0xF0, 0x11, 0x20, 0x11, 0x10, 0x12, 0x10, 0x00, 0x00 }; /*797A*/
const unsigned char  uc2_7980 [] = {0x02, 0x00, 0x7F, 0xF0, 0x25, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6C, 0x20, 0x00, 0x00 }; /*7980*/
const unsigned char  uc2_7981 [] = {0x10, 0x40, 0x7D, 0xF0, 0x38, 0xE0, 0x55, 0x50, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x22, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*7981*/
const unsigned char  uc2_7984 [] = {0x23, 0xE0, 0x10, 0x20, 0x79, 0xC0, 0x08, 0x40, 0x17, 0xF0, 0x18, 0x80, 0x36, 0xD0, 0x55, 0xA0, 0x12, 0xA0, 0x1C, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*7984*/
const unsigned char  uc2_7985 [] = {0x22, 0x20, 0x11, 0x40, 0x7B, 0xE0, 0x0A, 0xA0, 0x13, 0xE0, 0x1A, 0xA0, 0x37, 0xE0, 0x54, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*7985*/
const unsigned char  uc2_798A [] = {0x42, 0x00, 0x27, 0xF0, 0x72, 0x50, 0x17, 0x50, 0x22, 0x50, 0x6F, 0xA0, 0x32, 0x80, 0x2F, 0xF0, 0x20, 0x80, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*798A*/
const unsigned char  uc2_798F [] = {0x20, 0x00, 0x17, 0xF0, 0x78, 0x00, 0x0B, 0xE0, 0x12, 0x20, 0x1F, 0xF0, 0x34, 0x90, 0x57, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*798F*/
const unsigned char  uc2_799A [] = {0x22, 0x20, 0x11, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x37, 0xF0, 0x54, 0x00, 0x12, 0xA0, 0x15, 0x50, 0x15, 0x50, 0x00, 0x00 }; /*799A*/
const unsigned char  uc2_79A7 [] = {0x20, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x0B, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x35, 0x40, 0x57, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*79A7*/
const unsigned char  uc2_79B3 [] = {0x20, 0x80, 0x17, 0xF0, 0x7A, 0xA0, 0x0F, 0xF0, 0x11, 0x40, 0x1B, 0xE0, 0x35, 0x40, 0x57, 0xF0, 0x11, 0x50, 0x1E, 0xE0, 0x13, 0x30, 0x00, 0x00 }; /*79B3*/
const unsigned char  uc2_79B9 [] = {0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x50, 0x43, 0xB0, 0x5C, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*79B9*/
const unsigned char  uc2_79BA [] = {0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xF0, 0x42, 0x90, 0x43, 0x90, 0x5C, 0x50, 0x40, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*79BA*/
const unsigned char  uc2_79BB [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x27, 0x20, 0x28, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x44, 0x90, 0x4B, 0x50, 0x4C, 0x60, 0x00, 0x00 }; /*79BB*/
const unsigned char  uc2_79BD [] = {0x0F, 0x80, 0x74, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x27, 0x20, 0x28, 0xA0, 0x7F, 0xF0, 0x44, 0x90, 0x4F, 0x50, 0x40, 0x60, 0x00, 0x00 }; /*79BD*/
const unsigned char  uc2_79BE [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x07, 0x00, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*79BE*/
const unsigned char  uc2_79C0 [] = {0x01, 0xC0, 0x3E, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x62, 0x30, 0x1F, 0x80, 0x08, 0x80, 0x09, 0xF0, 0x10, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*79C0*/
const unsigned char  uc2_79C1 [] = {0x08, 0x80, 0x30, 0x80, 0x10, 0x80, 0x7C, 0x80, 0x10, 0x80, 0x39, 0x00, 0x35, 0x40, 0x55, 0x20, 0x52, 0x20, 0x13, 0xD0, 0x10, 0x10, 0x00, 0x00 }; /*79C1*/
const unsigned char  uc2_79C3 [] = {0x01, 0xE0, 0x3E, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x60, 0x30, 0x0F, 0x80, 0x08, 0x90, 0x08, 0x90, 0x70, 0x70, 0x00, 0x00 }; /*79C3*/
const unsigned char  uc2_79C6 [] = {0x08, 0x00, 0x33, 0xE0, 0x10, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x38, 0x80, 0x34, 0x80, 0x54, 0x80, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*79C6*/
const unsigned char  uc2_79C9 [] = {0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xF0, 0x02, 0x20, 0x3F, 0xE0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*79C9*/
const unsigned char  uc2_79CB [] = {0x08, 0x40, 0x30, 0x40, 0x11, 0x50, 0x7D, 0x50, 0x12, 0x60, 0x38, 0x40, 0x34, 0xA0, 0x54, 0xA0, 0x51, 0x20, 0x11, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*79CB*/
const unsigned char  uc2_79CD [] = {0x04, 0x40, 0x18, 0x40, 0x09, 0xF0, 0x3F, 0x50, 0x09, 0x50, 0x1D, 0xF0, 0x2B, 0x50, 0x2A, 0x40, 0x48, 0x40, 0x08, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*79CD*/
const unsigned char  uc2_79D1 [] = {0x09, 0x20, 0x30, 0xA0, 0x10, 0xA0, 0x7D, 0x20, 0x10, 0xA0, 0x38, 0xA0, 0x34, 0x70, 0x55, 0xA0, 0x50, 0x20, 0x10, 0x20, 0x10, 0x20, 0x00, 0x00 }; /*79D1*/
const unsigned char  uc2_79D2 [] = {0x08, 0x40, 0x30, 0x40, 0x11, 0x60, 0x7D, 0x50, 0x12, 0x50, 0x38, 0x40, 0x34, 0x20, 0x54, 0x20, 0x50, 0x40, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*79D2*/
const unsigned char  uc2_79D5 [] = {0x0A, 0x40, 0x32, 0x40, 0x12, 0x40, 0x7E, 0x50, 0x13, 0x60, 0x3A, 0x40, 0x36, 0x40, 0x52, 0x50, 0x52, 0x50, 0x12, 0xD0, 0x13, 0x20, 0x00, 0x00 }; /*79D5*/
const unsigned char  uc2_79D8 [] = {0x09, 0x00, 0x30, 0xA0, 0x10, 0xA0, 0x7D, 0x20, 0x11, 0x20, 0x3B, 0x40, 0x35, 0x50, 0x55, 0x90, 0x51, 0x20, 0x13, 0x20, 0x1C, 0xC0, 0x00, 0x00 }; /*79D8*/
const unsigned char  uc2_79DF [] = {0x08, 0x00, 0x33, 0xE0, 0x12, 0x20, 0x7E, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x36, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x12, 0x20, 0x17, 0xF0, 0x00, 0x00 }; /*79DF*/
const unsigned char  uc2_79E3 [] = {0x08, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x7C, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x55, 0xC0, 0x52, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*79E3*/
const unsigned char  uc2_79E4 [] = {0x08, 0x00, 0x33, 0xE0, 0x10, 0x80, 0x7E, 0xA0, 0x11, 0xC0, 0x38, 0x80, 0x37, 0xF0, 0x54, 0x80, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*79E4*/
const unsigned char  uc2_79E6 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x09, 0x40, 0x76, 0x30, 0x1F, 0xC0, 0x0A, 0x80, 0x32, 0x60, 0x00, 0x00 }; /*79E6*/
const unsigned char  uc2_79E7 [] = {0x08, 0x80, 0x30, 0x80, 0x13, 0xE0, 0x7E, 0xA0, 0x1A, 0xA0, 0x37, 0xF0, 0x34, 0x80, 0x51, 0x40, 0x51, 0x40, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*79E7*/
const unsigned char  uc2_79E9 [] = {0x08, 0x40, 0x31, 0x40, 0x11, 0xE0, 0x7D, 0x40, 0x12, 0x40, 0x3B, 0xF0, 0x34, 0x40, 0x54, 0xA0, 0x50, 0xA0, 0x11, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*79E9*/
const unsigned char  uc2_79EB [] = {0x0C, 0xA0, 0x70, 0x90, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x39, 0xC0, 0x56, 0xA0, 0x52, 0xA0, 0x54, 0x90, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*79EB*/
const unsigned char  uc2_79ED [] = {0x08, 0x40, 0x30, 0x70, 0x10, 0xC0, 0x7D, 0x40, 0x11, 0x40, 0x39, 0xF0, 0x34, 0xD0, 0x55, 0x50, 0x51, 0x60, 0x12, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*79ED*/
const unsigned char  uc2_79EF [] = {0x08, 0x00, 0x33, 0xE0, 0x12, 0x20, 0x7E, 0x20, 0x12, 0x20, 0x3B, 0xE0, 0x34, 0x00, 0x55, 0x40, 0x51, 0x20, 0x12, 0x10, 0x14, 0x10, 0x00, 0x00 }; /*79EF*/
const unsigned char  uc2_79F0 [] = {0x0A, 0x00, 0x33, 0xF0, 0x12, 0x10, 0x7C, 0x90, 0x10, 0xA0, 0x38, 0x80, 0x36, 0xA0, 0x52, 0x90, 0x54, 0x90, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*79F0*/
const unsigned char  uc2_79F8 [] = {0x08, 0x80, 0x30, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x38, 0x00, 0x37, 0xE0, 0x52, 0x20, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*79F8*/
const unsigned char  uc2_79FD [] = {0x08, 0x40, 0x31, 0x50, 0x11, 0x50, 0x7D, 0xF0, 0x10, 0x80, 0x38, 0xE0, 0x35, 0x20, 0x56, 0xA0, 0x50, 0x40, 0x11, 0x80, 0x16, 0x00, 0x00, 0x00 }; /*79FD*/
const unsigned char  uc2_7A00 [] = {0x09, 0x20, 0x30, 0xC0, 0x11, 0x20, 0x7C, 0x80, 0x13, 0xF0, 0x39, 0x40, 0x37, 0xF0, 0x51, 0x50, 0x51, 0x50, 0x11, 0x60, 0x10, 0x40, 0x00, 0x00 }; /*7A00*/
const unsigned char  uc2_7A02 [] = {0x08, 0x80, 0x33, 0xE0, 0x12, 0x20, 0x7F, 0xE0, 0x12, 0x20, 0x3B, 0xE0, 0x36, 0x80, 0x52, 0xA0, 0x52, 0xA0, 0x13, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*7A02*/
const unsigned char  uc2_7A03 [] = {0x08, 0x30, 0x33, 0xD0, 0x11, 0x50, 0x7C, 0xA0, 0x11, 0xE0, 0x38, 0x20, 0x34, 0x40, 0x57, 0xF0, 0x50, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*7A03*/
const unsigned char  uc2_7A06 [] = {0x08, 0x00, 0x31, 0xE0, 0x11, 0x20, 0x7D, 0x20, 0x11, 0xE0, 0x38, 0x00, 0x37, 0xF0, 0x52, 0x10, 0x52, 0x10, 0x13, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*7A06*/
const unsigned char  uc2_7A0B [] = {0x08, 0x00, 0x33, 0xE0, 0x12, 0x20, 0x7F, 0xE0, 0x10, 0x00, 0x3B, 0xE0, 0x34, 0x80, 0x55, 0xC0, 0x50, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*7A0B*/
const unsigned char  uc2_7A0D [] = {0x08, 0x40, 0x31, 0x50, 0x10, 0xA0, 0x7D, 0xF0, 0x11, 0x10, 0x39, 0xF0, 0x35, 0x10, 0x55, 0xF0, 0x51, 0x10, 0x11, 0x10, 0x11, 0x20, 0x00, 0x00 }; /*7A0D*/
const unsigned char  uc2_7A0E [] = {0x0A, 0x20, 0x31, 0x40, 0x13, 0xE0, 0x7E, 0x20, 0x12, 0x20, 0x3A, 0x20, 0x37, 0xE0, 0x51, 0x40, 0x51, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x00, 0x00 }; /*7A0E*/
const unsigned char  uc2_7A14 [] = {0x08, 0x80, 0x31, 0x40, 0x16, 0xB0, 0x7D, 0xC0, 0x10, 0x40, 0x38, 0x80, 0x35, 0x00, 0x54, 0xA0, 0x53, 0x50, 0x15, 0x50, 0x10, 0x80, 0x00, 0x00 }; /*7A14*/
const unsigned char  uc2_7A17 [] = {0x08, 0x80, 0x33, 0xE0, 0x12, 0xA0, 0x7F, 0xE0, 0x12, 0xA0, 0x3B, 0xE0, 0x35, 0x00, 0x52, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*7A17*/
const unsigned char  uc2_7A1A [] = {0x09, 0x80, 0x31, 0x40, 0x13, 0xF0, 0x7E, 0x40, 0x13, 0xE0, 0x3A, 0x40, 0x36, 0x40, 0x53, 0xE0, 0x52, 0x40, 0x13, 0xF0, 0x12, 0x00, 0x00, 0x00 }; /*7A1A*/
const unsigned char  uc2_7A1E [] = {0x0B, 0xE0, 0x32, 0xA0, 0x13, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x38, 0x80, 0x57, 0xF0, 0x51, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x00, 0x00 }; /*7A1E*/
const unsigned char  uc2_7A20 [] = {0x0F, 0xF0, 0x34, 0x90, 0x15, 0xD0, 0x7C, 0x90, 0x17, 0xF0, 0x3C, 0x10, 0x35, 0xD0, 0x55, 0x50, 0x55, 0xD0, 0x14, 0x10, 0x18, 0x60, 0x00, 0x00 }; /*7A20*/
const unsigned char  uc2_7A23 [] = {0x20, 0x60, 0x3B, 0x80, 0x48, 0x80, 0x7C, 0x80, 0x57, 0xF0, 0x7C, 0x80, 0x55, 0xC0, 0x7E, 0xA0, 0x00, 0xA0, 0x0C, 0x90, 0x70, 0x80, 0x00, 0x00 }; /*7A23*/
const unsigned char  uc2_7A33 [] = {0x09, 0x00, 0x31, 0xC0, 0x12, 0x40, 0x7D, 0xE0, 0x10, 0x20, 0x3B, 0xE0, 0x34, 0x20, 0x55, 0xE0, 0x50, 0xA0, 0x13, 0x50, 0x15, 0xC0, 0x00, 0x00 }; /*7A33*/
const unsigned char  uc2_7A37 [] = {0x0B, 0xE0, 0x32, 0xA0, 0x13, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x3A, 0x20, 0x35, 0x10, 0x55, 0xC0, 0x53, 0x40, 0x10, 0x80, 0x17, 0x70, 0x00, 0x00 }; /*7A37*/
const unsigned char  uc2_7A39 [] = {0x0C, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x7D, 0x00, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x52, 0x20, 0x57, 0xF0, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*7A39*/
const unsigned char  uc2_7A3B [] = {0x08, 0x30, 0x31, 0xD0, 0x11, 0x50, 0x7C, 0xA0, 0x10, 0x40, 0x39, 0xB0, 0x35, 0x10, 0x55, 0xB0, 0x51, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*7A3B*/
const unsigned char  uc2_7A3C [] = {0x08, 0x80, 0x37, 0xE0, 0x14, 0x20, 0x7B, 0xC0, 0x11, 0x00, 0x3A, 0x90, 0x35, 0xE0, 0x52, 0xA0, 0x51, 0xA0, 0x16, 0x90, 0x11, 0x00, 0x00, 0x00 }; /*7A3C*/
const unsigned char  uc2_7A3D [] = {0x0D, 0x20, 0x77, 0xF0, 0x11, 0x50, 0x7E, 0x30, 0x13, 0xC0, 0x3A, 0x10, 0x55, 0xF0, 0x52, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*7A3D*/
const unsigned char  uc2_7A3F [] = {0x08, 0x80, 0x77, 0xF0, 0x11, 0x40, 0x79, 0x40, 0x17, 0xF0, 0x34, 0x10, 0x5D, 0xD0, 0x55, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*7A3F*/
const unsigned char  uc2_7A46 [] = {0x08, 0x80, 0x33, 0xE0, 0x12, 0x20, 0x7F, 0xE0, 0x12, 0x20, 0x3B, 0xE0, 0x32, 0xA0, 0x54, 0xD0, 0x53, 0x00, 0x10, 0x60, 0x13, 0x80, 0x00, 0x00 }; /*7A46*/
const unsigned char  uc2_7A51 [] = {0x08, 0x80, 0x37, 0xF0, 0x10, 0x80, 0x7A, 0xA0, 0x17, 0xF0, 0x38, 0x00, 0x37, 0xF0, 0x55, 0x50, 0x55, 0xD0, 0x14, 0x10, 0x17, 0xF0, 0x00, 0x00 }; /*7A51*/
const unsigned char  uc2_7A57 [] = {0x08, 0x80, 0x37, 0xF0, 0x12, 0xA0, 0x7F, 0xE0, 0x12, 0xA0, 0x3B, 0xE0, 0x34, 0xA0, 0x57, 0xD0, 0x54, 0xA0, 0x1A, 0x50, 0x11, 0x80, 0x00, 0x00 }; /*7A57*/
const unsigned char  uc2_7A70 [] = {0x08, 0x80, 0x37, 0xF0, 0x12, 0xA0, 0x7F, 0xF0, 0x11, 0x40, 0x3B, 0xE0, 0x35, 0x40, 0x57, 0xF0, 0x51, 0x50, 0x1E, 0xE0, 0x13, 0x30, 0x00, 0x00 }; /*7A70*/
const unsigned char  uc2_7A74 [] = {0x04, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x48, 0x90, 0x08, 0x80, 0x08, 0x80, 0x10, 0x40, 0x10, 0x40, 0x20, 0x20, 0x40, 0x10, 0x00, 0x00 }; /*7A74*/
const unsigned char  uc2_7A76 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x30, 0x20, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x90, 0x04, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*7A76*/
const unsigned char  uc2_7A77 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x32, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x20, 0x04, 0x20, 0x18, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*7A77*/
const unsigned char  uc2_7A78 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x32, 0x20, 0x03, 0xC0, 0x04, 0x40, 0x3A, 0x40, 0x02, 0x80, 0x03, 0x00, 0x7C, 0x00, 0x00, 0x00 }; /*7A78*/
const unsigned char  uc2_7A79 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x3F, 0xE0, 0x00, 0x20, 0x1F, 0xE0, 0x20, 0x00, 0x3F, 0xF0, 0x00, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*7A79*/
const unsigned char  uc2_7A7A [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x30, 0x20, 0x00, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7A7A*/
const unsigned char  uc2_7A7F [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x0F, 0xE0, 0x10, 0x80, 0x3F, 0xF0, 0x02, 0x80, 0x0C, 0x80, 0x70, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*7A7F*/
const unsigned char  uc2_7A80 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x12, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*7A80*/
const unsigned char  uc2_7A81 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x32, 0x20, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7A81*/
const unsigned char  uc2_7A83 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x13, 0xE0, 0x7C, 0xA0, 0x10, 0xA0, 0x10, 0xA0, 0x14, 0xA0, 0x19, 0x20, 0x06, 0x40, 0x00, 0x00 }; /*7A83*/
const unsigned char  uc2_7A84 [] = {0x02, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x34, 0x20, 0x07, 0xE0, 0x0C, 0x00, 0x37, 0xC0, 0x04, 0x00, 0x07, 0xC0, 0x04, 0x00, 0x00, 0x00 }; /*7A84*/
const unsigned char  uc2_7A86 [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x21, 0xA0, 0x1E, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x07, 0x80, 0x18, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*7A86*/
const unsigned char  uc2_7A88 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x10, 0x80, 0x2B, 0xE0, 0x70, 0xA0, 0x10, 0xA0, 0x29, 0x20, 0x75, 0x20, 0x02, 0x40, 0x00, 0x00 }; /*7A88*/
const unsigned char  uc2_7A8D [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x03, 0xF0, 0x7C, 0x80, 0x11, 0x00, 0x11, 0xF0, 0x1C, 0x10, 0x60, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*7A8D*/
const unsigned char  uc2_7A91 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*7A91*/
const unsigned char  uc2_7A92 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0x40, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7A92*/
const unsigned char  uc2_7A95 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x15, 0x40, 0x05, 0x00, 0x35, 0x60, 0x0D, 0x80, 0x35, 0x60, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*7A95*/
const unsigned char  uc2_7A96 [] = {0x04, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x12, 0x40, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*7A96*/
const unsigned char  uc2_7A97 [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x24, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x27, 0xA0, 0x3C, 0xA0, 0x23, 0x20, 0x2C, 0xA0, 0x3F, 0xE0, 0x00, 0x00 }; /*7A97*/
const unsigned char  uc2_7A98 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xC0, 0x04, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x3F, 0xE0, 0x10, 0x20, 0x7F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*7A98*/
const unsigned char  uc2_7A9C [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xF0, 0x42, 0x10, 0x7F, 0xF0, 0x42, 0x10, 0x02, 0x00, 0x00, 0x00 }; /*7A9C*/
const unsigned char  uc2_7A9D [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x2F, 0xA0, 0x08, 0x80, 0x0F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x28, 0xA0, 0x20, 0x60, 0x00, 0x00 }; /*7A9D*/
const unsigned char  uc2_7A9F [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x21, 0x00, 0x29, 0x20, 0x2F, 0xE0, 0x51, 0x10, 0x5F, 0xF0, 0x00, 0x00 }; /*7A9F*/
const unsigned char  uc2_7AA0 [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x3F, 0xE0, 0x52, 0x50, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x02, 0x00, 0x00, 0x00 }; /*7AA0*/
const unsigned char  uc2_7AA5 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x13, 0xE0, 0x3A, 0x20, 0x12, 0xA0, 0x7E, 0xA0, 0x11, 0x50, 0x29, 0x50, 0x46, 0x20, 0x00, 0x00 }; /*7AA5*/
const unsigned char  uc2_7AA6 [] = {0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x0F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x20, 0x12, 0x00, 0x7F, 0xF0, 0x04, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*7AA6*/
const unsigned char  uc2_7AA8 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x12, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7AA8*/
const unsigned char  uc2_7AAC [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x27, 0x20, 0x78, 0xF0, 0x07, 0x00, 0x3C, 0x20, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x2C, 0x60, 0x00, 0x00 }; /*7AAC*/
const unsigned char  uc2_7AAD [] = {0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x3F, 0xE0, 0x0A, 0x80, 0x72, 0x70, 0x04, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x60, 0x78, 0x10, 0x00, 0x00 }; /*7AAD*/
const unsigned char  uc2_7AB3 [] = {0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x0C, 0x60, 0x73, 0xC0, 0x5A, 0xA0, 0x56, 0xA0, 0x52, 0xA0, 0x56, 0xA0, 0x5A, 0xD0, 0x14, 0x80, 0x00, 0x00 }; /*7AB3*/
const unsigned char  uc2_7ABF [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x11, 0xE0, 0x76, 0x20, 0x51, 0xC0, 0x66, 0x30, 0x52, 0x80, 0x53, 0xE0, 0x64, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*7ABF*/
const unsigned char  uc2_7ACB [] = {0x04, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x10, 0x40, 0x08, 0x40, 0x08, 0x40, 0x04, 0x80, 0x04, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7ACB*/
const unsigned char  uc2_7AD6 [] = {0x10, 0x00, 0x57, 0xC0, 0x52, 0x40, 0x51, 0x80, 0x52, 0x40, 0x1C, 0x30, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7AD6*/
const unsigned char  uc2_7AD9 [] = {0x20, 0x80, 0x10, 0x80, 0x78, 0xF0, 0x00, 0x80, 0x48, 0x80, 0x2B, 0xE0, 0x2A, 0x20, 0x12, 0x20, 0x1A, 0x20, 0x63, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*7AD9*/
const unsigned char  uc2_7ADE [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*7ADE*/
const unsigned char  uc2_7ADF [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*7ADF*/
const unsigned char  uc2_7AE0 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7AE0*/
const unsigned char  uc2_7AE3 [] = {0x21, 0x00, 0x12, 0x40, 0x7B, 0xA0, 0x00, 0x40, 0x4A, 0x20, 0x2D, 0x20, 0x29, 0xC0, 0x13, 0x40, 0x18, 0x80, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*7AE3*/
const unsigned char  uc2_7AE5 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7AE5*/
const unsigned char  uc2_7AE6 [] = {0x20, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x03, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x28, 0x80, 0x11, 0xC0, 0x1A, 0xA0, 0x62, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*7AE6*/
const unsigned char  uc2_7AED [] = {0x23, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x02, 0x20, 0x4B, 0xE0, 0x29, 0x00, 0x29, 0xF0, 0x16, 0x50, 0x1A, 0xB0, 0x63, 0xD0, 0x00, 0x20, 0x00, 0x00 }; /*7AED*/
const unsigned char  uc2_7AEF [] = {0x20, 0x80, 0x14, 0x90, 0x7F, 0xF0, 0x00, 0x00, 0x4F, 0xF0, 0x29, 0x00, 0x17, 0xF0, 0x15, 0x50, 0x1D, 0x50, 0x65, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*7AEF*/
const unsigned char  uc2_7AF9 [] = {0x10, 0x80, 0x10, 0x80, 0x1E, 0xF0, 0x29, 0x40, 0x4A, 0x40, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*7AF9*/
const unsigned char  uc2_7AFA [] = {0x20, 0x80, 0x3E, 0xF0, 0x28, 0xA0, 0x45, 0x10, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7AFA*/
const unsigned char  uc2_7AFD [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*7AFD*/
const unsigned char  uc2_7AFF [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7AFF*/
const unsigned char  uc2_7B03 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x3F, 0xC0, 0x08, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0xD0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*7B03*/
const unsigned char  uc2_7B04 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x3F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*7B04*/
const unsigned char  uc2_7B06 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*7B06*/
const unsigned char  uc2_7B08 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x1F, 0x80, 0x08, 0x80, 0x09, 0x00, 0x09, 0xC0, 0x14, 0x40, 0x13, 0x80, 0x6C, 0x70, 0x00, 0x00 }; /*7B08*/
const unsigned char  uc2_7B0A [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x00, 0x60, 0x1F, 0x80, 0x12, 0x40, 0x12, 0x40, 0x22, 0x20, 0x22, 0x20, 0x42, 0x10, 0x00, 0x00 }; /*7B0A*/
const unsigned char  uc2_7B0B [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x04, 0x40, 0x78, 0x00, 0x00, 0x00 }; /*7B0B*/
const unsigned char  uc2_7B0F [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x10, 0x00, 0x1F, 0xF0, 0x64, 0x90, 0x08, 0x90, 0x71, 0x10, 0x06, 0x20, 0x18, 0xC0, 0x00, 0x00 }; /*7B0F*/
const unsigned char  uc2_7B11 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x70, 0x00, 0x00 }; /*7B11*/
const unsigned char  uc2_7B14 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x01, 0xC0, 0x3E, 0x00, 0x03, 0xC0, 0x1E, 0x00, 0x03, 0xE0, 0x3E, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*7B14*/
const unsigned char  uc2_7B15 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*7B15*/
const unsigned char  uc2_7B19 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x22, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x5F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7B19*/
const unsigned char  uc2_7B1B [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x46, 0x20, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*7B1B*/
const unsigned char  uc2_7B1E [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x20, 0x10, 0x40, 0x21, 0xE0, 0x3E, 0x10, 0x00, 0x10, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*7B1E*/
const unsigned char  uc2_7B20 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x08, 0x40, 0x08, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7B20*/
const unsigned char  uc2_7B24 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x02, 0x20, 0x0C, 0x20, 0x70, 0x40, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*7B24*/
const unsigned char  uc2_7B25 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x00, 0x20, 0x7F, 0xA0, 0x00, 0x20, 0x3F, 0x20, 0x21, 0x20, 0x3F, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*7B25*/
const unsigned char  uc2_7B26 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x10, 0x40, 0x2F, 0xF0, 0x60, 0x40, 0x22, 0x40, 0x21, 0x40, 0x20, 0x40, 0x21, 0x80, 0x00, 0x00 }; /*7B26*/
const unsigned char  uc2_7B28 [] = {0x20, 0x80, 0x3E, 0xF0, 0x28, 0xA0, 0x45, 0x10, 0x02, 0x00, 0x7F, 0xF0, 0x07, 0x00, 0x0A, 0x80, 0x12, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x00, 0x00 }; /*7B28*/
const unsigned char  uc2_7B2A [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7B2A*/
const unsigned char  uc2_7B2B [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x02, 0x60, 0x1F, 0x80, 0x22, 0x00, 0x3F, 0xF0, 0x0A, 0x10, 0x72, 0x60, 0x02, 0x00, 0x00, 0x00 }; /*7B2B*/
const unsigned char  uc2_7B2C [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x1F, 0xE0, 0x22, 0x00, 0x3F, 0xF0, 0x0A, 0x10, 0x72, 0x60, 0x02, 0x00, 0x00, 0x00 }; /*7B2C*/
const unsigned char  uc2_7B2E [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x54, 0x20, 0x1F, 0xF0, 0x28, 0x00, 0x2F, 0xC0, 0x48, 0x00, 0x0F, 0xE0, 0x08, 0x00, 0x08, 0x00, 0x00, 0x00 }; /*7B2E*/
const unsigned char  uc2_7B31 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x54, 0x20, 0x1F, 0xE0, 0x20, 0x20, 0x5F, 0x20, 0x11, 0x20, 0x1F, 0x20, 0x11, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*7B31*/
const unsigned char  uc2_7B33 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x10, 0x00, 0x7E, 0xF0, 0x12, 0x90, 0x12, 0x90, 0x22, 0x90, 0x22, 0xF0, 0x4C, 0x90, 0x00, 0x00 }; /*7B33*/
const unsigned char  uc2_7B38 [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0x20, 0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xC0, 0x28, 0x40, 0x2F, 0xC0, 0x20, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*7B38*/
const unsigned char  uc2_7B3A [] = {0x20, 0x80, 0x3E, 0xF0, 0x29, 0x40, 0x44, 0xA0, 0x05, 0xE0, 0x3E, 0x00, 0x02, 0xE0, 0x7F, 0x00, 0x01, 0x50, 0x00, 0x90, 0x7F, 0x60, 0x00, 0x00 }; /*7B3A*/
const unsigned char  uc2_7B3C [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x00, 0x0A, 0x20, 0x12, 0x40, 0x13, 0x90, 0x2E, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*7B3C*/
const unsigned char  uc2_7B3E [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x61, 0x00, 0x17, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x11, 0x20, 0x16, 0xC0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*7B3E*/
const unsigned char  uc2_7B45 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x05, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*7B45*/
const unsigned char  uc2_7B47 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x7D, 0xE0, 0x11, 0x20, 0x11, 0x40, 0x11, 0x20, 0x1D, 0x10, 0x61, 0x60, 0x01, 0x00, 0x00, 0x00 }; /*7B47*/
const unsigned char  uc2_7B49 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x80, 0x3F, 0xE0, 0x10, 0x80, 0x0B, 0x00, 0x00, 0x00 }; /*7B49*/
const unsigned char  uc2_7B4B [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3C, 0x40, 0x25, 0xF0, 0x3C, 0x50, 0x24, 0x50, 0x3C, 0x50, 0x24, 0x90, 0x24, 0x90, 0x5B, 0x60, 0x00, 0x00 }; /*7B4B*/
const unsigned char  uc2_7B4C [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7B4C*/
const unsigned char  uc2_7B4F [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x09, 0x00, 0x11, 0x40, 0x31, 0xE0, 0x5F, 0x00, 0x11, 0x20, 0x10, 0xD0, 0x11, 0x90, 0x16, 0x60, 0x00, 0x00 }; /*7B4F*/
const unsigned char  uc2_7B50 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x27, 0xC0, 0x21, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*7B50*/
const unsigned char  uc2_7B51 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x03, 0xC0, 0x7E, 0x40, 0x13, 0x40, 0x12, 0xD0, 0x1E, 0x50, 0x62, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*7B51*/
const unsigned char  uc2_7B52 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*7B52*/
const unsigned char  uc2_7B54 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*7B54*/
const unsigned char  uc2_7B56 [] = {0x20, 0x80, 0x3C, 0xF0, 0x4B, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x27, 0x20, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*7B56*/
const unsigned char  uc2_7B58 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x08, 0x00, 0x3F, 0xE0, 0x09, 0x20, 0x0F, 0x20, 0x39, 0x20, 0x09, 0x20, 0x09, 0xE0, 0x31, 0x20, 0x00, 0x00 }; /*7B58*/
const unsigned char  uc2_7B5A [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x21, 0x20, 0x39, 0xD0, 0x27, 0x10, 0x38, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7B5A*/
const unsigned char  uc2_7B5B [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x10, 0x00, 0x57, 0xF0, 0x50, 0x80, 0x57, 0xF0, 0x54, 0x90, 0x24, 0x90, 0x24, 0xE0, 0x40, 0x80, 0x00, 0x00 }; /*7B5B*/
const unsigned char  uc2_7B5D [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x20, 0x0F, 0x80, 0x30, 0x80, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*7B5D*/
const unsigned char  uc2_7B60 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x11, 0x00, 0x11, 0xF0, 0x7D, 0x10, 0x12, 0x90, 0x10, 0x50, 0x1D, 0x90, 0x60, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*7B60*/
const unsigned char  uc2_7B62 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x10, 0x00, 0x7B, 0xE0, 0x12, 0xA0, 0x1A, 0xA0, 0x73, 0xE0, 0x12, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*7B62*/
const unsigned char  uc2_7B6E [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x40, 0x12, 0x40, 0x2A, 0xA0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7B6E*/
const unsigned char  uc2_7B71 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x11, 0x00, 0x29, 0xE0, 0x6A, 0x40, 0x2A, 0x40, 0x2D, 0x40, 0x28, 0x80, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*7B71*/
const unsigned char  uc2_7B72 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x12, 0x40, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*7B72*/
const unsigned char  uc2_7B75 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x20, 0x73, 0xC0, 0x10, 0x80, 0x3A, 0xE0, 0x0A, 0x80, 0x2B, 0xE0, 0x1C, 0x00, 0x63, 0xF0, 0x00, 0x00 }; /*7B75*/
const unsigned char  uc2_7B77 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x10, 0x80, 0x13, 0xE0, 0x18, 0xA0, 0x37, 0xF0, 0x50, 0x80, 0x11, 0x40, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*7B77*/
const unsigned char  uc2_7B79 [] = {0x20, 0x80, 0x3E, 0xF0, 0x4B, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x0F, 0x80, 0x04, 0x00, 0x3F, 0xE0, 0x0C, 0x80, 0x72, 0x80, 0x01, 0x00, 0x00, 0x00 }; /*7B79*/
const unsigned char  uc2_7B7B [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x00, 0x0C, 0x00, 0x7B, 0xF0, 0x00, 0x00 }; /*7B7B*/
const unsigned char  uc2_7B7E [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x40, 0x14, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*7B7E*/
const unsigned char  uc2_7B80 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x27, 0xE0, 0x10, 0x20, 0x2F, 0xA0, 0x28, 0xA0, 0x2F, 0xA0, 0x28, 0xA0, 0x2F, 0xA0, 0x28, 0xC0, 0x00, 0x00 }; /*7B80*/
const unsigned char  uc2_7B85 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*7B85*/
const unsigned char  uc2_7B8D [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x20, 0x17, 0xF0, 0x7C, 0x40, 0x15, 0xF0, 0x1D, 0x50, 0x75, 0x60, 0x14, 0x40, 0x14, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*7B8D*/
const unsigned char  uc2_7B90 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0x40, 0x11, 0xC0, 0x00, 0x00 }; /*7B90*/
const unsigned char  uc2_7B94 [] = {0x20, 0x80, 0x3C, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x30, 0x80, 0x0B, 0xF0, 0x62, 0x10, 0x13, 0xF0, 0x0A, 0x10, 0x13, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*7B94*/
const unsigned char  uc2_7B95 [] = {0x21, 0x00, 0x3D, 0xF0, 0x52, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x20, 0x20, 0x00, 0x00 }; /*7B95*/
const unsigned char  uc2_7B97 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x00, 0x00 }; /*7B97*/
const unsigned char  uc2_7B9C [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x10, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7B9C*/
const unsigned char  uc2_7B9D [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x11, 0x20, 0x13, 0xF0, 0x7D, 0x20, 0x11, 0xE0, 0x1D, 0x20, 0x71, 0x20, 0x11, 0xE0, 0x61, 0x20, 0x00, 0x00 }; /*7B9D*/
const unsigned char  uc2_7BA1 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*7BA1*/
const unsigned char  uc2_7BA2 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x7F, 0xF0, 0x50, 0x10, 0x1D, 0xC0, 0x15, 0x40, 0x6D, 0x40, 0x05, 0x90, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*7BA2*/
const unsigned char  uc2_7BA6 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x05, 0x80, 0x18, 0x40, 0x00, 0x00 }; /*7BA6*/
const unsigned char  uc2_7BA7 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x25, 0x40, 0x3F, 0xF0, 0x22, 0x40, 0x24, 0x20, 0x3F, 0xF0, 0x00, 0x00 }; /*7BA7*/
const unsigned char  uc2_7BA8 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x17, 0xE0, 0x7A, 0x20, 0x11, 0xC0, 0x1E, 0xB0, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*7BA8*/
const unsigned char  uc2_7BA9 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x07, 0xC0, 0x38, 0x40, 0x05, 0x80, 0x7E, 0x00, 0x00, 0x00 }; /*7BA9*/
const unsigned char  uc2_7BAA [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7BAA*/
const unsigned char  uc2_7BAB [] = {0x20, 0x80, 0x3E, 0xF0, 0x4B, 0x40, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x2A, 0xA0, 0x52, 0x60, 0x00, 0x00 }; /*7BAB*/
const unsigned char  uc2_7BAC [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x04, 0x00, 0x0F, 0xC0, 0x78, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*7BAC*/
const unsigned char  uc2_7BAD [] = {0x20, 0x80, 0x3C, 0xF0, 0x51, 0x20, 0x08, 0x40, 0x7F, 0xF0, 0x00, 0x00, 0x3E, 0x20, 0x22, 0xA0, 0x3E, 0xA0, 0x22, 0xA0, 0x2E, 0x60, 0x00, 0x00 }; /*7BAD*/
const unsigned char  uc2_7BB1 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x11, 0xF0, 0x7D, 0x10, 0x19, 0xF0, 0x35, 0x10, 0x35, 0xF0, 0x51, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*7BB1*/
const unsigned char  uc2_7BB4 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xF0, 0x20, 0x40, 0x3F, 0x50, 0x20, 0x50, 0x2E, 0x60, 0x2A, 0x50, 0x2E, 0xD0, 0x49, 0x20, 0x00, 0x00 }; /*7BB4*/
const unsigned char  uc2_7BB8 [] = {0x3D, 0xF0, 0x4A, 0x20, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x04, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*7BB8*/
const unsigned char  uc2_7BC1 [] = {0x3D, 0xF0, 0x4A, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7BC1*/
const unsigned char  uc2_7BC6 [] = {0x3E, 0xF0, 0x49, 0x20, 0x07, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x0C, 0x20, 0x32, 0x40, 0x0D, 0x80, 0x33, 0x40, 0x0D, 0x30, 0x33, 0x00, 0x00, 0x00 }; /*7BC6*/
const unsigned char  uc2_7BC7 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xF0, 0x2A, 0x50, 0x2F, 0xF0, 0x2A, 0x50, 0x4A, 0x60, 0x00, 0x00 }; /*7BC7*/
const unsigned char  uc2_7BCC [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x0B, 0xE0, 0x10, 0x20, 0x77, 0xF0, 0x12, 0x00, 0x13, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x12, 0x20, 0x00, 0x00 }; /*7BCC*/
const unsigned char  uc2_7BD1 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x20, 0x20, 0x22, 0x20, 0x22, 0x20, 0x05, 0x80, 0x38, 0x60, 0x00, 0x00 }; /*7BD1*/
const unsigned char  uc2_7BD3 [] = {0x21, 0x00, 0x3D, 0xF0, 0x52, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x04, 0x00, 0x7F, 0xF0, 0x10, 0x80, 0x0F, 0x60, 0x70, 0x10, 0x00, 0x00 }; /*7BD3*/
const unsigned char  uc2_7BD9 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x7F, 0xF0, 0x48, 0x90, 0x4F, 0x90, 0x40, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*7BD9*/
const unsigned char  uc2_7BDA [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x00, 0x00, 0x3F, 0xF0, 0x22, 0x80, 0x2E, 0xE0, 0x22, 0x80, 0x2E, 0xE0, 0x22, 0x80, 0x3F, 0xF0, 0x00, 0x00 }; /*7BDA*/
const unsigned char  uc2_7BDD [] = {0x3D, 0xE0, 0x4A, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x11, 0xC0, 0x00, 0x00 }; /*7BDD*/
const unsigned char  uc2_7BE1 [] = {0x20, 0x80, 0x3C, 0xF0, 0x49, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x69, 0x30, 0x0E, 0x80, 0x00, 0x00 }; /*7BE1*/
const unsigned char  uc2_7BE5 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x02, 0x00, 0x00, 0x00 }; /*7BE5*/
const unsigned char  uc2_7BE6 [] = {0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x28, 0xA0, 0x27, 0x20, 0x28, 0xA0, 0x3F, 0xE0, 0x21, 0x20, 0x3D, 0xC0, 0x21, 0x10, 0x3C, 0xF0, 0x00, 0x00 }; /*7BE6*/
const unsigned char  uc2_7BEA [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xF0, 0x21, 0x00, 0x2F, 0xF0, 0x29, 0x10, 0x2F, 0xC0, 0x29, 0x20, 0x53, 0xD0, 0x56, 0x70, 0x00, 0x00 }; /*7BEA*/
const unsigned char  uc2_7BEE [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x01, 0x00, 0x09, 0xF0, 0x29, 0x00, 0x2A, 0x40, 0x00, 0x20, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*7BEE*/
const unsigned char  uc2_7BF1 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xF0, 0x04, 0x80, 0x13, 0x20, 0x14, 0xA0, 0x1F, 0xE0, 0x24, 0x90, 0x2F, 0x50, 0x20, 0x60, 0x00, 0x00 }; /*7BF1*/
const unsigned char  uc2_7BF7 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4B, 0x40, 0x61, 0x80, 0x16, 0xF0, 0x71, 0x80, 0x10, 0xE0, 0x13, 0x80, 0x10, 0xE0, 0x2D, 0x80, 0x43, 0xF0, 0x00, 0x00 }; /*7BF7*/
const unsigned char  uc2_7BFC [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x37, 0x60, 0x25, 0x20, 0x27, 0x20, 0x2D, 0x20, 0x37, 0x60, 0x08, 0x90, 0x08, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*7BFC*/
const unsigned char  uc2_7BFE [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x40, 0x3F, 0xE0, 0x22, 0x40, 0x39, 0x90, 0x46, 0x60, 0x00, 0x00 }; /*7BFE*/
const unsigned char  uc2_7C07 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x11, 0x00, 0x7D, 0xE0, 0x22, 0x00, 0x39, 0xE0, 0x2A, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*7C07*/
const unsigned char  uc2_7C0B [] = {0x3E, 0xF0, 0x49, 0x20, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xD0, 0x22, 0x20, 0x3F, 0xF0, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*7C0B*/
const unsigned char  uc2_7C0C [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3E, 0x80, 0x08, 0xF0, 0x3E, 0x90, 0x2B, 0x60, 0x3E, 0x40, 0x14, 0x40, 0x2A, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*7C0C*/
const unsigned char  uc2_7C0F [] = {0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x24, 0x80, 0x3F, 0xE0, 0x24, 0xA0, 0x3F, 0xE0, 0x28, 0xA0, 0x2E, 0xD0, 0x29, 0x90, 0x4E, 0x60, 0x00, 0x00 }; /*7C0F*/
const unsigned char  uc2_7C16 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x6A, 0x30, 0x54, 0xC0, 0x7E, 0x80, 0x48, 0xF0, 0x5C, 0xA0, 0x6A, 0xA0, 0x7E, 0xA0, 0x01, 0x20, 0x00, 0x00 }; /*7C16*/
const unsigned char  uc2_7C1F [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x12, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7C1F*/
const unsigned char  uc2_7C26 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x1D, 0x20, 0x47, 0x50, 0x28, 0xA0, 0x1F, 0xC0, 0x68, 0xB0, 0x0F, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7C26*/
const unsigned char  uc2_7C27 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x60, 0x20, 0x00, 0x00 }; /*7C27*/
const unsigned char  uc2_7C2A [] = {0x20, 0x80, 0x3E, 0xF0, 0x55, 0x40, 0x1F, 0xF0, 0x0A, 0xC0, 0x73, 0x50, 0x1F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7C2A*/
const unsigned char  uc2_7C38 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x7D, 0xF0, 0x29, 0x50, 0x39, 0x40, 0x29, 0xE0, 0x39, 0xA0, 0x29, 0x40, 0x7D, 0x60, 0x2A, 0x90, 0x00, 0x00 }; /*7C38*/
const unsigned char  uc2_7C3F [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0xA0, 0x27, 0xF0, 0x12, 0xA0, 0x43, 0xE0, 0x22, 0xA0, 0x00, 0x40, 0x17, 0xF0, 0x22, 0x40, 0x40, 0xC0, 0x00, 0x00 }; /*7C3F*/
const unsigned char  uc2_7C40 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x13, 0x00, 0x7C, 0xF0, 0x15, 0x50, 0x17, 0xE0, 0x1A, 0xA0, 0x73, 0xE0, 0x12, 0xA0, 0x63, 0xE0, 0x00, 0x00 }; /*7C40*/
const unsigned char  uc2_7C41 [] = {0x20, 0x80, 0x3E, 0xF0, 0x49, 0x40, 0x7C, 0xE0, 0x11, 0x20, 0x7F, 0xF0, 0x55, 0x10, 0x7D, 0x50, 0x29, 0x50, 0x54, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*7C41*/
const unsigned char  uc2_7C4D [] = {0x20, 0x80, 0x3C, 0xF0, 0x53, 0x20, 0x7D, 0x40, 0x13, 0xE0, 0x39, 0x40, 0x17, 0xF0, 0x7A, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x00, 0x00 }; /*7C4D*/
const unsigned char  uc2_7C73 [] = {0x02, 0x00, 0x12, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x07, 0x00, 0x0A, 0x80, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*7C73*/
const unsigned char  uc2_7C74 [] = {0x0E, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x62, 0x30, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*7C74*/
const unsigned char  uc2_7C7B [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0xC0, 0x72, 0x20, 0x00, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7C7B*/
const unsigned char  uc2_7C7C [] = {0x10, 0x40, 0x54, 0x40, 0x39, 0x50, 0x11, 0x50, 0x7D, 0x50, 0x11, 0x50, 0x39, 0x50, 0x35, 0x50, 0x51, 0x50, 0x11, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*7C7C*/
const unsigned char  uc2_7C7D [] = {0x10, 0x00, 0x55, 0xE0, 0x38, 0x20, 0x10, 0x40, 0x7C, 0x40, 0x13, 0xF0, 0x38, 0x40, 0x34, 0x40, 0x50, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*7C7D*/
const unsigned char  uc2_7C89 [] = {0x10, 0x40, 0x55, 0x20, 0x39, 0x20, 0x12, 0x10, 0x7D, 0xE0, 0x10, 0xA0, 0x38, 0xA0, 0x34, 0xA0, 0x51, 0x20, 0x11, 0x20, 0x12, 0x40, 0x00, 0x00 }; /*7C89*/
const unsigned char  uc2_7C91 [] = {0x10, 0x00, 0x55, 0xF0, 0x39, 0x50, 0x11, 0x50, 0x7D, 0x50, 0x11, 0xF0, 0x39, 0x00, 0x35, 0x00, 0x51, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*7C91*/
const unsigned char  uc2_7C92 [] = {0x10, 0x80, 0x54, 0x40, 0x39, 0xF0, 0x10, 0x00, 0x7D, 0x20, 0x10, 0xA0, 0x38, 0xA0, 0x34, 0xA0, 0x50, 0x20, 0x10, 0x40, 0x11, 0xF0, 0x00, 0x00 }; /*7C92*/
const unsigned char  uc2_7C95 [] = {0x10, 0x40, 0x55, 0xF0, 0x39, 0x10, 0x11, 0x10, 0x7D, 0x10, 0x11, 0xF0, 0x39, 0x10, 0x35, 0x10, 0x51, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*7C95*/
const unsigned char  uc2_7C97 [] = {0x10, 0x00, 0x55, 0xE0, 0x39, 0x20, 0x11, 0x20, 0x7D, 0xE0, 0x11, 0x20, 0x39, 0x20, 0x35, 0xE0, 0x51, 0x20, 0x11, 0x20, 0x13, 0xF0, 0x00, 0x00 }; /*7C97*/
const unsigned char  uc2_7C98 [] = {0x10, 0x80, 0x54, 0x80, 0x38, 0xF0, 0x10, 0x80, 0x7C, 0x80, 0x13, 0xE0, 0x3A, 0x20, 0x36, 0x20, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*7C98*/
const unsigned char  uc2_7C9C [] = {0x12, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*7C9C*/
const unsigned char  uc2_7C9D [] = {0x10, 0x00, 0x57, 0xF0, 0x3A, 0x00, 0x13, 0xF0, 0x7E, 0x80, 0x12, 0x80, 0x3A, 0xE0, 0x36, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x15, 0x40, 0x00, 0x00 }; /*7C9D*/
const unsigned char  uc2_7C9E [] = {0x10, 0x00, 0x57, 0xF0, 0x39, 0x40, 0x17, 0xF0, 0x7D, 0x50, 0x15, 0x50, 0x3D, 0x30, 0x36, 0x10, 0x54, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*7C9E*/
const unsigned char  uc2_7C9F [] = {0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*7C9F*/
const unsigned char  uc2_7CA2 [] = {0x32, 0x00, 0x0B, 0xE0, 0x0C, 0xA0, 0x31, 0x40, 0x06, 0x20, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x00, 0x00 }; /*7CA2*/
const unsigned char  uc2_7CA4 [] = {0x04, 0x00, 0x3F, 0xE0, 0x2A, 0xA0, 0x3F, 0xE0, 0x27, 0x20, 0x2A, 0xA0, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*7CA4*/
const unsigned char  uc2_7CA5 [] = {0x02, 0x00, 0x7A, 0xF0, 0x17, 0x10, 0x32, 0x30, 0x4F, 0xC0, 0x72, 0x70, 0x17, 0x10, 0x1A, 0x90, 0x12, 0x10, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*7CA5*/
const unsigned char  uc2_7CAA [] = {0x12, 0x40, 0x3F, 0xE0, 0x0A, 0x80, 0x72, 0x70, 0x02, 0x00, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x60, 0x20, 0x00, 0x00 }; /*7CAA*/
const unsigned char  uc2_7CAE [] = {0x10, 0x40, 0x55, 0xE0, 0x39, 0x20, 0x11, 0xE0, 0x7D, 0x20, 0x11, 0xE0, 0x39, 0x50, 0x35, 0x60, 0x51, 0x40, 0x11, 0xA0, 0x11, 0x10, 0x00, 0x00 }; /*7CAE*/
const unsigned char  uc2_7CB1 [] = {0x67, 0xC0, 0x11, 0x40, 0x65, 0x60, 0x1A, 0x50, 0x65, 0x80, 0x00, 0x00, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x02, 0x00, 0x00, 0x00 }; /*7CB1*/
const unsigned char  uc2_7CB2 [] = {0x08, 0x00, 0x0E, 0xF0, 0x28, 0x10, 0x3C, 0xE0, 0x54, 0x50, 0x19, 0x90, 0x62, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*7CB2*/
const unsigned char  uc2_7CB3 [] = {0x10, 0x00, 0x57, 0xF0, 0x38, 0x80, 0x13, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x3A, 0xA0, 0x37, 0xE0, 0x52, 0x80, 0x11, 0x00, 0x16, 0xF0, 0x00, 0x00 }; /*7CB3*/
const unsigned char  uc2_7CB9 [] = {0x10, 0x80, 0x57, 0xF0, 0x3A, 0x20, 0x12, 0x20, 0x7D, 0x50, 0x10, 0x80, 0x38, 0x80, 0x37, 0xF0, 0x50, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*7CB9*/
const unsigned char  uc2_7CBC [] = {0x49, 0x50, 0x2A, 0x50, 0x7F, 0x50, 0x1C, 0x50, 0x6A, 0xA0, 0x02, 0xA0, 0x37, 0xA0, 0x52, 0x50, 0x3A, 0x50, 0x2F, 0x50, 0x42, 0x50, 0x00, 0x00 }; /*7CBC*/
const unsigned char  uc2_7CBD [] = {0x10, 0x80, 0x57, 0xF0, 0x3C, 0x10, 0x13, 0xE0, 0x78, 0x00, 0x17, 0xF0, 0x38, 0x80, 0x32, 0xA0, 0x54, 0x90, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*7CBD*/
const unsigned char  uc2_7CBE [] = {0x10, 0x80, 0x57, 0xF0, 0x38, 0x80, 0x13, 0xE0, 0x7C, 0x80, 0x17, 0xF0, 0x3A, 0x20, 0x57, 0xE0, 0x52, 0x20, 0x13, 0xA0, 0x12, 0x60, 0x00, 0x00 }; /*7CBE*/
const unsigned char  uc2_7CC1 [] = {0x11, 0x40, 0x55, 0xA0, 0x38, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x16, 0xB0, 0x39, 0x00, 0x34, 0x40, 0x53, 0x90, 0x10, 0x60, 0x13, 0x80, 0x00, 0x00 }; /*7CC1*/
const unsigned char  uc2_7CC5 [] = {0x13, 0xE0, 0x59, 0x20, 0x30, 0xC0, 0x13, 0xF0, 0x7D, 0x50, 0x12, 0x40, 0x3C, 0x40, 0x30, 0x80, 0x57, 0xF0, 0x12, 0xA0, 0x14, 0x90, 0x00, 0x00 }; /*7CC5*/
const unsigned char  uc2_7CC7 [] = {0x11, 0x00, 0x55, 0xE0, 0x3A, 0x20, 0x13, 0xF0, 0x7E, 0x80, 0x12, 0xE0, 0x3B, 0x40, 0x37, 0xF0, 0x52, 0x40, 0x12, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*7CC7*/
const unsigned char  uc2_7CC8 [] = {0x13, 0xF0, 0x54, 0x90, 0x3A, 0xE0, 0x12, 0x80, 0x7D, 0xF0, 0x10, 0x00, 0x3B, 0xE0, 0x56, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x12, 0x60, 0x00, 0x00 }; /*7CC8*/
const unsigned char  uc2_7CCA [] = {0x12, 0x00, 0x5A, 0x70, 0x37, 0x50, 0x12, 0x70, 0x7A, 0x50, 0x17, 0x50, 0x35, 0x70, 0x3D, 0x50, 0x57, 0x50, 0x14, 0x50, 0x10, 0xA0, 0x00, 0x00 }; /*7CCA*/
const unsigned char  uc2_7CCC [] = {0x12, 0x20, 0x5B, 0xB0, 0x36, 0xA0, 0x11, 0x20, 0x7E, 0xF0, 0x10, 0x00, 0x3B, 0xE0, 0x36, 0x20, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*7CCC*/
const unsigned char  uc2_7CCD [] = {0x11, 0x40, 0x57, 0xF0, 0x3A, 0x20, 0x15, 0x50, 0x7D, 0x50, 0x16, 0x60, 0x3A, 0x20, 0x35, 0x50, 0x55, 0x50, 0x17, 0x70, 0x11, 0x10, 0x00, 0x00 }; /*7CCD*/
const unsigned char  uc2_7CD5 [] = {0x12, 0x20, 0x57, 0xF0, 0x38, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x38, 0x80, 0x37, 0xF0, 0x50, 0x00, 0x12, 0xA0, 0x1D, 0x50, 0x00, 0x00 }; /*7CD5*/
const unsigned char  uc2_7CD6 [] = {0x10, 0x80, 0x57, 0xF0, 0x3C, 0xA0, 0x17, 0xF0, 0x7C, 0xA0, 0x15, 0xE0, 0x3C, 0x80, 0x35, 0xE0, 0x55, 0x20, 0x15, 0xE0, 0x19, 0x20, 0x00, 0x00 }; /*7CD6*/
const unsigned char  uc2_7CD7 [] = {0x10, 0x80, 0x57, 0xE0, 0x3A, 0x20, 0x13, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x50, 0x90, 0x17, 0xF0, 0x12, 0x20, 0x00, 0x00 }; /*7CD7*/
const unsigned char  uc2_7CD9 [] = {0x11, 0x40, 0x55, 0xE0, 0x3A, 0x40, 0x11, 0xF0, 0x7E, 0x00, 0x12, 0xE0, 0x3A, 0xA0, 0x36, 0xE0, 0x52, 0xA0, 0x15, 0x00, 0x18, 0xF0, 0x00, 0x00 }; /*7CD9*/
const unsigned char  uc2_7CDC [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x29, 0x20, 0x25, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x59, 0x30, 0x00, 0x00 }; /*7CDC*/
const unsigned char  uc2_7CDF [] = {0x11, 0x40, 0x57, 0xF0, 0x39, 0x40, 0x17, 0xF0, 0x7D, 0x50, 0x17, 0xF0, 0x3D, 0x50, 0x37, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*7CDF*/
const unsigned char  uc2_7CE0 [] = {0x10, 0x80, 0x57, 0xF0, 0x3C, 0xA0, 0x17, 0xF0, 0x7C, 0xA0, 0x15, 0xE0, 0x3C, 0x90, 0x36, 0xE0, 0x55, 0xA0, 0x16, 0x90, 0x19, 0x00, 0x00, 0x00 }; /*7CE0*/
const unsigned char  uc2_7CE8 [] = {0x16, 0xE0, 0x52, 0xA0, 0x3A, 0xE0, 0x14, 0x40, 0x7D, 0xF0, 0x17, 0x50, 0x32, 0xF0, 0x3A, 0x40, 0x52, 0x40, 0x12, 0x60, 0x15, 0xD0, 0x00, 0x00 }; /*7CE8*/
const unsigned char  uc2_7CEF [] = {0x17, 0xF0, 0x58, 0x80, 0x37, 0xF0, 0x15, 0x50, 0x7A, 0xA0, 0x17, 0xF0, 0x39, 0x00, 0x37, 0xF0, 0x55, 0x50, 0x15, 0x50, 0x15, 0x20, 0x00, 0x00 }; /*7CEF*/
const unsigned char  uc2_7CF8 [] = {0x04, 0x00, 0x04, 0x80, 0x08, 0x80, 0x1F, 0x00, 0x04, 0x40, 0x08, 0xC0, 0x3F, 0x20, 0x02, 0x20, 0x0A, 0xC0, 0x32, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*7CF8*/
const unsigned char  uc2_7CFB [] = {0x03, 0xC0, 0x3C, 0x00, 0x05, 0x00, 0x09, 0x00, 0x1E, 0x00, 0x04, 0x80, 0x09, 0xC0, 0x1E, 0x40, 0x12, 0xC0, 0x62, 0x20, 0x0C, 0x00, 0x00, 0x00 }; /*7CFB*/
const unsigned char  uc2_7D0A [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x0F, 0x80, 0x72, 0x70, 0x0C, 0x80, 0x03, 0x00, 0x0C, 0x60, 0x3F, 0x90, 0x11, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*7D0A*/
const unsigned char  uc2_7D20 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x06, 0x40, 0x3F, 0xA0, 0x12, 0x40, 0x26, 0x20, 0x00, 0x00 }; /*7D20*/
const unsigned char  uc2_7D22 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x44, 0x10, 0x19, 0x80, 0x06, 0x00, 0x08, 0xC0, 0x3F, 0x20, 0x12, 0x40, 0x6C, 0x20, 0x00, 0x00 }; /*7D22*/
const unsigned char  uc2_7D27 [] = {0x08, 0x00, 0x2B, 0xE0, 0x29, 0x20, 0x28, 0xC0, 0x09, 0x30, 0x36, 0x00, 0x08, 0x40, 0x7F, 0xA0, 0x02, 0x00, 0x12, 0x60, 0x6C, 0x10, 0x00, 0x00 }; /*7D27*/
const unsigned char  uc2_7D2B [] = {0x08, 0x80, 0x2E, 0xB0, 0x28, 0xC0, 0x2E, 0x90, 0x70, 0x60, 0x04, 0x80, 0x1F, 0x00, 0x04, 0x60, 0x3F, 0x90, 0x11, 0x20, 0x66, 0x10, 0x00, 0x00 }; /*7D2B*/
const unsigned char  uc2_7D2F [] = {0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x04, 0x80, 0x1B, 0x00, 0x04, 0x40, 0x3F, 0xA0, 0x12, 0x40, 0x64, 0x20, 0x00, 0x00 }; /*7D2F*/
const unsigned char  uc2_7D6E [] = {0x10, 0x00, 0x7E, 0xF0, 0x22, 0x90, 0x1C, 0x90, 0x62, 0xF0, 0x09, 0x80, 0x3E, 0x00, 0x08, 0x60, 0x7F, 0x90, 0x12, 0x60, 0x6C, 0x10, 0x00, 0x00 }; /*7D6E*/
const unsigned char  uc2_7D77 [] = {0x11, 0x00, 0x7B, 0xC0, 0x11, 0x50, 0x7B, 0x50, 0x12, 0xB0, 0x34, 0x90, 0x1B, 0x00, 0x04, 0x60, 0x3F, 0x90, 0x11, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*7D77*/
const unsigned char  uc2_7DA6 [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x15, 0x40, 0x6A, 0x30, 0x1F, 0xC0, 0x12, 0x40, 0x26, 0x20, 0x00, 0x00 }; /*7DA6*/
const unsigned char  uc2_7DAE [] = {0x08, 0x80, 0x3C, 0xF0, 0x27, 0x20, 0x3C, 0xC0, 0x23, 0x30, 0x44, 0x00, 0x1B, 0x40, 0x04, 0xA0, 0x7F, 0x10, 0x22, 0x20, 0x4E, 0x10, 0x00, 0x00 }; /*7DAE*/
const unsigned char  uc2_7E3B [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x27, 0x80, 0x22, 0x40, 0x2F, 0xA0, 0x25, 0x40, 0x4B, 0x20, 0x00, 0x00 }; /*7E3B*/
const unsigned char  uc2_7E41 [] = {0x10, 0x80, 0x7E, 0xF0, 0x2B, 0xA0, 0x7E, 0xA0, 0x2A, 0x40, 0x3F, 0xB0, 0x15, 0x00, 0x08, 0x20, 0x7F, 0xD0, 0x12, 0x40, 0x66, 0x20, 0x00, 0x00 }; /*7E41*/
const unsigned char  uc2_7E47 [] = {0x0C, 0x30, 0x75, 0xC0, 0x54, 0x40, 0x28, 0x90, 0x39, 0xE0, 0x50, 0x90, 0x7D, 0xF0, 0x10, 0x40, 0x54, 0xE0, 0x7F, 0x50, 0x04, 0x80, 0x00, 0x00 }; /*7E47*/
const unsigned char  uc2_7E82 [] = {0x21, 0x00, 0x3D, 0xF0, 0x4A, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x15, 0x40, 0x6E, 0x30, 0x04, 0xC0, 0x1F, 0x40, 0x22, 0x20, 0x00, 0x00 }; /*7E82*/
const unsigned char  uc2_7E9B [] = {0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x7F, 0xF0, 0x22, 0xA0, 0x3E, 0x40, 0x22, 0x90, 0x7F, 0xE0, 0x08, 0x50, 0x5A, 0xD0, 0x00, 0x00 }; /*7E9B*/
const unsigned char  uc2_7EA0 [] = {0x10, 0x20, 0x10, 0x20, 0x29, 0x20, 0x29, 0x20, 0x71, 0x20, 0x11, 0x20, 0x2D, 0x60, 0x71, 0xA0, 0x00, 0x20, 0x1C, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*7EA0*/
const unsigned char  uc2_7EA1 [] = {0x10, 0x00, 0x13, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x2C, 0x80, 0x70, 0x80, 0x00, 0x80, 0x1C, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*7EA1*/
const unsigned char  uc2_7EA2 [] = {0x10, 0x00, 0x13, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x70, 0x80, 0x10, 0x80, 0x28, 0x80, 0x70, 0x80, 0x00, 0x80, 0x18, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*7EA2*/
const unsigned char  uc2_7EA3 [] = {0x10, 0x20, 0x10, 0x20, 0x2B, 0xF0, 0x28, 0x20, 0x71, 0x20, 0x10, 0xA0, 0x2C, 0xA0, 0x70, 0x20, 0x00, 0x20, 0x1C, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*7EA3*/
const unsigned char  uc2_7EA4 [] = {0x10, 0x60, 0x13, 0x80, 0x28, 0x80, 0x28, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x2C, 0x80, 0x70, 0x80, 0x00, 0x80, 0x1C, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7EA4*/
const unsigned char  uc2_7EA5 [] = {0x11, 0x00, 0x11, 0xF0, 0x29, 0x00, 0x2A, 0x00, 0x71, 0xE0, 0x10, 0x20, 0x2C, 0x40, 0x70, 0x80, 0x01, 0x10, 0x1D, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*7EA5*/
const unsigned char  uc2_7EA6 [] = {0x11, 0x00, 0x11, 0xF0, 0x29, 0x10, 0x2A, 0x10, 0x71, 0x90, 0x10, 0x50, 0x2C, 0x50, 0x70, 0x10, 0x00, 0x10, 0x1C, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*7EA6*/
const unsigned char  uc2_7EA7 [] = {0x10, 0x00, 0x13, 0xE0, 0x29, 0x20, 0x29, 0x40, 0x71, 0x70, 0x11, 0x10, 0x29, 0x10, 0x71, 0xA0, 0x02, 0x40, 0x1A, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*7EA7*/
const unsigned char  uc2_7EA8 [] = {0x11, 0x00, 0x11, 0x00, 0x2F, 0xC0, 0x29, 0x40, 0x71, 0x40, 0x17, 0x40, 0x29, 0xC0, 0x71, 0x50, 0x02, 0x50, 0x1A, 0x30, 0x64, 0x10, 0x00, 0x00 }; /*7EA8*/
const unsigned char  uc2_7EA9 [] = {0x10, 0x40, 0x13, 0xF0, 0x2A, 0x00, 0x2A, 0x00, 0x72, 0x00, 0x12, 0x00, 0x2A, 0x00, 0x72, 0x00, 0x02, 0x00, 0x1A, 0x00, 0x64, 0x00, 0x00, 0x00 }; /*7EA9*/
const unsigned char  uc2_7EAA [] = {0x10, 0x00, 0x13, 0xE0, 0x28, 0x20, 0x28, 0x20, 0x71, 0xE0, 0x11, 0x20, 0x29, 0x00, 0x71, 0x10, 0x01, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*7EAA*/
const unsigned char  uc2_7EAB [] = {0x10, 0x00, 0x13, 0xF0, 0x28, 0x50, 0x28, 0x50, 0x71, 0x50, 0x11, 0x50, 0x2A, 0x50, 0x70, 0x50, 0x00, 0x90, 0x18, 0x90, 0x63, 0x60, 0x00, 0x00 }; /*7EAB*/
const unsigned char  uc2_7EAC [] = {0x10, 0x80, 0x10, 0x80, 0x2B, 0xF0, 0x28, 0x80, 0x71, 0xE0, 0x10, 0x80, 0x2B, 0xF0, 0x74, 0x90, 0x04, 0x90, 0x18, 0xE0, 0x60, 0x80, 0x00, 0x00 }; /*7EAC*/
const unsigned char  uc2_7EAD [] = {0x10, 0x00, 0x13, 0xE0, 0x28, 0x00, 0x28, 0x00, 0x77, 0xF0, 0x10, 0x80, 0x28, 0x80, 0x71, 0x20, 0x02, 0x60, 0x1B, 0x90, 0x60, 0x10, 0x00, 0x00 }; /*7EAD*/
const unsigned char  uc2_7EAF [] = {0x10, 0x80, 0x17, 0xF0, 0x28, 0x80, 0x2A, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x2B, 0xE0, 0x70, 0xA0, 0x00, 0x90, 0x18, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*7EAF*/
const unsigned char  uc2_7EB0 [] = {0x12, 0x40, 0x12, 0x40, 0x2A, 0x40, 0x2A, 0x50, 0x73, 0x60, 0x12, 0x40, 0x2A, 0x40, 0x72, 0x50, 0x02, 0x50, 0x1A, 0xD0, 0x63, 0x20, 0x00, 0x00 }; /*7EB0*/
const unsigned char  uc2_7EB1 [] = {0x10, 0x80, 0x10, 0x80, 0x2A, 0xA0, 0x2A, 0x90, 0x74, 0x90, 0x10, 0xA0, 0x28, 0xA0, 0x70, 0x20, 0x00, 0x40, 0x19, 0x80, 0x66, 0x00, 0x00, 0x00 }; /*7EB1*/
const unsigned char  uc2_7EB2 [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x10, 0x2C, 0x50, 0x77, 0x50, 0x14, 0x90, 0x2D, 0x50, 0x76, 0x50, 0x04, 0x10, 0x1C, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*7EB2*/
const unsigned char  uc2_7EB3 [] = {0x10, 0x80, 0x10, 0x80, 0x27, 0xF0, 0x2C, 0x90, 0x74, 0x90, 0x15, 0x50, 0x2D, 0x50, 0x76, 0x50, 0x04, 0x10, 0x1C, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*7EB3*/
const unsigned char  uc2_7EB4 [] = {0x10, 0x60, 0x13, 0x80, 0x28, 0x80, 0x28, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x28, 0x80, 0x70, 0x80, 0x00, 0x80, 0x18, 0x80, 0x63, 0xE0, 0x00, 0x00 }; /*7EB4*/
const unsigned char  uc2_7EB5 [] = {0x12, 0x40, 0x12, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x72, 0x40, 0x12, 0x40, 0x2B, 0x40, 0x74, 0xA0, 0x04, 0xA0, 0x14, 0xA0, 0x69, 0x10, 0x00, 0x00 }; /*7EB5*/
const unsigned char  uc2_7EB6 [] = {0x10, 0x80, 0x10, 0x80, 0x29, 0x40, 0x29, 0x40, 0x76, 0x30, 0x11, 0x00, 0x29, 0x20, 0x71, 0xC0, 0x01, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*7EB6*/
const unsigned char  uc2_7EB7 [] = {0x10, 0x40, 0x11, 0x40, 0x29, 0x20, 0x29, 0x20, 0x72, 0x10, 0x11, 0xE0, 0x28, 0xA0, 0x70, 0xA0, 0x01, 0x20, 0x19, 0x20, 0x62, 0x40, 0x00, 0x00 }; /*7EB7*/
const unsigned char  uc2_7EB8 [] = {0x10, 0x30, 0x13, 0xC0, 0x2A, 0x40, 0x2A, 0x40, 0x73, 0xF0, 0x12, 0x40, 0x2A, 0x40, 0x72, 0x50, 0x02, 0x50, 0x1A, 0xB0, 0x63, 0x10, 0x00, 0x00 }; /*7EB8*/
const unsigned char  uc2_7EB9 [] = {0x11, 0x00, 0x10, 0x80, 0x27, 0xF0, 0x2A, 0x20, 0x72, 0x20, 0x11, 0x40, 0x29, 0x40, 0x70, 0x80, 0x01, 0x40, 0x1A, 0x20, 0x64, 0x10, 0x00, 0x00 }; /*7EB9*/
const unsigned char  uc2_7EBA [] = {0x11, 0x00, 0x10, 0x80, 0x2F, 0xF0, 0x29, 0x00, 0x71, 0x00, 0x11, 0xE0, 0x29, 0x20, 0x71, 0x20, 0x01, 0x20, 0x1A, 0x20, 0x64, 0xC0, 0x00, 0x00 }; /*7EBA*/
const unsigned char  uc2_7EBD [] = {0x10, 0x00, 0x13, 0xF0, 0x28, 0x90, 0x28, 0x90, 0x70, 0x90, 0x13, 0xE0, 0x29, 0x20, 0x71, 0x20, 0x01, 0x20, 0x19, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*7EBD*/
const unsigned char  uc2_7EBE [] = {0x10, 0x00, 0x11, 0xE0, 0x28, 0xA0, 0x28, 0x40, 0x73, 0xF0, 0x10, 0x50, 0x2C, 0x60, 0x70, 0x40, 0x00, 0x40, 0x1C, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*7EBE*/
const unsigned char  uc2_7EBF [] = {0x11, 0x40, 0x11, 0x60, 0x27, 0x80, 0x29, 0x00, 0x71, 0x60, 0x17, 0x80, 0x29, 0x20, 0x71, 0x20, 0x00, 0xD0, 0x19, 0x90, 0x66, 0x60, 0x00, 0x00 }; /*7EBF*/
const unsigned char  uc2_7EC0 [] = {0x12, 0x20, 0x12, 0x20, 0x2F, 0xF0, 0x2A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x2A, 0x20, 0x72, 0x20, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7EC0*/
const unsigned char  uc2_7EC1 [] = {0x10, 0xA0, 0x12, 0xA0, 0x2A, 0xA0, 0x2F, 0xF0, 0x72, 0xA0, 0x12, 0xA0, 0x2A, 0xA0, 0x72, 0xE0, 0x02, 0x00, 0x1A, 0x00, 0x63, 0xF0, 0x00, 0x00 }; /*7EC1*/
const unsigned char  uc2_7EC2 [] = {0x11, 0x40, 0x11, 0x20, 0x2F, 0xF0, 0x29, 0x00, 0x71, 0xE0, 0x12, 0xA0, 0x2A, 0xA0, 0x72, 0xA0, 0x02, 0x40, 0x1A, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*7EC2*/
const unsigned char  uc2_7EC3 [] = {0x10, 0x80, 0x17, 0xF0, 0x28, 0x80, 0x2B, 0xC0, 0x71, 0x40, 0x12, 0x40, 0x2B, 0xF0, 0x70, 0x40, 0x01, 0x60, 0x1E, 0x50, 0x61, 0x80, 0x00, 0x00 }; /*7EC3*/
const unsigned char  uc2_7EC4 [] = {0x10, 0x00, 0x13, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x73, 0xE0, 0x12, 0x20, 0x2A, 0x20, 0x73, 0xE0, 0x02, 0x20, 0x1A, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*7EC4*/
const unsigned char  uc2_7EC5 [] = {0x10, 0x40, 0x10, 0x40, 0x29, 0xF0, 0x29, 0x50, 0x71, 0xF0, 0x11, 0x50, 0x2D, 0xF0, 0x71, 0x50, 0x00, 0x40, 0x1C, 0x40, 0x60, 0x40, 0x00, 0x00 }; /*7EC5*/
const unsigned char  uc2_7EC6 [] = {0x10, 0x00, 0x17, 0xF0, 0x24, 0x90, 0x2C, 0x90, 0x74, 0x90, 0x17, 0xF0, 0x2C, 0x90, 0x74, 0x90, 0x04, 0x90, 0x1F, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*7EC6*/
const unsigned char  uc2_7EC7 [] = {0x10, 0x00, 0x13, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x28, 0x00, 0x71, 0x40, 0x01, 0x20, 0x1A, 0x20, 0x64, 0x20, 0x00, 0x00 }; /*7EC7*/
const unsigned char  uc2_7EC8 [] = {0x11, 0x00, 0x11, 0xE0, 0x2B, 0x20, 0x29, 0x20, 0x70, 0xC0, 0x11, 0x20, 0x2E, 0x10, 0x70, 0xC0, 0x00, 0x20, 0x19, 0xC0, 0x60, 0x20, 0x00, 0x00 }; /*7EC8*/
const unsigned char  uc2_7EC9 [] = {0x11, 0x00, 0x11, 0xE0, 0x2A, 0x20, 0x29, 0xF0, 0x70, 0x10, 0x10, 0x10, 0x2B, 0xF0, 0x70, 0x10, 0x0C, 0x10, 0x77, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*7EC9*/
const unsigned char  uc2_7ECA [] = {0x10, 0x80, 0x12, 0xA0, 0x29, 0x40, 0x2B, 0xE0, 0x70, 0x80, 0x10, 0x80, 0x2F, 0xF0, 0x70, 0x80, 0x00, 0x80, 0x18, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7ECA*/
const unsigned char  uc2_7ECB [] = {0x11, 0x40, 0x17, 0xF0, 0x29, 0x50, 0x2B, 0xF0, 0x75, 0x40, 0x17, 0xF0, 0x29, 0x50, 0x71, 0x50, 0x02, 0x50, 0x1A, 0x60, 0x64, 0x40, 0x00, 0x00 }; /*7ECB*/
const unsigned char  uc2_7ECC [] = {0x10, 0x80, 0x14, 0x90, 0x24, 0x90, 0x2C, 0x90, 0x77, 0xF0, 0x10, 0x80, 0x2C, 0x90, 0x74, 0x90, 0x04, 0x90, 0x1F, 0xF0, 0x60, 0x10, 0x00, 0x00 }; /*7ECC*/
const unsigned char  uc2_7ECD [] = {0x10, 0x00, 0x13, 0xF0, 0x28, 0x90, 0x29, 0x10, 0x76, 0x60, 0x10, 0x00, 0x2B, 0xF0, 0x72, 0x10, 0x02, 0x10, 0x1B, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*7ECD*/
const unsigned char  uc2_7ECE [] = {0x10, 0x00, 0x17, 0xE0, 0x22, 0x20, 0x29, 0xC0, 0x76, 0x30, 0x10, 0x80, 0x2B, 0xE0, 0x70, 0x80, 0x07, 0xF0, 0x18, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7ECE*/
const unsigned char  uc2_7ECF [] = {0x10, 0x00, 0x13, 0xC0, 0x28, 0x40, 0x28, 0x80, 0x71, 0x60, 0x16, 0x10, 0x28, 0x00, 0x73, 0xE0, 0x00, 0x80, 0x18, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*7ECF*/
const unsigned char  uc2_7ED0 [] = {0x11, 0x00, 0x11, 0x40, 0x2A, 0x20, 0x2C, 0x60, 0x77, 0x90, 0x10, 0x10, 0x2B, 0xE0, 0x72, 0x20, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7ED0*/
const unsigned char  uc2_7ED1 [] = {0x12, 0x00, 0x12, 0x70, 0x2F, 0xD0, 0x2A, 0x50, 0x77, 0x60, 0x12, 0x50, 0x2F, 0xD0, 0x72, 0x50, 0x02, 0x60, 0x1A, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*7ED1*/
const unsigned char  uc2_7ED2 [] = {0x10, 0x50, 0x13, 0xF0, 0x28, 0x40, 0x29, 0x40, 0x71, 0x50, 0x13, 0xD0, 0x29, 0x50, 0x71, 0x60, 0x02, 0x40, 0x18, 0xD0, 0x61, 0x20, 0x00, 0x00 }; /*7ED2*/
const unsigned char  uc2_7ED3 [] = {0x10, 0x80, 0x10, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x73, 0xE0, 0x10, 0x00, 0x2B, 0xE0, 0x72, 0x20, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7ED3*/
const unsigned char  uc2_7ED4 [] = {0x10, 0x80, 0x17, 0xF0, 0x29, 0x40, 0x2E, 0x30, 0x71, 0xC0, 0x10, 0x00, 0x2F, 0xF0, 0x71, 0x00, 0x03, 0xE0, 0x18, 0x20, 0x61, 0xC0, 0x00, 0x00 }; /*7ED4*/
const unsigned char  uc2_7ED5 [] = {0x11, 0x00, 0x11, 0xF0, 0x2F, 0x00, 0x29, 0x60, 0x70, 0x90, 0x17, 0x60, 0x28, 0x00, 0x77, 0xF0, 0x01, 0x40, 0x19, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*7ED5*/
const unsigned char  uc2_7ED7 [] = {0x12, 0x00, 0x12, 0x60, 0x2C, 0x00, 0x29, 0x00, 0x71, 0xF0, 0x16, 0x20, 0x2A, 0x20, 0x72, 0x20, 0x02, 0x20, 0x1A, 0x20, 0x62, 0xC0, 0x00, 0x00 }; /*7ED7*/
const unsigned char  uc2_7ED8 [] = {0x10, 0x80, 0x10, 0x80, 0x29, 0x40, 0x2E, 0x30, 0x71, 0xC0, 0x10, 0x00, 0x2B, 0xE0, 0x71, 0x00, 0x02, 0x20, 0x1B, 0xD0, 0x60, 0x10, 0x00, 0x00 }; /*7ED8*/
const unsigned char  uc2_7ED9 [] = {0x10, 0x80, 0x10, 0x80, 0x29, 0x40, 0x2E, 0x30, 0x71, 0xC0, 0x10, 0x00, 0x2B, 0xE0, 0x72, 0x20, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7ED9*/
const unsigned char  uc2_7EDA [] = {0x11, 0x00, 0x11, 0xF0, 0x2A, 0x10, 0x2D, 0xD0, 0x71, 0x50, 0x11, 0xD0, 0x29, 0x50, 0x71, 0xD0, 0x01, 0x50, 0x18, 0x10, 0x60, 0x60, 0x00, 0x00 }; /*7EDA*/
const unsigned char  uc2_7EDB [] = {0x12, 0x00, 0x13, 0xE0, 0x2E, 0x20, 0x29, 0xC0, 0x76, 0x30, 0x10, 0x80, 0x29, 0xE0, 0x72, 0x80, 0x07, 0xF0, 0x18, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7EDB*/
const unsigned char  uc2_7EDC [] = {0x12, 0x00, 0x13, 0xE0, 0x2E, 0x20, 0x29, 0xC0, 0x76, 0x30, 0x10, 0x00, 0x2B, 0xE0, 0x72, 0x20, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7EDC*/
const unsigned char  uc2_7EDD [] = {0x11, 0x00, 0x11, 0xC0, 0x2A, 0x40, 0x2F, 0xE0, 0x72, 0xA0, 0x12, 0xA0, 0x2B, 0xE0, 0x72, 0x00, 0x02, 0x10, 0x1A, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*7EDD*/
const unsigned char  uc2_7EDE [] = {0x10, 0x80, 0x17, 0xF0, 0x29, 0x40, 0x2A, 0x20, 0x71, 0x40, 0x11, 0x40, 0x29, 0x40, 0x70, 0x80, 0x00, 0x80, 0x19, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*7EDE*/
const unsigned char  uc2_7EDF [] = {0x10, 0x80, 0x17, 0xF0, 0x29, 0x00, 0x29, 0x20, 0x72, 0x60, 0x13, 0x90, 0x28, 0x10, 0x71, 0x40, 0x01, 0x50, 0x1A, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*7EDF*/
const unsigned char  uc2_7EE0 [] = {0x10, 0x00, 0x17, 0xF0, 0x28, 0x80, 0x2B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x2A, 0xA0, 0x73, 0xE0, 0x02, 0x80, 0x19, 0x80, 0x66, 0x70, 0x00, 0x00 }; /*7EE0*/
const unsigned char  uc2_7EE1 [] = {0x10, 0x40, 0x11, 0x50, 0x28, 0xA0, 0x29, 0xF0, 0x71, 0x10, 0x11, 0xF0, 0x2D, 0x10, 0x71, 0xF0, 0x01, 0x10, 0x1D, 0x10, 0x61, 0x60, 0x00, 0x00 }; /*7EE1*/
const unsigned char  uc2_7EE2 [] = {0x11, 0xE0, 0x11, 0x20, 0x29, 0xE0, 0x28, 0x00, 0x73, 0xF0, 0x12, 0x10, 0x2B, 0xF0, 0x72, 0x10, 0x03, 0xF0, 0x1A, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*7EE2*/
const unsigned char  uc2_7EE3 [] = {0x10, 0x60, 0x13, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x71, 0x40, 0x16, 0xB0, 0x2B, 0xE0, 0x71, 0x40, 0x01, 0x70, 0x1A, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*7EE3*/
const unsigned char  uc2_7EE5 [] = {0x10, 0x70, 0x17, 0xA0, 0x25, 0x20, 0x2A, 0xA0, 0x72, 0xC0, 0x11, 0x00, 0x2F, 0xF0, 0x71, 0x20, 0x03, 0xC0, 0x18, 0xA0, 0x67, 0x10, 0x00, 0x00 }; /*7EE5*/
const unsigned char  uc2_7EE6 [] = {0x12, 0x00, 0x13, 0xE0, 0x26, 0x20, 0x29, 0xC0, 0x76, 0x30, 0x10, 0x80, 0x2B, 0xE0, 0x70, 0x80, 0x02, 0xA0, 0x1C, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*7EE6*/
const unsigned char  uc2_7EE7 [] = {0x10, 0x40, 0x12, 0x50, 0x2B, 0x50, 0x2A, 0xA0, 0x73, 0xF0, 0x12, 0x40, 0x2A, 0xE0, 0x73, 0x50, 0x02, 0x40, 0x1A, 0x40, 0x63, 0xF0, 0x00, 0x00 }; /*7EE7*/
const unsigned char  uc2_7EE8 [] = {0x11, 0x40, 0x13, 0xE0, 0x28, 0xA0, 0x29, 0xE0, 0x72, 0x80, 0x13, 0xF0, 0x29, 0x90, 0x72, 0x90, 0x02, 0x90, 0x1C, 0xA0, 0x60, 0x80, 0x00, 0x00 }; /*7EE8*/
const unsigned char  uc2_7EE9 [] = {0x10, 0x80, 0x13, 0xE0, 0x28, 0x80, 0x29, 0xC0, 0x70, 0x80, 0x17, 0xF0, 0x2A, 0x20, 0x72, 0xA0, 0x02, 0xA0, 0x19, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*7EE9*/
const unsigned char  uc2_7EEA [] = {0x10, 0x90, 0x13, 0xE0, 0x28, 0xA0, 0x2F, 0xF0, 0x70, 0x80, 0x11, 0xE0, 0x2F, 0x20, 0x71, 0xE0, 0x01, 0x20, 0x19, 0xE0, 0x61, 0x20, 0x00, 0x00 }; /*7EEA*/
const unsigned char  uc2_7EEB [] = {0x10, 0x80, 0x13, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x71, 0x40, 0x16, 0x20, 0x29, 0x00, 0x71, 0xE0, 0x06, 0x20, 0x19, 0xC0, 0x66, 0x30, 0x00, 0x00 }; /*7EEB*/
const unsigned char  uc2_7EED [] = {0x10, 0x80, 0x13, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x72, 0x10, 0x15, 0xA0, 0x2A, 0x80, 0x77, 0xF0, 0x00, 0x80, 0x19, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*7EED*/
const unsigned char  uc2_7EEE [] = {0x10, 0x80, 0x17, 0xF0, 0x29, 0x40, 0x2A, 0x20, 0x77, 0xF0, 0x10, 0x20, 0x2B, 0xA0, 0x72, 0xA0, 0x03, 0xA0, 0x1A, 0xA0, 0x60, 0xC0, 0x00, 0x00 }; /*7EEE*/
const unsigned char  uc2_7EEF [] = {0x11, 0x40, 0x11, 0x40, 0x2F, 0x70, 0x29, 0x40, 0x73, 0x60, 0x11, 0x40, 0x29, 0x40, 0x77, 0x70, 0x01, 0x40, 0x19, 0x40, 0x61, 0x40, 0x00, 0x00 }; /*7EEF*/
const unsigned char  uc2_7EF0 [] = {0x20, 0x80, 0x20, 0xF0, 0x48, 0x80, 0x73, 0xE0, 0x12, 0x20, 0x23, 0xE0, 0x4A, 0x20, 0x73, 0xE0, 0x00, 0x80, 0x1F, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*7EF0*/
const unsigned char  uc2_7EF1 [] = {0x14, 0x90, 0x12, 0x90, 0x22, 0xA0, 0x2F, 0xF0, 0x74, 0x10, 0x15, 0xD0, 0x2D, 0x50, 0x75, 0xD0, 0x04, 0x10, 0x1C, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*7EF1*/
const unsigned char  uc2_7EF2 [] = {0x10, 0x00, 0x13, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x2A, 0x50, 0x73, 0x60, 0x02, 0x50, 0x1A, 0xD0, 0x63, 0x20, 0x00, 0x00 }; /*7EF2*/
const unsigned char  uc2_7EF3 [] = {0x11, 0xC0, 0x11, 0x40, 0x2B, 0xE0, 0x2A, 0xA0, 0x73, 0xE0, 0x12, 0xA0, 0x2B, 0xE0, 0x72, 0xA0, 0x00, 0x90, 0x18, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*7EF3*/
const unsigned char  uc2_7EF4 [] = {0x11, 0x80, 0x11, 0x40, 0x2B, 0xF0, 0x2E, 0x40, 0x73, 0xE0, 0x12, 0x40, 0x2B, 0xE0, 0x72, 0x40, 0x02, 0x40, 0x1B, 0xF0, 0x62, 0x00, 0x00, 0x00 }; /*7EF4*/
const unsigned char  uc2_7EF5 [] = {0x10, 0x80, 0x13, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x28, 0x80, 0x77, 0xF0, 0x04, 0x90, 0x1C, 0xE0, 0x60, 0x80, 0x00, 0x00 }; /*7EF5*/
const unsigned char  uc2_7EF6 [] = {0x10, 0x30, 0x13, 0xD0, 0x29, 0x50, 0x2B, 0xF0, 0x72, 0x10, 0x11, 0xE0, 0x2C, 0xA0, 0x70, 0xA0, 0x00, 0x40, 0x1C, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*7EF6*/
const unsigned char  uc2_7EF7 [] = {0x10, 0x00, 0x17, 0x70, 0x25, 0x50, 0x2D, 0x50, 0x77, 0x70, 0x15, 0x50, 0x2F, 0x70, 0x75, 0x50, 0x0D, 0x50, 0x75, 0x50, 0x0A, 0xA0, 0x00, 0x00 }; /*7EF7*/
const unsigned char  uc2_7EF8 [] = {0x17, 0xF0, 0x14, 0x90, 0x25, 0xD0, 0x2C, 0x90, 0x77, 0xF0, 0x14, 0x10, 0x2D, 0xD0, 0x75, 0x50, 0x05, 0xD0, 0x18, 0x10, 0x68, 0x60, 0x00, 0x00 }; /*7EF8*/
const unsigned char  uc2_7EFA [] = {0x12, 0x20, 0x13, 0xA0, 0x2A, 0xB0, 0x2E, 0xA0, 0x71, 0x20, 0x16, 0xF0, 0x28, 0x00, 0x73, 0xE0, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7EFA*/
const unsigned char  uc2_7EFB [] = {0x10, 0x80, 0x12, 0xA0, 0x27, 0xE0, 0x29, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x2F, 0xF0, 0x72, 0x40, 0x02, 0xA0, 0x1A, 0x20, 0x61, 0xC0, 0x00, 0x00 }; /*7EFB*/
const unsigned char  uc2_7EFC [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x2B, 0xE0, 0x70, 0x00, 0x17, 0xF0, 0x28, 0x80, 0x72, 0xA0, 0x02, 0x90, 0x1C, 0x90, 0x61, 0x00, 0x00, 0x00 }; /*7EFC*/
const unsigned char  uc2_7EFD [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x28, 0x00, 0x77, 0xF0, 0x10, 0x80, 0x2A, 0x80, 0x72, 0xE0, 0x02, 0x80, 0x1B, 0x80, 0x64, 0x70, 0x00, 0x00 }; /*7EFD*/
const unsigned char  uc2_7EFE [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x2B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x2A, 0x00, 0x73, 0xF0, 0x02, 0x10, 0x1B, 0xF0, 0x62, 0x10, 0x00, 0x00 }; /*7EFE*/
const unsigned char  uc2_7EFF [] = {0x13, 0xE0, 0x10, 0x20, 0x29, 0xC0, 0x28, 0x40, 0x77, 0xF0, 0x10, 0x80, 0x2E, 0x90, 0x71, 0xE0, 0x02, 0xA0, 0x1C, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*7EFF*/
const unsigned char  uc2_7F00 [] = {0x17, 0x70, 0x11, 0x10, 0x25, 0x50, 0x2A, 0x20, 0x75, 0x50, 0x10, 0x00, 0x2F, 0x70, 0x71, 0x50, 0x05, 0x50, 0x1A, 0x20, 0x65, 0x50, 0x00, 0x00 }; /*7F00*/
const unsigned char  uc2_7F01 [] = {0x24, 0x90, 0x24, 0x90, 0x49, 0x20, 0x74, 0x90, 0x17, 0xF0, 0x24, 0x90, 0x4C, 0x90, 0x77, 0xF0, 0x04, 0x90, 0x1C, 0x90, 0x67, 0xF0, 0x00, 0x00 }; /*7F01*/
const unsigned char  uc2_7F02 [] = {0x11, 0x40, 0x17, 0xF0, 0x29, 0x40, 0x28, 0x80, 0x73, 0xE0, 0x12, 0xA0, 0x2B, 0xE0, 0x70, 0x80, 0x07, 0xF0, 0x18, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7F02*/
const unsigned char  uc2_7F03 [] = {0x11, 0x00, 0x11, 0x70, 0x2B, 0xD0, 0x29, 0x50, 0x71, 0x70, 0x13, 0xD0, 0x2D, 0x70, 0x71, 0x50, 0x01, 0x50, 0x19, 0x70, 0x61, 0x50, 0x00, 0x00 }; /*7F03*/
const unsigned char  uc2_7F04 [] = {0x10, 0x50, 0x17, 0xF0, 0x24, 0x40, 0x2F, 0x40, 0x74, 0x50, 0x17, 0x50, 0x2D, 0x50, 0x77, 0x60, 0x04, 0x50, 0x18, 0xD0, 0x6B, 0x20, 0x00, 0x00 }; /*7F04*/
const unsigned char  uc2_7F05 [] = {0x10, 0x00, 0x17, 0xF0, 0x20, 0x80, 0x2F, 0xF0, 0x75, 0x50, 0x15, 0xD0, 0x2D, 0x50, 0x75, 0xD0, 0x05, 0x50, 0x1F, 0xF0, 0x64, 0x10, 0x00, 0x00 }; /*7F05*/
const unsigned char  uc2_7F06 [] = {0x11, 0x40, 0x15, 0x70, 0x25, 0xA0, 0x2D, 0x10, 0x73, 0xE0, 0x12, 0x20, 0x2A, 0xA0, 0x72, 0xA0, 0x00, 0x90, 0x19, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*7F06*/
const unsigned char  uc2_7F07 [] = {0x13, 0xE0, 0x12, 0x20, 0x23, 0xE0, 0x2A, 0x20, 0x77, 0xF0, 0x10, 0x80, 0x2A, 0x80, 0x72, 0xE0, 0x02, 0x80, 0x1B, 0x80, 0x64, 0x70, 0x00, 0x00 }; /*7F07*/
const unsigned char  uc2_7F08 [] = {0x20, 0x40, 0x2E, 0x40, 0x4A, 0xE0, 0x5F, 0x50, 0x2A, 0x50, 0x2E, 0x40, 0x5A, 0x20, 0x6E, 0x20, 0x0A, 0x40, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*7F08*/
const unsigned char  uc2_7F09 [] = {0x10, 0x00, 0x11, 0xE0, 0x29, 0x20, 0x2B, 0xF0, 0x71, 0x20, 0x11, 0xE0, 0x29, 0x20, 0x71, 0xE0, 0x01, 0x30, 0x1B, 0xE0, 0x60, 0x20, 0x00, 0x00 }; /*7F09*/
const unsigned char  uc2_7F0B [] = {0x10, 0x80, 0x13, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x2A, 0x20, 0x72, 0xA0, 0x02, 0xA0, 0x19, 0x40, 0x66, 0x20, 0x00, 0x00 }; /*7F0B*/
const unsigned char  uc2_7F0C [] = {0x10, 0x00, 0x13, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x28, 0x80, 0x72, 0x50, 0x05, 0x10, 0x19, 0x40, 0x60, 0x80, 0x00, 0x00 }; /*7F0C*/
const unsigned char  uc2_7F0D [] = {0x20, 0x60, 0x23, 0x80, 0x20, 0x80, 0x57, 0xF0, 0x62, 0xA0, 0x2F, 0xF0, 0x52, 0xA0, 0x67, 0xF0, 0x00, 0x80, 0x1B, 0xE0, 0x60, 0x00, 0x00, 0x00 }; /*7F0D*/
const unsigned char  uc2_7F0E [] = {0x22, 0x00, 0x24, 0xE0, 0x54, 0xA0, 0x56, 0xA0, 0x65, 0x10, 0x26, 0xE0, 0x54, 0xA0, 0x66, 0xA0, 0x0C, 0x40, 0x14, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*7F0E*/
const unsigned char  uc2_7F0F [] = {0x12, 0x00, 0x13, 0xF0, 0x24, 0x40, 0x2D, 0xF0, 0x75, 0x50, 0x15, 0xF0, 0x2D, 0x50, 0x75, 0xF0, 0x05, 0x40, 0x1C, 0x80, 0x67, 0x70, 0x00, 0x00 }; /*7F0F*/
const unsigned char  uc2_7F11 [] = {0x11, 0x00, 0x11, 0xE0, 0x2A, 0x20, 0x2F, 0xF0, 0x72, 0x80, 0x12, 0xE0, 0x2B, 0x40, 0x73, 0xF0, 0x02, 0x40, 0x1A, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*7F11*/
const unsigned char  uc2_7F12 [] = {0x14, 0x40, 0x12, 0xE0, 0x28, 0xA0, 0x2E, 0xE0, 0x72, 0x80, 0x12, 0xE0, 0x2A, 0xA0, 0x72, 0xA0, 0x02, 0xE0, 0x1D, 0x00, 0x64, 0xF0, 0x00, 0x00 }; /*7F12*/
const unsigned char  uc2_7F13 [] = {0x10, 0x70, 0x17, 0x90, 0x2A, 0xA0, 0x2B, 0xE0, 0x71, 0x00, 0x17, 0xF0, 0x29, 0x00, 0x71, 0xE0, 0x01, 0x20, 0x1E, 0xC0, 0x63, 0x30, 0x00, 0x00 }; /*7F13*/
const unsigned char  uc2_7F14 [] = {0x10, 0x80, 0x13, 0xE0, 0x21, 0x40, 0x2F, 0xF0, 0x74, 0x10, 0x14, 0x90, 0x2B, 0xE0, 0x72, 0xA0, 0x02, 0xA0, 0x1A, 0xC0, 0x60, 0x80, 0x00, 0x00 }; /*7F14*/
const unsigned char  uc2_7F15 [] = {0x14, 0x90, 0x12, 0xA0, 0x27, 0xF0, 0x2A, 0xA0, 0x74, 0x90, 0x11, 0x00, 0x2F, 0xF0, 0x71, 0x20, 0x02, 0x40, 0x19, 0xA0, 0x66, 0x10, 0x00, 0x00 }; /*7F15*/
const unsigned char  uc2_7F16 [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x10, 0x2F, 0xF0, 0x74, 0x00, 0x17, 0xF0, 0x2D, 0x50, 0x77, 0xF0, 0x15, 0x50, 0x6D, 0x50, 0x15, 0x20, 0x00, 0x00 }; /*7F16*/
const unsigned char  uc2_7F17 [] = {0x17, 0xE0, 0x14, 0x20, 0x27, 0xE0, 0x2C, 0x80, 0x77, 0xE0, 0x14, 0x50, 0x2F, 0xF0, 0x74, 0x20, 0x07, 0xE0, 0x1C, 0x20, 0x67, 0xE0, 0x00, 0x00 }; /*7F17*/
const unsigned char  uc2_7F18 [] = {0x11, 0x80, 0x12, 0x40, 0x29, 0x80, 0x2F, 0xE0, 0x71, 0x00, 0x16, 0x90, 0x29, 0xE0, 0x76, 0xA0, 0x01, 0xA0, 0x1E, 0x90, 0x61, 0x00, 0x00, 0x00 }; /*7F18*/
const unsigned char  uc2_7F19 [] = {0x13, 0xE0, 0x11, 0x40, 0x25, 0x50, 0x2B, 0x60, 0x77, 0xF0, 0x10, 0x00, 0x2B, 0xE0, 0x72, 0x20, 0x03, 0xE0, 0x1A, 0x20, 0x63, 0xE0, 0x00, 0x00 }; /*7F19*/
const unsigned char  uc2_7F1A [] = {0x10, 0xA0, 0x17, 0xF0, 0x2A, 0xA0, 0x2B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x2A, 0xA0, 0x70, 0x40, 0x07, 0xF0, 0x19, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*7F1A*/
const unsigned char  uc2_7F1B [] = {0x17, 0xF0, 0x14, 0x00, 0x25, 0xE0, 0x2C, 0x00, 0x77, 0xF0, 0x15, 0x50, 0x2D, 0xA0, 0x74, 0x20, 0x07, 0xF0, 0x19, 0x20, 0x68, 0xC0, 0x00, 0x00 }; /*7F1B*/
const unsigned char  uc2_7F1C [] = {0x10, 0x40, 0x10, 0x40, 0x2B, 0xF0, 0x28, 0x80, 0x71, 0xE0, 0x11, 0x20, 0x29, 0xE0, 0x71, 0x20, 0x03, 0xF0, 0x19, 0x20, 0x62, 0x10, 0x00, 0x00 }; /*7F1C*/
const unsigned char  uc2_7F1D [] = {0x28, 0xE0, 0x25, 0xA0, 0x50, 0x40, 0x5D, 0xB0, 0x64, 0x40, 0x25, 0xF0, 0x54, 0x40, 0x64, 0xA0, 0x05, 0xF0, 0x1A, 0x40, 0x69, 0xF0, 0x00, 0x00 }; /*7F1D*/
const unsigned char  uc2_7F1F [] = {0x10, 0x80, 0x17, 0xF0, 0x2A, 0x20, 0x2B, 0xE0, 0x70, 0x00, 0x17, 0xF0, 0x2C, 0x90, 0x75, 0x50, 0x05, 0xD0, 0x1C, 0x10, 0x64, 0x60, 0x00, 0x00 }; /*7F1F*/
const unsigned char  uc2_7F20 [] = {0x21, 0x00, 0x20, 0x80, 0x4F, 0xF0, 0x5A, 0xA0, 0x6B, 0xE0, 0x2A, 0xA0, 0x5B, 0xE0, 0x68, 0x80, 0x0B, 0xE0, 0x30, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*7F20*/
const unsigned char  uc2_7F21 [] = {0x10, 0x80, 0x17, 0xF0, 0x29, 0x40, 0x2A, 0xA0, 0x73, 0x60, 0x12, 0x20, 0x2F, 0xF0, 0x74, 0x90, 0x05, 0x50, 0x1D, 0xD0, 0x64, 0x60, 0x00, 0x00 }; /*7F21*/
const unsigned char  uc2_7F22 [] = {0x24, 0x40, 0x22, 0x80, 0x40, 0x00, 0x5F, 0xF0, 0x60, 0x00, 0x22, 0xC0, 0x5C, 0x20, 0x60, 0x00, 0x0F, 0xE0, 0x2A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*7F22*/
const unsigned char  uc2_7F23 [] = {0x22, 0x80, 0x2F, 0xE0, 0x52, 0x80, 0x7F, 0xE0, 0x22, 0xA0, 0x2F, 0xF0, 0x52, 0xA0, 0x7F, 0xE0, 0x06, 0xC0, 0x1A, 0xB0, 0x62, 0x80, 0x00, 0x00 }; /*7F23*/
const unsigned char  uc2_7F24 [] = {0x10, 0x80, 0x17, 0xF0, 0x24, 0x50, 0x2B, 0x80, 0x72, 0x00, 0x13, 0xE0, 0x2A, 0x80, 0x77, 0xF0, 0x01, 0x40, 0x19, 0x20, 0x66, 0x20, 0x00, 0x00 }; /*7F24*/
const unsigned char  uc2_7F25 [] = {0x17, 0xF0, 0x11, 0x40, 0x27, 0xF0, 0x2D, 0x50, 0x77, 0xF0, 0x10, 0x00, 0x2B, 0xE0, 0x70, 0x00, 0x07, 0xF0, 0x1A, 0xA0, 0x65, 0x90, 0x00, 0x00 }; /*7F25*/
const unsigned char  uc2_7F26 [] = {0x13, 0xE0, 0x12, 0x20, 0x23, 0xE0, 0x2A, 0x20, 0x77, 0xF0, 0x15, 0x50, 0x2F, 0xF0, 0x72, 0x10, 0x01, 0x20, 0x18, 0xC0, 0x67, 0x30, 0x00, 0x00 }; /*7F26*/
const unsigned char  uc2_7F27 [] = {0x13, 0xE0, 0x12, 0xA0, 0x23, 0xE0, 0x2A, 0xA0, 0x73, 0xE0, 0x11, 0x00, 0x2A, 0xA0, 0x71, 0x30, 0x07, 0xD0, 0x1A, 0xA0, 0x65, 0x90, 0x00, 0x00 }; /*7F27*/
const unsigned char  uc2_7F28 [] = {0x10, 0x00, 0x17, 0x70, 0x25, 0x50, 0x2D, 0x50, 0x72, 0x20, 0x15, 0x50, 0x29, 0x10, 0x77, 0xF0, 0x02, 0x40, 0x19, 0xA0, 0x66, 0x10, 0x00, 0x00 }; /*7F28*/
const unsigned char  uc2_7F29 [] = {0x10, 0x80, 0x17, 0xF0, 0x25, 0x10, 0x29, 0xE0, 0x72, 0x40, 0x16, 0xE0, 0x2A, 0xA0, 0x72, 0xE0, 0x02, 0xA0, 0x1A, 0xE0, 0x62, 0xA0, 0x00, 0x00 }; /*7F29*/
const unsigned char  uc2_7F2A [] = {0x17, 0x70, 0x15, 0x50, 0x23, 0x30, 0x2D, 0x50, 0x70, 0x80, 0x17, 0x70, 0x29, 0x80, 0x70, 0x60, 0x03, 0x90, 0x18, 0x60, 0x67, 0x80, 0x00, 0x00 }; /*7F2A*/
const unsigned char  uc2_7F2B [] = {0x12, 0xA0, 0x15, 0x40, 0x22, 0xA0, 0x2B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x2A, 0xA0, 0x77, 0xF0, 0x01, 0xC0, 0x1A, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*7F2B*/
const unsigned char  uc2_7F2C [] = {0x25, 0xF0, 0x24, 0x40, 0x5F, 0xF0, 0x65, 0x10, 0x2F, 0x50, 0x21, 0x50, 0x5F, 0x50, 0x6A, 0x40, 0x1A, 0xA0, 0x6E, 0x90, 0x09, 0x10, 0x00, 0x00 }; /*7F2C*/
const unsigned char  uc2_7F2D [] = {0x10, 0x80, 0x17, 0xF0, 0x25, 0x50, 0x2B, 0xE0, 0x76, 0x30, 0x13, 0xE0, 0x2A, 0x20, 0x73, 0xE0, 0x02, 0xA0, 0x1C, 0x90, 0x63, 0x00, 0x00, 0x00 }; /*7F2D*/
const unsigned char  uc2_7F2E [] = {0x11, 0x40, 0x17, 0xF0, 0x28, 0x80, 0x2B, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x29, 0x40, 0x77, 0xF0, 0x02, 0x20, 0x1B, 0xE0, 0x62, 0x20, 0x00, 0x00 }; /*7F2E*/
const unsigned char  uc2_7F2F [] = {0x22, 0x20, 0x21, 0x40, 0x4F, 0xF0, 0x76, 0xB0, 0x15, 0xD0, 0x24, 0x90, 0x4F, 0xF0, 0x72, 0x20, 0x03, 0xE0, 0x1A, 0x20, 0x63, 0xE0, 0x00, 0x00 }; /*7F2F*/
const unsigned char  uc2_7F30 [] = {0x10, 0x00, 0x17, 0xF0, 0x2A, 0xA0, 0x2B, 0xE0, 0x72, 0xA0, 0x17, 0xF0, 0x2A, 0xA0, 0x73, 0xE0, 0x02, 0xA0, 0x1F, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*7F30*/
const unsigned char  uc2_7F31 [] = {0x28, 0x40, 0x25, 0xF0, 0x51, 0x50, 0x73, 0xF0, 0x2D, 0x10, 0x25, 0xE0, 0x55, 0x10, 0x75, 0x10, 0x05, 0xF0, 0x17, 0x00, 0x68, 0xF0, 0x00, 0x00 }; /*7F31*/
const unsigned char  uc2_7F32 [] = {0x13, 0xE0, 0x12, 0x20, 0x23, 0xE0, 0x28, 0x00, 0x77, 0x70, 0x15, 0x50, 0x2F, 0x70, 0x70, 0x80, 0x07, 0xF0, 0x1A, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*7F32*/
const unsigned char  uc2_7F33 [] = {0x27, 0xF0, 0x25, 0x50, 0x4F, 0xF0, 0x70, 0x00, 0x13, 0xE0, 0x22, 0x20, 0x4B, 0xE0, 0x71, 0x50, 0x06, 0x60, 0x1A, 0xC0, 0x63, 0x30, 0x00, 0x00 }; /*7F33*/
const unsigned char  uc2_7F34 [] = {0x22, 0x40, 0x27, 0x70, 0x55, 0x90, 0x77, 0x50, 0x25, 0x50, 0x22, 0x50, 0x5F, 0xD0, 0x74, 0x50, 0x07, 0x20, 0x15, 0x50, 0x6A, 0x90, 0x00, 0x00 }; /*7F34*/
const unsigned char  uc2_7F35 [] = {0x2A, 0xA0, 0x2F, 0xF0, 0x5A, 0xA0, 0x6F, 0xF0, 0x25, 0x50, 0x2B, 0xE0, 0x52, 0x20, 0x72, 0xA0, 0x00, 0x80, 0x19, 0x60, 0x66, 0x10, 0x00, 0x00 }; /*7F35*/
const unsigned char  uc2_7F36 [] = {0x10, 0x00, 0x1F, 0xE0, 0x22, 0x00, 0x42, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x22, 0x20, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*7F36*/
const unsigned char  uc2_7F38 [] = {0x20, 0x00, 0x3D, 0xF0, 0x28, 0x40, 0x48, 0x40, 0x7E, 0x40, 0x08, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x2E, 0x40, 0x33, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*7F38*/
const unsigned char  uc2_7F3A [] = {0x20, 0x80, 0x3C, 0x80, 0x51, 0xE0, 0x10, 0xA0, 0x7C, 0xA0, 0x13, 0xF0, 0x54, 0x80, 0x55, 0x40, 0x5D, 0x40, 0x65, 0x20, 0x02, 0x10, 0x00, 0x00 }; /*7F3A*/
const unsigned char  uc2_7F42 [] = {0x7D, 0xF0, 0x55, 0x50, 0x28, 0xA0, 0x55, 0x10, 0x1F, 0xE0, 0x22, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*7F42*/
const unsigned char  uc2_7F44 [] = {0x08, 0xE0, 0x3E, 0xA0, 0x09, 0xF0, 0x3E, 0xA0, 0x2A, 0x40, 0x5F, 0xB0, 0x22, 0x00, 0x7F, 0xF0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*7F44*/
const unsigned char  uc2_7F45 [] = {0x10, 0xE0, 0x1C, 0x80, 0x2B, 0xF0, 0x0A, 0x90, 0x7F, 0xE0, 0x0A, 0x90, 0x2B, 0xE0, 0x2B, 0x50, 0x2E, 0xE0, 0x33, 0xF0, 0x04, 0x40, 0x00, 0x00 }; /*7F45*/
const unsigned char  uc2_7F50 [] = {0x22, 0x20, 0x3F, 0xF0, 0x52, 0x20, 0x17, 0x70, 0x7D, 0x50, 0x17, 0xF0, 0x52, 0x40, 0x57, 0xF0, 0x7A, 0x40, 0x4B, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*7F50*/
const unsigned char  uc2_7F51 [] = {0x7F, 0xF0, 0x40, 0x10, 0x66, 0x50, 0x55, 0x50, 0x48, 0x90, 0x48, 0x90, 0x55, 0x50, 0x55, 0x50, 0x62, 0x10, 0x40, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*7F51*/
const unsigned char  uc2_7F54 [] = {0x7F, 0xF0, 0x48, 0x90, 0x45, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x5F, 0xD0, 0x48, 0x10, 0x48, 0x10, 0x47, 0x90, 0x40, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*7F54*/
const unsigned char  uc2_7F55 [] = {0x7F, 0xF0, 0x40, 0x10, 0x08, 0xC0, 0x30, 0x20, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7F55*/
const unsigned char  uc2_7F57 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x03, 0xC0, 0x04, 0x40, 0x0A, 0x40, 0x32, 0x80, 0x01, 0x00, 0x06, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*7F57*/
const unsigned char  uc2_7F58 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x02, 0x00, 0x06, 0xE0, 0x7A, 0x10, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7F58*/
const unsigned char  uc2_7F5A [] = {0x3F, 0xF0, 0x24, 0x90, 0x3F, 0xF0, 0x00, 0x00, 0x18, 0x10, 0x04, 0x90, 0x70, 0x90, 0x10, 0x90, 0x12, 0x90, 0x14, 0x10, 0x18, 0x60, 0x00, 0x00 }; /*7F5A*/
const unsigned char  uc2_7F5F [] = {0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*7F5F*/
const unsigned char  uc2_7F61 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7F61*/
const unsigned char  uc2_7F62 [] = {0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x10, 0xA0, 0x1F, 0x20, 0x00, 0x00 }; /*7F62*/
const unsigned char  uc2_7F68 [] = {0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x0A, 0x80, 0x1F, 0xC0, 0x6A, 0xB0, 0x0F, 0x80, 0x0A, 0x80, 0x0F, 0x90, 0x02, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*7F68*/
const unsigned char  uc2_7F69 [] = {0x3F, 0xE0, 0x28, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7F69*/
const unsigned char  uc2_7F6A [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00 }; /*7F6A*/
const unsigned char  uc2_7F6E [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*7F6E*/
const unsigned char  uc2_7F71 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x25, 0x20, 0x2F, 0xA0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*7F71*/
const unsigned char  uc2_7F72 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*7F72*/
const unsigned char  uc2_7F74 [] = {0x7F, 0xF0, 0x48, 0x90, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x3F, 0xA0, 0x25, 0x20, 0x42, 0x90, 0x00, 0x00 }; /*7F74*/
const unsigned char  uc2_7F79 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x3C, 0x80, 0x57, 0xE0, 0x14, 0x80, 0x17, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*7F79*/
const unsigned char  uc2_7F7E [] = {0x7F, 0xF0, 0x48, 0x90, 0x7F, 0xF0, 0x22, 0x20, 0x32, 0x60, 0x2A, 0xA0, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*7F7E*/
const unsigned char  uc2_7F81 [] = {0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xE0, 0x28, 0xA0, 0x7D, 0x40, 0x55, 0xF0, 0x7C, 0x10, 0x13, 0xD0, 0x7C, 0x10, 0x10, 0x60, 0x00, 0x00 }; /*7F81*/
const unsigned char  uc2_7F8A [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7F8A*/
const unsigned char  uc2_7F8C [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*7F8C*/
const unsigned char  uc2_7F8E [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*7F8E*/
const unsigned char  uc2_7F94 [] = {0x10, 0x40, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*7F94*/
const unsigned char  uc2_7F97 [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x05, 0x40, 0x09, 0xA0, 0x09, 0xD0, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*7F97*/
const unsigned char  uc2_7F9A [] = {0x28, 0x80, 0x10, 0x80, 0x7D, 0x40, 0x12, 0x20, 0x3C, 0x90, 0x10, 0x40, 0x7F, 0xE0, 0x10, 0x20, 0x11, 0x40, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*7F9A*/
const unsigned char  uc2_7F9D [] = {0x28, 0x30, 0x13, 0xC0, 0x7E, 0x40, 0x12, 0x40, 0x3B, 0xF0, 0x12, 0x40, 0x7E, 0x40, 0x12, 0xC0, 0x13, 0x50, 0x20, 0xB0, 0x40, 0x90, 0x00, 0x00 }; /*7F9D*/
const unsigned char  uc2_7F9E [] = {0x04, 0x80, 0x1F, 0xC0, 0x02, 0x00, 0x0F, 0x80, 0x04, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6F, 0x80, 0x04, 0x80, 0x3F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*7F9E*/
const unsigned char  uc2_7F9F [] = {0x28, 0x00, 0x13, 0xC0, 0x7C, 0x40, 0x10, 0x80, 0x39, 0x60, 0x12, 0x10, 0x7D, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x20, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*7F9F*/
const unsigned char  uc2_7FA1 [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x63, 0xE0, 0x14, 0xA0, 0x09, 0x40, 0x76, 0x30, 0x00, 0x00 }; /*7FA1*/
const unsigned char  uc2_7FA4 [] = {0x00, 0xA0, 0x3D, 0xF0, 0x14, 0x40, 0x7E, 0x40, 0x14, 0xE0, 0x3C, 0x40, 0x10, 0x40, 0x3D, 0xF0, 0x64, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x00, 0x00 }; /*7FA4*/
const unsigned char  uc2_7FA7 [] = {0x28, 0x80, 0x11, 0x20, 0x7D, 0xD0, 0x10, 0xA0, 0x3B, 0x10, 0x10, 0x80, 0x7C, 0xE0, 0x13, 0x20, 0x10, 0xA0, 0x20, 0x40, 0x43, 0xB0, 0x00, 0x00 }; /*7FA7*/
const unsigned char  uc2_7FAF [] = {0x28, 0x00, 0x13, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x39, 0x00, 0x11, 0xF0, 0x7E, 0x90, 0x12, 0x90, 0x13, 0x50, 0x23, 0xD0, 0x40, 0x20, 0x00, 0x00 }; /*7FAF*/
const unsigned char  uc2_7FB0 [] = {0x28, 0x80, 0x12, 0xA0, 0x7F, 0xE0, 0x12, 0x00, 0x3F, 0xF0, 0x12, 0x40, 0x7F, 0x50, 0x12, 0x40, 0x12, 0xA0, 0x24, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*7FB0*/
const unsigned char  uc2_7FB2 [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0xA0, 0x7F, 0xF0, 0x2A, 0xA0, 0x5E, 0x50, 0x05, 0xA0, 0x00, 0x00 }; /*7FB2*/
const unsigned char  uc2_7FB8 [] = {0x02, 0x00, 0x7F, 0xF0, 0x20, 0x00, 0x1F, 0xE0, 0x20, 0x40, 0x3F, 0xE0, 0x2A, 0xA0, 0x3F, 0xA0, 0x2A, 0xE0, 0x3F, 0xA0, 0x4A, 0x90, 0x00, 0x00 }; /*7FB8*/
const unsigned char  uc2_7FB9 [] = {0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x28, 0xA0, 0x45, 0x10, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*7FB9*/
const unsigned char  uc2_7FBC [] = {0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x24, 0x40, 0x2F, 0xE0, 0x21, 0x00, 0x3F, 0xF0, 0x2A, 0xA0, 0x24, 0x40, 0x3F, 0xF0, 0x48, 0x40, 0x00, 0x00 }; /*7FBC*/
const unsigned char  uc2_7FBD [] = {0x7D, 0xF0, 0x04, 0x10, 0x04, 0x10, 0x65, 0x90, 0x14, 0x50, 0x04, 0x10, 0x0C, 0x30, 0x14, 0x50, 0x65, 0x90, 0x04, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*7FBD*/
const unsigned char  uc2_7FBF [] = {0x3D, 0xE0, 0x04, 0x20, 0x35, 0xA0, 0x0C, 0x60, 0x35, 0xA0, 0x04, 0x20, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*7FBF*/
const unsigned char  uc2_7FC1 [] = {0x08, 0x80, 0x15, 0x40, 0x68, 0xB0, 0x0F, 0x40, 0x00, 0x40, 0x7D, 0xF0, 0x04, 0x10, 0x65, 0x90, 0x14, 0x50, 0x65, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*7FC1*/
const unsigned char  uc2_7FC5 [] = {0x10, 0x00, 0x7F, 0xE0, 0x10, 0xA0, 0x12, 0xE0, 0x79, 0xA0, 0x28, 0xA0, 0x29, 0xE0, 0x12, 0xA0, 0x28, 0xA0, 0x25, 0x40, 0x43, 0xF0, 0x00, 0x00 }; /*7FC5*/
const unsigned char  uc2_7FCA [] = {0x20, 0x00, 0x13, 0xB0, 0x7C, 0x90, 0x4A, 0xD0, 0x29, 0xB0, 0x28, 0x90, 0x29, 0xB0, 0x12, 0xD0, 0x1C, 0x90, 0x60, 0x90, 0x01, 0x20, 0x00, 0x00 }; /*7FCA*/
const unsigned char  uc2_7FCC [] = {0x7D, 0xF0, 0x24, 0x90, 0x1C, 0x70, 0x24, 0x90, 0x04, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x04, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*7FCC*/
const unsigned char  uc2_7FCE [] = {0x10, 0x00, 0x11, 0xF0, 0x28, 0x50, 0x25, 0x70, 0x54, 0xD0, 0x08, 0x50, 0x7C, 0xF0, 0x05, 0x50, 0x38, 0x50, 0x10, 0x50, 0x10, 0xA0, 0x00, 0x00 }; /*7FCE*/
const unsigned char  uc2_7FD4 [] = {0x28, 0x00, 0x11, 0xF0, 0x7C, 0x50, 0x11, 0x70, 0x38, 0xD0, 0x10, 0x50, 0x7C, 0xF0, 0x11, 0x50, 0x10, 0x50, 0x20, 0x50, 0x40, 0xA0, 0x00, 0x00 }; /*7FD4*/
const unsigned char  uc2_7FD5 [] = {0x07, 0x00, 0x08, 0x80, 0x17, 0x40, 0x60, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x7D, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x65, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*7FD5*/
const unsigned char  uc2_7FD8 [] = {0x13, 0xE0, 0x1C, 0xA0, 0x76, 0xE0, 0x19, 0xA0, 0x74, 0xA0, 0x09, 0xE0, 0x02, 0xA0, 0x7C, 0xA0, 0x29, 0x50, 0x28, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*7FD8*/
const unsigned char  uc2_7FDF [] = {0x3D, 0xE0, 0x14, 0xA0, 0x0C, 0x60, 0x14, 0xA0, 0x1F, 0xF0, 0x11, 0x00, 0x7F, 0xE0, 0x11, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*7FDF*/
const unsigned char  uc2_7FE0 [] = {0x3D, 0xE0, 0x14, 0xA0, 0x0C, 0x60, 0x16, 0xA0, 0x3F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x15, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*7FE0*/
const unsigned char  uc2_7FE1 [] = {0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x7D, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x69, 0xA0, 0x00, 0x00 }; /*7FE1*/
const unsigned char  uc2_7FE5 [] = {0x02, 0x20, 0x1F, 0xC0, 0x02, 0x80, 0x7F, 0xF0, 0x18, 0x40, 0x6F, 0xC0, 0x08, 0x40, 0x7F, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x28, 0xA0, 0x00, 0x00 }; /*7FE5*/
const unsigned char  uc2_7FE6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x22, 0x20, 0x3E, 0xA0, 0x22, 0xA0, 0x2E, 0x60, 0x00, 0x00, 0x7D, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x6D, 0xB0, 0x00, 0x00 }; /*7FE6*/
const unsigned char  uc2_7FE9 [] = {0x08, 0x00, 0x7F, 0xF0, 0x41, 0x50, 0x7F, 0x50, 0x40, 0xF0, 0x7F, 0x50, 0x55, 0x50, 0x7F, 0xF0, 0x55, 0x50, 0x51, 0x50, 0x46, 0xA0, 0x00, 0x00 }; /*7FE9*/
const unsigned char  uc2_7FEE [] = {0x00, 0x00, 0x7E, 0xF0, 0x00, 0x50, 0x3E, 0xF0, 0x22, 0x50, 0x7F, 0x50, 0x55, 0xF0, 0x49, 0x50, 0x7F, 0x50, 0x49, 0x50, 0x46, 0xA0, 0x00, 0x00 }; /*7FEE*/
const unsigned char  uc2_7FF0 [] = {0x10, 0x40, 0x7C, 0xA0, 0x11, 0x10, 0x38, 0x00, 0x29, 0xF0, 0x39, 0x50, 0x28, 0xF0, 0x38, 0x50, 0x11, 0xF0, 0x7C, 0x50, 0x11, 0xA0, 0x00, 0x00 }; /*7FF0*/
const unsigned char  uc2_7FF1 [] = {0x10, 0x00, 0x3B, 0xF0, 0x28, 0x90, 0x3A, 0xD0, 0x29, 0xB0, 0x7C, 0x90, 0x29, 0xB0, 0x56, 0xD0, 0x38, 0x90, 0x10, 0x90, 0x13, 0x60, 0x00, 0x00 }; /*7FF1*/
const unsigned char  uc2_7FF3 [] = {0x7C, 0xE0, 0x51, 0x10, 0x5D, 0xE0, 0x68, 0xA0, 0x7E, 0x40, 0x54, 0xA0, 0x7D, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x65, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*7FF3*/
const unsigned char  uc2_7FFB [] = {0x06, 0x00, 0x39, 0xB0, 0x2A, 0x50, 0x7F, 0x50, 0x14, 0xF0, 0x6A, 0x50, 0x3E, 0x50, 0x2A, 0xF0, 0x3E, 0x50, 0x2A, 0x50, 0x3E, 0xA0, 0x00, 0x00 }; /*7FFB*/
const unsigned char  uc2_7FFC [] = {0x7D, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x3F, 0xD0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x00, 0x00 }; /*7FFC*/
const unsigned char  uc2_8000 [] = {0x17, 0x70, 0x55, 0x50, 0x3A, 0xB0, 0x15, 0xF0, 0x7E, 0x40, 0x2B, 0xF0, 0x2A, 0x40, 0x2B, 0xF0, 0x2E, 0x40, 0x2B, 0xF0, 0x42, 0x00, 0x00, 0x00 }; /*8000*/
const unsigned char  uc2_8001 [] = {0x02, 0x00, 0x1F, 0xD0, 0x02, 0x20, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x04, 0x60, 0x1F, 0x80, 0x64, 0x10, 0x04, 0x10, 0x03, 0xE0, 0x00, 0x00 }; /*8001*/
const unsigned char  uc2_8003 [] = {0x04, 0x00, 0x04, 0x20, 0x3F, 0x40, 0x04, 0x80, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xE0, 0x64, 0x00, 0x0F, 0xE0, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*8003*/
const unsigned char  uc2_8004 [] = {0x04, 0x00, 0x1F, 0x20, 0x04, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x0A, 0x20, 0x3F, 0xC0, 0x04, 0x00, 0x3F, 0xD0, 0x04, 0x10, 0x7B, 0xE0, 0x00, 0x00 }; /*8004*/
const unsigned char  uc2_8005 [] = {0x02, 0x20, 0x1F, 0xC0, 0x02, 0x80, 0x7F, 0xF0, 0x04, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x00, 0x00 }; /*8005*/
const unsigned char  uc2_8006 [] = {0x02, 0x00, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x14, 0x00, 0x64, 0x90, 0x0F, 0xF0, 0x08, 0x20, 0x0F, 0xE0, 0x08, 0x20, 0x0F, 0xE0, 0x00, 0x00 }; /*8006*/
const unsigned char  uc2_800B [] = {0x04, 0x00, 0x1F, 0x20, 0x04, 0x40, 0x7F, 0xF0, 0x04, 0x80, 0x09, 0x40, 0x3F, 0xE0, 0x02, 0x20, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*800B*/
const unsigned char  uc2_800C [] = {0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*800C*/
const unsigned char  uc2_800D [] = {0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0x00, 0x04, 0xE0, 0x78, 0x10, 0x00, 0x00 }; /*800D*/
const unsigned char  uc2_8010 [] = {0x7F, 0x20, 0x08, 0x20, 0x10, 0xF0, 0x7F, 0x20, 0x55, 0x20, 0x55, 0xA0, 0x55, 0x60, 0x55, 0x20, 0x55, 0x20, 0x51, 0x20, 0x46, 0xC0, 0x00, 0x00 }; /*8010*/
const unsigned char  uc2_8012 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*8012*/
const unsigned char  uc2_8014 [] = {0x08, 0x00, 0x3E, 0xE0, 0x08, 0x20, 0x1C, 0x40, 0x08, 0x40, 0x3F, 0xF0, 0x0C, 0x40, 0x1A, 0x40, 0x6A, 0x40, 0x08, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*8014*/
const unsigned char  uc2_8015 [] = {0x08, 0xA0, 0x3E, 0xA0, 0x09, 0xF0, 0x1C, 0xA0, 0x08, 0xA0, 0x3F, 0xF0, 0x0C, 0xA0, 0x1A, 0xA0, 0x6B, 0x20, 0x09, 0x20, 0x0A, 0x20, 0x00, 0x00 }; /*8015*/
const unsigned char  uc2_8016 [] = {0x08, 0x40, 0x3E, 0x40, 0x09, 0x60, 0x1D, 0x50, 0x09, 0x50, 0x3E, 0x40, 0x0C, 0x50, 0x1A, 0x20, 0x6A, 0x40, 0x08, 0x80, 0x0B, 0x00, 0x00, 0x00 }; /*8016*/
const unsigned char  uc2_8017 [] = {0x08, 0x30, 0x3F, 0xC0, 0x08, 0x80, 0x1C, 0xB0, 0x09, 0xC0, 0x3E, 0x80, 0x0C, 0xB0, 0x1B, 0xC0, 0x6A, 0x90, 0x08, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*8017*/
const unsigned char  uc2_8018 [] = {0x08, 0x00, 0x3E, 0xE0, 0x08, 0x00, 0x1C, 0x00, 0x09, 0xF0, 0x3E, 0x40, 0x0C, 0x80, 0x1A, 0xA0, 0x6B, 0x20, 0x09, 0xD0, 0x08, 0x10, 0x00, 0x00 }; /*8018*/
const unsigned char  uc2_8019 [] = {0x08, 0x00, 0x3F, 0xF0, 0x09, 0x50, 0x1D, 0x50, 0x09, 0x50, 0x3F, 0xF0, 0x0D, 0x00, 0x1B, 0x00, 0x69, 0x10, 0x09, 0x10, 0x08, 0xE0, 0x00, 0x00 }; /*8019*/
const unsigned char  uc2_801C [] = {0x08, 0x00, 0x3F, 0xE0, 0x09, 0x20, 0x1D, 0x20, 0x09, 0xE0, 0x3F, 0x00, 0x0D, 0xF0, 0x1B, 0x10, 0x69, 0x10, 0x09, 0xF0, 0x09, 0x10, 0x00, 0x00 }; /*801C*/
const unsigned char  uc2_8020 [] = {0x10, 0x80, 0x7C, 0x80, 0x11, 0x40, 0x39, 0x20, 0x12, 0xD0, 0x7C, 0x00, 0x19, 0xE0, 0x35, 0x20, 0x55, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*8020*/
const unsigned char  uc2_8022 [] = {0x11, 0x20, 0x7F, 0xF0, 0x11, 0x20, 0x3B, 0xF0, 0x12, 0x10, 0x7C, 0x80, 0x19, 0xE0, 0x34, 0xA0, 0x54, 0xA0, 0x11, 0x20, 0x16, 0x40, 0x00, 0x00 }; /*8022*/
const unsigned char  uc2_8025 [] = {0x14, 0x90, 0x7A, 0x90, 0x12, 0xA0, 0x3F, 0xF0, 0x14, 0x10, 0x7D, 0xD0, 0x15, 0x50, 0x3D, 0x50, 0x55, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*8025*/
const unsigned char  uc2_8026 [] = {0x13, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x3A, 0xA0, 0x13, 0xE0, 0x7C, 0x80, 0x17, 0xF0, 0x3C, 0xB0, 0x57, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*8026*/
const unsigned char  uc2_8027 [] = {0x14, 0x90, 0x7A, 0xA0, 0x17, 0xF0, 0x39, 0xA0, 0x12, 0xA0, 0x7C, 0x10, 0x10, 0x80, 0x3B, 0xF0, 0x55, 0x20, 0x10, 0xD0, 0x13, 0x10, 0x00, 0x00 }; /*8027*/
const unsigned char  uc2_8028 [] = {0x13, 0xF0, 0x7E, 0x00, 0x12, 0xE0, 0x3A, 0x00, 0x13, 0xF0, 0x7E, 0xA0, 0x1A, 0xD0, 0x36, 0x20, 0x53, 0xF0, 0x12, 0xA0, 0x14, 0x60, 0x00, 0x00 }; /*8028*/
const unsigned char  uc2_8029 [] = {0x11, 0x40, 0x7F, 0xF0, 0x11, 0x40, 0x3B, 0xE0, 0x11, 0x40, 0x7F, 0xF0, 0x1A, 0xA0, 0x37, 0xE0, 0x52, 0xA0, 0x17, 0xF0, 0x12, 0x40, 0x00, 0x00 }; /*8029*/
const unsigned char  uc2_802A [] = {0x10, 0x80, 0x7F, 0xF0, 0x11, 0x20, 0x3B, 0xF0, 0x12, 0x90, 0x7C, 0x40, 0x1B, 0xF0, 0x35, 0x00, 0x55, 0xE0, 0x11, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*802A*/
const unsigned char  uc2_8031 [] = {0x10, 0x80, 0x7F, 0xF0, 0x15, 0x20, 0x3F, 0xF0, 0x15, 0x20, 0x7F, 0xF0, 0x14, 0x80, 0x3D, 0xE0, 0x57, 0x20, 0x15, 0xE0, 0x19, 0x20, 0x00, 0x00 }; /*8031*/
const unsigned char  uc2_8033 [] = {0x3F, 0xF0, 0x08, 0x40, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x08, 0x70, 0x0F, 0xC0, 0x70, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*8033*/
const unsigned char  uc2_8035 [] = {0x00, 0x00, 0x7F, 0xF0, 0x24, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x3E, 0x40, 0x64, 0x40, 0x04, 0x40, 0x05, 0x80, 0x00, 0x00 }; /*8035*/
const unsigned char  uc2_8036 [] = {0x00, 0x00, 0x7E, 0xF0, 0x24, 0x90, 0x3C, 0x90, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0x90, 0x3E, 0x90, 0x64, 0xE0, 0x04, 0x80, 0x04, 0x80, 0x00, 0x00 }; /*8036*/
const unsigned char  uc2_8037 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0xC0, 0x68, 0xB0, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0xF0, 0x30, 0x80, 0x00, 0x00 }; /*8037*/
const unsigned char  uc2_8038 [] = {0x08, 0x80, 0x08, 0x80, 0x15, 0x40, 0x3F, 0xF0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xF0, 0x30, 0x40, 0x00, 0x00 }; /*8038*/
const unsigned char  uc2_803B [] = {0x00, 0x40, 0x7C, 0x40, 0x29, 0x40, 0x39, 0x40, 0x29, 0x70, 0x39, 0x40, 0x2D, 0x40, 0x39, 0x40, 0x69, 0x40, 0x0B, 0xF0, 0x08, 0x00, 0x00, 0x00 }; /*803B*/
const unsigned char  uc2_803D [] = {0x00, 0x80, 0x7C, 0x80, 0x2B, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x38, 0x80, 0x2D, 0x40, 0x39, 0x40, 0x69, 0x50, 0x0A, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*803D*/
const unsigned char  uc2_803F [] = {0x00, 0x80, 0x7C, 0x80, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x3C, 0xC0, 0x28, 0x80, 0x3D, 0x40, 0x69, 0x40, 0x0A, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*803F*/
const unsigned char  uc2_8042 [] = {0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x80, 0x7F, 0xE0, 0x05, 0x20, 0x39, 0x20, 0x14, 0xC0, 0x63, 0x30, 0x00, 0x00 }; /*8042*/
const unsigned char  uc2_8043 [] = {0x00, 0x80, 0x7F, 0xE0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2B, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x3F, 0xF0, 0x6A, 0x20, 0x0A, 0x20, 0x0A, 0xC0, 0x00, 0x00 }; /*8043*/
const unsigned char  uc2_8046 [] = {0x00, 0x80, 0x7C, 0x80, 0x29, 0x40, 0x3A, 0x30, 0x2C, 0x80, 0x3B, 0xE0, 0x28, 0x20, 0x3C, 0x40, 0x69, 0x80, 0x08, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*8046*/
const unsigned char  uc2_804A [] = {0x01, 0x70, 0x7E, 0x50, 0x2A, 0x50, 0x3A, 0x50, 0x2A, 0xD0, 0x3A, 0xD0, 0x2F, 0x50, 0x38, 0xE0, 0x69, 0x40, 0x09, 0x40, 0x0A, 0x40, 0x00, 0x00 }; /*804A*/
const unsigned char  uc2_804B [] = {0x04, 0x80, 0x7F, 0xE0, 0x0A, 0x50, 0x73, 0xF0, 0x04, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x70, 0x7F, 0xC0, 0x00, 0x40, 0x00, 0x00 }; /*804B*/
const unsigned char  uc2_804C [] = {0x00, 0x00, 0x7D, 0xF0, 0x29, 0x10, 0x39, 0x10, 0x29, 0x10, 0x39, 0xF0, 0x2C, 0x00, 0x38, 0xA0, 0x68, 0x90, 0x09, 0x10, 0x0A, 0x10, 0x00, 0x00 }; /*804C*/
const unsigned char  uc2_804D [] = {0x01, 0x80, 0x7C, 0x40, 0x2B, 0xF0, 0x3A, 0x10, 0x28, 0x00, 0x3B, 0xF0, 0x2C, 0x40, 0x38, 0x40, 0x68, 0x40, 0x08, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*804D*/
const unsigned char  uc2_8052 [] = {0x00, 0x20, 0x7D, 0xC0, 0x28, 0x80, 0x38, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x2B, 0xE0, 0x3E, 0x20, 0x6A, 0x20, 0x0B, 0xE0, 0x0A, 0x20, 0x00, 0x00 }; /*8052*/
const unsigned char  uc2_8054 [] = {0x02, 0x20, 0x7D, 0x40, 0x2B, 0xE0, 0x38, 0x80, 0x28, 0x80, 0x3F, 0xF0, 0x28, 0x80, 0x3D, 0x40, 0x69, 0x40, 0x0A, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*8054*/
const unsigned char  uc2_8058 [] = {0x00, 0x80, 0x7F, 0xE0, 0x2A, 0xA0, 0x3B, 0xE0, 0x2A, 0xA0, 0x3F, 0xF0, 0x29, 0x00, 0x3B, 0xE0, 0x68, 0x20, 0x08, 0x20, 0x09, 0xC0, 0x00, 0x00 }; /*8058*/
const unsigned char  uc2_805A [] = {0x7D, 0xE0, 0x28, 0x20, 0x39, 0xC0, 0x2C, 0xA0, 0x79, 0x10, 0x08, 0xE0, 0x7F, 0x00, 0x0A, 0xA0, 0x32, 0xA0, 0x0A, 0x40, 0x72, 0x30, 0x00, 0x00 }; /*805A*/
const unsigned char  uc2_8069 [] = {0x00, 0x80, 0x7F, 0xE0, 0x2A, 0xA0, 0x3B, 0xE0, 0x28, 0x80, 0x3F, 0xF0, 0x2A, 0x20, 0x3E, 0xA0, 0x6A, 0xA0, 0x09, 0x60, 0x0E, 0x10, 0x00, 0x00 }; /*8069*/
const unsigned char  uc2_806A [] = {0x02, 0x20, 0x7D, 0x40, 0x2B, 0xE0, 0x3A, 0x20, 0x2A, 0x20, 0x3B, 0xE0, 0x2C, 0x80, 0x39, 0x50, 0x6B, 0x50, 0x0D, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*806A*/
const unsigned char  uc2_8071 [] = {0x10, 0x80, 0x7C, 0xF0, 0x11, 0x20, 0x7E, 0xC0, 0x25, 0x30, 0x5F, 0xE0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x70, 0x7F, 0xC0, 0x00, 0x40, 0x00, 0x00 }; /*8071*/
const unsigned char  uc2_807F [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*807F*/
const unsigned char  uc2_8083 [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x2B, 0x20, 0x2A, 0xA0, 0x32, 0xA0, 0x42, 0x20, 0x00, 0x00 }; /*8083*/
const unsigned char  uc2_8084 [] = {0x24, 0x80, 0x39, 0xE0, 0x24, 0xA0, 0x1B, 0xF0, 0x20, 0xA0, 0x3D, 0xE0, 0x50, 0x80, 0x7D, 0xE0, 0x10, 0x80, 0x2B, 0xF0, 0x44, 0x80, 0x00, 0x00 }; /*8084*/
const unsigned char  uc2_8086 [] = {0x3C, 0x80, 0x23, 0xE0, 0x38, 0xA0, 0x27, 0xF0, 0x38, 0xA0, 0x23, 0xE0, 0x7C, 0x80, 0x23, 0xE0, 0x48, 0x80, 0x77, 0xF0, 0x04, 0x80, 0x00, 0x00 }; /*8086*/
const unsigned char  uc2_8087 [] = {0x08, 0x60, 0x3D, 0x90, 0x26, 0x60, 0x3F, 0xD0, 0x42, 0x40, 0x3F, 0xF0, 0x02, 0x40, 0x1F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8087*/
const unsigned char  uc2_8089 [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x23, 0x20, 0x24, 0xA0, 0x3A, 0xA0, 0x22, 0x20, 0x25, 0x20, 0x39, 0x20, 0x20, 0x40, 0x00, 0x00 }; /*8089*/
const unsigned char  uc2_808B [] = {0x3C, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x3C, 0x90, 0x24, 0x90, 0x25, 0x10, 0x25, 0x10, 0x4A, 0x60, 0x00, 0x00 }; /*808B*/
const unsigned char  uc2_808C [] = {0x3B, 0xC0, 0x2A, 0x40, 0x2A, 0x40, 0x3A, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x3A, 0x40, 0x2A, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*808C*/
const unsigned char  uc2_8093 [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x0F, 0xE0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x08, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*8093*/
const unsigned char  uc2_8096 [] = {0x12, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*8096*/
const unsigned char  uc2_8098 [] = {0x3C, 0x20, 0x24, 0x20, 0x27, 0xF0, 0x3C, 0x20, 0x25, 0x20, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x24, 0x20, 0x24, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*8098*/
const unsigned char  uc2_809A [] = {0x38, 0x80, 0x28, 0x80, 0x28, 0x80, 0x38, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x50, 0x00, 0x00, 0x00 }; /*809A*/
const unsigned char  uc2_809B [] = {0x38, 0x00, 0x2B, 0xE0, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x50, 0x00, 0x00, 0x00 }; /*809B*/
const unsigned char  uc2_809C [] = {0x3C, 0x20, 0x24, 0x40, 0x24, 0x80, 0x3F, 0x10, 0x24, 0x20, 0x24, 0x40, 0x3D, 0x80, 0x24, 0x10, 0x24, 0x20, 0x24, 0x40, 0x49, 0x80, 0x00, 0x00 }; /*809C*/
const unsigned char  uc2_809D [] = {0x3B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x38, 0x80, 0x28, 0x80, 0x28, 0x80, 0x28, 0x80, 0x50, 0x80, 0x00, 0x00 }; /*809D*/
const unsigned char  uc2_809F [] = {0x39, 0xE0, 0x28, 0x00, 0x28, 0x00, 0x3B, 0xF0, 0x28, 0x80, 0x29, 0x00, 0x39, 0xE0, 0x28, 0x20, 0x28, 0x20, 0x28, 0x40, 0x51, 0x80, 0x00, 0x00 }; /*809F*/
const unsigned char  uc2_80A0 [] = {0x3B, 0xC0, 0x28, 0x40, 0x29, 0x80, 0x3A, 0x00, 0x2B, 0xF0, 0x29, 0x50, 0x39, 0x50, 0x2A, 0x90, 0x28, 0x90, 0x29, 0x10, 0x50, 0x60, 0x00, 0x00 }; /*80A0*/
const unsigned char  uc2_80A1 [] = {0x39, 0xC0, 0x29, 0x40, 0x29, 0x50, 0x3A, 0x50, 0x2C, 0x20, 0x2B, 0xC0, 0x39, 0x40, 0x29, 0x40, 0x28, 0x80, 0x49, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*80A1*/
const unsigned char  uc2_80A2 [] = {0x38, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x28, 0x80, 0x2F, 0xE0, 0x3A, 0x20, 0x29, 0x40, 0x28, 0x80, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*80A2*/
const unsigned char  uc2_80A4 [] = {0x38, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x29, 0x40, 0x29, 0x40, 0x2A, 0x20, 0x54, 0x10, 0x00, 0x00 }; /*80A4*/
const unsigned char  uc2_80A5 [] = {0x3D, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x3D, 0x50, 0x25, 0x50, 0x25, 0xF0, 0x3D, 0x00, 0x25, 0x10, 0x25, 0x10, 0x25, 0x10, 0x48, 0xE0, 0x00, 0x00 }; /*80A5*/
const unsigned char  uc2_80A9 [] = {0x01, 0x00, 0x1F, 0xF0, 0x10, 0x10, 0x1F, 0xF0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x24, 0x20, 0x24, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*80A9*/
const unsigned char  uc2_80AA [] = {0x3B, 0x00, 0x28, 0x80, 0x2F, 0xF0, 0x39, 0x00, 0x29, 0x00, 0x29, 0xE0, 0x39, 0x20, 0x29, 0x20, 0x2A, 0x20, 0x2A, 0x20, 0x54, 0xC0, 0x00, 0x00 }; /*80AA*/
const unsigned char  uc2_80AB [] = {0x38, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x2A, 0xA0, 0x2A, 0xA0, 0x3B, 0xE0, 0x28, 0xA0, 0x28, 0x90, 0x28, 0x90, 0x50, 0x60, 0x00, 0x00 }; /*80AB*/
const unsigned char  uc2_80AD [] = {0x1C, 0x40, 0x14, 0x40, 0x15, 0xF0, 0x1D, 0x50, 0x15, 0x50, 0x15, 0x50, 0x1D, 0xB0, 0x15, 0x10, 0x25, 0x10, 0x25, 0x10, 0x49, 0x20, 0x00, 0x00 }; /*80AD*/
const unsigned char  uc2_80AE [] = {0x3B, 0x00, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x00, 0x29, 0xC0, 0x29, 0x40, 0x39, 0x40, 0x29, 0x40, 0x29, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*80AE*/
const unsigned char  uc2_80AF [] = {0x02, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*80AF*/
const unsigned char  uc2_80B1 [] = {0x39, 0x00, 0x29, 0x00, 0x2F, 0xF0, 0x39, 0x00, 0x29, 0x40, 0x2A, 0x40, 0x3A, 0x80, 0x2C, 0xA0, 0x29, 0x20, 0x29, 0xD0, 0x50, 0x10, 0x00, 0x00 }; /*80B1*/
const unsigned char  uc2_80B2 [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x3F, 0xA0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*80B2*/
const unsigned char  uc2_80B4 [] = {0x1C, 0xC0, 0x03, 0x00, 0x1C, 0x80, 0x04, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*80B4*/
const unsigned char  uc2_80B7 [] = {0x39, 0x00, 0x29, 0x00, 0x29, 0xF0, 0x3A, 0x10, 0x2A, 0xA0, 0x2C, 0x80, 0x38, 0x80, 0x29, 0x40, 0x29, 0x40, 0x2A, 0x20, 0x54, 0x10, 0x00, 0x00 }; /*80B7*/
const unsigned char  uc2_80BA [] = {0x38, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x2B, 0xE0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xC0, 0x28, 0x80, 0x50, 0x80, 0x00, 0x00 }; /*80BA*/
const unsigned char  uc2_80BC [] = {0x39, 0x40, 0x29, 0x40, 0x2B, 0xE0, 0x39, 0x40, 0x29, 0x40, 0x2F, 0xF0, 0x39, 0x40, 0x29, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x54, 0x40, 0x00, 0x00 }; /*80BC*/
const unsigned char  uc2_80BD [] = {0x38, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x28, 0x80, 0x29, 0x40, 0x39, 0x40, 0x29, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x54, 0x10, 0x00, 0x00 }; /*80BD*/
const unsigned char  uc2_80BE [] = {0x0B, 0xE0, 0x29, 0x20, 0x28, 0xC0, 0x2B, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x13, 0x80, 0x00, 0x00 }; /*80BE*/
const unsigned char  uc2_80BF [] = {0x38, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3B, 0xE0, 0x2A, 0xA0, 0x28, 0x80, 0x28, 0x80, 0x50, 0x80, 0x00, 0x00 }; /*80BF*/
const unsigned char  uc2_80C0 [] = {0x3A, 0x40, 0x2A, 0x40, 0x2A, 0x80, 0x3B, 0x00, 0x2F, 0xF0, 0x2A, 0x80, 0x3A, 0x80, 0x2A, 0x40, 0x2A, 0x40, 0x2A, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*80C0*/
const unsigned char  uc2_80C1 [] = {0x39, 0x00, 0x29, 0x00, 0x2B, 0xC0, 0x39, 0x40, 0x29, 0x40, 0x2B, 0x60, 0x3D, 0x50, 0x29, 0x50, 0x2A, 0x40, 0x2A, 0x40, 0x55, 0x80, 0x00, 0x00 }; /*80C1*/
const unsigned char  uc2_80C2 [] = {0x38, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x3A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x3B, 0xE0, 0x2A, 0xA0, 0x28, 0x80, 0x28, 0x80, 0x50, 0x80, 0x00, 0x00 }; /*80C2*/
const unsigned char  uc2_80C3 [] = {0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*80C3*/
const unsigned char  uc2_80C4 [] = {0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0x40, 0x11, 0xC0, 0x00, 0x00 }; /*80C4*/
const unsigned char  uc2_80C6 [] = {0x3B, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x3B, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x3B, 0xE0, 0x28, 0x00, 0x28, 0x00, 0x2F, 0xF0, 0x50, 0x00, 0x00, 0x00 }; /*80C6*/
const unsigned char  uc2_80CC [] = {0x09, 0x10, 0x79, 0xE0, 0x09, 0x00, 0x19, 0x10, 0x68, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x11, 0xC0, 0x00, 0x00 }; /*80CC*/
const unsigned char  uc2_80CD [] = {0x38, 0x10, 0x2B, 0xE0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xD0, 0x2C, 0xB0, 0x54, 0xD0, 0x00, 0x00 }; /*80CD*/
const unsigned char  uc2_80CE [] = {0x38, 0x80, 0x28, 0x80, 0x29, 0x20, 0x3A, 0x60, 0x2B, 0x90, 0x28, 0x10, 0x39, 0xE0, 0x29, 0x20, 0x29, 0x20, 0x29, 0xE0, 0x51, 0x20, 0x00, 0x00 }; /*80CE*/
const unsigned char  uc2_80D6 [] = {0x3C, 0x90, 0x2A, 0x90, 0x2A, 0xA0, 0x38, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x3F, 0xF0, 0x28, 0x80, 0x28, 0x80, 0x28, 0x80, 0x50, 0x80, 0x00, 0x00 }; /*80D6*/
const unsigned char  uc2_80D7 [] = {0x38, 0x80, 0x28, 0x80, 0x29, 0x40, 0x3E, 0x30, 0x28, 0x80, 0x2B, 0x20, 0x38, 0x40, 0x2B, 0x90, 0x28, 0x20, 0x28, 0xC0, 0x53, 0x00, 0x00, 0x00 }; /*80D7*/
const unsigned char  uc2_80D9 [] = {0x39, 0x00, 0x29, 0x00, 0x29, 0xF0, 0x3B, 0x00, 0x2D, 0x00, 0x29, 0xE0, 0x39, 0x00, 0x29, 0xE0, 0x29, 0x00, 0x29, 0x00, 0x51, 0x00, 0x00, 0x00 }; /*80D9*/
const unsigned char  uc2_80DA [] = {0x38, 0x00, 0x2F, 0xF0, 0x28, 0x80, 0x38, 0x80, 0x29, 0xA0, 0x2A, 0x90, 0x3C, 0x90, 0x28, 0x80, 0x28, 0x80, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*80DA*/
const unsigned char  uc2_80DB [] = {0x3D, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x3D, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x3D, 0xF0, 0x25, 0x50, 0x24, 0x40, 0x24, 0x40, 0x48, 0x40, 0x00, 0x00 }; /*80DB*/
const unsigned char  uc2_80DC [] = {0x38, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x3B, 0xF0, 0x2C, 0x80, 0x28, 0x80, 0x3B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*80DC*/
const unsigned char  uc2_80DD [] = {0x38, 0x30, 0x2B, 0xC0, 0x2A, 0x40, 0x3A, 0x40, 0x2B, 0xF0, 0x2A, 0x40, 0x3A, 0x40, 0x2A, 0xC0, 0x2B, 0x50, 0x28, 0xB0, 0x50, 0x90, 0x00, 0x00 }; /*80DD*/
const unsigned char  uc2_80DE [] = {0x39, 0x00, 0x29, 0xE0, 0x2A, 0x20, 0x3F, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3B, 0xA0, 0x2A, 0x40, 0x2A, 0x10, 0x2A, 0x10, 0x51, 0xE0, 0x00, 0x00 }; /*80DE*/
const unsigned char  uc2_80E1 [] = {0x08, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x7F, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x3E, 0xF0, 0x22, 0x90, 0x22, 0x90, 0x3E, 0x90, 0x21, 0x60, 0x00, 0x00 }; /*80E1*/
const unsigned char  uc2_80E4 [] = {0x24, 0x40, 0x2A, 0x40, 0x2C, 0x40, 0x29, 0x40, 0x3F, 0xC0, 0x29, 0x40, 0x2F, 0x40, 0x29, 0x50, 0x2F, 0x50, 0x29, 0x50, 0x4A, 0x20, 0x00, 0x00 }; /*80E4*/
const unsigned char  uc2_80E5 [] = {0x3F, 0xE0, 0x02, 0x20, 0x13, 0xC0, 0x12, 0x00, 0x3F, 0xC0, 0x50, 0x70, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*80E5*/
const unsigned char  uc2_80E7 [] = {0x3A, 0xC0, 0x2A, 0x20, 0x2F, 0xF0, 0x3A, 0x80, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xC0, 0x2C, 0x90, 0x29, 0x90, 0x52, 0x60, 0x00, 0x00 }; /*80E7*/
const unsigned char  uc2_80E8 [] = {0x39, 0x00, 0x29, 0x00, 0x2F, 0xF0, 0x39, 0x00, 0x2A, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x2A, 0xA0, 0x2A, 0x90, 0x2C, 0x90, 0x53, 0x00, 0x00, 0x00 }; /*80E8*/
const unsigned char  uc2_80E9 [] = {0x38, 0x80, 0x28, 0x80, 0x28, 0xE0, 0x38, 0x80, 0x2B, 0xF0, 0x28, 0x80, 0x38, 0xC0, 0x28, 0xA0, 0x28, 0xA0, 0x28, 0x80, 0x50, 0x80, 0x00, 0x00 }; /*80E9*/
const unsigned char  uc2_80EA [] = {0x38, 0x80, 0x28, 0xF0, 0x28, 0x80, 0x3B, 0xF0, 0x2A, 0x10, 0x2A, 0x10, 0x3B, 0xF0, 0x2A, 0x00, 0x2A, 0x00, 0x2A, 0x00, 0x54, 0x00, 0x00, 0x00 }; /*80EA*/
const unsigned char  uc2_80EB [] = {0x3B, 0xC0, 0x28, 0x40, 0x28, 0x80, 0x39, 0x60, 0x2E, 0x10, 0x28, 0x00, 0x3B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x50, 0x00, 0x00, 0x00 }; /*80EB*/
const unsigned char  uc2_80EC [] = {0x10, 0x00, 0x7D, 0xE0, 0x24, 0xA0, 0x78, 0x40, 0x15, 0xB0, 0x62, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x2D, 0xA0, 0x22, 0x20, 0x2D, 0xE0, 0x00, 0x00 }; /*80EC*/
const unsigned char  uc2_80ED [] = {0x3B, 0xE0, 0x2A, 0x20, 0x2A, 0xA0, 0x3A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2B, 0x60, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*80ED*/
const unsigned char  uc2_80EF [] = {0x38, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x3E, 0x30, 0x29, 0xC0, 0x28, 0x00, 0x3F, 0xF0, 0x29, 0x00, 0x2B, 0xE0, 0x28, 0x20, 0x51, 0xC0, 0x00, 0x00 }; /*80EF*/
const unsigned char  uc2_80F0 [] = {0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x3B, 0xE0, 0x28, 0xA0, 0x29, 0xE0, 0x3A, 0x80, 0x2B, 0xF0, 0x28, 0x90, 0x29, 0x60, 0x56, 0x30, 0x00, 0x00 }; /*80F0*/
const unsigned char  uc2_80F1 [] = {0x38, 0x80, 0x2C, 0x90, 0x2A, 0x90, 0x3A, 0xA0, 0x2F, 0xF0, 0x29, 0x40, 0x39, 0x40, 0x29, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*80F1*/
const unsigned char  uc2_80F2 [] = {0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x39, 0x20, 0x2A, 0x40, 0x2B, 0x90, 0x39, 0x20, 0x2E, 0x40, 0x28, 0xA0, 0x29, 0x10, 0x56, 0x10, 0x00, 0x00 }; /*80F2*/
const unsigned char  uc2_80F3 [] = {0x39, 0x00, 0x29, 0xE0, 0x2A, 0x20, 0x3D, 0x40, 0x28, 0x80, 0x29, 0x40, 0x3E, 0x30, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*80F3*/
const unsigned char  uc2_80F4 [] = {0x3B, 0xF0, 0x2A, 0x10, 0x2A, 0xD0, 0x3A, 0x10, 0x2A, 0xD0, 0x2B, 0x30, 0x3B, 0x30, 0x2A, 0xD0, 0x2A, 0x10, 0x2A, 0x10, 0x52, 0x60, 0x00, 0x00 }; /*80F4*/
const unsigned char  uc2_80F6 [] = {0x38, 0x80, 0x2F, 0xF0, 0x29, 0x20, 0x3E, 0x10, 0x28, 0x10, 0x29, 0x40, 0x39, 0x40, 0x29, 0x40, 0x28, 0x80, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*80F6*/
const unsigned char  uc2_80F8 [] = {0x3A, 0x00, 0x2B, 0xF0, 0x2A, 0x10, 0x3C, 0x50, 0x2B, 0x50, 0x2A, 0x90, 0x3B, 0x50, 0x2A, 0x50, 0x2B, 0xF0, 0x28, 0x10, 0x50, 0x60, 0x00, 0x00 }; /*80F8*/
const unsigned char  uc2_80FA [] = {0x38, 0x40, 0x2B, 0xF0, 0x2A, 0x10, 0x3A, 0x90, 0x28, 0x80, 0x2F, 0xF0, 0x39, 0x20, 0x2B, 0x40, 0x28, 0x80, 0x29, 0x60, 0x56, 0x10, 0x00, 0x00 }; /*80FA*/
const unsigned char  uc2_80FC [] = {0x3A, 0x20, 0x29, 0x40, 0x2B, 0xE0, 0x39, 0x40, 0x29, 0x40, 0x2F, 0xF0, 0x39, 0x40, 0x29, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x54, 0x40, 0x00, 0x00 }; /*80FC*/
const unsigned char  uc2_80FD [] = {0x10, 0x80, 0x14, 0xA0, 0x2A, 0xD0, 0x32, 0x90, 0x1E, 0x60, 0x22, 0x80, 0x3E, 0x90, 0x22, 0xE0, 0x3E, 0x90, 0x22, 0x90, 0x2C, 0x60, 0x00, 0x00 }; /*80FD*/
const unsigned char  uc2_8102 [] = {0x3A, 0x20, 0x2B, 0xD0, 0x2A, 0x10, 0x39, 0xE0, 0x28, 0x00, 0x2B, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*8102*/
const unsigned char  uc2_8106 [] = {0x39, 0x00, 0x29, 0xC0, 0x2A, 0x40, 0x3F, 0xF0, 0x2A, 0x00, 0x2A, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xD0, 0x2A, 0x90, 0x54, 0x60, 0x00, 0x00 }; /*8106*/
const unsigned char  uc2_8109 [] = {0x39, 0x80, 0x28, 0x40, 0x2B, 0x80, 0x38, 0x80, 0x2E, 0x90, 0x2A, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2C, 0xA0, 0x48, 0x90, 0x53, 0x00, 0x00, 0x00 }; /*8109*/
const unsigned char  uc2_810A [] = {0x32, 0x60, 0x0A, 0x80, 0x72, 0x70, 0x05, 0x00, 0x78, 0xF0, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0x40, 0x10, 0xC0, 0x00, 0x00 }; /*810A*/
const unsigned char  uc2_810D [] = {0x38, 0x80, 0x28, 0x80, 0x29, 0x40, 0x3A, 0x20, 0x2D, 0xD0, 0x28, 0x00, 0x3B, 0xF0, 0x29, 0x20, 0x2A, 0x60, 0x2B, 0x90, 0x50, 0x10, 0x00, 0x00 }; /*810D*/
const unsigned char  uc2_810E [] = {0x3E, 0x60, 0x29, 0x80, 0x29, 0x60, 0x3E, 0x10, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x2A, 0xA0, 0x2A, 0x90, 0x2C, 0x90, 0x53, 0x00, 0x00, 0x00 }; /*810E*/
const unsigned char  uc2_810F [] = {0x39, 0x80, 0x28, 0x40, 0x2B, 0xF0, 0x3A, 0x00, 0x2A, 0x40, 0x2A, 0x40, 0x3A, 0xE0, 0x2A, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x55, 0xF0, 0x00, 0x00 }; /*810F*/
const unsigned char  uc2_8110 [] = {0x3B, 0x00, 0x28, 0x80, 0x2F, 0xF0, 0x3A, 0x40, 0x29, 0x80, 0x2A, 0x40, 0x3C, 0x30, 0x2A, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x54, 0x40, 0x00, 0x00 }; /*8110*/
const unsigned char  uc2_8111 [] = {0x3B, 0x00, 0x28, 0x80, 0x2F, 0xF0, 0x38, 0x00, 0x2A, 0x60, 0x2B, 0xA0, 0x3A, 0xA0, 0x2B, 0x60, 0x2A, 0x20, 0x2B, 0xE0, 0x50, 0x20, 0x00, 0x00 }; /*8111*/
const unsigned char  uc2_8112 [] = {0x38, 0x80, 0x2C, 0x90, 0x2A, 0x90, 0x3A, 0xA0, 0x2F, 0xF0, 0x28, 0x80, 0x39, 0xC0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2C, 0x90, 0x50, 0x80, 0x00, 0x00 }; /*8112*/
const unsigned char  uc2_8113 [] = {0x38, 0x40, 0x28, 0x40, 0x2B, 0xF0, 0x3A, 0x90, 0x28, 0x80, 0x29, 0x90, 0x3B, 0x50, 0x2D, 0x60, 0x29, 0x20, 0x29, 0xA0, 0x51, 0x10, 0x00, 0x00 }; /*8113*/
const unsigned char  uc2_8114 [] = {0x02, 0x00, 0x7F, 0xF0, 0x15, 0x20, 0x65, 0x10, 0x02, 0x10, 0x3F, 0xE0, 0x25, 0x20, 0x3A, 0xA0, 0x25, 0x20, 0x38, 0xA0, 0x20, 0xC0, 0x00, 0x00 }; /*8114*/
const unsigned char  uc2_8116 [] = {0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x3F, 0xF0, 0x2C, 0x10, 0x2B, 0xC0, 0x38, 0x40, 0x2F, 0xF0, 0x28, 0x80, 0x28, 0x80, 0x53, 0x00, 0x00, 0x00 }; /*8116*/
const unsigned char  uc2_8118 [] = {0x38, 0x80, 0x2F, 0xF0, 0x2C, 0x10, 0x3B, 0xE0, 0x28, 0x00, 0x2F, 0xF0, 0x39, 0x40, 0x29, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*8118*/
const unsigned char  uc2_811A [] = {0x3A, 0x00, 0x2A, 0x70, 0x2F, 0x50, 0x3A, 0x50, 0x2F, 0xD0, 0x28, 0x50, 0x3A, 0x50, 0x2A, 0x50, 0x2D, 0x60, 0x2E, 0xC0, 0x50, 0x40, 0x00, 0x00 }; /*811A*/
const unsigned char  uc2_811E [] = {0x38, 0x80, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2D, 0xD0, 0x28, 0x80, 0x38, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*811E*/
const unsigned char  uc2_812C [] = {0x38, 0x30, 0x2F, 0xC0, 0x2D, 0x10, 0x3A, 0x90, 0x2A, 0xA0, 0x2B, 0xC0, 0x38, 0x40, 0x2F, 0xF0, 0x28, 0x80, 0x28, 0x80, 0x53, 0x00, 0x00, 0x00 }; /*812C*/
const unsigned char  uc2_812F [] = {0x38, 0xA0, 0x2F, 0xF0, 0x28, 0x80, 0x3B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x3A, 0xA0, 0x2B, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x52, 0x40, 0x00, 0x00 }; /*812F*/
const unsigned char  uc2_8131 [] = {0x3A, 0x20, 0x29, 0x20, 0x29, 0x40, 0x3B, 0xE0, 0x2A, 0x20, 0x2A, 0x20, 0x3B, 0xE0, 0x29, 0x40, 0x29, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*8131*/
const unsigned char  uc2_8132 [] = {0x3F, 0xE0, 0x28, 0x20, 0x2F, 0xE0, 0x38, 0x00, 0x28, 0x80, 0x28, 0x90, 0x3E, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2C, 0x90, 0x53, 0x00, 0x00, 0x00 }; /*8132*/
const unsigned char  uc2_8136 [] = {0x39, 0xE0, 0x29, 0x20, 0x29, 0x20, 0x39, 0xE0, 0x28, 0x40, 0x2B, 0xF0, 0x3A, 0x50, 0x2A, 0x50, 0x2B, 0xB0, 0x2A, 0x10, 0x52, 0x60, 0x00, 0x00 }; /*8136*/
const unsigned char  uc2_8138 [] = {0x38, 0x80, 0x28, 0x80, 0x29, 0x40, 0x3A, 0x20, 0x2C, 0x10, 0x2B, 0xE0, 0x39, 0x10, 0x2C, 0x90, 0x2A, 0xA0, 0x2A, 0x40, 0x57, 0xF0, 0x00, 0x00 }; /*8138*/
const unsigned char  uc2_813E [] = {0x39, 0x00, 0x2B, 0xE0, 0x2A, 0xA0, 0x3B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x38, 0x80, 0x29, 0x40, 0x2F, 0xF0, 0x28, 0x40, 0x50, 0x40, 0x00, 0x00 }; /*813E*/
const unsigned char  uc2_8146 [] = {0x71, 0x40, 0x51, 0x40, 0x57, 0xF0, 0x75, 0x50, 0x57, 0xF0, 0x55, 0x50, 0x75, 0x50, 0x5F, 0xF0, 0x52, 0x20, 0x52, 0x10, 0x24, 0x10, 0x00, 0x00 }; /*8146*/
const unsigned char  uc2_8148 [] = {0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x3B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x3A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xA0, 0x5A, 0x60, 0x00, 0x00 }; /*8148*/
const unsigned char  uc2_814A [] = {0x39, 0x40, 0x2B, 0xE0, 0x29, 0x40, 0x3F, 0xF0, 0x28, 0x00, 0x2B, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*814A*/
const unsigned char  uc2_814B [] = {0x38, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x3A, 0x70, 0x2E, 0x90, 0x2A, 0xD0, 0x3B, 0xA0, 0x2A, 0x60, 0x2A, 0x40, 0x2A, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*814B*/
const unsigned char  uc2_814C [] = {0x38, 0x80, 0x2B, 0xF0, 0x29, 0x40, 0x3A, 0xA0, 0x2F, 0xF0, 0x2A, 0xA0, 0x3B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x28, 0x90, 0x50, 0x60, 0x00, 0x00 }; /*814C*/
const unsigned char  uc2_8150 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x20, 0x2D, 0xF0, 0x34, 0xA0, 0x24, 0x60, 0x21, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x4A, 0xA0, 0x48, 0x60, 0x00, 0x00 }; /*8150*/
const unsigned char  uc2_8151 [] = {0x00, 0x40, 0x3B, 0xF0, 0x2A, 0x00, 0x2A, 0x50, 0x3A, 0x90, 0x2B, 0x70, 0x2A, 0x90, 0x3A, 0xD0, 0x2A, 0xB0, 0x2A, 0x90, 0x5C, 0xB0, 0x00, 0x00 }; /*8151*/
const unsigned char  uc2_8153 [] = {0x39, 0x40, 0x29, 0x40, 0x2F, 0x70, 0x39, 0x40, 0x29, 0x40, 0x2B, 0x60, 0x39, 0x40, 0x29, 0x40, 0x2F, 0x70, 0x29, 0x40, 0x51, 0x40, 0x00, 0x00 }; /*8153*/
const unsigned char  uc2_8154 [] = {0x38, 0x80, 0x2B, 0xF0, 0x2C, 0x10, 0x39, 0x40, 0x29, 0x20, 0x2A, 0x20, 0x3B, 0xE0, 0x28, 0x80, 0x28, 0x80, 0x2F, 0xF0, 0x50, 0x00, 0x00, 0x00 }; /*8154*/
const unsigned char  uc2_8155 [] = {0x38, 0x80, 0x2F, 0xF0, 0x2C, 0x10, 0x3A, 0xE0, 0x2B, 0xA0, 0x2A, 0xA0, 0x3E, 0xA0, 0x29, 0xC0, 0x2A, 0x90, 0x2C, 0x90, 0x50, 0x60, 0x00, 0x00 }; /*8155*/
const unsigned char  uc2_8159 [] = {0x38, 0x80, 0x2B, 0xF0, 0x2C, 0x10, 0x3B, 0xE0, 0x28, 0x00, 0x2F, 0xF0, 0x38, 0x80, 0x2A, 0xA0, 0x2A, 0x90, 0x2C, 0x90, 0x53, 0x00, 0x00, 0x00 }; /*8159*/
const unsigned char  uc2_815A [] = {0x38, 0x80, 0x2B, 0xF0, 0x2C, 0x10, 0x38, 0x00, 0x2F, 0xF0, 0x28, 0x80, 0x3A, 0x80, 0x2A, 0xE0, 0x2A, 0x80, 0x2D, 0x80, 0x58, 0x70, 0x00, 0x00 }; /*815A*/
const unsigned char  uc2_8160 [] = {0x38, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x3B, 0xE0, 0x29, 0x00, 0x2F, 0xF0, 0x3A, 0x20, 0x2D, 0xD0, 0x28, 0x80, 0x2B, 0xE0, 0x51, 0x40, 0x00, 0x00 }; /*8160*/
const unsigned char  uc2_8165 [] = {0x3B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x2A, 0x80, 0x3B, 0xE0, 0x2C, 0x80, 0x29, 0xC0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*8165*/
const unsigned char  uc2_8167 [] = {0x70, 0x80, 0x51, 0x40, 0x56, 0x30, 0x71, 0xC0, 0x56, 0x10, 0x55, 0x50, 0x77, 0x50, 0x55, 0x50, 0x57, 0x50, 0x55, 0x50, 0x22, 0x20, 0x00, 0x00 }; /*8167*/
const unsigned char  uc2_8169 [] = {0x70, 0x80, 0x57, 0xF0, 0x51, 0x00, 0x77, 0xF0, 0x55, 0x50, 0x54, 0x90, 0x75, 0xD0, 0x54, 0x90, 0x57, 0xF0, 0x54, 0x90, 0x24, 0x60, 0x00, 0x00 }; /*8169*/
const unsigned char  uc2_816D [] = {0x3B, 0x70, 0x2A, 0xD0, 0x2B, 0x30, 0x38, 0x00, 0x2B, 0xE0, 0x28, 0x00, 0x3F, 0xF0, 0x29, 0x00, 0x2B, 0xE0, 0x28, 0x20, 0x51, 0xC0, 0x00, 0x00 }; /*816D*/
const unsigned char  uc2_816E [] = {0x77, 0xF0, 0x54, 0x90, 0x57, 0xF0, 0x74, 0x90, 0x57, 0xF0, 0x51, 0x00, 0x70, 0xA0, 0x54, 0x90, 0x56, 0x50, 0x5A, 0x40, 0x21, 0x80, 0x00, 0x00 }; /*816E*/
const unsigned char  uc2_8170 [] = {0x77, 0xF0, 0x51, 0x40, 0x57, 0xF0, 0x75, 0x50, 0x57, 0xF0, 0x50, 0x80, 0x77, 0xF0, 0x51, 0x20, 0x53, 0xC0, 0x50, 0xA0, 0x27, 0x10, 0x00, 0x00 }; /*8170*/
const unsigned char  uc2_8171 [] = {0x70, 0x80, 0x5D, 0xE0, 0x54, 0xA0, 0x77, 0xF0, 0x58, 0xA0, 0x55, 0xE0, 0x74, 0x80, 0x5F, 0xF0, 0x54, 0x80, 0x5A, 0x00, 0x21, 0xF0, 0x00, 0x00 }; /*8171*/
const unsigned char  uc2_8174 [] = {0x72, 0x80, 0x54, 0xB0, 0x54, 0x90, 0x76, 0xB0, 0x54, 0x90, 0x57, 0xF0, 0x70, 0x80, 0x51, 0x40, 0x51, 0x40, 0x52, 0x40, 0x2C, 0x30, 0x00, 0x00 }; /*8174*/
const unsigned char  uc2_8179 [] = {0x3A, 0x00, 0x2B, 0xF0, 0x2C, 0x00, 0x3B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x2E, 0x20, 0x29, 0xC0, 0x56, 0x30, 0x00, 0x00 }; /*8179*/
const unsigned char  uc2_817A [] = {0x38, 0x80, 0x2B, 0xE0, 0x2A, 0x20, 0x3B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x38, 0x90, 0x2E, 0xD0, 0x2A, 0xA0, 0x2A, 0xA0, 0x55, 0x10, 0x00, 0x00 }; /*817A*/
const unsigned char  uc2_817B [] = {0x38, 0x50, 0x2F, 0xF0, 0x28, 0x40, 0x3B, 0xC0, 0x28, 0x40, 0x2B, 0xC0, 0x38, 0x40, 0x2B, 0xD0, 0x2A, 0xD0, 0x29, 0x30, 0x5A, 0x90, 0x00, 0x00 }; /*817B*/
const unsigned char  uc2_817C [] = {0x77, 0xF0, 0x50, 0x80, 0x51, 0x00, 0x77, 0xF0, 0x55, 0x50, 0x55, 0xD0, 0x75, 0x50, 0x55, 0xD0, 0x55, 0x50, 0x57, 0xF0, 0x24, 0x10, 0x00, 0x00 }; /*817C*/
const unsigned char  uc2_817D [] = {0x3B, 0xC0, 0x2A, 0x40, 0x2B, 0xC0, 0x3A, 0x40, 0x2B, 0xC0, 0x28, 0x00, 0x3F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2F, 0xF0, 0x50, 0x00, 0x00, 0x00 }; /*817D*/
const unsigned char  uc2_817E [] = {0x3C, 0x90, 0x2A, 0xA0, 0x2B, 0xE0, 0x39, 0x00, 0x2F, 0xF0, 0x2A, 0x20, 0x3D, 0xD0, 0x2A, 0x40, 0x2B, 0xF0, 0x28, 0x10, 0x53, 0xA0, 0x00, 0x00 }; /*817E*/
const unsigned char  uc2_817F [] = {0x38, 0xF0, 0x2C, 0x90, 0x2A, 0xF0, 0x38, 0x90, 0x2E, 0xF0, 0x2A, 0x80, 0x3A, 0xD0, 0x2A, 0xA0, 0x2A, 0xD0, 0x2D, 0x80, 0x50, 0x70, 0x00, 0x00 }; /*817F*/
const unsigned char  uc2_8180 [] = {0x38, 0x80, 0x2B, 0xE0, 0x2A, 0x20, 0x39, 0x40, 0x2B, 0xF0, 0x2C, 0x90, 0x3B, 0xE0, 0x29, 0x00, 0x29, 0xE0, 0x2A, 0x20, 0x54, 0xC0, 0x00, 0x00 }; /*8180*/
const unsigned char  uc2_8182 [] = {0x11, 0x00, 0x7D, 0xF0, 0x23, 0x40, 0x39, 0x50, 0x29, 0xA0, 0x50, 0x10, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0xE0, 0x00, 0x00 }; /*8182*/
const unsigned char  uc2_8188 [] = {0x77, 0xF0, 0x50, 0x00, 0x53, 0xE0, 0x72, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x77, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x54, 0x90, 0x24, 0xA0, 0x00, 0x00 }; /*8188*/
const unsigned char  uc2_818A [] = {0x38, 0xA0, 0x2F, 0xF0, 0x2A, 0xA0, 0x3B, 0xE0, 0x2A, 0xA0, 0x2B, 0xE0, 0x3A, 0xA0, 0x28, 0x40, 0x2F, 0xF0, 0x2A, 0x40, 0x51, 0x80, 0x00, 0x00 }; /*818A*/
const unsigned char  uc2_818F [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x48, 0x90, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0x40, 0x11, 0xC0, 0x00, 0x00 }; /*818F*/
const unsigned char  uc2_8191 [] = {0x38, 0x80, 0x2B, 0xF0, 0x2C, 0x10, 0x38, 0x60, 0x2B, 0x80, 0x2A, 0x00, 0x3B, 0xE0, 0x2A, 0x80, 0x2F, 0xF0, 0x29, 0x20, 0x56, 0x10, 0x00, 0x00 }; /*8191*/
const unsigned char  uc2_8198 [] = {0x77, 0xF0, 0x51, 0x40, 0x57, 0xF0, 0x75, 0x50, 0x57, 0xF0, 0x50, 0x00, 0x73, 0xE0, 0x50, 0x00, 0x5F, 0xF0, 0x52, 0xA0, 0x2D, 0x90, 0x00, 0x00 }; /*8198*/
const unsigned char  uc2_819B [] = {0x3C, 0x90, 0x2A, 0xA0, 0x2B, 0xF0, 0x3C, 0x10, 0x2B, 0xE0, 0x2A, 0x20, 0x3B, 0xE0, 0x28, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*819B*/
const unsigned char  uc2_819C [] = {0x39, 0x40, 0x2F, 0xF0, 0x29, 0x40, 0x3B, 0xE0, 0x2A, 0x20, 0x2B, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x5A, 0x20, 0x00, 0x00 }; /*819C*/
const unsigned char  uc2_819D [] = {0x38, 0x80, 0x2F, 0xF0, 0x2A, 0xA0, 0x3C, 0x90, 0x29, 0xC0, 0x2E, 0xB0, 0x38, 0x00, 0x2A, 0xA0, 0x29, 0xC0, 0x2E, 0xB0, 0x51, 0x80, 0x00, 0x00 }; /*819D*/
const unsigned char  uc2_81A3 [] = {0x39, 0x00, 0x2B, 0xF0, 0x2D, 0x50, 0x3A, 0x20, 0x2F, 0xF0, 0x29, 0x40, 0x3B, 0xA0, 0x28, 0xA0, 0x2B, 0xE0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*81A3*/
const unsigned char  uc2_81A6 [] = {0x3C, 0x90, 0x2A, 0xA0, 0x2F, 0xF0, 0x3A, 0xA0, 0x2C, 0x90, 0x2A, 0xA0, 0x3B, 0x20, 0x2D, 0x70, 0x2A, 0xA0, 0x2A, 0xF0, 0x5C, 0x20, 0x00, 0x00 }; /*81A6*/
const unsigned char  uc2_81A8 [] = {0x39, 0x10, 0x2F, 0xD0, 0x29, 0x20, 0x3B, 0xC0, 0x28, 0x10, 0x2B, 0xA0, 0x3A, 0xC0, 0x2B, 0x90, 0x2A, 0x90, 0x29, 0x20, 0x56, 0xC0, 0x00, 0x00 }; /*81A8*/
const unsigned char  uc2_81AA [] = {0x38, 0x80, 0x2B, 0xE0, 0x29, 0x40, 0x3F, 0xF0, 0x2C, 0x90, 0x2B, 0xE0, 0x3A, 0xA0, 0x28, 0xC0, 0x2B, 0xE0, 0x2A, 0x20, 0x53, 0xE0, 0x00, 0x00 }; /*81AA*/
const unsigned char  uc2_81B3 [] = {0x39, 0x40, 0x2F, 0xF0, 0x28, 0x80, 0x3B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x3A, 0xA0, 0x2F, 0xF0, 0x2A, 0x20, 0x2B, 0xE0, 0x52, 0x20, 0x00, 0x00 }; /*81B3*/
const unsigned char  uc2_81BA [] = {0x01, 0x00, 0x3F, 0xF0, 0x2A, 0x40, 0x2B, 0xF0, 0x3E, 0x40, 0x2B, 0xF0, 0x2A, 0x40, 0x2F, 0xF0, 0x28, 0x20, 0x2F, 0xA0, 0x48, 0x60, 0x00, 0x00 }; /*81BA*/
const unsigned char  uc2_81BB [] = {0x70, 0x80, 0x57, 0xF0, 0x55, 0x50, 0x75, 0xD0, 0x54, 0x10, 0x57, 0xF0, 0x72, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x52, 0x20, 0x57, 0xF0, 0x00, 0x00 }; /*81BB*/
const unsigned char  uc2_81C0 [] = {0x3E, 0xE0, 0x22, 0xA0, 0x3F, 0xF0, 0x2A, 0xA0, 0x3F, 0x40, 0x2A, 0xB0, 0x5F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0xE0, 0x00, 0x00 }; /*81C0*/
const unsigned char  uc2_81C1 [] = {0x70, 0x80, 0x57, 0xF0, 0x55, 0x40, 0x77, 0xE0, 0x55, 0x50, 0x57, 0xF0, 0x75, 0x50, 0x57, 0xE0, 0x55, 0x40, 0x57, 0x60, 0x29, 0x50, 0x00, 0x00 }; /*81C1*/
const unsigned char  uc2_81C2 [] = {0x3E, 0x40, 0x23, 0xF0, 0x3E, 0xA0, 0x20, 0x40, 0x3F, 0xF0, 0x52, 0x40, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x10, 0xE0, 0x00, 0x00 }; /*81C2*/
const unsigned char  uc2_81C3 [] = {0x71, 0x00, 0x5F, 0xF0, 0x55, 0x40, 0x75, 0xF0, 0x5B, 0x40, 0x55, 0xE0, 0x7B, 0x40, 0x55, 0xE0, 0x55, 0x40, 0x55, 0xF0, 0x29, 0x00, 0x00, 0x00 }; /*81C3*/
const unsigned char  uc2_81C6 [] = {0x38, 0x80, 0x2B, 0xE0, 0x29, 0x40, 0x3F, 0xF0, 0x2A, 0x20, 0x2B, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x28, 0x80, 0x2D, 0x50, 0x59, 0xC0, 0x00, 0x00 }; /*81C6*/
const unsigned char  uc2_81CA [] = {0x39, 0xC0, 0x29, 0x40, 0x29, 0xC0, 0x3B, 0x70, 0x2D, 0x50, 0x2B, 0x70, 0x38, 0x80, 0x2F, 0xF0, 0x2A, 0xA0, 0x2C, 0x90, 0x50, 0x80, 0x00, 0x00 }; /*81CA*/
const unsigned char  uc2_81CC [] = {0x72, 0x20, 0x5F, 0xA0, 0x52, 0x70, 0x77, 0x20, 0x50, 0xF0, 0x57, 0x50, 0x75, 0x50, 0x57, 0x50, 0x55, 0x20, 0x53, 0x50, 0x2C, 0x90, 0x00, 0x00 }; /*81CC*/
const unsigned char  uc2_81E3 [] = {0x00, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x22, 0x00, 0x3F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x3F, 0xC0, 0x22, 0x00, 0x22, 0x00, 0x3F, 0xF0, 0x00, 0x00 }; /*81E3*/
const unsigned char  uc2_81E7 [] = {0x20, 0x50, 0x2F, 0xF0, 0x28, 0x40, 0x3F, 0x50, 0x0A, 0x50, 0x7F, 0x50, 0x29, 0x60, 0x2F, 0x40, 0x2A, 0x50, 0x4E, 0xD0, 0x11, 0x20, 0x00, 0x00 }; /*81E7*/
const unsigned char  uc2_81EA [] = {0x02, 0x00, 0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*81EA*/
const unsigned char  uc2_81EC [] = {0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*81EC*/
const unsigned char  uc2_81ED [] = {0x04, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x80, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*81ED*/
const unsigned char  uc2_81F3 [] = {0x7F, 0xF0, 0x04, 0x00, 0x08, 0x40, 0x11, 0xC0, 0x1E, 0x20, 0x00, 0x20, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*81F3*/
const unsigned char  uc2_81F4 [] = {0x7E, 0x80, 0x10, 0x80, 0x14, 0xF0, 0x24, 0xA0, 0x3B, 0x20, 0x00, 0xA0, 0x08, 0xA0, 0x3E, 0x40, 0x08, 0xA0, 0x0E, 0xA0, 0x71, 0x10, 0x00, 0x00 }; /*81F4*/
const unsigned char  uc2_81FB [] = {0x00, 0x40, 0x7B, 0xF0, 0x20, 0x40, 0x49, 0xE0, 0x74, 0x80, 0x07, 0xF0, 0x11, 0x20, 0x3A, 0xD0, 0x10, 0x40, 0x1D, 0xF0, 0x62, 0x50, 0x00, 0x00 }; /*81FB*/
const unsigned char  uc2_81FC [] = {0x04, 0x00, 0x39, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3D, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*81FC*/
const unsigned char  uc2_81FE [] = {0x02, 0x00, 0x0A, 0x00, 0x32, 0xE0, 0x22, 0x20, 0x3A, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*81FE*/
const unsigned char  uc2_8200 [] = {0x00, 0x60, 0x3F, 0xA0, 0x12, 0x20, 0x09, 0x40, 0x09, 0x00, 0x31, 0xE0, 0x20, 0x20, 0x3D, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8200*/
const unsigned char  uc2_8201 [] = {0x0C, 0x00, 0x31, 0xE0, 0x20, 0x20, 0x3D, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*8201*/
const unsigned char  uc2_8202 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x3D, 0xE0, 0x50, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*8202*/
const unsigned char  uc2_8204 [] = {0x3C, 0xE0, 0x20, 0x20, 0x3D, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x60, 0x90, 0x0A, 0x50, 0x15, 0x10, 0x65, 0x60, 0x00, 0x00 }; /*8204*/
const unsigned char  uc2_8205 [] = {0x39, 0xE0, 0x20, 0x20, 0x3D, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x04, 0x20, 0x79, 0xC0, 0x00, 0x00 }; /*8205*/
const unsigned char  uc2_8206 [] = {0x34, 0x60, 0x2F, 0x20, 0x2A, 0x20, 0x3F, 0x60, 0x22, 0x20, 0x3F, 0x60, 0x22, 0x20, 0x7F, 0xF0, 0x08, 0x40, 0x10, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*8206*/
const unsigned char  uc2_820C [] = {0x01, 0xE0, 0x3E, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*820C*/
const unsigned char  uc2_820D [] = {0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x02, 0x00, 0x7F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*820D*/
const unsigned char  uc2_8210 [] = {0x0C, 0x30, 0x71, 0xC0, 0x11, 0x40, 0x7D, 0x40, 0x11, 0xF0, 0x11, 0x40, 0x39, 0x40, 0x29, 0x50, 0x29, 0x50, 0x39, 0xB0, 0x29, 0x10, 0x00, 0x00 }; /*8210*/
const unsigned char  uc2_8212 [] = {0x08, 0x00, 0x0D, 0xE0, 0x12, 0x20, 0x7C, 0xC0, 0x08, 0x40, 0x3F, 0xF0, 0x08, 0x50, 0x3E, 0x60, 0x22, 0x40, 0x3E, 0x40, 0x22, 0x80, 0x00, 0x00 }; /*8212*/
const unsigned char  uc2_8214 [] = {0x0B, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x11, 0x40, 0x7E, 0x30, 0x10, 0x80, 0x3A, 0xA0, 0x2A, 0x90, 0x2C, 0xC0, 0x38, 0xA0, 0x2B, 0x00, 0x00, 0x00 }; /*8214*/
const unsigned char  uc2_821B [] = {0x20, 0x40, 0x20, 0x40, 0x3D, 0xE0, 0x24, 0x40, 0x45, 0x40, 0x5A, 0x40, 0x0B, 0xF0, 0x10, 0x40, 0x10, 0x40, 0x20, 0x40, 0x40, 0x40, 0x00, 0x00 }; /*821B*/
const unsigned char  uc2_821C [] = {0x00, 0xF0, 0x3F, 0x20, 0x12, 0x40, 0x3F, 0xF0, 0x20, 0x10, 0x10, 0x40, 0x1C, 0xE0, 0x65, 0x40, 0x15, 0xF0, 0x08, 0x40, 0x70, 0x40, 0x00, 0x00 }; /*821C*/
const unsigned char  uc2_821E [] = {0x10, 0x00, 0x3F, 0xE0, 0x55, 0x40, 0x3F, 0xE0, 0x15, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1D, 0xE0, 0x75, 0x40, 0x1B, 0xF0, 0x60, 0x40, 0x00, 0x00 }; /*821E*/
const unsigned char  uc2_821F [] = {0x04, 0x00, 0x0F, 0xC0, 0x0A, 0x40, 0x09, 0x40, 0x09, 0x40, 0x7F, 0xF0, 0x0A, 0x40, 0x09, 0x40, 0x11, 0x40, 0x10, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*821F*/
const unsigned char  uc2_8221 [] = {0x10, 0x00, 0x3C, 0xE0, 0x24, 0x40, 0x34, 0x40, 0x2C, 0x40, 0x7C, 0x40, 0x24, 0x40, 0x34, 0x40, 0x2C, 0x40, 0x25, 0xF0, 0x48, 0x00, 0x00, 0x00 }; /*8221*/
const unsigned char  uc2_8222 [] = {0x10, 0x40, 0x3C, 0x40, 0x25, 0x50, 0x35, 0x50, 0x2D, 0x50, 0x7D, 0x50, 0x25, 0x50, 0x35, 0x50, 0x2D, 0x50, 0x25, 0xF0, 0x48, 0x10, 0x00, 0x00 }; /*8222*/
const unsigned char  uc2_8223 [] = {0x11, 0x00, 0x3C, 0xA0, 0x24, 0xA0, 0x36, 0x20, 0x2D, 0x20, 0x7D, 0x40, 0x25, 0x40, 0x34, 0x80, 0x2C, 0x80, 0x25, 0x40, 0x4A, 0x30, 0x00, 0x00 }; /*8223*/
const unsigned char  uc2_8228 [] = {0x10, 0x30, 0x3D, 0xC0, 0x25, 0x00, 0x35, 0x00, 0x2D, 0xE0, 0x7D, 0x20, 0x25, 0xA0, 0x35, 0x40, 0x2D, 0x40, 0x26, 0xA0, 0x48, 0x90, 0x00, 0x00 }; /*8228*/
const unsigned char  uc2_822A [] = {0x11, 0x80, 0x3C, 0x40, 0x27, 0xF0, 0x34, 0x00, 0x2D, 0xC0, 0x7D, 0x40, 0x25, 0x40, 0x35, 0x50, 0x2D, 0x50, 0x25, 0x50, 0x4A, 0x20, 0x00, 0x00 }; /*822A*/
const unsigned char  uc2_822B [] = {0x11, 0x80, 0x3C, 0x40, 0x27, 0xF0, 0x34, 0x80, 0x2C, 0x80, 0x7C, 0xE0, 0x24, 0xA0, 0x34, 0xA0, 0x2D, 0x20, 0x25, 0x20, 0x4A, 0xC0, 0x00, 0x00 }; /*822B*/
const unsigned char  uc2_822C [] = {0x10, 0x00, 0x3D, 0xE0, 0x25, 0x20, 0x35, 0x20, 0x2E, 0x10, 0x7D, 0xE0, 0x25, 0x20, 0x34, 0xC0, 0x2C, 0x80, 0x25, 0x40, 0x4A, 0x30, 0x00, 0x00 }; /*822C*/
const unsigned char  uc2_822D [] = {0x11, 0x40, 0x3D, 0x40, 0x25, 0x50, 0x35, 0x50, 0x2D, 0xE0, 0x7D, 0x40, 0x25, 0x40, 0x35, 0x40, 0x2D, 0x50, 0x25, 0xD0, 0x49, 0x20, 0x00, 0x00 }; /*822D*/
const unsigned char  uc2_822F [] = {0x10, 0x40, 0x3C, 0x40, 0x25, 0xF0, 0x35, 0x50, 0x2D, 0x50, 0x7D, 0x50, 0x25, 0xF0, 0x35, 0x50, 0x2C, 0x40, 0x24, 0x40, 0x58, 0x40, 0x00, 0x00 }; /*822F*/
const unsigned char  uc2_8230 [] = {0x10, 0x00, 0x3B, 0xE0, 0x2A, 0x20, 0x3A, 0xA0, 0x2A, 0xA0, 0x7A, 0xA0, 0x28, 0xC0, 0x39, 0x40, 0x29, 0x50, 0x2A, 0x50, 0x54, 0x20, 0x00, 0x00 }; /*8230*/
const unsigned char  uc2_8231 [] = {0x10, 0x40, 0x3C, 0x40, 0x24, 0xA0, 0x35, 0x20, 0x2E, 0x10, 0x7D, 0xE0, 0x25, 0x20, 0x35, 0x60, 0x2D, 0x10, 0x25, 0x10, 0x48, 0xE0, 0x00, 0x00 }; /*8231*/
const unsigned char  uc2_8233 [] = {0x10, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x35, 0xF0, 0x2D, 0x50, 0x7D, 0x50, 0x25, 0xF0, 0x35, 0x50, 0x2D, 0x50, 0x25, 0xF0, 0x59, 0x10, 0x00, 0x00 }; /*8233*/
const unsigned char  uc2_8234 [] = {0x10, 0x80, 0x3C, 0x80, 0x24, 0xF0, 0x37, 0x00, 0x2D, 0x00, 0x7D, 0xC0, 0x25, 0x00, 0x35, 0x00, 0x2D, 0xE0, 0x25, 0x00, 0x49, 0x00, 0x00, 0x00 }; /*8234*/
const unsigned char  uc2_8235 [] = {0x11, 0x80, 0x3C, 0x40, 0x25, 0xF0, 0x35, 0x10, 0x2D, 0x10, 0x7C, 0x80, 0x24, 0xA0, 0x34, 0xC0, 0x2C, 0x90, 0x24, 0x90, 0x48, 0x60, 0x00, 0x00 }; /*8235*/
const unsigned char  uc2_8236 [] = {0x10, 0x40, 0x3C, 0x80, 0x25, 0xF0, 0x35, 0x10, 0x2D, 0x10, 0x7D, 0xF0, 0x25, 0x10, 0x35, 0x10, 0x2D, 0x10, 0x25, 0xF0, 0x59, 0x10, 0x00, 0x00 }; /*8236*/
const unsigned char  uc2_8237 [] = {0x11, 0x80, 0x3C, 0x40, 0x27, 0xF0, 0x34, 0x80, 0x2C, 0xA0, 0x7D, 0x20, 0x25, 0xC0, 0x34, 0xA0, 0x2D, 0x20, 0x25, 0xD0, 0x48, 0x10, 0x00, 0x00 }; /*8237*/
const unsigned char  uc2_8238 [] = {0x10, 0x00, 0x3D, 0xF0, 0x24, 0x20, 0x34, 0xE0, 0x2C, 0xA0, 0x7C, 0xA0, 0x24, 0xE0, 0x34, 0xA0, 0x2C, 0x20, 0x24, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*8238*/
const unsigned char  uc2_8239 [] = {0x10, 0x00, 0x3D, 0xE0, 0x25, 0x20, 0x35, 0x20, 0x2D, 0x20, 0x7E, 0x10, 0x25, 0xE0, 0x35, 0x20, 0x2D, 0x20, 0x25, 0xE0, 0x49, 0x20, 0x00, 0x00 }; /*8239*/
const unsigned char  uc2_823B [] = {0x10, 0x80, 0x3C, 0xF0, 0x24, 0x80, 0x35, 0xF0, 0x2D, 0x10, 0x7D, 0x10, 0x25, 0xF0, 0x35, 0x00, 0x2D, 0x00, 0x25, 0x00, 0x4A, 0x00, 0x00, 0x00 }; /*823B*/
const unsigned char  uc2_823E [] = {0x10, 0x00, 0x3D, 0xF0, 0x24, 0xA0, 0x34, 0xA0, 0x2D, 0xF0, 0x7D, 0x50, 0x25, 0x50, 0x35, 0xB0, 0x2D, 0x10, 0x25, 0xF0, 0x59, 0x10, 0x00, 0x00 }; /*823E*/
const unsigned char  uc2_8244 [] = {0x11, 0x50, 0x3C, 0xD0, 0x24, 0x60, 0x35, 0xF0, 0x2D, 0x10, 0x7D, 0xF0, 0x25, 0x10, 0x35, 0xF0, 0x2D, 0x10, 0x25, 0x10, 0x59, 0x60, 0x00, 0x00 }; /*8244*/
const unsigned char  uc2_8247 [] = {0x10, 0x10, 0x3F, 0x60, 0x29, 0x20, 0x3A, 0x20, 0x2F, 0x70, 0x79, 0x20, 0x2D, 0x20, 0x3A, 0x70, 0x2A, 0x00, 0x2D, 0x80, 0x54, 0x70, 0x00, 0x00 }; /*8247*/
const unsigned char  uc2_8249 [] = {0x10, 0x00, 0x3D, 0xF0, 0x25, 0x10, 0x35, 0xF0, 0x2D, 0x20, 0x7D, 0xC0, 0x25, 0x70, 0x35, 0xC0, 0x2D, 0x70, 0x25, 0xD0, 0x4A, 0x70, 0x00, 0x00 }; /*8249*/
const unsigned char  uc2_824B [] = {0x10, 0x00, 0x3B, 0xC0, 0x28, 0x40, 0x38, 0x80, 0x2B, 0xE0, 0x78, 0x80, 0x29, 0x00, 0x3F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x57, 0xF0, 0x00, 0x00 }; /*824B*/
const unsigned char  uc2_824F [] = {0x10, 0xA0, 0x3D, 0xF0, 0x24, 0x40, 0x35, 0xF0, 0x2D, 0x10, 0x7D, 0xF0, 0x25, 0x10, 0x35, 0xF0, 0x2D, 0x10, 0x25, 0xF0, 0x49, 0x10, 0x00, 0x00 }; /*824F*/
const unsigned char  uc2_8258 [] = {0x13, 0xB0, 0x3A, 0x90, 0x2B, 0xB0, 0x3A, 0x90, 0x2B, 0xF0, 0x78, 0x80, 0x2B, 0xE0, 0x39, 0x20, 0x28, 0xC0, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*8258*/
const unsigned char  uc2_825A [] = {0x11, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x37, 0xF0, 0x2D, 0x50, 0x7F, 0xF0, 0x25, 0x50, 0x37, 0xF0, 0x2D, 0x20, 0x25, 0xE0, 0x59, 0x20, 0x00, 0x00 }; /*825A*/
const unsigned char  uc2_825F [] = {0x10, 0x80, 0x3B, 0xE0, 0x2A, 0x40, 0x39, 0x40, 0x2F, 0xF0, 0x7A, 0xA0, 0x2B, 0xE0, 0x3A, 0xA0, 0x2B, 0xE0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*825F*/
const unsigned char  uc2_8268 [] = {0x11, 0x20, 0x3B, 0xF0, 0x29, 0x20, 0x3B, 0xF0, 0x2A, 0x10, 0x79, 0xE0, 0x2A, 0x80, 0x39, 0x50, 0x2A, 0xE0, 0x29, 0x50, 0x5A, 0xD0, 0x00, 0x00 }; /*8268*/
const unsigned char  uc2_826E [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x12, 0x20, 0x11, 0x20, 0x11, 0x40, 0x12, 0x80, 0x1C, 0x40, 0x10, 0x30, 0x00, 0x00 }; /*826E*/
const unsigned char  uc2_826F [] = {0x04, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x24, 0x40, 0x22, 0x80, 0x25, 0x00, 0x38, 0xC0, 0x20, 0x30, 0x00, 0x00 }; /*826F*/
const unsigned char  uc2_8270 [] = {0x03, 0xE0, 0x7A, 0x20, 0x0B, 0xE0, 0x6A, 0x20, 0x13, 0xE0, 0x12, 0x80, 0x2A, 0x90, 0x2A, 0x60, 0x4A, 0x40, 0x03, 0x20, 0x02, 0x10, 0x00, 0x00 }; /*8270*/
const unsigned char  uc2_8272 [] = {0x08, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x11, 0x00, 0x3F, 0xC0, 0x52, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x10, 0x10, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*8272*/
const unsigned char  uc2_8273 [] = {0x11, 0x00, 0x7D, 0xC0, 0x12, 0x40, 0x17, 0xE0, 0x3A, 0xA0, 0x12, 0xA0, 0x13, 0xE0, 0x7E, 0x00, 0x12, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*8273*/
const unsigned char  uc2_8274 [] = {0x14, 0x80, 0x14, 0xE0, 0x7F, 0x20, 0x15, 0xF0, 0x3F, 0x50, 0x55, 0x50, 0x7F, 0xF0, 0x15, 0x00, 0x17, 0x10, 0x25, 0x10, 0x44, 0xE0, 0x00, 0x00 }; /*8274*/
const unsigned char  uc2_827A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x03, 0x00, 0x0C, 0x10, 0x10, 0x10, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*827A*/
const unsigned char  uc2_827D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x80, 0x04, 0x90, 0x08, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*827D*/
const unsigned char  uc2_827E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x40, 0x08, 0x40, 0x04, 0x80, 0x02, 0x80, 0x01, 0x00, 0x02, 0x80, 0x0C, 0x40, 0x70, 0x30, 0x00, 0x00 }; /*827E*/
const unsigned char  uc2_827F [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xC0, 0x04, 0x40, 0x04, 0x80, 0x08, 0xF0, 0x08, 0x10, 0x10, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*827F*/
const unsigned char  uc2_8282 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x20, 0x02, 0x20, 0x02, 0x20, 0x02, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8282*/
const unsigned char  uc2_8284 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x80, 0x1C, 0x80, 0x06, 0x80, 0x09, 0x90, 0x10, 0x90, 0x60, 0x60, 0x00, 0x00 }; /*8284*/
const unsigned char  uc2_8285 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x05, 0x80, 0x04, 0x70, 0x07, 0x80, 0x7A, 0x00, 0x02, 0x00, 0x01, 0x10, 0x00, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*8285*/
const unsigned char  uc2_8288 [] = {0x02, 0x00, 0x0A, 0x80, 0x7A, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8288*/
const unsigned char  uc2_828A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*828A*/
const unsigned char  uc2_828B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*828B*/
const unsigned char  uc2_828D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x00, 0x0F, 0xE0, 0x10, 0x20, 0x64, 0x20, 0x02, 0x20, 0x02, 0x20, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*828D*/
const unsigned char  uc2_828E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x1F, 0xC0, 0x20, 0x00, 0x3F, 0xE0, 0x00, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*828E*/
const unsigned char  uc2_828F [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*828F*/
const unsigned char  uc2_8291 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x1F, 0xC0, 0x10, 0x50, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*8291*/
const unsigned char  uc2_8292 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x01, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x0F, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*8292*/
const unsigned char  uc2_8297 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x04, 0x80, 0x1F, 0x20, 0x02, 0x20, 0x04, 0xC0, 0x1F, 0x40, 0x00, 0x80, 0x07, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*8297*/
const unsigned char  uc2_8298 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x21, 0x00, 0x21, 0x00, 0x3D, 0x30, 0x21, 0xC0, 0x21, 0x00, 0x2D, 0x10, 0x31, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*8298*/
const unsigned char  uc2_8299 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*8299*/
const unsigned char  uc2_829C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x03, 0x00, 0x05, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*829C*/
const unsigned char  uc2_829D [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x03, 0x00, 0x0C, 0x00, 0x33, 0x00, 0x40, 0xF0, 0x00, 0x00 }; /*829D*/
const unsigned char  uc2_829F [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x70, 0x70, 0x1F, 0x80, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*829F*/
const unsigned char  uc2_82A1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x00, 0x0F, 0xE0, 0x10, 0x20, 0x62, 0x40, 0x02, 0x00, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*82A1*/
const unsigned char  uc2_82A4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3C, 0x80, 0x04, 0x80, 0x08, 0x80, 0x1E, 0x80, 0x68, 0x90, 0x08, 0x90, 0x30, 0x60, 0x00, 0x00 }; /*82A4*/
const unsigned char  uc2_82A5 [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x03, 0x00, 0x04, 0x80, 0x18, 0x40, 0x64, 0xB0, 0x04, 0x80, 0x04, 0x80, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*82A5*/
const unsigned char  uc2_82A6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00 }; /*82A6*/
const unsigned char  uc2_82A8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x08, 0x40, 0x08, 0x80, 0x09, 0xE0, 0x14, 0x20, 0x12, 0x40, 0x23, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*82A8*/
const unsigned char  uc2_82A9 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x02, 0x00, 0x05, 0x00, 0x1A, 0xC0, 0x61, 0x30, 0x1F, 0xC0, 0x00, 0x40, 0x01, 0x80, 0x06, 0x00, 0x00, 0x00 }; /*82A9*/
const unsigned char  uc2_82AA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0xE0, 0x3F, 0x00, 0x21, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x20, 0x90, 0x2C, 0x90, 0x30, 0x60, 0x00, 0x00 }; /*82AA*/
const unsigned char  uc2_82AB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*82AB*/
const unsigned char  uc2_82AC [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x04, 0x80, 0x04, 0x80, 0x08, 0x80, 0x73, 0x00, 0x00, 0x00 }; /*82AC*/
const unsigned char  uc2_82AD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x10, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*82AD*/
const unsigned char  uc2_82AE [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x23, 0x20, 0x24, 0xA0, 0x38, 0xA0, 0x20, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*82AE*/
const unsigned char  uc2_82AF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x02, 0x00, 0x29, 0x60, 0x29, 0x10, 0x28, 0x50, 0x48, 0x40, 0x07, 0x80, 0x00, 0x00, 0x00, 0x00 }; /*82AF*/
const unsigned char  uc2_82B0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xC0, 0x10, 0x40, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*82B0*/
const unsigned char  uc2_82B1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x05, 0x00, 0x09, 0x20, 0x11, 0x40, 0x71, 0x80, 0x17, 0x10, 0x11, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*82B1*/
const unsigned char  uc2_82B3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x08, 0x40, 0x10, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*82B3*/
const unsigned char  uc2_82B4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x00, 0x1F, 0xE0, 0x64, 0xA0, 0x04, 0xA0, 0x09, 0x20, 0x31, 0x20, 0x02, 0x40, 0x0D, 0x80, 0x00, 0x00 }; /*82B4*/
const unsigned char  uc2_82B7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x12, 0x00, 0x13, 0xE0, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*82B7*/
const unsigned char  uc2_82B8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0xC0, 0x1E, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*82B8*/
const unsigned char  uc2_82B9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x60, 0x1F, 0x80, 0x10, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x21, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*82B9*/
const unsigned char  uc2_82BD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x00, 0x80, 0x10, 0x80, 0x3F, 0xF0, 0x02, 0x80, 0x0C, 0x80, 0x70, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*82BD*/
const unsigned char  uc2_82BE [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x22, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*82BE*/
const unsigned char  uc2_82C1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x14, 0x80, 0x15, 0x40, 0x21, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*82C1*/
const unsigned char  uc2_82C4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x03, 0x80, 0x02, 0x40, 0x02, 0x40, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*82C4*/
const unsigned char  uc2_82C7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xF0, 0x02, 0x10, 0x02, 0x60, 0x02, 0x00, 0x00, 0x00 }; /*82C7*/
const unsigned char  uc2_82C8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xF0, 0x20, 0x00, 0x21, 0x00, 0x2F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x44, 0x20, 0x59, 0xC0, 0x00, 0x00 }; /*82C8*/
const unsigned char  uc2_82CA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xF0, 0x20, 0x00, 0x27, 0xC0, 0x24, 0x40, 0x25, 0x90, 0x24, 0x10, 0x43, 0xE0, 0x00, 0x00 }; /*82CA*/
const unsigned char  uc2_82CB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*82CB*/
const unsigned char  uc2_82CC [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0xC0, 0x1F, 0x00, 0x10, 0x00, 0x7F, 0xF0, 0x12, 0x00, 0x15, 0x00, 0x18, 0xC0, 0x10, 0x30, 0x00, 0x00 }; /*82CC*/
const unsigned char  uc2_82CD [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x05, 0x00, 0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x08, 0x80, 0x0B, 0x20, 0x08, 0x20, 0x07, 0xC0, 0x00, 0x00 }; /*82CD*/
const unsigned char  uc2_82CE [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x20, 0x20, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*82CE*/
const unsigned char  uc2_82CF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x40, 0x14, 0x60, 0x64, 0x50, 0x08, 0x50, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*82CF*/
const unsigned char  uc2_82D1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x00, 0x11, 0xE0, 0x1D, 0x20, 0x25, 0x20, 0x55, 0x40, 0x09, 0x10, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*82D1*/
const unsigned char  uc2_82D2 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xF0, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*82D2*/
const unsigned char  uc2_82D3 [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x05, 0x00, 0x1A, 0xC0, 0x61, 0x30, 0x0F, 0x80, 0x00, 0x80, 0x0D, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*82D3*/
const unsigned char  uc2_82D4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x40, 0x11, 0xC0, 0x1E, 0x20, 0x00, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*82D4*/
const unsigned char  uc2_82D5 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x20, 0x0C, 0x20, 0x70, 0x40, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*82D5*/
const unsigned char  uc2_82D7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*82D7*/
const unsigned char  uc2_82D8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x28, 0xA0, 0x2F, 0xA0, 0x20, 0x20, 0x21, 0xC0, 0x00, 0x00 }; /*82D8*/
const unsigned char  uc2_82DB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*82DB*/
const unsigned char  uc2_82DC [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*82DC*/
const unsigned char  uc2_82DE [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x20, 0x40, 0x3F, 0x40, 0x51, 0x40, 0x1F, 0x40, 0x11, 0x90, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*82DE*/
const unsigned char  uc2_82DF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x00, 0x07, 0xE0, 0x18, 0x20, 0x6F, 0x20, 0x09, 0x20, 0x0F, 0x20, 0x09, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*82DF*/
const unsigned char  uc2_82E0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x22, 0x00, 0x3F, 0xE0, 0x21, 0x10, 0x2C, 0x90, 0x30, 0x60, 0x00, 0x00 }; /*82E0*/
const unsigned char  uc2_82E1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x28, 0x00, 0x24, 0x40, 0x24, 0x40, 0x20, 0x40, 0x26, 0x40, 0x38, 0xA0, 0x21, 0x10, 0x06, 0x10, 0x00, 0x00 }; /*82E1*/
const unsigned char  uc2_82E3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0xE0, 0x10, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*82E3*/
const unsigned char  uc2_82E4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x06, 0xC0, 0x1A, 0x20, 0x62, 0x10, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*82E4*/
const unsigned char  uc2_82E5 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x00, 0x00 }; /*82E5*/
const unsigned char  uc2_82E6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*82E6*/
const unsigned char  uc2_82EB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x03, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*82EB*/
const unsigned char  uc2_82EF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*82EF*/
const unsigned char  uc2_82F1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*82F1*/
const unsigned char  uc2_82F4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*82F4*/
const unsigned char  uc2_82F7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*82F7*/
const unsigned char  uc2_82F9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*82F9*/
const unsigned char  uc2_82FB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x40, 0x10, 0x40, 0x37, 0xF0, 0x50, 0x40, 0x14, 0x40, 0x12, 0x40, 0x12, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*82FB*/
const unsigned char  uc2_8301 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x12, 0x40, 0x12, 0x40, 0x1F, 0xC0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*8301*/
const unsigned char  uc2_8302 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x40, 0x3F, 0xF0, 0x22, 0x20, 0x21, 0x40, 0x20, 0x90, 0x21, 0x90, 0x2E, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*8302*/
const unsigned char  uc2_8303 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x33, 0xE0, 0x0A, 0x20, 0x62, 0x20, 0x12, 0xC0, 0x0A, 0x10, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*8303*/
const unsigned char  uc2_8304 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x08, 0xF0, 0x7E, 0x90, 0x0A, 0x90, 0x12, 0x90, 0x12, 0x90, 0x22, 0xF0, 0x4C, 0x90, 0x00, 0x00 }; /*8304*/
const unsigned char  uc2_8305 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0x80, 0x04, 0x80, 0x03, 0x00, 0x7F, 0xF0, 0x05, 0x10, 0x05, 0x20, 0x19, 0x00, 0x66, 0x00, 0x00, 0x00 }; /*8305*/
const unsigned char  uc2_8306 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x06, 0x00, 0x38, 0xF0, 0x22, 0x90, 0x26, 0x90, 0x3A, 0x90, 0x04, 0xA0, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*8306*/
const unsigned char  uc2_8307 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x40, 0x3F, 0xF0, 0x04, 0x00, 0x07, 0xC0, 0x0A, 0x40, 0x11, 0x80, 0x66, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*8307*/
const unsigned char  uc2_8308 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x09, 0x00, 0x29, 0x30, 0x2F, 0xC0, 0x29, 0x00, 0x2F, 0x10, 0x71, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*8308*/
const unsigned char  uc2_8309 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*8309*/
const unsigned char  uc2_830C [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x08, 0x80, 0x10, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*830C*/
const unsigned char  uc2_830E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0x80, 0x00, 0x80, 0x07, 0x00, 0x78, 0xC0, 0x00, 0x20, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*830E*/
const unsigned char  uc2_830F [] = {0x10, 0x40, 0x7F, 0xF0, 0x11, 0x40, 0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x00, 0x0A, 0x20, 0x12, 0x40, 0x13, 0x90, 0x2E, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*830F*/
const unsigned char  uc2_8311 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x04, 0x00, 0x1F, 0xC0, 0x14, 0x40, 0x12, 0x80, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*8311*/
const unsigned char  uc2_8314 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*8314*/
const unsigned char  uc2_8315 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0x80, 0x08, 0x80, 0x08, 0x80, 0x7F, 0x50, 0x08, 0x50, 0x08, 0x30, 0x00, 0x00 }; /*8315*/
const unsigned char  uc2_8317 [] = {0x10, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x07, 0x80, 0x18, 0x80, 0x67, 0x00, 0x08, 0x00, 0x7F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*8317*/
const unsigned char  uc2_831A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x06, 0x00, 0x39, 0xF0, 0x21, 0x10, 0x3D, 0x10, 0x21, 0x10, 0x2D, 0x60, 0x31, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*831A*/
const unsigned char  uc2_831B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xD0, 0x11, 0x20, 0x14, 0xC0, 0x18, 0x30, 0x00, 0x00 }; /*831B*/
const unsigned char  uc2_831C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x28, 0xE0, 0x30, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*831C*/
const unsigned char  uc2_8327 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x40, 0x03, 0xE0, 0x7C, 0x10, 0x00, 0x10, 0x00, 0x00 }; /*8327*/
const unsigned char  uc2_8328 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x01, 0x00, 0x61, 0xF0, 0x16, 0x10, 0x10, 0xA0, 0x08, 0x80, 0x11, 0x40, 0x62, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*8328*/
const unsigned char  uc2_832B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x31, 0x80, 0x08, 0x40, 0x07, 0xF0, 0x62, 0x00, 0x12, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x61, 0xE0, 0x00, 0x00 }; /*832B*/
const unsigned char  uc2_832C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x14, 0x80, 0x1B, 0xE0, 0x70, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*832C*/
const unsigned char  uc2_832D [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x10, 0x20, 0x68, 0xA0, 0x07, 0x00, 0x08, 0xC0, 0x70, 0x30, 0x00, 0x00 }; /*832D*/
const unsigned char  uc2_832F [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x08, 0xA0, 0x10, 0x90, 0x77, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x1C, 0x10, 0x00, 0x00 }; /*832F*/
const unsigned char  uc2_8331 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*8331*/
const unsigned char  uc2_8333 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x30, 0x00, 0x0B, 0xE0, 0x60, 0x80, 0x10, 0x80, 0x08, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x60, 0x00, 0x00, 0x00 }; /*8333*/
const unsigned char  uc2_8334 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8334*/
const unsigned char  uc2_8335 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x2F, 0xA0, 0x25, 0x20, 0x28, 0xA0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8335*/
const unsigned char  uc2_8336 [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x05, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x1F, 0xC0, 0x02, 0x00, 0x12, 0x40, 0x62, 0x20, 0x0C, 0x20, 0x00, 0x00 }; /*8336*/
const unsigned char  uc2_8338 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x70, 0x7F, 0xC0, 0x00, 0x40, 0x00, 0x00 }; /*8338*/
const unsigned char  uc2_8339 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x00, 0x7E, 0xF0, 0x12, 0x90, 0x12, 0x90, 0x34, 0x90, 0x0C, 0x90, 0x12, 0xF0, 0x62, 0x90, 0x00, 0x00 }; /*8339*/
const unsigned char  uc2_833A [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x10, 0x80, 0x1F, 0x40, 0x05, 0x50, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*833A*/
const unsigned char  uc2_833C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x20, 0x20, 0x2F, 0xA0, 0x28, 0xA0, 0x2F, 0xA0, 0x20, 0x40, 0x00, 0x00 }; /*833C*/
const unsigned char  uc2_8340 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x0F, 0xE0, 0x10, 0x20, 0x6F, 0x20, 0x09, 0x20, 0x0F, 0x20, 0x09, 0x20, 0x0F, 0x40, 0x09, 0x80, 0x00, 0x00 }; /*8340*/
const unsigned char  uc2_8343 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x05, 0x80, 0x18, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*8343*/
const unsigned char  uc2_8346 [] = {0x12, 0x10, 0x7F, 0x90, 0x12, 0x50, 0x00, 0x50, 0x3F, 0x50, 0x12, 0x50, 0x12, 0x50, 0x7F, 0xD0, 0x12, 0x50, 0x12, 0x10, 0x62, 0x60, 0x00, 0x00 }; /*8346*/
const unsigned char  uc2_8347 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x00, 0x73, 0xE0, 0x08, 0x00, 0x17, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*8347*/
const unsigned char  uc2_8349 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8349*/
const unsigned char  uc2_834F [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x60, 0x13, 0x80, 0x70, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*834F*/
const unsigned char  uc2_8350 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x04, 0x00, 0x0B, 0xC0, 0x70, 0x40, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*8350*/
const unsigned char  uc2_8351 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x20, 0x1F, 0xE0, 0x22, 0x00, 0x3F, 0xE0, 0x05, 0x20, 0x78, 0xF0, 0x00, 0x00 }; /*8351*/
const unsigned char  uc2_8352 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x0F, 0xC0, 0x00, 0x00, 0x12, 0x40, 0x12, 0x50, 0x62, 0x70, 0x00, 0x00 }; /*8352*/
const unsigned char  uc2_8354 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x1F, 0xE0, 0x04, 0x20, 0x39, 0xC0, 0x10, 0x40, 0x7D, 0xF0, 0x14, 0x50, 0x24, 0x90, 0x4B, 0x20, 0x00, 0x00 }; /*8354*/
const unsigned char  uc2_835A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*835A*/
const unsigned char  uc2_835B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0xC0, 0x3F, 0x00, 0x02, 0xC0, 0x3F, 0x10, 0x00, 0x90, 0x7F, 0xE0, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*835B*/
const unsigned char  uc2_835C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x21, 0x20, 0x3D, 0xC0, 0x21, 0x10, 0x3C, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*835C*/
const unsigned char  uc2_835E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x3F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x70, 0x08, 0x80, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*835E*/
const unsigned char  uc2_835F [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x05, 0x00, 0x18, 0xC0, 0x67, 0x30, 0x00, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x11, 0xC0, 0x1E, 0x20, 0x00, 0x00 }; /*835F*/
const unsigned char  uc2_8360 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x0F, 0x80, 0x70, 0x70, 0x08, 0x80, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*8360*/
const unsigned char  uc2_8361 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x37, 0x80, 0x08, 0x80, 0x61, 0x00, 0x17, 0xF0, 0x02, 0x50, 0x14, 0x90, 0x11, 0x20, 0x66, 0xC0, 0x00, 0x00 }; /*8361*/
const unsigned char  uc2_8363 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*8363*/
const unsigned char  uc2_8364 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x44, 0x10, 0x3F, 0xE0, 0x0A, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8364*/
const unsigned char  uc2_8365 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x02, 0x40, 0x3A, 0x40, 0x0B, 0x80, 0x12, 0x40, 0x62, 0x30, 0x0C, 0x00, 0x00, 0x00 }; /*8365*/
const unsigned char  uc2_8366 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8366*/
const unsigned char  uc2_8367 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x12, 0x40, 0x12, 0x40, 0x05, 0x00, 0x08, 0xC0, 0x70, 0x30, 0x00, 0x00 }; /*8367*/
const unsigned char  uc2_8368 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xC0, 0x00, 0x40, 0x1F, 0xC0, 0x00, 0x40, 0x7F, 0xF0, 0x10, 0x80, 0x08, 0x80, 0x0B, 0x00, 0x00, 0x00 }; /*8368*/
const unsigned char  uc2_8369 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x21, 0x00, 0x2C, 0xC0, 0x43, 0x30, 0x4C, 0x00, 0x03, 0x00, 0x00, 0x00 }; /*8369*/
const unsigned char  uc2_836A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3C, 0x40, 0x04, 0x40, 0x09, 0x60, 0x0D, 0x50, 0x79, 0x50, 0x0A, 0x50, 0x08, 0x40, 0x31, 0x80, 0x00, 0x00 }; /*836A*/
const unsigned char  uc2_836B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0xE0, 0x25, 0x20, 0x29, 0xE0, 0x25, 0x20, 0x25, 0xE0, 0x39, 0x20, 0x21, 0x20, 0x22, 0x40, 0x00, 0x00 }; /*836B*/
const unsigned char  uc2_836C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x20, 0x35, 0x40, 0x09, 0x00, 0x7F, 0xF0, 0x02, 0x40, 0x0C, 0x20, 0x70, 0x20, 0x00, 0x00 }; /*836C*/
const unsigned char  uc2_836D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x20, 0x00, 0x4B, 0xE0, 0x70, 0x80, 0x20, 0x80, 0x4C, 0x80, 0x70, 0x80, 0x0C, 0x80, 0x77, 0xF0, 0x00, 0x00 }; /*836D*/
const unsigned char  uc2_836E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x20, 0x40, 0x4B, 0xF0, 0x70, 0x40, 0x22, 0x40, 0x49, 0x40, 0x71, 0x40, 0x0C, 0x40, 0x71, 0x80, 0x00, 0x00 }; /*836E*/
const unsigned char  uc2_836F [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x21, 0x00, 0x49, 0xE0, 0x72, 0x20, 0x22, 0x20, 0x49, 0x20, 0x71, 0x20, 0x0C, 0x40, 0x71, 0x80, 0x00, 0x00 }; /*836F*/
const unsigned char  uc2_8377 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x00, 0x0F, 0xF0, 0x10, 0x20, 0x77, 0xA0, 0x14, 0xA0, 0x17, 0xA0, 0x14, 0xA0, 0x10, 0xC0, 0x00, 0x00 }; /*8377*/
const unsigned char  uc2_8378 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x41, 0x10, 0x02, 0x00, 0x7F, 0xE0, 0x02, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*8378*/
const unsigned char  uc2_837B [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x34, 0x80, 0x0A, 0xA0, 0x1A, 0xA0, 0x6C, 0xC0, 0x18, 0x80, 0x69, 0x40, 0x09, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*837B*/
const unsigned char  uc2_837C [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x05, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x40, 0x72, 0x20, 0x04, 0x00, 0x00, 0x00 }; /*837C*/
const unsigned char  uc2_837D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x3F, 0xC0, 0x12, 0x20, 0x09, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x10, 0x80, 0x0F, 0xC0, 0x30, 0x20, 0x00, 0x00 }; /*837D*/
const unsigned char  uc2_8385 [] = {0x10, 0x40, 0x7F, 0xF0, 0x11, 0x40, 0x08, 0x80, 0x17, 0xE0, 0x74, 0x00, 0x12, 0x40, 0x12, 0x40, 0x10, 0x80, 0x1F, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*8385*/
const unsigned char  uc2_8386 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0xA0, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xA0, 0x22, 0x40, 0x00, 0x00 }; /*8386*/
const unsigned char  uc2_8389 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x20, 0x3C, 0xA0, 0x08, 0xA0, 0x3E, 0xA0, 0x0C, 0xA0, 0x1A, 0xA0, 0x6A, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*8389*/
const unsigned char  uc2_838E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x30, 0x80, 0x0A, 0xA0, 0x72, 0x90, 0x0A, 0x90, 0x04, 0xA0, 0x08, 0x40, 0x11, 0x80, 0x6E, 0x00, 0x00, 0x00 }; /*838E*/
const unsigned char  uc2_8392 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8392*/
const unsigned char  uc2_8393 [] = {0x10, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x0F, 0xF0, 0x10, 0x00, 0x7F, 0xE0, 0x09, 0x20, 0x7F, 0xF0, 0x12, 0x20, 0x1F, 0xB0, 0x00, 0x40, 0x00, 0x00 }; /*8393*/
const unsigned char  uc2_8398 [] = {0x08, 0x40, 0x7F, 0xF0, 0x0A, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8398*/
const unsigned char  uc2_839B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x38, 0x30, 0x09, 0xC0, 0x10, 0x40, 0x3C, 0xE0, 0x04, 0x40, 0x39, 0xF0, 0x0E, 0x00, 0x71, 0xF0, 0x00, 0x00 }; /*839B*/
const unsigned char  uc2_839C [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x08, 0x80, 0x14, 0xF0, 0x75, 0x20, 0x16, 0xA0, 0x14, 0xA0, 0x14, 0x40, 0x10, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*839C*/
const unsigned char  uc2_839E [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x05, 0x10, 0x78, 0xE0, 0x00, 0x00 }; /*839E*/
const unsigned char  uc2_83A0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6F, 0xB0, 0x04, 0xC0, 0x18, 0x40, 0x63, 0x80, 0x00, 0x00 }; /*83A0*/
const unsigned char  uc2_83A8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x11, 0x20, 0x16, 0xC0, 0x18, 0x30, 0x00, 0x00 }; /*83A8*/
const unsigned char  uc2_83A9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x7F, 0xC0, 0x12, 0x20, 0x09, 0x40, 0x3F, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x0E, 0x00, 0x00, 0x00 }; /*83A9*/
const unsigned char  uc2_83AA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0x40, 0x09, 0x20, 0x7F, 0xF0, 0x09, 0x20, 0x0E, 0xC0, 0x78, 0x90, 0x0B, 0x50, 0x30, 0x20, 0x00, 0x00 }; /*83AA*/
const unsigned char  uc2_83AB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x00, 0x00 }; /*83AB*/
const unsigned char  uc2_83B0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x00, 0x11, 0xE0, 0x7E, 0x20, 0x12, 0xC0, 0x10, 0x80, 0x1D, 0x40, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*83B0*/
const unsigned char  uc2_83B1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*83B1*/
const unsigned char  uc2_83B2 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x61, 0x00, 0x17, 0xF0, 0x02, 0x80, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*83B2*/
const unsigned char  uc2_83B3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x20, 0x3C, 0x20, 0x25, 0xF0, 0x3E, 0x20, 0x25, 0x20, 0x3D, 0x20, 0x24, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*83B3*/
const unsigned char  uc2_83B4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x38, 0xA0, 0x20, 0x40, 0x00, 0x00 }; /*83B4*/
const unsigned char  uc2_83B6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x03, 0x00, 0x04, 0x80, 0x18, 0x70, 0x67, 0x80, 0x12, 0x20, 0x09, 0x20, 0x09, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*83B6*/
const unsigned char  uc2_83B7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x30, 0xC0, 0x08, 0xA0, 0x1F, 0xF0, 0x68, 0x80, 0x19, 0x40, 0x69, 0x40, 0x0A, 0x20, 0x34, 0x10, 0x00, 0x00 }; /*83B7*/
const unsigned char  uc2_83B8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x34, 0xC0, 0x08, 0xA0, 0x77, 0xF0, 0x0C, 0x80, 0x15, 0x40, 0x65, 0x50, 0x0A, 0x50, 0x34, 0x20, 0x00, 0x00 }; /*83B8*/
const unsigned char  uc2_83B9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x80, 0x02, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*83B9*/
const unsigned char  uc2_83BA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x1F, 0x80, 0x14, 0x80, 0x11, 0x00, 0x1F, 0xE0, 0x00, 0x20, 0x7E, 0xE0, 0x00, 0x00 }; /*83BA*/
const unsigned char  uc2_83BC [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x20, 0x80, 0x4B, 0xF0, 0x70, 0x80, 0x22, 0xA0, 0x4B, 0xE0, 0x70, 0xA0, 0x0C, 0x90, 0x70, 0x70, 0x00, 0x00 }; /*83BC*/
const unsigned char  uc2_83BD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x70, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*83BD*/
const unsigned char  uc2_83C0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x50, 0x10, 0x1D, 0xC0, 0x25, 0x40, 0x59, 0xD0, 0x11, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*83C0*/
const unsigned char  uc2_83C1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0x40, 0x10, 0xC0, 0x00, 0x00 }; /*83C1*/
const unsigned char  uc2_83C5 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*83C5*/
const unsigned char  uc2_83C7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x40, 0x7C, 0x40, 0x17, 0xF0, 0x24, 0x40, 0x39, 0xF0, 0x15, 0x10, 0x15, 0xF0, 0x61, 0x10, 0x00, 0x00 }; /*83C7*/
const unsigned char  uc2_83CA [] = {0x10, 0x80, 0x7F, 0xF0, 0x14, 0x80, 0x0F, 0xF0, 0x72, 0x10, 0x0A, 0x90, 0x0A, 0x90, 0x3F, 0xD0, 0x0B, 0x10, 0x32, 0x90, 0x02, 0xA0, 0x00, 0x40, }; /*83CA*/
const unsigned char  uc2_83CC [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0xA0, 0x2F, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x2A, 0xA0, 0x32, 0x60, 0x3F, 0xE0, 0x00, 0x00 }; /*83CC*/
const unsigned char  uc2_83CF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x37, 0xF0, 0x08, 0x20, 0x63, 0xA0, 0x12, 0xA0, 0x13, 0xA0, 0x0A, 0xA0, 0x10, 0x20, 0x61, 0xC0, 0x00, 0x00 }; /*83CF*/
const unsigned char  uc2_83D3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*83D3*/
const unsigned char  uc2_83D4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0xE0, 0x25, 0x20, 0x3D, 0x40, 0x25, 0xE0, 0x3D, 0xA0, 0x25, 0x40, 0x25, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*83D4*/
const unsigned char  uc2_83D6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*83D6*/
const unsigned char  uc2_83D8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x40, 0x7D, 0x40, 0x12, 0x20, 0x3A, 0xA0, 0x54, 0x80, 0x55, 0x40, 0x11, 0xA0, 0x10, 0x20, 0x00, 0x00 }; /*83D8*/
const unsigned char  uc2_83DC [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x3F, 0xC0, 0x12, 0x20, 0x09, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x00, 0x00 }; /*83DC*/
const unsigned char  uc2_83DD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0x20, 0x17, 0xF0, 0x7D, 0x00, 0x11, 0xE0, 0x1E, 0xA0, 0x72, 0xA0, 0x14, 0x40, 0x69, 0xB0, 0x00, 0x00 }; /*83DD*/
const unsigned char  uc2_83DF [] = {0x10, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x07, 0x00, 0x09, 0x00, 0x3F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x03, 0x50, 0x0D, 0x30, 0x70, 0xE0, 0x00, 0x00 }; /*83DF*/
const unsigned char  uc2_83E0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x37, 0xF0, 0x0C, 0x90, 0x64, 0xA0, 0x17, 0xE0, 0x05, 0x20, 0x14, 0xC0, 0x14, 0xA0, 0x6B, 0x10, 0x00, 0x00 }; /*83E0*/
const unsigned char  uc2_83E1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x0F, 0x00, 0x21, 0x20, 0x3A, 0x60, 0x27, 0xA0, 0x2A, 0x20, 0x33, 0xA0, 0x24, 0x60, 0x3F, 0xE0, 0x00, 0x00 }; /*83E1*/
const unsigned char  uc2_83E5 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x30, 0x11, 0xC0, 0x7D, 0x00, 0x19, 0xF0, 0x35, 0x20, 0x55, 0x20, 0x51, 0x20, 0x12, 0x20, 0x00, 0x00 }; /*83E5*/
const unsigned char  uc2_83E9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*83E9*/
const unsigned char  uc2_83EA [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0xE0, 0x08, 0x00, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*83EA*/
const unsigned char  uc2_83F0 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x50, 0x7B, 0xE0, 0x0A, 0xA0, 0x12, 0xA0, 0x1E, 0xA0, 0x72, 0xA0, 0x14, 0xD0, 0x14, 0xB0, 0x68, 0xD0, 0x00, 0x00 }; /*83F0*/
const unsigned char  uc2_83F1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x14, 0x40, 0x67, 0xA0, 0x18, 0xA0, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*83F1*/
const unsigned char  uc2_83F2 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00 }; /*83F2*/
const unsigned char  uc2_83F8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x08, 0x40, 0x7E, 0xA0, 0x11, 0x10, 0x1E, 0xC0, 0x14, 0x20, 0x25, 0x80, 0x24, 0x40, 0x48, 0x40, 0x00, 0x00 }; /*83F8*/
const unsigned char  uc2_83F9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x30, 0x00, 0x0B, 0xE0, 0x62, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x0B, 0xE0, 0x12, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*83F9*/
const unsigned char  uc2_83FD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x00, 0x1D, 0xE0, 0x10, 0xA0, 0x7E, 0xA0, 0x00, 0xA0, 0x54, 0x40, 0x54, 0xA0, 0x23, 0x10, 0x00, 0x00 }; /*83FD*/
const unsigned char  uc2_8401 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x20, 0x20, 0x00, 0x00 }; /*8401*/
const unsigned char  uc2_8403 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x0C, 0xC0, 0x13, 0x20, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8403*/
const unsigned char  uc2_8404 [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xF0, 0x28, 0x10, 0x4F, 0x90, 0x12, 0x10, 0x3F, 0xF0, 0x12, 0x50, 0x1F, 0xD0, 0x00, 0x60, 0x00, 0x00 }; /*8404*/
const unsigned char  uc2_8406 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x09, 0x00, 0x7F, 0xF0, 0x01, 0x00, 0x00, 0x00 }; /*8406*/
const unsigned char  uc2_840B [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x7F, 0xF0, 0x10, 0x80, 0x0F, 0xC0, 0x70, 0x20, 0x00, 0x00 }; /*840B*/
const unsigned char  uc2_840C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x03, 0xE0, 0x7A, 0x20, 0x4B, 0xE0, 0x7A, 0x20, 0x4B, 0xE0, 0x7A, 0x20, 0x4A, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*840C*/
const unsigned char  uc2_840D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x20, 0x00, 0x13, 0xE0, 0x54, 0x90, 0x22, 0x90, 0x22, 0xA0, 0x07, 0xF0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*840D*/
const unsigned char  uc2_840E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0xC0, 0x78, 0x20, 0x00, 0x00 }; /*840E*/
const unsigned char  uc2_840F [] = {0x10, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x07, 0xC0, 0x08, 0x40, 0x32, 0x80, 0x1D, 0xE0, 0x20, 0x20, 0x3D, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*840F*/
const unsigned char  uc2_8411 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x11, 0x00, 0x1F, 0xE0, 0x71, 0x00, 0x1F, 0xC0, 0x11, 0x00, 0x1F, 0xC0, 0x11, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*8411*/
const unsigned char  uc2_8418 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x05, 0x00, 0x1F, 0xC0, 0x60, 0x30, 0x1F, 0xC0, 0x0A, 0x80, 0x12, 0x40, 0x66, 0x40, 0x00, 0x00 }; /*8418*/
const unsigned char  uc2_841C [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x10, 0x80, 0x10, 0x80, 0x7C, 0xF0, 0x54, 0x80, 0x57, 0xE0, 0x5A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*841C*/
const unsigned char  uc2_841D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x04, 0x00, 0x0F, 0x80, 0x78, 0x80, 0x07, 0x00, 0x78, 0x00, 0x00, 0x00 }; /*841D*/
const unsigned char  uc2_8424 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x03, 0xD0, 0x3C, 0x10, 0x00, 0x00 }; /*8424*/
const unsigned char  uc2_8425 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8425*/
const unsigned char  uc2_8426 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x44, 0x90, 0x49, 0x10, 0x1E, 0x40, 0x04, 0xC0, 0x3F, 0x40, 0x11, 0x20, 0x66, 0x20, 0x00, 0x00 }; /*8426*/
const unsigned char  uc2_8427 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x3F, 0xC0, 0x2B, 0x20, 0x2A, 0xA0, 0x52, 0xA0, 0x00, 0x00 }; /*8427*/
const unsigned char  uc2_8428 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3C, 0x40, 0x25, 0xF0, 0x28, 0xA0, 0x24, 0x40, 0x25, 0xF0, 0x39, 0x00, 0x21, 0x00, 0x26, 0x00, 0x00, 0x00 }; /*8428*/
const unsigned char  uc2_8431 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x50, 0x50, 0x5F, 0xD0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*8431*/
const unsigned char  uc2_8438 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x32, 0xE0, 0x22, 0x20, 0x3A, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x05, 0x00, 0x08, 0xC0, 0x70, 0x30, 0x00, 0x00 }; /*8438*/
const unsigned char  uc2_843C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0xE0, 0x25, 0x20, 0x18, 0xC0, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x03, 0x80, 0x00, 0x00 }; /*843C*/
const unsigned char  uc2_843D [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x33, 0xC0, 0x0E, 0x40, 0x61, 0x80, 0x16, 0x70, 0x13, 0xC0, 0x0A, 0x40, 0x13, 0xC0, 0x62, 0x40, 0x00, 0x00 }; /*843D*/
const unsigned char  uc2_8446 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x0B, 0xE0, 0x0A, 0x20, 0x13, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x14, 0x90, 0x00, 0x00 }; /*8446*/
const unsigned char  uc2_8451 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x20, 0x3E, 0xF0, 0x08, 0x20, 0x7F, 0x20, 0x08, 0xA0, 0x3E, 0xA0, 0x09, 0x20, 0x7E, 0xC0, 0x00, 0x00 }; /*8451*/
const unsigned char  uc2_8457 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x00, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x1F, 0xC0, 0x68, 0x40, 0x0F, 0xC0, 0x00, 0x00 }; /*8457*/
const unsigned char  uc2_8459 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0xE0, 0x7D, 0x20, 0x31, 0xE0, 0x59, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*8459*/
const unsigned char  uc2_845A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x80, 0x14, 0x40, 0x0F, 0xE0, 0x00, 0x00 }; /*845A*/
const unsigned char  uc2_845B [] = {0x09, 0x00, 0x7F, 0xE0, 0x09, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xE0, 0x62, 0x20, 0x15, 0x20, 0x1F, 0x60, 0x00, 0x00 }; /*845B*/
const unsigned char  uc2_845C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x80, 0x39, 0xE0, 0x10, 0xA0, 0x39, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x05, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*845C*/
const unsigned char  uc2_8461 [] = {0x08, 0x80, 0x7F, 0xF0, 0x28, 0x80, 0x3F, 0xF0, 0x42, 0x90, 0x3F, 0xF0, 0x12, 0x50, 0x1F, 0xD0, 0x12, 0x50, 0x1F, 0xD0, 0x12, 0xA0, 0x00, 0x00 }; /*8461*/
const unsigned char  uc2_8463 [] = {0x10, 0x40, 0x7F, 0xF0, 0x15, 0x40, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*8463*/
const unsigned char  uc2_8469 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x23, 0xE0, 0x7A, 0xA0, 0x4A, 0xA0, 0x7B, 0xE0, 0x4A, 0x00, 0x7A, 0x10, 0x4A, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*8469*/
const unsigned char  uc2_846B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x11, 0xF0, 0x7D, 0x10, 0x11, 0xF0, 0x7D, 0x10, 0x45, 0xF0, 0x7D, 0x10, 0x41, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*846B*/
const unsigned char  uc2_846C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x15, 0x20, 0x75, 0xC0, 0x09, 0x10, 0x14, 0xA0, 0x7F, 0xF0, 0x08, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*846C*/
const unsigned char  uc2_846D [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0xE0, 0x24, 0x20, 0x3D, 0xE0, 0x20, 0x00, 0x3B, 0xE0, 0x21, 0x20, 0x38, 0xC0, 0x23, 0x30, 0x00, 0x00 }; /*846D*/
const unsigned char  uc2_8471 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xE0, 0x6A, 0xA0, 0x06, 0xA0, 0x39, 0x20, 0x06, 0xC0, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*8471*/
const unsigned char  uc2_8473 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x3F, 0xF0, 0x20, 0x80, 0x3F, 0xA0, 0x24, 0xA0, 0x3F, 0x40, 0x29, 0x50, 0x26, 0x50, 0x59, 0xA0, 0x00, 0x00 }; /*8473*/
const unsigned char  uc2_8475 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0x40, 0x05, 0xA0, 0x38, 0xC0, 0x17, 0x40, 0x62, 0x30, 0x3F, 0xC0, 0x04, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8475*/
const unsigned char  uc2_8476 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00 }; /*8476*/
const unsigned char  uc2_8478 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x90, 0x00, 0x00 }; /*8478*/
const unsigned char  uc2_847A [] = {0x09, 0x00, 0x7F, 0xE0, 0x09, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x7F, 0xE0, 0x10, 0x80, 0x1F, 0x80, 0x10, 0xF0, 0x7F, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*847A*/
const unsigned char  uc2_8482 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0xC0, 0x02, 0x00, 0x00, 0x00 }; /*8482*/
const unsigned char  uc2_8487 [] = {0x10, 0x40, 0x7F, 0xF0, 0x11, 0x50, 0x3F, 0xF0, 0x20, 0x80, 0x3E, 0xA0, 0x2A, 0xA0, 0x2A, 0x40, 0x2C, 0xD0, 0x2B, 0x50, 0x52, 0x20, 0x00, 0x00 }; /*8487*/
const unsigned char  uc2_8488 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x21, 0x20, 0x3D, 0xD0, 0x21, 0x10, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8488*/
const unsigned char  uc2_8489 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x0D, 0xC0, 0x70, 0x20, 0x00, 0x00 }; /*8489*/
const unsigned char  uc2_848B [] = {0x10, 0x40, 0x7F, 0xF0, 0x11, 0x40, 0x01, 0xE0, 0x6B, 0x20, 0x18, 0xC0, 0x09, 0x20, 0x1F, 0xF0, 0x6A, 0x20, 0x09, 0x20, 0x09, 0x40, 0x00, 0x00 }; /*848B*/
const unsigned char  uc2_848C [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x0F, 0xC0, 0x70, 0x20, 0x00, 0x00 }; /*848C*/
const unsigned char  uc2_848E [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x67, 0xC0, 0x14, 0x30, 0x65, 0xC0, 0x15, 0x50, 0x05, 0x20, 0x15, 0x60, 0x15, 0xA0, 0x69, 0x10, 0x00, 0x00 }; /*848E*/
const unsigned char  uc2_8497 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x33, 0xE0, 0x0A, 0x20, 0x63, 0xE0, 0x12, 0x20, 0x03, 0xE0, 0x0A, 0xA0, 0x12, 0x40, 0x63, 0x30, 0x00, 0x00 }; /*8497*/
const unsigned char  uc2_8499 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x3F, 0xE0, 0x0A, 0x90, 0x05, 0xE0, 0x3A, 0xA0, 0x04, 0xA0, 0x3B, 0x10, 0x00, 0x00 }; /*8499*/
const unsigned char  uc2_849C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0xE0, 0x00, 0x00, 0x7D, 0xF0, 0x08, 0x40, 0x2D, 0x60, 0x2A, 0x50, 0x4A, 0x50, 0x31, 0x80, 0x00, 0x00 }; /*849C*/
const unsigned char  uc2_84A1 [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x3F, 0xE0, 0x09, 0x00, 0x10, 0x80, 0x67, 0x00, 0x00, 0x00 }; /*84A1*/
const unsigned char  uc2_84AF [] = {0x22, 0x10, 0x7F, 0x10, 0x22, 0x50, 0x77, 0x50, 0x55, 0x50, 0x77, 0x50, 0x55, 0x50, 0x77, 0x50, 0x55, 0x10, 0x55, 0x10, 0x2A, 0x60, 0x00, 0x00 }; /*84AF*/
const unsigned char  uc2_84B2 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x67, 0xF0, 0x10, 0x80, 0x67, 0xF0, 0x14, 0x90, 0x07, 0xF0, 0x14, 0x90, 0x17, 0xD0, 0x64, 0xA0, 0x00, 0x00 }; /*84B2*/
const unsigned char  uc2_84B4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x2A, 0x80, 0x14, 0xF0, 0x7F, 0x90, 0x08, 0xF0, 0x2A, 0x90, 0x3E, 0xF0, 0x08, 0x90, 0x11, 0x10, 0x61, 0x60, 0x00, 0x00 }; /*84B4*/
const unsigned char  uc2_84B8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x00, 0x40, 0x39, 0xB0, 0x09, 0x40, 0x72, 0x30, 0x1F, 0xC0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*84B8*/
const unsigned char  uc2_84B9 [] = {0x10, 0x40, 0x7F, 0xF0, 0x15, 0x40, 0x3F, 0xE0, 0x09, 0x40, 0x7F, 0xF0, 0x09, 0x40, 0x3F, 0xC0, 0x19, 0x40, 0x69, 0x30, 0x09, 0x00, 0x00, 0x00 }; /*84B9*/
const unsigned char  uc2_84BA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xF0, 0x52, 0x00, 0x53, 0xE0, 0x34, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x21, 0x40, 0x26, 0x30, 0x00, 0x00 }; /*84BA*/
const unsigned char  uc2_84BD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x14, 0x20, 0x32, 0x50, 0x4F, 0x90, 0x00, 0x00 }; /*84BD*/
const unsigned char  uc2_84BF [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*84BF*/
const unsigned char  uc2_84C1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x1E, 0xC0, 0x62, 0x30, 0x1F, 0xC0, 0x72, 0x70, 0x00, 0x00 }; /*84C1*/
const unsigned char  uc2_84C4 [] = {0x08, 0x40, 0x7F, 0xF0, 0x0A, 0x40, 0x7F, 0xF0, 0x09, 0x00, 0x06, 0x40, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*84C4*/
const unsigned char  uc2_84C9 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x48, 0x50, 0x32, 0x20, 0x0D, 0xA0, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*84C9*/
const unsigned char  uc2_84CA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x75, 0x70, 0x0E, 0x80, 0x00, 0x00, 0x7D, 0xF0, 0x24, 0x90, 0x14, 0x50, 0x65, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*84CA*/
const unsigned char  uc2_84CD [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x02, 0x80, 0x7F, 0xF0, 0x0C, 0x00, 0x77, 0xD0, 0x04, 0x10, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*84CD*/
const unsigned char  uc2_84D0 [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x3F, 0xF0, 0x22, 0x00, 0x3F, 0xF0, 0x28, 0xA0, 0x2A, 0x40, 0x3F, 0xF0, 0x28, 0x40, 0x44, 0xC0, 0x00, 0x00 }; /*84D0*/
const unsigned char  uc2_84D1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xE0, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x3F, 0xE0, 0x09, 0x40, 0x7A, 0xC0, 0x0C, 0x30, 0x00, 0x00 }; /*84D1*/
const unsigned char  uc2_84D3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x0F, 0xE0, 0x12, 0x40, 0x3F, 0xF0, 0x50, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x00, 0x00 }; /*84D3*/
const unsigned char  uc2_84D6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x27, 0x20, 0x28, 0xA0, 0x3F, 0xE0, 0x21, 0x20, 0x3D, 0xC0, 0x21, 0x10, 0x3C, 0xF0, 0x00, 0x00 }; /*84D6*/
const unsigned char  uc2_84DD [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x04, 0x80, 0x24, 0xF0, 0x24, 0x80, 0x24, 0xC0, 0x05, 0x20, 0x3F, 0xE0, 0x28, 0xA0, 0x7F, 0xF0, 0x00, 0x00 }; /*84DD*/
const unsigned char  uc2_84DF [] = {0x10, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x14, 0x10, 0x3E, 0x90, 0x6A, 0x90, 0x3E, 0x90, 0x2A, 0x90, 0x3E, 0x90, 0x03, 0x10, 0x7C, 0x60, 0x00, 0x00 }; /*84DF*/
const unsigned char  uc2_84E0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x05, 0x00, 0x12, 0x40, 0x15, 0x40, 0x3F, 0xE0, 0x25, 0x20, 0x2E, 0xA0, 0x20, 0xC0, 0x00, 0x00 }; /*84E0*/
const unsigned char  uc2_84E3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x79, 0xF0, 0x28, 0x40, 0x11, 0xF0, 0x7D, 0x10, 0x15, 0x50, 0x19, 0x50, 0x10, 0xA0, 0x63, 0x20, 0x00, 0x00 }; /*84E3*/
const unsigned char  uc2_84E5 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x42, 0x10, 0x0D, 0x80, 0x77, 0x70, 0x02, 0x00, 0x1F, 0xC0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*84E5*/
const unsigned char  uc2_84E6 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x28, 0xA0, 0x5F, 0xD0, 0x00, 0x40, 0x3E, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*84E6*/
const unsigned char  uc2_84EC [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xC0, 0x67, 0x20, 0x11, 0xC0, 0x06, 0xB0, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*84EC*/
const unsigned char  uc2_84F0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0xE0, 0x6A, 0x80, 0x0F, 0xF0, 0x70, 0x00, 0x12, 0x80, 0x12, 0xE0, 0x13, 0x80, 0x1C, 0x70, 0x00, 0x00 }; /*84F0*/
const unsigned char  uc2_84FC [] = {0x08, 0x80, 0x7F, 0xF0, 0x14, 0xA0, 0x0C, 0x60, 0x35, 0xA0, 0x02, 0x00, 0x0D, 0x80, 0x72, 0x70, 0x0C, 0x80, 0x03, 0x00, 0x1C, 0x00, 0x00, 0x00 }; /*84FC*/
const unsigned char  uc2_84FF [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x48, 0x10, 0x17, 0xE0, 0x71, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x00, 0x00 }; /*84FF*/
const unsigned char  uc2_850C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3E, 0xF0, 0x08, 0x90, 0x3F, 0x50, 0x2A, 0x60, 0x3E, 0x40, 0x14, 0xA0, 0x6A, 0xA0, 0x0B, 0x10, 0x00, 0x00 }; /*850C*/
const unsigned char  uc2_8511 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x80, 0x3F, 0xF0, 0x22, 0x40, 0x39, 0x90, 0x46, 0x60, 0x00, 0x00 }; /*8511*/
const unsigned char  uc2_8513 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*8513*/
const unsigned char  uc2_8517 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x27, 0xC0, 0x2A, 0xA0, 0x51, 0x50, 0x00, 0x00 }; /*8517*/
const unsigned char  uc2_851A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3E, 0x20, 0x22, 0x20, 0x3E, 0xF0, 0x24, 0x20, 0x2E, 0xA0, 0x24, 0x60, 0x36, 0x20, 0x4D, 0x60, 0x00, 0x00 }; /*851A*/
const unsigned char  uc2_851F [] = {0x08, 0x80, 0x7F, 0xF0, 0x2A, 0x80, 0x13, 0xF0, 0x7D, 0x00, 0x25, 0xE0, 0x3A, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x29, 0x40, 0x56, 0x30, 0x00, 0x00 }; /*851F*/
const unsigned char  uc2_8521 [] = {0x10, 0x40, 0x7F, 0xF0, 0x11, 0x40, 0x1D, 0xE0, 0x14, 0xA0, 0x6F, 0xC0, 0x10, 0x40, 0x6F, 0xB0, 0x02, 0x00, 0x12, 0xC0, 0x66, 0x20, 0x00, 0x00 }; /*8521*/
const unsigned char  uc2_852B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xE0, 0x02, 0x40, 0x12, 0x80, 0x7F, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x2A, 0x90, 0x45, 0x60, 0x00, 0x00 }; /*852B*/
const unsigned char  uc2_852C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7B, 0xF0, 0x08, 0x80, 0x11, 0x20, 0x5D, 0xD0, 0x50, 0x00, 0x5E, 0xA0, 0x62, 0xA0, 0x04, 0xB0, 0x00, 0x00 }; /*852C*/
const unsigned char  uc2_8537 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x12, 0x40, 0x7F, 0xF0, 0x28, 0xA0, 0x2F, 0xA0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8537*/
const unsigned char  uc2_8538 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x0F, 0x60, 0x35, 0x20, 0x27, 0x20, 0x25, 0x20, 0x2F, 0x60, 0x35, 0x10, 0x09, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*8538*/
const unsigned char  uc2_8539 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x08, 0x80, 0x14, 0xF0, 0x61, 0x20, 0x3E, 0xA0, 0x54, 0xA0, 0x28, 0x40, 0x3C, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*8539*/
const unsigned char  uc2_853A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x5F, 0xF0, 0x25, 0x10, 0x4F, 0xD0, 0x59, 0x10, 0x4F, 0x90, 0x49, 0x10, 0x4F, 0xD0, 0x48, 0x30, 0x00, 0x00 }; /*853A*/
const unsigned char  uc2_853B [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x41, 0x30, 0x39, 0x50, 0x01, 0xC0, 0x7E, 0x40, 0x29, 0x90, 0x2A, 0x50, 0x47, 0xE0, 0x00, 0x00 }; /*853B*/
const unsigned char  uc2_853C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x23, 0xE0, 0x12, 0x20, 0x03, 0xE0, 0x72, 0x20, 0x13, 0xF0, 0x14, 0x90, 0x1D, 0x50, 0x17, 0xB0, 0x00, 0x00 }; /*853C*/
const unsigned char  uc2_853D [] = {0x08, 0x40, 0x7F, 0xF0, 0x2A, 0x40, 0x1C, 0x80, 0x36, 0xF0, 0x2A, 0xA0, 0x2F, 0xA0, 0x3A, 0xA0, 0x2A, 0x40, 0x2A, 0xA0, 0x2D, 0x10, 0x00, 0x00 }; /*853D*/
const unsigned char  uc2_8543 [] = {0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8543*/
const unsigned char  uc2_8548 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8548*/
const unsigned char  uc2_8549 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x09, 0x00, 0x1F, 0xF0, 0x71, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*8549*/
const unsigned char  uc2_854A [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x02, 0x20, 0x29, 0x50, 0x48, 0x40, 0x07, 0x80, 0x00, 0x00, 0x55, 0x50, 0x2A, 0xA0, 0x38, 0xE0, 0x00, 0x00 }; /*854A*/
const unsigned char  uc2_8556 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x60, 0x00, 0x17, 0xF0, 0x6C, 0x20, 0x17, 0xE0, 0x24, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*8556*/
const unsigned char  uc2_8559 [] = {0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x7F, 0xD0, 0x04, 0x00, 0x2A, 0xA0, 0x4F, 0x90, 0x00, 0x00 }; /*8559*/
const unsigned char  uc2_855E [] = {0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x24, 0x00, 0x3D, 0xE0, 0x26, 0xA0, 0x7C, 0x40, 0x05, 0xB0, 0x00, 0x00 }; /*855E*/
const unsigned char  uc2_8564 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x7D, 0x40, 0x11, 0xF0, 0x6A, 0x40, 0x1C, 0xE0, 0x6A, 0x40, 0x1B, 0xF0, 0x69, 0x00, 0x18, 0xF0, 0x00, 0x00 }; /*8564*/
const unsigned char  uc2_8568 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x3F, 0xF0, 0x2A, 0x80, 0x3F, 0xF0, 0x24, 0x50, 0x35, 0x60, 0x2F, 0x40, 0x24, 0xA0, 0x5B, 0x10, 0x00, 0x00 }; /*8568*/
const unsigned char  uc2_8572 [] = {0x08, 0x80, 0x7F, 0xF0, 0x2A, 0x80, 0x14, 0x30, 0x3E, 0xC0, 0x2A, 0x80, 0x3E, 0xF0, 0x2A, 0xA0, 0x7F, 0xA0, 0x08, 0xA0, 0x0B, 0x20, 0x00, 0x00 }; /*8572*/
const unsigned char  uc2_8574 [] = {0x08, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x23, 0xE0, 0x4A, 0x20, 0x73, 0xE0, 0x22, 0x20, 0x4B, 0xE0, 0x75, 0x50, 0x05, 0x50, 0x7F, 0xF0, 0x00, 0x00 }; /*8574*/
const unsigned char  uc2_8579 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x11, 0x40, 0x2B, 0xF0, 0x76, 0x40, 0x2B, 0xF0, 0x7A, 0x40, 0x13, 0xF0, 0x62, 0x00, 0x00, 0x00 }; /*8579*/
const unsigned char  uc2_857A [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x3C, 0xC0, 0x24, 0xA0, 0x7F, 0xF0, 0x24, 0x80, 0x3C, 0xA0, 0x26, 0x40, 0x7C, 0xD0, 0x05, 0x30, 0x00, 0x00 }; /*857A*/
const unsigned char  uc2_857B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0x40, 0x23, 0xE0, 0x39, 0x40, 0x21, 0x40, 0x7F, 0xF0, 0x20, 0x00, 0x29, 0x60, 0x76, 0x10, 0x00, 0x00 }; /*857B*/
const unsigned char  uc2_857E [] = {0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x7F, 0xF0, 0x4A, 0x90, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*857E*/
const unsigned char  uc2_8584 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x67, 0xF0, 0x12, 0xA0, 0x63, 0xE0, 0x12, 0xA0, 0x07, 0xF0, 0x12, 0x20, 0x11, 0x20, 0x61, 0x40, 0x00, 0x00 }; /*8584*/
const unsigned char  uc2_8585 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x13, 0xF0, 0x7E, 0x40, 0x2B, 0xF0, 0x2A, 0xA0, 0x52, 0x90, 0x37, 0xF0, 0x29, 0x20, 0x48, 0xA0, 0x00, 0x00 }; /*8585*/
const unsigned char  uc2_8587 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x12, 0x20, 0x6A, 0xA0, 0x1F, 0xB0, 0x60, 0x50, 0x2F, 0xD0, 0x25, 0x20, 0x25, 0x50, 0x28, 0x90, 0x00, 0x00 }; /*8587*/
const unsigned char  uc2_858F [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x05, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x2A, 0x20, 0x29, 0x50, 0x47, 0x80, 0x00, 0x00 }; /*858F*/
const unsigned char  uc2_859B [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3D, 0xF0, 0x24, 0xA0, 0x3C, 0x40, 0x21, 0xF0, 0x3E, 0x40, 0x23, 0xF0, 0x3E, 0x40, 0x22, 0x40, 0x00, 0x00 }; /*859B*/
const unsigned char  uc2_859C [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3C, 0x40, 0x25, 0xF0, 0x3C, 0xA0, 0x21, 0xF0, 0x3C, 0x40, 0x55, 0xF0, 0x5C, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*859C*/
const unsigned char  uc2_85A4 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7D, 0x40, 0x27, 0x70, 0x39, 0x40, 0x2B, 0x60, 0x59, 0x40, 0x0F, 0x70, 0x11, 0x40, 0x67, 0xF0, 0x00, 0x00 }; /*85A4*/
const unsigned char  uc2_85A8 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x48, 0x90, 0x0E, 0xA0, 0x32, 0xD0, 0x0C, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*85A8*/
const unsigned char  uc2_85AA [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3E, 0x30, 0x14, 0xC0, 0x7F, 0x80, 0x08, 0xF0, 0x3E, 0xA0, 0x28, 0xA0, 0x4A, 0xA0, 0x31, 0x20, 0x00, 0x00 }; /*85AA*/
const unsigned char  uc2_85AE [] = {0x08, 0x80, 0x7F, 0xF0, 0x4A, 0x80, 0x2A, 0x40, 0x7F, 0x70, 0x1A, 0xA0, 0x28, 0xA0, 0x7F, 0xA0, 0x22, 0x40, 0x1C, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*85AE*/
const unsigned char  uc2_85AF [] = {0x08, 0x80, 0x7F, 0xF0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xA0, 0x02, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x70, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*85AF*/
const unsigned char  uc2_85B0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x3F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x49, 0x10, 0x00, 0x00 }; /*85B0*/
const unsigned char  uc2_85B7 [] = {0x08, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x60, 0x00, 0x00 }; /*85B7*/
const unsigned char  uc2_85B9 [] = {0x10, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x7F, 0xF0, 0x44, 0x90, 0x0F, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*85B9*/
const unsigned char  uc2_85C1 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x25, 0x20, 0x27, 0x60, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*85C1*/
const unsigned char  uc2_85C9 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x7D, 0x20, 0x13, 0xF0, 0x39, 0x20, 0x13, 0xF0, 0x7D, 0x20, 0x39, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x00, 0x00 }; /*85C9*/
const unsigned char  uc2_85CF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0xA0, 0x2F, 0xF0, 0x2A, 0x40, 0x3F, 0x50, 0x09, 0x50, 0x7F, 0x60, 0x2A, 0x50, 0x4F, 0x50, 0x10, 0xB0, 0x00, 0x00 }; /*85CF*/
const unsigned char  uc2_85D0 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x17, 0xE0, 0x6A, 0x20, 0x1B, 0xE0, 0x6A, 0x20, 0x17, 0xE0, 0x6D, 0x50, 0x15, 0x50, 0x6A, 0x20, 0x00, 0x00 }; /*85D0*/
const unsigned char  uc2_85D3 [] = {0x08, 0x80, 0x7F, 0xF0, 0x18, 0xA0, 0x24, 0x40, 0x7F, 0xF0, 0x2A, 0x40, 0x3E, 0xE0, 0x2A, 0x40, 0x3F, 0xF0, 0x02, 0x40, 0x7C, 0x40, 0x00, 0x00 }; /*85D3*/
const unsigned char  uc2_85D5 [] = {0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x7D, 0xF0, 0x11, 0x50, 0x7D, 0xF0, 0x31, 0x50, 0x5B, 0xF0, 0x56, 0x50, 0x53, 0xB0, 0x12, 0x10, 0x00, 0x00 }; /*85D5*/
const unsigned char  uc2_85DC [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3C, 0xF0, 0x09, 0x50, 0x7C, 0x50, 0x2A, 0xB0, 0x4D, 0x80, 0x72, 0x70, 0x0A, 0x80, 0x76, 0x60, 0x00, 0x00 }; /*85DC*/
const unsigned char  uc2_85E4 [] = {0x10, 0x80, 0x7F, 0xF0, 0x12, 0xA0, 0x39, 0x40, 0x2B, 0xE0, 0x38, 0x80, 0x2F, 0xF0, 0x39, 0x20, 0x2E, 0xB0, 0x2A, 0xC0, 0x55, 0xB0, 0x00, 0x00 }; /*85E4*/
const unsigned char  uc2_85E9 [] = {0x10, 0x80, 0x7F, 0xF0, 0x12, 0xA0, 0x67, 0xF0, 0x12, 0xA0, 0x64, 0x90, 0x13, 0xE0, 0x02, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x63, 0xE0, 0x00, 0x00 }; /*85E9*/
const unsigned char  uc2_85FB [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x61, 0xC0, 0x17, 0x70, 0x65, 0xD0, 0x17, 0x70, 0x00, 0x80, 0x17, 0xF0, 0x22, 0xA0, 0x44, 0x90, 0x00, 0x00 }; /*85FB*/
const unsigned char  uc2_85FF [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x11, 0x00, 0x3F, 0xE0, 0x51, 0x00, 0x1F, 0xE0, 0x00, 0x00 }; /*85FF*/
const unsigned char  uc2_8605 [] = {0x08, 0x40, 0x7F, 0xF0, 0x16, 0x40, 0x69, 0x70, 0x0F, 0x80, 0x1A, 0xF0, 0x6F, 0xA0, 0x2A, 0xA0, 0x3F, 0xA0, 0x25, 0x20, 0x38, 0xC0, 0x00, 0x00 }; /*8605*/
const unsigned char  uc2_8611 [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xF0, 0x24, 0x80, 0x3F, 0xF0, 0x2D, 0xA0, 0x34, 0x90, 0x2F, 0xE0, 0x38, 0x20, 0x4F, 0xE0, 0x00, 0x00 }; /*8611*/
const unsigned char  uc2_8616 [] = {0x08, 0x80, 0x7F, 0xF0, 0x39, 0x40, 0x2B, 0xE0, 0x30, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x72, 0x70, 0x00, 0x00 }; /*8616*/
const unsigned char  uc2_8627 [] = {0x10, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x47, 0xE0, 0x24, 0x90, 0x07, 0xF0, 0x64, 0x80, 0x2B, 0x50, 0x28, 0xE0, 0x33, 0x50, 0x4F, 0xF0, 0x00, 0x00 }; /*8627*/
const unsigned char  uc2_8629 [] = {0x10, 0x40, 0x7F, 0xF0, 0x2A, 0x40, 0x7E, 0xF0, 0x2B, 0xA0, 0x3E, 0x40, 0x09, 0xB0, 0x06, 0x40, 0x3F, 0xE0, 0x09, 0x20, 0x77, 0x10, 0x00, 0x00 }; /*8629*/
const unsigned char  uc2_8638 [] = {0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x7D, 0x40, 0x2B, 0xF0, 0x7D, 0x40, 0x55, 0xE0, 0x6D, 0x40, 0x7D, 0xF0, 0x44, 0x00, 0x7D, 0x50, 0x00, 0x00 }; /*8638*/
const unsigned char  uc2_863C [] = {0x08, 0x80, 0x7F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x22, 0x80, 0x2E, 0xE0, 0x22, 0x80, 0x5E, 0xF0, 0x42, 0x80, 0x00, 0x00 }; /*863C*/
const unsigned char  uc2_864E [] = {0x03, 0xE0, 0x02, 0x00, 0x3F, 0xF0, 0x22, 0x10, 0x23, 0xC0, 0x2E, 0x20, 0x23, 0xE0, 0x20, 0x00, 0x23, 0xC0, 0x22, 0x50, 0x4C, 0x70, 0x00, 0x00 }; /*864E*/
const unsigned char  uc2_864F [] = {0x03, 0xE0, 0x02, 0x00, 0x1F, 0xF0, 0x12, 0x90, 0x1F, 0x20, 0x12, 0xC0, 0x11, 0x00, 0x17, 0xE0, 0x21, 0x20, 0x22, 0x20, 0x4C, 0x40, 0x00, 0x00 }; /*864F*/
const unsigned char  uc2_8650 [] = {0x03, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x2F, 0xC0, 0x22, 0x20, 0x27, 0xE0, 0x24, 0x00, 0x3F, 0xF0, 0x44, 0x00, 0x47, 0xE0, 0x00, 0x00 }; /*8650*/
const unsigned char  uc2_8651 [] = {0x03, 0xE0, 0x02, 0x00, 0x3F, 0xF0, 0x22, 0x10, 0x23, 0xC0, 0x2E, 0x20, 0x21, 0xE0, 0x22, 0x00, 0x2D, 0x20, 0x54, 0x50, 0x43, 0xC0, 0x00, 0x00 }; /*8651*/
const unsigned char  uc2_8654 [] = {0x03, 0xE0, 0x02, 0x00, 0x3F, 0xF0, 0x22, 0x90, 0x2F, 0x20, 0x21, 0xE0, 0x21, 0x00, 0x2F, 0xE0, 0x24, 0x40, 0x23, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*8654*/
const unsigned char  uc2_865A [] = {0x03, 0xE0, 0x02, 0x00, 0x3F, 0xF0, 0x22, 0x10, 0x23, 0xC0, 0x2E, 0x20, 0x21, 0xE0, 0x32, 0x90, 0x2A, 0xA0, 0x22, 0x80, 0x5F, 0xF0, 0x00, 0x00 }; /*865A*/
const unsigned char  uc2_865E [] = {0x03, 0xC0, 0x02, 0x00, 0x3F, 0xF0, 0x22, 0x10, 0x2F, 0xC0, 0x22, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x3F, 0xF0, 0x22, 0x80, 0x5C, 0x70, 0x00, 0x00 }; /*865E*/
const unsigned char  uc2_8662 [] = {0x04, 0x80, 0x78, 0xF0, 0x28, 0x80, 0x57, 0xF0, 0x2A, 0x90, 0x7E, 0xA0, 0x4B, 0x50, 0x2A, 0xE0, 0x2A, 0xA0, 0x0A, 0xA0, 0x35, 0x10, 0x00, 0x00 }; /*8662*/
const unsigned char  uc2_866B [] = {0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x20, 0x03, 0xE0, 0x7C, 0x10, 0x00, 0x10, 0x00, 0x00 }; /*866B*/
const unsigned char  uc2_866C [] = {0x08, 0x80, 0x08, 0x80, 0x3E, 0x80, 0x2A, 0x80, 0x2A, 0x80, 0x3E, 0x80, 0x08, 0x90, 0x0A, 0x90, 0x0D, 0x90, 0x70, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*866C*/
const unsigned char  uc2_866E [] = {0x10, 0x00, 0x11, 0xC0, 0x7D, 0x40, 0x55, 0x40, 0x55, 0x40, 0x7D, 0x40, 0x11, 0x40, 0x15, 0x50, 0x1A, 0x50, 0x62, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*866E*/
const unsigned char  uc2_8671 [] = {0x7F, 0xC0, 0x01, 0x40, 0x7E, 0x40, 0x08, 0x40, 0x3E, 0x40, 0x2A, 0x40, 0x2A, 0x40, 0x3E, 0x50, 0x0A, 0x50, 0x0D, 0x30, 0x71, 0x10, 0x00, 0x00 }; /*8671*/
const unsigned char  uc2_8679 [] = {0x10, 0x00, 0x11, 0xF0, 0x7C, 0x40, 0x54, 0x40, 0x54, 0x40, 0x7C, 0x40, 0x10, 0x40, 0x14, 0x40, 0x1A, 0x40, 0x63, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*8679*/
const unsigned char  uc2_867A [] = {0x00, 0x80, 0x7C, 0x80, 0x2B, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2B, 0xE0, 0x28, 0xA0, 0x2B, 0xD0, 0x28, 0x10, 0x27, 0xE0, 0x40, 0x00, 0x00, 0x00 }; /*867A*/
const unsigned char  uc2_867B [] = {0x10, 0x80, 0x10, 0x40, 0x7C, 0x40, 0x57, 0xF0, 0x55, 0x00, 0x7D, 0x00, 0x11, 0x00, 0x15, 0x00, 0x1D, 0x00, 0x62, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*867B*/
const unsigned char  uc2_867C [] = {0x10, 0x80, 0x10, 0x80, 0x7C, 0xF0, 0x55, 0x00, 0x56, 0xE0, 0x7C, 0x20, 0x10, 0x40, 0x14, 0x80, 0x1D, 0x10, 0x63, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*867C*/
const unsigned char  uc2_867D [] = {0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x03, 0xF0, 0x7C, 0x10, 0x00, 0x00 }; /*867D*/
const unsigned char  uc2_867E [] = {0x17, 0xF0, 0x10, 0x80, 0x7C, 0x80, 0x54, 0xC0, 0x54, 0xA0, 0x7C, 0x90, 0x10, 0x90, 0x14, 0x80, 0x1A, 0x80, 0x62, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*867E*/
const unsigned char  uc2_867F [] = {0x7F, 0xF0, 0x08, 0x00, 0x0F, 0xC0, 0x10, 0x40, 0x63, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*867F*/
const unsigned char  uc2_8680 [] = {0x20, 0x80, 0x20, 0x80, 0x3B, 0xE0, 0x26, 0xA0, 0x46, 0xA0, 0x5B, 0xE0, 0x10, 0x80, 0x10, 0xA0, 0x14, 0xE0, 0x1B, 0x10, 0x10, 0x10, 0x00, 0x00 }; /*8680*/
const unsigned char  uc2_8681 [] = {0x11, 0x00, 0x10, 0x80, 0x7C, 0xA0, 0x56, 0x20, 0x55, 0x40, 0x7D, 0x40, 0x10, 0x80, 0x14, 0x80, 0x1B, 0x40, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*8681*/
const unsigned char  uc2_8682 [] = {0x13, 0xE0, 0x10, 0x20, 0x7D, 0x20, 0x55, 0x40, 0x56, 0x40, 0x7D, 0xF0, 0x10, 0x10, 0x15, 0xD0, 0x1A, 0x10, 0x62, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8682*/
const unsigned char  uc2_868A [] = {0x11, 0x80, 0x10, 0x40, 0x7F, 0xF0, 0x55, 0x20, 0x55, 0x20, 0x7D, 0x20, 0x11, 0x40, 0x14, 0x80, 0x1A, 0x80, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*868A*/
const unsigned char  uc2_868B [] = {0x10, 0x40, 0x10, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x7D, 0x50, 0x11, 0xB0, 0x15, 0x10, 0x1B, 0x10, 0x61, 0x10, 0x01, 0x60, 0x00, 0x00 }; /*868B*/
const unsigned char  uc2_868C [] = {0x10, 0x40, 0x11, 0xF0, 0x7C, 0x40, 0x54, 0x40, 0x54, 0xE0, 0x7C, 0x40, 0x10, 0x40, 0x15, 0xF0, 0x1A, 0x40, 0x62, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*868C*/
const unsigned char  uc2_868D [] = {0x11, 0x40, 0x11, 0x40, 0x7D, 0x50, 0x55, 0xD0, 0x55, 0x60, 0x7D, 0x40, 0x11, 0x40, 0x15, 0x50, 0x1B, 0x50, 0x61, 0xD0, 0x01, 0x20, 0x00, 0x00 }; /*868D*/
const unsigned char  uc2_8693 [] = {0x11, 0xD0, 0x10, 0x50, 0x7C, 0x50, 0x55, 0xD0, 0x55, 0x10, 0x7D, 0x10, 0x11, 0xD0, 0x14, 0x50, 0x1A, 0x50, 0x62, 0x50, 0x01, 0x90, 0x00, 0x00 }; /*8693*/
const unsigned char  uc2_8695 [] = {0x1F, 0xC0, 0x04, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x72, 0x70, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x03, 0xD0, 0x7C, 0x10, 0x00, 0x00 }; /*8695*/
const unsigned char  uc2_869C [] = {0x11, 0xF0, 0x10, 0x20, 0x7C, 0xA0, 0x55, 0x20, 0x55, 0xF0, 0x7C, 0x60, 0x10, 0xA0, 0x14, 0xA0, 0x1B, 0x20, 0x62, 0x20, 0x00, 0x40, 0x00, 0x00 }; /*869C*/
const unsigned char  uc2_869D [] = {0x10, 0x60, 0x13, 0x80, 0x7C, 0x80, 0x54, 0xE0, 0x57, 0x80, 0x7C, 0xB0, 0x10, 0xC0, 0x17, 0x90, 0x1C, 0x90, 0x62, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*869D*/
const unsigned char  uc2_86A3 [] = {0x10, 0xA0, 0x10, 0xA0, 0x7D, 0x20, 0x55, 0x50, 0x56, 0x50, 0x7C, 0x40, 0x10, 0x80, 0x14, 0x80, 0x1B, 0x20, 0x61, 0xD0, 0x00, 0x10, 0x00, 0x00 }; /*86A3*/
const unsigned char  uc2_86A4 [] = {0x3F, 0xC0, 0x12, 0x40, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x62, 0x30, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*86A4*/
const unsigned char  uc2_86A7 [] = {0x10, 0x40, 0x10, 0x40, 0x7C, 0xA0, 0x54, 0xA0, 0x55, 0x10, 0x7E, 0xA0, 0x10, 0xA0, 0x14, 0xA0, 0x1B, 0x20, 0x61, 0x20, 0x06, 0x20, 0x00, 0x00 }; /*86A7*/
const unsigned char  uc2_86A8 [] = {0x10, 0x80, 0x10, 0x80, 0x7F, 0xE0, 0x54, 0x80, 0x54, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x15, 0x40, 0x1B, 0x40, 0x62, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*86A8*/
const unsigned char  uc2_86A9 [] = {0x02, 0x00, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*86A9*/
const unsigned char  uc2_86AA [] = {0x10, 0x20, 0x11, 0xA0, 0x7C, 0x60, 0x54, 0x20, 0x55, 0xA0, 0x7C, 0x60, 0x10, 0x30, 0x15, 0xE0, 0x1A, 0x20, 0x62, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*86AA*/
const unsigned char  uc2_86AC [] = {0x13, 0xE0, 0x12, 0x20, 0x7A, 0xA0, 0x56, 0xA0, 0x56, 0xA0, 0x7A, 0xA0, 0x10, 0x80, 0x15, 0x50, 0x1B, 0x50, 0x62, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*86AC*/
const unsigned char  uc2_86AF [] = {0x10, 0x30, 0x11, 0xC0, 0x7D, 0x00, 0x55, 0x00, 0x55, 0xF0, 0x7D, 0x20, 0x11, 0x20, 0x15, 0x20, 0x1B, 0x20, 0x61, 0x20, 0x03, 0xF0, 0x00, 0x00 }; /*86AF*/
const unsigned char  uc2_86B0 [] = {0x10, 0x40, 0x10, 0x40, 0x7C, 0x40, 0x55, 0xF0, 0x55, 0x50, 0x7D, 0x50, 0x11, 0xF0, 0x15, 0x50, 0x1B, 0x50, 0x63, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*86B0*/
const unsigned char  uc2_86B1 [] = {0x10, 0x80, 0x10, 0xF0, 0x7D, 0x80, 0x56, 0x80, 0x54, 0xE0, 0x7C, 0x80, 0x10, 0xF0, 0x14, 0x80, 0x1A, 0x80, 0x62, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*86B1*/
const unsigned char  uc2_86B4 [] = {0x11, 0x40, 0x12, 0x40, 0x7C, 0xF0, 0x57, 0x50, 0x55, 0x50, 0x7A, 0x50, 0x15, 0x50, 0x17, 0x90, 0x1C, 0x90, 0x64, 0x90, 0x01, 0x60, 0x00, 0x00 }; /*86B4*/
const unsigned char  uc2_86B5 [] = {0x13, 0xF0, 0x10, 0x20, 0x7C, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x7D, 0x20, 0x11, 0xE0, 0x15, 0x20, 0x1A, 0x20, 0x62, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*86B5*/
const unsigned char  uc2_86B6 [] = {0x11, 0x20, 0x11, 0x20, 0x7F, 0xF0, 0x55, 0x20, 0x55, 0x20, 0x7D, 0xE0, 0x11, 0x20, 0x15, 0x20, 0x1B, 0x20, 0x61, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*86B6*/
const unsigned char  uc2_86BA [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x56, 0xA0, 0x57, 0xE0, 0x7A, 0xA0, 0x17, 0xF0, 0x12, 0x20, 0x1A, 0x20, 0x66, 0x20, 0x02, 0xC0, 0x00, 0x00 }; /*86BA*/
const unsigned char  uc2_86C0 [] = {0x11, 0x80, 0x10, 0x40, 0x7D, 0xF0, 0x54, 0x40, 0x54, 0x40, 0x7C, 0xE0, 0x10, 0x40, 0x14, 0x40, 0x1A, 0x40, 0x63, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*86C0*/
const unsigned char  uc2_86C4 [] = {0x10, 0x40, 0x10, 0x40, 0x7C, 0x40, 0x57, 0xF0, 0x54, 0x40, 0x7C, 0x40, 0x11, 0xF0, 0x15, 0x10, 0x1B, 0x10, 0x61, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*86C4*/
const unsigned char  uc2_86C6 [] = {0x10, 0x00, 0x11, 0xE0, 0x7D, 0x20, 0x55, 0x20, 0x55, 0xE0, 0x7D, 0x20, 0x11, 0x20, 0x15, 0xE0, 0x1B, 0x20, 0x61, 0x20, 0x03, 0xF0, 0x00, 0x00 }; /*86C6*/
const unsigned char  uc2_86C7 [] = {0x10, 0xC0, 0x10, 0x20, 0x7D, 0xF0, 0x55, 0x10, 0x54, 0x80, 0x7C, 0x90, 0x10, 0xE0, 0x14, 0x80, 0x1A, 0x90, 0x60, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*86C7*/
const unsigned char  uc2_86C9 [] = {0x10, 0x40, 0x10, 0x40, 0x7C, 0xA0, 0x55, 0x10, 0x56, 0x40, 0x7D, 0xF0, 0x10, 0x10, 0x14, 0x20, 0x1A, 0xC0, 0x62, 0x20, 0x00, 0x20, 0x00, 0x00 }; /*86C9*/
const unsigned char  uc2_86CA [] = {0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x10, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*86CA*/
const unsigned char  uc2_86CB [] = {0x7F, 0xF0, 0x02, 0x10, 0x13, 0xA0, 0x1E, 0x00, 0x61, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*86CB*/
const unsigned char  uc2_86CE [] = {0x11, 0xF0, 0x11, 0x00, 0x7D, 0x00, 0x55, 0xF0, 0x55, 0x40, 0x7D, 0x70, 0x11, 0x50, 0x15, 0x50, 0x1A, 0x90, 0x62, 0x90, 0x05, 0x20, 0x00, 0x00 }; /*86CE*/
const unsigned char  uc2_86CF [] = {0x10, 0x00, 0x11, 0xE0, 0x7C, 0xA0, 0x54, 0x40, 0x55, 0xB0, 0x7C, 0x40, 0x10, 0x40, 0x14, 0xE0, 0x1A, 0x40, 0x62, 0x40, 0x03, 0xF0, 0x00, 0x00 }; /*86CF*/
const unsigned char  uc2_86D0 [] = {0x11, 0x40, 0x11, 0x40, 0x7D, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x7D, 0x50, 0x17, 0xF0, 0x15, 0x50, 0x1D, 0x50, 0x67, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*86D0*/
const unsigned char  uc2_86D1 [] = {0x10, 0x40, 0x10, 0xA0, 0x7D, 0x20, 0x55, 0xD0, 0x55, 0x40, 0x7D, 0xF0, 0x12, 0x40, 0x15, 0xF0, 0x1A, 0x40, 0x62, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*86D1*/
const unsigned char  uc2_86D4 [] = {0x10, 0x00, 0x17, 0xF0, 0x7C, 0x10, 0x55, 0xD0, 0x55, 0x50, 0x7D, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x1C, 0x10, 0x67, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*86D4*/
const unsigned char  uc2_86D8 [] = {0x11, 0x10, 0x10, 0xA0, 0x7D, 0xF0, 0x54, 0x40, 0x54, 0xE0, 0x7C, 0x40, 0x11, 0xF0, 0x14, 0x40, 0x1A, 0x40, 0x62, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*86D8*/
const unsigned char  uc2_86D9 [] = {0x10, 0x80, 0x13, 0xE0, 0x7C, 0x80, 0x54, 0x80, 0x57, 0xF0, 0x7C, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x1A, 0x80, 0x67, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*86D9*/
const unsigned char  uc2_86DB [] = {0x10, 0x40, 0x11, 0x40, 0x7D, 0xE0, 0x56, 0x40, 0x54, 0x40, 0x7F, 0xF0, 0x10, 0xC0, 0x15, 0x60, 0x1A, 0x50, 0x62, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*86DB*/
const unsigned char  uc2_86DE [] = {0x10, 0x30, 0x11, 0xC0, 0x7C, 0x40, 0x55, 0xF0, 0x54, 0x40, 0x7C, 0x40, 0x11, 0xF0, 0x15, 0x10, 0x1B, 0x10, 0x61, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*86DE*/
const unsigned char  uc2_86DF [] = {0x11, 0x80, 0x10, 0x40, 0x7D, 0xF0, 0x54, 0xA0, 0x54, 0x90, 0x7F, 0x10, 0x10, 0xA0, 0x14, 0xA0, 0x1A, 0x40, 0x62, 0xA0, 0x07, 0x10, 0x00, 0x00 }; /*86DF*/
const unsigned char  uc2_86E4 [] = {0x10, 0x80, 0x10, 0x80, 0x7D, 0x40, 0x56, 0x30, 0x55, 0xE0, 0x7C, 0x00, 0x11, 0xE0, 0x15, 0x20, 0x1B, 0x20, 0x61, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*86E4*/
const unsigned char  uc2_86E9 [] = {0x3B, 0xC0, 0x12, 0x40, 0x13, 0x50, 0x1E, 0xD0, 0x64, 0x20, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*86E9*/
const unsigned char  uc2_86ED [] = {0x11, 0xF0, 0x10, 0x40, 0x7C, 0xA0, 0x55, 0x20, 0x55, 0xD0, 0x7C, 0x10, 0x10, 0x40, 0x15, 0xF0, 0x1A, 0x40, 0x62, 0x40, 0x01, 0xF0, 0x00, 0x00 }; /*86ED*/
const unsigned char  uc2_86EE [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x15, 0x60, 0x65, 0x10, 0x02, 0x10, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*86EE*/
const unsigned char  uc2_86F0 [] = {0x10, 0x80, 0x7D, 0xE0, 0x12, 0xA0, 0x7D, 0xA0, 0x11, 0x60, 0x62, 0x10, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*86F0*/
const unsigned char  uc2_86F1 [] = {0x10, 0x80, 0x13, 0xE0, 0x7C, 0x90, 0x56, 0x90, 0x55, 0xA0, 0x7F, 0xF0, 0x10, 0x80, 0x15, 0x40, 0x1D, 0x40, 0x62, 0x20, 0x04, 0x10, 0x00, 0x00 }; /*86F1*/
const unsigned char  uc2_86F2 [] = {0x11, 0x20, 0x11, 0xC0, 0x7E, 0xA0, 0x54, 0x50, 0x57, 0xB0, 0x7C, 0x00, 0x13, 0xF0, 0x15, 0x40, 0x1B, 0x50, 0x61, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*86F2*/
const unsigned char  uc2_86F3 [] = {0x11, 0x00, 0x11, 0xF0, 0x7D, 0x40, 0x55, 0x40, 0x55, 0xF0, 0x7D, 0x50, 0x15, 0x50, 0x15, 0x60, 0x1D, 0x40, 0x62, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*86F3*/
const unsigned char  uc2_86F4 [] = {0x10, 0x40, 0x13, 0xF0, 0x7D, 0x20, 0x55, 0x20, 0x54, 0xC0, 0x7F, 0x30, 0x10, 0x00, 0x15, 0x20, 0x1B, 0x20, 0x61, 0x20, 0x02, 0x20, 0x00, 0x00 }; /*86F4*/
const unsigned char  uc2_86F8 [] = {0x12, 0x50, 0x11, 0x50, 0x7D, 0x60, 0x55, 0xF0, 0x55, 0x10, 0x7D, 0xF0, 0x11, 0x10, 0x15, 0xF0, 0x1B, 0x10, 0x61, 0x10, 0x01, 0x60, 0x00, 0x00 }; /*86F8*/
const unsigned char  uc2_86F9 [] = {0x11, 0xF0, 0x10, 0x90, 0x7C, 0x60, 0x55, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x11, 0x50, 0x15, 0xF0, 0x1B, 0x50, 0x61, 0x50, 0x01, 0x20, 0x00, 0x00 }; /*86F9*/
const unsigned char  uc2_86FE [] = {0x10, 0xC0, 0x13, 0x60, 0x7D, 0x50, 0x55, 0x40, 0x57, 0xF0, 0x7D, 0x40, 0x11, 0xD0, 0x17, 0x60, 0x19, 0x50, 0x61, 0xB0, 0x06, 0x10, 0x00, 0x00 }; /*86FE*/
const unsigned char  uc2_8700 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x62, 0x10, 0x1F, 0xD0, 0x12, 0x50, 0x1F, 0xD0, 0x02, 0x90, 0x3F, 0x60, 0x00, 0x00 }; /*8700*/
const unsigned char  uc2_8702 [] = {0x10, 0x80, 0x10, 0xE0, 0x7D, 0xA0, 0x54, 0xE0, 0x57, 0x50, 0x7D, 0xF0, 0x10, 0x40, 0x14, 0xE0, 0x1C, 0x40, 0x63, 0xF0, 0x00, 0x40, 0x00, 0x00 }; /*8702*/
const unsigned char  uc2_8703 [] = {0x3F, 0xF0, 0x22, 0x00, 0x3F, 0xF0, 0x24, 0xA0, 0x27, 0x60, 0x25, 0x10, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x20, 0x5F, 0xD0, 0x00, 0x00 }; /*8703*/
const unsigned char  uc2_8707 [] = {0x11, 0xE0, 0x7D, 0x00, 0x11, 0xF0, 0x7D, 0x40, 0x11, 0x40, 0x62, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*8707*/
const unsigned char  uc2_8708 [] = {0x13, 0xE0, 0x12, 0x20, 0x7A, 0x20, 0x57, 0xE0, 0x54, 0x00, 0x7B, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x1C, 0x80, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*8708*/
const unsigned char  uc2_8709 [] = {0x10, 0x30, 0x13, 0xD0, 0x7D, 0x50, 0x54, 0xA0, 0x55, 0xE0, 0x7C, 0x20, 0x10, 0x40, 0x15, 0xF0, 0x1C, 0x40, 0x62, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*8709*/
const unsigned char  uc2_870A [] = {0x10, 0x90, 0x13, 0x10, 0x7D, 0x50, 0x55, 0x50, 0x57, 0xD0, 0x7D, 0x50, 0x13, 0xD0, 0x15, 0x50, 0x1D, 0x10, 0x63, 0x10, 0x01, 0x60, 0x00, 0x00 }; /*870A*/
const unsigned char  uc2_870D [] = {0x10, 0x80, 0x11, 0x40, 0x7E, 0x30, 0x54, 0x00, 0x57, 0xE0, 0x7C, 0x80, 0x13, 0xF0, 0x14, 0xA0, 0x1A, 0x90, 0x64, 0x90, 0x03, 0x00, 0x00, 0x00 }; /*870D*/
const unsigned char  uc2_8712 [] = {0x13, 0x90, 0x10, 0xE0, 0x7C, 0xA0, 0x55, 0x30, 0x57, 0xA0, 0x7C, 0xA0, 0x12, 0xA0, 0x15, 0xF0, 0x1D, 0x00, 0x62, 0xC0, 0x04, 0x30, 0x00, 0x00 }; /*8712*/
const unsigned char  uc2_8713 [] = {0x13, 0x90, 0x10, 0xE0, 0x7C, 0xA0, 0x55, 0x20, 0x57, 0xF0, 0x7C, 0xA0, 0x12, 0xA0, 0x15, 0x20, 0x1D, 0x70, 0x62, 0x80, 0x04, 0x70, 0x00, 0x00 }; /*8713*/
const unsigned char  uc2_8715 [] = {0x11, 0x10, 0x10, 0xA0, 0x7D, 0xF0, 0x55, 0x10, 0x55, 0x10, 0x7D, 0xF0, 0x10, 0xA0, 0x14, 0xA0, 0x1A, 0xA0, 0x60, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*8715*/
const unsigned char  uc2_8717 [] = {0x13, 0xE0, 0x12, 0x20, 0x7A, 0x20, 0x57, 0xE0, 0x54, 0x80, 0x7F, 0xF0, 0x14, 0x90, 0x15, 0x50, 0x1E, 0x30, 0x64, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*8717*/
const unsigned char  uc2_8718 [] = {0x12, 0x70, 0x13, 0xD0, 0x7D, 0x50, 0x55, 0x50, 0x57, 0xD0, 0x7D, 0x50, 0x11, 0x50, 0x12, 0xD0, 0x1E, 0x70, 0x62, 0x50, 0x04, 0x00, 0x00, 0x00 }; /*8718*/
const unsigned char  uc2_871A [] = {0x08, 0x80, 0x78, 0xF0, 0x08, 0x80, 0x38, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x03, 0xF0, 0x7C, 0x10, 0x00, 0x00 }; /*871A*/
const unsigned char  uc2_871C [] = {0x02, 0x00, 0x7F, 0xF0, 0x42, 0x90, 0x29, 0x20, 0x5E, 0x50, 0x64, 0x90, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*871C*/
const unsigned char  uc2_871E [] = {0x11, 0x20, 0x13, 0xF0, 0x7D, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x7D, 0xE0, 0x11, 0x20, 0x17, 0xF0, 0x1C, 0xA0, 0x62, 0x90, 0x01, 0x10, 0x00, 0x00 }; /*871E*/
const unsigned char  uc2_8721 [] = {0x11, 0x40, 0x13, 0xE0, 0x7D, 0x40, 0x57, 0xF0, 0x54, 0x00, 0x7F, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x67, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8721*/
const unsigned char  uc2_8722 [] = {0x11, 0xE0, 0x10, 0x20, 0x7C, 0x40, 0x57, 0xF0, 0x54, 0x40, 0x7C, 0x40, 0x10, 0x80, 0x17, 0xF0, 0x1D, 0x50, 0x65, 0x50, 0x0F, 0xF0, 0x00, 0x00 }; /*8722*/
const unsigned char  uc2_8723 [] = {0x11, 0x40, 0x17, 0xF0, 0x7C, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x14, 0xC0, 0x1D, 0x50, 0x65, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*8723*/
const unsigned char  uc2_8725 [] = {0x11, 0x10, 0x11, 0x60, 0x7F, 0xC0, 0x55, 0x40, 0x55, 0xF0, 0x7F, 0x50, 0x11, 0x50, 0x15, 0x50, 0x1D, 0x50, 0x63, 0x50, 0x01, 0x90, 0x00, 0x00 }; /*8725*/
const unsigned char  uc2_8729 [] = {0x17, 0xF0, 0x14, 0x90, 0x7D, 0xD0, 0x54, 0x90, 0x57, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x1D, 0xD0, 0x64, 0x10, 0x08, 0xE0, 0x00, 0x00 }; /*8729*/
const unsigned char  uc2_872E [] = {0x10, 0x60, 0x10, 0x50, 0x7F, 0xF0, 0x54, 0x40, 0x57, 0x40, 0x7D, 0x50, 0x13, 0x50, 0x14, 0xE0, 0x1F, 0x50, 0x64, 0xD0, 0x03, 0x20, 0x00, 0x00 }; /*872E*/
const unsigned char  uc2_8731 [] = {0x10, 0x40, 0x11, 0xF0, 0x7D, 0x50, 0x55, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x10, 0x80, 0x15, 0x40, 0x1F, 0xF0, 0x62, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*8731*/
const unsigned char  uc2_8734 [] = {0x11, 0xE0, 0x11, 0x20, 0x7D, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x7C, 0x80, 0x11, 0xF0, 0x16, 0xB0, 0x1D, 0x50, 0x62, 0x90, 0x01, 0x60, 0x00, 0x00 }; /*8734*/
const unsigned char  uc2_8737 [] = {0x14, 0x90, 0x12, 0xA0, 0x7F, 0xE0, 0x54, 0x80, 0x57, 0xF0, 0x7D, 0x40, 0x13, 0xF0, 0x15, 0x40, 0x1D, 0x90, 0x63, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*8737*/
const unsigned char  uc2_873B [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x7F, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x1E, 0x20, 0x73, 0xA0, 0x02, 0x60, 0x00, 0x00 }; /*873B*/
const unsigned char  uc2_873E [] = {0x11, 0xF0, 0x11, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x7C, 0x40, 0x13, 0xF0, 0x15, 0x40, 0x1D, 0x60, 0x66, 0x50, 0x00, 0x40, 0x00, 0x00 }; /*873E*/
const unsigned char  uc2_873F [] = {0x10, 0x40, 0x13, 0xF0, 0x7E, 0x10, 0x55, 0x00, 0x55, 0xF0, 0x7D, 0x50, 0x11, 0xD0, 0x16, 0x60, 0x1A, 0xD0, 0x61, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*873F*/
const unsigned char  uc2_8747 [] = {0x11, 0xC0, 0x11, 0x40, 0x7D, 0xC0, 0x54, 0x80, 0x55, 0xE0, 0x7E, 0xA0, 0x13, 0xE0, 0x16, 0xA0, 0x1B, 0xE0, 0x62, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*8747*/
const unsigned char  uc2_8748 [] = {0x11, 0xF0, 0x11, 0x10, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x7D, 0x70, 0x11, 0x50, 0x15, 0xF0, 0x1D, 0x10, 0x63, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*8748*/
const unsigned char  uc2_8749 [] = {0x10, 0xA0, 0x10, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x7D, 0x50, 0x11, 0xF0, 0x14, 0x40, 0x1D, 0xF0, 0x62, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*8749*/
const unsigned char  uc2_874C [] = {0x11, 0x20, 0x16, 0x20, 0x7A, 0xA0, 0x52, 0x60, 0x57, 0xA0, 0x7A, 0x60, 0x17, 0x30, 0x12, 0xE0, 0x1A, 0x20, 0x66, 0x20, 0x02, 0x20, 0x00, 0x00 }; /*874C*/
const unsigned char  uc2_874E [] = {0x11, 0xE0, 0x11, 0x20, 0x7D, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x7C, 0x80, 0x11, 0xF0, 0x1B, 0x50, 0x15, 0xB0, 0x79, 0xD0, 0x00, 0x30, 0x00, 0x00 }; /*874E*/
const unsigned char  uc2_8753 [] = {0x10, 0x80, 0x11, 0x40, 0x7E, 0x30, 0x55, 0xC0, 0x56, 0x10, 0x7D, 0x50, 0x17, 0x50, 0x15, 0x50, 0x1F, 0x50, 0x65, 0x10, 0x02, 0x60, 0x00, 0x00 }; /*8753*/
const unsigned char  uc2_8757 [] = {0x10, 0x40, 0x11, 0xF0, 0x7D, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x7C, 0xE0, 0x11, 0xF0, 0x14, 0x40, 0x1C, 0xE0, 0x64, 0x40, 0x05, 0xF0, 0x00, 0x00 }; /*8757*/
const unsigned char  uc2_8759 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x57, 0xF0, 0x54, 0x00, 0x7F, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x1F, 0xF0, 0x75, 0x50, 0x09, 0x20, 0x00, 0x00 }; /*8759*/
const unsigned char  uc2_8760 [] = {0x11, 0xF0, 0x10, 0x00, 0x7C, 0xE0, 0x54, 0xA0, 0x54, 0xE0, 0x7C, 0x00, 0x11, 0xF0, 0x15, 0x50, 0x1D, 0xF0, 0x63, 0x50, 0x01, 0xF0, 0x00, 0x00 }; /*8760*/
const unsigned char  uc2_8763 [] = {0x16, 0x40, 0x11, 0x40, 0x7F, 0x70, 0x52, 0x80, 0x56, 0x70, 0x7B, 0x90, 0x12, 0xA0, 0x12, 0xF0, 0x1A, 0xA0, 0x64, 0xA0, 0x09, 0x40, 0x00, 0x00 }; /*8763*/
const unsigned char  uc2_8764 [] = {0x12, 0x20, 0x17, 0xF0, 0x79, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x7E, 0x30, 0x14, 0x10, 0x17, 0xF0, 0x1C, 0x10, 0x67, 0xF0, 0x04, 0x10, 0x00, 0x00 }; /*8764*/
const unsigned char  uc2_8765 [] = {0x3C, 0x80, 0x14, 0xF0, 0x7F, 0xA0, 0x2A, 0x40, 0x29, 0xB0, 0x52, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*8765*/
const unsigned char  uc2_876E [] = {0x11, 0x00, 0x11, 0xF0, 0x7E, 0x00, 0x55, 0xE0, 0x55, 0x20, 0x7D, 0xE0, 0x11, 0x20, 0x15, 0xE0, 0x1F, 0x20, 0x64, 0xC0, 0x03, 0x30, 0x00, 0x00 }; /*876E*/
const unsigned char  uc2_8770 [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x56, 0xA0, 0x55, 0xD0, 0x78, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x1F, 0xE0, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*8770*/
const unsigned char  uc2_8774 [] = {0x12, 0x70, 0x12, 0x50, 0x7A, 0x50, 0x57, 0xF0, 0x52, 0x50, 0x7F, 0x50, 0x15, 0x70, 0x15, 0x50, 0x1F, 0x50, 0x64, 0x50, 0x00, 0xA0, 0x00, 0x00 }; /*8774*/
const unsigned char  uc2_8776 [] = {0x12, 0xA0, 0x17, 0xF0, 0x7A, 0xA0, 0x56, 0xE0, 0x56, 0x00, 0x7B, 0xF0, 0x10, 0x80, 0x17, 0xF0, 0x19, 0xC0, 0x72, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*8776*/
const unsigned char  uc2_877B [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x00, 0x57, 0xF0, 0x55, 0x50, 0x7C, 0x90, 0x15, 0xD0, 0x14, 0x90, 0x1F, 0xF0, 0x64, 0x90, 0x04, 0x20, 0x00, 0x00 }; /*877B*/
const unsigned char  uc2_877C [] = {0x11, 0x50, 0x10, 0x40, 0x7D, 0xF0, 0x54, 0x40, 0x54, 0xE0, 0x7D, 0x50, 0x10, 0x80, 0x15, 0xF0, 0x1E, 0xA0, 0x62, 0x40, 0x01, 0xB0, 0x00, 0x00 }; /*877C*/
const unsigned char  uc2_877D [] = {0x10, 0x40, 0x13, 0xF0, 0x7C, 0x40, 0x55, 0xE0, 0x54, 0x80, 0x7F, 0xF0, 0x11, 0x20, 0x17, 0xF0, 0x1D, 0x20, 0x65, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*877D*/
const unsigned char  uc2_877E [] = {0x11, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x7C, 0x00, 0x57, 0xF0, 0x54, 0x10, 0x7C, 0x80, 0x17, 0xF0, 0x19, 0xC0, 0x16, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*877E*/
const unsigned char  uc2_8782 [] = {0x12, 0x00, 0x17, 0x70, 0x7D, 0x50, 0x57, 0x50, 0x55, 0x60, 0x7F, 0x50, 0x14, 0x50, 0x15, 0x60, 0x1F, 0x40, 0x64, 0xC0, 0x00, 0x40, 0x00, 0x00 }; /*8782*/
const unsigned char  uc2_8783 [] = {0x10, 0x80, 0x13, 0xF0, 0x7E, 0x20, 0x55, 0x40, 0x57, 0xF0, 0x7C, 0x90, 0x13, 0xE0, 0x15, 0x00, 0x1D, 0xE0, 0x62, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*8783*/
const unsigned char  uc2_8785 [] = {0x10, 0x80, 0x11, 0xE0, 0x7D, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x7D, 0xE0, 0x11, 0x20, 0x15, 0xE0, 0x1E, 0x90, 0x63, 0x20, 0x05, 0xE0, 0x00, 0x00 }; /*8785*/
const unsigned char  uc2_8788 [] = {0x17, 0xF0, 0x14, 0x40, 0x7D, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x7D, 0x10, 0x15, 0xF0, 0x14, 0x40, 0x1D, 0x60, 0x66, 0x50, 0x09, 0x90, 0x00, 0x00 }; /*8788*/
const unsigned char  uc2_878B [] = {0x11, 0x80, 0x16, 0xB0, 0x7C, 0x90, 0x56, 0xB0, 0x54, 0x90, 0x7F, 0xF0, 0x10, 0x80, 0x17, 0xE0, 0x1D, 0x20, 0x60, 0xC0, 0x07, 0x70, 0x00, 0x00 }; /*878B*/
const unsigned char  uc2_878D [] = {0x7C, 0x80, 0x00, 0x80, 0x38, 0x80, 0x2B, 0xE0, 0x2A, 0xA0, 0x7A, 0xA0, 0x6F, 0xE0, 0x54, 0x80, 0x7C, 0xA0, 0x54, 0xD0, 0x5B, 0x10, 0x00, 0x00 }; /*878D*/
const unsigned char  uc2_8793 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x57, 0xE0, 0x55, 0x00, 0x7F, 0xF0, 0x12, 0x60, 0x14, 0x90, 0x1B, 0xF0, 0x62, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*8793*/
const unsigned char  uc2_8797 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x80, 0x57, 0xE0, 0x54, 0xA0, 0x7F, 0xF0, 0x14, 0xA0, 0x17, 0xE0, 0x1A, 0x20, 0x6B, 0xE0, 0x0A, 0x20, 0x00, 0x00 }; /*8797*/
const unsigned char  uc2_879F [] = {0x13, 0xF0, 0x12, 0x10, 0x7D, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x7D, 0x20, 0x11, 0xE0, 0x14, 0x80, 0x1F, 0xF0, 0x61, 0x20, 0x06, 0x10, 0x00, 0x00 }; /*879F*/
const unsigned char  uc2_87A8 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x57, 0xF0, 0x55, 0x40, 0x7F, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x1E, 0xB0, 0x64, 0x10, 0x04, 0x20, 0x00, 0x00 }; /*87A8*/
const unsigned char  uc2_87AB [] = {0x08, 0x40, 0x3E, 0x70, 0x09, 0xA0, 0x7E, 0xA0, 0x15, 0x40, 0x54, 0xB0, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*87AB*/
const unsigned char  uc2_87AC [] = {0x11, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x7F, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x7D, 0x50, 0x17, 0xF0, 0x1E, 0x20, 0x63, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*87AC*/
const unsigned char  uc2_87AD [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x54, 0x90, 0x55, 0x50, 0x7F, 0xF0, 0x14, 0x90, 0x15, 0x50, 0x1D, 0xB0, 0x64, 0x10, 0x04, 0x20, 0x00, 0x00 }; /*87AD*/
const unsigned char  uc2_87AF [] = {0x08, 0x80, 0x3E, 0xF0, 0x09, 0xA0, 0x7E, 0x40, 0x15, 0xB0, 0x6C, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x20, 0x3F, 0xD0, 0x00, 0x00 }; /*87AF*/
const unsigned char  uc2_87B3 [] = {0x14, 0x90, 0x12, 0xA0, 0x7F, 0xF0, 0x54, 0x10, 0x55, 0xD0, 0x7D, 0x40, 0x11, 0xC0, 0x14, 0x80, 0x1F, 0xE0, 0x60, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*87B3*/
const unsigned char  uc2_87B5 [] = {0x17, 0xF0, 0x11, 0x40, 0x7F, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x7C, 0x00, 0x13, 0xE0, 0x14, 0x00, 0x1F, 0xF0, 0x64, 0xA0, 0x0B, 0x10, 0x00, 0x00 }; /*87B5*/
const unsigned char  uc2_87BA [] = {0x11, 0xF0, 0x11, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x7C, 0xA0, 0x11, 0x40, 0x14, 0x90, 0x1F, 0xE0, 0x65, 0x50, 0x02, 0xD0, 0x00, 0x00 }; /*87BA*/
const unsigned char  uc2_87BD [] = {0x0F, 0x80, 0x38, 0x80, 0x07, 0x00, 0x7A, 0xF0, 0x05, 0x00, 0x12, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x14, 0x50, 0x7B, 0xF0, 0x00, 0x00 }; /*87BD*/
const unsigned char  uc2_87C0 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x80, 0x57, 0x50, 0x55, 0xA0, 0x7C, 0xA0, 0x13, 0x50, 0x14, 0x80, 0x1F, 0xF0, 0x64, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*87C0*/
const unsigned char  uc2_87C6 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x57, 0xE0, 0x56, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x1C, 0x80, 0x61, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*87C6*/
const unsigned char  uc2_87CA [] = {0x0F, 0x80, 0x02, 0x80, 0x3F, 0xE0, 0x05, 0x20, 0x79, 0x00, 0x16, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x14, 0x50, 0x7B, 0xF0, 0x00, 0x00 }; /*87CA*/
const unsigned char  uc2_87CB [] = {0x10, 0x60, 0x13, 0x80, 0x7E, 0xA0, 0x55, 0x40, 0x57, 0xF0, 0x7A, 0xA0, 0x14, 0x90, 0x11, 0x00, 0x1A, 0xA0, 0x66, 0x50, 0x09, 0xD0, 0x00, 0x00 }; /*87CB*/
const unsigned char  uc2_87D1 [] = {0x10, 0x80, 0x13, 0xE0, 0x79, 0x40, 0x57, 0xF0, 0x56, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x18, 0x80, 0x67, 0xF0, 0x00, 0x80, 0x00, 0x00 }; /*87D1*/
const unsigned char  uc2_87D2 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x54, 0xA0, 0x57, 0xF0, 0x79, 0x40, 0x16, 0x30, 0x11, 0x40, 0x1F, 0xF0, 0x62, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*87D2*/
const unsigned char  uc2_87D3 [] = {0x10, 0xE0, 0x13, 0x20, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x7D, 0x80, 0x12, 0xD0, 0x15, 0x60, 0x1E, 0xD0, 0x65, 0x50, 0x06, 0xD0, 0x00, 0x00 }; /*87D3*/
const unsigned char  uc2_87DB [] = {0x11, 0x10, 0x17, 0xD0, 0x79, 0x10, 0x57, 0xA0, 0x54, 0x10, 0x7B, 0x90, 0x12, 0xA0, 0x13, 0xD0, 0x1E, 0x90, 0x61, 0x10, 0x07, 0xA0, 0x00, 0x00 }; /*87DB*/
const unsigned char  uc2_87E0 [] = {0x11, 0xF0, 0x11, 0x50, 0x7C, 0xA0, 0x57, 0xF0, 0x54, 0xA0, 0x7D, 0x50, 0x11, 0xF0, 0x15, 0x50, 0x1B, 0xF0, 0x61, 0x50, 0x01, 0xF0, 0x00, 0x00 }; /*87E0*/
const unsigned char  uc2_87E5 [] = {0x11, 0x40, 0x13, 0xE0, 0x79, 0x40, 0x57, 0xF0, 0x56, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x17, 0xE0, 0x1A, 0x00, 0x61, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*87E5*/
const unsigned char  uc2_87EA [] = {0x10, 0x80, 0x17, 0xF0, 0x7A, 0xA0, 0x57, 0xE0, 0x56, 0xA0, 0x7B, 0xE0, 0x10, 0xA0, 0x17, 0xF0, 0x1A, 0xA0, 0x66, 0x50, 0x09, 0x90, 0x00, 0x00 }; /*87EA*/
const unsigned char  uc2_87EE [] = {0x11, 0x40, 0x17, 0xF0, 0x78, 0x80, 0x57, 0xE0, 0x54, 0x80, 0x7F, 0xF0, 0x12, 0xA0, 0x17, 0xF0, 0x1A, 0x20, 0x63, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*87EE*/
const unsigned char  uc2_87F9 [] = {0x1D, 0xF0, 0x24, 0x50, 0x7E, 0xA0, 0x2A, 0xF0, 0x3F, 0x20, 0x2A, 0xF0, 0x3F, 0xA0, 0x4A, 0xA0, 0x0F, 0x80, 0x02, 0x20, 0x7F, 0xD0, 0x00, 0x00 }; /*87F9*/
const unsigned char  uc2_87FE [] = {0x11, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x55, 0x20, 0x56, 0x90, 0x7D, 0xE0, 0x15, 0x40, 0x14, 0xA0, 0x1D, 0xE0, 0x65, 0x20, 0x09, 0xE0, 0x00, 0x00 }; /*87FE*/
const unsigned char  uc2_8803 [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x00, 0x0F, 0xE0, 0x08, 0x40, 0x3F, 0xE0, 0x2A, 0xA0, 0x3F, 0xE0, 0x2A, 0xA0, 0x3E, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*8803*/
const unsigned char  uc2_880A [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x20, 0x57, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x15, 0x50, 0x1F, 0xF0, 0x15, 0x40, 0x67, 0x60, 0x09, 0x50, 0x00, 0x00 }; /*880A*/
const unsigned char  uc2_8813 [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x57, 0xF0, 0x54, 0x90, 0x7B, 0xE0, 0x11, 0x40, 0x16, 0xD0, 0x1D, 0x60, 0x61, 0x50, 0x06, 0x80, 0x00, 0x00 }; /*8813*/
const unsigned char  uc2_8815 [] = {0x13, 0xE0, 0x10, 0x80, 0x7F, 0xF0, 0x54, 0x90, 0x56, 0xA0, 0x7F, 0xF0, 0x10, 0x80, 0x17, 0xF0, 0x1D, 0x50, 0x65, 0x50, 0x04, 0x30, 0x00, 0x00 }; /*8815*/
const unsigned char  uc2_8816 [] = {0x11, 0x40, 0x17, 0xF0, 0x7D, 0x40, 0x57, 0xF0, 0x54, 0x80, 0x7F, 0xF0, 0x14, 0x80, 0x17, 0xF0, 0x1A, 0x20, 0x61, 0xC0, 0x06, 0x30, 0x00, 0x00 }; /*8816*/
const unsigned char  uc2_881B [] = {0x11, 0x40, 0x17, 0xF0, 0x79, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x10, 0xA0, 0x17, 0xF0, 0x1C, 0xA0, 0x66, 0xD0, 0x09, 0x30, 0x00, 0x00 }; /*881B*/
const unsigned char  uc2_8821 [] = {0x07, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x16, 0x20, 0x2B, 0x40, 0x15, 0x20, 0x7F, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x14, 0x50, 0x79, 0xE0, 0x00, 0x00 }; /*8821*/
const unsigned char  uc2_8822 [] = {0x02, 0x00, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x28, 0xA0, 0x4F, 0x90, 0x78, 0xF0, 0x57, 0x50, 0x7D, 0xF0, 0x14, 0x50, 0x79, 0xE0, 0x00, 0x00 }; /*8822*/
const unsigned char  uc2_8832 [] = {0x45, 0xF0, 0x29, 0x50, 0x7D, 0xF0, 0x29, 0x00, 0x45, 0xF0, 0x02, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x5E, 0x50, 0x61, 0xE0, 0x00, 0x00 }; /*8832*/
const unsigned char  uc2_8839 [] = {0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x7F, 0xF0, 0x48, 0x50, 0x17, 0xC0, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x14, 0x50, 0x79, 0xE0, 0x00, 0x00 }; /*8839*/
const unsigned char  uc2_883C [] = {0x17, 0x70, 0x15, 0x50, 0x7D, 0x50, 0x57, 0xF0, 0x56, 0x40, 0x7B, 0xE0, 0x12, 0x40, 0x13, 0xF0, 0x19, 0x20, 0x74, 0xC0, 0x03, 0x30, 0x00, 0x00 }; /*883C*/
const unsigned char  uc2_8840 [] = {0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x25, 0x20, 0x7F, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*8840*/
const unsigned char  uc2_8844 [] = {0x08, 0x00, 0x11, 0xF0, 0x3E, 0x50, 0x2A, 0x50, 0x2A, 0x50, 0x2B, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2F, 0xA0, 0x70, 0xA0, 0x01, 0xF0, 0x00, 0x00 }; /*8844*/
const unsigned char  uc2_8845 [] = {0x08, 0x40, 0x11, 0x50, 0x7E, 0xE0, 0x55, 0x40, 0x55, 0xF0, 0x55, 0x40, 0x55, 0x40, 0x57, 0xF0, 0x58, 0x40, 0x60, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*8845*/
const unsigned char  uc2_884C [] = {0x08, 0x00, 0x13, 0xE0, 0x60, 0x00, 0x08, 0x00, 0x17, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*884C*/
const unsigned char  uc2_884D [] = {0x08, 0x00, 0x16, 0xE0, 0x60, 0x00, 0x08, 0x00, 0x15, 0xF0, 0x72, 0x40, 0x12, 0x40, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x15, 0x80, 0x00, 0x00 }; /*884D*/
const unsigned char  uc2_8854 [] = {0x12, 0x00, 0x12, 0x70, 0x63, 0x80, 0x14, 0x00, 0x1F, 0xF0, 0x62, 0x20, 0x2F, 0xA0, 0x22, 0x20, 0x22, 0xA0, 0x23, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*8854*/
const unsigned char  uc2_8857 [] = {0x12, 0x00, 0x12, 0x70, 0x67, 0x00, 0x12, 0x00, 0x6F, 0xF0, 0x22, 0x20, 0x27, 0x20, 0x22, 0x20, 0x23, 0xA0, 0x2C, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*8857*/
const unsigned char  uc2_8859 [] = {0x10, 0x00, 0x17, 0xB0, 0x62, 0x00, 0x17, 0x00, 0x15, 0x70, 0x6F, 0xA0, 0x20, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x25, 0x60, 0x00, 0x00 }; /*8859*/
const unsigned char  uc2_8861 [] = {0x17, 0x00, 0x19, 0x70, 0x6F, 0x80, 0x0A, 0x80, 0x1F, 0xF0, 0x6A, 0xA0, 0x2F, 0xA0, 0x22, 0x20, 0x2F, 0xA0, 0x25, 0x20, 0x38, 0xC0, 0x00, 0x00 }; /*8861*/
const unsigned char  uc2_8862 [] = {0x2D, 0x80, 0x4A, 0xB0, 0x0F, 0x80, 0x2A, 0x80, 0x6F, 0xF0, 0x3A, 0x20, 0x2F, 0xA0, 0x2A, 0x20, 0x2F, 0xA0, 0x2A, 0x20, 0x2F, 0xE0, 0x00, 0x00 }; /*8862*/
const unsigned char  uc2_8863 [] = {0x02, 0x00, 0x3F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x09, 0x20, 0x19, 0x20, 0x68, 0xC0, 0x08, 0x80, 0x08, 0x40, 0x0F, 0x30, 0x08, 0x00, 0x00, 0x00 }; /*8863*/
const unsigned char  uc2_8865 [] = {0x10, 0x80, 0x08, 0x80, 0x3C, 0x80, 0x04, 0xC0, 0x0A, 0xA0, 0x1C, 0x90, 0x6A, 0x90, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*8865*/
const unsigned char  uc2_8868 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xA0, 0x6A, 0xC0, 0x0C, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*8868*/
const unsigned char  uc2_8869 [] = {0x20, 0x00, 0x17, 0xE0, 0x7A, 0xA0, 0x0A, 0xA0, 0x15, 0x40, 0x39, 0x40, 0x54, 0x80, 0x10, 0x80, 0x11, 0x40, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*8869*/
const unsigned char  uc2_886B [] = {0x20, 0x40, 0x10, 0x40, 0x78, 0x80, 0x0B, 0x20, 0x14, 0x20, 0x38, 0x40, 0x50, 0x90, 0x13, 0x10, 0x10, 0x20, 0x10, 0xC0, 0x13, 0x00, 0x00, 0x00 }; /*886B*/
const unsigned char  uc2_886C [] = {0x10, 0x20, 0x08, 0x20, 0x3D, 0xF0, 0x04, 0x20, 0x0A, 0x20, 0x1D, 0x20, 0x6A, 0xA0, 0x08, 0xA0, 0x08, 0x20, 0x08, 0x20, 0x09, 0xC0, 0x00, 0x00 }; /*886C*/
const unsigned char  uc2_886E [] = {0x01, 0x00, 0x7F, 0xF0, 0x08, 0x40, 0x12, 0x20, 0x64, 0x90, 0x0F, 0x50, 0x00, 0x40, 0x05, 0x10, 0x78, 0xA0, 0x13, 0x40, 0x1C, 0x30, 0x00, 0x00 }; /*886E*/
const unsigned char  uc2_8870 [] = {0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xD0, 0x05, 0x20, 0x78, 0xC0, 0x0E, 0x30, 0x00, 0x00 }; /*8870*/
const unsigned char  uc2_8872 [] = {0x10, 0x40, 0x08, 0x40, 0x3D, 0xF0, 0x05, 0x50, 0x0B, 0x50, 0x1D, 0x50, 0x6B, 0xB0, 0x09, 0x10, 0x09, 0x10, 0x09, 0x10, 0x09, 0x60, 0x00, 0x00 }; /*8872*/
const unsigned char  uc2_8877 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x0D, 0x20, 0x70, 0xC0, 0x16, 0x40, 0x18, 0x30, 0x00, 0x00 }; /*8877*/
const unsigned char  uc2_887D [] = {0x20, 0x60, 0x13, 0x80, 0x78, 0x80, 0x08, 0x80, 0x14, 0x80, 0x3B, 0xF0, 0x54, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*887D*/
const unsigned char  uc2_887E [] = {0x02, 0x00, 0x0D, 0x80, 0x72, 0x70, 0x0F, 0x80, 0x00, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xA0, 0x6A, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*887E*/
const unsigned char  uc2_887F [] = {0x20, 0x80, 0x10, 0x80, 0x79, 0x40, 0x0A, 0x20, 0x15, 0x90, 0x38, 0x40, 0x55, 0xE0, 0x10, 0x20, 0x10, 0x20, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*887F*/
const unsigned char  uc2_8881 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x05, 0x20, 0x09, 0x20, 0x18, 0xC0, 0x6E, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*8881*/
const unsigned char  uc2_8882 [] = {0x20, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x08, 0xA0, 0x14, 0xA0, 0x3B, 0xF0, 0x54, 0x80, 0x11, 0x40, 0x11, 0x40, 0x12, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*8882*/
const unsigned char  uc2_8884 [] = {0x20, 0x60, 0x13, 0x80, 0x78, 0x80, 0x08, 0x80, 0x17, 0xF0, 0x38, 0x80, 0x54, 0x80, 0x11, 0x40, 0x11, 0x40, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*8884*/
const unsigned char  uc2_8885 [] = {0x02, 0x00, 0x1F, 0x80, 0x14, 0x80, 0x12, 0x80, 0x1F, 0xE0, 0x02, 0x20, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xA0, 0x6E, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*8885*/
const unsigned char  uc2_8888 [] = {0x08, 0x00, 0x3E, 0xF0, 0x0A, 0x90, 0x12, 0xF0, 0x64, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xA0, 0x6B, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*8888*/
const unsigned char  uc2_888B [] = {0x0A, 0xC0, 0x0A, 0x30, 0x71, 0xC0, 0x17, 0x00, 0x10, 0x90, 0x12, 0x50, 0x7F, 0xF0, 0x05, 0x20, 0x19, 0x40, 0x6E, 0x80, 0x08, 0x70, 0x00, 0x00 }; /*888B*/
const unsigned char  uc2_888D [] = {0x21, 0x00, 0x11, 0xE0, 0x7A, 0x20, 0x0F, 0xA0, 0x12, 0xA0, 0x3A, 0xA0, 0x57, 0xA0, 0x12, 0x20, 0x12, 0xD0, 0x12, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*888D*/
const unsigned char  uc2_8892 [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0A, 0x20, 0x17, 0xE0, 0x3A, 0x20, 0x56, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*8892*/
const unsigned char  uc2_8896 [] = {0x10, 0x40, 0x08, 0x40, 0x3C, 0x40, 0x05, 0xF0, 0x0B, 0x50, 0x1D, 0x50, 0x6B, 0xF0, 0x09, 0x50, 0x09, 0x50, 0x09, 0xF0, 0x09, 0x10, 0x00, 0x00 }; /*8896*/
const unsigned char  uc2_889C [] = {0x30, 0x80, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x14, 0x80, 0x3B, 0xE0, 0x54, 0x80, 0x11, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x00, 0x00 }; /*889C*/
const unsigned char  uc2_88A2 [] = {0x20, 0x80, 0x14, 0x90, 0x7A, 0x90, 0x0A, 0xA0, 0x17, 0xE0, 0x38, 0x80, 0x54, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*88A2*/
const unsigned char  uc2_88A4 [] = {0x02, 0x00, 0x7F, 0xF0, 0x04, 0x80, 0x03, 0x00, 0x3F, 0xE0, 0x05, 0x20, 0x7B, 0x40, 0x05, 0x00, 0x18, 0xA0, 0x6B, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*88A4*/
const unsigned char  uc2_88AB [] = {0x30, 0x40, 0x08, 0x40, 0x7B, 0xF0, 0x0A, 0x50, 0x16, 0x40, 0x3B, 0xE0, 0x56, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x12, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*88AB*/
const unsigned char  uc2_88AD [] = {0x04, 0x40, 0x7F, 0xF0, 0x09, 0x40, 0x11, 0x90, 0x66, 0xE0, 0x01, 0x00, 0x7F, 0xF0, 0x05, 0x20, 0x18, 0xA0, 0x6E, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*88AD*/
const unsigned char  uc2_88B1 [] = {0x21, 0x40, 0x11, 0x60, 0x7A, 0x50, 0x0B, 0xF0, 0x16, 0x40, 0x3A, 0x40, 0x56, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*88B1*/
const unsigned char  uc2_88B4 [] = {0x20, 0x80, 0x17, 0xF0, 0x79, 0x40, 0x0A, 0x30, 0x15, 0xC0, 0x38, 0x00, 0x57, 0xF0, 0x11, 0x00, 0x13, 0xE0, 0x10, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*88B4*/
const unsigned char  uc2_88B7 [] = {0x20, 0x80, 0x10, 0x80, 0x79, 0x40, 0x0E, 0x30, 0x11, 0xC0, 0x34, 0x00, 0x5B, 0xE0, 0x16, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*88B7*/
const unsigned char  uc2_88BC [] = {0x21, 0x00, 0x11, 0xE0, 0x7A, 0x20, 0x0D, 0x40, 0x14, 0x80, 0x39, 0x40, 0x56, 0x30, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*88BC*/
const unsigned char  uc2_88C1 [] = {0x08, 0x80, 0x3E, 0xC0, 0x08, 0xA0, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0xA0, 0x08, 0xA0, 0x15, 0x40, 0x72, 0x50, 0x1A, 0xD0, 0x11, 0x20, 0x00, 0x00 }; /*88C1*/
const unsigned char  uc2_88C2 [] = {0x3F, 0x50, 0x08, 0x50, 0x0E, 0x50, 0x32, 0x10, 0x0C, 0x60, 0x12, 0x00, 0x7F, 0xF0, 0x04, 0x80, 0x18, 0xA0, 0x6E, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*88C2*/
const unsigned char  uc2_88C5 [] = {0x08, 0x80, 0x6B, 0xF0, 0x18, 0x80, 0x18, 0x80, 0x6B, 0xE0, 0x0A, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x19, 0x20, 0x6C, 0xC0, 0x08, 0x30, 0x00, 0x00 }; /*88C5*/
const unsigned char  uc2_88C6 [] = {0x20, 0x80, 0x14, 0x90, 0x7A, 0x90, 0x0A, 0xA0, 0x10, 0x80, 0x3F, 0xF0, 0x50, 0x10, 0x1B, 0xF0, 0x10, 0x10, 0x17, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*88C6*/
const unsigned char  uc2_88C9 [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0B, 0xE0, 0x16, 0x20, 0x3B, 0xE0, 0x56, 0x90, 0x12, 0xA0, 0x12, 0x40, 0x13, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*88C9*/
const unsigned char  uc2_88CE [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0A, 0x20, 0x17, 0xE0, 0x38, 0x00, 0x57, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*88CE*/
const unsigned char  uc2_88D2 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x10, 0x40, 0x1D, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x05, 0x20, 0x19, 0x40, 0x6E, 0x80, 0x08, 0x70, 0x00, 0x00 }; /*88D2*/
const unsigned char  uc2_88D4 [] = {0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xA0, 0x6E, 0x40, 0x08, 0x30, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x25, 0x20, 0x27, 0x40, 0x00, 0x00 }; /*88D4*/
const unsigned char  uc2_88D5 [] = {0x21, 0x40, 0x11, 0x20, 0x7A, 0xA0, 0x08, 0xC0, 0x15, 0x20, 0x3A, 0x10, 0x55, 0xE0, 0x15, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*88D5*/
const unsigned char  uc2_88D8 [] = {0x02, 0x40, 0x7F, 0xF0, 0x02, 0x20, 0x32, 0xC0, 0x0A, 0x20, 0x70, 0x10, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0xA0, 0x78, 0x40, 0x0E, 0x30, 0x00, 0x00 }; /*88D8*/
const unsigned char  uc2_88D9 [] = {0x20, 0x00, 0x13, 0xE0, 0x79, 0x20, 0x0F, 0xF0, 0x11, 0x20, 0x3B, 0xE0, 0x51, 0x00, 0x1B, 0xE0, 0x16, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*88D9*/
const unsigned char  uc2_88DF [] = {0x30, 0x80, 0x0A, 0xA0, 0x32, 0x90, 0x0C, 0x50, 0x31, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x18, 0xA0, 0x6A, 0x40, 0x0C, 0x30, 0x00, 0x00 }; /*88DF*/
const unsigned char  uc2_88E2 [] = {0x44, 0x20, 0x22, 0x20, 0x72, 0xF0, 0x10, 0x40, 0x2E, 0xA0, 0x72, 0xF0, 0x2A, 0x20, 0x22, 0xF0, 0x22, 0x20, 0x25, 0x20, 0x28, 0xF0, 0x00, 0x00 }; /*88E2*/
const unsigned char  uc2_88E3 [] = {0x20, 0x80, 0x10, 0x80, 0x79, 0x40, 0x0A, 0x20, 0x14, 0x10, 0x3B, 0xE0, 0x55, 0x20, 0x14, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x17, 0xF0, 0x00, 0x00 }; /*88E3*/
const unsigned char  uc2_88E4 [] = {0x20, 0x40, 0x13, 0xF0, 0x7A, 0x80, 0x0B, 0xF0, 0x16, 0x80, 0x3B, 0x40, 0x57, 0xE0, 0x12, 0x40, 0x13, 0xF0, 0x12, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*88E4*/
const unsigned char  uc2_88E5 [] = {0x24, 0x00, 0x12, 0xF0, 0x7C, 0x10, 0x0D, 0xD0, 0x15, 0x50, 0x3D, 0xD0, 0x55, 0x50, 0x1D, 0xD0, 0x15, 0x50, 0x14, 0x10, 0x14, 0xE0, 0x00, 0x00 }; /*88E5*/
const unsigned char  uc2_88E8 [] = {0x21, 0x00, 0x13, 0xE0, 0x7A, 0xA0, 0x0B, 0xE0, 0x16, 0xA0, 0x3B, 0xE0, 0x55, 0x00, 0x12, 0x40, 0x17, 0xF0, 0x10, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*88E8*/
const unsigned char  uc2_88F0 [] = {0x27, 0x70, 0x11, 0x10, 0x7D, 0x50, 0x0A, 0x20, 0x15, 0x50, 0x38, 0x00, 0x57, 0xF0, 0x11, 0x50, 0x15, 0x50, 0x12, 0x20, 0x15, 0x50, 0x00, 0x00 }; /*88F0*/
const unsigned char  uc2_88F1 [] = {0x20, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x0B, 0xE0, 0x14, 0x80, 0x3B, 0xF0, 0x55, 0x40, 0x12, 0x50, 0x1E, 0x20, 0x13, 0xA0, 0x12, 0x10, 0x00, 0x00 }; /*88F1*/
const unsigned char  uc2_88F3 [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x50, 0x50, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x05, 0x20, 0x19, 0x20, 0x6C, 0xC0, 0x08, 0x30, 0x00, 0x00 }; /*88F3*/
const unsigned char  uc2_88F4 [] = {0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x7F, 0xF0, 0x05, 0x20, 0x78, 0xC0, 0x0E, 0x30, 0x00, 0x00 }; /*88F4*/
const unsigned char  uc2_88F8 [] = {0x23, 0xE0, 0x12, 0xA0, 0x7B, 0xE0, 0x0A, 0xA0, 0x17, 0xE0, 0x38, 0x80, 0x57, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*88F8*/
const unsigned char  uc2_88F9 [] = {0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x60, 0x72, 0x10, 0x0D, 0x20, 0x78, 0xC0, 0x0C, 0x30, 0x00, 0x00 }; /*88F9*/
const unsigned char  uc2_88FC [] = {0x23, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x0A, 0x20, 0x17, 0xE0, 0x39, 0x00, 0x55, 0xF0, 0x12, 0xB0, 0x15, 0x50, 0x10, 0x90, 0x13, 0x60, 0x00, 0x00 }; /*88FC*/
const unsigned char  uc2_88FE [] = {0x20, 0x00, 0x13, 0xF0, 0x7A, 0x10, 0x0B, 0xF0, 0x16, 0x40, 0x3B, 0xF0, 0x56, 0x40, 0x12, 0xF0, 0x12, 0x90, 0x12, 0xF0, 0x14, 0x90, 0x00, 0x00 }; /*88FE*/
const unsigned char  uc2_8902 [] = {0x21, 0x40, 0x13, 0xC0, 0x79, 0x40, 0x09, 0x60, 0x17, 0xD0, 0x39, 0x50, 0x55, 0x50, 0x13, 0xC0, 0x11, 0x40, 0x11, 0xC0, 0x16, 0x40, 0x00, 0x00 }; /*8902*/
const unsigned char  uc2_890A [] = {0x20, 0x80, 0x17, 0xF0, 0x7C, 0x10, 0x0F, 0xF0, 0x14, 0x00, 0x3F, 0xF0, 0x55, 0x50, 0x1F, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x18, 0x20, 0x00, 0x00 }; /*890A*/
const unsigned char  uc2_8910 [] = {0x23, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x0A, 0x20, 0x17, 0xE0, 0x3A, 0x00, 0x53, 0xF0, 0x1E, 0x90, 0x15, 0x50, 0x17, 0xD0, 0x10, 0x60, 0x00, 0x00 }; /*8910*/
const unsigned char  uc2_8912 [] = {0x01, 0x00, 0x7F, 0xF0, 0x0A, 0x20, 0x13, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x06, 0x90, 0x19, 0x20, 0x68, 0xC0, 0x0C, 0x30, 0x00, 0x00 }; /*8912*/
const unsigned char  uc2_8913 [] = {0x21, 0xE0, 0x12, 0xA0, 0x7A, 0xA0, 0x0A, 0xE0, 0x16, 0x40, 0x3B, 0xF0, 0x56, 0x40, 0x12, 0xC0, 0x13, 0x60, 0x12, 0x50, 0x12, 0x40, 0x00, 0x00 }; /*8913*/
const unsigned char  uc2_8919 [] = {0x21, 0x50, 0x17, 0x60, 0x79, 0x50, 0x0A, 0x20, 0x17, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*8919*/
const unsigned char  uc2_891A [] = {0x20, 0x90, 0x11, 0xD0, 0x78, 0xA0, 0x0B, 0xF0, 0x14, 0x80, 0x39, 0xE0, 0x57, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*891A*/
const unsigned char  uc2_891B [] = {0x24, 0x90, 0x12, 0xA0, 0x7F, 0xF0, 0x0A, 0xA0, 0x14, 0x90, 0x39, 0x00, 0x57, 0xF0, 0x11, 0x20, 0x13, 0x40, 0x10, 0xE0, 0x17, 0x10, 0x00, 0x00 }; /*891B*/
const unsigned char  uc2_8921 [] = {0x22, 0x20, 0x17, 0xF0, 0x7A, 0xA0, 0x09, 0x40, 0x16, 0x30, 0x39, 0xC0, 0x54, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*8921*/
const unsigned char  uc2_8925 [] = {0x23, 0xF0, 0x12, 0x40, 0x7A, 0x80, 0x0B, 0xF0, 0x16, 0xA0, 0x3A, 0xD0, 0x56, 0x20, 0x13, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x60, 0x00, 0x00 }; /*8925*/
const unsigned char  uc2_892A [] = {0x49, 0xE0, 0x25, 0x20, 0x75, 0xE0, 0x11, 0x20, 0x2D, 0xF0, 0x75, 0x50, 0x2D, 0x20, 0x25, 0xD0, 0x25, 0x10, 0x2A, 0x00, 0x31, 0xF0, 0x00, 0x00 }; /*892A*/
const unsigned char  uc2_892B [] = {0x47, 0xF0, 0x24, 0xA0, 0x74, 0xC0, 0x15, 0xF0, 0x2D, 0x50, 0x75, 0x60, 0x2D, 0xC0, 0x25, 0x50, 0x2A, 0xE0, 0x2A, 0xA0, 0x35, 0x30, 0x00, 0x00 }; /*892B*/
const unsigned char  uc2_8930 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x22, 0x20, 0x5F, 0xD0, 0x0A, 0x40, 0x71, 0x80, 0x1C, 0x70, 0x00, 0x00 }; /*8930*/
const unsigned char  uc2_8934 [] = {0x41, 0x40, 0x25, 0x70, 0x75, 0x40, 0x15, 0xA0, 0x15, 0x10, 0x29, 0x10, 0x70, 0x00, 0x2F, 0xF0, 0x25, 0x50, 0x25, 0x50, 0x2F, 0xF0, 0x00, 0x00 }; /*8934*/
const unsigned char  uc2_8936 [] = {0x2E, 0xF0, 0x15, 0x50, 0x7B, 0x30, 0x09, 0xD0, 0x15, 0x10, 0x3B, 0xE0, 0x56, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*8936*/
const unsigned char  uc2_8941 [] = {0x40, 0x00, 0x26, 0xE0, 0x72, 0xA0, 0x12, 0xE0, 0x2E, 0x40, 0x35, 0xF0, 0x6D, 0x50, 0x27, 0xF0, 0x22, 0x40, 0x22, 0x60, 0x2D, 0x90, 0x00, 0x00 }; /*8941*/
const unsigned char  uc2_8944 [] = {0x02, 0x00, 0x7F, 0xF0, 0x15, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x1F, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x09, 0x20, 0x70, 0xC0, 0x1C, 0x30, 0x00, 0x00 }; /*8944*/
const unsigned char  uc2_895E [] = {0x00, 0x40, 0x3D, 0xF0, 0x24, 0xA0, 0x3D, 0xF0, 0x20, 0x40, 0x3C, 0xE0, 0x54, 0x40, 0x7F, 0xF0, 0x05, 0x20, 0x18, 0xC0, 0x6E, 0x30, 0x00, 0x00 }; /*895E*/
const unsigned char  uc2_895F [] = {0x22, 0x40, 0x17, 0xF0, 0x7A, 0x40, 0x0B, 0xE0, 0x16, 0x50, 0x3B, 0xE0, 0x54, 0x00, 0x17, 0xF0, 0x10, 0xA0, 0x12, 0x90, 0x15, 0x90, 0x00, 0x00 }; /*895F*/
const unsigned char  uc2_8966 [] = {0x23, 0xE0, 0x00, 0x80, 0x77, 0xF0, 0x14, 0x90, 0x22, 0xA0, 0x68, 0x00, 0x37, 0xF0, 0x29, 0x00, 0x27, 0xF0, 0x25, 0x50, 0x24, 0x30, 0x00, 0x00 }; /*8966*/
const unsigned char  uc2_897B [] = {0x22, 0xA0, 0x17, 0x70, 0x72, 0xA0, 0x17, 0x70, 0x22, 0xA0, 0x6F, 0xF0, 0x32, 0xA0, 0x2D, 0xD0, 0x20, 0x80, 0x2E, 0xF0, 0x21, 0x80, 0x00, 0x00 }; /*897B*/
const unsigned char  uc2_897F [] = {0x00, 0x00, 0x7F, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x28, 0xE0, 0x30, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*897F*/
const unsigned char  uc2_8981 [] = {0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x1D, 0x00, 0x03, 0xC0, 0x3C, 0x20, 0x00, 0x00 }; /*8981*/
const unsigned char  uc2_8983 [] = {0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8983*/
const unsigned char  uc2_8986 [] = {0x7F, 0xF0, 0x25, 0x20, 0x3F, 0xF0, 0x22, 0x20, 0x47, 0xE0, 0x12, 0x20, 0x63, 0xE0, 0x22, 0x20, 0x2D, 0x40, 0x21, 0xC0, 0x2E, 0x30, 0x00, 0x00 }; /*8986*/
const unsigned char  uc2_89C1 [] = {0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x13, 0x40, 0x05, 0x00, 0x05, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*89C1*/
const unsigned char  uc2_89C2 [] = {0x03, 0xE0, 0x7A, 0x20, 0x0A, 0x20, 0x0A, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x2A, 0xA0, 0x28, 0xC0, 0x41, 0x50, 0x01, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*89C2*/
const unsigned char  uc2_89C4 [] = {0x13, 0xE0, 0x12, 0x20, 0x3A, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x7E, 0xA0, 0x12, 0xA0, 0x10, 0xC0, 0x29, 0x50, 0x29, 0x50, 0x46, 0x20, 0x00, 0x00 }; /*89C4*/
const unsigned char  uc2_89C5 [] = {0x00, 0x60, 0x3F, 0x80, 0x12, 0x20, 0x09, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x10, 0x19, 0x10, 0x60, 0xE0, 0x00, 0x00 }; /*89C5*/
const unsigned char  uc2_89C6 [] = {0x20, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x0A, 0xA0, 0x12, 0xA0, 0x3A, 0xA0, 0x56, 0xA0, 0x10, 0xC0, 0x11, 0x50, 0x11, 0x50, 0x16, 0x20, 0x00, 0x00 }; /*89C6*/
const unsigned char  uc2_89C7 [] = {0x23, 0xE0, 0x22, 0x20, 0x3A, 0xA0, 0x22, 0xA0, 0x22, 0xA0, 0x7A, 0xA0, 0x4A, 0xA0, 0x48, 0xC0, 0x79, 0x50, 0x41, 0x50, 0x06, 0x20, 0x00, 0x00 }; /*89C7*/
const unsigned char  uc2_89C8 [] = {0x04, 0x80, 0x24, 0xF0, 0x25, 0x40, 0x26, 0x20, 0x04, 0x20, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x50, 0x0D, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*89C8*/
const unsigned char  uc2_89C9 [] = {0x24, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x40, 0x10, 0x5F, 0xD0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x03, 0x10, 0x0D, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*89C9*/
const unsigned char  uc2_89CA [] = {0x11, 0xF0, 0x55, 0x10, 0x7D, 0x50, 0x01, 0x50, 0x7D, 0x50, 0x05, 0x50, 0x7D, 0x50, 0x40, 0xA0, 0x4C, 0xA0, 0x71, 0x20, 0x46, 0x10, 0x00, 0x00 }; /*89CA*/
const unsigned char  uc2_89CB [] = {0x01, 0xF0, 0x7F, 0x10, 0x09, 0x50, 0x2D, 0x50, 0x25, 0x50, 0x2B, 0x50, 0x59, 0x50, 0x48, 0x60, 0x0E, 0xA0, 0x70, 0xA0, 0x03, 0x10, 0x00, 0x00 }; /*89CB*/
const unsigned char  uc2_89CC [] = {0x11, 0xF0, 0x3D, 0x10, 0x11, 0x50, 0x7D, 0x50, 0x23, 0x50, 0x59, 0x50, 0x29, 0x50, 0x7E, 0x60, 0x08, 0xA0, 0x14, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*89CC*/
const unsigned char  uc2_89CE [] = {0x08, 0x00, 0x15, 0xF0, 0x23, 0x10, 0x5D, 0x50, 0x71, 0x50, 0x55, 0x50, 0x75, 0x50, 0x55, 0x40, 0x75, 0x60, 0x51, 0xA0, 0x36, 0x90, 0x00, 0x00 }; /*89CE*/
const unsigned char  uc2_89CF [] = {0x14, 0x00, 0x7F, 0xF0, 0x15, 0x10, 0x3F, 0x50, 0x15, 0x50, 0x7F, 0x50, 0x2B, 0x50, 0x3E, 0x60, 0x2A, 0xA0, 0x7F, 0xA0, 0x25, 0x10, 0x00, 0x00 }; /*89CF*/
const unsigned char  uc2_89D0 [] = {0x29, 0xF0, 0x7D, 0x10, 0x29, 0x50, 0x11, 0x50, 0x7D, 0x50, 0x55, 0x50, 0x7D, 0x50, 0x10, 0x60, 0x7C, 0xA0, 0x12, 0xA0, 0x7D, 0x10, 0x00, 0x00 }; /*89D0*/
const unsigned char  uc2_89D1 [] = {0x15, 0xF0, 0x19, 0x10, 0x7D, 0x50, 0x53, 0x50, 0x5D, 0x50, 0x73, 0x50, 0x4C, 0x60, 0x56, 0xA0, 0x74, 0xA0, 0x56, 0xA0, 0x79, 0x10, 0x00, 0x00 }; /*89D1*/
const unsigned char  uc2_89D2 [] = {0x04, 0x00, 0x07, 0x80, 0x08, 0x80, 0x1F, 0xE0, 0x29, 0x20, 0x0F, 0xE0, 0x09, 0x20, 0x0F, 0xE0, 0x09, 0x20, 0x11, 0x20, 0x60, 0xC0, 0x00, 0x00 }; /*89D2*/
const unsigned char  uc2_89D6 [] = {0x10, 0x00, 0x1C, 0x80, 0x24, 0x80, 0x7D, 0xE0, 0x2A, 0xA0, 0x3E, 0xA0, 0x2B, 0xF0, 0x3E, 0x80, 0x2A, 0xC0, 0x23, 0x20, 0x4C, 0x10, 0x00, 0x00 }; /*89D6*/
const unsigned char  uc2_89DA [] = {0x10, 0x30, 0x1B, 0xC0, 0x2A, 0xA0, 0x7E, 0xA0, 0x2A, 0xA0, 0x3E, 0xA0, 0x2A, 0xA0, 0x3E, 0xA0, 0x2A, 0xD0, 0x22, 0xB0, 0x4C, 0xD0, 0x00, 0x00 }; /*89DA*/
const unsigned char  uc2_89DC [] = {0x09, 0x20, 0x2F, 0xC0, 0x29, 0x10, 0x7F, 0xE0, 0x11, 0x00, 0x1F, 0xC0, 0x72, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0x40, 0x62, 0x80, 0x00, 0x00 }; /*89DC*/
const unsigned char  uc2_89DE [] = {0x10, 0x80, 0x1C, 0xF0, 0x25, 0x00, 0x7E, 0xE0, 0x2A, 0x20, 0x3E, 0xF0, 0x2A, 0x50, 0x3E, 0x90, 0x2B, 0x30, 0x22, 0x50, 0x4D, 0xA0, 0x00, 0x00 }; /*89DE*/
const unsigned char  uc2_89E3 [] = {0x21, 0xF0, 0x38, 0x90, 0x48, 0x90, 0x7D, 0x30, 0x54, 0x40, 0x7D, 0x40, 0x55, 0xE0, 0x7E, 0x40, 0x57, 0xF0, 0x44, 0x40, 0x58, 0x40, 0x00, 0x00 }; /*89E3*/
const unsigned char  uc2_89E5 [] = {0x20, 0x80, 0x3C, 0xA0, 0x4A, 0xA0, 0x7E, 0xC0, 0x54, 0x80, 0x7F, 0xF0, 0x55, 0x40, 0x7D, 0x50, 0x55, 0x50, 0x45, 0x50, 0x5A, 0x20, 0x00, 0x00 }; /*89E5*/
const unsigned char  uc2_89E6 [] = {0x20, 0x40, 0x38, 0x40, 0x48, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0x50, 0x55, 0xF0, 0x7C, 0x40, 0x54, 0x50, 0x44, 0x70, 0x5B, 0x90, 0x00, 0x00 }; /*89E6*/
const unsigned char  uc2_89EB [] = {0x10, 0x40, 0x1D, 0xF0, 0x24, 0x40, 0x7F, 0xF0, 0x2A, 0x50, 0x3F, 0xF0, 0x2A, 0x40, 0x3E, 0xC0, 0x2B, 0x60, 0x22, 0x50, 0x4C, 0x40, 0x00, 0x00 }; /*89EB*/
const unsigned char  uc2_89EF [] = {0x21, 0x10, 0x38, 0xA0, 0x49, 0xF0, 0x7D, 0x50, 0x55, 0xF0, 0x7D, 0x50, 0x55, 0xF0, 0x7C, 0x40, 0x55, 0xF0, 0x44, 0x40, 0x58, 0x40, 0x00, 0x00 }; /*89EF*/
const unsigned char  uc2_89F3 [] = {0x08, 0xE0, 0x3E, 0xA0, 0x08, 0xA0, 0x7E, 0x90, 0x55, 0x00, 0x3F, 0xE0, 0x6A, 0xA0, 0x3E, 0xA0, 0x2A, 0x40, 0x3E, 0xA0, 0x4B, 0x10, 0x00, 0x00 }; /*89F3*/
const unsigned char  uc2_8A00 [] = {0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*8A00*/
const unsigned char  uc2_8A07 [] = {0x10, 0x00, 0x1F, 0xF0, 0x22, 0x10, 0x5F, 0xD0, 0x00, 0x10, 0x0F, 0x90, 0x00, 0x10, 0x0F, 0x90, 0x08, 0x90, 0x0F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*8A07*/
const unsigned char  uc2_8A3E [] = {0x11, 0x20, 0x5D, 0xC0, 0x51, 0x10, 0x7C, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*8A3E*/
const unsigned char  uc2_8A48 [] = {0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8A48*/
const unsigned char  uc2_8A79 [] = {0x0F, 0xC0, 0x10, 0x40, 0x3F, 0xF0, 0x65, 0x40, 0x3F, 0xF0, 0x20, 0x00, 0x2F, 0xE0, 0x20, 0x00, 0x3F, 0xF0, 0x28, 0x20, 0x4F, 0xE0, 0x00, 0x00 }; /*8A79*/
const unsigned char  uc2_8A89 [] = {0x24, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x22, 0x20, 0x5F, 0xD0, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8A89*/
const unsigned char  uc2_8A8A [] = {0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x3F, 0xE0, 0x40, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*8A8A*/
const unsigned char  uc2_8A93 [] = {0x11, 0xE0, 0x7D, 0x00, 0x11, 0xF0, 0x7D, 0x40, 0x11, 0x40, 0x22, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8A93*/
const unsigned char  uc2_8B07 [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x3F, 0xE0, 0x48, 0x90, 0x0F, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*8B07*/
const unsigned char  uc2_8B26 [] = {0x3E, 0xE0, 0x09, 0xB0, 0x3E, 0x00, 0x2A, 0xE0, 0x3E, 0xA0, 0x42, 0x40, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8B26*/
const unsigned char  uc2_8B66 [] = {0x24, 0x80, 0x7E, 0xF0, 0x25, 0xA0, 0x7E, 0x40, 0x2A, 0xB0, 0x3A, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8B66*/
const unsigned char  uc2_8B6C [] = {0x3C, 0x40, 0x25, 0xF0, 0x3C, 0xA0, 0x21, 0xF0, 0x3C, 0x40, 0x54, 0x40, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8B6C*/
const unsigned char  uc2_8BA1 [] = {0x30, 0x80, 0x08, 0x80, 0x00, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BA1*/
const unsigned char  uc2_8BA2 [] = {0x30, 0x00, 0x0B, 0xF0, 0x00, 0x80, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*8BA2*/
const unsigned char  uc2_8BA3 [] = {0x31, 0x00, 0x09, 0x00, 0x01, 0x00, 0x71, 0xC0, 0x11, 0x20, 0x11, 0x10, 0x11, 0x10, 0x15, 0x00, 0x19, 0x00, 0x11, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*8BA3*/
const unsigned char  uc2_8BA4 [] = {0x30, 0x80, 0x08, 0x80, 0x00, 0x80, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x15, 0x40, 0x19, 0x40, 0x12, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*8BA4*/
const unsigned char  uc2_8BA5 [] = {0x30, 0x00, 0x0B, 0xC0, 0x02, 0x40, 0x72, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x16, 0x50, 0x1A, 0x50, 0x12, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*8BA5*/
const unsigned char  uc2_8BA6 [] = {0x30, 0x00, 0x0B, 0xE0, 0x00, 0x80, 0x70, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BA6*/
const unsigned char  uc2_8BA7 [] = {0x30, 0x00, 0x0B, 0xE0, 0x00, 0x80, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*8BA7*/
const unsigned char  uc2_8BA8 [] = {0x30, 0x20, 0x08, 0x20, 0x03, 0xF0, 0x70, 0x20, 0x11, 0x20, 0x10, 0xA0, 0x10, 0xA0, 0x14, 0xA0, 0x18, 0x20, 0x10, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8BA8*/
const unsigned char  uc2_8BA9 [] = {0x30, 0x80, 0x08, 0x80, 0x00, 0x80, 0x70, 0x80, 0x10, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*8BA9*/
const unsigned char  uc2_8BAA [] = {0x30, 0x80, 0x08, 0x80, 0x00, 0x80, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x16, 0xA0, 0x1A, 0xA0, 0x13, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*8BAA*/
const unsigned char  uc2_8BAB [] = {0x31, 0x00, 0x09, 0xF0, 0x02, 0x00, 0x72, 0x00, 0x15, 0xE0, 0x10, 0x20, 0x10, 0x40, 0x14, 0x90, 0x19, 0x10, 0x12, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*8BAB*/
const unsigned char  uc2_8BAD [] = {0x32, 0x20, 0x0A, 0xA0, 0x02, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x16, 0xA0, 0x1A, 0x20, 0x12, 0x20, 0x04, 0x20, 0x00, 0x00 }; /*8BAD*/
const unsigned char  uc2_8BAE [] = {0x31, 0x00, 0x0A, 0xA0, 0x02, 0xA0, 0x72, 0x20, 0x11, 0x40, 0x11, 0x40, 0x10, 0x80, 0x15, 0x40, 0x19, 0x40, 0x12, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*8BAE*/
const unsigned char  uc2_8BAF [] = {0x40, 0x00, 0x2F, 0xC0, 0x02, 0x40, 0x62, 0x40, 0x22, 0x40, 0x2F, 0x40, 0x22, 0x40, 0x2A, 0x50, 0x32, 0x50, 0x22, 0x30, 0x02, 0x10, 0x00, 0x00 }; /*8BAF*/
const unsigned char  uc2_8BB0 [] = {0x30, 0x00, 0x0B, 0xE0, 0x00, 0x20, 0x70, 0x20, 0x10, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x16, 0x00, 0x1A, 0x10, 0x12, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*8BB0*/
const unsigned char  uc2_8BB2 [] = {0x31, 0x40, 0x09, 0x40, 0x03, 0xE0, 0x71, 0x40, 0x11, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x40, 0x12, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*8BB2*/
const unsigned char  uc2_8BB3 [] = {0x30, 0x80, 0x08, 0x80, 0x07, 0xF0, 0x70, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x18, 0x90, 0x10, 0xA0, 0x00, 0x80, 0x00, 0x00 }; /*8BB3*/
const unsigned char  uc2_8BB4 [] = {0x33, 0xF0, 0x0A, 0x00, 0x03, 0x20, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x12, 0xA0, 0x16, 0x90, 0x1B, 0x10, 0x12, 0x00, 0x03, 0xF0, 0x00, 0x00 }; /*8BB4*/
const unsigned char  uc2_8BB5 [] = {0x33, 0xF0, 0x0A, 0x00, 0x02, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x16, 0x00, 0x1A, 0x00, 0x13, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*8BB5*/
const unsigned char  uc2_8BB6 [] = {0x33, 0xF0, 0x08, 0x20, 0x01, 0x20, 0x72, 0x20, 0x13, 0xF0, 0x10, 0x60, 0x10, 0xA0, 0x14, 0xA0, 0x19, 0x20, 0x16, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8BB6*/
const unsigned char  uc2_8BB7 [] = {0x30, 0x80, 0x08, 0x80, 0x07, 0xF0, 0x74, 0x90, 0x14, 0x90, 0x15, 0x50, 0x15, 0x30, 0x16, 0x10, 0x1C, 0x10, 0x14, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*8BB7*/
const unsigned char  uc2_8BB8 [] = {0x32, 0x00, 0x0B, 0xE0, 0x02, 0x80, 0x74, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BB8*/
const unsigned char  uc2_8BB9 [] = {0x31, 0x40, 0x09, 0x40, 0x02, 0x50, 0x72, 0x50, 0x16, 0x60, 0x12, 0x40, 0x12, 0xC0, 0x16, 0x50, 0x1A, 0x50, 0x12, 0x50, 0x02, 0x20, 0x00, 0x00 }; /*8BB9*/
const unsigned char  uc2_8BBA [] = {0x30, 0x80, 0x08, 0x80, 0x01, 0x40, 0x76, 0x30, 0x11, 0x00, 0x11, 0x20, 0x11, 0xC0, 0x15, 0x10, 0x19, 0x10, 0x10, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*8BBA*/
const unsigned char  uc2_8BBC [] = {0x31, 0x40, 0x09, 0x20, 0x02, 0x20, 0x72, 0x90, 0x14, 0x90, 0x10, 0x80, 0x11, 0x40, 0x15, 0x20, 0x1A, 0x60, 0x13, 0x90, 0x00, 0x10, 0x00, 0x00 }; /*8BBC*/
const unsigned char  uc2_8BBD [] = {0x60, 0x00, 0x17, 0xC0, 0x04, 0x40, 0x76, 0xC0, 0x15, 0x40, 0x15, 0x40, 0x15, 0x40, 0x16, 0xD0, 0x1C, 0x50, 0x14, 0x30, 0x08, 0x10, 0x00, 0x00 }; /*8BBD*/
const unsigned char  uc2_8BBE [] = {0x33, 0xC0, 0x0A, 0x40, 0x02, 0x40, 0x72, 0x30, 0x14, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x15, 0x40, 0x18, 0x80, 0x11, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*8BBE*/
const unsigned char  uc2_8BBF [] = {0x30, 0x80, 0x08, 0x40, 0x07, 0xF0, 0x71, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x15, 0x20, 0x1A, 0x20, 0x12, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*8BBF*/
const unsigned char  uc2_8BC0 [] = {0x31, 0x00, 0x09, 0x00, 0x07, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x1F, 0xF0, 0x11, 0x00, 0x16, 0x80, 0x1A, 0x80, 0x14, 0x40, 0x08, 0x30, 0x00, 0x00 }; /*8BC0*/
const unsigned char  uc2_8BC1 [] = {0x30, 0x00, 0x0F, 0xF0, 0x00, 0x80, 0x70, 0x80, 0x12, 0x80, 0x12, 0xE0, 0x12, 0x80, 0x16, 0x80, 0x1A, 0x80, 0x12, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*8BC1*/
const unsigned char  uc2_8BC2 [] = {0x30, 0x80, 0x08, 0x80, 0x07, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BC2*/
const unsigned char  uc2_8BC3 [] = {0x30, 0x00, 0x0F, 0xF0, 0x00, 0x20, 0x73, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x13, 0xA0, 0x16, 0xA0, 0x18, 0x20, 0x10, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8BC3*/
const unsigned char  uc2_8BC4 [] = {0x33, 0xE0, 0x08, 0x80, 0x04, 0xA0, 0x72, 0xA0, 0x12, 0xC0, 0x17, 0xF0, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BC4*/
const unsigned char  uc2_8BC5 [] = {0x33, 0xE0, 0x0A, 0x20, 0x02, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x17, 0xE0, 0x1A, 0x20, 0x12, 0x20, 0x07, 0xF0, 0x00, 0x00 }; /*8BC5*/
const unsigned char  uc2_8BC6 [] = {0x33, 0xE0, 0x0A, 0x20, 0x02, 0x20, 0x72, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x00, 0x15, 0x40, 0x19, 0x20, 0x12, 0x10, 0x04, 0x10, 0x00, 0x00 }; /*8BC6*/
const unsigned char  uc2_8BC8 [] = {0x32, 0x00, 0x0B, 0xF0, 0x05, 0x00, 0x75, 0x00, 0x19, 0xC0, 0x11, 0x00, 0x11, 0x00, 0x15, 0xE0, 0x19, 0x00, 0x11, 0x00, 0x01, 0x00, 0x00, 0x00 }; /*8BC8*/
const unsigned char  uc2_8BC9 [] = {0x30, 0x60, 0x0B, 0x80, 0x02, 0x00, 0x72, 0x00, 0x13, 0xF0, 0x12, 0x40, 0x13, 0xC0, 0x16, 0x60, 0x1A, 0x50, 0x12, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*8BC9*/
const unsigned char  uc2_8BCA [] = {0x30, 0x80, 0x08, 0xC0, 0x01, 0x20, 0x76, 0x50, 0x10, 0x80, 0x13, 0x20, 0x10, 0x40, 0x15, 0x90, 0x18, 0x20, 0x10, 0xC0, 0x03, 0x00, 0x00, 0x00 }; /*8BCA*/
const unsigned char  uc2_8BCB [] = {0x30, 0x30, 0x0B, 0xC0, 0x02, 0x40, 0x72, 0x40, 0x13, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x16, 0xD0, 0x1B, 0x50, 0x12, 0xB0, 0x00, 0x90, 0x00, 0x00 }; /*8BCB*/
const unsigned char  uc2_8BCC [] = {0x31, 0x00, 0x09, 0xC0, 0x02, 0x40, 0x77, 0xF0, 0x10, 0x10, 0x10, 0x10, 0x11, 0xF0, 0x14, 0x10, 0x18, 0x10, 0x13, 0xF0, 0x00, 0x10, 0x00, 0x00 }; /*8BCC*/
const unsigned char  uc2_8BCD [] = {0x37, 0xF0, 0x08, 0x10, 0x07, 0xD0, 0x70, 0x10, 0x13, 0x90, 0x12, 0x90, 0x12, 0x90, 0x17, 0x90, 0x1A, 0x90, 0x10, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*8BCD*/
const unsigned char  uc2_8BCE [] = {0x30, 0x80, 0x0A, 0xA0, 0x02, 0xA0, 0x72, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x12, 0xA0, 0x16, 0xA0, 0x1A, 0xA0, 0x13, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*8BCE*/
const unsigned char  uc2_8BCF [] = {0x33, 0xF0, 0x08, 0x90, 0x00, 0x90, 0x71, 0x10, 0x16, 0x60, 0x10, 0x00, 0x11, 0xF0, 0x15, 0x10, 0x19, 0x10, 0x11, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*8BCF*/
const unsigned char  uc2_8BD1 [] = {0x33, 0xE0, 0x09, 0x20, 0x01, 0x40, 0x70, 0xC0, 0x17, 0x30, 0x10, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BD1*/
const unsigned char  uc2_8BD2 [] = {0x31, 0x00, 0x09, 0x40, 0x02, 0x20, 0x74, 0xE0, 0x17, 0x10, 0x10, 0x10, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BD2*/
const unsigned char  uc2_8BD3 [] = {0x33, 0xF0, 0x0A, 0x00, 0x03, 0xF0, 0x72, 0x40, 0x12, 0x40, 0x12, 0xE0, 0x12, 0x40, 0x16, 0x40, 0x1B, 0xF0, 0x12, 0x00, 0x03, 0xF0, 0x00, 0x00 }; /*8BD3*/
const unsigned char  uc2_8BD4 [] = {0x60, 0x80, 0x17, 0xF0, 0x00, 0x80, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x14, 0x90, 0x08, 0x80, 0x00, 0x00 }; /*8BD4*/
const unsigned char  uc2_8BD5 [] = {0x30, 0xA0, 0x08, 0x90, 0x07, 0xF0, 0x70, 0x40, 0x17, 0x40, 0x12, 0x40, 0x12, 0x40, 0x16, 0xD0, 0x1B, 0x50, 0x14, 0x50, 0x00, 0x20, 0x00, 0x00 }; /*8BD5*/
const unsigned char  uc2_8BD6 [] = {0x30, 0x80, 0x0B, 0xE0, 0x00, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x10, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x10, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*8BD6*/
const unsigned char  uc2_8BD7 [] = {0x30, 0x80, 0x0B, 0xE0, 0x00, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x00, 0x10, 0x40, 0x13, 0xE0, 0x1A, 0x40, 0x11, 0x40, 0x00, 0xC0, 0x00, 0x00 }; /*8BD7*/
const unsigned char  uc2_8BD8 [] = {0x30, 0x80, 0x0F, 0xF0, 0x00, 0x80, 0x70, 0x80, 0x13, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BD8*/
const unsigned char  uc2_8BD9 [] = {0x31, 0x00, 0x09, 0x00, 0x07, 0xF0, 0x71, 0x00, 0x12, 0x50, 0x12, 0xD0, 0x13, 0x60, 0x14, 0x40, 0x1C, 0xA0, 0x14, 0xA0, 0x0B, 0x10, 0x00, 0x00 }; /*8BD9*/
const unsigned char  uc2_8BDA [] = {0x30, 0xA0, 0x08, 0xA0, 0x07, 0xF0, 0x74, 0x80, 0x17, 0x50, 0x15, 0x50, 0x15, 0x60, 0x16, 0x40, 0x1C, 0xD0, 0x15, 0x50, 0x0A, 0x20, 0x00, 0x00 }; /*8BDA*/
const unsigned char  uc2_8BDB [] = {0x30, 0x80, 0x0A, 0x80, 0x03, 0xE0, 0x74, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x1A, 0xA0, 0x14, 0x90, 0x08, 0x80, 0x00, 0x00 }; /*8BDB*/
const unsigned char  uc2_8BDC [] = {0x30, 0x80, 0x0A, 0x80, 0x03, 0xE0, 0x72, 0x80, 0x14, 0x80, 0x17, 0xF0, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x50, 0x12, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*8BDC*/
const unsigned char  uc2_8BDD [] = {0x30, 0x60, 0x0B, 0x80, 0x00, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BDD*/
const unsigned char  uc2_8BDE [] = {0x6E, 0x10, 0x12, 0xE0, 0x04, 0x20, 0x6E, 0x20, 0x22, 0xB0, 0x2A, 0xA0, 0x2A, 0xA0, 0x24, 0xA0, 0x36, 0xF0, 0x29, 0x80, 0x10, 0x70, 0x00, 0x00 }; /*8BDE*/
const unsigned char  uc2_8BDF [] = {0x30, 0x30, 0x0B, 0xC0, 0x02, 0x00, 0x73, 0xF0, 0x12, 0x00, 0x12, 0x00, 0x12, 0xF0, 0x16, 0x90, 0x1A, 0x90, 0x12, 0xF0, 0x04, 0x90, 0x00, 0x00 }; /*8BDF*/
const unsigned char  uc2_8BE0 [] = {0x30, 0x80, 0x08, 0xC0, 0x01, 0x20, 0x76, 0x10, 0x13, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x10, 0x80, 0x07, 0xF0, 0x00, 0x00 }; /*8BE0*/
const unsigned char  uc2_8BE1 [] = {0x32, 0x00, 0x0B, 0xC0, 0x04, 0x40, 0x77, 0xF0, 0x14, 0x00, 0x15, 0xE0, 0x15, 0x20, 0x15, 0xC0, 0x1D, 0x10, 0x15, 0x10, 0x08, 0xE0, 0x00, 0x00 }; /*8BE1*/
const unsigned char  uc2_8BE2 [] = {0x32, 0x00, 0x0B, 0xF0, 0x02, 0x10, 0x77, 0xD0, 0x12, 0x50, 0x13, 0xD0, 0x12, 0x50, 0x17, 0xD0, 0x1A, 0x50, 0x10, 0x10, 0x00, 0x60, 0x00, 0x00 }; /*8BE2*/
const unsigned char  uc2_8BE3 [] = {0x32, 0x60, 0x0B, 0x80, 0x02, 0x10, 0x71, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x17, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BE3*/
const unsigned char  uc2_8BE4 [] = {0x31, 0x00, 0x09, 0xC0, 0x02, 0x40, 0x77, 0xE0, 0x10, 0xA0, 0x17, 0xF0, 0x10, 0xA0, 0x17, 0xE0, 0x18, 0x80, 0x10, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*8BE4*/
const unsigned char  uc2_8BE5 [] = {0x30, 0x80, 0x0F, 0xF0, 0x00, 0x80, 0x71, 0x20, 0x12, 0x40, 0x13, 0x90, 0x11, 0x20, 0x16, 0x20, 0x18, 0x40, 0x11, 0xA0, 0x06, 0x10, 0x00, 0x00 }; /*8BE5*/
const unsigned char  uc2_8BE6 [] = {0x32, 0x20, 0x09, 0x40, 0x07, 0xF0, 0x70, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BE6*/
const unsigned char  uc2_8BE7 [] = {0x60, 0x80, 0x17, 0xF0, 0x04, 0x10, 0x70, 0x60, 0x13, 0x80, 0x10, 0x80, 0x10, 0xF0, 0x17, 0x80, 0x18, 0x90, 0x10, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*8BE7*/
const unsigned char  uc2_8BE8 [] = {0x37, 0xF0, 0x0D, 0x10, 0x07, 0xE0, 0x71, 0x00, 0x12, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8BE8*/
const unsigned char  uc2_8BE9 [] = {0x37, 0x70, 0x08, 0x90, 0x00, 0x90, 0x76, 0xD0, 0x11, 0xB0, 0x10, 0x90, 0x11, 0xB0, 0x16, 0xD0, 0x18, 0x90, 0x10, 0x90, 0x03, 0x60, 0x00, 0x00 }; /*8BE9*/
const unsigned char  uc2_8BEB [] = {0x60, 0x60, 0x10, 0x50, 0x0F, 0xF0, 0x60, 0x40, 0x25, 0x50, 0x2F, 0xD0, 0x25, 0x50, 0x2D, 0x60, 0x34, 0x50, 0x28, 0xB0, 0x03, 0x10, 0x00, 0x00 }; /*8BEB*/
const unsigned char  uc2_8BEC [] = {0x37, 0xF0, 0x08, 0x80, 0x02, 0xA0, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x15, 0xD0, 0x14, 0x90, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*8BEC*/
const unsigned char  uc2_8BED [] = {0x37, 0xF0, 0x08, 0x80, 0x03, 0xE0, 0x71, 0x20, 0x17, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BED*/
const unsigned char  uc2_8BEE [] = {0x34, 0x90, 0x0A, 0x90, 0x02, 0xA0, 0x77, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x1C, 0x10, 0x14, 0x10, 0x04, 0xE0, 0x00, 0x00 }; /*8BEE*/
const unsigned char  uc2_8BEF [] = {0x33, 0xE0, 0x0A, 0x20, 0x02, 0x20, 0x73, 0xE0, 0x10, 0x00, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x11, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*8BEF*/
const unsigned char  uc2_8BF0 [] = {0x32, 0x80, 0x0B, 0xE0, 0x02, 0x80, 0x74, 0x80, 0x1F, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BF0*/
const unsigned char  uc2_8BF1 [] = {0x33, 0xE0, 0x08, 0x80, 0x07, 0xF0, 0x72, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x17, 0xE0, 0x15, 0x20, 0x19, 0x70, 0x12, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*8BF1*/
const unsigned char  uc2_8BF2 [] = {0x62, 0x00, 0x13, 0xF0, 0x0C, 0x00, 0x73, 0xE0, 0x12, 0xA0, 0x17, 0xF0, 0x12, 0x20, 0x14, 0xA0, 0x17, 0xF0, 0x18, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8BF2*/
const unsigned char  uc2_8BF3 [] = {0x6D, 0x00, 0x13, 0xF0, 0x02, 0x40, 0x66, 0x40, 0x3A, 0x40, 0x22, 0xE0, 0x26, 0x40, 0x2A, 0x40, 0x32, 0x40, 0x22, 0x40, 0x0D, 0xF0, 0x00, 0x00 }; /*8BF3*/
const unsigned char  uc2_8BF4 [] = {0x36, 0x20, 0x09, 0x40, 0x03, 0xE0, 0x72, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x11, 0x40, 0x15, 0x50, 0x19, 0x50, 0x12, 0x50, 0x0C, 0x20, 0x00, 0x00 }; /*8BF4*/
const unsigned char  uc2_8BF5 [] = {0x33, 0xE0, 0x09, 0x20, 0x00, 0xC0, 0x77, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x1C, 0x90, 0x14, 0x90, 0x04, 0x60, 0x00, 0x00 }; /*8BF5*/
const unsigned char  uc2_8BF6 [] = {0x31, 0x40, 0x0A, 0x20, 0x07, 0xD0, 0x72, 0x10, 0x13, 0xE0, 0x14, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x11, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*8BF6*/
const unsigned char  uc2_8BF7 [] = {0x30, 0x80, 0x0F, 0xF0, 0x00, 0x80, 0x73, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x12, 0x20, 0x17, 0xE0, 0x1A, 0x20, 0x13, 0xA0, 0x02, 0x40, 0x00, 0x00 }; /*8BF7*/
const unsigned char  uc2_8BF8 [] = {0x31, 0x00, 0x0B, 0xE0, 0x01, 0x40, 0x77, 0xF0, 0x11, 0x00, 0x13, 0xE0, 0x1E, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BF8*/
const unsigned char  uc2_8BF9 [] = {0x30, 0x00, 0x0F, 0x00, 0x05, 0xF0, 0x77, 0x50, 0x15, 0x50, 0x17, 0x50, 0x15, 0xA0, 0x17, 0x20, 0x19, 0x50, 0x11, 0x50, 0x01, 0x90, 0x00, 0x00 }; /*8BF9*/
const unsigned char  uc2_8BFA [] = {0x32, 0x20, 0x0F, 0xF0, 0x02, 0x20, 0x70, 0x80, 0x17, 0xF0, 0x11, 0x00, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8BFA*/
const unsigned char  uc2_8BFB [] = {0x30, 0x80, 0x0B, 0xE0, 0x00, 0x80, 0x77, 0xF0, 0x12, 0x10, 0x15, 0xA0, 0x12, 0x80, 0x17, 0xF0, 0x18, 0xA0, 0x11, 0x10, 0x06, 0x10, 0x00, 0x00 }; /*8BFB*/
const unsigned char  uc2_8BFC [] = {0x37, 0xF0, 0x09, 0x00, 0x06, 0x90, 0x72, 0xD0, 0x17, 0x60, 0x11, 0x50, 0x10, 0xD0, 0x17, 0x50, 0x18, 0x50, 0x10, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*8BFC*/
const unsigned char  uc2_8BFD [] = {0x31, 0x40, 0x09, 0x40, 0x07, 0x70, 0x71, 0x40, 0x13, 0x60, 0x11, 0x40, 0x11, 0x40, 0x17, 0x70, 0x1D, 0x40, 0x11, 0x40, 0x01, 0x40, 0x00, 0x00 }; /*8BFD*/
const unsigned char  uc2_8BFE [] = {0x33, 0xE0, 0x0A, 0xA0, 0x03, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x1A, 0xA0, 0x14, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*8BFE*/
const unsigned char  uc2_8BFF [] = {0x60, 0x60, 0x13, 0x80, 0x00, 0x80, 0x77, 0xF0, 0x11, 0xC0, 0x16, 0xB0, 0x11, 0x00, 0x17, 0xF0, 0x1A, 0x20, 0x11, 0xC0, 0x06, 0x30, 0x00, 0x00 }; /*8BFF*/
const unsigned char  uc2_8C00 [] = {0x20, 0x80, 0x12, 0xB0, 0x14, 0x90, 0x06, 0xB0, 0x74, 0x90, 0x17, 0xF0, 0x10, 0x80, 0x15, 0x40, 0x19, 0x40, 0x12, 0x20, 0x0C, 0x10, 0x00, 0x00 }; /*8C00*/
const unsigned char  uc2_8C01 [] = {0x61, 0x80, 0x12, 0x40, 0x03, 0xF0, 0x76, 0x40, 0x13, 0xE0, 0x12, 0x40, 0x13, 0xE0, 0x16, 0x40, 0x1A, 0x40, 0x13, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8C01*/
const unsigned char  uc2_8C02 [] = {0x60, 0x80, 0x11, 0x40, 0x06, 0xB0, 0x70, 0x40, 0x13, 0xE0, 0x10, 0x40, 0x11, 0x80, 0x10, 0xA0, 0x1A, 0x50, 0x15, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*8C02*/
const unsigned char  uc2_8C03 [] = {0x67, 0xF0, 0x14, 0x90, 0x05, 0xD0, 0x74, 0x90, 0x17, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x1D, 0xD0, 0x14, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*8C03*/
const unsigned char  uc2_8C04 [] = {0x61, 0x00, 0x11, 0xE0, 0x01, 0x20, 0x72, 0x40, 0x14, 0x80, 0x13, 0x70, 0x12, 0x10, 0x17, 0x30, 0x1A, 0x10, 0x13, 0xF0, 0x02, 0x10, 0x00, 0x00 }; /*8C04*/
const unsigned char  uc2_8C05 [] = {0x60, 0x80, 0x17, 0xF0, 0x00, 0x00, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x12, 0xA0, 0x1A, 0x90, 0x14, 0x90, 0x03, 0x00, 0x00, 0x00 }; /*8C05*/
const unsigned char  uc2_8C06 [] = {0x60, 0x80, 0x17, 0xF0, 0x02, 0x20, 0x73, 0xE0, 0x10, 0x00, 0x13, 0xC0, 0x10, 0x40, 0x17, 0xF0, 0x18, 0x80, 0x10, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*8C06*/
const unsigned char  uc2_8C07 [] = {0x60, 0x80, 0x17, 0xF0, 0x00, 0x00, 0x72, 0x20, 0x12, 0x20, 0x15, 0x50, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8C07*/
const unsigned char  uc2_8C08 [] = {0x60, 0x80, 0x12, 0x90, 0x04, 0xA0, 0x70, 0x80, 0x11, 0x60, 0x16, 0x10, 0x10, 0x80, 0x12, 0x90, 0x14, 0xA0, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*8C08*/
const unsigned char  uc2_8C0A [] = {0x60, 0x80, 0x17, 0xF0, 0x04, 0x10, 0x74, 0x10, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x07, 0xF0, 0x00, 0x00 }; /*8C0A*/
const unsigned char  uc2_8C0B [] = {0x62, 0x20, 0x17, 0xF0, 0x02, 0x20, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x19, 0xA0, 0x16, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*8C0B*/
const unsigned char  uc2_8C0C [] = {0x62, 0x40, 0x17, 0xE0, 0x02, 0x40, 0x63, 0xC0, 0x22, 0x40, 0x23, 0xC0, 0x22, 0x40, 0x2F, 0xF0, 0x35, 0x40, 0x26, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*8C0C*/
const unsigned char  uc2_8C0D [] = {0x62, 0xA0, 0x17, 0xF0, 0x02, 0xA0, 0x72, 0x40, 0x13, 0xF0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0xC0, 0x19, 0xA0, 0x16, 0x90, 0x00, 0x80, 0x00, 0x00 }; /*8C0D*/
const unsigned char  uc2_8C0E [] = {0x61, 0x40, 0x17, 0xF0, 0x01, 0x40, 0x70, 0x80, 0x17, 0xF0, 0x12, 0x00, 0x11, 0xE0, 0x14, 0x00, 0x1A, 0xA0, 0x12, 0xA0, 0x04, 0x90, 0x00, 0x00 }; /*8C0E*/
const unsigned char  uc2_8C0F [] = {0x61, 0x00, 0x1F, 0xF0, 0x01, 0x00, 0x6F, 0xE0, 0x29, 0x20, 0x2D, 0x60, 0x29, 0x20, 0x2F, 0xE0, 0x33, 0x80, 0x25, 0x40, 0x19, 0x30, 0x00, 0x00 }; /*8C0F*/
const unsigned char  uc2_8C10 [] = {0x64, 0x50, 0x17, 0x60, 0x04, 0x50, 0x77, 0x50, 0x15, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x17, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8C10*/
const unsigned char  uc2_8C11 [] = {0x61, 0xE0, 0x11, 0x00, 0x07, 0xF0, 0x65, 0x10, 0x25, 0xC0, 0x27, 0x20, 0x25, 0xE0, 0x25, 0x00, 0x37, 0xF0, 0x29, 0x00, 0x09, 0xE0, 0x00, 0x00 }; /*8C11*/
const unsigned char  uc2_8C12 [] = {0x63, 0xE0, 0x12, 0x20, 0x03, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x11, 0x00, 0x13, 0xF0, 0x14, 0x50, 0x1A, 0xB0, 0x13, 0xD0, 0x00, 0x60, 0x00, 0x00 }; /*8C12*/
const unsigned char  uc2_8C13 [] = {0x67, 0xF0, 0x14, 0x90, 0x07, 0xF0, 0x74, 0x90, 0x17, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x02, 0xC0, 0x00, 0x00 }; /*8C13*/
const unsigned char  uc2_8C14 [] = {0x67, 0x70, 0x15, 0x50, 0x07, 0x70, 0x70, 0x00, 0x13, 0xE0, 0x10, 0x00, 0x17, 0xF0, 0x11, 0x00, 0x1B, 0xE0, 0x10, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*8C14*/
const unsigned char  uc2_8C15 [] = {0x60, 0x80, 0x11, 0x40, 0x06, 0x30, 0x71, 0xC0, 0x17, 0x10, 0x15, 0x50, 0x17, 0x50, 0x15, 0x50, 0x1F, 0x50, 0x15, 0x10, 0x06, 0x60, 0x00, 0x00 }; /*8C15*/
const unsigned char  uc2_8C16 [] = {0x60, 0x70, 0x17, 0x90, 0x02, 0xA0, 0x67, 0xE0, 0x21, 0x00, 0x2F, 0xF0, 0x22, 0x00, 0x23, 0xE0, 0x35, 0x20, 0x28, 0xC0, 0x03, 0x30, 0x00, 0x00 }; /*8C16*/
const unsigned char  uc2_8C17 [] = {0x61, 0x00, 0x11, 0xC0, 0x02, 0x40, 0x77, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x11, 0x50, 0x16, 0xA0, 0x18, 0x40, 0x11, 0x80, 0x00, 0x40, 0x00, 0x00 }; /*8C17*/
const unsigned char  uc2_8C18 [] = {0x29, 0x00, 0x15, 0xF0, 0x15, 0x10, 0x02, 0x40, 0x74, 0x40, 0x15, 0xB0, 0x10, 0x00, 0x17, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8C18*/
const unsigned char  uc2_8C19 [] = {0x60, 0x80, 0x13, 0xE0, 0x02, 0x20, 0x71, 0x40, 0x17, 0xF0, 0x10, 0x00, 0x13, 0xE0, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*8C19*/
const unsigned char  uc2_8C1A [] = {0x60, 0x80, 0x17, 0xF0, 0x01, 0x40, 0x73, 0xF0, 0x12, 0x20, 0x12, 0xC0, 0x12, 0x20, 0x12, 0xC0, 0x1A, 0x10, 0x14, 0x60, 0x05, 0x80, 0x00, 0x00 }; /*8C1A*/
const unsigned char  uc2_8C1B [] = {0x60, 0x80, 0x13, 0xE0, 0x01, 0x40, 0x70, 0x80, 0x17, 0xF0, 0x14, 0x10, 0x10, 0x80, 0x17, 0xE0, 0x1A, 0xA0, 0x12, 0xC0, 0x00, 0x80, 0x00, 0x00 }; /*8C1B*/
const unsigned char  uc2_8C1C [] = {0x48, 0x40, 0x25, 0x50, 0x24, 0xE0, 0x00, 0x40, 0x6D, 0xF0, 0x24, 0x40, 0x24, 0xE0, 0x25, 0x50, 0x34, 0x40, 0x26, 0x00, 0x09, 0xF0, 0x00, 0x00 }; /*8C1C*/
const unsigned char  uc2_8C1D [] = {0x60, 0x80, 0x17, 0xF0, 0x04, 0x10, 0x77, 0xF0, 0x14, 0x00, 0x17, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x1D, 0x50, 0x15, 0x10, 0x08, 0x60, 0x00, 0x00 }; /*8C1D*/
const unsigned char  uc2_8C1F [] = {0x61, 0x40, 0x17, 0xF0, 0x01, 0x40, 0x63, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x22, 0x20, 0x23, 0xE0, 0x30, 0x80, 0x27, 0xF0, 0x02, 0x20, 0x00, 0x00 }; /*8C1F*/
const unsigned char  uc2_8C20 [] = {0x64, 0x90, 0x12, 0xA0, 0x07, 0xF0, 0x74, 0x10, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x15, 0x40, 0x19, 0x50, 0x12, 0x50, 0x04, 0x20, 0x00, 0x00 }; /*8C20*/
const unsigned char  uc2_8C21 [] = {0x33, 0xE0, 0x0A, 0xA0, 0x03, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x12, 0x90, 0x15, 0xD0, 0x13, 0x40, 0x1D, 0x40, 0x10, 0x80, 0x07, 0x70, 0x00, 0x00 }; /*8C21*/
const unsigned char  uc2_8C22 [] = {0x44, 0x20, 0x2F, 0x20, 0x09, 0xF0, 0x6F, 0x20, 0x29, 0x20, 0x2F, 0xA0, 0x29, 0x60, 0x3F, 0x20, 0x25, 0x20, 0x35, 0x20, 0x2B, 0x60, 0x00, 0x00 }; /*8C22*/
const unsigned char  uc2_8C23 [] = {0x47, 0xF0, 0x22, 0xA0, 0x21, 0x40, 0x02, 0x00, 0x63, 0xE0, 0x24, 0x80, 0x27, 0xF0, 0x20, 0x80, 0x2A, 0xA0, 0x33, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*8C23*/
const unsigned char  uc2_8C24 [] = {0x60, 0x80, 0x17, 0xF0, 0x01, 0x40, 0x77, 0xF0, 0x15, 0x10, 0x10, 0x80, 0x17, 0xF0, 0x15, 0x00, 0x19, 0xE0, 0x12, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*8C24*/
const unsigned char  uc2_8C25 [] = {0x44, 0x40, 0x22, 0x80, 0x0F, 0xE0, 0x60, 0x00, 0x22, 0xC0, 0x2C, 0x20, 0x20, 0x00, 0x2F, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x1F, 0xF0, 0x00, 0x00 }; /*8C25*/
const unsigned char  uc2_8C26 [] = {0x64, 0x40, 0x1F, 0xF0, 0x02, 0x80, 0x77, 0xE0, 0x12, 0xA0, 0x1F, 0xF0, 0x12, 0xA0, 0x17, 0xE0, 0x16, 0xC0, 0x1A, 0xB0, 0x02, 0x80, 0x00, 0x00 }; /*8C26*/
const unsigned char  uc2_8C27 [] = {0x41, 0x80, 0x2A, 0x40, 0x0A, 0xA0, 0x72, 0xA0, 0x23, 0x40, 0x2D, 0x80, 0x20, 0x00, 0x2F, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x1F, 0xF0, 0x00, 0x00 }; /*8C27*/
const unsigned char  uc2_8C28 [] = {0x61, 0x40, 0x17, 0xF0, 0x01, 0x40, 0x73, 0xE0, 0x12, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00, 0x00, 0x00 }; /*8C28*/
const unsigned char  uc2_8C29 [] = {0x03, 0xE0, 0x62, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x77, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x17, 0xF0, 0x12, 0x20, 0x19, 0xC0, 0x16, 0x30, 0x00, 0x00 }; /*8C29*/
const unsigned char  uc2_8C2A [] = {0x60, 0x80, 0x17, 0xF0, 0x01, 0x40, 0x77, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x15, 0x50, 0x1D, 0xD0, 0x14, 0x10, 0x04, 0x60, 0x00, 0x00 }; /*8C2A*/
const unsigned char  uc2_8C2B [] = {0x62, 0x40, 0x1F, 0xF0, 0x05, 0x00, 0x77, 0x50, 0x15, 0x50, 0x17, 0x50, 0x15, 0x10, 0x12, 0x20, 0x1B, 0xF0, 0x10, 0x90, 0x07, 0x60, 0x00, 0x00 }; /*8C2B*/
const unsigned char  uc2_8C2C [] = {0x67, 0x70, 0x12, 0xD0, 0x01, 0xB0, 0x76, 0xD0, 0x10, 0x80, 0x17, 0x40, 0x10, 0xB0, 0x13, 0x40, 0x1C, 0x90, 0x10, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*8C2C*/
const unsigned char  uc2_8C2D [] = {0x67, 0xF0, 0x11, 0x40, 0x07, 0xF0, 0x75, 0x50, 0x17, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1F, 0xF0, 0x10, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*8C2D*/
const unsigned char  uc2_8C2E [] = {0x67, 0x70, 0x1A, 0xA0, 0x0F, 0xF0, 0x72, 0xA0, 0x1D, 0x50, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x1C, 0x20, 0x17, 0xE0, 0x04, 0x20, 0x00, 0x00 }; /*8C2E*/
const unsigned char  uc2_8C2F [] = {0x62, 0x80, 0x17, 0xF0, 0x0C, 0x80, 0x77, 0xE0, 0x14, 0x80, 0x17, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x1A, 0xA0, 0x15, 0x50, 0x09, 0x50, 0x00, 0x00 }; /*8C2F*/
const unsigned char  uc2_8C30 [] = {0x64, 0xF0, 0x12, 0x90, 0x07, 0xF0, 0x75, 0x50, 0x16, 0xB0, 0x15, 0xD0, 0x14, 0x90, 0x15, 0xD0, 0x1E, 0xB0, 0x14, 0x90, 0x04, 0x60, 0x00, 0x00 }; /*8C30*/
const unsigned char  uc2_8C31 [] = {0x61, 0x40, 0x17, 0xF0, 0x09, 0x50, 0x75, 0x50, 0x15, 0x60, 0x17, 0xF0, 0x12, 0x20, 0x17, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x00, 0x00 }; /*8C31*/
const unsigned char  uc2_8C32 [] = {0x63, 0xC0, 0x10, 0x40, 0x07, 0xF0, 0x72, 0x90, 0x1C, 0x80, 0x17, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x1D, 0x50, 0x15, 0xD0, 0x04, 0x20, 0x00, 0x00 }; /*8C32*/
const unsigned char  uc2_8C33 [] = {0x42, 0x20, 0x2F, 0xB0, 0x02, 0x20, 0x6F, 0xF0, 0x2D, 0xA0, 0x2A, 0xA0, 0x2F, 0xA0, 0x2A, 0xA0, 0x3F, 0xA0, 0x2A, 0xD0, 0x09, 0x50, 0x00, 0x00 }; /*8C33*/
const unsigned char  uc2_8C34 [] = {0x48, 0x40, 0x25, 0xF0, 0x25, 0x50, 0x03, 0xF0, 0x6C, 0x40, 0x27, 0xF0, 0x25, 0x20, 0x25, 0xE0, 0x37, 0x20, 0x29, 0xC0, 0x10, 0x30, 0x00, 0x00 }; /*8C34*/
const unsigned char  uc2_8C35 [] = {0x43, 0xC0, 0x22, 0x40, 0x07, 0xF0, 0x6D, 0x20, 0x26, 0xD0, 0x24, 0x00, 0x25, 0xE0, 0x24, 0x00, 0x35, 0xE0, 0x25, 0x20, 0x09, 0xE0, 0x00, 0x00 }; /*8C35*/
const unsigned char  uc2_8C36 [] = {0x45, 0x60, 0x2A, 0xD0, 0x0F, 0xF0, 0x05, 0x40, 0x6D, 0xD0, 0x25, 0x50, 0x2D, 0xC0, 0x25, 0x60, 0x3D, 0xD0, 0x25, 0x50, 0x1F, 0xA0, 0x00, 0x00 }; /*8C36*/
const unsigned char  uc2_8C37 [] = {0x08, 0xC0, 0x0A, 0x20, 0x32, 0x20, 0x05, 0x00, 0x18, 0xC0, 0x60, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*8C37*/
const unsigned char  uc2_8C41 [] = {0x08, 0xA0, 0x7F, 0x90, 0x49, 0x50, 0x3E, 0x40, 0x08, 0xA0, 0x3F, 0x10, 0x08, 0xE0, 0x7F, 0xA0, 0x22, 0xA0, 0x3E, 0xE0, 0x22, 0xA0, 0x00, 0x00 }; /*8C41*/
const unsigned char  uc2_8C46 [] = {0x00, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x08, 0x80, 0x04, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*8C46*/
const unsigned char  uc2_8C47 [] = {0x00, 0x00, 0x7F, 0xF0, 0x00, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x24, 0x40, 0x3C, 0x40, 0x24, 0x40, 0x16, 0x40, 0x18, 0x40, 0x63, 0xF0, 0x00, 0x00 }; /*8C47*/
const unsigned char  uc2_8C49 [] = {0x00, 0x40, 0x7E, 0x40, 0x01, 0xF0, 0x3C, 0x40, 0x25, 0xE0, 0x24, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x16, 0x40, 0x18, 0xA0, 0x63, 0x10, 0x00, 0x00 }; /*8C49*/
const unsigned char  uc2_8C4C [] = {0x00, 0x80, 0x7F, 0xF0, 0x04, 0x10, 0x7E, 0x10, 0x4B, 0xE0, 0x7E, 0xA0, 0x4A, 0xA0, 0x29, 0xC0, 0x2E, 0x90, 0x12, 0x90, 0x64, 0x60, 0x00, 0x00 }; /*8C4C*/
const unsigned char  uc2_8C55 [] = {0x7F, 0xE0, 0x04, 0x00, 0x0A, 0x20, 0x73, 0x40, 0x05, 0x40, 0x19, 0x80, 0x63, 0x80, 0x05, 0x40, 0x19, 0x40, 0x61, 0x20, 0x06, 0x00, 0x00, 0x00 }; /*8C55*/
const unsigned char  uc2_8C5A [] = {0x3F, 0xF0, 0x28, 0x80, 0x2F, 0x20, 0x38, 0xA0, 0x29, 0xC0, 0x2E, 0xA0, 0x38, 0xA0, 0x29, 0xA0, 0x2E, 0x90, 0x28, 0x80, 0x53, 0x00, 0x00, 0x00 }; /*8C5A*/
const unsigned char  uc2_8C61 [] = {0x0F, 0x80, 0x10, 0x80, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x0A, 0x00, 0x33, 0x30, 0x0D, 0xC0, 0x32, 0xA0, 0x0C, 0xA0, 0x73, 0x10, 0x00, 0x00 }; /*8C61*/
const unsigned char  uc2_8C62 [] = {0x12, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6D, 0x30, 0x02, 0xA0, 0x1D, 0xC0, 0x02, 0xA0, 0x1D, 0x10, 0x00, 0x00 }; /*8C62*/
const unsigned char  uc2_8C6A [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x40, 0x10, 0x3F, 0xE0, 0x12, 0x00, 0x65, 0x20, 0x1B, 0xC0, 0x05, 0x40, 0x3B, 0x30, 0x00, 0x00 }; /*8C6A*/
const unsigned char  uc2_8C6B [] = {0x39, 0xC0, 0x0E, 0x40, 0x33, 0xE0, 0x0A, 0xA0, 0x7F, 0xE0, 0x15, 0x90, 0x16, 0xD0, 0x11, 0x60, 0x16, 0xD0, 0x11, 0x50, 0x66, 0x80, 0x00, 0x00 }; /*8C6B*/
const unsigned char  uc2_8C73 [] = {0x3A, 0xE0, 0x52, 0x90, 0x6B, 0x50, 0x5E, 0xF0, 0x6B, 0x50, 0x5E, 0xF0, 0x6B, 0x50, 0x5A, 0xD0, 0x42, 0x10, 0x7F, 0xF0, 0x40, 0x10, 0x00, 0x00 }; /*8C73*/
const unsigned char  uc2_8C79 [] = {0x04, 0x80, 0x19, 0x80, 0x6A, 0xF0, 0x2C, 0x90, 0x35, 0x10, 0x0A, 0x90, 0x32, 0x50, 0x06, 0x50, 0x7A, 0x10, 0x04, 0x10, 0x38, 0x60, 0x00, 0x00 }; /*8C79*/
const unsigned char  uc2_8C7A [] = {0x04, 0x20, 0x19, 0x20, 0x6A, 0x20, 0x2D, 0xF0, 0x74, 0x60, 0x0A, 0xA0, 0x32, 0xA0, 0x06, 0xA0, 0x7A, 0xA0, 0x05, 0x20, 0x38, 0x40, 0x00, 0x00 }; /*8C7A*/
const unsigned char  uc2_8C82 [] = {0x05, 0xF0, 0x18, 0x90, 0x6A, 0x90, 0x2C, 0x90, 0x17, 0x60, 0x6C, 0x00, 0x15, 0xF0, 0x6D, 0x10, 0x15, 0x10, 0x65, 0xF0, 0x19, 0x10, 0x00, 0x00 }; /*8C82*/
const unsigned char  uc2_8C85 [] = {0x09, 0x40, 0x31, 0x40, 0x52, 0x40, 0x5F, 0xF0, 0x2A, 0x40, 0x5A, 0xE0, 0x2B, 0x50, 0x5A, 0x40, 0x2A, 0x40, 0x4A, 0x40, 0x32, 0x40, 0x00, 0x00 }; /*8C85*/
const unsigned char  uc2_8C89 [] = {0x04, 0x80, 0x18, 0xE0, 0x69, 0x20, 0x2E, 0xC0, 0x14, 0xA0, 0x6F, 0x10, 0x15, 0xE0, 0x6D, 0x20, 0x15, 0x20, 0x65, 0xE0, 0x19, 0x20, 0x00, 0x00 }; /*8C89*/
const unsigned char  uc2_8C8A [] = {0x05, 0xF0, 0x1A, 0x40, 0x6A, 0x80, 0x2D, 0xF0, 0x15, 0x10, 0x6D, 0x10, 0x15, 0xF0, 0x6D, 0x10, 0x15, 0x10, 0x65, 0xF0, 0x19, 0x10, 0x00, 0x00 }; /*8C8A*/
const unsigned char  uc2_8C8C [] = {0x08, 0x80, 0x31, 0x00, 0x57, 0xE0, 0x3A, 0x20, 0x2B, 0xE0, 0x5A, 0x20, 0x2B, 0xE0, 0x59, 0x40, 0x29, 0x50, 0x4A, 0x50, 0x34, 0x30, 0x00, 0x00 }; /*8C8C*/
const unsigned char  uc2_8C94 [] = {0x10, 0x80, 0x77, 0xF0, 0x4D, 0x50, 0x34, 0x90, 0x55, 0x50, 0x37, 0xF0, 0x50, 0x00, 0x34, 0x50, 0x57, 0x60, 0x14, 0x50, 0x37, 0x70, 0x00, 0x00 }; /*8C94*/
const unsigned char  uc2_8C98 [] = {0x09, 0x40, 0x37, 0xF0, 0x55, 0x40, 0x5B, 0xE0, 0x2A, 0x20, 0x5B, 0xE0, 0x2A, 0x20, 0x5F, 0xF0, 0x28, 0x80, 0x49, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*8C98*/
const unsigned char  uc2_8D1D [] = {0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x14, 0x40, 0x05, 0x80, 0x08, 0x40, 0x10, 0x20, 0x60, 0x20, 0x00, 0x00 }; /*8D1D*/
const unsigned char  uc2_8D1E [] = {0x02, 0x00, 0x03, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x08, 0x40, 0x70, 0x20, 0x00, 0x00 }; /*8D1E*/
const unsigned char  uc2_8D1F [] = {0x08, 0x00, 0x0F, 0x00, 0x11, 0x00, 0x3F, 0xC0, 0x50, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x18, 0x40, 0x60, 0x20, 0x00, 0x00 }; /*8D1F*/
const unsigned char  uc2_8D21 [] = {0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x18, 0x40, 0x60, 0x20, 0x00, 0x00 }; /*8D21*/
const unsigned char  uc2_8D22 [] = {0x00, 0x20, 0x7C, 0x20, 0x44, 0x20, 0x55, 0xF0, 0x54, 0xA0, 0x54, 0xA0, 0x54, 0xA0, 0x19, 0x20, 0x25, 0x20, 0x22, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*8D22*/
const unsigned char  uc2_8D23 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x0D, 0x80, 0x70, 0x60, 0x00, 0x00 }; /*8D23*/
const unsigned char  uc2_8D24 [] = {0x0B, 0xC0, 0x29, 0x40, 0x28, 0x80, 0x0B, 0x70, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D24*/
const unsigned char  uc2_8D25 [] = {0x01, 0x00, 0x7D, 0x00, 0x45, 0xF0, 0x55, 0x20, 0x55, 0x20, 0x56, 0xA0, 0x54, 0xA0, 0x18, 0x40, 0x24, 0xA0, 0x25, 0x20, 0x42, 0x10, 0x00, 0x00 }; /*8D25*/
const unsigned char  uc2_8D26 [] = {0x01, 0x20, 0x7D, 0x20, 0x45, 0x40, 0x55, 0x80, 0x57, 0xF0, 0x55, 0x40, 0x55, 0x40, 0x19, 0x40, 0x25, 0x60, 0x25, 0xA0, 0x41, 0x10, 0x00, 0x00 }; /*8D26*/
const unsigned char  uc2_8D27 [] = {0x09, 0x40, 0x11, 0x90, 0x77, 0x10, 0x10, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x38, 0x40, 0x00, 0x00 }; /*8D27*/
const unsigned char  uc2_8D28 [] = {0x00, 0x70, 0x3F, 0x80, 0x21, 0x00, 0x3F, 0xF0, 0x22, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x29, 0x20, 0x29, 0x20, 0x42, 0xC0, 0x5C, 0x20, 0x00, 0x00 }; /*8D28*/
const unsigned char  uc2_8D29 [] = {0x00, 0x10, 0x7D, 0xE0, 0x45, 0x00, 0x55, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x55, 0x50, 0x11, 0x50, 0x29, 0x20, 0x2A, 0x20, 0x4A, 0x50, 0x00, 0x00 }; /*8D29*/
const unsigned char  uc2_8D2A [] = {0x02, 0x00, 0x0D, 0x80, 0x72, 0x70, 0x0F, 0x80, 0x00, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x38, 0x40, 0x00, 0x00 }; /*8D2A*/
const unsigned char  uc2_8D2B [] = {0x08, 0x80, 0x10, 0x40, 0x6F, 0xB0, 0x04, 0x80, 0x79, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x38, 0x40, 0x00, 0x00 }; /*8D2B*/
const unsigned char  uc2_8D2C [] = {0x00, 0x30, 0x7D, 0xC0, 0x44, 0x80, 0x54, 0x40, 0x55, 0xE0, 0x54, 0x20, 0x54, 0x40, 0x10, 0x80, 0x29, 0x00, 0x2A, 0xC0, 0x42, 0x30, 0x00, 0x00 }; /*8D2C*/
const unsigned char  uc2_8D2D [] = {0x01, 0x00, 0x7D, 0x00, 0x45, 0xF0, 0x56, 0x10, 0x54, 0x90, 0x54, 0x90, 0x55, 0x50, 0x19, 0xB0, 0x24, 0x10, 0x24, 0x10, 0x40, 0x60, 0x00, 0x00 }; /*8D2D*/
const unsigned char  uc2_8D2E [] = {0x00, 0x80, 0x7C, 0x40, 0x45, 0xF0, 0x55, 0x10, 0x55, 0x10, 0x54, 0x00, 0x54, 0x00, 0x18, 0x00, 0x24, 0x00, 0x25, 0xF0, 0x40, 0x00, 0x00, 0x00 }; /*8D2E*/
const unsigned char  uc2_8D2F [] = {0x0F, 0xE0, 0x09, 0x20, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D2F*/
const unsigned char  uc2_8D30 [] = {0x00, 0xA0, 0x7F, 0xF0, 0x00, 0x80, 0x3E, 0x80, 0x00, 0x80, 0x7F, 0x80, 0x22, 0x80, 0x2A, 0x90, 0x2A, 0x50, 0x14, 0x50, 0x64, 0x30, 0x00, 0x00 }; /*8D30*/
const unsigned char  uc2_8D31 [] = {0x00, 0xA0, 0x7C, 0x90, 0x44, 0xF0, 0x57, 0x80, 0x54, 0x80, 0x54, 0xF0, 0x57, 0x90, 0x18, 0xA0, 0x24, 0x40, 0x24, 0xD0, 0x43, 0x20, 0x00, 0x00 }; /*8D31*/
const unsigned char  uc2_8D32 [] = {0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D32*/
const unsigned char  uc2_8D33 [] = {0x14, 0x80, 0x7F, 0xF0, 0x14, 0x80, 0x17, 0x80, 0x10, 0x00, 0x1F, 0xE0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D33*/
const unsigned char  uc2_8D34 [] = {0x00, 0x80, 0x7C, 0x80, 0x44, 0xF0, 0x54, 0x80, 0x54, 0x80, 0x55, 0xE0, 0x55, 0x20, 0x19, 0x20, 0x25, 0x20, 0x25, 0xE0, 0x41, 0x20, 0x00, 0x00 }; /*8D34*/
const unsigned char  uc2_8D35 [] = {0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D35*/
const unsigned char  uc2_8D36 [] = {0x00, 0x00, 0x7D, 0xE0, 0x45, 0x20, 0x55, 0x20, 0x55, 0x20, 0x54, 0xE0, 0x55, 0x40, 0x19, 0x40, 0x25, 0x50, 0x25, 0x50, 0x42, 0x20, 0x00, 0x00 }; /*8D36*/
const unsigned char  uc2_8D37 [] = {0x09, 0x40, 0x11, 0xE0, 0x77, 0x10, 0x10, 0xD0, 0x00, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D37*/
const unsigned char  uc2_8D38 [] = {0x0C, 0x00, 0x33, 0xE0, 0x28, 0xA0, 0x34, 0xA0, 0x21, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x40, 0x00, 0x00 }; /*8D38*/
const unsigned char  uc2_8D39 [] = {0x09, 0x00, 0x3F, 0xC0, 0x09, 0x40, 0x3F, 0xC0, 0x49, 0x00, 0x7F, 0xE0, 0x09, 0x20, 0x3F, 0xC0, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D39*/
const unsigned char  uc2_8D3A [] = {0x08, 0x00, 0x3E, 0xF0, 0x0A, 0x90, 0x12, 0xF0, 0x64, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x0D, 0x80, 0x70, 0x40, 0x00, 0x00 }; /*8D3A*/
const unsigned char  uc2_8D3B [] = {0x00, 0x80, 0x7C, 0x80, 0x44, 0xA0, 0x55, 0x20, 0x55, 0xD0, 0x54, 0x10, 0x55, 0xE0, 0x11, 0x20, 0x29, 0x20, 0x25, 0xE0, 0x45, 0x20, 0x00, 0x00 }; /*8D3B*/
const unsigned char  uc2_8D3C [] = {0x00, 0x40, 0x7C, 0x50, 0x47, 0xF0, 0x55, 0x40, 0x55, 0x50, 0x57, 0xD0, 0x55, 0x50, 0x19, 0x60, 0x25, 0x50, 0x25, 0x50, 0x42, 0xA0, 0x00, 0x00 }; /*8D3C*/
const unsigned char  uc2_8D3D [] = {0x11, 0x00, 0x7B, 0xC0, 0x11, 0x50, 0x7B, 0x50, 0x11, 0xB0, 0x66, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D3D*/
const unsigned char  uc2_8D3E [] = {0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D3E*/
const unsigned char  uc2_8D3F [] = {0x00, 0x80, 0x7C, 0x80, 0x47, 0xF0, 0x55, 0x00, 0x57, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x19, 0x20, 0x25, 0xE0, 0x25, 0x20, 0x41, 0x40, 0x00, 0x00 }; /*8D3F*/
const unsigned char  uc2_8D40 [] = {0x09, 0x20, 0x2D, 0xC0, 0x29, 0x10, 0x2D, 0x10, 0x70, 0xE0, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x13, 0x00, 0x0C, 0xC0, 0x70, 0x20, 0x00, 0x00 }; /*8D40*/
const unsigned char  uc2_8D41 [] = {0x0B, 0xE0, 0x10, 0x80, 0x77, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D41*/
const unsigned char  uc2_8D42 [] = {0x00, 0x80, 0x7C, 0xE0, 0x45, 0x20, 0x56, 0xA0, 0x54, 0x40, 0x54, 0xA0, 0x57, 0x10, 0x19, 0xE0, 0x25, 0x20, 0x25, 0xE0, 0x41, 0x20, 0x00, 0x00 }; /*8D42*/
const unsigned char  uc2_8D43 [] = {0x00, 0x40, 0x7D, 0xF0, 0x45, 0x00, 0x55, 0x40, 0x55, 0x40, 0x55, 0xF0, 0x55, 0x40, 0x19, 0x40, 0x25, 0x40, 0x25, 0xF0, 0x42, 0x00, 0x00, 0x00 }; /*8D43*/
const unsigned char  uc2_8D44 [] = {0x32, 0x00, 0x0B, 0xE0, 0x04, 0xA0, 0x11, 0x40, 0x62, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D44*/
const unsigned char  uc2_8D45 [] = {0x00, 0x40, 0x7F, 0xF0, 0x44, 0x80, 0x55, 0x20, 0x55, 0xC0, 0x54, 0x50, 0x54, 0x90, 0x1B, 0x20, 0x24, 0x40, 0x24, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*8D45*/
const unsigned char  uc2_8D46 [] = {0x00, 0x00, 0x7D, 0xE0, 0x45, 0x20, 0x55, 0xE0, 0x55, 0x40, 0x55, 0x40, 0x55, 0x20, 0x12, 0xD0, 0x28, 0x20, 0x29, 0x80, 0x40, 0x40, 0x00, 0x00 }; /*8D46*/
const unsigned char  uc2_8D47 [] = {0x00, 0xA0, 0x7C, 0x90, 0x47, 0xF0, 0x54, 0x80, 0x56, 0x90, 0x55, 0xE0, 0x54, 0xA0, 0x11, 0xA0, 0x2A, 0x90, 0x28, 0x80, 0x4B, 0x00, 0x00, 0x00 }; /*8D47*/
const unsigned char  uc2_8D48 [] = {0x00, 0x00, 0x7D, 0xF0, 0x45, 0x00, 0x55, 0xE0, 0x55, 0x00, 0x55, 0xF0, 0x55, 0xA0, 0x1A, 0xB0, 0x26, 0xA0, 0x22, 0xE0, 0x44, 0x90, 0x00, 0x00 }; /*8D48*/
const unsigned char  uc2_8D49 [] = {0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x60, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D49*/
const unsigned char  uc2_8D4A [] = {0x00, 0x80, 0x7D, 0x40, 0x46, 0x30, 0x54, 0x00, 0x57, 0xE0, 0x54, 0x00, 0x57, 0xF0, 0x18, 0xA0, 0x26, 0x90, 0x24, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*8D4A*/
const unsigned char  uc2_8D4B [] = {0x00, 0x40, 0x7D, 0xE0, 0x44, 0x50, 0x57, 0xF0, 0x54, 0xA0, 0x56, 0xE0, 0x56, 0xA0, 0x12, 0xA0, 0x2A, 0xE0, 0x2B, 0x30, 0x4E, 0x20, 0x00, 0x00 }; /*8D4B*/
const unsigned char  uc2_8D4C [] = {0x00, 0x90, 0x7D, 0xF0, 0x44, 0xA0, 0x57, 0xF0, 0x54, 0x80, 0x55, 0xE0, 0x57, 0x20, 0x29, 0xE0, 0x25, 0x20, 0x25, 0xE0, 0x41, 0x20, 0x00, 0x00 }; /*8D4C*/
const unsigned char  uc2_8D4D [] = {0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x2A, 0xA0, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D4D*/
const unsigned char  uc2_8D4E [] = {0x00, 0x80, 0x7F, 0xE0, 0x44, 0x80, 0x57, 0xF0, 0x55, 0x10, 0x56, 0xC0, 0x55, 0x40, 0x1B, 0xF0, 0x24, 0x80, 0x25, 0x60, 0x42, 0x10, 0x00, 0x00 }; /*8D4E*/
const unsigned char  uc2_8D4F [] = {0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x48, 0x90, 0x0F, 0x80, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x05, 0x80, 0x78, 0x40, 0x00, 0x00 }; /*8D4F*/
const unsigned char  uc2_8D50 [] = {0x01, 0xE0, 0x7D, 0x20, 0x45, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x54, 0x80, 0x55, 0xF0, 0x1A, 0xB0, 0x25, 0x50, 0x26, 0x90, 0x41, 0x60, 0x00, 0x00 }; /*8D50*/
const unsigned char  uc2_8D53 [] = {0x02, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xF0, 0x2C, 0x60, 0x35, 0x50, 0x25, 0x40, 0x22, 0x80, 0x4C, 0x60, 0x00, 0x00 }; /*8D53*/
const unsigned char  uc2_8D54 [] = {0x00, 0x80, 0x7D, 0xE0, 0x45, 0x20, 0x55, 0x40, 0x57, 0xF0, 0x54, 0x00, 0x55, 0xE0, 0x19, 0x20, 0x25, 0x20, 0x25, 0xE0, 0x41, 0x20, 0x00, 0x00 }; /*8D54*/
const unsigned char  uc2_8D55 [] = {0x00, 0x50, 0x3E, 0xD0, 0x23, 0x60, 0x2A, 0x50, 0x2B, 0x90, 0x2A, 0x40, 0x2A, 0xD0, 0x0D, 0x50, 0x12, 0x60, 0x12, 0x90, 0x61, 0x10, 0x00, 0x00 }; /*8D55*/
const unsigned char  uc2_8D56 [] = {0x10, 0x80, 0x7E, 0xE0, 0x11, 0x20, 0x7D, 0xF0, 0x55, 0x10, 0x7D, 0x50, 0x19, 0x50, 0x35, 0x50, 0x54, 0xA0, 0x10, 0x90, 0x13, 0x10, 0x00, 0x00 }; /*8D56*/
const unsigned char  uc2_8D58 [] = {0x36, 0x40, 0x08, 0xF0, 0x3F, 0xA0, 0x08, 0x40, 0x7F, 0xB0, 0x12, 0x80, 0x7F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x38, 0x60, 0x00, 0x00 }; /*8D58*/
const unsigned char  uc2_8D59 [] = {0x00, 0x50, 0x7F, 0xF0, 0x45, 0x50, 0x55, 0xF0, 0x55, 0x50, 0x55, 0xF0, 0x55, 0x50, 0x18, 0x20, 0x27, 0xF0, 0x25, 0x20, 0x41, 0x40, 0x00, 0x00 }; /*8D59*/
const unsigned char  uc2_8D5A [] = {0x01, 0x40, 0x7F, 0xF0, 0x45, 0x40, 0x57, 0xF0, 0x55, 0x50, 0x57, 0xF0, 0x55, 0x50, 0x13, 0xF0, 0x29, 0x60, 0x2B, 0x50, 0x4D, 0x40, 0x00, 0x00 }; /*8D5A*/
const unsigned char  uc2_8D5B [] = {0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x3F, 0xE0, 0x52, 0x50, 0x05, 0x80, 0x78, 0x60, 0x00, 0x00 }; /*8D5B*/
const unsigned char  uc2_8D5C [] = {0x00, 0x80, 0x7F, 0xE0, 0x48, 0x80, 0x4B, 0xE0, 0x5C, 0x80, 0x57, 0xF0, 0x5A, 0x20, 0x4A, 0xA0, 0x4A, 0x80, 0x7D, 0x60, 0x06, 0x10, 0x00, 0x00 }; /*8D5C*/
const unsigned char  uc2_8D5D [] = {0x3F, 0xF0, 0x25, 0x40, 0x29, 0xF0, 0x3B, 0x40, 0x29, 0xE0, 0x29, 0x40, 0x2F, 0xF0, 0x28, 0x20, 0x29, 0x20, 0x22, 0xC0, 0x4C, 0x20, 0x00, 0x00 }; /*8D5D*/
const unsigned char  uc2_8D5E [] = {0x29, 0x40, 0x3F, 0xE0, 0x4A, 0x40, 0x7F, 0xF0, 0x14, 0xA0, 0x65, 0x10, 0x1F, 0xC0, 0x10, 0x40, 0x12, 0x40, 0x03, 0x80, 0x3C, 0x60, 0x00, 0x00 }; /*8D5E*/
const unsigned char  uc2_8D60 [] = {0x02, 0x10, 0x7D, 0x20, 0x47, 0xF0, 0x56, 0xB0, 0x55, 0xD0, 0x54, 0x90, 0x57, 0xF0, 0x2A, 0x20, 0x27, 0xE0, 0x22, 0x20, 0x43, 0xE0, 0x00, 0x00 }; /*8D60*/
const unsigned char  uc2_8D61 [] = {0x01, 0xC0, 0x7E, 0x40, 0x47, 0xF0, 0x56, 0xA0, 0x55, 0xD0, 0x54, 0x00, 0x55, 0xE0, 0x1C, 0x00, 0x27, 0xF0, 0x25, 0x20, 0x49, 0xE0, 0x00, 0x00 }; /*8D61*/
const unsigned char  uc2_8D62 [] = {0x02, 0x00, 0x7F, 0xF0, 0x20, 0x00, 0x1F, 0xE0, 0x08, 0x80, 0x3F, 0xE0, 0x28, 0xA0, 0x3A, 0xA0, 0x2A, 0xE0, 0x3A, 0xA0, 0x4D, 0x10, 0x00, 0x00 }; /*8D62*/
const unsigned char  uc2_8D63 [] = {0x11, 0x00, 0x7D, 0xE0, 0x2A, 0x20, 0x7D, 0xC0, 0x2A, 0x30, 0x3B, 0xE0, 0x28, 0x80, 0x13, 0xF0, 0x7E, 0xA0, 0x10, 0x80, 0x17, 0x60, 0x00, 0x00 }; /*8D63*/
const unsigned char  uc2_8D64 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x28, 0xA0, 0x28, 0x90, 0x48, 0x90, 0x10, 0x80, 0x63, 0x00, 0x00, 0x00 }; /*8D64*/
const unsigned char  uc2_8D66 [] = {0x08, 0x80, 0x3E, 0x80, 0x08, 0xF0, 0x7F, 0xA0, 0x14, 0xA0, 0x36, 0xA0, 0x55, 0x40, 0x55, 0x40, 0x14, 0xA0, 0x24, 0xA0, 0x59, 0x10, 0x00, 0x00 }; /*8D66*/
const unsigned char  uc2_8D67 [] = {0x10, 0x00, 0x39, 0xF0, 0x11, 0x10, 0x7D, 0x60, 0x29, 0x00, 0x29, 0xF0, 0x6D, 0x50, 0x29, 0x50, 0x29, 0x20, 0x29, 0x20, 0x51, 0x50, 0x00, 0x00 }; /*8D67*/
const unsigned char  uc2_8D6B [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x15, 0x40, 0x15, 0x40, 0x35, 0x60, 0x57, 0x50, 0x15, 0x50, 0x25, 0x40, 0x5A, 0x80, 0x00, 0x00 }; /*8D6B*/
const unsigned char  uc2_8D6D [] = {0x08, 0x40, 0x3E, 0xF0, 0x09, 0x50, 0x7F, 0xF0, 0x14, 0x40, 0x36, 0xF0, 0x55, 0x90, 0x56, 0xF0, 0x14, 0x90, 0x24, 0xF0, 0x58, 0x90, 0x00, 0x00 }; /*8D6D*/
const unsigned char  uc2_8D70 [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x1A, 0x00, 0x16, 0x00, 0x61, 0xF0, 0x00, 0x00 }; /*8D70*/
const unsigned char  uc2_8D73 [] = {0x08, 0x10, 0x3E, 0x90, 0x08, 0x90, 0x08, 0x90, 0x7F, 0x90, 0x08, 0xB0, 0x2E, 0xD0, 0x28, 0x10, 0x38, 0x10, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D73*/
const unsigned char  uc2_8D74 [] = {0x08, 0x40, 0x3E, 0x40, 0x08, 0x40, 0x08, 0x60, 0x7F, 0x50, 0x08, 0x50, 0x2E, 0x40, 0x28, 0x40, 0x38, 0x40, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D74*/
const unsigned char  uc2_8D75 [] = {0x09, 0x20, 0x3E, 0xA0, 0x08, 0xA0, 0x08, 0x40, 0x7F, 0x40, 0x08, 0xA0, 0x2E, 0xA0, 0x29, 0x20, 0x38, 0x00, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D75*/
const unsigned char  uc2_8D76 [] = {0x08, 0x00, 0x3E, 0xE0, 0x08, 0x40, 0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x2E, 0x40, 0x28, 0x40, 0x38, 0x40, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D76*/
const unsigned char  uc2_8D77 [] = {0x08, 0x00, 0x3E, 0xE0, 0x08, 0x20, 0x08, 0x20, 0x7E, 0xE0, 0x08, 0xA0, 0x28, 0x90, 0x2E, 0x90, 0x38, 0x60, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D77*/
const unsigned char  uc2_8D81 [] = {0x08, 0x40, 0x3E, 0x40, 0x08, 0xB0, 0x09, 0x20, 0x7E, 0xD0, 0x08, 0x20, 0x2E, 0xD0, 0x28, 0x20, 0x39, 0xC0, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D81*/
const unsigned char  uc2_8D84 [] = {0x08, 0x00, 0x3E, 0xE0, 0x08, 0xA0, 0x08, 0xE0, 0x7F, 0xA0, 0x08, 0xE0, 0x2E, 0xA0, 0x28, 0xA0, 0x39, 0xF0, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D84*/
const unsigned char  uc2_8D85 [] = {0x09, 0xF0, 0x3E, 0x50, 0x08, 0x50, 0x08, 0x90, 0x7F, 0x20, 0x08, 0xF0, 0x2E, 0x90, 0x28, 0xF0, 0x38, 0x90, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D85*/
const unsigned char  uc2_8D8A [] = {0x08, 0xA0, 0x3F, 0xF0, 0x0A, 0x80, 0x0A, 0x90, 0x7E, 0x90, 0x0B, 0x60, 0x2E, 0x50, 0x28, 0xD0, 0x3B, 0x20, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D8A*/
const unsigned char  uc2_8D8B [] = {0x08, 0x80, 0x3E, 0xF0, 0x08, 0x90, 0x09, 0x20, 0x7F, 0xF0, 0x08, 0x10, 0x2E, 0xF0, 0x28, 0x10, 0x39, 0xF0, 0x2C, 0x10, 0x43, 0xF0, 0x00, 0x00 }; /*8D8B*/
const unsigned char  uc2_8D91 [] = {0x08, 0x80, 0x3E, 0xF0, 0x0A, 0x90, 0x09, 0x40, 0x7C, 0x40, 0x09, 0x40, 0x2E, 0xA0, 0x28, 0x90, 0x39, 0x10, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8D91*/
const unsigned char  uc2_8D94 [] = {0x17, 0x10, 0x3A, 0x50, 0x13, 0x50, 0x15, 0x50, 0x7D, 0x50, 0x13, 0x50, 0x5A, 0x10, 0x52, 0x10, 0x74, 0x60, 0x58, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8D94*/
const unsigned char  uc2_8D9F [] = {0x10, 0x80, 0x3E, 0xA0, 0x11, 0x40, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x5D, 0x50, 0x55, 0xD0, 0x74, 0x10, 0x5C, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*8D9F*/
const unsigned char  uc2_8DA3 [] = {0x17, 0xC0, 0x3A, 0xB0, 0x13, 0xD0, 0x12, 0xD0, 0x7F, 0xA0, 0x12, 0xA0, 0x5F, 0xA0, 0x52, 0xD0, 0x70, 0x90, 0x58, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*8DA3*/
const unsigned char  uc2_8DB1 [] = {0x12, 0xA0, 0x3B, 0xF0, 0x14, 0xA0, 0x13, 0xF0, 0x39, 0x20, 0x12, 0xD0, 0x5B, 0xE0, 0x52, 0x20, 0x72, 0xA0, 0x59, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*8DB1*/
const unsigned char  uc2_8DB3 [] = {0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x12, 0x00, 0x13, 0xE0, 0x12, 0x00, 0x2E, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*8DB3*/
const unsigned char  uc2_8DB4 [] = {0x00, 0xA0, 0x3C, 0xA0, 0x24, 0xA0, 0x24, 0xA0, 0x3C, 0xA0, 0x08, 0xA0, 0x2E, 0xA0, 0x28, 0xA0, 0x2F, 0x20, 0x71, 0x10, 0x02, 0x10, 0x00, 0x00 }; /*8DB4*/
const unsigned char  uc2_8DB5 [] = {0x01, 0x00, 0x3D, 0x00, 0x25, 0xF0, 0x26, 0x10, 0x3C, 0x90, 0x08, 0x50, 0x2E, 0x50, 0x28, 0x10, 0x2E, 0x10, 0x70, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8DB5*/
const unsigned char  uc2_8DB8 [] = {0x7F, 0xF0, 0x04, 0x00, 0x0F, 0xC0, 0x10, 0x40, 0x6F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x12, 0x00, 0x13, 0xC0, 0x1A, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*8DB8*/
const unsigned char  uc2_8DBA [] = {0x00, 0x80, 0x3C, 0x80, 0x27, 0xE0, 0x24, 0x80, 0x3C, 0x80, 0x0B, 0xF0, 0x2D, 0x40, 0x29, 0x40, 0x2D, 0x20, 0x72, 0x20, 0x04, 0x10, 0x00, 0x00 }; /*8DBA*/
const unsigned char  uc2_8DBC [] = {0x00, 0x00, 0x3F, 0xE0, 0x25, 0x40, 0x25, 0x40, 0x3D, 0x40, 0x0B, 0xF0, 0x2D, 0x40, 0x29, 0x40, 0x2E, 0x40, 0x72, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*8DBC*/
const unsigned char  uc2_8DBE [] = {0x00, 0x40, 0x3C, 0x40, 0x25, 0x40, 0x25, 0x40, 0x3D, 0x70, 0x09, 0x40, 0x2D, 0x40, 0x29, 0x40, 0x2D, 0x40, 0x71, 0x40, 0x03, 0xF0, 0x00, 0x00 }; /*8DBE*/
const unsigned char  uc2_8DBF [] = {0x00, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x40, 0x3D, 0x70, 0x09, 0x10, 0x2F, 0xA0, 0x29, 0x60, 0x2E, 0x40, 0x72, 0xA0, 0x05, 0x10, 0x00, 0x00 }; /*8DBF*/
const unsigned char  uc2_8DC3 [] = {0x00, 0x30, 0x3D, 0xC0, 0x24, 0x40, 0x24, 0x40, 0x3F, 0xF0, 0x08, 0x40, 0x2E, 0xA0, 0x28, 0xA0, 0x2F, 0x20, 0x71, 0x10, 0x02, 0x10, 0x00, 0x00 }; /*8DC3*/
const unsigned char  uc2_8DC4 [] = {0x00, 0x80, 0x3C, 0xC0, 0x25, 0x20, 0x26, 0x10, 0x3D, 0xE0, 0x09, 0x20, 0x2D, 0x20, 0x29, 0x40, 0x2F, 0x10, 0x71, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*8DC4*/
const unsigned char  uc2_8DC6 [] = {0x00, 0x40, 0x3C, 0x80, 0x24, 0xA0, 0x25, 0x10, 0x3D, 0xF0, 0x08, 0x10, 0x2E, 0xE0, 0x28, 0xA0, 0x28, 0xA0, 0x2E, 0xE0, 0x70, 0xA0, 0x00, 0x00 }; /*8DC6*/
const unsigned char  uc2_8DCB [] = {0x01, 0x40, 0x79, 0x20, 0x4F, 0xF0, 0x49, 0x00, 0x79, 0xE0, 0x11, 0x20, 0x5E, 0xA0, 0x52, 0xA0, 0x5C, 0x40, 0x34, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*8DCB*/
const unsigned char  uc2_8DCC [] = {0x00, 0x40, 0x3D, 0x40, 0x25, 0xE0, 0x26, 0x40, 0x3C, 0x40, 0x0B, 0xF0, 0x28, 0x40, 0x2E, 0xA0, 0x28, 0xA0, 0x2E, 0xA0, 0x71, 0x10, 0x00, 0x00 }; /*8DCC*/
const unsigned char  uc2_8DCE [] = {0x00, 0x80, 0x3C, 0x40, 0x25, 0xF0, 0x26, 0x10, 0x3D, 0x00, 0x09, 0x20, 0x2F, 0xC0, 0x29, 0x00, 0x29, 0x10, 0x2F, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*8DCE*/
const unsigned char  uc2_8DCF [] = {0x01, 0x00, 0x3D, 0x70, 0x27, 0xD0, 0x25, 0x50, 0x3D, 0x50, 0x09, 0x50, 0x2F, 0x50, 0x29, 0x50, 0x2F, 0x50, 0x71, 0x70, 0x06, 0x90, 0x00, 0x00 }; /*8DCF*/
const unsigned char  uc2_8DD1 [] = {0x01, 0x00, 0x3D, 0x00, 0x25, 0xF0, 0x26, 0x10, 0x3D, 0xD0, 0x09, 0x50, 0x2D, 0xD0, 0x29, 0x60, 0x29, 0x10, 0x2F, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*8DD1*/
const unsigned char  uc2_8DD6 [] = {0x3F, 0xF0, 0x24, 0x80, 0x24, 0x80, 0x3D, 0x00, 0x09, 0xE0, 0x2F, 0x20, 0x29, 0x20, 0x29, 0x20, 0x2F, 0x20, 0x71, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*8DD6*/
const unsigned char  uc2_8DD7 [] = {0x00, 0xA0, 0x3C, 0xA0, 0x25, 0x20, 0x27, 0xF0, 0x3D, 0x20, 0x09, 0xA0, 0x2F, 0x60, 0x29, 0x20, 0x29, 0x20, 0x2F, 0x20, 0x71, 0x40, 0x00, 0x00 }; /*8DD7*/
const unsigned char  uc2_8DDA [] = {0x7B, 0xE0, 0x4A, 0xA0, 0x4A, 0xA0, 0x7A, 0xA0, 0x17, 0xF0, 0x5A, 0xA0, 0x52, 0xA0, 0x52, 0xA0, 0x3E, 0xA0, 0x62, 0xA0, 0x05, 0x40, 0x00, 0x00 }; /*8DDA*/
const unsigned char  uc2_8DDB [] = {0x00, 0x40, 0x7B, 0xF0, 0x4A, 0x50, 0x4A, 0x40, 0x7B, 0xE0, 0x12, 0xA0, 0x52, 0xA0, 0x5A, 0x40, 0x52, 0x40, 0x3A, 0xA0, 0x65, 0x10, 0x00, 0x00 }; /*8DDB*/
const unsigned char  uc2_8DDD [] = {0x00, 0x00, 0x3D, 0xF0, 0x25, 0x00, 0x25, 0x00, 0x3D, 0xE0, 0x09, 0x20, 0x2F, 0x20, 0x29, 0xE0, 0x29, 0x00, 0x2F, 0x00, 0x71, 0xF0, 0x00, 0x00 }; /*8DDD*/
const unsigned char  uc2_8DDE [] = {0x00, 0x20, 0x3D, 0xC0, 0x25, 0x00, 0x25, 0x40, 0x3E, 0x40, 0x09, 0xF0, 0x2E, 0x40, 0x29, 0x60, 0x29, 0x50, 0x2E, 0x50, 0x71, 0x80, 0x00, 0x00 }; /*8DDE*/
const unsigned char  uc2_8DDF [] = {0x3D, 0xF0, 0x25, 0x10, 0x25, 0xF0, 0x3D, 0x10, 0x09, 0xF0, 0x2F, 0x40, 0x29, 0x50, 0x29, 0x20, 0x2F, 0x20, 0x71, 0xD0, 0x01, 0x10, 0x00, 0x00 }; /*8DDF*/
const unsigned char  uc2_8DE3 [] = {0x02, 0x80, 0x7A, 0x80, 0x4B, 0xE0, 0x4C, 0x80, 0x78, 0x80, 0x17, 0xF0, 0x5D, 0x40, 0x51, 0x40, 0x56, 0x50, 0x3A, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*8DE3*/
const unsigned char  uc2_8DE4 [] = {0x00, 0x80, 0x3C, 0x40, 0x27, 0xF0, 0x25, 0x20, 0x3E, 0x10, 0x09, 0x50, 0x2D, 0x40, 0x28, 0x80, 0x2F, 0x40, 0x71, 0x40, 0x06, 0x30, 0x00, 0x00 }; /*8DE4*/
const unsigned char  uc2_8DE8 [] = {0x3C, 0x80, 0x27, 0xF0, 0x25, 0x40, 0x3E, 0x30, 0x09, 0xC0, 0x2C, 0x00, 0x2B, 0xF0, 0x29, 0x00, 0x2D, 0xE0, 0x70, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*8DE8*/
const unsigned char  uc2_8DEA [] = {0x01, 0x00, 0x79, 0xC0, 0x4A, 0x40, 0x4F, 0xF0, 0x7A, 0x00, 0x12, 0xE0, 0x52, 0xA0, 0x5A, 0xC0, 0x52, 0x90, 0x3A, 0x90, 0x64, 0x60, 0x00, 0x00 }; /*8DEA*/
const unsigned char  uc2_8DEB [] = {0x3D, 0xC0, 0x11, 0x50, 0x1D, 0xD0, 0x62, 0x20, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x02, 0x00, 0x13, 0xC0, 0x1A, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*8DEB*/
const unsigned char  uc2_8DEC [] = {0x00, 0x40, 0x3C, 0x40, 0x24, 0xE0, 0x24, 0x40, 0x3D, 0xF0, 0x08, 0x00, 0x28, 0x40, 0x2E, 0xE0, 0x28, 0x40, 0x2E, 0x40, 0x71, 0xF0, 0x00, 0x00 }; /*8DEC*/
const unsigned char  uc2_8DEF [] = {0x3C, 0x80, 0x24, 0xE0, 0x27, 0x20, 0x3D, 0x40, 0x08, 0xA0, 0x2F, 0x10, 0x29, 0xE0, 0x29, 0x20, 0x2F, 0x20, 0x71, 0xE0, 0x01, 0x20, 0x00, 0x00 }; /*8DEF*/
const unsigned char  uc2_8DF3 [] = {0x01, 0x40, 0x79, 0x40, 0x4D, 0x50, 0x4B, 0x60, 0x79, 0x40, 0x13, 0x60, 0x55, 0x50, 0x59, 0x40, 0x52, 0x50, 0x3A, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*8DF3*/
const unsigned char  uc2_8DF5 [] = {0x00, 0xA0, 0x3C, 0x90, 0x24, 0xE0, 0x27, 0x80, 0x3C, 0x90, 0x08, 0xE0, 0x2B, 0x90, 0x2C, 0xA0, 0x28, 0x50, 0x2C, 0xD0, 0x73, 0x20, 0x00, 0x00 }; /*8DF5*/
const unsigned char  uc2_8DF7 [] = {0x01, 0x60, 0x7F, 0x80, 0x49, 0x00, 0x48, 0xE0, 0x7B, 0x90, 0x10, 0x50, 0x57, 0xF0, 0x59, 0x40, 0x55, 0x50, 0x3A, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*8DF7*/
const unsigned char  uc2_8DF8 [] = {0x02, 0x40, 0x7A, 0x50, 0x4B, 0xE0, 0x4A, 0x50, 0x7A, 0xD0, 0x13, 0x20, 0x58, 0x80, 0x57, 0xF0, 0x50, 0x80, 0x3C, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*8DF8*/
const unsigned char  uc2_8DF9 [] = {0x04, 0x10, 0x7A, 0xE0, 0x4A, 0x40, 0x48, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x52, 0x40, 0x5A, 0x40, 0x52, 0x40, 0x3B, 0x00, 0x44, 0xF0, 0x00, 0x00 }; /*8DF9*/
const unsigned char  uc2_8DFA [] = {0x00, 0x00, 0x3C, 0xE0, 0x24, 0xA0, 0x24, 0xA0, 0x3D, 0x10, 0x08, 0x40, 0x2D, 0xF0, 0x28, 0x40, 0x28, 0xE0, 0x2D, 0x50, 0x70, 0x40, 0x00, 0x00 }; /*8DFA*/
const unsigned char  uc2_8DFB [] = {0x3C, 0x40, 0x27, 0xF0, 0x25, 0x20, 0x3C, 0xC0, 0x0B, 0x30, 0x28, 0x00, 0x2D, 0x20, 0x29, 0x20, 0x2D, 0x20, 0x71, 0x20, 0x02, 0x20, 0x00, 0x00 }; /*8DFB*/
const unsigned char  uc2_8DFD [] = {0x00, 0x00, 0x7B, 0xE0, 0x48, 0x20, 0x4B, 0xE0, 0x7A, 0x20, 0x12, 0x10, 0x51, 0xE0, 0x5A, 0x90, 0x55, 0x50, 0x3D, 0x20, 0x40, 0xE0, 0x00, 0x00 }; /*8DFD*/
const unsigned char  uc2_8DFF [] = {0x00, 0x80, 0x7B, 0xE0, 0x48, 0x80, 0x48, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x52, 0x80, 0x5E, 0xE0, 0x52, 0x80, 0x3B, 0x80, 0x44, 0x70, 0x00, 0x00 }; /*8DFF*/
const unsigned char  uc2_8E05 [] = {0x10, 0x60, 0x7D, 0x80, 0x11, 0x00, 0x7D, 0xF0, 0x11, 0x20, 0x3F, 0xE0, 0x20, 0x40, 0x3F, 0xC0, 0x02, 0x60, 0x12, 0x80, 0x6F, 0xF0, 0x00, 0x00 }; /*8E05*/
const unsigned char  uc2_8E09 [] = {0x00, 0x40, 0x3D, 0xF0, 0x25, 0x10, 0x25, 0xF0, 0x3D, 0x10, 0x09, 0xF0, 0x2D, 0x40, 0x29, 0x50, 0x2D, 0x20, 0x71, 0xA0, 0x01, 0x10, 0x00, 0x00 }; /*8E09*/
const unsigned char  uc2_8E0A [] = {0x01, 0xE0, 0x3C, 0xA0, 0x24, 0x40, 0x25, 0xF0, 0x3D, 0x50, 0x09, 0xF0, 0x2D, 0x50, 0x29, 0xF0, 0x2D, 0x50, 0x71, 0x50, 0x01, 0x20, 0x00, 0x00 }; /*8E0A*/
const unsigned char  uc2_8E0C [] = {0x00, 0x40, 0x3D, 0xF0, 0x24, 0x40, 0x24, 0xE0, 0x3C, 0x40, 0x09, 0xF0, 0x2C, 0xA0, 0x29, 0xF0, 0x2E, 0xA0, 0x70, 0xA0, 0x00, 0x40, 0x00, 0x00 }; /*8E0C*/
const unsigned char  uc2_8E0F [] = {0x00, 0x80, 0x7E, 0x90, 0x4A, 0xE0, 0x4A, 0xA0, 0x7D, 0x90, 0x10, 0x00, 0x5B, 0xE0, 0x52, 0x20, 0x5F, 0xE0, 0x62, 0x20, 0x03, 0xE0, 0x00, 0x00 }; /*8E0F*/
const unsigned char  uc2_8E14 [] = {0x00, 0x80, 0x78, 0xF0, 0x48, 0x80, 0x4B, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x5A, 0x20, 0x53, 0xE0, 0x58, 0x80, 0x67, 0xF0, 0x00, 0x80, 0x00, 0x00 }; /*8E14*/
const unsigned char  uc2_8E1D [] = {0x03, 0xE0, 0x7A, 0xA0, 0x4B, 0xE0, 0x4A, 0xA0, 0x7B, 0xE0, 0x10, 0x80, 0x5F, 0xF0, 0x51, 0x80, 0x5E, 0xC0, 0x30, 0xB0, 0x40, 0x80, 0x00, 0x00 }; /*8E1D*/
const unsigned char  uc2_8E1E [] = {0x03, 0xF0, 0x7A, 0x10, 0x4B, 0xF0, 0x4A, 0x00, 0x7A, 0x40, 0x13, 0xF0, 0x5A, 0x40, 0x52, 0xE0, 0x5C, 0xA0, 0x34, 0xE0, 0x48, 0xA0, 0x00, 0x00 }; /*8E1E*/
const unsigned char  uc2_8E1F [] = {0x02, 0x00, 0x7A, 0x70, 0x4B, 0xD0, 0x4D, 0x50, 0x79, 0x50, 0x17, 0xD0, 0x59, 0x50, 0x52, 0xD0, 0x5E, 0x50, 0x32, 0x70, 0x4C, 0x50, 0x00, 0x00 }; /*8E1F*/
const unsigned char  uc2_8E22 [] = {0x01, 0xE0, 0x3D, 0x20, 0x25, 0xE0, 0x25, 0x20, 0x3D, 0xE0, 0x09, 0x00, 0x2D, 0xF0, 0x2A, 0xB0, 0x2D, 0x50, 0x72, 0x50, 0x01, 0xA0, 0x00, 0x00 }; /*8E22*/
const unsigned char  uc2_8E23 [] = {0x00, 0x80, 0x3C, 0x40, 0x25, 0xF0, 0x24, 0xA0, 0x3F, 0xF0, 0x08, 0x00, 0x2F, 0xF0, 0x29, 0x10, 0x2F, 0x10, 0x71, 0xF0, 0x01, 0x10, 0x00, 0x00 }; /*8E23*/
const unsigned char  uc2_8E29 [] = {0x00, 0x70, 0x7B, 0x80, 0x4D, 0x20, 0x4A, 0xA0, 0x78, 0x40, 0x10, 0x80, 0x5F, 0xF0, 0x51, 0x80, 0x5A, 0xC0, 0x34, 0xB0, 0x40, 0x80, 0x00, 0x00 }; /*8E29*/
const unsigned char  uc2_8E2A [] = {0x03, 0x00, 0x78, 0x80, 0x4B, 0xF0, 0x4C, 0x10, 0x7B, 0xE0, 0x10, 0x00, 0x5F, 0xF0, 0x52, 0xA0, 0x5A, 0x90, 0x34, 0x90, 0x41, 0x80, 0x00, 0x00 }; /*8E2A*/
const unsigned char  uc2_8E2C [] = {0x00, 0x30, 0x3D, 0xC0, 0x25, 0x20, 0x25, 0xF0, 0x3D, 0x40, 0x09, 0xF0, 0x0D, 0x10, 0x29, 0x50, 0x2D, 0x40, 0x3A, 0x60, 0x64, 0x90, 0x00, 0x00 }; /*8E2C*/
const unsigned char  uc2_8E2E [] = {0x01, 0x80, 0x78, 0x40, 0x4B, 0xF0, 0x4A, 0x40, 0x7A, 0x70, 0x12, 0x40, 0x5A, 0xE0, 0x52, 0xA0, 0x5E, 0xA0, 0x32, 0xE0, 0x44, 0xA0, 0x00, 0x00 }; /*8E2E*/
const unsigned char  uc2_8E2F [] = {0x05, 0x00, 0x7A, 0x70, 0x4F, 0x50, 0x4A, 0x50, 0x7A, 0x60, 0x17, 0xD0, 0x5A, 0x50, 0x53, 0x50, 0x5C, 0xE0, 0x34, 0x40, 0x48, 0x40, 0x00, 0x00 }; /*8E2F*/
const unsigned char  uc2_8E31 [] = {0x00, 0x40, 0x7B, 0xF0, 0x4A, 0xA0, 0x4B, 0xF0, 0x7A, 0xA0, 0x12, 0xE0, 0x5A, 0x00, 0x53, 0xE0, 0x5E, 0xA0, 0x22, 0x40, 0x45, 0xB0, 0x00, 0x00 }; /*8E31*/
const unsigned char  uc2_8E35 [] = {0x00, 0x60, 0x7B, 0x80, 0x48, 0x80, 0x4F, 0xF0, 0x7B, 0x60, 0x12, 0xA0, 0x5F, 0xE0, 0x50, 0x80, 0x5F, 0xE0, 0x30, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*8E35*/
const unsigned char  uc2_8E39 [] = {0x00, 0x80, 0x74, 0x90, 0x4F, 0xF0, 0x48, 0x00, 0x77, 0xF0, 0x10, 0x80, 0x5F, 0xF0, 0x55, 0x50, 0x5D, 0x50, 0x35, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*8E39*/
const unsigned char  uc2_8E3A [] = {0x00, 0xF0, 0x76, 0x50, 0x4B, 0xF0, 0x4C, 0x50, 0x76, 0xF0, 0x12, 0x40, 0x5A, 0xE0, 0x56, 0x40, 0x5A, 0xF0, 0x35, 0x40, 0x48, 0xF0, 0x00, 0x00 }; /*8E3A*/
const unsigned char  uc2_8E3D [] = {0x00, 0x60, 0x7B, 0x80, 0x48, 0x80, 0x4B, 0xE0, 0x7A, 0xA0, 0x13, 0xE0, 0x58, 0x80, 0x57, 0xF0, 0x55, 0x50, 0x3D, 0xD0, 0x44, 0x20, 0x00, 0x00 }; /*8E3D*/
const unsigned char  uc2_8E40 [] = {0x00, 0xA0, 0x7A, 0xA0, 0x4F, 0xF0, 0x4A, 0xA0, 0x7A, 0xE0, 0x12, 0x00, 0x5B, 0xF0, 0x50, 0x80, 0x57, 0xF0, 0x5A, 0xA0, 0x64, 0x90, 0x00, 0x00 }; /*8E40*/
const unsigned char  uc2_8E41 [] = {0x00, 0x80, 0x77, 0xF0, 0x4C, 0x10, 0x4F, 0xF0, 0x74, 0x00, 0x17, 0xF0, 0x5D, 0x50, 0x57, 0xF0, 0x5D, 0x50, 0x25, 0x10, 0x48, 0x60, 0x00, 0x00 }; /*8E41*/
const unsigned char  uc2_8E42 [] = {0x03, 0xE0, 0x79, 0x20, 0x48, 0xC0, 0x4B, 0xF0, 0x79, 0x50, 0x16, 0xC0, 0x58, 0x80, 0x57, 0xF0, 0x59, 0xC0, 0x66, 0xB0, 0x00, 0x80, 0x00, 0x00 }; /*8E42*/
const unsigned char  uc2_8E44 [] = {0x00, 0x80, 0x7B, 0xE0, 0x49, 0x40, 0x48, 0x80, 0x77, 0xF0, 0x14, 0x90, 0x5B, 0xE0, 0x52, 0xA0, 0x5E, 0xC0, 0x30, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*8E44*/
const unsigned char  uc2_8E47 [] = {0x02, 0x00, 0x7F, 0xF0, 0x45, 0x10, 0x3F, 0xE0, 0x05, 0x00, 0x7F, 0xF0, 0x28, 0xA0, 0x4F, 0x90, 0x12, 0xE0, 0x1A, 0x00, 0x67, 0xF0, 0x00, 0x00 }; /*8E47*/
const unsigned char  uc2_8E48 [] = {0x00, 0x60, 0x77, 0x80, 0x4D, 0x20, 0x4A, 0xA0, 0x79, 0x40, 0x16, 0x70, 0x5C, 0x10, 0x57, 0x70, 0x5C, 0x10, 0x37, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*8E48*/
const unsigned char  uc2_8E49 [] = {0x02, 0x20, 0x79, 0x40, 0x4F, 0xF0, 0x48, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x5F, 0xF0, 0x51, 0x00, 0x5D, 0xE0, 0x32, 0x40, 0x4D, 0xF0, 0x00, 0x00 }; /*8E49*/
const unsigned char  uc2_8E4A [] = {0x00, 0x70, 0x7F, 0xA0, 0x4A, 0xA0, 0x49, 0x40, 0x7B, 0x80, 0x11, 0x60, 0x5B, 0x90, 0x50, 0x80, 0x5F, 0xF0, 0x31, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*8E4A*/
const unsigned char  uc2_8E4B [] = {0x00, 0x00, 0x7B, 0xE0, 0x4A, 0x20, 0x4B, 0xE0, 0x7A, 0x20, 0x17, 0x70, 0x5A, 0xD0, 0x51, 0xB0, 0x5E, 0xD0, 0x30, 0x90, 0x43, 0x60, 0x00, 0x00 }; /*8E4B*/
const unsigned char  uc2_8E51 [] = {0x07, 0xF0, 0x7A, 0x20, 0x4B, 0xE0, 0x4A, 0x20, 0x7F, 0xF0, 0x10, 0x20, 0x5F, 0xF0, 0x55, 0x50, 0x55, 0x50, 0x5A, 0x20, 0x65, 0x50, 0x00, 0x00 }; /*8E51*/
const unsigned char  uc2_8E52 [] = {0x01, 0x40, 0x7F, 0xF0, 0x49, 0x40, 0x4F, 0xF0, 0x79, 0x40, 0x17, 0xF0, 0x5D, 0x50, 0x55, 0x50, 0x5E, 0xB0, 0x34, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*8E52*/
const unsigned char  uc2_8E59 [] = {0x00, 0x50, 0x3F, 0xF0, 0x25, 0x40, 0x24, 0x50, 0x5F, 0x60, 0x55, 0x50, 0x0F, 0xB0, 0x08, 0x80, 0x0F, 0xE0, 0x12, 0x00, 0x6F, 0xF0, 0x00, 0x00 }; /*8E59*/
const unsigned char  uc2_8E66 [] = {0x00, 0x80, 0x74, 0x90, 0x4F, 0xF0, 0x48, 0x00, 0x77, 0x70, 0x15, 0x50, 0x5F, 0x70, 0x55, 0x50, 0x5F, 0x70, 0x25, 0x50, 0x4A, 0xA0, 0x00, 0x00 }; /*8E66*/
const unsigned char  uc2_8E69 [] = {0x54, 0x80, 0x7C, 0xF0, 0x55, 0xA0, 0x7C, 0x40, 0x55, 0xB0, 0x3F, 0xC0, 0x20, 0x40, 0x3F, 0xC0, 0x12, 0x60, 0x1A, 0x80, 0x67, 0xF0, 0x00, 0x00 }; /*8E69*/
const unsigned char  uc2_8E6C [] = {0x00, 0x50, 0x7F, 0x60, 0x49, 0x50, 0x4E, 0x20, 0x7B, 0xE0, 0x14, 0x10, 0x5B, 0xE0, 0x52, 0x20, 0x5F, 0xE0, 0x31, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*8E6C*/
const unsigned char  uc2_8E6D [] = {0x02, 0x20, 0x79, 0x40, 0x4F, 0xF0, 0x4E, 0xB0, 0x7D, 0xD0, 0x14, 0x90, 0x5F, 0xF0, 0x52, 0x20, 0x57, 0xE0, 0x5A, 0x20, 0x63, 0xE0, 0x00, 0x00 }; /*8E6D*/
const unsigned char  uc2_8E6F [] = {0x00, 0x60, 0x7F, 0xA0, 0x4A, 0xA0, 0x4F, 0xF0, 0x79, 0x40, 0x16, 0xB0, 0x5B, 0xE0, 0x52, 0xA0, 0x5F, 0xE0, 0x32, 0xA0, 0x43, 0xE0, 0x00, 0x00 }; /*8E6F*/
const unsigned char  uc2_8E70 [] = {0x0F, 0xF0, 0x78, 0x00, 0x4F, 0x20, 0x48, 0x20, 0x7F, 0x70, 0x15, 0x20, 0x5F, 0xA0, 0x55, 0x60, 0x52, 0x20, 0x5B, 0x20, 0x64, 0x60, 0x00, 0x00 }; /*8E70*/
const unsigned char  uc2_8E72 [] = {0x02, 0x20, 0x7F, 0xF0, 0x49, 0x40, 0x4B, 0xE0, 0x7A, 0xA0, 0x13, 0x60, 0x5A, 0xA0, 0x57, 0xF0, 0x59, 0x20, 0x30, 0xA0, 0x40, 0x40, 0x00, 0x00 }; /*8E72*/
const unsigned char  uc2_8E74 [] = {0x02, 0x40, 0x77, 0xE0, 0x48, 0x50, 0x4F, 0xF0, 0x75, 0x40, 0x17, 0x40, 0x5A, 0x40, 0x57, 0x50, 0x5A, 0xD0, 0x32, 0x50, 0x44, 0xB0, 0x00, 0x00 }; /*8E74*/
const unsigned char  uc2_8E76 [] = {0x77, 0xF0, 0x54, 0x00, 0x56, 0xC0, 0x75, 0x70, 0x17, 0xD0, 0x5D, 0x50, 0x55, 0x60, 0x57, 0xA0, 0x5D, 0x20, 0x65, 0x20, 0x0A, 0x50, 0x00, 0x00 }; /*8E76*/
const unsigned char  uc2_8E7C [] = {0x01, 0x40, 0x75, 0x50, 0x4F, 0xF0, 0x49, 0x40, 0x7B, 0xE0, 0x10, 0x80, 0x5D, 0xC0, 0x50, 0x80, 0x57, 0xF0, 0x39, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*8E7C*/
const unsigned char  uc2_8E7F [] = {0x00, 0x80, 0x7F, 0xF0, 0x4D, 0x50, 0x4A, 0x20, 0x7C, 0x90, 0x13, 0xE0, 0x5A, 0xA0, 0x57, 0xF0, 0x54, 0x90, 0x5F, 0xF0, 0x60, 0x80, 0x00, 0x00 }; /*8E7F*/
const unsigned char  uc2_8E81 [] = {0x7B, 0xE0, 0x4A, 0x20, 0x4B, 0xE0, 0x78, 0x00, 0x17, 0x70, 0x5D, 0x50, 0x57, 0x70, 0x50, 0x80, 0x5F, 0xF0, 0x61, 0xC0, 0x06, 0xB0, 0x00, 0x00 }; /*8E81*/
const unsigned char  uc2_8E85 [] = {0x00, 0x00, 0x77, 0xF0, 0x4D, 0x50, 0x4B, 0xE0, 0x71, 0x10, 0x17, 0xD0, 0x5D, 0x50, 0x57, 0xD0, 0x5A, 0x90, 0x37, 0x50, 0x40, 0x60, 0x00, 0x00 }; /*8E85*/
const unsigned char  uc2_8E87 [] = {0x01, 0x40, 0x7B, 0xE0, 0x48, 0xA0, 0x49, 0xD0, 0x78, 0xA0, 0x17, 0xF0, 0x58, 0xC0, 0x57, 0x20, 0x59, 0xE0, 0x31, 0x20, 0x41, 0xE0, 0x00, 0x00 }; /*8E87*/
const unsigned char  uc2_8E8F [] = {0x01, 0x20, 0x77, 0xF0, 0x51, 0x20, 0x55, 0xF0, 0x73, 0x50, 0x15, 0xF0, 0x5F, 0x50, 0x55, 0xF0, 0x5D, 0x50, 0x65, 0xF0, 0x05, 0x30, 0x00, 0x00 }; /*8E8F*/
const unsigned char  uc2_8E90 [] = {0x01, 0x50, 0x7A, 0xA0, 0x49, 0x50, 0x4F, 0xF0, 0x7D, 0x50, 0x14, 0x90, 0x5D, 0x50, 0x57, 0xF0, 0x5C, 0xA0, 0x65, 0xA0, 0x06, 0xD0, 0x00, 0x00 }; /*8E90*/
const unsigned char  uc2_8E94 [] = {0x7B, 0xF0, 0x4A, 0xA0, 0x4B, 0xE0, 0x7A, 0xA0, 0x13, 0xE0, 0x5A, 0x80, 0x53, 0xF0, 0x52, 0xA0, 0x5B, 0xD0, 0x74, 0x80, 0x0B, 0xF0, 0x00, 0x00 }; /*8E94*/
const unsigned char  uc2_8E9C [] = {0x0A, 0xA0, 0x7F, 0xF0, 0x4A, 0xA0, 0x4F, 0x70, 0x7A, 0x20, 0x15, 0x50, 0x5B, 0xE0, 0x52, 0x20, 0x52, 0xA0, 0x5D, 0x40, 0x62, 0x20, 0x00, 0x00 }; /*8E9C*/
const unsigned char  uc2_8E9E [] = {0x7A, 0xA0, 0x4B, 0xE0, 0x4E, 0x30, 0x7B, 0xE0, 0x12, 0x20, 0x15, 0xD0, 0x59, 0x50, 0x57, 0xE0, 0x52, 0x20, 0x59, 0xC0, 0x66, 0x30, 0x00, 0x00 }; /*8E9E*/
const unsigned char  uc2_8EAB [] = {0x02, 0x00, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xC0, 0x08, 0x40, 0x0F, 0xD0, 0x08, 0x60, 0x3F, 0xC0, 0x01, 0x40, 0x06, 0x40, 0x39, 0x80, 0x00, 0x00 }; /*8EAB*/
const unsigned char  uc2_8EAC [] = {0x10, 0x00, 0x3D, 0xF0, 0x24, 0x10, 0x3C, 0xF0, 0x24, 0x80, 0x3D, 0x00, 0x25, 0xF0, 0x7C, 0x10, 0x14, 0x10, 0x64, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*8EAC*/
const unsigned char  uc2_8EAF [] = {0x10, 0x00, 0x3D, 0xF0, 0x25, 0x00, 0x3D, 0x10, 0x25, 0xD0, 0x3D, 0x20, 0x25, 0x20, 0x7D, 0x50, 0x15, 0x90, 0x65, 0x00, 0x19, 0xF0, 0x00, 0x00 }; /*8EAF*/
const unsigned char  uc2_8EB2 [] = {0x10, 0x00, 0x3B, 0xE0, 0x2A, 0x20, 0x3A, 0x20, 0x2C, 0x90, 0x38, 0x80, 0x2F, 0xF0, 0x79, 0xC0, 0x1A, 0xA0, 0x6C, 0x90, 0x18, 0x80, 0x00, 0x00 }; /*8EB2*/
const unsigned char  uc2_8EBA [] = {0x10, 0x80, 0x3E, 0xA0, 0x25, 0x40, 0x3F, 0xF0, 0x24, 0x10, 0x3D, 0xD0, 0x25, 0x50, 0x7D, 0x50, 0x15, 0xD0, 0x64, 0x10, 0x0C, 0x60, 0x00, 0x00 }; /*8EBA*/
const unsigned char  uc2_8ECE [] = {0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*8ECE*/
const unsigned char  uc2_8F66 [] = {0x02, 0x00, 0x04, 0x00, 0x3F, 0xE0, 0x08, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8F66*/
const unsigned char  uc2_8F67 [] = {0x10, 0x80, 0x10, 0x80, 0x7E, 0x80, 0x20, 0x80, 0x48, 0x80, 0x7E, 0x80, 0x08, 0x80, 0x0E, 0x90, 0x78, 0x90, 0x08, 0x90, 0x08, 0x60, 0x00, 0x00 }; /*8F67*/
const unsigned char  uc2_8F68 [] = {0x11, 0x00, 0x11, 0x00, 0x7D, 0x00, 0x23, 0xC0, 0x51, 0x40, 0x79, 0x40, 0x11, 0x40, 0x1D, 0x50, 0x71, 0x50, 0x11, 0x50, 0x12, 0x20, 0x00, 0x00 }; /*8F68*/
const unsigned char  uc2_8F69 [] = {0x10, 0x00, 0x13, 0xE0, 0x7C, 0x80, 0x20, 0x80, 0x57, 0xF0, 0x78, 0x80, 0x10, 0x80, 0x1C, 0x80, 0x70, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*8F69*/
const unsigned char  uc2_8F6B [] = {0x10, 0x00, 0x13, 0xF0, 0x7C, 0x50, 0x20, 0x50, 0x51, 0x50, 0x79, 0x50, 0x12, 0x50, 0x1C, 0x90, 0x70, 0x90, 0x11, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*8F6B*/
const unsigned char  uc2_8F6C [] = {0x10, 0x80, 0x10, 0x80, 0x7B, 0xE0, 0x20, 0x80, 0x57, 0xF0, 0x79, 0x00, 0x11, 0xE0, 0x1C, 0x20, 0x71, 0xA0, 0x10, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*8F6C*/
const unsigned char  uc2_8F6D [] = {0x10, 0x00, 0x13, 0xF0, 0x7E, 0x00, 0x22, 0xE0, 0x52, 0xA0, 0x7A, 0xA0, 0x12, 0xA0, 0x1E, 0xC0, 0x72, 0x90, 0x12, 0x90, 0x14, 0x60, 0x00, 0x00 }; /*8F6D*/
const unsigned char  uc2_8F6E [] = {0x10, 0x80, 0x10, 0x80, 0x7D, 0x40, 0x21, 0x40, 0x56, 0x30, 0x79, 0x00, 0x11, 0x20, 0x1D, 0xC0, 0x71, 0x10, 0x11, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*8F6E*/
const unsigned char  uc2_8F6F [] = {0x10, 0x80, 0x10, 0x80, 0x7C, 0xF0, 0x21, 0x10, 0x52, 0x50, 0x78, 0x40, 0x10, 0x40, 0x1C, 0xA0, 0x70, 0xA0, 0x10, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*8F6F*/
const unsigned char  uc2_8F70 [] = {0x02, 0x00, 0x3F, 0xE0, 0x12, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x7D, 0xF0, 0x24, 0x90, 0x18, 0x60, 0x65, 0x90, 0x00, 0x00 }; /*8F70*/
const unsigned char  uc2_8F71 [] = {0x10, 0x80, 0x10, 0x80, 0x78, 0x80, 0x27, 0xF0, 0x50, 0x80, 0x78, 0x80, 0x13, 0xE0, 0x1E, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*8F71*/
const unsigned char  uc2_8F72 [] = {0x10, 0x00, 0x17, 0xF0, 0x78, 0x20, 0x20, 0x20, 0x53, 0xA0, 0x7A, 0xA0, 0x12, 0xA0, 0x1F, 0xA0, 0x72, 0xA0, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*8F72*/
const unsigned char  uc2_8F73 [] = {0x10, 0x80, 0x10, 0xF0, 0x7C, 0x80, 0x23, 0xE0, 0x52, 0x20, 0x7A, 0x20, 0x13, 0xE0, 0x1E, 0x00, 0x72, 0x00, 0x12, 0x00, 0x14, 0x00, 0x00, 0x00 }; /*8F73*/
const unsigned char  uc2_8F74 [] = {0x10, 0x40, 0x10, 0x40, 0x7C, 0x40, 0x21, 0xF0, 0x51, 0x50, 0x79, 0x50, 0x11, 0xF0, 0x1D, 0x50, 0x71, 0x50, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*8F74*/
const unsigned char  uc2_8F75 [] = {0x10, 0x00, 0x13, 0xE0, 0x7E, 0x20, 0x22, 0x20, 0x52, 0x20, 0x7B, 0xE0, 0x10, 0x00, 0x1D, 0x40, 0x71, 0x20, 0x12, 0x10, 0x14, 0x10, 0x00, 0x00 }; /*8F75*/
const unsigned char  uc2_8F76 [] = {0x10, 0x40, 0x11, 0x40, 0x7D, 0xE0, 0x22, 0x40, 0x50, 0x40, 0x7B, 0xF0, 0x10, 0x40, 0x1C, 0xA0, 0x70, 0xA0, 0x11, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*8F76*/
const unsigned char  uc2_8F77 [] = {0x10, 0x60, 0x13, 0x80, 0x7C, 0x80, 0x22, 0xA0, 0x51, 0xC0, 0x78, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x70, 0x80, 0x10, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*8F77*/
const unsigned char  uc2_8F78 [] = {0x10, 0x80, 0x10, 0x80, 0x7D, 0x40, 0x26, 0x70, 0x50, 0x80, 0x7B, 0x20, 0x10, 0x40, 0x1D, 0x90, 0x70, 0x20, 0x10, 0xC0, 0x13, 0x00, 0x00, 0x00 }; /*8F78*/
const unsigned char  uc2_8F79 [] = {0x10, 0x20, 0x11, 0xC0, 0x7D, 0x00, 0x21, 0x40, 0x52, 0x40, 0x7B, 0xF0, 0x10, 0x40, 0x1D, 0x60, 0x71, 0x50, 0x12, 0x50, 0x11, 0x80, 0x00, 0x00 }; /*8F79*/
const unsigned char  uc2_8F7A [] = {0x10, 0x00, 0x13, 0xF0, 0x7C, 0x90, 0x20, 0x90, 0x53, 0x60, 0x78, 0x00, 0x11, 0xF0, 0x1D, 0x10, 0x71, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*8F7A*/
const unsigned char  uc2_8F7B [] = {0x10, 0x00, 0x13, 0xC0, 0x7C, 0x40, 0x20, 0x40, 0x50, 0x80, 0x7D, 0x60, 0x12, 0x10, 0x1D, 0xC0, 0x70, 0x80, 0x10, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*8F7B*/
const unsigned char  uc2_8F7C [] = {0x10, 0x60, 0x10, 0x50, 0x7F, 0xF0, 0x20, 0x40, 0x53, 0xC0, 0x79, 0x40, 0x11, 0x40, 0x1D, 0x50, 0x71, 0xD0, 0x17, 0x30, 0x10, 0x10, 0x00, 0x00 }; /*8F7C*/
const unsigned char  uc2_8F7D [] = {0x08, 0x80, 0x3E, 0xC0, 0x08, 0xA0, 0x7F, 0xF0, 0x10, 0x80, 0x7E, 0xA0, 0x28, 0xA0, 0x3E, 0xA0, 0x08, 0x50, 0x7E, 0xD0, 0x09, 0x20, 0x00, 0x00 }; /*8F7D*/
const unsigned char  uc2_8F7E [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x40, 0x22, 0x40, 0x53, 0xA0, 0x78, 0x20, 0x10, 0x80, 0x1B, 0xE0, 0x70, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*8F7E*/
const unsigned char  uc2_8F7F [] = {0x10, 0x60, 0x13, 0x80, 0x78, 0x80, 0x27, 0xF0, 0x51, 0x40, 0x7A, 0x20, 0x15, 0x50, 0x19, 0x40, 0x71, 0x40, 0x11, 0x40, 0x16, 0x40, 0x00, 0x00 }; /*8F7F*/
const unsigned char  uc2_8F81 [] = {0x10, 0x80, 0x10, 0x80, 0x79, 0x40, 0x26, 0x30, 0x50, 0x00, 0x7B, 0xE0, 0x10, 0x80, 0x1D, 0xC0, 0x70, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*8F81*/
const unsigned char  uc2_8F82 [] = {0x11, 0x00, 0x11, 0xE0, 0x7A, 0x20, 0x25, 0x40, 0x50, 0x80, 0x79, 0x40, 0x16, 0x30, 0x1B, 0xE0, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*8F82*/
const unsigned char  uc2_8F83 [] = {0x11, 0x00, 0x10, 0x80, 0x7F, 0xF0, 0x20, 0x00, 0x51, 0x60, 0x7E, 0x10, 0x11, 0x40, 0x19, 0x40, 0x70, 0x80, 0x11, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*8F83*/
const unsigned char  uc2_8F84 [] = {0x10, 0x00, 0x17, 0xF0, 0x7A, 0x80, 0x23, 0xA0, 0x52, 0xA0, 0x7B, 0xA0, 0x12, 0xE0, 0x1B, 0xA0, 0x76, 0xA0, 0x10, 0xA0, 0x10, 0x90, 0x00, 0x00 }; /*8F84*/
const unsigned char  uc2_8F85 [] = {0x10, 0xA0, 0x17, 0xF0, 0x78, 0x80, 0x23, 0xE0, 0x52, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x1B, 0xE0, 0x72, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x00, 0x00 }; /*8F85*/
const unsigned char  uc2_8F86 [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x40, 0x21, 0x40, 0x57, 0xF0, 0x7D, 0x50, 0x15, 0x50, 0x1E, 0xB0, 0x74, 0x10, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*8F86*/
const unsigned char  uc2_8F87 [] = {0x08, 0x80, 0x1D, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x22, 0x20, 0x7D, 0xF0, 0x12, 0x00, 0x1F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8F87*/
const unsigned char  uc2_8F88 [] = {0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x1D, 0xC0, 0x05, 0x00, 0x7F, 0xF0, 0x12, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*8F88*/
const unsigned char  uc2_8F89 [] = {0x17, 0xF0, 0x14, 0x10, 0x54, 0x80, 0x2B, 0xE0, 0x7D, 0x00, 0x2A, 0x80, 0x2B, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x28, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*8F89*/
const unsigned char  uc2_8F8A [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x23, 0xE0, 0x52, 0x20, 0x7B, 0xE0, 0x12, 0x50, 0x1B, 0x60, 0x72, 0x50, 0x13, 0x50, 0x12, 0x20, 0x00, 0x00 }; /*8F8A*/
const unsigned char  uc2_8F8B [] = {0x10, 0x00, 0x17, 0xF0, 0x7D, 0x50, 0x27, 0xF0, 0x54, 0x90, 0x7F, 0xF0, 0x15, 0x10, 0x1D, 0x10, 0x74, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*8F8B*/
const unsigned char  uc2_8F8D [] = {0x10, 0x00, 0x17, 0xF0, 0x79, 0x10, 0x25, 0x50, 0x52, 0x20, 0x7D, 0x50, 0x10, 0x00, 0x1F, 0xF0, 0x75, 0x50, 0x12, 0x20, 0x15, 0x50, 0x00, 0x00 }; /*8F8D*/
const unsigned char  uc2_8F8E [] = {0x11, 0x50, 0x12, 0xA0, 0x7A, 0xA0, 0x22, 0xA0, 0x51, 0x50, 0x7B, 0xE0, 0x12, 0xA0, 0x1B, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*8F8E*/
const unsigned char  uc2_8F8F [] = {0x10, 0x80, 0x17, 0xF0, 0x79, 0xA0, 0x22, 0xC0, 0x57, 0xF0, 0x79, 0x40, 0x17, 0xB0, 0x18, 0x80, 0x73, 0xE0, 0x11, 0x20, 0x16, 0x10, 0x00, 0x00 }; /*8F8F*/
const unsigned char  uc2_8F90 [] = {0x09, 0xF0, 0x08, 0x00, 0x7E, 0xE0, 0x10, 0xA0, 0x28, 0xE0, 0x3E, 0x00, 0x09, 0xF0, 0x0F, 0x50, 0x79, 0xF0, 0x09, 0x50, 0x09, 0xF0, 0x00, 0x00 }; /*8F90*/
const unsigned char  uc2_8F91 [] = {0x10, 0x00, 0x13, 0xE0, 0x7A, 0x20, 0x27, 0xF0, 0x52, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x72, 0x30, 0x17, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*8F91*/
const unsigned char  uc2_8F93 [] = {0x10, 0x80, 0x11, 0x40, 0x7E, 0x30, 0x21, 0xC0, 0x57, 0x10, 0x7D, 0x50, 0x17, 0x50, 0x1D, 0x50, 0x77, 0x50, 0x15, 0x10, 0x16, 0x60, 0x00, 0x00 }; /*8F93*/
const unsigned char  uc2_8F94 [] = {0x24, 0x20, 0x2F, 0xA0, 0x44, 0x40, 0x2A, 0x20, 0x5F, 0xD0, 0x62, 0x60, 0x1F, 0x90, 0x62, 0x60, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*8F94*/
const unsigned char  uc2_8F95 [] = {0x10, 0x80, 0x13, 0xE0, 0x78, 0x80, 0x27, 0xF0, 0x52, 0x20, 0x7B, 0xE0, 0x11, 0x40, 0x1A, 0x50, 0x76, 0x50, 0x13, 0x20, 0x12, 0x10, 0x00, 0x00 }; /*8F95*/
const unsigned char  uc2_8F96 [] = {0x10, 0x80, 0x17, 0xF0, 0x7C, 0x90, 0x23, 0xE0, 0x50, 0x80, 0x79, 0xC0, 0x10, 0x80, 0x1F, 0xF0, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*8F96*/
const unsigned char  uc2_8F97 [] = {0x17, 0xE0, 0x14, 0x20, 0x7F, 0xE0, 0x25, 0x40, 0x57, 0xE0, 0x7D, 0x40, 0x17, 0xF0, 0x1D, 0x40, 0x75, 0x50, 0x15, 0xA0, 0x19, 0x10, 0x00, 0x00 }; /*8F97*/
const unsigned char  uc2_8F98 [] = {0x10, 0x80, 0x17, 0xF0, 0x7D, 0x40, 0x27, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x15, 0x50, 0x1D, 0xE0, 0x75, 0x40, 0x15, 0xD0, 0x19, 0x20, 0x00, 0x00 }; /*8F98*/
const unsigned char  uc2_8F99 [] = {0x12, 0x40, 0x17, 0x70, 0x7A, 0x50, 0x25, 0xD0, 0x52, 0x50, 0x7F, 0x50, 0x15, 0x50, 0x1F, 0x20, 0x75, 0x20, 0x17, 0x50, 0x15, 0x90, 0x00, 0x00 }; /*8F99*/
const unsigned char  uc2_8F9A [] = {0x12, 0xA0, 0x17, 0xF0, 0x7A, 0xA0, 0x24, 0x90, 0x54, 0x20, 0x7F, 0xF0, 0x15, 0x20, 0x1F, 0xA0, 0x75, 0x70, 0x12, 0x20, 0x14, 0x20, 0x00, 0x00 }; /*8F9A*/
const unsigned char  uc2_8F9B [] = {0x0C, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x05, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*8F9B*/
const unsigned char  uc2_8F9C [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x00, 0x00 }; /*8F9C*/
const unsigned char  uc2_8F9E [] = {0x09, 0x00, 0x30, 0x80, 0x13, 0xE0, 0x7D, 0x40, 0x10, 0x80, 0x17, 0xF0, 0x38, 0x80, 0x28, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x28, 0x80, 0x00, 0x00 }; /*8F9E*/
const unsigned char  uc2_8F9F [] = {0x00, 0x80, 0x3C, 0x40, 0x25, 0xF0, 0x24, 0xA0, 0x3C, 0x40, 0x21, 0xF0, 0x3C, 0x40, 0x54, 0x40, 0x55, 0xF0, 0x5C, 0x40, 0x54, 0x40, 0x00, 0x00 }; /*8F9F*/
const unsigned char  uc2_8FA3 [] = {0x10, 0x80, 0x7F, 0xF0, 0x28, 0x80, 0x2B, 0xE0, 0x12, 0xA0, 0x7F, 0xE0, 0x11, 0xC0, 0x3A, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x20, 0x80, 0x00, 0x00 }; /*8FA3*/
const unsigned char  uc2_8FA8 [] = {0x21, 0x20, 0x71, 0x70, 0x01, 0x00, 0x55, 0x50, 0x25, 0x20, 0x75, 0x70, 0x29, 0x20, 0x71, 0x70, 0x22, 0x20, 0x22, 0x20, 0x44, 0x20, 0x00, 0x00 }; /*8FA8*/
const unsigned char  uc2_8FA9 [] = {0x24, 0x20, 0x72, 0x70, 0x00, 0x00, 0x56, 0x50, 0x22, 0x20, 0x72, 0x70, 0x22, 0x20, 0x72, 0x70, 0x22, 0xA0, 0x23, 0x20, 0x42, 0x20, 0x00, 0x00 }; /*8FA9*/
const unsigned char  uc2_8FAB [] = {0x22, 0x20, 0x72, 0x70, 0x02, 0x00, 0x54, 0x50, 0x27, 0x20, 0x72, 0x70, 0x24, 0x20, 0x77, 0x70, 0x20, 0x20, 0x23, 0x20, 0x4C, 0x20, 0x00, 0x00 }; /*8FAB*/
const unsigned char  uc2_8FB0 [] = {0x00, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x17, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x14, 0x80, 0x14, 0xA0, 0x24, 0xA0, 0x25, 0x40, 0x46, 0x30, 0x00, 0x00 }; /*8FB0*/
const unsigned char  uc2_8FB1 [] = {0x1F, 0xF0, 0x10, 0x00, 0x17, 0xE0, 0x10, 0x00, 0x1F, 0xF0, 0x14, 0x50, 0x26, 0x20, 0x24, 0x50, 0x5F, 0xF0, 0x04, 0x40, 0x01, 0x80, 0x00, 0x00 }; /*8FB1*/
const unsigned char  uc2_8FB9 [] = {0x21, 0x00, 0x11, 0x00, 0x07, 0xE0, 0x71, 0x20, 0x11, 0x20, 0x11, 0x20, 0x12, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FB9*/
const unsigned char  uc2_8FBD [] = {0x20, 0x00, 0x17, 0xF0, 0x00, 0x10, 0x70, 0x20, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x11, 0x80, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FBD*/
const unsigned char  uc2_8FBE [] = {0x20, 0x80, 0x10, 0x80, 0x07, 0xF0, 0x70, 0x80, 0x10, 0x80, 0x11, 0x40, 0x11, 0x20, 0x12, 0x10, 0x14, 0x10, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FBE*/
const unsigned char  uc2_8FC1 [] = {0x20, 0x60, 0x13, 0x80, 0x00, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FC1*/
const unsigned char  uc2_8FC2 [] = {0x20, 0x00, 0x13, 0xE0, 0x00, 0x80, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x13, 0x00, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FC2*/
const unsigned char  uc2_8FC4 [] = {0x22, 0x00, 0x13, 0xE0, 0x02, 0x00, 0x75, 0xC0, 0x10, 0x40, 0x10, 0x80, 0x11, 0x10, 0x12, 0x10, 0x11, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FC4*/
const unsigned char  uc2_8FC5 [] = {0x20, 0x00, 0x17, 0xC0, 0x02, 0x40, 0x72, 0x40, 0x12, 0x40, 0x17, 0x50, 0x12, 0x50, 0x12, 0x30, 0x12, 0x10, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FC5*/
const unsigned char  uc2_8FC7 [] = {0x20, 0x20, 0x10, 0x20, 0x07, 0xF0, 0x70, 0x20, 0x12, 0x20, 0x11, 0x20, 0x11, 0x20, 0x10, 0x20, 0x10, 0xC0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FC7*/
const unsigned char  uc2_8FC8 [] = {0x20, 0x00, 0x17, 0xF0, 0x01, 0x00, 0x71, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x12, 0x20, 0x12, 0x20, 0x14, 0xC0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FC8*/
const unsigned char  uc2_8FCE [] = {0x23, 0x00, 0x14, 0xF0, 0x04, 0x90, 0x74, 0x90, 0x14, 0x90, 0x15, 0x90, 0x16, 0xE0, 0x10, 0x80, 0x10, 0x80, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FCE*/
const unsigned char  uc2_8FD0 [] = {0x20, 0x00, 0x17, 0xE0, 0x00, 0x00, 0x70, 0x00, 0x1F, 0xF0, 0x11, 0x00, 0x12, 0x40, 0x14, 0xA0, 0x17, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FD0*/
const unsigned char  uc2_8FD1 [] = {0x20, 0x60, 0x13, 0x80, 0x02, 0x00, 0x73, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x14, 0x40, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FD1*/
const unsigned char  uc2_8FD3 [] = {0x23, 0xE0, 0x10, 0x40, 0x02, 0x40, 0x74, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x12, 0x40, 0x1C, 0x40, 0x11, 0x80, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FD3*/
const unsigned char  uc2_8FD4 [] = {0x20, 0x30, 0x13, 0xC0, 0x02, 0x00, 0x73, 0xF0, 0x12, 0x10, 0x12, 0xE0, 0x12, 0x20, 0x12, 0x50, 0x15, 0x90, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FD4*/
const unsigned char  uc2_8FD5 [] = {0x22, 0x00, 0x13, 0xE0, 0x02, 0x80, 0x74, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FD5*/
const unsigned char  uc2_8FD8 [] = {0x20, 0x00, 0x17, 0xF0, 0x00, 0x80, 0x70, 0x80, 0x11, 0xA0, 0x12, 0x90, 0x1C, 0x90, 0x10, 0x80, 0x10, 0x80, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FD8*/
const unsigned char  uc2_8FD9 [] = {0x21, 0x80, 0x10, 0x40, 0x03, 0xF0, 0x70, 0x00, 0x10, 0x20, 0x11, 0xA0, 0x10, 0x40, 0x10, 0xA0, 0x13, 0x10, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FD9*/
const unsigned char  uc2_8FDB [] = {0x22, 0x40, 0x12, 0x40, 0x07, 0xE0, 0x72, 0x40, 0x12, 0x40, 0x1F, 0xF0, 0x12, 0x40, 0x12, 0x40, 0x14, 0x40, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FDB*/
const unsigned char  uc2_8FDC [] = {0x20, 0x00, 0x13, 0xE0, 0x00, 0x00, 0x70, 0x00, 0x17, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x14, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FDC*/
const unsigned char  uc2_8FDD [] = {0x20, 0x80, 0x13, 0xE0, 0x00, 0x80, 0x71, 0xC0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x90, 0x10, 0xA0, 0x10, 0x80, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FDD*/
const unsigned char  uc2_8FDE [] = {0x20, 0x80, 0x13, 0xE0, 0x01, 0x00, 0x72, 0x80, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FDE*/
const unsigned char  uc2_8FDF [] = {0x20, 0x00, 0x13, 0xE0, 0x02, 0x20, 0x72, 0x20, 0x13, 0xE0, 0x12, 0x00, 0x12, 0xC0, 0x12, 0x20, 0x14, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FDF*/
const unsigned char  uc2_8FE2 [] = {0x20, 0x00, 0x17, 0xE0, 0x00, 0xA0, 0x71, 0x20, 0x16, 0xC0, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FE2*/
const unsigned char  uc2_8FE4 [] = {0x22, 0x00, 0x13, 0xF0, 0x0C, 0x80, 0x72, 0xE0, 0x13, 0xA0, 0x16, 0xC0, 0x12, 0x90, 0x12, 0x10, 0x11, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FE4*/
const unsigned char  uc2_8FE5 [] = {0x20, 0x00, 0x17, 0xF0, 0x04, 0x10, 0x75, 0xD0, 0x15, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x14, 0x60, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FE5*/
const unsigned char  uc2_8FE6 [] = {0x44, 0x00, 0x24, 0x70, 0x0F, 0x50, 0x65, 0x50, 0x25, 0x50, 0x25, 0x50, 0x25, 0x50, 0x25, 0x70, 0x2A, 0x50, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*8FE6*/
const unsigned char  uc2_8FE8 [] = {0x21, 0x00, 0x12, 0x20, 0x04, 0xD0, 0x77, 0x10, 0x10, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FE8*/
const unsigned char  uc2_8FE9 [] = {0x22, 0x00, 0x13, 0xE0, 0x02, 0x20, 0x74, 0x40, 0x10, 0x80, 0x12, 0xA0, 0x12, 0x90, 0x14, 0x90, 0x11, 0x00, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FE9*/
const unsigned char  uc2_8FEA [] = {0x20, 0x80, 0x10, 0x80, 0x00, 0x80, 0x77, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x10, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FEA*/
const unsigned char  uc2_8FEB [] = {0x20, 0x80, 0x11, 0x00, 0x07, 0xE0, 0x74, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x10, 0x00, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FEB*/
const unsigned char  uc2_8FED [] = {0x20, 0x80, 0x12, 0x80, 0x03, 0xE0, 0x74, 0x80, 0x10, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x60, 0x16, 0x10, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FED*/
const unsigned char  uc2_8FEE [] = {0x22, 0x00, 0x12, 0x00, 0x03, 0xF0, 0x75, 0x00, 0x19, 0xE0, 0x11, 0x00, 0x11, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FEE*/
const unsigned char  uc2_8FF0 [] = {0x20, 0xA0, 0x10, 0x90, 0x00, 0x80, 0x77, 0xF0, 0x11, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x10, 0x80, 0x2C, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*8FF0*/
const unsigned char  uc2_8FF3 [] = {0x20, 0x00, 0x13, 0xC0, 0x00, 0x40, 0x70, 0x80, 0x11, 0x60, 0x16, 0x10, 0x13, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FF3*/
const unsigned char  uc2_8FF7 [] = {0x24, 0x90, 0x12, 0x90, 0x02, 0xA0, 0x70, 0x80, 0x17, 0xF0, 0x11, 0x80, 0x12, 0xE0, 0x1C, 0x90, 0x10, 0x80, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FF7*/
const unsigned char  uc2_8FF8 [] = {0x22, 0x20, 0x11, 0x40, 0x03, 0xE0, 0x71, 0x40, 0x11, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x16, 0x40, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FF8*/
const unsigned char  uc2_8FF9 [] = {0x23, 0x00, 0x10, 0x80, 0x07, 0xF0, 0x71, 0x40, 0x15, 0x60, 0x15, 0x50, 0x19, 0x50, 0x12, 0x40, 0x14, 0x80, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FF9*/
const unsigned char  uc2_8FFD [] = {0x21, 0x00, 0x17, 0xC0, 0x04, 0x40, 0x77, 0xC0, 0x14, 0x00, 0x17, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x14, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*8FFD*/
const unsigned char  uc2_9000 [] = {0x67, 0xE0, 0x14, 0x20, 0x17, 0xE0, 0x04, 0x20, 0x77, 0xE0, 0x14, 0xA0, 0x14, 0x40, 0x14, 0xA0, 0x17, 0x20, 0x2C, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9000*/
const unsigned char  uc2_9001 [] = {0x62, 0x20, 0x11, 0x20, 0x11, 0x40, 0x03, 0xE0, 0x70, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x16, 0x20, 0x28, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*9001*/
const unsigned char  uc2_9002 [] = {0x60, 0x60, 0x13, 0x80, 0x10, 0x80, 0x07, 0xF0, 0x70, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9002*/
const unsigned char  uc2_9003 [] = {0x62, 0x80, 0x12, 0xA0, 0x1A, 0xA0, 0x06, 0xC0, 0x72, 0xA0, 0x16, 0xA0, 0x1A, 0x90, 0x12, 0x90, 0x14, 0x60, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9003*/
const unsigned char  uc2_9004 [] = {0x62, 0x00, 0x13, 0xE0, 0x1E, 0x20, 0x01, 0xC0, 0x7E, 0xB0, 0x12, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*9004*/
const unsigned char  uc2_9005 [] = {0x60, 0x60, 0x13, 0x80, 0x12, 0x00, 0x03, 0xF0, 0x72, 0x00, 0x12, 0xE0, 0x12, 0xA0, 0x14, 0xA0, 0x14, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9005*/
const unsigned char  uc2_9006 [] = {0x62, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x00, 0x80, 0x72, 0xA0, 0x13, 0xE0, 0x10, 0xA0, 0x11, 0x00, 0x16, 0x00, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9006*/
const unsigned char  uc2_9009 [] = {0x60, 0x80, 0x12, 0x80, 0x13, 0xE0, 0x04, 0x80, 0x77, 0xF0, 0x11, 0x40, 0x11, 0x50, 0x12, 0x50, 0x1C, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9009*/
const unsigned char  uc2_900A [] = {0x5E, 0x40, 0x22, 0x40, 0x25, 0x60, 0x07, 0x50, 0x7D, 0x50, 0x26, 0x50, 0x24, 0x40, 0x24, 0x40, 0x29, 0x80, 0x50, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*900A*/
const unsigned char  uc2_900B [] = {0x60, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x07, 0xF0, 0x74, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x2C, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*900B*/
const unsigned char  uc2_900D [] = {0x64, 0x90, 0x12, 0x90, 0x12, 0xA0, 0x07, 0xF0, 0x74, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x17, 0xF0, 0x14, 0x10, 0x2C, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*900D*/
const unsigned char  uc2_900F [] = {0x40, 0xC0, 0x27, 0x00, 0x21, 0x00, 0x0F, 0xE0, 0x65, 0x40, 0x39, 0x30, 0x27, 0x80, 0x22, 0xE0, 0x22, 0x20, 0x34, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*900F*/
const unsigned char  uc2_9010 [] = {0x6F, 0xF0, 0x10, 0x80, 0x13, 0x20, 0x0D, 0xA0, 0x72, 0xC0, 0x1D, 0xA0, 0x12, 0xA0, 0x1C, 0x90, 0x13, 0x00, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9010*/
const unsigned char  uc2_9011 [] = {0x60, 0xA0, 0x10, 0x90, 0x17, 0xF0, 0x00, 0xA0, 0x76, 0xA0, 0x11, 0xC0, 0x16, 0xA0, 0x10, 0xA0, 0x13, 0x00, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9011*/
const unsigned char  uc2_9012 [] = {0x62, 0x20, 0x11, 0x40, 0x17, 0xE0, 0x00, 0xA0, 0x73, 0xE0, 0x14, 0x80, 0x17, 0xF0, 0x12, 0x90, 0x1C, 0xE0, 0x28, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*9012*/
const unsigned char  uc2_9014 [] = {0x41, 0x00, 0x22, 0x80, 0x24, 0x40, 0x1B, 0xB0, 0x61, 0x00, 0x2F, 0xE0, 0x25, 0x40, 0x25, 0x20, 0x29, 0x20, 0x32, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9014*/
const unsigned char  uc2_9016 [] = {0x4A, 0x40, 0x25, 0x50, 0x2D, 0x50, 0x15, 0x50, 0x66, 0x60, 0x2C, 0x40, 0x34, 0xA0, 0x24, 0x90, 0x2B, 0x10, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9016*/
const unsigned char  uc2_9017 [] = {0x4F, 0xF0, 0x20, 0x00, 0x27, 0xE0, 0x04, 0x20, 0x67, 0xE0, 0x24, 0x40, 0x22, 0x40, 0x22, 0x80, 0x2F, 0xF0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9017*/
const unsigned char  uc2_901A [] = {0x4F, 0x80, 0x22, 0x80, 0x21, 0x00, 0x0F, 0xE0, 0x69, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x38, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*901A*/
const unsigned char  uc2_901B [] = {0x45, 0x00, 0x23, 0xF0, 0x26, 0x40, 0x1A, 0x40, 0x62, 0xE0, 0x26, 0x40, 0x3A, 0x40, 0x22, 0x40, 0x2D, 0xF0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*901B*/
const unsigned char  uc2_901D [] = {0x62, 0x30, 0x12, 0xC0, 0x17, 0x80, 0x02, 0xF0, 0x73, 0xA0, 0x16, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1D, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*901D*/
const unsigned char  uc2_901E [] = {0x47, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x00, 0x00, 0x67, 0xC0, 0x21, 0x00, 0x23, 0x80, 0x21, 0x00, 0x2F, 0xE0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*901E*/
const unsigned char  uc2_901F [] = {0x41, 0x00, 0x3F, 0xF0, 0x21, 0x00, 0x0F, 0xE0, 0x69, 0x20, 0x2F, 0xE0, 0x25, 0x40, 0x25, 0x20, 0x29, 0x20, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*901F*/
const unsigned char  uc2_9020 [] = {0x62, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x07, 0xF0, 0x70, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9020*/
const unsigned char  uc2_9021 [] = {0x61, 0x40, 0x12, 0x20, 0x14, 0xD0, 0x07, 0x10, 0x72, 0x20, 0x1D, 0xD0, 0x13, 0x50, 0x10, 0x80, 0x13, 0x40, 0x28, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*9021*/
const unsigned char  uc2_9022 [] = {0x47, 0xC0, 0x2C, 0x40, 0x23, 0x80, 0x1D, 0x70, 0x67, 0xC0, 0x21, 0x00, 0x23, 0x80, 0x21, 0x00, 0x2F, 0xE0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*9022*/
const unsigned char  uc2_9026 [] = {0x5F, 0xF0, 0x20, 0x00, 0x2E, 0xE0, 0x0A, 0xA0, 0x6A, 0xA0, 0x2E, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2C, 0xC0, 0x50, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9026*/
const unsigned char  uc2_902D [] = {0x43, 0x00, 0x20, 0x80, 0x2F, 0xF0, 0x0A, 0x50, 0x73, 0xC0, 0x12, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*902D*/
const unsigned char  uc2_902E [] = {0x60, 0x80, 0x13, 0xE0, 0x10, 0xA0, 0x07, 0xF0, 0x70, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x11, 0xC0, 0x16, 0xB0, 0x29, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*902E*/
const unsigned char  uc2_902F [] = {0x4F, 0xC0, 0x20, 0x40, 0x27, 0x80, 0x00, 0x80, 0x6F, 0xE0, 0x21, 0x20, 0x2D, 0xC0, 0x23, 0x20, 0x2D, 0x10, 0x32, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*902F*/
const unsigned char  uc2_9035 [] = {0x41, 0x00, 0x27, 0xC0, 0x21, 0x00, 0x0F, 0xE0, 0x64, 0x40, 0x39, 0x20, 0x27, 0xC0, 0x21, 0x00, 0x2F, 0xE0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9035*/
const unsigned char  uc2_9036 [] = {0x40, 0xC0, 0x27, 0x00, 0x21, 0x00, 0x0F, 0xE0, 0x65, 0x40, 0x29, 0x20, 0x2F, 0xE0, 0x22, 0x40, 0x21, 0x80, 0x32, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*9036*/
const unsigned char  uc2_9038 [] = {0x61, 0x00, 0x11, 0xC0, 0x12, 0x40, 0x07, 0xE0, 0x72, 0xA0, 0x13, 0xE0, 0x10, 0xA0, 0x11, 0x50, 0x16, 0x30, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9038*/
const unsigned char  uc2_903B [] = {0x67, 0xF0, 0x15, 0x50, 0x17, 0xF0, 0x01, 0x00, 0x71, 0xF0, 0x12, 0x10, 0x1D, 0xA0, 0x10, 0x40, 0x11, 0x80, 0x2A, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*903B*/
const unsigned char  uc2_903C [] = {0x47, 0xF0, 0x20, 0x00, 0x13, 0xE0, 0x02, 0x20, 0x77, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*903C*/
const unsigned char  uc2_903E [] = {0x41, 0x00, 0x22, 0x80, 0x27, 0xC0, 0x1A, 0x30, 0x6A, 0xA0, 0x2E, 0xA0, 0x2A, 0xA0, 0x2E, 0xA0, 0x2A, 0x20, 0x34, 0xC0, 0x4F, 0xF0, 0x00, 0x00 }; /*903E*/
const unsigned char  uc2_9041 [] = {0x27, 0xF0, 0x14, 0x40, 0x17, 0xF0, 0x04, 0x80, 0x75, 0xE0, 0x15, 0x20, 0x15, 0xE0, 0x15, 0x20, 0x15, 0xE0, 0x19, 0x20, 0x67, 0xF0, 0x00, 0x00 }; /*9041*/
const unsigned char  uc2_9042 [] = {0x42, 0x80, 0x2F, 0xE0, 0x22, 0x00, 0x0D, 0x20, 0x62, 0xC0, 0x2D, 0xA0, 0x22, 0xA0, 0x2C, 0x90, 0x23, 0x00, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9042*/
const unsigned char  uc2_9044 [] = {0x41, 0x00, 0x29, 0x20, 0x2F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x21, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x3A, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*9044*/
const unsigned char  uc2_9047 [] = {0x47, 0xC0, 0x25, 0x40, 0x27, 0xC0, 0x05, 0x40, 0x6F, 0xE0, 0x29, 0x20, 0x29, 0xA0, 0x2E, 0x60, 0x28, 0xC0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9047*/
const unsigned char  uc2_904D [] = {0x41, 0x00, 0x2F, 0xE0, 0x28, 0x20, 0x0F, 0xE0, 0x68, 0x00, 0x2F, 0xE0, 0x2A, 0xA0, 0x2F, 0xE0, 0x2A, 0xA0, 0x50, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*904D*/
const unsigned char  uc2_904F [] = {0x63, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x02, 0x20, 0x73, 0xF0, 0x12, 0x90, 0x1D, 0x50, 0x12, 0x50, 0x13, 0xD0, 0x28, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*904F*/
const unsigned char  uc2_9050 [] = {0x4E, 0xE0, 0x2A, 0x20, 0x2E, 0xE0, 0x08, 0x00, 0x6E, 0xE0, 0x28, 0x20, 0x2F, 0xA0, 0x28, 0x40, 0x29, 0xA0, 0x30, 0x20, 0x4F, 0xF0, 0x00, 0x00 }; /*9050*/
const unsigned char  uc2_9051 [] = {0x41, 0x00, 0x22, 0x00, 0x27, 0xC0, 0x04, 0x40, 0x67, 0xC0, 0x24, 0x40, 0x27, 0xC0, 0x21, 0x00, 0x27, 0xC0, 0x31, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9051*/
const unsigned char  uc2_9052 [] = {0x44, 0x40, 0x3F, 0xF0, 0x22, 0x80, 0x0F, 0xE0, 0x6A, 0xA0, 0x2C, 0x60, 0x2B, 0xA0, 0x28, 0x20, 0x2F, 0xE0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9052*/
const unsigned char  uc2_9053 [] = {0x62, 0x20, 0x11, 0x40, 0x17, 0xF0, 0x00, 0x80, 0x73, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x2A, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*9053*/
const unsigned char  uc2_9057 [] = {0x40, 0x80, 0x23, 0xE0, 0x22, 0xA0, 0x07, 0xF0, 0x62, 0x20, 0x22, 0xA0, 0x22, 0xA0, 0x20, 0xC0, 0x23, 0x20, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9057*/
const unsigned char  uc2_9058 [] = {0x42, 0x80, 0x2F, 0xE0, 0x22, 0x80, 0x1F, 0xF0, 0x69, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x3F, 0xF0, 0x28, 0x20, 0x38, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*9058*/
const unsigned char  uc2_905B [] = {0x42, 0x00, 0x2D, 0xE0, 0x28, 0xA0, 0x0A, 0xA0, 0x6F, 0x40, 0x2A, 0x00, 0x27, 0xC0, 0x25, 0x40, 0x27, 0xC0, 0x35, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*905B*/
const unsigned char  uc2_9062 [] = {0x4F, 0xC0, 0x28, 0x40, 0x2F, 0xC0, 0x08, 0x40, 0x7F, 0xE0, 0x2A, 0xA0, 0x26, 0x60, 0x3B, 0xA0, 0x24, 0x40, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9062*/
const unsigned char  uc2_9063 [] = {0x41, 0x00, 0x2F, 0xE0, 0x29, 0x20, 0x1F, 0xF0, 0x64, 0x40, 0x27, 0xC0, 0x24, 0x00, 0x27, 0xE0, 0x24, 0x20, 0x34, 0x20, 0x4F, 0xF0, 0x00, 0x00 }; /*9063*/
const unsigned char  uc2_9065 [] = {0x60, 0x70, 0x17, 0xA0, 0x12, 0xA0, 0x01, 0x40, 0x71, 0xE0, 0x12, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x28, 0x00, 0x47, 0xF0, 0x00, 0x00 }; /*9065*/
const unsigned char  uc2_9068 [] = {0x42, 0x40, 0x2F, 0xC0, 0x22, 0x70, 0x07, 0xD0, 0x62, 0x50, 0x2F, 0xA0, 0x25, 0x20, 0x25, 0x50, 0x29, 0x90, 0x32, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9068*/
const unsigned char  uc2_906D [] = {0x42, 0x80, 0x3F, 0xF0, 0x2A, 0xA0, 0x0F, 0xE0, 0x6A, 0xA0, 0x2F, 0xE0, 0x22, 0x40, 0x25, 0x40, 0x27, 0xC0, 0x34, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*906D*/
const unsigned char  uc2_906E [] = {0x40, 0x80, 0x2F, 0xF0, 0x29, 0x40, 0x09, 0x40, 0x6F, 0xF0, 0x29, 0x40, 0x29, 0xC0, 0x28, 0x00, 0x32, 0xA0, 0x35, 0x50, 0x4F, 0xF0, 0x00, 0x00 }; /*906E*/
const unsigned char  uc2_9074 [] = {0x49, 0x20, 0x25, 0x40, 0x3F, 0xF0, 0x05, 0x40, 0x79, 0x30, 0x29, 0x40, 0x2E, 0xF0, 0x33, 0x40, 0x2D, 0xF0, 0x30, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*9074*/
const unsigned char  uc2_9075 [] = {0x42, 0x40, 0x2F, 0xF0, 0x25, 0xA0, 0x06, 0x60, 0x64, 0x20, 0x27, 0xE0, 0x20, 0x40, 0x2F, 0xF0, 0x24, 0x40, 0x32, 0x40, 0x4F, 0xF0, 0x00, 0x00 }; /*9075*/
const unsigned char  uc2_907D [] = {0x41, 0xE0, 0x21, 0x00, 0x2F, 0xF0, 0x09, 0x10, 0x6F, 0xC0, 0x29, 0x20, 0x2F, 0xF0, 0x2B, 0x20, 0x2D, 0xC0, 0x32, 0xA0, 0x4F, 0xF0, 0x00, 0x00 }; /*907D*/
const unsigned char  uc2_907F [] = {0x4E, 0x40, 0x2B, 0xF0, 0x2A, 0xA0, 0x0E, 0x40, 0x69, 0xF0, 0x2E, 0x40, 0x3B, 0xF0, 0x2A, 0x40, 0x2E, 0x40, 0x3A, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*907F*/
const unsigned char  uc2_9080 [] = {0x44, 0x80, 0x2A, 0xF0, 0x2F, 0xA0, 0x0A, 0xA0, 0x6E, 0xA0, 0x24, 0x40, 0x3F, 0x40, 0x2A, 0xA0, 0x2A, 0xA0, 0x55, 0x20, 0x4F, 0xF0, 0x00, 0x00 }; /*9080*/
const unsigned char  uc2_9082 [] = {0x44, 0xF0, 0x27, 0x50, 0x29, 0x50, 0x1F, 0x90, 0x6A, 0xA0, 0x2F, 0xF0, 0x2A, 0xA0, 0x2F, 0xF0, 0x2A, 0xA0, 0x51, 0x20, 0x4F, 0xF0, 0x00, 0x00 }; /*9082*/
const unsigned char  uc2_9083 [] = {0x20, 0x80, 0x17, 0xF0, 0x15, 0x50, 0x02, 0x20, 0x71, 0x40, 0x17, 0xF0, 0x12, 0x90, 0x14, 0xE0, 0x11, 0x50, 0x2A, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*9083*/
const unsigned char  uc2_9088 [] = {0x44, 0x40, 0x2A, 0xF0, 0x24, 0x90, 0x0A, 0xF0, 0x66, 0x90, 0x2A, 0xF0, 0x26, 0x40, 0x2A, 0x50, 0x26, 0xB0, 0x30, 0x00, 0x4F, 0xF0, 0x00, 0x00 }; /*9088*/
const unsigned char  uc2_908B [] = {0x44, 0x90, 0x29, 0x20, 0x2F, 0xF0, 0x0A, 0x50, 0x69, 0x90, 0x2A, 0x50, 0x2F, 0xF0, 0x29, 0x20, 0x2D, 0xA0, 0x29, 0x10, 0x5F, 0xF0, 0x00, 0x00 }; /*908B*/
const unsigned char  uc2_9091 [] = {0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x7F, 0xC0, 0x44, 0x40, 0x44, 0x40, 0x7F, 0xC0, 0x40, 0x10, 0x40, 0x10, 0x3F, 0xE0, 0x00, 0x00 }; /*9091*/
const unsigned char  uc2_9093 [] = {0x00, 0xF0, 0x3E, 0x90, 0x02, 0x90, 0x12, 0xA0, 0x0A, 0xA0, 0x04, 0x90, 0x04, 0x90, 0x0A, 0x90, 0x12, 0xE0, 0x62, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*9093*/
const unsigned char  uc2_9095 [] = {0x12, 0x40, 0x24, 0x80, 0x12, 0x40, 0x3F, 0xC0, 0x20, 0x80, 0x7F, 0xC0, 0x44, 0x40, 0x7F, 0xC0, 0x40, 0x10, 0x40, 0x10, 0x3F, 0xE0, 0x00, 0x00 }; /*9095*/
const unsigned char  uc2_9097 [] = {0x3E, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x08, 0xA0, 0x7F, 0xA0, 0x08, 0x90, 0x08, 0x90, 0x08, 0x90, 0x08, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*9097*/
const unsigned char  uc2_9099 [] = {0x18, 0xF0, 0x04, 0x90, 0x04, 0x90, 0x7F, 0xA0, 0x20, 0xA0, 0x20, 0x90, 0x20, 0x90, 0x20, 0x90, 0x20, 0xE0, 0x1E, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*9099*/
const unsigned char  uc2_909B [] = {0x00, 0xF0, 0x3E, 0x90, 0x08, 0x90, 0x08, 0xA0, 0x08, 0xA0, 0x08, 0x90, 0x08, 0x90, 0x0F, 0x90, 0x70, 0xE0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*909B*/
const unsigned char  uc2_909D [] = {0x18, 0xF0, 0x04, 0x90, 0x3F, 0x90, 0x20, 0xA0, 0x20, 0xA0, 0x20, 0x90, 0x20, 0x90, 0x20, 0x90, 0x20, 0xE0, 0x20, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*909D*/
const unsigned char  uc2_90A1 [] = {0x30, 0xF0, 0x08, 0x90, 0x7F, 0x90, 0x10, 0xA0, 0x1E, 0xA0, 0x12, 0x90, 0x12, 0x90, 0x12, 0x90, 0x22, 0xE0, 0x22, 0x80, 0x4C, 0x80, 0x00, 0x00 }; /*90A1*/
const unsigned char  uc2_90A2 [] = {0x3E, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x14, 0xA0, 0x7F, 0xA0, 0x14, 0x90, 0x14, 0x90, 0x14, 0x90, 0x24, 0xE0, 0x24, 0x80, 0x44, 0x80, 0x00, 0x00 }; /*90A2*/
const unsigned char  uc2_90A3 [] = {0x3E, 0xF0, 0x12, 0x90, 0x12, 0x90, 0x3E, 0xA0, 0x12, 0xA0, 0x12, 0x90, 0x3E, 0x90, 0x12, 0x90, 0x12, 0xE0, 0x22, 0x80, 0x4C, 0x80, 0x00, 0x00 }; /*90A3*/
const unsigned char  uc2_90A6 [] = {0x08, 0xF0, 0x7F, 0x90, 0x08, 0x90, 0x08, 0xA0, 0x3E, 0xA0, 0x08, 0x90, 0x08, 0x90, 0x7F, 0x90, 0x08, 0xE0, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*90A6*/
const unsigned char  uc2_90AA [] = {0x7E, 0xF0, 0x14, 0x90, 0x24, 0x90, 0x7F, 0xA0, 0x04, 0xA0, 0x0C, 0x90, 0x14, 0x90, 0x14, 0x90, 0x24, 0xE0, 0x44, 0x80, 0x18, 0x80, 0x00, 0x00 }; /*90AA*/
const unsigned char  uc2_90AC [] = {0x10, 0xF0, 0x3E, 0x90, 0x22, 0x90, 0x2C, 0xA0, 0x20, 0xA0, 0x3E, 0x90, 0x02, 0x90, 0x1A, 0x90, 0x62, 0xE0, 0x02, 0x80, 0x1C, 0x80, 0x00, 0x00 }; /*90AC*/
const unsigned char  uc2_90AE [] = {0x08, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x3E, 0xA0, 0x2A, 0xA0, 0x2A, 0x90, 0x3E, 0x90, 0x2A, 0x90, 0x2A, 0xE0, 0x3E, 0x80, 0x22, 0x80, 0x00, 0x00 }; /*90AE*/
const unsigned char  uc2_90AF [] = {0x24, 0xF0, 0x24, 0x90, 0x24, 0x90, 0x7E, 0xA0, 0x24, 0xA0, 0x24, 0x90, 0x3C, 0x90, 0x24, 0x90, 0x24, 0xE0, 0x3C, 0x80, 0x24, 0x80, 0x00, 0x00 }; /*90AF*/
const unsigned char  uc2_90B0 [] = {0x10, 0xF0, 0x10, 0x90, 0x24, 0x90, 0x4A, 0xA0, 0x72, 0xA0, 0x00, 0x90, 0x3C, 0x90, 0x24, 0x90, 0x24, 0xE0, 0x3C, 0x80, 0x24, 0x80, 0x00, 0x00 }; /*90B0*/
const unsigned char  uc2_90B1 [] = {0x06, 0xF0, 0x38, 0x90, 0x20, 0x90, 0x20, 0xA0, 0x3E, 0xA0, 0x24, 0x90, 0x24, 0x90, 0x24, 0x90, 0x27, 0xE0, 0x78, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*90B1*/
const unsigned char  uc2_90B3 [] = {0x7F, 0xF0, 0x04, 0x90, 0x04, 0x90, 0x08, 0xA0, 0x1C, 0xA0, 0x6A, 0x90, 0x0A, 0x90, 0x08, 0x90, 0x08, 0xE0, 0x0F, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*90B3*/
const unsigned char  uc2_90B4 [] = {0x7F, 0xF0, 0x08, 0x90, 0x08, 0x90, 0x3E, 0xA0, 0x2A, 0xA0, 0x2A, 0x90, 0x36, 0x90, 0x22, 0x90, 0x22, 0xE0, 0x22, 0x80, 0x2C, 0x80, 0x00, 0x00 }; /*90B4*/
const unsigned char  uc2_90B5 [] = {0x7E, 0xF0, 0x12, 0x90, 0x12, 0x90, 0x22, 0xA0, 0x44, 0xA0, 0x3C, 0x90, 0x24, 0x90, 0x24, 0x90, 0x24, 0xE0, 0x3C, 0x80, 0x24, 0x80, 0x00, 0x00 }; /*90B5*/
const unsigned char  uc2_90B6 [] = {0x14, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x77, 0xA0, 0x14, 0xA0, 0x14, 0x90, 0x14, 0x90, 0x35, 0x90, 0x56, 0xE0, 0x14, 0x80, 0x00, 0x80, 0x00, 0x00 }; /*90B6*/
const unsigned char  uc2_90B8 [] = {0x06, 0xF0, 0x78, 0x90, 0x48, 0x90, 0x48, 0xA0, 0x7E, 0xA0, 0x48, 0x90, 0x58, 0x90, 0x68, 0x90, 0x44, 0xE0, 0x65, 0x80, 0x12, 0x80, 0x00, 0x00 }; /*90B8*/
const unsigned char  uc2_90B9 [] = {0x10, 0xF0, 0x1C, 0x90, 0x64, 0x90, 0x3E, 0xA0, 0x02, 0xA0, 0x02, 0x90, 0x1E, 0x90, 0x02, 0x90, 0x02, 0xE0, 0x3E, 0x80, 0x02, 0x80, 0x00, 0x00 }; /*90B9*/
const unsigned char  uc2_90BA [] = {0x14, 0x70, 0x14, 0x50, 0x15, 0x50, 0x55, 0x50, 0x55, 0x60, 0x36, 0x50, 0x14, 0x50, 0x15, 0xD0, 0x16, 0x60, 0x78, 0x40, 0x00, 0x40, 0x00, 0x00 }; /*90BA*/
const unsigned char  uc2_90BB [] = {0x08, 0xF0, 0x0C, 0x90, 0x12, 0x90, 0x6A, 0xA0, 0x04, 0xA0, 0x3E, 0x90, 0x02, 0x90, 0x04, 0x90, 0x18, 0xE0, 0x04, 0x80, 0x04, 0x80, 0x00, 0x00 }; /*90BB*/
const unsigned char  uc2_90BE [] = {0x08, 0xF0, 0x28, 0x90, 0x3E, 0x90, 0x48, 0xA0, 0x08, 0xA0, 0x7F, 0x90, 0x28, 0x90, 0x2C, 0x90, 0x2A, 0xE0, 0x4A, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*90BE*/
const unsigned char  uc2_90C1 [] = {0x08, 0xF0, 0x7F, 0x90, 0x08, 0x90, 0x1E, 0xA0, 0x72, 0xA0, 0x1E, 0x90, 0x12, 0x90, 0x1E, 0x90, 0x12, 0xE0, 0x12, 0x80, 0x14, 0x80, 0x00, 0x00 }; /*90C1*/
const unsigned char  uc2_90C4 [] = {0x32, 0xF0, 0x0C, 0x90, 0x12, 0x90, 0x62, 0xA0, 0x10, 0xA0, 0x7F, 0x90, 0x10, 0x90, 0x14, 0x90, 0x28, 0xE0, 0x52, 0x80, 0x1D, 0x80, 0x00, 0x00 }; /*90C4*/
const unsigned char  uc2_90C5 [] = {0x7E, 0xF0, 0x10, 0x90, 0x14, 0x90, 0x24, 0xA0, 0x3A, 0xA0, 0x02, 0x90, 0x08, 0x90, 0x3E, 0x90, 0x08, 0xE0, 0x0F, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*90C5*/
const unsigned char  uc2_90C7 [] = {0x20, 0xF0, 0x3E, 0x90, 0x42, 0x90, 0x3A, 0xA0, 0x2A, 0xA0, 0x3A, 0x90, 0x2A, 0x90, 0x3A, 0x90, 0x2A, 0xE0, 0x04, 0x80, 0x18, 0x80, 0x00, 0x00 }; /*90C7*/
const unsigned char  uc2_90CA [] = {0x04, 0x70, 0x3F, 0xD0, 0x0A, 0x50, 0x09, 0x50, 0x31, 0x60, 0x02, 0x50, 0x1A, 0x50, 0x04, 0x50, 0x04, 0x60, 0x0A, 0x40, 0x32, 0x40, 0x00, 0x00 }; /*90CA*/
const unsigned char  uc2_90CE [] = {0x31, 0xE0, 0x09, 0x20, 0x7D, 0x20, 0x45, 0x40, 0x7D, 0x40, 0x45, 0x20, 0x7D, 0x20, 0x41, 0x20, 0x49, 0xC0, 0x55, 0x00, 0x65, 0x00, 0x00, 0x00 }; /*90CE*/
const unsigned char  uc2_90CF [] = {0x08, 0xF0, 0x3E, 0x90, 0x4A, 0x90, 0x2A, 0xA0, 0x2C, 0xA0, 0x7F, 0x90, 0x08, 0x90, 0x0C, 0x90, 0x0A, 0xE0, 0x12, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*90CF*/
const unsigned char  uc2_90D0 [] = {0x08, 0xF0, 0x08, 0x90, 0x14, 0x90, 0x63, 0xA0, 0x1C, 0xA0, 0x00, 0x90, 0x7F, 0x90, 0x14, 0x90, 0x24, 0xE0, 0x3A, 0x80, 0x02, 0x80, 0x00, 0x00 }; /*90D0*/
const unsigned char  uc2_90D1 [] = {0x22, 0xF0, 0x14, 0x90, 0x3E, 0x90, 0x08, 0xA0, 0x08, 0xA0, 0x7F, 0x90, 0x08, 0x90, 0x0C, 0x90, 0x0A, 0xE0, 0x12, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*90D1*/
const unsigned char  uc2_90D3 [] = {0x7E, 0xF0, 0x42, 0x90, 0x10, 0x90, 0x7E, 0xA0, 0x10, 0xA0, 0x28, 0x90, 0x3E, 0x90, 0x08, 0x90, 0x0E, 0xE0, 0x78, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*90D3*/
const unsigned char  uc2_90D7 [] = {0x72, 0xF0, 0x0C, 0x90, 0x72, 0x90, 0x12, 0xA0, 0x7F, 0xA0, 0x28, 0x90, 0x7E, 0x90, 0x2A, 0x90, 0x2A, 0xE0, 0x2C, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*90D7*/
const unsigned char  uc2_90DB [] = {0x07, 0xF0, 0x7A, 0x90, 0x2A, 0x90, 0x14, 0xA0, 0x3E, 0xA0, 0x02, 0x90, 0x04, 0x90, 0x07, 0x90, 0x7C, 0xE0, 0x04, 0x80, 0x18, 0x80, 0x00, 0x00 }; /*90DB*/
const unsigned char  uc2_90DC [] = {0x08, 0xF0, 0x28, 0x90, 0x3E, 0x90, 0x48, 0xA0, 0x7F, 0xA0, 0x00, 0x90, 0x3E, 0x90, 0x22, 0x90, 0x22, 0xE0, 0x3E, 0x80, 0x22, 0x80, 0x00, 0x00 }; /*90DC*/
const unsigned char  uc2_90DD [] = {0x04, 0x70, 0x04, 0x50, 0x1F, 0x50, 0x04, 0x50, 0x3F, 0xE0, 0x0A, 0x50, 0x2B, 0x50, 0x2A, 0xD0, 0x4A, 0x60, 0x12, 0x40, 0x2C, 0x40, 0x00, 0x00 }; /*90DD*/
const unsigned char  uc2_90E1 [] = {0x3E, 0xF0, 0x0A, 0x90, 0x7F, 0x90, 0x0A, 0xA0, 0x3E, 0xA0, 0x10, 0x90, 0x1E, 0x90, 0x32, 0x90, 0x52, 0xE0, 0x1E, 0x80, 0x12, 0x80, 0x00, 0x00 }; /*90E1*/
const unsigned char  uc2_90E2 [] = {0x3E, 0xF0, 0x22, 0x90, 0x22, 0x90, 0x3E, 0xA0, 0x00, 0xA0, 0x3E, 0x90, 0x08, 0x90, 0x3E, 0x90, 0x08, 0xE0, 0x0F, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*90E2*/
const unsigned char  uc2_90E6 [] = {0x7F, 0xF0, 0x00, 0x50, 0x77, 0x50, 0x55, 0x50, 0x55, 0x60, 0x77, 0x50, 0x55, 0x50, 0x55, 0x50, 0x55, 0x60, 0x55, 0x40, 0x66, 0x40, 0x00, 0x00 }; /*90E6*/
const unsigned char  uc2_90E7 [] = {0x1C, 0xF0, 0x14, 0x90, 0x1C, 0x90, 0x00, 0xA0, 0x3E, 0xA0, 0x22, 0x90, 0x2A, 0x90, 0x2A, 0x90, 0x0C, 0xE0, 0x12, 0x80, 0x62, 0x80, 0x00, 0x00 }; /*90E7*/
const unsigned char  uc2_90E8 [] = {0x08, 0xF0, 0x3E, 0x90, 0x22, 0x90, 0x14, 0xA0, 0x7F, 0xA0, 0x00, 0x90, 0x3E, 0x90, 0x22, 0x90, 0x22, 0xE0, 0x3E, 0x80, 0x22, 0x80, 0x00, 0x00 }; /*90E8*/
const unsigned char  uc2_90EB [] = {0x08, 0x70, 0x3F, 0x50, 0x25, 0x50, 0x3F, 0x50, 0x29, 0x60, 0x3F, 0x50, 0x10, 0x50, 0x24, 0x50, 0x7F, 0x60, 0x04, 0x40, 0x04, 0x40, 0x00, 0x00 }; /*90EB*/
const unsigned char  uc2_90ED [] = {0x08, 0xF0, 0x7F, 0x90, 0x22, 0x90, 0x3E, 0xA0, 0x00, 0xA0, 0x3C, 0x90, 0x04, 0x90, 0x0F, 0x90, 0x78, 0xE0, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*90ED*/
const unsigned char  uc2_90EF [] = {0x2A, 0xF0, 0x2A, 0x90, 0x4C, 0x90, 0x12, 0xA0, 0x62, 0xA0, 0x08, 0x90, 0x2A, 0x90, 0x2A, 0x90, 0x4C, 0xE0, 0x12, 0x80, 0x62, 0x80, 0x00, 0x00 }; /*90EF*/
const unsigned char  uc2_90F4 [] = {0x12, 0x70, 0x12, 0x50, 0x7F, 0xD0, 0x12, 0x50, 0x3A, 0x60, 0x57, 0x50, 0x56, 0xD0, 0x5A, 0x50, 0x12, 0x60, 0x12, 0x40, 0x12, 0x40, 0x00, 0x00 }; /*90F4*/
const unsigned char  uc2_90F8 [] = {0x62, 0xF0, 0x14, 0x90, 0x3E, 0x90, 0x2A, 0xA0, 0x3E, 0xA0, 0x2A, 0x90, 0x3E, 0x90, 0x08, 0x90, 0x7F, 0xE0, 0x08, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*90F8*/
const unsigned char  uc2_90FD [] = {0x08, 0xF0, 0x3F, 0x90, 0x0A, 0x90, 0x7F, 0xA0, 0x08, 0xA0, 0x1E, 0x90, 0x72, 0x90, 0x1E, 0x90, 0x12, 0xE0, 0x1E, 0x80, 0x12, 0x80, 0x00, 0x00 }; /*90FD*/
const unsigned char  uc2_90FE [] = {0x7F, 0xF0, 0x52, 0x90, 0x5E, 0x90, 0x52, 0xA0, 0x5E, 0xA0, 0x48, 0x90, 0x7F, 0x90, 0x52, 0x90, 0x4C, 0xE0, 0x52, 0x80, 0x7F, 0x80, 0x00, 0x00 }; /*90FE*/
const unsigned char  uc2_9102 [] = {0x77, 0x70, 0x55, 0x50, 0x22, 0x50, 0x3E, 0x50, 0x00, 0x60, 0x7F, 0x50, 0x08, 0x50, 0x10, 0x50, 0x1E, 0x60, 0x02, 0x40, 0x0C, 0x40, 0x00, 0x00 }; /*9102*/
const unsigned char  uc2_9104 [] = {0x7F, 0xF0, 0x14, 0x50, 0x7F, 0x50, 0x55, 0x50, 0x55, 0x60, 0x7F, 0x50, 0x08, 0x50, 0x3E, 0x50, 0x08, 0x60, 0x0F, 0x40, 0x70, 0x40, 0x00, 0x00 }; /*9104*/
const unsigned char  uc2_9119 [] = {0x3E, 0x70, 0x22, 0x50, 0x3E, 0x50, 0x08, 0x60, 0x7F, 0xD0, 0x08, 0x50, 0x7F, 0x50, 0x55, 0x50, 0x5D, 0x60, 0x41, 0x40, 0x7F, 0x40, 0x00, 0x00 }; /*9119*/
const unsigned char  uc2_911E [] = {0x14, 0xF0, 0x7F, 0x90, 0x14, 0x90, 0x3E, 0xA0, 0x2A, 0xA0, 0x7F, 0x90, 0x08, 0x90, 0x3E, 0x90, 0x08, 0xE0, 0x0F, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*911E*/
const unsigned char  uc2_9122 [] = {0x7F, 0x70, 0x08, 0x50, 0x2E, 0x50, 0x28, 0x60, 0x7F, 0x50, 0x20, 0x50, 0x3E, 0x50, 0x40, 0x50, 0x7F, 0x60, 0x2A, 0xC0, 0x55, 0x40, 0x00, 0x00 }; /*9122*/
const unsigned char  uc2_9123 [] = {0x08, 0xF0, 0x3E, 0x90, 0x14, 0x90, 0x7F, 0xA0, 0x22, 0xA0, 0x3E, 0x90, 0x22, 0x90, 0x3E, 0x90, 0x08, 0xE0, 0x7F, 0x80, 0x08, 0x80, 0x00, 0x00 }; /*9123*/
const unsigned char  uc2_912F [] = {0x14, 0xF0, 0x7F, 0x90, 0x08, 0x90, 0x3E, 0xA0, 0x08, 0xA0, 0x7F, 0x90, 0x2A, 0x90, 0x14, 0x90, 0x7F, 0xE0, 0x22, 0x80, 0x3E, 0x80, 0x00, 0x00 }; /*912F*/
const unsigned char  uc2_9131 [] = {0x07, 0x70, 0x79, 0x50, 0x2A, 0x50, 0x7F, 0x50, 0x2A, 0x60, 0x49, 0x50, 0x3E, 0x50, 0x2A, 0x50, 0x3E, 0x60, 0x2A, 0x40, 0x3E, 0x40, 0x00, 0x00 }; /*9131*/
const unsigned char  uc2_9139 [] = {0x7F, 0x70, 0x2A, 0xD0, 0x39, 0x50, 0x29, 0x60, 0x3A, 0xD0, 0x2B, 0x50, 0x7C, 0xD0, 0x17, 0x50, 0x6D, 0x60, 0x14, 0xC0, 0x64, 0x40, 0x00, 0x00 }; /*9139*/
const unsigned char  uc2_9143 [] = {0x3E, 0x70, 0x08, 0x50, 0x7F, 0x50, 0x49, 0x50, 0x2A, 0x60, 0x08, 0x50, 0x22, 0x50, 0x7F, 0x50, 0x55, 0x60, 0x7F, 0x40, 0x55, 0x40, 0x00, 0x00 }; /*9143*/
const unsigned char  uc2_9146 [] = {0x14, 0x70, 0x55, 0x50, 0x7F, 0x50, 0x55, 0x60, 0x7F, 0x50, 0x55, 0x50, 0x7F, 0x50, 0x22, 0x50, 0x3E, 0x60, 0x15, 0xC0, 0x7E, 0x40, 0x00, 0x00 }; /*9146*/
const unsigned char  uc2_9149 [] = {0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x25, 0x20, 0x28, 0xA0, 0x30, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*9149*/
const unsigned char  uc2_914A [] = {0x7D, 0xF0, 0x28, 0x40, 0x7C, 0x40, 0x54, 0x40, 0x54, 0x40, 0x6C, 0x40, 0x44, 0x40, 0x7C, 0x40, 0x44, 0x40, 0x7C, 0x40, 0x45, 0x80, 0x00, 0x00 }; /*914A*/
const unsigned char  uc2_914B [] = {0x08, 0x80, 0x7F, 0xF0, 0x05, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x28, 0xE0, 0x30, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*914B*/
const unsigned char  uc2_914C [] = {0x7E, 0x80, 0x14, 0xF0, 0x3E, 0x90, 0x2B, 0x10, 0x2A, 0x90, 0x36, 0x50, 0x22, 0x50, 0x3E, 0x10, 0x22, 0x10, 0x3E, 0x10, 0x22, 0xE0, 0x00, 0x00 }; /*914C*/
const unsigned char  uc2_914D [] = {0x7E, 0xF0, 0x14, 0x10, 0x3E, 0x10, 0x2A, 0x10, 0x2A, 0xF0, 0x36, 0x90, 0x22, 0x80, 0x3E, 0x90, 0x22, 0x90, 0x3E, 0x90, 0x22, 0x60, 0x00, 0x00 }; /*914D*/
const unsigned char  uc2_914E [] = {0x7F, 0x20, 0x14, 0x20, 0x3E, 0xF0, 0x2A, 0x20, 0x2B, 0x20, 0x36, 0xA0, 0x22, 0xA0, 0x3E, 0x20, 0x22, 0x20, 0x3E, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*914E*/
const unsigned char  uc2_914F [] = {0x7C, 0x40, 0x28, 0x40, 0x7D, 0x70, 0x57, 0xD0, 0x55, 0x50, 0x6D, 0x50, 0x45, 0x60, 0x7D, 0x50, 0x45, 0x10, 0x7D, 0x10, 0x44, 0xE0, 0x00, 0x00 }; /*914F*/
const unsigned char  uc2_9150 [] = {0x7E, 0xE0, 0x14, 0x40, 0x3E, 0x40, 0x2A, 0x40, 0x2B, 0xF0, 0x36, 0x40, 0x22, 0x40, 0x3E, 0x40, 0x22, 0x40, 0x3E, 0x40, 0x22, 0x40, 0x00, 0x00 }; /*9150*/
const unsigned char  uc2_9152 [] = {0x5F, 0xF0, 0x22, 0x80, 0x2F, 0xE0, 0x4A, 0xA0, 0x2A, 0xA0, 0x2C, 0x60, 0x08, 0x20, 0x2F, 0xE0, 0x28, 0x20, 0x4F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*9152*/
const unsigned char  uc2_9157 [] = {0x7C, 0x00, 0x29, 0x10, 0x7D, 0xB0, 0x55, 0x50, 0x55, 0x50, 0x6D, 0x50, 0x45, 0x50, 0x7D, 0xB0, 0x45, 0x10, 0x7D, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*9157*/
const unsigned char  uc2_915A [] = {0x7E, 0xA0, 0x14, 0xA0, 0x3E, 0xA0, 0x2B, 0x20, 0x2A, 0x10, 0x37, 0xE0, 0x22, 0xA0, 0x3E, 0xA0, 0x22, 0xA0, 0x3E, 0xA0, 0x23, 0x40, 0x00, 0x00 }; /*915A*/
const unsigned char  uc2_915D [] = {0x7C, 0xE0, 0x28, 0x00, 0x7C, 0x00, 0x54, 0x00, 0x55, 0xF0, 0x6C, 0x40, 0x44, 0x40, 0x7C, 0x80, 0x44, 0xA0, 0x7D, 0x20, 0x45, 0xD0, 0x00, 0x00 }; /*915D*/
const unsigned char  uc2_915E [] = {0x7F, 0x40, 0x14, 0x40, 0x3F, 0xF0, 0x2A, 0x40, 0x2A, 0x40, 0x36, 0xA0, 0x22, 0xA0, 0x3E, 0xA0, 0x22, 0xA0, 0x3F, 0x50, 0x22, 0x50, 0x00, 0x00 }; /*915E*/
const unsigned char  uc2_9161 [] = {0x7C, 0x40, 0x29, 0xF0, 0x7D, 0x10, 0x55, 0x10, 0x54, 0x80, 0x6C, 0x90, 0x44, 0xE0, 0x7C, 0x80, 0x44, 0x90, 0x7C, 0x90, 0x44, 0x60, 0x00, 0x00 }; /*9161*/
const unsigned char  uc2_9162 [] = {0x7C, 0x80, 0x28, 0xF0, 0x7D, 0x80, 0x56, 0x80, 0x54, 0xE0, 0x6C, 0x80, 0x44, 0x80, 0x7C, 0xE0, 0x44, 0x80, 0x7C, 0x80, 0x44, 0x80, 0x00, 0x00 }; /*9162*/
const unsigned char  uc2_9163 [] = {0x7D, 0x20, 0x29, 0x20, 0x7F, 0xF0, 0x55, 0x20, 0x55, 0x20, 0x6D, 0xE0, 0x45, 0x20, 0x7D, 0x20, 0x45, 0x20, 0x7D, 0xE0, 0x45, 0x20, 0x00, 0x00 }; /*9163*/
const unsigned char  uc2_9164 [] = {0x7F, 0x40, 0x14, 0x40, 0x3F, 0xF0, 0x2A, 0x40, 0x2A, 0x40, 0x36, 0xE0, 0x22, 0xA0, 0x3E, 0xA0, 0x22, 0xA0, 0x3E, 0xE0, 0x22, 0xA0, 0x00, 0x00 }; /*9164*/
const unsigned char  uc2_9165 [] = {0x7C, 0x60, 0x2B, 0x80, 0x7C, 0x80, 0x57, 0xF0, 0x54, 0x80, 0x6C, 0xC0, 0x45, 0xA0, 0x7E, 0xA0, 0x44, 0xA0, 0x7C, 0x90, 0x44, 0x80, 0x00, 0x00 }; /*9165*/
const unsigned char  uc2_9169 [] = {0x7F, 0x40, 0x14, 0x70, 0x3E, 0x90, 0x2B, 0xA0, 0x2A, 0x40, 0x36, 0xF0, 0x23, 0x90, 0x3E, 0x90, 0x22, 0x90, 0x3E, 0xF0, 0x22, 0x90, 0x00, 0x00 }; /*9169*/
const unsigned char  uc2_916A [] = {0x7E, 0x80, 0x14, 0xE0, 0x3F, 0xA0, 0x2A, 0xA0, 0x2A, 0x40, 0x37, 0xB0, 0x22, 0xE0, 0x3E, 0xA0, 0x22, 0xA0, 0x3E, 0xE0, 0x22, 0xA0, 0x00, 0x00 }; /*916A*/
const unsigned char  uc2_916C [] = {0x7F, 0x10, 0x29, 0x50, 0x7D, 0x50, 0x55, 0x50, 0x56, 0xB0, 0x6D, 0x50, 0x45, 0x50, 0x7D, 0x50, 0x45, 0x50, 0x7D, 0x50, 0x46, 0x10, 0x00, 0x00 }; /*916C*/
const unsigned char  uc2_916E [] = {0x7D, 0xF0, 0x29, 0x10, 0x7D, 0xF0, 0x55, 0x10, 0x55, 0x70, 0x6D, 0x50, 0x45, 0x50, 0x7D, 0x70, 0x45, 0x10, 0x7D, 0x10, 0x45, 0x60, 0x00, 0x00 }; /*916E*/
const unsigned char  uc2_916F [] = {0x7D, 0x30, 0x29, 0xC0, 0x7D, 0x10, 0x54, 0xE0, 0x54, 0x00, 0x6D, 0xF0, 0x45, 0x10, 0x7D, 0xF0, 0x45, 0x10, 0x7D, 0xF0, 0x45, 0x10, 0x00, 0x00 }; /*916F*/
const unsigned char  uc2_9170 [] = {0x7C, 0x80, 0x2A, 0x80, 0x7F, 0xE0, 0x54, 0x80, 0x54, 0x80, 0x6F, 0xF0, 0x45, 0x40, 0x7D, 0x40, 0x45, 0x50, 0x7D, 0x50, 0x46, 0x20, 0x00, 0x00 }; /*9170*/
const unsigned char  uc2_9171 [] = {0x08, 0x80, 0x68, 0xE0, 0x1B, 0x20, 0x68, 0xC0, 0x09, 0x00, 0x7F, 0xF0, 0x28, 0xA0, 0x30, 0x60, 0x3F, 0xE0, 0x20, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*9171*/
const unsigned char  uc2_9172 [] = {0x7F, 0xE0, 0x14, 0xA0, 0x3E, 0xA0, 0x2A, 0xE0, 0x2A, 0x00, 0x37, 0xF0, 0x22, 0x40, 0x3E, 0xE0, 0x22, 0x40, 0x3E, 0x40, 0x23, 0xF0, 0x00, 0x00 }; /*9172*/
const unsigned char  uc2_9174 [] = {0x7C, 0x40, 0x28, 0xA0, 0x7D, 0x10, 0x54, 0xE0, 0x54, 0x40, 0x6D, 0xF0, 0x44, 0x40, 0x7D, 0x60, 0x45, 0x50, 0x7E, 0x50, 0x45, 0x80, 0x00, 0x00 }; /*9174*/
const unsigned char  uc2_9175 [] = {0x7C, 0x90, 0x29, 0xD0, 0x7C, 0xA0, 0x57, 0xF0, 0x54, 0x80, 0x6D, 0xE0, 0x46, 0x20, 0x7C, 0x40, 0x45, 0xF0, 0x7C, 0x40, 0x45, 0x80, 0x00, 0x00 }; /*9175*/
const unsigned char  uc2_9176 [] = {0x7D, 0x00, 0x29, 0xF0, 0x7E, 0x00, 0x57, 0xE0, 0x55, 0x20, 0x6F, 0xF0, 0x45, 0x20, 0x7C, 0xA0, 0x47, 0xF0, 0x7C, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*9176*/
const unsigned char  uc2_9177 [] = {0x7C, 0x80, 0x2A, 0x80, 0x7F, 0xE0, 0x54, 0x80, 0x57, 0xF0, 0x6C, 0x00, 0x45, 0xE0, 0x7D, 0x20, 0x45, 0x20, 0x7D, 0xE0, 0x45, 0x20, 0x00, 0x00 }; /*9177*/
const unsigned char  uc2_9178 [] = {0x7C, 0x80, 0x29, 0x20, 0x7F, 0xD0, 0x55, 0x50, 0x55, 0x20, 0x6E, 0xA0, 0x44, 0xE0, 0x7F, 0xA0, 0x44, 0xA0, 0x7C, 0x40, 0x45, 0xB0, 0x00, 0x00 }; /*9178*/
const unsigned char  uc2_9179 [] = {0x7C, 0x30, 0x2B, 0xD0, 0x7D, 0x50, 0x54, 0xA0, 0x54, 0x20, 0x6F, 0xF0, 0x45, 0x20, 0x7C, 0xA0, 0x44, 0xA0, 0x7C, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*9179*/
const unsigned char  uc2_917D [] = {0x7F, 0xF0, 0x28, 0xA0, 0x7D, 0xB0, 0x54, 0xA0, 0x55, 0xF0, 0x6D, 0x00, 0x45, 0x00, 0x7D, 0x00, 0x45, 0x00, 0x7D, 0x00, 0x46, 0x00, 0x00, 0x00 }; /*917D*/
const unsigned char  uc2_917E [] = {0x7F, 0xF0, 0x28, 0x00, 0x7D, 0xB0, 0x55, 0x50, 0x55, 0x50, 0x6D, 0xB0, 0x45, 0x50, 0x7D, 0x50, 0x45, 0x50, 0x7D, 0x50, 0x46, 0xA0, 0x00, 0x00 }; /*917E*/
const unsigned char  uc2_917F [] = {0x7C, 0x40, 0x29, 0xF0, 0x7D, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x6D, 0xF0, 0x45, 0x50, 0x7D, 0x50, 0x45, 0x20, 0x7D, 0x60, 0x45, 0x90, 0x00, 0x00 }; /*917F*/
const unsigned char  uc2_9185 [] = {0x7E, 0x40, 0x15, 0xF0, 0x3E, 0xA0, 0x2A, 0x40, 0x2B, 0xF0, 0x36, 0x00, 0x22, 0xE0, 0x3E, 0xA0, 0x22, 0xA0, 0x3E, 0xE0, 0x22, 0xA0, 0x00, 0x00 }; /*9185*/
const unsigned char  uc2_9187 [] = {0x7C, 0x80, 0x2B, 0xF0, 0x7D, 0x20, 0x55, 0xE0, 0x54, 0x00, 0x6D, 0xE0, 0x44, 0x40, 0x7F, 0xF0, 0x44, 0x40, 0x7C, 0x40, 0x45, 0x80, 0x00, 0x00 }; /*9187*/
const unsigned char  uc2_9189 [] = {0x7C, 0x80, 0x2B, 0xE0, 0x7D, 0x40, 0x55, 0x40, 0x56, 0xA0, 0x6C, 0x80, 0x47, 0xF0, 0x7C, 0x80, 0x44, 0x80, 0x7C, 0x80, 0x44, 0x80, 0x00, 0x00 }; /*9189*/
const unsigned char  uc2_918B [] = {0x7D, 0x40, 0x2B, 0xE0, 0x7D, 0x40, 0x57, 0xF0, 0x54, 0x00, 0x6D, 0xE0, 0x45, 0x20, 0x7D, 0xE0, 0x45, 0x20, 0x7D, 0xE0, 0x45, 0x20, 0x00, 0x00 }; /*918B*/
const unsigned char  uc2_918C [] = {0x7D, 0xF0, 0x29, 0x10, 0x7D, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x6D, 0x40, 0x45, 0x50, 0x7D, 0xE0, 0x45, 0x50, 0x7D, 0x50, 0x45, 0xB0, 0x00, 0x00 }; /*918C*/
const unsigned char  uc2_918D [] = {0x7D, 0xF0, 0x29, 0x10, 0x7D, 0xF0, 0x55, 0x10, 0x57, 0xF0, 0x6C, 0x40, 0x45, 0x70, 0x7D, 0x40, 0x45, 0x40, 0x7E, 0xC0, 0x44, 0x30, 0x00, 0x00 }; /*918D*/
const unsigned char  uc2_9190 [] = {0x7D, 0x70, 0x29, 0x50, 0x7F, 0xD0, 0x55, 0x70, 0x55, 0x50, 0x6E, 0xD0, 0x46, 0xF0, 0x7D, 0x50, 0x44, 0x50, 0x7C, 0x50, 0x44, 0xA0, 0x00, 0x00 }; /*9190*/
const unsigned char  uc2_9191 [] = {0x7D, 0xF0, 0x28, 0x50, 0x7D, 0x60, 0x55, 0x40, 0x56, 0xF0, 0x6D, 0x20, 0x45, 0xE0, 0x7D, 0x20, 0x45, 0xE0, 0x7D, 0x20, 0x45, 0x60, 0x00, 0x00 }; /*9191*/
const unsigned char  uc2_9192 [] = {0x7D, 0xF0, 0x29, 0x10, 0x7D, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x6D, 0x40, 0x45, 0xF0, 0x7E, 0x40, 0x44, 0xE0, 0x7C, 0x40, 0x45, 0xF0, 0x00, 0x00 }; /*9192*/
const unsigned char  uc2_919A [] = {0x7C, 0x40, 0x29, 0x50, 0x7C, 0xE0, 0x54, 0x40, 0x57, 0xF0, 0x6D, 0x40, 0x45, 0xE0, 0x7D, 0x50, 0x45, 0x40, 0x7D, 0x00, 0x46, 0xF0, 0x00, 0x00 }; /*919A*/
const unsigned char  uc2_919B [] = {0x7D, 0x40, 0x2B, 0xF0, 0x7D, 0x40, 0x55, 0xC0, 0x56, 0x30, 0x6D, 0xC0, 0x44, 0x80, 0x7F, 0xE0, 0x44, 0x80, 0x7C, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*919B*/
const unsigned char  uc2_91A2 [] = {0x7C, 0x80, 0x2B, 0xF0, 0x7C, 0x80, 0x55, 0xE0, 0x57, 0x20, 0x6D, 0xE0, 0x44, 0x00, 0x7F, 0xF0, 0x45, 0x50, 0x7D, 0x50, 0x47, 0xF0, 0x00, 0x00 }; /*91A2*/
const unsigned char  uc2_91A3 [] = {0x7C, 0x80, 0x2B, 0xF0, 0x7C, 0xA0, 0x57, 0xF0, 0x6C, 0xA0, 0x45, 0xE0, 0x7C, 0x80, 0x45, 0xE0, 0x7D, 0x20, 0x45, 0xE0, 0x09, 0x20, 0x00, 0x00 }; /*91A3*/
const unsigned char  uc2_91AA [] = {0x7F, 0x70, 0x2A, 0xD0, 0x7D, 0xB0, 0x56, 0xD0, 0x55, 0x20, 0x6E, 0x40, 0x45, 0xA0, 0x7C, 0x40, 0x45, 0x90, 0x7C, 0x60, 0x45, 0x80, 0x00, 0x00 }; /*91AA*/
const unsigned char  uc2_91AD [] = {0x7D, 0x50, 0x2B, 0x60, 0x7E, 0xB0, 0x55, 0x40, 0x57, 0xF0, 0x6C, 0x80, 0x47, 0xE0, 0x7C, 0x80, 0x47, 0xF0, 0x7C, 0xA0, 0x47, 0x10, 0x00, 0x00 }; /*91AD*/
const unsigned char  uc2_91AE [] = {0x7D, 0x40, 0x29, 0xF0, 0x7F, 0x40, 0x55, 0xE0, 0x55, 0x40, 0x6D, 0xE0, 0x45, 0x40, 0x7D, 0xF0, 0x46, 0xA0, 0x7D, 0x50, 0x45, 0x50, 0x00, 0x00 }; /*91AE*/
const unsigned char  uc2_91AF [] = {0x7C, 0x80, 0x2B, 0xE0, 0x7D, 0x40, 0x57, 0xE0, 0x55, 0x40, 0x6D, 0x50, 0x44, 0x20, 0x7F, 0xF0, 0x45, 0x50, 0x7D, 0x50, 0x47, 0xF0, 0x00, 0x00 }; /*91AF*/
const unsigned char  uc2_91B4 [] = {0x7D, 0x40, 0x2B, 0xF0, 0x7D, 0x50, 0x57, 0xF0, 0x55, 0x50, 0x6F, 0xF0, 0x45, 0x20, 0x7D, 0xE0, 0x45, 0x20, 0x7C, 0xC0, 0x47, 0xF0, 0x00, 0x00 }; /*91B4*/
const unsigned char  uc2_91B5 [] = {0x7C, 0xE0, 0x28, 0x80, 0x7F, 0xF0, 0x54, 0x90, 0x57, 0xE0, 0x6C, 0x90, 0x47, 0xF0, 0x7D, 0x10, 0x46, 0xE0, 0x7D, 0x50, 0x44, 0xC0, 0x00, 0x00 }; /*91B5*/
const unsigned char  uc2_91BA [] = {0x7C, 0xE0, 0x28, 0x40, 0x7D, 0xF0, 0x54, 0x40, 0x55, 0xF0, 0x6D, 0x50, 0x45, 0xF0, 0x7C, 0x40, 0x45, 0xF0, 0x7C, 0xA0, 0x45, 0x50, 0x00, 0x00 }; /*91BA*/
const unsigned char  uc2_91C7 [] = {0x00, 0xF0, 0x7F, 0x20, 0x24, 0x20, 0x12, 0x40, 0x10, 0x80, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x80, 0x12, 0x40, 0x62, 0x30, 0x02, 0x00, 0x00, 0x00 }; /*91C7*/
const unsigned char  uc2_91C9 [] = {0x06, 0x40, 0x78, 0x40, 0x01, 0xF0, 0x2B, 0x50, 0x15, 0x50, 0x7F, 0xF0, 0x09, 0x50, 0x1D, 0x50, 0x2B, 0x50, 0x29, 0xF0, 0x49, 0x10, 0x00, 0x00 }; /*91C9*/
const unsigned char  uc2_91CA [] = {0x07, 0xE0, 0x7A, 0xA0, 0x2A, 0xA0, 0x14, 0x40, 0x7F, 0xB0, 0x08, 0x40, 0x1C, 0xE0, 0x2A, 0x40, 0x29, 0xF0, 0x48, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*91CA*/
const unsigned char  uc2_91CC [] = {0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*91CC*/
const unsigned char  uc2_91CD [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*91CD*/
const unsigned char  uc2_91CE [] = {0x7D, 0xE0, 0x54, 0xA0, 0x7C, 0x40, 0x57, 0xF0, 0x7C, 0x50, 0x10, 0x50, 0x7C, 0x60, 0x10, 0x40, 0x10, 0x40, 0x1C, 0x40, 0x61, 0x80, 0x00, 0x00 }; /*91CE*/
const unsigned char  uc2_91CF [] = {0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*91CF*/
const unsigned char  uc2_91D1 [] = {0x02, 0x00, 0x02, 0x00, 0x05, 0x00, 0x08, 0x80, 0x1F, 0xC0, 0x62, 0x30, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*91D1*/
const unsigned char  uc2_91DC [] = {0x08, 0xC0, 0x35, 0x20, 0x02, 0x00, 0x0D, 0x80, 0x70, 0x70, 0x0F, 0x80, 0x02, 0x00, 0x3F, 0xE0, 0x12, 0x40, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*91DC*/
const unsigned char  uc2_9274 [] = {0x09, 0x00, 0x29, 0xF0, 0x29, 0x40, 0x2E, 0x20, 0x0A, 0x20, 0x0D, 0x80, 0x77, 0x70, 0x02, 0x00, 0x1F, 0xC0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*9274*/
const unsigned char  uc2_928E [] = {0x3B, 0xC0, 0x12, 0x40, 0x13, 0x50, 0x1C, 0xD0, 0x67, 0x20, 0x18, 0xC0, 0x6F, 0xB0, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*928E*/
const unsigned char  uc2_92AE [] = {0x02, 0x00, 0x7F, 0xF0, 0x15, 0x20, 0x15, 0x10, 0x67, 0x10, 0x08, 0x80, 0x77, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*92AE*/
const unsigned char  uc2_92C8 [] = {0x33, 0xE0, 0x08, 0x80, 0x37, 0xF0, 0x09, 0x40, 0x33, 0x20, 0x0D, 0xA0, 0x37, 0x60, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*92C8*/
const unsigned char  uc2_933E [] = {0x7F, 0xE0, 0x29, 0x00, 0x7D, 0xF0, 0x09, 0x40, 0x7F, 0x40, 0x08, 0xC0, 0x77, 0x30, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*933E*/
const unsigned char  uc2_936A [] = {0x3C, 0x80, 0x14, 0xF0, 0x09, 0xA0, 0x7E, 0x40, 0x2B, 0xA0, 0x4C, 0x90, 0x37, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*936A*/
const unsigned char  uc2_938F [] = {0x60, 0x80, 0x17, 0xF0, 0x62, 0x20, 0x17, 0xD0, 0x62, 0xA0, 0x07, 0xB0, 0x18, 0xC0, 0x67, 0x30, 0x1F, 0xC0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*938F*/
const unsigned char  uc2_93CA [] = {0x10, 0x80, 0x7C, 0xF0, 0x11, 0xA0, 0x7C, 0x40, 0x2A, 0xB0, 0x4D, 0x80, 0x77, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*93CA*/
const unsigned char  uc2_93D6 [] = {0x01, 0x00, 0x3F, 0xF0, 0x22, 0xA0, 0x3F, 0xE0, 0x28, 0x90, 0x2E, 0xE0, 0x29, 0x90, 0x2E, 0xE0, 0x3B, 0xB0, 0x25, 0x40, 0x5F, 0xF0, 0x00, 0x00 }; /*93D6*/
const unsigned char  uc2_943E [] = {0x3C, 0x40, 0x25, 0xF0, 0x3C, 0xA0, 0x25, 0xF0, 0x5E, 0x40, 0x05, 0x80, 0x7F, 0x70, 0x02, 0x00, 0x3F, 0xE0, 0x0A, 0x80, 0x7F, 0xF0, 0x00, 0x00 }; /*943E*/
const unsigned char  uc2_946B [] = {0x0F, 0x80, 0x72, 0x70, 0x1F, 0xC0, 0x0A, 0x80, 0x7F, 0xF0, 0x10, 0x40, 0x6D, 0xB0, 0x10, 0x40, 0x7D, 0xF0, 0x28, 0xA0, 0x7D, 0xF0, 0x00, 0x00 }; /*946B*/
const unsigned char  uc2_9486 [] = {0x11, 0x00, 0x1D, 0x00, 0x21, 0x00, 0x3D, 0x00, 0x51, 0x00, 0x3D, 0x00, 0x11, 0x00, 0x11, 0x10, 0x15, 0x10, 0x19, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*9486*/
const unsigned char  uc2_9487 [] = {0x10, 0x00, 0x1D, 0xE0, 0x20, 0x20, 0x3C, 0x40, 0x50, 0x40, 0x3C, 0x80, 0x10, 0x80, 0x11, 0x00, 0x15, 0x10, 0x19, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*9487*/
const unsigned char  uc2_9488 [] = {0x10, 0x80, 0x1C, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x50, 0x80, 0x3C, 0x80, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*9488*/
const unsigned char  uc2_9489 [] = {0x10, 0x00, 0x1D, 0xF0, 0x20, 0x40, 0x3C, 0x40, 0x50, 0x40, 0x3C, 0x40, 0x10, 0x40, 0x10, 0x40, 0x14, 0x40, 0x18, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*9489*/
const unsigned char  uc2_948A [] = {0x10, 0x10, 0x1C, 0x90, 0x20, 0x90, 0x3C, 0x90, 0x50, 0x90, 0x3C, 0x90, 0x10, 0x90, 0x10, 0x90, 0x14, 0x10, 0x18, 0x10, 0x10, 0x60, 0x00, 0x00 }; /*948A*/
const unsigned char  uc2_948B [] = {0x10, 0x80, 0x1C, 0x80, 0x20, 0x80, 0x3C, 0xC0, 0x50, 0xA0, 0x3C, 0x90, 0x10, 0x90, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*948B*/
const unsigned char  uc2_948C [] = {0x10, 0x00, 0x1D, 0xF0, 0x20, 0x10, 0x3C, 0x20, 0x50, 0x40, 0x3C, 0x40, 0x10, 0x40, 0x10, 0x40, 0x14, 0x40, 0x18, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*948C*/
const unsigned char  uc2_948D [] = {0x10, 0x80, 0x1C, 0x80, 0x20, 0x80, 0x3C, 0x80, 0x53, 0xE0, 0x3C, 0x80, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*948D*/
const unsigned char  uc2_948E [] = {0x10, 0x60, 0x1F, 0x80, 0x20, 0x80, 0x3C, 0x80, 0x50, 0x80, 0x3F, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*948E*/
const unsigned char  uc2_948F [] = {0x11, 0x10, 0x1D, 0x50, 0x21, 0x50, 0x3D, 0x50, 0x51, 0x50, 0x3D, 0x50, 0x11, 0x50, 0x11, 0x50, 0x15, 0x50, 0x19, 0x50, 0x12, 0x10, 0x00, 0x00 }; /*948F*/
const unsigned char  uc2_9490 [] = {0x10, 0x20, 0x1C, 0x40, 0x21, 0x80, 0x3C, 0x10, 0x50, 0x20, 0x3C, 0x40, 0x11, 0x80, 0x10, 0x10, 0x14, 0x20, 0x18, 0xC0, 0x13, 0x00, 0x00, 0x00 }; /*9490*/
const unsigned char  uc2_9492 [] = {0x10, 0x00, 0x1F, 0xC0, 0x22, 0x40, 0x3E, 0x40, 0x53, 0x40, 0x3E, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x16, 0x50, 0x1A, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*9492*/
const unsigned char  uc2_9493 [] = {0x11, 0x00, 0x1D, 0xF0, 0x21, 0x10, 0x3E, 0x10, 0x50, 0x90, 0x3C, 0x50, 0x10, 0x50, 0x10, 0x10, 0x14, 0x10, 0x18, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*9493*/
const unsigned char  uc2_9494 [] = {0x13, 0x70, 0x1C, 0x90, 0x22, 0x10, 0x3E, 0x10, 0x52, 0x10, 0x3E, 0x10, 0x12, 0x10, 0x12, 0x10, 0x16, 0x10, 0x1A, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*9494*/
const unsigned char  uc2_9495 [] = {0x10, 0x80, 0x1C, 0x80, 0x23, 0xF0, 0x3C, 0xA0, 0x50, 0xA0, 0x3D, 0x20, 0x11, 0xA0, 0x10, 0x40, 0x14, 0xA0, 0x19, 0x20, 0x12, 0x20, 0x00, 0x00 }; /*9495*/
const unsigned char  uc2_9497 [] = {0x10, 0x00, 0x1F, 0xE0, 0x22, 0xA0, 0x3D, 0x40, 0x51, 0x40, 0x3C, 0x80, 0x10, 0x80, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*9497*/
const unsigned char  uc2_9499 [] = {0x13, 0xF0, 0x1C, 0x80, 0x22, 0x80, 0x3E, 0xF0, 0x52, 0x80, 0x3E, 0x80, 0x13, 0xF0, 0x10, 0x10, 0x14, 0x10, 0x18, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*9499*/
const unsigned char  uc2_949A [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x40, 0x3C, 0x80, 0x51, 0xA0, 0x3E, 0x90, 0x10, 0x90, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*949A*/
const unsigned char  uc2_949B [] = {0x10, 0x80, 0x1C, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x50, 0x80, 0x3C, 0x80, 0x11, 0x40, 0x11, 0x40, 0x16, 0xA0, 0x1A, 0xA0, 0x14, 0x10, 0x00, 0x00 }; /*949B*/
const unsigned char  uc2_949C [] = {0x10, 0x00, 0x1D, 0xF0, 0x21, 0x00, 0x3D, 0x00, 0x51, 0xE0, 0x3D, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x15, 0x00, 0x19, 0x00, 0x11, 0xF0, 0x00, 0x00 }; /*949C*/
const unsigned char  uc2_949D [] = {0x10, 0x80, 0x1F, 0xF0, 0x20, 0x80, 0x3E, 0xA0, 0x52, 0xA0, 0x3E, 0xA0, 0x13, 0xE0, 0x10, 0xA0, 0x14, 0x90, 0x18, 0x90, 0x10, 0x60, 0x00, 0x00 }; /*949D*/
const unsigned char  uc2_949E [] = {0x10, 0x80, 0x1C, 0x80, 0x22, 0xA0, 0x3E, 0x90, 0x52, 0x90, 0x3C, 0x80, 0x10, 0xA0, 0x10, 0x20, 0x14, 0x40, 0x19, 0x80, 0x16, 0x00, 0x00, 0x00 }; /*949E*/
const unsigned char  uc2_949F [] = {0x10, 0x40, 0x1C, 0x40, 0x21, 0xF0, 0x3D, 0x50, 0x51, 0x50, 0x3D, 0xF0, 0x11, 0x50, 0x10, 0x40, 0x14, 0x40, 0x18, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*949F*/
const unsigned char  uc2_94A0 [] = {0x10, 0x40, 0x1C, 0x40, 0x23, 0xF0, 0x3E, 0x50, 0x52, 0x50, 0x3F, 0xB0, 0x12, 0x30, 0x12, 0x10, 0x16, 0x10, 0x1A, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*94A0*/
const unsigned char  uc2_94A1 [] = {0x10, 0x00, 0x1D, 0xF0, 0x21, 0x10, 0x3D, 0x50, 0x51, 0x50, 0x3D, 0x50, 0x11, 0x50, 0x11, 0x50, 0x14, 0x60, 0x18, 0x90, 0x13, 0x10, 0x00, 0x00 }; /*94A1*/
const unsigned char  uc2_94A2 [] = {0x10, 0x00, 0x1F, 0xF0, 0x22, 0x10, 0x3F, 0x10, 0x52, 0xB0, 0x3E, 0x50, 0x12, 0x50, 0x12, 0xB0, 0x17, 0x10, 0x1A, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*94A2*/
const unsigned char  uc2_94A3 [] = {0x10, 0x30, 0x1F, 0xC0, 0x22, 0x00, 0x3B, 0xE0, 0x52, 0xA0, 0x3A, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x16, 0xA0, 0x1A, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*94A3*/
const unsigned char  uc2_94A4 [] = {0x10, 0x80, 0x1C, 0x80, 0x21, 0x40, 0x3E, 0x30, 0x51, 0x80, 0x3C, 0x40, 0x13, 0xE0, 0x10, 0x20, 0x14, 0x40, 0x18, 0x40, 0x10, 0x80, 0x00, 0x00 }; /*94A4*/
const unsigned char  uc2_94A5 [] = {0x10, 0x00, 0x1D, 0xF0, 0x21, 0x10, 0x3D, 0x10, 0x51, 0xF0, 0x3D, 0x10, 0x11, 0x10, 0x11, 0xF0, 0x15, 0x10, 0x19, 0x10, 0x16, 0x60, 0x00, 0x00 }; /*94A5*/
const unsigned char  uc2_94A6 [] = {0x12, 0x00, 0x1F, 0xE0, 0x22, 0x20, 0x3A, 0xA0, 0x54, 0xC0, 0x38, 0x80, 0x11, 0x40, 0x11, 0x40, 0x15, 0x20, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*94A6*/
const unsigned char  uc2_94A7 [] = {0x11, 0x00, 0x1D, 0x00, 0x21, 0xF0, 0x3E, 0x10, 0x50, 0x10, 0x3D, 0x90, 0x10, 0x50, 0x10, 0x90, 0x17, 0x10, 0x18, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*94A7*/
const unsigned char  uc2_94A8 [] = {0x11, 0x00, 0x1F, 0xE0, 0x22, 0x20, 0x3A, 0xC0, 0x52, 0x00, 0x3B, 0xF0, 0x10, 0x10, 0x17, 0xD0, 0x14, 0x10, 0x18, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*94A8*/
const unsigned char  uc2_94A9 [] = {0x11, 0x00, 0x1D, 0xF0, 0x21, 0x10, 0x3E, 0x90, 0x50, 0x90, 0x3D, 0x50, 0x11, 0x50, 0x11, 0xB0, 0x14, 0x10, 0x18, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*94A9*/
const unsigned char  uc2_94AA [] = {0x11, 0x00, 0x1C, 0x80, 0x23, 0xF0, 0x3C, 0x00, 0x50, 0x00, 0x3D, 0xC0, 0x11, 0x40, 0x11, 0x50, 0x15, 0x50, 0x1A, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*94AA*/
const unsigned char  uc2_94AB [] = {0x11, 0x80, 0x1C, 0x40, 0x23, 0xF0, 0x3D, 0x00, 0x51, 0x00, 0x3D, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x15, 0x20, 0x1A, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*94AB*/
const unsigned char  uc2_94AC [] = {0x10, 0x80, 0x1E, 0xA0, 0x22, 0xA0, 0x3A, 0xA0, 0x54, 0xC0, 0x38, 0x80, 0x10, 0x80, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*94AC*/
const unsigned char  uc2_94AD [] = {0x10, 0x20, 0x1D, 0x20, 0x20, 0xA0, 0x3C, 0xA0, 0x51, 0x20, 0x3C, 0xA0, 0x10, 0xA0, 0x10, 0xF0, 0x17, 0x20, 0x18, 0x20, 0x10, 0x20, 0x00, 0x00 }; /*94AD*/
const unsigned char  uc2_94AE [] = {0x10, 0x00, 0x1F, 0xE0, 0x20, 0xA0, 0x3C, 0xA0, 0x50, 0xA0, 0x3F, 0xE0, 0x11, 0x40, 0x11, 0x40, 0x15, 0x40, 0x19, 0x40, 0x17, 0xF0, 0x00, 0x00 }; /*94AE*/
const unsigned char  uc2_94AF [] = {0x10, 0x00, 0x1F, 0xE0, 0x22, 0xA0, 0x3E, 0xA0, 0x52, 0xA0, 0x3F, 0xE0, 0x12, 0x00, 0x12, 0x00, 0x16, 0x10, 0x1A, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*94AF*/
const unsigned char  uc2_94B0 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x80, 0x38, 0x80, 0x50, 0x80, 0x3B, 0xE0, 0x10, 0x80, 0x10, 0xC0, 0x14, 0xA0, 0x18, 0xA0, 0x17, 0xF0, 0x00, 0x00 }; /*94B0*/
const unsigned char  uc2_94B1 [] = {0x10, 0xC0, 0x1C, 0xA0, 0x20, 0xE0, 0x3F, 0x80, 0x50, 0x90, 0x3C, 0xE0, 0x13, 0x90, 0x10, 0xA0, 0x14, 0xD0, 0x1B, 0x50, 0x10, 0x30, 0x00, 0x00 }; /*94B1*/
const unsigned char  uc2_94B2 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x80, 0x3C, 0x80, 0x52, 0x80, 0x3E, 0xE0, 0x12, 0x80, 0x12, 0x80, 0x16, 0x80, 0x1A, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*94B2*/
const unsigned char  uc2_94B3 [] = {0x11, 0x20, 0x1D, 0x20, 0x23, 0xF0, 0x3D, 0x20, 0x51, 0x20, 0x3D, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x15, 0x20, 0x19, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*94B3*/
const unsigned char  uc2_94B4 [] = {0x10, 0x80, 0x1C, 0x80, 0x27, 0xF0, 0x38, 0x80, 0x50, 0x80, 0x3B, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*94B4*/
const unsigned char  uc2_94B5 [] = {0x10, 0x80, 0x1C, 0x80, 0x27, 0xF0, 0x38, 0x80, 0x51, 0xC0, 0x3A, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x17, 0xE0, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*94B5*/
const unsigned char  uc2_94B6 [] = {0x10, 0x00, 0x1F, 0xF0, 0x20, 0x20, 0x3B, 0xA0, 0x52, 0xA0, 0x3E, 0xA0, 0x13, 0xA0, 0x10, 0x20, 0x14, 0x20, 0x18, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*94B6*/
const unsigned char  uc2_94B7 [] = {0x10, 0x00, 0x1F, 0xF0, 0x22, 0x00, 0x3E, 0x00, 0x52, 0xE0, 0x3E, 0xA0, 0x12, 0xA0, 0x12, 0xE0, 0x16, 0x00, 0x1A, 0x00, 0x13, 0xF0, 0x00, 0x00 }; /*94B7*/
const unsigned char  uc2_94B8 [] = {0x10, 0x40, 0x1F, 0xF0, 0x20, 0x80, 0x3D, 0x40, 0x53, 0xF0, 0x3D, 0x50, 0x11, 0x50, 0x11, 0x50, 0x15, 0x60, 0x18, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*94B8*/
const unsigned char  uc2_94B9 [] = {0x10, 0xC0, 0x1C, 0xA0, 0x23, 0xF0, 0x3C, 0x80, 0x50, 0xE0, 0x3C, 0xA0, 0x10, 0xA0, 0x11, 0x40, 0x15, 0x40, 0x1A, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*94B9*/
const unsigned char  uc2_94BA [] = {0x10, 0x60, 0x1C, 0x50, 0x23, 0xF0, 0x3E, 0x40, 0x52, 0x50, 0x3E, 0x50, 0x12, 0xE0, 0x13, 0x40, 0x16, 0x50, 0x18, 0xB0, 0x13, 0x10, 0x00, 0x00 }; /*94BA*/
const unsigned char  uc2_94BB [] = {0x10, 0x80, 0x1C, 0x80, 0x20, 0xF0, 0x3C, 0x80, 0x50, 0x80, 0x3F, 0xE0, 0x12, 0x20, 0x12, 0x20, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*94BB*/
const unsigned char  uc2_94BC [] = {0x11, 0xF0, 0x1D, 0x10, 0x21, 0x10, 0x3D, 0xF0, 0x51, 0x10, 0x3D, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x15, 0x10, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*94BC*/
const unsigned char  uc2_94BD [] = {0x10, 0x00, 0x1F, 0xE0, 0x22, 0x20, 0x3E, 0x20, 0x53, 0xE0, 0x3E, 0x20, 0x12, 0x20, 0x13, 0xE0, 0x16, 0x20, 0x18, 0x00, 0x17, 0xF0, 0x00, 0x00 }; /*94BD*/
const unsigned char  uc2_94BE [] = {0x11, 0xF0, 0x1D, 0x50, 0x21, 0x50, 0x3D, 0xF0, 0x51, 0x50, 0x3D, 0x50, 0x11, 0xF0, 0x11, 0x50, 0x14, 0x40, 0x18, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*94BE*/
const unsigned char  uc2_94BF [] = {0x10, 0x00, 0x1D, 0xF0, 0x21, 0x50, 0x3D, 0x50, 0x51, 0x50, 0x3D, 0xF0, 0x11, 0x50, 0x11, 0x50, 0x15, 0x50, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*94BF*/
const unsigned char  uc2_94C0 [] = {0x10, 0x40, 0x1C, 0x40, 0x20, 0x40, 0x3D, 0xF0, 0x51, 0x50, 0x3D, 0x50, 0x11, 0xF0, 0x11, 0x50, 0x15, 0x50, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*94C0*/
const unsigned char  uc2_94C1 [] = {0x10, 0x80, 0x1A, 0x80, 0x23, 0xE0, 0x3C, 0x80, 0x50, 0x80, 0x3F, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*94C1*/
const unsigned char  uc2_94C2 [] = {0x10, 0x40, 0x1C, 0x80, 0x21, 0xF0, 0x3D, 0x10, 0x51, 0x10, 0x3D, 0xF0, 0x11, 0x10, 0x11, 0x10, 0x15, 0x10, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*94C2*/
const unsigned char  uc2_94C3 [] = {0x10, 0x80, 0x1C, 0x80, 0x21, 0x40, 0x3E, 0x30, 0x51, 0x80, 0x3C, 0x40, 0x13, 0xE0, 0x10, 0x20, 0x14, 0x40, 0x19, 0x80, 0x10, 0x40, 0x00, 0x00 }; /*94C3*/
const unsigned char  uc2_94C4 [] = {0x10, 0x60, 0x1D, 0x80, 0x21, 0x00, 0x3D, 0x40, 0x52, 0x40, 0x3F, 0xF0, 0x10, 0x40, 0x11, 0x60, 0x15, 0x50, 0x1A, 0x50, 0x11, 0x80, 0x00, 0x00 }; /*94C4*/
const unsigned char  uc2_94C5 [] = {0x11, 0xE0, 0x1D, 0x20, 0x21, 0x20, 0x3D, 0x20, 0x52, 0x10, 0x3D, 0xE0, 0x11, 0x20, 0x11, 0x20, 0x15, 0x20, 0x19, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*94C5*/
const unsigned char  uc2_94C6 [] = {0x11, 0x00, 0x1E, 0x70, 0x24, 0x50, 0x3D, 0x50, 0x55, 0x50, 0x3D, 0x50, 0x17, 0x50, 0x15, 0x50, 0x11, 0x60, 0x1A, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*94C6*/
const unsigned char  uc2_94C8 [] = {0x10, 0x80, 0x1C, 0x80, 0x23, 0xF0, 0x3C, 0x80, 0x53, 0xE0, 0x3E, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x16, 0xC0, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*94C8*/
const unsigned char  uc2_94C9 [] = {0x10, 0x40, 0x1F, 0xF0, 0x20, 0x80, 0x3C, 0xA0, 0x51, 0x20, 0x3D, 0xC0, 0x10, 0x40, 0x10, 0xA0, 0x14, 0x90, 0x19, 0x30, 0x11, 0xD0, 0x00, 0x00 }; /*94C9*/
const unsigned char  uc2_94CA [] = {0x11, 0x80, 0x1C, 0x40, 0x23, 0xF0, 0x3E, 0x10, 0x52, 0x10, 0x3D, 0x00, 0x11, 0x20, 0x11, 0xC0, 0x15, 0x10, 0x19, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*94CA*/
const unsigned char  uc2_94CB [] = {0x10, 0x80, 0x1C, 0x50, 0x20, 0x50, 0x3D, 0x10, 0x53, 0x20, 0x3D, 0x20, 0x11, 0x50, 0x11, 0x40, 0x15, 0x90, 0x19, 0x10, 0x12, 0xE0, 0x00, 0x00 }; /*94CB*/
const unsigned char  uc2_94CC [] = {0x13, 0xE0, 0x1E, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x52, 0x80, 0x3E, 0x90, 0x12, 0xE0, 0x12, 0x80, 0x16, 0x90, 0x1A, 0x90, 0x14, 0x60, 0x00, 0x00 }; /*94CC*/
const unsigned char  uc2_94CD [] = {0x10, 0x40, 0x1F, 0xF0, 0x22, 0x50, 0x3A, 0x50, 0x53, 0xE0, 0x3A, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x16, 0x40, 0x1A, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*94CD*/
const unsigned char  uc2_94CE [] = {0x10, 0x00, 0x1D, 0xE0, 0x20, 0xA0, 0x38, 0xA0, 0x50, 0x40, 0x3C, 0xA0, 0x11, 0x50, 0x10, 0xE0, 0x14, 0x40, 0x19, 0xF0, 0x10, 0x40, 0x00, 0x00 }; /*94CE*/
const unsigned char  uc2_94D0 [] = {0x10, 0x90, 0x1F, 0xE0, 0x20, 0xA0, 0x3F, 0xF0, 0x50, 0x80, 0x39, 0xF0, 0x16, 0x80, 0x10, 0xF0, 0x14, 0x10, 0x18, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*94D0*/
const unsigned char  uc2_94D1 [] = {0x10, 0x80, 0x1F, 0xE0, 0x20, 0xA0, 0x38, 0xC0, 0x57, 0xF0, 0x39, 0x00, 0x17, 0x30, 0x11, 0xC0, 0x15, 0x10, 0x19, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*94D1*/
const unsigned char  uc2_94D2 [] = {0x13, 0xF0, 0x1D, 0x20, 0x21, 0x20, 0x3D, 0xE0, 0x51, 0x20, 0x3D, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x15, 0x70, 0x1B, 0xA0, 0x10, 0x20, 0x00, 0x00 }; /*94D2*/
const unsigned char  uc2_94D5 [] = {0x10, 0x80, 0x1F, 0xF0, 0x20, 0x80, 0x3D, 0x00, 0x53, 0xE0, 0x3D, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x15, 0xE0, 0x19, 0x20, 0x11, 0x40, 0x00, 0x00 }; /*94D5*/
const unsigned char  uc2_94D6 [] = {0x10, 0x60, 0x18, 0x50, 0x27, 0xF0, 0x3C, 0x40, 0x57, 0x50, 0x3D, 0x50, 0x15, 0x50, 0x15, 0x60, 0x16, 0x50, 0x1C, 0xD0, 0x13, 0x30, 0x00, 0x00 }; /*94D6*/
const unsigned char  uc2_94D7 [] = {0x10, 0x80, 0x1F, 0xF0, 0x20, 0x90, 0x3C, 0x90, 0x52, 0xA0, 0x3F, 0xF0, 0x10, 0x80, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*94D7*/
const unsigned char  uc2_94D8 [] = {0x17, 0xF0, 0x1D, 0x50, 0x25, 0x50, 0x3F, 0x60, 0x51, 0xD0, 0x3B, 0x50, 0x15, 0x50, 0x15, 0x60, 0x15, 0x40, 0x19, 0x40, 0x12, 0x40, 0x00, 0x00 }; /*94D8*/
const unsigned char  uc2_94D9 [] = {0x11, 0x00, 0x1D, 0xE0, 0x23, 0x20, 0x3C, 0xD0, 0x53, 0x90, 0x3C, 0x60, 0x13, 0xF0, 0x11, 0x40, 0x15, 0x50, 0x19, 0x50, 0x16, 0x60, 0x00, 0x00 }; /*94D9*/
const unsigned char  uc2_94DB [] = {0x12, 0x50, 0x1D, 0x50, 0x21, 0x20, 0x3F, 0xF0, 0x50, 0x10, 0x3C, 0x10, 0x11, 0xF0, 0x10, 0x10, 0x14, 0x10, 0x1B, 0xF0, 0x10, 0x10, 0x00, 0x00 }; /*94DB*/
const unsigned char  uc2_94DC [] = {0x17, 0xF0, 0x1C, 0x10, 0x25, 0xD0, 0x3C, 0x10, 0x55, 0xD0, 0x3D, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x1C, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*94DC*/
const unsigned char  uc2_94DD [] = {0x11, 0xE0, 0x1D, 0x20, 0x21, 0x20, 0x3D, 0xE0, 0x50, 0x00, 0x3F, 0xF0, 0x12, 0x10, 0x12, 0x10, 0x16, 0x10, 0x1B, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*94DD*/
const unsigned char  uc2_94DE [] = {0x13, 0xE0, 0x1E, 0x20, 0x22, 0x20, 0x3B, 0xE0, 0x50, 0x80, 0x3F, 0xF0, 0x14, 0x90, 0x14, 0x90, 0x14, 0x90, 0x1C, 0xE0, 0x10, 0x80, 0x00, 0x00 }; /*94DE*/
const unsigned char  uc2_94DF [] = {0x13, 0xF0, 0x1A, 0x10, 0x22, 0x90, 0x3A, 0x90, 0x53, 0xF0, 0x3A, 0x90, 0x13, 0x50, 0x12, 0x50, 0x12, 0x10, 0x1B, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*94DF*/
const unsigned char  uc2_94E0 [] = {0x10, 0x80, 0x1E, 0xA0, 0x23, 0xE0, 0x3C, 0x00, 0x53, 0xE0, 0x3C, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x16, 0x10, 0x1A, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*94E0*/
const unsigned char  uc2_94E1 [] = {0x10, 0x10, 0x1F, 0x10, 0x25, 0x50, 0x3D, 0x50, 0x55, 0x50, 0x3D, 0x50, 0x15, 0x50, 0x12, 0x50, 0x1A, 0x10, 0x15, 0x10, 0x19, 0x60, 0x00, 0x00 }; /*94E1*/
const unsigned char  uc2_94E2 [] = {0x20, 0x80, 0x3A, 0x80, 0x23, 0xE0, 0x3A, 0x80, 0x54, 0x80, 0x13, 0xF0, 0x7D, 0xC0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x18, 0x80, 0x00, 0x00 }; /*94E2*/
const unsigned char  uc2_94E3 [] = {0x10, 0x80, 0x1E, 0x80, 0x23, 0xE0, 0x3C, 0x80, 0x50, 0x80, 0x3F, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x15, 0x50, 0x1A, 0x50, 0x14, 0x60, 0x00, 0x00 }; /*94E3*/
const unsigned char  uc2_94E4 [] = {0x10, 0x30, 0x1F, 0xC0, 0x21, 0x40, 0x3E, 0x40, 0x53, 0xF0, 0x3D, 0x40, 0x15, 0x40, 0x13, 0xF0, 0x15, 0x00, 0x1A, 0xC0, 0x14, 0x30, 0x00, 0x00 }; /*94E4*/
const unsigned char  uc2_94E5 [] = {0x10, 0x60, 0x1B, 0x80, 0x20, 0x80, 0x3B, 0xE0, 0x50, 0x80, 0x13, 0xF0, 0x7C, 0x80, 0x11, 0x00, 0x15, 0x20, 0x1A, 0x70, 0x13, 0x90, 0x00, 0x00 }; /*94E5*/
const unsigned char  uc2_94E7 [] = {0x11, 0x40, 0x19, 0x50, 0x26, 0x60, 0x3B, 0xC0, 0x52, 0x50, 0x3A, 0x60, 0x10, 0x80, 0x17, 0xF0, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*94E7*/
const unsigned char  uc2_94E8 [] = {0x10, 0x80, 0x1C, 0x80, 0x21, 0x40, 0x3A, 0x30, 0x50, 0x00, 0x3B, 0xE0, 0x10, 0x80, 0x11, 0xC0, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*94E8*/
const unsigned char  uc2_94E9 [] = {0x13, 0x20, 0x1C, 0xC0, 0x21, 0x20, 0x3E, 0xA0, 0x50, 0x80, 0x3F, 0xF0, 0x10, 0x80, 0x12, 0xA0, 0x12, 0x90, 0x1C, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*94E9*/
const unsigned char  uc2_94EA [] = {0x10, 0x80, 0x1C, 0x80, 0x21, 0x40, 0x3E, 0x30, 0x51, 0xC0, 0x3C, 0x00, 0x13, 0xE0, 0x12, 0x20, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*94EA*/
const unsigned char  uc2_94EB [] = {0x11, 0x40, 0x1D, 0x40, 0x21, 0x50, 0x3D, 0x60, 0x53, 0x40, 0x3D, 0x40, 0x11, 0x60, 0x13, 0x50, 0x15, 0x50, 0x19, 0x50, 0x12, 0x60, 0x00, 0x00 }; /*94EB*/
const unsigned char  uc2_94EC [] = {0x11, 0x00, 0x1D, 0xE0, 0x23, 0x20, 0x3D, 0x20, 0x50, 0xC0, 0x3F, 0x30, 0x11, 0xE0, 0x11, 0x20, 0x15, 0x20, 0x19, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*94EC*/
const unsigned char  uc2_94ED [] = {0x10, 0x80, 0x1C, 0xE0, 0x21, 0x20, 0x3E, 0xA0, 0x50, 0x40, 0x3C, 0x80, 0x17, 0xF0, 0x11, 0x10, 0x15, 0x10, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*94ED*/
const unsigned char  uc2_94EE [] = {0x11, 0x00, 0x1D, 0xC0, 0x26, 0x40, 0x3B, 0xE0, 0x50, 0xA0, 0x3F, 0xF0, 0x10, 0xA0, 0x13, 0xE0, 0x14, 0x80, 0x18, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*94EE*/
const unsigned char  uc2_94EF [] = {0x11, 0x00, 0x1D, 0xC0, 0x22, 0x40, 0x3F, 0xE0, 0x52, 0xA0, 0x3E, 0xA0, 0x13, 0xE0, 0x12, 0x00, 0x16, 0x10, 0x1A, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*94EF*/
const unsigned char  uc2_94F0 [] = {0x10, 0x80, 0x1F, 0xF0, 0x21, 0x40, 0x3D, 0x20, 0x52, 0x20, 0x3D, 0x40, 0x11, 0x40, 0x10, 0x80, 0x15, 0x40, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*94F0*/
const unsigned char  uc2_94F1 [] = {0x10, 0x40, 0x1F, 0xF0, 0x20, 0x80, 0x3C, 0x80, 0x51, 0x50, 0x3F, 0x50, 0x11, 0x50, 0x11, 0x20, 0x15, 0x60, 0x19, 0xA0, 0x11, 0x10, 0x00, 0x00 }; /*94F1*/
const unsigned char  uc2_94F2 [] = {0x10, 0x40, 0x1F, 0xF0, 0x20, 0xA0, 0x3C, 0x40, 0x53, 0xF0, 0x3E, 0x00, 0x12, 0x00, 0x12, 0x00, 0x16, 0x00, 0x1A, 0x00, 0x14, 0x00, 0x00, 0x00 }; /*94F2*/
const unsigned char  uc2_94F3 [] = {0x10, 0x80, 0x1F, 0xF0, 0x21, 0x20, 0x3E, 0x50, 0x53, 0x90, 0x3C, 0x00, 0x11, 0x40, 0x11, 0x40, 0x15, 0x50, 0x1A, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*94F3*/
const unsigned char  uc2_94F4 [] = {0x15, 0xE0, 0x1A, 0x20, 0x22, 0xC0, 0x3D, 0x00, 0x53, 0xF0, 0x39, 0x50, 0x11, 0x50, 0x12, 0x50, 0x12, 0x90, 0x1B, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*94F4*/
const unsigned char  uc2_94F5 [] = {0x10, 0x40, 0x1F, 0xF0, 0x22, 0x10, 0x3C, 0x80, 0x53, 0xF0, 0x3C, 0xA0, 0x11, 0x20, 0x11, 0xA0, 0x14, 0x40, 0x18, 0xA0, 0x13, 0x20, 0x00, 0x00 }; /*94F5*/
const unsigned char  uc2_94F6 [] = {0x13, 0xE0, 0x1E, 0x20, 0x23, 0xE0, 0x3E, 0x20, 0x53, 0xE0, 0x3E, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x16, 0x40, 0x1A, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*94F6*/
const unsigned char  uc2_94F7 [] = {0x24, 0x00, 0x3C, 0x70, 0x24, 0x50, 0x3F, 0x50, 0x55, 0x50, 0x15, 0x50, 0x3D, 0x50, 0x15, 0x50, 0x12, 0x50, 0x15, 0x70, 0x19, 0x50, 0x00, 0x00 }; /*94F7*/
const unsigned char  uc2_94F8 [] = {0x10, 0x80, 0x1F, 0xF0, 0x20, 0x80, 0x3B, 0xE0, 0x50, 0x80, 0x3B, 0xF0, 0x11, 0x20, 0x13, 0xF0, 0x15, 0x20, 0x18, 0xA0, 0x10, 0xC0, 0x00, 0x00 }; /*94F8*/
const unsigned char  uc2_94F9 [] = {0x11, 0x40, 0x1F, 0xF0, 0x21, 0x40, 0x3F, 0xF0, 0x54, 0x10, 0x3C, 0x80, 0x13, 0xE0, 0x10, 0xA0, 0x14, 0xA0, 0x19, 0x20, 0x16, 0xC0, 0x00, 0x00 }; /*94F9*/
const unsigned char  uc2_94FA [] = {0x10, 0xC0, 0x1C, 0xA0, 0x23, 0xF0, 0x3C, 0x80, 0x53, 0xE0, 0x3E, 0xA0, 0x13, 0xE0, 0x12, 0xA0, 0x17, 0xE0, 0x1A, 0xA0, 0x12, 0xC0, 0x00, 0x00 }; /*94FA*/
const unsigned char  uc2_94FC [] = {0x10, 0x80, 0x1F, 0xF0, 0x24, 0xA0, 0x3A, 0xA0, 0x52, 0xC0, 0x3F, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1C, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*94FC*/
const unsigned char  uc2_94FD [] = {0x20, 0x50, 0x3C, 0x50, 0x40, 0x40, 0x3B, 0xF0, 0x10, 0x40, 0x10, 0x40, 0x7D, 0x40, 0x12, 0xC0, 0x16, 0x50, 0x1A, 0xB0, 0x11, 0x90, 0x00, 0x00 }; /*94FD*/
const unsigned char  uc2_94FE [] = {0x14, 0x40, 0x1A, 0x40, 0x22, 0xF0, 0x38, 0x40, 0x56, 0xA0, 0x3A, 0xF0, 0x12, 0x20, 0x12, 0xF0, 0x1A, 0x20, 0x15, 0x00, 0x08, 0xF0, 0x00, 0x00 }; /*94FE*/
const unsigned char  uc2_94FF [] = {0x11, 0x00, 0x1D, 0xF0, 0x25, 0x50, 0x3D, 0x50, 0x55, 0x20, 0x39, 0x50, 0x10, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*94FF*/
const unsigned char  uc2_9500 [] = {0x10, 0x80, 0x1E, 0xA0, 0x21, 0x40, 0x3F, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x16, 0x20, 0x1A, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*9500*/
const unsigned char  uc2_9501 [] = {0x10, 0x80, 0x1E, 0xA0, 0x21, 0x40, 0x3F, 0xE0, 0x52, 0x20, 0x12, 0xA0, 0x7E, 0xA0, 0x12, 0xA0, 0x14, 0xC0, 0x19, 0x20, 0x16, 0x20, 0x00, 0x00 }; /*9501*/
const unsigned char  uc2_9502 [] = {0x10, 0x00, 0x1F, 0xE0, 0x22, 0xA0, 0x3F, 0xE0, 0x52, 0xA0, 0x13, 0xE0, 0x7C, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*9502*/
const unsigned char  uc2_9503 [] = {0x13, 0xE0, 0x1E, 0x20, 0x22, 0x20, 0x3F, 0xE0, 0x50, 0x00, 0x13, 0xE0, 0x7C, 0x80, 0x11, 0xC0, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*9503*/
const unsigned char  uc2_9504 [] = {0x27, 0x40, 0x3D, 0x40, 0x25, 0xF0, 0x3F, 0x50, 0x55, 0x50, 0x15, 0x50, 0x7F, 0x50, 0x15, 0x50, 0x15, 0xD0, 0x1E, 0x50, 0x10, 0xA0, 0x00, 0x00 }; /*9504*/
const unsigned char  uc2_9505 [] = {0x11, 0xE0, 0x1D, 0x20, 0x21, 0x20, 0x3D, 0xE0, 0x50, 0x80, 0x13, 0xF0, 0x7E, 0x90, 0x13, 0x50, 0x16, 0x50, 0x1A, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*9505*/
const unsigned char  uc2_9506 [] = {0x10, 0x80, 0x1E, 0x80, 0x23, 0xE0, 0x3C, 0x80, 0x57, 0xF0, 0x10, 0x00, 0x7F, 0xE0, 0x12, 0x20, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*9506*/
const unsigned char  uc2_9507 [] = {0x10, 0xC0, 0x1F, 0x60, 0x21, 0x50, 0x3F, 0xF0, 0x51, 0x40, 0x11, 0x50, 0x7D, 0xD0, 0x13, 0x60, 0x15, 0x50, 0x19, 0x50, 0x12, 0xB0, 0x00, 0x00 }; /*9507*/
const unsigned char  uc2_9508 [] = {0x10, 0x60, 0x1B, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x52, 0xA0, 0x14, 0x90, 0x7B, 0xC0, 0x11, 0x40, 0x15, 0x70, 0x1A, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*9508*/
const unsigned char  uc2_9509 [] = {0x10, 0x80, 0x1E, 0xA0, 0x22, 0xA0, 0x3A, 0xA0, 0x55, 0xD0, 0x10, 0x80, 0x78, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*9509*/
const unsigned char  uc2_950A [] = {0x10, 0x30, 0x1F, 0xD0, 0x22, 0x90, 0x3D, 0x50, 0x51, 0x60, 0x10, 0x20, 0x7F, 0xF0, 0x11, 0x20, 0x14, 0xA0, 0x18, 0xA0, 0x10, 0xC0, 0x00, 0x00 }; /*950A*/
const unsigned char  uc2_950B [] = {0x11, 0x00, 0x1D, 0xE0, 0x22, 0x20, 0x3D, 0xC0, 0x56, 0xB0, 0x13, 0xE0, 0x7C, 0x80, 0x11, 0xC0, 0x14, 0x80, 0x1B, 0xE0, 0x10, 0x80, 0x00, 0x00 }; /*950B*/
const unsigned char  uc2_950C [] = {0x10, 0x80, 0x1F, 0xE0, 0x22, 0x20, 0x3D, 0x40, 0x53, 0xE0, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*950C*/
const unsigned char  uc2_950D [] = {0x11, 0x00, 0x1F, 0xE0, 0x21, 0x00, 0x3A, 0x40, 0x53, 0xA0, 0x10, 0x20, 0x7D, 0x40, 0x15, 0x40, 0x1D, 0x50, 0x15, 0x50, 0x09, 0x20, 0x00, 0x00 }; /*950D*/
const unsigned char  uc2_950E [] = {0x14, 0x00, 0x1A, 0xF0, 0x24, 0x10, 0x3F, 0xF0, 0x55, 0x50, 0x17, 0xF0, 0x7D, 0x50, 0x15, 0x50, 0x15, 0x50, 0x1E, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*950E*/
const unsigned char  uc2_950F [] = {0x15, 0xF0, 0x1A, 0x10, 0x24, 0x10, 0x3D, 0xD0, 0x55, 0x50, 0x15, 0xD0, 0x7D, 0x50, 0x15, 0xD0, 0x15, 0x50, 0x1C, 0x10, 0x14, 0x60, 0x00, 0x00 }; /*950F*/
const unsigned char  uc2_9510 [] = {0x12, 0x20, 0x1D, 0x40, 0x23, 0xE0, 0x3E, 0x20, 0x52, 0x20, 0x13, 0xE0, 0x7D, 0x40, 0x11, 0x50, 0x15, 0x50, 0x1A, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*9510*/
const unsigned char  uc2_9511 [] = {0x11, 0x10, 0x1C, 0xA0, 0x21, 0xF0, 0x3C, 0x50, 0x50, 0xF0, 0x11, 0x40, 0x7D, 0xF0, 0x10, 0xD0, 0x15, 0x50, 0x19, 0x60, 0x12, 0x40, 0x00, 0x00 }; /*9511*/
const unsigned char  uc2_9512 [] = {0x10, 0x80, 0x1F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x7E, 0xA0, 0x12, 0xA0, 0x16, 0xC0, 0x1B, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*9512*/
const unsigned char  uc2_9513 [] = {0x13, 0xE0, 0x1C, 0x20, 0x21, 0xE0, 0x3C, 0x20, 0x57, 0xF0, 0x14, 0x10, 0x7F, 0xD0, 0x11, 0x40, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*9513*/
const unsigned char  uc2_9514 [] = {0x17, 0xE0, 0x1C, 0x20, 0x27, 0xE0, 0x3C, 0x00, 0x57, 0xF0, 0x14, 0x10, 0x7D, 0xD0, 0x15, 0x50, 0x1D, 0xD0, 0x14, 0x10, 0x18, 0xE0, 0x00, 0x00 }; /*9514*/
const unsigned char  uc2_9515 [] = {0x17, 0xF0, 0x1D, 0x20, 0x25, 0x60, 0x3E, 0xA0, 0x55, 0xA0, 0x15, 0x60, 0x7D, 0x20, 0x16, 0x20, 0x14, 0x20, 0x1C, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*9515*/
const unsigned char  uc2_9516 [] = {0x20, 0x80, 0x3F, 0xF0, 0x20, 0x80, 0x3B, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xA0, 0x12, 0x60, 0x00, 0x00 }; /*9516*/
const unsigned char  uc2_9517 [] = {0x10, 0x90, 0x1F, 0xE0, 0x20, 0xA0, 0x3F, 0xF0, 0x50, 0x80, 0x11, 0xE0, 0x7F, 0x20, 0x11, 0xE0, 0x15, 0x20, 0x19, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*9517*/
const unsigned char  uc2_9518 [] = {0x11, 0x40, 0x1F, 0xF0, 0x21, 0x40, 0x3C, 0x80, 0x53, 0xF0, 0x11, 0x00, 0x7B, 0xE0, 0x15, 0x20, 0x15, 0x20, 0x19, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*9518*/
const unsigned char  uc2_9519 [] = {0x11, 0x40, 0x1F, 0xE0, 0x21, 0x40, 0x3F, 0xF0, 0x50, 0x00, 0x13, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*9519*/
const unsigned char  uc2_951A [] = {0x11, 0x40, 0x1F, 0xF0, 0x21, 0x40, 0x3F, 0xE0, 0x52, 0xA0, 0x12, 0xA0, 0x7F, 0xE0, 0x12, 0xA0, 0x16, 0xA0, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*951A*/
const unsigned char  uc2_951B [] = {0x20, 0x80, 0x37, 0xF0, 0x41, 0x40, 0x76, 0x30, 0x20, 0x80, 0x23, 0xE0, 0x78, 0x80, 0x22, 0x20, 0x27, 0xF0, 0x32, 0x20, 0x24, 0x20, 0x00, 0x00 }; /*951B*/
const unsigned char  uc2_951D [] = {0x13, 0xE0, 0x1E, 0x20, 0x23, 0xE0, 0x3E, 0x20, 0x53, 0xE0, 0x10, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x15, 0x40, 0x18, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*951D*/
const unsigned char  uc2_951E [] = {0x13, 0xE0, 0x1E, 0xA0, 0x23, 0xE0, 0x3E, 0xA0, 0x53, 0xE0, 0x10, 0x80, 0x7F, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x14, 0x90, 0x18, 0x80, 0x00, 0x00 }; /*951E*/
const unsigned char  uc2_951F [] = {0x13, 0xE0, 0x1E, 0x20, 0x23, 0xE0, 0x3E, 0x20, 0x53, 0xE0, 0x12, 0x40, 0x7E, 0x50, 0x13, 0xE0, 0x16, 0x50, 0x1A, 0xD0, 0x13, 0x30, 0x00, 0x00 }; /*951F*/
const unsigned char  uc2_9521 [] = {0x13, 0xE0, 0x1A, 0x20, 0x23, 0xE0, 0x3A, 0x20, 0x53, 0xE0, 0x12, 0x00, 0x7B, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x1A, 0x90, 0x11, 0x60, 0x00, 0x00 }; /*9521*/
const unsigned char  uc2_9522 [] = {0x10, 0x00, 0x1F, 0xF0, 0x24, 0x90, 0x3F, 0xF0, 0x54, 0x90, 0x15, 0xD0, 0x7D, 0x50, 0x15, 0xD0, 0x14, 0x10, 0x1F, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*9522*/
const unsigned char  uc2_9523 [] = {0x10, 0x00, 0x1F, 0xF0, 0x25, 0x50, 0x3D, 0x50, 0x57, 0xF0, 0x11, 0x00, 0x7D, 0xE0, 0x13, 0x20, 0x14, 0xC0, 0x19, 0x80, 0x16, 0x00, 0x00, 0x00 }; /*9523*/
const unsigned char  uc2_9524 [] = {0x10, 0x60, 0x1F, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x52, 0xA0, 0x17, 0xF0, 0x7A, 0xA0, 0x12, 0xA0, 0x17, 0xF0, 0x18, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*9524*/
const unsigned char  uc2_9525 [] = {0x11, 0x80, 0x1D, 0x40, 0x21, 0xF0, 0x3F, 0x40, 0x51, 0xE0, 0x11, 0x40, 0x7D, 0xE0, 0x11, 0x40, 0x15, 0x40, 0x19, 0xF0, 0x11, 0x00, 0x00, 0x00 }; /*9525*/
const unsigned char  uc2_9526 [] = {0x10, 0x80, 0x1B, 0xE0, 0x22, 0x20, 0x3B, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x78, 0x80, 0x17, 0xF0, 0x14, 0x90, 0x1C, 0xA0, 0x10, 0x80, 0x00, 0x00 }; /*9526*/
const unsigned char  uc2_9528 [] = {0x11, 0x80, 0x1E, 0xF0, 0x24, 0x90, 0x3C, 0x50, 0x57, 0x60, 0x15, 0x40, 0x7D, 0x40, 0x15, 0x40, 0x15, 0xA0, 0x1D, 0x20, 0x11, 0x10, 0x00, 0x00 }; /*9528*/
const unsigned char  uc2_9529 [] = {0x12, 0xA0, 0x1D, 0x40, 0x23, 0xE0, 0x38, 0x80, 0x57, 0xF0, 0x11, 0x40, 0x7F, 0xF0, 0x12, 0x20, 0x16, 0xD0, 0x1A, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*9529*/
const unsigned char  uc2_952A [] = {0x12, 0x00, 0x1B, 0xF0, 0x25, 0x50, 0x39, 0x50, 0x56, 0x90, 0x11, 0x60, 0x78, 0xA0, 0x12, 0x50, 0x15, 0x50, 0x1D, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*952A*/
const unsigned char  uc2_952B [] = {0x10, 0x80, 0x1F, 0xE0, 0x22, 0x20, 0x39, 0x40, 0x57, 0xF0, 0x10, 0x00, 0x7B, 0xE0, 0x12, 0x20, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*952B*/
const unsigned char  uc2_952C [] = {0x10, 0x40, 0x1C, 0xD0, 0x21, 0x50, 0x3C, 0x60, 0x51, 0x90, 0x10, 0x40, 0x7C, 0xD0, 0x11, 0x50, 0x10, 0xA0, 0x14, 0xA0, 0x19, 0x10, 0x00, 0x00 }; /*952C*/
const unsigned char  uc2_952D [] = {0x10, 0x80, 0x1F, 0xF0, 0x24, 0x10, 0x3C, 0x10, 0x53, 0xE0, 0x10, 0x80, 0x7E, 0x80, 0x12, 0xE0, 0x12, 0x80, 0x15, 0x80, 0x18, 0xF0, 0x00, 0x00 }; /*952D*/
const unsigned char  uc2_952E [] = {0x10, 0x80, 0x1F, 0xE0, 0x22, 0xA0, 0x3B, 0xF0, 0x54, 0xA0, 0x17, 0xF0, 0x7A, 0x80, 0x13, 0xF0, 0x14, 0x80, 0x1A, 0x80, 0x11, 0xF0, 0x00, 0x00 }; /*952E*/
const unsigned char  uc2_952F [] = {0x10, 0x00, 0x1F, 0xF0, 0x22, 0x10, 0x3F, 0xF0, 0x52, 0x40, 0x13, 0xF0, 0x7E, 0x40, 0x13, 0xF0, 0x16, 0x10, 0x1B, 0xF0, 0x15, 0x10, 0x00, 0x00 }; /*952F*/
const unsigned char  uc2_9530 [] = {0x13, 0xC0, 0x1C, 0x40, 0x20, 0x80, 0x3F, 0xF0, 0x50, 0x80, 0x10, 0x80, 0x7D, 0x00, 0x17, 0xF0, 0x1D, 0x50, 0x15, 0x50, 0x1F, 0xF0, 0x00, 0x00 }; /*9530*/
const unsigned char  uc2_9531 [] = {0x11, 0x50, 0x1D, 0x50, 0x22, 0xA0, 0x3D, 0x50, 0x51, 0x50, 0x11, 0xF0, 0x7D, 0x50, 0x11, 0xF0, 0x15, 0x50, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*9531*/
const unsigned char  uc2_9532 [] = {0x12, 0x00, 0x1F, 0xF0, 0x22, 0x50, 0x3F, 0x50, 0x52, 0x50, 0x17, 0x50, 0x7A, 0xA0, 0x17, 0xF0, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*9532*/
const unsigned char  uc2_9534 [] = {0x12, 0x50, 0x1F, 0xE0, 0x22, 0x50, 0x3F, 0x70, 0x50, 0x80, 0x13, 0xF0, 0x7E, 0x10, 0x13, 0xF0, 0x16, 0x10, 0x1B, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*9534*/
const unsigned char  uc2_9535 [] = {0x12, 0x40, 0x1A, 0x70, 0x23, 0xD0, 0x3A, 0xA0, 0x57, 0xE0, 0x12, 0x20, 0x7B, 0xF0, 0x12, 0xA0, 0x16, 0x60, 0x1A, 0x20, 0x12, 0xC0, 0x00, 0x00 }; /*9535*/
const unsigned char  uc2_9536 [] = {0x13, 0xE0, 0x1E, 0xA0, 0x23, 0xE0, 0x3E, 0xA0, 0x53, 0xE0, 0x10, 0x00, 0x7C, 0xA0, 0x13, 0x50, 0x15, 0x50, 0x19, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*9536*/
const unsigned char  uc2_9537 [] = {0x13, 0x60, 0x1E, 0xA0, 0x23, 0x60, 0x3C, 0x00, 0x53, 0xE0, 0x10, 0x00, 0x7F, 0xF0, 0x11, 0x00, 0x15, 0xE0, 0x18, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*9537*/
const unsigned char  uc2_9538 [] = {0x10, 0x60, 0x1F, 0x80, 0x20, 0x80, 0x3F, 0xF0, 0x51, 0x80, 0x16, 0xB0, 0x7C, 0x90, 0x16, 0xB0, 0x14, 0x90, 0x1F, 0xF0, 0x14, 0x10, 0x00, 0x00 }; /*9538*/
const unsigned char  uc2_9539 [] = {0x11, 0xC0, 0x1E, 0x40, 0x22, 0x50, 0x3F, 0xD0, 0x52, 0x60, 0x17, 0x40, 0x7A, 0xA0, 0x12, 0xA0, 0x16, 0xA0, 0x1A, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*9539*/
const unsigned char  uc2_953A [] = {0x13, 0xE0, 0x1C, 0x80, 0x27, 0xF0, 0x3A, 0xA0, 0x53, 0xE0, 0x12, 0xA0, 0x7B, 0xE0, 0x10, 0x80, 0x17, 0xE0, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*953A*/
const unsigned char  uc2_953B [] = {0x11, 0xE0, 0x1E, 0xA0, 0x24, 0xA0, 0x3F, 0x10, 0x54, 0xE0, 0x17, 0xA0, 0x7C, 0xA0, 0x17, 0x40, 0x14, 0x40, 0x1C, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*953B*/
const unsigned char  uc2_953C [] = {0x22, 0x80, 0x34, 0xB0, 0x44, 0x90, 0x76, 0xB0, 0x24, 0x90, 0x27, 0xF0, 0x70, 0x80, 0x27, 0xE0, 0x22, 0x20, 0x31, 0xC0, 0x26, 0x30, 0x00, 0x00 }; /*953C*/
const unsigned char  uc2_953E [] = {0x10, 0x60, 0x1F, 0xA0, 0x25, 0x40, 0x3F, 0xE0, 0x52, 0x00, 0x17, 0xE0, 0x7A, 0x00, 0x13, 0xE0, 0x16, 0x20, 0x19, 0xC0, 0x16, 0x30, 0x00, 0x00 }; /*953E*/
const unsigned char  uc2_953F [] = {0x10, 0x80, 0x1F, 0xF0, 0x20, 0x00, 0x3F, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x7D, 0x50, 0x13, 0x60, 0x15, 0x40, 0x19, 0xA0, 0x11, 0x10, 0x00, 0x00 }; /*953F*/
const unsigned char  uc2_9540 [] = {0x10, 0x40, 0x1F, 0xF0, 0x22, 0xA0, 0x3F, 0xF0, 0x52, 0xA0, 0x12, 0xE0, 0x7E, 0x00, 0x13, 0xE0, 0x16, 0xA0, 0x1A, 0x40, 0x15, 0xB0, 0x00, 0x00 }; /*9540*/
const unsigned char  uc2_9541 [] = {0x11, 0x40, 0x1B, 0xE0, 0x20, 0x80, 0x3D, 0xC0, 0x50, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x13, 0xE0, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*9541*/
const unsigned char  uc2_9542 [] = {0x11, 0x50, 0x1C, 0xE0, 0x23, 0x50, 0x3C, 0xE0, 0x53, 0x50, 0x10, 0x80, 0x7F, 0xF0, 0x11, 0x20, 0x15, 0x20, 0x18, 0xC0, 0x13, 0x20, 0x00, 0x00 }; /*9542*/
const unsigned char  uc2_9544 [] = {0x11, 0x40, 0x1F, 0xF0, 0x21, 0x50, 0x3F, 0xF0, 0x55, 0x40, 0x17, 0xF0, 0x7A, 0x10, 0x12, 0xA0, 0x16, 0xA0, 0x18, 0xC0, 0x17, 0x20, 0x00, 0x00 }; /*9544*/
const unsigned char  uc2_9545 [] = {0x13, 0xF0, 0x1E, 0x50, 0x22, 0x50, 0x3F, 0xF0, 0x52, 0x90, 0x12, 0xF0, 0x7E, 0x90, 0x12, 0xF0, 0x16, 0x90, 0x1A, 0xF0, 0x14, 0x90, 0x00, 0x00 }; /*9545*/
const unsigned char  uc2_9546 [] = {0x11, 0x40, 0x1F, 0xF0, 0x22, 0x20, 0x3B, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x78, 0x80, 0x17, 0xF0, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*9546*/
const unsigned char  uc2_9547 [] = {0x20, 0x80, 0x38, 0x80, 0x27, 0xF0, 0x39, 0x00, 0x53, 0xE0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*9547*/
const unsigned char  uc2_9549 [] = {0x17, 0xF0, 0x18, 0x00, 0x23, 0xE0, 0x3A, 0x20, 0x57, 0xF0, 0x15, 0x50, 0x7C, 0x90, 0x17, 0xF0, 0x14, 0x90, 0x1C, 0x90, 0x14, 0x20, 0x00, 0x00 }; /*9549*/
const unsigned char  uc2_954A [] = {0x27, 0xF0, 0x32, 0x20, 0x43, 0xE0, 0x72, 0x20, 0x27, 0xF0, 0x20, 0x20, 0x77, 0xF0, 0x21, 0x50, 0x25, 0x50, 0x32, 0x20, 0x25, 0x50, 0x00, 0x00 }; /*954A*/
const unsigned char  uc2_954C [] = {0x21, 0x40, 0x3B, 0xF0, 0x26, 0x40, 0x3B, 0xE0, 0x52, 0x40, 0x13, 0xF0, 0x7A, 0x00, 0x13, 0xE0, 0x11, 0x30, 0x19, 0x10, 0x16, 0x60, 0x00, 0x00 }; /*954C*/
const unsigned char  uc2_954D [] = {0x10, 0x80, 0x1B, 0xE0, 0x22, 0x20, 0x3B, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x78, 0x80, 0x17, 0xF0, 0x11, 0xC0, 0x1A, 0xA0, 0x14, 0x90, 0x00, 0x00 }; /*954D*/
const unsigned char  uc2_954E [] = {0x10, 0x80, 0x1D, 0x40, 0x27, 0xF0, 0x39, 0x40, 0x53, 0xE0, 0x10, 0x80, 0x7B, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x18, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*954E*/
const unsigned char  uc2_954F [] = {0x11, 0x00, 0x1E, 0xF0, 0x25, 0x50, 0x3D, 0x50, 0x56, 0xA0, 0x13, 0xE0, 0x7A, 0xA0, 0x13, 0xE0, 0x16, 0xA0, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*954F*/
const unsigned char  uc2_9550 [] = {0x10, 0x80, 0x1F, 0xF0, 0x22, 0x20, 0x3B, 0xE0, 0x50, 0x00, 0x17, 0xF0, 0x7C, 0x10, 0x15, 0xD0, 0x15, 0x50, 0x1D, 0xD0, 0x14, 0x60, 0x00, 0x00 }; /*9550*/
const unsigned char  uc2_9551 [] = {0x10, 0x80, 0x1F, 0xF0, 0x21, 0x40, 0x3F, 0xF0, 0x54, 0x90, 0x13, 0xE0, 0x79, 0x00, 0x11, 0xE0, 0x15, 0x20, 0x1A, 0x20, 0x14, 0xC0, 0x00, 0x00 }; /*9551*/
const unsigned char  uc2_9552 [] = {0x12, 0x20, 0x19, 0x40, 0x27, 0xF0, 0x39, 0x40, 0x51, 0x20, 0x12, 0x20, 0x78, 0x00, 0x17, 0xF0, 0x1D, 0x50, 0x15, 0x50, 0x1F, 0xF0, 0x00, 0x00 }; /*9552*/
const unsigned char  uc2_9553 [] = {0x10, 0x80, 0x1F, 0xE0, 0x24, 0x20, 0x3B, 0xC0, 0x51, 0x20, 0x16, 0xA0, 0x79, 0xC0, 0x16, 0xA0, 0x11, 0xA0, 0x1E, 0x90, 0x11, 0x00, 0x00, 0x00 }; /*9553*/
const unsigned char  uc2_9554 [] = {0x10, 0x40, 0x1F, 0xF0, 0x22, 0x10, 0x3D, 0xE0, 0x51, 0x00, 0x11, 0xE0, 0x7D, 0x40, 0x13, 0xF0, 0x15, 0x20, 0x19, 0x10, 0x12, 0x10, 0x00, 0x00 }; /*9554*/
const unsigned char  uc2_9555 [] = {0x10, 0x80, 0x1F, 0xF0, 0x24, 0x10, 0x39, 0x60, 0x56, 0x90, 0x11, 0x40, 0x7E, 0x30, 0x13, 0xE0, 0x16, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*9555*/
const unsigned char  uc2_9556 [] = {0x17, 0xF0, 0x19, 0x40, 0x27, 0xF0, 0x3D, 0x50, 0x57, 0xF0, 0x11, 0x00, 0x78, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x1A, 0x90, 0x15, 0x10, 0x00, 0x00 }; /*9556*/
const unsigned char  uc2_9557 [] = {0x14, 0x90, 0x1A, 0xA0, 0x27, 0xF0, 0x3C, 0x10, 0x55, 0xD0, 0x11, 0x40, 0x79, 0xC0, 0x10, 0x80, 0x17, 0xE0, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*9557*/
const unsigned char  uc2_9558 [] = {0x13, 0xE0, 0x1E, 0x20, 0x23, 0xE0, 0x3A, 0x20, 0x57, 0xF0, 0x15, 0x50, 0x7D, 0x50, 0x17, 0xF0, 0x12, 0x20, 0x19, 0xC0, 0x16, 0x30, 0x00, 0x00 }; /*9558*/
const unsigned char  uc2_9559 [] = {0x13, 0xE0, 0x1E, 0xA0, 0x23, 0xE0, 0x3E, 0xA0, 0x53, 0xE0, 0x11, 0x40, 0x7F, 0x80, 0x10, 0xA0, 0x17, 0xE0, 0x19, 0x50, 0x12, 0x90, 0x00, 0x00 }; /*9559*/
const unsigned char  uc2_955B [] = {0x10, 0x80, 0x1F, 0xF0, 0x22, 0xA0, 0x3F, 0xF0, 0x52, 0xA0, 0x13, 0xC0, 0x7E, 0xA0, 0x13, 0xE0, 0x16, 0xA0, 0x1B, 0xE0, 0x14, 0xA0, 0x00, 0x00 }; /*955B*/
const unsigned char  uc2_955C [] = {0x10, 0x80, 0x1B, 0xE0, 0x21, 0x40, 0x3F, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x15, 0x50, 0x19, 0x50, 0x16, 0x60, 0x00, 0x00 }; /*955C*/
const unsigned char  uc2_955D [] = {0x10, 0x80, 0x1F, 0xF0, 0x21, 0x40, 0x3F, 0xF0, 0x54, 0x90, 0x17, 0xF0, 0x7C, 0x90, 0x15, 0xD0, 0x15, 0x50, 0x1D, 0xD0, 0x14, 0x60, 0x00, 0x00 }; /*955D*/
const unsigned char  uc2_955E [] = {0x12, 0x40, 0x1F, 0x70, 0x24, 0x80, 0x3C, 0x40, 0x57, 0x70, 0x15, 0xA0, 0x7D, 0x20, 0x15, 0xF0, 0x1D, 0x20, 0x15, 0x20, 0x1A, 0x50, 0x00, 0x00 }; /*955E*/
const unsigned char  uc2_955F [] = {0x24, 0x80, 0x32, 0xF0, 0x4F, 0x00, 0x74, 0x00, 0x27, 0xF0, 0x25, 0x50, 0x75, 0x40, 0x25, 0x70, 0x25, 0x40, 0x35, 0x40, 0x2A, 0xB0, 0x00, 0x00 }; /*955F*/
const unsigned char  uc2_9561 [] = {0x17, 0xF0, 0x19, 0x40, 0x27, 0xF0, 0x3D, 0x50, 0x57, 0xF0, 0x12, 0x20, 0x7B, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x18, 0x80, 0x10, 0x80, 0x00, 0x00 }; /*9561*/
const unsigned char  uc2_9562 [] = {0x17, 0xF0, 0x1A, 0x80, 0x25, 0x40, 0x3F, 0xF0, 0x55, 0x50, 0x15, 0x60, 0x7F, 0xA0, 0x15, 0x20, 0x1D, 0x20, 0x15, 0x20, 0x1A, 0x50, 0x00, 0x00 }; /*9562*/
const unsigned char  uc2_9563 [] = {0x20, 0x80, 0x37, 0xF0, 0x22, 0xA0, 0x39, 0x40, 0x53, 0xE0, 0x16, 0x30, 0x7B, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0xA0, 0x15, 0x90, 0x00, 0x00 }; /*9563*/
const unsigned char  uc2_9564 [] = {0x15, 0x50, 0x1B, 0x60, 0x27, 0xF0, 0x39, 0x40, 0x53, 0xE0, 0x10, 0x80, 0x7D, 0xC0, 0x10, 0x80, 0x17, 0xF0, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*9564*/
const unsigned char  uc2_9565 [] = {0x11, 0xC0, 0x1A, 0x40, 0x27, 0xE0, 0x3A, 0xA0, 0x53, 0xE0, 0x12, 0xA0, 0x7F, 0xF0, 0x12, 0x20, 0x13, 0xE0, 0x1A, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*9565*/
const unsigned char  uc2_9566 [] = {0x12, 0x40, 0x1F, 0xC0, 0x25, 0x70, 0x3F, 0x50, 0x50, 0xD0, 0x17, 0x50, 0x79, 0x20, 0x13, 0xA0, 0x16, 0x20, 0x1A, 0x20, 0x14, 0xD0, 0x00, 0x00 }; /*9566*/
const unsigned char  uc2_9567 [] = {0x15, 0xF0, 0x1A, 0x10, 0x24, 0x90, 0x3F, 0xF0, 0x54, 0x90, 0x15, 0xD0, 0x7D, 0x50, 0x15, 0xD0, 0x16, 0xB0, 0x1C, 0x90, 0x14, 0x30, 0x00, 0x00 }; /*9567*/
const unsigned char  uc2_9568 [] = {0x11, 0x40, 0x1B, 0xE0, 0x25, 0x50, 0x3B, 0x60, 0x51, 0x40, 0x17, 0xF0, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x1B, 0xE0, 0x12, 0x20, 0x00, 0x00 }; /*9568*/
const unsigned char  uc2_9569 [] = {0x10, 0x80, 0x1F, 0xF0, 0x25, 0x50, 0x3E, 0xB0, 0x53, 0xE0, 0x12, 0xA0, 0x7F, 0xF0, 0x14, 0x90, 0x17, 0xF0, 0x1C, 0x90, 0x10, 0x80, 0x00, 0x00 }; /*9569*/
const unsigned char  uc2_956A [] = {0x16, 0xE0, 0x1A, 0xA0, 0x22, 0xE0, 0x3A, 0x40, 0x55, 0xF0, 0x15, 0x50, 0x7F, 0xF0, 0x12, 0x40, 0x12, 0x50, 0x1A, 0x70, 0x15, 0x90, 0x00, 0x00 }; /*956A*/
const unsigned char  uc2_956B [] = {0x17, 0x50, 0x1D, 0x60, 0x22, 0x50, 0x3B, 0xE0, 0x54, 0x10, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x19, 0x40, 0x17, 0xF0, 0x00, 0x00 }; /*956B*/
const unsigned char  uc2_956C [] = {0x11, 0x20, 0x1B, 0xF0, 0x21, 0x20, 0x3B, 0xF0, 0x56, 0x40, 0x13, 0xE0, 0x7A, 0x40, 0x13, 0xF0, 0x11, 0x20, 0x18, 0xC0, 0x13, 0x30, 0x00, 0x00 }; /*956C*/
const unsigned char  uc2_956D [] = {0x13, 0xE0, 0x18, 0x80, 0x27, 0xF0, 0x3C, 0x90, 0x52, 0xA0, 0x10, 0x00, 0x7B, 0xE0, 0x12, 0xA0, 0x13, 0xE0, 0x1A, 0xA0, 0x13, 0xE0, 0x00, 0x00 }; /*956D*/
const unsigned char  uc2_956F [] = {0x17, 0xF0, 0x1D, 0x50, 0x25, 0x50, 0x37, 0xE0, 0x59, 0x10, 0x17, 0xD0, 0x7D, 0x50, 0x17, 0xD0, 0x11, 0x50, 0x19, 0xD0, 0x16, 0x60, 0x00, 0x00 }; /*956F*/
const unsigned char  uc2_9570 [] = {0x21, 0x00, 0x3F, 0xF0, 0x4A, 0x80, 0x7F, 0xF0, 0x2A, 0xA0, 0x2F, 0xF0, 0x7A, 0xA0, 0x2F, 0xE0, 0x3A, 0x80, 0x2E, 0xC0, 0x32, 0xB0, 0x00, 0x00 }; /*9570*/
const unsigned char  uc2_9571 [] = {0x10, 0x80, 0x1B, 0xE0, 0x21, 0x40, 0x3F, 0xF0, 0x52, 0x20, 0x13, 0xE0, 0x7A, 0x20, 0x13, 0xE0, 0x12, 0xA0, 0x1D, 0x50, 0x15, 0xD0, 0x00, 0x00 }; /*9571*/
const unsigned char  uc2_9572 [] = {0x20, 0x80, 0x37, 0xF0, 0x44, 0x10, 0x77, 0x70, 0x2D, 0x50, 0x22, 0x20, 0x75, 0xD0, 0x20, 0x00, 0x27, 0xF0, 0x32, 0xA0, 0x25, 0x90, 0x00, 0x00 }; /*9572*/
const unsigned char  uc2_9573 [] = {0x10, 0x80, 0x1F, 0xF0, 0x25, 0x40, 0x3F, 0xF0, 0x55, 0x50, 0x17, 0xF0, 0x7D, 0x50, 0x15, 0x60, 0x1D, 0xB0, 0x16, 0xA0, 0x19, 0x50, 0x00, 0x00 }; /*9573*/
const unsigned char  uc2_9576 [] = {0x10, 0x80, 0x1F, 0xF0, 0x22, 0xA0, 0x3F, 0xF0, 0x51, 0x40, 0x17, 0xE0, 0x79, 0x40, 0x17, 0xF0, 0x11, 0x50, 0x1F, 0x60, 0x11, 0xB0, 0x00, 0x00 }; /*9576*/
const unsigned char  uc2_957F [] = {0x08, 0x20, 0x08, 0xC0, 0x0F, 0x00, 0x08, 0x00, 0x7F, 0xF0, 0x09, 0x00, 0x09, 0x00, 0x08, 0x80, 0x0A, 0x40, 0x0C, 0x30, 0x08, 0x00, 0x00, 0x00 }; /*957F*/
const unsigned char  uc2_95E8 [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x60, 0x00, 0x00 }; /*95E8*/
const unsigned char  uc2_95E9 [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x2F, 0xD0, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*95E9*/
const unsigned char  uc2_95EA [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x21, 0x10, 0x21, 0x10, 0x21, 0x10, 0x21, 0x90, 0x22, 0x50, 0x2C, 0x50, 0x20, 0x10, 0x20, 0x60, 0x00, 0x00 }; /*95EA*/
const unsigned char  uc2_95EB [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x20, 0x10, 0x27, 0x90, 0x20, 0x10, 0x23, 0x10, 0x20, 0x10, 0x2F, 0xD0, 0x20, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*95EB*/
const unsigned char  uc2_95ED [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x20, 0x90, 0x2F, 0xF0, 0x22, 0x90, 0x22, 0x90, 0x24, 0x90, 0x38, 0x90, 0x23, 0x10, 0x20, 0x60, 0x00, 0x00 }; /*95ED*/
const unsigned char  uc2_95EE [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x20, 0x10, 0x27, 0x90, 0x24, 0x90, 0x24, 0x90, 0x27, 0x90, 0x24, 0x90, 0x20, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*95EE*/
const unsigned char  uc2_95EF [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x2F, 0x90, 0x24, 0x90, 0x29, 0x10, 0x2F, 0xD0, 0x20, 0x50, 0x3F, 0x50, 0x20, 0x50, 0x21, 0xA0, 0x00, 0x00 }; /*95EF*/
const unsigned char  uc2_95F0 [] = {0x30, 0x00, 0x0B, 0xF0, 0x40, 0x10, 0x4F, 0x90, 0x42, 0x10, 0x47, 0x10, 0x42, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x40, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*95F0*/
const unsigned char  uc2_95F1 [] = {0x30, 0x00, 0x0B, 0xF0, 0x22, 0x10, 0x3F, 0xD0, 0x22, 0x10, 0x2F, 0x90, 0x22, 0x10, 0x3F, 0xD0, 0x22, 0x50, 0x23, 0x90, 0x22, 0x60, 0x00, 0x00 }; /*95F1*/
const unsigned char  uc2_95F2 [] = {0x30, 0x00, 0x0B, 0xF0, 0x40, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x47, 0x10, 0x5A, 0x90, 0x42, 0x90, 0x42, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*95F2*/
const unsigned char  uc2_95F3 [] = {0x30, 0x00, 0x0B, 0xF0, 0x40, 0x10, 0x44, 0x10, 0x5F, 0xD0, 0x45, 0x10, 0x49, 0x10, 0x72, 0x90, 0x44, 0x90, 0x47, 0x50, 0x40, 0x60, 0x00, 0x00 }; /*95F3*/
const unsigned char  uc2_95F4 [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x27, 0x90, 0x24, 0x90, 0x27, 0x90, 0x24, 0x90, 0x27, 0x90, 0x24, 0x90, 0x20, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*95F4*/
const unsigned char  uc2_95F5 [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x22, 0x10, 0x2F, 0xD0, 0x20, 0x90, 0x26, 0x90, 0x21, 0x10, 0x22, 0x90, 0x2C, 0x90, 0x20, 0x60, 0x00, 0x00 }; /*95F5*/
const unsigned char  uc2_95F6 [] = {0x30, 0x00, 0x0B, 0xF0, 0x24, 0x10, 0x22, 0x10, 0x3F, 0xD0, 0x20, 0x10, 0x27, 0x10, 0x25, 0x50, 0x25, 0x50, 0x38, 0x90, 0x20, 0x60, 0x00, 0x00 }; /*95F6*/
const unsigned char  uc2_95F7 [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x22, 0x10, 0x29, 0x90, 0x29, 0x50, 0x34, 0x50, 0x24, 0x90, 0x23, 0x10, 0x20, 0x10, 0x20, 0xE0, 0x00, 0x00 }; /*95F7*/
const unsigned char  uc2_95F8 [] = {0x30, 0x00, 0x0B, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x2A, 0xA0, 0x2F, 0xA0, 0x2A, 0xA0, 0x2F, 0xA0, 0x22, 0x20, 0x22, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*95F8*/
const unsigned char  uc2_95F9 [] = {0x30, 0x00, 0x0B, 0xF0, 0x44, 0x10, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x4A, 0x90, 0x4A, 0x90, 0x4B, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*95F9*/
const unsigned char  uc2_95FA [] = {0x30, 0x00, 0x0B, 0xF0, 0x42, 0x10, 0x4F, 0x90, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x10, 0x4F, 0x90, 0x42, 0x10, 0x5F, 0xD0, 0x40, 0x60, 0x00, 0x00 }; /*95FA*/
const unsigned char  uc2_95FB [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x2F, 0xD0, 0x24, 0x90, 0x27, 0x90, 0x24, 0x90, 0x27, 0x90, 0x24, 0xF0, 0x3F, 0x90, 0x20, 0xE0, 0x00, 0x00 }; /*95FB*/
const unsigned char  uc2_95FC [] = {0x30, 0x00, 0x0B, 0xF0, 0x31, 0x10, 0x29, 0x10, 0x27, 0xD0, 0x39, 0x10, 0x29, 0x90, 0x2E, 0x50, 0x28, 0x50, 0x37, 0xD0, 0x20, 0x60, 0x00, 0x00 }; /*95FC*/
const unsigned char  uc2_95FD [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x22, 0x10, 0x2F, 0x90, 0x2A, 0x90, 0x2F, 0x90, 0x22, 0x90, 0x23, 0xD0, 0x3C, 0x50, 0x20, 0xE0, 0x00, 0x00 }; /*95FD*/
const unsigned char  uc2_95FE [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0x10, 0x27, 0x90, 0x24, 0x90, 0x27, 0x90, 0x20, 0x10, 0x2F, 0xD0, 0x28, 0x50, 0x2F, 0xD0, 0x28, 0x60, 0x00, 0x00 }; /*95FE*/
const unsigned char  uc2_9600 [] = {0x30, 0x00, 0x0F, 0xF0, 0x25, 0x10, 0x29, 0x50, 0x39, 0xF0, 0x2F, 0x50, 0x29, 0x50, 0x29, 0x90, 0x2F, 0x30, 0x28, 0xD0, 0x20, 0x60, 0x00, 0x00 }; /*9600*/
const unsigned char  uc2_9601 [] = {0x30, 0x00, 0x0F, 0xF0, 0x24, 0x10, 0x27, 0x90, 0x2C, 0x90, 0x23, 0x10, 0x3C, 0xF0, 0x27, 0x90, 0x24, 0x90, 0x27, 0x90, 0x24, 0x60, 0x00, 0x00 }; /*9601*/
const unsigned char  uc2_9602 [] = {0x30, 0x00, 0x0F, 0xF0, 0x22, 0x10, 0x3F, 0xD0, 0x25, 0x10, 0x2E, 0x90, 0x22, 0x90, 0x3D, 0x10, 0x22, 0x90, 0x3C, 0x90, 0x20, 0x60, 0x00, 0x00 }; /*9602*/
const unsigned char  uc2_9603 [] = {0x67, 0xF0, 0x10, 0x10, 0x5F, 0xD0, 0x52, 0x50, 0x5F, 0xD0, 0x52, 0x50, 0x57, 0x50, 0x5A, 0xD0, 0x52, 0x50, 0x5F, 0xD0, 0x50, 0x70, 0x00, 0x00 }; /*9603*/
const unsigned char  uc2_9604 [] = {0x67, 0xF0, 0x14, 0x10, 0x47, 0x10, 0x49, 0x10, 0x5F, 0x90, 0x4A, 0x90, 0x4F, 0x90, 0x4A, 0x90, 0x4F, 0x90, 0x42, 0x50, 0x41, 0xA0, 0x00, 0x00 }; /*9604*/
const unsigned char  uc2_9605 [] = {0x00, 0x00, 0x37, 0xF0, 0x08, 0x90, 0x25, 0x10, 0x2F, 0x90, 0x28, 0x90, 0x2F, 0x90, 0x25, 0x50, 0x25, 0x50, 0x38, 0x90, 0x20, 0xE0, 0x00, 0x00 }; /*9605*/
const unsigned char  uc2_9606 [] = {0x67, 0xF0, 0x12, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x10, 0x4B, 0x50, 0x48, 0x90, 0x4C, 0x70, 0x00, 0x00 }; /*9606*/
const unsigned char  uc2_9608 [] = {0x60, 0x00, 0x17, 0xF0, 0x41, 0x50, 0x7F, 0xF0, 0x55, 0x10, 0x55, 0x50, 0x5D, 0x50, 0x41, 0x50, 0x46, 0xB0, 0x59, 0x50, 0x40, 0x20, 0x00, 0x00 }; /*9608*/
const unsigned char  uc2_9609 [] = {0x67, 0xF0, 0x12, 0x10, 0x5F, 0xD0, 0x45, 0x10, 0x4F, 0x90, 0x7A, 0xF0, 0x4F, 0x90, 0x4A, 0x90, 0x4F, 0x90, 0x42, 0x50, 0x41, 0xE0, 0x00, 0x00 }; /*9609*/
const unsigned char  uc2_960A [] = {0x60, 0x00, 0x17, 0xF0, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x90, 0x5F, 0xD0, 0x50, 0x50, 0x5F, 0xD0, 0x50, 0x50, 0x5F, 0xD0, 0x50, 0x60, 0x00, 0x00 }; /*960A*/
const unsigned char  uc2_960B [] = {0x60, 0x00, 0x17, 0xF0, 0x42, 0x10, 0x4D, 0x90, 0x48, 0x90, 0x4D, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x45, 0x50, 0x49, 0x50, 0x70, 0xE0, 0x00, 0x00 }; /*960B*/
const unsigned char  uc2_960C [] = {0x30, 0x00, 0x0B, 0xF0, 0x20, 0xD0, 0x2F, 0x50, 0x2A, 0x90, 0x2F, 0xD0, 0x28, 0x50, 0x27, 0x90, 0x22, 0x90, 0x21, 0x10, 0x2E, 0xA0, 0x00, 0x00 }; /*960C*/
const unsigned char  uc2_960D [] = {0x67, 0xF0, 0x10, 0x90, 0x5F, 0x10, 0x52, 0x10, 0x5F, 0x90, 0x51, 0x50, 0x5F, 0xD0, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0xB0, 0x00, 0x00 }; /*960D*/
const unsigned char  uc2_960E [] = {0x60, 0x00, 0x17, 0xF0, 0x48, 0x10, 0x4F, 0x90, 0x72, 0x90, 0x5D, 0xD0, 0x50, 0x50, 0x5D, 0xD0, 0x50, 0x50, 0x5F, 0xD0, 0x50, 0x60, 0x00, 0x00 }; /*960E*/
const unsigned char  uc2_960F [] = {0x60, 0x00, 0x17, 0xF0, 0x48, 0x90, 0x7F, 0x50, 0x51, 0x50, 0x5E, 0x30, 0x54, 0x90, 0x54, 0x50, 0x55, 0x10, 0x68, 0x90, 0x40, 0xE0, 0x00, 0x00 }; /*960F*/
const unsigned char  uc2_9610 [] = {0x60, 0x00, 0x1F, 0xF0, 0x45, 0x10, 0x4F, 0x90, 0x4A, 0x90, 0x4F, 0x90, 0x4A, 0x90, 0x4F, 0x90, 0x42, 0x10, 0x5F, 0xD0, 0x42, 0x60, 0x00, 0x00 }; /*9610*/
const unsigned char  uc2_9611 [] = {0x60, 0x00, 0x17, 0xF0, 0x42, 0x10, 0x5F, 0xD0, 0x4D, 0x90, 0x4A, 0x90, 0x4F, 0x90, 0x43, 0x10, 0x46, 0x90, 0x5A, 0x90, 0x42, 0x60, 0x00, 0x00 }; /*9611*/
const unsigned char  uc2_9612 [] = {0x67, 0xF0, 0x10, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x42, 0x90, 0x5F, 0xD0, 0x45, 0x10, 0x58, 0xB0, 0x00, 0x00 }; /*9612*/
const unsigned char  uc2_9614 [] = {0x60, 0x00, 0x17, 0xF0, 0x48, 0x50, 0x45, 0x90, 0x50, 0x90, 0x4B, 0xF0, 0x40, 0x90, 0x49, 0xD0, 0x49, 0x50, 0x51, 0xD0, 0x40, 0x60, 0x00, 0x00 }; /*9614*/
const unsigned char  uc2_9615 [] = {0x60, 0x00, 0x17, 0xF0, 0x41, 0x50, 0x5D, 0x90, 0x55, 0x50, 0x48, 0x90, 0x57, 0x50, 0x62, 0x30, 0x5F, 0xD0, 0x45, 0x10, 0x58, 0xA0, 0x00, 0x00 }; /*9615*/
const unsigned char  uc2_9616 [] = {0x60, 0x00, 0x17, 0xF0, 0x42, 0x10, 0x4F, 0x90, 0x42, 0x10, 0x5F, 0xD0, 0x48, 0x90, 0x5F, 0xD0, 0x55, 0x50, 0x7F, 0xF0, 0x40, 0x20, 0x00, 0x00 }; /*9616*/
const unsigned char  uc2_9617 [] = {0x4F, 0xF0, 0x22, 0x10, 0x5F, 0xD0, 0x44, 0x10, 0x4F, 0x90, 0x48, 0x90, 0x4F, 0x90, 0x48, 0x90, 0x5F, 0xD0, 0x48, 0x90, 0x50, 0x70, 0x00, 0x00 }; /*9617*/
const unsigned char  uc2_9619 [] = {0x60, 0x00, 0x17, 0xF0, 0x69, 0x10, 0x51, 0x10, 0x7D, 0xD0, 0x56, 0x50, 0x7D, 0x90, 0x51, 0x10, 0x52, 0x90, 0x6C, 0x50, 0x40, 0x60, 0x00, 0x00 }; /*9619*/
const unsigned char  uc2_961A [] = {0x60, 0x00, 0x1F, 0xF0, 0x49, 0x10, 0x7F, 0x10, 0x55, 0xF0, 0x5E, 0x50, 0x55, 0x50, 0x5C, 0x90, 0x56, 0x90, 0x7D, 0x50, 0x46, 0x60, 0x00, 0x00 }; /*961A*/
const unsigned char  uc2_961C [] = {0x04, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*961C*/
const unsigned char  uc2_961F [] = {0x79, 0x00, 0x49, 0x00, 0x49, 0x00, 0x51, 0x00, 0x51, 0x00, 0x49, 0x00, 0x49, 0x00, 0x72, 0x80, 0x42, 0x80, 0x44, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*961F*/
const unsigned char  uc2_9621 [] = {0x78, 0x60, 0x4B, 0x80, 0x48, 0x80, 0x50, 0x80, 0x48, 0x80, 0x4F, 0xF0, 0x48, 0x80, 0x70, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*9621*/
const unsigned char  uc2_9622 [] = {0x7F, 0xF0, 0x49, 0x40, 0x49, 0x40, 0x51, 0x40, 0x49, 0x40, 0x49, 0x40, 0x49, 0x40, 0x72, 0x50, 0x42, 0x50, 0x44, 0x50, 0x48, 0x20, 0x00, 0x00 }; /*9622*/
const unsigned char  uc2_962A [] = {0x00, 0x20, 0x7B, 0xC0, 0x4A, 0x00, 0x4A, 0x00, 0x53, 0xE0, 0x4A, 0xA0, 0x4A, 0xA0, 0x4A, 0x40, 0x74, 0xA0, 0x44, 0xA0, 0x49, 0x10, 0x00, 0x00 }; /*962A*/
const unsigned char  uc2_962E [] = {0x7B, 0xE0, 0x48, 0x00, 0x48, 0x00, 0x57, 0xF0, 0x49, 0x40, 0x49, 0x40, 0x49, 0x40, 0x71, 0x50, 0x42, 0x50, 0x42, 0x50, 0x44, 0x20, 0x00, 0x00 }; /*962E*/
const unsigned char  uc2_9631 [] = {0x79, 0x40, 0x49, 0x40, 0x4B, 0xE0, 0x51, 0x40, 0x49, 0x40, 0x4F, 0xF0, 0x49, 0x40, 0x71, 0x40, 0x42, 0x40, 0x42, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*9631*/
const unsigned char  uc2_9632 [] = {0x79, 0x80, 0x48, 0x40, 0x4F, 0xF0, 0x51, 0x00, 0x49, 0x00, 0x49, 0xE0, 0x49, 0x20, 0x71, 0x20, 0x42, 0x20, 0x42, 0x20, 0x4C, 0xC0, 0x00, 0x00 }; /*9632*/
const unsigned char  uc2_9633 [] = {0x78, 0x00, 0x4B, 0xE0, 0x4A, 0x20, 0x52, 0x20, 0x52, 0x20, 0x4B, 0xE0, 0x4A, 0x20, 0x4A, 0x20, 0x72, 0x20, 0x43, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*9633*/
const unsigned char  uc2_9634 [] = {0x79, 0xF0, 0x49, 0x10, 0x49, 0x10, 0x51, 0xF0, 0x51, 0x10, 0x49, 0x10, 0x49, 0xF0, 0x49, 0x10, 0x71, 0x10, 0x42, 0x10, 0x4C, 0x60, 0x00, 0x00 }; /*9634*/
const unsigned char  uc2_9635 [] = {0x79, 0x00, 0x4F, 0xF0, 0x4A, 0x00, 0x54, 0x80, 0x57, 0xE0, 0x48, 0x80, 0x48, 0x80, 0x4F, 0xF0, 0x78, 0x80, 0x40, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*9635*/
const unsigned char  uc2_9636 [] = {0x78, 0x80, 0x48, 0x80, 0x49, 0x40, 0x56, 0x30, 0x51, 0x40, 0x49, 0x40, 0x49, 0x40, 0x49, 0x40, 0x72, 0x40, 0x42, 0x40, 0x44, 0x40, 0x00, 0x00 }; /*9636*/
const unsigned char  uc2_963B [] = {0x7B, 0xE0, 0x4A, 0x20, 0x4A, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x4A, 0x20, 0x4B, 0xE0, 0x4A, 0x20, 0x72, 0x20, 0x42, 0x20, 0x47, 0xF0, 0x00, 0x00 }; /*963B*/
const unsigned char  uc2_963C [] = {0x79, 0x00, 0x49, 0xF0, 0x4B, 0x00, 0x55, 0x00, 0x49, 0xE0, 0x49, 0x00, 0x49, 0x00, 0x71, 0xE0, 0x41, 0x00, 0x41, 0x00, 0x41, 0x00, 0x00, 0x00 }; /*963C*/
const unsigned char  uc2_963D [] = {0x78, 0x80, 0x48, 0x80, 0x48, 0xF0, 0x50, 0x80, 0x48, 0x80, 0x4B, 0xE0, 0x4A, 0x20, 0x72, 0x20, 0x42, 0x20, 0x43, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*963D*/
const unsigned char  uc2_963F [] = {0x7F, 0xF0, 0x48, 0x20, 0x4B, 0xA0, 0x52, 0xA0, 0x4A, 0xA0, 0x4A, 0xA0, 0x4B, 0xA0, 0x72, 0xA0, 0x40, 0x20, 0x40, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*963F*/
const unsigned char  uc2_9640 [] = {0x01, 0x80, 0x78, 0x40, 0x4B, 0xF0, 0x4A, 0x10, 0x52, 0x10, 0x49, 0x20, 0x49, 0xC0, 0x49, 0x00, 0x71, 0x10, 0x41, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*9640*/
const unsigned char  uc2_9642 [] = {0x00, 0x40, 0x78, 0x40, 0x4B, 0xF0, 0x4A, 0x50, 0x52, 0x50, 0x4B, 0xE0, 0x4A, 0xA0, 0x4A, 0xA0, 0x72, 0x40, 0x44, 0xA0, 0x4B, 0x10, 0x00, 0x00 }; /*9642*/
const unsigned char  uc2_9644 [] = {0x79, 0x20, 0x49, 0x20, 0x4A, 0x20, 0x57, 0xF0, 0x4A, 0x20, 0x4B, 0x20, 0x4A, 0xA0, 0x72, 0xA0, 0x42, 0x20, 0x42, 0x20, 0x42, 0xC0, 0x00, 0x00 }; /*9644*/
const unsigned char  uc2_9645 [] = {0x7B, 0xE0, 0x48, 0x00, 0x48, 0x00, 0x57, 0xF0, 0x48, 0x80, 0x48, 0x80, 0x4A, 0xA0, 0x72, 0x90, 0x44, 0x90, 0x40, 0x80, 0x43, 0x00, 0x00, 0x00 }; /*9645*/
const unsigned char  uc2_9646 [] = {0x78, 0x80, 0x4B, 0xE0, 0x48, 0x80, 0x50, 0x80, 0x4F, 0xF0, 0x48, 0x80, 0x4A, 0xA0, 0x72, 0xA0, 0x42, 0xA0, 0x43, 0xE0, 0x40, 0x20, 0x00, 0x00 }; /*9646*/
const unsigned char  uc2_9647 [] = {0x7A, 0xC0, 0x4A, 0x20, 0x4F, 0xF0, 0x52, 0x80, 0x52, 0x90, 0x4A, 0xA0, 0x4A, 0xA0, 0x4C, 0xC0, 0x74, 0x90, 0x49, 0x90, 0x56, 0x60, 0x00, 0x00 }; /*9647*/
const unsigned char  uc2_9648 [] = {0x79, 0x00, 0x4F, 0xF0, 0x49, 0x00, 0x52, 0x80, 0x52, 0x80, 0x4F, 0xE0, 0x48, 0x80, 0x4A, 0xA0, 0x72, 0x90, 0x4C, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*9648*/
const unsigned char  uc2_9649 [] = {0x7B, 0xE0, 0x48, 0x20, 0x48, 0x40, 0x50, 0xA0, 0x4F, 0x10, 0x48, 0x10, 0x48, 0x00, 0x73, 0xE0, 0x40, 0x80, 0x40, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*9649*/
const unsigned char  uc2_964B [] = {0x73, 0xF0, 0x50, 0x40, 0x55, 0xF0, 0x65, 0x50, 0x55, 0x50, 0x55, 0x50, 0x55, 0xB0, 0x55, 0x10, 0x65, 0x60, 0x44, 0x00, 0x43, 0xF0, 0x00, 0x00 }; /*964B*/
const unsigned char  uc2_964C [] = {0x7F, 0xF0, 0x48, 0x80, 0x49, 0x00, 0x53, 0xE0, 0x4A, 0x20, 0x4A, 0x20, 0x4B, 0xE0, 0x72, 0x20, 0x42, 0x20, 0x43, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*964C*/
const unsigned char  uc2_964D [] = {0x02, 0x00, 0x7B, 0xE0, 0x4E, 0x20, 0x49, 0xC0, 0x56, 0x30, 0x48, 0x80, 0x4B, 0xE0, 0x4A, 0x80, 0x77, 0xF0, 0x40, 0x80, 0x40, 0x80, 0x00, 0x00 }; /*964D*/
const unsigned char  uc2_9650 [] = {0x7B, 0xE0, 0x4A, 0x20, 0x4B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x4A, 0xA0, 0x4A, 0xA0, 0x4A, 0x40, 0x72, 0x40, 0x42, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*9650*/
const unsigned char  uc2_9654 [] = {0x7B, 0x00, 0x48, 0x80, 0x4F, 0xF0, 0x50, 0x80, 0x49, 0x20, 0x4B, 0xC0, 0x48, 0x90, 0x77, 0x20, 0x40, 0x60, 0x41, 0x90, 0x46, 0x10, 0x00, 0x00 }; /*9654*/
const unsigned char  uc2_9655 [] = {0x71, 0x00, 0x51, 0x00, 0x5F, 0xE0, 0x55, 0x40, 0x62, 0x80, 0x5F, 0xF0, 0x51, 0x00, 0x52, 0x80, 0x62, 0x80, 0x44, 0x40, 0x58, 0x30, 0x00, 0x00 }; /*9655*/
const unsigned char  uc2_965B [] = {0x7A, 0x40, 0x4A, 0x50, 0x4B, 0x60, 0x52, 0x50, 0x4A, 0x50, 0x4B, 0x20, 0x48, 0x80, 0x73, 0xE0, 0x40, 0x80, 0x40, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*965B*/
const unsigned char  uc2_965F [] = {0x78, 0x80, 0x4A, 0x80, 0x4A, 0xE0, 0x52, 0x80, 0x57, 0xF0, 0x48, 0x00, 0x48, 0x80, 0x4A, 0xA0, 0x74, 0xC0, 0x41, 0x80, 0x4E, 0x00, 0x00, 0x00 }; /*965F*/
const unsigned char  uc2_9661 [] = {0x78, 0x80, 0x48, 0x80, 0x4B, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x48, 0x00, 0x48, 0x80, 0x4A, 0xE0, 0x72, 0x80, 0x45, 0x80, 0x48, 0x70, 0x00, 0x00 }; /*9661*/
const unsigned char  uc2_9662 [] = {0x03, 0x00, 0x70, 0x80, 0x57, 0xF0, 0x54, 0x10, 0x63, 0xE0, 0x50, 0x00, 0x57, 0xF0, 0x51, 0x40, 0x61, 0x50, 0x42, 0x50, 0x4C, 0x20, 0x00, 0x00 }; /*9662*/
const unsigned char  uc2_9664 [] = {0x78, 0x80, 0x49, 0x40, 0x4E, 0x30, 0x50, 0x00, 0x53, 0xE0, 0x48, 0x80, 0x4F, 0xF0, 0x4A, 0xA0, 0x72, 0x90, 0x44, 0x90, 0x43, 0x00, 0x00, 0x00 }; /*9664*/
const unsigned char  uc2_9667 [] = {0x7B, 0xE0, 0x4A, 0x20, 0x4B, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x48, 0x00, 0x48, 0x80, 0x4B, 0xE0, 0x70, 0x80, 0x40, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*9667*/
const unsigned char  uc2_9668 [] = {0x73, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x50, 0x00, 0x67, 0xF0, 0x54, 0x10, 0x54, 0x90, 0x54, 0x90, 0x64, 0x90, 0x41, 0x60, 0x4E, 0x10, 0x00, 0x00 }; /*9668*/
const unsigned char  uc2_9669 [] = {0x78, 0x80, 0x49, 0x40, 0x4E, 0x30, 0x50, 0x00, 0x53, 0xE0, 0x49, 0x00, 0x4C, 0xA0, 0x4A, 0xA0, 0x72, 0x40, 0x40, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*9669*/
const unsigned char  uc2_966A [] = {0x01, 0x80, 0x78, 0x40, 0x4B, 0xE0, 0x49, 0x40, 0x50, 0x80, 0x4F, 0xF0, 0x48, 0x00, 0x4B, 0xE0, 0x72, 0x20, 0x43, 0xE0, 0x42, 0x20, 0x00, 0x00 }; /*966A*/
const unsigned char  uc2_966C [] = {0x7F, 0x80, 0x55, 0x00, 0x55, 0xF0, 0x67, 0x50, 0x55, 0x50, 0x57, 0x50, 0x55, 0x20, 0x65, 0xA0, 0x4F, 0x20, 0x41, 0x20, 0x41, 0xD0, 0x00, 0x00 }; /*966C*/
const unsigned char  uc2_9672 [] = {0x70, 0xC0, 0x57, 0x00, 0x51, 0x00, 0x6F, 0xE0, 0x55, 0x40, 0x5F, 0xF0, 0x55, 0x40, 0x65, 0x40, 0x4F, 0xE0, 0x41, 0x00, 0x47, 0xC0, 0x00, 0x00 }; /*9672*/
const unsigned char  uc2_9674 [] = {0x00, 0x80, 0x79, 0x00, 0x4B, 0xE0, 0x4A, 0xA0, 0x53, 0xE0, 0x4A, 0xA0, 0x4B, 0xE0, 0x49, 0x00, 0x72, 0x40, 0x47, 0xF0, 0x40, 0x40, 0x00, 0x00 }; /*9674*/
const unsigned char  uc2_9675 [] = {0x00, 0x80, 0x7B, 0xE0, 0x48, 0x80, 0x4F, 0xF0, 0x51, 0x20, 0x4E, 0x10, 0x49, 0x10, 0x49, 0xE0, 0x73, 0x20, 0x40, 0xC0, 0x47, 0x30, 0x00, 0x00 }; /*9675*/
const unsigned char  uc2_9676 [] = {0x74, 0x00, 0x57, 0xF0, 0x58, 0x10, 0x64, 0x10, 0x57, 0xD0, 0x59, 0x10, 0x57, 0xF0, 0x61, 0x10, 0x45, 0x50, 0x47, 0xD0, 0x40, 0x60, 0x00, 0x00 }; /*9676*/
const unsigned char  uc2_9677 [] = {0x71, 0x00, 0x51, 0xE0, 0x52, 0x20, 0x5C, 0x40, 0x61, 0x80, 0x56, 0x70, 0x54, 0x10, 0x57, 0x70, 0x64, 0x10, 0x47, 0xF0, 0x44, 0x10, 0x00, 0x00 }; /*9677*/
const unsigned char  uc2_9685 [] = {0x73, 0xE0, 0x52, 0xA0, 0x53, 0xE0, 0x52, 0xA0, 0x67, 0xF0, 0x54, 0x90, 0x54, 0x90, 0x54, 0xD0, 0x67, 0xB0, 0x44, 0x10, 0x44, 0x60, 0x00, 0x00 }; /*9685*/
const unsigned char  uc2_9686 [] = {0x79, 0xE0, 0x4E, 0x20, 0x49, 0xC0, 0x56, 0x30, 0x4B, 0xE0, 0x4A, 0x80, 0x4B, 0xE0, 0x74, 0x80, 0x43, 0xE0, 0x40, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*9686*/
const unsigned char  uc2_9688 [] = {0x7B, 0xE0, 0x4A, 0xA0, 0x4B, 0xE0, 0x52, 0xA0, 0x4B, 0xE0, 0x48, 0x00, 0x4F, 0xF0, 0x72, 0xA0, 0x42, 0x40, 0x42, 0xB0, 0x43, 0x00, 0x00, 0x00 }; /*9688*/
const unsigned char  uc2_968B [] = {0x71, 0x00, 0x57, 0xF0, 0x52, 0x00, 0x65, 0xE0, 0x50, 0x80, 0x57, 0xF0, 0x52, 0x20, 0x63, 0xE0, 0x42, 0x20, 0x43, 0xA0, 0x42, 0x60, 0x00, 0x00 }; /*968B*/
const unsigned char  uc2_968D [] = {0x78, 0x80, 0x4B, 0xE0, 0x4A, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x4F, 0xF0, 0x48, 0x80, 0x4B, 0xE0, 0x70, 0x80, 0x40, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*968D*/
const unsigned char  uc2_968F [] = {0x78, 0x80, 0x57, 0xF0, 0x54, 0x80, 0x51, 0xE0, 0x6F, 0x20, 0x55, 0xE0, 0x55, 0x20, 0x55, 0xE0, 0x65, 0x20, 0x46, 0x40, 0x59, 0xF0, 0x00, 0x00 }; /*968F*/
const unsigned char  uc2_9690 [] = {0x79, 0x00, 0x49, 0xC0, 0x4E, 0x40, 0x53, 0xE0, 0x50, 0x20, 0x4F, 0xE0, 0x48, 0x20, 0x4B, 0xE0, 0x72, 0xA0, 0x46, 0x50, 0x49, 0xD0, 0x00, 0x00 }; /*9690*/
const unsigned char  uc2_9694 [] = {0x77, 0xF0, 0x50, 0x00, 0x53, 0xE0, 0x62, 0x20, 0x57, 0xF0, 0x55, 0x50, 0x54, 0x90, 0x67, 0xF0, 0x44, 0x90, 0x44, 0x90, 0x44, 0x60, 0x00, 0x00 }; /*9694*/
const unsigned char  uc2_9697 [] = {0x71, 0x00, 0x57, 0xC0, 0x55, 0x40, 0x57, 0xC0, 0x65, 0x40, 0x57, 0xC0, 0x51, 0xA0, 0x52, 0xD0, 0x62, 0xA0, 0x44, 0x90, 0x58, 0x60, 0x00, 0x00 }; /*9697*/
const unsigned char  uc2_9698 [] = {0x74, 0x40, 0x52, 0x80, 0x5F, 0xE0, 0x62, 0x40, 0x52, 0x20, 0x54, 0x20, 0x5F, 0xE0, 0x6A, 0xA0, 0x4A, 0xA0, 0x4A, 0xA0, 0x5F, 0xF0, 0x00, 0x00 }; /*9698*/
const unsigned char  uc2_9699 [] = {0x78, 0x80, 0x4A, 0xA0, 0x4C, 0x90, 0x53, 0xE0, 0x52, 0x20, 0x4B, 0xE0, 0x4A, 0x20, 0x4B, 0xE0, 0x72, 0xA0, 0x42, 0x90, 0x45, 0x10, 0x00, 0x00 }; /*9699*/
const unsigned char  uc2_969C [] = {0x00, 0x80, 0x7B, 0xE0, 0x49, 0x40, 0x4F, 0xF0, 0x52, 0x20, 0x4B, 0xE0, 0x4A, 0x20, 0x4B, 0xE0, 0x70, 0x80, 0x47, 0xF0, 0x40, 0x80, 0x00, 0x00 }; /*969C*/
const unsigned char  uc2_96A7 [] = {0x71, 0x40, 0x5B, 0xF0, 0x54, 0x90, 0x6F, 0x60, 0x54, 0xC0, 0x57, 0x60, 0x54, 0xD0, 0x67, 0x40, 0x44, 0x40, 0x46, 0x80, 0x49, 0xF0, 0x00, 0x00 }; /*96A7*/
const unsigned char  uc2_96B0 [] = {0x73, 0xE0, 0x52, 0x20, 0x53, 0xE0, 0x52, 0x20, 0x65, 0xD0, 0x57, 0x70, 0x52, 0x20, 0x55, 0x50, 0x67, 0x70, 0x42, 0x20, 0x45, 0x50, 0x00, 0x00 }; /*96B0*/
const unsigned char  uc2_96B3 [] = {0x39, 0x00, 0x2F, 0xF0, 0x32, 0x40, 0x2F, 0xF0, 0x2A, 0x20, 0x3B, 0xA0, 0x22, 0x60, 0x0D, 0x80, 0x72, 0x70, 0x12, 0xA0, 0x26, 0x90, 0x00, 0x00 }; /*96B3*/
const unsigned char  uc2_96B6 [] = {0x02, 0x00, 0x1F, 0xC0, 0x02, 0x40, 0x7F, 0xF0, 0x02, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x33, 0x60, 0x0E, 0x80, 0x12, 0x40, 0x6C, 0x30, 0x00, 0x00 }; /*96B6*/
const unsigned char  uc2_96B9 [] = {0x0A, 0x00, 0x09, 0x00, 0x1F, 0xF0, 0x71, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x11, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*96B9*/
const unsigned char  uc2_96BC [] = {0x09, 0x00, 0x1F, 0xE0, 0x71, 0x00, 0x1F, 0xC0, 0x11, 0x00, 0x1F, 0xC0, 0x11, 0x00, 0x1F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*96BC*/
const unsigned char  uc2_96BD [] = {0x09, 0x00, 0x1F, 0xF0, 0x71, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x3F, 0xC0, 0x04, 0x70, 0x08, 0x10, 0x71, 0xE0, 0x00, 0x00 }; /*96BD*/
const unsigned char  uc2_96BE [] = {0x01, 0x80, 0x01, 0x40, 0x7B, 0xF0, 0x0E, 0x40, 0x2B, 0xE0, 0x12, 0x40, 0x13, 0xE0, 0x2A, 0x40, 0x4A, 0x40, 0x03, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*96BE*/
const unsigned char  uc2_96C0 [] = {0x02, 0x00, 0x12, 0x60, 0x62, 0x10, 0x02, 0x40, 0x01, 0x80, 0x0F, 0xF0, 0x71, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x10, 0x00, 0x00, 0x00 }; /*96C0*/
const unsigned char  uc2_96C1 [] = {0x3F, 0xF0, 0x25, 0x80, 0x25, 0x40, 0x29, 0xF0, 0x3E, 0x40, 0x2B, 0xE0, 0x2A, 0x40, 0x2B, 0xE0, 0x2A, 0x40, 0x2B, 0xF0, 0x4A, 0x00, 0x00, 0x00 }; /*96C1*/
const unsigned char  uc2_96C4 [] = {0x10, 0x80, 0x11, 0x40, 0x7D, 0xF0, 0x13, 0x40, 0x11, 0xE0, 0x29, 0x40, 0x29, 0xE0, 0x29, 0x40, 0x55, 0x40, 0x5D, 0xF0, 0x45, 0x00, 0x00, 0x00 }; /*96C4*/
const unsigned char  uc2_96C5 [] = {0x00, 0x80, 0x3F, 0x40, 0x15, 0xF0, 0x27, 0x40, 0x25, 0xE0, 0x3F, 0x40, 0x15, 0xE0, 0x15, 0x40, 0x25, 0x40, 0x45, 0xF0, 0x19, 0x00, 0x00, 0x00 }; /*96C5*/
const unsigned char  uc2_96C6 [] = {0x09, 0x00, 0x1F, 0xF0, 0x71, 0x00, 0x1F, 0xE0, 0x11, 0x00, 0x1F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x07, 0x00, 0x1A, 0xC0, 0x62, 0x30, 0x00, 0x00 }; /*96C6*/
const unsigned char  uc2_96C7 [] = {0x01, 0x00, 0x3F, 0xF0, 0x20, 0x10, 0x3F, 0xF0, 0x24, 0x80, 0x2F, 0xF0, 0x38, 0x80, 0x2F, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x48, 0x00, 0x00, 0x00 }; /*96C7*/
const unsigned char  uc2_96C9 [] = {0x00, 0x80, 0x21, 0x40, 0x3D, 0xF0, 0x53, 0x40, 0x11, 0xE0, 0x7D, 0x40, 0x11, 0xE0, 0x19, 0x40, 0x25, 0x40, 0x25, 0xF0, 0x41, 0x00, 0x00, 0x00 }; /*96C9*/
const unsigned char  uc2_96CC [] = {0x0A, 0x40, 0x0A, 0xA0, 0x2A, 0xF0, 0x2B, 0xA0, 0x2E, 0xF0, 0x2A, 0xA0, 0x2A, 0xF0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2F, 0xF0, 0x72, 0x80, 0x00, 0x00 }; /*96CC*/
const unsigned char  uc2_96CD [] = {0x02, 0x00, 0x7F, 0xF0, 0x15, 0x40, 0x27, 0xF0, 0x39, 0x40, 0x11, 0xE0, 0x25, 0x40, 0x39, 0xE0, 0x09, 0x40, 0x11, 0xF0, 0x61, 0x00, 0x00, 0x00 }; /*96CD*/
const unsigned char  uc2_96CE [] = {0x00, 0x80, 0x3D, 0x40, 0x25, 0xF0, 0x27, 0x40, 0x3D, 0xE0, 0x25, 0x40, 0x3D, 0xE0, 0x25, 0x40, 0x25, 0x40, 0x2F, 0xF0, 0x71, 0x00, 0x00, 0x00 }; /*96CE*/
const unsigned char  uc2_96CF [] = {0x10, 0x80, 0x19, 0x40, 0x69, 0xF0, 0x3F, 0x40, 0x05, 0xE0, 0x05, 0x40, 0x3D, 0xE0, 0x05, 0x40, 0x05, 0x40, 0x7D, 0xF0, 0x05, 0x00, 0x00, 0x00 }; /*96CF*/
const unsigned char  uc2_96D2 [] = {0x20, 0x80, 0x39, 0x40, 0x49, 0xF0, 0x2B, 0x40, 0x11, 0xE0, 0x29, 0x40, 0x45, 0xE0, 0x39, 0x40, 0x29, 0x40, 0x39, 0xF0, 0x29, 0x00, 0x00, 0x00 }; /*96D2*/
const unsigned char  uc2_96D5 [] = {0x3E, 0x40, 0x2A, 0xA0, 0x3F, 0xF0, 0x2A, 0xA0, 0x3E, 0xF0, 0x22, 0xA0, 0x2A, 0xF0, 0x36, 0xA0, 0x2A, 0xA0, 0x22, 0xF0, 0x44, 0x80, 0x00, 0x00 }; /*96D5*/
const unsigned char  uc2_96E0 [] = {0x28, 0xA0, 0x3C, 0xF0, 0x6B, 0xA0, 0x28, 0xA0, 0x3E, 0xF0, 0x2A, 0xA0, 0x3E, 0xF0, 0x2A, 0xA0, 0x2B, 0xA0, 0x3E, 0xF0, 0x20, 0x80, 0x00, 0x00 }; /*96E0*/
const unsigned char  uc2_96E8 [] = {0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x32, 0xA0, 0x2A, 0x60, 0x32, 0xA0, 0x2A, 0x60, 0x22, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*96E8*/
const unsigned char  uc2_96E9 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x08, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x07, 0x80, 0x00, 0x00 }; /*96E9*/
const unsigned char  uc2_96EA [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5A, 0xD0, 0x00, 0x00, 0x3F, 0xE0, 0x00, 0x20, 0x1F, 0xE0, 0x00, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*96EA*/
const unsigned char  uc2_96EF [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5A, 0xD0, 0x04, 0x00, 0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x00, 0x00 }; /*96EF*/
const unsigned char  uc2_96F3 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5A, 0xD0, 0x02, 0x00, 0x3F, 0xE0, 0x22, 0x00, 0x2F, 0xE0, 0x22, 0x20, 0x4C, 0xC0, 0x00, 0x00 }; /*96F3*/
const unsigned char  uc2_96F6 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x1A, 0xC0, 0x07, 0x00, 0x1A, 0xC0, 0x6F, 0xB0, 0x00, 0x80, 0x07, 0x00, 0x00, 0x80, 0x00, 0x00 }; /*96F6*/
const unsigned char  uc2_96F7 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5A, 0xD0, 0x00, 0x00, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00 }; /*96F7*/
const unsigned char  uc2_96F9 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x1F, 0xC0, 0x60, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x1E, 0x90, 0x10, 0x10, 0x0F, 0xE0, 0x00, 0x00 }; /*96F9*/
const unsigned char  uc2_96FE [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x0F, 0x80, 0x38, 0x80, 0x07, 0x00, 0x7A, 0xF0, 0x0F, 0x80, 0x04, 0x80, 0x7B, 0x00, 0x00, 0x00 }; /*96FE*/
const unsigned char  uc2_9700 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x1A, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x48, 0xB0, 0x00, 0x00 }; /*9700*/
const unsigned char  uc2_9701 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x00, 0x78, 0xF0, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*9701*/
const unsigned char  uc2_9704 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x12, 0x40, 0x0A, 0x80, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x11, 0xC0, 0x00, 0x00 }; /*9704*/
const unsigned char  uc2_9706 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x3B, 0xE0, 0x10, 0x80, 0x3B, 0xE0, 0x08, 0x80, 0x2F, 0xF0, 0x10, 0x00, 0x6F, 0xF0, 0x00, 0x00 }; /*9706*/
const unsigned char  uc2_9707 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x3F, 0xE0, 0x20, 0x00, 0x2F, 0xC0, 0x20, 0x00, 0x3F, 0xE0, 0x29, 0x40, 0x4C, 0xF0, 0x00, 0x00 }; /*9707*/
const unsigned char  uc2_9708 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x60, 0x80, 0x17, 0xF0, 0x60, 0x80, 0x13, 0xE0, 0x02, 0xA0, 0x12, 0xC0, 0x60, 0x80, 0x00, 0x00 }; /*9708*/
const unsigned char  uc2_9709 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x1F, 0xE0, 0x60, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x14, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*9709*/
const unsigned char  uc2_970D [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x42, 0x10, 0x5A, 0xD0, 0x09, 0x00, 0x1F, 0xE0, 0x71, 0x00, 0x1F, 0xC0, 0x11, 0x00, 0x1F, 0xF0, 0x00, 0x00 }; /*970D*/
const unsigned char  uc2_970E [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x7F, 0x70, 0x00, 0x00 }; /*970E*/
const unsigned char  uc2_970F [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x02, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x00, 0x00 }; /*970F*/
const unsigned char  uc2_9713 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x1D, 0xC0, 0x10, 0x40, 0x1D, 0xC0, 0x10, 0x40, 0x1F, 0xD0, 0x05, 0x10, 0x79, 0xF0, 0x00, 0x00 }; /*9713*/
const unsigned char  uc2_9716 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x4A, 0x90, 0x08, 0x80, 0x7F, 0xF0, 0x18, 0xC0, 0x2D, 0xA0, 0x2A, 0xA0, 0x48, 0x90, 0x00, 0x00 }; /*9716*/
const unsigned char  uc2_971C [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x13, 0xE0, 0x7E, 0x20, 0x13, 0xE0, 0x3A, 0x20, 0x57, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x00, 0x00 }; /*971C*/
const unsigned char  uc2_971E [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x00, 0x00, 0x3D, 0xE0, 0x24, 0x20, 0x3D, 0xE0, 0x21, 0x20, 0x3C, 0xC0, 0x23, 0x30, 0x00, 0x00 }; /*971E*/
const unsigned char  uc2_972A [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x67, 0xF0, 0x12, 0xA0, 0x63, 0xE0, 0x10, 0x80, 0x07, 0xF0, 0x10, 0x80, 0x63, 0xE0, 0x00, 0x00 }; /*972A*/
const unsigned char  uc2_972D [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x52, 0x50, 0x03, 0xE0, 0x32, 0xA0, 0x03, 0xF0, 0x6C, 0x90, 0x25, 0x50, 0x37, 0x90, 0x20, 0x70, 0x00, 0x00 }; /*972D*/
const unsigned char  uc2_9730 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x4A, 0x90, 0x14, 0x40, 0x3E, 0x40, 0x14, 0xF0, 0x7F, 0xA0, 0x22, 0xA0, 0x3A, 0x40, 0x26, 0xB0, 0x00, 0x00 }; /*9730*/
const unsigned char  uc2_9732 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x3F, 0xE0, 0x25, 0x20, 0x3C, 0xC0, 0x0B, 0x30, 0x2D, 0xE0, 0x2B, 0x20, 0x7D, 0xE0, 0x00, 0x00 }; /*9732*/
const unsigned char  uc2_9738 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x14, 0x90, 0x2A, 0xF0, 0x3E, 0x90, 0x08, 0xF0, 0x7E, 0x90, 0x09, 0x20, 0x00, 0x00 }; /*9738*/
const unsigned char  uc2_9739 [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x3B, 0xE0, 0x29, 0x40, 0x3F, 0xF0, 0x20, 0x80, 0x3B, 0xE0, 0x28, 0x80, 0x58, 0x80, 0x00, 0x00 }; /*9739*/
const unsigned char  uc2_973E [] = {0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x55, 0x50, 0x73, 0xE0, 0x2A, 0xA0, 0x5B, 0xE0, 0x2A, 0xA0, 0x5F, 0xF0, 0x28, 0x80, 0x57, 0xF0, 0x00, 0x00 }; /*973E*/
const unsigned char  uc2_9752 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0x40, 0x10, 0xC0, 0x00, 0x00 }; /*9752*/
const unsigned char  uc2_9753 [] = {0x10, 0x00, 0x7F, 0xE0, 0x12, 0x20, 0x3A, 0xA0, 0x12, 0xA0, 0x6E, 0xA0, 0x3A, 0xA0, 0x28, 0x80, 0x39, 0x50, 0x29, 0x50, 0x36, 0x20, 0x00, 0x00 }; /*9753*/
const unsigned char  uc2_9756 [] = {0x10, 0x80, 0x17, 0xF0, 0x78, 0x80, 0x03, 0xE0, 0x28, 0x80, 0x2F, 0xF0, 0x2A, 0x20, 0x13, 0xE0, 0x7A, 0x20, 0x03, 0xA0, 0x02, 0x60, 0x00, 0x00 }; /*9756*/
const unsigned char  uc2_9759 [] = {0x11, 0x00, 0x7D, 0xC0, 0x16, 0x40, 0x3B, 0xE0, 0x10, 0xA0, 0x6F, 0xF0, 0x38, 0xA0, 0x2B, 0xE0, 0x38, 0x80, 0x28, 0x80, 0x33, 0x00, 0x00, 0x00 }; /*9759*/
const unsigned char  uc2_975B [] = {0x10, 0x40, 0x7D, 0xF0, 0x11, 0x10, 0x38, 0x00, 0x11, 0xF0, 0x6C, 0x40, 0x39, 0x40, 0x29, 0x70, 0x39, 0x40, 0x2A, 0xC0, 0x34, 0x30, 0x00, 0x00 }; /*975B*/
const unsigned char  uc2_975E [] = {0x05, 0x00, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x05, 0x00, 0x7D, 0xF0, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00 }; /*975E*/
const unsigned char  uc2_9760 [] = {0x12, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x35, 0x60, 0x0D, 0x80, 0x35, 0x60, 0x0D, 0x80, 0x75, 0x70, 0x00, 0x00 }; /*9760*/
const unsigned char  uc2_9761 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x22, 0x80, 0x2E, 0xE0, 0x22, 0x80, 0x3E, 0xF0, 0x42, 0x80, 0x00, 0x00 }; /*9761*/
const unsigned char  uc2_9762 [] = {0x7F, 0xF0, 0x02, 0x00, 0x04, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x27, 0x20, 0x25, 0x20, 0x27, 0x20, 0x25, 0x20, 0x3F, 0xE0, 0x20, 0x20, 0x00, 0x00 }; /*9762*/
const unsigned char  uc2_9765 [] = {0x3F, 0xF0, 0x21, 0x40, 0x2F, 0xF0, 0x22, 0x40, 0x2C, 0x20, 0x3F, 0xF0, 0x2A, 0xA0, 0x2B, 0xA0, 0x2A, 0xA0, 0x2F, 0xE0, 0x48, 0x20, 0x00, 0x00 }; /*9765*/
const unsigned char  uc2_9769 [] = {0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x0F, 0x80, 0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*9769*/
const unsigned char  uc2_9773 [] = {0x28, 0x30, 0x7D, 0xC0, 0x29, 0x00, 0x39, 0x00, 0x11, 0xF0, 0x7D, 0x40, 0x55, 0x40, 0x7D, 0x40, 0x11, 0x40, 0x7D, 0x40, 0x12, 0x40, 0x00, 0x00 }; /*9773*/
const unsigned char  uc2_9774 [] = {0x28, 0xC0, 0x7D, 0x40, 0x29, 0x40, 0x3B, 0x50, 0x11, 0x50, 0x7D, 0x60, 0x55, 0xC0, 0x7D, 0x40, 0x11, 0x50, 0x7D, 0x50, 0x11, 0x20, 0x00, 0x00 }; /*9774*/
const unsigned char  uc2_9776 [] = {0x28, 0x00, 0x7D, 0xF0, 0x29, 0x50, 0x39, 0x50, 0x11, 0x50, 0x7D, 0xF0, 0x55, 0x00, 0x7D, 0x10, 0x11, 0x10, 0x7D, 0x10, 0x10, 0xE0, 0x00, 0x00 }; /*9776*/
const unsigned char  uc2_977C [] = {0x28, 0x00, 0x7F, 0xE0, 0x29, 0x20, 0x39, 0x20, 0x11, 0xE0, 0x7D, 0x20, 0x55, 0x20, 0x7D, 0xE0, 0x10, 0x00, 0x7C, 0x00, 0x13, 0xF0, 0x00, 0x00 }; /*977C*/
const unsigned char  uc2_9785 [] = {0x28, 0x80, 0x7C, 0x80, 0x28, 0x80, 0x3B, 0xE0, 0x12, 0xA0, 0x7A, 0xA0, 0x57, 0xF0, 0x7C, 0x80, 0x11, 0x40, 0x7D, 0x40, 0x12, 0x30, 0x00, 0x00 }; /*9785*/
const unsigned char  uc2_978B [] = {0x28, 0x80, 0x7C, 0x80, 0x2B, 0xE0, 0x38, 0x80, 0x13, 0xF0, 0x7C, 0x80, 0x54, 0x80, 0x7F, 0xE0, 0x10, 0x80, 0x7C, 0x80, 0x13, 0xF0, 0x00, 0x00 }; /*978B*/
const unsigned char  uc2_978D [] = {0x28, 0x80, 0x7F, 0xF0, 0x2A, 0x10, 0x38, 0x80, 0x13, 0xF0, 0x7C, 0xA0, 0x54, 0xA0, 0x7D, 0x20, 0x11, 0xC0, 0x7C, 0xA0, 0x13, 0x20, 0x00, 0x00 }; /*978D*/
const unsigned char  uc2_9791 [] = {0x2A, 0x40, 0x7D, 0x40, 0x29, 0xF0, 0x3B, 0x40, 0x11, 0x40, 0x7D, 0x60, 0x55, 0x50, 0x7D, 0x90, 0x11, 0x00, 0x7D, 0x00, 0x12, 0xF0, 0x00, 0x00 }; /*9791*/
const unsigned char  uc2_9792 [] = {0x28, 0x60, 0x7F, 0x80, 0x28, 0x80, 0x3F, 0xF0, 0x11, 0x40, 0x7E, 0x30, 0x55, 0x40, 0x7D, 0x40, 0x11, 0x40, 0x7D, 0x40, 0x12, 0x40, 0x00, 0x00 }; /*9792*/
const unsigned char  uc2_9794 [] = {0x29, 0x00, 0x7D, 0xC0, 0x2A, 0x40, 0x3B, 0xE0, 0x12, 0xA0, 0x7A, 0xA0, 0x57, 0xE0, 0x78, 0x80, 0x11, 0x50, 0x7D, 0x50, 0x12, 0x20, 0x00, 0x00 }; /*9794*/
const unsigned char  uc2_9798 [] = {0x28, 0x40, 0x7D, 0x50, 0x28, 0xE0, 0x38, 0x40, 0x11, 0xF0, 0x7D, 0x10, 0x55, 0xF0, 0x7D, 0x10, 0x11, 0xF0, 0x7D, 0x10, 0x11, 0x60, 0x00, 0x00 }; /*9798*/
const unsigned char  uc2_97A0 [] = {0x29, 0x00, 0x7D, 0xF0, 0x29, 0x10, 0x3A, 0xB0, 0x11, 0xD0, 0x7C, 0x90, 0x57, 0xF0, 0x7D, 0xD0, 0x12, 0xB0, 0x7C, 0x90, 0x10, 0x60, 0x00, 0x00 }; /*97A0*/
const unsigned char  uc2_97A3 [] = {0x29, 0xE0, 0x7C, 0xA0, 0x28, 0x40, 0x3B, 0xF0, 0x11, 0x50, 0x7E, 0xC0, 0x54, 0x40, 0x7D, 0xF0, 0x10, 0xE0, 0x7D, 0x50, 0x10, 0x40, 0x00, 0x00 }; /*97A3*/
const unsigned char  uc2_97AB [] = {0x29, 0x00, 0x7D, 0xF0, 0x2A, 0x90, 0x3B, 0xF0, 0x10, 0x10, 0x7D, 0xD0, 0x54, 0x10, 0x7D, 0xD0, 0x11, 0x50, 0x7D, 0xD0, 0x11, 0x70, 0x00, 0x00 }; /*97AB*/
const unsigned char  uc2_97AD [] = {0x2A, 0x00, 0x73, 0xF0, 0x2C, 0x40, 0x35, 0xF0, 0x15, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x15, 0x40, 0x7C, 0x80, 0x17, 0x70, 0x00, 0x00 }; /*97AD*/
const unsigned char  uc2_97AF [] = {0x2A, 0x20, 0x7F, 0xF0, 0x2A, 0xA0, 0x3F, 0xF0, 0x11, 0x00, 0x7A, 0xE0, 0x56, 0x20, 0x7A, 0x40, 0x13, 0xF0, 0x7E, 0x40, 0x12, 0xC0, 0x00, 0x00 }; /*97AF*/
const unsigned char  uc2_97B2 [] = {0x29, 0x40, 0x7F, 0xE0, 0x29, 0x40, 0x3B, 0xE0, 0x11, 0x40, 0x7B, 0xF0, 0x56, 0xA0, 0x7B, 0xE0, 0x12, 0xA0, 0x7F, 0xF0, 0x12, 0x40, 0x00, 0x00 }; /*97B2*/
const unsigned char  uc2_97B4 [] = {0x28, 0xA0, 0x7D, 0xF0, 0x28, 0xA0, 0x39, 0xF0, 0x10, 0x80, 0x7C, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x11, 0x50, 0x7D, 0xF0, 0x11, 0x50, 0x00, 0x00 }; /*97B4*/
const unsigned char  uc2_97E6 [] = {0x02, 0x00, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x02, 0x10, 0x02, 0x10, 0x02, 0x60, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*97E6*/
const unsigned char  uc2_97E7 [] = {0x10, 0x00, 0x7F, 0xF0, 0x10, 0x50, 0x38, 0x50, 0x11, 0x50, 0x7D, 0x50, 0x16, 0x50, 0x14, 0x90, 0x18, 0x90, 0x11, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*97E7*/
const unsigned char  uc2_97E9 [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x3E, 0xE0, 0x22, 0x40, 0x3F, 0xF0, 0x22, 0x50, 0x3E, 0x50, 0x08, 0x60, 0x7F, 0x40, 0x08, 0x40, 0x00, 0x00 }; /*97E9*/
const unsigned char  uc2_97EA [] = {0x3E, 0x40, 0x23, 0xF0, 0x3E, 0x40, 0x22, 0xE0, 0x7F, 0x40, 0x09, 0xF0, 0x28, 0x50, 0x2E, 0x50, 0x38, 0x60, 0x28, 0x40, 0x47, 0xF0, 0x00, 0x00 }; /*97EA*/
const unsigned char  uc2_97EB [] = {0x21, 0xE0, 0x79, 0x20, 0x21, 0xE0, 0x79, 0x20, 0x21, 0xE0, 0x78, 0x00, 0x2B, 0xE0, 0x2A, 0xA0, 0x3A, 0xA0, 0x22, 0xA0, 0x27, 0xF0, 0x00, 0x00 }; /*97EB*/
const unsigned char  uc2_97EC [] = {0x10, 0x30, 0x7D, 0xD0, 0x11, 0x50, 0x38, 0xA0, 0x10, 0x40, 0x7D, 0xB0, 0x15, 0x10, 0x15, 0xB0, 0x19, 0x10, 0x11, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*97EC*/
const unsigned char  uc2_97ED [] = {0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x05, 0x00, 0x1D, 0xC0, 0x05, 0x00, 0x05, 0x00, 0x3D, 0xE0, 0x05, 0x00, 0x05, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*97ED*/
const unsigned char  uc2_97F3 [] = {0x02, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*97F3*/
const unsigned char  uc2_97F5 [] = {0x08, 0x80, 0x3E, 0xF0, 0x15, 0x90, 0x7E, 0x10, 0x00, 0xD0, 0x3E, 0x30, 0x22, 0x30, 0x3E, 0x50, 0x23, 0x90, 0x3E, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*97F5*/
const unsigned char  uc2_97F6 [] = {0x08, 0xF0, 0x3E, 0x50, 0x14, 0x50, 0x7F, 0x50, 0x00, 0xA0, 0x3E, 0x00, 0x22, 0xF0, 0x3E, 0x90, 0x22, 0x90, 0x3E, 0xF0, 0x22, 0x90, 0x00, 0x00 }; /*97F6*/
const unsigned char  uc2_9875 [] = {0x3F, 0xE0, 0x02, 0x00, 0x04, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x40, 0x05, 0x80, 0x18, 0x40, 0x60, 0x20, 0x00, 0x00 }; /*9875*/
const unsigned char  uc2_9876 [] = {0x7F, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x11, 0x40, 0x12, 0x20, 0x6C, 0x20, 0x00, 0x00 }; /*9876*/
const unsigned char  uc2_9877 [] = {0x47, 0xF0, 0x40, 0x80, 0x43, 0xE0, 0x7A, 0x20, 0x42, 0xA0, 0x42, 0xA0, 0x42, 0xA0, 0x4A, 0xA0, 0x70, 0xC0, 0x41, 0x20, 0x06, 0x20, 0x00, 0x00 }; /*9877*/
const unsigned char  uc2_9878 [] = {0x3F, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x7E, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x10, 0xC0, 0x11, 0x20, 0x16, 0x20, 0x00, 0x00 }; /*9878*/
const unsigned char  uc2_9879 [] = {0x07, 0xF0, 0x38, 0x80, 0x13, 0xE0, 0x12, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1E, 0xA0, 0x60, 0xC0, 0x01, 0x20, 0x06, 0x20, 0x00, 0x00 }; /*9879*/
const unsigned char  uc2_987A [] = {0x23, 0xF0, 0x2A, 0x80, 0x2B, 0xE0, 0x2A, 0x20, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xC0, 0x41, 0x20, 0x46, 0x20, 0x00, 0x00 }; /*987A*/
const unsigned char  uc2_987B [] = {0x07, 0xF0, 0x18, 0x80, 0x63, 0xE0, 0x06, 0x20, 0x1A, 0xA0, 0x62, 0xA0, 0x06, 0xA0, 0x1A, 0xA0, 0x60, 0xC0, 0x01, 0x20, 0x0E, 0x20, 0x00, 0x00 }; /*987B*/
const unsigned char  uc2_987C [] = {0x7F, 0xF0, 0x10, 0x80, 0x13, 0xE0, 0x3A, 0x20, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0xA0, 0x1E, 0xA0, 0x60, 0xC0, 0x01, 0x20, 0x0E, 0x20, 0x00, 0x00 }; /*987C*/
const unsigned char  uc2_987D [] = {0x3B, 0xF0, 0x00, 0x80, 0x03, 0xE0, 0x7E, 0x20, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2C, 0xC0, 0x49, 0x20, 0x46, 0x20, 0x00, 0x00 }; /*987D*/
const unsigned char  uc2_987E [] = {0x3F, 0xF0, 0x20, 0x80, 0x2F, 0xE0, 0x2A, 0x20, 0x2A, 0xA0, 0x2A, 0xA0, 0x2E, 0xA0, 0x2A, 0xA0, 0x2C, 0xC0, 0x49, 0x20, 0x46, 0x20, 0x00, 0x00 }; /*987E*/
const unsigned char  uc2_987F [] = {0x11, 0xF0, 0x7C, 0x40, 0x11, 0xF0, 0x55, 0x10, 0x55, 0x50, 0x7D, 0x50, 0x15, 0x50, 0x11, 0x50, 0x14, 0x60, 0x18, 0x90, 0x13, 0x10, 0x00, 0x00 }; /*987F*/
const unsigned char  uc2_9880 [] = {0x0F, 0xF0, 0x30, 0x80, 0x23, 0xE0, 0x22, 0x20, 0x3E, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x28, 0xC0, 0x49, 0x20, 0x4E, 0x20, 0x00, 0x00 }; /*9880*/
const unsigned char  uc2_9881 [] = {0x09, 0xF0, 0x24, 0x40, 0x25, 0xF0, 0x25, 0x10, 0x41, 0x50, 0x3D, 0x50, 0x15, 0x50, 0x15, 0x50, 0x14, 0x60, 0x24, 0x90, 0x5B, 0x10, 0x00, 0x00 }; /*9881*/
const unsigned char  uc2_9882 [] = {0x09, 0xF0, 0x24, 0x40, 0x25, 0xF0, 0x25, 0x10, 0x51, 0x50, 0x11, 0x50, 0x11, 0x50, 0x29, 0x50, 0x2C, 0x60, 0x34, 0x90, 0x03, 0x10, 0x00, 0x00 }; /*9882*/
const unsigned char  uc2_9883 [] = {0x31, 0xF0, 0x08, 0x40, 0x7F, 0xF0, 0x01, 0x10, 0x1D, 0x50, 0x15, 0x50, 0x15, 0x50, 0x17, 0x50, 0x24, 0x60, 0x20, 0x90, 0x43, 0x10, 0x00, 0x00 }; /*9883*/
const unsigned char  uc2_9884 [] = {0x39, 0xF0, 0x08, 0x40, 0x31, 0xF0, 0x09, 0x10, 0x7D, 0x50, 0x15, 0x50, 0x15, 0x50, 0x19, 0x50, 0x10, 0x60, 0x11, 0x90, 0x66, 0x10, 0x00, 0x00 }; /*9884*/
const unsigned char  uc2_9885 [] = {0x11, 0xF0, 0x1C, 0x40, 0x11, 0xF0, 0x3D, 0x10, 0x25, 0x50, 0x3D, 0x50, 0x25, 0x50, 0x21, 0x50, 0x20, 0x60, 0x20, 0x90, 0x43, 0x10, 0x00, 0x00 }; /*9885*/
const unsigned char  uc2_9886 [] = {0x11, 0xF0, 0x18, 0x40, 0x25, 0xF0, 0x55, 0x10, 0x09, 0x50, 0x7D, 0x50, 0x05, 0x50, 0x09, 0x50, 0x30, 0x60, 0x08, 0x90, 0x0B, 0x10, 0x00, 0x00 }; /*9886*/
const unsigned char  uc2_9887 [] = {0x09, 0xF0, 0x3E, 0x40, 0x2B, 0xF0, 0x2D, 0x10, 0x29, 0x50, 0x3D, 0x50, 0x25, 0x50, 0x35, 0x50, 0x28, 0x60, 0x34, 0x90, 0x47, 0x10, 0x00, 0x00 }; /*9887*/
const unsigned char  uc2_9888 [] = {0x7F, 0xF0, 0x08, 0x40, 0x19, 0xF0, 0x65, 0x10, 0x05, 0x50, 0x7D, 0x50, 0x11, 0x50, 0x11, 0x50, 0x1E, 0x60, 0x60, 0x90, 0x03, 0x10, 0x00, 0x00 }; /*9888*/
const unsigned char  uc2_9889 [] = {0x13, 0xE0, 0x7C, 0x80, 0x13, 0xE0, 0x3A, 0x20, 0x02, 0xA0, 0x3A, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x38, 0xC0, 0x21, 0x20, 0x06, 0x20, 0x00, 0x00 }; /*9889*/
const unsigned char  uc2_988A [] = {0x09, 0xF0, 0x3E, 0x40, 0x29, 0xF0, 0x1B, 0x10, 0x15, 0x50, 0x7F, 0x50, 0x09, 0x50, 0x0D, 0x50, 0x0A, 0x60, 0x12, 0x90, 0x63, 0x10, 0x00, 0x00 }; /*988A*/
const unsigned char  uc2_988C [] = {0x11, 0xF0, 0x18, 0x40, 0x25, 0xF0, 0x45, 0x10, 0x3D, 0x50, 0x01, 0x50, 0x3D, 0x50, 0x25, 0x50, 0x24, 0x60, 0x3C, 0x90, 0x23, 0x10, 0x00, 0x00 }; /*988C*/
const unsigned char  uc2_988D [] = {0x29, 0xF0, 0x30, 0x40, 0x25, 0xF0, 0x19, 0x10, 0x0B, 0x50, 0x6D, 0x50, 0x29, 0x50, 0x2D, 0x50, 0x2A, 0x60, 0x48, 0x90, 0x33, 0x10, 0x00, 0x00 }; /*988D*/
const unsigned char  uc2_988F [] = {0x31, 0xF0, 0x08, 0x40, 0x7F, 0xF0, 0x25, 0x10, 0x79, 0x50, 0x09, 0x50, 0x15, 0x50, 0x65, 0x50, 0x08, 0x60, 0x14, 0x90, 0x67, 0x10, 0x00, 0x00 }; /*988F*/
const unsigned char  uc2_9890 [] = {0x7F, 0xF0, 0x48, 0x40, 0x49, 0xF0, 0x5D, 0x10, 0x55, 0x50, 0x55, 0x50, 0x5D, 0x50, 0x49, 0x50, 0x48, 0x60, 0x7C, 0x90, 0x03, 0x10, 0x00, 0x00 }; /*9890*/
const unsigned char  uc2_9891 [] = {0x09, 0xF0, 0x2E, 0x40, 0x29, 0xF0, 0x7F, 0x10, 0x01, 0x50, 0x09, 0x50, 0x29, 0x50, 0x2A, 0x50, 0x44, 0x60, 0x18, 0x90, 0x63, 0x10, 0x00, 0x00 }; /*9891*/
const unsigned char  uc2_9893 [] = {0x05, 0xF0, 0x38, 0x80, 0x09, 0xF0, 0x7F, 0x10, 0x2B, 0x50, 0x49, 0x50, 0x1D, 0x50, 0x15, 0x50, 0x16, 0x60, 0x14, 0x90, 0x63, 0x10, 0x00, 0x00 }; /*9893*/
const unsigned char  uc2_9894 [] = {0x11, 0xF0, 0x18, 0x40, 0x25, 0xF0, 0x55, 0x10, 0x09, 0x50, 0x7D, 0x50, 0x09, 0x50, 0x7D, 0x50, 0x44, 0xA0, 0x7C, 0x90, 0x45, 0x10, 0x00, 0x00 }; /*9894*/
const unsigned char  uc2_9896 [] = {0x25, 0xF0, 0x38, 0x40, 0x23, 0xF0, 0x1D, 0x10, 0x03, 0x50, 0x3D, 0x50, 0x09, 0x50, 0x7F, 0x50, 0x2A, 0x60, 0x29, 0x90, 0x4B, 0x10, 0x00, 0x00 }; /*9896*/
const unsigned char  uc2_9897 [] = {0x7D, 0xF0, 0x54, 0x40, 0x7D, 0xF0, 0x55, 0x10, 0x7D, 0x50, 0x11, 0x50, 0x7D, 0x50, 0x11, 0x50, 0x38, 0x60, 0x54, 0x90, 0x13, 0x10, 0x00, 0x00 }; /*9897*/
const unsigned char  uc2_9898 [] = {0x3D, 0xF0, 0x24, 0x40, 0x3D, 0xF0, 0x25, 0x10, 0x7F, 0x50, 0x09, 0x50, 0x2F, 0x50, 0x28, 0xA0, 0x3B, 0x10, 0x26, 0x10, 0x41, 0xF0, 0x00, 0x00 }; /*9898*/
const unsigned char  uc2_989A [] = {0x6D, 0xF0, 0x54, 0x40, 0x6D, 0xF0, 0x01, 0x10, 0x39, 0x50, 0x01, 0x50, 0x7D, 0x50, 0x21, 0x50, 0x3C, 0x60, 0x04, 0x90, 0x1B, 0x10, 0x00, 0x00 }; /*989A*/
const unsigned char  uc2_989B [] = {0x09, 0xF0, 0x49, 0x40, 0x7F, 0xF0, 0x01, 0x10, 0x7F, 0x50, 0x11, 0x50, 0x7F, 0x50, 0x55, 0x50, 0x55, 0x60, 0x51, 0x90, 0x46, 0x10, 0x00, 0x00 }; /*989B*/
const unsigned char  uc2_989C [] = {0x09, 0xF0, 0x3E, 0x40, 0x15, 0xF0, 0x2B, 0x10, 0x3D, 0x50, 0x29, 0x50, 0x35, 0x50, 0x29, 0x50, 0x32, 0x60, 0x24, 0x90, 0x5B, 0x10, 0x00, 0x00 }; /*989C*/
const unsigned char  uc2_989D [] = {0x11, 0xF0, 0x7E, 0x40, 0x53, 0xF0, 0x1D, 0x10, 0x65, 0x50, 0x19, 0x50, 0x65, 0x50, 0x3D, 0x50, 0x24, 0x60, 0x3C, 0x90, 0x27, 0x10, 0x00, 0x00 }; /*989D*/
const unsigned char  uc2_989E [] = {0x7F, 0xF0, 0x24, 0x40, 0x3C, 0x80, 0x25, 0xF0, 0x7F, 0x10, 0x05, 0x50, 0x7F, 0x50, 0x12, 0x50, 0x5A, 0x40, 0x24, 0xA0, 0x5B, 0x10, 0x00, 0x00 }; /*989E*/
const unsigned char  uc2_989F [] = {0x25, 0xF0, 0x7E, 0x40, 0x24, 0x80, 0x01, 0xF0, 0x7F, 0x10, 0x15, 0x50, 0x7F, 0x50, 0x55, 0x50, 0x6B, 0x50, 0x41, 0x60, 0x46, 0x90, 0x00, 0x00 }; /*989F*/
const unsigned char  uc2_98A0 [] = {0x08, 0x00, 0x09, 0xF0, 0x7E, 0x40, 0x10, 0x80, 0x3D, 0xF0, 0x25, 0x10, 0x3D, 0x50, 0x25, 0x50, 0x7F, 0x50, 0x24, 0xA0, 0x43, 0x10, 0x00, 0x00 }; /*98A0*/
const unsigned char  uc2_98A1 [] = {0x1D, 0xF0, 0x14, 0x40, 0x09, 0xF0, 0x15, 0x10, 0x3D, 0x50, 0x2B, 0x50, 0x15, 0x50, 0x2B, 0x50, 0x7D, 0x60, 0x2A, 0x90, 0x49, 0x10, 0x00, 0x00 }; /*98A1*/
const unsigned char  uc2_98A2 [] = {0x3D, 0xF0, 0x24, 0x40, 0x3D, 0xF0, 0x25, 0x10, 0x7F, 0x50, 0x25, 0x50, 0x3D, 0x50, 0x09, 0x50, 0x2C, 0x60, 0x2A, 0x90, 0x53, 0x10, 0x00, 0x00 }; /*98A2*/
const unsigned char  uc2_98A4 [] = {0x09, 0xF0, 0x7E, 0x40, 0x2B, 0xF0, 0x2D, 0x10, 0x21, 0x50, 0x3F, 0x50, 0x15, 0x50, 0x1D, 0x50, 0x14, 0x60, 0x1E, 0x90, 0x63, 0x10, 0x00, 0x00 }; /*98A4*/
const unsigned char  uc2_98A5 [] = {0x7F, 0xF0, 0x08, 0x40, 0x7F, 0xF0, 0x49, 0x10, 0x2B, 0x50, 0x7F, 0x50, 0x09, 0x50, 0x7F, 0x50, 0x55, 0x60, 0x55, 0x90, 0x42, 0x10, 0x00, 0x00 }; /*98A5*/
const unsigned char  uc2_98A6 [] = {0x2D, 0xF0, 0x28, 0x40, 0x7F, 0xF0, 0x09, 0x10, 0x2C, 0x40, 0x71, 0xB0, 0x04, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x02, 0x00, 0x00, 0x00 }; /*98A6*/
const unsigned char  uc2_98A7 [] = {0x15, 0xF0, 0x3E, 0x40, 0x15, 0xF0, 0x2B, 0x10, 0x3D, 0x50, 0x29, 0x50, 0x7F, 0x50, 0x29, 0x50, 0x3E, 0x60, 0x28, 0x90, 0x3F, 0x10, 0x00, 0x00 }; /*98A7*/
const unsigned char  uc2_98CE [] = {0x3F, 0xC0, 0x20, 0x40, 0x39, 0x40, 0x25, 0x40, 0x22, 0x40, 0x22, 0x40, 0x25, 0x40, 0x39, 0x50, 0x20, 0x50, 0x20, 0x30, 0x40, 0x10, 0x00, 0x00 }; /*98CE*/
const unsigned char  uc2_98D1 [] = {0x3E, 0x00, 0x23, 0xE0, 0x22, 0x20, 0x37, 0xA0, 0x2A, 0xA0, 0x2B, 0x20, 0x2A, 0xC0, 0x36, 0x20, 0x23, 0xD0, 0x21, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*98D1*/
const unsigned char  uc2_98D2 [] = {0x47, 0xC0, 0x24, 0x40, 0x74, 0x40, 0x06, 0xC0, 0x55, 0x40, 0x55, 0x40, 0x25, 0x40, 0x36, 0xD0, 0x44, 0x50, 0x08, 0x30, 0x10, 0x10, 0x00, 0x00 }; /*98D2*/
const unsigned char  uc2_98D3 [] = {0x3E, 0xE0, 0x22, 0xA0, 0x22, 0xE0, 0x36, 0xA0, 0x2A, 0xE0, 0x2A, 0xA0, 0x2B, 0xF0, 0x36, 0xA0, 0x23, 0x10, 0x22, 0x00, 0x41, 0xF0, 0x00, 0x00 }; /*98D3*/
const unsigned char  uc2_98D5 [] = {0x7C, 0x80, 0x46, 0xB0, 0x44, 0x90, 0x6E, 0xB0, 0x54, 0x90, 0x57, 0xF0, 0x55, 0x20, 0x6C, 0xC0, 0x45, 0x30, 0x42, 0x10, 0x41, 0xF0, 0x00, 0x00 }; /*98D5*/
const unsigned char  uc2_98D8 [] = {0x7D, 0xF0, 0x29, 0x10, 0x7D, 0x10, 0x55, 0xB0, 0x7D, 0x50, 0x01, 0x50, 0x39, 0x50, 0x01, 0xB0, 0x7D, 0x10, 0x11, 0x10, 0x55, 0x10, 0x00, 0x00 }; /*98D8*/
const unsigned char  uc2_98D9 [] = {0x17, 0xE0, 0x7E, 0x20, 0x12, 0x20, 0x6F, 0x60, 0x02, 0xA0, 0x2A, 0xA0, 0x2A, 0xA0, 0x7F, 0x60, 0x2A, 0x20, 0x2A, 0x20, 0x54, 0x10, 0x00, 0x00 }; /*98D9*/
const unsigned char  uc2_98DA [] = {0x3E, 0xD0, 0x23, 0x50, 0x22, 0x60, 0x37, 0x90, 0x2A, 0x10, 0x2A, 0xA0, 0x2B, 0x50, 0x36, 0xA0, 0x23, 0x50, 0x41, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*98DA*/
const unsigned char  uc2_98DE [] = {0x7F, 0x20, 0x01, 0x20, 0x01, 0x40, 0x01, 0x80, 0x01, 0x40, 0x01, 0x20, 0x01, 0x20, 0x01, 0x00, 0x00, 0x90, 0x00, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*98DE*/
const unsigned char  uc2_98DF [] = {0x03, 0x00, 0x0C, 0xC0, 0x72, 0x30, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xD0, 0x10, 0xA0, 0x13, 0x60, 0x1C, 0x10, 0x00, 0x00 }; /*98DF*/
const unsigned char  uc2_98E7 [] = {0x10, 0x40, 0x10, 0xA0, 0x1F, 0x50, 0x15, 0xE0, 0x15, 0x20, 0x15, 0xE0, 0x6D, 0x20, 0x09, 0xE0, 0x09, 0x10, 0x11, 0x60, 0x61, 0x90, 0x00, 0x00 }; /*98E7*/
const unsigned char  uc2_98E8 [] = {0x10, 0x40, 0x10, 0xA0, 0x27, 0x50, 0x49, 0xE0, 0x71, 0x20, 0x15, 0xE0, 0x25, 0x20, 0x79, 0xE0, 0x09, 0x10, 0x11, 0x60, 0x61, 0x90, 0x00, 0x00 }; /*98E8*/
const unsigned char  uc2_990D [] = {0x3F, 0xF0, 0x21, 0x40, 0x3F, 0xF0, 0x24, 0x20, 0x2B, 0x90, 0x2D, 0x60, 0x37, 0xD0, 0x24, 0x40, 0x27, 0xD0, 0x44, 0x60, 0x47, 0x10, 0x00, 0x00 }; /*990D*/
const unsigned char  uc2_9910 [] = {0x0D, 0xE0, 0x28, 0x20, 0x3D, 0xA0, 0x54, 0x40, 0x1F, 0xA0, 0x6A, 0x40, 0x1F, 0xB0, 0x68, 0x80, 0x0F, 0xA0, 0x08, 0xC0, 0x0C, 0x20, 0x00, 0x00 }; /*9910*/
const unsigned char  uc2_992E [] = {0x7C, 0x40, 0x11, 0xB0, 0x3C, 0x40, 0x65, 0xA0, 0x1A, 0x40, 0x6F, 0x80, 0x18, 0xC0, 0x6F, 0xB0, 0x08, 0x40, 0x0B, 0x80, 0x0C, 0x60, 0x00, 0x00 }; /*992E*/
const unsigned char  uc2_9954 [] = {0x02, 0x00, 0x7F, 0xF0, 0x11, 0x40, 0x2B, 0xF0, 0x75, 0x40, 0x2B, 0xF0, 0x75, 0x40, 0x12, 0xF0, 0x7F, 0xA0, 0x12, 0x40, 0x1C, 0x20, 0x00, 0x00 }; /*9954*/
const unsigned char  uc2_9955 [] = {0x38, 0x70, 0x28, 0x40, 0x7D, 0xF0, 0x11, 0x50, 0x39, 0xE0, 0x0A, 0xB0, 0x1F, 0xC0, 0x68, 0xB0, 0x0F, 0xA0, 0x08, 0xC0, 0x0C, 0x20, 0x00, 0x00 }; /*9955*/
const unsigned char  uc2_9965 [] = {0x10, 0x00, 0x1D, 0xC0, 0x25, 0x40, 0x29, 0x40, 0x51, 0x40, 0x11, 0x40, 0x11, 0x40, 0x11, 0x50, 0x16, 0x50, 0x1A, 0x50, 0x14, 0x20, 0x00, 0x00 }; /*9965*/
const unsigned char  uc2_9967 [] = {0x13, 0xC0, 0x1C, 0x40, 0x24, 0x80, 0x29, 0x00, 0x57, 0xF0, 0x11, 0x50, 0x16, 0x50, 0x11, 0x90, 0x16, 0x10, 0x18, 0x20, 0x11, 0xC0, 0x00, 0x00 }; /*9967*/
const unsigned char  uc2_9968 [] = {0x10, 0x80, 0x1F, 0xF0, 0x24, 0x80, 0x2A, 0xA0, 0x52, 0xA0, 0x12, 0xA0, 0x13, 0xE0, 0x10, 0xA0, 0x14, 0x90, 0x18, 0x90, 0x10, 0x60, 0x00, 0x00 }; /*9968*/
const unsigned char  uc2_9969 [] = {0x11, 0x00, 0x1D, 0xF0, 0x25, 0x00, 0x2A, 0xE0, 0x50, 0x00, 0x13, 0xC0, 0x10, 0x40, 0x10, 0x50, 0x14, 0x50, 0x18, 0x20, 0x10, 0x20, 0x00, 0x00 }; /*9969*/
const unsigned char  uc2_996A [] = {0x10, 0x60, 0x1F, 0x80, 0x24, 0x80, 0x28, 0x80, 0x50, 0x80, 0x17, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x18, 0x80, 0x13, 0xE0, 0x00, 0x00 }; /*996A*/
const unsigned char  uc2_996B [] = {0x10, 0x60, 0x1F, 0x80, 0x24, 0x80, 0x28, 0x80, 0x57, 0xF0, 0x10, 0x80, 0x10, 0x80, 0x11, 0x40, 0x15, 0x40, 0x1A, 0x20, 0x14, 0x10, 0x00, 0x00 }; /*996B*/
const unsigned char  uc2_996C [] = {0x11, 0x00, 0x1D, 0xF0, 0x25, 0x00, 0x29, 0x40, 0x52, 0x40, 0x11, 0xF0, 0x10, 0x50, 0x10, 0x90, 0x14, 0x90, 0x19, 0x10, 0x12, 0x60, 0x00, 0x00 }; /*996C*/
const unsigned char  uc2_996D [] = {0x10, 0x30, 0x1D, 0xC0, 0x26, 0x00, 0x2A, 0x00, 0x53, 0xE0, 0x12, 0xA0, 0x12, 0xA0, 0x12, 0x40, 0x16, 0x40, 0x1A, 0xA0, 0x15, 0x10, 0x00, 0x00 }; /*996D*/
const unsigned char  uc2_996E [] = {0x11, 0x00, 0x1D, 0xE0, 0x25, 0x20, 0x2A, 0x20, 0x50, 0xC0, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*996E*/
const unsigned char  uc2_996F [] = {0x10, 0xC0, 0x1C, 0xA0, 0x27, 0xF0, 0x28, 0x80, 0x50, 0xB0, 0x13, 0xC0, 0x10, 0x90, 0x10, 0xA0, 0x14, 0xD0, 0x1B, 0x50, 0x10, 0x20, 0x00, 0x00 }; /*996F*/
const unsigned char  uc2_9970 [] = {0x11, 0x00, 0x1D, 0xF0, 0x25, 0x00, 0x2A, 0x40, 0x51, 0xF0, 0x11, 0x50, 0x11, 0x50, 0x11, 0x50, 0x15, 0x60, 0x18, 0x40, 0x10, 0x40, 0x00, 0x00 }; /*9970*/
const unsigned char  uc2_9971 [] = {0x11, 0x00, 0x1D, 0xE0, 0x22, 0x20, 0x27, 0xA0, 0x5A, 0xA0, 0x12, 0xA0, 0x13, 0xA0, 0x12, 0x20, 0x16, 0xD0, 0x1A, 0x10, 0x11, 0xE0, 0x00, 0x00 }; /*9971*/
const unsigned char  uc2_9972 [] = {0x10, 0x00, 0x1F, 0xF0, 0x24, 0x10, 0x2B, 0xD0, 0x50, 0x10, 0x13, 0xD0, 0x12, 0x50, 0x13, 0xD0, 0x16, 0x50, 0x18, 0x10, 0x10, 0x60, 0x00, 0x00 }; /*9972*/
const unsigned char  uc2_9974 [] = {0x10, 0x80, 0x1C, 0x80, 0x25, 0x20, 0x29, 0x70, 0x53, 0x90, 0x10, 0x00, 0x11, 0xE0, 0x11, 0x20, 0x15, 0x20, 0x19, 0xE0, 0x11, 0x20, 0x00, 0x00 }; /*9974*/
const unsigned char  uc2_9975 [] = {0x13, 0xF0, 0x1D, 0x20, 0x25, 0x20, 0x29, 0xE0, 0x51, 0x20, 0x11, 0x20, 0x11, 0xE0, 0x11, 0x20, 0x15, 0x70, 0x1B, 0xA0, 0x10, 0x20, 0x00, 0x00 }; /*9975*/
const unsigned char  uc2_9976 [] = {0x11, 0x60, 0x1F, 0x80, 0x25, 0x60, 0x28, 0x90, 0x57, 0x60, 0x10, 0x00, 0x17, 0xF0, 0x11, 0x40, 0x15, 0x50, 0x19, 0x50, 0x16, 0x20, 0x00, 0x00 }; /*9976*/
const unsigned char  uc2_9977 [] = {0x10, 0x40, 0x1C, 0x80, 0x25, 0xF0, 0x29, 0x10, 0x51, 0xD0, 0x11, 0x50, 0x11, 0x50, 0x11, 0x50, 0x15, 0xD0, 0x19, 0x10, 0x11, 0x60, 0x00, 0x00 }; /*9977*/
const unsigned char  uc2_997A [] = {0x10, 0x40, 0x1F, 0xF0, 0x24, 0xA0, 0x28, 0x90, 0x53, 0x10, 0x10, 0xA0, 0x10, 0xA0, 0x10, 0x40, 0x14, 0xA0, 0x18, 0xA0, 0x13, 0x10, 0x00, 0x00 }; /*997A*/
const unsigned char  uc2_997C [] = {0x12, 0x20, 0x1D, 0x40, 0x27, 0xE0, 0x29, 0x40, 0x51, 0x40, 0x17, 0xF0, 0x11, 0x40, 0x11, 0x40, 0x16, 0x40, 0x1A, 0x40, 0x14, 0x40, 0x00, 0x00 }; /*997C*/
const unsigned char  uc2_997D [] = {0x10, 0x80, 0x1F, 0xE0, 0x24, 0x80, 0x2F, 0xF0, 0x54, 0x10, 0x13, 0xE0, 0x10, 0x40, 0x13, 0xE0, 0x14, 0x80, 0x18, 0x80, 0x13, 0x00, 0x00, 0x00 }; /*997D*/
const unsigned char  uc2_997F [] = {0x10, 0xC0, 0x1F, 0x60, 0x25, 0x50, 0x2B, 0xF0, 0x51, 0x40, 0x11, 0x40, 0x11, 0xD0, 0x13, 0x50, 0x15, 0x60, 0x19, 0x50, 0x12, 0xB0, 0x00, 0x00 }; /*997F*/
const unsigned char  uc2_9980 [] = {0x10, 0x80, 0x1D, 0x40, 0x26, 0x30, 0x28, 0x00, 0x53, 0xE0, 0x10, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x12, 0x90, 0x1C, 0x90, 0x13, 0x00, 0x00, 0x00 }; /*9980*/
const unsigned char  uc2_9981 [] = {0x10, 0x30, 0x1D, 0xD0, 0x25, 0x50, 0x28, 0xA0, 0x50, 0x40, 0x13, 0xF0, 0x10, 0xA0, 0x11, 0xA0, 0x14, 0x40, 0x18, 0xA0, 0x13, 0x20, 0x00, 0x00 }; /*9981*/
const unsigned char  uc2_9984 [] = {0x11, 0xE0, 0x1D, 0x20, 0x25, 0xE0, 0x29, 0x20, 0x51, 0xE0, 0x11, 0x40, 0x11, 0x50, 0x11, 0xE0, 0x15, 0x50, 0x19, 0x50, 0x11, 0xA0, 0x00, 0x00 }; /*9984*/
const unsigned char  uc2_9985 [] = {0x11, 0x00, 0x1D, 0xE0, 0x25, 0x20, 0x2E, 0x40, 0x50, 0x80, 0x13, 0x30, 0x12, 0x10, 0x13, 0x30, 0x16, 0x10, 0x1B, 0xF0, 0x12, 0x10, 0x00, 0x00 }; /*9985*/
const unsigned char  uc2_9986 [] = {0x10, 0x80, 0x1B, 0xF0, 0x26, 0x10, 0x29, 0xE0, 0x51, 0x20, 0x11, 0xE0, 0x11, 0x00, 0x11, 0xF0, 0x15, 0x10, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*9986*/
const unsigned char  uc2_9987 [] = {0x10, 0x80, 0x1F, 0xF0, 0x25, 0x40, 0x2E, 0xB0, 0x53, 0xE0, 0x12, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x17, 0xE0, 0x18, 0x00, 0x17, 0xF0, 0x00, 0x00 }; /*9987*/
const unsigned char  uc2_9988 [] = {0x10, 0x80, 0x1B, 0xE0, 0x26, 0xA0, 0x2B, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x12, 0xA0, 0x16, 0xA0, 0x19, 0x60, 0x16, 0x10, 0x00, 0x00 }; /*9988*/
const unsigned char  uc2_998A [] = {0x22, 0x80, 0x34, 0xB0, 0x54, 0x90, 0x46, 0xB0, 0x24, 0x90, 0x27, 0xF0, 0x20, 0x80, 0x27, 0xE0, 0x2A, 0x20, 0x31, 0xC0, 0x26, 0x30, 0x00, 0x00 }; /*998A*/
const unsigned char  uc2_998B [] = {0x11, 0xC0, 0x1A, 0x40, 0x27, 0xE0, 0x2A, 0xA0, 0x53, 0xE0, 0x10, 0x90, 0x13, 0x70, 0x10, 0xC0, 0x14, 0x20, 0x19, 0x80, 0x10, 0x40, 0x00, 0x00 }; /*998B*/
const unsigned char  uc2_998D [] = {0x11, 0x40, 0x1F, 0xF0, 0x25, 0x40, 0x2B, 0xE0, 0x52, 0x20, 0x13, 0xE0, 0x12, 0x20, 0x17, 0xF0, 0x14, 0x80, 0x19, 0x40, 0x16, 0x30, 0x00, 0x00 }; /*998D*/
const unsigned char  uc2_998F [] = {0x11, 0xB0, 0x1D, 0x50, 0x25, 0x50, 0x29, 0xD0, 0x51, 0x20, 0x11, 0xF0, 0x11, 0x50, 0x11, 0xF0, 0x15, 0x50, 0x19, 0xF0, 0x11, 0x10, 0x00, 0x00 }; /*998F*/
const unsigned char  uc2_9990 [] = {0x11, 0x40, 0x1F, 0xF0, 0x24, 0x80, 0x2B, 0xE0, 0x50, 0x80, 0x17, 0xF0, 0x12, 0xA0, 0x13, 0xE0, 0x15, 0x20, 0x19, 0x20, 0x17, 0xF0, 0x00, 0x00 }; /*9990*/
const unsigned char  uc2_9991 [] = {0x11, 0x40, 0x1F, 0xF0, 0x25, 0x40, 0x2B, 0xE0, 0x52, 0xA0, 0x12, 0xA0, 0x17, 0xF0, 0x10, 0x80, 0x17, 0xE0, 0x18, 0x80, 0x17, 0xF0, 0x00, 0x00 }; /*9991*/
const unsigned char  uc2_9992 [] = {0x13, 0xE0, 0x1A, 0x20, 0x27, 0xE0, 0x2A, 0x20, 0x57, 0xF0, 0x15, 0x50, 0x15, 0x50, 0x17, 0xF0, 0x11, 0x20, 0x14, 0xC0, 0x1B, 0x30, 0x00, 0x00 }; /*9992*/
const unsigned char  uc2_9993 [] = {0x12, 0xA0, 0x1F, 0xE0, 0x2A, 0xB0, 0x2F, 0xD0, 0x51, 0x50, 0x12, 0xD0, 0x13, 0xA0, 0x12, 0xA0, 0x17, 0xA0, 0x1A, 0xD0, 0x13, 0x50, 0x00, 0x00 }; /*9993*/
const unsigned char  uc2_9994 [] = {0x13, 0x60, 0x1A, 0xA0, 0x27, 0xC0, 0x2A, 0xA0, 0x51, 0x40, 0x11, 0x40, 0x13, 0xE0, 0x11, 0x40, 0x17, 0xF0, 0x19, 0x40, 0x16, 0x20, 0x00, 0x00 }; /*9994*/
const unsigned char  uc2_9995 [] = {0x20, 0x80, 0x3F, 0xF0, 0x2A, 0xA0, 0x27, 0xF0, 0x55, 0x50, 0x13, 0xE0, 0x11, 0x40, 0x17, 0xF0, 0x12, 0xA0, 0x16, 0x40, 0x1B, 0x30, 0x00, 0x00 }; /*9995*/
const unsigned char  uc2_9996 [] = {0x08, 0x40, 0x3F, 0xF0, 0x02, 0x00, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x1F, 0xE0, 0x10, 0x20, 0x00, 0x00 }; /*9996*/
const unsigned char  uc2_9997 [] = {0x22, 0x40, 0x27, 0xE0, 0x79, 0x00, 0x2B, 0xC0, 0x2A, 0x40, 0x2B, 0xC0, 0x2A, 0x40, 0x2B, 0xC0, 0x2A, 0x50, 0x2A, 0x50, 0x47, 0xE0, 0x00, 0x00 }; /*9997*/
const unsigned char  uc2_9998 [] = {0x28, 0xC0, 0x7C, 0xA0, 0x13, 0xF0, 0x38, 0x80, 0x2B, 0xA0, 0x3A, 0xA0, 0x2B, 0xA0, 0x38, 0xC0, 0x2F, 0x50, 0x38, 0xD0, 0x23, 0x20, 0x00, 0x00 }; /*9998*/
const unsigned char  uc2_9999 [] = {0x00, 0xE0, 0x3F, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x0A, 0x40, 0x3F, 0xE0, 0x50, 0x50, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00 }; /*9999*/
const unsigned char  uc2_99A5 [] = {0x09, 0x00, 0x31, 0xF0, 0x13, 0x20, 0x7D, 0xE0, 0x29, 0x20, 0x7D, 0xE0, 0x29, 0x00, 0x39, 0xE0, 0x2B, 0x20, 0x38, 0xC0, 0x2B, 0x30, 0x00, 0x00 }; /*99A5*/
const unsigned char  uc2_99A8 [] = {0x08, 0xE0, 0x7E, 0xA0, 0x2B, 0xF0, 0x3E, 0xA0, 0x20, 0x40, 0x5F, 0xB0, 0x02, 0x00, 0x7F, 0xF0, 0x18, 0xC0, 0x68, 0xB0, 0x0F, 0x80, 0x00, 0x00 }; /*99A8*/
const unsigned char  uc2_9A6C [] = {0x3F, 0xC0, 0x00, 0x40, 0x08, 0x40, 0x10, 0x80, 0x1F, 0xF0, 0x00, 0x10, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x10, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*9A6C*/
const unsigned char  uc2_9A6D [] = {0x3D, 0xE0, 0x04, 0xA0, 0x14, 0xA0, 0x28, 0xA0, 0x3E, 0xA0, 0x02, 0xA0, 0x0A, 0x40, 0x72, 0x40, 0x02, 0xA0, 0x04, 0xA0, 0x19, 0x10, 0x00, 0x00 }; /*9A6D*/
const unsigned char  uc2_9A6E [] = {0x78, 0x80, 0x08, 0x80, 0x28, 0x80, 0x53, 0xE0, 0x7C, 0x80, 0x04, 0x80, 0x1D, 0x40, 0x65, 0x40, 0x05, 0x40, 0x0A, 0x20, 0x34, 0x10, 0x00, 0x00 }; /*9A6E*/
const unsigned char  uc2_9A6F [] = {0x79, 0x10, 0x09, 0x50, 0x29, 0x50, 0x51, 0x50, 0x7D, 0x50, 0x05, 0x50, 0x1D, 0x50, 0x65, 0x50, 0x05, 0x50, 0x09, 0x10, 0x32, 0x10, 0x00, 0x00 }; /*9A6F*/
const unsigned char  uc2_9A70 [] = {0x78, 0x40, 0x09, 0x40, 0x29, 0x70, 0x51, 0xD0, 0x7F, 0x50, 0x05, 0x50, 0x1D, 0x60, 0x65, 0x40, 0x05, 0x10, 0x09, 0x10, 0x30, 0xE0, 0x00, 0x00 }; /*9A70*/
const unsigned char  uc2_9A71 [] = {0x79, 0xF0, 0x09, 0x00, 0x29, 0x90, 0x51, 0x50, 0x7D, 0x20, 0x05, 0x20, 0x1D, 0x20, 0x65, 0x50, 0x05, 0x90, 0x09, 0x00, 0x31, 0xF0, 0x00, 0x00 }; /*9A71*/
const unsigned char  uc2_9A73 [] = {0x7B, 0x40, 0x08, 0x80, 0x29, 0x40, 0x52, 0x20, 0x7C, 0x00, 0x05, 0x40, 0x1D, 0x40, 0x65, 0x40, 0x04, 0x80, 0x09, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*9A73*/
const unsigned char  uc2_9A74 [] = {0x79, 0x80, 0x08, 0x40, 0x29, 0xF0, 0x51, 0x10, 0x7D, 0x10, 0x05, 0xF0, 0x1D, 0x00, 0x65, 0x00, 0x05, 0x00, 0x09, 0x00, 0x32, 0x00, 0x00, 0x00 }; /*9A74*/
const unsigned char  uc2_9A75 [] = {0x79, 0xE0, 0x09, 0x20, 0x29, 0x20, 0x51, 0xE0, 0x7D, 0x20, 0x05, 0x20, 0x1D, 0xE0, 0x65, 0x20, 0x05, 0x20, 0x09, 0x20, 0x33, 0xF0, 0x00, 0x00 }; /*9A75*/
const unsigned char  uc2_9A76 [] = {0x78, 0x40, 0x08, 0x40, 0x29, 0xF0, 0x51, 0x50, 0x7D, 0x50, 0x05, 0xF0, 0x1C, 0x40, 0x65, 0x40, 0x04, 0x80, 0x09, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*9A76*/
const unsigned char  uc2_9A77 [] = {0x77, 0xF0, 0x0D, 0x50, 0x2D, 0x50, 0x55, 0x50, 0x7D, 0x50, 0x05, 0x50, 0x1E, 0x30, 0x64, 0x10, 0x04, 0x10, 0x0F, 0xF0, 0x34, 0x10, 0x00, 0x00 }; /*9A77*/
const unsigned char  uc2_9A78 [] = {0x79, 0x20, 0x09, 0x20, 0x29, 0xF0, 0x53, 0x20, 0x7D, 0xA0, 0x05, 0x60, 0x1D, 0x20, 0x65, 0x20, 0x05, 0x20, 0x09, 0x20, 0x31, 0x40, 0x00, 0x00 }; /*9A78*/
const unsigned char  uc2_9A79 [] = {0x79, 0x00, 0x09, 0xF0, 0x2A, 0x10, 0x50, 0x10, 0x7D, 0xD0, 0x05, 0x50, 0x1D, 0x50, 0x65, 0xD0, 0x05, 0x50, 0x08, 0x10, 0x30, 0xE0, 0x00, 0x00 }; /*9A79*/
const unsigned char  uc2_9A7A [] = {0x78, 0x80, 0x08, 0xE0, 0x29, 0x20, 0x52, 0x40, 0x7F, 0xF0, 0x04, 0x10, 0x1D, 0xF0, 0x64, 0x10, 0x04, 0x10, 0x0B, 0xF0, 0x30, 0x10, 0x00, 0x00 }; /*9A7A*/
const unsigned char  uc2_9A7B [] = {0x03, 0x00, 0x78, 0x80, 0x0F, 0xF0, 0x28, 0x80, 0x50, 0x80, 0x7F, 0xE0, 0x04, 0x80, 0x1C, 0x80, 0x64, 0x80, 0x08, 0x80, 0x37, 0xF0, 0x00, 0x00 }; /*9A7B*/
const unsigned char  uc2_9A7C [] = {0x01, 0x80, 0x78, 0x40, 0x0B, 0xF0, 0x2A, 0x10, 0x51, 0x00, 0x7D, 0x20, 0x05, 0xC0, 0x1D, 0x00, 0x65, 0x10, 0x09, 0x10, 0x30, 0xE0, 0x00, 0x00 }; /*9A7C*/
const unsigned char  uc2_9A7D [] = {0x10, 0x00, 0x7D, 0xE0, 0x24, 0xA0, 0x18, 0x40, 0x64, 0xB0, 0x1F, 0xC0, 0x04, 0x40, 0x0F, 0xF0, 0x00, 0x10, 0x3F, 0x90, 0x00, 0xE0, 0x00, 0x00 }; /*9A7D*/
const unsigned char  uc2_9A7E [] = {0x08, 0x00, 0x7E, 0xF0, 0x0A, 0x90, 0x12, 0xF0, 0x64, 0x00, 0x1F, 0xC0, 0x04, 0x40, 0x0F, 0xF0, 0x00, 0x10, 0x3F, 0x90, 0x00, 0xE0, 0x00, 0x00 }; /*9A7E*/
const unsigned char  uc2_9A7F [] = {0x7B, 0xC0, 0x09, 0x40, 0x29, 0x40, 0x50, 0x80, 0x7D, 0x40, 0x06, 0xB0, 0x1C, 0x80, 0x67, 0xE0, 0x04, 0x80, 0x0F, 0xF0, 0x30, 0x80, 0x00, 0x00 }; /*9A7F*/
const unsigned char  uc2_9A80 [] = {0x00, 0x80, 0x78, 0x80, 0x09, 0x20, 0x29, 0x70, 0x53, 0x90, 0x7C, 0x00, 0x05, 0xE0, 0x1D, 0x20, 0x65, 0x20, 0x09, 0xE0, 0x31, 0x20, 0x00, 0x00 }; /*9A80*/
const unsigned char  uc2_9A81 [] = {0x79, 0x60, 0x0B, 0x80, 0x29, 0x60, 0x53, 0x90, 0x7C, 0xE0, 0x04, 0x00, 0x1F, 0xF0, 0x65, 0x40, 0x05, 0x50, 0x09, 0x50, 0x36, 0x20, 0x00, 0x00 }; /*9A81*/
const unsigned char  uc2_9A82 [] = {0x7D, 0xF0, 0x45, 0x10, 0x7D, 0xF0, 0x00, 0x00, 0x3F, 0xC0, 0x08, 0x40, 0x10, 0x80, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9A82*/
const unsigned char  uc2_9A84 [] = {0x00, 0x60, 0x7B, 0x80, 0x08, 0x80, 0x2B, 0xF0, 0x51, 0x40, 0x7E, 0x30, 0x05, 0x40, 0x1D, 0x40, 0x65, 0x40, 0x09, 0x40, 0x32, 0x40, 0x00, 0x00 }; /*9A84*/
const unsigned char  uc2_9A85 [] = {0x79, 0x40, 0x09, 0x50, 0x2E, 0xE0, 0x2A, 0x50, 0x52, 0x50, 0x7E, 0xA0, 0x04, 0x80, 0x1F, 0xF0, 0x64, 0x80, 0x08, 0x80, 0x30, 0x80, 0x00, 0x00 }; /*9A85*/
const unsigned char  uc2_9A86 [] = {0x01, 0x00, 0x79, 0xE0, 0x0B, 0x20, 0x28, 0xC0, 0x53, 0x30, 0x7C, 0x00, 0x05, 0xE0, 0x1D, 0x20, 0x65, 0x20, 0x09, 0xE0, 0x31, 0x20, 0x00, 0x00 }; /*9A86*/
const unsigned char  uc2_9A87 [] = {0x78, 0x40, 0x0B, 0xF0, 0x28, 0x80, 0x51, 0x20, 0x7D, 0xE0, 0x04, 0x50, 0x1C, 0x90, 0x67, 0x20, 0x04, 0x60, 0x08, 0x90, 0x33, 0x10, 0x00, 0x00 }; /*9A87*/
const unsigned char  uc2_9A88 [] = {0x02, 0x20, 0x79, 0x40, 0x0B, 0xE0, 0x29, 0x40, 0x51, 0x40, 0x7F, 0xF0, 0x05, 0x40, 0x1D, 0x40, 0x65, 0x40, 0x09, 0x40, 0x32, 0x40, 0x00, 0x00 }; /*9A88*/
const unsigned char  uc2_9A8A [] = {0x7F, 0xF0, 0x08, 0x00, 0x2F, 0x70, 0x55, 0x50, 0x7D, 0x50, 0x07, 0x70, 0x1D, 0x50, 0x65, 0x50, 0x05, 0x50, 0x0D, 0x50, 0x32, 0x20, 0x00, 0x00 }; /*9A8A*/
const unsigned char  uc2_9A8B [] = {0x00, 0x80, 0x7B, 0xE0, 0x0A, 0xA0, 0x2B, 0xE0, 0x52, 0xA0, 0x7F, 0xF0, 0x09, 0x00, 0x19, 0xE0, 0x68, 0x20, 0x08, 0x20, 0x31, 0xC0, 0x00, 0x00 }; /*9A8B*/
const unsigned char  uc2_9A8C [] = {0x00, 0x80, 0x78, 0x80, 0x09, 0x40, 0x2E, 0x30, 0x51, 0xC0, 0x7C, 0x00, 0x05, 0x20, 0x1E, 0xA0, 0x65, 0x20, 0x08, 0x40, 0x33, 0xF0, 0x00, 0x00 }; /*9A8C*/
const unsigned char  uc2_9A8F [] = {0x79, 0x40, 0x0A, 0x60, 0x2B, 0xA0, 0x51, 0x40, 0x7E, 0x20, 0x05, 0x20, 0x1D, 0xC0, 0x67, 0x40, 0x05, 0x40, 0x08, 0x80, 0x33, 0x70, 0x00, 0x00 }; /*9A8F*/
const unsigned char  uc2_9A90 [] = {0x79, 0x40, 0x0B, 0xE0, 0x29, 0x40, 0x51, 0xC0, 0x7D, 0x40, 0x05, 0xC0, 0x1D, 0x40, 0x67, 0xF0, 0x05, 0x40, 0x09, 0x20, 0x32, 0x20, 0x00, 0x00 }; /*9A90*/
const unsigned char  uc2_9A91 [] = {0x78, 0x80, 0x0B, 0xF0, 0x29, 0x40, 0x52, 0x20, 0x7F, 0xF0, 0x04, 0x20, 0x1D, 0xA0, 0x65, 0x60, 0x05, 0xA0, 0x08, 0x20, 0x30, 0xC0, 0x00, 0x00 }; /*9A91*/
const unsigned char  uc2_9A92 [] = {0x7B, 0xE0, 0x0A, 0xA0, 0x4B, 0xE0, 0x52, 0xA0, 0x7B, 0xE0, 0x08, 0x80, 0x1F, 0xF0, 0x69, 0xC0, 0x0A, 0xA0, 0x0C, 0x90, 0x30, 0x80, 0x00, 0x00 }; /*9A92*/
const unsigned char  uc2_9A93 [] = {0x00, 0x80, 0x79, 0x40, 0x09, 0xF0, 0x2B, 0x40, 0x51, 0xE0, 0x7D, 0x40, 0x05, 0xE0, 0x1D, 0x40, 0x65, 0x40, 0x09, 0xF0, 0x31, 0x00, 0x00, 0x00 }; /*9A93*/
const unsigned char  uc2_9A96 [] = {0x79, 0x40, 0x09, 0xE0, 0x28, 0x80, 0x53, 0xF0, 0x7D, 0x20, 0x06, 0x50, 0x1D, 0xA0, 0x64, 0x40, 0x05, 0x90, 0x08, 0x60, 0x33, 0x80, 0x00, 0x00 }; /*9A96*/
const unsigned char  uc2_9A97 [] = {0x00, 0x80, 0x77, 0xF0, 0x0C, 0x10, 0x2F, 0xF0, 0x54, 0x00, 0x7F, 0xF0, 0x05, 0x50, 0x1F, 0xF0, 0x65, 0x50, 0x0D, 0x10, 0x34, 0x60, 0x00, 0x00 }; /*9A97*/
const unsigned char  uc2_9A98 [] = {0x7A, 0xE0, 0x4A, 0x80, 0x77, 0xF0, 0x4A, 0xA0, 0x74, 0x40, 0x5F, 0xC0, 0x08, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9A98*/
const unsigned char  uc2_9A9A [] = {0x7F, 0xE0, 0x0A, 0xA0, 0x29, 0xC0, 0x56, 0x30, 0x78, 0x80, 0x0B, 0xE0, 0x1A, 0xA0, 0x6B, 0xE0, 0x08, 0xA0, 0x08, 0xF0, 0x37, 0x10, 0x00, 0x00 }; /*9A9A*/
const unsigned char  uc2_9A9B [] = {0x3C, 0x80, 0x14, 0xF0, 0x09, 0xA0, 0x7E, 0x40, 0x2A, 0xB0, 0x5F, 0x80, 0x08, 0x80, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9A9B*/
const unsigned char  uc2_9A9C [] = {0x08, 0x80, 0x3E, 0xF0, 0x09, 0xA0, 0x3E, 0x40, 0x08, 0xB0, 0x7F, 0xC0, 0x14, 0x40, 0x6F, 0xF0, 0x00, 0x10, 0x3F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9A9C*/
const unsigned char  uc2_9A9D [] = {0x7B, 0xB0, 0x0A, 0x50, 0x2A, 0x50, 0x52, 0xD0, 0x7F, 0x20, 0x05, 0xF0, 0x15, 0x50, 0x65, 0xF0, 0x05, 0x50, 0x09, 0xF0, 0x31, 0x10, 0x00, 0x00 }; /*9A9D*/
const unsigned char  uc2_9A9E [] = {0x02, 0x00, 0x3F, 0xE0, 0x25, 0x20, 0x1F, 0xC0, 0x05, 0x00, 0x7F, 0xF0, 0x15, 0x40, 0x6F, 0xB0, 0x00, 0x80, 0x3C, 0x80, 0x03, 0x00, 0x00, 0x00 }; /*9A9E*/
const unsigned char  uc2_9A9F [] = {0x00, 0x80, 0x77, 0xF0, 0x0C, 0x10, 0x2F, 0xF0, 0x54, 0x00, 0x7F, 0xF0, 0x04, 0x90, 0x1E, 0xD0, 0x65, 0xB0, 0x06, 0xD0, 0x39, 0x20, 0x00, 0x00 }; /*9A9F*/
const unsigned char  uc2_9AA0 [] = {0x7F, 0xF0, 0x09, 0x40, 0x2F, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x08, 0x00, 0x1B, 0xE0, 0x68, 0x00, 0x0F, 0xF0, 0x0A, 0xA0, 0x35, 0x10, 0x00, 0x00 }; /*9AA0*/
const unsigned char  uc2_9AA1 [] = {0x79, 0xF0, 0x09, 0x50, 0x29, 0xF0, 0x51, 0x50, 0x7D, 0xF0, 0x04, 0xA0, 0x1D, 0xF0, 0x64, 0x90, 0x05, 0xE0, 0x09, 0x50, 0x32, 0x90, 0x00, 0x00 }; /*9AA1*/
const unsigned char  uc2_9AA2 [] = {0x78, 0x80, 0x0B, 0xF0, 0x2A, 0xD0, 0x53, 0x50, 0x7A, 0xD0, 0x0B, 0x30, 0x1B, 0xF0, 0x68, 0x80, 0x0B, 0x50, 0x0D, 0x20, 0x31, 0xE0, 0x00, 0x00 }; /*9AA2*/
const unsigned char  uc2_9AA3 [] = {0x7B, 0xF0, 0x0A, 0x10, 0x2B, 0xF0, 0x52, 0x20, 0x7B, 0xF0, 0x0A, 0x40, 0x1B, 0xF0, 0x6A, 0xA0, 0x0B, 0xF0, 0x0A, 0xA0, 0x35, 0x40, 0x00, 0x00 }; /*9AA3*/
const unsigned char  uc2_9AA4 [] = {0x7F, 0xC0, 0x0A, 0xB0, 0x2B, 0xD0, 0x52, 0xA0, 0x7B, 0xD0, 0x0A, 0xA0, 0x1F, 0xC0, 0x69, 0x80, 0x0E, 0xD0, 0x09, 0xA0, 0x36, 0x90, 0x00, 0x00 }; /*9AA4*/
const unsigned char  uc2_9AA5 [] = {0x01, 0x40, 0x7F, 0x50, 0x0B, 0xE0, 0x2E, 0xB0, 0x53, 0xE0, 0x7A, 0xA0, 0x0B, 0xE0, 0x19, 0x40, 0x6F, 0xF0, 0x09, 0x20, 0x36, 0x10, 0x00, 0x00 }; /*9AA5*/
const unsigned char  uc2_9AA7 [] = {0x00, 0x80, 0x7F, 0xF0, 0x0A, 0xA0, 0x29, 0x40, 0x53, 0xE0, 0x79, 0x40, 0x0B, 0xE0, 0x19, 0x40, 0x6F, 0xF0, 0x0A, 0xA0, 0x35, 0x70, 0x00, 0x00 }; /*9AA7*/
const unsigned char  uc2_9AA8 [] = {0x1F, 0xC0, 0x10, 0x40, 0x1E, 0x40, 0x12, 0x40, 0x7F, 0xF0, 0x50, 0x50, 0x5F, 0xD0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x11, 0x80, 0x00, 0x00 }; /*9AA8*/
const unsigned char  uc2_9AB0 [] = {0x39, 0xC0, 0x29, 0x40, 0x39, 0x40, 0x6E, 0x30, 0x54, 0x00, 0x2B, 0xC0, 0x39, 0x40, 0x29, 0x40, 0x38, 0x80, 0x29, 0x40, 0x36, 0x30, 0x00, 0x00 }; /*9AB0*/
const unsigned char  uc2_9AB1 [] = {0x38, 0x80, 0x29, 0x40, 0x3A, 0x30, 0x6C, 0x00, 0x55, 0x40, 0x29, 0x40, 0x39, 0x40, 0x29, 0x40, 0x39, 0x40, 0x2A, 0x40, 0x34, 0x40, 0x00, 0x00 }; /*9AB1*/
const unsigned char  uc2_9AB6 [] = {0x38, 0x60, 0x2B, 0x80, 0x3A, 0x80, 0x6A, 0x80, 0x57, 0xE0, 0x2A, 0x80, 0x3A, 0x80, 0x2A, 0x50, 0x3A, 0xD0, 0x2B, 0x30, 0x32, 0x90, 0x00, 0x00 }; /*9AB6*/
const unsigned char  uc2_9AB7 [] = {0x38, 0x80, 0x28, 0x80, 0x38, 0x80, 0x6F, 0xF0, 0x54, 0x80, 0x28, 0x80, 0x3B, 0xE0, 0x2A, 0x20, 0x3A, 0x20, 0x2B, 0xE0, 0x32, 0x20, 0x00, 0x00 }; /*9AB7*/
const unsigned char  uc2_9AB8 [] = {0x38, 0x40, 0x2B, 0xF0, 0x38, 0x80, 0x6D, 0x20, 0x55, 0xE0, 0x28, 0x50, 0x38, 0x90, 0x2B, 0x20, 0x38, 0x60, 0x28, 0x90, 0x33, 0x10, 0x00, 0x00 }; /*9AB8*/
const unsigned char  uc2_9ABA [] = {0x38, 0x60, 0x2B, 0x80, 0x3A, 0x00, 0x6B, 0xF0, 0x56, 0x00, 0x2A, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x3A, 0xA0, 0x2A, 0xE0, 0x34, 0xA0, 0x00, 0x00 }; /*9ABA*/
const unsigned char  uc2_9ABC [] = {0x39, 0x00, 0x29, 0xE0, 0x3B, 0x20, 0x6C, 0xC0, 0x57, 0x30, 0x28, 0x00, 0x39, 0xE0, 0x29, 0x20, 0x39, 0x20, 0x29, 0xE0, 0x31, 0x20, 0x00, 0x00 }; /*9ABC*/
const unsigned char  uc2_9AC0 [] = {0x38, 0x40, 0x28, 0x80, 0x39, 0xF0, 0x6D, 0x50, 0x55, 0xF0, 0x29, 0x50, 0x39, 0xF0, 0x29, 0x40, 0x3B, 0xF0, 0x28, 0x40, 0x30, 0x40, 0x00, 0x00 }; /*9AC0*/
const unsigned char  uc2_9AC1 [] = {0x3B, 0xE0, 0x2A, 0xA0, 0x7F, 0xE0, 0x42, 0xA0, 0x7B, 0xE0, 0x28, 0x80, 0x3F, 0xF0, 0x28, 0xC0, 0x39, 0xA0, 0x2A, 0xA0, 0x2C, 0x90, 0x00, 0x00 }; /*9AC1*/
const unsigned char  uc2_9AC2 [] = {0x38, 0x40, 0x2B, 0xF0, 0x3A, 0x90, 0x6C, 0xE0, 0x57, 0x20, 0x28, 0xC0, 0x3B, 0x30, 0x29, 0xE0, 0x39, 0x20, 0x29, 0xE0, 0x31, 0x20, 0x00, 0x00 }; /*9AC2*/
const unsigned char  uc2_9AC5 [] = {0x3C, 0x90, 0x2A, 0xA0, 0x7F, 0xF0, 0x45, 0xA0, 0x3A, 0x90, 0x2C, 0x80, 0x3B, 0xF0, 0x29, 0x20, 0x39, 0xC0, 0x28, 0x40, 0x33, 0xA0, 0x00, 0x00 }; /*9AC5*/
const unsigned char  uc2_9ACB [] = {0x38, 0x80, 0x2F, 0xF0, 0x35, 0x50, 0x6F, 0xE0, 0x55, 0x40, 0x2B, 0xE0, 0x3A, 0xA0, 0x2A, 0xA0, 0x39, 0x50, 0x29, 0x50, 0x36, 0x20, 0x00, 0x00 }; /*9ACB*/
const unsigned char  uc2_9ACC [] = {0x38, 0x40, 0x2B, 0xF0, 0x3A, 0x50, 0x6F, 0x90, 0x55, 0x00, 0x29, 0xE0, 0x39, 0x40, 0x2B, 0xF0, 0x39, 0x20, 0x29, 0x10, 0x32, 0x10, 0x00, 0x00 }; /*9ACC*/
const unsigned char  uc2_9AD1 [] = {0x3F, 0xE0, 0x2A, 0xA0, 0x3A, 0xA0, 0x6F, 0xF0, 0x55, 0x10, 0x2B, 0xD0, 0x3D, 0x50, 0x2B, 0xD0, 0x39, 0x10, 0x2F, 0x90, 0x30, 0x60, 0x00, 0x00 }; /*9AD1*/
const unsigned char  uc2_9AD3 [] = {0x38, 0x40, 0x2D, 0xF0, 0x3A, 0xA0, 0x6F, 0xF0, 0x52, 0xA0, 0x2A, 0xE0, 0x3A, 0xA0, 0x2A, 0xE0, 0x3A, 0xA0, 0x2A, 0x40, 0x35, 0xF0, 0x00, 0x00 }; /*9AD3*/
const unsigned char  uc2_9AD8 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x00, 0x3F, 0xE0, 0x20, 0x20, 0x2F, 0xA0, 0x28, 0xA0, 0x2F, 0xA0, 0x20, 0xC0, 0x00, 0x00 }; /*9AD8*/
const unsigned char  uc2_9ADF [] = {0x00, 0x10, 0x3E, 0x60, 0x21, 0x80, 0x3C, 0x00, 0x20, 0x10, 0x3C, 0x60, 0x21, 0x80, 0x7E, 0x00, 0x14, 0x10, 0x26, 0x60, 0x7B, 0x80, 0x00, 0x00 }; /*9ADF*/
const unsigned char  uc2_9AE1 [] = {0x3E, 0x60, 0x21, 0x80, 0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x10, 0x24, 0x20, 0x1E, 0xC0, 0x00, 0x00, 0x7F, 0xE0, 0x08, 0x90, 0x70, 0x70, 0x00, 0x00 }; /*9AE1*/
const unsigned char  uc2_9AE6 [] = {0x3E, 0x60, 0x21, 0x80, 0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x10, 0x24, 0xE0, 0x1F, 0x00, 0x04, 0x60, 0x7F, 0x80, 0x04, 0x10, 0x03, 0xF0, 0x00, 0x00 }; /*9AE6*/
const unsigned char  uc2_9AEB [] = {0x3E, 0x60, 0x21, 0x80, 0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x10, 0x24, 0x20, 0x7F, 0xF0, 0x10, 0x10, 0x6F, 0xF0, 0x08, 0x20, 0x0F, 0xE0, 0x00, 0x00 }; /*9AEB*/
const unsigned char  uc2_9AED [] = {0x3E, 0x60, 0x21, 0x80, 0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x30, 0x24, 0xC0, 0x1A, 0x00, 0x09, 0x20, 0x2D, 0xC0, 0x29, 0x10, 0x7E, 0xF0, 0x00, 0x00 }; /*9AED*/
const unsigned char  uc2_9AEF [] = {0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x30, 0x24, 0xC0, 0x4A, 0x30, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xB0, 0x20, 0x60, 0x00, 0x00 }; /*9AEF*/
const unsigned char  uc2_9AF9 [] = {0x3E, 0x60, 0x21, 0x80, 0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x10, 0x24, 0x20, 0x1E, 0xC0, 0x08, 0x80, 0x17, 0xF0, 0x72, 0xA0, 0x14, 0x90, 0x00, 0x00 }; /*9AF9*/
const unsigned char  uc2_9AFB [] = {0x3E, 0x60, 0x21, 0x80, 0x3C, 0x30, 0x20, 0xC0, 0x7F, 0x10, 0x22, 0x60, 0x7F, 0xF0, 0x02, 0x00, 0x3F, 0xE0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*9AFB*/
const unsigned char  uc2_9B03 [] = {0x3E, 0x30, 0x20, 0xC0, 0x7F, 0x30, 0x12, 0x40, 0x7F, 0xF0, 0x40, 0x10, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x26, 0x20, 0x00, 0x00 }; /*9B03*/
const unsigned char  uc2_9B08 [] = {0x3E, 0x30, 0x20, 0xC0, 0x7F, 0x30, 0x12, 0x40, 0x3F, 0xE0, 0x04, 0x00, 0x7F, 0xF0, 0x28, 0xA0, 0x4B, 0x90, 0x08, 0x20, 0x07, 0xE0, 0x00, 0x00 }; /*9B08*/
const unsigned char  uc2_9B0F [] = {0x3C, 0x40, 0x21, 0x90, 0x7E, 0x60, 0x24, 0x10, 0x7E, 0xE0, 0x08, 0x40, 0x7F, 0x50, 0x09, 0x50, 0x1C, 0x40, 0x6A, 0xA0, 0x09, 0x10, 0x00, 0x00 }; /*9B0F*/
const unsigned char  uc2_9B13 [] = {0x1E, 0x20, 0x10, 0xD0, 0x7F, 0x20, 0x12, 0x10, 0x3F, 0xE0, 0x28, 0x20, 0x0F, 0xC0, 0x09, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x20, 0x20, 0x00, 0x00 }; /*9B13*/
const unsigned char  uc2_9B1F [] = {0x3C, 0x30, 0x20, 0xC0, 0x7E, 0x30, 0x24, 0x40, 0x7F, 0xE0, 0x25, 0x20, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x0C, 0xA0, 0x76, 0x70, 0x00, 0x00 }; /*9B1F*/
const unsigned char  uc2_9B23 [] = {0x3E, 0x40, 0x20, 0xA0, 0x7F, 0x50, 0x24, 0xA0, 0x3F, 0xE0, 0x28, 0xA0, 0x27, 0x20, 0x28, 0xA0, 0x3F, 0xE0, 0x22, 0x50, 0x3B, 0xB0, 0x00, 0x00 }; /*9B23*/
const unsigned char  uc2_9B2F [] = {0x5A, 0x90, 0x45, 0x50, 0x73, 0x30, 0x4C, 0x90, 0x46, 0x50, 0x59, 0x50, 0x7F, 0xF0, 0x20, 0x40, 0x3F, 0x90, 0x20, 0x10, 0x1F, 0xE0, 0x00, 0x00 }; /*9B2F*/
const unsigned char  uc2_9B32 [] = {0x7F, 0xF0, 0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0x7F, 0xF0, 0x48, 0x90, 0x5F, 0xD0, 0x42, 0x10, 0x42, 0x60, 0x00, 0x00 }; /*9B32*/
const unsigned char  uc2_9B3B [] = {0x7A, 0xF0, 0x15, 0x10, 0x7F, 0xF0, 0x45, 0x40, 0x7A, 0xF0, 0x1F, 0x90, 0x10, 0x60, 0x7F, 0xF0, 0x48, 0x90, 0x5F, 0xD0, 0x42, 0x60, 0x00, 0x00 }; /*9B3B*/
const unsigned char  uc2_9B3C [] = {0x08, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x06, 0x40, 0x0A, 0xA0, 0x0A, 0xE0, 0x12, 0x10, 0x61, 0xE0, 0x00, 0x00 }; /*9B3C*/
const unsigned char  uc2_9B41 [] = {0x10, 0x20, 0x3E, 0xA0, 0x2A, 0x60, 0x3E, 0xA0, 0x2A, 0x60, 0x3E, 0x30, 0x09, 0xE0, 0x0E, 0xA0, 0x15, 0x30, 0x14, 0x10, 0x63, 0xE0, 0x00, 0x00 }; /*9B41*/
const unsigned char  uc2_9B42 [] = {0x02, 0x00, 0x37, 0xC0, 0x05, 0x40, 0x7F, 0xC0, 0x25, 0x40, 0x37, 0xC0, 0x49, 0x20, 0x79, 0xD0, 0x0A, 0xA0, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*9B42*/
const unsigned char  uc2_9B43 [] = {0x10, 0xC0, 0x3E, 0xA0, 0x2B, 0xF0, 0x3E, 0x80, 0x2A, 0xE0, 0x3E, 0xA0, 0x09, 0x40, 0x0D, 0xA0, 0x16, 0x90, 0x15, 0x10, 0x63, 0xE0, 0x00, 0x00 }; /*9B43*/
const unsigned char  uc2_9B44 [] = {0x12, 0x00, 0x27, 0xC0, 0x75, 0x40, 0x57, 0xC0, 0x75, 0x40, 0x57, 0xC0, 0x51, 0x20, 0x71, 0xD0, 0x52, 0xA0, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*9B44*/
const unsigned char  uc2_9B45 [] = {0x20, 0x40, 0x7C, 0x40, 0x55, 0xF0, 0x7C, 0x40, 0x57, 0xF0, 0x7C, 0xE0, 0x15, 0x50, 0x1A, 0x40, 0x2E, 0x40, 0x28, 0x10, 0x47, 0xF0, 0x00, 0x00 }; /*9B45*/
const unsigned char  uc2_9B47 [] = {0x3F, 0xF0, 0x21, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x3F, 0xF0, 0x29, 0x20, 0x2F, 0xE0, 0x29, 0x20, 0x2F, 0xE0, 0x21, 0x50, 0x5E, 0xE0, 0x00, 0x00 }; /*9B47*/
const unsigned char  uc2_9B48 [] = {0x20, 0x40, 0x7D, 0x50, 0x54, 0xA0, 0x7D, 0xF0, 0x55, 0x10, 0x7D, 0xF0, 0x13, 0x10, 0x1D, 0xF0, 0x2B, 0x10, 0x29, 0x20, 0x47, 0xE0, 0x00, 0x00 }; /*9B48*/
const unsigned char  uc2_9B49 [] = {0x23, 0xF0, 0x7D, 0x40, 0x57, 0xF0, 0x7D, 0x50, 0x55, 0x50, 0x7E, 0xB0, 0x14, 0x10, 0x1A, 0x60, 0x2D, 0x10, 0x2A, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*9B49*/
const unsigned char  uc2_9B4D [] = {0x27, 0xF0, 0x7E, 0x30, 0x55, 0x50, 0x7F, 0xF0, 0x54, 0x90, 0x7F, 0xF0, 0x15, 0x10, 0x1B, 0xD0, 0x2E, 0x20, 0x28, 0x10, 0x47, 0xF0, 0x00, 0x00 }; /*9B4D*/
const unsigned char  uc2_9B4F [] = {0x39, 0x00, 0x13, 0xE0, 0x7E, 0xA0, 0x2B, 0xE0, 0x56, 0xA0, 0x13, 0xE0, 0x7C, 0xA0, 0x24, 0xD0, 0x39, 0x60, 0x15, 0x50, 0x66, 0x20, 0x00, 0x00 }; /*9B4F*/
const unsigned char  uc2_9B51 [] = {0x20, 0x40, 0x7F, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x54, 0x40, 0x7D, 0xF0, 0x13, 0x50, 0x1D, 0xB0, 0x2B, 0x50, 0x28, 0x10, 0x47, 0xE0, 0x00, 0x00 }; /*9B51*/
const unsigned char  uc2_9B54 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x2E, 0xE0, 0x35, 0x50, 0x27, 0xC0, 0x25, 0x40, 0x27, 0xE0, 0x22, 0x90, 0x5C, 0xF0, 0x00, 0x00 }; /*9B54*/
const unsigned char  uc2_9C7C [] = {0x08, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x11, 0x00, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x00, 0x00 }; /*9C7C*/
const unsigned char  uc2_9C7F [] = {0x21, 0x00, 0x39, 0x40, 0x49, 0x20, 0x7F, 0xF0, 0x55, 0x40, 0x7D, 0x40, 0x55, 0x40, 0x7D, 0x50, 0x02, 0x50, 0x1A, 0x50, 0x64, 0x20, 0x00, 0x00 }; /*9C7F*/
const unsigned char  uc2_9C81 [] = {0x0F, 0x80, 0x10, 0x80, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xF0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x00, 0x00 }; /*9C81*/
const unsigned char  uc2_9C82 [] = {0x21, 0x80, 0x38, 0x40, 0x4B, 0xF0, 0x3C, 0x80, 0x54, 0xE0, 0x7C, 0xA0, 0x54, 0xA0, 0x7C, 0xA0, 0x01, 0x20, 0x0D, 0x20, 0x72, 0xC0, 0x00, 0x00 }; /*9C82*/
const unsigned char  uc2_9C85 [] = {0x20, 0xC0, 0x38, 0xA0, 0x4B, 0xF0, 0x3C, 0x80, 0x54, 0xE0, 0x7D, 0x20, 0x55, 0x20, 0x7D, 0xA0, 0x02, 0x40, 0x1A, 0xC0, 0x65, 0x30, 0x00, 0x00 }; /*9C85*/
const unsigned char  uc2_9C86 [] = {0x23, 0xE0, 0x38, 0x80, 0x48, 0xA0, 0x3E, 0xA0, 0x55, 0xC0, 0x7C, 0x80, 0x57, 0xF0, 0x7C, 0x80, 0x00, 0x80, 0x0E, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*9C86*/
const unsigned char  uc2_9C87 [] = {0x20, 0x40, 0x38, 0x40, 0x48, 0x70, 0x3C, 0x40, 0x54, 0x40, 0x7D, 0xF0, 0x55, 0x10, 0x7D, 0x10, 0x01, 0x10, 0x0D, 0xF0, 0x71, 0x10, 0x00, 0x00 }; /*9C87*/
const unsigned char  uc2_9C88 [] = {0x20, 0x40, 0x38, 0x70, 0x48, 0x40, 0x3D, 0xF0, 0x55, 0x10, 0x7D, 0xF0, 0x55, 0x00, 0x7D, 0x00, 0x01, 0x00, 0x0D, 0x00, 0x72, 0x00, 0x00, 0x00 }; /*9C88*/
const unsigned char  uc2_9C8B [] = {0x20, 0xA0, 0x38, 0xA0, 0x49, 0x20, 0x3F, 0xF0, 0x55, 0x20, 0x7D, 0x20, 0x55, 0xA0, 0x7D, 0x60, 0x01, 0x20, 0x0D, 0x20, 0x71, 0x40, 0x00, 0x00 }; /*9C8B*/
const unsigned char  uc2_9C8D [] = {0x21, 0x00, 0x39, 0x00, 0x49, 0xF0, 0x3E, 0x10, 0x55, 0xD0, 0x7D, 0x50, 0x55, 0x50, 0x7D, 0xD0, 0x01, 0x20, 0x0D, 0x10, 0x70, 0xE0, 0x00, 0x00 }; /*9C8D*/
const unsigned char  uc2_9C8E [] = {0x24, 0x20, 0x12, 0x40, 0x7F, 0xF0, 0x48, 0x10, 0x4F, 0x10, 0x11, 0x00, 0x7F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*9C8E*/
const unsigned char  uc2_9C90 [] = {0x20, 0x80, 0x38, 0x80, 0x49, 0x20, 0x3D, 0x30, 0x57, 0xD0, 0x7C, 0x00, 0x55, 0xE0, 0x7D, 0x20, 0x01, 0x20, 0x0D, 0xE0, 0x71, 0x20, 0x00, 0x00 }; /*9C90*/
const unsigned char  uc2_9C91 [] = {0x20, 0x80, 0x38, 0x80, 0x4B, 0xE0, 0x3C, 0x80, 0x57, 0xF0, 0x7C, 0x00, 0x54, 0x80, 0x7F, 0xE0, 0x00, 0x80, 0x0C, 0x80, 0x73, 0xF0, 0x00, 0x00 }; /*9C91*/
const unsigned char  uc2_9C92 [] = {0x10, 0x40, 0x1C, 0x40, 0x65, 0xF0, 0x3E, 0x40, 0x2A, 0xE0, 0x3E, 0x00, 0x2A, 0xE0, 0x3E, 0xA0, 0x00, 0xA0, 0x06, 0xE0, 0x78, 0xA0, 0x00, 0x00 }; /*9C92*/
const unsigned char  uc2_9C94 [] = {0x20, 0x80, 0x38, 0x80, 0x4B, 0xF0, 0x3D, 0x00, 0x57, 0xE0, 0x7D, 0x20, 0x55, 0xE0, 0x7D, 0x20, 0x01, 0xE0, 0x0D, 0x20, 0x71, 0x40, 0x00, 0x00 }; /*9C94*/
const unsigned char  uc2_9C95 [] = {0x20, 0x00, 0x3B, 0xF0, 0x48, 0x80, 0x3D, 0x00, 0x57, 0xF0, 0x7D, 0x50, 0x55, 0x50, 0x7D, 0x50, 0x05, 0x50, 0x0D, 0x10, 0x74, 0x60, 0x00, 0x00 }; /*9C95*/
const unsigned char  uc2_9C9A [] = {0x20, 0x80, 0x3B, 0xE0, 0x49, 0x40, 0x3C, 0x80, 0x55, 0x40, 0x7E, 0x30, 0x55, 0x40, 0x7D, 0x40, 0x01, 0x40, 0x0D, 0x40, 0x72, 0x40, 0x00, 0x00 }; /*9C9A*/
const unsigned char  uc2_9C9B [] = {0x21, 0x80, 0x38, 0x40, 0x4B, 0xF0, 0x3C, 0xA0, 0x54, 0x90, 0x7D, 0x10, 0x54, 0xA0, 0x7C, 0xA0, 0x00, 0x40, 0x0C, 0xA0, 0x73, 0x10, 0x00, 0x00 }; /*9C9B*/
const unsigned char  uc2_9C9C [] = {0x22, 0x20, 0x39, 0x40, 0x4B, 0xF0, 0x3C, 0x80, 0x54, 0x80, 0x7F, 0xE0, 0x54, 0x80, 0x7C, 0x80, 0x03, 0xF0, 0x0C, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*9C9C*/
const unsigned char  uc2_9C9E [] = {0x32, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x09, 0x40, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x00, 0x00 }; /*9C9E*/
const unsigned char  uc2_9C9F [] = {0x21, 0xF0, 0x38, 0x10, 0x48, 0xF0, 0x3C, 0x10, 0x55, 0xF0, 0x7C, 0x20, 0x57, 0xF0, 0x7D, 0x20, 0x00, 0xA0, 0x0C, 0x20, 0x71, 0xC0, 0x00, 0x00 }; /*9C9F*/
const unsigned char  uc2_9CA0 [] = {0x23, 0xF0, 0x38, 0x40, 0x49, 0xF0, 0x3D, 0x50, 0x55, 0xF0, 0x7D, 0x50, 0x55, 0xF0, 0x7C, 0x40, 0x01, 0x40, 0x0C, 0x80, 0x73, 0x70, 0x00, 0x00 }; /*9CA0*/
const unsigned char  uc2_9CA1 [] = {0x27, 0xF0, 0x38, 0x00, 0x48, 0x00, 0x3F, 0x70, 0x55, 0x50, 0x7D, 0x50, 0x57, 0x70, 0x7D, 0x50, 0x05, 0x50, 0x0D, 0x50, 0x72, 0x20, 0x00, 0x00 }; /*9CA1*/
const unsigned char  uc2_9CA2 [] = {0x22, 0x40, 0x39, 0xF0, 0x49, 0x40, 0x3C, 0xA0, 0x57, 0x20, 0x7D, 0xF0, 0x55, 0x20, 0x7D, 0xF0, 0x01, 0x20, 0x0D, 0x20, 0x72, 0xF0, 0x00, 0x00 }; /*9CA2*/
const unsigned char  uc2_9CA3 [] = {0x21, 0xF0, 0x39, 0x50, 0x49, 0x50, 0x3D, 0x20, 0x55, 0x50, 0x7C, 0x80, 0x54, 0x80, 0x7F, 0xE0, 0x00, 0x80, 0x0C, 0x80, 0x77, 0xF0, 0x00, 0x00 }; /*9CA3*/
const unsigned char  uc2_9CA4 [] = {0x20, 0x00, 0x39, 0xF0, 0x49, 0x50, 0x3D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x54, 0x40, 0x7D, 0xF0, 0x00, 0x40, 0x0E, 0x40, 0x71, 0xF0, 0x00, 0x00 }; /*9CA4*/
const unsigned char  uc2_9CA5 [] = {0x20, 0x20, 0x3F, 0x20, 0x45, 0xF0, 0x3D, 0x20, 0x57, 0x20, 0x7D, 0xA0, 0x55, 0x60, 0x7F, 0x20, 0x05, 0x20, 0x0C, 0x20, 0x70, 0xC0, 0x00, 0x00 }; /*9CA5*/
const unsigned char  uc2_9CA6 [] = {0x20, 0x80, 0x38, 0xE0, 0x49, 0xA0, 0x3C, 0x40, 0x55, 0xB0, 0x7C, 0x40, 0x57, 0xF0, 0x7C, 0x40, 0x01, 0x60, 0x0E, 0x50, 0x71, 0x80, 0x00, 0x00 }; /*9CA6*/
const unsigned char  uc2_9CA7 [] = {0x20, 0x60, 0x39, 0x80, 0x48, 0xA0, 0x3F, 0xC0, 0x54, 0xA0, 0x7D, 0x30, 0x57, 0xD0, 0x7D, 0x60, 0x01, 0x50, 0x0E, 0x50, 0x71, 0x80, 0x00, 0x00 }; /*9CA7*/
const unsigned char  uc2_9CA8 [] = {0x30, 0x80, 0x0A, 0xA0, 0x74, 0xB0, 0x08, 0xD0, 0x7F, 0x00, 0x11, 0x00, 0x7F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x7F, 0xF0, 0x00, 0x00 }; /*9CA8*/
const unsigned char  uc2_9CA9 [] = {0x20, 0x80, 0x3B, 0xE0, 0x4A, 0x20, 0x3D, 0xC0, 0x54, 0x00, 0x7F, 0xE0, 0x55, 0x40, 0x7D, 0x40, 0x01, 0x50, 0x0D, 0x50, 0x72, 0x20, 0x00, 0x00 }; /*9CA9*/
const unsigned char  uc2_9CAB [] = {0x27, 0x70, 0x3D, 0x50, 0x47, 0x50, 0x3D, 0x50, 0x57, 0x50, 0x7C, 0x50, 0x54, 0x50, 0x7E, 0x50, 0x05, 0x60, 0x0F, 0x40, 0x75, 0x40, 0x00, 0x00 }; /*9CAB*/
const unsigned char  uc2_9CAC [] = {0x21, 0xE0, 0x38, 0x20, 0x48, 0xC0, 0x3C, 0x40, 0x55, 0xF0, 0x7D, 0x50, 0x55, 0xF0, 0x7D, 0x50, 0x01, 0xF0, 0x0D, 0x50, 0x71, 0x20, 0x00, 0x00 }; /*9CAC*/
const unsigned char  uc2_9CAD [] = {0x23, 0xF0, 0x38, 0x80, 0x4B, 0xE0, 0x3C, 0x80, 0x57, 0xF0, 0x7D, 0x20, 0x55, 0xE0, 0x7D, 0x20, 0x01, 0xE0, 0x1D, 0x20, 0x61, 0x60, 0x00, 0x00 }; /*9CAD*/
const unsigned char  uc2_9CAE [] = {0x20, 0x80, 0x3B, 0xE0, 0x48, 0x80, 0x3F, 0xF0, 0x55, 0x40, 0x7E, 0x20, 0x55, 0x20, 0x7D, 0xC0, 0x03, 0x40, 0x0C, 0x80, 0x73, 0x70, 0x00, 0x00 }; /*9CAE*/
const unsigned char  uc2_9CB0 [] = {0x27, 0x80, 0x3D, 0x00, 0x45, 0xF0, 0x3F, 0x50, 0x55, 0x50, 0x7F, 0x50, 0x55, 0x50, 0x7D, 0x20, 0x07, 0xA0, 0x0D, 0x20, 0x71, 0xD0, 0x00, 0x00 }; /*9CB0*/
const unsigned char  uc2_9CB1 [] = {0x21, 0x40, 0x3D, 0x40, 0x47, 0x70, 0x3D, 0x40, 0x55, 0x40, 0x7F, 0x60, 0x55, 0x40, 0x7D, 0x40, 0x03, 0x70, 0x0D, 0x40, 0x71, 0x40, 0x00, 0x00 }; /*9CB1*/
const unsigned char  uc2_9CB2 [] = {0x21, 0xE0, 0x39, 0x20, 0x49, 0xE0, 0x3D, 0x20, 0x55, 0xE0, 0x7D, 0x40, 0x55, 0x50, 0x7D, 0xE0, 0x01, 0x50, 0x0D, 0xD0, 0x71, 0x20, 0x00, 0x00 }; /*9CB2*/
const unsigned char  uc2_9CB3 [] = {0x20, 0x00, 0x38, 0xE0, 0x48, 0xA0, 0x3C, 0xE0, 0x54, 0xA0, 0x7D, 0xF0, 0x55, 0x10, 0x7D, 0xF0, 0x01, 0x10, 0x0D, 0xF0, 0x71, 0x10, 0x00, 0x00 }; /*9CB3*/
const unsigned char  uc2_9CB4 [] = {0x20, 0x00, 0x37, 0xF0, 0x54, 0x90, 0x7C, 0x90, 0x57, 0xF0, 0x7C, 0x90, 0x55, 0xD0, 0x7D, 0x50, 0x05, 0xD0, 0x1C, 0x10, 0x67, 0xF0, 0x00, 0x00 }; /*9CB4*/
const unsigned char  uc2_9CB5 [] = {0x21, 0x00, 0x3A, 0x60, 0x4A, 0x20, 0x3B, 0x60, 0x56, 0x20, 0x7D, 0xE0, 0x55, 0x40, 0x7D, 0x40, 0x01, 0x50, 0x09, 0x50, 0x76, 0x20, 0x00, 0x00 }; /*9CB5*/
const unsigned char  uc2_9CB6 [] = {0x21, 0x00, 0x3A, 0x80, 0x45, 0x60, 0x3C, 0x80, 0x57, 0xC0, 0x7C, 0x40, 0x55, 0x80, 0x7C, 0xA0, 0x02, 0x50, 0x0D, 0x50, 0x71, 0x80, 0x00, 0x00 }; /*9CB6*/
const unsigned char  uc2_9CB7 [] = {0x21, 0xF0, 0x39, 0x50, 0x49, 0xF0, 0x3D, 0x50, 0x55, 0xF0, 0x7D, 0x10, 0x55, 0xD0, 0x7D, 0x50, 0x01, 0xD0, 0x0D, 0x10, 0x72, 0x60, 0x00, 0x00 }; /*9CB7*/
const unsigned char  uc2_9CB8 [] = {0x20, 0x80, 0x3B, 0xF0, 0x48, 0x00, 0x3D, 0xE0, 0x55, 0x20, 0x7D, 0xE0, 0x54, 0x40, 0x7D, 0x60, 0x01, 0x50, 0x0E, 0x50, 0x71, 0x80, 0x00, 0x00 }; /*9CB8*/
const unsigned char  uc2_9CBA [] = {0x23, 0xC0, 0x38, 0xC0, 0x4B, 0x40, 0x3D, 0x40, 0x57, 0xC0, 0x7D, 0x40, 0x57, 0xC0, 0x7D, 0x40, 0x01, 0xD0, 0x0E, 0x50, 0x70, 0x20, 0x00, 0x00 }; /*9CBA*/
const unsigned char  uc2_9CBB [] = {0x21, 0x50, 0x39, 0x50, 0x4A, 0xA0, 0x3D, 0x50, 0x55, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x01, 0x50, 0x0D, 0xF0, 0x71, 0x10, 0x00, 0x00 }; /*9CBB*/
const unsigned char  uc2_9CBC [] = {0x20, 0x40, 0x39, 0xF0, 0x48, 0x40, 0x3C, 0xA0, 0x55, 0xF0, 0x7C, 0xA0, 0x55, 0xF0, 0x7D, 0x10, 0x01, 0x50, 0x0E, 0x60, 0x71, 0x90, 0x00, 0x00 }; /*9CBC*/
const unsigned char  uc2_9CBD [] = {0x22, 0xA0, 0x3F, 0xF0, 0x4A, 0xA0, 0x3A, 0xE0, 0x56, 0x00, 0x7B, 0xF0, 0x54, 0x80, 0x7F, 0xF0, 0x02, 0xA0, 0x0C, 0x90, 0x70, 0x80, 0x00, 0x00 }; /*9CBD*/
const unsigned char  uc2_9CC3 [] = {0x20, 0x00, 0x39, 0xF0, 0x49, 0x50, 0x3D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x54, 0x80, 0x7C, 0x60, 0x01, 0x50, 0x0E, 0x90, 0x70, 0x60, 0x00, 0x00 }; /*9CC3*/
const unsigned char  uc2_9CC4 [] = {0x23, 0xE0, 0x3A, 0xA0, 0x49, 0x40, 0x3D, 0xE0, 0x54, 0x00, 0x7F, 0xF0, 0x55, 0x00, 0x7F, 0xE0, 0x00, 0x20, 0x0C, 0x20, 0x70, 0xC0, 0x00, 0x00 }; /*9CC4*/
const unsigned char  uc2_9CC5 [] = {0x20, 0xA0, 0x3B, 0x20, 0x49, 0x20, 0x3D, 0x50, 0x57, 0xA0, 0x7D, 0x20, 0x57, 0xA0, 0x7D, 0x60, 0x01, 0x20, 0x0D, 0x20, 0x71, 0xD0, 0x00, 0x00 }; /*9CC5*/
const unsigned char  uc2_9CC6 [] = {0x21, 0x00, 0x39, 0xF0, 0x4B, 0x20, 0x3D, 0xE0, 0x55, 0x20, 0x7D, 0xE0, 0x55, 0x00, 0x7D, 0xE0, 0x02, 0xA0, 0x0C, 0x40, 0x73, 0xB0, 0x00, 0x00 }; /*9CC6*/
const unsigned char  uc2_9CC7 [] = {0x21, 0x00, 0x3B, 0xE0, 0x4A, 0x20, 0x3B, 0xE0, 0x56, 0x20, 0x7B, 0xF0, 0x54, 0x80, 0x7F, 0xE0, 0x00, 0x80, 0x0C, 0x80, 0x73, 0xF0, 0x00, 0x00 }; /*9CC7*/
const unsigned char  uc2_9CCA [] = {0x23, 0x00, 0x38, 0x80, 0x47, 0xF0, 0x3C, 0x10, 0x57, 0xF0, 0x7C, 0x00, 0x57, 0xF0, 0x7D, 0x50, 0x07, 0xF0, 0x0D, 0x50, 0x70, 0x60, 0x00, 0x00 }; /*9CCA*/
const unsigned char  uc2_9CCB [] = {0x23, 0xF0, 0x39, 0x50, 0x48, 0xE0, 0x3D, 0x10, 0x54, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x00, 0x40, 0x0C, 0x60, 0x71, 0xD0, 0x00, 0x00 }; /*9CCB*/
const unsigned char  uc2_9CCC [] = {0x08, 0x80, 0x3E, 0xF0, 0x09, 0xA0, 0x3E, 0x40, 0x09, 0xB0, 0x72, 0x00, 0x1F, 0xE0, 0x69, 0x20, 0x0F, 0xE0, 0x09, 0x20, 0x1F, 0xF0, 0x00, 0x00 }; /*9CCC*/
const unsigned char  uc2_9CCD [] = {0x20, 0x90, 0x39, 0xF0, 0x48, 0xA0, 0x3F, 0xF0, 0x55, 0x20, 0x7F, 0x50, 0x54, 0xE0, 0x7D, 0x10, 0x01, 0xF0, 0x0D, 0x10, 0x71, 0xF0, 0x00, 0x00 }; /*9CCD*/
const unsigned char  uc2_9CCE [] = {0x21, 0xF0, 0x39, 0x10, 0x49, 0xF0, 0x3D, 0x10, 0x57, 0xF0, 0x7C, 0x90, 0x56, 0xD0, 0x7D, 0xB0, 0x02, 0xD0, 0x0C, 0x90, 0x73, 0x60, 0x00, 0x00 }; /*9CCE*/
const unsigned char  uc2_9CCF [] = {0x27, 0xF0, 0x3D, 0x50, 0x45, 0x50, 0x3F, 0xF0, 0x54, 0x80, 0x7D, 0xE0, 0x56, 0x90, 0x7D, 0xE0, 0x02, 0x90, 0x0C, 0x80, 0x70, 0x80, 0x00, 0x00 }; /*9CCF*/
const unsigned char  uc2_9CD0 [] = {0x20, 0x30, 0x39, 0xD0, 0x49, 0x50, 0x3C, 0xA0, 0x55, 0x00, 0x7D, 0xF0, 0x56, 0x40, 0x7D, 0xF0, 0x01, 0x50, 0x0D, 0xF0, 0x70, 0x10, 0x00, 0x00 }; /*9CD0*/
const unsigned char  uc2_9CD3 [] = {0x22, 0xC0, 0x3F, 0x40, 0x4A, 0xC0, 0x3D, 0x70, 0x57, 0xD0, 0x7D, 0x50, 0x57, 0xD0, 0x7D, 0x50, 0x03, 0xD0, 0x0D, 0x50, 0x71, 0xA0, 0x00, 0x00 }; /*9CD3*/
const unsigned char  uc2_9CD4 [] = {0x27, 0xF0, 0x3D, 0x40, 0x47, 0xF0, 0x3D, 0x50, 0x57, 0xF0, 0x7C, 0x00, 0x57, 0xE0, 0x7C, 0x00, 0x07, 0xF0, 0x0A, 0xA0, 0x75, 0x10, 0x00, 0x00 }; /*9CD4*/
const unsigned char  uc2_9CD5 [] = {0x21, 0xF0, 0x38, 0x40, 0x49, 0xF0, 0x3D, 0x50, 0x54, 0xA0, 0x7D, 0xF0, 0x54, 0x10, 0x7C, 0xF0, 0x00, 0x10, 0x0D, 0xF0, 0x70, 0x10, 0x00, 0x00 }; /*9CD5*/
const unsigned char  uc2_9CD6 [] = {0x49, 0x40, 0x2A, 0x70, 0x7F, 0xD0, 0x55, 0x50, 0x6F, 0x20, 0x49, 0x50, 0x0F, 0xE0, 0x19, 0x20, 0x6F, 0xE0, 0x09, 0x20, 0x3F, 0xF0, 0x00, 0x00 }; /*9CD6*/
const unsigned char  uc2_9CD7 [] = {0x21, 0xE0, 0x39, 0x20, 0x49, 0xE0, 0x3D, 0x20, 0x57, 0xF0, 0x7D, 0x50, 0x55, 0x50, 0x7F, 0xE0, 0x01, 0x20, 0x0C, 0xC0, 0x73, 0x30, 0x00, 0x00 }; /*9CD7*/
const unsigned char  uc2_9CD8 [] = {0x3E, 0x80, 0x40, 0xF0, 0x3F, 0xA0, 0x2A, 0xA0, 0x7F, 0x40, 0x2A, 0xB0, 0x3F, 0xE0, 0x09, 0x20, 0x0F, 0xE0, 0x09, 0x20, 0x3F, 0xF0, 0x00, 0x00 }; /*9CD8*/
const unsigned char  uc2_9CD9 [] = {0x10, 0x80, 0x1F, 0xF0, 0x62, 0xA0, 0x3F, 0xF0, 0x2A, 0xA0, 0x3F, 0xC0, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0xA0, 0x0B, 0xE0, 0x74, 0xA0, 0x00, 0x00 }; /*9CD9*/
const unsigned char  uc2_9CDC [] = {0x27, 0xF0, 0x3A, 0xA0, 0x55, 0x20, 0x3F, 0xF0, 0x55, 0x50, 0x7D, 0x60, 0x57, 0xA0, 0x7D, 0x20, 0x05, 0x20, 0x0A, 0x20, 0x74, 0x50, 0x00, 0x00 }; /*9CDC*/
const unsigned char  uc2_9CDD [] = {0x20, 0xA0, 0x39, 0xF0, 0x48, 0x40, 0x7D, 0xF0, 0x54, 0x40, 0x7F, 0xF0, 0x55, 0x50, 0x7C, 0xA0, 0x01, 0xF0, 0x0D, 0x10, 0x71, 0xF0, 0x00, 0x00 }; /*9CDD*/
const unsigned char  uc2_9CDE [] = {0x21, 0x50, 0x38, 0x40, 0x49, 0xF0, 0x7C, 0xE0, 0x55, 0x50, 0x7C, 0x20, 0x55, 0xF0, 0x7E, 0xA0, 0x03, 0xF0, 0x0C, 0xA0, 0x71, 0x20, 0x00, 0x00 }; /*9CDE*/
const unsigned char  uc2_9CDF [] = {0x20, 0xA0, 0x39, 0xF0, 0x48, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x54, 0x20, 0x7D, 0xF0, 0x00, 0x20, 0x0C, 0xA0, 0x70, 0x40, 0x00, 0x00 }; /*9CDF*/
const unsigned char  uc2_9CE2 [] = {0x21, 0x40, 0x3F, 0xF0, 0x45, 0x50, 0x3F, 0xF0, 0x55, 0x50, 0x7F, 0xF0, 0x54, 0x20, 0x7B, 0xE0, 0x06, 0x20, 0x09, 0x40, 0x77, 0xF0, 0x00, 0x00 }; /*9CE2*/
const unsigned char  uc2_9E1F [] = {0x04, 0x00, 0x08, 0x00, 0x3F, 0xC0, 0x20, 0x40, 0x2C, 0x40, 0x22, 0x80, 0x3F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*9E1F*/
const unsigned char  uc2_9E20 [] = {0x10, 0x40, 0x10, 0x80, 0x11, 0xE0, 0x7D, 0x20, 0x15, 0xA0, 0x15, 0x40, 0x15, 0xF0, 0x24, 0x10, 0x27, 0xD0, 0x24, 0x10, 0x40, 0xE0, 0x00, 0x00 }; /*9E20*/
const unsigned char  uc2_9E21 [] = {0x00, 0x40, 0x00, 0x80, 0x3D, 0xE0, 0x05, 0x20, 0x25, 0xA0, 0x15, 0x40, 0x09, 0xF0, 0x08, 0x10, 0x15, 0xD0, 0x64, 0x10, 0x00, 0xE0, 0x00, 0x00 }; /*9E21*/
const unsigned char  uc2_9E22 [] = {0x04, 0x80, 0x07, 0xE0, 0x7C, 0x00, 0x0A, 0x10, 0x3F, 0xE0, 0x24, 0x80, 0x3F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*9E22*/
const unsigned char  uc2_9E23 [] = {0x00, 0x80, 0x7B, 0xE0, 0x4A, 0x20, 0x4B, 0xA0, 0x4A, 0x40, 0x7B, 0xF0, 0x40, 0x10, 0x0F, 0xD0, 0x00, 0x10, 0x00, 0x20, 0x01, 0xC0, 0x00, 0x00 }; /*9E23*/
const unsigned char  uc2_9E25 [] = {0x00, 0x80, 0x7D, 0xE0, 0x41, 0x20, 0x65, 0xA0, 0x55, 0x40, 0x49, 0xF0, 0x54, 0x10, 0x67, 0xD0, 0x40, 0x10, 0x7C, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*9E25*/
const unsigned char  uc2_9E26 [] = {0x00, 0x80, 0x7F, 0xE0, 0x15, 0x20, 0x25, 0xA0, 0x3F, 0x40, 0x05, 0xF0, 0x0C, 0x10, 0x17, 0xD0, 0x14, 0x10, 0x64, 0x20, 0x18, 0xC0, 0x00, 0x00 }; /*9E26*/
const unsigned char  uc2_9E28 [] = {0x20, 0x80, 0x25, 0xE0, 0x39, 0x20, 0x25, 0xA0, 0x25, 0x40, 0x19, 0xF0, 0x10, 0x10, 0x7D, 0xD0, 0x10, 0x10, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*9E28*/
const unsigned char  uc2_9E29 [] = {0x10, 0x80, 0x11, 0xE0, 0x7F, 0x20, 0x51, 0xA0, 0x15, 0x40, 0x15, 0xF0, 0x14, 0x10, 0x15, 0xD0, 0x26, 0x10, 0x24, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*9E29*/
const unsigned char  uc2_9E2A [] = {0x10, 0x80, 0x11, 0xE0, 0x7D, 0x20, 0x11, 0xA0, 0x11, 0x40, 0x7D, 0xF0, 0x44, 0x10, 0x47, 0xD0, 0x44, 0x10, 0x7C, 0x20, 0x44, 0xC0, 0x00, 0x00 }; /*9E2A*/
const unsigned char  uc2_9E2B [] = {0x10, 0x80, 0x7F, 0xE0, 0x21, 0x20, 0x29, 0xA0, 0x49, 0x40, 0x7D, 0xF0, 0x08, 0x10, 0x2D, 0xD0, 0x2A, 0x10, 0x4A, 0x20, 0x30, 0xC0, 0x00, 0x00 }; /*9E2B*/
const unsigned char  uc2_9E2C [] = {0x10, 0x80, 0x1D, 0xE0, 0x11, 0x20, 0x3D, 0xA0, 0x25, 0x40, 0x25, 0xF0, 0x3C, 0x10, 0x23, 0xD0, 0x20, 0x10, 0x20, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*9E2C*/
const unsigned char  uc2_9E2D [] = {0x7C, 0x80, 0x55, 0xE0, 0x55, 0x20, 0x7D, 0xA0, 0x55, 0x40, 0x55, 0xF0, 0x7C, 0x10, 0x13, 0xD0, 0x10, 0x10, 0x10, 0x20, 0x10, 0xC0, 0x00, 0x00 }; /*9E2D*/
const unsigned char  uc2_9E2F [] = {0x02, 0x00, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x0A, 0x80, 0x3F, 0xE0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0xD0, 0x00, 0x60, 0x00, 0x00 }; /*9E2F*/
const unsigned char  uc2_9E31 [] = {0x06, 0x80, 0x79, 0xE0, 0x49, 0x20, 0x49, 0xA0, 0x7F, 0x40, 0x49, 0xF0, 0x58, 0x10, 0x67, 0xF0, 0x55, 0x10, 0x0B, 0x20, 0x08, 0xC0, 0x00, 0x00 }; /*9E31*/
const unsigned char  uc2_9E32 [] = {0x20, 0x40, 0x20, 0xE0, 0x3E, 0xA0, 0x42, 0xE0, 0x3A, 0xA0, 0x2A, 0xF0, 0x2A, 0x10, 0x3B, 0xD0, 0x2A, 0x10, 0x02, 0x10, 0x0C, 0x60, 0x00, 0x00 }; /*9E32*/
const unsigned char  uc2_9E33 [] = {0x10, 0x00, 0x1D, 0xE0, 0x75, 0x20, 0x09, 0x40, 0x75, 0x10, 0x1F, 0xE0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9E33*/
const unsigned char  uc2_9E35 [] = {0x10, 0x40, 0x3D, 0xF0, 0x25, 0x10, 0x35, 0x10, 0x28, 0x80, 0x3E, 0x90, 0x02, 0xE0, 0x7E, 0x80, 0x02, 0x90, 0x04, 0x90, 0x18, 0x60, 0x00, 0x00 }; /*9E35*/
const unsigned char  uc2_9E36 [] = {0x14, 0xA0, 0x39, 0xC0, 0x10, 0x80, 0x3D, 0xE0, 0x00, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x3F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9E36*/
const unsigned char  uc2_9E37 [] = {0x11, 0x00, 0x7B, 0xC0, 0x11, 0x50, 0x7B, 0x50, 0x12, 0xB0, 0x3F, 0xC0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9E37*/
const unsigned char  uc2_9E38 [] = {0x00, 0x80, 0x7F, 0xE0, 0x09, 0x20, 0x7F, 0xA0, 0x55, 0x40, 0x55, 0xF0, 0x55, 0x10, 0x55, 0xF0, 0x55, 0x10, 0x51, 0x20, 0x46, 0xC0, 0x00, 0x00 }; /*9E38*/
const unsigned char  uc2_9E39 [] = {0x06, 0x40, 0x38, 0xE0, 0x08, 0xA0, 0x7F, 0xE0, 0x08, 0xA0, 0x08, 0xF0, 0x3E, 0x10, 0x23, 0xD0, 0x22, 0x10, 0x3E, 0x10, 0x22, 0x60, 0x00, 0x00 }; /*9E39*/
const unsigned char  uc2_9E3A [] = {0x14, 0x40, 0x14, 0xF0, 0x24, 0x90, 0x7F, 0xD0, 0x24, 0xB0, 0x2E, 0x80, 0x35, 0xF0, 0x24, 0x10, 0x25, 0xD0, 0x24, 0x10, 0x24, 0x60, 0x00, 0x00 }; /*9E3A*/
const unsigned char  uc2_9E3D [] = {0x10, 0x80, 0x19, 0xE0, 0x15, 0x20, 0x65, 0xA0, 0x3D, 0x40, 0x01, 0xF0, 0x3C, 0x10, 0x27, 0xD0, 0x24, 0x10, 0x3C, 0x20, 0x24, 0xC0, 0x00, 0x00 }; /*9E3D*/
const unsigned char  uc2_9E3E [] = {0x02, 0x00, 0x7F, 0xF0, 0x14, 0xA0, 0x64, 0x90, 0x1F, 0xC0, 0x14, 0x40, 0x12, 0x80, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9E3E*/
const unsigned char  uc2_9E3F [] = {0x40, 0x80, 0x21, 0xE0, 0x2F, 0x20, 0x05, 0xA0, 0x45, 0x40, 0x25, 0xF0, 0x24, 0x10, 0x07, 0xD0, 0x38, 0x10, 0x20, 0x20, 0x40, 0xC0, 0x00, 0x00 }; /*9E3F*/
const unsigned char  uc2_9E41 [] = {0x08, 0x80, 0x7F, 0xE0, 0x09, 0x20, 0x3F, 0xA0, 0x21, 0x40, 0x1D, 0xF0, 0x04, 0x10, 0x0F, 0xD0, 0x78, 0x10, 0x08, 0x20, 0x30, 0xC0, 0x00, 0x00 }; /*9E41*/
const unsigned char  uc2_9E42 [] = {0x00, 0x80, 0x7D, 0xE0, 0x01, 0x20, 0x7D, 0xA0, 0x55, 0x60, 0x55, 0x00, 0x7D, 0xF0, 0x54, 0x10, 0x57, 0xD0, 0x54, 0x10, 0x2C, 0x60, 0x00, 0x00 }; /*9E42*/
const unsigned char  uc2_9E43 [] = {0x38, 0x80, 0x29, 0xE0, 0x39, 0x20, 0x01, 0xA0, 0x7D, 0x40, 0x45, 0xF0, 0x7C, 0x10, 0x47, 0xD0, 0x7C, 0x10, 0x44, 0x20, 0x58, 0xC0, 0x00, 0x00 }; /*9E43*/
const unsigned char  uc2_9E44 [] = {0x08, 0x40, 0x28, 0xE0, 0x3E, 0xA0, 0x48, 0xE0, 0x7E, 0xA0, 0x00, 0xF0, 0x3E, 0x10, 0x23, 0xD0, 0x22, 0x10, 0x3E, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*9E44*/
const unsigned char  uc2_9E45 [] = {0x1C, 0x40, 0x6A, 0xE0, 0x2A, 0xA0, 0x7E, 0xE0, 0x2A, 0xA0, 0x2A, 0xF0, 0x34, 0x10, 0x65, 0xD0, 0x2D, 0x10, 0x33, 0x20, 0x41, 0xC0, 0x00, 0x00 }; /*9E45*/
const unsigned char  uc2_9E46 [] = {0x14, 0x80, 0x13, 0xE0, 0x69, 0x20, 0x09, 0xA0, 0x15, 0x40, 0x63, 0xF0, 0x3C, 0x10, 0x27, 0xD0, 0x24, 0x10, 0x3C, 0x20, 0x24, 0xC0, 0x00, 0x00 }; /*9E46*/
const unsigned char  uc2_9E47 [] = {0x5C, 0x80, 0x25, 0xE0, 0x55, 0x20, 0x55, 0xA0, 0x7D, 0x60, 0x55, 0x00, 0x5D, 0xF0, 0x74, 0x10, 0x57, 0xD0, 0x54, 0x10, 0x4C, 0x60, 0x00, 0x00 }; /*9E47*/
const unsigned char  uc2_9E48 [] = {0x14, 0x40, 0x3E, 0xE0, 0x0A, 0xA0, 0x3E, 0xE0, 0x28, 0xA0, 0x3E, 0xF0, 0x0A, 0x10, 0x1B, 0xD0, 0x2C, 0x10, 0x28, 0x20, 0x48, 0xC0, 0x00, 0x00 }; /*9E48*/
const unsigned char  uc2_9E49 [] = {0x36, 0x40, 0x05, 0xE0, 0x7E, 0xA0, 0x04, 0xE0, 0x14, 0xA0, 0x54, 0xF0, 0x5C, 0x10, 0x55, 0xD0, 0x5D, 0x10, 0x62, 0x20, 0x00, 0xC0, 0x00, 0x00 }; /*9E49*/
const unsigned char  uc2_9E4A [] = {0x14, 0x40, 0x3E, 0xE0, 0x14, 0xA0, 0x7F, 0xE0, 0x00, 0xA0, 0x3E, 0xF0, 0x22, 0x10, 0x3F, 0xD0, 0x22, 0x10, 0x3E, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*9E4A*/
const unsigned char  uc2_9E4B [] = {0x14, 0x40, 0x7F, 0xE0, 0x14, 0xA0, 0x3E, 0xE0, 0x2A, 0xA0, 0x2A, 0xF0, 0x3E, 0x10, 0x2B, 0xD0, 0x2A, 0x10, 0x3E, 0x20, 0x22, 0xC0, 0x00, 0x00 }; /*9E4B*/
const unsigned char  uc2_9E4C [] = {0x08, 0x40, 0x7F, 0xE0, 0x14, 0xA0, 0x6A, 0xE0, 0x3E, 0xA0, 0x2A, 0xF0, 0x3E, 0x10, 0x2B, 0xD0, 0x3E, 0x10, 0x0A, 0x20, 0x0C, 0xC0, 0x00, 0x00 }; /*9E4C*/
const unsigned char  uc2_9E4E [] = {0x10, 0x40, 0x3E, 0xE0, 0x2A, 0xA0, 0x3E, 0xE0, 0x2A, 0xA0, 0x3E, 0xF0, 0x10, 0x10, 0x25, 0xD0, 0x7E, 0x10, 0x04, 0x20, 0x04, 0xC0, 0x00, 0x00 }; /*9E4E*/
const unsigned char  uc2_9E4F [] = {0x3E, 0x40, 0x2A, 0xE0, 0x2A, 0xA0, 0x3E, 0xE0, 0x2A, 0xA0, 0x2A, 0xF0, 0x3E, 0x10, 0x2B, 0xD0, 0x2A, 0x10, 0x2A, 0x20, 0x54, 0xC0, 0x00, 0x00 }; /*9E4F*/
const unsigned char  uc2_9E51 [] = {0x08, 0x80, 0x7F, 0xE0, 0x25, 0x20, 0x3D, 0xA0, 0x01, 0x40, 0x3D, 0xF0, 0x04, 0x10, 0x0F, 0xD0, 0x78, 0x10, 0x08, 0x20, 0x30, 0xC0, 0x00, 0x00 }; /*9E51*/
const unsigned char  uc2_9E55 [] = {0x27, 0x40, 0x25, 0xE0, 0x75, 0x20, 0x27, 0xA0, 0x75, 0x40, 0x55, 0xF0, 0x57, 0x10, 0x75, 0xD0, 0x55, 0x10, 0x09, 0x20, 0x0A, 0xC0, 0x00, 0x00 }; /*9E55*/
const unsigned char  uc2_9E57 [] = {0x76, 0x80, 0x5B, 0xE0, 0x6D, 0x20, 0x01, 0xA0, 0x3D, 0x40, 0x01, 0xF0, 0x7E, 0x10, 0x11, 0xD0, 0x3C, 0x10, 0x04, 0x20, 0x18, 0xC0, 0x00, 0x00 }; /*9E57*/
const unsigned char  uc2_9E58 [] = {0x3E, 0x40, 0x22, 0xF0, 0x3A, 0x90, 0x2A, 0xD0, 0x7F, 0xB0, 0x41, 0x80, 0x3E, 0xF0, 0x22, 0x10, 0x3F, 0xF0, 0x22, 0x10, 0x26, 0x60, 0x00, 0x00 }; /*9E58*/
const unsigned char  uc2_9E5A [] = {0x22, 0x40, 0x14, 0xF0, 0x7F, 0x90, 0x22, 0xD0, 0x22, 0xB0, 0x55, 0x80, 0x77, 0xF0, 0x22, 0x10, 0x55, 0xF0, 0x77, 0x10, 0x11, 0x60, 0x00, 0x00 }; /*9E5A*/
const unsigned char  uc2_9E5B [] = {0x00, 0x40, 0x3E, 0xE0, 0x2A, 0xA0, 0x3E, 0xE0, 0x24, 0xA0, 0x2A, 0xF0, 0x2E, 0x10, 0x2B, 0xD0, 0x2E, 0x10, 0x2A, 0x20, 0x4E, 0xC0, 0x00, 0x00 }; /*9E5B*/
const unsigned char  uc2_9E5C [] = {0x3C, 0x80, 0x14, 0xF0, 0x7E, 0xA0, 0x2B, 0x40, 0x48, 0xB0, 0x3F, 0xC0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9E5C*/
const unsigned char  uc2_9E5E [] = {0x0C, 0x80, 0x75, 0xE0, 0x55, 0x20, 0x59, 0xA0, 0x21, 0x20, 0x3D, 0x40, 0x51, 0xF0, 0x3C, 0x10, 0x10, 0xD0, 0x57, 0x10, 0x7C, 0x60, 0x00, 0x00 }; /*9E5E*/
const unsigned char  uc2_9E63 [] = {0x14, 0x80, 0x7F, 0xE0, 0x15, 0x20, 0x3F, 0xA0, 0x15, 0x40, 0x7F, 0xF0, 0x15, 0x10, 0x3F, 0xD0, 0x14, 0x10, 0x36, 0x20, 0x55, 0xC0, 0x00, 0x00 }; /*9E63*/
const unsigned char  uc2_9E64 [] = {0x08, 0x40, 0x7F, 0xE0, 0x54, 0xA0, 0x1F, 0xE0, 0x64, 0xA0, 0x3E, 0xF0, 0x24, 0x10, 0x3F, 0xD0, 0x24, 0x10, 0x3F, 0x20, 0x20, 0xC0, 0x00, 0x00 }; /*9E64*/
const unsigned char  uc2_9E66 [] = {0x77, 0x40, 0x55, 0xE0, 0x55, 0x20, 0x22, 0xA0, 0x55, 0x40, 0x09, 0xF0, 0x7E, 0x10, 0x13, 0xD0, 0x3C, 0x10, 0x12, 0x20, 0x62, 0xC0, 0x00, 0x00 }; /*9E66*/
const unsigned char  uc2_9E67 [] = {0x04, 0x40, 0x3F, 0xE0, 0x2A, 0xA0, 0x3F, 0xE0, 0x2A, 0xA0, 0x2E, 0xF0, 0x20, 0x10, 0x2B, 0xD0, 0x35, 0x10, 0x55, 0x20, 0x55, 0xC0, 0x00, 0x00 }; /*9E67*/
const unsigned char  uc2_9E68 [] = {0x6E, 0x40, 0x5A, 0xE0, 0x36, 0xA0, 0x5A, 0xE0, 0x0A, 0xA0, 0x14, 0xF0, 0x6A, 0x10, 0x05, 0xD0, 0x3A, 0x10, 0x04, 0x20, 0x78, 0xC0, 0x00, 0x00 }; /*9E68*/
const unsigned char  uc2_9E69 [] = {0x08, 0x40, 0x7E, 0xE0, 0x49, 0xA0, 0x3E, 0xE0, 0x63, 0xA0, 0x3E, 0xF0, 0x22, 0x10, 0x3F, 0xD0, 0x2A, 0x10, 0x49, 0x20, 0x31, 0xC0, 0x00, 0x00 }; /*9E69*/
const unsigned char  uc2_9E6A [] = {0x28, 0x40, 0x3E, 0xE0, 0x68, 0xA0, 0x3E, 0xE0, 0x28, 0xA0, 0x3E, 0xF0, 0x28, 0x10, 0x3F, 0xD0, 0x2A, 0x10, 0x35, 0x20, 0x55, 0xC0, 0x00, 0x00 }; /*9E6A*/
const unsigned char  uc2_9E6B [] = {0x08, 0xC0, 0x7E, 0xA0, 0x27, 0xF0, 0x3C, 0x80, 0x2B, 0x50, 0x5F, 0xE0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0x60, 0x00, 0x00 }; /*9E6B*/
const unsigned char  uc2_9E6C [] = {0x3C, 0x80, 0x15, 0xE0, 0x7F, 0x20, 0x25, 0xA0, 0x4B, 0x40, 0x7F, 0xF0, 0x55, 0x10, 0x7F, 0xD0, 0x55, 0x10, 0x5D, 0x20, 0x42, 0xC0, 0x00, 0x00 }; /*9E6C*/
const unsigned char  uc2_9E6D [] = {0x3D, 0xE0, 0x27, 0x20, 0x3C, 0xC0, 0x57, 0x30, 0x49, 0x20, 0x7F, 0xE0, 0x12, 0x40, 0x1F, 0xF0, 0x00, 0x10, 0x7F, 0x90, 0x00, 0xE0, 0x00, 0x00 }; /*9E6D*/
const unsigned char  uc2_9E70 [] = {0x3F, 0xF0, 0x25, 0x50, 0x2B, 0xE0, 0x39, 0x50, 0x29, 0x60, 0x2F, 0xF0, 0x29, 0x40, 0x2F, 0xF0, 0x20, 0x10, 0x3F, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*9E70*/
const unsigned char  uc2_9E71 [] = {0x11, 0x20, 0x3F, 0xF0, 0x25, 0x20, 0x35, 0xF0, 0x2B, 0x50, 0x3E, 0xE0, 0x03, 0x50, 0x7D, 0xF0, 0x03, 0x20, 0x04, 0xC0, 0x1B, 0x30, 0x00, 0x00 }; /*9E71*/
const unsigned char  uc2_9E73 [] = {0x14, 0x40, 0x7F, 0xE0, 0x2A, 0xA0, 0x14, 0xE0, 0x7E, 0xA0, 0x28, 0xF0, 0x3E, 0x10, 0x29, 0xD0, 0x3E, 0x10, 0x28, 0x20, 0x3E, 0xC0, 0x00, 0x00 }; /*9E73*/
const unsigned char  uc2_9E7E [] = {0x11, 0x40, 0x1F, 0xF0, 0x10, 0x80, 0x7F, 0xE0, 0x44, 0x80, 0x6F, 0xF0, 0x55, 0x00, 0x6D, 0xE0, 0x46, 0x80, 0x7C, 0x80, 0x47, 0xF0, 0x00, 0x00 }; /*9E7E*/
const unsigned char  uc2_9E7F [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x80, 0x3F, 0xE0, 0x24, 0xA0, 0x3F, 0xE0, 0x28, 0x90, 0x2E, 0xE0, 0x29, 0x90, 0x4E, 0x90, 0x48, 0x60, 0x00, 0x00 }; /*9E7F*/
const unsigned char  uc2_9E82 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0xA0, 0x3F, 0xE0, 0x24, 0xA0, 0x3F, 0xC0, 0x2B, 0x50, 0x2C, 0xE0, 0x27, 0x90, 0x44, 0x90, 0x58, 0x60, 0x00, 0x00 }; /*9E82*/
const unsigned char  uc2_9E87 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0xA0, 0x3F, 0xE0, 0x28, 0x50, 0x2E, 0x60, 0x29, 0x50, 0x3F, 0xF0, 0x25, 0x40, 0x59, 0x30, 0x41, 0x00, 0x00, 0x00 }; /*9E87*/
const unsigned char  uc2_9E88 [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x80, 0x3F, 0xF0, 0x24, 0x90, 0x3F, 0xF0, 0x2A, 0xA0, 0x25, 0x50, 0x2F, 0xE0, 0x21, 0x00, 0x5F, 0xF0, 0x00, 0x00 }; /*9E88*/
const unsigned char  uc2_9E8B [] = {0x01, 0x00, 0x3F, 0xF0, 0x25, 0x20, 0x3F, 0xE0, 0x29, 0x50, 0x2E, 0xE0, 0x29, 0x20, 0x25, 0x40, 0x3F, 0xF0, 0x25, 0x40, 0x59, 0x30, 0x00, 0x00 }; /*9E8B*/
const unsigned char  uc2_9E92 [] = {0x08, 0xA0, 0x3F, 0xF0, 0x28, 0xA0, 0x3E, 0xE0, 0x2A, 0xA0, 0x3E, 0xE0, 0x24, 0xA0, 0x37, 0xF0, 0x24, 0xA0, 0x36, 0x90, 0x41, 0x10, 0x00, 0x00 }; /*9E92*/
const unsigned char  uc2_9E93 [] = {0x08, 0x80, 0x7F, 0xF0, 0x15, 0x40, 0x2A, 0xA0, 0x3F, 0xF0, 0x24, 0x80, 0x3F, 0xE0, 0x24, 0xA0, 0x3F, 0xE0, 0x29, 0x50, 0x4E, 0xE0, 0x00, 0x00 }; /*9E93*/
const unsigned char  uc2_9E9D [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0xA0, 0x3F, 0xE0, 0x2A, 0x90, 0x2F, 0x70, 0x29, 0x20, 0x29, 0xF0, 0x3F, 0x20, 0x25, 0xA0, 0x5B, 0x60, 0x00, 0x00 }; /*9E9D*/
const unsigned char  uc2_9E9F [] = {0x09, 0x50, 0x7E, 0xA0, 0x55, 0xF0, 0x7E, 0xA0, 0x55, 0x50, 0x7F, 0x20, 0x55, 0xF0, 0x5E, 0xA0, 0x55, 0xF0, 0x5F, 0x20, 0x54, 0x20, 0x00, 0x00 }; /*9E9F*/
const unsigned char  uc2_9EA6 [] = {0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x7F, 0xF0, 0x04, 0x00, 0x07, 0xC0, 0x78, 0x40, 0x07, 0x80, 0x78, 0x70, 0x00, 0x00 }; /*9EA6*/
const unsigned char  uc2_9EB4 [] = {0x09, 0x00, 0x7F, 0xF0, 0x29, 0x10, 0x2A, 0xB0, 0x55, 0x50, 0x67, 0xF0, 0x10, 0x90, 0x1D, 0xD0, 0x66, 0xB0, 0x18, 0x90, 0x64, 0x60, 0x00, 0x00 }; /*9EB4*/
const unsigned char  uc2_9EB8 [] = {0x10, 0x80, 0x7C, 0x80, 0x13, 0xE0, 0x38, 0x80, 0x10, 0x80, 0x7F, 0xF0, 0x10, 0x80, 0x1C, 0x80, 0x65, 0x40, 0x19, 0x40, 0x66, 0x30, 0x00, 0x00 }; /*9EB8*/
const unsigned char  uc2_9EBB [] = {0x02, 0x00, 0x3F, 0xF0, 0x24, 0x80, 0x3F, 0xF0, 0x24, 0x80, 0x25, 0xC0, 0x2E, 0xA0, 0x35, 0xA0, 0x24, 0x90, 0x24, 0x80, 0x44, 0x80, 0x00, 0x00 }; /*9EBB*/
const unsigned char  uc2_9EBD [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x24, 0x40, 0x2E, 0xE0, 0x35, 0x50, 0x24, 0x80, 0x39, 0x20, 0x22, 0x60, 0x4F, 0x90, 0x00, 0x00 }; /*9EBD*/
const unsigned char  uc2_9EBE [] = {0x01, 0x00, 0x3F, 0xF0, 0x24, 0x40, 0x3F, 0xF0, 0x35, 0x50, 0x2E, 0x00, 0x23, 0x80, 0x2E, 0x00, 0x23, 0xC0, 0x3E, 0x10, 0x41, 0xE0, 0x00, 0x00 }; /*9EBE*/
const unsigned char  uc2_9EC4 [] = {0x08, 0x80, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x22, 0x20, 0x3F, 0xE0, 0x22, 0x20, 0x3F, 0xE0, 0x08, 0x40, 0x30, 0x20, 0x00, 0x00 }; /*9EC4*/
const unsigned char  uc2_9EC9 [] = {0x12, 0x40, 0x7F, 0xF0, 0x48, 0x90, 0x1F, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x60, 0x30, 0x00, 0x00 }; /*9EC9*/
const unsigned char  uc2_9ECD [] = {0x01, 0xE0, 0x3E, 0x00, 0x02, 0x00, 0x7F, 0xF0, 0x12, 0x40, 0x6D, 0xB0, 0x12, 0x40, 0x72, 0xB0, 0x0B, 0x00, 0x12, 0xC0, 0x6C, 0x20, 0x00, 0x00 }; /*9ECD*/
const unsigned char  uc2_9ECE [] = {0x39, 0x00, 0x11, 0xF0, 0x7E, 0x50, 0x10, 0x50, 0x39, 0x90, 0x56, 0x20, 0x1B, 0xC0, 0x6A, 0xB0, 0x07, 0x00, 0x1A, 0xC0, 0x66, 0x20, 0x00, 0x00 }; /*9ECE*/
const unsigned char  uc2_9ECF [] = {0x3E, 0x40, 0x08, 0x40, 0x7F, 0x70, 0x1A, 0x40, 0x69, 0x40, 0x18, 0x40, 0x65, 0xF0, 0x2B, 0x10, 0x1D, 0x10, 0x2B, 0xF0, 0x59, 0x10, 0x00, 0x00 }; /*9ECF*/
const unsigned char  uc2_9ED1 [] = {0x3F, 0xE0, 0x32, 0x60, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x29, 0x20, 0x24, 0x90, 0x44, 0x90, 0x00, 0x00 }; /*9ED1*/
const unsigned char  uc2_9ED4 [] = {0x7C, 0x40, 0x6C, 0x40, 0x54, 0xA0, 0x55, 0xA0, 0x7E, 0x50, 0x11, 0xE0, 0x7C, 0x20, 0x10, 0x20, 0x7E, 0x40, 0x2A, 0x40, 0x55, 0x80, 0x00, 0x00 }; /*9ED4*/
const unsigned char  uc2_9ED8 [] = {0x7C, 0x80, 0x6C, 0xC0, 0x54, 0xA0, 0x57, 0xF0, 0x7C, 0x80, 0x10, 0x80, 0x7D, 0x40, 0x11, 0x40, 0x7F, 0x20, 0x2A, 0x20, 0x54, 0x10, 0x00, 0x00 }; /*9ED8*/
const unsigned char  uc2_9EDB [] = {0x11, 0x40, 0x6F, 0xE0, 0x20, 0x90, 0x3F, 0xE0, 0x32, 0x60, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*9EDB*/
const unsigned char  uc2_9EDC [] = {0x7C, 0x40, 0x6D, 0x50, 0x55, 0x50, 0x55, 0x50, 0x7D, 0xF0, 0x10, 0x40, 0x7D, 0x50, 0x11, 0x50, 0x7F, 0x50, 0x2B, 0xF0, 0x54, 0x10, 0x00, 0x00 }; /*9EDC*/
const unsigned char  uc2_9EDD [] = {0x7C, 0x40, 0x6D, 0x40, 0x56, 0x40, 0x56, 0xF0, 0x7D, 0x50, 0x11, 0x50, 0x7E, 0x50, 0x13, 0x50, 0x7E, 0x50, 0x2A, 0x90, 0x55, 0x60, 0x00, 0x00 }; /*9EDD*/
const unsigned char  uc2_9EDF [] = {0x7C, 0x40, 0x6C, 0x70, 0x55, 0x90, 0x54, 0x70, 0x7C, 0x20, 0x11, 0xC0, 0x7C, 0x70, 0x11, 0xD0, 0x7C, 0x50, 0x28, 0x20, 0x55, 0xC0, 0x00, 0x00 }; /*9EDF*/
const unsigned char  uc2_9EE0 [] = {0x7C, 0x40, 0x6D, 0xF0, 0x54, 0x40, 0x54, 0x40, 0x7C, 0xE0, 0x10, 0x00, 0x7D, 0xF0, 0x11, 0x10, 0x7D, 0x10, 0x29, 0xF0, 0x55, 0x10, 0x00, 0x00 }; /*9EE0*/
const unsigned char  uc2_9EE2 [] = {0x7C, 0x40, 0x6C, 0x40, 0x54, 0x90, 0x55, 0xF0, 0x7C, 0xA0, 0x13, 0x90, 0x7C, 0xE0, 0x11, 0xA0, 0x7C, 0xA0, 0x28, 0x40, 0x55, 0xB0, 0x00, 0x00 }; /*9EE2*/
const unsigned char  uc2_9EE5 [] = {0x7C, 0x40, 0x6D, 0xF0, 0x54, 0x00, 0x55, 0xF0, 0x7D, 0x10, 0x11, 0xF0, 0x7C, 0x40, 0x11, 0x60, 0x7D, 0x50, 0x2A, 0x50, 0x55, 0x80, 0x00, 0x00 }; /*9EE5*/
const unsigned char  uc2_9EE7 [] = {0x3E, 0x80, 0x08, 0xF0, 0x7F, 0x50, 0x2A, 0xA0, 0x7F, 0xE0, 0x2A, 0xA0, 0x3F, 0xE0, 0x02, 0x00, 0x7F, 0xF0, 0x29, 0x20, 0x44, 0x90, 0x00, 0x00 }; /*9EE7*/
const unsigned char  uc2_9EE9 [] = {0x7C, 0x40, 0x6F, 0xF0, 0x54, 0x40, 0x57, 0xF0, 0x7D, 0x50, 0x12, 0xE0, 0x7D, 0x40, 0x13, 0xF0, 0x7C, 0x40, 0x2A, 0xA0, 0x55, 0x20, 0x00, 0x00 }; /*9EE9*/
const unsigned char  uc2_9EEA [] = {0x7C, 0x40, 0x6C, 0x40, 0x54, 0xA0, 0x55, 0xD0, 0x7C, 0x80, 0x13, 0xF0, 0x7C, 0xA0, 0x13, 0x30, 0x7C, 0xC0, 0x28, 0x20, 0x55, 0xC0, 0x00, 0x00 }; /*9EEA*/
const unsigned char  uc2_9EEF [] = {0x7C, 0x80, 0x6F, 0xE0, 0x55, 0x40, 0x55, 0x40, 0x7F, 0xF0, 0x10, 0x00, 0x7F, 0xE0, 0x12, 0x20, 0x7F, 0xE0, 0x2A, 0x20, 0x57, 0xE0, 0x00, 0x00 }; /*9EEF*/
const unsigned char  uc2_9EF9 [] = {0x28, 0xA0, 0x18, 0xC0, 0x08, 0x80, 0x7F, 0xF0, 0x12, 0x40, 0x0A, 0x80, 0x3F, 0xE0, 0x22, 0x20, 0x27, 0x20, 0x2A, 0xA0, 0x22, 0x60, 0x00, 0x00 }; /*9EF9*/
const unsigned char  uc2_9EFB [] = {0x55, 0xA0, 0x36, 0x90, 0x15, 0xF0, 0x7E, 0x80, 0x2A, 0xF0, 0x14, 0x90, 0x7E, 0xD0, 0x4A, 0xA0, 0x56, 0xA0, 0x6A, 0xA0, 0x4D, 0x50, 0x00, 0x00 }; /*9EFB*/
const unsigned char  uc2_9EFC [] = {0x28, 0x60, 0x6C, 0x50, 0x29, 0xF0, 0x7C, 0x40, 0x55, 0xF0, 0x29, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x6D, 0xF0, 0x55, 0x50, 0x59, 0x20, 0x00, 0x00 }; /*9EFC*/
const unsigned char  uc2_9EFE [] = {0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x04, 0x00, 0x7F, 0xC0, 0x44, 0x40, 0x7F, 0xC0, 0x44, 0x40, 0x7F, 0xD0, 0x44, 0x50, 0x03, 0xE0, 0x00, 0x00 }; /*9EFE*/
const unsigned char  uc2_9F0B [] = {0x1F, 0x80, 0x00, 0x00, 0x7F, 0xE0, 0x10, 0x90, 0x6F, 0x70, 0x09, 0x00, 0x3F, 0xC0, 0x22, 0x40, 0x3F, 0xC0, 0x22, 0x50, 0x3D, 0xF0, 0x00, 0x00 }; /*9F0B*/
const unsigned char  uc2_9F0D [] = {0x3D, 0xE0, 0x25, 0x20, 0x3F, 0xE0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x1F, 0xC0, 0x12, 0x50, 0x1D, 0xF0, 0x00, 0x00 }; /*9F0D*/
const unsigned char  uc2_9F0E [] = {0x07, 0xC0, 0x04, 0x40, 0x17, 0xD0, 0x14, 0x50, 0x17, 0xD0, 0x14, 0x50, 0x1F, 0xF0, 0x02, 0x80, 0x3E, 0xF0, 0x0A, 0x90, 0x72, 0x90, 0x00, 0x00 }; /*9F0E*/
const unsigned char  uc2_9F10 [] = {0x7F, 0xC0, 0x10, 0x40, 0x1F, 0xF0, 0x28, 0x90, 0x4F, 0xB0, 0x28, 0xA0, 0x3F, 0xE0, 0x05, 0x00, 0x3D, 0xE0, 0x25, 0x20, 0x45, 0x20, 0x00, 0x00 }; /*9F10*/
const unsigned char  uc2_9F13 [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x3E, 0x40, 0x01, 0xE0, 0x3E, 0xA0, 0x22, 0xA0, 0x3E, 0x40, 0x24, 0x40, 0x16, 0xA0, 0x79, 0x10, 0x00, 0x00 }; /*9F13*/
const unsigned char  uc2_9F17 [] = {0x05, 0x00, 0x15, 0x40, 0x0D, 0x80, 0x15, 0x50, 0x7E, 0xA0, 0x09, 0xF0, 0x3E, 0x40, 0x23, 0xE0, 0x3E, 0xA0, 0x14, 0x40, 0x7F, 0xB0, 0x00, 0x00 }; /*9F17*/
const unsigned char  uc2_9F19 [] = {0x08, 0x40, 0x7F, 0xF0, 0x08, 0x40, 0x3E, 0xA0, 0x14, 0x40, 0x7F, 0xB0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x01, 0x00, 0x00, 0x00 }; /*9F19*/
const unsigned char  uc2_9F20 [] = {0x04, 0x00, 0x79, 0xE0, 0x40, 0x20, 0x79, 0xE0, 0x40, 0x20, 0x7F, 0xE0, 0x55, 0x40, 0x6E, 0xC0, 0x55, 0x50, 0x4C, 0xD0, 0x77, 0x20, 0x00, 0x00 }; /*9F20*/
const unsigned char  uc2_9F22 [] = {0x10, 0xA0, 0x6C, 0xA0, 0x44, 0xA0, 0x6D, 0x20, 0x46, 0x10, 0x7D, 0xE0, 0x54, 0xA0, 0x7C, 0xA0, 0x54, 0xA0, 0x7D, 0x20, 0x52, 0x40, 0x00, 0x00 }; /*9F22*/
const unsigned char  uc2_9F2C [] = {0x10, 0x40, 0x6C, 0x40, 0x45, 0xF0, 0x6D, 0x50, 0x45, 0x50, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0x50, 0x55, 0x50, 0x7D, 0xF0, 0x53, 0x10, 0x00, 0x00 }; /*9F2C*/
const unsigned char  uc2_9F2F [] = {0x13, 0xF0, 0x6C, 0x80, 0x45, 0xE0, 0x6C, 0xA0, 0x47, 0xF0, 0x7C, 0x00, 0x55, 0xE0, 0x7D, 0x20, 0x55, 0x20, 0x7D, 0xE0, 0x53, 0x20, 0x00, 0x00 }; /*9F2F*/
const unsigned char  uc2_9F37 [] = {0x10, 0x30, 0x6D, 0xD0, 0x45, 0x50, 0x6C, 0xA0, 0x45, 0xC0, 0x7C, 0xA0, 0x55, 0xF0, 0x7C, 0x50, 0x55, 0xF0, 0x7C, 0xA0, 0x53, 0x10, 0x00, 0x00 }; /*9F37*/
const unsigned char  uc2_9F39 [] = {0x10, 0xE0, 0x6C, 0xA0, 0x44, 0xE0, 0x6C, 0xA0, 0x44, 0x40, 0x7D, 0xF0, 0x55, 0x50, 0x7D, 0xF0, 0x54, 0xA0, 0x7C, 0x40, 0x53, 0xB0, 0x00, 0x00 }; /*9F39*/
const unsigned char  uc2_9F3B [] = {0x04, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x08, 0x80, 0x1F, 0xC0, 0x12, 0x40, 0x1F, 0xC0, 0x12, 0x40, 0x7F, 0xF0, 0x08, 0x80, 0x00, 0x00 }; /*9F3B*/
const unsigned char  uc2_9F3D [] = {0x11, 0x00, 0x29, 0x00, 0x3B, 0xC0, 0x29, 0x40, 0x7D, 0x40, 0x55, 0x40, 0x7D, 0x40, 0x55, 0x50, 0x7F, 0x50, 0x29, 0x50, 0x4A, 0x20, 0x00, 0x00 }; /*9F3D*/
const unsigned char  uc2_9F3E [] = {0x08, 0x00, 0x14, 0xE0, 0x1C, 0x40, 0x14, 0x40, 0x3E, 0x40, 0x2B, 0xF0, 0x3E, 0x40, 0x2A, 0x40, 0x7F, 0x40, 0x14, 0x40, 0x64, 0x40, 0x00, 0x00 }; /*9F3E*/
const unsigned char  uc2_9F44 [] = {0x08, 0x40, 0x1D, 0xF0, 0x14, 0xE0, 0x1D, 0x50, 0x14, 0xE0, 0x3E, 0xA0, 0x2A, 0xE0, 0x3E, 0xA0, 0x2A, 0xE0, 0x7F, 0x00, 0x15, 0xF0, 0x00, 0x00 }; /*9F44*/
const unsigned char  uc2_9F50 [] = {0x02, 0x00, 0x7F, 0xF0, 0x08, 0x80, 0x07, 0x00, 0x18, 0xC0, 0x68, 0xB0, 0x08, 0x80, 0x08, 0x80, 0x08, 0x80, 0x10, 0x80, 0x60, 0x80, 0x00, 0x00 }; /*9F50*/
const unsigned char  uc2_9F51 [] = {0x02, 0x00, 0x7F, 0xF0, 0x10, 0x40, 0x0F, 0x80, 0x75, 0x70, 0x2D, 0x60, 0x35, 0xA0, 0x2D, 0x60, 0x35, 0xA0, 0x29, 0x60, 0x5F, 0xA0, 0x00, 0x00 }; /*9F51*/
const unsigned char  uc2_9F7F [] = {0x02, 0x00, 0x12, 0x00, 0x13, 0xC0, 0x12, 0x00, 0x7F, 0xF0, 0x00, 0x00, 0x22, 0x20, 0x25, 0x20, 0x28, 0xA0, 0x3F, 0xE0, 0x00, 0x20, 0x00, 0x00 }; /*9F7F*/
const unsigned char  uc2_9F80 [] = {0x08, 0x40, 0x2E, 0x40, 0x28, 0x40, 0x7F, 0x50, 0x00, 0x60, 0x2A, 0xC0, 0x2A, 0x40, 0x36, 0x50, 0x22, 0x50, 0x2E, 0x50, 0x32, 0x20, 0x00, 0x00 }; /*9F80*/
const unsigned char  uc2_9F83 [] = {0x08, 0xE0, 0x2E, 0xA0, 0x28, 0xA0, 0x7F, 0xE0, 0x00, 0xA0, 0x2A, 0xA0, 0x2A, 0xE0, 0x36, 0xA0, 0x22, 0xA0, 0x2E, 0xA0, 0x33, 0xF0, 0x00, 0x00 }; /*9F83*/
const unsigned char  uc2_9F84 [] = {0x08, 0x40, 0x2E, 0x40, 0x28, 0xA0, 0x7F, 0x10, 0x00, 0xC0, 0x2A, 0x20, 0x2B, 0xF0, 0x36, 0x20, 0x22, 0xC0, 0x2E, 0x20, 0x32, 0x20, 0x00, 0x00 }; /*9F84*/
const unsigned char  uc2_9F85 [] = {0x09, 0x00, 0x2D, 0xE0, 0x2A, 0x20, 0x7F, 0xA0, 0x02, 0xA0, 0x2B, 0xA0, 0x2E, 0x20, 0x32, 0xC0, 0x26, 0x10, 0x3A, 0x10, 0x01, 0xE0, 0x00, 0x00 }; /*9F85*/
const unsigned char  uc2_9F86 [] = {0x09, 0xF0, 0x2E, 0x90, 0x28, 0x90, 0x7F, 0x60, 0x00, 0x00, 0x2A, 0xF0, 0x2A, 0x90, 0x36, 0x90, 0x22, 0x90, 0x2E, 0xF0, 0x32, 0x90, 0x00, 0x00 }; /*9F86*/
const unsigned char  uc2_9F87 [] = {0x11, 0x40, 0x5D, 0x40, 0x51, 0x40, 0x7D, 0x50, 0x11, 0xE0, 0x55, 0x40, 0x5D, 0x40, 0x65, 0x50, 0x4D, 0x50, 0x75, 0xD0, 0x06, 0x20, 0x00, 0x00 }; /*9F87*/
const unsigned char  uc2_9F88 [] = {0x11, 0xE0, 0x5D, 0x20, 0x51, 0xE0, 0x7F, 0x20, 0x11, 0xE0, 0x55, 0x50, 0x5D, 0x50, 0x65, 0x20, 0x4D, 0x20, 0x75, 0xD0, 0x05, 0x00, 0x00, 0x00 }; /*9F88*/
const unsigned char  uc2_9F89 [] = {0x09, 0xE0, 0x2E, 0x40, 0x29, 0xE0, 0x7E, 0xA0, 0x01, 0xF0, 0x2A, 0x00, 0x2A, 0xE0, 0x36, 0xA0, 0x22, 0xA0, 0x2E, 0xE0, 0x32, 0xA0, 0x00, 0x00 }; /*9F89*/
const unsigned char  uc2_9F8A [] = {0x08, 0xF0, 0x2E, 0x90, 0x28, 0x90, 0x7F, 0x90, 0x08, 0xF0, 0x2A, 0xA0, 0x2A, 0xB0, 0x36, 0xA0, 0x22, 0xA0, 0x2F, 0x60, 0x32, 0x30, 0x00, 0x00 }; /*9F8A*/
const unsigned char  uc2_9F8B [] = {0x10, 0x30, 0x5D, 0xC0, 0x50, 0x40, 0x7F, 0xF0, 0x11, 0x50, 0x55, 0xF0, 0x54, 0x40, 0x6D, 0xF0, 0x45, 0x50, 0x4D, 0xB0, 0x75, 0x20, 0x00, 0x00 }; /*9F8B*/
const unsigned char  uc2_9F8C [] = {0x0B, 0xF0, 0x2E, 0x10, 0x2B, 0xF0, 0x7E, 0x00, 0x0B, 0xF0, 0x2A, 0xA0, 0x2B, 0xF0, 0x36, 0x50, 0x22, 0xE0, 0x26, 0x40, 0x3F, 0xF0, 0x00, 0x00 }; /*9F8C*/
const unsigned char  uc2_9F99 [] = {0x08, 0x80, 0x08, 0x40, 0x7F, 0xF0, 0x0A, 0x00, 0x0A, 0x40, 0x12, 0x40, 0x12, 0x80, 0x13, 0x10, 0x22, 0x10, 0x26, 0x10, 0x59, 0xE0, 0x00, 0x00 }; /*9F99*/
const unsigned char  uc2_9F9A [] = {0x08, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x13, 0x20, 0x6D, 0xE0, 0x08, 0x80, 0x3F, 0xE0, 0x08, 0x80, 0x7F, 0xF0, 0x08, 0x40, 0x30, 0x20, 0x00, 0x00 }; /*9F9A*/
const unsigned char  uc2_9F9B [] = {0x07, 0x00, 0x18, 0xC0, 0x67, 0x30, 0x1D, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x04, 0x80, 0x7F, 0xF0, 0x0A, 0x80, 0x13, 0x10, 0x6D, 0xF0, 0x00, 0x00 }; /*9F9B*/
const unsigned char  uc2_9F9F [] = {0x08, 0x00, 0x1E, 0x00, 0x62, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0xA0, 0x24, 0xA0, 0x04, 0x20, 0x03, 0xC0, 0x00, 0x00 }; /*9F9F*/
const unsigned char  uc2_9FA0 [] = {0x07, 0x00, 0x18, 0xC0, 0x6F, 0xB0, 0x00, 0x00, 0x77, 0x70, 0x55, 0x50, 0x7F, 0xF0, 0x48, 0x90, 0x7F, 0xF0, 0x48, 0x90, 0x40, 0x60, 0x00, 0x00 }; /*9FA0*/
const unsigned char  uc2_BEE1 [] = {0x00, 0x60, 0x55, 0x20, 0x2a, 0xa0, 0x3b, 0xa0, 0x2a, 0xe0, 0x2a, 0xa0, 0x00, 0x00, 0x08, 0x20, 0x1f, 0xe0, 0x08, 0x02, 0x0f, 0xe0, 0x00, 0x00 }; /*BEE1*/
const unsigned char  uc2_CF5C [] = {0x3f, 0xc0, 0x00, 0x40, 0x3f, 0xc0, 0x00, 0x04, 0x02, 0x00, 0x7f, 0xe0, 0x00, 0x00, 0x3f, 0xc0, 0x00, 0x40, 0x3f, 0xc0, 0x10, 0x00, 0x1f, 0xc0 }; /*CF5C*/
const unsigned char  uc2_CF5D [] = {0xff, 0xe0, 0x84, 0x20, 0x84, 0x20, 0x84, 0x20, 0xbf, 0xa0, 0x84, 0x20, 0xbf, 0xa0, 0x84, 0x20, 0x84, 0x20, 0x84, 0x20, 0x84, 0x20, 0x00, 0x00 }; /*CF5D*/
const unsigned char  uc2_CF5E [] = {0x04, 0x00, 0x02, 0x00, 0x03, 0xfe, 0x20, 0x00, 0x2A, 0x40, 0x2A, 0x40, 0x2A, 0x80, 0x4a, 0x80, 0x41, 0x00, 0x81, 0x00, 0x9f, 0xe0, 0x00, 0x00 }; /*CF5E*/
const unsigned char  uc2_F000 [] = {0x00, 0x00, 0x0E, 0x00, 0x11, 0x00, 0x11, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F001 [] = {0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F002 [] = {0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x04, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F003 [] = {0x04, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F004 [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F005 [] = {0x00, 0x00, 0x7F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F006 [] = {0x00, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F007 [] = {0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x04, 0x00, 0x08, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F008 [] = {0x00, 0x00, 0x7E, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x80, 0x02, 0x80, 0x01, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F009 [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F011 [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F013 [] = {0x00, 0x00, 0x1F, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F016 [] = {0x08, 0x00, 0x08, 0x00, 0x7F, 0xC0, 0x08, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F019 [] = {0x00, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F01E [] = {0x00, 0x00, 0x08, 0x00, 0x08, 0x00, 0x0F, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F021 [] = {0x3F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F022 [] = {0x3F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F023 [] = {0x1E, 0x00, 0x12, 0x00, 0x14, 0x00, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x14, 0x00, 0x10, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F024 [] = {0x04, 0x00, 0x0F, 0xC0, 0x10, 0x80, 0x61, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F025 [] = {0x03, 0x80, 0x3C, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F026 [] = {0x04, 0x00, 0x0F, 0xC0, 0x10, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F027 [] = {0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x06, 0x00, 0x1A, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F028 [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F02A [] = {0x10, 0x80, 0x08, 0x80, 0x05, 0x00, 0x02, 0x00, 0x03, 0x00, 0x05, 0x00, 0x08, 0x80, 0x10, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F02C [] = {0x10, 0x00, 0x1F, 0xC0, 0x20, 0x40, 0x40, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F02E [] = {0x20, 0x00, 0x22, 0x00, 0x2C, 0x00, 0x30, 0x00, 0x20, 0x00, 0x21, 0x00, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F032 [] = {0x00, 0x00, 0x04, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F033 [] = {0x08, 0x00, 0x04, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F034 [] = {0x02, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x03, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F035 [] = {0x00, 0x00, 0x3F, 0xC0, 0x20, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F036 [] = {0x00, 0x40, 0x20, 0x40, 0x10, 0x80, 0x09, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F03C [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0xC0, 0x04, 0x40, 0x04, 0x40, 0x08, 0x40, 0x11, 0x40, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F03D [] = {0x3F, 0x80, 0x10, 0x80, 0x11, 0x00, 0x09, 0x00, 0x06, 0x00, 0x06, 0x00, 0x09, 0x00, 0x30, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F03E [] = {0x3F, 0xC0, 0x08, 0x80, 0x09, 0x00, 0x09, 0xC0, 0x10, 0x40, 0x10, 0x40, 0x20, 0x40, 0x41, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F03F [] = {0x02, 0x00, 0x02, 0x00, 0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x11, 0x00, 0x3F, 0x80, 0x00, 0x40, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F042 [] = {0x04, 0x00, 0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F043 [] = {0x00, 0x00, 0x11, 0x00, 0x7F, 0xC0, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F044 [] = {0x00, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F045 [] = {0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F046 [] = {0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F04B [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F050 [] = {0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x05, 0x00, 0x0E, 0x00, 0x14, 0x00, 0x04, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F054 [] = {0x00, 0x00, 0x3F, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x3F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F055 [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x25, 0x80, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F056 [] = {0x04, 0x00, 0x04, 0x00, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F05A [] = {0x01, 0x00, 0x09, 0x00, 0x05, 0x00, 0x01, 0x00, 0x03, 0x00, 0x05, 0x00, 0x09, 0x00, 0x01, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F05D [] = {0x04, 0x00, 0x0A, 0x00, 0x14, 0x00, 0x0C, 0x00, 0x14, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F05F [] = {0x10, 0x00, 0x1F, 0x80, 0x20, 0x80, 0x51, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x08, 0x00, 0x70, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F060 [] = {0x08, 0x00, 0x1F, 0x00, 0x22, 0x00, 0x54, 0x00, 0x0C, 0x00, 0x13, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F062 [] = {0x03, 0x80, 0x3C, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F067 [] = {0x0F, 0x80, 0x08, 0x00, 0x0F, 0x80, 0x08, 0x00, 0x1F, 0xC0, 0x04, 0x00, 0x09, 0x00, 0x1E, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F069 [] = {0x11, 0x00, 0x0A, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F06A [] = {0x10, 0x00, 0x08, 0x00, 0x20, 0x00, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 0x20, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F06B [] = {0x02, 0x00, 0x02, 0x00, 0x03, 0x00, 0x06, 0x80, 0x06, 0x80, 0x0A, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F06D [] = {0x04, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F06F [] = {0x08, 0x00, 0x1F, 0x00, 0x15, 0x00, 0x24, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F070 [] = {0x02, 0x00, 0x1F, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F071 [] = {0x04, 0x00, 0x00, 0x00, 0x7F, 0xC0, 0x40, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F072 [] = {0x10, 0x00, 0x0B, 0xC0, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F074 [] = {0x00, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F077 [] = {0x3F, 0xC0, 0x00, 0x40, 0x3F, 0xC0, 0x20, 0x00, 0x3F, 0xC0, 0x00, 0x40, 0x02, 0x40, 0x01, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F078 [] = {0x02, 0x00, 0x04, 0x00, 0x3F, 0xE0, 0x08, 0x80, 0x11, 0x00, 0x0E, 0x00, 0x0B, 0x00, 0x30, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F07A [] = {0x00, 0x00, 0x04, 0x80, 0x24, 0x80, 0x15, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F07B [] = {0x00, 0x00, 0x08, 0x40, 0x24, 0x80, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F07C [] = {0x3F, 0x80, 0x01, 0x00, 0x06, 0x00, 0x04, 0xC0, 0x1F, 0x00, 0x64, 0x00, 0x04, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F07D [] = {0x3F, 0x00, 0x01, 0x00, 0x11, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x7E, 0x40, 0x01, 0x40, 0x00, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F07E [] = {0x02, 0x00, 0x04, 0x80, 0x1F, 0x00, 0x02, 0x00, 0x05, 0x80, 0x1E, 0x00, 0x03, 0x80, 0x1C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F07F [] = {0x02, 0x00, 0x04, 0x80, 0x09, 0x00, 0x1E, 0x00, 0x04, 0x00, 0x09, 0x00, 0x1F, 0x80, 0x00, 0x40, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F080 [] = {0x00, 0x00, 0x12, 0x20, 0x22, 0x40, 0x24, 0x40, 0x48, 0x80, 0x24, 0x40, 0x22, 0x40, 0x12, 0x20, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F081 [] = {0x14, 0x00, 0x08, 0x00, 0x14, 0x00, 0x04, 0x00, 0x0C, 0x00, 0x14, 0x00, 0x04, 0x00, 0x08, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F082 [] = {0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F083 [] = {0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F084 [] = {0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x60, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F089 [] = {0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F08E [] = {0x08, 0x80, 0x3F, 0x00, 0x0A, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x08, 0x00, 0x10, 0x00, 0x60, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F08F [] = {0x11, 0x00, 0x11, 0x00, 0x7F, 0xC0, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F090 [] = {0x00, 0x00, 0x09, 0x00, 0x1F, 0x80, 0x09, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F091 [] = {0x00, 0x00, 0x3F, 0x80, 0x06, 0x00, 0x04, 0x00, 0x0D, 0x00, 0x14, 0x80, 0x24, 0x00, 0x04, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F092 [] = {0x00, 0x00, 0x3F, 0x80, 0x06, 0x00, 0x04, 0x00, 0x0D, 0x00, 0x14, 0x80, 0x24, 0x00, 0x04, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F094 [] = {0x7F, 0x80, 0x10, 0x00, 0x1F, 0x00, 0x31, 0x00, 0x4A, 0x00, 0x04, 0x00, 0x08, 0x00, 0x70, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F095 [] = {0x10, 0x00, 0x3F, 0x00, 0x14, 0x00, 0x3F, 0x00, 0x04, 0x00, 0x1F, 0x00, 0x24, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F098 [] = {0x1F, 0x80, 0x11, 0x00, 0x21, 0x00, 0x3F, 0xC0, 0x09, 0x00, 0x11, 0x00, 0x61, 0x00, 0x07, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0A3 [] = {0x12, 0x00, 0x12, 0x00, 0x1F, 0x80, 0x10, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x21, 0x00, 0x41, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0A5 [] = {0x00, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0A7 [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0A8 [] = {0x3F, 0x80, 0x20, 0x80, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x2A, 0x80, 0x11, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0AA [] = {0x08, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x80, 0x1F, 0x80, 0x04, 0x80, 0x08, 0x80, 0x10, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0AD [] = {0x02, 0x00, 0x0A, 0x00, 0x0F, 0x00, 0x12, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0A, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0AE [] = {0x04, 0x00, 0x14, 0x00, 0x3F, 0x80, 0x44, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0B4 [] = {0x06, 0x00, 0x38, 0x00, 0x08, 0x00, 0x3E, 0x00, 0x08, 0x00, 0x7F, 0x00, 0x08, 0x80, 0x0F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0B5 [] = {0x08, 0x00, 0x1F, 0x80, 0x20, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x3F, 0x80, 0x01, 0x20, 0x00, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
//const unsigned char  uc2_F0b5 [] = {0x08, 0x00, 0x1F, 0x80, 0x20, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x3F, 0x80, 0x01, 0x20, 0x00, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F0B9 [] = {0x03, 0xC0, 0x7C, 0x00, 0x00, 0x80, 0x25, 0x00, 0x15, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0BB [] = {0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x24, 0xC0, 0x5F, 0x80, 0x01, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0BD [] = {0x09, 0x00, 0x10, 0x80, 0x30, 0xC0, 0x49, 0x20, 0x06, 0x00, 0x06, 0x00, 0x09, 0x00, 0x30, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0BF [] = {0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x10, 0x80, 0x21, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0C0 [] = {0x01, 0xC0, 0x1E, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x12, 0x00, 0x11, 0x00, 0x15, 0x40, 0x18, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0C6 [] = {0x04, 0x00, 0x3F, 0x80, 0x11, 0x00, 0x11, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x31, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F0C7 [] = {0x04, 0x00, 0x3F, 0xC0, 0x08, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x10, 0x80, 0x12, 0x80, 0x21, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0C8 [] = {0x04, 0x00, 0x14, 0x80, 0x15, 0x00, 0x24, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0CA [] = {0x02, 0x00, 0x1F, 0xC0, 0x10, 0x40, 0x1F, 0xC0, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0CD [] = {0x04, 0x00, 0x1F, 0x00, 0x02, 0x00, 0x04, 0x00, 0x0D, 0x00, 0x34, 0x80, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0D7 [] = {0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x11, 0x00, 0x60, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0D9 [] = {0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x11, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0DE [] = {0x3F, 0xC0, 0x08, 0x00, 0x10, 0x00, 0x3F, 0x80, 0x50, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0DF [] = {0x04, 0x00, 0x05, 0x00, 0x3F, 0xC0, 0x0A, 0x00, 0x0A, 0x80, 0x13, 0x00, 0x12, 0x40, 0x25, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0E3 [] = {0x00, 0x00, 0x09, 0x00, 0x29, 0x40, 0x29, 0x40, 0x19, 0x80, 0x19, 0x80, 0x09, 0x00, 0x7F, 0xE0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0E5 [] = {0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0E7 [] = {0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0E8 [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0ED [] = {0x00, 0x00, 0x3F, 0xC0, 0x29, 0x40, 0x29, 0x40, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0F7 [] = {0x01, 0x00, 0x1E, 0x00, 0x10, 0x00, 0x10, 0x00, 0x1F, 0x00, 0x12, 0x00, 0x12, 0x00, 0x3F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0FB [] = {0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x24, 0x80, 0x5F, 0x40, 0x02, 0x00, 0x0C, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0FE [] = {0x08, 0x00, 0x0F, 0x00, 0x10, 0x00, 0x1F, 0x00, 0x24, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x06, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F0FF [] = {0x10, 0x00, 0x1F, 0x00, 0x24, 0x00, 0x44, 0x00, 0x3F, 0x80, 0x0A, 0x00, 0x11, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F100 [] = {0x03, 0x00, 0x1C, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x0E, 0x00, 0x15, 0x00, 0x24, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F101 [] = {0x10, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F105 [] = {0x02, 0x00, 0x1F, 0xC0, 0x30, 0x00, 0x10, 0x00, 0x30, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F108 [] = {0x04, 0x00, 0x1F, 0x00, 0x02, 0x00, 0x05, 0x00, 0x1E, 0x00, 0x05, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F10A [] = {0x04, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x00, 0x80, 0x10, 0x80, 0x11, 0x00, 0x09, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F10C [] = {0x04, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x20, 0x80, 0x0A, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x20, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F112 [] = {0x1F, 0x80, 0x01, 0x00, 0x02, 0x00, 0x3F, 0xC0, 0x06, 0x80, 0x0A, 0x00, 0x12, 0x00, 0x26, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F115 [] = {0x04, 0x00, 0x7F, 0xC0, 0x1F, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x0E, 0x00, 0x15, 0x00, 0x64, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F11A [] = {0x3F, 0xC0, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0x80, 0x7F, 0xE0, 0x00, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F11B [] = {0x3F, 0xC0, 0x24, 0x00, 0x3F, 0x00, 0x21, 0x00, 0x21, 0x00, 0x3F, 0x00, 0x24, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F11C [] = {0x00, 0x00, 0x3F, 0xC0, 0x09, 0x00, 0x3F, 0xC0, 0x29, 0x40, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F120 [] = {0x3F, 0xE0, 0x05, 0x00, 0x25, 0x20, 0x25, 0x40, 0x15, 0x80, 0x15, 0x80, 0x05, 0x00, 0x3F, 0xE0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F122 [] = {0x02, 0x00, 0x03, 0x80, 0x3F, 0xE0, 0x23, 0x00, 0x2E, 0x40, 0x23, 0xC0, 0x40, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F125 [] = {0x04, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x80, 0x07, 0xC0, 0x78, 0x60, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F127 [] = {0x08, 0x00, 0x1F, 0xC0, 0x22, 0x00, 0x3F, 0xE0, 0x02, 0x00, 0x12, 0x40, 0x1F, 0xC0, 0x10, 0x40, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F128 [] = {0x03, 0x80, 0x0E, 0x00, 0x02, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x0F, 0x80, 0x08, 0x80, 0x0F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F12A [] = {0x21, 0x00, 0x3D, 0xE0, 0x29, 0x40, 0x4A, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F12B [] = {0x04, 0x00, 0x08, 0x00, 0x33, 0x80, 0x20, 0x80, 0x3B, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F12C [] = {0x08, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F12F [] = {0x08, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x24, 0x80, 0x7F, 0xC0, 0x20, 0x80, 0x24, 0x80, 0x41, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F138 [] = {0x11, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x3F, 0x80, 0x7F, 0xC0, 0x08, 0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F139 [] = {0x11, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F13A [] = {0x04, 0x00, 0x15, 0x00, 0x0E, 0x00, 0x3F, 0x80, 0x15, 0x00, 0x15, 0x00, 0x24, 0x80, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F140 [] = {0x7B, 0xC0, 0x08, 0x40, 0x29, 0x40, 0x18, 0xC0, 0x18, 0xC0, 0x6B, 0x40, 0x08, 0x40, 0x31, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F147 [] = {0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x7F, 0xC0, 0x14, 0x00, 0x17, 0x80, 0x34, 0x00, 0x4F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F148 [] = {0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x7F, 0xC0, 0x11, 0x00, 0x31, 0x80, 0x51, 0x40, 0x23, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F149 [] = {0x3F, 0x80, 0x00, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x11, 0x00, 0x0A, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F14A [] = {0x04, 0x00, 0x3F, 0x80, 0x1F, 0x00, 0x15, 0x00, 0x1F, 0x00, 0x0E, 0x00, 0x15, 0x00, 0x24, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F14B [] = {0x3F, 0x80, 0x0A, 0x00, 0x3F, 0x80, 0x2A, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F155 [] = {0x1F, 0x00, 0x11, 0x00, 0x1F, 0x00, 0x04, 0x00, 0x16, 0x00, 0x14, 0x00, 0x17, 0x00, 0x3C, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F15A [] = {0x08, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x10, 0xC0, 0x3F, 0x80, 0x06, 0x80, 0x39, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F15D [] = {0x0A, 0x00, 0x14, 0x00, 0x2A, 0x00, 0x76, 0x00, 0x0A, 0x00, 0x16, 0x00, 0x0A, 0x00, 0x36, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F15F [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F162 [] = {0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x3F, 0x80, 0x40, 0x40, 0x1F, 0x00, 0x11, 0x00, 0x1F, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F164 [] = {0x15, 0x00, 0x0E, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x2E, 0x80, 0x35, 0x80, 0x24, 0x80, 0x25, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F166 [] = {0x06, 0x00, 0x1F, 0x80, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x09, 0x00, 0x0F, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F168 [] = {0x04, 0x00, 0x3F, 0x80, 0x1F, 0x00, 0x7F, 0xC0, 0x11, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x23, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F16B [] = {0x09, 0x00, 0x1F, 0x80, 0x09, 0x00, 0x0F, 0x00, 0x09, 0x00, 0x3F, 0xC0, 0x09, 0x00, 0x10, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F16E [] = {0x00, 0x00, 0x0A, 0x00, 0x7B, 0xC0, 0x0A, 0x00, 0x3B, 0x80, 0x0A, 0x00, 0x7B, 0xC0, 0x0A, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F16F [] = {0x04, 0x00, 0x17, 0x00, 0x14, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x2A, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F171 [] = {0x0A, 0x00, 0x10, 0x00, 0x3F, 0x80, 0x57, 0x00, 0x12, 0x00, 0x17, 0x00, 0x12, 0x00, 0x1F, 0x80, 0x00, 0x00, 0xBA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F172 [] = {0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x3F, 0x80, 0x44, 0x40, 0x3F, 0x80, 0x15, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F173 [] = {0x1F, 0x00, 0x22, 0x00, 0x1F, 0x80, 0x14, 0x80, 0x1F, 0x80, 0x14, 0x80, 0x1F, 0x80, 0x7F, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F175 [] = {0x0A, 0x00, 0x3F, 0x80, 0x0E, 0x00, 0x1F, 0x00, 0x15, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F17C [] = {0x1F, 0x00, 0x13, 0x00, 0x7F, 0xC0, 0x5F, 0x40, 0x11, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x23, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F17E [] = {0x08, 0x00, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x3F, 0x80, 0x0C, 0x80, 0x15, 0x60, 0x63, 0xE0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F180 [] = {0x04, 0x00, 0x3F, 0x80, 0x11, 0x00, 0x7F, 0xC0, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F186 [] = {0x04, 0x00, 0x7F, 0xC0, 0x49, 0x00, 0x7F, 0xC0, 0x5D, 0x80, 0x5B, 0x80, 0x6D, 0x40, 0x49, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F187 [] = {0x04, 0x00, 0x3F, 0xC0, 0x29, 0x00, 0x3F, 0x80, 0x3F, 0x80, 0x2D, 0x80, 0x2B, 0x40, 0x4D, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x40, 0x00, 0x10};
const unsigned char  uc2_F18A [] = {0x7F, 0xC0, 0x55, 0x40, 0x7F, 0xC0, 0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x7F, 0xC0, 0x2A, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F18B [] = {0x3C, 0x80, 0x27, 0xE0, 0x3D, 0x40, 0x23, 0xE0, 0x3C, 0x80, 0x37, 0xE0, 0x54, 0x80, 0x5C, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F18D [] = {0x30, 0x00, 0x67, 0x00, 0x73, 0x00, 0x7F, 0x00, 0x49, 0x00, 0x6D, 0x00, 0x49, 0x00, 0x6C, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F192 [] = {0x1F, 0x00, 0x11, 0x00, 0x15, 0x00, 0x15, 0x00, 0x15, 0x00, 0x15, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F193 [] = {0x04, 0x00, 0x3F, 0x80, 0x08, 0x00, 0x14, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F195 [] = {0x20, 0x00, 0x17, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x21, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F196 [] = {0x3F, 0x80, 0x20, 0x80, 0x2A, 0x80, 0x24, 0x80, 0x24, 0x80, 0x2A, 0x80, 0x20, 0x40, 0x40, 0x20, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F19A [] = {0x3E, 0x00, 0x02, 0x00, 0x12, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x7E, 0x80, 0x00, 0x80, 0x01, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F19D [] = {0x1F, 0x00, 0x22, 0x00, 0x7F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F1A5 [] = {0x04, 0x00, 0x17, 0x00, 0x14, 0x00, 0x7F, 0xC0, 0x24, 0x80, 0x2A, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F1A6 [] = {0x04, 0x00, 0x05, 0x00, 0x3F, 0xC0, 0x0A, 0x00, 0x0A, 0x80, 0x13, 0x00, 0x12, 0x40, 0x25, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F1A9 [] = {0x00, 0x00, 0x08, 0x00, 0x08, 0x00, 0x3F, 0x00, 0x09, 0x00, 0x09, 0x00, 0x11, 0x40, 0x21, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F1AA [] = {0x3F, 0xC0, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x0C, 0x00, 0x00, 0x00, 0xA2, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F1FF [] = {0x08, 0x00, 0x1F, 0x00, 0x15, 0x00, 0x24, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F20C [] = {0x04, 0x00, 0x0F, 0xC0, 0x18, 0x80, 0x25, 0x00, 0x52, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x70, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F20D [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F211 [] = {0x04, 0x00, 0x0F, 0xC0, 0x18, 0x80, 0x25, 0x00, 0x52, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x70, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F238 [] = {0x06, 0x00, 0x11, 0x00, 0x11, 0x00, 0x3F, 0x80, 0x49, 0x40, 0x09, 0x00, 0x11, 0x00, 0x26, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F244 [] = {0x09, 0x00, 0x09, 0x00, 0x2D, 0xC0, 0x29, 0x00, 0x29, 0x00, 0x29, 0x40, 0x2D, 0x40, 0x70, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F249 [] = {0x00, 0x00, 0x04, 0x00, 0x07, 0xC0, 0x04, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F24B [] = {0x04, 0x00, 0x7F, 0xC0, 0x04, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x3F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F25B [] = {0x00, 0x00, 0x10, 0x00, 0x3D, 0xC0, 0x15, 0x40, 0x15, 0x40, 0x15, 0x40, 0x15, 0xC0, 0x2D, 0x40, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F263 [] = {0x11, 0x00, 0x7F, 0xC0, 0x3F, 0x80, 0x2E, 0x80, 0x3F, 0x80, 0x04, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F278 [] = {0x08, 0x00, 0x1F, 0x80, 0x21, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x1F, 0xC0, 0x00, 0x40, 0x1F, 0xC0, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F27F [] = {0x04, 0x00, 0x09, 0x00, 0x1E, 0x00, 0x04, 0x80, 0x09, 0x00, 0x1E, 0x00, 0x04, 0x00, 0x38, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F28C [] = {0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x3F, 0x80, 0x68, 0xC0, 0x3A, 0x80, 0x2A, 0x80, 0x59, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F29A [] = {0x00, 0x00, 0x10, 0x00, 0x1F, 0x80, 0x20, 0x80, 0x3F, 0x80, 0x01, 0x00, 0x02, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F2B6 [] = {0x1F, 0x00, 0x10, 0x00, 0x1F, 0x00, 0x10, 0x00, 0x3F, 0x80, 0x08, 0x00, 0x11, 0x00, 0x3E, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F2E6 [] = {0x12, 0x00, 0x73, 0x80, 0x12, 0x00, 0x73, 0x80, 0x12, 0x00, 0x73, 0x80, 0x12, 0x00, 0x22, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F2EA [] = {0x1F, 0x00, 0x13, 0x00, 0x7F, 0xC0, 0x5F, 0x40, 0x11, 0x00, 0x1F, 0x00, 0x11, 0x00, 0x23, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F311 [] = {0x11, 0x00, 0x7F, 0xC0, 0x0A, 0x00, 0x3F, 0x80, 0x2A, 0x80, 0x33, 0x80, 0x2E, 0x80, 0x3F, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F325 [] = {0x00, 0x00, 0x1F, 0xC0, 0x02, 0x00, 0x3F, 0xE0, 0x2A, 0xA0, 0x2A, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F32B [] = {0x04, 0x00, 0x07, 0x00, 0x1C, 0x00, 0x0E, 0x00, 0x1F, 0x00, 0x0E, 0x00, 0x15, 0x00, 0x24, 0x80, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F38A [] = {0x04, 0x00, 0x09, 0x00, 0x3E, 0x00, 0x04, 0x00, 0x0B, 0x00, 0x3C, 0x00, 0x03, 0x00, 0x3C, 0x00, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F38F [] = {0x11, 0x00, 0x7D, 0xE0, 0x3A, 0x40, 0x7D, 0x40, 0x21, 0x40, 0x38, 0x80, 0x29, 0x80, 0x5A, 0x60, 0x00, 0x00, 0xAA, 0xA0, 0x55, 0x50, 0x00, 0x00 };
const unsigned char  uc2_F405 [] = {0x10, 0x00, 0x20, 0x00, 0x3F, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x12, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F406 [] = {0x10, 0x00, 0x3F, 0x80, 0x00, 0x80, 0x11, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x31, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F407 [] = {0x00, 0x00, 0x1F, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F408 [] = {0x00, 0x00, 0x3F, 0x80, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x1F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F409 [] = {0x10, 0x00, 0x20, 0x00, 0x3F, 0xC0, 0x08, 0x40, 0x08, 0x40, 0x08, 0x40, 0x12, 0x80, 0x21, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F40A [] = {0x04, 0x00, 0x04, 0x00, 0x3F, 0x80, 0x08, 0x00, 0x10, 0x00, 0x12, 0x00, 0x3F, 0x00, 0x00, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F40B [] = {0x1F, 0x80, 0x01, 0x00, 0x02, 0x00, 0x0F, 0xC0, 0x00, 0x40, 0x00, 0x40, 0x04, 0x80, 0x03, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F40C [] = {0x0A, 0x00, 0x12, 0x00, 0x1F, 0xC0, 0x04, 0x40, 0x04, 0x40, 0x04, 0x40, 0x09, 0x40, 0x10, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F40D [] = {0x00, 0x00, 0x04, 0x80, 0x04, 0x80, 0x09, 0x00, 0x12, 0x00, 0x09, 0x00, 0x04, 0x80, 0x04, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F40E [] = {0x00, 0x00, 0x3F, 0x80, 0x08, 0x00, 0x1F, 0x00, 0x01, 0x00, 0x01, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F40F [] = {0x00, 0x00, 0x1F, 0x80, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F410 [] = {0x01, 0x00, 0x11, 0x00, 0x11, 0x00, 0x13, 0x00, 0x15, 0x00, 0x19, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F411 [] = {0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x10, 0x00, 0x08, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F412 [] = {0x00, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F413 [] = {0x04, 0x00, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x3F, 0x80, 0x04, 0x00, 0x04, 0x00, 0x7F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F414 [] = {0x02, 0x00, 0x04, 0x80, 0x09, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0A, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F415 [] = {0x00, 0x00, 0x3F, 0x80, 0x00, 0x80, 0x1F, 0x80, 0x10, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F416 [] = {0x1F, 0x80, 0x10, 0x80, 0x14, 0x80, 0x12, 0x80, 0x12, 0x80, 0x10, 0x80, 0x10, 0x80, 0x1F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F417 [] = {0x3F, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x15, 0x00, 0x12, 0x00, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F418 [] = {0x10, 0x00, 0x7F, 0x80, 0x10, 0x00, 0x20, 0x00, 0x3F, 0x00, 0x01, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F419 [] = {0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x7F, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F41A [] = {0x20, 0x80, 0x11, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F41B [] = {0x00, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x1C, 0x00, 0x24, 0x00, 0x20, 0x80, 0x11, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F41C [] = {0x04, 0x00, 0x3F, 0x80, 0x04, 0x00, 0x1C, 0x00, 0x24, 0x00, 0x20, 0x80, 0x11, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F41D [] = {0x09, 0x00, 0x09, 0x00, 0x3F, 0xC0, 0x09, 0x00, 0x09, 0x00, 0x09, 0x00, 0x04, 0x00, 0x03, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F41E [] = {0x00, 0x00, 0x3F, 0xC0, 0x12, 0x00, 0x24, 0x00, 0x3F, 0x80, 0x08, 0x80, 0x10, 0x80, 0x21, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F41F [] = {0x04, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F420 [] = {0x08, 0x00, 0x11, 0x00, 0x22, 0x00, 0x14, 0x00, 0x08, 0x00, 0x12, 0x00, 0x26, 0x00, 0x39, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F421 [] = {0x00, 0x00, 0x3F, 0x80, 0x00, 0x80, 0x11, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x31, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F422 [] = {0x3F, 0x80, 0x04, 0x80, 0x09, 0x00, 0x1F, 0xC0, 0x00, 0x40, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F423 [] = {0x08, 0x00, 0x10, 0x00, 0x20, 0x00, 0x3F, 0x80, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x04, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F424 [] = {0x08, 0x00, 0x08, 0x00, 0x3F, 0x80, 0x08, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x12, 0x00, 0x21, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F425 [] = {0x02, 0x00, 0x02, 0x00, 0x04, 0x00, 0x04, 0x00, 0x08, 0x00, 0x08, 0x00, 0x10, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F426 [] = {0x0A, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x12, 0x00, 0x21, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F427 [] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F428 [] = {0x00, 0x00, 0x20, 0x80, 0x11, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x20, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F429 [] = {0x00, 0x00, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x0F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F431 [] = {0x00, 0x00, 0x0C, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F432 [] = {0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x12, 0x00, 0x02, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F433 [] = {0x00, 0x00, 0x1C, 0x00, 0x02, 0x00, 0x04, 0x00, 0x0C, 0x00, 0x02, 0x00, 0x02, 0x00, 0x1C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F434 [] = {0x00, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0A, 0x00, 0x0F, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F435 [] = {0x00, 0x00, 0x01, 0x80, 0x02, 0x00, 0x03, 0x00, 0x00, 0x80, 0x00, 0x80, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F461 [] = {0x00, 0x00, 0x0F, 0x00, 0x10, 0x80, 0x00, 0x80, 0x0F, 0x80, 0x10, 0x80, 0x11, 0x80, 0x0E, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F462 [] = {0x00, 0x00, 0x18, 0x00, 0x08, 0x00, 0x0B, 0x00, 0x0C, 0x80, 0x08, 0x80, 0x0C, 0x80, 0x1B, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F463 [] = {0x00, 0x00, 0x00, 0x00, 0x1E, 0x80, 0x21, 0x80, 0x40, 0x00, 0x40, 0x00, 0x20, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F464 [] = {0x00, 0x00, 0x03, 0x00, 0x01, 0x00, 0x0D, 0x00, 0x13, 0x00, 0x21, 0x00, 0x13, 0x00, 0x0D, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F465 [] = {0x00, 0x00, 0x0E, 0x00, 0x11, 0x00, 0x20, 0x80, 0x3F, 0x80, 0x20, 0x00, 0x10, 0x80, 0x0F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F466 [] = {0x00, 0x00, 0x07, 0x80, 0x08, 0x00, 0x3F, 0x00, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F467 [] = {0x00, 0x00, 0x0E, 0xC0, 0x11, 0x80, 0x20, 0x80, 0x11, 0x80, 0x0E, 0x80, 0x00, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F468 [] = {0x00, 0x00, 0x30, 0x00, 0x10, 0x00, 0x16, 0x00, 0x19, 0x00, 0x11, 0x00, 0x11, 0x00, 0x3B, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F469 [] = {0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x04, 0x00, 0x04, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F46A [] = {0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F46B [] = {0x00, 0x00, 0x30, 0x00, 0x13, 0x80, 0x12, 0x00, 0x14, 0x00, 0x1C, 0x00, 0x12, 0x00, 0x33, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F46C [] = {0x00, 0x00, 0x0C, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F46D [] = {0x00, 0x00, 0x69, 0x00, 0x36, 0x80, 0x24, 0x80, 0x24, 0x80, 0x24, 0x80, 0x76, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F46E [] = {0x00, 0x00, 0x00, 0x00, 0x37, 0x00, 0x18, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0x80, 0x39, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F46F [] = {0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x11, 0x00, 0x20, 0x80, 0x20, 0x80, 0x11, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F470 [] = {0x00, 0x00, 0x37, 0x00, 0x18, 0x80, 0x10, 0x40, 0x10, 0x40, 0x18, 0x80, 0x17, 0x00, 0x38, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F471 [] = {0x00, 0x00, 0x0E, 0xC0, 0x11, 0x80, 0x20, 0x80, 0x20, 0x80, 0x11, 0x80, 0x0E, 0x80, 0x01, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F472 [] = {0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x1C, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F473 [] = {0x00, 0x00, 0x1E, 0x80, 0x21, 0x80, 0x20, 0x00, 0x1F, 0x00, 0x00, 0x80, 0x20, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F474 [] = {0x00, 0x00, 0x10, 0x00, 0x10, 0x00, 0x3E, 0x00, 0x10, 0x00, 0x10, 0x00, 0x11, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F475 [] = {0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x11, 0x00, 0x11, 0x00, 0x11, 0x00, 0x13, 0x00, 0x0D, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F476 [] = {0x00, 0x00, 0x10, 0x80, 0x00, 0x00, 0x31, 0x80, 0x10, 0x80, 0x10, 0x80, 0x11, 0x80, 0x0E, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F477 [] = {0x00, 0x00, 0x71, 0x80, 0x20, 0x80, 0x20, 0x80, 0x11, 0x00, 0x15, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
/*SPR 1956, Changed bitmap for code F478 from u with umlaut to an X*/
const unsigned char  uc2_F478 [] = {0x00, 0x00, 0x60, 0xC0, 0x11, 0x00, 0x0a, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x11, 0x00, 0x60, 0xC0, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F479 [] = {0x00, 0x00, 0x71, 0xC0, 0x20, 0x80, 0x11, 0x00, 0x0A, 0x00, 0x04, 0x00, 0x04, 0x00, 0x18, 0x00, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
const unsigned char  uc2_F47A [] = {0x00, 0x00, 0x00, 0x00, 0x1F, 0x80, 0x00, 0x80, 0x03, 0x00, 0x0C, 0x00, 0x10, 0x80, 0x1F, 0x80, 0x00, 0x00, 0x55, 0x40, 0x2A, 0xA0, 0x00, 0x00 };
//const unsigned char  uc2_rubbish[] = {0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0, 0xff, 0xe0};


/*GW Added the following characters*/
const unsigned char  uc2_4E28 [] = {0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00 }; /*GW*/
//const unsigned char  uc2_4E3B [] = {0x08, 0x00, 0x04, 0x00, 0x00, 0x20, 0x7F, 0xE0, 0x04, 0x40, 0x04, 0x00, 0x3F, 0xC0, 0x04, 0x00, 0x04, 0x20, 0x7F, 0xE0, 0x00, 0x00, 0x00, 0x00 }; /*GW*/
const unsigned char  uc2_4EA0 [] = {0x00, 0x00, 0x10, 0x00, 0x10, 0x02, 0x10, 0x02, 0x7F, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }; /*GW*/
const unsigned char  uc2_4EBB [] = {0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x02, 0x00, 0x06, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00 }; /*GW*/
//const unsigned char  uc2_4EE3 [] = {0x12, 0x40, 0x12, 0x20, 0x22, 0x00, 0x67, 0xC0, 0x42, 0x00, 0x42, 0x00, 0x41, 0x00, 0x41, 0x00, 0x40, 0x82, 0x40, 0x80, 0x40, 0x42, 0x00, 0x00 }; /*GW*/
//const unsigned char  uc2_4EE5 [] = {0x20, 0x80, 0x28, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x20, 0x80, 0x28, 0x80, 0x30, 0x80, 0x21, 0x40, 0x02, 0x20, 0x0C, 0x20, 0x00, 0x00 }; /*GW*/
const unsigned char  uc2_5182 [] = {0x00, 0x00, 0x7F, 0xE0, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x20, 0x40, 0x60, 0x00, 0x00, 0x00, 0x00 }; /*GW*/
const unsigned char  uc2_5196 [] = {0x00, 0x00, 0x00, 0x00, 0x1F, 0xE0, 0x20, 0x40, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }; /*GW*/
const unsigned char  uc2_51AB [] = {0x00, 0x00, 0x44, 0x00, 0xC4, 0x00, 0x08, 0x00, 0x08, 0x00, 0x10, 0x00, 0x30, 0x00, 0xF0, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x00, 0x00 }; /*API-51AB*/
const unsigned char  uc2_5202 [] = {0x00, 0x40, 0x00, 0x60, 0x04, 0x40, 0x06, 0x40, 0x04, 0x40, 0x04, 0x40, 0x04, 0X40, 0x04, 0x40, 0x00, 0x40, 0x03, 0xC0, 0x01, 0x80, 0x00, 0x00 }; /*API-5202*/
const unsigned char  uc2_531A [] = {0x40, 0x40, 0x7F, 0x70, 0x60, 0x00, 0x60, 0x00, 0x60, 0x00, 0x60, 0x00, 0x60, 0x00, 0x60, 0x00, 0x60, 0x40, 0xFF, 0xE0, 0x04, 0x00, 0x00, 0x00 }; /*API-531A*/
const unsigned char  uc2_5369 [] = {0x10, 0x40, 0x1F, 0xE0, 0x10, 0x40, 0x10, 0x40, 0x10, 0x40, 0x17, 0xC0, 0x11, 0x80, 0x11, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00 }; /*API-5369*/
const unsigned char  uc2_6C35 [] = {0x04, 0x00, 0x02, 0x00, 0x08, 0x00, 0x0C, 0x00, 0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x00, 0x00 }; /*6C35*//*SPR 1299*/
const unsigned char  uc2_72AD [] = {0x08, 0x00, 0x60, 0x00, 0x10, 0x00, 0x30, 0x00, 0x40, 0x00, 0x0F, 0x00, 0x18, 0x00, 0x68, 0x00, 0x08, 0x00, 0x10, 0x00, 0x60, 0x00, 0x00, 0x00 }; /*GW*/
const unsigned char  uc2_7E9F [] = {0x00, 0x00, 0x04, 0x00, 0x08, 0x00, 0x11, 0x00, 0x22, 0x00, 0x3C, 0x00, 0x08, 0x00, 0x10, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x1E, 0x00, 0x00, 0x00 }; /*API-7E9F*/
const unsigned char  uc2_961D [] = {0x81, 0x00, 0xFE, 0x00, 0xC6, 0x00, 0xC4, 0x00, 0xC8, 0x00, 0xC4, 0x00, 0xC6, 0x00, 0xC4, 0x00, 0xD0, 0x00, 0xC0, 0x00, 0x80, 0x00, 0x00, 0x00 }; /*API-961D*/

#endif



#define NUM_BITMAPS_FONT0  /*257*/267




#ifndef LSCREEN
static const t_font_bitmap database0[NUM_BITMAPS_FONT0] =
{
	{0x0000,1,12,6,12,(char*) uc2_0000},
	{0x0001,1,12,6,12,(char*) uc2_0001},
	{0x0002,1,12,6,12,(char*) uc2_0002},
	{0x0003,1,12,6,12,(char*) uc2_0003},
	{0x0004,1,12,6,12,(char*) uc2_0004},
	{0x0005,1,12,6,12,(char*) uc2_0005},
	{0x0006,1,12,6,12,(char*) uc2_0006},
	{0x0007,1,12,6,12,(char*) uc2_0007},
	{0x0008,1,12,6,12,(char*) uc2_0008},
	{0x0009,1,12,6,12,(char*) uc2_0009},
	{0x000A,1,12,6,12,(char*) uc2_000A},
	{0x000B,1,12,6,12,(char*) uc2_000B},
	{0x000C,1,12,6,12,(char*) uc2_000C},
	{0x000D,1,12,6,12,(char*) uc2_000D},
	{0x000E,1,12,6,12,(char*) uc2_000E},
	{0x000F,1,12,6,12,(char*) uc2_000F},
	{0x0010,1,12,6,12,(char*) uc2_0010},
	{0x0011,1,12,6,12,(char*) uc2_0011},
	{0x0012,1,12,6,12,(char*) uc2_0012},
	{0x0013,1,12,6,12,(char*) uc2_0013},
	{0x0014,1,12,6,12,(char*) uc2_0014},
	{0x0015,1,12,6,12,(char*) uc2_0015},
	{0x0016,1,12,6,12,(char*) uc2_0016},
	{0x0017,1,12,6,12,(char*) uc2_0017},
	{0x0018,1,12,6,12,(char*) uc2_0018},
	{0x0019,1,12,6,12,(char*) uc2_0019},
	{0x001A,1,12,6,12,(char*) uc2_001A},
	{0x001B,1,12,6,12,(char*) uc2_001B},
	{0x001C,1,12,6,12,(char*) uc2_001C},
	{0x001D,1,12,6,12,(char*) uc2_001D},
	{0x001E,1,12,6,12,(char*) uc2_001E},
	{0x001F,1,12,6,12,(char*) uc2_001F},
	{0x0020,1,12,6,12,(char*) uc2_0020},
	{0x0021,1,12,6,12,(char*) uc2_0021},
	{0x0022,1,12,6,12,(char*) uc2_0022},
	{0x0023,1,12,6,12,(char*) uc2_0023},
	{0x0024,1,12,6,12,(char*) uc2_0024},
	{0x0025,1,12,6,12,(char*) uc2_0025},
	{0x0026,1,12,6,12,(char*) uc2_0026},
	{0x0027,1,12,6,12,(char*) uc2_0027},
	{0x0028,1,12,6,12,(char*) uc2_0028},
	{0x0029,1,12,6,12,(char*) uc2_0029},
	{0x002A,1,12,6,12,(char*) uc2_002A},
	{0x002B,1,12,6,12,(char*) uc2_002B},
	{0x002C,1,12,6,12,(char*) uc2_002C},
	{0x002D,1,12,6,12,(char*) uc2_002D},
	{0x002E,1,12,6,12,(char*) uc2_002E},
	{0x002F,1,12,6,12,(char*) uc2_002F},
	{0x0030,1,12,6,12,(char*) uc2_0030},
	{0x0031,1,12,6,12,(char*) uc2_0031},
	{0x0032,1,12,6,12,(char*) uc2_0032},
	{0x0033,1,12,6,12,(char*) uc2_0033},
	{0x0034,1,12,6,12,(char*) uc2_0034},
	{0x0035,1,12,6,12,(char*) uc2_0035},
	{0x0036,1,12,6,12,(char*) uc2_0036},
	{0x0037,1,12,6,12,(char*) uc2_0037},
	{0x0038,1,12,6,12,(char*) uc2_0038},
	{0x0039,1,12,6,12,(char*) uc2_0039},
	{0x003A,1,12,6,12,(char*) uc2_003A},
	{0x003B,1,12,6,12,(char*) uc2_003B},
	{0x003C,1,12,6,12,(char*) uc2_003C},
	{0x003D,1,12,6,12,(char*) uc2_003D},
	{0x003E,1,12,6,12,(char*) uc2_003E},
	{0x003F,1,12,6,12,(char*) uc2_003F},
	{0x0040,1,12,6,12,(char*) uc2_0040},
	{0x0041,1,12,6,12,(char*) uc2_0041},
	{0x0042,1,12,6,12,(char*) uc2_0042},
	{0x0043,1,12,6,12,(char*) uc2_0043},
	{0x0044,1,12,6,12,(char*) uc2_0044},
	{0x0045,1,12,6,12,(char*) uc2_0045},
	{0x0046,1,12,6,12,(char*) uc2_0046},
	{0x0047,1,12,6,12,(char*) uc2_0047},
	{0x0048,1,12,6,12,(char*) uc2_0048},
	{0x0049,1,12,6,12,(char*) uc2_0049},
	{0x004A,1,12,6,12,(char*) uc2_004A},
	{0x004B,1,12,6,12,(char*) uc2_004B},
	{0x004C,1,12,6,12,(char*) uc2_004C},
	{0x004D,1,12,6,12,(char*) uc2_004D},
	{0x004E,1,12,6,12,(char*) uc2_004E},
	{0x004F,1,12,6,12,(char*) uc2_004F},
	{0x0050,1,12,6,12,(char*) uc2_0050},
	{0x0051,1,12,6,12,(char*) uc2_0051},
	{0x0052,1,12,6,12,(char*) uc2_0052},
	{0x0053,1,12,6,12,(char*) uc2_0053},
	{0x0054,1,12,6,12,(char*) uc2_0054},
	{0x0055,1,12,6,12,(char*) uc2_0055},
	{0x0056,1,12,6,12,(char*) uc2_0056},
	{0x0057,1,12,6,12,(char*) uc2_0057},
	{0x0058,1,12,6,12,(char*) uc2_0058},
	{0x0059,1,12,6,12,(char*) uc2_0059},
	{0x005A,1,12,6,12,(char*) uc2_005A},
	{0x005B,1,12,6,12,(char*) uc2_005B},
	{0x005C,1,12,6,12,(char*) uc2_005C},
	{0x005D,1,12,6,12,(char*) uc2_005D},
	{0x005E,1,12,6,12,(char*) uc2_005E},
	{0x005F,1,12,6,12,(char*) uc2_005F},
	{0x0060,1,12,6,12,(char*) uc2_0060},
	{0x0061,1,12,6,12,(char*) uc2_0061},
	{0x0062,1,12,6,12,(char*) uc2_0062},
	{0x0063,1,12,6,12,(char*) uc2_0063},
	{0x0064,1,12,6,12,(char*) uc2_0064},
	{0x0065,1,12,6,12,(char*) uc2_0065},
	{0x0066,1,12,6,12,(char*) uc2_0066},
	{0x0067,1,12,6,12,(char*) uc2_0067},
	{0x0068,1,12,6,12,(char*) uc2_0068},
	{0x0069,1,12,6,12,(char*) uc2_0069},
	{0x006A,1,12,6,12,(char*) uc2_006A},
	{0x006B,1,12,6,12,(char*) uc2_006B},
	{0x006C,1,12,6,12,(char*) uc2_006C},
	{0x006D,1,12,6,12,(char*) uc2_006D},
	{0x006E,1,12,6,12,(char*) uc2_006E},
	{0x006F,1,12,6,12,(char*) uc2_006F},
	{0x0070,1,12,6,12,(char*) uc2_0070},
	{0x0071,1,12,6,12,(char*) uc2_0071},
	{0x0072,1,12,6,12,(char*) uc2_0072},
	{0x0073,1,12,6,12,(char*) uc2_0073},
	{0x0074,1,12,6,12,(char*) uc2_0074},
	{0x0075,1,12,6,12,(char*) uc2_0075},
	{0x0076,1,12,6,12,(char*) uc2_0076},
	{0x0077,1,12,6,12,(char*) uc2_0077},
	{0x0078,1,12,6,12,(char*) uc2_0078},
	{0x0079,1,12,6,12,(char*) uc2_0079},
	{0x007A,1,12,6,12,(char*) uc2_007A},
	{0x007B,1,12,6,12,(char*) uc2_007B},
	{0x007C,1,12,6,12,(char*) uc2_007C},
	{0x007D,1,12,6,12,(char*) uc2_007D},
	{0x007E,1,12,6,12,(char*) uc2_007E},
	{0x007F,1,12,6,12,(char*) uc2_007F},
	{0x0080,1,12,6,12,(char*) uc2_0080},
	{0x0081,1,12,6,12,(char*) uc2_0081},
	{0x0082,1,12,6,12,(char*) uc2_0082},
	{0x0083,1,12,6,12,(char*) uc2_0083},
	{0x0084,1,12,6,12,(char*) uc2_0084},
	{0x0085,1,12,6,12,(char*) uc2_0085},
	{0x0086,1,12,6,12,(char*) uc2_0086},
	{0x0087,1,12,6,12,(char*) uc2_0087},
	{0x0088,1,12,6,12,(char*) uc2_0088},
	{0x0089,1,12,6,12,(char*) uc2_0089},
	{0x008A,1,12,6,12,(char*) uc2_008A},
	{0x008B,1,12,6,12,(char*) uc2_008B},
	{0x008C,1,12,6,12,(char*) uc2_008C},
	{0x008D,1,12,6,12,(char*) uc2_008D},
	{0x008E,1,12,6,12,(char*) uc2_008E},
	{0x008F,1,12,6,12,(char*) uc2_008F},
	{0x0090,1,12,6,12,(char*) uc2_0090},
	{0x0091,1,12,6,12,(char*) uc2_0091},
	{0x0092,1,12,6,12,(char*) uc2_0092},
	{0x0093,1,12,6,12,(char*) uc2_0093},
	{0x0094,1,12,6,12,(char*) uc2_0094},
	{0x0095,1,12,6,12,(char*) uc2_0095},
	{0x0096,1,12,6,12,(char*) uc2_0096},
	{0x0097,1,12,6,12,(char*) uc2_0097},
	{0x0098,1,12,6,12,(char*) uc2_0098},
	{0x0099,1,12,6,12,(char*) uc2_0099},
	{0x009A,1,12,6,12,(char*) uc2_009A},
	{0x009B,1,12,6,12,(char*) uc2_009B},
	{0x009C,1,12,6,12,(char*) uc2_009C},
	{0x009D,1,12,6,12,(char*) uc2_009D},
	{0x009E,1,12,6,12,(char*) uc2_009E},
	{0x009F,1,12,6,12,(char*) uc2_009F},
	{0x00A0,1,12,6,12,(char*) uc2_00A0},
	{0x00A1,1,12,6,12,(char*) uc2_00A1},
	{0x00A2,1,12,6,12,(char*) uc2_00A2},
	{0x00A3,1,12,6,12,(char*) uc2_00A3},
	{0x00A4,1,12,6,12,(char*) uc2_00A4},
	{0x00A5,1,12,6,12,(char*) uc2_00A5},
	{0x00A6,1,12,6,12,(char*) uc2_00A6},
	{0x00A7,1,12,6,12,(char*) uc2_00A7},
	{0x00A8,1,12,6,12,(char*) uc2_00A8},
	{0x00A9,1,12,6,12,(char*) uc2_00A9},
	{0x00AA,1,12,6,12,(char*) uc2_00AA},
	{0x00AB,1,12,6,12,(char*) uc2_00AB},
	{0x00AC,1,12,6,12,(char*) uc2_00AC},
	{0x00AD,1,12,6,12,(char*) uc2_00AD},
	{0x00AE,1,12,6,12,(char*) uc2_00AE},
	{0x00AF,1,12,6,12,(char*) uc2_00AF},
	{0x00B0,1,12,6,12,(char*) uc2_00B0},
	{0x00B1,1,12,6,12,(char*) uc2_00B1},
	{0x00B2,1,12,6,12,(char*) uc2_00B2},
	{0x00B3,1,12,6,12,(char*) uc2_00B3},
	{0x00B4,1,12,6,12,(char*) uc2_00B4},
	{0x00B5,1,12,6,12,(char*) uc2_00B5},
	{0x00B6,1,12,6,12,(char*) uc2_00B6},
	{0x00B7,1,12,6,12,(char*) uc2_00B7},
	{0x00B8,1,12,6,12,(char*) uc2_00B8},
	{0x00B9,1,12,6,12,(char*) uc2_00B9},
	{0x00BA,1,12,6,12,(char*) uc2_00BA},
	{0x00BB,1,12,6,12,(char*) uc2_00BB},
	{0x00BC,1,12,6,12,(char*) uc2_00BC},
	{0x00BD,1,12,6,12,(char*) uc2_00BD},
	{0x00BE,1,12,6,12,(char*) uc2_00BE},
	{0x00BF,1,12,6,12,(char*) uc2_00BF},
	{0x00C0,1,12,6,12,(char*) uc2_00C0},
	{0x00C1,1,12,6,12,(char*) uc2_00C1},
	{0x00C2,1,12,6,12,(char*) uc2_00C2},
	{0x00C3,1,12,6,12,(char*) uc2_00C3},
	{0x00C4,1,12,6,12,(char*) uc2_00C4},
	{0x00C5,1,12,6,12,(char*) uc2_00C5},
	{0x00C6,1,12,6,12,(char*) uc2_00C6},
	{0x00C7,1,12,6,12,(char*) uc2_00C7},
	{0x00C8,1,12,6,12,(char*) uc2_00C8},
	{0x00C9,1,12,6,12,(char*) uc2_00C9},
	{0x00CA,1,12,6,12,(char*) uc2_00CA},
	{0x00CB,1,12,6,12,(char*) uc2_00CB},
	{0x00CC,1,12,6,12,(char*) uc2_00CC},
	{0x00CD,1,12,6,12,(char*) uc2_00CD},
	{0x00CE,1,12,6,12,(char*) uc2_00CE},
	{0x00CF,1,12,6,12,(char*) uc2_00CF},
	{0x00D0,1,12,6,12,(char*) uc2_00D0},
	{0x00D1,1,12,6,12,(char*) uc2_00D1},
	{0x00D2,1,12,6,12,(char*) uc2_00D2},
	{0x00D3,1,12,6,12,(char*) uc2_00D3},
	{0x00D4,1,12,6,12,(char*) uc2_00D4},
	{0x00D5,1,12,6,12,(char*) uc2_00D5},
	{0x00D6,1,12,6,12,(char*) uc2_00D6},
	{0x00D7,1,12,6,12,(char*) uc2_00D7},
	{0x00D8,1,12,6,12,(char*) uc2_00D8},
	{0x00D9,1,12,6,12,(char*) uc2_00D9},
	{0x00DA,1,12,6,12,(char*) uc2_00DA},
	{0x00DB,1,12,6,12,(char*) uc2_00DB},
	{0x00DC,1,12,6,12,(char*) uc2_00DC},
	{0x00DD,1,12,6,12,(char*) uc2_00DD},
	{0x00DE,1,12,6,12,(char*) uc2_00DE},
	{0x00DF,1,12,6,12,(char*) uc2_00DF},
	{0x00E0,1,12,6,12,(char*) uc2_00E0},
	{0x00E1,1,12,6,12,(char*) uc2_00E1},
	{0x00E2,1,12,6,12,(char*) uc2_00E2},
	{0x00E3,1,12,6,12,(char*) uc2_00E3},
	{0x00E4,1,12,6,12,(char*) uc2_00E4},
	{0x00E5,1,12,6,12,(char*) uc2_00E5},
	{0x00E6,1,12,6,12,(char*) uc2_00E6},
	{0x00E7,1,12,6,12,(char*) uc2_00E7},
	{0x00E8,1,12,6,12,(char*) uc2_00E8},
	{0x00E9,1,12,6,12,(char*) uc2_00E9},
	{0x00EA,1,12,6,12,(char*) uc2_00EA},
	{0x00EB,1,12,6,12,(char*) uc2_00EB},
	{0x00EC,1,12,6,12,(char*) uc2_00EC},
	{0x00ED,1,12,6,12,(char*) uc2_00ED},
	{0x00EE,1,12,6,12,(char*) uc2_00EE},
	{0x00EF,1,12,6,12,(char*) uc2_00EE},
	{0x00F0,1,12,6,12,(char*) uc2_00F0},
	{0x00F1,1,12,6,12,(char*) uc2_00F1},
	{0x00F2,1,12,6,12,(char*) uc2_00F2},
	{0x00F3,1,12,6,12,(char*) uc2_00F3},
	{0x00F4,1,12,6,12,(char*) uc2_00F4},
	{0x00F5,1,12,6,12,(char*) uc2_00F5},
	{0x00F6,1,12,6,12,(char*) uc2_00F6},
	{0x00F7,1,12,6,12,(char*) uc2_00F7},
	{0x00F8,1,12,6,12,(char*) uc2_00F8},
	{0x00F9,1,12,6,12,(char*) uc2_00F9},
	{0x00FA,1,12,6,12,(char*) uc2_00FA},
	{0x00FB,1,12,6,12,(char*) uc2_00FB},
	{0x00FC,1,12,6,12,(char*) uc2_00FC},
	{0x00FD,1,12,6,12,(char*) uc2_00FD},
	{0x00FE,1,12,6,12,(char*) uc2_00FE},
	{0x00FF,1,12,6,12,(char*) uc2_00FF},
	/* SPR1212 Start: Greek characters */
	{0x0393,1,12,6,12,(char*) uc2_0393},    /* Gamma */
	{0x0394,1,12,6,12,(char*) uc2_0394},    /* Delta */
	{0x0398,1,12,6,12,(char*) uc2_0398},    /* Theta */
	{0x039B,1,12,6,12,(char*) uc2_039B},    /* Lambda */
	{0x039e,1,12,6,12,(char*) uc2_039E},    /* Xi */
	{0x03A0,1,12,6,12,(char*) uc2_03A0},    /* Pi */
	{0x03a3,1,12,6,12,(char*) uc2_03A3},    /* Sigma */
	{0x03A6,1,12,6,12,(char*) uc2_03A6},    /* Phi */
	{0x03A8,1,12,6,12,(char*) uc2_03A8},    /* Psi */
	{0x03A9,1,12,6,12,(char*) uc2_03A9},    /* Omega */
	{0xFFFF, 1, 12, 12, 24, (char *) uc2_rubbish}
	};

#endif
	#ifdef CHINESE_MMI

	#define NUM_BITMAPS_CHINESE_FONT  7033


const t_font_bitmap chinese_chars[NUM_BITMAPS_CHINESE_FONT]=
{	{ 0x0000 , 1 ,12 ,12 ,24 ,(char *) uc2_rubbish },
	{ 0x4E00 , 1 ,12 ,12 ,24 ,(char *) uc2_4E00 },
	{ 0x4E01 , 1 ,12 ,12 ,24 ,(char *) uc2_4E01 },
	{ 0x4E03 , 1 ,12 ,12 ,24 ,(char *) uc2_4E03 },
	{ 0x4E07 , 1 ,12 ,12 ,24 ,(char *) uc2_4E07 },
	{ 0x4E08 , 1 ,12 ,12 ,24 ,(char *) uc2_4E08 },
	{ 0x4E09 , 1 ,12 ,12 ,24 ,(char *) uc2_4E09 },
	{ 0x4E0A , 1 ,12 ,12 ,24 ,(char *) uc2_4E0A },
	{ 0x4E0B , 1 ,12 ,12 ,24 ,(char *) uc2_4E0B },
	{ 0x4E0C , 1 ,12 ,12 ,24 ,(char *) uc2_4E0C },
	{ 0x4E0D , 1 ,12 ,12 ,24 ,(char *) uc2_4E0D },
	{ 0x4E0E , 1 ,12 ,12 ,24 ,(char *) uc2_4E0E },
	{ 0x4E10 , 1 ,12 ,12 ,24 ,(char *) uc2_4E10 },
	{ 0x4E11 , 1 ,12 ,12 ,24 ,(char *) uc2_4E11 },
	{ 0x4E13 , 1 ,12 ,12 ,24 ,(char *) uc2_4E13 },
	{ 0x4E14 , 1 ,12 ,12 ,24 ,(char *) uc2_4E14 },
	{ 0x4E15 , 1 ,12 ,12 ,24 ,(char *) uc2_4E15 },
	{ 0x4E16 , 1 ,12 ,12 ,24 ,(char *) uc2_4E16 },
	{ 0x4E18 , 1 ,12 ,12 ,24 ,(char *) uc2_4E18 },
	{ 0x4E19 , 1 ,12 ,12 ,24 ,(char *) uc2_4E19 },
	{ 0x4E1A , 1 ,12 ,12 ,24 ,(char *) uc2_4E1A },
	{ 0x4E1B , 1 ,12 ,12 ,24 ,(char *) uc2_4E1B },
	{ 0x4E1C , 1 ,12 ,12 ,24 ,(char *) uc2_4E1C },
	{ 0x4E1D , 1 ,12 ,12 ,24 ,(char *) uc2_4E1D },
	{ 0x4E1E , 1 ,12 ,12 ,24 ,(char *) uc2_4E1E },
	{ 0x4E22 , 1 ,12 ,12 ,24 ,(char *) uc2_4E22 },
	{ 0x4E24 , 1 ,12 ,12 ,24 ,(char *) uc2_4E24 },
	{ 0x4E25 , 1 ,12 ,12 ,24 ,(char *) uc2_4E25 },
	{ 0x4E27 , 1 ,12 ,12 ,24 ,(char *) uc2_4E27 },
	{ 0x4E28 , 1 ,12 ,12 ,24 ,(char *) uc2_4E28 }, /* GW */
	{ 0x4E2A , 1 ,12 ,12 ,24 ,(char *) uc2_4E2A },
	{ 0x4E2B , 1 ,12 ,12 ,24 ,(char *) uc2_4E2B },
	{ 0x4E2D , 1 ,12 ,12 ,24 ,(char *) uc2_4E2D },
	{ 0x4E30 , 1 ,12 ,12 ,24 ,(char *) uc2_4E30 },
	{ 0x4E32 , 1 ,12 ,12 ,24 ,(char *) uc2_4E32 },
	{ 0x4E34 , 1 ,12 ,12 ,24 ,(char *) uc2_4E34 },
	{ 0x4E36 , 1 ,12 ,12 ,24 ,(char *) uc2_4E36 },/*SPR 1299*/
	{ 0x4E38 , 1 ,12 ,12 ,24 ,(char *) uc2_4E38 },
	{ 0x4E39 , 1 ,12 ,12 ,24 ,(char *) uc2_4E39 },
	{ 0x4E3A , 1 ,12 ,12 ,24 ,(char *) uc2_4E3A },
	{ 0x4E3B , 1 ,12 ,12 ,24 ,(char *) uc2_4E3B },
	{ 0x4E3D , 1 ,12 ,12 ,24 ,(char *) uc2_4E3D },
	{ 0x4E3E , 1 ,12 ,12 ,24 ,(char *) uc2_4E3E },
	{ 0x4E3F , 1 ,12 ,12 ,24 ,(char *) uc2_4E3F },/*SPR 1299*/
	{ 0x4E43 , 1 ,12 ,12 ,24 ,(char *) uc2_4E43 },
	{ 0x4E45 , 1 ,12 ,12 ,24 ,(char *) uc2_4E45 },
	{ 0x4E47 , 1 ,12 ,12 ,24 ,(char *) uc2_4E47 },
	{ 0x4E48 , 1 ,12 ,12 ,24 ,(char *) uc2_4E48 },
	{ 0x4E49 , 1 ,12 ,12 ,24 ,(char *) uc2_4E49 },
	{ 0x4E4B , 1 ,12 ,12 ,24 ,(char *) uc2_4E4B },
	{ 0x4E4C , 1 ,12 ,12 ,24 ,(char *) uc2_4E4C },
	{ 0x4E4D , 1 ,12 ,12 ,24 ,(char *) uc2_4E4D },
	{ 0x4E4E , 1 ,12 ,12 ,24 ,(char *) uc2_4E4E },
	{ 0x4E4F , 1 ,12 ,12 ,24 ,(char *) uc2_4E4F },
	{ 0x4E50 , 1 ,12 ,12 ,24 ,(char *) uc2_4E50 },
	{ 0x4E52 , 1 ,12 ,12 ,24 ,(char *) uc2_4E52 },
	{ 0x4E53 , 1 ,12 ,12 ,24 ,(char *) uc2_4E53 },
	{ 0x4E54 , 1 ,12 ,12 ,24 ,(char *) uc2_4E54 },
	{ 0x4E56 , 1 ,12 ,12 ,24 ,(char *) uc2_4E56 },
	{ 0x4E58 , 1 ,12 ,12 ,24 ,(char *) uc2_4E58 },
	{ 0x4E59 , 1 ,12 ,12 ,24 ,(char *) uc2_4E59 },
	{ 0x4E5C , 1 ,12 ,12 ,24 ,(char *) uc2_4E5C },
	{ 0x4E5D , 1 ,12 ,12 ,24 ,(char *) uc2_4E5D },
	{ 0x4E5E , 1 ,12 ,12 ,24 ,(char *) uc2_4E5E },
	{ 0x4E5F , 1 ,12 ,12 ,24 ,(char *) uc2_4E5F },
	{ 0x4E60 , 1 ,12 ,12 ,24 ,(char *) uc2_4E60 },
	{ 0x4E61 , 1 ,12 ,12 ,24 ,(char *) uc2_4E61 },
	{ 0x4E66 , 1 ,12 ,12 ,24 ,(char *) uc2_4E66 },
	{ 0x4E69 , 1 ,12 ,12 ,24 ,(char *) uc2_4E69 },
	{ 0x4E70 , 1 ,12 ,12 ,24 ,(char *) uc2_4E70 },
	{ 0x4E71 , 1 ,12 ,12 ,24 ,(char *) uc2_4E71 },
	{ 0x4E73 , 1 ,12 ,12 ,24 ,(char *) uc2_4E73 },
	{ 0x4E7E , 1 ,12 ,12 ,24 ,(char *) uc2_4E7E },
	{ 0x4E86 , 1 ,12 ,12 ,24 ,(char *) uc2_4E86 },
	{ 0x4E88 , 1 ,12 ,12 ,24 ,(char *) uc2_4E88 },
	{ 0x4E89 , 1 ,12 ,12 ,24 ,(char *) uc2_4E89 },
	{ 0x4E8B , 1 ,12 ,12 ,24 ,(char *) uc2_4E8B },
	{ 0x4E8C , 1 ,12 ,12 ,24 ,(char *) uc2_4E8C },
	{ 0x4E8D , 1 ,12 ,12 ,24 ,(char *) uc2_4E8D },
	{ 0x4E8E , 1 ,12 ,12 ,24 ,(char *) uc2_4E8E },
	{ 0x4E8F , 1 ,12 ,12 ,24 ,(char *) uc2_4E8F },
	{ 0x4E91 , 1 ,12 ,12 ,24 ,(char *) uc2_4E91 },
	{ 0x4E92 , 1 ,12 ,12 ,24 ,(char *) uc2_4E92 },
	{ 0x4E93 , 1 ,12 ,12 ,24 ,(char *) uc2_4E93 },
	{ 0x4E94 , 1 ,12 ,12 ,24 ,(char *) uc2_4E94 },
	{ 0x4E95 , 1 ,12 ,12 ,24 ,(char *) uc2_4E95 },
	{ 0x4E98 , 1 ,12 ,12 ,24 ,(char *) uc2_4E98 },
	{ 0x4E9A , 1 ,12 ,12 ,24 ,(char *) uc2_4E9A },
	{ 0x4E9B , 1 ,12 ,12 ,24 ,(char *) uc2_4E9B },
	{ 0x4E9F , 1 ,12 ,12 ,24 ,(char *) uc2_4E9F },
	{ 0x4EA0 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA0 }, /* GW */
	{ 0x4EA1 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA1 },
	{ 0x4EA2 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA2 },
	{ 0x4EA4 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA4 },
	{ 0x4EA5 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA5 },
	{ 0x4EA6 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA6 },
	{ 0x4EA7 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA7 },
	{ 0x4EA8 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA8 },
	{ 0x4EA9 , 1 ,12 ,12 ,24 ,(char *) uc2_4EA9 },
	{ 0x4EAB , 1 ,12 ,12 ,24 ,(char *) uc2_4EAB },
	{ 0x4EAC , 1 ,12 ,12 ,24 ,(char *) uc2_4EAC },
	{ 0x4EAD , 1 ,12 ,12 ,24 ,(char *) uc2_4EAD },
	{ 0x4EAE , 1 ,12 ,12 ,24 ,(char *) uc2_4EAE },
	{ 0x4EB2 , 1 ,12 ,12 ,24 ,(char *) uc2_4EB2 },
	{ 0x4EB3 , 1 ,12 ,12 ,24 ,(char *) uc2_4EB3 },
	{ 0x4EB5 , 1 ,12 ,12 ,24 ,(char *) uc2_4EB5 },
	{ 0x4EBA , 1 ,12 ,12 ,24 ,(char *) uc2_4EBA },
	{ 0x4EBB , 1 ,12 ,12 ,24 ,(char *) uc2_4EBB }, /*GW*/
	{ 0x4EBF , 1 ,12 ,12 ,24 ,(char *) uc2_4EBF },
	{ 0x4EC0 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC0 },
	{ 0x4EC1 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC1 },
	{ 0x4EC2 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC2 },
	{ 0x4EC3 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC3 },
	{ 0x4EC4 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC4 },
	{ 0x4EC5 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC5 },
	{ 0x4EC6 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC6 },
	{ 0x4EC7 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC7 },
	{ 0x4EC9 , 1 ,12 ,12 ,24 ,(char *) uc2_4EC9 },
	{ 0x4ECA , 1 ,12 ,12 ,24 ,(char *) uc2_4ECA },
	{ 0x4ECB , 1 ,12 ,12 ,24 ,(char *) uc2_4ECB },
	{ 0x4ECD , 1 ,12 ,12 ,24 ,(char *) uc2_4ECD },
	{ 0x4ECE , 1 ,12 ,12 ,24 ,(char *) uc2_4ECE },
//	{ 0x4EE3 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE3 },
//	{ 0x4EE5 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE5 },
	{ 0x4ED1 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED1 },
	{ 0x4ED3 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED3 },
	{ 0x4ED4 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED4 },
	{ 0x4ED5 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED5 },
	{ 0x4ED6 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED6 },
	{ 0x4ED7 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED7 },
	{ 0x4ED8 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED8 },
	{ 0x4ED9 , 1 ,12 ,12 ,24 ,(char *) uc2_4ED9 },
	{ 0x4EDD , 1 ,12 ,12 ,24 ,(char *) uc2_4EDD },
	{ 0x4EDE , 1 ,12 ,12 ,24 ,(char *) uc2_4EDE },
	{ 0x4EDF , 1 ,12 ,12 ,24 ,(char *) uc2_4EDF },
	{ 0x4EE1 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE1 },
	{ 0x4EE3 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE3 }, /*GW*/
	{ 0x4EE4 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE4 },
	{ 0x4EE5 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE5 }, /*GW*/
	{ 0x4EE8 , 1 ,12 ,12 ,24 ,(char *) uc2_4EE8 },
	{ 0x4EEA , 1 ,12 ,12 ,24 ,(char *) uc2_4EEA },
	{ 0x4EEB , 1 ,12 ,12 ,24 ,(char *) uc2_4EEB },
	{ 0x4EEC , 1 ,12 ,12 ,24 ,(char *) uc2_4EEC },
	{ 0x4EF0 , 1 ,12 ,12 ,24 ,(char *) uc2_4EF0 },
	{ 0x4EF2 , 1 ,12 ,12 ,24 ,(char *) uc2_4EF2 },
	{ 0x4EF3 , 1 ,12 ,12 ,24 ,(char *) uc2_4EF3 },
	{ 0x4EF5 , 1 ,12 ,12 ,24 ,(char *) uc2_4EF5 },
	{ 0x4EF6 , 1 ,12 ,12 ,24 ,(char *) uc2_4EF6 },
	{ 0x4EF7 , 1 ,12 ,12 ,24 ,(char *) uc2_4EF7 },
	{ 0x4EFB , 1 ,12 ,12 ,24 ,(char *) uc2_4EFB },
	{ 0x4EFD , 1 ,12 ,12 ,24 ,(char *) uc2_4EFD },
	{ 0x4EFF , 1 ,12 ,12 ,24 ,(char *) uc2_4EFF },
	{ 0x4F01 , 1 ,12 ,12 ,24 ,(char *) uc2_4F01 },
	{ 0x4F09 , 1 ,12 ,12 ,24 ,(char *) uc2_4F09 },
	{ 0x4F0A , 1 ,12 ,12 ,24 ,(char *) uc2_4F0A },
	{ 0x4F0D , 1 ,12 ,12 ,24 ,(char *) uc2_4F0D },
	{ 0x4F0E , 1 ,12 ,12 ,24 ,(char *) uc2_4F0E },
	{ 0x4F0F , 1 ,12 ,12 ,24 ,(char *) uc2_4F0F },
	{ 0x4F10 , 1 ,12 ,12 ,24 ,(char *) uc2_4F10 },
	{ 0x4F11 , 1 ,12 ,12 ,24 ,(char *) uc2_4F11 },
	{ 0x4F17 , 1 ,12 ,12 ,24 ,(char *) uc2_4F17 },
	{ 0x4F18 , 1 ,12 ,12 ,24 ,(char *) uc2_4F18 },
	{ 0x4F19 , 1 ,12 ,12 ,24 ,(char *) uc2_4F19 },
	{ 0x4F1A , 1 ,12 ,12 ,24 ,(char *) uc2_4F1A },
	{ 0x4F1B , 1 ,12 ,12 ,24 ,(char *) uc2_4F1B },
	{ 0x4F1E , 1 ,12 ,12 ,24 ,(char *) uc2_4F1E },
	{ 0x4F1F , 1 ,12 ,12 ,24 ,(char *) uc2_4F1F },
	{ 0x4F20 , 1 ,12 ,12 ,24 ,(char *) uc2_4F20 },
	{ 0x4F22 , 1 ,12 ,12 ,24 ,(char *) uc2_4F22 },
	{ 0x4F24 , 1 ,12 ,12 ,24 ,(char *) uc2_4F24 },
	{ 0x4F25 , 1 ,12 ,12 ,24 ,(char *) uc2_4F25 },
	{ 0x4F26 , 1 ,12 ,12 ,24 ,(char *) uc2_4F26 },
	{ 0x4F27 , 1 ,12 ,12 ,24 ,(char *) uc2_4F27 },
	{ 0x4F2A , 1 ,12 ,12 ,24 ,(char *) uc2_4F2A },
	{ 0x4F2B , 1 ,12 ,12 ,24 ,(char *) uc2_4F2B },
	{ 0x4F2F , 1 ,12 ,12 ,24 ,(char *) uc2_4F2F },
	{ 0x4F30 , 1 ,12 ,12 ,24 ,(char *) uc2_4F30 },
	{ 0x4F32 , 1 ,12 ,12 ,24 ,(char *) uc2_4F32 },
	{ 0x4F34 , 1 ,12 ,12 ,24 ,(char *) uc2_4F34 },
	{ 0x4F36 , 1 ,12 ,12 ,24 ,(char *) uc2_4F36 },
	{ 0x4F38 , 1 ,12 ,12 ,24 ,(char *) uc2_4F38 },
	{ 0x4F3A , 1 ,12 ,12 ,24 ,(char *) uc2_4F3A },
	{ 0x4F3C , 1 ,12 ,12 ,24 ,(char *) uc2_4F3C },
	{ 0x4F3D , 1 ,12 ,12 ,24 ,(char *) uc2_4F3D },
	{ 0x4F43 , 1 ,12 ,12 ,24 ,(char *) uc2_4F43 },
	{ 0x4F46 , 1 ,12 ,12 ,24 ,(char *) uc2_4F46 },
	{ 0x4F4D , 1 ,12 ,12 ,24 ,(char *) uc2_4F4D },
	{ 0x4F4E , 1 ,12 ,12 ,24 ,(char *) uc2_4F4E },
	{ 0x4F4F , 1 ,12 ,12 ,24 ,(char *) uc2_4F4F },
	{ 0x4F50 , 1 ,12 ,12 ,24 ,(char *) uc2_4F50 },
	{ 0x4F51 , 1 ,12 ,12 ,24 ,(char *) uc2_4F51 },
	{ 0x4F53 , 1 ,12 ,12 ,24 ,(char *) uc2_4F53 },
	{ 0x4F55 , 1 ,12 ,12 ,24 ,(char *) uc2_4F55 },
	{ 0x4F57 , 1 ,12 ,12 ,24 ,(char *) uc2_4F57 },
	{ 0x4F58 , 1 ,12 ,12 ,24 ,(char *) uc2_4F58 },
	{ 0x4F59 , 1 ,12 ,12 ,24 ,(char *) uc2_4F59 },
	{ 0x4F5A , 1 ,12 ,12 ,24 ,(char *) uc2_4F5A },
	{ 0x4F5B , 1 ,12 ,12 ,24 ,(char *) uc2_4F5B },
	{ 0x4F5C , 1 ,12 ,12 ,24 ,(char *) uc2_4F5C },
	{ 0x4F5D , 1 ,12 ,12 ,24 ,(char *) uc2_4F5D },
	{ 0x4F5E , 1 ,12 ,12 ,24 ,(char *) uc2_4F5E },
	{ 0x4F5F , 1 ,12 ,12 ,24 ,(char *) uc2_4F5F },
	{ 0x4F60 , 1 ,12 ,12 ,24 ,(char *) uc2_4F60 },
	{ 0x4F63 , 1 ,12 ,12 ,24 ,(char *) uc2_4F63 },
	{ 0x4F64 , 1 ,12 ,12 ,24 ,(char *) uc2_4F64 },
	{ 0x4F65 , 1 ,12 ,12 ,24 ,(char *) uc2_4F65 },
	{ 0x4F67 , 1 ,12 ,12 ,24 ,(char *) uc2_4F67 },
	{ 0x4F69 , 1 ,12 ,12 ,24 ,(char *) uc2_4F69 },
	{ 0x4F6C , 1 ,12 ,12 ,24 ,(char *) uc2_4F6C },
	{ 0x4F6F , 1 ,12 ,12 ,24 ,(char *) uc2_4F6F },
	{ 0x4F70 , 1 ,12 ,12 ,24 ,(char *) uc2_4F70 },
	{ 0x4F73 , 1 ,12 ,12 ,24 ,(char *) uc2_4F73 },
	{ 0x4F74 , 1 ,12 ,12 ,24 ,(char *) uc2_4F74 },
	{ 0x4F76 , 1 ,12 ,12 ,24 ,(char *) uc2_4F76 },
	{ 0x4F7B , 1 ,12 ,12 ,24 ,(char *) uc2_4F7B },
	{ 0x4F7C , 1 ,12 ,12 ,24 ,(char *) uc2_4F7C },
	{ 0x4F7E , 1 ,12 ,12 ,24 ,(char *) uc2_4F7E },
	{ 0x4F7F , 1 ,12 ,12 ,24 ,(char *) uc2_4F7F },
	{ 0x4F83 , 1 ,12 ,12 ,24 ,(char *) uc2_4F83 },
	{ 0x4F84 , 1 ,12 ,12 ,24 ,(char *) uc2_4F84 },
	{ 0x4F88 , 1 ,12 ,12 ,24 ,(char *) uc2_4F88 },
	{ 0x4F89 , 1 ,12 ,12 ,24 ,(char *) uc2_4F89 },
	{ 0x4F8B , 1 ,12 ,12 ,24 ,(char *) uc2_4F8B },
	{ 0x4F8D , 1 ,12 ,12 ,24 ,(char *) uc2_4F8D },
	{ 0x4F8F , 1 ,12 ,12 ,24 ,(char *) uc2_4F8F },
	{ 0x4F91 , 1 ,12 ,12 ,24 ,(char *) uc2_4F91 },
	{ 0x4F94 , 1 ,12 ,12 ,24 ,(char *) uc2_4F94 },
	{ 0x4F97 , 1 ,12 ,12 ,24 ,(char *) uc2_4F97 },
	{ 0x4F98 , 1 ,12 ,12 ,24 ,(char *) uc2_4F98 },
	{ 0x4F9B , 1 ,12 ,12 ,24 ,(char *) uc2_4F9B },
	{ 0x4F9D , 1 ,12 ,12 ,24 ,(char *) uc2_4F9D },
	{ 0x4FA0 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA0 },
	{ 0x4FA3 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA3 },
	{ 0x4FA5 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA5 },
	{ 0x4FA6 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA6 },
	{ 0x4FA7 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA7 },
	{ 0x4FA8 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA8 },
	{ 0x4FA9 , 1 ,12 ,12 ,24 ,(char *) uc2_4FA9 },
	{ 0x4FAA , 1 ,12 ,12 ,24 ,(char *) uc2_4FAA },
	{ 0x4FAC , 1 ,12 ,12 ,24 ,(char *) uc2_4FAC },
	{ 0x4FAE , 1 ,12 ,12 ,24 ,(char *) uc2_4FAE },
	{ 0x4FAF , 1 ,12 ,12 ,24 ,(char *) uc2_4FAF },
	{ 0x4FB5 , 1 ,12 ,12 ,24 ,(char *) uc2_4FB5 },
	{ 0x4FBF , 1 ,12 ,12 ,24 ,(char *) uc2_4FBF },
	{ 0x4FC3 , 1 ,12 ,12 ,24 ,(char *) uc2_4FC3 },
	{ 0x4FC4 , 1 ,12 ,12 ,24 ,(char *) uc2_4FC4 },
	{ 0x4FC5 , 1 ,12 ,12 ,24 ,(char *) uc2_4FC5 },
	{ 0x4FCA , 1 ,12 ,12 ,24 ,(char *) uc2_4FCA },
	{ 0x4FCE , 1 ,12 ,12 ,24 ,(char *) uc2_4FCE },
	{ 0x4FCF , 1 ,12 ,12 ,24 ,(char *) uc2_4FCF },
	{ 0x4FD0 , 1 ,12 ,12 ,24 ,(char *) uc2_4FD0 },
	{ 0x4FD1 , 1 ,12 ,12 ,24 ,(char *) uc2_4FD1 },
	{ 0x4FD7 , 1 ,12 ,12 ,24 ,(char *) uc2_4FD7 },
	{ 0x4FD8 , 1 ,12 ,12 ,24 ,(char *) uc2_4FD8 },
	{ 0x4FDA , 1 ,12 ,12 ,24 ,(char *) uc2_4FDA },
	{ 0x4FDC , 1 ,12 ,12 ,24 ,(char *) uc2_4FDC },
	{ 0x4FDD , 1 ,12 ,12 ,24 ,(char *) uc2_4FDD },
	{ 0x4FDE , 1 ,12 ,12 ,24 ,(char *) uc2_4FDE },
	{ 0x4FDF , 1 ,12 ,12 ,24 ,(char *) uc2_4FDF },
	{ 0x4FE1 , 1 ,12 ,12 ,24 ,(char *) uc2_4FE1 },
	{ 0x4FE3 , 1 ,12 ,12 ,24 ,(char *) uc2_4FE3 },
	{ 0x4FE6 , 1 ,12 ,12 ,24 ,(char *) uc2_4FE6 },
	{ 0x4FE8 , 1 ,12 ,12 ,24 ,(char *) uc2_4FE8 },
	{ 0x4FE9 , 1 ,12 ,12 ,24 ,(char *) uc2_4FE9 },
	{ 0x4FEA , 1 ,12 ,12 ,24 ,(char *) uc2_4FEA },
	{ 0x4FED , 1 ,12 ,12 ,24 ,(char *) uc2_4FED },
	{ 0x4FEE , 1 ,12 ,12 ,24 ,(char *) uc2_4FEE },
	{ 0x4FEF , 1 ,12 ,12 ,24 ,(char *) uc2_4FEF },
	{ 0x4FF1 , 1 ,12 ,12 ,24 ,(char *) uc2_4FF1 },
	{ 0x4FF3 , 1 ,12 ,12 ,24 ,(char *) uc2_4FF3 },
	{ 0x4FF8 , 1 ,12 ,12 ,24 ,(char *) uc2_4FF8 },
	{ 0x4FFA , 1 ,12 ,12 ,24 ,(char *) uc2_4FFA },
	{ 0x4FFE , 1 ,12 ,12 ,24 ,(char *) uc2_4FFE },
	{ 0x500C , 1 ,12 ,12 ,24 ,(char *) uc2_500C },
	{ 0x500D , 1 ,12 ,12 ,24 ,(char *) uc2_500D },
	{ 0x500F , 1 ,12 ,12 ,24 ,(char *) uc2_500F },
	{ 0x5012 , 1 ,12 ,12 ,24 ,(char *) uc2_5012 },
	{ 0x5014 , 1 ,12 ,12 ,24 ,(char *) uc2_5014 },
	{ 0x5018 , 1 ,12 ,12 ,24 ,(char *) uc2_5018 },
	{ 0x5019 , 1 ,12 ,12 ,24 ,(char *) uc2_5019 },
	{ 0x501A , 1 ,12 ,12 ,24 ,(char *) uc2_501A },
	{ 0x501C , 1 ,12 ,12 ,24 ,(char *) uc2_501C },
	{ 0x501F , 1 ,12 ,12 ,24 ,(char *) uc2_501F },
	{ 0x5021 , 1 ,12 ,12 ,24 ,(char *) uc2_5021 },
	{ 0x5025 , 1 ,12 ,12 ,24 ,(char *) uc2_5025 },
	{ 0x5026 , 1 ,12 ,12 ,24 ,(char *) uc2_5026 },
	{ 0x5028 , 1 ,12 ,12 ,24 ,(char *) uc2_5028 },
	{ 0x5029 , 1 ,12 ,12 ,24 ,(char *) uc2_5029 },
	{ 0x502A , 1 ,12 ,12 ,24 ,(char *) uc2_502A },
	{ 0x502C , 1 ,12 ,12 ,24 ,(char *) uc2_502C },
	{ 0x502D , 1 ,12 ,12 ,24 ,(char *) uc2_502D },
	{ 0x502E , 1 ,12 ,12 ,24 ,(char *) uc2_502E },
	{ 0x503A , 1 ,12 ,12 ,24 ,(char *) uc2_503A },
	{ 0x503C , 1 ,12 ,12 ,24 ,(char *) uc2_503C },
	{ 0x503E , 1 ,12 ,12 ,24 ,(char *) uc2_503E },
	{ 0x5043 , 1 ,12 ,12 ,24 ,(char *) uc2_5043 },
	{ 0x5047 , 1 ,12 ,12 ,24 ,(char *) uc2_5047 },
	{ 0x5048 , 1 ,12 ,12 ,24 ,(char *) uc2_5048 },
	{ 0x504C , 1 ,12 ,12 ,24 ,(char *) uc2_504C },
	{ 0x504E , 1 ,12 ,12 ,24 ,(char *) uc2_504E },
	{ 0x504F , 1 ,12 ,12 ,24 ,(char *) uc2_504F },
	{ 0x5055 , 1 ,12 ,12 ,24 ,(char *) uc2_5055 },
	{ 0x505A , 1 ,12 ,12 ,24 ,(char *) uc2_505A },
	{ 0x505C , 1 ,12 ,12 ,24 ,(char *) uc2_505C },
	{ 0x5065 , 1 ,12 ,12 ,24 ,(char *) uc2_5065 },
	{ 0x506C , 1 ,12 ,12 ,24 ,(char *) uc2_506C },
	{ 0x5076 , 1 ,12 ,12 ,24 ,(char *) uc2_5076 },
	{ 0x5077 , 1 ,12 ,12 ,24 ,(char *) uc2_5077 },
	{ 0x507B , 1 ,12 ,12 ,24 ,(char *) uc2_507B },
	{ 0x507E , 1 ,12 ,12 ,24 ,(char *) uc2_507E },
	{ 0x507F , 1 ,12 ,12 ,24 ,(char *) uc2_507F },
	{ 0x5080 , 1 ,12 ,12 ,24 ,(char *) uc2_5080 },
	{ 0x5085 , 1 ,12 ,12 ,24 ,(char *) uc2_5085 },
	{ 0x5088 , 1 ,12 ,12 ,24 ,(char *) uc2_5088 },
	{ 0x508D , 1 ,12 ,12 ,24 ,(char *) uc2_508D },
	{ 0x50A3 , 1 ,12 ,12 ,24 ,(char *) uc2_50A3 },
	{ 0x50A5 , 1 ,12 ,12 ,24 ,(char *) uc2_50A5 },
	{ 0x50A7 , 1 ,12 ,12 ,24 ,(char *) uc2_50A7 },
	{ 0x50A8 , 1 ,12 ,12 ,24 ,(char *) uc2_50A8 },
	{ 0x50A9 , 1 ,12 ,12 ,24 ,(char *) uc2_50A9 },
	{ 0x50AC , 1 ,12 ,12 ,24 ,(char *) uc2_50AC },
	{ 0x50B2 , 1 ,12 ,12 ,24 ,(char *) uc2_50B2 },
	{ 0x50BA , 1 ,12 ,12 ,24 ,(char *) uc2_50BA },
	{ 0x50BB , 1 ,12 ,12 ,24 ,(char *) uc2_50BB },
	{ 0x50CF , 1 ,12 ,12 ,24 ,(char *) uc2_50CF },
	{ 0x50D6 , 1 ,12 ,12 ,24 ,(char *) uc2_50D6 },
	{ 0x50DA , 1 ,12 ,12 ,24 ,(char *) uc2_50DA },
	{ 0x50E6 , 1 ,12 ,12 ,24 ,(char *) uc2_50E6 },
	{ 0x50E7 , 1 ,12 ,12 ,24 ,(char *) uc2_50E7 },
	{ 0x50EC , 1 ,12 ,12 ,24 ,(char *) uc2_50EC },
	{ 0x50ED , 1 ,12 ,12 ,24 ,(char *) uc2_50ED },
	{ 0x50EE , 1 ,12 ,12 ,24 ,(char *) uc2_50EE },
	{ 0x50F3 , 1 ,12 ,12 ,24 ,(char *) uc2_50F3 },
	{ 0x50F5 , 1 ,12 ,12 ,24 ,(char *) uc2_50F5 },
	{ 0x50FB , 1 ,12 ,12 ,24 ,(char *) uc2_50FB },
	{ 0x5106 , 1 ,12 ,12 ,24 ,(char *) uc2_5106 },
	{ 0x5107 , 1 ,12 ,12 ,24 ,(char *) uc2_5107 },
	{ 0x510B , 1 ,12 ,12 ,24 ,(char *) uc2_510B },
	{ 0x5112 , 1 ,12 ,12 ,24 ,(char *) uc2_5112 },
	{ 0x5121 , 1 ,12 ,12 ,24 ,(char *) uc2_5121 },
	{ 0x513F , 1 ,12 ,12 ,24 ,(char *) uc2_513F },
	{ 0x5140 , 1 ,12 ,12 ,24 ,(char *) uc2_5140 },
	{ 0x5141 , 1 ,12 ,12 ,24 ,(char *) uc2_5141 },
	{ 0x5143 , 1 ,12 ,12 ,24 ,(char *) uc2_5143 },
	{ 0x5144 , 1 ,12 ,12 ,24 ,(char *) uc2_5144 },
	{ 0x5145 , 1 ,12 ,12 ,24 ,(char *) uc2_5145 },
	{ 0x5146 , 1 ,12 ,12 ,24 ,(char *) uc2_5146 },
	{ 0x5148 , 1 ,12 ,12 ,24 ,(char *) uc2_5148 },
	{ 0x5149 , 1 ,12 ,12 ,24 ,(char *) uc2_5149 },
	{ 0x514B , 1 ,12 ,12 ,24 ,(char *) uc2_514B },
	{ 0x514D , 1 ,12 ,12 ,24 ,(char *) uc2_514D },
	{ 0x5151 , 1 ,12 ,12 ,24 ,(char *) uc2_5151 },
	{ 0x5154 , 1 ,12 ,12 ,24 ,(char *) uc2_5154 },
	{ 0x5155 , 1 ,12 ,12 ,24 ,(char *) uc2_5155 },
	{ 0x5156 , 1 ,12 ,12 ,24 ,(char *) uc2_5156 },
	{ 0x515A , 1 ,12 ,12 ,24 ,(char *) uc2_515A },
	{ 0x515C , 1 ,12 ,12 ,24 ,(char *) uc2_515C },
	{ 0x5162 , 1 ,12 ,12 ,24 ,(char *) uc2_5162 },
	{ 0x5165 , 1 ,12 ,12 ,24 ,(char *) uc2_5165 },
	{ 0x5168 , 1 ,12 ,12 ,24 ,(char *) uc2_5168 },
	{ 0x516B , 1 ,12 ,12 ,24 ,(char *) uc2_516B },
	{ 0x516C , 1 ,12 ,12 ,24 ,(char *) uc2_516C },
	{ 0x516D , 1 ,12 ,12 ,24 ,(char *) uc2_516D },
	{ 0x516E , 1 ,12 ,12 ,24 ,(char *) uc2_516E },
	{ 0x5170 , 1 ,12 ,12 ,24 ,(char *) uc2_5170 },
	{ 0x5171 , 1 ,12 ,12 ,24 ,(char *) uc2_5171 },
	{ 0x5173 , 1 ,12 ,12 ,24 ,(char *) uc2_5173 },
	{ 0x5174 , 1 ,12 ,12 ,24 ,(char *) uc2_5174 },
	{ 0x5175 , 1 ,12 ,12 ,24 ,(char *) uc2_5175 },
	{ 0x5176 , 1 ,12 ,12 ,24 ,(char *) uc2_5176 },
	{ 0x5177 , 1 ,12 ,12 ,24 ,(char *) uc2_5177 },
	{ 0x5178 , 1 ,12 ,12 ,24 ,(char *) uc2_5178 },
	{ 0x5179 , 1 ,12 ,12 ,24 ,(char *) uc2_5179 },
	{ 0x517B , 1 ,12 ,12 ,24 ,(char *) uc2_517B },
	{ 0x517C , 1 ,12 ,12 ,24 ,(char *) uc2_517C },
	{ 0x517D , 1 ,12 ,12 ,24 ,(char *) uc2_517D },
	{ 0x5180 , 1 ,12 ,12 ,24 ,(char *) uc2_5180 },
	{ 0x5181 , 1 ,12 ,12 ,24 ,(char *) uc2_5181 },
	{ 0x5182 , 1 ,12 ,12 ,24 ,(char *) uc2_5182 }, /* GW */
	{ 0x5185 , 1 ,12 ,12 ,24 ,(char *) uc2_5185 },
	{ 0x5188 , 1 ,12 ,12 ,24 ,(char *) uc2_5188 },
	{ 0x5189 , 1 ,12 ,12 ,24 ,(char *) uc2_5189 },
	{ 0x518C , 1 ,12 ,12 ,24 ,(char *) uc2_518C },
	{ 0x518D , 1 ,12 ,12 ,24 ,(char *) uc2_518D },
	{ 0x5192 , 1 ,12 ,12 ,24 ,(char *) uc2_5192 },
	{ 0x5195 , 1 ,12 ,12 ,24 ,(char *) uc2_5195 },
	{ 0x5196 , 1 ,12 ,12 ,24 ,(char *) uc2_5196 }, /* GW */
	{ 0x5197 , 1 ,12 ,12 ,24 ,(char *) uc2_5197 },
	{ 0x5199 , 1 ,12 ,12 ,24 ,(char *) uc2_5199 },
	{ 0x519B , 1 ,12 ,12 ,24 ,(char *) uc2_519B },
	{ 0x519C , 1 ,12 ,12 ,24 ,(char *) uc2_519C },
	{ 0x51A0 , 1 ,12 ,12 ,24 ,(char *) uc2_51A0 },
	{ 0x51A2 , 1 ,12 ,12 ,24 ,(char *) uc2_51A2 },
	{ 0x51A4 , 1 ,12 ,12 ,24 ,(char *) uc2_51A4 },
	{ 0x51A5 , 1 ,12 ,12 ,24 ,(char *) uc2_51A5 },
	{ 0x51AB , 1 ,12 ,12 ,24 ,(char *) uc2_51AB },/*API*/
	{ 0x51AC , 1 ,12 ,12 ,24 ,(char *) uc2_51AC },
	{ 0x51AF , 1 ,12 ,12 ,24 ,(char *) uc2_51AF },
	{ 0x51B0 , 1 ,12 ,12 ,24 ,(char *) uc2_51B0 },
	{ 0x51B1 , 1 ,12 ,12 ,24 ,(char *) uc2_51B1 },
	{ 0x51B2 , 1 ,12 ,12 ,24 ,(char *) uc2_51B2 },
	{ 0x51B3 , 1 ,12 ,12 ,24 ,(char *) uc2_51B3 },
	{ 0x51B5 , 1 ,12 ,12 ,24 ,(char *) uc2_51B5 },
	{ 0x51B6 , 1 ,12 ,12 ,24 ,(char *) uc2_51B6 },
	{ 0x51B7 , 1 ,12 ,12 ,24 ,(char *) uc2_51B7 },
	{ 0x51BB , 1 ,12 ,12 ,24 ,(char *) uc2_51BB },
	{ 0x51BC , 1 ,12 ,12 ,24 ,(char *) uc2_51BC },
	{ 0x51BD , 1 ,12 ,12 ,24 ,(char *) uc2_51BD },
	{ 0x51C0 , 1 ,12 ,12 ,24 ,(char *) uc2_51C0 },
	{ 0x51C4 , 1 ,12 ,12 ,24 ,(char *) uc2_51C4 },
	{ 0x51C6 , 1 ,12 ,12 ,24 ,(char *) uc2_51C6 },
	{ 0x51C7 , 1 ,12 ,12 ,24 ,(char *) uc2_51C7 },
	{ 0x51C9 , 1 ,12 ,12 ,24 ,(char *) uc2_51C9 },
	{ 0x51CB , 1 ,12 ,12 ,24 ,(char *) uc2_51CB },
	{ 0x51CC , 1 ,12 ,12 ,24 ,(char *) uc2_51CC },
	{ 0x51CF , 1 ,12 ,12 ,24 ,(char *) uc2_51CF },
	{ 0x51D1 , 1 ,12 ,12 ,24 ,(char *) uc2_51D1 },
	{ 0x51DB , 1 ,12 ,12 ,24 ,(char *) uc2_51DB },
	{ 0x51DD , 1 ,12 ,12 ,24 ,(char *) uc2_51DD },
	{ 0x51E0 , 1 ,12 ,12 ,24 ,(char *) uc2_51E0 },
	{ 0x51E1 , 1 ,12 ,12 ,24 ,(char *) uc2_51E1 },
	{ 0x51E4 , 1 ,12 ,12 ,24 ,(char *) uc2_51E4 },
	{ 0x51EB , 1 ,12 ,12 ,24 ,(char *) uc2_51EB },
	{ 0x51ED , 1 ,12 ,12 ,24 ,(char *) uc2_51ED },
	{ 0x51EF , 1 ,12 ,12 ,24 ,(char *) uc2_51EF },
	{ 0x51F0 , 1 ,12 ,12 ,24 ,(char *) uc2_51F0 },
	{ 0x51F3 , 1 ,12 ,12 ,24 ,(char *) uc2_51F3 },
	{ 0x51F6 , 1 ,12 ,12 ,24 ,(char *) uc2_51F6 },
	{ 0x51F8 , 1 ,12 ,12 ,24 ,(char *) uc2_51F8 },
	{ 0x51F9 , 1 ,12 ,12 ,24 ,(char *) uc2_51F9 },
	{ 0x51FA , 1 ,12 ,12 ,24 ,(char *) uc2_51FA },
	{ 0x51FB , 1 ,12 ,12 ,24 ,(char *) uc2_51FB },
	{ 0x51FC , 1 ,12 ,12 ,24 ,(char *) uc2_51FC },
	{ 0x51FD , 1 ,12 ,12 ,24 ,(char *) uc2_51FD },
	{ 0x51FF , 1 ,12 ,12 ,24 ,(char *) uc2_51FF },
	{ 0x5200 , 1 ,12 ,12 ,24 ,(char *) uc2_5200 },
	{ 0x5201 , 1 ,12 ,12 ,24 ,(char *) uc2_5201 },
	{ 0x5202 , 1 ,12 ,12 ,24 ,(char *) uc2_5202 },/*API*/
	{ 0x5203 , 1 ,12 ,12 ,24 ,(char *) uc2_5203 },
	{ 0x5206 , 1 ,12 ,12 ,24 ,(char *) uc2_5206 },
	{ 0x5207 , 1 ,12 ,12 ,24 ,(char *) uc2_5207 },
	{ 0x5208 , 1 ,12 ,12 ,24 ,(char *) uc2_5208 },
	{ 0x520A , 1 ,12 ,12 ,24 ,(char *) uc2_520A },
	{ 0x520D , 1 ,12 ,12 ,24 ,(char *) uc2_520D },
	{ 0x520E , 1 ,12 ,12 ,24 ,(char *) uc2_520E },
	{ 0x5211 , 1 ,12 ,12 ,24 ,(char *) uc2_5211 },
	{ 0x5212 , 1 ,12 ,12 ,24 ,(char *) uc2_5212 },
	{ 0x5216 , 1 ,12 ,12 ,24 ,(char *) uc2_5216 },
	{ 0x5217 , 1 ,12 ,12 ,24 ,(char *) uc2_5217 },
	{ 0x5218 , 1 ,12 ,12 ,24 ,(char *) uc2_5218 },
	{ 0x5219 , 1 ,12 ,12 ,24 ,(char *) uc2_5219 },
	{ 0x521A , 1 ,12 ,12 ,24 ,(char *) uc2_521A },
	{ 0x521B , 1 ,12 ,12 ,24 ,(char *) uc2_521B },
	{ 0x521D , 1 ,12 ,12 ,24 ,(char *) uc2_521D },
	{ 0x5220 , 1 ,12 ,12 ,24 ,(char *) uc2_5220 },
	{ 0x5224 , 1 ,12 ,12 ,24 ,(char *) uc2_5224 },
	{ 0x5228 , 1 ,12 ,12 ,24 ,(char *) uc2_5228 },
	{ 0x5229 , 1 ,12 ,12 ,24 ,(char *) uc2_5229 },
	{ 0x522B , 1 ,12 ,12 ,24 ,(char *) uc2_522B },
	{ 0x522D , 1 ,12 ,12 ,24 ,(char *) uc2_522D },
	{ 0x522E , 1 ,12 ,12 ,24 ,(char *) uc2_522E },
	{ 0x5230 , 1 ,12 ,12 ,24 ,(char *) uc2_5230 },
	{ 0x5233 , 1 ,12 ,12 ,24 ,(char *) uc2_5233 },
	{ 0x5236 , 1 ,12 ,12 ,24 ,(char *) uc2_5236 },
	{ 0x5237 , 1 ,12 ,12 ,24 ,(char *) uc2_5237 },
	{ 0x5238 , 1 ,12 ,12 ,24 ,(char *) uc2_5238 },
	{ 0x5239 , 1 ,12 ,12 ,24 ,(char *) uc2_5239 },
	{ 0x523A , 1 ,12 ,12 ,24 ,(char *) uc2_523A },
	{ 0x523B , 1 ,12 ,12 ,24 ,(char *) uc2_523B },
	{ 0x523D , 1 ,12 ,12 ,24 ,(char *) uc2_523D },
	{ 0x523F , 1 ,12 ,12 ,24 ,(char *) uc2_523F },
	{ 0x5240 , 1 ,12 ,12 ,24 ,(char *) uc2_5240 },
	{ 0x5241 , 1 ,12 ,12 ,24 ,(char *) uc2_5241 },
	{ 0x5242 , 1 ,12 ,12 ,24 ,(char *) uc2_5242 },
	{ 0x5243 , 1 ,12 ,12 ,24 ,(char *) uc2_5243 },
	{ 0x524A , 1 ,12 ,12 ,24 ,(char *) uc2_524A },
	{ 0x524C , 1 ,12 ,12 ,24 ,(char *) uc2_524C },
	{ 0x524D , 1 ,12 ,12 ,24 ,(char *) uc2_524D },
	{ 0x5250 , 1 ,12 ,12 ,24 ,(char *) uc2_5250 },
	{ 0x5251 , 1 ,12 ,12 ,24 ,(char *) uc2_5251 },
	{ 0x5254 , 1 ,12 ,12 ,24 ,(char *) uc2_5254 },
	{ 0x5256 , 1 ,12 ,12 ,24 ,(char *) uc2_5256 },
	{ 0x525C , 1 ,12 ,12 ,24 ,(char *) uc2_525C },
	{ 0x525E , 1 ,12 ,12 ,24 ,(char *) uc2_525E },
	{ 0x5261 , 1 ,12 ,12 ,24 ,(char *) uc2_5261 },
	{ 0x5265 , 1 ,12 ,12 ,24 ,(char *) uc2_5265 },
	{ 0x5267 , 1 ,12 ,12 ,24 ,(char *) uc2_5267 },
	{ 0x5269 , 1 ,12 ,12 ,24 ,(char *) uc2_5269 },
	{ 0x526A , 1 ,12 ,12 ,24 ,(char *) uc2_526A },
	{ 0x526F , 1 ,12 ,12 ,24 ,(char *) uc2_526F },
	{ 0x5272 , 1 ,12 ,12 ,24 ,(char *) uc2_5272 },
	{ 0x527D , 1 ,12 ,12 ,24 ,(char *) uc2_527D },
	{ 0x527F , 1 ,12 ,12 ,24 ,(char *) uc2_527F },
	{ 0x5281 , 1 ,12 ,12 ,24 ,(char *) uc2_5281 },
	{ 0x5282 , 1 ,12 ,12 ,24 ,(char *) uc2_5282 },
	{ 0x5288 , 1 ,12 ,12 ,24 ,(char *) uc2_5288 },
	{ 0x5290 , 1 ,12 ,12 ,24 ,(char *) uc2_5290 },
	{ 0x5293 , 1 ,12 ,12 ,24 ,(char *) uc2_5293 },
	{ 0x529B , 1 ,12 ,12 ,24 ,(char *) uc2_529B },
	{ 0x529D , 1 ,12 ,12 ,24 ,(char *) uc2_529D },
	{ 0x529E , 1 ,12 ,12 ,24 ,(char *) uc2_529E },
	{ 0x529F , 1 ,12 ,12 ,24 ,(char *) uc2_529F },
	{ 0x52A0 , 1 ,12 ,12 ,24 ,(char *) uc2_52A0 },
	{ 0x52A1 , 1 ,12 ,12 ,24 ,(char *) uc2_52A1 },
	{ 0x52A2 , 1 ,12 ,12 ,24 ,(char *) uc2_52A2 },
	{ 0x52A3 , 1 ,12 ,12 ,24 ,(char *) uc2_52A3 },
	{ 0x52A8 , 1 ,12 ,12 ,24 ,(char *) uc2_52A8 },
	{ 0x52A9 , 1 ,12 ,12 ,24 ,(char *) uc2_52A9 },
	{ 0x52AA , 1 ,12 ,12 ,24 ,(char *) uc2_52AA },
	{ 0x52AB , 1 ,12 ,12 ,24 ,(char *) uc2_52AB },
	{ 0x52AC , 1 ,12 ,12 ,24 ,(char *) uc2_52AC },
	{ 0x52AD , 1 ,12 ,12 ,24 ,(char *) uc2_52AD },
	{ 0x52B1 , 1 ,12 ,12 ,24 ,(char *) uc2_52B1 },
	{ 0x52B2 , 1 ,12 ,12 ,24 ,(char *) uc2_52B2 },
	{ 0x52B3 , 1 ,12 ,12 ,24 ,(char *) uc2_52B3 },
	{ 0x52BE , 1 ,12 ,12 ,24 ,(char *) uc2_52BE },
	{ 0x52BF , 1 ,12 ,12 ,24 ,(char *) uc2_52BF },
	{ 0x52C3 , 1 ,12 ,12 ,24 ,(char *) uc2_52C3 },
	{ 0x52C7 , 1 ,12 ,12 ,24 ,(char *) uc2_52C7 },
	{ 0x52C9 , 1 ,12 ,12 ,24 ,(char *) uc2_52C9 },
	{ 0x52CB , 1 ,12 ,12 ,24 ,(char *) uc2_52CB },
	{ 0x52D0 , 1 ,12 ,12 ,24 ,(char *) uc2_52D0 },
	{ 0x52D2 , 1 ,12 ,12 ,24 ,(char *) uc2_52D2 },
	{ 0x52D4 , 1 ,12 ,12 ,24 ,(char *) uc2_52D4 },
	{ 0x52D6 , 1 ,12 ,12 ,24 ,(char *) uc2_52D6 },
	{ 0x52D8 , 1 ,12 ,12 ,24 ,(char *) uc2_52D8 },
	{ 0x52DF , 1 ,12 ,12 ,24 ,(char *) uc2_52DF },
	{ 0x52E4 , 1 ,12 ,12 ,24 ,(char *) uc2_52E4 },
	{ 0x52F0 , 1 ,12 ,12 ,24 ,(char *) uc2_52F0 },
	{ 0x52FA , 1 ,12 ,12 ,24 ,(char *) uc2_52FA },
	{ 0x52FE , 1 ,12 ,12 ,24 ,(char *) uc2_52FE },
	{ 0x52FF , 1 ,12 ,12 ,24 ,(char *) uc2_52FF },
	{ 0x5300 , 1 ,12 ,12 ,24 ,(char *) uc2_5300 },
	{ 0x5305 , 1 ,12 ,12 ,24 ,(char *) uc2_5305 },
	{ 0x5306 , 1 ,12 ,12 ,24 ,(char *) uc2_5306 },
	{ 0x5308 , 1 ,12 ,12 ,24 ,(char *) uc2_5308 },
	{ 0x530D , 1 ,12 ,12 ,24 ,(char *) uc2_530D },
	{ 0x530F , 1 ,12 ,12 ,24 ,(char *) uc2_530F },
	{ 0x5310 , 1 ,12 ,12 ,24 ,(char *) uc2_5310 },
	{ 0x5315 , 1 ,12 ,12 ,24 ,(char *) uc2_5315 },
	{ 0x5316 , 1 ,12 ,12 ,24 ,(char *) uc2_5316 },
	{ 0x5317 , 1 ,12 ,12 ,24 ,(char *) uc2_5317 },
	{ 0x5319 , 1 ,12 ,12 ,24 ,(char *) uc2_5319 },
	{ 0x531A , 1 ,12 ,12 ,24 ,(char *) uc2_531A },/*API*/
	{ 0x531D , 1 ,12 ,12 ,24 ,(char *) uc2_531D },
	{ 0x5320 , 1 ,12 ,12 ,24 ,(char *) uc2_5320 },
	{ 0x5321 , 1 ,12 ,12 ,24 ,(char *) uc2_5321 },
	{ 0x5323 , 1 ,12 ,12 ,24 ,(char *) uc2_5323 },
	{ 0x5326 , 1 ,12 ,12 ,24 ,(char *) uc2_5326 },
	{ 0x532A , 1 ,12 ,12 ,24 ,(char *) uc2_532A },
	{ 0x532E , 1 ,12 ,12 ,24 ,(char *) uc2_532E },
	{ 0x5339 , 1 ,12 ,12 ,24 ,(char *) uc2_5339 },
	{ 0x533A , 1 ,12 ,12 ,24 ,(char *) uc2_533A },
	{ 0x533B , 1 ,12 ,12 ,24 ,(char *) uc2_533B },
	{ 0x533E , 1 ,12 ,12 ,24 ,(char *) uc2_533E },
	{ 0x533F , 1 ,12 ,12 ,24 ,(char *) uc2_533F },
	{ 0x5341 , 1 ,12 ,12 ,24 ,(char *) uc2_5341 },
	{ 0x5343 , 1 ,12 ,12 ,24 ,(char *) uc2_5343 },
	{ 0x5345 , 1 ,12 ,12 ,24 ,(char *) uc2_5345 },
	{ 0x5347 , 1 ,12 ,12 ,24 ,(char *) uc2_5347 },
	{ 0x5348 , 1 ,12 ,12 ,24 ,(char *) uc2_5348 },
	{ 0x5349 , 1 ,12 ,12 ,24 ,(char *) uc2_5349 },
	{ 0x534A , 1 ,12 ,12 ,24 ,(char *) uc2_534A },
	{ 0x534E , 1 ,12 ,12 ,24 ,(char *) uc2_534E },
	{ 0x534F , 1 ,12 ,12 ,24 ,(char *) uc2_534F },
	{ 0x5351 , 1 ,12 ,12 ,24 ,(char *) uc2_5351 },
	{ 0x5352 , 1 ,12 ,12 ,24 ,(char *) uc2_5352 },
	{ 0x5353 , 1 ,12 ,12 ,24 ,(char *) uc2_5353 },
	{ 0x5355 , 1 ,12 ,12 ,24 ,(char *) uc2_5355 },
	{ 0x5356 , 1 ,12 ,12 ,24 ,(char *) uc2_5356 },
	{ 0x5357 , 1 ,12 ,12 ,24 ,(char *) uc2_5357 },
	{ 0x535A , 1 ,12 ,12 ,24 ,(char *) uc2_535A },
	{ 0x535C , 1 ,12 ,12 ,24 ,(char *) uc2_535C },
	{ 0x535E , 1 ,12 ,12 ,24 ,(char *) uc2_535E },
	{ 0x535F , 1 ,12 ,12 ,24 ,(char *) uc2_535F },
	{ 0x5360 , 1 ,12 ,12 ,24 ,(char *) uc2_5360 },
	{ 0x5361 , 1 ,12 ,12 ,24 ,(char *) uc2_5361 },
	{ 0x5362 , 1 ,12 ,12 ,24 ,(char *) uc2_5362 },
	{ 0x5363 , 1 ,12 ,12 ,24 ,(char *) uc2_5363 },
	{ 0x5364 , 1 ,12 ,12 ,24 ,(char *) uc2_5364 },
	{ 0x5366 , 1 ,12 ,12 ,24 ,(char *) uc2_5366 },
	{ 0x5367 , 1 ,12 ,12 ,24 ,(char *) uc2_5367 },
	{ 0x5369 , 1 ,12 ,12 ,24 ,(char *) uc2_5369 },/*API*/
	{ 0x536B , 1 ,12 ,12 ,24 ,(char *) uc2_536B },
	{ 0x536E , 1 ,12 ,12 ,24 ,(char *) uc2_536E },
	{ 0x536F , 1 ,12 ,12 ,24 ,(char *) uc2_536F },
	{ 0x5370 , 1 ,12 ,12 ,24 ,(char *) uc2_5370 },
	{ 0x5371 , 1 ,12 ,12 ,24 ,(char *) uc2_5371 },
	{ 0x5373 , 1 ,12 ,12 ,24 ,(char *) uc2_5373 },
	{ 0x5374 , 1 ,12 ,12 ,24 ,(char *) uc2_5374 },
	{ 0x5375 , 1 ,12 ,12 ,24 ,(char *) uc2_5375 },
	{ 0x5377 , 1 ,12 ,12 ,24 ,(char *) uc2_5377 },
	{ 0x5378 , 1 ,12 ,12 ,24 ,(char *) uc2_5378 },
	{ 0x537A , 1 ,12 ,12 ,24 ,(char *) uc2_537A },
	{ 0x537F , 1 ,12 ,12 ,24 ,(char *) uc2_537F },
	{ 0x5382 , 1 ,12 ,12 ,24 ,(char *) uc2_5382 },
	{ 0x5384 , 1 ,12 ,12 ,24 ,(char *) uc2_5384 },
	{ 0x5385 , 1 ,12 ,12 ,24 ,(char *) uc2_5385 },
	{ 0x5386 , 1 ,12 ,12 ,24 ,(char *) uc2_5386 },
	{ 0x5389 , 1 ,12 ,12 ,24 ,(char *) uc2_5389 },
	{ 0x538B , 1 ,12 ,12 ,24 ,(char *) uc2_538B },
	{ 0x538C , 1 ,12 ,12 ,24 ,(char *) uc2_538C },
	{ 0x538D , 1 ,12 ,12 ,24 ,(char *) uc2_538D },
	{ 0x5395 , 1 ,12 ,12 ,24 ,(char *) uc2_5395 },
	{ 0x5398 , 1 ,12 ,12 ,24 ,(char *) uc2_5398 },
	{ 0x539A , 1 ,12 ,12 ,24 ,(char *) uc2_539A },
	{ 0x539D , 1 ,12 ,12 ,24 ,(char *) uc2_539D },
	{ 0x539F , 1 ,12 ,12 ,24 ,(char *) uc2_539F },
	{ 0x53A2 , 1 ,12 ,12 ,24 ,(char *) uc2_53A2 },
	{ 0x53A3 , 1 ,12 ,12 ,24 ,(char *) uc2_53A3 },
	{ 0x53A5 , 1 ,12 ,12 ,24 ,(char *) uc2_53A5 },
	{ 0x53A6 , 1 ,12 ,12 ,24 ,(char *) uc2_53A6 },
	{ 0x53A8 , 1 ,12 ,12 ,24 ,(char *) uc2_53A8 },
	{ 0x53A9 , 1 ,12 ,12 ,24 ,(char *) uc2_53A9 },
	{ 0x53AE , 1 ,12 ,12 ,24 ,(char *) uc2_53AE },
	{ 0x53BB , 1 ,12 ,12 ,24 ,(char *) uc2_53BB },
	{ 0x53BF , 1 ,12 ,12 ,24 ,(char *) uc2_53BF },
	{ 0x53C1 , 1 ,12 ,12 ,24 ,(char *) uc2_53C1 },
	{ 0x53C2 , 1 ,12 ,12 ,24 ,(char *) uc2_53C2 },
	{ 0x53C8 , 1 ,12 ,12 ,24 ,(char *) uc2_53C8 },
	{ 0x53C9 , 1 ,12 ,12 ,24 ,(char *) uc2_53C9 },
	{ 0x53CA , 1 ,12 ,12 ,24 ,(char *) uc2_53CA },
	{ 0x53CB , 1 ,12 ,12 ,24 ,(char *) uc2_53CB },
	{ 0x53CC , 1 ,12 ,12 ,24 ,(char *) uc2_53CC },
	{ 0x53CD , 1 ,12 ,12 ,24 ,(char *) uc2_53CD },
	{ 0x53D0 , 1 ,12 ,12 ,24 ,(char *) uc2_53D0 },
	{ 0x53D1 , 1 ,12 ,12 ,24 ,(char *) uc2_53D1 },
	{ 0x53D4 , 1 ,12 ,12 ,24 ,(char *) uc2_53D4 },
	{ 0x53D6 , 1 ,12 ,12 ,24 ,(char *) uc2_53D6 },
	{ 0x53D7 , 1 ,12 ,12 ,24 ,(char *) uc2_53D7 },
	{ 0x53D8 , 1 ,12 ,12 ,24 ,(char *) uc2_53D8 },
	{ 0x53D9 , 1 ,12 ,12 ,24 ,(char *) uc2_53D9 },
	{ 0x53DB , 1 ,12 ,12 ,24 ,(char *) uc2_53DB },
	{ 0x53DF , 1 ,12 ,12 ,24 ,(char *) uc2_53DF },
	{ 0x53E0 , 1 ,12 ,12 ,24 ,(char *) uc2_53E0 },
	{ 0x53E3 , 1 ,12 ,12 ,24 ,(char *) uc2_53E3 },
	{ 0x53E4 , 1 ,12 ,12 ,24 ,(char *) uc2_53E4 },
	{ 0x53E5 , 1 ,12 ,12 ,24 ,(char *) uc2_53E5 },
	{ 0x53E6 , 1 ,12 ,12 ,24 ,(char *) uc2_53E6 },
	{ 0x53E8 , 1 ,12 ,12 ,24 ,(char *) uc2_53E8 },
	{ 0x53E9 , 1 ,12 ,12 ,24 ,(char *) uc2_53E9 },
	{ 0x53EA , 1 ,12 ,12 ,24 ,(char *) uc2_53EA },
	{ 0x53EB , 1 ,12 ,12 ,24 ,(char *) uc2_53EB },
	{ 0x53EC , 1 ,12 ,12 ,24 ,(char *) uc2_53EC },
	{ 0x53ED , 1 ,12 ,12 ,24 ,(char *) uc2_53ED },
	{ 0x53EE , 1 ,12 ,12 ,24 ,(char *) uc2_53EE },
	{ 0x53EF , 1 ,12 ,12 ,24 ,(char *) uc2_53EF },
	{ 0x53F0 , 1 ,12 ,12 ,24 ,(char *) uc2_53F0 },
	{ 0x53F1 , 1 ,12 ,12 ,24 ,(char *) uc2_53F1 },
	{ 0x53F2 , 1 ,12 ,12 ,24 ,(char *) uc2_53F2 },
	{ 0x53F3 , 1 ,12 ,12 ,24 ,(char *) uc2_53F3 },
	{ 0x53F5 , 1 ,12 ,12 ,24 ,(char *) uc2_53F5 },
	{ 0x53F6 , 1 ,12 ,12 ,24 ,(char *) uc2_53F6 },
	{ 0x53F7 , 1 ,12 ,12 ,24 ,(char *) uc2_53F7 },
	{ 0x53F8 , 1 ,12 ,12 ,24 ,(char *) uc2_53F8 },
	{ 0x53F9 , 1 ,12 ,12 ,24 ,(char *) uc2_53F9 },
	{ 0x53FB , 1 ,12 ,12 ,24 ,(char *) uc2_53FB },
	{ 0x53FC , 1 ,12 ,12 ,24 ,(char *) uc2_53FC },
	{ 0x53FD , 1 ,12 ,12 ,24 ,(char *) uc2_53FD },
	{ 0x5401 , 1 ,12 ,12 ,24 ,(char *) uc2_5401 },
	{ 0x5403 , 1 ,12 ,12 ,24 ,(char *) uc2_5403 },
	{ 0x5404 , 1 ,12 ,12 ,24 ,(char *) uc2_5404 },
	{ 0x5406 , 1 ,12 ,12 ,24 ,(char *) uc2_5406 },
	{ 0x5408 , 1 ,12 ,12 ,24 ,(char *) uc2_5408 },
	{ 0x5409 , 1 ,12 ,12 ,24 ,(char *) uc2_5409 },
	{ 0x540A , 1 ,12 ,12 ,24 ,(char *) uc2_540A },
	{ 0x540C , 1 ,12 ,12 ,24 ,(char *) uc2_540C },
	{ 0x540D , 1 ,12 ,12 ,24 ,(char *) uc2_540D },
	{ 0x540E , 1 ,12 ,12 ,24 ,(char *) uc2_540E },
	{ 0x540F , 1 ,12 ,12 ,24 ,(char *) uc2_540F },
	{ 0x5410 , 1 ,12 ,12 ,24 ,(char *) uc2_5410 },
	{ 0x5411 , 1 ,12 ,12 ,24 ,(char *) uc2_5411 },
	{ 0x5412 , 1 ,12 ,12 ,24 ,(char *) uc2_5412 },
	{ 0x5413 , 1 ,12 ,12 ,24 ,(char *) uc2_5413 },
	{ 0x5415 , 1 ,12 ,12 ,24 ,(char *) uc2_5415 },
	{ 0x5416 , 1 ,12 ,12 ,24 ,(char *) uc2_5416 },
	{ 0x5417 , 1 ,12 ,12 ,24 ,(char *) uc2_5417 },
	{ 0x541B , 1 ,12 ,12 ,24 ,(char *) uc2_541B },
	{ 0x541D , 1 ,12 ,12 ,24 ,(char *) uc2_541D },
	{ 0x541E , 1 ,12 ,12 ,24 ,(char *) uc2_541E },
	{ 0x541F , 1 ,12 ,12 ,24 ,(char *) uc2_541F },
	{ 0x5420 , 1 ,12 ,12 ,24 ,(char *) uc2_5420 },
	{ 0x5421 , 1 ,12 ,12 ,24 ,(char *) uc2_5421 },
	{ 0x5423 , 1 ,12 ,12 ,24 ,(char *) uc2_5423 },
	{ 0x5426 , 1 ,12 ,12 ,24 ,(char *) uc2_5426 },
	{ 0x5427 , 1 ,12 ,12 ,24 ,(char *) uc2_5427 },
	{ 0x5428 , 1 ,12 ,12 ,24 ,(char *) uc2_5428 },
	{ 0x5429 , 1 ,12 ,12 ,24 ,(char *) uc2_5429 },
	{ 0x542B , 1 ,12 ,12 ,24 ,(char *) uc2_542B },
	{ 0x542C , 1 ,12 ,12 ,24 ,(char *) uc2_542C },
	{ 0x542D , 1 ,12 ,12 ,24 ,(char *) uc2_542D },
	{ 0x542E , 1 ,12 ,12 ,24 ,(char *) uc2_542E },
	{ 0x542F , 1 ,12 ,12 ,24 ,(char *) uc2_542F },
	{ 0x5431 , 1 ,12 ,12 ,24 ,(char *) uc2_5431 },
	{ 0x5432 , 1 ,12 ,12 ,24 ,(char *) uc2_5432 },
	{ 0x5434 , 1 ,12 ,12 ,24 ,(char *) uc2_5434 },
	{ 0x5435 , 1 ,12 ,12 ,24 ,(char *) uc2_5435 },
	{ 0x5438 , 1 ,12 ,12 ,24 ,(char *) uc2_5438 },
	{ 0x5439 , 1 ,12 ,12 ,24 ,(char *) uc2_5439 },
	{ 0x543B , 1 ,12 ,12 ,24 ,(char *) uc2_543B },
	{ 0x543C , 1 ,12 ,12 ,24 ,(char *) uc2_543C },
	{ 0x543E , 1 ,12 ,12 ,24 ,(char *) uc2_543E },
	{ 0x5440 , 1 ,12 ,12 ,24 ,(char *) uc2_5440 },
	{ 0x5443 , 1 ,12 ,12 ,24 ,(char *) uc2_5443 },
	{ 0x5446 , 1 ,12 ,12 ,24 ,(char *) uc2_5446 },
	{ 0x5448 , 1 ,12 ,12 ,24 ,(char *) uc2_5448 },
	{ 0x544A , 1 ,12 ,12 ,24 ,(char *) uc2_544A },
	{ 0x544B , 1 ,12 ,12 ,24 ,(char *) uc2_544B },
	{ 0x5450 , 1 ,12 ,12 ,24 ,(char *) uc2_5450 },
	{ 0x5452 , 1 ,12 ,12 ,24 ,(char *) uc2_5452 },
	{ 0x5453 , 1 ,12 ,12 ,24 ,(char *) uc2_5453 },
	{ 0x5454 , 1 ,12 ,12 ,24 ,(char *) uc2_5454 },
	{ 0x5455 , 1 ,12 ,12 ,24 ,(char *) uc2_5455 },
	{ 0x5456 , 1 ,12 ,12 ,24 ,(char *) uc2_5456 },
	{ 0x5457 , 1 ,12 ,12 ,24 ,(char *) uc2_5457 },
	{ 0x5458 , 1 ,12 ,12 ,24 ,(char *) uc2_5458 },
	{ 0x5459 , 1 ,12 ,12 ,24 ,(char *) uc2_5459 },
	{ 0x545B , 1 ,12 ,12 ,24 ,(char *) uc2_545B },
	{ 0x545C , 1 ,12 ,12 ,24 ,(char *) uc2_545C },
	{ 0x5462 , 1 ,12 ,12 ,24 ,(char *) uc2_5462 },
	{ 0x5464 , 1 ,12 ,12 ,24 ,(char *) uc2_5464 },
	{ 0x5466 , 1 ,12 ,12 ,24 ,(char *) uc2_5466 },
	{ 0x5468 , 1 ,12 ,12 ,24 ,(char *) uc2_5468 },
	{ 0x5471 , 1 ,12 ,12 ,24 ,(char *) uc2_5471 },
	{ 0x5472 , 1 ,12 ,12 ,24 ,(char *) uc2_5472 },
	{ 0x5473 , 1 ,12 ,12 ,24 ,(char *) uc2_5473 },
	{ 0x5475 , 1 ,12 ,12 ,24 ,(char *) uc2_5475 },
	{ 0x5476 , 1 ,12 ,12 ,24 ,(char *) uc2_5476 },
	{ 0x5477 , 1 ,12 ,12 ,24 ,(char *) uc2_5477 },
	{ 0x5478 , 1 ,12 ,12 ,24 ,(char *) uc2_5478 },
	{ 0x547B , 1 ,12 ,12 ,24 ,(char *) uc2_547B },
	{ 0x547C , 1 ,12 ,12 ,24 ,(char *) uc2_547C },
	{ 0x547D , 1 ,12 ,12 ,24 ,(char *) uc2_547D },
	{ 0x5480 , 1 ,12 ,12 ,24 ,(char *) uc2_5480 },
	{ 0x5482 , 1 ,12 ,12 ,24 ,(char *) uc2_5482 },
	{ 0x5484 , 1 ,12 ,12 ,24 ,(char *) uc2_5484 },
	{ 0x5486 , 1 ,12 ,12 ,24 ,(char *) uc2_5486 },
	{ 0x548B , 1 ,12 ,12 ,24 ,(char *) uc2_548B },
	{ 0x548C , 1 ,12 ,12 ,24 ,(char *) uc2_548C },
	{ 0x548E , 1 ,12 ,12 ,24 ,(char *) uc2_548E },
	{ 0x548F , 1 ,12 ,12 ,24 ,(char *) uc2_548F },
	{ 0x5490 , 1 ,12 ,12 ,24 ,(char *) uc2_5490 },
	{ 0x5492 , 1 ,12 ,12 ,24 ,(char *) uc2_5492 },
	{ 0x5494 , 1 ,12 ,12 ,24 ,(char *) uc2_5494 },
	{ 0x5495 , 1 ,12 ,12 ,24 ,(char *) uc2_5495 },
	{ 0x5496 , 1 ,12 ,12 ,24 ,(char *) uc2_5496 },
	{ 0x5499 , 1 ,12 ,12 ,24 ,(char *) uc2_5499 },
	{ 0x549A , 1 ,12 ,12 ,24 ,(char *) uc2_549A },
	{ 0x549B , 1 ,12 ,12 ,24 ,(char *) uc2_549B },
	{ 0x549D , 1 ,12 ,12 ,24 ,(char *) uc2_549D },
	{ 0x54A3 , 1 ,12 ,12 ,24 ,(char *) uc2_54A3 },
	{ 0x54A4 , 1 ,12 ,12 ,24 ,(char *) uc2_54A4 },
	{ 0x54A6 , 1 ,12 ,12 ,24 ,(char *) uc2_54A6 },
	{ 0x54A7 , 1 ,12 ,12 ,24 ,(char *) uc2_54A7 },
	{ 0x54A8 , 1 ,12 ,12 ,24 ,(char *) uc2_54A8 },
	{ 0x54A9 , 1 ,12 ,12 ,24 ,(char *) uc2_54A9 },
	{ 0x54AA , 1 ,12 ,12 ,24 ,(char *) uc2_54AA },
	{ 0x54AB , 1 ,12 ,12 ,24 ,(char *) uc2_54AB },
	{ 0x54AC , 1 ,12 ,12 ,24 ,(char *) uc2_54AC },
	{ 0x54AD , 1 ,12 ,12 ,24 ,(char *) uc2_54AD },
	{ 0x54AF , 1 ,12 ,12 ,24 ,(char *) uc2_54AF },
	{ 0x54B1 , 1 ,12 ,12 ,24 ,(char *) uc2_54B1 },
	{ 0x54B3 , 1 ,12 ,12 ,24 ,(char *) uc2_54B3 },
	{ 0x54B4 , 1 ,12 ,12 ,24 ,(char *) uc2_54B4 },
	{ 0x54B8 , 1 ,12 ,12 ,24 ,(char *) uc2_54B8 },
	{ 0x54BB , 1 ,12 ,12 ,24 ,(char *) uc2_54BB },
	{ 0x54BD , 1 ,12 ,12 ,24 ,(char *) uc2_54BD },
	{ 0x54BF , 1 ,12 ,12 ,24 ,(char *) uc2_54BF },
	{ 0x54C0 , 1 ,12 ,12 ,24 ,(char *) uc2_54C0 },
	{ 0x54C1 , 1 ,12 ,12 ,24 ,(char *) uc2_54C1 },
	{ 0x54C2 , 1 ,12 ,12 ,24 ,(char *) uc2_54C2 },
	{ 0x54C4 , 1 ,12 ,12 ,24 ,(char *) uc2_54C4 },
	{ 0x54C6 , 1 ,12 ,12 ,24 ,(char *) uc2_54C6 },
	{ 0x54C7 , 1 ,12 ,12 ,24 ,(char *) uc2_54C7 },
	{ 0x54C8 , 1 ,12 ,12 ,24 ,(char *) uc2_54C8 },
	{ 0x54C9 , 1 ,12 ,12 ,24 ,(char *) uc2_54C9 },
	{ 0x54CC , 1 ,12 ,12 ,24 ,(char *) uc2_54CC },
	{ 0x54CD , 1 ,12 ,12 ,24 ,(char *) uc2_54CD },
	{ 0x54CE , 1 ,12 ,12 ,24 ,(char *) uc2_54CE },
	{ 0x54CF , 1 ,12 ,12 ,24 ,(char *) uc2_54CF },
	{ 0x54D0 , 1 ,12 ,12 ,24 ,(char *) uc2_54D0 },
	{ 0x54D1 , 1 ,12 ,12 ,24 ,(char *) uc2_54D1 },
	{ 0x54D2 , 1 ,12 ,12 ,24 ,(char *) uc2_54D2 },
	{ 0x54D3 , 1 ,12 ,12 ,24 ,(char *) uc2_54D3 },
	{ 0x54D4 , 1 ,12 ,12 ,24 ,(char *) uc2_54D4 },
	{ 0x54D5 , 1 ,12 ,12 ,24 ,(char *) uc2_54D5 },
	{ 0x54D7 , 1 ,12 ,12 ,24 ,(char *) uc2_54D7 },
	{ 0x54D9 , 1 ,12 ,12 ,24 ,(char *) uc2_54D9 },
	{ 0x54DA , 1 ,12 ,12 ,24 ,(char *) uc2_54DA },
	{ 0x54DC , 1 ,12 ,12 ,24 ,(char *) uc2_54DC },
	{ 0x54DD , 1 ,12 ,12 ,24 ,(char *) uc2_54DD },
	{ 0x54DE , 1 ,12 ,12 ,24 ,(char *) uc2_54DE },
	{ 0x54DF , 1 ,12 ,12 ,24 ,(char *) uc2_54DF },
	{ 0x54E5 , 1 ,12 ,12 ,24 ,(char *) uc2_54E5 },
	{ 0x54E6 , 1 ,12 ,12 ,24 ,(char *) uc2_54E6 },
	{ 0x54E7 , 1 ,12 ,12 ,24 ,(char *) uc2_54E7 },
	{ 0x54E8 , 1 ,12 ,12 ,24 ,(char *) uc2_54E8 },
	{ 0x54E9 , 1 ,12 ,12 ,24 ,(char *) uc2_54E9 },
	{ 0x54EA , 1 ,12 ,12 ,24 ,(char *) uc2_54EA },
	{ 0x54ED , 1 ,12 ,12 ,24 ,(char *) uc2_54ED },
	{ 0x54EE , 1 ,12 ,12 ,24 ,(char *) uc2_54EE },
	{ 0x54F2 , 1 ,12 ,12 ,24 ,(char *) uc2_54F2 },
	{ 0x54F3 , 1 ,12 ,12 ,24 ,(char *) uc2_54F3 },
	{ 0x54FA , 1 ,12 ,12 ,24 ,(char *) uc2_54FA },
	{ 0x54FC , 1 ,12 ,12 ,24 ,(char *) uc2_54FC },
	{ 0x54FD , 1 ,12 ,12 ,24 ,(char *) uc2_54FD },
	{ 0x54FF , 1 ,12 ,12 ,24 ,(char *) uc2_54FF },
	{ 0x5501 , 1 ,12 ,12 ,24 ,(char *) uc2_5501 },
	{ 0x5506 , 1 ,12 ,12 ,24 ,(char *) uc2_5506 },
	{ 0x5507 , 1 ,12 ,12 ,24 ,(char *) uc2_5507 },
	{ 0x5509 , 1 ,12 ,12 ,24 ,(char *) uc2_5509 },
	{ 0x550F , 1 ,12 ,12 ,24 ,(char *) uc2_550F },
	{ 0x5510 , 1 ,12 ,12 ,24 ,(char *) uc2_5510 },
	{ 0x5511 , 1 ,12 ,12 ,24 ,(char *) uc2_5511 },
	{ 0x5514 , 1 ,12 ,12 ,24 ,(char *) uc2_5514 },
	{ 0x551B , 1 ,12 ,12 ,24 ,(char *) uc2_551B },
	{ 0x5520 , 1 ,12 ,12 ,24 ,(char *) uc2_5520 },
	{ 0x5522 , 1 ,12 ,12 ,24 ,(char *) uc2_5522 },
	{ 0x5523 , 1 ,12 ,12 ,24 ,(char *) uc2_5523 },
	{ 0x5524 , 1 ,12 ,12 ,24 ,(char *) uc2_5524 },
	{ 0x5527 , 1 ,12 ,12 ,24 ,(char *) uc2_5527 },
	{ 0x552A , 1 ,12 ,12 ,24 ,(char *) uc2_552A },
	{ 0x552C , 1 ,12 ,12 ,24 ,(char *) uc2_552C },
	{ 0x552E , 1 ,12 ,12 ,24 ,(char *) uc2_552E },
	{ 0x552F , 1 ,12 ,12 ,24 ,(char *) uc2_552F },
	{ 0x5530 , 1 ,12 ,12 ,24 ,(char *) uc2_5530 },
	{ 0x5531 , 1 ,12 ,12 ,24 ,(char *) uc2_5531 },
	{ 0x5533 , 1 ,12 ,12 ,24 ,(char *) uc2_5533 },
	{ 0x5537 , 1 ,12 ,12 ,24 ,(char *) uc2_5537 },
	{ 0x553C , 1 ,12 ,12 ,24 ,(char *) uc2_553C },
	{ 0x553E , 1 ,12 ,12 ,24 ,(char *) uc2_553E },
	{ 0x553F , 1 ,12 ,12 ,24 ,(char *) uc2_553F },
	{ 0x5541 , 1 ,12 ,12 ,24 ,(char *) uc2_5541 },
	{ 0x5543 , 1 ,12 ,12 ,24 ,(char *) uc2_5543 },
	{ 0x5544 , 1 ,12 ,12 ,24 ,(char *) uc2_5544 },
	{ 0x5546 , 1 ,12 ,12 ,24 ,(char *) uc2_5546 },
	{ 0x5549 , 1 ,12 ,12 ,24 ,(char *) uc2_5549 },
	{ 0x554A , 1 ,12 ,12 ,24 ,(char *) uc2_554A },
	{ 0x5550 , 1 ,12 ,12 ,24 ,(char *) uc2_5550 },
	{ 0x5555 , 1 ,12 ,12 ,24 ,(char *) uc2_5555 },
	{ 0x5556 , 1 ,12 ,12 ,24 ,(char *) uc2_5556 },
	{ 0x555C , 1 ,12 ,12 ,24 ,(char *) uc2_555C },
	{ 0x5561 , 1 ,12 ,12 ,24 ,(char *) uc2_5561 },
	{ 0x5564 , 1 ,12 ,12 ,24 ,(char *) uc2_5564 },
	{ 0x5565 , 1 ,12 ,12 ,24 ,(char *) uc2_5565 },
	{ 0x5566 , 1 ,12 ,12 ,24 ,(char *) uc2_5566 },
	{ 0x5567 , 1 ,12 ,12 ,24 ,(char *) uc2_5567 },
	{ 0x556A , 1 ,12 ,12 ,24 ,(char *) uc2_556A },
	{ 0x556C , 1 ,12 ,12 ,24 ,(char *) uc2_556C },
	{ 0x556D , 1 ,12 ,12 ,24 ,(char *) uc2_556D },
	{ 0x556E , 1 ,12 ,12 ,24 ,(char *) uc2_556E },
	{ 0x5575 , 1 ,12 ,12 ,24 ,(char *) uc2_5575 },
	{ 0x5576 , 1 ,12 ,12 ,24 ,(char *) uc2_5576 },
	{ 0x5577 , 1 ,12 ,12 ,24 ,(char *) uc2_5577 },
	{ 0x5578 , 1 ,12 ,12 ,24 ,(char *) uc2_5578 },
	{ 0x557B , 1 ,12 ,12 ,24 ,(char *) uc2_557B },
	{ 0x557C , 1 ,12 ,12 ,24 ,(char *) uc2_557C },
	{ 0x557E , 1 ,12 ,12 ,24 ,(char *) uc2_557E },
	{ 0x5580 , 1 ,12 ,12 ,24 ,(char *) uc2_5580 },
	{ 0x5581 , 1 ,12 ,12 ,24 ,(char *) uc2_5581 },
	{ 0x5582 , 1 ,12 ,12 ,24 ,(char *) uc2_5582 },
	{ 0x5583 , 1 ,12 ,12 ,24 ,(char *) uc2_5583 },
	{ 0x5584 , 1 ,12 ,12 ,24 ,(char *) uc2_5584 },
	{ 0x5587 , 1 ,12 ,12 ,24 ,(char *) uc2_5587 },
	{ 0x5588 , 1 ,12 ,12 ,24 ,(char *) uc2_5588 },
	{ 0x5589 , 1 ,12 ,12 ,24 ,(char *) uc2_5589 },
	{ 0x558A , 1 ,12 ,12 ,24 ,(char *) uc2_558A },
	{ 0x558B , 1 ,12 ,12 ,24 ,(char *) uc2_558B },
	{ 0x558F , 1 ,12 ,12 ,24 ,(char *) uc2_558F },
	{ 0x5591 , 1 ,12 ,12 ,24 ,(char *) uc2_5591 },
	{ 0x5594 , 1 ,12 ,12 ,24 ,(char *) uc2_5594 },
	{ 0x5598 , 1 ,12 ,12 ,24 ,(char *) uc2_5598 },
	{ 0x5599 , 1 ,12 ,12 ,24 ,(char *) uc2_5599 },
	{ 0x559C , 1 ,12 ,12 ,24 ,(char *) uc2_559C },
	{ 0x559D , 1 ,12 ,12 ,24 ,(char *) uc2_559D },
	{ 0x559F , 1 ,12 ,12 ,24 ,(char *) uc2_559F },
	{ 0x55A7 , 1 ,12 ,12 ,24 ,(char *) uc2_55A7 },
	{ 0x55B1 , 1 ,12 ,12 ,24 ,(char *) uc2_55B1 },
	{ 0x55B3 , 1 ,12 ,12 ,24 ,(char *) uc2_55B3 },
	{ 0x55B5 , 1 ,12 ,12 ,24 ,(char *) uc2_55B5 },
	{ 0x55B7 , 1 ,12 ,12 ,24 ,(char *) uc2_55B7 },
	{ 0x55B9 , 1 ,12 ,12 ,24 ,(char *) uc2_55B9 },
	{ 0x55BB , 1 ,12 ,12 ,24 ,(char *) uc2_55BB },
	{ 0x55BD , 1 ,12 ,12 ,24 ,(char *) uc2_55BD },
	{ 0x55BE , 1 ,12 ,12 ,24 ,(char *) uc2_55BE },
	{ 0x55C4 , 1 ,12 ,12 ,24 ,(char *) uc2_55C4 },
	{ 0x55C5 , 1 ,12 ,12 ,24 ,(char *) uc2_55C5 },
	{ 0x55C9 , 1 ,12 ,12 ,24 ,(char *) uc2_55C9 },
	{ 0x55CC , 1 ,12 ,12 ,24 ,(char *) uc2_55CC },
	{ 0x55CD , 1 ,12 ,12 ,24 ,(char *) uc2_55CD },
	{ 0x55D1 , 1 ,12 ,12 ,24 ,(char *) uc2_55D1 },
	{ 0x55D2 , 1 ,12 ,12 ,24 ,(char *) uc2_55D2 },
	{ 0x55D3 , 1 ,12 ,12 ,24 ,(char *) uc2_55D3 },
	{ 0x55D4 , 1 ,12 ,12 ,24 ,(char *) uc2_55D4 },
	{ 0x55D6 , 1 ,12 ,12 ,24 ,(char *) uc2_55D6 },
	{ 0x55DC , 1 ,12 ,12 ,24 ,(char *) uc2_55DC },
	{ 0x55DD , 1 ,12 ,12 ,24 ,(char *) uc2_55DD },
	{ 0x55DF , 1 ,12 ,12 ,24 ,(char *) uc2_55DF },
	{ 0x55E1 , 1 ,12 ,12 ,24 ,(char *) uc2_55E1 },
	{ 0x55E3 , 1 ,12 ,12 ,24 ,(char *) uc2_55E3 },
	{ 0x55E4 , 1 ,12 ,12 ,24 ,(char *) uc2_55E4 },
	{ 0x55E5 , 1 ,12 ,12 ,24 ,(char *) uc2_55E5 },
	{ 0x55E6 , 1 ,12 ,12 ,24 ,(char *) uc2_55E6 },
	{ 0x55E8 , 1 ,12 ,12 ,24 ,(char *) uc2_55E8 },
	{ 0x55EA , 1 ,12 ,12 ,24 ,(char *) uc2_55EA },
	{ 0x55EB , 1 ,12 ,12 ,24 ,(char *) uc2_55EB },
	{ 0x55EC , 1 ,12 ,12 ,24 ,(char *) uc2_55EC },
	{ 0x55EF , 1 ,12 ,12 ,24 ,(char *) uc2_55EF },
	{ 0x55F2 , 1 ,12 ,12 ,24 ,(char *) uc2_55F2 },
	{ 0x55F3 , 1 ,12 ,12 ,24 ,(char *) uc2_55F3 },
	{ 0x55F5 , 1 ,12 ,12 ,24 ,(char *) uc2_55F5 },
	{ 0x55F7 , 1 ,12 ,12 ,24 ,(char *) uc2_55F7 },
	{ 0x55FD , 1 ,12 ,12 ,24 ,(char *) uc2_55FD },
	{ 0x55FE , 1 ,12 ,12 ,24 ,(char *) uc2_55FE },
	{ 0x5600 , 1 ,12 ,12 ,24 ,(char *) uc2_5600 },
	{ 0x5601 , 1 ,12 ,12 ,24 ,(char *) uc2_5601 },
	{ 0x5608 , 1 ,12 ,12 ,24 ,(char *) uc2_5608 },
	{ 0x5609 , 1 ,12 ,12 ,24 ,(char *) uc2_5609 },
	{ 0x560C , 1 ,12 ,12 ,24 ,(char *) uc2_560C },
	{ 0x560E , 1 ,12 ,12 ,24 ,(char *) uc2_560E },
	{ 0x560F , 1 ,12 ,12 ,24 ,(char *) uc2_560F },
	{ 0x5618 , 1 ,12 ,12 ,24 ,(char *) uc2_5618 },
	{ 0x561B , 1 ,12 ,12 ,24 ,(char *) uc2_561B },
	{ 0x561E , 1 ,12 ,12 ,24 ,(char *) uc2_561E },
	{ 0x561F , 1 ,12 ,12 ,24 ,(char *) uc2_561F },
	{ 0x5623 , 1 ,12 ,12 ,24 ,(char *) uc2_5623 },
	{ 0x5624 , 1 ,12 ,12 ,24 ,(char *) uc2_5624 },
	{ 0x5627 , 1 ,12 ,12 ,24 ,(char *) uc2_5627 },
	{ 0x562C , 1 ,12 ,12 ,24 ,(char *) uc2_562C },
	{ 0x562D , 1 ,12 ,12 ,24 ,(char *) uc2_562D },
	{ 0x5631 , 1 ,12 ,12 ,24 ,(char *) uc2_5631 },
	{ 0x5632 , 1 ,12 ,12 ,24 ,(char *) uc2_5632 },
	{ 0x5634 , 1 ,12 ,12 ,24 ,(char *) uc2_5634 },
	{ 0x5636 , 1 ,12 ,12 ,24 ,(char *) uc2_5636 },
	{ 0x5639 , 1 ,12 ,12 ,24 ,(char *) uc2_5639 },
	{ 0x563B , 1 ,12 ,12 ,24 ,(char *) uc2_563B },
	{ 0x563F , 1 ,12 ,12 ,24 ,(char *) uc2_563F },
	{ 0x564C , 1 ,12 ,12 ,24 ,(char *) uc2_564C },
	{ 0x564D , 1 ,12 ,12 ,24 ,(char *) uc2_564D },
	{ 0x564E , 1 ,12 ,12 ,24 ,(char *) uc2_564E },
	{ 0x5654 , 1 ,12 ,12 ,24 ,(char *) uc2_5654 },
	{ 0x5657 , 1 ,12 ,12 ,24 ,(char *) uc2_5657 },
	{ 0x5658 , 1 ,12 ,12 ,24 ,(char *) uc2_5658 },
	{ 0x5659 , 1 ,12 ,12 ,24 ,(char *) uc2_5659 },
	{ 0x565C , 1 ,12 ,12 ,24 ,(char *) uc2_565C },
	{ 0x5662 , 1 ,12 ,12 ,24 ,(char *) uc2_5662 },
	{ 0x5664 , 1 ,12 ,12 ,24 ,(char *) uc2_5664 },
	{ 0x5668 , 1 ,12 ,12 ,24 ,(char *) uc2_5668 },
	{ 0x5669 , 1 ,12 ,12 ,24 ,(char *) uc2_5669 },
	{ 0x566A , 1 ,12 ,12 ,24 ,(char *) uc2_566A },
	{ 0x566B , 1 ,12 ,12 ,24 ,(char *) uc2_566B },
	{ 0x566C , 1 ,12 ,12 ,24 ,(char *) uc2_566C },
	{ 0x5671 , 1 ,12 ,12 ,24 ,(char *) uc2_5671 },
	{ 0x5676 , 1 ,12 ,12 ,24 ,(char *) uc2_5676 },
	{ 0x567B , 1 ,12 ,12 ,24 ,(char *) uc2_567B },
	{ 0x567C , 1 ,12 ,12 ,24 ,(char *) uc2_567C },
	{ 0x5685 , 1 ,12 ,12 ,24 ,(char *) uc2_5685 },
	{ 0x5686 , 1 ,12 ,12 ,24 ,(char *) uc2_5686 },
	{ 0x568E , 1 ,12 ,12 ,24 ,(char *) uc2_568E },
	{ 0x568F , 1 ,12 ,12 ,24 ,(char *) uc2_568F },
	{ 0x5693 , 1 ,12 ,12 ,24 ,(char *) uc2_5693 },
	{ 0x56A3 , 1 ,12 ,12 ,24 ,(char *) uc2_56A3 },
	{ 0x56AF , 1 ,12 ,12 ,24 ,(char *) uc2_56AF },
	{ 0x56B7 , 1 ,12 ,12 ,24 ,(char *) uc2_56B7 },
	{ 0x56BC , 1 ,12 ,12 ,24 ,(char *) uc2_56BC },
	{ 0x56CA , 1 ,12 ,12 ,24 ,(char *) uc2_56CA },
	{ 0x56D4 , 1 ,12 ,12 ,24 ,(char *) uc2_56D4 },
	{ 0x56D7 , 1 ,12 ,12 ,24 ,(char *) uc2_56D7 },
	{ 0x56DA , 1 ,12 ,12 ,24 ,(char *) uc2_56DA },
	{ 0x56DB , 1 ,12 ,12 ,24 ,(char *) uc2_56DB },
	{ 0x56DD , 1 ,12 ,12 ,24 ,(char *) uc2_56DD },
	{ 0x56DE , 1 ,12 ,12 ,24 ,(char *) uc2_56DE },
	{ 0x56DF , 1 ,12 ,12 ,24 ,(char *) uc2_56DF },
	{ 0x56E0 , 1 ,12 ,12 ,24 ,(char *) uc2_56E0 },
	{ 0x56E1 , 1 ,12 ,12 ,24 ,(char *) uc2_56E1 },
	{ 0x56E2 , 1 ,12 ,12 ,24 ,(char *) uc2_56E2 },
	{ 0x56E4 , 1 ,12 ,12 ,24 ,(char *) uc2_56E4 },
	{ 0x56EB , 1 ,12 ,12 ,24 ,(char *) uc2_56EB },
	{ 0x56ED , 1 ,12 ,12 ,24 ,(char *) uc2_56ED },
	{ 0x56F0 , 1 ,12 ,12 ,24 ,(char *) uc2_56F0 },
	{ 0x56F1 , 1 ,12 ,12 ,24 ,(char *) uc2_56F1 },
	{ 0x56F4 , 1 ,12 ,12 ,24 ,(char *) uc2_56F4 },
	{ 0x56F5 , 1 ,12 ,12 ,24 ,(char *) uc2_56F5 },
	{ 0x56F9 , 1 ,12 ,12 ,24 ,(char *) uc2_56F9 },
	{ 0x56FA , 1 ,12 ,12 ,24 ,(char *) uc2_56FA },
	{ 0x56FD , 1 ,12 ,12 ,24 ,(char *) uc2_56FD },
	{ 0x56FE , 1 ,12 ,12 ,24 ,(char *) uc2_56FE },
	{ 0x56FF , 1 ,12 ,12 ,24 ,(char *) uc2_56FF },
	{ 0x5703 , 1 ,12 ,12 ,24 ,(char *) uc2_5703 },
	{ 0x5704 , 1 ,12 ,12 ,24 ,(char *) uc2_5704 },
	{ 0x5706 , 1 ,12 ,12 ,24 ,(char *) uc2_5706 },
	{ 0x5708 , 1 ,12 ,12 ,24 ,(char *) uc2_5708 },
	{ 0x5709 , 1 ,12 ,12 ,24 ,(char *) uc2_5709 },
	{ 0x570A , 1 ,12 ,12 ,24 ,(char *) uc2_570A },
	{ 0x571C , 1 ,12 ,12 ,24 ,(char *) uc2_571C },
	{ 0x571F , 1 ,12 ,12 ,24 ,(char *) uc2_571F },
	{ 0x5723 , 1 ,12 ,12 ,24 ,(char *) uc2_5723 },
	{ 0x5728 , 1 ,12 ,12 ,24 ,(char *) uc2_5728 },
	{ 0x5729 , 1 ,12 ,12 ,24 ,(char *) uc2_5729 },
	{ 0x572A , 1 ,12 ,12 ,24 ,(char *) uc2_572A },
	{ 0x572C , 1 ,12 ,12 ,24 ,(char *) uc2_572C },
	{ 0x572D , 1 ,12 ,12 ,24 ,(char *) uc2_572D },
	{ 0x572E , 1 ,12 ,12 ,24 ,(char *) uc2_572E },
	{ 0x572F , 1 ,12 ,12 ,24 ,(char *) uc2_572F },
	{ 0x5730 , 1 ,12 ,12 ,24 ,(char *) uc2_5730 },
	{ 0x5733 , 1 ,12 ,12 ,24 ,(char *) uc2_5733 },
	{ 0x5739 , 1 ,12 ,12 ,24 ,(char *) uc2_5739 },
	{ 0x573A , 1 ,12 ,12 ,24 ,(char *) uc2_573A },
	{ 0x573B , 1 ,12 ,12 ,24 ,(char *) uc2_573B },
	{ 0x573E , 1 ,12 ,12 ,24 ,(char *) uc2_573E },
	{ 0x5740 , 1 ,12 ,12 ,24 ,(char *) uc2_5740 },
	{ 0x5742 , 1 ,12 ,12 ,24 ,(char *) uc2_5742 },
	{ 0x5747 , 1 ,12 ,12 ,24 ,(char *) uc2_5747 },
	{ 0x574A , 1 ,12 ,12 ,24 ,(char *) uc2_574A },
	{ 0x574C , 1 ,12 ,12 ,24 ,(char *) uc2_574C },
	{ 0x574D , 1 ,12 ,12 ,24 ,(char *) uc2_574D },
	{ 0x574E , 1 ,12 ,12 ,24 ,(char *) uc2_574E },
	{ 0x574F , 1 ,12 ,12 ,24 ,(char *) uc2_574F },
	{ 0x5750 , 1 ,12 ,12 ,24 ,(char *) uc2_5750 },
	{ 0x5751 , 1 ,12 ,12 ,24 ,(char *) uc2_5751 },
	{ 0x5757 , 1 ,12 ,12 ,24 ,(char *) uc2_5757 },
	{ 0x575A , 1 ,12 ,12 ,24 ,(char *) uc2_575A },
	{ 0x575B , 1 ,12 ,12 ,24 ,(char *) uc2_575B },
	{ 0x575C , 1 ,12 ,12 ,24 ,(char *) uc2_575C },
	{ 0x575D , 1 ,12 ,12 ,24 ,(char *) uc2_575D },
	{ 0x575E , 1 ,12 ,12 ,24 ,(char *) uc2_575E },
	{ 0x575F , 1 ,12 ,12 ,24 ,(char *) uc2_575F },
	{ 0x5760 , 1 ,12 ,12 ,24 ,(char *) uc2_5760 },
	{ 0x5761 , 1 ,12 ,12 ,24 ,(char *) uc2_5761 },
	{ 0x5764 , 1 ,12 ,12 ,24 ,(char *) uc2_5764 },
	{ 0x5766 , 1 ,12 ,12 ,24 ,(char *) uc2_5766 },
	{ 0x5768 , 1 ,12 ,12 ,24 ,(char *) uc2_5768 },
	{ 0x5769 , 1 ,12 ,12 ,24 ,(char *) uc2_5769 },
	{ 0x576A , 1 ,12 ,12 ,24 ,(char *) uc2_576A },
	{ 0x576B , 1 ,12 ,12 ,24 ,(char *) uc2_576B },
	{ 0x576D , 1 ,12 ,12 ,24 ,(char *) uc2_576D },
	{ 0x576F , 1 ,12 ,12 ,24 ,(char *) uc2_576F },
	{ 0x5773 , 1 ,12 ,12 ,24 ,(char *) uc2_5773 },
	{ 0x5776 , 1 ,12 ,12 ,24 ,(char *) uc2_5776 },
	{ 0x5777 , 1 ,12 ,12 ,24 ,(char *) uc2_5777 },
	{ 0x5779 , 1 ,12 ,12 ,24 ,(char *) uc2_5779 },
	{ 0x577B , 1 ,12 ,12 ,24 ,(char *) uc2_577B },
	{ 0x577C , 1 ,12 ,12 ,24 ,(char *) uc2_577C },
	{ 0x5782 , 1 ,12 ,12 ,24 ,(char *) uc2_5782 },
	{ 0x5783 , 1 ,12 ,12 ,24 ,(char *) uc2_5783 },
	{ 0x5784 , 1 ,12 ,12 ,24 ,(char *) uc2_5784 },
	{ 0x5785 , 1 ,12 ,12 ,24 ,(char *) uc2_5785 },
	{ 0x5786 , 1 ,12 ,12 ,24 ,(char *) uc2_5786 },
	{ 0x578B , 1 ,12 ,12 ,24 ,(char *) uc2_578B },
	{ 0x578C , 1 ,12 ,12 ,24 ,(char *) uc2_578C },
	{ 0x5792 , 1 ,12 ,12 ,24 ,(char *) uc2_5792 },
	{ 0x5793 , 1 ,12 ,12 ,24 ,(char *) uc2_5793 },
	{ 0x579B , 1 ,12 ,12 ,24 ,(char *) uc2_579B },
	{ 0x57A0 , 1 ,12 ,12 ,24 ,(char *) uc2_57A0 },
	{ 0x57A1 , 1 ,12 ,12 ,24 ,(char *) uc2_57A1 },
	{ 0x57A2 , 1 ,12 ,12 ,24 ,(char *) uc2_57A2 },
	{ 0x57A3 , 1 ,12 ,12 ,24 ,(char *) uc2_57A3 },
	{ 0x57A4 , 1 ,12 ,12 ,24 ,(char *) uc2_57A4 },
	{ 0x57A6 , 1 ,12 ,12 ,24 ,(char *) uc2_57A6 },
	{ 0x57A7 , 1 ,12 ,12 ,24 ,(char *) uc2_57A7 },
	{ 0x57A9 , 1 ,12 ,12 ,24 ,(char *) uc2_57A9 },
	{ 0x57AB , 1 ,12 ,12 ,24 ,(char *) uc2_57AB },
	{ 0x57AD , 1 ,12 ,12 ,24 ,(char *) uc2_57AD },
	{ 0x57AE , 1 ,12 ,12 ,24 ,(char *) uc2_57AE },
	{ 0x57B2 , 1 ,12 ,12 ,24 ,(char *) uc2_57B2 },
	{ 0x57B4 , 1 ,12 ,12 ,24 ,(char *) uc2_57B4 },
	{ 0x57B8 , 1 ,12 ,12 ,24 ,(char *) uc2_57B8 },
	{ 0x57C2 , 1 ,12 ,12 ,24 ,(char *) uc2_57C2 },
	{ 0x57C3 , 1 ,12 ,12 ,24 ,(char *) uc2_57C3 },
	{ 0x57CB , 1 ,12 ,12 ,24 ,(char *) uc2_57CB },
	{ 0x57CE , 1 ,12 ,12 ,24 ,(char *) uc2_57CE },
	{ 0x57CF , 1 ,12 ,12 ,24 ,(char *) uc2_57CF },
	{ 0x57D2 , 1 ,12 ,12 ,24 ,(char *) uc2_57D2 },
	{ 0x57D4 , 1 ,12 ,12 ,24 ,(char *) uc2_57D4 },
	{ 0x57D5 , 1 ,12 ,12 ,24 ,(char *) uc2_57D5 },
	{ 0x57D7 , 1 ,12 ,12 ,24 ,(char *) uc2_57D7 },
	{ 0x57D8 , 1 ,12 ,12 ,24 ,(char *) uc2_57D8 },
	{ 0x57D9 , 1 ,12 ,12 ,24 ,(char *) uc2_57D9 },
	{ 0x57DA , 1 ,12 ,12 ,24 ,(char *) uc2_57DA },
	{ 0x57DD , 1 ,12 ,12 ,24 ,(char *) uc2_57DD },
	{ 0x57DF , 1 ,12 ,12 ,24 ,(char *) uc2_57DF },
	{ 0x57E0 , 1 ,12 ,12 ,24 ,(char *) uc2_57E0 },
	{ 0x57E4 , 1 ,12 ,12 ,24 ,(char *) uc2_57E4 },
	{ 0x57ED , 1 ,12 ,12 ,24 ,(char *) uc2_57ED },
	{ 0x57EF , 1 ,12 ,12 ,24 ,(char *) uc2_57EF },
	{ 0x57F4 , 1 ,12 ,12 ,24 ,(char *) uc2_57F4 },
	{ 0x57F8 , 1 ,12 ,12 ,24 ,(char *) uc2_57F8 },
	{ 0x57F9 , 1 ,12 ,12 ,24 ,(char *) uc2_57F9 },
	{ 0x57FA , 1 ,12 ,12 ,24 ,(char *) uc2_57FA },
	{ 0x57FD , 1 ,12 ,12 ,24 ,(char *) uc2_57FD },
	{ 0x5800 , 1 ,12 ,12 ,24 ,(char *) uc2_5800 },
	{ 0x5802 , 1 ,12 ,12 ,24 ,(char *) uc2_5802 },
	{ 0x5806 , 1 ,12 ,12 ,24 ,(char *) uc2_5806 },
	{ 0x5807 , 1 ,12 ,12 ,24 ,(char *) uc2_5807 },
	{ 0x580B , 1 ,12 ,12 ,24 ,(char *) uc2_580B },
	{ 0x580D , 1 ,12 ,12 ,24 ,(char *) uc2_580D },
	{ 0x5811 , 1 ,12 ,12 ,24 ,(char *) uc2_5811 },
	{ 0x5815 , 1 ,12 ,12 ,24 ,(char *) uc2_5815 },
	{ 0x5819 , 1 ,12 ,12 ,24 ,(char *) uc2_5819 },
	{ 0x581E , 1 ,12 ,12 ,24 ,(char *) uc2_581E },
	{ 0x5820 , 1 ,12 ,12 ,24 ,(char *) uc2_5820 },
	{ 0x5821 , 1 ,12 ,12 ,24 ,(char *) uc2_5821 },
	{ 0x5824 , 1 ,12 ,12 ,24 ,(char *) uc2_5824 },
	{ 0x582A , 1 ,12 ,12 ,24 ,(char *) uc2_582A },
	{ 0x5830 , 1 ,12 ,12 ,24 ,(char *) uc2_5830 },
	{ 0x5835 , 1 ,12 ,12 ,24 ,(char *) uc2_5835 },
	{ 0x583E , 1 ,12 ,12 ,24 ,(char *) uc2_583E },
	{ 0x5844 , 1 ,12 ,12 ,24 ,(char *) uc2_5844 },
	{ 0x584C , 1 ,12 ,12 ,24 ,(char *) uc2_584C },
	{ 0x584D , 1 ,12 ,12 ,24 ,(char *) uc2_584D },
	{ 0x5851 , 1 ,12 ,12 ,24 ,(char *) uc2_5851 },
	{ 0x5854 , 1 ,12 ,12 ,24 ,(char *) uc2_5854 },
	{ 0x5858 , 1 ,12 ,12 ,24 ,(char *) uc2_5858 },
	{ 0x585E , 1 ,12 ,12 ,24 ,(char *) uc2_585E },
	{ 0x5865 , 1 ,12 ,12 ,24 ,(char *) uc2_5865 },
	{ 0x586B , 1 ,12 ,12 ,24 ,(char *) uc2_586B },
	{ 0x586C , 1 ,12 ,12 ,24 ,(char *) uc2_586C },
	{ 0x587E , 1 ,12 ,12 ,24 ,(char *) uc2_587E },
	{ 0x5880 , 1 ,12 ,12 ,24 ,(char *) uc2_5880 },
	{ 0x5881 , 1 ,12 ,12 ,24 ,(char *) uc2_5881 },
	{ 0x5883 , 1 ,12 ,12 ,24 ,(char *) uc2_5883 },
	{ 0x5885 , 1 ,12 ,12 ,24 ,(char *) uc2_5885 },
	{ 0x5889 , 1 ,12 ,12 ,24 ,(char *) uc2_5889 },
	{ 0x5892 , 1 ,12 ,12 ,24 ,(char *) uc2_5892 },
	{ 0x5893 , 1 ,12 ,12 ,24 ,(char *) uc2_5893 },
	{ 0x5899 , 1 ,12 ,12 ,24 ,(char *) uc2_5899 },
	{ 0x589A , 1 ,12 ,12 ,24 ,(char *) uc2_589A },
	{ 0x589E , 1 ,12 ,12 ,24 ,(char *) uc2_589E },
	{ 0x589F , 1 ,12 ,12 ,24 ,(char *) uc2_589F },
	{ 0x58A8 , 1 ,12 ,12 ,24 ,(char *) uc2_58A8 },
	{ 0x58A9 , 1 ,12 ,12 ,24 ,(char *) uc2_58A9 },
	{ 0x58BC , 1 ,12 ,12 ,24 ,(char *) uc2_58BC },
	{ 0x58C1 , 1 ,12 ,12 ,24 ,(char *) uc2_58C1 },
	{ 0x58C5 , 1 ,12 ,12 ,24 ,(char *) uc2_58C5 },
	{ 0x58D1 , 1 ,12 ,12 ,24 ,(char *) uc2_58D1 },
	{ 0x58D5 , 1 ,12 ,12 ,24 ,(char *) uc2_58D5 },
	{ 0x58E4 , 1 ,12 ,12 ,24 ,(char *) uc2_58E4 },
	{ 0x58EB , 1 ,12 ,12 ,24 ,(char *) uc2_58EB },
	{ 0x58EC , 1 ,12 ,12 ,24 ,(char *) uc2_58EC },
	{ 0x58EE , 1 ,12 ,12 ,24 ,(char *) uc2_58EE },
	{ 0x58F0 , 1 ,12 ,12 ,24 ,(char *) uc2_58F0 },
	{ 0x58F3 , 1 ,12 ,12 ,24 ,(char *) uc2_58F3 },
	{ 0x58F6 , 1 ,12 ,12 ,24 ,(char *) uc2_58F6 },
	{ 0x58F9 , 1 ,12 ,12 ,24 ,(char *) uc2_58F9 },
	{ 0x5904 , 1 ,12 ,12 ,24 ,(char *) uc2_5904 },
	{ 0x5907 , 1 ,12 ,12 ,24 ,(char *) uc2_5907 },
	{ 0x590D , 1 ,12 ,12 ,24 ,(char *) uc2_590D },
	{ 0x590F , 1 ,12 ,12 ,24 ,(char *) uc2_590F },
	{ 0x5914 , 1 ,12 ,12 ,24 ,(char *) uc2_5914 },
	{ 0x5915 , 1 ,12 ,12 ,24 ,(char *) uc2_5915 },
	{ 0x5916 , 1 ,12 ,12 ,24 ,(char *) uc2_5916 },
	{ 0x5919 , 1 ,12 ,12 ,24 ,(char *) uc2_5919 },
	{ 0x591A , 1 ,12 ,12 ,24 ,(char *) uc2_591A },
	{ 0x591C , 1 ,12 ,12 ,24 ,(char *) uc2_591C },
	{ 0x591F , 1 ,12 ,12 ,24 ,(char *) uc2_591F },
	{ 0x5924 , 1 ,12 ,12 ,24 ,(char *) uc2_5924 },
	{ 0x5925 , 1 ,12 ,12 ,24 ,(char *) uc2_5925 },
	{ 0x5927 , 1 ,12 ,12 ,24 ,(char *) uc2_5927 },
	{ 0x5929 , 1 ,12 ,12 ,24 ,(char *) uc2_5929 },
	{ 0x592A , 1 ,12 ,12 ,24 ,(char *) uc2_592A },
	{ 0x592B , 1 ,12 ,12 ,24 ,(char *) uc2_592B },
	{ 0x592D , 1 ,12 ,12 ,24 ,(char *) uc2_592D },
	{ 0x592E , 1 ,12 ,12 ,24 ,(char *) uc2_592E },
	{ 0x592F , 1 ,12 ,12 ,24 ,(char *) uc2_592F },
	{ 0x5931 , 1 ,12 ,12 ,24 ,(char *) uc2_5931 },
	{ 0x5934 , 1 ,12 ,12 ,24 ,(char *) uc2_5934 },
	{ 0x5937 , 1 ,12 ,12 ,24 ,(char *) uc2_5937 },
	{ 0x5938 , 1 ,12 ,12 ,24 ,(char *) uc2_5938 },
	{ 0x5939 , 1 ,12 ,12 ,24 ,(char *) uc2_5939 },
	{ 0x593A , 1 ,12 ,12 ,24 ,(char *) uc2_593A },
	{ 0x593C , 1 ,12 ,12 ,24 ,(char *) uc2_593C },
	{ 0x5941 , 1 ,12 ,12 ,24 ,(char *) uc2_5941 },
	{ 0x5942 , 1 ,12 ,12 ,24 ,(char *) uc2_5942 },
	{ 0x5944 , 1 ,12 ,12 ,24 ,(char *) uc2_5944 },
	{ 0x5947 , 1 ,12 ,12 ,24 ,(char *) uc2_5947 },
	{ 0x5948 , 1 ,12 ,12 ,24 ,(char *) uc2_5948 },
	{ 0x5949 , 1 ,12 ,12 ,24 ,(char *) uc2_5949 },
	{ 0x594B , 1 ,12 ,12 ,24 ,(char *) uc2_594B },
	{ 0x594E , 1 ,12 ,12 ,24 ,(char *) uc2_594E },
	{ 0x594F , 1 ,12 ,12 ,24 ,(char *) uc2_594F },
	{ 0x5951 , 1 ,12 ,12 ,24 ,(char *) uc2_5951 },
	{ 0x5954 , 1 ,12 ,12 ,24 ,(char *) uc2_5954 },
	{ 0x5955 , 1 ,12 ,12 ,24 ,(char *) uc2_5955 },
	{ 0x5956 , 1 ,12 ,12 ,24 ,(char *) uc2_5956 },
	{ 0x5957 , 1 ,12 ,12 ,24 ,(char *) uc2_5957 },
	{ 0x5958 , 1 ,12 ,12 ,24 ,(char *) uc2_5958 },
	{ 0x595A , 1 ,12 ,12 ,24 ,(char *) uc2_595A },
	{ 0x5960 , 1 ,12 ,12 ,24 ,(char *) uc2_5960 },
	{ 0x5962 , 1 ,12 ,12 ,24 ,(char *) uc2_5962 },
	{ 0x5965 , 1 ,12 ,12 ,24 ,(char *) uc2_5965 },
	{ 0x5973 , 1 ,12 ,12 ,24 ,(char *) uc2_5973 },
	{ 0x5974 , 1 ,12 ,12 ,24 ,(char *) uc2_5974 },
	{ 0x5976 , 1 ,12 ,12 ,24 ,(char *) uc2_5976 },
	{ 0x5978 , 1 ,12 ,12 ,24 ,(char *) uc2_5978 },
	{ 0x5979 , 1 ,12 ,12 ,24 ,(char *) uc2_5979 },
	{ 0x597D , 1 ,12 ,12 ,24 ,(char *) uc2_597D },
	{ 0x5981 , 1 ,12 ,12 ,24 ,(char *) uc2_5981 },
	{ 0x5982 , 1 ,12 ,12 ,24 ,(char *) uc2_5982 },
	{ 0x5983 , 1 ,12 ,12 ,24 ,(char *) uc2_5983 },
	{ 0x5984 , 1 ,12 ,12 ,24 ,(char *) uc2_5984 },
	{ 0x5986 , 1 ,12 ,12 ,24 ,(char *) uc2_5986 },
	{ 0x5987 , 1 ,12 ,12 ,24 ,(char *) uc2_5987 },
	{ 0x5988 , 1 ,12 ,12 ,24 ,(char *) uc2_5988 },
	{ 0x598A , 1 ,12 ,12 ,24 ,(char *) uc2_598A },
	{ 0x598D , 1 ,12 ,12 ,24 ,(char *) uc2_598D },
	{ 0x5992 , 1 ,12 ,12 ,24 ,(char *) uc2_5992 },
	{ 0x5993 , 1 ,12 ,12 ,24 ,(char *) uc2_5993 },
	{ 0x5996 , 1 ,12 ,12 ,24 ,(char *) uc2_5996 },
	{ 0x5997 , 1 ,12 ,12 ,24 ,(char *) uc2_5997 },
	{ 0x5999 , 1 ,12 ,12 ,24 ,(char *) uc2_5999 },
	{ 0x599E , 1 ,12 ,12 ,24 ,(char *) uc2_599E },
	{ 0x59A3 , 1 ,12 ,12 ,24 ,(char *) uc2_59A3 },
	{ 0x59A4 , 1 ,12 ,12 ,24 ,(char *) uc2_59A4 },
	{ 0x59A5 , 1 ,12 ,12 ,24 ,(char *) uc2_59A5 },
	{ 0x59A8 , 1 ,12 ,12 ,24 ,(char *) uc2_59A8 },
	{ 0x59A9 , 1 ,12 ,12 ,24 ,(char *) uc2_59A9 },
	{ 0x59AA , 1 ,12 ,12 ,24 ,(char *) uc2_59AA },
	{ 0x59AB , 1 ,12 ,12 ,24 ,(char *) uc2_59AB },
	{ 0x59AE , 1 ,12 ,12 ,24 ,(char *) uc2_59AE },
	{ 0x59AF , 1 ,12 ,12 ,24 ,(char *) uc2_59AF },
	{ 0x59B2 , 1 ,12 ,12 ,24 ,(char *) uc2_59B2 },
	{ 0x59B9 , 1 ,12 ,12 ,24 ,(char *) uc2_59B9 },
	{ 0x59BB , 1 ,12 ,12 ,24 ,(char *) uc2_59BB },
	{ 0x59BE , 1 ,12 ,12 ,24 ,(char *) uc2_59BE },
	{ 0x59C6 , 1 ,12 ,12 ,24 ,(char *) uc2_59C6 },
	{ 0x59CA , 1 ,12 ,12 ,24 ,(char *) uc2_59CA },
	{ 0x59CB , 1 ,12 ,12 ,24 ,(char *) uc2_59CB },
	{ 0x59D0 , 1 ,12 ,12 ,24 ,(char *) uc2_59D0 },
	{ 0x59D1 , 1 ,12 ,12 ,24 ,(char *) uc2_59D1 },
	{ 0x59D2 , 1 ,12 ,12 ,24 ,(char *) uc2_59D2 },
	{ 0x59D3 , 1 ,12 ,12 ,24 ,(char *) uc2_59D3 },
	{ 0x59D4 , 1 ,12 ,12 ,24 ,(char *) uc2_59D4 },
	{ 0x59D7 , 1 ,12 ,12 ,24 ,(char *) uc2_59D7 },
	{ 0x59D8 , 1 ,12 ,12 ,24 ,(char *) uc2_59D8 },
	{ 0x59DA , 1 ,12 ,12 ,24 ,(char *) uc2_59DA },
	{ 0x59DC , 1 ,12 ,12 ,24 ,(char *) uc2_59DC },
	{ 0x59DD , 1 ,12 ,12 ,24 ,(char *) uc2_59DD },
	{ 0x59E3 , 1 ,12 ,12 ,24 ,(char *) uc2_59E3 },
	{ 0x59E5 , 1 ,12 ,12 ,24 ,(char *) uc2_59E5 },
	{ 0x59E8 , 1 ,12 ,12 ,24 ,(char *) uc2_59E8 },
	{ 0x59EB , 1 ,12 ,12 ,24 ,(char *) uc2_59EB },
	{ 0x59EC , 1 ,12 ,12 ,24 ,(char *) uc2_59EC },
	{ 0x59F9 , 1 ,12 ,12 ,24 ,(char *) uc2_59F9 },
	{ 0x59FB , 1 ,12 ,12 ,24 ,(char *) uc2_59FB },
	{ 0x59FF , 1 ,12 ,12 ,24 ,(char *) uc2_59FF },
	{ 0x5A01 , 1 ,12 ,12 ,24 ,(char *) uc2_5A01 },
	{ 0x5A03 , 1 ,12 ,12 ,24 ,(char *) uc2_5A03 },
	{ 0x5A04 , 1 ,12 ,12 ,24 ,(char *) uc2_5A04 },
	{ 0x5A05 , 1 ,12 ,12 ,24 ,(char *) uc2_5A05 },
	{ 0x5A06 , 1 ,12 ,12 ,24 ,(char *) uc2_5A06 },
	{ 0x5A07 , 1 ,12 ,12 ,24 ,(char *) uc2_5A07 },
	{ 0x5A08 , 1 ,12 ,12 ,24 ,(char *) uc2_5A08 },
	{ 0x5A09 , 1 ,12 ,12 ,24 ,(char *) uc2_5A09 },
	{ 0x5A0C , 1 ,12 ,12 ,24 ,(char *) uc2_5A0C },
	{ 0x5A11 , 1 ,12 ,12 ,24 ,(char *) uc2_5A11 },
	{ 0x5A13 , 1 ,12 ,12 ,24 ,(char *) uc2_5A13 },
	{ 0x5A18 , 1 ,12 ,12 ,24 ,(char *) uc2_5A18 },
	{ 0x5A1C , 1 ,12 ,12 ,24 ,(char *) uc2_5A1C },
	{ 0x5A1F , 1 ,12 ,12 ,24 ,(char *) uc2_5A1F },
	{ 0x5A20 , 1 ,12 ,12 ,24 ,(char *) uc2_5A20 },
	{ 0x5A23 , 1 ,12 ,12 ,24 ,(char *) uc2_5A23 },
	{ 0x5A25 , 1 ,12 ,12 ,24 ,(char *) uc2_5A25 },
	{ 0x5A29 , 1 ,12 ,12 ,24 ,(char *) uc2_5A29 },
	{ 0x5A31 , 1 ,12 ,12 ,24 ,(char *) uc2_5A31 },
	{ 0x5A32 , 1 ,12 ,12 ,24 ,(char *) uc2_5A32 },
	{ 0x5A34 , 1 ,12 ,12 ,24 ,(char *) uc2_5A34 },
	{ 0x5A36 , 1 ,12 ,12 ,24 ,(char *) uc2_5A36 },
	{ 0x5A3C , 1 ,12 ,12 ,24 ,(char *) uc2_5A3C },
	{ 0x5A40 , 1 ,12 ,12 ,24 ,(char *) uc2_5A40 },
	{ 0x5A46 , 1 ,12 ,12 ,24 ,(char *) uc2_5A46 },
	{ 0x5A49 , 1 ,12 ,12 ,24 ,(char *) uc2_5A49 },
	{ 0x5A4A , 1 ,12 ,12 ,24 ,(char *) uc2_5A4A },
	{ 0x5A55 , 1 ,12 ,12 ,24 ,(char *) uc2_5A55 },
	{ 0x5A5A , 1 ,12 ,12 ,24 ,(char *) uc2_5A5A },
	{ 0x5A62 , 1 ,12 ,12 ,24 ,(char *) uc2_5A62 },
	{ 0x5A67 , 1 ,12 ,12 ,24 ,(char *) uc2_5A67 },
	{ 0x5A6A , 1 ,12 ,12 ,24 ,(char *) uc2_5A6A },
	{ 0x5A74 , 1 ,12 ,12 ,24 ,(char *) uc2_5A74 },
	{ 0x5A75 , 1 ,12 ,12 ,24 ,(char *) uc2_5A75 },
	{ 0x5A76 , 1 ,12 ,12 ,24 ,(char *) uc2_5A76 },
	{ 0x5A77 , 1 ,12 ,12 ,24 ,(char *) uc2_5A77 },
	{ 0x5A7A , 1 ,12 ,12 ,24 ,(char *) uc2_5A7A },
	{ 0x5A7F , 1 ,12 ,12 ,24 ,(char *) uc2_5A7F },
	{ 0x5A92 , 1 ,12 ,12 ,24 ,(char *) uc2_5A92 },
	{ 0x5A96 , 1 ,12 ,12 ,24 ,(char *) uc2_5A96 },
	{ 0x5A9A , 1 ,12 ,12 ,24 ,(char *) uc2_5A9A },
	{ 0x5A9B , 1 ,12 ,12 ,24 ,(char *) uc2_5A9B },
	{ 0x5AAA , 1 ,12 ,12 ,24 ,(char *) uc2_5AAA },
	{ 0x5AB2 , 1 ,12 ,12 ,24 ,(char *) uc2_5AB2 },
	{ 0x5AB3 , 1 ,12 ,12 ,24 ,(char *) uc2_5AB3 },
	{ 0x5AB5 , 1 ,12 ,12 ,24 ,(char *) uc2_5AB5 },
	{ 0x5AB8 , 1 ,12 ,12 ,24 ,(char *) uc2_5AB8 },
	{ 0x5ABE , 1 ,12 ,12 ,24 ,(char *) uc2_5ABE },
	{ 0x5AC1 , 1 ,12 ,12 ,24 ,(char *) uc2_5AC1 },
	{ 0x5AC2 , 1 ,12 ,12 ,24 ,(char *) uc2_5AC2 },
	{ 0x5AC9 , 1 ,12 ,12 ,24 ,(char *) uc2_5AC9 },
	{ 0x5ACC , 1 ,12 ,12 ,24 ,(char *) uc2_5ACC },
	{ 0x5AD2 , 1 ,12 ,12 ,24 ,(char *) uc2_5AD2 },
	{ 0x5AD4 , 1 ,12 ,12 ,24 ,(char *) uc2_5AD4 },
	{ 0x5AD6 , 1 ,12 ,12 ,24 ,(char *) uc2_5AD6 },
	{ 0x5AD8 , 1 ,12 ,12 ,24 ,(char *) uc2_5AD8 },
	{ 0x5ADC , 1 ,12 ,12 ,24 ,(char *) uc2_5ADC },
	{ 0x5AE0 , 1 ,12 ,12 ,24 ,(char *) uc2_5AE0 },
	{ 0x5AE1 , 1 ,12 ,12 ,24 ,(char *) uc2_5AE1 },
	{ 0x5AE3 , 1 ,12 ,12 ,24 ,(char *) uc2_5AE3 },
	{ 0x5AE6 , 1 ,12 ,12 ,24 ,(char *) uc2_5AE6 },
	{ 0x5AE9 , 1 ,12 ,12 ,24 ,(char *) uc2_5AE9 },
	{ 0x5AEB , 1 ,12 ,12 ,24 ,(char *) uc2_5AEB },
	{ 0x5AF1 , 1 ,12 ,12 ,24 ,(char *) uc2_5AF1 },
	{ 0x5B09 , 1 ,12 ,12 ,24 ,(char *) uc2_5B09 },
	{ 0x5B16 , 1 ,12 ,12 ,24 ,(char *) uc2_5B16 },
	{ 0x5B17 , 1 ,12 ,12 ,24 ,(char *) uc2_5B17 },
	{ 0x5B32 , 1 ,12 ,12 ,24 ,(char *) uc2_5B32 },
	{ 0x5B34 , 1 ,12 ,12 ,24 ,(char *) uc2_5B34 },
	{ 0x5B37 , 1 ,12 ,12 ,24 ,(char *) uc2_5B37 },
	{ 0x5B40 , 1 ,12 ,12 ,24 ,(char *) uc2_5B40 },
	{ 0x5B50 , 1 ,12 ,12 ,24 ,(char *) uc2_5B50 },
	{ 0x5B51 , 1 ,12 ,12 ,24 ,(char *) uc2_5B51 },
	{ 0x5B53 , 1 ,12 ,12 ,24 ,(char *) uc2_5B53 },
	{ 0x5B54 , 1 ,12 ,12 ,24 ,(char *) uc2_5B54 },
	{ 0x5B55 , 1 ,12 ,12 ,24 ,(char *) uc2_5B55 },
	{ 0x5B57 , 1 ,12 ,12 ,24 ,(char *) uc2_5B57 },
	{ 0x5B58 , 1 ,12 ,12 ,24 ,(char *) uc2_5B58 },
	{ 0x5B59 , 1 ,12 ,12 ,24 ,(char *) uc2_5B59 },
	{ 0x5B5A , 1 ,12 ,12 ,24 ,(char *) uc2_5B5A },
	{ 0x5B5B , 1 ,12 ,12 ,24 ,(char *) uc2_5B5B },
	{ 0x5B5C , 1 ,12 ,12 ,24 ,(char *) uc2_5B5C },
	{ 0x5B5D , 1 ,12 ,12 ,24 ,(char *) uc2_5B5D },
	{ 0x5B5F , 1 ,12 ,12 ,24 ,(char *) uc2_5B5F },
	{ 0x5B62 , 1 ,12 ,12 ,24 ,(char *) uc2_5B62 },
	{ 0x5B63 , 1 ,12 ,12 ,24 ,(char *) uc2_5B63 },
	{ 0x5B64 , 1 ,12 ,12 ,24 ,(char *) uc2_5B64 },
	{ 0x5B65 , 1 ,12 ,12 ,24 ,(char *) uc2_5B65 },
	{ 0x5B66 , 1 ,12 ,12 ,24 ,(char *) uc2_5B66 },
	{ 0x5B69 , 1 ,12 ,12 ,24 ,(char *) uc2_5B69 },
	{ 0x5B6A , 1 ,12 ,12 ,24 ,(char *) uc2_5B6A },
	{ 0x5B6C , 1 ,12 ,12 ,24 ,(char *) uc2_5B6C },
	{ 0x5B70 , 1 ,12 ,12 ,24 ,(char *) uc2_5B70 },
	{ 0x5B71 , 1 ,12 ,12 ,24 ,(char *) uc2_5B71 },
	{ 0x5B73 , 1 ,12 ,12 ,24 ,(char *) uc2_5B73 },
	{ 0x5B75 , 1 ,12 ,12 ,24 ,(char *) uc2_5B75 },
	{ 0x5B7A , 1 ,12 ,12 ,24 ,(char *) uc2_5B7A },
	{ 0x5B7D , 1 ,12 ,12 ,24 ,(char *) uc2_5B7D },
	{ 0x5B81 , 1 ,12 ,12 ,24 ,(char *) uc2_5B81 },
	{ 0x5B83 , 1 ,12 ,12 ,24 ,(char *) uc2_5B83 },
	{ 0x5B84 , 1 ,12 ,12 ,24 ,(char *) uc2_5B84 },
	{ 0x5B85 , 1 ,12 ,12 ,24 ,(char *) uc2_5B85 },
	{ 0x5B87 , 1 ,12 ,12 ,24 ,(char *) uc2_5B87 },
	{ 0x5B88 , 1 ,12 ,12 ,24 ,(char *) uc2_5B88 },
	{ 0x5B89 , 1 ,12 ,12 ,24 ,(char *) uc2_5B89 },
	{ 0x5B8B , 1 ,12 ,12 ,24 ,(char *) uc2_5B8B },
	{ 0x5B8C , 1 ,12 ,12 ,24 ,(char *) uc2_5B8C },
	{ 0x5B8F , 1 ,12 ,12 ,24 ,(char *) uc2_5B8F },
	{ 0x5B91 , 1 ,12 ,12 ,24 ,(char *) uc2_5B91 },
	{ 0x5B93 , 1 ,12 ,12 ,24 ,(char *) uc2_5B93 },
	{ 0x5B95 , 1 ,12 ,12 ,24 ,(char *) uc2_5B95 },
	{ 0x5B97 , 1 ,12 ,12 ,24 ,(char *) uc2_5B97 },
	{ 0x5B98 , 1 ,12 ,12 ,24 ,(char *) uc2_5B98 },
	{ 0x5B99 , 1 ,12 ,12 ,24 ,(char *) uc2_5B99 },
	{ 0x5B9A , 1 ,12 ,12 ,24 ,(char *) uc2_5B9A },
	{ 0x5B9B , 1 ,12 ,12 ,24 ,(char *) uc2_5B9B },
	{ 0x5B9C , 1 ,12 ,12 ,24 ,(char *) uc2_5B9C },
	{ 0x5B9D , 1 ,12 ,12 ,24 ,(char *) uc2_5B9D },
	{ 0x5B9E , 1 ,12 ,12 ,24 ,(char *) uc2_5B9E },
	{ 0x5BA0 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA0 },
	{ 0x5BA1 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA1 },
	{ 0x5BA2 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA2 },
	{ 0x5BA3 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA3 },
	{ 0x5BA4 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA4 },
	{ 0x5BA5 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA5 },
	{ 0x5BA6 , 1 ,12 ,12 ,24 ,(char *) uc2_5BA6 },
	{ 0x5BAA , 1 ,12 ,12 ,24 ,(char *) uc2_5BAA },
	{ 0x5BAB , 1 ,12 ,12 ,24 ,(char *) uc2_5BAB },
	{ 0x5BB0 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB0 },
	{ 0x5BB3 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB3 },
	{ 0x5BB4 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB4 },
	{ 0x5BB5 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB5 },
	{ 0x5BB6 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB6 },
	{ 0x5BB8 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB8 },
	{ 0x5BB9 , 1 ,12 ,12 ,24 ,(char *) uc2_5BB9 },
	{ 0x5BBD , 1 ,12 ,12 ,24 ,(char *) uc2_5BBD },
	{ 0x5BBE , 1 ,12 ,12 ,24 ,(char *) uc2_5BBE },
	{ 0x5BBF , 1 ,12 ,12 ,24 ,(char *) uc2_5BBF },
	{ 0x5BC2 , 1 ,12 ,12 ,24 ,(char *) uc2_5BC2 },
	{ 0x5BC4 , 1 ,12 ,12 ,24 ,(char *) uc2_5BC4 },
	{ 0x5BC5 , 1 ,12 ,12 ,24 ,(char *) uc2_5BC5 },
	{ 0x5BC6 , 1 ,12 ,12 ,24 ,(char *) uc2_5BC6 },
	{ 0x5BC7 , 1 ,12 ,12 ,24 ,(char *) uc2_5BC7 },
	{ 0x5BCC , 1 ,12 ,12 ,24 ,(char *) uc2_5BCC },
	{ 0x5BD0 , 1 ,12 ,12 ,24 ,(char *) uc2_5BD0 },
	{ 0x5BD2 , 1 ,12 ,12 ,24 ,(char *) uc2_5BD2 },
	{ 0x5BD3 , 1 ,12 ,12 ,24 ,(char *) uc2_5BD3 },
	{ 0x5BDD , 1 ,12 ,12 ,24 ,(char *) uc2_5BDD },
	{ 0x5BDE , 1 ,12 ,12 ,24 ,(char *) uc2_5BDE },
	{ 0x5BDF , 1 ,12 ,12 ,24 ,(char *) uc2_5BDF },
	{ 0x5BE1 , 1 ,12 ,12 ,24 ,(char *) uc2_5BE1 },
	{ 0x5BE4 , 1 ,12 ,12 ,24 ,(char *) uc2_5BE4 },
	{ 0x5BE5 , 1 ,12 ,12 ,24 ,(char *) uc2_5BE5 },
	{ 0x5BE8 , 1 ,12 ,12 ,24 ,(char *) uc2_5BE8 },
	{ 0x5BEE , 1 ,12 ,12 ,24 ,(char *) uc2_5BEE },
	{ 0x5BF0 , 1 ,12 ,12 ,24 ,(char *) uc2_5BF0 },
	{ 0x5BF8 , 1 ,12 ,12 ,24 ,(char *) uc2_5BF8 },
	{ 0x5BF9 , 1 ,12 ,12 ,24 ,(char *) uc2_5BF9 },
	{ 0x5BFA , 1 ,12 ,12 ,24 ,(char *) uc2_5BFA },
	{ 0x5BFB , 1 ,12 ,12 ,24 ,(char *) uc2_5BFB },
	{ 0x5BFC , 1 ,12 ,12 ,24 ,(char *) uc2_5BFC },
	{ 0x5BFF , 1 ,12 ,12 ,24 ,(char *) uc2_5BFF },
	{ 0x5C01 , 1 ,12 ,12 ,24 ,(char *) uc2_5C01 },
	{ 0x5C04 , 1 ,12 ,12 ,24 ,(char *) uc2_5C04 },
	{ 0x5C06 , 1 ,12 ,12 ,24 ,(char *) uc2_5C06 },
	{ 0x5C09 , 1 ,12 ,12 ,24 ,(char *) uc2_5C09 },
	{ 0x5C0A , 1 ,12 ,12 ,24 ,(char *) uc2_5C0A },
	{ 0x5C0F , 1 ,12 ,12 ,24 ,(char *) uc2_5C0F },
	{ 0x5C11 , 1 ,12 ,12 ,24 ,(char *) uc2_5C11 },
	{ 0x5C14 , 1 ,12 ,12 ,24 ,(char *) uc2_5C14 },
	{ 0x5C15 , 1 ,12 ,12 ,24 ,(char *) uc2_5C15 },
	{ 0x5C16 , 1 ,12 ,12 ,24 ,(char *) uc2_5C16 },
	{ 0x5C18 , 1 ,12 ,12 ,24 ,(char *) uc2_5C18 },
	{ 0x5C1A , 1 ,12 ,12 ,24 ,(char *) uc2_5C1A },
	{ 0x5C1C , 1 ,12 ,12 ,24 ,(char *) uc2_5C1C },
	{ 0x5C1D , 1 ,12 ,12 ,24 ,(char *) uc2_5C1D },
	{ 0x5C22 , 1 ,12 ,12 ,24 ,(char *) uc2_5C22 },
	{ 0x5C24 , 1 ,12 ,12 ,24 ,(char *) uc2_5C24 },
	{ 0x5C25 , 1 ,12 ,12 ,24 ,(char *) uc2_5C25 },
	{ 0x5C27 , 1 ,12 ,12 ,24 ,(char *) uc2_5C27 },
	{ 0x5C2C , 1 ,12 ,12 ,24 ,(char *) uc2_5C2C },
	{ 0x5C31 , 1 ,12 ,12 ,24 ,(char *) uc2_5C31 },
	{ 0x5C34 , 1 ,12 ,12 ,24 ,(char *) uc2_5C34 },
	{ 0x5C38 , 1 ,12 ,12 ,24 ,(char *) uc2_5C38 },
	{ 0x5C39 , 1 ,12 ,12 ,24 ,(char *) uc2_5C39 },
	{ 0x5C3A , 1 ,12 ,12 ,24 ,(char *) uc2_5C3A },
	{ 0x5C3B , 1 ,12 ,12 ,24 ,(char *) uc2_5C3B },
	{ 0x5C3C , 1 ,12 ,12 ,24 ,(char *) uc2_5C3C },
	{ 0x5C3D , 1 ,12 ,12 ,24 ,(char *) uc2_5C3D },
	{ 0x5C3E , 1 ,12 ,12 ,24 ,(char *) uc2_5C3E },
	{ 0x5C3F , 1 ,12 ,12 ,24 ,(char *) uc2_5C3F },
	{ 0x5C40 , 1 ,12 ,12 ,24 ,(char *) uc2_5C40 },
	{ 0x5C41 , 1 ,12 ,12 ,24 ,(char *) uc2_5C41 },
	{ 0x5C42 , 1 ,12 ,12 ,24 ,(char *) uc2_5C42 },
	{ 0x5C45 , 1 ,12 ,12 ,24 ,(char *) uc2_5C45 },
	{ 0x5C48 , 1 ,12 ,12 ,24 ,(char *) uc2_5C48 },
	{ 0x5C49 , 1 ,12 ,12 ,24 ,(char *) uc2_5C49 },
	{ 0x5C4A , 1 ,12 ,12 ,24 ,(char *) uc2_5C4A },
	{ 0x5C4B , 1 ,12 ,12 ,24 ,(char *) uc2_5C4B },
	{ 0x5C4E , 1 ,12 ,12 ,24 ,(char *) uc2_5C4E },
	{ 0x5C4F , 1 ,12 ,12 ,24 ,(char *) uc2_5C4F },
	{ 0x5C50 , 1 ,12 ,12 ,24 ,(char *) uc2_5C50 },
	{ 0x5C51 , 1 ,12 ,12 ,24 ,(char *) uc2_5C51 },
	{ 0x5C55 , 1 ,12 ,12 ,24 ,(char *) uc2_5C55 },
	{ 0x5C59 , 1 ,12 ,12 ,24 ,(char *) uc2_5C59 },
	{ 0x5C5E , 1 ,12 ,12 ,24 ,(char *) uc2_5C5E },
	{ 0x5C60 , 1 ,12 ,12 ,24 ,(char *) uc2_5C60 },
	{ 0x5C61 , 1 ,12 ,12 ,24 ,(char *) uc2_5C61 },
	{ 0x5C63 , 1 ,12 ,12 ,24 ,(char *) uc2_5C63 },
	{ 0x5C65 , 1 ,12 ,12 ,24 ,(char *) uc2_5C65 },
	{ 0x5C66 , 1 ,12 ,12 ,24 ,(char *) uc2_5C66 },
	{ 0x5C6F , 1 ,12 ,12 ,24 ,(char *) uc2_5C6F },
	{ 0x5C71 , 1 ,12 ,12 ,24 ,(char *) uc2_5C71 },
	{ 0x5C79 , 1 ,12 ,12 ,24 ,(char *) uc2_5C79 },
	{ 0x5C7A , 1 ,12 ,12 ,24 ,(char *) uc2_5C7A },
	{ 0x5C7F , 1 ,12 ,12 ,24 ,(char *) uc2_5C7F },
	{ 0x5C80 , 1 ,12 ,12 ,24 ,(char *) uc2_5C80 },
	{ 0x5C81 , 1 ,12 ,12 ,24 ,(char *) uc2_5C81 },
	{ 0x5C82 , 1 ,12 ,12 ,24 ,(char *) uc2_5C82 },
	{ 0x5C88 , 1 ,12 ,12 ,24 ,(char *) uc2_5C88 },
	{ 0x5C8C , 1 ,12 ,12 ,24 ,(char *) uc2_5C8C },
	{ 0x5C8D , 1 ,12 ,12 ,24 ,(char *) uc2_5C8D },
	{ 0x5C90 , 1 ,12 ,12 ,24 ,(char *) uc2_5C90 },
	{ 0x5C91 , 1 ,12 ,12 ,24 ,(char *) uc2_5C91 },
	{ 0x5C94 , 1 ,12 ,12 ,24 ,(char *) uc2_5C94 },
	{ 0x5C96 , 1 ,12 ,12 ,24 ,(char *) uc2_5C96 },
	{ 0x5C97 , 1 ,12 ,12 ,24 ,(char *) uc2_5C97 },
	{ 0x5C98 , 1 ,12 ,12 ,24 ,(char *) uc2_5C98 },
	{ 0x5C99 , 1 ,12 ,12 ,24 ,(char *) uc2_5C99 },
	{ 0x5C9A , 1 ,12 ,12 ,24 ,(char *) uc2_5C9A },
	{ 0x5C9B , 1 ,12 ,12 ,24 ,(char *) uc2_5C9B },
	{ 0x5C9C , 1 ,12 ,12 ,24 ,(char *) uc2_5C9C },
	{ 0x5CA2 , 1 ,12 ,12 ,24 ,(char *) uc2_5CA2 },
	{ 0x5CA3 , 1 ,12 ,12 ,24 ,(char *) uc2_5CA3 },
	{ 0x5CA9 , 1 ,12 ,12 ,24 ,(char *) uc2_5CA9 },
	{ 0x5CAB , 1 ,12 ,12 ,24 ,(char *) uc2_5CAB },
	{ 0x5CAC , 1 ,12 ,12 ,24 ,(char *) uc2_5CAC },
	{ 0x5CAD , 1 ,12 ,12 ,24 ,(char *) uc2_5CAD },
	{ 0x5CB1 , 1 ,12 ,12 ,24 ,(char *) uc2_5CB1 },
	{ 0x5CB3 , 1 ,12 ,12 ,24 ,(char *) uc2_5CB3 },
	{ 0x5CB5 , 1 ,12 ,12 ,24 ,(char *) uc2_5CB5 },
	{ 0x5CB7 , 1 ,12 ,12 ,24 ,(char *) uc2_5CB7 },
	{ 0x5CB8 , 1 ,12 ,12 ,24 ,(char *) uc2_5CB8 },
	{ 0x5CBD , 1 ,12 ,12 ,24 ,(char *) uc2_5CBD },
	{ 0x5CBF , 1 ,12 ,12 ,24 ,(char *) uc2_5CBF },
	{ 0x5CC1 , 1 ,12 ,12 ,24 ,(char *) uc2_5CC1 },
	{ 0x5CC4 , 1 ,12 ,12 ,24 ,(char *) uc2_5CC4 },
	{ 0x5CCB , 1 ,12 ,12 ,24 ,(char *) uc2_5CCB },
	{ 0x5CD2 , 1 ,12 ,12 ,24 ,(char *) uc2_5CD2 },
	{ 0x5CD9 , 1 ,12 ,12 ,24 ,(char *) uc2_5CD9 },
	{ 0x5CE1 , 1 ,12 ,12 ,24 ,(char *) uc2_5CE1 },
	{ 0x5CE4 , 1 ,12 ,12 ,24 ,(char *) uc2_5CE4 },
	{ 0x5CE5 , 1 ,12 ,12 ,24 ,(char *) uc2_5CE5 },
	{ 0x5CE6 , 1 ,12 ,12 ,24 ,(char *) uc2_5CE6 },
	{ 0x5CE8 , 1 ,12 ,12 ,24 ,(char *) uc2_5CE8 },
	{ 0x5CEA , 1 ,12 ,12 ,24 ,(char *) uc2_5CEA },
	{ 0x5CED , 1 ,12 ,12 ,24 ,(char *) uc2_5CED },
	{ 0x5CF0 , 1 ,12 ,12 ,24 ,(char *) uc2_5CF0 },
	{ 0x5CFB , 1 ,12 ,12 ,24 ,(char *) uc2_5CFB },
	{ 0x5D02 , 1 ,12 ,12 ,24 ,(char *) uc2_5D02 },
	{ 0x5D03 , 1 ,12 ,12 ,24 ,(char *) uc2_5D03 },
	{ 0x5D06 , 1 ,12 ,12 ,24 ,(char *) uc2_5D06 },
	{ 0x5D07 , 1 ,12 ,12 ,24 ,(char *) uc2_5D07 },
	{ 0x5D0E , 1 ,12 ,12 ,24 ,(char *) uc2_5D0E },
	{ 0x5D14 , 1 ,12 ,12 ,24 ,(char *) uc2_5D14 },
	{ 0x5D16 , 1 ,12 ,12 ,24 ,(char *) uc2_5D16 },
	{ 0x5D1B , 1 ,12 ,12 ,24 ,(char *) uc2_5D1B },
	{ 0x5D1E , 1 ,12 ,12 ,24 ,(char *) uc2_5D1E },
	{ 0x5D24 , 1 ,12 ,12 ,24 ,(char *) uc2_5D24 },
	{ 0x5D26 , 1 ,12 ,12 ,24 ,(char *) uc2_5D26 },
	{ 0x5D27 , 1 ,12 ,12 ,24 ,(char *) uc2_5D27 },
	{ 0x5D29 , 1 ,12 ,12 ,24 ,(char *) uc2_5D29 },
	{ 0x5D2D , 1 ,12 ,12 ,24 ,(char *) uc2_5D2D },
	{ 0x5D2E , 1 ,12 ,12 ,24 ,(char *) uc2_5D2E },
	{ 0x5D34 , 1 ,12 ,12 ,24 ,(char *) uc2_5D34 },
	{ 0x5D3D , 1 ,12 ,12 ,24 ,(char *) uc2_5D3D },
	{ 0x5D3E , 1 ,12 ,12 ,24 ,(char *) uc2_5D3E },
	{ 0x5D47 , 1 ,12 ,12 ,24 ,(char *) uc2_5D47 },
	{ 0x5D4A , 1 ,12 ,12 ,24 ,(char *) uc2_5D4A },
	{ 0x5D4B , 1 ,12 ,12 ,24 ,(char *) uc2_5D4B },
	{ 0x5D4C , 1 ,12 ,12 ,24 ,(char *) uc2_5D4C },
	{ 0x5D58 , 1 ,12 ,12 ,24 ,(char *) uc2_5D58 },
	{ 0x5D5B , 1 ,12 ,12 ,24 ,(char *) uc2_5D5B },
	{ 0x5D5D , 1 ,12 ,12 ,24 ,(char *) uc2_5D5D },
	{ 0x5D69 , 1 ,12 ,12 ,24 ,(char *) uc2_5D69 },
	{ 0x5D6B , 1 ,12 ,12 ,24 ,(char *) uc2_5D6B },
	{ 0x5D6C , 1 ,12 ,12 ,24 ,(char *) uc2_5D6C },
	{ 0x5D6F , 1 ,12 ,12 ,24 ,(char *) uc2_5D6F },
	{ 0x5D74 , 1 ,12 ,12 ,24 ,(char *) uc2_5D74 },
	{ 0x5D82 , 1 ,12 ,12 ,24 ,(char *) uc2_5D82 },
	{ 0x5D99 , 1 ,12 ,12 ,24 ,(char *) uc2_5D99 },
	{ 0x5D9D , 1 ,12 ,12 ,24 ,(char *) uc2_5D9D },
	{ 0x5DB7 , 1 ,12 ,12 ,24 ,(char *) uc2_5DB7 },
	{ 0x5DC5 , 1 ,12 ,12 ,24 ,(char *) uc2_5DC5 },
	{ 0x5DCD , 1 ,12 ,12 ,24 ,(char *) uc2_5DCD },
	{ 0x5DDD , 1 ,12 ,12 ,24 ,(char *) uc2_5DDD },
	{ 0x5DDE , 1 ,12 ,12 ,24 ,(char *) uc2_5DDE },
	{ 0x5DE1 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE1 },
	{ 0x5DE2 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE2 },
	{ 0x5DE5 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE5 },
	{ 0x5DE6 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE6 },
	{ 0x5DE7 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE7 },
	{ 0x5DE8 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE8 },
	{ 0x5DE9 , 1 ,12 ,12 ,24 ,(char *) uc2_5DE9 },
	{ 0x5DEB , 1 ,12 ,12 ,24 ,(char *) uc2_5DEB },
	{ 0x5DEE , 1 ,12 ,12 ,24 ,(char *) uc2_5DEE },
	{ 0x5DEF , 1 ,12 ,12 ,24 ,(char *) uc2_5DEF },
	{ 0x5DF1 , 1 ,12 ,12 ,24 ,(char *) uc2_5DF1 },
	{ 0x5DF2 , 1 ,12 ,12 ,24 ,(char *) uc2_5DF2 },
	{ 0x5DF3 , 1 ,12 ,12 ,24 ,(char *) uc2_5DF3 },
	{ 0x5DF4 , 1 ,12 ,12 ,24 ,(char *) uc2_5DF4 },
	{ 0x5DF7 , 1 ,12 ,12 ,24 ,(char *) uc2_5DF7 },
	{ 0x5DFD , 1 ,12 ,12 ,24 ,(char *) uc2_5DFD },
	{ 0x5DFE , 1 ,12 ,12 ,24 ,(char *) uc2_5DFE },
	{ 0x5E01 , 1 ,12 ,12 ,24 ,(char *) uc2_5E01 },
	{ 0x5E02 , 1 ,12 ,12 ,24 ,(char *) uc2_5E02 },
	{ 0x5E03 , 1 ,12 ,12 ,24 ,(char *) uc2_5E03 },
	{ 0x5E05 , 1 ,12 ,12 ,24 ,(char *) uc2_5E05 },
	{ 0x5E06 , 1 ,12 ,12 ,24 ,(char *) uc2_5E06 },
	{ 0x5E08 , 1 ,12 ,12 ,24 ,(char *) uc2_5E08 },
	{ 0x5E0C , 1 ,12 ,12 ,24 ,(char *) uc2_5E0C },
	{ 0x5E0F , 1 ,12 ,12 ,24 ,(char *) uc2_5E0F },
	{ 0x5E10 , 1 ,12 ,12 ,24 ,(char *) uc2_5E10 },
	{ 0x5E11 , 1 ,12 ,12 ,24 ,(char *) uc2_5E11 },
	{ 0x5E14 , 1 ,12 ,12 ,24 ,(char *) uc2_5E14 },
	{ 0x5E15 , 1 ,12 ,12 ,24 ,(char *) uc2_5E15 },
	{ 0x5E16 , 1 ,12 ,12 ,24 ,(char *) uc2_5E16 },
	{ 0x5E18 , 1 ,12 ,12 ,24 ,(char *) uc2_5E18 },
	{ 0x5E19 , 1 ,12 ,12 ,24 ,(char *) uc2_5E19 },
	{ 0x5E1A , 1 ,12 ,12 ,24 ,(char *) uc2_5E1A },
	{ 0x5E1B , 1 ,12 ,12 ,24 ,(char *) uc2_5E1B },
	{ 0x5E1C , 1 ,12 ,12 ,24 ,(char *) uc2_5E1C },
	{ 0x5E1D , 1 ,12 ,12 ,24 ,(char *) uc2_5E1D },
	{ 0x5E26 , 1 ,12 ,12 ,24 ,(char *) uc2_5E26 },
	{ 0x5E27 , 1 ,12 ,12 ,24 ,(char *) uc2_5E27 },
	{ 0x5E2D , 1 ,12 ,12 ,24 ,(char *) uc2_5E2D },
	{ 0x5E2E , 1 ,12 ,12 ,24 ,(char *) uc2_5E2E },
	{ 0x5E31 , 1 ,12 ,12 ,24 ,(char *) uc2_5E31 },
	{ 0x5E37 , 1 ,12 ,12 ,24 ,(char *) uc2_5E37 },
	{ 0x5E38 , 1 ,12 ,12 ,24 ,(char *) uc2_5E38 },
	{ 0x5E3B , 1 ,12 ,12 ,24 ,(char *) uc2_5E3B },
	{ 0x5E3C , 1 ,12 ,12 ,24 ,(char *) uc2_5E3C },
	{ 0x5E3D , 1 ,12 ,12 ,24 ,(char *) uc2_5E3D },
	{ 0x5E42 , 1 ,12 ,12 ,24 ,(char *) uc2_5E42 },
	{ 0x5E44 , 1 ,12 ,12 ,24 ,(char *) uc2_5E44 },
	{ 0x5E45 , 1 ,12 ,12 ,24 ,(char *) uc2_5E45 },
	{ 0x5E4C , 1 ,12 ,12 ,24 ,(char *) uc2_5E4C },
	{ 0x5E54 , 1 ,12 ,12 ,24 ,(char *) uc2_5E54 },
	{ 0x5E55 , 1 ,12 ,12 ,24 ,(char *) uc2_5E55 },
	{ 0x5E5B , 1 ,12 ,12 ,24 ,(char *) uc2_5E5B },
	{ 0x5E5E , 1 ,12 ,12 ,24 ,(char *) uc2_5E5E },
	{ 0x5E61 , 1 ,12 ,12 ,24 ,(char *) uc2_5E61 },
	{ 0x5E62 , 1 ,12 ,12 ,24 ,(char *) uc2_5E62 },
	{ 0x5E72 , 1 ,12 ,12 ,24 ,(char *) uc2_5E72 },
	{ 0x5E73 , 1 ,12 ,12 ,24 ,(char *) uc2_5E73 },
	{ 0x5E74 , 1 ,12 ,12 ,24 ,(char *) uc2_5E74 },
	{ 0x5E76 , 1 ,12 ,12 ,24 ,(char *) uc2_5E76 },
	{ 0x5E78 , 1 ,12 ,12 ,24 ,(char *) uc2_5E78 },
	{ 0x5E7A , 1 ,12 ,12 ,24 ,(char *) uc2_5E7A },
	{ 0x5E7B , 1 ,12 ,12 ,24 ,(char *) uc2_5E7B },
	{ 0x5E7C , 1 ,12 ,12 ,24 ,(char *) uc2_5E7C },
	{ 0x5E7D , 1 ,12 ,12 ,24 ,(char *) uc2_5E7D },
	{ 0x5E7F , 1 ,12 ,12 ,24 ,(char *) uc2_5E7F },
	{ 0x5E80 , 1 ,12 ,12 ,24 ,(char *) uc2_5E80 },
	{ 0x5E84 , 1 ,12 ,12 ,24 ,(char *) uc2_5E84 },
	{ 0x5E86 , 1 ,12 ,12 ,24 ,(char *) uc2_5E86 },
	{ 0x5E87 , 1 ,12 ,12 ,24 ,(char *) uc2_5E87 },
	{ 0x5E8A , 1 ,12 ,12 ,24 ,(char *) uc2_5E8A },
	{ 0x5E8B , 1 ,12 ,12 ,24 ,(char *) uc2_5E8B },
	{ 0x5E8F , 1 ,12 ,12 ,24 ,(char *) uc2_5E8F },
	{ 0x5E90 , 1 ,12 ,12 ,24 ,(char *) uc2_5E90 },
	{ 0x5E91 , 1 ,12 ,12 ,24 ,(char *) uc2_5E91 },
	{ 0x5E93 , 1 ,12 ,12 ,24 ,(char *) uc2_5E93 },
	{ 0x5E94 , 1 ,12 ,12 ,24 ,(char *) uc2_5E94 },
	{ 0x5E95 , 1 ,12 ,12 ,24 ,(char *) uc2_5E95 },
	{ 0x5E96 , 1 ,12 ,12 ,24 ,(char *) uc2_5E96 },
	{ 0x5E97 , 1 ,12 ,12 ,24 ,(char *) uc2_5E97 },
	{ 0x5E99 , 1 ,12 ,12 ,24 ,(char *) uc2_5E99 },
	{ 0x5E9A , 1 ,12 ,12 ,24 ,(char *) uc2_5E9A },
	{ 0x5E9C , 1 ,12 ,12 ,24 ,(char *) uc2_5E9C },
	{ 0x5E9E , 1 ,12 ,12 ,24 ,(char *) uc2_5E9E },
	{ 0x5E9F , 1 ,12 ,12 ,24 ,(char *) uc2_5E9F },
	{ 0x5EA0 , 1 ,12 ,12 ,24 ,(char *) uc2_5EA0 },
	{ 0x5EA5 , 1 ,12 ,12 ,24 ,(char *) uc2_5EA5 },
	{ 0x5EA6 , 1 ,12 ,12 ,24 ,(char *) uc2_5EA6 },
	{ 0x5EA7 , 1 ,12 ,12 ,24 ,(char *) uc2_5EA7 },
	{ 0x5EAD , 1 ,12 ,12 ,24 ,(char *) uc2_5EAD },
	{ 0x5EB3 , 1 ,12 ,12 ,24 ,(char *) uc2_5EB3 },
	{ 0x5EB5 , 1 ,12 ,12 ,24 ,(char *) uc2_5EB5 },
	{ 0x5EB6 , 1 ,12 ,12 ,24 ,(char *) uc2_5EB6 },
	{ 0x5EB7 , 1 ,12 ,12 ,24 ,(char *) uc2_5EB7 },
	{ 0x5EB8 , 1 ,12 ,12 ,24 ,(char *) uc2_5EB8 },
	{ 0x5EB9 , 1 ,12 ,12 ,24 ,(char *) uc2_5EB9 },
	{ 0x5EBE , 1 ,12 ,12 ,24 ,(char *) uc2_5EBE },
	{ 0x5EC9 , 1 ,12 ,12 ,24 ,(char *) uc2_5EC9 },
	{ 0x5ECA , 1 ,12 ,12 ,24 ,(char *) uc2_5ECA },
	{ 0x5ED1 , 1 ,12 ,12 ,24 ,(char *) uc2_5ED1 },
	{ 0x5ED2 , 1 ,12 ,12 ,24 ,(char *) uc2_5ED2 },
	{ 0x5ED3 , 1 ,12 ,12 ,24 ,(char *) uc2_5ED3 },
	{ 0x5ED6 , 1 ,12 ,12 ,24 ,(char *) uc2_5ED6 },
	{ 0x5EDB , 1 ,12 ,12 ,24 ,(char *) uc2_5EDB },
	{ 0x5EE8 , 1 ,12 ,12 ,24 ,(char *) uc2_5EE8 },
	{ 0x5EEA , 1 ,12 ,12 ,24 ,(char *) uc2_5EEA },
	{ 0x5EF6 , 1 ,12 ,12 ,24 ,(char *) uc2_5EF6 },
	{ 0x5EF7 , 1 ,12 ,12 ,24 ,(char *) uc2_5EF7 },
	{ 0x5EFA , 1 ,12 ,12 ,24 ,(char *) uc2_5EFA },
	{ 0x5EFF , 1 ,12 ,12 ,24 ,(char *) uc2_5EFF },
	{ 0x5F00 , 1 ,12 ,12 ,24 ,(char *) uc2_5F00 },
	{ 0x5F01 , 1 ,12 ,12 ,24 ,(char *) uc2_5F01 },
	{ 0x5F02 , 1 ,12 ,12 ,24 ,(char *) uc2_5F02 },
	{ 0x5F03 , 1 ,12 ,12 ,24 ,(char *) uc2_5F03 },
	{ 0x5F04 , 1 ,12 ,12 ,24 ,(char *) uc2_5F04 },
	{ 0x5F08 , 1 ,12 ,12 ,24 ,(char *) uc2_5F08 },
	{ 0x5F0A , 1 ,12 ,12 ,24 ,(char *) uc2_5F0A },
	{ 0x5F0B , 1 ,12 ,12 ,24 ,(char *) uc2_5F0B },
	{ 0x5F0D , 1 ,12 ,12 ,24 ,(char *) uc2_5F0D },
	{ 0x5F0F , 1 ,12 ,12 ,24 ,(char *) uc2_5F0F },
	{ 0x5F11 , 1 ,12 ,12 ,24 ,(char *) uc2_5F11 },
	{ 0x5F13 , 1 ,12 ,12 ,24 ,(char *) uc2_5F13 },
	{ 0x5F15 , 1 ,12 ,12 ,24 ,(char *) uc2_5F15 },
	{ 0x5F17 , 1 ,12 ,12 ,24 ,(char *) uc2_5F17 },
	{ 0x5F18 , 1 ,12 ,12 ,24 ,(char *) uc2_5F18 },
	{ 0x5F1B , 1 ,12 ,12 ,24 ,(char *) uc2_5F1B },
	{ 0x5F1F , 1 ,12 ,12 ,24 ,(char *) uc2_5F1F },
	{ 0x5F20 , 1 ,12 ,12 ,24 ,(char *) uc2_5F20 },
	{ 0x5F25 , 1 ,12 ,12 ,24 ,(char *) uc2_5F25 },
	{ 0x5F26 , 1 ,12 ,12 ,24 ,(char *) uc2_5F26 },
	{ 0x5F27 , 1 ,12 ,12 ,24 ,(char *) uc2_5F27 },
	{ 0x5F29 , 1 ,12 ,12 ,24 ,(char *) uc2_5F29 },
	{ 0x5F2A , 1 ,12 ,12 ,24 ,(char *) uc2_5F2A },
	{ 0x5F2D , 1 ,12 ,12 ,24 ,(char *) uc2_5F2D },
	{ 0x5F2F , 1 ,12 ,12 ,24 ,(char *) uc2_5F2F },
	{ 0x5F31 , 1 ,12 ,12 ,24 ,(char *) uc2_5F31 },
	{ 0x5F39 , 1 ,12 ,12 ,24 ,(char *) uc2_5F39 },
	{ 0x5F3A , 1 ,12 ,12 ,24 ,(char *) uc2_5F3A },
	{ 0x5F3C , 1 ,12 ,12 ,24 ,(char *) uc2_5F3C },
	{ 0x5F40 , 1 ,12 ,12 ,24 ,(char *) uc2_5F40 },
	{ 0x5F52 , 1 ,12 ,12 ,24 ,(char *) uc2_5F52 },
	{ 0x5F53 , 1 ,12 ,12 ,24 ,(char *) uc2_5F53 },
	{ 0x5F55 , 1 ,12 ,12 ,24 ,(char *) uc2_5F55 },
	{ 0x5F56 , 1 ,12 ,12 ,24 ,(char *) uc2_5F56 },
	{ 0x5F57 , 1 ,12 ,12 ,24 ,(char *) uc2_5F57 },
	{ 0x5F58 , 1 ,12 ,12 ,24 ,(char *) uc2_5F58 },
	{ 0x5F5D , 1 ,12 ,12 ,24 ,(char *) uc2_5F5D },
	{ 0x5F62 , 1 ,12 ,12 ,24 ,(char *) uc2_5F62 },
	{ 0x5F64 , 1 ,12 ,12 ,24 ,(char *) uc2_5F64 },
	{ 0x5F66 , 1 ,12 ,12 ,24 ,(char *) uc2_5F66 },
	{ 0x5F69 , 1 ,12 ,12 ,24 ,(char *) uc2_5F69 },
	{ 0x5F6A , 1 ,12 ,12 ,24 ,(char *) uc2_5F6A },
	{ 0x5F6C , 1 ,12 ,12 ,24 ,(char *) uc2_5F6C },
	{ 0x5F6D , 1 ,12 ,12 ,24 ,(char *) uc2_5F6D },
	{ 0x5F70 , 1 ,12 ,12 ,24 ,(char *) uc2_5F70 },
	{ 0x5F71 , 1 ,12 ,12 ,24 ,(char *) uc2_5F71 },
	{ 0x5F77 , 1 ,12 ,12 ,24 ,(char *) uc2_5F77 },
	{ 0x5F79 , 1 ,12 ,12 ,24 ,(char *) uc2_5F79 },
	{ 0x5F7B , 1 ,12 ,12 ,24 ,(char *) uc2_5F7B },
	{ 0x5F7C , 1 ,12 ,12 ,24 ,(char *) uc2_5F7C },
	{ 0x5F80 , 1 ,12 ,12 ,24 ,(char *) uc2_5F80 },
	{ 0x5F81 , 1 ,12 ,12 ,24 ,(char *) uc2_5F81 },
	{ 0x5F82 , 1 ,12 ,12 ,24 ,(char *) uc2_5F82 },
	{ 0x5F84 , 1 ,12 ,12 ,24 ,(char *) uc2_5F84 },
	{ 0x5F85 , 1 ,12 ,12 ,24 ,(char *) uc2_5F85 },
	{ 0x5F87 , 1 ,12 ,12 ,24 ,(char *) uc2_5F87 },
	{ 0x5F88 , 1 ,12 ,12 ,24 ,(char *) uc2_5F88 },
	{ 0x5F89 , 1 ,12 ,12 ,24 ,(char *) uc2_5F89 },
	{ 0x5F8A , 1 ,12 ,12 ,24 ,(char *) uc2_5F8A },
	{ 0x5F8B , 1 ,12 ,12 ,24 ,(char *) uc2_5F8B },
	{ 0x5F8C , 1 ,12 ,12 ,24 ,(char *) uc2_5F8C },
	{ 0x5F90 , 1 ,12 ,12 ,24 ,(char *) uc2_5F90 },
	{ 0x5F92 , 1 ,12 ,12 ,24 ,(char *) uc2_5F92 },
	{ 0x5F95 , 1 ,12 ,12 ,24 ,(char *) uc2_5F95 },
	{ 0x5F97 , 1 ,12 ,12 ,24 ,(char *) uc2_5F97 },
	{ 0x5F98 , 1 ,12 ,12 ,24 ,(char *) uc2_5F98 },
	{ 0x5F99 , 1 ,12 ,12 ,24 ,(char *) uc2_5F99 },
	{ 0x5F9C , 1 ,12 ,12 ,24 ,(char *) uc2_5F9C },
	{ 0x5FA1 , 1 ,12 ,12 ,24 ,(char *) uc2_5FA1 },
	{ 0x5FA8 , 1 ,12 ,12 ,24 ,(char *) uc2_5FA8 },
	{ 0x5FAA , 1 ,12 ,12 ,24 ,(char *) uc2_5FAA },
	{ 0x5FAD , 1 ,12 ,12 ,24 ,(char *) uc2_5FAD },
	{ 0x5FAE , 1 ,12 ,12 ,24 ,(char *) uc2_5FAE },
	{ 0x5FB5 , 1 ,12 ,12 ,24 ,(char *) uc2_5FB5 },
	{ 0x5FB7 , 1 ,12 ,12 ,24 ,(char *) uc2_5FB7 },
	{ 0x5FBC , 1 ,12 ,12 ,24 ,(char *) uc2_5FBC },
	{ 0x5FBD , 1 ,12 ,12 ,24 ,(char *) uc2_5FBD },
	{ 0x5FC3 , 1 ,12 ,12 ,24 ,(char *) uc2_5FC3 },
	{ 0x5FC5 , 1 ,12 ,12 ,24 ,(char *) uc2_5FC5 },
	{ 0x5FC6 , 1 ,12 ,12 ,24 ,(char *) uc2_5FC6 },
	{ 0x5FC9 , 1 ,12 ,12 ,24 ,(char *) uc2_5FC9 },
	{ 0x5FCC , 1 ,12 ,12 ,24 ,(char *) uc2_5FCC },
	{ 0x5FCD , 1 ,12 ,12 ,24 ,(char *) uc2_5FCD },
	{ 0x5FCF , 1 ,12 ,12 ,24 ,(char *) uc2_5FCF },
	{ 0x5FD0 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD0 },
	{ 0x5FD1 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD1 },
	{ 0x5FD2 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD2 },
	{ 0x5FD6 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD6 },
	{ 0x5FD7 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD7 },
	{ 0x5FD8 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD8 },
	{ 0x5FD9 , 1 ,12 ,12 ,24 ,(char *) uc2_5FD9 },
	{ 0x5FDD , 1 ,12 ,12 ,24 ,(char *) uc2_5FDD },
	{ 0x5FE0 , 1 ,12 ,12 ,24 ,(char *) uc2_5FE0 },
	{ 0x5FE1 , 1 ,12 ,12 ,24 ,(char *) uc2_5FE1 },
	{ 0x5FE4 , 1 ,12 ,12 ,24 ,(char *) uc2_5FE4 },
	{ 0x5FE7 , 1 ,12 ,12 ,24 ,(char *) uc2_5FE7 },
	{ 0x5FEA , 1 ,12 ,12 ,24 ,(char *) uc2_5FEA },
	{ 0x5FEB , 1 ,12 ,12 ,24 ,(char *) uc2_5FEB },
	{ 0x5FED , 1 ,12 ,12 ,24 ,(char *) uc2_5FED },
	{ 0x5FEE , 1 ,12 ,12 ,24 ,(char *) uc2_5FEE },
	{ 0x5FF1 , 1 ,12 ,12 ,24 ,(char *) uc2_5FF1 },
	{ 0x5FF5 , 1 ,12 ,12 ,24 ,(char *) uc2_5FF5 },
	{ 0x5FF8 , 1 ,12 ,12 ,24 ,(char *) uc2_5FF8 },
	{ 0x5FFB , 1 ,12 ,12 ,24 ,(char *) uc2_5FFB },
	{ 0x5FFD , 1 ,12 ,12 ,24 ,(char *) uc2_5FFD },
	{ 0x5FFE , 1 ,12 ,12 ,24 ,(char *) uc2_5FFE },
	{ 0x5FFF , 1 ,12 ,12 ,24 ,(char *) uc2_5FFF },
	{ 0x6000 , 1 ,12 ,12 ,24 ,(char *) uc2_6000 },
	{ 0x6001 , 1 ,12 ,12 ,24 ,(char *) uc2_6001 },
	{ 0x6002 , 1 ,12 ,12 ,24 ,(char *) uc2_6002 },
	{ 0x6003 , 1 ,12 ,12 ,24 ,(char *) uc2_6003 },
	{ 0x6004 , 1 ,12 ,12 ,24 ,(char *) uc2_6004 },
	{ 0x6005 , 1 ,12 ,12 ,24 ,(char *) uc2_6005 },
	{ 0x6006 , 1 ,12 ,12 ,24 ,(char *) uc2_6006 },
	{ 0x600A , 1 ,12 ,12 ,24 ,(char *) uc2_600A },
	{ 0x600D , 1 ,12 ,12 ,24 ,(char *) uc2_600D },
	{ 0x600E , 1 ,12 ,12 ,24 ,(char *) uc2_600E },
	{ 0x600F , 1 ,12 ,12 ,24 ,(char *) uc2_600F },
	{ 0x6012 , 1 ,12 ,12 ,24 ,(char *) uc2_6012 },
	{ 0x6014 , 1 ,12 ,12 ,24 ,(char *) uc2_6014 },
	{ 0x6015 , 1 ,12 ,12 ,24 ,(char *) uc2_6015 },
	{ 0x6016 , 1 ,12 ,12 ,24 ,(char *) uc2_6016 },
	{ 0x6019 , 1 ,12 ,12 ,24 ,(char *) uc2_6019 },
	{ 0x601B , 1 ,12 ,12 ,24 ,(char *) uc2_601B },
	{ 0x601C , 1 ,12 ,12 ,24 ,(char *) uc2_601C },
	{ 0x601D , 1 ,12 ,12 ,24 ,(char *) uc2_601D },
	{ 0x6020 , 1 ,12 ,12 ,24 ,(char *) uc2_6020 },
	{ 0x6021 , 1 ,12 ,12 ,24 ,(char *) uc2_6021 },
	{ 0x6025 , 1 ,12 ,12 ,24 ,(char *) uc2_6025 },
	{ 0x6026 , 1 ,12 ,12 ,24 ,(char *) uc2_6026 },
	{ 0x6027 , 1 ,12 ,12 ,24 ,(char *) uc2_6027 },
	{ 0x6028 , 1 ,12 ,12 ,24 ,(char *) uc2_6028 },
	{ 0x6029 , 1 ,12 ,12 ,24 ,(char *) uc2_6029 },
	{ 0x602A , 1 ,12 ,12 ,24 ,(char *) uc2_602A },
	{ 0x602B , 1 ,12 ,12 ,24 ,(char *) uc2_602B },
	{ 0x602F , 1 ,12 ,12 ,24 ,(char *) uc2_602F },
	{ 0x6031 , 1 ,12 ,12 ,24 ,(char *) uc2_6031 },
	{ 0x6035 , 1 ,12 ,12 ,24 ,(char *) uc2_6035 },
	{ 0x603B , 1 ,12 ,12 ,24 ,(char *) uc2_603B },
	{ 0x603C , 1 ,12 ,12 ,24 ,(char *) uc2_603C },
	{ 0x603F , 1 ,12 ,12 ,24 ,(char *) uc2_603F },
	{ 0x6041 , 1 ,12 ,12 ,24 ,(char *) uc2_6041 },
	{ 0x6042 , 1 ,12 ,12 ,24 ,(char *) uc2_6042 },
	{ 0x6043 , 1 ,12 ,12 ,24 ,(char *) uc2_6043 },
	{ 0x604B , 1 ,12 ,12 ,24 ,(char *) uc2_604B },
	{ 0x604D , 1 ,12 ,12 ,24 ,(char *) uc2_604D },
	{ 0x6050 , 1 ,12 ,12 ,24 ,(char *) uc2_6050 },
	{ 0x6052 , 1 ,12 ,12 ,24 ,(char *) uc2_6052 },
	{ 0x6055 , 1 ,12 ,12 ,24 ,(char *) uc2_6055 },
	{ 0x6059 , 1 ,12 ,12 ,24 ,(char *) uc2_6059 },
	{ 0x605A , 1 ,12 ,12 ,24 ,(char *) uc2_605A },
	{ 0x605D , 1 ,12 ,12 ,24 ,(char *) uc2_605D },
	{ 0x6062 , 1 ,12 ,12 ,24 ,(char *) uc2_6062 },
	{ 0x6063 , 1 ,12 ,12 ,24 ,(char *) uc2_6063 },
	{ 0x6064 , 1 ,12 ,12 ,24 ,(char *) uc2_6064 },
	{ 0x6067 , 1 ,12 ,12 ,24 ,(char *) uc2_6067 },
	{ 0x6068 , 1 ,12 ,12 ,24 ,(char *) uc2_6068 },
	{ 0x6069 , 1 ,12 ,12 ,24 ,(char *) uc2_6069 },
	{ 0x606A , 1 ,12 ,12 ,24 ,(char *) uc2_606A },
	{ 0x606B , 1 ,12 ,12 ,24 ,(char *) uc2_606B },
	{ 0x606C , 1 ,12 ,12 ,24 ,(char *) uc2_606C },
	{ 0x606D , 1 ,12 ,12 ,24 ,(char *) uc2_606D },
	{ 0x606F , 1 ,12 ,12 ,24 ,(char *) uc2_606F },
	{ 0x6070 , 1 ,12 ,12 ,24 ,(char *) uc2_6070 },
	{ 0x6073 , 1 ,12 ,12 ,24 ,(char *) uc2_6073 },
	{ 0x6076 , 1 ,12 ,12 ,24 ,(char *) uc2_6076 },
	{ 0x6078 , 1 ,12 ,12 ,24 ,(char *) uc2_6078 },
	{ 0x6079 , 1 ,12 ,12 ,24 ,(char *) uc2_6079 },
	{ 0x607A , 1 ,12 ,12 ,24 ,(char *) uc2_607A },
	{ 0x607B , 1 ,12 ,12 ,24 ,(char *) uc2_607B },
	{ 0x607C , 1 ,12 ,12 ,24 ,(char *) uc2_607C },
	{ 0x607D , 1 ,12 ,12 ,24 ,(char *) uc2_607D },
	{ 0x607F , 1 ,12 ,12 ,24 ,(char *) uc2_607F },
	{ 0x6083 , 1 ,12 ,12 ,24 ,(char *) uc2_6083 },
	{ 0x6084 , 1 ,12 ,12 ,24 ,(char *) uc2_6084 },
	{ 0x6089 , 1 ,12 ,12 ,24 ,(char *) uc2_6089 },
	{ 0x608C , 1 ,12 ,12 ,24 ,(char *) uc2_608C },
	{ 0x608D , 1 ,12 ,12 ,24 ,(char *) uc2_608D },
	{ 0x6092 , 1 ,12 ,12 ,24 ,(char *) uc2_6092 },
	{ 0x6094 , 1 ,12 ,12 ,24 ,(char *) uc2_6094 },
	{ 0x6096 , 1 ,12 ,12 ,24 ,(char *) uc2_6096 },
	{ 0x609A , 1 ,12 ,12 ,24 ,(char *) uc2_609A },
	{ 0x609B , 1 ,12 ,12 ,24 ,(char *) uc2_609B },
	{ 0x609D , 1 ,12 ,12 ,24 ,(char *) uc2_609D },
	{ 0x609F , 1 ,12 ,12 ,24 ,(char *) uc2_609F },
	{ 0x60A0 , 1 ,12 ,12 ,24 ,(char *) uc2_60A0 },
	{ 0x60A3 , 1 ,12 ,12 ,24 ,(char *) uc2_60A3 },
	{ 0x60A6 , 1 ,12 ,12 ,24 ,(char *) uc2_60A6 },
	{ 0x60A8 , 1 ,12 ,12 ,24 ,(char *) uc2_60A8 },
	{ 0x60AB , 1 ,12 ,12 ,24 ,(char *) uc2_60AB },
	{ 0x60AC , 1 ,12 ,12 ,24 ,(char *) uc2_60AC },
	{ 0x60AD , 1 ,12 ,12 ,24 ,(char *) uc2_60AD },
	{ 0x60AF , 1 ,12 ,12 ,24 ,(char *) uc2_60AF },
	{ 0x60B1 , 1 ,12 ,12 ,24 ,(char *) uc2_60B1 },
	{ 0x60B2 , 1 ,12 ,12 ,24 ,(char *) uc2_60B2 },
	{ 0x60B4 , 1 ,12 ,12 ,24 ,(char *) uc2_60B4 },
	{ 0x60B8 , 1 ,12 ,12 ,24 ,(char *) uc2_60B8 },
	{ 0x60BB , 1 ,12 ,12 ,24 ,(char *) uc2_60BB },
	{ 0x60BC , 1 ,12 ,12 ,24 ,(char *) uc2_60BC },
	{ 0x60C5 , 1 ,12 ,12 ,24 ,(char *) uc2_60C5 },
	{ 0x60C6 , 1 ,12 ,12 ,24 ,(char *) uc2_60C6 },
	{ 0x60CA , 1 ,12 ,12 ,24 ,(char *) uc2_60CA },
	{ 0x60CB , 1 ,12 ,12 ,24 ,(char *) uc2_60CB },
	{ 0x60D1 , 1 ,12 ,12 ,24 ,(char *) uc2_60D1 },
	{ 0x60D5 , 1 ,12 ,12 ,24 ,(char *) uc2_60D5 },
	{ 0x60D8 , 1 ,12 ,12 ,24 ,(char *) uc2_60D8 },
	{ 0x60DA , 1 ,12 ,12 ,24 ,(char *) uc2_60DA },
	{ 0x60DC , 1 ,12 ,12 ,24 ,(char *) uc2_60DC },
	{ 0x60DD , 1 ,12 ,12 ,24 ,(char *) uc2_60DD },
	{ 0x60DF , 1 ,12 ,12 ,24 ,(char *) uc2_60DF },
	{ 0x60E0 , 1 ,12 ,12 ,24 ,(char *) uc2_60E0 },
	{ 0x60E6 , 1 ,12 ,12 ,24 ,(char *) uc2_60E6 },
	{ 0x60E7 , 1 ,12 ,12 ,24 ,(char *) uc2_60E7 },
	{ 0x60E8 , 1 ,12 ,12 ,24 ,(char *) uc2_60E8 },
	{ 0x60E9 , 1 ,12 ,12 ,24 ,(char *) uc2_60E9 },
	{ 0x60EB , 1 ,12 ,12 ,24 ,(char *) uc2_60EB },
	{ 0x60EC , 1 ,12 ,12 ,24 ,(char *) uc2_60EC },
	{ 0x60ED , 1 ,12 ,12 ,24 ,(char *) uc2_60ED },
	{ 0x60EE , 1 ,12 ,12 ,24 ,(char *) uc2_60EE },
	{ 0x60EF , 1 ,12 ,12 ,24 ,(char *) uc2_60EF },
	{ 0x60F0 , 1 ,12 ,12 ,24 ,(char *) uc2_60F0 },
	{ 0x60F3 , 1 ,12 ,12 ,24 ,(char *) uc2_60F3 },
	{ 0x60F4 , 1 ,12 ,12 ,24 ,(char *) uc2_60F4 },
	{ 0x60F6 , 1 ,12 ,12 ,24 ,(char *) uc2_60F6 },
	{ 0x60F9 , 1 ,12 ,12 ,24 ,(char *) uc2_60F9 },
	{ 0x60FA , 1 ,12 ,12 ,24 ,(char *) uc2_60FA },
	{ 0x6100 , 1 ,12 ,12 ,24 ,(char *) uc2_6100 },
	{ 0x6101 , 1 ,12 ,12 ,24 ,(char *) uc2_6101 },
	{ 0x6106 , 1 ,12 ,12 ,24 ,(char *) uc2_6106 },
	{ 0x6108 , 1 ,12 ,12 ,24 ,(char *) uc2_6108 },
	{ 0x6109 , 1 ,12 ,12 ,24 ,(char *) uc2_6109 },
	{ 0x610D , 1 ,12 ,12 ,24 ,(char *) uc2_610D },
	{ 0x610E , 1 ,12 ,12 ,24 ,(char *) uc2_610E },
	{ 0x610F , 1 ,12 ,12 ,24 ,(char *) uc2_610F },
	{ 0x6115 , 1 ,12 ,12 ,24 ,(char *) uc2_6115 },
	{ 0x611A , 1 ,12 ,12 ,24 ,(char *) uc2_611A },
	{ 0x611F , 1 ,12 ,12 ,24 ,(char *) uc2_611F },
	{ 0x6120 , 1 ,12 ,12 ,24 ,(char *) uc2_6120 },
	{ 0x6123 , 1 ,12 ,12 ,24 ,(char *) uc2_6123 },
	{ 0x6124 , 1 ,12 ,12 ,24 ,(char *) uc2_6124 },
	{ 0x6126 , 1 ,12 ,12 ,24 ,(char *) uc2_6126 },
	{ 0x6127 , 1 ,12 ,12 ,24 ,(char *) uc2_6127 },
	{ 0x612B , 1 ,12 ,12 ,24 ,(char *) uc2_612B },
	{ 0x613F , 1 ,12 ,12 ,24 ,(char *) uc2_613F },
	{ 0x6148 , 1 ,12 ,12 ,24 ,(char *) uc2_6148 },
	{ 0x614A , 1 ,12 ,12 ,24 ,(char *) uc2_614A },
	{ 0x614C , 1 ,12 ,12 ,24 ,(char *) uc2_614C },
	{ 0x614E , 1 ,12 ,12 ,24 ,(char *) uc2_614E },
	{ 0x6151 , 1 ,12 ,12 ,24 ,(char *) uc2_6151 },
	{ 0x6155 , 1 ,12 ,12 ,24 ,(char *) uc2_6155 },
	{ 0x615D , 1 ,12 ,12 ,24 ,(char *) uc2_615D },
	{ 0x6162 , 1 ,12 ,12 ,24 ,(char *) uc2_6162 },
	{ 0x6167 , 1 ,12 ,12 ,24 ,(char *) uc2_6167 },
	{ 0x6168 , 1 ,12 ,12 ,24 ,(char *) uc2_6168 },
	{ 0x6170 , 1 ,12 ,12 ,24 ,(char *) uc2_6170 },
	{ 0x6175 , 1 ,12 ,12 ,24 ,(char *) uc2_6175 },
	{ 0x6177 , 1 ,12 ,12 ,24 ,(char *) uc2_6177 },
	{ 0x618B , 1 ,12 ,12 ,24 ,(char *) uc2_618B },
	{ 0x618E , 1 ,12 ,12 ,24 ,(char *) uc2_618E },
	{ 0x6194 , 1 ,12 ,12 ,24 ,(char *) uc2_6194 },
	{ 0x619D , 1 ,12 ,12 ,24 ,(char *) uc2_619D },
	{ 0x61A7 , 1 ,12 ,12 ,24 ,(char *) uc2_61A7 },
	{ 0x61A8 , 1 ,12 ,12 ,24 ,(char *) uc2_61A8 },
	{ 0x61A9 , 1 ,12 ,12 ,24 ,(char *) uc2_61A9 },
	{ 0x61AC , 1 ,12 ,12 ,24 ,(char *) uc2_61AC },
	{ 0x61B6 , 1 ,12 ,12 ,24 ,(char *) uc2_61B6 },
	{ 0x61B7 , 1 ,12 ,12 ,24 ,(char *) uc2_61B7 },
	{ 0x61BE , 1 ,12 ,12 ,24 ,(char *) uc2_61BE },
	{ 0x61C2 , 1 ,12 ,12 ,24 ,(char *) uc2_61C2 },
	{ 0x61C8 , 1 ,12 ,12 ,24 ,(char *) uc2_61C8 },
	{ 0x61CA , 1 ,12 ,12 ,24 ,(char *) uc2_61CA },
	{ 0x61CB , 1 ,12 ,12 ,24 ,(char *) uc2_61CB },
	{ 0x61D1 , 1 ,12 ,12 ,24 ,(char *) uc2_61D1 },
	{ 0x61D2 , 1 ,12 ,12 ,24 ,(char *) uc2_61D2 },
	{ 0x61D4 , 1 ,12 ,12 ,24 ,(char *) uc2_61D4 },
	{ 0x61E6 , 1 ,12 ,12 ,24 ,(char *) uc2_61E6 },
	{ 0x61F5 , 1 ,12 ,12 ,24 ,(char *) uc2_61F5 },
	{ 0x61FF , 1 ,12 ,12 ,24 ,(char *) uc2_61FF },
	{ 0x6206 , 1 ,12 ,12 ,24 ,(char *) uc2_6206 },
	{ 0x6208 , 1 ,12 ,12 ,24 ,(char *) uc2_6208 },
	{ 0x620A , 1 ,12 ,12 ,24 ,(char *) uc2_620A },
	{ 0x620B , 1 ,12 ,12 ,24 ,(char *) uc2_620B },
	{ 0x620C , 1 ,12 ,12 ,24 ,(char *) uc2_620C },
	{ 0x620D , 1 ,12 ,12 ,24 ,(char *) uc2_620D },
	{ 0x620E , 1 ,12 ,12 ,24 ,(char *) uc2_620E },
	{ 0x620F , 1 ,12 ,12 ,24 ,(char *) uc2_620F },
	{ 0x6210 , 1 ,12 ,12 ,24 ,(char *) uc2_6210 },
	{ 0x6211 , 1 ,12 ,12 ,24 ,(char *) uc2_6211 },
	{ 0x6212 , 1 ,12 ,12 ,24 ,(char *) uc2_6212 },
	{ 0x6215 , 1 ,12 ,12 ,24 ,(char *) uc2_6215 },
	{ 0x6216 , 1 ,12 ,12 ,24 ,(char *) uc2_6216 },
	{ 0x6217 , 1 ,12 ,12 ,24 ,(char *) uc2_6217 },
	{ 0x6218 , 1 ,12 ,12 ,24 ,(char *) uc2_6218 },
	{ 0x621A , 1 ,12 ,12 ,24 ,(char *) uc2_621A },
	{ 0x621B , 1 ,12 ,12 ,24 ,(char *) uc2_621B },
	{ 0x621F , 1 ,12 ,12 ,24 ,(char *) uc2_621F },
	{ 0x6221 , 1 ,12 ,12 ,24 ,(char *) uc2_6221 },
	{ 0x6222 , 1 ,12 ,12 ,24 ,(char *) uc2_6222 },
	{ 0x6224 , 1 ,12 ,12 ,24 ,(char *) uc2_6224 },
	{ 0x6225 , 1 ,12 ,12 ,24 ,(char *) uc2_6225 },
	{ 0x622A , 1 ,12 ,12 ,24 ,(char *) uc2_622A },
	{ 0x622C , 1 ,12 ,12 ,24 ,(char *) uc2_622C },
	{ 0x622E , 1 ,12 ,12 ,24 ,(char *) uc2_622E },
	{ 0x6233 , 1 ,12 ,12 ,24 ,(char *) uc2_6233 },
	{ 0x6234 , 1 ,12 ,12 ,24 ,(char *) uc2_6234 },
	{ 0x6237 , 1 ,12 ,12 ,24 ,(char *) uc2_6237 },
	{ 0x623D , 1 ,12 ,12 ,24 ,(char *) uc2_623D },
	{ 0x623E , 1 ,12 ,12 ,24 ,(char *) uc2_623E },
	{ 0x623F , 1 ,12 ,12 ,24 ,(char *) uc2_623F },
	{ 0x6240 , 1 ,12 ,12 ,24 ,(char *) uc2_6240 },
	{ 0x6241 , 1 ,12 ,12 ,24 ,(char *) uc2_6241 },
	{ 0x6243 , 1 ,12 ,12 ,24 ,(char *) uc2_6243 },
	{ 0x6247 , 1 ,12 ,12 ,24 ,(char *) uc2_6247 },
	{ 0x6248 , 1 ,12 ,12 ,24 ,(char *) uc2_6248 },
	{ 0x6249 , 1 ,12 ,12 ,24 ,(char *) uc2_6249 },
	{ 0x624B , 1 ,12 ,12 ,24 ,(char *) uc2_624B },
	{ 0x624D , 1 ,12 ,12 ,24 ,(char *) uc2_624D },
	{ 0x624E , 1 ,12 ,12 ,24 ,(char *) uc2_624E },
	{ 0x6251 , 1 ,12 ,12 ,24 ,(char *) uc2_6251 },
	{ 0x6252 , 1 ,12 ,12 ,24 ,(char *) uc2_6252 },
	{ 0x6253 , 1 ,12 ,12 ,24 ,(char *) uc2_6253 },
	{ 0x6254 , 1 ,12 ,12 ,24 ,(char *) uc2_6254 },
	{ 0x6258 , 1 ,12 ,12 ,24 ,(char *) uc2_6258 },
	{ 0x625B , 1 ,12 ,12 ,24 ,(char *) uc2_625B },
	{ 0x6263 , 1 ,12 ,12 ,24 ,(char *) uc2_6263 },
	{ 0x6266 , 1 ,12 ,12 ,24 ,(char *) uc2_6266 },
	{ 0x6267 , 1 ,12 ,12 ,24 ,(char *) uc2_6267 },
	{ 0x6269 , 1 ,12 ,12 ,24 ,(char *) uc2_6269 },
	{ 0x626A , 1 ,12 ,12 ,24 ,(char *) uc2_626A },
	{ 0x626B , 1 ,12 ,12 ,24 ,(char *) uc2_626B },
	{ 0x626C , 1 ,12 ,12 ,24 ,(char *) uc2_626C },
	{ 0x626D , 1 ,12 ,12 ,24 ,(char *) uc2_626D },
	{ 0x626E , 1 ,12 ,12 ,24 ,(char *) uc2_626E },
	{ 0x626F , 1 ,12 ,12 ,24 ,(char *) uc2_626F },
	{ 0x6270 , 1 ,12 ,12 ,24 ,(char *) uc2_6270 },
	{ 0x6273 , 1 ,12 ,12 ,24 ,(char *) uc2_6273 },
	{ 0x6276 , 1 ,12 ,12 ,24 ,(char *) uc2_6276 },
	{ 0x6279 , 1 ,12 ,12 ,24 ,(char *) uc2_6279 },
	{ 0x627C , 1 ,12 ,12 ,24 ,(char *) uc2_627C },
	{ 0x627E , 1 ,12 ,12 ,24 ,(char *) uc2_627E },
	{ 0x627F , 1 ,12 ,12 ,24 ,(char *) uc2_627F },
	{ 0x6280 , 1 ,12 ,12 ,24 ,(char *) uc2_6280 },
	{ 0x6284 , 1 ,12 ,12 ,24 ,(char *) uc2_6284 },
	{ 0x6289 , 1 ,12 ,12 ,24 ,(char *) uc2_6289 },
	{ 0x628A , 1 ,12 ,12 ,24 ,(char *) uc2_628A },
	{ 0x6291 , 1 ,12 ,12 ,24 ,(char *) uc2_6291 },
	{ 0x6292 , 1 ,12 ,12 ,24 ,(char *) uc2_6292 },
	{ 0x6293 , 1 ,12 ,12 ,24 ,(char *) uc2_6293 },
	{ 0x6295 , 1 ,12 ,12 ,24 ,(char *) uc2_6295 },
	{ 0x6296 , 1 ,12 ,12 ,24 ,(char *) uc2_6296 },
	{ 0x6297 , 1 ,12 ,12 ,24 ,(char *) uc2_6297 },
	{ 0x6298 , 1 ,12 ,12 ,24 ,(char *) uc2_6298 },
	{ 0x629A , 1 ,12 ,12 ,24 ,(char *) uc2_629A },
	{ 0x629B , 1 ,12 ,12 ,24 ,(char *) uc2_629B },
	{ 0x629F , 1 ,12 ,12 ,24 ,(char *) uc2_629F },
	{ 0x62A0 , 1 ,12 ,12 ,24 ,(char *) uc2_62A0 },
	{ 0x62A1 , 1 ,12 ,12 ,24 ,(char *) uc2_62A1 },
	{ 0x62A2 , 1 ,12 ,12 ,24 ,(char *) uc2_62A2 },
	{ 0x62A4 , 1 ,12 ,12 ,24 ,(char *) uc2_62A4 },
	{ 0x62A5 , 1 ,12 ,12 ,24 ,(char *) uc2_62A5 },
	{ 0x62A8 , 1 ,12 ,12 ,24 ,(char *) uc2_62A8 },
	{ 0x62AB , 1 ,12 ,12 ,24 ,(char *) uc2_62AB },
	{ 0x62AC , 1 ,12 ,12 ,24 ,(char *) uc2_62AC },
	{ 0x62B1 , 1 ,12 ,12 ,24 ,(char *) uc2_62B1 },
	{ 0x62B5 , 1 ,12 ,12 ,24 ,(char *) uc2_62B5 },
	{ 0x62B9 , 1 ,12 ,12 ,24 ,(char *) uc2_62B9 },
	{ 0x62BB , 1 ,12 ,12 ,24 ,(char *) uc2_62BB },
	{ 0x62BC , 1 ,12 ,12 ,24 ,(char *) uc2_62BC },
	{ 0x62BD , 1 ,12 ,12 ,24 ,(char *) uc2_62BD },
	{ 0x62BF , 1 ,12 ,12 ,24 ,(char *) uc2_62BF },
	{ 0x62C2 , 1 ,12 ,12 ,24 ,(char *) uc2_62C2 },
	{ 0x62C4 , 1 ,12 ,12 ,24 ,(char *) uc2_62C4 },
	{ 0x62C5 , 1 ,12 ,12 ,24 ,(char *) uc2_62C5 },
	{ 0x62C6 , 1 ,12 ,12 ,24 ,(char *) uc2_62C6 },
	{ 0x62C7 , 1 ,12 ,12 ,24 ,(char *) uc2_62C7 },
	{ 0x62C8 , 1 ,12 ,12 ,24 ,(char *) uc2_62C8 },
	{ 0x62C9 , 1 ,12 ,12 ,24 ,(char *) uc2_62C9 },
	{ 0x62CA , 1 ,12 ,12 ,24 ,(char *) uc2_62CA },
	{ 0x62CC , 1 ,12 ,12 ,24 ,(char *) uc2_62CC },
	{ 0x62CD , 1 ,12 ,12 ,24 ,(char *) uc2_62CD },
	{ 0x62CE , 1 ,12 ,12 ,24 ,(char *) uc2_62CE },
	{ 0x62D0 , 1 ,12 ,12 ,24 ,(char *) uc2_62D0 },
	{ 0x62D2 , 1 ,12 ,12 ,24 ,(char *) uc2_62D2 },
	{ 0x62D3 , 1 ,12 ,12 ,24 ,(char *) uc2_62D3 },
	{ 0x62D4 , 1 ,12 ,12 ,24 ,(char *) uc2_62D4 },
	{ 0x62D6 , 1 ,12 ,12 ,24 ,(char *) uc2_62D6 },
	{ 0x62D7 , 1 ,12 ,12 ,24 ,(char *) uc2_62D7 },
	{ 0x62D8 , 1 ,12 ,12 ,24 ,(char *) uc2_62D8 },
	{ 0x62D9 , 1 ,12 ,12 ,24 ,(char *) uc2_62D9 },
	{ 0x62DA , 1 ,12 ,12 ,24 ,(char *) uc2_62DA },
	{ 0x62DB , 1 ,12 ,12 ,24 ,(char *) uc2_62DB },
	{ 0x62DC , 1 ,12 ,12 ,24 ,(char *) uc2_62DC },
	{ 0x62DF , 1 ,12 ,12 ,24 ,(char *) uc2_62DF },
	{ 0x62E2 , 1 ,12 ,12 ,24 ,(char *) uc2_62E2 },
	{ 0x62E3 , 1 ,12 ,12 ,24 ,(char *) uc2_62E3 },
	{ 0x62E5 , 1 ,12 ,12 ,24 ,(char *) uc2_62E5 },
	{ 0x62E6 , 1 ,12 ,12 ,24 ,(char *) uc2_62E6 },
	{ 0x62E7 , 1 ,12 ,12 ,24 ,(char *) uc2_62E7 },
	{ 0x62E8 , 1 ,12 ,12 ,24 ,(char *) uc2_62E8 },
	{ 0x62E9 , 1 ,12 ,12 ,24 ,(char *) uc2_62E9 },
	{ 0x62EC , 1 ,12 ,12 ,24 ,(char *) uc2_62EC },
	{ 0x62ED , 1 ,12 ,12 ,24 ,(char *) uc2_62ED },
	{ 0x62EE , 1 ,12 ,12 ,24 ,(char *) uc2_62EE },
	{ 0x62EF , 1 ,12 ,12 ,24 ,(char *) uc2_62EF },
	{ 0x62F1 , 1 ,12 ,12 ,24 ,(char *) uc2_62F1 },
	{ 0x62F3 , 1 ,12 ,12 ,24 ,(char *) uc2_62F3 },
	{ 0x62F4 , 1 ,12 ,12 ,24 ,(char *) uc2_62F4 },
	{ 0x62F6 , 1 ,12 ,12 ,24 ,(char *) uc2_62F6 },
	{ 0x62F7 , 1 ,12 ,12 ,24 ,(char *) uc2_62F7 },
	{ 0x62FC , 1 ,12 ,12 ,24 ,(char *) uc2_62FC },
	{ 0x62FD , 1 ,12 ,12 ,24 ,(char *) uc2_62FD },
	{ 0x62FE , 1 ,12 ,12 ,24 ,(char *) uc2_62FE },
	{ 0x62FF , 1 ,12 ,12 ,24 ,(char *) uc2_62FF },
	{ 0x6301 , 1 ,12 ,12 ,24 ,(char *) uc2_6301 },
	{ 0x6302 , 1 ,12 ,12 ,24 ,(char *) uc2_6302 },
	{ 0x6307 , 1 ,12 ,12 ,24 ,(char *) uc2_6307 },
	{ 0x6308 , 1 ,12 ,12 ,24 ,(char *) uc2_6308 },
	{ 0x6309 , 1 ,12 ,12 ,24 ,(char *) uc2_6309 },
	{ 0x630E , 1 ,12 ,12 ,24 ,(char *) uc2_630E },
	{ 0x6311 , 1 ,12 ,12 ,24 ,(char *) uc2_6311 },
	{ 0x6316 , 1 ,12 ,12 ,24 ,(char *) uc2_6316 },
	{ 0x631A , 1 ,12 ,12 ,24 ,(char *) uc2_631A },
	{ 0x631B , 1 ,12 ,12 ,24 ,(char *) uc2_631B },
	{ 0x631D , 1 ,12 ,12 ,24 ,(char *) uc2_631D },
	{ 0x631E , 1 ,12 ,12 ,24 ,(char *) uc2_631E },
	{ 0x631F , 1 ,12 ,12 ,24 ,(char *) uc2_631F },
	{ 0x6320 , 1 ,12 ,12 ,24 ,(char *) uc2_6320 },
	{ 0x6321 , 1 ,12 ,12 ,24 ,(char *) uc2_6321 },
	{ 0x6322 , 1 ,12 ,12 ,24 ,(char *) uc2_6322 },
	{ 0x6323 , 1 ,12 ,12 ,24 ,(char *) uc2_6323 },
	{ 0x6324 , 1 ,12 ,12 ,24 ,(char *) uc2_6324 },
	{ 0x6325 , 1 ,12 ,12 ,24 ,(char *) uc2_6325 },
	{ 0x6328 , 1 ,12 ,12 ,24 ,(char *) uc2_6328 },
	{ 0x632A , 1 ,12 ,12 ,24 ,(char *) uc2_632A },
	{ 0x632B , 1 ,12 ,12 ,24 ,(char *) uc2_632B },
	{ 0x632F , 1 ,12 ,12 ,24 ,(char *) uc2_632F },
	{ 0x6332 , 1 ,12 ,12 ,24 ,(char *) uc2_6332 },
	{ 0x6339 , 1 ,12 ,12 ,24 ,(char *) uc2_6339 },
	{ 0x633A , 1 ,12 ,12 ,24 ,(char *) uc2_633A },
	{ 0x633D , 1 ,12 ,12 ,24 ,(char *) uc2_633D },
	{ 0x6342 , 1 ,12 ,12 ,24 ,(char *) uc2_6342 },
	{ 0x6343 , 1 ,12 ,12 ,24 ,(char *) uc2_6343 },
	{ 0x6345 , 1 ,12 ,12 ,24 ,(char *) uc2_6345 },
	{ 0x6346 , 1 ,12 ,12 ,24 ,(char *) uc2_6346 },
	{ 0x6349 , 1 ,12 ,12 ,24 ,(char *) uc2_6349 },
	{ 0x634B , 1 ,12 ,12 ,24 ,(char *) uc2_634B },
	{ 0x634C , 1 ,12 ,12 ,24 ,(char *) uc2_634C },
	{ 0x634D , 1 ,12 ,12 ,24 ,(char *) uc2_634D },
	{ 0x634E , 1 ,12 ,12 ,24 ,(char *) uc2_634E },
	{ 0x634F , 1 ,12 ,12 ,24 ,(char *) uc2_634F },
	{ 0x6350 , 1 ,12 ,12 ,24 ,(char *) uc2_6350 },
	{ 0x6355 , 1 ,12 ,12 ,24 ,(char *) uc2_6355 },
	{ 0x635E , 1 ,12 ,12 ,24 ,(char *) uc2_635E },
	{ 0x635F , 1 ,12 ,12 ,24 ,(char *) uc2_635F },
	{ 0x6361 , 1 ,12 ,12 ,24 ,(char *) uc2_6361 },
	{ 0x6362 , 1 ,12 ,12 ,24 ,(char *) uc2_6362 },
	{ 0x6363 , 1 ,12 ,12 ,24 ,(char *) uc2_6363 },
	{ 0x6367 , 1 ,12 ,12 ,24 ,(char *) uc2_6367 },
	{ 0x6369 , 1 ,12 ,12 ,24 ,(char *) uc2_6369 },
	{ 0x636D , 1 ,12 ,12 ,24 ,(char *) uc2_636D },
	{ 0x636E , 1 ,12 ,12 ,24 ,(char *) uc2_636E },
	{ 0x6371 , 1 ,12 ,12 ,24 ,(char *) uc2_6371 },
	{ 0x6376 , 1 ,12 ,12 ,24 ,(char *) uc2_6376 },
	{ 0x6377 , 1 ,12 ,12 ,24 ,(char *) uc2_6377 },
	{ 0x637A , 1 ,12 ,12 ,24 ,(char *) uc2_637A },
	{ 0x637B , 1 ,12 ,12 ,24 ,(char *) uc2_637B },
	{ 0x6380 , 1 ,12 ,12 ,24 ,(char *) uc2_6380 },
	{ 0x6382 , 1 ,12 ,12 ,24 ,(char *) uc2_6382 },
	{ 0x6387 , 1 ,12 ,12 ,24 ,(char *) uc2_6387 },
	{ 0x6388 , 1 ,12 ,12 ,24 ,(char *) uc2_6388 },
	{ 0x6389 , 1 ,12 ,12 ,24 ,(char *) uc2_6389 },
	{ 0x638A , 1 ,12 ,12 ,24 ,(char *) uc2_638A },
	{ 0x638C , 1 ,12 ,12 ,24 ,(char *) uc2_638C },
	{ 0x638E , 1 ,12 ,12 ,24 ,(char *) uc2_638E },
	{ 0x638F , 1 ,12 ,12 ,24 ,(char *) uc2_638F },
	{ 0x6390 , 1 ,12 ,12 ,24 ,(char *) uc2_6390 },
	{ 0x6392 , 1 ,12 ,12 ,24 ,(char *) uc2_6392 },
	{ 0x6396 , 1 ,12 ,12 ,24 ,(char *) uc2_6396 },
	{ 0x6398 , 1 ,12 ,12 ,24 ,(char *) uc2_6398 },
	{ 0x63A0 , 1 ,12 ,12 ,24 ,(char *) uc2_63A0 },
	{ 0x63A2 , 1 ,12 ,12 ,24 ,(char *) uc2_63A2 },
	{ 0x63A3 , 1 ,12 ,12 ,24 ,(char *) uc2_63A3 },
	{ 0x63A5 , 1 ,12 ,12 ,24 ,(char *) uc2_63A5 },
	{ 0x63A7 , 1 ,12 ,12 ,24 ,(char *) uc2_63A7 },
	{ 0x63A8 , 1 ,12 ,12 ,24 ,(char *) uc2_63A8 },
	{ 0x63A9 , 1 ,12 ,12 ,24 ,(char *) uc2_63A9 },
	{ 0x63AA , 1 ,12 ,12 ,24 ,(char *) uc2_63AA },
	{ 0x63AC , 1 ,12 ,12 ,24 ,(char *) uc2_63AC },
	{ 0x63AD , 1 ,12 ,12 ,24 ,(char *) uc2_63AD },
	{ 0x63AE , 1 ,12 ,12 ,24 ,(char *) uc2_63AE },
	{ 0x63B0 , 1 ,12 ,12 ,24 ,(char *) uc2_63B0 },
	{ 0x63B3 , 1 ,12 ,12 ,24 ,(char *) uc2_63B3 },
	{ 0x63B4 , 1 ,12 ,12 ,24 ,(char *) uc2_63B4 },
	{ 0x63B7 , 1 ,12 ,12 ,24 ,(char *) uc2_63B7 },
	{ 0x63B8 , 1 ,12 ,12 ,24 ,(char *) uc2_63B8 },
	{ 0x63BA , 1 ,12 ,12 ,24 ,(char *) uc2_63BA },
	{ 0x63BC , 1 ,12 ,12 ,24 ,(char *) uc2_63BC },
	{ 0x63BE , 1 ,12 ,12 ,24 ,(char *) uc2_63BE },
	{ 0x63C4 , 1 ,12 ,12 ,24 ,(char *) uc2_63C4 },
	{ 0x63C6 , 1 ,12 ,12 ,24 ,(char *) uc2_63C6 },
	{ 0x63C9 , 1 ,12 ,12 ,24 ,(char *) uc2_63C9 },
	{ 0x63CD , 1 ,12 ,12 ,24 ,(char *) uc2_63CD },
	{ 0x63CE , 1 ,12 ,12 ,24 ,(char *) uc2_63CE },
	{ 0x63CF , 1 ,12 ,12 ,24 ,(char *) uc2_63CF },
	{ 0x63D0 , 1 ,12 ,12 ,24 ,(char *) uc2_63D0 },
	{ 0x63D2 , 1 ,12 ,12 ,24 ,(char *) uc2_63D2 },
	{ 0x63D6 , 1 ,12 ,12 ,24 ,(char *) uc2_63D6 },
	{ 0x63DE , 1 ,12 ,12 ,24 ,(char *) uc2_63DE },
	{ 0x63E0 , 1 ,12 ,12 ,24 ,(char *) uc2_63E0 },
	{ 0x63E1 , 1 ,12 ,12 ,24 ,(char *) uc2_63E1 },
	{ 0x63E3 , 1 ,12 ,12 ,24 ,(char *) uc2_63E3 },
	{ 0x63E9 , 1 ,12 ,12 ,24 ,(char *) uc2_63E9 },
	{ 0x63EA , 1 ,12 ,12 ,24 ,(char *) uc2_63EA },
	{ 0x63ED , 1 ,12 ,12 ,24 ,(char *) uc2_63ED },
	{ 0x63F2 , 1 ,12 ,12 ,24 ,(char *) uc2_63F2 },
	{ 0x63F4 , 1 ,12 ,12 ,24 ,(char *) uc2_63F4 },
	{ 0x63F6 , 1 ,12 ,12 ,24 ,(char *) uc2_63F6 },
	{ 0x63F8 , 1 ,12 ,12 ,24 ,(char *) uc2_63F8 },
	{ 0x63FD , 1 ,12 ,12 ,24 ,(char *) uc2_63FD },
	{ 0x63FF , 1 ,12 ,12 ,24 ,(char *) uc2_63FF },
	{ 0x6400 , 1 ,12 ,12 ,24 ,(char *) uc2_6400 },
	{ 0x6401 , 1 ,12 ,12 ,24 ,(char *) uc2_6401 },
	{ 0x6402 , 1 ,12 ,12 ,24 ,(char *) uc2_6402 },
	{ 0x6405 , 1 ,12 ,12 ,24 ,(char *) uc2_6405 },
	{ 0x640B , 1 ,12 ,12 ,24 ,(char *) uc2_640B },
	{ 0x640C , 1 ,12 ,12 ,24 ,(char *) uc2_640C },
	{ 0x640F , 1 ,12 ,12 ,24 ,(char *) uc2_640F },
	{ 0x6410 , 1 ,12 ,12 ,24 ,(char *) uc2_6410 },
	{ 0x6413 , 1 ,12 ,12 ,24 ,(char *) uc2_6413 },
	{ 0x6414 , 1 ,12 ,12 ,24 ,(char *) uc2_6414 },
	{ 0x641B , 1 ,12 ,12 ,24 ,(char *) uc2_641B },
	{ 0x641C , 1 ,12 ,12 ,24 ,(char *) uc2_641C },
	{ 0x641E , 1 ,12 ,12 ,24 ,(char *) uc2_641E },
	{ 0x6420 , 1 ,12 ,12 ,24 ,(char *) uc2_6420 },
	{ 0x6421 , 1 ,12 ,12 ,24 ,(char *) uc2_6421 },
	{ 0x6426 , 1 ,12 ,12 ,24 ,(char *) uc2_6426 },
	{ 0x642A , 1 ,12 ,12 ,24 ,(char *) uc2_642A },
	{ 0x642C , 1 ,12 ,12 ,24 ,(char *) uc2_642C },
	{ 0x642D , 1 ,12 ,12 ,24 ,(char *) uc2_642D },
	{ 0x6434 , 1 ,12 ,12 ,24 ,(char *) uc2_6434 },
	{ 0x643A , 1 ,12 ,12 ,24 ,(char *) uc2_643A },
	{ 0x643D , 1 ,12 ,12 ,24 ,(char *) uc2_643D },
	{ 0x643F , 1 ,12 ,12 ,24 ,(char *) uc2_643F },
	{ 0x6441 , 1 ,12 ,12 ,24 ,(char *) uc2_6441 },
	{ 0x6444 , 1 ,12 ,12 ,24 ,(char *) uc2_6444 },
	{ 0x6445 , 1 ,12 ,12 ,24 ,(char *) uc2_6445 },
	{ 0x6446 , 1 ,12 ,12 ,24 ,(char *) uc2_6446 },
	{ 0x6447 , 1 ,12 ,12 ,24 ,(char *) uc2_6447 },
	{ 0x6448 , 1 ,12 ,12 ,24 ,(char *) uc2_6448 },
	{ 0x644A , 1 ,12 ,12 ,24 ,(char *) uc2_644A },
	{ 0x6452 , 1 ,12 ,12 ,24 ,(char *) uc2_6452 },
	{ 0x6454 , 1 ,12 ,12 ,24 ,(char *) uc2_6454 },
	{ 0x6458 , 1 ,12 ,12 ,24 ,(char *) uc2_6458 },
	{ 0x645E , 1 ,12 ,12 ,24 ,(char *) uc2_645E },
	{ 0x6467 , 1 ,12 ,12 ,24 ,(char *) uc2_6467 },
	{ 0x6469 , 1 ,12 ,12 ,24 ,(char *) uc2_6469 },
	{ 0x646D , 1 ,12 ,12 ,24 ,(char *) uc2_646D },
	{ 0x6478 , 1 ,12 ,12 ,24 ,(char *) uc2_6478 },
	{ 0x6479 , 1 ,12 ,12 ,24 ,(char *) uc2_6479 },
	{ 0x647A , 1 ,12 ,12 ,24 ,(char *) uc2_647A },
	{ 0x6482 , 1 ,12 ,12 ,24 ,(char *) uc2_6482 },
	{ 0x6484 , 1 ,12 ,12 ,24 ,(char *) uc2_6484 },
	{ 0x6485 , 1 ,12 ,12 ,24 ,(char *) uc2_6485 },
	{ 0x6487 , 1 ,12 ,12 ,24 ,(char *) uc2_6487 },
	{ 0x6491 , 1 ,12 ,12 ,24 ,(char *) uc2_6491 },
	{ 0x6492 , 1 ,12 ,12 ,24 ,(char *) uc2_6492 },
	{ 0x6495 , 1 ,12 ,12 ,24 ,(char *) uc2_6495 },
	{ 0x6496 , 1 ,12 ,12 ,24 ,(char *) uc2_6496 },
	{ 0x6499 , 1 ,12 ,12 ,24 ,(char *) uc2_6499 },
	{ 0x649E , 1 ,12 ,12 ,24 ,(char *) uc2_649E },
	{ 0x64A4 , 1 ,12 ,12 ,24 ,(char *) uc2_64A4 },
	{ 0x64A9 , 1 ,12 ,12 ,24 ,(char *) uc2_64A9 },
	{ 0x64AC , 1 ,12 ,12 ,24 ,(char *) uc2_64AC },
	{ 0x64AD , 1 ,12 ,12 ,24 ,(char *) uc2_64AD },
	{ 0x64AE , 1 ,12 ,12 ,24 ,(char *) uc2_64AE },
	{ 0x64B0 , 1 ,12 ,12 ,24 ,(char *) uc2_64B0 },
	{ 0x64B5 , 1 ,12 ,12 ,24 ,(char *) uc2_64B5 },
	{ 0x64B7 , 1 ,12 ,12 ,24 ,(char *) uc2_64B7 },
	{ 0x64B8 , 1 ,12 ,12 ,24 ,(char *) uc2_64B8 },
	{ 0x64BA , 1 ,12 ,12 ,24 ,(char *) uc2_64BA },
	{ 0x64BC , 1 ,12 ,12 ,24 ,(char *) uc2_64BC },
	{ 0x64C0 , 1 ,12 ,12 ,24 ,(char *) uc2_64C0 },
	{ 0x64C2 , 1 ,12 ,12 ,24 ,(char *) uc2_64C2 },
	{ 0x64C5 , 1 ,12 ,12 ,24 ,(char *) uc2_64C5 },
	{ 0x64CD , 1 ,12 ,12 ,24 ,(char *) uc2_64CD },
	{ 0x64CE , 1 ,12 ,12 ,24 ,(char *) uc2_64CE },
	{ 0x64D0 , 1 ,12 ,12 ,24 ,(char *) uc2_64D0 },
	{ 0x64D2 , 1 ,12 ,12 ,24 ,(char *) uc2_64D2 },
	{ 0x64D7 , 1 ,12 ,12 ,24 ,(char *) uc2_64D7 },
	{ 0x64D8 , 1 ,12 ,12 ,24 ,(char *) uc2_64D8 },
	{ 0x64DE , 1 ,12 ,12 ,24 ,(char *) uc2_64DE },
	{ 0x64E2 , 1 ,12 ,12 ,24 ,(char *) uc2_64E2 },
	{ 0x64E4 , 1 ,12 ,12 ,24 ,(char *) uc2_64E4 },
	{ 0x64E6 , 1 ,12 ,12 ,24 ,(char *) uc2_64E6 },
	{ 0x6500 , 1 ,12 ,12 ,24 ,(char *) uc2_6500 },
	{ 0x6509 , 1 ,12 ,12 ,24 ,(char *) uc2_6509 },
	{ 0x6512 , 1 ,12 ,12 ,24 ,(char *) uc2_6512 },
	{ 0x6518 , 1 ,12 ,12 ,24 ,(char *) uc2_6518 },
	{ 0x6525 , 1 ,12 ,12 ,24 ,(char *) uc2_6525 },
	{ 0x652B , 1 ,12 ,12 ,24 ,(char *) uc2_652B },
	{ 0x652E , 1 ,12 ,12 ,24 ,(char *) uc2_652E },
	{ 0x652F , 1 ,12 ,12 ,24 ,(char *) uc2_652F },
	{ 0x6534 , 1 ,12 ,12 ,24 ,(char *) uc2_6534 },
	{ 0x6536 , 1 ,12 ,12 ,24 ,(char *) uc2_6536 },
	{ 0x6538 , 1 ,12 ,12 ,24 ,(char *) uc2_6538 },
	{ 0x6539 , 1 ,12 ,12 ,24 ,(char *) uc2_6539 },
	{ 0x653B , 1 ,12 ,12 ,24 ,(char *) uc2_653B },
	{ 0x653E , 1 ,12 ,12 ,24 ,(char *) uc2_653E },
	{ 0x653F , 1 ,12 ,12 ,24 ,(char *) uc2_653F },
	{ 0x6545 , 1 ,12 ,12 ,24 ,(char *) uc2_6545 },
	{ 0x6548 , 1 ,12 ,12 ,24 ,(char *) uc2_6548 },
	{ 0x6549 , 1 ,12 ,12 ,24 ,(char *) uc2_6549 },
	{ 0x654C , 1 ,12 ,12 ,24 ,(char *) uc2_654C },
	{ 0x654F , 1 ,12 ,12 ,24 ,(char *) uc2_654F },
	{ 0x6551 , 1 ,12 ,12 ,24 ,(char *) uc2_6551 },
	{ 0x6555 , 1 ,12 ,12 ,24 ,(char *) uc2_6555 },
	{ 0x6556 , 1 ,12 ,12 ,24 ,(char *) uc2_6556 },
	{ 0x6559 , 1 ,12 ,12 ,24 ,(char *) uc2_6559 },
	{ 0x655B , 1 ,12 ,12 ,24 ,(char *) uc2_655B },
	{ 0x655D , 1 ,12 ,12 ,24 ,(char *) uc2_655D },
	{ 0x655E , 1 ,12 ,12 ,24 ,(char *) uc2_655E },
	{ 0x6562 , 1 ,12 ,12 ,24 ,(char *) uc2_6562 },
	{ 0x6563 , 1 ,12 ,12 ,24 ,(char *) uc2_6563 },
	{ 0x6566 , 1 ,12 ,12 ,24 ,(char *) uc2_6566 },
	{ 0x656B , 1 ,12 ,12 ,24 ,(char *) uc2_656B },
	{ 0x656C , 1 ,12 ,12 ,24 ,(char *) uc2_656C },
	{ 0x6570 , 1 ,12 ,12 ,24 ,(char *) uc2_6570 },
	{ 0x6572 , 1 ,12 ,12 ,24 ,(char *) uc2_6572 },
	{ 0x6574 , 1 ,12 ,12 ,24 ,(char *) uc2_6574 },
	{ 0x6577 , 1 ,12 ,12 ,24 ,(char *) uc2_6577 },
	{ 0x6587 , 1 ,12 ,12 ,24 ,(char *) uc2_6587 },
	{ 0x658B , 1 ,12 ,12 ,24 ,(char *) uc2_658B },
	{ 0x658C , 1 ,12 ,12 ,24 ,(char *) uc2_658C },
	{ 0x6590 , 1 ,12 ,12 ,24 ,(char *) uc2_6590 },
	{ 0x6591 , 1 ,12 ,12 ,24 ,(char *) uc2_6591 },
	{ 0x6593 , 1 ,12 ,12 ,24 ,(char *) uc2_6593 },
	{ 0x6597 , 1 ,12 ,12 ,24 ,(char *) uc2_6597 },
	{ 0x6599 , 1 ,12 ,12 ,24 ,(char *) uc2_6599 },
	{ 0x659B , 1 ,12 ,12 ,24 ,(char *) uc2_659B },
	{ 0x659C , 1 ,12 ,12 ,24 ,(char *) uc2_659C },
	{ 0x659F , 1 ,12 ,12 ,24 ,(char *) uc2_659F },
	{ 0x65A1 , 1 ,12 ,12 ,24 ,(char *) uc2_65A1 },
	{ 0x65A4 , 1 ,12 ,12 ,24 ,(char *) uc2_65A4 },
	{ 0x65A5 , 1 ,12 ,12 ,24 ,(char *) uc2_65A5 },
	{ 0x65A7 , 1 ,12 ,12 ,24 ,(char *) uc2_65A7 },
	{ 0x65A9 , 1 ,12 ,12 ,24 ,(char *) uc2_65A9 },
	{ 0x65AB , 1 ,12 ,12 ,24 ,(char *) uc2_65AB },
	{ 0x65AD , 1 ,12 ,12 ,24 ,(char *) uc2_65AD },
	{ 0x65AF , 1 ,12 ,12 ,24 ,(char *) uc2_65AF },
	{ 0x65B0 , 1 ,12 ,12 ,24 ,(char *) uc2_65B0 },
	{ 0x65B9 , 1 ,12 ,12 ,24 ,(char *) uc2_65B9 },
	{ 0x65BC , 1 ,12 ,12 ,24 ,(char *) uc2_65BC },
	{ 0x65BD , 1 ,12 ,12 ,24 ,(char *) uc2_65BD },
	{ 0x65C1 , 1 ,12 ,12 ,24 ,(char *) uc2_65C1 },
	{ 0x65C3 , 1 ,12 ,12 ,24 ,(char *) uc2_65C3 },
	{ 0x65C4 , 1 ,12 ,12 ,24 ,(char *) uc2_65C4 },
	{ 0x65C5 , 1 ,12 ,12 ,24 ,(char *) uc2_65C5 },
	{ 0x65C6 , 1 ,12 ,12 ,24 ,(char *) uc2_65C6 },
	{ 0x65CB , 1 ,12 ,12 ,24 ,(char *) uc2_65CB },
	{ 0x65CC , 1 ,12 ,12 ,24 ,(char *) uc2_65CC },
	{ 0x65CE , 1 ,12 ,12 ,24 ,(char *) uc2_65CE },
	{ 0x65CF , 1 ,12 ,12 ,24 ,(char *) uc2_65CF },
	{ 0x65D2 , 1 ,12 ,12 ,24 ,(char *) uc2_65D2 },
	{ 0x65D6 , 1 ,12 ,12 ,24 ,(char *) uc2_65D6 },
	{ 0x65D7 , 1 ,12 ,12 ,24 ,(char *) uc2_65D7 },
	{ 0x65E0 , 1 ,12 ,12 ,24 ,(char *) uc2_65E0 },
	{ 0x65E2 , 1 ,12 ,12 ,24 ,(char *) uc2_65E2 },
	{ 0x65E5 , 1 ,12 ,12 ,24 ,(char *) uc2_65E5 },
	{ 0x65E6 , 1 ,12 ,12 ,24 ,(char *) uc2_65E6 },
	{ 0x65E7 , 1 ,12 ,12 ,24 ,(char *) uc2_65E7 },
	{ 0x65E8 , 1 ,12 ,12 ,24 ,(char *) uc2_65E8 },
	{ 0x65E9 , 1 ,12 ,12 ,24 ,(char *) uc2_65E9 },
	{ 0x65EC , 1 ,12 ,12 ,24 ,(char *) uc2_65EC },
	{ 0x65ED , 1 ,12 ,12 ,24 ,(char *) uc2_65ED },
	{ 0x65EE , 1 ,12 ,12 ,24 ,(char *) uc2_65EE },
	{ 0x65EF , 1 ,12 ,12 ,24 ,(char *) uc2_65EF },
	{ 0x65F0 , 1 ,12 ,12 ,24 ,(char *) uc2_65F0 },
	{ 0x65F1 , 1 ,12 ,12 ,24 ,(char *) uc2_65F1 },
	{ 0x65F6 , 1 ,12 ,12 ,24 ,(char *) uc2_65F6 },
	{ 0x65F7 , 1 ,12 ,12 ,24 ,(char *) uc2_65F7 },
	{ 0x65FA , 1 ,12 ,12 ,24 ,(char *) uc2_65FA },
	{ 0x6600 , 1 ,12 ,12 ,24 ,(char *) uc2_6600 },
	{ 0x6602 , 1 ,12 ,12 ,24 ,(char *) uc2_6602 },
	{ 0x6603 , 1 ,12 ,12 ,24 ,(char *) uc2_6603 },
	{ 0x6606 , 1 ,12 ,12 ,24 ,(char *) uc2_6606 },
	{ 0x660A , 1 ,12 ,12 ,24 ,(char *) uc2_660A },
	{ 0x660C , 1 ,12 ,12 ,24 ,(char *) uc2_660C },
	{ 0x660E , 1 ,12 ,12 ,24 ,(char *) uc2_660E },
	{ 0x660F , 1 ,12 ,12 ,24 ,(char *) uc2_660F },
	{ 0x6613 , 1 ,12 ,12 ,24 ,(char *) uc2_6613 },
	{ 0x6614 , 1 ,12 ,12 ,24 ,(char *) uc2_6614 },
	{ 0x6615 , 1 ,12 ,12 ,24 ,(char *) uc2_6615 },
	{ 0x6619 , 1 ,12 ,12 ,24 ,(char *) uc2_6619 },
	{ 0x661D , 1 ,12 ,12 ,24 ,(char *) uc2_661D },
	{ 0x661F , 1 ,12 ,12 ,24 ,(char *) uc2_661F },
	{ 0x6620 , 1 ,12 ,12 ,24 ,(char *) uc2_6620 },
	{ 0x6625 , 1 ,12 ,12 ,24 ,(char *) uc2_6625 },
	{ 0x6627 , 1 ,12 ,12 ,24 ,(char *) uc2_6627 },
	{ 0x6628 , 1 ,12 ,12 ,24 ,(char *) uc2_6628 },
	{ 0x662D , 1 ,12 ,12 ,24 ,(char *) uc2_662D },
	{ 0x662F , 1 ,12 ,12 ,24 ,(char *) uc2_662F },
	{ 0x6631 , 1 ,12 ,12 ,24 ,(char *) uc2_6631 },
	{ 0x6634 , 1 ,12 ,12 ,24 ,(char *) uc2_6634 },
	{ 0x6635 , 1 ,12 ,12 ,24 ,(char *) uc2_6635 },
	{ 0x6636 , 1 ,12 ,12 ,24 ,(char *) uc2_6636 },
	{ 0x663C , 1 ,12 ,12 ,24 ,(char *) uc2_663C },
	{ 0x663E , 1 ,12 ,12 ,24 ,(char *) uc2_663E },
	{ 0x6641 , 1 ,12 ,12 ,24 ,(char *) uc2_6641 },
	{ 0x6643 , 1 ,12 ,12 ,24 ,(char *) uc2_6643 },
	{ 0x664B , 1 ,12 ,12 ,24 ,(char *) uc2_664B },
	{ 0x664C , 1 ,12 ,12 ,24 ,(char *) uc2_664C },
	{ 0x664F , 1 ,12 ,12 ,24 ,(char *) uc2_664F },
	{ 0x6652 , 1 ,12 ,12 ,24 ,(char *) uc2_6652 },
	{ 0x6653 , 1 ,12 ,12 ,24 ,(char *) uc2_6653 },
	{ 0x6654 , 1 ,12 ,12 ,24 ,(char *) uc2_6654 },
	{ 0x6655 , 1 ,12 ,12 ,24 ,(char *) uc2_6655 },
	{ 0x6656 , 1 ,12 ,12 ,24 ,(char *) uc2_6656 },
	{ 0x6657 , 1 ,12 ,12 ,24 ,(char *) uc2_6657 },
	{ 0x665A , 1 ,12 ,12 ,24 ,(char *) uc2_665A },
	{ 0x665F , 1 ,12 ,12 ,24 ,(char *) uc2_665F },
	{ 0x6661 , 1 ,12 ,12 ,24 ,(char *) uc2_6661 },
	{ 0x6664 , 1 ,12 ,12 ,24 ,(char *) uc2_6664 },
	{ 0x6666 , 1 ,12 ,12 ,24 ,(char *) uc2_6666 },
	{ 0x6668 , 1 ,12 ,12 ,24 ,(char *) uc2_6668 },
	{ 0x666E , 1 ,12 ,12 ,24 ,(char *) uc2_666E },
	{ 0x666F , 1 ,12 ,12 ,24 ,(char *) uc2_666F },
	{ 0x6670 , 1 ,12 ,12 ,24 ,(char *) uc2_6670 },
	{ 0x6674 , 1 ,12 ,12 ,24 ,(char *) uc2_6674 },
	{ 0x6676 , 1 ,12 ,12 ,24 ,(char *) uc2_6676 },
	{ 0x6677 , 1 ,12 ,12 ,24 ,(char *) uc2_6677 },
	{ 0x667A , 1 ,12 ,12 ,24 ,(char *) uc2_667A },
	{ 0x667E , 1 ,12 ,12 ,24 ,(char *) uc2_667E },
	{ 0x6682 , 1 ,12 ,12 ,24 ,(char *) uc2_6682 },
	{ 0x6684 , 1 ,12 ,12 ,24 ,(char *) uc2_6684 },
	{ 0x6687 , 1 ,12 ,12 ,24 ,(char *) uc2_6687 },
	{ 0x668C , 1 ,12 ,12 ,24 ,(char *) uc2_668C },
	{ 0x6691 , 1 ,12 ,12 ,24 ,(char *) uc2_6691 },
	{ 0x6696 , 1 ,12 ,12 ,24 ,(char *) uc2_6696 },
	{ 0x6697 , 1 ,12 ,12 ,24 ,(char *) uc2_6697 },
	{ 0x669D , 1 ,12 ,12 ,24 ,(char *) uc2_669D },
	{ 0x66A7 , 1 ,12 ,12 ,24 ,(char *) uc2_66A7 },
	{ 0x66A8 , 1 ,12 ,12 ,24 ,(char *) uc2_66A8 },
	{ 0x66AE , 1 ,12 ,12 ,24 ,(char *) uc2_66AE },
	{ 0x66B4 , 1 ,12 ,12 ,24 ,(char *) uc2_66B4 },
	{ 0x66B9 , 1 ,12 ,12 ,24 ,(char *) uc2_66B9 },
	{ 0x66BE , 1 ,12 ,12 ,24 ,(char *) uc2_66BE },
	{ 0x66D9 , 1 ,12 ,12 ,24 ,(char *) uc2_66D9 },
	{ 0x66DB , 1 ,12 ,12 ,24 ,(char *) uc2_66DB },
	{ 0x66DC , 1 ,12 ,12 ,24 ,(char *) uc2_66DC },
	{ 0x66DD , 1 ,12 ,12 ,24 ,(char *) uc2_66DD },
	{ 0x66E6 , 1 ,12 ,12 ,24 ,(char *) uc2_66E6 },
	{ 0x66E9 , 1 ,12 ,12 ,24 ,(char *) uc2_66E9 },
	{ 0x66EF , 1 ,12 ,12 ,24 ,(char *) uc2_66EF },
	{ 0x66F0 , 1 ,12 ,12 ,24 ,(char *) uc2_66F0 },
	{ 0x66F2 , 1 ,12 ,12 ,24 ,(char *) uc2_66F2 },
	{ 0x66F3 , 1 ,12 ,12 ,24 ,(char *) uc2_66F3 },
	{ 0x66F4 , 1 ,12 ,12 ,24 ,(char *) uc2_66F4 },
	{ 0x66F7 , 1 ,12 ,12 ,24 ,(char *) uc2_66F7 },
	{ 0x66F9 , 1 ,12 ,12 ,24 ,(char *) uc2_66F9 },
	{ 0x66FC , 1 ,12 ,12 ,24 ,(char *) uc2_66FC },
	{ 0x66FE , 1 ,12 ,12 ,24 ,(char *) uc2_66FE },
	{ 0x66FF , 1 ,12 ,12 ,24 ,(char *) uc2_66FF },
	{ 0x6700 , 1 ,12 ,12 ,24 ,(char *) uc2_6700 },
	{ 0x6708 , 1 ,12 ,12 ,24 ,(char *) uc2_6708 },
	{ 0x6709 , 1 ,12 ,12 ,24 ,(char *) uc2_6709 },
	{ 0x670A , 1 ,12 ,12 ,24 ,(char *) uc2_670A },
	{ 0x670B , 1 ,12 ,12 ,24 ,(char *) uc2_670B },
	{ 0x670D , 1 ,12 ,12 ,24 ,(char *) uc2_670D },
	{ 0x6710 , 1 ,12 ,12 ,24 ,(char *) uc2_6710 },
	{ 0x6714 , 1 ,12 ,12 ,24 ,(char *) uc2_6714 },
	{ 0x6715 , 1 ,12 ,12 ,24 ,(char *) uc2_6715 },
	{ 0x6717 , 1 ,12 ,12 ,24 ,(char *) uc2_6717 },
	{ 0x671B , 1 ,12 ,12 ,24 ,(char *) uc2_671B },
	{ 0x671D , 1 ,12 ,12 ,24 ,(char *) uc2_671D },
	{ 0x671F , 1 ,12 ,12 ,24 ,(char *) uc2_671F },
	{ 0x6726 , 1 ,12 ,12 ,24 ,(char *) uc2_6726 },
	{ 0x6728 , 1 ,12 ,12 ,24 ,(char *) uc2_6728 },
	{ 0x672A , 1 ,12 ,12 ,24 ,(char *) uc2_672A },
	{ 0x672B , 1 ,12 ,12 ,24 ,(char *) uc2_672B },
	{ 0x672C , 1 ,12 ,12 ,24 ,(char *) uc2_672C },
	{ 0x672D , 1 ,12 ,12 ,24 ,(char *) uc2_672D },
	{ 0x672F , 1 ,12 ,12 ,24 ,(char *) uc2_672F },
	{ 0x6731 , 1 ,12 ,12 ,24 ,(char *) uc2_6731 },
	{ 0x6734 , 1 ,12 ,12 ,24 ,(char *) uc2_6734 },
	{ 0x6735 , 1 ,12 ,12 ,24 ,(char *) uc2_6735 },
	{ 0x673A , 1 ,12 ,12 ,24 ,(char *) uc2_673A },
	{ 0x673D , 1 ,12 ,12 ,24 ,(char *) uc2_673D },
	{ 0x6740 , 1 ,12 ,12 ,24 ,(char *) uc2_6740 },
	{ 0x6742 , 1 ,12 ,12 ,24 ,(char *) uc2_6742 },
	{ 0x6743 , 1 ,12 ,12 ,24 ,(char *) uc2_6743 },
	{ 0x6746 , 1 ,12 ,12 ,24 ,(char *) uc2_6746 },
	{ 0x6748 , 1 ,12 ,12 ,24 ,(char *) uc2_6748 },
	{ 0x6749 , 1 ,12 ,12 ,24 ,(char *) uc2_6749 },
	{ 0x674C , 1 ,12 ,12 ,24 ,(char *) uc2_674C },
	{ 0x674E , 1 ,12 ,12 ,24 ,(char *) uc2_674E },
	{ 0x674F , 1 ,12 ,12 ,24 ,(char *) uc2_674F },
	{ 0x6750 , 1 ,12 ,12 ,24 ,(char *) uc2_6750 },
	{ 0x6751 , 1 ,12 ,12 ,24 ,(char *) uc2_6751 },
	{ 0x6753 , 1 ,12 ,12 ,24 ,(char *) uc2_6753 },
	{ 0x6756 , 1 ,12 ,12 ,24 ,(char *) uc2_6756 },
	{ 0x675C , 1 ,12 ,12 ,24 ,(char *) uc2_675C },
	{ 0x675E , 1 ,12 ,12 ,24 ,(char *) uc2_675E },
	{ 0x675F , 1 ,12 ,12 ,24 ,(char *) uc2_675F },
	{ 0x6760 , 1 ,12 ,12 ,24 ,(char *) uc2_6760 },
	{ 0x6761 , 1 ,12 ,12 ,24 ,(char *) uc2_6761 },
	{ 0x6765 , 1 ,12 ,12 ,24 ,(char *) uc2_6765 },
	{ 0x6768 , 1 ,12 ,12 ,24 ,(char *) uc2_6768 },
	{ 0x6769 , 1 ,12 ,12 ,24 ,(char *) uc2_6769 },
	{ 0x676A , 1 ,12 ,12 ,24 ,(char *) uc2_676A },
	{ 0x676D , 1 ,12 ,12 ,24 ,(char *) uc2_676D },
	{ 0x676F , 1 ,12 ,12 ,24 ,(char *) uc2_676F },
	{ 0x6770 , 1 ,12 ,12 ,24 ,(char *) uc2_6770 },
	{ 0x6772 , 1 ,12 ,12 ,24 ,(char *) uc2_6772 },
	{ 0x6773 , 1 ,12 ,12 ,24 ,(char *) uc2_6773 },
	{ 0x6775 , 1 ,12 ,12 ,24 ,(char *) uc2_6775 },
	{ 0x6777 , 1 ,12 ,12 ,24 ,(char *) uc2_6777 },
	{ 0x677C , 1 ,12 ,12 ,24 ,(char *) uc2_677C },
	{ 0x677E , 1 ,12 ,12 ,24 ,(char *) uc2_677E },
	{ 0x677F , 1 ,12 ,12 ,24 ,(char *) uc2_677F },
	{ 0x6781 , 1 ,12 ,12 ,24 ,(char *) uc2_6781 },
	{ 0x6784 , 1 ,12 ,12 ,24 ,(char *) uc2_6784 },
	{ 0x6787 , 1 ,12 ,12 ,24 ,(char *) uc2_6787 },
	{ 0x6789 , 1 ,12 ,12 ,24 ,(char *) uc2_6789 },
	{ 0x678B , 1 ,12 ,12 ,24 ,(char *) uc2_678B },
	{ 0x6790 , 1 ,12 ,12 ,24 ,(char *) uc2_6790 },
	{ 0x6795 , 1 ,12 ,12 ,24 ,(char *) uc2_6795 },
	{ 0x6797 , 1 ,12 ,12 ,24 ,(char *) uc2_6797 },
	{ 0x6798 , 1 ,12 ,12 ,24 ,(char *) uc2_6798 },
	{ 0x679A , 1 ,12 ,12 ,24 ,(char *) uc2_679A },
	{ 0x679C , 1 ,12 ,12 ,24 ,(char *) uc2_679C },
	{ 0x679D , 1 ,12 ,12 ,24 ,(char *) uc2_679D },
	{ 0x679E , 1 ,12 ,12 ,24 ,(char *) uc2_679E },
	{ 0x67A2 , 1 ,12 ,12 ,24 ,(char *) uc2_67A2 },
	{ 0x67A3 , 1 ,12 ,12 ,24 ,(char *) uc2_67A3 },
	{ 0x67A5 , 1 ,12 ,12 ,24 ,(char *) uc2_67A5 },
	{ 0x67A7 , 1 ,12 ,12 ,24 ,(char *) uc2_67A7 },
	{ 0x67A8 , 1 ,12 ,12 ,24 ,(char *) uc2_67A8 },
	{ 0x67AA , 1 ,12 ,12 ,24 ,(char *) uc2_67AA },
	{ 0x67AB , 1 ,12 ,12 ,24 ,(char *) uc2_67AB },
	{ 0x67AD , 1 ,12 ,12 ,24 ,(char *) uc2_67AD },
	{ 0x67AF , 1 ,12 ,12 ,24 ,(char *) uc2_67AF },
	{ 0x67B0 , 1 ,12 ,12 ,24 ,(char *) uc2_67B0 },
	{ 0x67B3 , 1 ,12 ,12 ,24 ,(char *) uc2_67B3 },
	{ 0x67B5 , 1 ,12 ,12 ,24 ,(char *) uc2_67B5 },
	{ 0x67B6 , 1 ,12 ,12 ,24 ,(char *) uc2_67B6 },
	{ 0x67B7 , 1 ,12 ,12 ,24 ,(char *) uc2_67B7 },
	{ 0x67B8 , 1 ,12 ,12 ,24 ,(char *) uc2_67B8 },
	{ 0x67C1 , 1 ,12 ,12 ,24 ,(char *) uc2_67C1 },
	{ 0x67C3 , 1 ,12 ,12 ,24 ,(char *) uc2_67C3 },
	{ 0x67C4 , 1 ,12 ,12 ,24 ,(char *) uc2_67C4 },
	{ 0x67CF , 1 ,12 ,12 ,24 ,(char *) uc2_67CF },
	{ 0x67D0 , 1 ,12 ,12 ,24 ,(char *) uc2_67D0 },
	{ 0x67D1 , 1 ,12 ,12 ,24 ,(char *) uc2_67D1 },
	{ 0x67D2 , 1 ,12 ,12 ,24 ,(char *) uc2_67D2 },
	{ 0x67D3 , 1 ,12 ,12 ,24 ,(char *) uc2_67D3 },
	{ 0x67D4 , 1 ,12 ,12 ,24 ,(char *) uc2_67D4 },
	{ 0x67D8 , 1 ,12 ,12 ,24 ,(char *) uc2_67D8 },
	{ 0x67D9 , 1 ,12 ,12 ,24 ,(char *) uc2_67D9 },
	{ 0x67DA , 1 ,12 ,12 ,24 ,(char *) uc2_67DA },
	{ 0x67DC , 1 ,12 ,12 ,24 ,(char *) uc2_67DC },
	{ 0x67DD , 1 ,12 ,12 ,24 ,(char *) uc2_67DD },
	{ 0x67DE , 1 ,12 ,12 ,24 ,(char *) uc2_67DE },
	{ 0x67E0 , 1 ,12 ,12 ,24 ,(char *) uc2_67E0 },
	{ 0x67E2 , 1 ,12 ,12 ,24 ,(char *) uc2_67E2 },
	{ 0x67E5 , 1 ,12 ,12 ,24 ,(char *) uc2_67E5 },
	{ 0x67E9 , 1 ,12 ,12 ,24 ,(char *) uc2_67E9 },
	{ 0x67EC , 1 ,12 ,12 ,24 ,(char *) uc2_67EC },
	{ 0x67EE , 1 ,12 ,12 ,24 ,(char *) uc2_67EE },
	{ 0x67EF , 1 ,12 ,12 ,24 ,(char *) uc2_67EF },
	{ 0x67F0 , 1 ,12 ,12 ,24 ,(char *) uc2_67F0 },
	{ 0x67F1 , 1 ,12 ,12 ,24 ,(char *) uc2_67F1 },
	{ 0x67F3 , 1 ,12 ,12 ,24 ,(char *) uc2_67F3 },
	{ 0x67F4 , 1 ,12 ,12 ,24 ,(char *) uc2_67F4 },
	{ 0x67FD , 1 ,12 ,12 ,24 ,(char *) uc2_67FD },
	{ 0x67FF , 1 ,12 ,12 ,24 ,(char *) uc2_67FF },
	{ 0x6800 , 1 ,12 ,12 ,24 ,(char *) uc2_6800 },
	{ 0x6805 , 1 ,12 ,12 ,24 ,(char *) uc2_6805 },
	{ 0x6807 , 1 ,12 ,12 ,24 ,(char *) uc2_6807 },
	{ 0x6808 , 1 ,12 ,12 ,24 ,(char *) uc2_6808 },
	{ 0x6809 , 1 ,12 ,12 ,24 ,(char *) uc2_6809 },
	{ 0x680A , 1 ,12 ,12 ,24 ,(char *) uc2_680A },
	{ 0x680B , 1 ,12 ,12 ,24 ,(char *) uc2_680B },
	{ 0x680C , 1 ,12 ,12 ,24 ,(char *) uc2_680C },
	{ 0x680E , 1 ,12 ,12 ,24 ,(char *) uc2_680E },
	{ 0x680F , 1 ,12 ,12 ,24 ,(char *) uc2_680F },
	{ 0x6811 , 1 ,12 ,12 ,24 ,(char *) uc2_6811 },
	{ 0x6813 , 1 ,12 ,12 ,24 ,(char *) uc2_6813 },
	{ 0x6816 , 1 ,12 ,12 ,24 ,(char *) uc2_6816 },
	{ 0x6817 , 1 ,12 ,12 ,24 ,(char *) uc2_6817 },
	{ 0x681D , 1 ,12 ,12 ,24 ,(char *) uc2_681D },
	{ 0x6821 , 1 ,12 ,12 ,24 ,(char *) uc2_6821 },
	{ 0x6829 , 1 ,12 ,12 ,24 ,(char *) uc2_6829 },
	{ 0x682A , 1 ,12 ,12 ,24 ,(char *) uc2_682A },
	{ 0x6832 , 1 ,12 ,12 ,24 ,(char *) uc2_6832 },
	{ 0x6833 , 1 ,12 ,12 ,24 ,(char *) uc2_6833 },
	{ 0x6837 , 1 ,12 ,12 ,24 ,(char *) uc2_6837 },
	{ 0x6838 , 1 ,12 ,12 ,24 ,(char *) uc2_6838 },
	{ 0x6839 , 1 ,12 ,12 ,24 ,(char *) uc2_6839 },
	{ 0x683C , 1 ,12 ,12 ,24 ,(char *) uc2_683C },
	{ 0x683D , 1 ,12 ,12 ,24 ,(char *) uc2_683D },
	{ 0x683E , 1 ,12 ,12 ,24 ,(char *) uc2_683E },
	{ 0x6840 , 1 ,12 ,12 ,24 ,(char *) uc2_6840 },
	{ 0x6841 , 1 ,12 ,12 ,24 ,(char *) uc2_6841 },
	{ 0x6842 , 1 ,12 ,12 ,24 ,(char *) uc2_6842 },
	{ 0x6843 , 1 ,12 ,12 ,24 ,(char *) uc2_6843 },
	{ 0x6844 , 1 ,12 ,12 ,24 ,(char *) uc2_6844 },
	{ 0x6845 , 1 ,12 ,12 ,24 ,(char *) uc2_6845 },
	{ 0x6846 , 1 ,12 ,12 ,24 ,(char *) uc2_6846 },
	{ 0x6848 , 1 ,12 ,12 ,24 ,(char *) uc2_6848 },
	{ 0x6849 , 1 ,12 ,12 ,24 ,(char *) uc2_6849 },
	{ 0x684A , 1 ,12 ,12 ,24 ,(char *) uc2_684A },
	{ 0x684C , 1 ,12 ,12 ,24 ,(char *) uc2_684C },
	{ 0x684E , 1 ,12 ,12 ,24 ,(char *) uc2_684E },
	{ 0x6850 , 1 ,12 ,12 ,24 ,(char *) uc2_6850 },
	{ 0x6851 , 1 ,12 ,12 ,24 ,(char *) uc2_6851 },
	{ 0x6853 , 1 ,12 ,12 ,24 ,(char *) uc2_6853 },
	{ 0x6854 , 1 ,12 ,12 ,24 ,(char *) uc2_6854 },
	{ 0x6855 , 1 ,12 ,12 ,24 ,(char *) uc2_6855 },
	{ 0x6860 , 1 ,12 ,12 ,24 ,(char *) uc2_6860 },
	{ 0x6861 , 1 ,12 ,12 ,24 ,(char *) uc2_6861 },
	{ 0x6862 , 1 ,12 ,12 ,24 ,(char *) uc2_6862 },
	{ 0x6863 , 1 ,12 ,12 ,24 ,(char *) uc2_6863 },
	{ 0x6864 , 1 ,12 ,12 ,24 ,(char *) uc2_6864 },
	{ 0x6865 , 1 ,12 ,12 ,24 ,(char *) uc2_6865 },
	{ 0x6866 , 1 ,12 ,12 ,24 ,(char *) uc2_6866 },
	{ 0x6867 , 1 ,12 ,12 ,24 ,(char *) uc2_6867 },
	{ 0x6868 , 1 ,12 ,12 ,24 ,(char *) uc2_6868 },
	{ 0x6869 , 1 ,12 ,12 ,24 ,(char *) uc2_6869 },
	{ 0x686B , 1 ,12 ,12 ,24 ,(char *) uc2_686B },
	{ 0x6874 , 1 ,12 ,12 ,24 ,(char *) uc2_6874 },
	{ 0x6876 , 1 ,12 ,12 ,24 ,(char *) uc2_6876 },
	{ 0x6877 , 1 ,12 ,12 ,24 ,(char *) uc2_6877 },
	{ 0x6881 , 1 ,12 ,12 ,24 ,(char *) uc2_6881 },
	{ 0x6883 , 1 ,12 ,12 ,24 ,(char *) uc2_6883 },
	{ 0x6885 , 1 ,12 ,12 ,24 ,(char *) uc2_6885 },
	{ 0x6886 , 1 ,12 ,12 ,24 ,(char *) uc2_6886 },
	{ 0x688F , 1 ,12 ,12 ,24 ,(char *) uc2_688F },
	{ 0x6893 , 1 ,12 ,12 ,24 ,(char *) uc2_6893 },
	{ 0x6897 , 1 ,12 ,12 ,24 ,(char *) uc2_6897 },
	{ 0x68A2 , 1 ,12 ,12 ,24 ,(char *) uc2_68A2 },
	{ 0x68A6 , 1 ,12 ,12 ,24 ,(char *) uc2_68A6 },
	{ 0x68A7 , 1 ,12 ,12 ,24 ,(char *) uc2_68A7 },
	{ 0x68A8 , 1 ,12 ,12 ,24 ,(char *) uc2_68A8 },
	{ 0x68AD , 1 ,12 ,12 ,24 ,(char *) uc2_68AD },
	{ 0x68AF , 1 ,12 ,12 ,24 ,(char *) uc2_68AF },
	{ 0x68B0 , 1 ,12 ,12 ,24 ,(char *) uc2_68B0 },
	{ 0x68B3 , 1 ,12 ,12 ,24 ,(char *) uc2_68B3 },
	{ 0x68B5 , 1 ,12 ,12 ,24 ,(char *) uc2_68B5 },
	{ 0x68C0 , 1 ,12 ,12 ,24 ,(char *) uc2_68C0 },
	{ 0x68C2 , 1 ,12 ,12 ,24 ,(char *) uc2_68C2 },
	{ 0x68C9 , 1 ,12 ,12 ,24 ,(char *) uc2_68C9 },
	{ 0x68CB , 1 ,12 ,12 ,24 ,(char *) uc2_68CB },
	{ 0x68CD , 1 ,12 ,12 ,24 ,(char *) uc2_68CD },
	{ 0x68D2 , 1 ,12 ,12 ,24 ,(char *) uc2_68D2 },
	{ 0x68D5 , 1 ,12 ,12 ,24 ,(char *) uc2_68D5 },
	{ 0x68D8 , 1 ,12 ,12 ,24 ,(char *) uc2_68D8 },
	{ 0x68DA , 1 ,12 ,12 ,24 ,(char *) uc2_68DA },
	{ 0x68E0 , 1 ,12 ,12 ,24 ,(char *) uc2_68E0 },
	{ 0x68E3 , 1 ,12 ,12 ,24 ,(char *) uc2_68E3 },
	{ 0x68EE , 1 ,12 ,12 ,24 ,(char *) uc2_68EE },
	{ 0x68F0 , 1 ,12 ,12 ,24 ,(char *) uc2_68F0 },
	{ 0x68F1 , 1 ,12 ,12 ,24 ,(char *) uc2_68F1 },
	{ 0x68F5 , 1 ,12 ,12 ,24 ,(char *) uc2_68F5 },
	{ 0x68F9 , 1 ,12 ,12 ,24 ,(char *) uc2_68F9 },
	{ 0x68FA , 1 ,12 ,12 ,24 ,(char *) uc2_68FA },
	{ 0x68FC , 1 ,12 ,12 ,24 ,(char *) uc2_68FC },
	{ 0x6901 , 1 ,12 ,12 ,24 ,(char *) uc2_6901 },
	{ 0x6905 , 1 ,12 ,12 ,24 ,(char *) uc2_6905 },
	{ 0x690B , 1 ,12 ,12 ,24 ,(char *) uc2_690B },
	{ 0x690D , 1 ,12 ,12 ,24 ,(char *) uc2_690D },
	{ 0x690E , 1 ,12 ,12 ,24 ,(char *) uc2_690E },
	{ 0x6910 , 1 ,12 ,12 ,24 ,(char *) uc2_6910 },
	{ 0x6912 , 1 ,12 ,12 ,24 ,(char *) uc2_6912 },
	{ 0x691F , 1 ,12 ,12 ,24 ,(char *) uc2_691F },
	{ 0x6920 , 1 ,12 ,12 ,24 ,(char *) uc2_6920 },
	{ 0x6924 , 1 ,12 ,12 ,24 ,(char *) uc2_6924 },
	{ 0x692D , 1 ,12 ,12 ,24 ,(char *) uc2_692D },
	{ 0x6930 , 1 ,12 ,12 ,24 ,(char *) uc2_6930 },
	{ 0x6934 , 1 ,12 ,12 ,24 ,(char *) uc2_6934 },
	{ 0x6939 , 1 ,12 ,12 ,24 ,(char *) uc2_6939 },
	{ 0x693D , 1 ,12 ,12 ,24 ,(char *) uc2_693D },
	{ 0x693F , 1 ,12 ,12 ,24 ,(char *) uc2_693F },
	{ 0x6942 , 1 ,12 ,12 ,24 ,(char *) uc2_6942 },
	{ 0x6954 , 1 ,12 ,12 ,24 ,(char *) uc2_6954 },
	{ 0x6957 , 1 ,12 ,12 ,24 ,(char *) uc2_6957 },
	{ 0x695A , 1 ,12 ,12 ,24 ,(char *) uc2_695A },
	{ 0x695D , 1 ,12 ,12 ,24 ,(char *) uc2_695D },
	{ 0x695E , 1 ,12 ,12 ,24 ,(char *) uc2_695E },
	{ 0x6960 , 1 ,12 ,12 ,24 ,(char *) uc2_6960 },
	{ 0x6963 , 1 ,12 ,12 ,24 ,(char *) uc2_6963 },
	{ 0x6966 , 1 ,12 ,12 ,24 ,(char *) uc2_6966 },
	{ 0x696B , 1 ,12 ,12 ,24 ,(char *) uc2_696B },
	{ 0x696E , 1 ,12 ,12 ,24 ,(char *) uc2_696E },
	{ 0x6971 , 1 ,12 ,12 ,24 ,(char *) uc2_6971 },
	{ 0x6977 , 1 ,12 ,12 ,24 ,(char *) uc2_6977 },
	{ 0x6978 , 1 ,12 ,12 ,24 ,(char *) uc2_6978 },
	{ 0x6979 , 1 ,12 ,12 ,24 ,(char *) uc2_6979 },
	{ 0x697C , 1 ,12 ,12 ,24 ,(char *) uc2_697C },
	{ 0x6980 , 1 ,12 ,12 ,24 ,(char *) uc2_6980 },
	{ 0x6982 , 1 ,12 ,12 ,24 ,(char *) uc2_6982 },
	{ 0x6984 , 1 ,12 ,12 ,24 ,(char *) uc2_6984 },
	{ 0x6986 , 1 ,12 ,12 ,24 ,(char *) uc2_6986 },
	{ 0x6987 , 1 ,12 ,12 ,24 ,(char *) uc2_6987 },
	{ 0x6988 , 1 ,12 ,12 ,24 ,(char *) uc2_6988 },
	{ 0x6989 , 1 ,12 ,12 ,24 ,(char *) uc2_6989 },
	{ 0x698D , 1 ,12 ,12 ,24 ,(char *) uc2_698D },
	{ 0x6994 , 1 ,12 ,12 ,24 ,(char *) uc2_6994 },
	{ 0x6995 , 1 ,12 ,12 ,24 ,(char *) uc2_6995 },
	{ 0x6998 , 1 ,12 ,12 ,24 ,(char *) uc2_6998 },
	{ 0x699B , 1 ,12 ,12 ,24 ,(char *) uc2_699B },
	{ 0x699C , 1 ,12 ,12 ,24 ,(char *) uc2_699C },
	{ 0x69A7 , 1 ,12 ,12 ,24 ,(char *) uc2_69A7 },
	{ 0x69A8 , 1 ,12 ,12 ,24 ,(char *) uc2_69A8 },
	{ 0x69AB , 1 ,12 ,12 ,24 ,(char *) uc2_69AB },
	{ 0x69AD , 1 ,12 ,12 ,24 ,(char *) uc2_69AD },
	{ 0x69B1 , 1 ,12 ,12 ,24 ,(char *) uc2_69B1 },
	{ 0x69B4 , 1 ,12 ,12 ,24 ,(char *) uc2_69B4 },
	{ 0x69B7 , 1 ,12 ,12 ,24 ,(char *) uc2_69B7 },
	{ 0x69BB , 1 ,12 ,12 ,24 ,(char *) uc2_69BB },
	{ 0x69C1 , 1 ,12 ,12 ,24 ,(char *) uc2_69C1 },
	{ 0x69CA , 1 ,12 ,12 ,24 ,(char *) uc2_69CA },
	{ 0x69CC , 1 ,12 ,12 ,24 ,(char *) uc2_69CC },
	{ 0x69CE , 1 ,12 ,12 ,24 ,(char *) uc2_69CE },
	{ 0x69D0 , 1 ,12 ,12 ,24 ,(char *) uc2_69D0 },
	{ 0x69D4 , 1 ,12 ,12 ,24 ,(char *) uc2_69D4 },
	{ 0x69DB , 1 ,12 ,12 ,24 ,(char *) uc2_69DB },
	{ 0x69DF , 1 ,12 ,12 ,24 ,(char *) uc2_69DF },
	{ 0x69E0 , 1 ,12 ,12 ,24 ,(char *) uc2_69E0 },
	{ 0x69ED , 1 ,12 ,12 ,24 ,(char *) uc2_69ED },
	{ 0x69F2 , 1 ,12 ,12 ,24 ,(char *) uc2_69F2 },
	{ 0x69FD , 1 ,12 ,12 ,24 ,(char *) uc2_69FD },
	{ 0x69FF , 1 ,12 ,12 ,24 ,(char *) uc2_69FF },
	{ 0x6A0A , 1 ,12 ,12 ,24 ,(char *) uc2_6A0A },
	{ 0x6A17 , 1 ,12 ,12 ,24 ,(char *) uc2_6A17 },
	{ 0x6A18 , 1 ,12 ,12 ,24 ,(char *) uc2_6A18 },
	{ 0x6A1F , 1 ,12 ,12 ,24 ,(char *) uc2_6A1F },
	{ 0x6A21 , 1 ,12 ,12 ,24 ,(char *) uc2_6A21 },
	{ 0x6A28 , 1 ,12 ,12 ,24 ,(char *) uc2_6A28 },
	{ 0x6A2A , 1 ,12 ,12 ,24 ,(char *) uc2_6A2A },
	{ 0x6A2F , 1 ,12 ,12 ,24 ,(char *) uc2_6A2F },
	{ 0x6A31 , 1 ,12 ,12 ,24 ,(char *) uc2_6A31 },
	{ 0x6A35 , 1 ,12 ,12 ,24 ,(char *) uc2_6A35 },
	{ 0x6A3D , 1 ,12 ,12 ,24 ,(char *) uc2_6A3D },
	{ 0x6A3E , 1 ,12 ,12 ,24 ,(char *) uc2_6A3E },
	{ 0x6A44 , 1 ,12 ,12 ,24 ,(char *) uc2_6A44 },
	{ 0x6A47 , 1 ,12 ,12 ,24 ,(char *) uc2_6A47 },
	{ 0x6A50 , 1 ,12 ,12 ,24 ,(char *) uc2_6A50 },
	{ 0x6A58 , 1 ,12 ,12 ,24 ,(char *) uc2_6A58 },
	{ 0x6A59 , 1 ,12 ,12 ,24 ,(char *) uc2_6A59 },
	{ 0x6A5B , 1 ,12 ,12 ,24 ,(char *) uc2_6A5B },
	{ 0x6A61 , 1 ,12 ,12 ,24 ,(char *) uc2_6A61 },
	{ 0x6A65 , 1 ,12 ,12 ,24 ,(char *) uc2_6A65 },
	{ 0x6A71 , 1 ,12 ,12 ,24 ,(char *) uc2_6A71 },
	{ 0x6A79 , 1 ,12 ,12 ,24 ,(char *) uc2_6A79 },
	{ 0x6A7C , 1 ,12 ,12 ,24 ,(char *) uc2_6A7C },
	{ 0x6A80 , 1 ,12 ,12 ,24 ,(char *) uc2_6A80 },
	{ 0x6A84 , 1 ,12 ,12 ,24 ,(char *) uc2_6A84 },
	{ 0x6A8E , 1 ,12 ,12 ,24 ,(char *) uc2_6A8E },
	{ 0x6A90 , 1 ,12 ,12 ,24 ,(char *) uc2_6A90 },
	{ 0x6A91 , 1 ,12 ,12 ,24 ,(char *) uc2_6A91 },
	{ 0x6A97 , 1 ,12 ,12 ,24 ,(char *) uc2_6A97 },
	{ 0x6AA0 , 1 ,12 ,12 ,24 ,(char *) uc2_6AA0 },
	{ 0x6AA9 , 1 ,12 ,12 ,24 ,(char *) uc2_6AA9 },
	{ 0x6AAB , 1 ,12 ,12 ,24 ,(char *) uc2_6AAB },
	{ 0x6AAC , 1 ,12 ,12 ,24 ,(char *) uc2_6AAC },
	{ 0x6B20 , 1 ,12 ,12 ,24 ,(char *) uc2_6B20 },
	{ 0x6B21 , 1 ,12 ,12 ,24 ,(char *) uc2_6B21 },
	{ 0x6B22 , 1 ,12 ,12 ,24 ,(char *) uc2_6B22 },
	{ 0x6B23 , 1 ,12 ,12 ,24 ,(char *) uc2_6B23 },
	{ 0x6B24 , 1 ,12 ,12 ,24 ,(char *) uc2_6B24 },
	{ 0x6B27 , 1 ,12 ,12 ,24 ,(char *) uc2_6B27 },
	{ 0x6B32 , 1 ,12 ,12 ,24 ,(char *) uc2_6B32 },
	{ 0x6B37 , 1 ,12 ,12 ,24 ,(char *) uc2_6B37 },
	{ 0x6B39 , 1 ,12 ,12 ,24 ,(char *) uc2_6B39 },
	{ 0x6B3A , 1 ,12 ,12 ,24 ,(char *) uc2_6B3A },
	{ 0x6B3E , 1 ,12 ,12 ,24 ,(char *) uc2_6B3E },
	{ 0x6B43 , 1 ,12 ,12 ,24 ,(char *) uc2_6B43 },
	{ 0x6B46 , 1 ,12 ,12 ,24 ,(char *) uc2_6B46 },
	{ 0x6B47 , 1 ,12 ,12 ,24 ,(char *) uc2_6B47 },
	{ 0x6B49 , 1 ,12 ,12 ,24 ,(char *) uc2_6B49 },
	{ 0x6B4C , 1 ,12 ,12 ,24 ,(char *) uc2_6B4C },
	{ 0x6B59 , 1 ,12 ,12 ,24 ,(char *) uc2_6B59 },
	{ 0x6B62 , 1 ,12 ,12 ,24 ,(char *) uc2_6B62 },
	{ 0x6B63 , 1 ,12 ,12 ,24 ,(char *) uc2_6B63 },
	{ 0x6B64 , 1 ,12 ,12 ,24 ,(char *) uc2_6B64 },
	{ 0x6B65 , 1 ,12 ,12 ,24 ,(char *) uc2_6B65 },
	{ 0x6B66 , 1 ,12 ,12 ,24 ,(char *) uc2_6B66 },
	{ 0x6B67 , 1 ,12 ,12 ,24 ,(char *) uc2_6B67 },
	{ 0x6B6A , 1 ,12 ,12 ,24 ,(char *) uc2_6B6A },
	{ 0x6B79 , 1 ,12 ,12 ,24 ,(char *) uc2_6B79 },
	{ 0x6B7B , 1 ,12 ,12 ,24 ,(char *) uc2_6B7B },
	{ 0x6B7C , 1 ,12 ,12 ,24 ,(char *) uc2_6B7C },
	{ 0x6B81 , 1 ,12 ,12 ,24 ,(char *) uc2_6B81 },
	{ 0x6B82 , 1 ,12 ,12 ,24 ,(char *) uc2_6B82 },
	{ 0x6B83 , 1 ,12 ,12 ,24 ,(char *) uc2_6B83 },
	{ 0x6B84 , 1 ,12 ,12 ,24 ,(char *) uc2_6B84 },
	{ 0x6B86 , 1 ,12 ,12 ,24 ,(char *) uc2_6B86 },
	{ 0x6B87 , 1 ,12 ,12 ,24 ,(char *) uc2_6B87 },
	{ 0x6B89 , 1 ,12 ,12 ,24 ,(char *) uc2_6B89 },
	{ 0x6B8A , 1 ,12 ,12 ,24 ,(char *) uc2_6B8A },
	{ 0x6B8B , 1 ,12 ,12 ,24 ,(char *) uc2_6B8B },
	{ 0x6B8D , 1 ,12 ,12 ,24 ,(char *) uc2_6B8D },
	{ 0x6B92 , 1 ,12 ,12 ,24 ,(char *) uc2_6B92 },
	{ 0x6B93 , 1 ,12 ,12 ,24 ,(char *) uc2_6B93 },
	{ 0x6B96 , 1 ,12 ,12 ,24 ,(char *) uc2_6B96 },
	{ 0x6B9A , 1 ,12 ,12 ,24 ,(char *) uc2_6B9A },
	{ 0x6B9B , 1 ,12 ,12 ,24 ,(char *) uc2_6B9B },
	{ 0x6BA1 , 1 ,12 ,12 ,24 ,(char *) uc2_6BA1 },
	{ 0x6BAA , 1 ,12 ,12 ,24 ,(char *) uc2_6BAA },
	{ 0x6BB3 , 1 ,12 ,12 ,24 ,(char *) uc2_6BB3 },
	{ 0x6BB4 , 1 ,12 ,12 ,24 ,(char *) uc2_6BB4 },
	{ 0x6BB5 , 1 ,12 ,12 ,24 ,(char *) uc2_6BB5 },
	{ 0x6BB7 , 1 ,12 ,12 ,24 ,(char *) uc2_6BB7 },
	{ 0x6BBF , 1 ,12 ,12 ,24 ,(char *) uc2_6BBF },
	{ 0x6BC1 , 1 ,12 ,12 ,24 ,(char *) uc2_6BC1 },
	{ 0x6BC2 , 1 ,12 ,12 ,24 ,(char *) uc2_6BC2 },
	{ 0x6BC5 , 1 ,12 ,12 ,24 ,(char *) uc2_6BC5 },
	{ 0x6BCB , 1 ,12 ,12 ,24 ,(char *) uc2_6BCB },
	{ 0x6BCD , 1 ,12 ,12 ,24 ,(char *) uc2_6BCD },
	{ 0x6BCF , 1 ,12 ,12 ,24 ,(char *) uc2_6BCF },
	{ 0x6BD2 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD2 },
	{ 0x6BD3 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD3 },
	{ 0x6BD4 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD4 },
	{ 0x6BD5 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD5 },
	{ 0x6BD6 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD6 },
	{ 0x6BD7 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD7 },
	{ 0x6BD9 , 1 ,12 ,12 ,24 ,(char *) uc2_6BD9 },
	{ 0x6BDB , 1 ,12 ,12 ,24 ,(char *) uc2_6BDB },
	{ 0x6BE1 , 1 ,12 ,12 ,24 ,(char *) uc2_6BE1 },
	{ 0x6BEA , 1 ,12 ,12 ,24 ,(char *) uc2_6BEA },
	{ 0x6BEB , 1 ,12 ,12 ,24 ,(char *) uc2_6BEB },
	{ 0x6BEF , 1 ,12 ,12 ,24 ,(char *) uc2_6BEF },
	{ 0x6BF3 , 1 ,12 ,12 ,24 ,(char *) uc2_6BF3 },
	{ 0x6BF5 , 1 ,12 ,12 ,24 ,(char *) uc2_6BF5 },
	{ 0x6BF9 , 1 ,12 ,12 ,24 ,(char *) uc2_6BF9 },
	{ 0x6BFD , 1 ,12 ,12 ,24 ,(char *) uc2_6BFD },
	{ 0x6C05 , 1 ,12 ,12 ,24 ,(char *) uc2_6C05 },
	{ 0x6C06 , 1 ,12 ,12 ,24 ,(char *) uc2_6C06 },
	{ 0x6C07 , 1 ,12 ,12 ,24 ,(char *) uc2_6C07 },
	{ 0x6C0D , 1 ,12 ,12 ,24 ,(char *) uc2_6C0D },
	{ 0x6C0F , 1 ,12 ,12 ,24 ,(char *) uc2_6C0F },
	{ 0x6C10 , 1 ,12 ,12 ,24 ,(char *) uc2_6C10 },
	{ 0x6C11 , 1 ,12 ,12 ,24 ,(char *) uc2_6C11 },
	{ 0x6C13 , 1 ,12 ,12 ,24 ,(char *) uc2_6C13 },
	{ 0x6C14 , 1 ,12 ,12 ,24 ,(char *) uc2_6C14 },
	{ 0x6C15 , 1 ,12 ,12 ,24 ,(char *) uc2_6C15 },
	{ 0x6C16 , 1 ,12 ,12 ,24 ,(char *) uc2_6C16 },
	{ 0x6C18 , 1 ,12 ,12 ,24 ,(char *) uc2_6C18 },
	{ 0x6C19 , 1 ,12 ,12 ,24 ,(char *) uc2_6C19 },
	{ 0x6C1A , 1 ,12 ,12 ,24 ,(char *) uc2_6C1A },
	{ 0x6C1B , 1 ,12 ,12 ,24 ,(char *) uc2_6C1B },
	{ 0x6C1F , 1 ,12 ,12 ,24 ,(char *) uc2_6C1F },
	{ 0x6C21 , 1 ,12 ,12 ,24 ,(char *) uc2_6C21 },
	{ 0x6C22 , 1 ,12 ,12 ,24 ,(char *) uc2_6C22 },
	{ 0x6C24 , 1 ,12 ,12 ,24 ,(char *) uc2_6C24 },
	{ 0x6C26 , 1 ,12 ,12 ,24 ,(char *) uc2_6C26 },
	{ 0x6C27 , 1 ,12 ,12 ,24 ,(char *) uc2_6C27 },
	{ 0x6C28 , 1 ,12 ,12 ,24 ,(char *) uc2_6C28 },
	{ 0x6C29 , 1 ,12 ,12 ,24 ,(char *) uc2_6C29 },
	{ 0x6C2A , 1 ,12 ,12 ,24 ,(char *) uc2_6C2A },
	{ 0x6C2E , 1 ,12 ,12 ,24 ,(char *) uc2_6C2E },
	{ 0x6C2F , 1 ,12 ,12 ,24 ,(char *) uc2_6C2F },
	{ 0x6C30 , 1 ,12 ,12 ,24 ,(char *) uc2_6C30 },
	{ 0x6C32 , 1 ,12 ,12 ,24 ,(char *) uc2_6C32 },
	{ 0x6C34 , 1 ,12 ,12 ,24 ,(char *) uc2_6C34 },
	{ 0x6C35 , 1 ,12 ,12 ,24 ,(char *) uc2_6C35 },/*SPR 1299*/
	{ 0x6C38 , 1 ,12 ,12 ,24 ,(char *) uc2_6C38 },
	{ 0x6C3D , 1 ,12 ,12 ,24 ,(char *) uc2_6C3D },
	{ 0x6C40 , 1 ,12 ,12 ,24 ,(char *) uc2_6C40 },
	{ 0x6C41 , 1 ,12 ,12 ,24 ,(char *) uc2_6C41 },
	{ 0x6C42 , 1 ,12 ,12 ,24 ,(char *) uc2_6C42 },
	{ 0x6C46 , 1 ,12 ,12 ,24 ,(char *) uc2_6C46 },
	{ 0x6C47 , 1 ,12 ,12 ,24 ,(char *) uc2_6C47 },
	{ 0x6C49 , 1 ,12 ,12 ,24 ,(char *) uc2_6C49 },
	{ 0x6C4A , 1 ,12 ,12 ,24 ,(char *) uc2_6C4A },
	{ 0x6C50 , 1 ,12 ,12 ,24 ,(char *) uc2_6C50 },
	{ 0x6C54 , 1 ,12 ,12 ,24 ,(char *) uc2_6C54 },
	{ 0x6C55 , 1 ,12 ,12 ,24 ,(char *) uc2_6C55 },
	{ 0x6C57 , 1 ,12 ,12 ,24 ,(char *) uc2_6C57 },
	{ 0x6C5B , 1 ,12 ,12 ,24 ,(char *) uc2_6C5B },
	{ 0x6C5C , 1 ,12 ,12 ,24 ,(char *) uc2_6C5C },
	{ 0x6C5D , 1 ,12 ,12 ,24 ,(char *) uc2_6C5D },
	{ 0x6C5E , 1 ,12 ,12 ,24 ,(char *) uc2_6C5E },
	{ 0x6C5F , 1 ,12 ,12 ,24 ,(char *) uc2_6C5F },
	{ 0x6C60 , 1 ,12 ,12 ,24 ,(char *) uc2_6C60 },
	{ 0x6C61 , 1 ,12 ,12 ,24 ,(char *) uc2_6C61 },
	{ 0x6C64 , 1 ,12 ,12 ,24 ,(char *) uc2_6C64 },
	{ 0x6C68 , 1 ,12 ,12 ,24 ,(char *) uc2_6C68 },
	{ 0x6C69 , 1 ,12 ,12 ,24 ,(char *) uc2_6C69 },
	{ 0x6C6A , 1 ,12 ,12 ,24 ,(char *) uc2_6C6A },
	{ 0x6C70 , 1 ,12 ,12 ,24 ,(char *) uc2_6C70 },
	{ 0x6C72 , 1 ,12 ,12 ,24 ,(char *) uc2_6C72 },
	{ 0x6C74 , 1 ,12 ,12 ,24 ,(char *) uc2_6C74 },
	{ 0x6C76 , 1 ,12 ,12 ,24 ,(char *) uc2_6C76 },
	{ 0x6C79 , 1 ,12 ,12 ,24 ,(char *) uc2_6C79 },
	{ 0x6C7D , 1 ,12 ,12 ,24 ,(char *) uc2_6C7D },
	{ 0x6C7E , 1 ,12 ,12 ,24 ,(char *) uc2_6C7E },
	{ 0x6C81 , 1 ,12 ,12 ,24 ,(char *) uc2_6C81 },
	{ 0x6C82 , 1 ,12 ,12 ,24 ,(char *) uc2_6C82 },
	{ 0x6C83 , 1 ,12 ,12 ,24 ,(char *) uc2_6C83 },
	{ 0x6C85 , 1 ,12 ,12 ,24 ,(char *) uc2_6C85 },
	{ 0x6C86 , 1 ,12 ,12 ,24 ,(char *) uc2_6C86 },
	{ 0x6C88 , 1 ,12 ,12 ,24 ,(char *) uc2_6C88 },
	{ 0x6C89 , 1 ,12 ,12 ,24 ,(char *) uc2_6C89 },
	{ 0x6C8C , 1 ,12 ,12 ,24 ,(char *) uc2_6C8C },
	{ 0x6C8F , 1 ,12 ,12 ,24 ,(char *) uc2_6C8F },
	{ 0x6C90 , 1 ,12 ,12 ,24 ,(char *) uc2_6C90 },
	{ 0x6C92 , 1 ,12 ,12 ,24 ,(char *) uc2_6C92 },
	{ 0x6C93 , 1 ,12 ,12 ,24 ,(char *) uc2_6C93 },
	{ 0x6C94 , 1 ,12 ,12 ,24 ,(char *) uc2_6C94 },
	{ 0x6C99 , 1 ,12 ,12 ,24 ,(char *) uc2_6C99 },
	{ 0x6C9B , 1 ,12 ,12 ,24 ,(char *) uc2_6C9B },
	{ 0x6C9F , 1 ,12 ,12 ,24 ,(char *) uc2_6C9F },
	{ 0x6CA1 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA1 },
	{ 0x6CA3 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA3 },
	{ 0x6CA4 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA4 },
	{ 0x6CA5 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA5 },
	{ 0x6CA6 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA6 },
	{ 0x6CA7 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA7 },
	{ 0x6CA9 , 1 ,12 ,12 ,24 ,(char *) uc2_6CA9 },
	{ 0x6CAA , 1 ,12 ,12 ,24 ,(char *) uc2_6CAA },
	{ 0x6CAB , 1 ,12 ,12 ,24 ,(char *) uc2_6CAB },
	{ 0x6CAD , 1 ,12 ,12 ,24 ,(char *) uc2_6CAD },
	{ 0x6CAE , 1 ,12 ,12 ,24 ,(char *) uc2_6CAE },
	{ 0x6CB1 , 1 ,12 ,12 ,24 ,(char *) uc2_6CB1 },
	{ 0x6CB2 , 1 ,12 ,12 ,24 ,(char *) uc2_6CB2 },
	{ 0x6CB3 , 1 ,12 ,12 ,24 ,(char *) uc2_6CB3 },
	{ 0x6CB8 , 1 ,12 ,12 ,24 ,(char *) uc2_6CB8 },
	{ 0x6CB9 , 1 ,12 ,12 ,24 ,(char *) uc2_6CB9 },
	{ 0x6CBB , 1 ,12 ,12 ,24 ,(char *) uc2_6CBB },
	{ 0x6CBC , 1 ,12 ,12 ,24 ,(char *) uc2_6CBC },
	{ 0x6CBD , 1 ,12 ,12 ,24 ,(char *) uc2_6CBD },
	{ 0x6CBE , 1 ,12 ,12 ,24 ,(char *) uc2_6CBE },
	{ 0x6CBF , 1 ,12 ,12 ,24 ,(char *) uc2_6CBF },
	{ 0x6CC4 , 1 ,12 ,12 ,24 ,(char *) uc2_6CC4 },
	{ 0x6CC5 , 1 ,12 ,12 ,24 ,(char *) uc2_6CC5 },
	{ 0x6CC9 , 1 ,12 ,12 ,24 ,(char *) uc2_6CC9 },
	{ 0x6CCA , 1 ,12 ,12 ,24 ,(char *) uc2_6CCA },
	{ 0x6CCC , 1 ,12 ,12 ,24 ,(char *) uc2_6CCC },
	{ 0x6CD0 , 1 ,12 ,12 ,24 ,(char *) uc2_6CD0 },
	{ 0x6CD3 , 1 ,12 ,12 ,24 ,(char *) uc2_6CD3 },
	{ 0x6CD4 , 1 ,12 ,12 ,24 ,(char *) uc2_6CD4 },
	{ 0x6CD5 , 1 ,12 ,12 ,24 ,(char *) uc2_6CD5 },
	{ 0x6CD6 , 1 ,12 ,12 ,24 ,(char *) uc2_6CD6 },
	{ 0x6CD7 , 1 ,12 ,12 ,24 ,(char *) uc2_6CD7 },
	{ 0x6CDB , 1 ,12 ,12 ,24 ,(char *) uc2_6CDB },
	{ 0x6CDE , 1 ,12 ,12 ,24 ,(char *) uc2_6CDE },
	{ 0x6CE0 , 1 ,12 ,12 ,24 ,(char *) uc2_6CE0 },
	{ 0x6CE1 , 1 ,12 ,12 ,24 ,(char *) uc2_6CE1 },
	{ 0x6CE2 , 1 ,12 ,12 ,24 ,(char *) uc2_6CE2 },
	{ 0x6CE3 , 1 ,12 ,12 ,24 ,(char *) uc2_6CE3 },
	{ 0x6CE5 , 1 ,12 ,12 ,24 ,(char *) uc2_6CE5 },
	{ 0x6CE8 , 1 ,12 ,12 ,24 ,(char *) uc2_6CE8 },
	{ 0x6CEA , 1 ,12 ,12 ,24 ,(char *) uc2_6CEA },
	{ 0x6CEB , 1 ,12 ,12 ,24 ,(char *) uc2_6CEB },
	{ 0x6CEE , 1 ,12 ,12 ,24 ,(char *) uc2_6CEE },
	{ 0x6CEF , 1 ,12 ,12 ,24 ,(char *) uc2_6CEF },
	{ 0x6CF0 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF0 },
	{ 0x6CF1 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF1 },
	{ 0x6CF3 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF3 },
	{ 0x6CF5 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF5 },
	{ 0x6CF6 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF6 },
	{ 0x6CF7 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF7 },
	{ 0x6CF8 , 1 ,12 ,12 ,24 ,(char *) uc2_6CF8 },
	{ 0x6CFA , 1 ,12 ,12 ,24 ,(char *) uc2_6CFA },
	{ 0x6CFB , 1 ,12 ,12 ,24 ,(char *) uc2_6CFB },
	{ 0x6CFC , 1 ,12 ,12 ,24 ,(char *) uc2_6CFC },
	{ 0x6CFD , 1 ,12 ,12 ,24 ,(char *) uc2_6CFD },
	{ 0x6CFE , 1 ,12 ,12 ,24 ,(char *) uc2_6CFE },
	{ 0x6D01 , 1 ,12 ,12 ,24 ,(char *) uc2_6D01 },
	{ 0x6D04 , 1 ,12 ,12 ,24 ,(char *) uc2_6D04 },
	{ 0x6D07 , 1 ,12 ,12 ,24 ,(char *) uc2_6D07 },
	{ 0x6D0B , 1 ,12 ,12 ,24 ,(char *) uc2_6D0B },
	{ 0x6D0C , 1 ,12 ,12 ,24 ,(char *) uc2_6D0C },
	{ 0x6D0E , 1 ,12 ,12 ,24 ,(char *) uc2_6D0E },
	{ 0x6D12 , 1 ,12 ,12 ,24 ,(char *) uc2_6D12 },
	{ 0x6D17 , 1 ,12 ,12 ,24 ,(char *) uc2_6D17 },
	{ 0x6D19 , 1 ,12 ,12 ,24 ,(char *) uc2_6D19 },
	{ 0x6D1A , 1 ,12 ,12 ,24 ,(char *) uc2_6D1A },
	{ 0x6D1B , 1 ,12 ,12 ,24 ,(char *) uc2_6D1B },
	{ 0x6D1E , 1 ,12 ,12 ,24 ,(char *) uc2_6D1E },
	{ 0x6D25 , 1 ,12 ,12 ,24 ,(char *) uc2_6D25 },
	{ 0x6D27 , 1 ,12 ,12 ,24 ,(char *) uc2_6D27 },
	{ 0x6D2A , 1 ,12 ,12 ,24 ,(char *) uc2_6D2A },
	{ 0x6D2B , 1 ,12 ,12 ,24 ,(char *) uc2_6D2B },
	{ 0x6D2E , 1 ,12 ,12 ,24 ,(char *) uc2_6D2E },
	{ 0x6D31 , 1 ,12 ,12 ,24 ,(char *) uc2_6D31 },
	{ 0x6D32 , 1 ,12 ,12 ,24 ,(char *) uc2_6D32 },
	{ 0x6D33 , 1 ,12 ,12 ,24 ,(char *) uc2_6D33 },
	{ 0x6D35 , 1 ,12 ,12 ,24 ,(char *) uc2_6D35 },
	{ 0x6D39 , 1 ,12 ,12 ,24 ,(char *) uc2_6D39 },
	{ 0x6D3B , 1 ,12 ,12 ,24 ,(char *) uc2_6D3B },
	{ 0x6D3C , 1 ,12 ,12 ,24 ,(char *) uc2_6D3C },
	{ 0x6D3D , 1 ,12 ,12 ,24 ,(char *) uc2_6D3D },
	{ 0x6D3E , 1 ,12 ,12 ,24 ,(char *) uc2_6D3E },
	{ 0x6D41 , 1 ,12 ,12 ,24 ,(char *) uc2_6D41 },
	{ 0x6D43 , 1 ,12 ,12 ,24 ,(char *) uc2_6D43 },
	{ 0x6D45 , 1 ,12 ,12 ,24 ,(char *) uc2_6D45 },
	{ 0x6D46 , 1 ,12 ,12 ,24 ,(char *) uc2_6D46 },
	{ 0x6D47 , 1 ,12 ,12 ,24 ,(char *) uc2_6D47 },
	{ 0x6D48 , 1 ,12 ,12 ,24 ,(char *) uc2_6D48 },
	{ 0x6D4A , 1 ,12 ,12 ,24 ,(char *) uc2_6D4A },
	{ 0x6D4B , 1 ,12 ,12 ,24 ,(char *) uc2_6D4B },
	{ 0x6D4D , 1 ,12 ,12 ,24 ,(char *) uc2_6D4D },
	{ 0x6D4E , 1 ,12 ,12 ,24 ,(char *) uc2_6D4E },
	{ 0x6D4F , 1 ,12 ,12 ,24 ,(char *) uc2_6D4F },
	{ 0x6D51 , 1 ,12 ,12 ,24 ,(char *) uc2_6D51 },
	{ 0x6D52 , 1 ,12 ,12 ,24 ,(char *) uc2_6D52 },
	{ 0x6D53 , 1 ,12 ,12 ,24 ,(char *) uc2_6D53 },
	{ 0x6D54 , 1 ,12 ,12 ,24 ,(char *) uc2_6D54 },
	{ 0x6D59 , 1 ,12 ,12 ,24 ,(char *) uc2_6D59 },
	{ 0x6D5A , 1 ,12 ,12 ,24 ,(char *) uc2_6D5A },
	{ 0x6D5C , 1 ,12 ,12 ,24 ,(char *) uc2_6D5C },
	{ 0x6D5E , 1 ,12 ,12 ,24 ,(char *) uc2_6D5E },
	{ 0x6D60 , 1 ,12 ,12 ,24 ,(char *) uc2_6D60 },
	{ 0x6D63 , 1 ,12 ,12 ,24 ,(char *) uc2_6D63 },
	{ 0x6D66 , 1 ,12 ,12 ,24 ,(char *) uc2_6D66 },
	{ 0x6D69 , 1 ,12 ,12 ,24 ,(char *) uc2_6D69 },
	{ 0x6D6A , 1 ,12 ,12 ,24 ,(char *) uc2_6D6A },
	{ 0x6D6E , 1 ,12 ,12 ,24 ,(char *) uc2_6D6E },
	{ 0x6D6F , 1 ,12 ,12 ,24 ,(char *) uc2_6D6F },
	{ 0x6D74 , 1 ,12 ,12 ,24 ,(char *) uc2_6D74 },
	{ 0x6D77 , 1 ,12 ,12 ,24 ,(char *) uc2_6D77 },
	{ 0x6D78 , 1 ,12 ,12 ,24 ,(char *) uc2_6D78 },
	{ 0x6D7C , 1 ,12 ,12 ,24 ,(char *) uc2_6D7C },
	{ 0x6D82 , 1 ,12 ,12 ,24 ,(char *) uc2_6D82 },
	{ 0x6D85 , 1 ,12 ,12 ,24 ,(char *) uc2_6D85 },
	{ 0x6D88 , 1 ,12 ,12 ,24 ,(char *) uc2_6D88 },
	{ 0x6D89 , 1 ,12 ,12 ,24 ,(char *) uc2_6D89 },
	{ 0x6D8C , 1 ,12 ,12 ,24 ,(char *) uc2_6D8C },
	{ 0x6D8E , 1 ,12 ,12 ,24 ,(char *) uc2_6D8E },
	{ 0x6D91 , 1 ,12 ,12 ,24 ,(char *) uc2_6D91 },
	{ 0x6D93 , 1 ,12 ,12 ,24 ,(char *) uc2_6D93 },
	{ 0x6D94 , 1 ,12 ,12 ,24 ,(char *) uc2_6D94 },
	{ 0x6D95 , 1 ,12 ,12 ,24 ,(char *) uc2_6D95 },
	{ 0x6D9B , 1 ,12 ,12 ,24 ,(char *) uc2_6D9B },
	{ 0x6D9D , 1 ,12 ,12 ,24 ,(char *) uc2_6D9D },
	{ 0x6D9E , 1 ,12 ,12 ,24 ,(char *) uc2_6D9E },
	{ 0x6D9F , 1 ,12 ,12 ,24 ,(char *) uc2_6D9F },
	{ 0x6DA0 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA0 },
	{ 0x6DA1 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA1 },
	{ 0x6DA3 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA3 },
	{ 0x6DA4 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA4 },
	{ 0x6DA6 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA6 },
	{ 0x6DA7 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA7 },
	{ 0x6DA8 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA8 },
	{ 0x6DA9 , 1 ,12 ,12 ,24 ,(char *) uc2_6DA9 },
	{ 0x6DAA , 1 ,12 ,12 ,24 ,(char *) uc2_6DAA },
	{ 0x6DAB , 1 ,12 ,12 ,24 ,(char *) uc2_6DAB },
	{ 0x6DAE , 1 ,12 ,12 ,24 ,(char *) uc2_6DAE },
	{ 0x6DAF , 1 ,12 ,12 ,24 ,(char *) uc2_6DAF },
	{ 0x6DB2 , 1 ,12 ,12 ,24 ,(char *) uc2_6DB2 },
	{ 0x6DB5 , 1 ,12 ,12 ,24 ,(char *) uc2_6DB5 },
	{ 0x6DB8 , 1 ,12 ,12 ,24 ,(char *) uc2_6DB8 },
	{ 0x6DBF , 1 ,12 ,12 ,24 ,(char *) uc2_6DBF },
	{ 0x6DC0 , 1 ,12 ,12 ,24 ,(char *) uc2_6DC0 },
	{ 0x6DC4 , 1 ,12 ,12 ,24 ,(char *) uc2_6DC4 },
	{ 0x6DC5 , 1 ,12 ,12 ,24 ,(char *) uc2_6DC5 },
	{ 0x6DC6 , 1 ,12 ,12 ,24 ,(char *) uc2_6DC6 },
	{ 0x6DC7 , 1 ,12 ,12 ,24 ,(char *) uc2_6DC7 },
	{ 0x6DCB , 1 ,12 ,12 ,24 ,(char *) uc2_6DCB },
	{ 0x6DCC , 1 ,12 ,12 ,24 ,(char *) uc2_6DCC },
	{ 0x6DD1 , 1 ,12 ,12 ,24 ,(char *) uc2_6DD1 },
	{ 0x6DD6 , 1 ,12 ,12 ,24 ,(char *) uc2_6DD6 },
	{ 0x6DD8 , 1 ,12 ,12 ,24 ,(char *) uc2_6DD8 },
	{ 0x6DD9 , 1 ,12 ,12 ,24 ,(char *) uc2_6DD9 },
	{ 0x6DDD , 1 ,12 ,12 ,24 ,(char *) uc2_6DDD },
	{ 0x6DDE , 1 ,12 ,12 ,24 ,(char *) uc2_6DDE },
	{ 0x6DE0 , 1 ,12 ,12 ,24 ,(char *) uc2_6DE0 },
	{ 0x6DE1 , 1 ,12 ,12 ,24 ,(char *) uc2_6DE1 },
	{ 0x6DE4 , 1 ,12 ,12 ,24 ,(char *) uc2_6DE4 },
	{ 0x6DE6 , 1 ,12 ,12 ,24 ,(char *) uc2_6DE6 },
	{ 0x6DEB , 1 ,12 ,12 ,24 ,(char *) uc2_6DEB },
	{ 0x6DEC , 1 ,12 ,12 ,24 ,(char *) uc2_6DEC },
	{ 0x6DEE , 1 ,12 ,12 ,24 ,(char *) uc2_6DEE },
	{ 0x6DF1 , 1 ,12 ,12 ,24 ,(char *) uc2_6DF1 },
	{ 0x6DF3 , 1 ,12 ,12 ,24 ,(char *) uc2_6DF3 },
	{ 0x6DF7 , 1 ,12 ,12 ,24 ,(char *) uc2_6DF7 },
	{ 0x6DF9 , 1 ,12 ,12 ,24 ,(char *) uc2_6DF9 },
	{ 0x6DFB , 1 ,12 ,12 ,24 ,(char *) uc2_6DFB },
	{ 0x6DFC , 1 ,12 ,12 ,24 ,(char *) uc2_6DFC },
	{ 0x6E05 , 1 ,12 ,12 ,24 ,(char *) uc2_6E05 },
	{ 0x6E0A , 1 ,12 ,12 ,24 ,(char *) uc2_6E0A },
	{ 0x6E0C , 1 ,12 ,12 ,24 ,(char *) uc2_6E0C },
	{ 0x6E0D , 1 ,12 ,12 ,24 ,(char *) uc2_6E0D },
	{ 0x6E0E , 1 ,12 ,12 ,24 ,(char *) uc2_6E0E },
	{ 0x6E10 , 1 ,12 ,12 ,24 ,(char *) uc2_6E10 },
	{ 0x6E11 , 1 ,12 ,12 ,24 ,(char *) uc2_6E11 },
	{ 0x6E14 , 1 ,12 ,12 ,24 ,(char *) uc2_6E14 },
	{ 0x6E16 , 1 ,12 ,12 ,24 ,(char *) uc2_6E16 },
	{ 0x6E17 , 1 ,12 ,12 ,24 ,(char *) uc2_6E17 },
	{ 0x6E1A , 1 ,12 ,12 ,24 ,(char *) uc2_6E1A },
	{ 0x6E1D , 1 ,12 ,12 ,24 ,(char *) uc2_6E1D },
	{ 0x6E20 , 1 ,12 ,12 ,24 ,(char *) uc2_6E20 },
	{ 0x6E21 , 1 ,12 ,12 ,24 ,(char *) uc2_6E21 },
	{ 0x6E23 , 1 ,12 ,12 ,24 ,(char *) uc2_6E23 },
	{ 0x6E24 , 1 ,12 ,12 ,24 ,(char *) uc2_6E24 },
	{ 0x6E25 , 1 ,12 ,12 ,24 ,(char *) uc2_6E25 },
	{ 0x6E29 , 1 ,12 ,12 ,24 ,(char *) uc2_6E29 },
	{ 0x6E2B , 1 ,12 ,12 ,24 ,(char *) uc2_6E2B },
	{ 0x6E2D , 1 ,12 ,12 ,24 ,(char *) uc2_6E2D },
	{ 0x6E2F , 1 ,12 ,12 ,24 ,(char *) uc2_6E2F },
	{ 0x6E32 , 1 ,12 ,12 ,24 ,(char *) uc2_6E32 },
	{ 0x6E34 , 1 ,12 ,12 ,24 ,(char *) uc2_6E34 },
	{ 0x6E38 , 1 ,12 ,12 ,24 ,(char *) uc2_6E38 },
	{ 0x6E3A , 1 ,12 ,12 ,24 ,(char *) uc2_6E3A },
	{ 0x6E43 , 1 ,12 ,12 ,24 ,(char *) uc2_6E43 },
	{ 0x6E44 , 1 ,12 ,12 ,24 ,(char *) uc2_6E44 },
	{ 0x6E4D , 1 ,12 ,12 ,24 ,(char *) uc2_6E4D },
	{ 0x6E4E , 1 ,12 ,12 ,24 ,(char *) uc2_6E4E },
	{ 0x6E53 , 1 ,12 ,12 ,24 ,(char *) uc2_6E53 },
	{ 0x6E54 , 1 ,12 ,12 ,24 ,(char *) uc2_6E54 },
	{ 0x6E56 , 1 ,12 ,12 ,24 ,(char *) uc2_6E56 },
	{ 0x6E58 , 1 ,12 ,12 ,24 ,(char *) uc2_6E58 },
	{ 0x6E5B , 1 ,12 ,12 ,24 ,(char *) uc2_6E5B },
	{ 0x6E5F , 1 ,12 ,12 ,24 ,(char *) uc2_6E5F },
	{ 0x6E6B , 1 ,12 ,12 ,24 ,(char *) uc2_6E6B },
	{ 0x6E6E , 1 ,12 ,12 ,24 ,(char *) uc2_6E6E },
	{ 0x6E7E , 1 ,12 ,12 ,24 ,(char *) uc2_6E7E },
	{ 0x6E7F , 1 ,12 ,12 ,24 ,(char *) uc2_6E7F },
	{ 0x6E83 , 1 ,12 ,12 ,24 ,(char *) uc2_6E83 },
	{ 0x6E85 , 1 ,12 ,12 ,24 ,(char *) uc2_6E85 },
	{ 0x6E86 , 1 ,12 ,12 ,24 ,(char *) uc2_6E86 },
	{ 0x6E89 , 1 ,12 ,12 ,24 ,(char *) uc2_6E89 },
	{ 0x6E8F , 1 ,12 ,12 ,24 ,(char *) uc2_6E8F },
	{ 0x6E90 , 1 ,12 ,12 ,24 ,(char *) uc2_6E90 },
	{ 0x6E98 , 1 ,12 ,12 ,24 ,(char *) uc2_6E98 },
	{ 0x6E9C , 1 ,12 ,12 ,24 ,(char *) uc2_6E9C },
	{ 0x6E9F , 1 ,12 ,12 ,24 ,(char *) uc2_6E9F },
	{ 0x6EA2 , 1 ,12 ,12 ,24 ,(char *) uc2_6EA2 },
	{ 0x6EA5 , 1 ,12 ,12 ,24 ,(char *) uc2_6EA5 },
	{ 0x6EA7 , 1 ,12 ,12 ,24 ,(char *) uc2_6EA7 },
	{ 0x6EAA , 1 ,12 ,12 ,24 ,(char *) uc2_6EAA },
	{ 0x6EAF , 1 ,12 ,12 ,24 ,(char *) uc2_6EAF },
	{ 0x6EB1 , 1 ,12 ,12 ,24 ,(char *) uc2_6EB1 },
	{ 0x6EB2 , 1 ,12 ,12 ,24 ,(char *) uc2_6EB2 },
	{ 0x6EB4 , 1 ,12 ,12 ,24 ,(char *) uc2_6EB4 },
	{ 0x6EB6 , 1 ,12 ,12 ,24 ,(char *) uc2_6EB6 },
	{ 0x6EB7 , 1 ,12 ,12 ,24 ,(char *) uc2_6EB7 },
	{ 0x6EBA , 1 ,12 ,12 ,24 ,(char *) uc2_6EBA },
	{ 0x6EBB , 1 ,12 ,12 ,24 ,(char *) uc2_6EBB },
	{ 0x6EBD , 1 ,12 ,12 ,24 ,(char *) uc2_6EBD },
	{ 0x6EC1 , 1 ,12 ,12 ,24 ,(char *) uc2_6EC1 },
	{ 0x6EC2 , 1 ,12 ,12 ,24 ,(char *) uc2_6EC2 },
	{ 0x6EC7 , 1 ,12 ,12 ,24 ,(char *) uc2_6EC7 },
	{ 0x6ECB , 1 ,12 ,12 ,24 ,(char *) uc2_6ECB },
	{ 0x6ECF , 1 ,12 ,12 ,24 ,(char *) uc2_6ECF },
	{ 0x6ED1 , 1 ,12 ,12 ,24 ,(char *) uc2_6ED1 },
	{ 0x6ED3 , 1 ,12 ,12 ,24 ,(char *) uc2_6ED3 },
	{ 0x6ED4 , 1 ,12 ,12 ,24 ,(char *) uc2_6ED4 },
	{ 0x6ED5 , 1 ,12 ,12 ,24 ,(char *) uc2_6ED5 },
	{ 0x6ED7 , 1 ,12 ,12 ,24 ,(char *) uc2_6ED7 },
	{ 0x6EDA , 1 ,12 ,12 ,24 ,(char *) uc2_6EDA },
	{ 0x6EDE , 1 ,12 ,12 ,24 ,(char *) uc2_6EDE },
	{ 0x6EDF , 1 ,12 ,12 ,24 ,(char *) uc2_6EDF },
	{ 0x6EE0 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE0 },
	{ 0x6EE1 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE1 },
	{ 0x6EE2 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE2 },
	{ 0x6EE4 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE4 },
	{ 0x6EE5 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE5 },
	{ 0x6EE6 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE6 },
	{ 0x6EE8 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE8 },
	{ 0x6EE9 , 1 ,12 ,12 ,24 ,(char *) uc2_6EE9 },
	{ 0x6EF4 , 1 ,12 ,12 ,24 ,(char *) uc2_6EF4 },
	{ 0x6EF9 , 1 ,12 ,12 ,24 ,(char *) uc2_6EF9 },
	{ 0x6F02 , 1 ,12 ,12 ,24 ,(char *) uc2_6F02 },
	{ 0x6F06 , 1 ,12 ,12 ,24 ,(char *) uc2_6F06 },
	{ 0x6F09 , 1 ,12 ,12 ,24 ,(char *) uc2_6F09 },
	{ 0x6F0F , 1 ,12 ,12 ,24 ,(char *) uc2_6F0F },
	{ 0x6F13 , 1 ,12 ,12 ,24 ,(char *) uc2_6F13 },
	{ 0x6F14 , 1 ,12 ,12 ,24 ,(char *) uc2_6F14 },
	{ 0x6F15 , 1 ,12 ,12 ,24 ,(char *) uc2_6F15 },
	{ 0x6F20 , 1 ,12 ,12 ,24 ,(char *) uc2_6F20 },
	{ 0x6F24 , 1 ,12 ,12 ,24 ,(char *) uc2_6F24 },
	{ 0x6F29 , 1 ,12 ,12 ,24 ,(char *) uc2_6F29 },
	{ 0x6F2A , 1 ,12 ,12 ,24 ,(char *) uc2_6F2A },
	{ 0x6F2B , 1 ,12 ,12 ,24 ,(char *) uc2_6F2B },
	{ 0x6F2D , 1 ,12 ,12 ,24 ,(char *) uc2_6F2D },
	{ 0x6F2F , 1 ,12 ,12 ,24 ,(char *) uc2_6F2F },
	{ 0x6F31 , 1 ,12 ,12 ,24 ,(char *) uc2_6F31 },
	{ 0x6F33 , 1 ,12 ,12 ,24 ,(char *) uc2_6F33 },
	{ 0x6F36 , 1 ,12 ,12 ,24 ,(char *) uc2_6F36 },
	{ 0x6F3E , 1 ,12 ,12 ,24 ,(char *) uc2_6F3E },
	{ 0x6F46 , 1 ,12 ,12 ,24 ,(char *) uc2_6F46 },
	{ 0x6F47 , 1 ,12 ,12 ,24 ,(char *) uc2_6F47 },
	{ 0x6F4B , 1 ,12 ,12 ,24 ,(char *) uc2_6F4B },
	{ 0x6F4D , 1 ,12 ,12 ,24 ,(char *) uc2_6F4D },
	{ 0x6F58 , 1 ,12 ,12 ,24 ,(char *) uc2_6F58 },
	{ 0x6F5C , 1 ,12 ,12 ,24 ,(char *) uc2_6F5C },
	{ 0x6F5E , 1 ,12 ,12 ,24 ,(char *) uc2_6F5E },
	{ 0x6F62 , 1 ,12 ,12 ,24 ,(char *) uc2_6F62 },
	{ 0x6F66 , 1 ,12 ,12 ,24 ,(char *) uc2_6F66 },
	{ 0x6F6D , 1 ,12 ,12 ,24 ,(char *) uc2_6F6D },
	{ 0x6F6E , 1 ,12 ,12 ,24 ,(char *) uc2_6F6E },
	{ 0x6F72 , 1 ,12 ,12 ,24 ,(char *) uc2_6F72 },
	{ 0x6F74 , 1 ,12 ,12 ,24 ,(char *) uc2_6F74 },
	{ 0x6F78 , 1 ,12 ,12 ,24 ,(char *) uc2_6F78 },
	{ 0x6F7A , 1 ,12 ,12 ,24 ,(char *) uc2_6F7A },
	{ 0x6F7C , 1 ,12 ,12 ,24 ,(char *) uc2_6F7C },
	{ 0x6F84 , 1 ,12 ,12 ,24 ,(char *) uc2_6F84 },
	{ 0x6F88 , 1 ,12 ,12 ,24 ,(char *) uc2_6F88 },
	{ 0x6F89 , 1 ,12 ,12 ,24 ,(char *) uc2_6F89 },
	{ 0x6F8C , 1 ,12 ,12 ,24 ,(char *) uc2_6F8C },
	{ 0x6F8D , 1 ,12 ,12 ,24 ,(char *) uc2_6F8D },
	{ 0x6F8E , 1 ,12 ,12 ,24 ,(char *) uc2_6F8E },
	{ 0x6F9C , 1 ,12 ,12 ,24 ,(char *) uc2_6F9C },
	{ 0x6FA1 , 1 ,12 ,12 ,24 ,(char *) uc2_6FA1 },
	{ 0x6FA7 , 1 ,12 ,12 ,24 ,(char *) uc2_6FA7 },
	{ 0x6FB3 , 1 ,12 ,12 ,24 ,(char *) uc2_6FB3 },
	{ 0x6FB6 , 1 ,12 ,12 ,24 ,(char *) uc2_6FB6 },
	{ 0x6FB9 , 1 ,12 ,12 ,24 ,(char *) uc2_6FB9 },
	{ 0x6FC0 , 1 ,12 ,12 ,24 ,(char *) uc2_6FC0 },
	{ 0x6FC2 , 1 ,12 ,12 ,24 ,(char *) uc2_6FC2 },
	{ 0x6FC9 , 1 ,12 ,12 ,24 ,(char *) uc2_6FC9 },
	{ 0x6FD1 , 1 ,12 ,12 ,24 ,(char *) uc2_6FD1 },
	{ 0x6FD2 , 1 ,12 ,12 ,24 ,(char *) uc2_6FD2 },
	{ 0x6FDE , 1 ,12 ,12 ,24 ,(char *) uc2_6FDE },
	{ 0x6FE0 , 1 ,12 ,12 ,24 ,(char *) uc2_6FE0 },
	{ 0x6FE1 , 1 ,12 ,12 ,24 ,(char *) uc2_6FE1 },
	{ 0x6FEE , 1 ,12 ,12 ,24 ,(char *) uc2_6FEE },
	{ 0x6FEF , 1 ,12 ,12 ,24 ,(char *) uc2_6FEF },
	{ 0x7011 , 1 ,12 ,12 ,24 ,(char *) uc2_7011 },
	{ 0x701A , 1 ,12 ,12 ,24 ,(char *) uc2_701A },
	{ 0x701B , 1 ,12 ,12 ,24 ,(char *) uc2_701B },
	{ 0x7023 , 1 ,12 ,12 ,24 ,(char *) uc2_7023 },
	{ 0x7035 , 1 ,12 ,12 ,24 ,(char *) uc2_7035 },
	{ 0x7039 , 1 ,12 ,12 ,24 ,(char *) uc2_7039 },
	{ 0x704C , 1 ,12 ,12 ,24 ,(char *) uc2_704C },
	{ 0x704F , 1 ,12 ,12 ,24 ,(char *) uc2_704F },
	{ 0x705E , 1 ,12 ,12 ,24 ,(char *) uc2_705E },
	{ 0x706B , 1 ,12 ,12 ,24 ,(char *) uc2_706B },
	{ 0x706D , 1 ,12 ,12 ,24 ,(char *) uc2_706D },
	{ 0x706F , 1 ,12 ,12 ,24 ,(char *) uc2_706F },
	{ 0x7070 , 1 ,12 ,12 ,24 ,(char *) uc2_7070 },
	{ 0x7075 , 1 ,12 ,12 ,24 ,(char *) uc2_7075 },
	{ 0x7076 , 1 ,12 ,12 ,24 ,(char *) uc2_7076 },
	{ 0x7078 , 1 ,12 ,12 ,24 ,(char *) uc2_7078 },
	{ 0x707C , 1 ,12 ,12 ,24 ,(char *) uc2_707C },
	{ 0x707E , 1 ,12 ,12 ,24 ,(char *) uc2_707E },
	{ 0x707F , 1 ,12 ,12 ,24 ,(char *) uc2_707F },
	{ 0x7080 , 1 ,12 ,12 ,24 ,(char *) uc2_7080 },
	{ 0x7085 , 1 ,12 ,12 ,24 ,(char *) uc2_7085 },
	{ 0x7089 , 1 ,12 ,12 ,24 ,(char *) uc2_7089 },
	{ 0x708A , 1 ,12 ,12 ,24 ,(char *) uc2_708A },
	{ 0x708E , 1 ,12 ,12 ,24 ,(char *) uc2_708E },
	{ 0x7092 , 1 ,12 ,12 ,24 ,(char *) uc2_7092 },
	{ 0x7094 , 1 ,12 ,12 ,24 ,(char *) uc2_7094 },
	{ 0x7095 , 1 ,12 ,12 ,24 ,(char *) uc2_7095 },
	{ 0x7096 , 1 ,12 ,12 ,24 ,(char *) uc2_7096 },
	{ 0x7099 , 1 ,12 ,12 ,24 ,(char *) uc2_7099 },
	{ 0x709C , 1 ,12 ,12 ,24 ,(char *) uc2_709C },
	{ 0x709D , 1 ,12 ,12 ,24 ,(char *) uc2_709D },
	{ 0x70AB , 1 ,12 ,12 ,24 ,(char *) uc2_70AB },
	{ 0x70AC , 1 ,12 ,12 ,24 ,(char *) uc2_70AC },
	{ 0x70AD , 1 ,12 ,12 ,24 ,(char *) uc2_70AD },
	{ 0x70AE , 1 ,12 ,12 ,24 ,(char *) uc2_70AE },
	{ 0x70AF , 1 ,12 ,12 ,24 ,(char *) uc2_70AF },
	{ 0x70B1 , 1 ,12 ,12 ,24 ,(char *) uc2_70B1 },
	{ 0x70B3 , 1 ,12 ,12 ,24 ,(char *) uc2_70B3 },
	{ 0x70B7 , 1 ,12 ,12 ,24 ,(char *) uc2_70B7 },
	{ 0x70B8 , 1 ,12 ,12 ,24 ,(char *) uc2_70B8 },
	{ 0x70B9 , 1 ,12 ,12 ,24 ,(char *) uc2_70B9 },
	{ 0x70BB , 1 ,12 ,12 ,24 ,(char *) uc2_70BB },
	{ 0x70BC , 1 ,12 ,12 ,24 ,(char *) uc2_70BC },
	{ 0x70BD , 1 ,12 ,12 ,24 ,(char *) uc2_70BD },
	{ 0x70C0 , 1 ,12 ,12 ,24 ,(char *) uc2_70C0 },
	{ 0x70C1 , 1 ,12 ,12 ,24 ,(char *) uc2_70C1 },
	{ 0x70C2 , 1 ,12 ,12 ,24 ,(char *) uc2_70C2 },
	{ 0x70C3 , 1 ,12 ,12 ,24 ,(char *) uc2_70C3 },
	{ 0x70C8 , 1 ,12 ,12 ,24 ,(char *) uc2_70C8 },
	{ 0x70CA , 1 ,12 ,12 ,24 ,(char *) uc2_70CA },
	{ 0x70D8 , 1 ,12 ,12 ,24 ,(char *) uc2_70D8 },
	{ 0x70D9 , 1 ,12 ,12 ,24 ,(char *) uc2_70D9 },
	{ 0x70DB , 1 ,12 ,12 ,24 ,(char *) uc2_70DB },
	{ 0x70DF , 1 ,12 ,12 ,24 ,(char *) uc2_70DF },
	{ 0x70E4 , 1 ,12 ,12 ,24 ,(char *) uc2_70E4 },
	{ 0x70E6 , 1 ,12 ,12 ,24 ,(char *) uc2_70E6 },
	{ 0x70E7 , 1 ,12 ,12 ,24 ,(char *) uc2_70E7 },
	{ 0x70E8 , 1 ,12 ,12 ,24 ,(char *) uc2_70E8 },
	{ 0x70E9 , 1 ,12 ,12 ,24 ,(char *) uc2_70E9 },
	{ 0x70EB , 1 ,12 ,12 ,24 ,(char *) uc2_70EB },
	{ 0x70EC , 1 ,12 ,12 ,24 ,(char *) uc2_70EC },
	{ 0x70ED , 1 ,12 ,12 ,24 ,(char *) uc2_70ED },
	{ 0x70EF , 1 ,12 ,12 ,24 ,(char *) uc2_70EF },
	{ 0x70F7 , 1 ,12 ,12 ,24 ,(char *) uc2_70F7 },
	{ 0x70F9 , 1 ,12 ,12 ,24 ,(char *) uc2_70F9 },
	{ 0x70FD , 1 ,12 ,12 ,24 ,(char *) uc2_70FD },
	{ 0x7109 , 1 ,12 ,12 ,24 ,(char *) uc2_7109 },
	{ 0x710A , 1 ,12 ,12 ,24 ,(char *) uc2_710A },
	{ 0x7110 , 1 ,12 ,12 ,24 ,(char *) uc2_7110 },
	{ 0x7113 , 1 ,12 ,12 ,24 ,(char *) uc2_7113 },
	{ 0x7115 , 1 ,12 ,12 ,24 ,(char *) uc2_7115 },
	{ 0x7116 , 1 ,12 ,12 ,24 ,(char *) uc2_7116 },
	{ 0x7118 , 1 ,12 ,12 ,24 ,(char *) uc2_7118 },
	{ 0x7119 , 1 ,12 ,12 ,24 ,(char *) uc2_7119 },
	{ 0x711A , 1 ,12 ,12 ,24 ,(char *) uc2_711A },
	{ 0x7126 , 1 ,12 ,12 ,24 ,(char *) uc2_7126 },
	{ 0x712F , 1 ,12 ,12 ,24 ,(char *) uc2_712F },
	{ 0x7130 , 1 ,12 ,12 ,24 ,(char *) uc2_7130 },
	{ 0x7131 , 1 ,12 ,12 ,24 ,(char *) uc2_7131 },
	{ 0x7136 , 1 ,12 ,12 ,24 ,(char *) uc2_7136 },
	{ 0x7145 , 1 ,12 ,12 ,24 ,(char *) uc2_7145 },
	{ 0x714A , 1 ,12 ,12 ,24 ,(char *) uc2_714A },
	{ 0x714C , 1 ,12 ,12 ,24 ,(char *) uc2_714C },
	{ 0x714E , 1 ,12 ,12 ,24 ,(char *) uc2_714E },
	{ 0x715C , 1 ,12 ,12 ,24 ,(char *) uc2_715C },
	{ 0x715E , 1 ,12 ,12 ,24 ,(char *) uc2_715E },
	{ 0x7164 , 1 ,12 ,12 ,24 ,(char *) uc2_7164 },
	{ 0x7166 , 1 ,12 ,12 ,24 ,(char *) uc2_7166 },
	{ 0x7167 , 1 ,12 ,12 ,24 ,(char *) uc2_7167 },
	{ 0x7168 , 1 ,12 ,12 ,24 ,(char *) uc2_7168 },
	{ 0x716E , 1 ,12 ,12 ,24 ,(char *) uc2_716E },
	{ 0x7172 , 1 ,12 ,12 ,24 ,(char *) uc2_7172 },
	{ 0x7173 , 1 ,12 ,12 ,24 ,(char *) uc2_7173 },
	{ 0x7178 , 1 ,12 ,12 ,24 ,(char *) uc2_7178 },
	{ 0x717A , 1 ,12 ,12 ,24 ,(char *) uc2_717A },
	{ 0x717D , 1 ,12 ,12 ,24 ,(char *) uc2_717D },
	{ 0x7184 , 1 ,12 ,12 ,24 ,(char *) uc2_7184 },
	{ 0x718A , 1 ,12 ,12 ,24 ,(char *) uc2_718A },
	{ 0x718F , 1 ,12 ,12 ,24 ,(char *) uc2_718F },
	{ 0x7194 , 1 ,12 ,12 ,24 ,(char *) uc2_7194 },
	{ 0x7198 , 1 ,12 ,12 ,24 ,(char *) uc2_7198 },
	{ 0x7199 , 1 ,12 ,12 ,24 ,(char *) uc2_7199 },
	{ 0x719F , 1 ,12 ,12 ,24 ,(char *) uc2_719F },
	{ 0x71A0 , 1 ,12 ,12 ,24 ,(char *) uc2_71A0 },
	{ 0x71A8 , 1 ,12 ,12 ,24 ,(char *) uc2_71A8 },
	{ 0x71AC , 1 ,12 ,12 ,24 ,(char *) uc2_71AC },
	{ 0x71B3 , 1 ,12 ,12 ,24 ,(char *) uc2_71B3 },
	{ 0x71B5 , 1 ,12 ,12 ,24 ,(char *) uc2_71B5 },
	{ 0x71B9 , 1 ,12 ,12 ,24 ,(char *) uc2_71B9 },
	{ 0x71C3 , 1 ,12 ,12 ,24 ,(char *) uc2_71C3 },
	{ 0x71CE , 1 ,12 ,12 ,24 ,(char *) uc2_71CE },
	{ 0x71D4 , 1 ,12 ,12 ,24 ,(char *) uc2_71D4 },
	{ 0x71D5 , 1 ,12 ,12 ,24 ,(char *) uc2_71D5 },
	{ 0x71E0 , 1 ,12 ,12 ,24 ,(char *) uc2_71E0 },
	{ 0x71E5 , 1 ,12 ,12 ,24 ,(char *) uc2_71E5 },
	{ 0x71E7 , 1 ,12 ,12 ,24 ,(char *) uc2_71E7 },
	{ 0x71EE , 1 ,12 ,12 ,24 ,(char *) uc2_71EE },
	{ 0x71F9 , 1 ,12 ,12 ,24 ,(char *) uc2_71F9 },
	{ 0x7206 , 1 ,12 ,12 ,24 ,(char *) uc2_7206 },
	{ 0x721D , 1 ,12 ,12 ,24 ,(char *) uc2_721D },
	{ 0x7228 , 1 ,12 ,12 ,24 ,(char *) uc2_7228 },
	{ 0x722A , 1 ,12 ,12 ,24 ,(char *) uc2_722A },
	{ 0x722C , 1 ,12 ,12 ,24 ,(char *) uc2_722C },
	{ 0x7230 , 1 ,12 ,12 ,24 ,(char *) uc2_7230 },
	{ 0x7231 , 1 ,12 ,12 ,24 ,(char *) uc2_7231 },
	{ 0x7235 , 1 ,12 ,12 ,24 ,(char *) uc2_7235 },
	{ 0x7236 , 1 ,12 ,12 ,24 ,(char *) uc2_7236 },
	{ 0x7237 , 1 ,12 ,12 ,24 ,(char *) uc2_7237 },
	{ 0x7238 , 1 ,12 ,12 ,24 ,(char *) uc2_7238 },
	{ 0x7239 , 1 ,12 ,12 ,24 ,(char *) uc2_7239 },
	{ 0x723B , 1 ,12 ,12 ,24 ,(char *) uc2_723B },
	{ 0x723D , 1 ,12 ,12 ,24 ,(char *) uc2_723D },
	{ 0x723F , 1 ,12 ,12 ,24 ,(char *) uc2_723F },
	{ 0x7247 , 1 ,12 ,12 ,24 ,(char *) uc2_7247 },
	{ 0x7248 , 1 ,12 ,12 ,24 ,(char *) uc2_7248 },
	{ 0x724C , 1 ,12 ,12 ,24 ,(char *) uc2_724C },
	{ 0x724D , 1 ,12 ,12 ,24 ,(char *) uc2_724D },
	{ 0x7252 , 1 ,12 ,12 ,24 ,(char *) uc2_7252 },
	{ 0x7256 , 1 ,12 ,12 ,24 ,(char *) uc2_7256 },
	{ 0x7259 , 1 ,12 ,12 ,24 ,(char *) uc2_7259 },
	{ 0x725B , 1 ,12 ,12 ,24 ,(char *) uc2_725B },
	{ 0x725D , 1 ,12 ,12 ,24 ,(char *) uc2_725D },
	{ 0x725F , 1 ,12 ,12 ,24 ,(char *) uc2_725F },
	{ 0x7261 , 1 ,12 ,12 ,24 ,(char *) uc2_7261 },
	{ 0x7262 , 1 ,12 ,12 ,24 ,(char *) uc2_7262 },
	{ 0x7266 , 1 ,12 ,12 ,24 ,(char *) uc2_7266 },
	{ 0x7267 , 1 ,12 ,12 ,24 ,(char *) uc2_7267 },
	{ 0x7269 , 1 ,12 ,12 ,24 ,(char *) uc2_7269 },
	{ 0x726E , 1 ,12 ,12 ,24 ,(char *) uc2_726E },
	{ 0x726F , 1 ,12 ,12 ,24 ,(char *) uc2_726F },
	{ 0x7272 , 1 ,12 ,12 ,24 ,(char *) uc2_7272 },
	{ 0x7275 , 1 ,12 ,12 ,24 ,(char *) uc2_7275 },
	{ 0x7279 , 1 ,12 ,12 ,24 ,(char *) uc2_7279 },
	{ 0x727A , 1 ,12 ,12 ,24 ,(char *) uc2_727A },
	{ 0x727E , 1 ,12 ,12 ,24 ,(char *) uc2_727E },
	{ 0x727F , 1 ,12 ,12 ,24 ,(char *) uc2_727F },
	{ 0x7280 , 1 ,12 ,12 ,24 ,(char *) uc2_7280 },
	{ 0x7281 , 1 ,12 ,12 ,24 ,(char *) uc2_7281 },
	{ 0x7284 , 1 ,12 ,12 ,24 ,(char *) uc2_7284 },
	{ 0x7287 , 1 ,12 ,12 ,24 ,(char *) uc2_7287 },
	{ 0x728A , 1 ,12 ,12 ,24 ,(char *) uc2_728A },
	{ 0x728B , 1 ,12 ,12 ,24 ,(char *) uc2_728B },
	{ 0x728D , 1 ,12 ,12 ,24 ,(char *) uc2_728D },
	{ 0x728F , 1 ,12 ,12 ,24 ,(char *) uc2_728F },
	{ 0x7292 , 1 ,12 ,12 ,24 ,(char *) uc2_7292 },
	{ 0x729F , 1 ,12 ,12 ,24 ,(char *) uc2_729F },
	{ 0x72AC , 1 ,12 ,12 ,24 ,(char *) uc2_72AC },
	{ 0x72AD , 1 ,12 ,12 ,24 ,(char *) uc2_72AD },	
	{ 0x72AF , 1 ,12 ,12 ,24 ,(char *) uc2_72AF },
	{ 0x72B0 , 1 ,12 ,12 ,24 ,(char *) uc2_72B0 },
	{ 0x72B4 , 1 ,12 ,12 ,24 ,(char *) uc2_72B4 },
	{ 0x72B6 , 1 ,12 ,12 ,24 ,(char *) uc2_72B6 },
	{ 0x72B7 , 1 ,12 ,12 ,24 ,(char *) uc2_72B7 },
	{ 0x72B8 , 1 ,12 ,12 ,24 ,(char *) uc2_72B8 },
	{ 0x72B9 , 1 ,12 ,12 ,24 ,(char *) uc2_72B9 },
	{ 0x72C1 , 1 ,12 ,12 ,24 ,(char *) uc2_72C1 },
	{ 0x72C2 , 1 ,12 ,12 ,24 ,(char *) uc2_72C2 },
	{ 0x72C3 , 1 ,12 ,12 ,24 ,(char *) uc2_72C3 },
	{ 0x72C4 , 1 ,12 ,12 ,24 ,(char *) uc2_72C4 },
	{ 0x72C8 , 1 ,12 ,12 ,24 ,(char *) uc2_72C8 },
	{ 0x72CD , 1 ,12 ,12 ,24 ,(char *) uc2_72CD },
	{ 0x72CE , 1 ,12 ,12 ,24 ,(char *) uc2_72CE },
	{ 0x72D0 , 1 ,12 ,12 ,24 ,(char *) uc2_72D0 },
	{ 0x72D2 , 1 ,12 ,12 ,24 ,(char *) uc2_72D2 },
	{ 0x72D7 , 1 ,12 ,12 ,24 ,(char *) uc2_72D7 },
	{ 0x72D9 , 1 ,12 ,12 ,24 ,(char *) uc2_72D9 },
	{ 0x72DE , 1 ,12 ,12 ,24 ,(char *) uc2_72DE },
	{ 0x72E0 , 1 ,12 ,12 ,24 ,(char *) uc2_72E0 },
	{ 0x72E1 , 1 ,12 ,12 ,24 ,(char *) uc2_72E1 },
	{ 0x72E8 , 1 ,12 ,12 ,24 ,(char *) uc2_72E8 },
	{ 0x72E9 , 1 ,12 ,12 ,24 ,(char *) uc2_72E9 },
	{ 0x72EC , 1 ,12 ,12 ,24 ,(char *) uc2_72EC },
	{ 0x72ED , 1 ,12 ,12 ,24 ,(char *) uc2_72ED },
	{ 0x72EE , 1 ,12 ,12 ,24 ,(char *) uc2_72EE },
	{ 0x72EF , 1 ,12 ,12 ,24 ,(char *) uc2_72EF },
	{ 0x72F0 , 1 ,12 ,12 ,24 ,(char *) uc2_72F0 },
	{ 0x72F1 , 1 ,12 ,12 ,24 ,(char *) uc2_72F1 },
	{ 0x72F2 , 1 ,12 ,12 ,24 ,(char *) uc2_72F2 },
	{ 0x72F3 , 1 ,12 ,12 ,24 ,(char *) uc2_72F3 },
	{ 0x72F4 , 1 ,12 ,12 ,24 ,(char *) uc2_72F4 },
	{ 0x72F7 , 1 ,12 ,12 ,24 ,(char *) uc2_72F7 },
	{ 0x72F8 , 1 ,12 ,12 ,24 ,(char *) uc2_72F8 },
	{ 0x72FA , 1 ,12 ,12 ,24 ,(char *) uc2_72FA },
	{ 0x72FB , 1 ,12 ,12 ,24 ,(char *) uc2_72FB },
	{ 0x72FC , 1 ,12 ,12 ,24 ,(char *) uc2_72FC },
	{ 0x7301 , 1 ,12 ,12 ,24 ,(char *) uc2_7301 },
	{ 0x7303 , 1 ,12 ,12 ,24 ,(char *) uc2_7303 },
	{ 0x730A , 1 ,12 ,12 ,24 ,(char *) uc2_730A },
	{ 0x730E , 1 ,12 ,12 ,24 ,(char *) uc2_730E },
	{ 0x7313 , 1 ,12 ,12 ,24 ,(char *) uc2_7313 },
	{ 0x7315 , 1 ,12 ,12 ,24 ,(char *) uc2_7315 },
	{ 0x7316 , 1 ,12 ,12 ,24 ,(char *) uc2_7316 },
	{ 0x7317 , 1 ,12 ,12 ,24 ,(char *) uc2_7317 },
	{ 0x731B , 1 ,12 ,12 ,24 ,(char *) uc2_731B },
	{ 0x731C , 1 ,12 ,12 ,24 ,(char *) uc2_731C },
	{ 0x731D , 1 ,12 ,12 ,24 ,(char *) uc2_731D },
	{ 0x731E , 1 ,12 ,12 ,24 ,(char *) uc2_731E },
	{ 0x7321 , 1 ,12 ,12 ,24 ,(char *) uc2_7321 },
	{ 0x7322 , 1 ,12 ,12 ,24 ,(char *) uc2_7322 },
	{ 0x7325 , 1 ,12 ,12 ,24 ,(char *) uc2_7325 },
	{ 0x7329 , 1 ,12 ,12 ,24 ,(char *) uc2_7329 },
	{ 0x732A , 1 ,12 ,12 ,24 ,(char *) uc2_732A },
	{ 0x732B , 1 ,12 ,12 ,24 ,(char *) uc2_732B },
	{ 0x732C , 1 ,12 ,12 ,24 ,(char *) uc2_732C },
	{ 0x732E , 1 ,12 ,12 ,24 ,(char *) uc2_732E },
	{ 0x7331 , 1 ,12 ,12 ,24 ,(char *) uc2_7331 },
	{ 0x7334 , 1 ,12 ,12 ,24 ,(char *) uc2_7334 },
	{ 0x7337 , 1 ,12 ,12 ,24 ,(char *) uc2_7337 },
	{ 0x7338 , 1 ,12 ,12 ,24 ,(char *) uc2_7338 },
	{ 0x7339 , 1 ,12 ,12 ,24 ,(char *) uc2_7339 },
	{ 0x733E , 1 ,12 ,12 ,24 ,(char *) uc2_733E },
	{ 0x733F , 1 ,12 ,12 ,24 ,(char *) uc2_733F },
	{ 0x734D , 1 ,12 ,12 ,24 ,(char *) uc2_734D },
	{ 0x7350 , 1 ,12 ,12 ,24 ,(char *) uc2_7350 },
	{ 0x7352 , 1 ,12 ,12 ,24 ,(char *) uc2_7352 },
	{ 0x7357 , 1 ,12 ,12 ,24 ,(char *) uc2_7357 },
	{ 0x7360 , 1 ,12 ,12 ,24 ,(char *) uc2_7360 },
	{ 0x736C , 1 ,12 ,12 ,24 ,(char *) uc2_736C },
	{ 0x736D , 1 ,12 ,12 ,24 ,(char *) uc2_736D },
	{ 0x736F , 1 ,12 ,12 ,24 ,(char *) uc2_736F },
	{ 0x737E , 1 ,12 ,12 ,24 ,(char *) uc2_737E },
	{ 0x7384 , 1 ,12 ,12 ,24 ,(char *) uc2_7384 },
	{ 0x7387 , 1 ,12 ,12 ,24 ,(char *) uc2_7387 },
	{ 0x7389 , 1 ,12 ,12 ,24 ,(char *) uc2_7389 },
	{ 0x738B , 1 ,12 ,12 ,24 ,(char *) uc2_738B },
	{ 0x738E , 1 ,12 ,12 ,24 ,(char *) uc2_738E },
	{ 0x7391 , 1 ,12 ,12 ,24 ,(char *) uc2_7391 },
	{ 0x7396 , 1 ,12 ,12 ,24 ,(char *) uc2_7396 },
	{ 0x739B , 1 ,12 ,12 ,24 ,(char *) uc2_739B },
	{ 0x739F , 1 ,12 ,12 ,24 ,(char *) uc2_739F },
	{ 0x73A2 , 1 ,12 ,12 ,24 ,(char *) uc2_73A2 },
	{ 0x73A9 , 1 ,12 ,12 ,24 ,(char *) uc2_73A9 },
	{ 0x73AB , 1 ,12 ,12 ,24 ,(char *) uc2_73AB },
	{ 0x73AE , 1 ,12 ,12 ,24 ,(char *) uc2_73AE },
	{ 0x73AF , 1 ,12 ,12 ,24 ,(char *) uc2_73AF },
	{ 0x73B0 , 1 ,12 ,12 ,24 ,(char *) uc2_73B0 },
	{ 0x73B1 , 1 ,12 ,12 ,24 ,(char *) uc2_73B1 },
	{ 0x73B2 , 1 ,12 ,12 ,24 ,(char *) uc2_73B2 },
	{ 0x73B3 , 1 ,12 ,12 ,24 ,(char *) uc2_73B3 },
	{ 0x73B7 , 1 ,12 ,12 ,24 ,(char *) uc2_73B7 },
	{ 0x73BA , 1 ,12 ,12 ,24 ,(char *) uc2_73BA },
	{ 0x73BB , 1 ,12 ,12 ,24 ,(char *) uc2_73BB },
	{ 0x73C0 , 1 ,12 ,12 ,24 ,(char *) uc2_73C0 },
	{ 0x73C2 , 1 ,12 ,12 ,24 ,(char *) uc2_73C2 },
	{ 0x73C8 , 1 ,12 ,12 ,24 ,(char *) uc2_73C8 },
	{ 0x73C9 , 1 ,12 ,12 ,24 ,(char *) uc2_73C9 },
	{ 0x73CA , 1 ,12 ,12 ,24 ,(char *) uc2_73CA },
	{ 0x73CD , 1 ,12 ,12 ,24 ,(char *) uc2_73CD },
	{ 0x73CF , 1 ,12 ,12 ,24 ,(char *) uc2_73CF },
	{ 0x73D0 , 1 ,12 ,12 ,24 ,(char *) uc2_73D0 },
	{ 0x73D1 , 1 ,12 ,12 ,24 ,(char *) uc2_73D1 },
	{ 0x73D9 , 1 ,12 ,12 ,24 ,(char *) uc2_73D9 },
	{ 0x73DE , 1 ,12 ,12 ,24 ,(char *) uc2_73DE },
	{ 0x73E0 , 1 ,12 ,12 ,24 ,(char *) uc2_73E0 },
	{ 0x73E5 , 1 ,12 ,12 ,24 ,(char *) uc2_73E5 },
	{ 0x73E7 , 1 ,12 ,12 ,24 ,(char *) uc2_73E7 },
	{ 0x73E9 , 1 ,12 ,12 ,24 ,(char *) uc2_73E9 },
	{ 0x73ED , 1 ,12 ,12 ,24 ,(char *) uc2_73ED },
	{ 0x73F2 , 1 ,12 ,12 ,24 ,(char *) uc2_73F2 },
	{ 0x7403 , 1 ,12 ,12 ,24 ,(char *) uc2_7403 },
	{ 0x7405 , 1 ,12 ,12 ,24 ,(char *) uc2_7405 },
	{ 0x7406 , 1 ,12 ,12 ,24 ,(char *) uc2_7406 },
	{ 0x7409 , 1 ,12 ,12 ,24 ,(char *) uc2_7409 },
	{ 0x740A , 1 ,12 ,12 ,24 ,(char *) uc2_740A },
	{ 0x740F , 1 ,12 ,12 ,24 ,(char *) uc2_740F },
	{ 0x7410 , 1 ,12 ,12 ,24 ,(char *) uc2_7410 },
	{ 0x741A , 1 ,12 ,12 ,24 ,(char *) uc2_741A },
	{ 0x741B , 1 ,12 ,12 ,24 ,(char *) uc2_741B },
	{ 0x7422 , 1 ,12 ,12 ,24 ,(char *) uc2_7422 },
	{ 0x7425 , 1 ,12 ,12 ,24 ,(char *) uc2_7425 },
	{ 0x7426 , 1 ,12 ,12 ,24 ,(char *) uc2_7426 },
	{ 0x7428 , 1 ,12 ,12 ,24 ,(char *) uc2_7428 },
	{ 0x742A , 1 ,12 ,12 ,24 ,(char *) uc2_742A },
	{ 0x742C , 1 ,12 ,12 ,24 ,(char *) uc2_742C },
	{ 0x742E , 1 ,12 ,12 ,24 ,(char *) uc2_742E },
	{ 0x7430 , 1 ,12 ,12 ,24 ,(char *) uc2_7430 },
	{ 0x7433 , 1 ,12 ,12 ,24 ,(char *) uc2_7433 },
	{ 0x7434 , 1 ,12 ,12 ,24 ,(char *) uc2_7434 },
	{ 0x7435 , 1 ,12 ,12 ,24 ,(char *) uc2_7435 },
	{ 0x7436 , 1 ,12 ,12 ,24 ,(char *) uc2_7436 },
	{ 0x743C , 1 ,12 ,12 ,24 ,(char *) uc2_743C },
	{ 0x7441 , 1 ,12 ,12 ,24 ,(char *) uc2_7441 },
	{ 0x7455 , 1 ,12 ,12 ,24 ,(char *) uc2_7455 },
	{ 0x7457 , 1 ,12 ,12 ,24 ,(char *) uc2_7457 },
	{ 0x7459 , 1 ,12 ,12 ,24 ,(char *) uc2_7459 },
	{ 0x745A , 1 ,12 ,12 ,24 ,(char *) uc2_745A },
	{ 0x745B , 1 ,12 ,12 ,24 ,(char *) uc2_745B },
	{ 0x745C , 1 ,12 ,12 ,24 ,(char *) uc2_745C },
	{ 0x745E , 1 ,12 ,12 ,24 ,(char *) uc2_745E },
	{ 0x745F , 1 ,12 ,12 ,24 ,(char *) uc2_745F },
	{ 0x746D , 1 ,12 ,12 ,24 ,(char *) uc2_746D },
	{ 0x7470 , 1 ,12 ,12 ,24 ,(char *) uc2_7470 },
	{ 0x7476 , 1 ,12 ,12 ,24 ,(char *) uc2_7476 },
	{ 0x7477 , 1 ,12 ,12 ,24 ,(char *) uc2_7477 },
	{ 0x747E , 1 ,12 ,12 ,24 ,(char *) uc2_747E },
	{ 0x7480 , 1 ,12 ,12 ,24 ,(char *) uc2_7480 },
	{ 0x7481 , 1 ,12 ,12 ,24 ,(char *) uc2_7481 },
	{ 0x7483 , 1 ,12 ,12 ,24 ,(char *) uc2_7483 },
	{ 0x7487 , 1 ,12 ,12 ,24 ,(char *) uc2_7487 },
	{ 0x748B , 1 ,12 ,12 ,24 ,(char *) uc2_748B },
	{ 0x748E , 1 ,12 ,12 ,24 ,(char *) uc2_748E },
	{ 0x7490 , 1 ,12 ,12 ,24 ,(char *) uc2_7490 },
	{ 0x749C , 1 ,12 ,12 ,24 ,(char *) uc2_749C },
	{ 0x749E , 1 ,12 ,12 ,24 ,(char *) uc2_749E },
	{ 0x74A7 , 1 ,12 ,12 ,24 ,(char *) uc2_74A7 },
	{ 0x74A8 , 1 ,12 ,12 ,24 ,(char *) uc2_74A8 },
	{ 0x74A9 , 1 ,12 ,12 ,24 ,(char *) uc2_74A9 },
	{ 0x74BA , 1 ,12 ,12 ,24 ,(char *) uc2_74BA },
	{ 0x74D2 , 1 ,12 ,12 ,24 ,(char *) uc2_74D2 },
	{ 0x74DC , 1 ,12 ,12 ,24 ,(char *) uc2_74DC },
	{ 0x74DE , 1 ,12 ,12 ,24 ,(char *) uc2_74DE },
	{ 0x74E0 , 1 ,12 ,12 ,24 ,(char *) uc2_74E0 },
	{ 0x74E2 , 1 ,12 ,12 ,24 ,(char *) uc2_74E2 },
	{ 0x74E3 , 1 ,12 ,12 ,24 ,(char *) uc2_74E3 },
	{ 0x74E4 , 1 ,12 ,12 ,24 ,(char *) uc2_74E4 },
	{ 0x74E6 , 1 ,12 ,12 ,24 ,(char *) uc2_74E6 },
	{ 0x74E9 , 1 ,12 ,12 ,24 ,(char *) uc2_74E9 },
	{ 0x74EE , 1 ,12 ,12 ,24 ,(char *) uc2_74EE },
	{ 0x74EF , 1 ,12 ,12 ,24 ,(char *) uc2_74EF },
	{ 0x74F4 , 1 ,12 ,12 ,24 ,(char *) uc2_74F4 },
	{ 0x74F6 , 1 ,12 ,12 ,24 ,(char *) uc2_74F6 },
	{ 0x74F7 , 1 ,12 ,12 ,24 ,(char *) uc2_74F7 },
	{ 0x74FF , 1 ,12 ,12 ,24 ,(char *) uc2_74FF },
	{ 0x7504 , 1 ,12 ,12 ,24 ,(char *) uc2_7504 },
	{ 0x750D , 1 ,12 ,12 ,24 ,(char *) uc2_750D },
	{ 0x750F , 1 ,12 ,12 ,24 ,(char *) uc2_750F },
	{ 0x7511 , 1 ,12 ,12 ,24 ,(char *) uc2_7511 },
	{ 0x7513 , 1 ,12 ,12 ,24 ,(char *) uc2_7513 },
	{ 0x7518 , 1 ,12 ,12 ,24 ,(char *) uc2_7518 },
	{ 0x7519 , 1 ,12 ,12 ,24 ,(char *) uc2_7519 },
	{ 0x751A , 1 ,12 ,12 ,24 ,(char *) uc2_751A },
	{ 0x751C , 1 ,12 ,12 ,24 ,(char *) uc2_751C },
	{ 0x751F , 1 ,12 ,12 ,24 ,(char *) uc2_751F },
	{ 0x7525 , 1 ,12 ,12 ,24 ,(char *) uc2_7525 },
	{ 0x7528 , 1 ,12 ,12 ,24 ,(char *) uc2_7528 },
	{ 0x7529 , 1 ,12 ,12 ,24 ,(char *) uc2_7529 },
	{ 0x752B , 1 ,12 ,12 ,24 ,(char *) uc2_752B },
	{ 0x752C , 1 ,12 ,12 ,24 ,(char *) uc2_752C },
	{ 0x752D , 1 ,12 ,12 ,24 ,(char *) uc2_752D },
	{ 0x752F , 1 ,12 ,12 ,24 ,(char *) uc2_752F },
	{ 0x7530 , 1 ,12 ,12 ,24 ,(char *) uc2_7530 },
	{ 0x7531 , 1 ,12 ,12 ,24 ,(char *) uc2_7531 },
	{ 0x7532 , 1 ,12 ,12 ,24 ,(char *) uc2_7532 },
	{ 0x7533 , 1 ,12 ,12 ,24 ,(char *) uc2_7533 },
	{ 0x7535 , 1 ,12 ,12 ,24 ,(char *) uc2_7535 },
	{ 0x7537 , 1 ,12 ,12 ,24 ,(char *) uc2_7537 },
	{ 0x7538 , 1 ,12 ,12 ,24 ,(char *) uc2_7538 },
	{ 0x753A , 1 ,12 ,12 ,24 ,(char *) uc2_753A },
	{ 0x753B , 1 ,12 ,12 ,24 ,(char *) uc2_753B },
	{ 0x753E , 1 ,12 ,12 ,24 ,(char *) uc2_753E },
	{ 0x7540 , 1 ,12 ,12 ,24 ,(char *) uc2_7540 },
	{ 0x7545 , 1 ,12 ,12 ,24 ,(char *) uc2_7545 },
	{ 0x7548 , 1 ,12 ,12 ,24 ,(char *) uc2_7548 },
	{ 0x754B , 1 ,12 ,12 ,24 ,(char *) uc2_754B },
	{ 0x754C , 1 ,12 ,12 ,24 ,(char *) uc2_754C },
	{ 0x754E , 1 ,12 ,12 ,24 ,(char *) uc2_754E },
	{ 0x754F , 1 ,12 ,12 ,24 ,(char *) uc2_754F },
	{ 0x7554 , 1 ,12 ,12 ,24 ,(char *) uc2_7554 },
	{ 0x7559 , 1 ,12 ,12 ,24 ,(char *) uc2_7559 },
	{ 0x755A , 1 ,12 ,12 ,24 ,(char *) uc2_755A },
	{ 0x755B , 1 ,12 ,12 ,24 ,(char *) uc2_755B },
	{ 0x755C , 1 ,12 ,12 ,24 ,(char *) uc2_755C },
	{ 0x7565 , 1 ,12 ,12 ,24 ,(char *) uc2_7565 },
	{ 0x7566 , 1 ,12 ,12 ,24 ,(char *) uc2_7566 },
	{ 0x756A , 1 ,12 ,12 ,24 ,(char *) uc2_756A },
	{ 0x7572 , 1 ,12 ,12 ,24 ,(char *) uc2_7572 },
	{ 0x7574 , 1 ,12 ,12 ,24 ,(char *) uc2_7574 },
	{ 0x7578 , 1 ,12 ,12 ,24 ,(char *) uc2_7578 },
	{ 0x7579 , 1 ,12 ,12 ,24 ,(char *) uc2_7579 },
	{ 0x757F , 1 ,12 ,12 ,24 ,(char *) uc2_757F },
	{ 0x7583 , 1 ,12 ,12 ,24 ,(char *) uc2_7583 },
	{ 0x7586 , 1 ,12 ,12 ,24 ,(char *) uc2_7586 },
	{ 0x758B , 1 ,12 ,12 ,24 ,(char *) uc2_758B },
	{ 0x758F , 1 ,12 ,12 ,24 ,(char *) uc2_758F },
	{ 0x7591 , 1 ,12 ,12 ,24 ,(char *) uc2_7591 },
	{ 0x7594 , 1 ,12 ,12 ,24 ,(char *) uc2_7594 },
	{ 0x7596 , 1 ,12 ,12 ,24 ,(char *) uc2_7596 },
	{ 0x7597 , 1 ,12 ,12 ,24 ,(char *) uc2_7597 },
	{ 0x7599 , 1 ,12 ,12 ,24 ,(char *) uc2_7599 },
	{ 0x759A , 1 ,12 ,12 ,24 ,(char *) uc2_759A },
	{ 0x759D , 1 ,12 ,12 ,24 ,(char *) uc2_759D },
	{ 0x759F , 1 ,12 ,12 ,24 ,(char *) uc2_759F },
	{ 0x75A0 , 1 ,12 ,12 ,24 ,(char *) uc2_75A0 },
	{ 0x75A1 , 1 ,12 ,12 ,24 ,(char *) uc2_75A1 },
	{ 0x75A3 , 1 ,12 ,12 ,24 ,(char *) uc2_75A3 },
	{ 0x75A4 , 1 ,12 ,12 ,24 ,(char *) uc2_75A4 },
	{ 0x75A5 , 1 ,12 ,12 ,24 ,(char *) uc2_75A5 },
	{ 0x75AB , 1 ,12 ,12 ,24 ,(char *) uc2_75AB },
	{ 0x75AC , 1 ,12 ,12 ,24 ,(char *) uc2_75AC },
	{ 0x75AE , 1 ,12 ,12 ,24 ,(char *) uc2_75AE },
	{ 0x75AF , 1 ,12 ,12 ,24 ,(char *) uc2_75AF },
	{ 0x75B0 , 1 ,12 ,12 ,24 ,(char *) uc2_75B0 },
	{ 0x75B1 , 1 ,12 ,12 ,24 ,(char *) uc2_75B1 },
	{ 0x75B2 , 1 ,12 ,12 ,24 ,(char *) uc2_75B2 },
	{ 0x75B3 , 1 ,12 ,12 ,24 ,(char *) uc2_75B3 },
	{ 0x75B4 , 1 ,12 ,12 ,24 ,(char *) uc2_75B4 },
	{ 0x75B5 , 1 ,12 ,12 ,24 ,(char *) uc2_75B5 },
	{ 0x75B8 , 1 ,12 ,12 ,24 ,(char *) uc2_75B8 },
	{ 0x75B9 , 1 ,12 ,12 ,24 ,(char *) uc2_75B9 },
	{ 0x75BC , 1 ,12 ,12 ,24 ,(char *) uc2_75BC },
	{ 0x75BD , 1 ,12 ,12 ,24 ,(char *) uc2_75BD },
	{ 0x75BE , 1 ,12 ,12 ,24 ,(char *) uc2_75BE },
	{ 0x75C2 , 1 ,12 ,12 ,24 ,(char *) uc2_75C2 },
	{ 0x75C3 , 1 ,12 ,12 ,24 ,(char *) uc2_75C3 },
	{ 0x75C4 , 1 ,12 ,12 ,24 ,(char *) uc2_75C4 },
	{ 0x75C5 , 1 ,12 ,12 ,24 ,(char *) uc2_75C5 },
	{ 0x75C7 , 1 ,12 ,12 ,24 ,(char *) uc2_75C7 },
	{ 0x75C8 , 1 ,12 ,12 ,24 ,(char *) uc2_75C8 },
	{ 0x75C9 , 1 ,12 ,12 ,24 ,(char *) uc2_75C9 },
	{ 0x75CA , 1 ,12 ,12 ,24 ,(char *) uc2_75CA },
	{ 0x75CD , 1 ,12 ,12 ,24 ,(char *) uc2_75CD },
	{ 0x75D2 , 1 ,12 ,12 ,24 ,(char *) uc2_75D2 },
	{ 0x75D4 , 1 ,12 ,12 ,24 ,(char *) uc2_75D4 },
	{ 0x75D5 , 1 ,12 ,12 ,24 ,(char *) uc2_75D5 },
	{ 0x75D6 , 1 ,12 ,12 ,24 ,(char *) uc2_75D6 },
	{ 0x75D8 , 1 ,12 ,12 ,24 ,(char *) uc2_75D8 },
	{ 0x75DB , 1 ,12 ,12 ,24 ,(char *) uc2_75DB },
	{ 0x75DE , 1 ,12 ,12 ,24 ,(char *) uc2_75DE },
	{ 0x75E2 , 1 ,12 ,12 ,24 ,(char *) uc2_75E2 },
	{ 0x75E3 , 1 ,12 ,12 ,24 ,(char *) uc2_75E3 },
	{ 0x75E4 , 1 ,12 ,12 ,24 ,(char *) uc2_75E4 },
	{ 0x75E6 , 1 ,12 ,12 ,24 ,(char *) uc2_75E6 },
	{ 0x75E7 , 1 ,12 ,12 ,24 ,(char *) uc2_75E7 },
	{ 0x75E8 , 1 ,12 ,12 ,24 ,(char *) uc2_75E8 },
	{ 0x75EA , 1 ,12 ,12 ,24 ,(char *) uc2_75EA },
	{ 0x75EB , 1 ,12 ,12 ,24 ,(char *) uc2_75EB },
	{ 0x75F0 , 1 ,12 ,12 ,24 ,(char *) uc2_75F0 },
	{ 0x75F1 , 1 ,12 ,12 ,24 ,(char *) uc2_75F1 },
	{ 0x75F4 , 1 ,12 ,12 ,24 ,(char *) uc2_75F4 },
	{ 0x75F9 , 1 ,12 ,12 ,24 ,(char *) uc2_75F9 },
	{ 0x75FC , 1 ,12 ,12 ,24 ,(char *) uc2_75FC },
	{ 0x75FF , 1 ,12 ,12 ,24 ,(char *) uc2_75FF },
	{ 0x7600 , 1 ,12 ,12 ,24 ,(char *) uc2_7600 },
	{ 0x7601 , 1 ,12 ,12 ,24 ,(char *) uc2_7601 },
	{ 0x7603 , 1 ,12 ,12 ,24 ,(char *) uc2_7603 },
	{ 0x7605 , 1 ,12 ,12 ,24 ,(char *) uc2_7605 },
	{ 0x760A , 1 ,12 ,12 ,24 ,(char *) uc2_760A },
	{ 0x760C , 1 ,12 ,12 ,24 ,(char *) uc2_760C },
	{ 0x7610 , 1 ,12 ,12 ,24 ,(char *) uc2_7610 },
	{ 0x7615 , 1 ,12 ,12 ,24 ,(char *) uc2_7615 },
	{ 0x7617 , 1 ,12 ,12 ,24 ,(char *) uc2_7617 },
	{ 0x7618 , 1 ,12 ,12 ,24 ,(char *) uc2_7618 },
	{ 0x7619 , 1 ,12 ,12 ,24 ,(char *) uc2_7619 },
	{ 0x761B , 1 ,12 ,12 ,24 ,(char *) uc2_761B },
	{ 0x761F , 1 ,12 ,12 ,24 ,(char *) uc2_761F },
	{ 0x7620 , 1 ,12 ,12 ,24 ,(char *) uc2_7620 },
	{ 0x7622 , 1 ,12 ,12 ,24 ,(char *) uc2_7622 },
	{ 0x7624 , 1 ,12 ,12 ,24 ,(char *) uc2_7624 },
	{ 0x7625 , 1 ,12 ,12 ,24 ,(char *) uc2_7625 },
	{ 0x7626 , 1 ,12 ,12 ,24 ,(char *) uc2_7626 },
	{ 0x7629 , 1 ,12 ,12 ,24 ,(char *) uc2_7629 },
	{ 0x762A , 1 ,12 ,12 ,24 ,(char *) uc2_762A },
	{ 0x762B , 1 ,12 ,12 ,24 ,(char *) uc2_762B },
	{ 0x762D , 1 ,12 ,12 ,24 ,(char *) uc2_762D },
	{ 0x7630 , 1 ,12 ,12 ,24 ,(char *) uc2_7630 },
	{ 0x7633 , 1 ,12 ,12 ,24 ,(char *) uc2_7633 },
	{ 0x7634 , 1 ,12 ,12 ,24 ,(char *) uc2_7634 },
	{ 0x7635 , 1 ,12 ,12 ,24 ,(char *) uc2_7635 },
	{ 0x7638 , 1 ,12 ,12 ,24 ,(char *) uc2_7638 },
	{ 0x763C , 1 ,12 ,12 ,24 ,(char *) uc2_763C },
	{ 0x763E , 1 ,12 ,12 ,24 ,(char *) uc2_763E },
	{ 0x763F , 1 ,12 ,12 ,24 ,(char *) uc2_763F },
	{ 0x7640 , 1 ,12 ,12 ,24 ,(char *) uc2_7640 },
	{ 0x7643 , 1 ,12 ,12 ,24 ,(char *) uc2_7643 },
	{ 0x764C , 1 ,12 ,12 ,24 ,(char *) uc2_764C },
	{ 0x764D , 1 ,12 ,12 ,24 ,(char *) uc2_764D },
	{ 0x7654 , 1 ,12 ,12 ,24 ,(char *) uc2_7654 },
	{ 0x7656 , 1 ,12 ,12 ,24 ,(char *) uc2_7656 },
	{ 0x765C , 1 ,12 ,12 ,24 ,(char *) uc2_765C },
	{ 0x765E , 1 ,12 ,12 ,24 ,(char *) uc2_765E },
	{ 0x7663 , 1 ,12 ,12 ,24 ,(char *) uc2_7663 },
	{ 0x766B , 1 ,12 ,12 ,24 ,(char *) uc2_766B },
	{ 0x766F , 1 ,12 ,12 ,24 ,(char *) uc2_766F },
	{ 0x7678 , 1 ,12 ,12 ,24 ,(char *) uc2_7678 },
	{ 0x767B , 1 ,12 ,12 ,24 ,(char *) uc2_767B },
	{ 0x767D , 1 ,12 ,12 ,24 ,(char *) uc2_767D },
	{ 0x767E , 1 ,12 ,12 ,24 ,(char *) uc2_767E },
	{ 0x7682 , 1 ,12 ,12 ,24 ,(char *) uc2_7682 },
	{ 0x7684 , 1 ,12 ,12 ,24 ,(char *) uc2_7684 },
	{ 0x7686 , 1 ,12 ,12 ,24 ,(char *) uc2_7686 },
	{ 0x7687 , 1 ,12 ,12 ,24 ,(char *) uc2_7687 },
	{ 0x7688 , 1 ,12 ,12 ,24 ,(char *) uc2_7688 },
	{ 0x768B , 1 ,12 ,12 ,24 ,(char *) uc2_768B },
	{ 0x768E , 1 ,12 ,12 ,24 ,(char *) uc2_768E },
	{ 0x7691 , 1 ,12 ,12 ,24 ,(char *) uc2_7691 },
	{ 0x7693 , 1 ,12 ,12 ,24 ,(char *) uc2_7693 },
	{ 0x7696 , 1 ,12 ,12 ,24 ,(char *) uc2_7696 },
	{ 0x7699 , 1 ,12 ,12 ,24 ,(char *) uc2_7699 },
	{ 0x76A4 , 1 ,12 ,12 ,24 ,(char *) uc2_76A4 },
	{ 0x76AE , 1 ,12 ,12 ,24 ,(char *) uc2_76AE },
	{ 0x76B1 , 1 ,12 ,12 ,24 ,(char *) uc2_76B1 },
	{ 0x76B2 , 1 ,12 ,12 ,24 ,(char *) uc2_76B2 },
	{ 0x76B4 , 1 ,12 ,12 ,24 ,(char *) uc2_76B4 },
	{ 0x76BF , 1 ,12 ,12 ,24 ,(char *) uc2_76BF },
	{ 0x76C2 , 1 ,12 ,12 ,24 ,(char *) uc2_76C2 },
	{ 0x76C5 , 1 ,12 ,12 ,24 ,(char *) uc2_76C5 },
	{ 0x76C6 , 1 ,12 ,12 ,24 ,(char *) uc2_76C6 },
	{ 0x76C8 , 1 ,12 ,12 ,24 ,(char *) uc2_76C8 },
	{ 0x76CA , 1 ,12 ,12 ,24 ,(char *) uc2_76CA },
	{ 0x76CD , 1 ,12 ,12 ,24 ,(char *) uc2_76CD },
	{ 0x76CE , 1 ,12 ,12 ,24 ,(char *) uc2_76CE },
	{ 0x76CF , 1 ,12 ,12 ,24 ,(char *) uc2_76CF },
	{ 0x76D0 , 1 ,12 ,12 ,24 ,(char *) uc2_76D0 },
	{ 0x76D1 , 1 ,12 ,12 ,24 ,(char *) uc2_76D1 },
	{ 0x76D2 , 1 ,12 ,12 ,24 ,(char *) uc2_76D2 },
	{ 0x76D4 , 1 ,12 ,12 ,24 ,(char *) uc2_76D4 },
	{ 0x76D6 , 1 ,12 ,12 ,24 ,(char *) uc2_76D6 },
	{ 0x76D7 , 1 ,12 ,12 ,24 ,(char *) uc2_76D7 },
	{ 0x76D8 , 1 ,12 ,12 ,24 ,(char *) uc2_76D8 },
	{ 0x76DB , 1 ,12 ,12 ,24 ,(char *) uc2_76DB },
	{ 0x76DF , 1 ,12 ,12 ,24 ,(char *) uc2_76DF },
	{ 0x76E5 , 1 ,12 ,12 ,24 ,(char *) uc2_76E5 },
	{ 0x76EE , 1 ,12 ,12 ,24 ,(char *) uc2_76EE },
	{ 0x76EF , 1 ,12 ,12 ,24 ,(char *) uc2_76EF },
	{ 0x76F1 , 1 ,12 ,12 ,24 ,(char *) uc2_76F1 },
	{ 0x76F2 , 1 ,12 ,12 ,24 ,(char *) uc2_76F2 },
	{ 0x76F4 , 1 ,12 ,12 ,24 ,(char *) uc2_76F4 },
	{ 0x76F8 , 1 ,12 ,12 ,24 ,(char *) uc2_76F8 },
	{ 0x76F9 , 1 ,12 ,12 ,24 ,(char *) uc2_76F9 },
	{ 0x76FC , 1 ,12 ,12 ,24 ,(char *) uc2_76FC },
	{ 0x76FE , 1 ,12 ,12 ,24 ,(char *) uc2_76FE },
	{ 0x7701 , 1 ,12 ,12 ,24 ,(char *) uc2_7701 },
	{ 0x7704 , 1 ,12 ,12 ,24 ,(char *) uc2_7704 },
	{ 0x7707 , 1 ,12 ,12 ,24 ,(char *) uc2_7707 },
	{ 0x7708 , 1 ,12 ,12 ,24 ,(char *) uc2_7708 },
	{ 0x7709 , 1 ,12 ,12 ,24 ,(char *) uc2_7709 },
	{ 0x770B , 1 ,12 ,12 ,24 ,(char *) uc2_770B },
	{ 0x770D , 1 ,12 ,12 ,24 ,(char *) uc2_770D },
	{ 0x7719 , 1 ,12 ,12 ,24 ,(char *) uc2_7719 },
	{ 0x771A , 1 ,12 ,12 ,24 ,(char *) uc2_771A },
	{ 0x771F , 1 ,12 ,12 ,24 ,(char *) uc2_771F },
	{ 0x7720 , 1 ,12 ,12 ,24 ,(char *) uc2_7720 },
	{ 0x7722 , 1 ,12 ,12 ,24 ,(char *) uc2_7722 },
	{ 0x7726 , 1 ,12 ,12 ,24 ,(char *) uc2_7726 },
	{ 0x7728 , 1 ,12 ,12 ,24 ,(char *) uc2_7728 },
	{ 0x7729 , 1 ,12 ,12 ,24 ,(char *) uc2_7729 },
	{ 0x772D , 1 ,12 ,12 ,24 ,(char *) uc2_772D },
	{ 0x772F , 1 ,12 ,12 ,24 ,(char *) uc2_772F },
	{ 0x7735 , 1 ,12 ,12 ,24 ,(char *) uc2_7735 },
	{ 0x7736 , 1 ,12 ,12 ,24 ,(char *) uc2_7736 },
	{ 0x7737 , 1 ,12 ,12 ,24 ,(char *) uc2_7737 },
	{ 0x7738 , 1 ,12 ,12 ,24 ,(char *) uc2_7738 },
	{ 0x773A , 1 ,12 ,12 ,24 ,(char *) uc2_773A },
	{ 0x773C , 1 ,12 ,12 ,24 ,(char *) uc2_773C },
	{ 0x7740 , 1 ,12 ,12 ,24 ,(char *) uc2_7740 },
	{ 0x7741 , 1 ,12 ,12 ,24 ,(char *) uc2_7741 },
	{ 0x7743 , 1 ,12 ,12 ,24 ,(char *) uc2_7743 },
	{ 0x7747 , 1 ,12 ,12 ,24 ,(char *) uc2_7747 },
	{ 0x7750 , 1 ,12 ,12 ,24 ,(char *) uc2_7750 },
	{ 0x7751 , 1 ,12 ,12 ,24 ,(char *) uc2_7751 },
	{ 0x775A , 1 ,12 ,12 ,24 ,(char *) uc2_775A },
	{ 0x775B , 1 ,12 ,12 ,24 ,(char *) uc2_775B },
	{ 0x7761 , 1 ,12 ,12 ,24 ,(char *) uc2_7761 },
	{ 0x7762 , 1 ,12 ,12 ,24 ,(char *) uc2_7762 },
	{ 0x7763 , 1 ,12 ,12 ,24 ,(char *) uc2_7763 },
	{ 0x7765 , 1 ,12 ,12 ,24 ,(char *) uc2_7765 },
	{ 0x7766 , 1 ,12 ,12 ,24 ,(char *) uc2_7766 },
	{ 0x7768 , 1 ,12 ,12 ,24 ,(char *) uc2_7768 },
	{ 0x776B , 1 ,12 ,12 ,24 ,(char *) uc2_776B },
	{ 0x776C , 1 ,12 ,12 ,24 ,(char *) uc2_776C },
	{ 0x7779 , 1 ,12 ,12 ,24 ,(char *) uc2_7779 },
	{ 0x777D , 1 ,12 ,12 ,24 ,(char *) uc2_777D },
	{ 0x777E , 1 ,12 ,12 ,24 ,(char *) uc2_777E },
	{ 0x777F , 1 ,12 ,12 ,24 ,(char *) uc2_777F },
	{ 0x7780 , 1 ,12 ,12 ,24 ,(char *) uc2_7780 },
	{ 0x7784 , 1 ,12 ,12 ,24 ,(char *) uc2_7784 },
	{ 0x7785 , 1 ,12 ,12 ,24 ,(char *) uc2_7785 },
	{ 0x778C , 1 ,12 ,12 ,24 ,(char *) uc2_778C },
	{ 0x778D , 1 ,12 ,12 ,24 ,(char *) uc2_778D },
	{ 0x778E , 1 ,12 ,12 ,24 ,(char *) uc2_778E },
	{ 0x7791 , 1 ,12 ,12 ,24 ,(char *) uc2_7791 },
	{ 0x7792 , 1 ,12 ,12 ,24 ,(char *) uc2_7792 },
	{ 0x779F , 1 ,12 ,12 ,24 ,(char *) uc2_779F },
	{ 0x77A0 , 1 ,12 ,12 ,24 ,(char *) uc2_77A0 },
	{ 0x77A2 , 1 ,12 ,12 ,24 ,(char *) uc2_77A2 },
	{ 0x77A5 , 1 ,12 ,12 ,24 ,(char *) uc2_77A5 },
	{ 0x77A7 , 1 ,12 ,12 ,24 ,(char *) uc2_77A7 },
	{ 0x77A9 , 1 ,12 ,12 ,24 ,(char *) uc2_77A9 },
	{ 0x77AA , 1 ,12 ,12 ,24 ,(char *) uc2_77AA },
	{ 0x77AC , 1 ,12 ,12 ,24 ,(char *) uc2_77AC },
	{ 0x77B0 , 1 ,12 ,12 ,24 ,(char *) uc2_77B0 },
	{ 0x77B3 , 1 ,12 ,12 ,24 ,(char *) uc2_77B3 },
	{ 0x77B5 , 1 ,12 ,12 ,24 ,(char *) uc2_77B5 },
	{ 0x77BB , 1 ,12 ,12 ,24 ,(char *) uc2_77BB },
	{ 0x77BD , 1 ,12 ,12 ,24 ,(char *) uc2_77BD },
	{ 0x77BF , 1 ,12 ,12 ,24 ,(char *) uc2_77BF },
	{ 0x77CD , 1 ,12 ,12 ,24 ,(char *) uc2_77CD },
	{ 0x77D7 , 1 ,12 ,12 ,24 ,(char *) uc2_77D7 },
	{ 0x77DB , 1 ,12 ,12 ,24 ,(char *) uc2_77DB },
	{ 0x77DC , 1 ,12 ,12 ,24 ,(char *) uc2_77DC },
	{ 0x77E2 , 1 ,12 ,12 ,24 ,(char *) uc2_77E2 },
	{ 0x77E3 , 1 ,12 ,12 ,24 ,(char *) uc2_77E3 },
	{ 0x77E5 , 1 ,12 ,12 ,24 ,(char *) uc2_77E5 },
	{ 0x77E7 , 1 ,12 ,12 ,24 ,(char *) uc2_77E7 },
	{ 0x77E9 , 1 ,12 ,12 ,24 ,(char *) uc2_77E9 },
	{ 0x77EB , 1 ,12 ,12 ,24 ,(char *) uc2_77EB },
	{ 0x77EC , 1 ,12 ,12 ,24 ,(char *) uc2_77EC },
	{ 0x77ED , 1 ,12 ,12 ,24 ,(char *) uc2_77ED },
	{ 0x77EE , 1 ,12 ,12 ,24 ,(char *) uc2_77EE },
	{ 0x77F3 , 1 ,12 ,12 ,24 ,(char *) uc2_77F3 },
	{ 0x77F6 , 1 ,12 ,12 ,24 ,(char *) uc2_77F6 },
	{ 0x77F8 , 1 ,12 ,12 ,24 ,(char *) uc2_77F8 },
	{ 0x77FD , 1 ,12 ,12 ,24 ,(char *) uc2_77FD },
	{ 0x77FE , 1 ,12 ,12 ,24 ,(char *) uc2_77FE },
	{ 0x77FF , 1 ,12 ,12 ,24 ,(char *) uc2_77FF },
	{ 0x7800 , 1 ,12 ,12 ,24 ,(char *) uc2_7800 },
	{ 0x7801 , 1 ,12 ,12 ,24 ,(char *) uc2_7801 },
	{ 0x7802 , 1 ,12 ,12 ,24 ,(char *) uc2_7802 },
	{ 0x7809 , 1 ,12 ,12 ,24 ,(char *) uc2_7809 },
	{ 0x780C , 1 ,12 ,12 ,24 ,(char *) uc2_780C },
	{ 0x780D , 1 ,12 ,12 ,24 ,(char *) uc2_780D },
	{ 0x7811 , 1 ,12 ,12 ,24 ,(char *) uc2_7811 },
	{ 0x7812 , 1 ,12 ,12 ,24 ,(char *) uc2_7812 },
	{ 0x7814 , 1 ,12 ,12 ,24 ,(char *) uc2_7814 },
	{ 0x7816 , 1 ,12 ,12 ,24 ,(char *) uc2_7816 },
	{ 0x7817 , 1 ,12 ,12 ,24 ,(char *) uc2_7817 },
	{ 0x7818 , 1 ,12 ,12 ,24 ,(char *) uc2_7818 },
	{ 0x781A , 1 ,12 ,12 ,24 ,(char *) uc2_781A },
	{ 0x781C , 1 ,12 ,12 ,24 ,(char *) uc2_781C },
	{ 0x781D , 1 ,12 ,12 ,24 ,(char *) uc2_781D },
	{ 0x781F , 1 ,12 ,12 ,24 ,(char *) uc2_781F },
	{ 0x7823 , 1 ,12 ,12 ,24 ,(char *) uc2_7823 },
	{ 0x7825 , 1 ,12 ,12 ,24 ,(char *) uc2_7825 },
	{ 0x7826 , 1 ,12 ,12 ,24 ,(char *) uc2_7826 },
	{ 0x7827 , 1 ,12 ,12 ,24 ,(char *) uc2_7827 },
	{ 0x7829 , 1 ,12 ,12 ,24 ,(char *) uc2_7829 },
	{ 0x782C , 1 ,12 ,12 ,24 ,(char *) uc2_782C },
	{ 0x782D , 1 ,12 ,12 ,24 ,(char *) uc2_782D },
	{ 0x7830 , 1 ,12 ,12 ,24 ,(char *) uc2_7830 },
	{ 0x7834 , 1 ,12 ,12 ,24 ,(char *) uc2_7834 },
	{ 0x7837 , 1 ,12 ,12 ,24 ,(char *) uc2_7837 },
	{ 0x7838 , 1 ,12 ,12 ,24 ,(char *) uc2_7838 },
	{ 0x7839 , 1 ,12 ,12 ,24 ,(char *) uc2_7839 },
	{ 0x783A , 1 ,12 ,12 ,24 ,(char *) uc2_783A },
	{ 0x783B , 1 ,12 ,12 ,24 ,(char *) uc2_783B },
	{ 0x783C , 1 ,12 ,12 ,24 ,(char *) uc2_783C },
	{ 0x783E , 1 ,12 ,12 ,24 ,(char *) uc2_783E },
	{ 0x7840 , 1 ,12 ,12 ,24 ,(char *) uc2_7840 },
	{ 0x7845 , 1 ,12 ,12 ,24 ,(char *) uc2_7845 },
	{ 0x7847 , 1 ,12 ,12 ,24 ,(char *) uc2_7847 },
	{ 0x784C , 1 ,12 ,12 ,24 ,(char *) uc2_784C },
	{ 0x784E , 1 ,12 ,12 ,24 ,(char *) uc2_784E },
	{ 0x7850 , 1 ,12 ,12 ,24 ,(char *) uc2_7850 },
	{ 0x7852 , 1 ,12 ,12 ,24 ,(char *) uc2_7852 },
	{ 0x7855 , 1 ,12 ,12 ,24 ,(char *) uc2_7855 },
	{ 0x7856 , 1 ,12 ,12 ,24 ,(char *) uc2_7856 },
	{ 0x7857 , 1 ,12 ,12 ,24 ,(char *) uc2_7857 },
	{ 0x785D , 1 ,12 ,12 ,24 ,(char *) uc2_785D },
	{ 0x786A , 1 ,12 ,12 ,24 ,(char *) uc2_786A },
	{ 0x786B , 1 ,12 ,12 ,24 ,(char *) uc2_786B },
	{ 0x786C , 1 ,12 ,12 ,24 ,(char *) uc2_786C },
	{ 0x786D , 1 ,12 ,12 ,24 ,(char *) uc2_786D },
	{ 0x786E , 1 ,12 ,12 ,24 ,(char *) uc2_786E },
	{ 0x7877 , 1 ,12 ,12 ,24 ,(char *) uc2_7877 },
	{ 0x787C , 1 ,12 ,12 ,24 ,(char *) uc2_787C },
	{ 0x7887 , 1 ,12 ,12 ,24 ,(char *) uc2_7887 },
	{ 0x7889 , 1 ,12 ,12 ,24 ,(char *) uc2_7889 },
	{ 0x788C , 1 ,12 ,12 ,24 ,(char *) uc2_788C },
	{ 0x788D , 1 ,12 ,12 ,24 ,(char *) uc2_788D },
	{ 0x788E , 1 ,12 ,12 ,24 ,(char *) uc2_788E },
	{ 0x7891 , 1 ,12 ,12 ,24 ,(char *) uc2_7891 },
	{ 0x7893 , 1 ,12 ,12 ,24 ,(char *) uc2_7893 },
	{ 0x7897 , 1 ,12 ,12 ,24 ,(char *) uc2_7897 },
	{ 0x7898 , 1 ,12 ,12 ,24 ,(char *) uc2_7898 },
	{ 0x789A , 1 ,12 ,12 ,24 ,(char *) uc2_789A },
	{ 0x789B , 1 ,12 ,12 ,24 ,(char *) uc2_789B },
	{ 0x789C , 1 ,12 ,12 ,24 ,(char *) uc2_789C },
	{ 0x789F , 1 ,12 ,12 ,24 ,(char *) uc2_789F },
	{ 0x78A1 , 1 ,12 ,12 ,24 ,(char *) uc2_78A1 },
	{ 0x78A3 , 1 ,12 ,12 ,24 ,(char *) uc2_78A3 },
	{ 0x78A5 , 1 ,12 ,12 ,24 ,(char *) uc2_78A5 },
	{ 0x78A7 , 1 ,12 ,12 ,24 ,(char *) uc2_78A7 },
	{ 0x78B0 , 1 ,12 ,12 ,24 ,(char *) uc2_78B0 },
	{ 0x78B1 , 1 ,12 ,12 ,24 ,(char *) uc2_78B1 },
	{ 0x78B2 , 1 ,12 ,12 ,24 ,(char *) uc2_78B2 },
	{ 0x78B3 , 1 ,12 ,12 ,24 ,(char *) uc2_78B3 },
	{ 0x78B4 , 1 ,12 ,12 ,24 ,(char *) uc2_78B4 },
	{ 0x78B9 , 1 ,12 ,12 ,24 ,(char *) uc2_78B9 },
	{ 0x78BE , 1 ,12 ,12 ,24 ,(char *) uc2_78BE },
	{ 0x78C1 , 1 ,12 ,12 ,24 ,(char *) uc2_78C1 },
	{ 0x78C5 , 1 ,12 ,12 ,24 ,(char *) uc2_78C5 },
	{ 0x78C9 , 1 ,12 ,12 ,24 ,(char *) uc2_78C9 },
	{ 0x78CA , 1 ,12 ,12 ,24 ,(char *) uc2_78CA },
	{ 0x78CB , 1 ,12 ,12 ,24 ,(char *) uc2_78CB },
	{ 0x78D0 , 1 ,12 ,12 ,24 ,(char *) uc2_78D0 },
	{ 0x78D4 , 1 ,12 ,12 ,24 ,(char *) uc2_78D4 },
	{ 0x78D5 , 1 ,12 ,12 ,24 ,(char *) uc2_78D5 },
	{ 0x78D9 , 1 ,12 ,12 ,24 ,(char *) uc2_78D9 },
	{ 0x78E8 , 1 ,12 ,12 ,24 ,(char *) uc2_78E8 },
	{ 0x78EC , 1 ,12 ,12 ,24 ,(char *) uc2_78EC },
	{ 0x78F2 , 1 ,12 ,12 ,24 ,(char *) uc2_78F2 },
	{ 0x78F4 , 1 ,12 ,12 ,24 ,(char *) uc2_78F4 },
	{ 0x78F7 , 1 ,12 ,12 ,24 ,(char *) uc2_78F7 },
	{ 0x78FA , 1 ,12 ,12 ,24 ,(char *) uc2_78FA },
	{ 0x7901 , 1 ,12 ,12 ,24 ,(char *) uc2_7901 },
	{ 0x7905 , 1 ,12 ,12 ,24 ,(char *) uc2_7905 },
	{ 0x7913 , 1 ,12 ,12 ,24 ,(char *) uc2_7913 },
	{ 0x791E , 1 ,12 ,12 ,24 ,(char *) uc2_791E },
	{ 0x7924 , 1 ,12 ,12 ,24 ,(char *) uc2_7924 },
	{ 0x7934 , 1 ,12 ,12 ,24 ,(char *) uc2_7934 },
	{ 0x793A , 1 ,12 ,12 ,24 ,(char *) uc2_793A },
	{ 0x793C , 1 ,12 ,12 ,24 ,(char *) uc2_793C },
	{ 0x793E , 1 ,12 ,12 ,24 ,(char *) uc2_793E },
	{ 0x7940 , 1 ,12 ,12 ,24 ,(char *) uc2_7940 },
	{ 0x7941 , 1 ,12 ,12 ,24 ,(char *) uc2_7941 },
	{ 0x7946 , 1 ,12 ,12 ,24 ,(char *) uc2_7946 },
	{ 0x7948 , 1 ,12 ,12 ,24 ,(char *) uc2_7948 },
	{ 0x7949 , 1 ,12 ,12 ,24 ,(char *) uc2_7949 },
	{ 0x7953 , 1 ,12 ,12 ,24 ,(char *) uc2_7953 },
	{ 0x7956 , 1 ,12 ,12 ,24 ,(char *) uc2_7956 },
	{ 0x7957 , 1 ,12 ,12 ,24 ,(char *) uc2_7957 },
	{ 0x795A , 1 ,12 ,12 ,24 ,(char *) uc2_795A },
	{ 0x795B , 1 ,12 ,12 ,24 ,(char *) uc2_795B },
	{ 0x795C , 1 ,12 ,12 ,24 ,(char *) uc2_795C },
	{ 0x795D , 1 ,12 ,12 ,24 ,(char *) uc2_795D },
	{ 0x795E , 1 ,12 ,12 ,24 ,(char *) uc2_795E },
	{ 0x795F , 1 ,12 ,12 ,24 ,(char *) uc2_795F },
	{ 0x7960 , 1 ,12 ,12 ,24 ,(char *) uc2_7960 },
	{ 0x7962 , 1 ,12 ,12 ,24 ,(char *) uc2_7962 },
	{ 0x7965 , 1 ,12 ,12 ,24 ,(char *) uc2_7965 },
	{ 0x7967 , 1 ,12 ,12 ,24 ,(char *) uc2_7967 },
	{ 0x7968 , 1 ,12 ,12 ,24 ,(char *) uc2_7968 },
	{ 0x796D , 1 ,12 ,12 ,24 ,(char *) uc2_796D },
	{ 0x796F , 1 ,12 ,12 ,24 ,(char *) uc2_796F },
	{ 0x7977 , 1 ,12 ,12 ,24 ,(char *) uc2_7977 },
	{ 0x7978 , 1 ,12 ,12 ,24 ,(char *) uc2_7978 },
	{ 0x797A , 1 ,12 ,12 ,24 ,(char *) uc2_797A },
	{ 0x7980 , 1 ,12 ,12 ,24 ,(char *) uc2_7980 },
	{ 0x7981 , 1 ,12 ,12 ,24 ,(char *) uc2_7981 },
	{ 0x7984 , 1 ,12 ,12 ,24 ,(char *) uc2_7984 },
	{ 0x7985 , 1 ,12 ,12 ,24 ,(char *) uc2_7985 },
	{ 0x798A , 1 ,12 ,12 ,24 ,(char *) uc2_798A },
	{ 0x798F , 1 ,12 ,12 ,24 ,(char *) uc2_798F },
	{ 0x799A , 1 ,12 ,12 ,24 ,(char *) uc2_799A },
	{ 0x79A7 , 1 ,12 ,12 ,24 ,(char *) uc2_79A7 },
	{ 0x79B3 , 1 ,12 ,12 ,24 ,(char *) uc2_79B3 },
	{ 0x79B9 , 1 ,12 ,12 ,24 ,(char *) uc2_79B9 },
	{ 0x79BA , 1 ,12 ,12 ,24 ,(char *) uc2_79BA },
	{ 0x79BB , 1 ,12 ,12 ,24 ,(char *) uc2_79BB },
	{ 0x79BD , 1 ,12 ,12 ,24 ,(char *) uc2_79BD },
	{ 0x79BE , 1 ,12 ,12 ,24 ,(char *) uc2_79BE },
	{ 0x79C0 , 1 ,12 ,12 ,24 ,(char *) uc2_79C0 },
	{ 0x79C1 , 1 ,12 ,12 ,24 ,(char *) uc2_79C1 },
	{ 0x79C3 , 1 ,12 ,12 ,24 ,(char *) uc2_79C3 },
	{ 0x79C6 , 1 ,12 ,12 ,24 ,(char *) uc2_79C6 },
	{ 0x79C9 , 1 ,12 ,12 ,24 ,(char *) uc2_79C9 },
	{ 0x79CB , 1 ,12 ,12 ,24 ,(char *) uc2_79CB },
	{ 0x79CD , 1 ,12 ,12 ,24 ,(char *) uc2_79CD },
	{ 0x79D1 , 1 ,12 ,12 ,24 ,(char *) uc2_79D1 },
	{ 0x79D2 , 1 ,12 ,12 ,24 ,(char *) uc2_79D2 },
	{ 0x79D5 , 1 ,12 ,12 ,24 ,(char *) uc2_79D5 },
	{ 0x79D8 , 1 ,12 ,12 ,24 ,(char *) uc2_79D8 },
	{ 0x79DF , 1 ,12 ,12 ,24 ,(char *) uc2_79DF },
	{ 0x79E3 , 1 ,12 ,12 ,24 ,(char *) uc2_79E3 },
	{ 0x79E4 , 1 ,12 ,12 ,24 ,(char *) uc2_79E4 },
	{ 0x79E6 , 1 ,12 ,12 ,24 ,(char *) uc2_79E6 },
	{ 0x79E7 , 1 ,12 ,12 ,24 ,(char *) uc2_79E7 },
	{ 0x79E9 , 1 ,12 ,12 ,24 ,(char *) uc2_79E9 },
	{ 0x79EB , 1 ,12 ,12 ,24 ,(char *) uc2_79EB },
	{ 0x79ED , 1 ,12 ,12 ,24 ,(char *) uc2_79ED },
	{ 0x79EF , 1 ,12 ,12 ,24 ,(char *) uc2_79EF },
	{ 0x79F0 , 1 ,12 ,12 ,24 ,(char *) uc2_79F0 },
	{ 0x79F8 , 1 ,12 ,12 ,24 ,(char *) uc2_79F8 },
	{ 0x79FD , 1 ,12 ,12 ,24 ,(char *) uc2_79FD },
	{ 0x7A00 , 1 ,12 ,12 ,24 ,(char *) uc2_7A00 },
	{ 0x7A02 , 1 ,12 ,12 ,24 ,(char *) uc2_7A02 },
	{ 0x7A03 , 1 ,12 ,12 ,24 ,(char *) uc2_7A03 },
	{ 0x7A06 , 1 ,12 ,12 ,24 ,(char *) uc2_7A06 },
	{ 0x7A0B , 1 ,12 ,12 ,24 ,(char *) uc2_7A0B },
	{ 0x7A0D , 1 ,12 ,12 ,24 ,(char *) uc2_7A0D },
	{ 0x7A0E , 1 ,12 ,12 ,24 ,(char *) uc2_7A0E },
	{ 0x7A14 , 1 ,12 ,12 ,24 ,(char *) uc2_7A14 },
	{ 0x7A17 , 1 ,12 ,12 ,24 ,(char *) uc2_7A17 },
	{ 0x7A1A , 1 ,12 ,12 ,24 ,(char *) uc2_7A1A },
	{ 0x7A1E , 1 ,12 ,12 ,24 ,(char *) uc2_7A1E },
	{ 0x7A20 , 1 ,12 ,12 ,24 ,(char *) uc2_7A20 },
	{ 0x7A23 , 1 ,12 ,12 ,24 ,(char *) uc2_7A23 },
	{ 0x7A33 , 1 ,12 ,12 ,24 ,(char *) uc2_7A33 },
	{ 0x7A37 , 1 ,12 ,12 ,24 ,(char *) uc2_7A37 },
	{ 0x7A39 , 1 ,12 ,12 ,24 ,(char *) uc2_7A39 },
	{ 0x7A3B , 1 ,12 ,12 ,24 ,(char *) uc2_7A3B },
	{ 0x7A3C , 1 ,12 ,12 ,24 ,(char *) uc2_7A3C },
	{ 0x7A3D , 1 ,12 ,12 ,24 ,(char *) uc2_7A3D },
	{ 0x7A3F , 1 ,12 ,12 ,24 ,(char *) uc2_7A3F },
	{ 0x7A46 , 1 ,12 ,12 ,24 ,(char *) uc2_7A46 },
	{ 0x7A51 , 1 ,12 ,12 ,24 ,(char *) uc2_7A51 },
	{ 0x7A57 , 1 ,12 ,12 ,24 ,(char *) uc2_7A57 },
	{ 0x7A70 , 1 ,12 ,12 ,24 ,(char *) uc2_7A70 },
	{ 0x7A74 , 1 ,12 ,12 ,24 ,(char *) uc2_7A74 },
	{ 0x7A76 , 1 ,12 ,12 ,24 ,(char *) uc2_7A76 },
	{ 0x7A77 , 1 ,12 ,12 ,24 ,(char *) uc2_7A77 },
	{ 0x7A78 , 1 ,12 ,12 ,24 ,(char *) uc2_7A78 },
	{ 0x7A79 , 1 ,12 ,12 ,24 ,(char *) uc2_7A79 },
	{ 0x7A7A , 1 ,12 ,12 ,24 ,(char *) uc2_7A7A },
	{ 0x7A7F , 1 ,12 ,12 ,24 ,(char *) uc2_7A7F },
	{ 0x7A80 , 1 ,12 ,12 ,24 ,(char *) uc2_7A80 },
	{ 0x7A81 , 1 ,12 ,12 ,24 ,(char *) uc2_7A81 },
	{ 0x7A83 , 1 ,12 ,12 ,24 ,(char *) uc2_7A83 },
	{ 0x7A84 , 1 ,12 ,12 ,24 ,(char *) uc2_7A84 },
	{ 0x7A86 , 1 ,12 ,12 ,24 ,(char *) uc2_7A86 },
	{ 0x7A88 , 1 ,12 ,12 ,24 ,(char *) uc2_7A88 },
	{ 0x7A8D , 1 ,12 ,12 ,24 ,(char *) uc2_7A8D },
	{ 0x7A91 , 1 ,12 ,12 ,24 ,(char *) uc2_7A91 },
	{ 0x7A92 , 1 ,12 ,12 ,24 ,(char *) uc2_7A92 },
	{ 0x7A95 , 1 ,12 ,12 ,24 ,(char *) uc2_7A95 },
	{ 0x7A96 , 1 ,12 ,12 ,24 ,(char *) uc2_7A96 },
	{ 0x7A97 , 1 ,12 ,12 ,24 ,(char *) uc2_7A97 },
	{ 0x7A98 , 1 ,12 ,12 ,24 ,(char *) uc2_7A98 },
	{ 0x7A9C , 1 ,12 ,12 ,24 ,(char *) uc2_7A9C },
	{ 0x7A9D , 1 ,12 ,12 ,24 ,(char *) uc2_7A9D },
	{ 0x7A9F , 1 ,12 ,12 ,24 ,(char *) uc2_7A9F },
	{ 0x7AA0 , 1 ,12 ,12 ,24 ,(char *) uc2_7AA0 },
	{ 0x7AA5 , 1 ,12 ,12 ,24 ,(char *) uc2_7AA5 },
	{ 0x7AA6 , 1 ,12 ,12 ,24 ,(char *) uc2_7AA6 },
	{ 0x7AA8 , 1 ,12 ,12 ,24 ,(char *) uc2_7AA8 },
	{ 0x7AAC , 1 ,12 ,12 ,24 ,(char *) uc2_7AAC },
	{ 0x7AAD , 1 ,12 ,12 ,24 ,(char *) uc2_7AAD },
	{ 0x7AB3 , 1 ,12 ,12 ,24 ,(char *) uc2_7AB3 },
	{ 0x7ABF , 1 ,12 ,12 ,24 ,(char *) uc2_7ABF },
	{ 0x7ACB , 1 ,12 ,12 ,24 ,(char *) uc2_7ACB },
	{ 0x7AD6 , 1 ,12 ,12 ,24 ,(char *) uc2_7AD6 },
	{ 0x7AD9 , 1 ,12 ,12 ,24 ,(char *) uc2_7AD9 },
	{ 0x7ADE , 1 ,12 ,12 ,24 ,(char *) uc2_7ADE },
	{ 0x7ADF , 1 ,12 ,12 ,24 ,(char *) uc2_7ADF },
	{ 0x7AE0 , 1 ,12 ,12 ,24 ,(char *) uc2_7AE0 },
	{ 0x7AE3 , 1 ,12 ,12 ,24 ,(char *) uc2_7AE3 },
	{ 0x7AE5 , 1 ,12 ,12 ,24 ,(char *) uc2_7AE5 },
	{ 0x7AE6 , 1 ,12 ,12 ,24 ,(char *) uc2_7AE6 },
	{ 0x7AED , 1 ,12 ,12 ,24 ,(char *) uc2_7AED },
	{ 0x7AEF , 1 ,12 ,12 ,24 ,(char *) uc2_7AEF },
	{ 0x7AF9 , 1 ,12 ,12 ,24 ,(char *) uc2_7AF9 },
	{ 0x7AFA , 1 ,12 ,12 ,24 ,(char *) uc2_7AFA },
	{ 0x7AFD , 1 ,12 ,12 ,24 ,(char *) uc2_7AFD },
	{ 0x7AFF , 1 ,12 ,12 ,24 ,(char *) uc2_7AFF },
	{ 0x7B03 , 1 ,12 ,12 ,24 ,(char *) uc2_7B03 },
	{ 0x7B04 , 1 ,12 ,12 ,24 ,(char *) uc2_7B04 },
	{ 0x7B06 , 1 ,12 ,12 ,24 ,(char *) uc2_7B06 },
	{ 0x7B08 , 1 ,12 ,12 ,24 ,(char *) uc2_7B08 },
	{ 0x7B0A , 1 ,12 ,12 ,24 ,(char *) uc2_7B0A },
	{ 0x7B0B , 1 ,12 ,12 ,24 ,(char *) uc2_7B0B },
	{ 0x7B0F , 1 ,12 ,12 ,24 ,(char *) uc2_7B0F },
	{ 0x7B11 , 1 ,12 ,12 ,24 ,(char *) uc2_7B11 },
	{ 0x7B14 , 1 ,12 ,12 ,24 ,(char *) uc2_7B14 },
	{ 0x7B15 , 1 ,12 ,12 ,24 ,(char *) uc2_7B15 },
	{ 0x7B19 , 1 ,12 ,12 ,24 ,(char *) uc2_7B19 },
	{ 0x7B1B , 1 ,12 ,12 ,24 ,(char *) uc2_7B1B },
	{ 0x7B1E , 1 ,12 ,12 ,24 ,(char *) uc2_7B1E },
	{ 0x7B20 , 1 ,12 ,12 ,24 ,(char *) uc2_7B20 },
	{ 0x7B24 , 1 ,12 ,12 ,24 ,(char *) uc2_7B24 },
	{ 0x7B25 , 1 ,12 ,12 ,24 ,(char *) uc2_7B25 },
	{ 0x7B26 , 1 ,12 ,12 ,24 ,(char *) uc2_7B26 },
	{ 0x7B28 , 1 ,12 ,12 ,24 ,(char *) uc2_7B28 },
	{ 0x7B2A , 1 ,12 ,12 ,24 ,(char *) uc2_7B2A },
	{ 0x7B2B , 1 ,12 ,12 ,24 ,(char *) uc2_7B2B },
	{ 0x7B2C , 1 ,12 ,12 ,24 ,(char *) uc2_7B2C },
	{ 0x7B2E , 1 ,12 ,12 ,24 ,(char *) uc2_7B2E },
	{ 0x7B31 , 1 ,12 ,12 ,24 ,(char *) uc2_7B31 },
	{ 0x7B33 , 1 ,12 ,12 ,24 ,(char *) uc2_7B33 },
	{ 0x7B38 , 1 ,12 ,12 ,24 ,(char *) uc2_7B38 },
	{ 0x7B3A , 1 ,12 ,12 ,24 ,(char *) uc2_7B3A },
	{ 0x7B3C , 1 ,12 ,12 ,24 ,(char *) uc2_7B3C },
	{ 0x7B3E , 1 ,12 ,12 ,24 ,(char *) uc2_7B3E },
	{ 0x7B45 , 1 ,12 ,12 ,24 ,(char *) uc2_7B45 },
	{ 0x7B47 , 1 ,12 ,12 ,24 ,(char *) uc2_7B47 },
	{ 0x7B49 , 1 ,12 ,12 ,24 ,(char *) uc2_7B49 },
	{ 0x7B4B , 1 ,12 ,12 ,24 ,(char *) uc2_7B4B },
	{ 0x7B4C , 1 ,12 ,12 ,24 ,(char *) uc2_7B4C },
	{ 0x7B4F , 1 ,12 ,12 ,24 ,(char *) uc2_7B4F },
	{ 0x7B50 , 1 ,12 ,12 ,24 ,(char *) uc2_7B50 },
	{ 0x7B51 , 1 ,12 ,12 ,24 ,(char *) uc2_7B51 },
	{ 0x7B52 , 1 ,12 ,12 ,24 ,(char *) uc2_7B52 },
	{ 0x7B54 , 1 ,12 ,12 ,24 ,(char *) uc2_7B54 },
	{ 0x7B56 , 1 ,12 ,12 ,24 ,(char *) uc2_7B56 },
	{ 0x7B58 , 1 ,12 ,12 ,24 ,(char *) uc2_7B58 },
	{ 0x7B5A , 1 ,12 ,12 ,24 ,(char *) uc2_7B5A },
	{ 0x7B5B , 1 ,12 ,12 ,24 ,(char *) uc2_7B5B },
	{ 0x7B5D , 1 ,12 ,12 ,24 ,(char *) uc2_7B5D },
	{ 0x7B60 , 1 ,12 ,12 ,24 ,(char *) uc2_7B60 },
	{ 0x7B62 , 1 ,12 ,12 ,24 ,(char *) uc2_7B62 },
	{ 0x7B6E , 1 ,12 ,12 ,24 ,(char *) uc2_7B6E },
	{ 0x7B71 , 1 ,12 ,12 ,24 ,(char *) uc2_7B71 },
	{ 0x7B72 , 1 ,12 ,12 ,24 ,(char *) uc2_7B72 },
	{ 0x7B75 , 1 ,12 ,12 ,24 ,(char *) uc2_7B75 },
	{ 0x7B77 , 1 ,12 ,12 ,24 ,(char *) uc2_7B77 },
	{ 0x7B79 , 1 ,12 ,12 ,24 ,(char *) uc2_7B79 },
	{ 0x7B7B , 1 ,12 ,12 ,24 ,(char *) uc2_7B7B },
	{ 0x7B7E , 1 ,12 ,12 ,24 ,(char *) uc2_7B7E },
	{ 0x7B80 , 1 ,12 ,12 ,24 ,(char *) uc2_7B80 },
	{ 0x7B85 , 1 ,12 ,12 ,24 ,(char *) uc2_7B85 },
	{ 0x7B8D , 1 ,12 ,12 ,24 ,(char *) uc2_7B8D },
	{ 0x7B90 , 1 ,12 ,12 ,24 ,(char *) uc2_7B90 },
	{ 0x7B94 , 1 ,12 ,12 ,24 ,(char *) uc2_7B94 },
	{ 0x7B95 , 1 ,12 ,12 ,24 ,(char *) uc2_7B95 },
	{ 0x7B97 , 1 ,12 ,12 ,24 ,(char *) uc2_7B97 },
	{ 0x7B9C , 1 ,12 ,12 ,24 ,(char *) uc2_7B9C },
	{ 0x7B9D , 1 ,12 ,12 ,24 ,(char *) uc2_7B9D },
	{ 0x7BA1 , 1 ,12 ,12 ,24 ,(char *) uc2_7BA1 },
	{ 0x7BA2 , 1 ,12 ,12 ,24 ,(char *) uc2_7BA2 },
	{ 0x7BA6 , 1 ,12 ,12 ,24 ,(char *) uc2_7BA6 },
	{ 0x7BA7 , 1 ,12 ,12 ,24 ,(char *) uc2_7BA7 },
	{ 0x7BA8 , 1 ,12 ,12 ,24 ,(char *) uc2_7BA8 },
	{ 0x7BA9 , 1 ,12 ,12 ,24 ,(char *) uc2_7BA9 },
	{ 0x7BAA , 1 ,12 ,12 ,24 ,(char *) uc2_7BAA },
	{ 0x7BAB , 1 ,12 ,12 ,24 ,(char *) uc2_7BAB },
	{ 0x7BAC , 1 ,12 ,12 ,24 ,(char *) uc2_7BAC },
	{ 0x7BAD , 1 ,12 ,12 ,24 ,(char *) uc2_7BAD },
	{ 0x7BB1 , 1 ,12 ,12 ,24 ,(char *) uc2_7BB1 },
	{ 0x7BB4 , 1 ,12 ,12 ,24 ,(char *) uc2_7BB4 },
	{ 0x7BB8 , 1 ,12 ,12 ,24 ,(char *) uc2_7BB8 },
	{ 0x7BC1 , 1 ,12 ,12 ,24 ,(char *) uc2_7BC1 },
	{ 0x7BC6 , 1 ,12 ,12 ,24 ,(char *) uc2_7BC6 },
	{ 0x7BC7 , 1 ,12 ,12 ,24 ,(char *) uc2_7BC7 },
	{ 0x7BCC , 1 ,12 ,12 ,24 ,(char *) uc2_7BCC },
	{ 0x7BD1 , 1 ,12 ,12 ,24 ,(char *) uc2_7BD1 },
	{ 0x7BD3 , 1 ,12 ,12 ,24 ,(char *) uc2_7BD3 },
	{ 0x7BD9 , 1 ,12 ,12 ,24 ,(char *) uc2_7BD9 },
	{ 0x7BDA , 1 ,12 ,12 ,24 ,(char *) uc2_7BDA },
	{ 0x7BDD , 1 ,12 ,12 ,24 ,(char *) uc2_7BDD },
	{ 0x7BE1 , 1 ,12 ,12 ,24 ,(char *) uc2_7BE1 },
	{ 0x7BE5 , 1 ,12 ,12 ,24 ,(char *) uc2_7BE5 },
	{ 0x7BE6 , 1 ,12 ,12 ,24 ,(char *) uc2_7BE6 },
	{ 0x7BEA , 1 ,12 ,12 ,24 ,(char *) uc2_7BEA },
	{ 0x7BEE , 1 ,12 ,12 ,24 ,(char *) uc2_7BEE },
	{ 0x7BF1 , 1 ,12 ,12 ,24 ,(char *) uc2_7BF1 },
	{ 0x7BF7 , 1 ,12 ,12 ,24 ,(char *) uc2_7BF7 },
	{ 0x7BFC , 1 ,12 ,12 ,24 ,(char *) uc2_7BFC },
	{ 0x7BFE , 1 ,12 ,12 ,24 ,(char *) uc2_7BFE },
	{ 0x7C07 , 1 ,12 ,12 ,24 ,(char *) uc2_7C07 },
	{ 0x7C0B , 1 ,12 ,12 ,24 ,(char *) uc2_7C0B },
	{ 0x7C0C , 1 ,12 ,12 ,24 ,(char *) uc2_7C0C },
	{ 0x7C0F , 1 ,12 ,12 ,24 ,(char *) uc2_7C0F },
	{ 0x7C16 , 1 ,12 ,12 ,24 ,(char *) uc2_7C16 },
	{ 0x7C1F , 1 ,12 ,12 ,24 ,(char *) uc2_7C1F },
	{ 0x7C26 , 1 ,12 ,12 ,24 ,(char *) uc2_7C26 },
	{ 0x7C27 , 1 ,12 ,12 ,24 ,(char *) uc2_7C27 },
	{ 0x7C2A , 1 ,12 ,12 ,24 ,(char *) uc2_7C2A },
	{ 0x7C38 , 1 ,12 ,12 ,24 ,(char *) uc2_7C38 },
	{ 0x7C3F , 1 ,12 ,12 ,24 ,(char *) uc2_7C3F },
	{ 0x7C40 , 1 ,12 ,12 ,24 ,(char *) uc2_7C40 },
	{ 0x7C41 , 1 ,12 ,12 ,24 ,(char *) uc2_7C41 },
	{ 0x7C4D , 1 ,12 ,12 ,24 ,(char *) uc2_7C4D },
	{ 0x7C73 , 1 ,12 ,12 ,24 ,(char *) uc2_7C73 },
	{ 0x7C74 , 1 ,12 ,12 ,24 ,(char *) uc2_7C74 },
	{ 0x7C7B , 1 ,12 ,12 ,24 ,(char *) uc2_7C7B },
	{ 0x7C7C , 1 ,12 ,12 ,24 ,(char *) uc2_7C7C },
	{ 0x7C7D , 1 ,12 ,12 ,24 ,(char *) uc2_7C7D },
	{ 0x7C89 , 1 ,12 ,12 ,24 ,(char *) uc2_7C89 },
	{ 0x7C91 , 1 ,12 ,12 ,24 ,(char *) uc2_7C91 },
	{ 0x7C92 , 1 ,12 ,12 ,24 ,(char *) uc2_7C92 },
	{ 0x7C95 , 1 ,12 ,12 ,24 ,(char *) uc2_7C95 },
	{ 0x7C97 , 1 ,12 ,12 ,24 ,(char *) uc2_7C97 },
	{ 0x7C98 , 1 ,12 ,12 ,24 ,(char *) uc2_7C98 },
	{ 0x7C9C , 1 ,12 ,12 ,24 ,(char *) uc2_7C9C },
	{ 0x7C9D , 1 ,12 ,12 ,24 ,(char *) uc2_7C9D },
	{ 0x7C9E , 1 ,12 ,12 ,24 ,(char *) uc2_7C9E },
	{ 0x7C9F , 1 ,12 ,12 ,24 ,(char *) uc2_7C9F },
	{ 0x7CA2 , 1 ,12 ,12 ,24 ,(char *) uc2_7CA2 },
	{ 0x7CA4 , 1 ,12 ,12 ,24 ,(char *) uc2_7CA4 },
	{ 0x7CA5 , 1 ,12 ,12 ,24 ,(char *) uc2_7CA5 },
	{ 0x7CAA , 1 ,12 ,12 ,24 ,(char *) uc2_7CAA },
	{ 0x7CAE , 1 ,12 ,12 ,24 ,(char *) uc2_7CAE },
	{ 0x7CB1 , 1 ,12 ,12 ,24 ,(char *) uc2_7CB1 },
	{ 0x7CB2 , 1 ,12 ,12 ,24 ,(char *) uc2_7CB2 },
	{ 0x7CB3 , 1 ,12 ,12 ,24 ,(char *) uc2_7CB3 },
	{ 0x7CB9 , 1 ,12 ,12 ,24 ,(char *) uc2_7CB9 },
	{ 0x7CBC , 1 ,12 ,12 ,24 ,(char *) uc2_7CBC },
	{ 0x7CBD , 1 ,12 ,12 ,24 ,(char *) uc2_7CBD },
	{ 0x7CBE , 1 ,12 ,12 ,24 ,(char *) uc2_7CBE },
	{ 0x7CC1 , 1 ,12 ,12 ,24 ,(char *) uc2_7CC1 },
	{ 0x7CC5 , 1 ,12 ,12 ,24 ,(char *) uc2_7CC5 },
	{ 0x7CC7 , 1 ,12 ,12 ,24 ,(char *) uc2_7CC7 },
	{ 0x7CC8 , 1 ,12 ,12 ,24 ,(char *) uc2_7CC8 },
	{ 0x7CCA , 1 ,12 ,12 ,24 ,(char *) uc2_7CCA },
	{ 0x7CCC , 1 ,12 ,12 ,24 ,(char *) uc2_7CCC },
	{ 0x7CCD , 1 ,12 ,12 ,24 ,(char *) uc2_7CCD },
	{ 0x7CD5 , 1 ,12 ,12 ,24 ,(char *) uc2_7CD5 },
	{ 0x7CD6 , 1 ,12 ,12 ,24 ,(char *) uc2_7CD6 },
	{ 0x7CD7 , 1 ,12 ,12 ,24 ,(char *) uc2_7CD7 },
	{ 0x7CD9 , 1 ,12 ,12 ,24 ,(char *) uc2_7CD9 },
	{ 0x7CDC , 1 ,12 ,12 ,24 ,(char *) uc2_7CDC },
	{ 0x7CDF , 1 ,12 ,12 ,24 ,(char *) uc2_7CDF },
	{ 0x7CE0 , 1 ,12 ,12 ,24 ,(char *) uc2_7CE0 },
	{ 0x7CE8 , 1 ,12 ,12 ,24 ,(char *) uc2_7CE8 },
	{ 0x7CEF , 1 ,12 ,12 ,24 ,(char *) uc2_7CEF },
	{ 0x7CF8 , 1 ,12 ,12 ,24 ,(char *) uc2_7CF8 },
	{ 0x7CFB , 1 ,12 ,12 ,24 ,(char *) uc2_7CFB },
	{ 0x7D0A , 1 ,12 ,12 ,24 ,(char *) uc2_7D0A },
	{ 0x7D20 , 1 ,12 ,12 ,24 ,(char *) uc2_7D20 },
	{ 0x7D22 , 1 ,12 ,12 ,24 ,(char *) uc2_7D22 },
	{ 0x7D27 , 1 ,12 ,12 ,24 ,(char *) uc2_7D27 },
	{ 0x7D2B , 1 ,12 ,12 ,24 ,(char *) uc2_7D2B },
	{ 0x7D2F , 1 ,12 ,12 ,24 ,(char *) uc2_7D2F },
	{ 0x7D6E , 1 ,12 ,12 ,24 ,(char *) uc2_7D6E },
	{ 0x7D77 , 1 ,12 ,12 ,24 ,(char *) uc2_7D77 },
	{ 0x7DA6 , 1 ,12 ,12 ,24 ,(char *) uc2_7DA6 },
	{ 0x7DAE , 1 ,12 ,12 ,24 ,(char *) uc2_7DAE },
	{ 0x7E3B , 1 ,12 ,12 ,24 ,(char *) uc2_7E3B },
	{ 0x7E41 , 1 ,12 ,12 ,24 ,(char *) uc2_7E41 },
	{ 0x7E47 , 1 ,12 ,12 ,24 ,(char *) uc2_7E47 },
	{ 0x7E82 , 1 ,12 ,12 ,24 ,(char *) uc2_7E82 },
	{ 0x7E9B , 1 ,12 ,12 ,24 ,(char *) uc2_7E9B },
	{ 0x7E9F , 1 ,12 ,12 ,24 ,(char *) uc2_7E9F },
	{ 0x7EA0 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA0 },
	{ 0x7EA1 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA1 },
	{ 0x7EA2 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA2 },
	{ 0x7EA3 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA3 },
	{ 0x7EA4 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA4 },
	{ 0x7EA5 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA5 },
	{ 0x7EA6 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA6 },
	{ 0x7EA7 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA7 },
	{ 0x7EA8 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA8 },
	{ 0x7EA9 , 1 ,12 ,12 ,24 ,(char *) uc2_7EA9 },
	{ 0x7EAA , 1 ,12 ,12 ,24 ,(char *) uc2_7EAA },
	{ 0x7EAB , 1 ,12 ,12 ,24 ,(char *) uc2_7EAB },
	{ 0x7EAC , 1 ,12 ,12 ,24 ,(char *) uc2_7EAC },
	{ 0x7EAD , 1 ,12 ,12 ,24 ,(char *) uc2_7EAD },
	{ 0x7EAF , 1 ,12 ,12 ,24 ,(char *) uc2_7EAF },
	{ 0x7EB0 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB0 },
	{ 0x7EB1 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB1 },
	{ 0x7EB2 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB2 },
	{ 0x7EB3 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB3 },
	{ 0x7EB4 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB4 },
	{ 0x7EB5 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB5 },
	{ 0x7EB6 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB6 },
	{ 0x7EB7 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB7 },
	{ 0x7EB8 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB8 },
	{ 0x7EB9 , 1 ,12 ,12 ,24 ,(char *) uc2_7EB9 },
	{ 0x7EBA , 1 ,12 ,12 ,24 ,(char *) uc2_7EBA },
	{ 0x7EBD , 1 ,12 ,12 ,24 ,(char *) uc2_7EBD },
	{ 0x7EBE , 1 ,12 ,12 ,24 ,(char *) uc2_7EBE },
	{ 0x7EBF , 1 ,12 ,12 ,24 ,(char *) uc2_7EBF },
	{ 0x7EC0 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC0 },
	{ 0x7EC1 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC1 },
	{ 0x7EC2 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC2 },
	{ 0x7EC3 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC3 },
	{ 0x7EC4 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC4 },
	{ 0x7EC5 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC5 },
	{ 0x7EC6 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC6 },
	{ 0x7EC7 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC7 },
	{ 0x7EC8 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC8 },
	{ 0x7EC9 , 1 ,12 ,12 ,24 ,(char *) uc2_7EC9 },
	{ 0x7ECA , 1 ,12 ,12 ,24 ,(char *) uc2_7ECA },
	{ 0x7ECB , 1 ,12 ,12 ,24 ,(char *) uc2_7ECB },
	{ 0x7ECC , 1 ,12 ,12 ,24 ,(char *) uc2_7ECC },
	{ 0x7ECD , 1 ,12 ,12 ,24 ,(char *) uc2_7ECD },
	{ 0x7ECE , 1 ,12 ,12 ,24 ,(char *) uc2_7ECE },
	{ 0x7ECF , 1 ,12 ,12 ,24 ,(char *) uc2_7ECF },
	{ 0x7ED0 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED0 },
	{ 0x7ED1 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED1 },
	{ 0x7ED2 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED2 },
	{ 0x7ED3 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED3 },
	{ 0x7ED4 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED4 },
	{ 0x7ED5 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED5 },
	{ 0x7ED7 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED7 },
	{ 0x7ED8 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED8 },
	{ 0x7ED9 , 1 ,12 ,12 ,24 ,(char *) uc2_7ED9 },
	{ 0x7EDA , 1 ,12 ,12 ,24 ,(char *) uc2_7EDA },
	{ 0x7EDB , 1 ,12 ,12 ,24 ,(char *) uc2_7EDB },
	{ 0x7EDC , 1 ,12 ,12 ,24 ,(char *) uc2_7EDC },
	{ 0x7EDD , 1 ,12 ,12 ,24 ,(char *) uc2_7EDD },
	{ 0x7EDE , 1 ,12 ,12 ,24 ,(char *) uc2_7EDE },
	{ 0x7EDF , 1 ,12 ,12 ,24 ,(char *) uc2_7EDF },
	{ 0x7EE0 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE0 },
	{ 0x7EE1 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE1 },
	{ 0x7EE2 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE2 },
	{ 0x7EE3 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE3 },
	{ 0x7EE5 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE5 },
	{ 0x7EE6 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE6 },
	{ 0x7EE7 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE7 },
	{ 0x7EE8 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE8 },
	{ 0x7EE9 , 1 ,12 ,12 ,24 ,(char *) uc2_7EE9 },
	{ 0x7EEA , 1 ,12 ,12 ,24 ,(char *) uc2_7EEA },
	{ 0x7EEB , 1 ,12 ,12 ,24 ,(char *) uc2_7EEB },
	{ 0x7EED , 1 ,12 ,12 ,24 ,(char *) uc2_7EED },
	{ 0x7EEE , 1 ,12 ,12 ,24 ,(char *) uc2_7EEE },
	{ 0x7EEF , 1 ,12 ,12 ,24 ,(char *) uc2_7EEF },
	{ 0x7EF0 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF0 },
	{ 0x7EF1 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF1 },
	{ 0x7EF2 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF2 },
	{ 0x7EF3 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF3 },
	{ 0x7EF4 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF4 },
	{ 0x7EF5 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF5 },
	{ 0x7EF6 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF6 },
	{ 0x7EF7 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF7 },
	{ 0x7EF8 , 1 ,12 ,12 ,24 ,(char *) uc2_7EF8 },
	{ 0x7EFA , 1 ,12 ,12 ,24 ,(char *) uc2_7EFA },
	{ 0x7EFB , 1 ,12 ,12 ,24 ,(char *) uc2_7EFB },
	{ 0x7EFC , 1 ,12 ,12 ,24 ,(char *) uc2_7EFC },
	{ 0x7EFD , 1 ,12 ,12 ,24 ,(char *) uc2_7EFD },
	{ 0x7EFE , 1 ,12 ,12 ,24 ,(char *) uc2_7EFE },
	{ 0x7EFF , 1 ,12 ,12 ,24 ,(char *) uc2_7EFF },
	{ 0x7F00 , 1 ,12 ,12 ,24 ,(char *) uc2_7F00 },
	{ 0x7F01 , 1 ,12 ,12 ,24 ,(char *) uc2_7F01 },
	{ 0x7F02 , 1 ,12 ,12 ,24 ,(char *) uc2_7F02 },
	{ 0x7F03 , 1 ,12 ,12 ,24 ,(char *) uc2_7F03 },
	{ 0x7F04 , 1 ,12 ,12 ,24 ,(char *) uc2_7F04 },
	{ 0x7F05 , 1 ,12 ,12 ,24 ,(char *) uc2_7F05 },
	{ 0x7F06 , 1 ,12 ,12 ,24 ,(char *) uc2_7F06 },
	{ 0x7F07 , 1 ,12 ,12 ,24 ,(char *) uc2_7F07 },
	{ 0x7F08 , 1 ,12 ,12 ,24 ,(char *) uc2_7F08 },
	{ 0x7F09 , 1 ,12 ,12 ,24 ,(char *) uc2_7F09 },
	{ 0x7F0B , 1 ,12 ,12 ,24 ,(char *) uc2_7F0B },
	{ 0x7F0C , 1 ,12 ,12 ,24 ,(char *) uc2_7F0C },
	{ 0x7F0D , 1 ,12 ,12 ,24 ,(char *) uc2_7F0D },
	{ 0x7F0E , 1 ,12 ,12 ,24 ,(char *) uc2_7F0E },
	{ 0x7F0F , 1 ,12 ,12 ,24 ,(char *) uc2_7F0F },
	{ 0x7F11 , 1 ,12 ,12 ,24 ,(char *) uc2_7F11 },
	{ 0x7F12 , 1 ,12 ,12 ,24 ,(char *) uc2_7F12 },
	{ 0x7F13 , 1 ,12 ,12 ,24 ,(char *) uc2_7F13 },
	{ 0x7F14 , 1 ,12 ,12 ,24 ,(char *) uc2_7F14 },
	{ 0x7F15 , 1 ,12 ,12 ,24 ,(char *) uc2_7F15 },
	{ 0x7F16 , 1 ,12 ,12 ,24 ,(char *) uc2_7F16 },
	{ 0x7F17 , 1 ,12 ,12 ,24 ,(char *) uc2_7F17 },
	{ 0x7F18 , 1 ,12 ,12 ,24 ,(char *) uc2_7F18 },
	{ 0x7F19 , 1 ,12 ,12 ,24 ,(char *) uc2_7F19 },
	{ 0x7F1A , 1 ,12 ,12 ,24 ,(char *) uc2_7F1A },
	{ 0x7F1B , 1 ,12 ,12 ,24 ,(char *) uc2_7F1B },
	{ 0x7F1C , 1 ,12 ,12 ,24 ,(char *) uc2_7F1C },
	{ 0x7F1D , 1 ,12 ,12 ,24 ,(char *) uc2_7F1D },
	{ 0x7F1F , 1 ,12 ,12 ,24 ,(char *) uc2_7F1F },
	{ 0x7F20 , 1 ,12 ,12 ,24 ,(char *) uc2_7F20 },
	{ 0x7F21 , 1 ,12 ,12 ,24 ,(char *) uc2_7F21 },
	{ 0x7F22 , 1 ,12 ,12 ,24 ,(char *) uc2_7F22 },
	{ 0x7F23 , 1 ,12 ,12 ,24 ,(char *) uc2_7F23 },
	{ 0x7F24 , 1 ,12 ,12 ,24 ,(char *) uc2_7F24 },
	{ 0x7F25 , 1 ,12 ,12 ,24 ,(char *) uc2_7F25 },
	{ 0x7F26 , 1 ,12 ,12 ,24 ,(char *) uc2_7F26 },
	{ 0x7F27 , 1 ,12 ,12 ,24 ,(char *) uc2_7F27 },
	{ 0x7F28 , 1 ,12 ,12 ,24 ,(char *) uc2_7F28 },
	{ 0x7F29 , 1 ,12 ,12 ,24 ,(char *) uc2_7F29 },
	{ 0x7F2A , 1 ,12 ,12 ,24 ,(char *) uc2_7F2A },
	{ 0x7F2B , 1 ,12 ,12 ,24 ,(char *) uc2_7F2B },
	{ 0x7F2C , 1 ,12 ,12 ,24 ,(char *) uc2_7F2C },
	{ 0x7F2D , 1 ,12 ,12 ,24 ,(char *) uc2_7F2D },
	{ 0x7F2E , 1 ,12 ,12 ,24 ,(char *) uc2_7F2E },
	{ 0x7F2F , 1 ,12 ,12 ,24 ,(char *) uc2_7F2F },
	{ 0x7F30 , 1 ,12 ,12 ,24 ,(char *) uc2_7F30 },
	{ 0x7F31 , 1 ,12 ,12 ,24 ,(char *) uc2_7F31 },
	{ 0x7F32 , 1 ,12 ,12 ,24 ,(char *) uc2_7F32 },
	{ 0x7F33 , 1 ,12 ,12 ,24 ,(char *) uc2_7F33 },
	{ 0x7F34 , 1 ,12 ,12 ,24 ,(char *) uc2_7F34 },
	{ 0x7F35 , 1 ,12 ,12 ,24 ,(char *) uc2_7F35 },
	{ 0x7F36 , 1 ,12 ,12 ,24 ,(char *) uc2_7F36 },
	{ 0x7F38 , 1 ,12 ,12 ,24 ,(char *) uc2_7F38 },
	{ 0x7F3A , 1 ,12 ,12 ,24 ,(char *) uc2_7F3A },
	{ 0x7F42 , 1 ,12 ,12 ,24 ,(char *) uc2_7F42 },
	{ 0x7F44 , 1 ,12 ,12 ,24 ,(char *) uc2_7F44 },
	{ 0x7F45 , 1 ,12 ,12 ,24 ,(char *) uc2_7F45 },
	{ 0x7F50 , 1 ,12 ,12 ,24 ,(char *) uc2_7F50 },
	{ 0x7F51 , 1 ,12 ,12 ,24 ,(char *) uc2_7F51 },
	{ 0x7F54 , 1 ,12 ,12 ,24 ,(char *) uc2_7F54 },
	{ 0x7F55 , 1 ,12 ,12 ,24 ,(char *) uc2_7F55 },
	{ 0x7F57 , 1 ,12 ,12 ,24 ,(char *) uc2_7F57 },
	{ 0x7F58 , 1 ,12 ,12 ,24 ,(char *) uc2_7F58 },
	{ 0x7F5A , 1 ,12 ,12 ,24 ,(char *) uc2_7F5A },
	{ 0x7F5F , 1 ,12 ,12 ,24 ,(char *) uc2_7F5F },
	{ 0x7F61 , 1 ,12 ,12 ,24 ,(char *) uc2_7F61 },
	{ 0x7F62 , 1 ,12 ,12 ,24 ,(char *) uc2_7F62 },
	{ 0x7F68 , 1 ,12 ,12 ,24 ,(char *) uc2_7F68 },
	{ 0x7F69 , 1 ,12 ,12 ,24 ,(char *) uc2_7F69 },
	{ 0x7F6A , 1 ,12 ,12 ,24 ,(char *) uc2_7F6A },
	{ 0x7F6E , 1 ,12 ,12 ,24 ,(char *) uc2_7F6E },
	{ 0x7F71 , 1 ,12 ,12 ,24 ,(char *) uc2_7F71 },
	{ 0x7F72 , 1 ,12 ,12 ,24 ,(char *) uc2_7F72 },
	{ 0x7F74 , 1 ,12 ,12 ,24 ,(char *) uc2_7F74 },
	{ 0x7F79 , 1 ,12 ,12 ,24 ,(char *) uc2_7F79 },
	{ 0x7F7E , 1 ,12 ,12 ,24 ,(char *) uc2_7F7E },
	{ 0x7F81 , 1 ,12 ,12 ,24 ,(char *) uc2_7F81 },
	{ 0x7F8A , 1 ,12 ,12 ,24 ,(char *) uc2_7F8A },
	{ 0x7F8C , 1 ,12 ,12 ,24 ,(char *) uc2_7F8C },
	{ 0x7F8E , 1 ,12 ,12 ,24 ,(char *) uc2_7F8E },
	{ 0x7F94 , 1 ,12 ,12 ,24 ,(char *) uc2_7F94 },
	{ 0x7F97 , 1 ,12 ,12 ,24 ,(char *) uc2_7F97 },
	{ 0x7F9A , 1 ,12 ,12 ,24 ,(char *) uc2_7F9A },
	{ 0x7F9D , 1 ,12 ,12 ,24 ,(char *) uc2_7F9D },
	{ 0x7F9E , 1 ,12 ,12 ,24 ,(char *) uc2_7F9E },
	{ 0x7F9F , 1 ,12 ,12 ,24 ,(char *) uc2_7F9F },
	{ 0x7FA1 , 1 ,12 ,12 ,24 ,(char *) uc2_7FA1 },
	{ 0x7FA4 , 1 ,12 ,12 ,24 ,(char *) uc2_7FA4 },
	{ 0x7FA7 , 1 ,12 ,12 ,24 ,(char *) uc2_7FA7 },
	{ 0x7FAF , 1 ,12 ,12 ,24 ,(char *) uc2_7FAF },
	{ 0x7FB0 , 1 ,12 ,12 ,24 ,(char *) uc2_7FB0 },
	{ 0x7FB2 , 1 ,12 ,12 ,24 ,(char *) uc2_7FB2 },
	{ 0x7FB8 , 1 ,12 ,12 ,24 ,(char *) uc2_7FB8 },
	{ 0x7FB9 , 1 ,12 ,12 ,24 ,(char *) uc2_7FB9 },
	{ 0x7FBC , 1 ,12 ,12 ,24 ,(char *) uc2_7FBC },
	{ 0x7FBD , 1 ,12 ,12 ,24 ,(char *) uc2_7FBD },
	{ 0x7FBF , 1 ,12 ,12 ,24 ,(char *) uc2_7FBF },
	{ 0x7FC1 , 1 ,12 ,12 ,24 ,(char *) uc2_7FC1 },
	{ 0x7FC5 , 1 ,12 ,12 ,24 ,(char *) uc2_7FC5 },
	{ 0x7FCA , 1 ,12 ,12 ,24 ,(char *) uc2_7FCA },
	{ 0x7FCC , 1 ,12 ,12 ,24 ,(char *) uc2_7FCC },
	{ 0x7FCE , 1 ,12 ,12 ,24 ,(char *) uc2_7FCE },
	{ 0x7FD4 , 1 ,12 ,12 ,24 ,(char *) uc2_7FD4 },
	{ 0x7FD5 , 1 ,12 ,12 ,24 ,(char *) uc2_7FD5 },
	{ 0x7FD8 , 1 ,12 ,12 ,24 ,(char *) uc2_7FD8 },
	{ 0x7FDF , 1 ,12 ,12 ,24 ,(char *) uc2_7FDF },
	{ 0x7FE0 , 1 ,12 ,12 ,24 ,(char *) uc2_7FE0 },
	{ 0x7FE1 , 1 ,12 ,12 ,24 ,(char *) uc2_7FE1 },
	{ 0x7FE5 , 1 ,12 ,12 ,24 ,(char *) uc2_7FE5 },
	{ 0x7FE6 , 1 ,12 ,12 ,24 ,(char *) uc2_7FE6 },
	{ 0x7FE9 , 1 ,12 ,12 ,24 ,(char *) uc2_7FE9 },
	{ 0x7FEE , 1 ,12 ,12 ,24 ,(char *) uc2_7FEE },
	{ 0x7FF0 , 1 ,12 ,12 ,24 ,(char *) uc2_7FF0 },
	{ 0x7FF1 , 1 ,12 ,12 ,24 ,(char *) uc2_7FF1 },
	{ 0x7FF3 , 1 ,12 ,12 ,24 ,(char *) uc2_7FF3 },
	{ 0x7FFB , 1 ,12 ,12 ,24 ,(char *) uc2_7FFB },
	{ 0x7FFC , 1 ,12 ,12 ,24 ,(char *) uc2_7FFC },
	{ 0x8000 , 1 ,12 ,12 ,24 ,(char *) uc2_8000 },
	{ 0x8001 , 1 ,12 ,12 ,24 ,(char *) uc2_8001 },
	{ 0x8003 , 1 ,12 ,12 ,24 ,(char *) uc2_8003 },
	{ 0x8004 , 1 ,12 ,12 ,24 ,(char *) uc2_8004 },
	{ 0x8005 , 1 ,12 ,12 ,24 ,(char *) uc2_8005 },
	{ 0x8006 , 1 ,12 ,12 ,24 ,(char *) uc2_8006 },
	{ 0x800B , 1 ,12 ,12 ,24 ,(char *) uc2_800B },
	{ 0x800C , 1 ,12 ,12 ,24 ,(char *) uc2_800C },
	{ 0x800D , 1 ,12 ,12 ,24 ,(char *) uc2_800D },
	{ 0x8010 , 1 ,12 ,12 ,24 ,(char *) uc2_8010 },
	{ 0x8012 , 1 ,12 ,12 ,24 ,(char *) uc2_8012 },
	{ 0x8014 , 1 ,12 ,12 ,24 ,(char *) uc2_8014 },
	{ 0x8015 , 1 ,12 ,12 ,24 ,(char *) uc2_8015 },
	{ 0x8016 , 1 ,12 ,12 ,24 ,(char *) uc2_8016 },
	{ 0x8017 , 1 ,12 ,12 ,24 ,(char *) uc2_8017 },
	{ 0x8018 , 1 ,12 ,12 ,24 ,(char *) uc2_8018 },
	{ 0x8019 , 1 ,12 ,12 ,24 ,(char *) uc2_8019 },
	{ 0x801C , 1 ,12 ,12 ,24 ,(char *) uc2_801C },
	{ 0x8020 , 1 ,12 ,12 ,24 ,(char *) uc2_8020 },
	{ 0x8022 , 1 ,12 ,12 ,24 ,(char *) uc2_8022 },
	{ 0x8025 , 1 ,12 ,12 ,24 ,(char *) uc2_8025 },
	{ 0x8026 , 1 ,12 ,12 ,24 ,(char *) uc2_8026 },
	{ 0x8027 , 1 ,12 ,12 ,24 ,(char *) uc2_8027 },
	{ 0x8028 , 1 ,12 ,12 ,24 ,(char *) uc2_8028 },
	{ 0x8029 , 1 ,12 ,12 ,24 ,(char *) uc2_8029 },
	{ 0x802A , 1 ,12 ,12 ,24 ,(char *) uc2_802A },
	{ 0x8031 , 1 ,12 ,12 ,24 ,(char *) uc2_8031 },
	{ 0x8033 , 1 ,12 ,12 ,24 ,(char *) uc2_8033 },
	{ 0x8035 , 1 ,12 ,12 ,24 ,(char *) uc2_8035 },
	{ 0x8036 , 1 ,12 ,12 ,24 ,(char *) uc2_8036 },
	{ 0x8037 , 1 ,12 ,12 ,24 ,(char *) uc2_8037 },
	{ 0x8038 , 1 ,12 ,12 ,24 ,(char *) uc2_8038 },
	{ 0x803B , 1 ,12 ,12 ,24 ,(char *) uc2_803B },
	{ 0x803D , 1 ,12 ,12 ,24 ,(char *) uc2_803D },
	{ 0x803F , 1 ,12 ,12 ,24 ,(char *) uc2_803F },
	{ 0x8042 , 1 ,12 ,12 ,24 ,(char *) uc2_8042 },
	{ 0x8043 , 1 ,12 ,12 ,24 ,(char *) uc2_8043 },
	{ 0x8046 , 1 ,12 ,12 ,24 ,(char *) uc2_8046 },
	{ 0x804A , 1 ,12 ,12 ,24 ,(char *) uc2_804A },
	{ 0x804B , 1 ,12 ,12 ,24 ,(char *) uc2_804B },
	{ 0x804C , 1 ,12 ,12 ,24 ,(char *) uc2_804C },
	{ 0x804D , 1 ,12 ,12 ,24 ,(char *) uc2_804D },
	{ 0x8052 , 1 ,12 ,12 ,24 ,(char *) uc2_8052 },
	{ 0x8054 , 1 ,12 ,12 ,24 ,(char *) uc2_8054 },
	{ 0x8058 , 1 ,12 ,12 ,24 ,(char *) uc2_8058 },
	{ 0x805A , 1 ,12 ,12 ,24 ,(char *) uc2_805A },
	{ 0x8069 , 1 ,12 ,12 ,24 ,(char *) uc2_8069 },
	{ 0x806A , 1 ,12 ,12 ,24 ,(char *) uc2_806A },
	{ 0x8071 , 1 ,12 ,12 ,24 ,(char *) uc2_8071 },
	{ 0x807F , 1 ,12 ,12 ,24 ,(char *) uc2_807F },
	{ 0x8083 , 1 ,12 ,12 ,24 ,(char *) uc2_8083 },
	{ 0x8084 , 1 ,12 ,12 ,24 ,(char *) uc2_8084 },
	{ 0x8086 , 1 ,12 ,12 ,24 ,(char *) uc2_8086 },
	{ 0x8087 , 1 ,12 ,12 ,24 ,(char *) uc2_8087 },
	{ 0x8089 , 1 ,12 ,12 ,24 ,(char *) uc2_8089 },
	{ 0x808B , 1 ,12 ,12 ,24 ,(char *) uc2_808B },
	{ 0x808C , 1 ,12 ,12 ,24 ,(char *) uc2_808C },
	{ 0x8093 , 1 ,12 ,12 ,24 ,(char *) uc2_8093 },
	{ 0x8096 , 1 ,12 ,12 ,24 ,(char *) uc2_8096 },
	{ 0x8098 , 1 ,12 ,12 ,24 ,(char *) uc2_8098 },
	{ 0x809A , 1 ,12 ,12 ,24 ,(char *) uc2_809A },
	{ 0x809B , 1 ,12 ,12 ,24 ,(char *) uc2_809B },
	{ 0x809C , 1 ,12 ,12 ,24 ,(char *) uc2_809C },
	{ 0x809D , 1 ,12 ,12 ,24 ,(char *) uc2_809D },
	{ 0x809F , 1 ,12 ,12 ,24 ,(char *) uc2_809F },
	{ 0x80A0 , 1 ,12 ,12 ,24 ,(char *) uc2_80A0 },
	{ 0x80A1 , 1 ,12 ,12 ,24 ,(char *) uc2_80A1 },
	{ 0x80A2 , 1 ,12 ,12 ,24 ,(char *) uc2_80A2 },
	{ 0x80A4 , 1 ,12 ,12 ,24 ,(char *) uc2_80A4 },
	{ 0x80A5 , 1 ,12 ,12 ,24 ,(char *) uc2_80A5 },
	{ 0x80A9 , 1 ,12 ,12 ,24 ,(char *) uc2_80A9 },
	{ 0x80AA , 1 ,12 ,12 ,24 ,(char *) uc2_80AA },
	{ 0x80AB , 1 ,12 ,12 ,24 ,(char *) uc2_80AB },
	{ 0x80AD , 1 ,12 ,12 ,24 ,(char *) uc2_80AD },
	{ 0x80AE , 1 ,12 ,12 ,24 ,(char *) uc2_80AE },
	{ 0x80AF , 1 ,12 ,12 ,24 ,(char *) uc2_80AF },
	{ 0x80B1 , 1 ,12 ,12 ,24 ,(char *) uc2_80B1 },
	{ 0x80B2 , 1 ,12 ,12 ,24 ,(char *) uc2_80B2 },
	{ 0x80B4 , 1 ,12 ,12 ,24 ,(char *) uc2_80B4 },
	{ 0x80B7 , 1 ,12 ,12 ,24 ,(char *) uc2_80B7 },
	{ 0x80BA , 1 ,12 ,12 ,24 ,(char *) uc2_80BA },
	{ 0x80BC , 1 ,12 ,12 ,24 ,(char *) uc2_80BC },
	{ 0x80BD , 1 ,12 ,12 ,24 ,(char *) uc2_80BD },
	{ 0x80BE , 1 ,12 ,12 ,24 ,(char *) uc2_80BE },
	{ 0x80BF , 1 ,12 ,12 ,24 ,(char *) uc2_80BF },
	{ 0x80C0 , 1 ,12 ,12 ,24 ,(char *) uc2_80C0 },
	{ 0x80C1 , 1 ,12 ,12 ,24 ,(char *) uc2_80C1 },
	{ 0x80C2 , 1 ,12 ,12 ,24 ,(char *) uc2_80C2 },
	{ 0x80C3 , 1 ,12 ,12 ,24 ,(char *) uc2_80C3 },
	{ 0x80C4 , 1 ,12 ,12 ,24 ,(char *) uc2_80C4 },
	{ 0x80C6 , 1 ,12 ,12 ,24 ,(char *) uc2_80C6 },
	{ 0x80CC , 1 ,12 ,12 ,24 ,(char *) uc2_80CC },
	{ 0x80CD , 1 ,12 ,12 ,24 ,(char *) uc2_80CD },
	{ 0x80CE , 1 ,12 ,12 ,24 ,(char *) uc2_80CE },
	{ 0x80D6 , 1 ,12 ,12 ,24 ,(char *) uc2_80D6 },
	{ 0x80D7 , 1 ,12 ,12 ,24 ,(char *) uc2_80D7 },
	{ 0x80D9 , 1 ,12 ,12 ,24 ,(char *) uc2_80D9 },
	{ 0x80DA , 1 ,12 ,12 ,24 ,(char *) uc2_80DA },
	{ 0x80DB , 1 ,12 ,12 ,24 ,(char *) uc2_80DB },
	{ 0x80DC , 1 ,12 ,12 ,24 ,(char *) uc2_80DC },
	{ 0x80DD , 1 ,12 ,12 ,24 ,(char *) uc2_80DD },
	{ 0x80DE , 1 ,12 ,12 ,24 ,(char *) uc2_80DE },
	{ 0x80E1 , 1 ,12 ,12 ,24 ,(char *) uc2_80E1 },
	{ 0x80E4 , 1 ,12 ,12 ,24 ,(char *) uc2_80E4 },
	{ 0x80E5 , 1 ,12 ,12 ,24 ,(char *) uc2_80E5 },
	{ 0x80E7 , 1 ,12 ,12 ,24 ,(char *) uc2_80E7 },
	{ 0x80E8 , 1 ,12 ,12 ,24 ,(char *) uc2_80E8 },
	{ 0x80E9 , 1 ,12 ,12 ,24 ,(char *) uc2_80E9 },
	{ 0x80EA , 1 ,12 ,12 ,24 ,(char *) uc2_80EA },
	{ 0x80EB , 1 ,12 ,12 ,24 ,(char *) uc2_80EB },
	{ 0x80EC , 1 ,12 ,12 ,24 ,(char *) uc2_80EC },
	{ 0x80ED , 1 ,12 ,12 ,24 ,(char *) uc2_80ED },
	{ 0x80EF , 1 ,12 ,12 ,24 ,(char *) uc2_80EF },
	{ 0x80F0 , 1 ,12 ,12 ,24 ,(char *) uc2_80F0 },
	{ 0x80F1 , 1 ,12 ,12 ,24 ,(char *) uc2_80F1 },
	{ 0x80F2 , 1 ,12 ,12 ,24 ,(char *) uc2_80F2 },
	{ 0x80F3 , 1 ,12 ,12 ,24 ,(char *) uc2_80F3 },
	{ 0x80F4 , 1 ,12 ,12 ,24 ,(char *) uc2_80F4 },
	{ 0x80F6 , 1 ,12 ,12 ,24 ,(char *) uc2_80F6 },
	{ 0x80F8 , 1 ,12 ,12 ,24 ,(char *) uc2_80F8 },
	{ 0x80FA , 1 ,12 ,12 ,24 ,(char *) uc2_80FA },
	{ 0x80FC , 1 ,12 ,12 ,24 ,(char *) uc2_80FC },
	{ 0x80FD , 1 ,12 ,12 ,24 ,(char *) uc2_80FD },
	{ 0x8102 , 1 ,12 ,12 ,24 ,(char *) uc2_8102 },
	{ 0x8106 , 1 ,12 ,12 ,24 ,(char *) uc2_8106 },
	{ 0x8109 , 1 ,12 ,12 ,24 ,(char *) uc2_8109 },
	{ 0x810A , 1 ,12 ,12 ,24 ,(char *) uc2_810A },
	{ 0x810D , 1 ,12 ,12 ,24 ,(char *) uc2_810D },
	{ 0x810E , 1 ,12 ,12 ,24 ,(char *) uc2_810E },
	{ 0x810F , 1 ,12 ,12 ,24 ,(char *) uc2_810F },
	{ 0x8110 , 1 ,12 ,12 ,24 ,(char *) uc2_8110 },
	{ 0x8111 , 1 ,12 ,12 ,24 ,(char *) uc2_8111 },
	{ 0x8112 , 1 ,12 ,12 ,24 ,(char *) uc2_8112 },
	{ 0x8113 , 1 ,12 ,12 ,24 ,(char *) uc2_8113 },
	{ 0x8114 , 1 ,12 ,12 ,24 ,(char *) uc2_8114 },
	{ 0x8116 , 1 ,12 ,12 ,24 ,(char *) uc2_8116 },
	{ 0x8118 , 1 ,12 ,12 ,24 ,(char *) uc2_8118 },
	{ 0x811A , 1 ,12 ,12 ,24 ,(char *) uc2_811A },
	{ 0x811E , 1 ,12 ,12 ,24 ,(char *) uc2_811E },
	{ 0x812C , 1 ,12 ,12 ,24 ,(char *) uc2_812C },
	{ 0x812F , 1 ,12 ,12 ,24 ,(char *) uc2_812F },
	{ 0x8131 , 1 ,12 ,12 ,24 ,(char *) uc2_8131 },
	{ 0x8132 , 1 ,12 ,12 ,24 ,(char *) uc2_8132 },
	{ 0x8136 , 1 ,12 ,12 ,24 ,(char *) uc2_8136 },
	{ 0x8138 , 1 ,12 ,12 ,24 ,(char *) uc2_8138 },
	{ 0x813E , 1 ,12 ,12 ,24 ,(char *) uc2_813E },
	{ 0x8146 , 1 ,12 ,12 ,24 ,(char *) uc2_8146 },
	{ 0x8148 , 1 ,12 ,12 ,24 ,(char *) uc2_8148 },
	{ 0x814A , 1 ,12 ,12 ,24 ,(char *) uc2_814A },
	{ 0x814B , 1 ,12 ,12 ,24 ,(char *) uc2_814B },
	{ 0x814C , 1 ,12 ,12 ,24 ,(char *) uc2_814C },
	{ 0x8150 , 1 ,12 ,12 ,24 ,(char *) uc2_8150 },
	{ 0x8151 , 1 ,12 ,12 ,24 ,(char *) uc2_8151 },
	{ 0x8153 , 1 ,12 ,12 ,24 ,(char *) uc2_8153 },
	{ 0x8154 , 1 ,12 ,12 ,24 ,(char *) uc2_8154 },
	{ 0x8155 , 1 ,12 ,12 ,24 ,(char *) uc2_8155 },
	{ 0x8159 , 1 ,12 ,12 ,24 ,(char *) uc2_8159 },
	{ 0x815A , 1 ,12 ,12 ,24 ,(char *) uc2_815A },
	{ 0x8160 , 1 ,12 ,12 ,24 ,(char *) uc2_8160 },
	{ 0x8165 , 1 ,12 ,12 ,24 ,(char *) uc2_8165 },
	{ 0x8167 , 1 ,12 ,12 ,24 ,(char *) uc2_8167 },
	{ 0x8169 , 1 ,12 ,12 ,24 ,(char *) uc2_8169 },
	{ 0x816D , 1 ,12 ,12 ,24 ,(char *) uc2_816D },
	{ 0x816E , 1 ,12 ,12 ,24 ,(char *) uc2_816E },
	{ 0x8170 , 1 ,12 ,12 ,24 ,(char *) uc2_8170 },
	{ 0x8171 , 1 ,12 ,12 ,24 ,(char *) uc2_8171 },
	{ 0x8174 , 1 ,12 ,12 ,24 ,(char *) uc2_8174 },
	{ 0x8179 , 1 ,12 ,12 ,24 ,(char *) uc2_8179 },
	{ 0x817A , 1 ,12 ,12 ,24 ,(char *) uc2_817A },
	{ 0x817B , 1 ,12 ,12 ,24 ,(char *) uc2_817B },
	{ 0x817C , 1 ,12 ,12 ,24 ,(char *) uc2_817C },
	{ 0x817D , 1 ,12 ,12 ,24 ,(char *) uc2_817D },
	{ 0x817E , 1 ,12 ,12 ,24 ,(char *) uc2_817E },
	{ 0x817F , 1 ,12 ,12 ,24 ,(char *) uc2_817F },
	{ 0x8180 , 1 ,12 ,12 ,24 ,(char *) uc2_8180 },
	{ 0x8182 , 1 ,12 ,12 ,24 ,(char *) uc2_8182 },
	{ 0x8188 , 1 ,12 ,12 ,24 ,(char *) uc2_8188 },
	{ 0x818A , 1 ,12 ,12 ,24 ,(char *) uc2_818A },
	{ 0x818F , 1 ,12 ,12 ,24 ,(char *) uc2_818F },
	{ 0x8191 , 1 ,12 ,12 ,24 ,(char *) uc2_8191 },
	{ 0x8198 , 1 ,12 ,12 ,24 ,(char *) uc2_8198 },
	{ 0x819B , 1 ,12 ,12 ,24 ,(char *) uc2_819B },
	{ 0x819C , 1 ,12 ,12 ,24 ,(char *) uc2_819C },
	{ 0x819D , 1 ,12 ,12 ,24 ,(char *) uc2_819D },
	{ 0x81A3 , 1 ,12 ,12 ,24 ,(char *) uc2_81A3 },
	{ 0x81A6 , 1 ,12 ,12 ,24 ,(char *) uc2_81A6 },
	{ 0x81A8 , 1 ,12 ,12 ,24 ,(char *) uc2_81A8 },
	{ 0x81AA , 1 ,12 ,12 ,24 ,(char *) uc2_81AA },
	{ 0x81B3 , 1 ,12 ,12 ,24 ,(char *) uc2_81B3 },
	{ 0x81BA , 1 ,12 ,12 ,24 ,(char *) uc2_81BA },
	{ 0x81BB , 1 ,12 ,12 ,24 ,(char *) uc2_81BB },
	{ 0x81C0 , 1 ,12 ,12 ,24 ,(char *) uc2_81C0 },
	{ 0x81C1 , 1 ,12 ,12 ,24 ,(char *) uc2_81C1 },
	{ 0x81C2 , 1 ,12 ,12 ,24 ,(char *) uc2_81C2 },
	{ 0x81C3 , 1 ,12 ,12 ,24 ,(char *) uc2_81C3 },
	{ 0x81C6 , 1 ,12 ,12 ,24 ,(char *) uc2_81C6 },
	{ 0x81CA , 1 ,12 ,12 ,24 ,(char *) uc2_81CA },
	{ 0x81CC , 1 ,12 ,12 ,24 ,(char *) uc2_81CC },
	{ 0x81E3 , 1 ,12 ,12 ,24 ,(char *) uc2_81E3 },
	{ 0x81E7 , 1 ,12 ,12 ,24 ,(char *) uc2_81E7 },
	{ 0x81EA , 1 ,12 ,12 ,24 ,(char *) uc2_81EA },
	{ 0x81EC , 1 ,12 ,12 ,24 ,(char *) uc2_81EC },
	{ 0x81ED , 1 ,12 ,12 ,24 ,(char *) uc2_81ED },
	{ 0x81F3 , 1 ,12 ,12 ,24 ,(char *) uc2_81F3 },
	{ 0x81F4 , 1 ,12 ,12 ,24 ,(char *) uc2_81F4 },
	{ 0x81FB , 1 ,12 ,12 ,24 ,(char *) uc2_81FB },
	{ 0x81FC , 1 ,12 ,12 ,24 ,(char *) uc2_81FC },
	{ 0x81FE , 1 ,12 ,12 ,24 ,(char *) uc2_81FE },
	{ 0x8200 , 1 ,12 ,12 ,24 ,(char *) uc2_8200 },
	{ 0x8201 , 1 ,12 ,12 ,24 ,(char *) uc2_8201 },
	{ 0x8202 , 1 ,12 ,12 ,24 ,(char *) uc2_8202 },
	{ 0x8204 , 1 ,12 ,12 ,24 ,(char *) uc2_8204 },
	{ 0x8205 , 1 ,12 ,12 ,24 ,(char *) uc2_8205 },
	{ 0x8206 , 1 ,12 ,12 ,24 ,(char *) uc2_8206 },
	{ 0x820C , 1 ,12 ,12 ,24 ,(char *) uc2_820C },
	{ 0x820D , 1 ,12 ,12 ,24 ,(char *) uc2_820D },
	{ 0x8210 , 1 ,12 ,12 ,24 ,(char *) uc2_8210 },
	{ 0x8212 , 1 ,12 ,12 ,24 ,(char *) uc2_8212 },
	{ 0x8214 , 1 ,12 ,12 ,24 ,(char *) uc2_8214 },
	{ 0x821B , 1 ,12 ,12 ,24 ,(char *) uc2_821B },
	{ 0x821C , 1 ,12 ,12 ,24 ,(char *) uc2_821C },
	{ 0x821E , 1 ,12 ,12 ,24 ,(char *) uc2_821E },
	{ 0x821F , 1 ,12 ,12 ,24 ,(char *) uc2_821F },
	{ 0x8221 , 1 ,12 ,12 ,24 ,(char *) uc2_8221 },
	{ 0x8222 , 1 ,12 ,12 ,24 ,(char *) uc2_8222 },
	{ 0x8223 , 1 ,12 ,12 ,24 ,(char *) uc2_8223 },
	{ 0x8228 , 1 ,12 ,12 ,24 ,(char *) uc2_8228 },
	{ 0x822A , 1 ,12 ,12 ,24 ,(char *) uc2_822A },
	{ 0x822B , 1 ,12 ,12 ,24 ,(char *) uc2_822B },
	{ 0x822C , 1 ,12 ,12 ,24 ,(char *) uc2_822C },
	{ 0x822D , 1 ,12 ,12 ,24 ,(char *) uc2_822D },
	{ 0x822F , 1 ,12 ,12 ,24 ,(char *) uc2_822F },
	{ 0x8230 , 1 ,12 ,12 ,24 ,(char *) uc2_8230 },
	{ 0x8231 , 1 ,12 ,12 ,24 ,(char *) uc2_8231 },
	{ 0x8233 , 1 ,12 ,12 ,24 ,(char *) uc2_8233 },
	{ 0x8234 , 1 ,12 ,12 ,24 ,(char *) uc2_8234 },
	{ 0x8235 , 1 ,12 ,12 ,24 ,(char *) uc2_8235 },
	{ 0x8236 , 1 ,12 ,12 ,24 ,(char *) uc2_8236 },
	{ 0x8237 , 1 ,12 ,12 ,24 ,(char *) uc2_8237 },
	{ 0x8238 , 1 ,12 ,12 ,24 ,(char *) uc2_8238 },
	{ 0x8239 , 1 ,12 ,12 ,24 ,(char *) uc2_8239 },
	{ 0x823B , 1 ,12 ,12 ,24 ,(char *) uc2_823B },
	{ 0x823E , 1 ,12 ,12 ,24 ,(char *) uc2_823E },
	{ 0x8244 , 1 ,12 ,12 ,24 ,(char *) uc2_8244 },
	{ 0x8247 , 1 ,12 ,12 ,24 ,(char *) uc2_8247 },
	{ 0x8249 , 1 ,12 ,12 ,24 ,(char *) uc2_8249 },
	{ 0x824B , 1 ,12 ,12 ,24 ,(char *) uc2_824B },
	{ 0x824F , 1 ,12 ,12 ,24 ,(char *) uc2_824F },
	{ 0x8258 , 1 ,12 ,12 ,24 ,(char *) uc2_8258 },
	{ 0x825A , 1 ,12 ,12 ,24 ,(char *) uc2_825A },
	{ 0x825F , 1 ,12 ,12 ,24 ,(char *) uc2_825F },
	{ 0x8268 , 1 ,12 ,12 ,24 ,(char *) uc2_8268 },
	{ 0x826E , 1 ,12 ,12 ,24 ,(char *) uc2_826E },
	{ 0x826F , 1 ,12 ,12 ,24 ,(char *) uc2_826F },
	{ 0x8270 , 1 ,12 ,12 ,24 ,(char *) uc2_8270 },
	{ 0x8272 , 1 ,12 ,12 ,24 ,(char *) uc2_8272 },
	{ 0x8273 , 1 ,12 ,12 ,24 ,(char *) uc2_8273 },
	{ 0x8274 , 1 ,12 ,12 ,24 ,(char *) uc2_8274 },
	{ 0x827A , 1 ,12 ,12 ,24 ,(char *) uc2_827A },
	{ 0x827D , 1 ,12 ,12 ,24 ,(char *) uc2_827D },
	{ 0x827E , 1 ,12 ,12 ,24 ,(char *) uc2_827E },
	{ 0x827F , 1 ,12 ,12 ,24 ,(char *) uc2_827F },
	{ 0x8282 , 1 ,12 ,12 ,24 ,(char *) uc2_8282 },
	{ 0x8284 , 1 ,12 ,12 ,24 ,(char *) uc2_8284 },
	{ 0x8285 , 1 ,12 ,12 ,24 ,(char *) uc2_8285 },
	{ 0x8288 , 1 ,12 ,12 ,24 ,(char *) uc2_8288 },
	{ 0x828A , 1 ,12 ,12 ,24 ,(char *) uc2_828A },
	{ 0x828B , 1 ,12 ,12 ,24 ,(char *) uc2_828B },
	{ 0x828D , 1 ,12 ,12 ,24 ,(char *) uc2_828D },
	{ 0x828E , 1 ,12 ,12 ,24 ,(char *) uc2_828E },
	{ 0x828F , 1 ,12 ,12 ,24 ,(char *) uc2_828F },
	{ 0x8291 , 1 ,12 ,12 ,24 ,(char *) uc2_8291 },
	{ 0x8292 , 1 ,12 ,12 ,24 ,(char *) uc2_8292 },
	{ 0x8297 , 1 ,12 ,12 ,24 ,(char *) uc2_8297 },
	{ 0x8298 , 1 ,12 ,12 ,24 ,(char *) uc2_8298 },
	{ 0x8299 , 1 ,12 ,12 ,24 ,(char *) uc2_8299 },
	{ 0x829C , 1 ,12 ,12 ,24 ,(char *) uc2_829C },
	{ 0x829D , 1 ,12 ,12 ,24 ,(char *) uc2_829D },
	{ 0x829F , 1 ,12 ,12 ,24 ,(char *) uc2_829F },
	{ 0x82A1 , 1 ,12 ,12 ,24 ,(char *) uc2_82A1 },
	{ 0x82A4 , 1 ,12 ,12 ,24 ,(char *) uc2_82A4 },
	{ 0x82A5 , 1 ,12 ,12 ,24 ,(char *) uc2_82A5 },
	{ 0x82A6 , 1 ,12 ,12 ,24 ,(char *) uc2_82A6 },
	{ 0x82A8 , 1 ,12 ,12 ,24 ,(char *) uc2_82A8 },
	{ 0x82A9 , 1 ,12 ,12 ,24 ,(char *) uc2_82A9 },
	{ 0x82AA , 1 ,12 ,12 ,24 ,(char *) uc2_82AA },
	{ 0x82AB , 1 ,12 ,12 ,24 ,(char *) uc2_82AB },
	{ 0x82AC , 1 ,12 ,12 ,24 ,(char *) uc2_82AC },
	{ 0x82AD , 1 ,12 ,12 ,24 ,(char *) uc2_82AD },
	{ 0x82AE , 1 ,12 ,12 ,24 ,(char *) uc2_82AE },
	{ 0x82AF , 1 ,12 ,12 ,24 ,(char *) uc2_82AF },
	{ 0x82B0 , 1 ,12 ,12 ,24 ,(char *) uc2_82B0 },
	{ 0x82B1 , 1 ,12 ,12 ,24 ,(char *) uc2_82B1 },
	{ 0x82B3 , 1 ,12 ,12 ,24 ,(char *) uc2_82B3 },
	{ 0x82B4 , 1 ,12 ,12 ,24 ,(char *) uc2_82B4 },
	{ 0x82B7 , 1 ,12 ,12 ,24 ,(char *) uc2_82B7 },
	{ 0x82B8 , 1 ,12 ,12 ,24 ,(char *) uc2_82B8 },
	{ 0x82B9 , 1 ,12 ,12 ,24 ,(char *) uc2_82B9 },
	{ 0x82BD , 1 ,12 ,12 ,24 ,(char *) uc2_82BD },
	{ 0x82BE , 1 ,12 ,12 ,24 ,(char *) uc2_82BE },
	{ 0x82C1 , 1 ,12 ,12 ,24 ,(char *) uc2_82C1 },
	{ 0x82C4 , 1 ,12 ,12 ,24 ,(char *) uc2_82C4 },
	{ 0x82C7 , 1 ,12 ,12 ,24 ,(char *) uc2_82C7 },
	{ 0x82C8 , 1 ,12 ,12 ,24 ,(char *) uc2_82C8 },
	{ 0x82CA , 1 ,12 ,12 ,24 ,(char *) uc2_82CA },
	{ 0x82CB , 1 ,12 ,12 ,24 ,(char *) uc2_82CB },
	{ 0x82CC , 1 ,12 ,12 ,24 ,(char *) uc2_82CC },
	{ 0x82CD , 1 ,12 ,12 ,24 ,(char *) uc2_82CD },
	{ 0x82CE , 1 ,12 ,12 ,24 ,(char *) uc2_82CE },
	{ 0x82CF , 1 ,12 ,12 ,24 ,(char *) uc2_82CF },
	{ 0x82D1 , 1 ,12 ,12 ,24 ,(char *) uc2_82D1 },
	{ 0x82D2 , 1 ,12 ,12 ,24 ,(char *) uc2_82D2 },
	{ 0x82D3 , 1 ,12 ,12 ,24 ,(char *) uc2_82D3 },
	{ 0x82D4 , 1 ,12 ,12 ,24 ,(char *) uc2_82D4 },
	{ 0x82D5 , 1 ,12 ,12 ,24 ,(char *) uc2_82D5 },
	{ 0x82D7 , 1 ,12 ,12 ,24 ,(char *) uc2_82D7 },
	{ 0x82D8 , 1 ,12 ,12 ,24 ,(char *) uc2_82D8 },
	{ 0x82DB , 1 ,12 ,12 ,24 ,(char *) uc2_82DB },
	{ 0x82DC , 1 ,12 ,12 ,24 ,(char *) uc2_82DC },
	{ 0x82DE , 1 ,12 ,12 ,24 ,(char *) uc2_82DE },
	{ 0x82DF , 1 ,12 ,12 ,24 ,(char *) uc2_82DF },
	{ 0x82E0 , 1 ,12 ,12 ,24 ,(char *) uc2_82E0 },
	{ 0x82E1 , 1 ,12 ,12 ,24 ,(char *) uc2_82E1 },
	{ 0x82E3 , 1 ,12 ,12 ,24 ,(char *) uc2_82E3 },
	{ 0x82E4 , 1 ,12 ,12 ,24 ,(char *) uc2_82E4 },
	{ 0x82E5 , 1 ,12 ,12 ,24 ,(char *) uc2_82E5 },
	{ 0x82E6 , 1 ,12 ,12 ,24 ,(char *) uc2_82E6 },
	{ 0x82EB , 1 ,12 ,12 ,24 ,(char *) uc2_82EB },
	{ 0x82EF , 1 ,12 ,12 ,24 ,(char *) uc2_82EF },
	{ 0x82F1 , 1 ,12 ,12 ,24 ,(char *) uc2_82F1 },
	{ 0x82F4 , 1 ,12 ,12 ,24 ,(char *) uc2_82F4 },
	{ 0x82F7 , 1 ,12 ,12 ,24 ,(char *) uc2_82F7 },
	{ 0x82F9 , 1 ,12 ,12 ,24 ,(char *) uc2_82F9 },
	{ 0x82FB , 1 ,12 ,12 ,24 ,(char *) uc2_82FB },
	{ 0x8301 , 1 ,12 ,12 ,24 ,(char *) uc2_8301 },
	{ 0x8302 , 1 ,12 ,12 ,24 ,(char *) uc2_8302 },
	{ 0x8303 , 1 ,12 ,12 ,24 ,(char *) uc2_8303 },
	{ 0x8304 , 1 ,12 ,12 ,24 ,(char *) uc2_8304 },
	{ 0x8305 , 1 ,12 ,12 ,24 ,(char *) uc2_8305 },
	{ 0x8306 , 1 ,12 ,12 ,24 ,(char *) uc2_8306 },
	{ 0x8307 , 1 ,12 ,12 ,24 ,(char *) uc2_8307 },
	{ 0x8308 , 1 ,12 ,12 ,24 ,(char *) uc2_8308 },
	{ 0x8309 , 1 ,12 ,12 ,24 ,(char *) uc2_8309 },
	{ 0x830C , 1 ,12 ,12 ,24 ,(char *) uc2_830C },
	{ 0x830E , 1 ,12 ,12 ,24 ,(char *) uc2_830E },
	{ 0x830F , 1 ,12 ,12 ,24 ,(char *) uc2_830F },
	{ 0x8311 , 1 ,12 ,12 ,24 ,(char *) uc2_8311 },
	{ 0x8314 , 1 ,12 ,12 ,24 ,(char *) uc2_8314 },
	{ 0x8315 , 1 ,12 ,12 ,24 ,(char *) uc2_8315 },
	{ 0x8317 , 1 ,12 ,12 ,24 ,(char *) uc2_8317 },
	{ 0x831A , 1 ,12 ,12 ,24 ,(char *) uc2_831A },
	{ 0x831B , 1 ,12 ,12 ,24 ,(char *) uc2_831B },
	{ 0x831C , 1 ,12 ,12 ,24 ,(char *) uc2_831C },
	{ 0x8327 , 1 ,12 ,12 ,24 ,(char *) uc2_8327 },
	{ 0x8328 , 1 ,12 ,12 ,24 ,(char *) uc2_8328 },
	{ 0x832B , 1 ,12 ,12 ,24 ,(char *) uc2_832B },
	{ 0x832C , 1 ,12 ,12 ,24 ,(char *) uc2_832C },
	{ 0x832D , 1 ,12 ,12 ,24 ,(char *) uc2_832D },
	{ 0x832F , 1 ,12 ,12 ,24 ,(char *) uc2_832F },
	{ 0x8331 , 1 ,12 ,12 ,24 ,(char *) uc2_8331 },
	{ 0x8333 , 1 ,12 ,12 ,24 ,(char *) uc2_8333 },
	{ 0x8334 , 1 ,12 ,12 ,24 ,(char *) uc2_8334 },
	{ 0x8335 , 1 ,12 ,12 ,24 ,(char *) uc2_8335 },
	{ 0x8336 , 1 ,12 ,12 ,24 ,(char *) uc2_8336 },
	{ 0x8338 , 1 ,12 ,12 ,24 ,(char *) uc2_8338 },
	{ 0x8339 , 1 ,12 ,12 ,24 ,(char *) uc2_8339 },
	{ 0x833A , 1 ,12 ,12 ,24 ,(char *) uc2_833A },
	{ 0x833C , 1 ,12 ,12 ,24 ,(char *) uc2_833C },
	{ 0x8340 , 1 ,12 ,12 ,24 ,(char *) uc2_8340 },
	{ 0x8343 , 1 ,12 ,12 ,24 ,(char *) uc2_8343 },
	{ 0x8346 , 1 ,12 ,12 ,24 ,(char *) uc2_8346 },
	{ 0x8347 , 1 ,12 ,12 ,24 ,(char *) uc2_8347 },
	{ 0x8349 , 1 ,12 ,12 ,24 ,(char *) uc2_8349 },
	{ 0x834F , 1 ,12 ,12 ,24 ,(char *) uc2_834F },
	{ 0x8350 , 1 ,12 ,12 ,24 ,(char *) uc2_8350 },
	{ 0x8351 , 1 ,12 ,12 ,24 ,(char *) uc2_8351 },
	{ 0x8352 , 1 ,12 ,12 ,24 ,(char *) uc2_8352 },
	{ 0x8354 , 1 ,12 ,12 ,24 ,(char *) uc2_8354 },
	{ 0x835A , 1 ,12 ,12 ,24 ,(char *) uc2_835A },
	{ 0x835B , 1 ,12 ,12 ,24 ,(char *) uc2_835B },
	{ 0x835C , 1 ,12 ,12 ,24 ,(char *) uc2_835C },
	{ 0x835E , 1 ,12 ,12 ,24 ,(char *) uc2_835E },
	{ 0x835F , 1 ,12 ,12 ,24 ,(char *) uc2_835F },
	{ 0x8360 , 1 ,12 ,12 ,24 ,(char *) uc2_8360 },
	{ 0x8361 , 1 ,12 ,12 ,24 ,(char *) uc2_8361 },
	{ 0x8363 , 1 ,12 ,12 ,24 ,(char *) uc2_8363 },
	{ 0x8364 , 1 ,12 ,12 ,24 ,(char *) uc2_8364 },
	{ 0x8365 , 1 ,12 ,12 ,24 ,(char *) uc2_8365 },
	{ 0x8366 , 1 ,12 ,12 ,24 ,(char *) uc2_8366 },
	{ 0x8367 , 1 ,12 ,12 ,24 ,(char *) uc2_8367 },
	{ 0x8368 , 1 ,12 ,12 ,24 ,(char *) uc2_8368 },
	{ 0x8369 , 1 ,12 ,12 ,24 ,(char *) uc2_8369 },
	{ 0x836A , 1 ,12 ,12 ,24 ,(char *) uc2_836A },
	{ 0x836B , 1 ,12 ,12 ,24 ,(char *) uc2_836B },
	{ 0x836C , 1 ,12 ,12 ,24 ,(char *) uc2_836C },
	{ 0x836D , 1 ,12 ,12 ,24 ,(char *) uc2_836D },
	{ 0x836E , 1 ,12 ,12 ,24 ,(char *) uc2_836E },
	{ 0x836F , 1 ,12 ,12 ,24 ,(char *) uc2_836F },
	{ 0x8377 , 1 ,12 ,12 ,24 ,(char *) uc2_8377 },
	{ 0x8378 , 1 ,12 ,12 ,24 ,(char *) uc2_8378 },
	{ 0x837B , 1 ,12 ,12 ,24 ,(char *) uc2_837B },
	{ 0x837C , 1 ,12 ,12 ,24 ,(char *) uc2_837C },
	{ 0x837D , 1 ,12 ,12 ,24 ,(char *) uc2_837D },
	{ 0x8385 , 1 ,12 ,12 ,24 ,(char *) uc2_8385 },
	{ 0x8386 , 1 ,12 ,12 ,24 ,(char *) uc2_8386 },
	{ 0x8389 , 1 ,12 ,12 ,24 ,(char *) uc2_8389 },
	{ 0x838E , 1 ,12 ,12 ,24 ,(char *) uc2_838E },
	{ 0x8392 , 1 ,12 ,12 ,24 ,(char *) uc2_8392 },
	{ 0x8393 , 1 ,12 ,12 ,24 ,(char *) uc2_8393 },
	{ 0x8398 , 1 ,12 ,12 ,24 ,(char *) uc2_8398 },
	{ 0x839B , 1 ,12 ,12 ,24 ,(char *) uc2_839B },
	{ 0x839C , 1 ,12 ,12 ,24 ,(char *) uc2_839C },
	{ 0x839E , 1 ,12 ,12 ,24 ,(char *) uc2_839E },
	{ 0x83A0 , 1 ,12 ,12 ,24 ,(char *) uc2_83A0 },
	{ 0x83A8 , 1 ,12 ,12 ,24 ,(char *) uc2_83A8 },
	{ 0x83A9 , 1 ,12 ,12 ,24 ,(char *) uc2_83A9 },
	{ 0x83AA , 1 ,12 ,12 ,24 ,(char *) uc2_83AA },
	{ 0x83AB , 1 ,12 ,12 ,24 ,(char *) uc2_83AB },
	{ 0x83B0 , 1 ,12 ,12 ,24 ,(char *) uc2_83B0 },
	{ 0x83B1 , 1 ,12 ,12 ,24 ,(char *) uc2_83B1 },
	{ 0x83B2 , 1 ,12 ,12 ,24 ,(char *) uc2_83B2 },
	{ 0x83B3 , 1 ,12 ,12 ,24 ,(char *) uc2_83B3 },
	{ 0x83B4 , 1 ,12 ,12 ,24 ,(char *) uc2_83B4 },
	{ 0x83B6 , 1 ,12 ,12 ,24 ,(char *) uc2_83B6 },
	{ 0x83B7 , 1 ,12 ,12 ,24 ,(char *) uc2_83B7 },
	{ 0x83B8 , 1 ,12 ,12 ,24 ,(char *) uc2_83B8 },
	{ 0x83B9 , 1 ,12 ,12 ,24 ,(char *) uc2_83B9 },
	{ 0x83BA , 1 ,12 ,12 ,24 ,(char *) uc2_83BA },
	{ 0x83BC , 1 ,12 ,12 ,24 ,(char *) uc2_83BC },
	{ 0x83BD , 1 ,12 ,12 ,24 ,(char *) uc2_83BD },
	{ 0x83C0 , 1 ,12 ,12 ,24 ,(char *) uc2_83C0 },
	{ 0x83C1 , 1 ,12 ,12 ,24 ,(char *) uc2_83C1 },
	{ 0x83C5 , 1 ,12 ,12 ,24 ,(char *) uc2_83C5 },
	{ 0x83C7 , 1 ,12 ,12 ,24 ,(char *) uc2_83C7 },
	{ 0x83CA , 1 ,12 ,12 ,24 ,(char *) uc2_83CA },
	{ 0x83CC , 1 ,12 ,12 ,24 ,(char *) uc2_83CC },
	{ 0x83CF , 1 ,12 ,12 ,24 ,(char *) uc2_83CF },
	{ 0x83D3 , 1 ,12 ,12 ,24 ,(char *) uc2_83D3 },
	{ 0x83D4 , 1 ,12 ,12 ,24 ,(char *) uc2_83D4 },
	{ 0x83D6 , 1 ,12 ,12 ,24 ,(char *) uc2_83D6 },
	{ 0x83D8 , 1 ,12 ,12 ,24 ,(char *) uc2_83D8 },
	{ 0x83DC , 1 ,12 ,12 ,24 ,(char *) uc2_83DC },
	{ 0x83DD , 1 ,12 ,12 ,24 ,(char *) uc2_83DD },
	{ 0x83DF , 1 ,12 ,12 ,24 ,(char *) uc2_83DF },
	{ 0x83E0 , 1 ,12 ,12 ,24 ,(char *) uc2_83E0 },
	{ 0x83E1 , 1 ,12 ,12 ,24 ,(char *) uc2_83E1 },
	{ 0x83E5 , 1 ,12 ,12 ,24 ,(char *) uc2_83E5 },
	{ 0x83E9 , 1 ,12 ,12 ,24 ,(char *) uc2_83E9 },
	{ 0x83EA , 1 ,12 ,12 ,24 ,(char *) uc2_83EA },
	{ 0x83F0 , 1 ,12 ,12 ,24 ,(char *) uc2_83F0 },
	{ 0x83F1 , 1 ,12 ,12 ,24 ,(char *) uc2_83F1 },
	{ 0x83F2 , 1 ,12 ,12 ,24 ,(char *) uc2_83F2 },
	{ 0x83F8 , 1 ,12 ,12 ,24 ,(char *) uc2_83F8 },
	{ 0x83F9 , 1 ,12 ,12 ,24 ,(char *) uc2_83F9 },
	{ 0x83FD , 1 ,12 ,12 ,24 ,(char *) uc2_83FD },
	{ 0x8401 , 1 ,12 ,12 ,24 ,(char *) uc2_8401 },
	{ 0x8403 , 1 ,12 ,12 ,24 ,(char *) uc2_8403 },
	{ 0x8404 , 1 ,12 ,12 ,24 ,(char *) uc2_8404 },
	{ 0x8406 , 1 ,12 ,12 ,24 ,(char *) uc2_8406 },
	{ 0x840B , 1 ,12 ,12 ,24 ,(char *) uc2_840B },
	{ 0x840C , 1 ,12 ,12 ,24 ,(char *) uc2_840C },
	{ 0x840D , 1 ,12 ,12 ,24 ,(char *) uc2_840D },
	{ 0x840E , 1 ,12 ,12 ,24 ,(char *) uc2_840E },
	{ 0x840F , 1 ,12 ,12 ,24 ,(char *) uc2_840F },
	{ 0x8411 , 1 ,12 ,12 ,24 ,(char *) uc2_8411 },
	{ 0x8418 , 1 ,12 ,12 ,24 ,(char *) uc2_8418 },
	{ 0x841C , 1 ,12 ,12 ,24 ,(char *) uc2_841C },
	{ 0x841D , 1 ,12 ,12 ,24 ,(char *) uc2_841D },
	{ 0x8424 , 1 ,12 ,12 ,24 ,(char *) uc2_8424 },
	{ 0x8425 , 1 ,12 ,12 ,24 ,(char *) uc2_8425 },
	{ 0x8426 , 1 ,12 ,12 ,24 ,(char *) uc2_8426 },
	{ 0x8427 , 1 ,12 ,12 ,24 ,(char *) uc2_8427 },
	{ 0x8428 , 1 ,12 ,12 ,24 ,(char *) uc2_8428 },
	{ 0x8431 , 1 ,12 ,12 ,24 ,(char *) uc2_8431 },
	{ 0x8438 , 1 ,12 ,12 ,24 ,(char *) uc2_8438 },
	{ 0x843C , 1 ,12 ,12 ,24 ,(char *) uc2_843C },
	{ 0x843D , 1 ,12 ,12 ,24 ,(char *) uc2_843D },
	{ 0x8446 , 1 ,12 ,12 ,24 ,(char *) uc2_8446 },
	{ 0x8451 , 1 ,12 ,12 ,24 ,(char *) uc2_8451 },
	{ 0x8457 , 1 ,12 ,12 ,24 ,(char *) uc2_8457 },
	{ 0x8459 , 1 ,12 ,12 ,24 ,(char *) uc2_8459 },
	{ 0x845A , 1 ,12 ,12 ,24 ,(char *) uc2_845A },
	{ 0x845B , 1 ,12 ,12 ,24 ,(char *) uc2_845B },
	{ 0x845C , 1 ,12 ,12 ,24 ,(char *) uc2_845C },
	{ 0x8461 , 1 ,12 ,12 ,24 ,(char *) uc2_8461 },
	{ 0x8463 , 1 ,12 ,12 ,24 ,(char *) uc2_8463 },
	{ 0x8469 , 1 ,12 ,12 ,24 ,(char *) uc2_8469 },
	{ 0x846B , 1 ,12 ,12 ,24 ,(char *) uc2_846B },
	{ 0x846C , 1 ,12 ,12 ,24 ,(char *) uc2_846C },
	{ 0x846D , 1 ,12 ,12 ,24 ,(char *) uc2_846D },
	{ 0x8471 , 1 ,12 ,12 ,24 ,(char *) uc2_8471 },
	{ 0x8473 , 1 ,12 ,12 ,24 ,(char *) uc2_8473 },
	{ 0x8475 , 1 ,12 ,12 ,24 ,(char *) uc2_8475 },
	{ 0x8476 , 1 ,12 ,12 ,24 ,(char *) uc2_8476 },
	{ 0x8478 , 1 ,12 ,12 ,24 ,(char *) uc2_8478 },
	{ 0x847A , 1 ,12 ,12 ,24 ,(char *) uc2_847A },
	{ 0x8482 , 1 ,12 ,12 ,24 ,(char *) uc2_8482 },
	{ 0x8487 , 1 ,12 ,12 ,24 ,(char *) uc2_8487 },
	{ 0x8488 , 1 ,12 ,12 ,24 ,(char *) uc2_8488 },
	{ 0x8489 , 1 ,12 ,12 ,24 ,(char *) uc2_8489 },
	{ 0x848B , 1 ,12 ,12 ,24 ,(char *) uc2_848B },
	{ 0x848C , 1 ,12 ,12 ,24 ,(char *) uc2_848C },
	{ 0x848E , 1 ,12 ,12 ,24 ,(char *) uc2_848E },
	{ 0x8497 , 1 ,12 ,12 ,24 ,(char *) uc2_8497 },
	{ 0x8499 , 1 ,12 ,12 ,24 ,(char *) uc2_8499 },
	{ 0x849C , 1 ,12 ,12 ,24 ,(char *) uc2_849C },
	{ 0x84A1 , 1 ,12 ,12 ,24 ,(char *) uc2_84A1 },
	{ 0x84AF , 1 ,12 ,12 ,24 ,(char *) uc2_84AF },
	{ 0x84B2 , 1 ,12 ,12 ,24 ,(char *) uc2_84B2 },
	{ 0x84B4 , 1 ,12 ,12 ,24 ,(char *) uc2_84B4 },
	{ 0x84B8 , 1 ,12 ,12 ,24 ,(char *) uc2_84B8 },
	{ 0x84B9 , 1 ,12 ,12 ,24 ,(char *) uc2_84B9 },
	{ 0x84BA , 1 ,12 ,12 ,24 ,(char *) uc2_84BA },
	{ 0x84BD , 1 ,12 ,12 ,24 ,(char *) uc2_84BD },
	{ 0x84BF , 1 ,12 ,12 ,24 ,(char *) uc2_84BF },
	{ 0x84C1 , 1 ,12 ,12 ,24 ,(char *) uc2_84C1 },
	{ 0x84C4 , 1 ,12 ,12 ,24 ,(char *) uc2_84C4 },
	{ 0x84C9 , 1 ,12 ,12 ,24 ,(char *) uc2_84C9 },
	{ 0x84CA , 1 ,12 ,12 ,24 ,(char *) uc2_84CA },
	{ 0x84CD , 1 ,12 ,12 ,24 ,(char *) uc2_84CD },
	{ 0x84D0 , 1 ,12 ,12 ,24 ,(char *) uc2_84D0 },
	{ 0x84D1 , 1 ,12 ,12 ,24 ,(char *) uc2_84D1 },
	{ 0x84D3 , 1 ,12 ,12 ,24 ,(char *) uc2_84D3 },
	{ 0x84D6 , 1 ,12 ,12 ,24 ,(char *) uc2_84D6 },
	{ 0x84DD , 1 ,12 ,12 ,24 ,(char *) uc2_84DD },
	{ 0x84DF , 1 ,12 ,12 ,24 ,(char *) uc2_84DF },
	{ 0x84E0 , 1 ,12 ,12 ,24 ,(char *) uc2_84E0 },
	{ 0x84E3 , 1 ,12 ,12 ,24 ,(char *) uc2_84E3 },
	{ 0x84E5 , 1 ,12 ,12 ,24 ,(char *) uc2_84E5 },
	{ 0x84E6 , 1 ,12 ,12 ,24 ,(char *) uc2_84E6 },
	{ 0x84EC , 1 ,12 ,12 ,24 ,(char *) uc2_84EC },
	{ 0x84F0 , 1 ,12 ,12 ,24 ,(char *) uc2_84F0 },
	{ 0x84FC , 1 ,12 ,12 ,24 ,(char *) uc2_84FC },
	{ 0x84FF , 1 ,12 ,12 ,24 ,(char *) uc2_84FF },
	{ 0x850C , 1 ,12 ,12 ,24 ,(char *) uc2_850C },
	{ 0x8511 , 1 ,12 ,12 ,24 ,(char *) uc2_8511 },
	{ 0x8513 , 1 ,12 ,12 ,24 ,(char *) uc2_8513 },
	{ 0x8517 , 1 ,12 ,12 ,24 ,(char *) uc2_8517 },
	{ 0x851A , 1 ,12 ,12 ,24 ,(char *) uc2_851A },
	{ 0x851F , 1 ,12 ,12 ,24 ,(char *) uc2_851F },
	{ 0x8521 , 1 ,12 ,12 ,24 ,(char *) uc2_8521 },
	{ 0x852B , 1 ,12 ,12 ,24 ,(char *) uc2_852B },
	{ 0x852C , 1 ,12 ,12 ,24 ,(char *) uc2_852C },
	{ 0x8537 , 1 ,12 ,12 ,24 ,(char *) uc2_8537 },
	{ 0x8538 , 1 ,12 ,12 ,24 ,(char *) uc2_8538 },
	{ 0x8539 , 1 ,12 ,12 ,24 ,(char *) uc2_8539 },
	{ 0x853A , 1 ,12 ,12 ,24 ,(char *) uc2_853A },
	{ 0x853B , 1 ,12 ,12 ,24 ,(char *) uc2_853B },
	{ 0x853C , 1 ,12 ,12 ,24 ,(char *) uc2_853C },
	{ 0x853D , 1 ,12 ,12 ,24 ,(char *) uc2_853D },
	{ 0x8543 , 1 ,12 ,12 ,24 ,(char *) uc2_8543 },
	{ 0x8548 , 1 ,12 ,12 ,24 ,(char *) uc2_8548 },
	{ 0x8549 , 1 ,12 ,12 ,24 ,(char *) uc2_8549 },
	{ 0x854A , 1 ,12 ,12 ,24 ,(char *) uc2_854A },
	{ 0x8556 , 1 ,12 ,12 ,24 ,(char *) uc2_8556 },
	{ 0x8559 , 1 ,12 ,12 ,24 ,(char *) uc2_8559 },
	{ 0x855E , 1 ,12 ,12 ,24 ,(char *) uc2_855E },
	{ 0x8564 , 1 ,12 ,12 ,24 ,(char *) uc2_8564 },
	{ 0x8568 , 1 ,12 ,12 ,24 ,(char *) uc2_8568 },
	{ 0x8572 , 1 ,12 ,12 ,24 ,(char *) uc2_8572 },
	{ 0x8574 , 1 ,12 ,12 ,24 ,(char *) uc2_8574 },
	{ 0x8579 , 1 ,12 ,12 ,24 ,(char *) uc2_8579 },
	{ 0x857A , 1 ,12 ,12 ,24 ,(char *) uc2_857A },
	{ 0x857B , 1 ,12 ,12 ,24 ,(char *) uc2_857B },
	{ 0x857E , 1 ,12 ,12 ,24 ,(char *) uc2_857E },
	{ 0x8584 , 1 ,12 ,12 ,24 ,(char *) uc2_8584 },
	{ 0x8585 , 1 ,12 ,12 ,24 ,(char *) uc2_8585 },
	{ 0x8587 , 1 ,12 ,12 ,24 ,(char *) uc2_8587 },
	{ 0x858F , 1 ,12 ,12 ,24 ,(char *) uc2_858F },
	{ 0x859B , 1 ,12 ,12 ,24 ,(char *) uc2_859B },
	{ 0x859C , 1 ,12 ,12 ,24 ,(char *) uc2_859C },
	{ 0x85A4 , 1 ,12 ,12 ,24 ,(char *) uc2_85A4 },
	{ 0x85A8 , 1 ,12 ,12 ,24 ,(char *) uc2_85A8 },
	{ 0x85AA , 1 ,12 ,12 ,24 ,(char *) uc2_85AA },
	{ 0x85AE , 1 ,12 ,12 ,24 ,(char *) uc2_85AE },
	{ 0x85AF , 1 ,12 ,12 ,24 ,(char *) uc2_85AF },
	{ 0x85B0 , 1 ,12 ,12 ,24 ,(char *) uc2_85B0 },
	{ 0x85B7 , 1 ,12 ,12 ,24 ,(char *) uc2_85B7 },
	{ 0x85B9 , 1 ,12 ,12 ,24 ,(char *) uc2_85B9 },
	{ 0x85C1 , 1 ,12 ,12 ,24 ,(char *) uc2_85C1 },
	{ 0x85C9 , 1 ,12 ,12 ,24 ,(char *) uc2_85C9 },
	{ 0x85CF , 1 ,12 ,12 ,24 ,(char *) uc2_85CF },
	{ 0x85D0 , 1 ,12 ,12 ,24 ,(char *) uc2_85D0 },
	{ 0x85D3 , 1 ,12 ,12 ,24 ,(char *) uc2_85D3 },
	{ 0x85D5 , 1 ,12 ,12 ,24 ,(char *) uc2_85D5 },
	{ 0x85DC , 1 ,12 ,12 ,24 ,(char *) uc2_85DC },
	{ 0x85E4 , 1 ,12 ,12 ,24 ,(char *) uc2_85E4 },
	{ 0x85E9 , 1 ,12 ,12 ,24 ,(char *) uc2_85E9 },
	{ 0x85FB , 1 ,12 ,12 ,24 ,(char *) uc2_85FB },
	{ 0x85FF , 1 ,12 ,12 ,24 ,(char *) uc2_85FF },
	{ 0x8605 , 1 ,12 ,12 ,24 ,(char *) uc2_8605 },
	{ 0x8611 , 1 ,12 ,12 ,24 ,(char *) uc2_8611 },
	{ 0x8616 , 1 ,12 ,12 ,24 ,(char *) uc2_8616 },
	{ 0x8627 , 1 ,12 ,12 ,24 ,(char *) uc2_8627 },
	{ 0x8629 , 1 ,12 ,12 ,24 ,(char *) uc2_8629 },
	{ 0x8638 , 1 ,12 ,12 ,24 ,(char *) uc2_8638 },
	{ 0x863C , 1 ,12 ,12 ,24 ,(char *) uc2_863C },
	{ 0x864E , 1 ,12 ,12 ,24 ,(char *) uc2_864E },
	{ 0x864F , 1 ,12 ,12 ,24 ,(char *) uc2_864F },
	{ 0x8650 , 1 ,12 ,12 ,24 ,(char *) uc2_8650 },
	{ 0x8651 , 1 ,12 ,12 ,24 ,(char *) uc2_8651 },
	{ 0x8654 , 1 ,12 ,12 ,24 ,(char *) uc2_8654 },
	{ 0x865A , 1 ,12 ,12 ,24 ,(char *) uc2_865A },
	{ 0x865E , 1 ,12 ,12 ,24 ,(char *) uc2_865E },
	{ 0x8662 , 1 ,12 ,12 ,24 ,(char *) uc2_8662 },
	{ 0x866B , 1 ,12 ,12 ,24 ,(char *) uc2_866B },
	{ 0x866C , 1 ,12 ,12 ,24 ,(char *) uc2_866C },
	{ 0x866E , 1 ,12 ,12 ,24 ,(char *) uc2_866E },
	{ 0x8671 , 1 ,12 ,12 ,24 ,(char *) uc2_8671 },
	{ 0x8679 , 1 ,12 ,12 ,24 ,(char *) uc2_8679 },
	{ 0x867A , 1 ,12 ,12 ,24 ,(char *) uc2_867A },
	{ 0x867B , 1 ,12 ,12 ,24 ,(char *) uc2_867B },
	{ 0x867C , 1 ,12 ,12 ,24 ,(char *) uc2_867C },
	{ 0x867D , 1 ,12 ,12 ,24 ,(char *) uc2_867D },
	{ 0x867E , 1 ,12 ,12 ,24 ,(char *) uc2_867E },
	{ 0x867F , 1 ,12 ,12 ,24 ,(char *) uc2_867F },
	{ 0x8680 , 1 ,12 ,12 ,24 ,(char *) uc2_8680 },
	{ 0x8681 , 1 ,12 ,12 ,24 ,(char *) uc2_8681 },
	{ 0x8682 , 1 ,12 ,12 ,24 ,(char *) uc2_8682 },
	{ 0x868A , 1 ,12 ,12 ,24 ,(char *) uc2_868A },
	{ 0x868B , 1 ,12 ,12 ,24 ,(char *) uc2_868B },
	{ 0x868C , 1 ,12 ,12 ,24 ,(char *) uc2_868C },
	{ 0x868D , 1 ,12 ,12 ,24 ,(char *) uc2_868D },
	{ 0x8693 , 1 ,12 ,12 ,24 ,(char *) uc2_8693 },
	{ 0x8695 , 1 ,12 ,12 ,24 ,(char *) uc2_8695 },
	{ 0x869C , 1 ,12 ,12 ,24 ,(char *) uc2_869C },
	{ 0x869D , 1 ,12 ,12 ,24 ,(char *) uc2_869D },
	{ 0x86A3 , 1 ,12 ,12 ,24 ,(char *) uc2_86A3 },
	{ 0x86A4 , 1 ,12 ,12 ,24 ,(char *) uc2_86A4 },
	{ 0x86A7 , 1 ,12 ,12 ,24 ,(char *) uc2_86A7 },
	{ 0x86A8 , 1 ,12 ,12 ,24 ,(char *) uc2_86A8 },
	{ 0x86A9 , 1 ,12 ,12 ,24 ,(char *) uc2_86A9 },
	{ 0x86AA , 1 ,12 ,12 ,24 ,(char *) uc2_86AA },
	{ 0x86AC , 1 ,12 ,12 ,24 ,(char *) uc2_86AC },
	{ 0x86AF , 1 ,12 ,12 ,24 ,(char *) uc2_86AF },
	{ 0x86B0 , 1 ,12 ,12 ,24 ,(char *) uc2_86B0 },
	{ 0x86B1 , 1 ,12 ,12 ,24 ,(char *) uc2_86B1 },
	{ 0x86B4 , 1 ,12 ,12 ,24 ,(char *) uc2_86B4 },
	{ 0x86B5 , 1 ,12 ,12 ,24 ,(char *) uc2_86B5 },
	{ 0x86B6 , 1 ,12 ,12 ,24 ,(char *) uc2_86B6 },
	{ 0x86BA , 1 ,12 ,12 ,24 ,(char *) uc2_86BA },
	{ 0x86C0 , 1 ,12 ,12 ,24 ,(char *) uc2_86C0 },
	{ 0x86C4 , 1 ,12 ,12 ,24 ,(char *) uc2_86C4 },
	{ 0x86C6 , 1 ,12 ,12 ,24 ,(char *) uc2_86C6 },
	{ 0x86C7 , 1 ,12 ,12 ,24 ,(char *) uc2_86C7 },
	{ 0x86C9 , 1 ,12 ,12 ,24 ,(char *) uc2_86C9 },
	{ 0x86CA , 1 ,12 ,12 ,24 ,(char *) uc2_86CA },
	{ 0x86CB , 1 ,12 ,12 ,24 ,(char *) uc2_86CB },
	{ 0x86CE , 1 ,12 ,12 ,24 ,(char *) uc2_86CE },
	{ 0x86CF , 1 ,12 ,12 ,24 ,(char *) uc2_86CF },
	{ 0x86D0 , 1 ,12 ,12 ,24 ,(char *) uc2_86D0 },
	{ 0x86D1 , 1 ,12 ,12 ,24 ,(char *) uc2_86D1 },
	{ 0x86D4 , 1 ,12 ,12 ,24 ,(char *) uc2_86D4 },
	{ 0x86D8 , 1 ,12 ,12 ,24 ,(char *) uc2_86D8 },
	{ 0x86D9 , 1 ,12 ,12 ,24 ,(char *) uc2_86D9 },
	{ 0x86DB , 1 ,12 ,12 ,24 ,(char *) uc2_86DB },
	{ 0x86DE , 1 ,12 ,12 ,24 ,(char *) uc2_86DE },
	{ 0x86DF , 1 ,12 ,12 ,24 ,(char *) uc2_86DF },
	{ 0x86E4 , 1 ,12 ,12 ,24 ,(char *) uc2_86E4 },
	{ 0x86E9 , 1 ,12 ,12 ,24 ,(char *) uc2_86E9 },
	{ 0x86ED , 1 ,12 ,12 ,24 ,(char *) uc2_86ED },
	{ 0x86EE , 1 ,12 ,12 ,24 ,(char *) uc2_86EE },
	{ 0x86F0 , 1 ,12 ,12 ,24 ,(char *) uc2_86F0 },
	{ 0x86F1 , 1 ,12 ,12 ,24 ,(char *) uc2_86F1 },
	{ 0x86F2 , 1 ,12 ,12 ,24 ,(char *) uc2_86F2 },
	{ 0x86F3 , 1 ,12 ,12 ,24 ,(char *) uc2_86F3 },
	{ 0x86F4 , 1 ,12 ,12 ,24 ,(char *) uc2_86F4 },
	{ 0x86F8 , 1 ,12 ,12 ,24 ,(char *) uc2_86F8 },
	{ 0x86F9 , 1 ,12 ,12 ,24 ,(char *) uc2_86F9 },
	{ 0x86FE , 1 ,12 ,12 ,24 ,(char *) uc2_86FE },
	{ 0x8700 , 1 ,12 ,12 ,24 ,(char *) uc2_8700 },
	{ 0x8702 , 1 ,12 ,12 ,24 ,(char *) uc2_8702 },
	{ 0x8703 , 1 ,12 ,12 ,24 ,(char *) uc2_8703 },
	{ 0x8707 , 1 ,12 ,12 ,24 ,(char *) uc2_8707 },
	{ 0x8708 , 1 ,12 ,12 ,24 ,(char *) uc2_8708 },
	{ 0x8709 , 1 ,12 ,12 ,24 ,(char *) uc2_8709 },
	{ 0x870A , 1 ,12 ,12 ,24 ,(char *) uc2_870A },
	{ 0x870D , 1 ,12 ,12 ,24 ,(char *) uc2_870D },
	{ 0x8712 , 1 ,12 ,12 ,24 ,(char *) uc2_8712 },
	{ 0x8713 , 1 ,12 ,12 ,24 ,(char *) uc2_8713 },
	{ 0x8715 , 1 ,12 ,12 ,24 ,(char *) uc2_8715 },
	{ 0x8717 , 1 ,12 ,12 ,24 ,(char *) uc2_8717 },
	{ 0x8718 , 1 ,12 ,12 ,24 ,(char *) uc2_8718 },
	{ 0x871A , 1 ,12 ,12 ,24 ,(char *) uc2_871A },
	{ 0x871C , 1 ,12 ,12 ,24 ,(char *) uc2_871C },
	{ 0x871E , 1 ,12 ,12 ,24 ,(char *) uc2_871E },
	{ 0x8721 , 1 ,12 ,12 ,24 ,(char *) uc2_8721 },
	{ 0x8722 , 1 ,12 ,12 ,24 ,(char *) uc2_8722 },
	{ 0x8723 , 1 ,12 ,12 ,24 ,(char *) uc2_8723 },
	{ 0x8725 , 1 ,12 ,12 ,24 ,(char *) uc2_8725 },
	{ 0x8729 , 1 ,12 ,12 ,24 ,(char *) uc2_8729 },
	{ 0x872E , 1 ,12 ,12 ,24 ,(char *) uc2_872E },
	{ 0x8731 , 1 ,12 ,12 ,24 ,(char *) uc2_8731 },
	{ 0x8734 , 1 ,12 ,12 ,24 ,(char *) uc2_8734 },
	{ 0x8737 , 1 ,12 ,12 ,24 ,(char *) uc2_8737 },
	{ 0x873B , 1 ,12 ,12 ,24 ,(char *) uc2_873B },
	{ 0x873E , 1 ,12 ,12 ,24 ,(char *) uc2_873E },
	{ 0x873F , 1 ,12 ,12 ,24 ,(char *) uc2_873F },
	{ 0x8747 , 1 ,12 ,12 ,24 ,(char *) uc2_8747 },
	{ 0x8748 , 1 ,12 ,12 ,24 ,(char *) uc2_8748 },
	{ 0x8749 , 1 ,12 ,12 ,24 ,(char *) uc2_8749 },
	{ 0x874C , 1 ,12 ,12 ,24 ,(char *) uc2_874C },
	{ 0x874E , 1 ,12 ,12 ,24 ,(char *) uc2_874E },
	{ 0x8753 , 1 ,12 ,12 ,24 ,(char *) uc2_8753 },
	{ 0x8757 , 1 ,12 ,12 ,24 ,(char *) uc2_8757 },
	{ 0x8759 , 1 ,12 ,12 ,24 ,(char *) uc2_8759 },
	{ 0x8760 , 1 ,12 ,12 ,24 ,(char *) uc2_8760 },
	{ 0x8763 , 1 ,12 ,12 ,24 ,(char *) uc2_8763 },
	{ 0x8764 , 1 ,12 ,12 ,24 ,(char *) uc2_8764 },
	{ 0x8765 , 1 ,12 ,12 ,24 ,(char *) uc2_8765 },
	{ 0x876E , 1 ,12 ,12 ,24 ,(char *) uc2_876E },
	{ 0x8770 , 1 ,12 ,12 ,24 ,(char *) uc2_8770 },
	{ 0x8774 , 1 ,12 ,12 ,24 ,(char *) uc2_8774 },
	{ 0x8776 , 1 ,12 ,12 ,24 ,(char *) uc2_8776 },
	{ 0x877B , 1 ,12 ,12 ,24 ,(char *) uc2_877B },
	{ 0x877C , 1 ,12 ,12 ,24 ,(char *) uc2_877C },
	{ 0x877D , 1 ,12 ,12 ,24 ,(char *) uc2_877D },
	{ 0x877E , 1 ,12 ,12 ,24 ,(char *) uc2_877E },
	{ 0x8782 , 1 ,12 ,12 ,24 ,(char *) uc2_8782 },
	{ 0x8783 , 1 ,12 ,12 ,24 ,(char *) uc2_8783 },
	{ 0x8785 , 1 ,12 ,12 ,24 ,(char *) uc2_8785 },
	{ 0x8788 , 1 ,12 ,12 ,24 ,(char *) uc2_8788 },
	{ 0x878B , 1 ,12 ,12 ,24 ,(char *) uc2_878B },
	{ 0x878D , 1 ,12 ,12 ,24 ,(char *) uc2_878D },
	{ 0x8793 , 1 ,12 ,12 ,24 ,(char *) uc2_8793 },
	{ 0x8797 , 1 ,12 ,12 ,24 ,(char *) uc2_8797 },
	{ 0x879F , 1 ,12 ,12 ,24 ,(char *) uc2_879F },
	{ 0x87A8 , 1 ,12 ,12 ,24 ,(char *) uc2_87A8 },
	{ 0x87AB , 1 ,12 ,12 ,24 ,(char *) uc2_87AB },
	{ 0x87AC , 1 ,12 ,12 ,24 ,(char *) uc2_87AC },
	{ 0x87AD , 1 ,12 ,12 ,24 ,(char *) uc2_87AD },
	{ 0x87AF , 1 ,12 ,12 ,24 ,(char *) uc2_87AF },
	{ 0x87B3 , 1 ,12 ,12 ,24 ,(char *) uc2_87B3 },
	{ 0x87B5 , 1 ,12 ,12 ,24 ,(char *) uc2_87B5 },
	{ 0x87BA , 1 ,12 ,12 ,24 ,(char *) uc2_87BA },
	{ 0x87BD , 1 ,12 ,12 ,24 ,(char *) uc2_87BD },
	{ 0x87C0 , 1 ,12 ,12 ,24 ,(char *) uc2_87C0 },
	{ 0x87C6 , 1 ,12 ,12 ,24 ,(char *) uc2_87C6 },
	{ 0x87CA , 1 ,12 ,12 ,24 ,(char *) uc2_87CA },
	{ 0x87CB , 1 ,12 ,12 ,24 ,(char *) uc2_87CB },
	{ 0x87D1 , 1 ,12 ,12 ,24 ,(char *) uc2_87D1 },
	{ 0x87D2 , 1 ,12 ,12 ,24 ,(char *) uc2_87D2 },
	{ 0x87D3 , 1 ,12 ,12 ,24 ,(char *) uc2_87D3 },
	{ 0x87DB , 1 ,12 ,12 ,24 ,(char *) uc2_87DB },
	{ 0x87E0 , 1 ,12 ,12 ,24 ,(char *) uc2_87E0 },
	{ 0x87E5 , 1 ,12 ,12 ,24 ,(char *) uc2_87E5 },
	{ 0x87EA , 1 ,12 ,12 ,24 ,(char *) uc2_87EA },
	{ 0x87EE , 1 ,12 ,12 ,24 ,(char *) uc2_87EE },
	{ 0x87F9 , 1 ,12 ,12 ,24 ,(char *) uc2_87F9 },
	{ 0x87FE , 1 ,12 ,12 ,24 ,(char *) uc2_87FE },
	{ 0x8803 , 1 ,12 ,12 ,24 ,(char *) uc2_8803 },
	{ 0x880A , 1 ,12 ,12 ,24 ,(char *) uc2_880A },
	{ 0x8813 , 1 ,12 ,12 ,24 ,(char *) uc2_8813 },
	{ 0x8815 , 1 ,12 ,12 ,24 ,(char *) uc2_8815 },
	{ 0x8816 , 1 ,12 ,12 ,24 ,(char *) uc2_8816 },
	{ 0x881B , 1 ,12 ,12 ,24 ,(char *) uc2_881B },
	{ 0x8821 , 1 ,12 ,12 ,24 ,(char *) uc2_8821 },
	{ 0x8822 , 1 ,12 ,12 ,24 ,(char *) uc2_8822 },
	{ 0x8832 , 1 ,12 ,12 ,24 ,(char *) uc2_8832 },
	{ 0x8839 , 1 ,12 ,12 ,24 ,(char *) uc2_8839 },
	{ 0x883C , 1 ,12 ,12 ,24 ,(char *) uc2_883C },
	{ 0x8840 , 1 ,12 ,12 ,24 ,(char *) uc2_8840 },
	{ 0x8844 , 1 ,12 ,12 ,24 ,(char *) uc2_8844 },
	{ 0x8845 , 1 ,12 ,12 ,24 ,(char *) uc2_8845 },
	{ 0x884C , 1 ,12 ,12 ,24 ,(char *) uc2_884C },
	{ 0x884D , 1 ,12 ,12 ,24 ,(char *) uc2_884D },
	{ 0x8854 , 1 ,12 ,12 ,24 ,(char *) uc2_8854 },
	{ 0x8857 , 1 ,12 ,12 ,24 ,(char *) uc2_8857 },
	{ 0x8859 , 1 ,12 ,12 ,24 ,(char *) uc2_8859 },
	{ 0x8861 , 1 ,12 ,12 ,24 ,(char *) uc2_8861 },
	{ 0x8862 , 1 ,12 ,12 ,24 ,(char *) uc2_8862 },
	{ 0x8863 , 1 ,12 ,12 ,24 ,(char *) uc2_8863 },
	{ 0x8865 , 1 ,12 ,12 ,24 ,(char *) uc2_8865 },
	{ 0x8868 , 1 ,12 ,12 ,24 ,(char *) uc2_8868 },
	{ 0x8869 , 1 ,12 ,12 ,24 ,(char *) uc2_8869 },
	{ 0x886B , 1 ,12 ,12 ,24 ,(char *) uc2_886B },
	{ 0x886C , 1 ,12 ,12 ,24 ,(char *) uc2_886C },
	{ 0x886E , 1 ,12 ,12 ,24 ,(char *) uc2_886E },
	{ 0x8870 , 1 ,12 ,12 ,24 ,(char *) uc2_8870 },
	{ 0x8872 , 1 ,12 ,12 ,24 ,(char *) uc2_8872 },
	{ 0x8877 , 1 ,12 ,12 ,24 ,(char *) uc2_8877 },
	{ 0x887D , 1 ,12 ,12 ,24 ,(char *) uc2_887D },
	{ 0x887E , 1 ,12 ,12 ,24 ,(char *) uc2_887E },
	{ 0x887F , 1 ,12 ,12 ,24 ,(char *) uc2_887F },
	{ 0x8881 , 1 ,12 ,12 ,24 ,(char *) uc2_8881 },
	{ 0x8882 , 1 ,12 ,12 ,24 ,(char *) uc2_8882 },
	{ 0x8884 , 1 ,12 ,12 ,24 ,(char *) uc2_8884 },
	{ 0x8885 , 1 ,12 ,12 ,24 ,(char *) uc2_8885 },
	{ 0x8888 , 1 ,12 ,12 ,24 ,(char *) uc2_8888 },
	{ 0x888B , 1 ,12 ,12 ,24 ,(char *) uc2_888B },
	{ 0x888D , 1 ,12 ,12 ,24 ,(char *) uc2_888D },
	{ 0x8892 , 1 ,12 ,12 ,24 ,(char *) uc2_8892 },
	{ 0x8896 , 1 ,12 ,12 ,24 ,(char *) uc2_8896 },
	{ 0x889C , 1 ,12 ,12 ,24 ,(char *) uc2_889C },
	{ 0x88A2 , 1 ,12 ,12 ,24 ,(char *) uc2_88A2 },
	{ 0x88A4 , 1 ,12 ,12 ,24 ,(char *) uc2_88A4 },
	{ 0x88AB , 1 ,12 ,12 ,24 ,(char *) uc2_88AB },
	{ 0x88AD , 1 ,12 ,12 ,24 ,(char *) uc2_88AD },
	{ 0x88B1 , 1 ,12 ,12 ,24 ,(char *) uc2_88B1 },
	{ 0x88B4 , 1 ,12 ,12 ,24 ,(char *) uc2_88B4 },
	{ 0x88B7 , 1 ,12 ,12 ,24 ,(char *) uc2_88B7 },
	{ 0x88BC , 1 ,12 ,12 ,24 ,(char *) uc2_88BC },
	{ 0x88C1 , 1 ,12 ,12 ,24 ,(char *) uc2_88C1 },
	{ 0x88C2 , 1 ,12 ,12 ,24 ,(char *) uc2_88C2 },
	{ 0x88C5 , 1 ,12 ,12 ,24 ,(char *) uc2_88C5 },
	{ 0x88C6 , 1 ,12 ,12 ,24 ,(char *) uc2_88C6 },
	{ 0x88C9 , 1 ,12 ,12 ,24 ,(char *) uc2_88C9 },
	{ 0x88CE , 1 ,12 ,12 ,24 ,(char *) uc2_88CE },
	{ 0x88D2 , 1 ,12 ,12 ,24 ,(char *) uc2_88D2 },
	{ 0x88D4 , 1 ,12 ,12 ,24 ,(char *) uc2_88D4 },
	{ 0x88D5 , 1 ,12 ,12 ,24 ,(char *) uc2_88D5 },
	{ 0x88D8 , 1 ,12 ,12 ,24 ,(char *) uc2_88D8 },
	{ 0x88D9 , 1 ,12 ,12 ,24 ,(char *) uc2_88D9 },
	{ 0x88DF , 1 ,12 ,12 ,24 ,(char *) uc2_88DF },
	{ 0x88E2 , 1 ,12 ,12 ,24 ,(char *) uc2_88E2 },
	{ 0x88E3 , 1 ,12 ,12 ,24 ,(char *) uc2_88E3 },
	{ 0x88E4 , 1 ,12 ,12 ,24 ,(char *) uc2_88E4 },
	{ 0x88E5 , 1 ,12 ,12 ,24 ,(char *) uc2_88E5 },
	{ 0x88E8 , 1 ,12 ,12 ,24 ,(char *) uc2_88E8 },
	{ 0x88F0 , 1 ,12 ,12 ,24 ,(char *) uc2_88F0 },
	{ 0x88F1 , 1 ,12 ,12 ,24 ,(char *) uc2_88F1 },
	{ 0x88F3 , 1 ,12 ,12 ,24 ,(char *) uc2_88F3 },
	{ 0x88F4 , 1 ,12 ,12 ,24 ,(char *) uc2_88F4 },
	{ 0x88F8 , 1 ,12 ,12 ,24 ,(char *) uc2_88F8 },
	{ 0x88F9 , 1 ,12 ,12 ,24 ,(char *) uc2_88F9 },
	{ 0x88FC , 1 ,12 ,12 ,24 ,(char *) uc2_88FC },
	{ 0x88FE , 1 ,12 ,12 ,24 ,(char *) uc2_88FE },
	{ 0x8902 , 1 ,12 ,12 ,24 ,(char *) uc2_8902 },
	{ 0x890A , 1 ,12 ,12 ,24 ,(char *) uc2_890A },
	{ 0x8910 , 1 ,12 ,12 ,24 ,(char *) uc2_8910 },
	{ 0x8912 , 1 ,12 ,12 ,24 ,(char *) uc2_8912 },
	{ 0x8913 , 1 ,12 ,12 ,24 ,(char *) uc2_8913 },
	{ 0x8919 , 1 ,12 ,12 ,24 ,(char *) uc2_8919 },
	{ 0x891A , 1 ,12 ,12 ,24 ,(char *) uc2_891A },
	{ 0x891B , 1 ,12 ,12 ,24 ,(char *) uc2_891B },
	{ 0x8921 , 1 ,12 ,12 ,24 ,(char *) uc2_8921 },
	{ 0x8925 , 1 ,12 ,12 ,24 ,(char *) uc2_8925 },
	{ 0x892A , 1 ,12 ,12 ,24 ,(char *) uc2_892A },
	{ 0x892B , 1 ,12 ,12 ,24 ,(char *) uc2_892B },
	{ 0x8930 , 1 ,12 ,12 ,24 ,(char *) uc2_8930 },
	{ 0x8934 , 1 ,12 ,12 ,24 ,(char *) uc2_8934 },
	{ 0x8936 , 1 ,12 ,12 ,24 ,(char *) uc2_8936 },
	{ 0x8941 , 1 ,12 ,12 ,24 ,(char *) uc2_8941 },
	{ 0x8944 , 1 ,12 ,12 ,24 ,(char *) uc2_8944 },
	{ 0x895E , 1 ,12 ,12 ,24 ,(char *) uc2_895E },
	{ 0x895F , 1 ,12 ,12 ,24 ,(char *) uc2_895F },
	{ 0x8966 , 1 ,12 ,12 ,24 ,(char *) uc2_8966 },
	{ 0x897B , 1 ,12 ,12 ,24 ,(char *) uc2_897B },
	{ 0x897F , 1 ,12 ,12 ,24 ,(char *) uc2_897F },
	{ 0x8981 , 1 ,12 ,12 ,24 ,(char *) uc2_8981 },
	{ 0x8983 , 1 ,12 ,12 ,24 ,(char *) uc2_8983 },
	{ 0x8986 , 1 ,12 ,12 ,24 ,(char *) uc2_8986 },
	{ 0x89C1 , 1 ,12 ,12 ,24 ,(char *) uc2_89C1 },
	{ 0x89C2 , 1 ,12 ,12 ,24 ,(char *) uc2_89C2 },
	{ 0x89C4 , 1 ,12 ,12 ,24 ,(char *) uc2_89C4 },
	{ 0x89C5 , 1 ,12 ,12 ,24 ,(char *) uc2_89C5 },
	{ 0x89C6 , 1 ,12 ,12 ,24 ,(char *) uc2_89C6 },
	{ 0x89C7 , 1 ,12 ,12 ,24 ,(char *) uc2_89C7 },
	{ 0x89C8 , 1 ,12 ,12 ,24 ,(char *) uc2_89C8 },
	{ 0x89C9 , 1 ,12 ,12 ,24 ,(char *) uc2_89C9 },
	{ 0x89CA , 1 ,12 ,12 ,24 ,(char *) uc2_89CA },
	{ 0x89CB , 1 ,12 ,12 ,24 ,(char *) uc2_89CB },
	{ 0x89CC , 1 ,12 ,12 ,24 ,(char *) uc2_89CC },
	{ 0x89CE , 1 ,12 ,12 ,24 ,(char *) uc2_89CE },
	{ 0x89CF , 1 ,12 ,12 ,24 ,(char *) uc2_89CF },
	{ 0x89D0 , 1 ,12 ,12 ,24 ,(char *) uc2_89D0 },
	{ 0x89D1 , 1 ,12 ,12 ,24 ,(char *) uc2_89D1 },
	{ 0x89D2 , 1 ,12 ,12 ,24 ,(char *) uc2_89D2 },
	{ 0x89D6 , 1 ,12 ,12 ,24 ,(char *) uc2_89D6 },
	{ 0x89DA , 1 ,12 ,12 ,24 ,(char *) uc2_89DA },
	{ 0x89DC , 1 ,12 ,12 ,24 ,(char *) uc2_89DC },
	{ 0x89DE , 1 ,12 ,12 ,24 ,(char *) uc2_89DE },
	{ 0x89E3 , 1 ,12 ,12 ,24 ,(char *) uc2_89E3 },
	{ 0x89E5 , 1 ,12 ,12 ,24 ,(char *) uc2_89E5 },
	{ 0x89E6 , 1 ,12 ,12 ,24 ,(char *) uc2_89E6 },
	{ 0x89EB , 1 ,12 ,12 ,24 ,(char *) uc2_89EB },
	{ 0x89EF , 1 ,12 ,12 ,24 ,(char *) uc2_89EF },
	{ 0x89F3 , 1 ,12 ,12 ,24 ,(char *) uc2_89F3 },
	{ 0x8A00 , 1 ,12 ,12 ,24 ,(char *) uc2_8A00 },
	{ 0x8A07 , 1 ,12 ,12 ,24 ,(char *) uc2_8A07 },
	{ 0x8A3E , 1 ,12 ,12 ,24 ,(char *) uc2_8A3E },
	{ 0x8A48 , 1 ,12 ,12 ,24 ,(char *) uc2_8A48 },
	{ 0x8A79 , 1 ,12 ,12 ,24 ,(char *) uc2_8A79 },
	{ 0x8A89 , 1 ,12 ,12 ,24 ,(char *) uc2_8A89 },
	{ 0x8A8A , 1 ,12 ,12 ,24 ,(char *) uc2_8A8A },
	{ 0x8A93 , 1 ,12 ,12 ,24 ,(char *) uc2_8A93 },
	{ 0x8B07 , 1 ,12 ,12 ,24 ,(char *) uc2_8B07 },
	{ 0x8B26 , 1 ,12 ,12 ,24 ,(char *) uc2_8B26 },
	{ 0x8B66 , 1 ,12 ,12 ,24 ,(char *) uc2_8B66 },
	{ 0x8B6C , 1 ,12 ,12 ,24 ,(char *) uc2_8B6C },
	{ 0x8BA1 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA1 },
	{ 0x8BA2 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA2 },
	{ 0x8BA3 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA3 },
	{ 0x8BA4 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA4 },
	{ 0x8BA5 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA5 },
	{ 0x8BA6 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA6 },
	{ 0x8BA7 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA7 },
	{ 0x8BA8 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA8 },
	{ 0x8BA9 , 1 ,12 ,12 ,24 ,(char *) uc2_8BA9 },
	{ 0x8BAA , 1 ,12 ,12 ,24 ,(char *) uc2_8BAA },
	{ 0x8BAB , 1 ,12 ,12 ,24 ,(char *) uc2_8BAB },
	{ 0x8BAD , 1 ,12 ,12 ,24 ,(char *) uc2_8BAD },
	{ 0x8BAE , 1 ,12 ,12 ,24 ,(char *) uc2_8BAE },
	{ 0x8BAF , 1 ,12 ,12 ,24 ,(char *) uc2_8BAF },
	{ 0x8BB0 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB0 },
	{ 0x8BB2 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB2 },
	{ 0x8BB3 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB3 },
	{ 0x8BB4 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB4 },
	{ 0x8BB5 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB5 },
	{ 0x8BB6 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB6 },
	{ 0x8BB7 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB7 },
	{ 0x8BB8 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB8 },
	{ 0x8BB9 , 1 ,12 ,12 ,24 ,(char *) uc2_8BB9 },
	{ 0x8BBA , 1 ,12 ,12 ,24 ,(char *) uc2_8BBA },
	{ 0x8BBC , 1 ,12 ,12 ,24 ,(char *) uc2_8BBC },
	{ 0x8BBD , 1 ,12 ,12 ,24 ,(char *) uc2_8BBD },
	{ 0x8BBE , 1 ,12 ,12 ,24 ,(char *) uc2_8BBE },
	{ 0x8BBF , 1 ,12 ,12 ,24 ,(char *) uc2_8BBF },
	{ 0x8BC0 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC0 },
	{ 0x8BC1 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC1 },
	{ 0x8BC2 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC2 },
	{ 0x8BC3 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC3 },
	{ 0x8BC4 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC4 },
	{ 0x8BC5 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC5 },
	{ 0x8BC6 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC6 },
	{ 0x8BC8 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC8 },
	{ 0x8BC9 , 1 ,12 ,12 ,24 ,(char *) uc2_8BC9 },
	{ 0x8BCA , 1 ,12 ,12 ,24 ,(char *) uc2_8BCA },
	{ 0x8BCB , 1 ,12 ,12 ,24 ,(char *) uc2_8BCB },
	{ 0x8BCC , 1 ,12 ,12 ,24 ,(char *) uc2_8BCC },
	{ 0x8BCD , 1 ,12 ,12 ,24 ,(char *) uc2_8BCD },
	{ 0x8BCE , 1 ,12 ,12 ,24 ,(char *) uc2_8BCE },
	{ 0x8BCF , 1 ,12 ,12 ,24 ,(char *) uc2_8BCF },
	{ 0x8BD1 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD1 },
	{ 0x8BD2 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD2 },
	{ 0x8BD3 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD3 },
	{ 0x8BD4 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD4 },
	{ 0x8BD5 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD5 },
	{ 0x8BD6 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD6 },
	{ 0x8BD7 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD7 },
	{ 0x8BD8 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD8 },
	{ 0x8BD9 , 1 ,12 ,12 ,24 ,(char *) uc2_8BD9 },
	{ 0x8BDA , 1 ,12 ,12 ,24 ,(char *) uc2_8BDA },
	{ 0x8BDB , 1 ,12 ,12 ,24 ,(char *) uc2_8BDB },
	{ 0x8BDC , 1 ,12 ,12 ,24 ,(char *) uc2_8BDC },
	{ 0x8BDD , 1 ,12 ,12 ,24 ,(char *) uc2_8BDD },
	{ 0x8BDE , 1 ,12 ,12 ,24 ,(char *) uc2_8BDE },
	{ 0x8BDF , 1 ,12 ,12 ,24 ,(char *) uc2_8BDF },
	{ 0x8BE0 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE0 },
	{ 0x8BE1 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE1 },
	{ 0x8BE2 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE2 },
	{ 0x8BE3 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE3 },
	{ 0x8BE4 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE4 },
	{ 0x8BE5 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE5 },
	{ 0x8BE6 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE6 },
	{ 0x8BE7 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE7 },
	{ 0x8BE8 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE8 },
	{ 0x8BE9 , 1 ,12 ,12 ,24 ,(char *) uc2_8BE9 },
	{ 0x8BEB , 1 ,12 ,12 ,24 ,(char *) uc2_8BEB },
	{ 0x8BEC , 1 ,12 ,12 ,24 ,(char *) uc2_8BEC },
	{ 0x8BED , 1 ,12 ,12 ,24 ,(char *) uc2_8BED },
	{ 0x8BEE , 1 ,12 ,12 ,24 ,(char *) uc2_8BEE },
	{ 0x8BEF , 1 ,12 ,12 ,24 ,(char *) uc2_8BEF },
	{ 0x8BF0 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF0 },
	{ 0x8BF1 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF1 },
	{ 0x8BF2 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF2 },
	{ 0x8BF3 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF3 },
	{ 0x8BF4 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF4 },
	{ 0x8BF5 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF5 },
	{ 0x8BF6 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF6 },
	{ 0x8BF7 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF7 },
	{ 0x8BF8 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF8 },
	{ 0x8BF9 , 1 ,12 ,12 ,24 ,(char *) uc2_8BF9 },
	{ 0x8BFA , 1 ,12 ,12 ,24 ,(char *) uc2_8BFA },
	{ 0x8BFB , 1 ,12 ,12 ,24 ,(char *) uc2_8BFB },
	{ 0x8BFC , 1 ,12 ,12 ,24 ,(char *) uc2_8BFC },
	{ 0x8BFD , 1 ,12 ,12 ,24 ,(char *) uc2_8BFD },
	{ 0x8BFE , 1 ,12 ,12 ,24 ,(char *) uc2_8BFE },
	{ 0x8BFF , 1 ,12 ,12 ,24 ,(char *) uc2_8BFF },
	{ 0x8C00 , 1 ,12 ,12 ,24 ,(char *) uc2_8C00 },
	{ 0x8C01 , 1 ,12 ,12 ,24 ,(char *) uc2_8C01 },
	{ 0x8C02 , 1 ,12 ,12 ,24 ,(char *) uc2_8C02 },
	{ 0x8C03 , 1 ,12 ,12 ,24 ,(char *) uc2_8C03 },
	{ 0x8C04 , 1 ,12 ,12 ,24 ,(char *) uc2_8C04 },
	{ 0x8C05 , 1 ,12 ,12 ,24 ,(char *) uc2_8C05 },
	{ 0x8C06 , 1 ,12 ,12 ,24 ,(char *) uc2_8C06 },
	{ 0x8C07 , 1 ,12 ,12 ,24 ,(char *) uc2_8C07 },
	{ 0x8C08 , 1 ,12 ,12 ,24 ,(char *) uc2_8C08 },
	{ 0x8C0A , 1 ,12 ,12 ,24 ,(char *) uc2_8C0A },
	{ 0x8C0B , 1 ,12 ,12 ,24 ,(char *) uc2_8C0B },
	{ 0x8C0C , 1 ,12 ,12 ,24 ,(char *) uc2_8C0C },
	{ 0x8C0D , 1 ,12 ,12 ,24 ,(char *) uc2_8C0D },
	{ 0x8C0E , 1 ,12 ,12 ,24 ,(char *) uc2_8C0E },
	{ 0x8C0F , 1 ,12 ,12 ,24 ,(char *) uc2_8C0F },
	{ 0x8C10 , 1 ,12 ,12 ,24 ,(char *) uc2_8C10 },
	{ 0x8C11 , 1 ,12 ,12 ,24 ,(char *) uc2_8C11 },
	{ 0x8C12 , 1 ,12 ,12 ,24 ,(char *) uc2_8C12 },
	{ 0x8C13 , 1 ,12 ,12 ,24 ,(char *) uc2_8C13 },
	{ 0x8C14 , 1 ,12 ,12 ,24 ,(char *) uc2_8C14 },
	{ 0x8C15 , 1 ,12 ,12 ,24 ,(char *) uc2_8C15 },
	{ 0x8C16 , 1 ,12 ,12 ,24 ,(char *) uc2_8C16 },
	{ 0x8C17 , 1 ,12 ,12 ,24 ,(char *) uc2_8C17 },
	{ 0x8C18 , 1 ,12 ,12 ,24 ,(char *) uc2_8C18 },
	{ 0x8C19 , 1 ,12 ,12 ,24 ,(char *) uc2_8C19 },
	{ 0x8C1A , 1 ,12 ,12 ,24 ,(char *) uc2_8C1A },
	{ 0x8C1B , 1 ,12 ,12 ,24 ,(char *) uc2_8C1B },
	{ 0x8C1C , 1 ,12 ,12 ,24 ,(char *) uc2_8C1C },
	{ 0x8C1D , 1 ,12 ,12 ,24 ,(char *) uc2_8C1D },
	{ 0x8C1F , 1 ,12 ,12 ,24 ,(char *) uc2_8C1F },
	{ 0x8C20 , 1 ,12 ,12 ,24 ,(char *) uc2_8C20 },
	{ 0x8C21 , 1 ,12 ,12 ,24 ,(char *) uc2_8C21 },
	{ 0x8C22 , 1 ,12 ,12 ,24 ,(char *) uc2_8C22 },
	{ 0x8C23 , 1 ,12 ,12 ,24 ,(char *) uc2_8C23 },
	{ 0x8C24 , 1 ,12 ,12 ,24 ,(char *) uc2_8C24 },
	{ 0x8C25 , 1 ,12 ,12 ,24 ,(char *) uc2_8C25 },
	{ 0x8C26 , 1 ,12 ,12 ,24 ,(char *) uc2_8C26 },
	{ 0x8C27 , 1 ,12 ,12 ,24 ,(char *) uc2_8C27 },
	{ 0x8C28 , 1 ,12 ,12 ,24 ,(char *) uc2_8C28 },
	{ 0x8C29 , 1 ,12 ,12 ,24 ,(char *) uc2_8C29 },
	{ 0x8C2A , 1 ,12 ,12 ,24 ,(char *) uc2_8C2A },
	{ 0x8C2B , 1 ,12 ,12 ,24 ,(char *) uc2_8C2B },
	{ 0x8C2C , 1 ,12 ,12 ,24 ,(char *) uc2_8C2C },
	{ 0x8C2D , 1 ,12 ,12 ,24 ,(char *) uc2_8C2D },
	{ 0x8C2E , 1 ,12 ,12 ,24 ,(char *) uc2_8C2E },
	{ 0x8C2F , 1 ,12 ,12 ,24 ,(char *) uc2_8C2F },
	{ 0x8C30 , 1 ,12 ,12 ,24 ,(char *) uc2_8C30 },
	{ 0x8C31 , 1 ,12 ,12 ,24 ,(char *) uc2_8C31 },
	{ 0x8C32 , 1 ,12 ,12 ,24 ,(char *) uc2_8C32 },
	{ 0x8C33 , 1 ,12 ,12 ,24 ,(char *) uc2_8C33 },
	{ 0x8C34 , 1 ,12 ,12 ,24 ,(char *) uc2_8C34 },
	{ 0x8C35 , 1 ,12 ,12 ,24 ,(char *) uc2_8C35 },
	{ 0x8C36 , 1 ,12 ,12 ,24 ,(char *) uc2_8C36 },
	{ 0x8C37 , 1 ,12 ,12 ,24 ,(char *) uc2_8C37 },
	{ 0x8C41 , 1 ,12 ,12 ,24 ,(char *) uc2_8C41 },
	{ 0x8C46 , 1 ,12 ,12 ,24 ,(char *) uc2_8C46 },
	{ 0x8C47 , 1 ,12 ,12 ,24 ,(char *) uc2_8C47 },
	{ 0x8C49 , 1 ,12 ,12 ,24 ,(char *) uc2_8C49 },
	{ 0x8C4C , 1 ,12 ,12 ,24 ,(char *) uc2_8C4C },
	{ 0x8C55 , 1 ,12 ,12 ,24 ,(char *) uc2_8C55 },
	{ 0x8C5A , 1 ,12 ,12 ,24 ,(char *) uc2_8C5A },
	{ 0x8C61 , 1 ,12 ,12 ,24 ,(char *) uc2_8C61 },
	{ 0x8C62 , 1 ,12 ,12 ,24 ,(char *) uc2_8C62 },
	{ 0x8C6A , 1 ,12 ,12 ,24 ,(char *) uc2_8C6A },
	{ 0x8C6B , 1 ,12 ,12 ,24 ,(char *) uc2_8C6B },
	{ 0x8C73 , 1 ,12 ,12 ,24 ,(char *) uc2_8C73 },
	{ 0x8C79 , 1 ,12 ,12 ,24 ,(char *) uc2_8C79 },
	{ 0x8C7A , 1 ,12 ,12 ,24 ,(char *) uc2_8C7A },
	{ 0x8C82 , 1 ,12 ,12 ,24 ,(char *) uc2_8C82 },
	{ 0x8C85 , 1 ,12 ,12 ,24 ,(char *) uc2_8C85 },
	{ 0x8C89 , 1 ,12 ,12 ,24 ,(char *) uc2_8C89 },
	{ 0x8C8A , 1 ,12 ,12 ,24 ,(char *) uc2_8C8A },
	{ 0x8C8C , 1 ,12 ,12 ,24 ,(char *) uc2_8C8C },
	{ 0x8C94 , 1 ,12 ,12 ,24 ,(char *) uc2_8C94 },
	{ 0x8C98 , 1 ,12 ,12 ,24 ,(char *) uc2_8C98 },
	{ 0x8D1D , 1 ,12 ,12 ,24 ,(char *) uc2_8D1D },
	{ 0x8D1E , 1 ,12 ,12 ,24 ,(char *) uc2_8D1E },
	{ 0x8D1F , 1 ,12 ,12 ,24 ,(char *) uc2_8D1F },
	{ 0x8D21 , 1 ,12 ,12 ,24 ,(char *) uc2_8D21 },
	{ 0x8D22 , 1 ,12 ,12 ,24 ,(char *) uc2_8D22 },
	{ 0x8D23 , 1 ,12 ,12 ,24 ,(char *) uc2_8D23 },
	{ 0x8D24 , 1 ,12 ,12 ,24 ,(char *) uc2_8D24 },
	{ 0x8D25 , 1 ,12 ,12 ,24 ,(char *) uc2_8D25 },
	{ 0x8D26 , 1 ,12 ,12 ,24 ,(char *) uc2_8D26 },
	{ 0x8D27 , 1 ,12 ,12 ,24 ,(char *) uc2_8D27 },
	{ 0x8D28 , 1 ,12 ,12 ,24 ,(char *) uc2_8D28 },
	{ 0x8D29 , 1 ,12 ,12 ,24 ,(char *) uc2_8D29 },
	{ 0x8D2A , 1 ,12 ,12 ,24 ,(char *) uc2_8D2A },
	{ 0x8D2B , 1 ,12 ,12 ,24 ,(char *) uc2_8D2B },
	{ 0x8D2C , 1 ,12 ,12 ,24 ,(char *) uc2_8D2C },
	{ 0x8D2D , 1 ,12 ,12 ,24 ,(char *) uc2_8D2D },
	{ 0x8D2E , 1 ,12 ,12 ,24 ,(char *) uc2_8D2E },
	{ 0x8D2F , 1 ,12 ,12 ,24 ,(char *) uc2_8D2F },
	{ 0x8D30 , 1 ,12 ,12 ,24 ,(char *) uc2_8D30 },
	{ 0x8D31 , 1 ,12 ,12 ,24 ,(char *) uc2_8D31 },
	{ 0x8D32 , 1 ,12 ,12 ,24 ,(char *) uc2_8D32 },
	{ 0x8D33 , 1 ,12 ,12 ,24 ,(char *) uc2_8D33 },
	{ 0x8D34 , 1 ,12 ,12 ,24 ,(char *) uc2_8D34 },
	{ 0x8D35 , 1 ,12 ,12 ,24 ,(char *) uc2_8D35 },
	{ 0x8D36 , 1 ,12 ,12 ,24 ,(char *) uc2_8D36 },
	{ 0x8D37 , 1 ,12 ,12 ,24 ,(char *) uc2_8D37 },
	{ 0x8D38 , 1 ,12 ,12 ,24 ,(char *) uc2_8D38 },
	{ 0x8D39 , 1 ,12 ,12 ,24 ,(char *) uc2_8D39 },
	{ 0x8D3A , 1 ,12 ,12 ,24 ,(char *) uc2_8D3A },
	{ 0x8D3B , 1 ,12 ,12 ,24 ,(char *) uc2_8D3B },
	{ 0x8D3C , 1 ,12 ,12 ,24 ,(char *) uc2_8D3C },
	{ 0x8D3D , 1 ,12 ,12 ,24 ,(char *) uc2_8D3D },
	{ 0x8D3E , 1 ,12 ,12 ,24 ,(char *) uc2_8D3E },
	{ 0x8D3F , 1 ,12 ,12 ,24 ,(char *) uc2_8D3F },
	{ 0x8D40 , 1 ,12 ,12 ,24 ,(char *) uc2_8D40 },
	{ 0x8D41 , 1 ,12 ,12 ,24 ,(char *) uc2_8D41 },
	{ 0x8D42 , 1 ,12 ,12 ,24 ,(char *) uc2_8D42 },
	{ 0x8D43 , 1 ,12 ,12 ,24 ,(char *) uc2_8D43 },
	{ 0x8D44 , 1 ,12 ,12 ,24 ,(char *) uc2_8D44 },
	{ 0x8D45 , 1 ,12 ,12 ,24 ,(char *) uc2_8D45 },
	{ 0x8D46 , 1 ,12 ,12 ,24 ,(char *) uc2_8D46 },
	{ 0x8D47 , 1 ,12 ,12 ,24 ,(char *) uc2_8D47 },
	{ 0x8D48 , 1 ,12 ,12 ,24 ,(char *) uc2_8D48 },
	{ 0x8D49 , 1 ,12 ,12 ,24 ,(char *) uc2_8D49 },
	{ 0x8D4A , 1 ,12 ,12 ,24 ,(char *) uc2_8D4A },
	{ 0x8D4B , 1 ,12 ,12 ,24 ,(char *) uc2_8D4B },
	{ 0x8D4C , 1 ,12 ,12 ,24 ,(char *) uc2_8D4C },
	{ 0x8D4D , 1 ,12 ,12 ,24 ,(char *) uc2_8D4D },
	{ 0x8D4E , 1 ,12 ,12 ,24 ,(char *) uc2_8D4E },
	{ 0x8D4F , 1 ,12 ,12 ,24 ,(char *) uc2_8D4F },
	{ 0x8D50 , 1 ,12 ,12 ,24 ,(char *) uc2_8D50 },
	{ 0x8D53 , 1 ,12 ,12 ,24 ,(char *) uc2_8D53 },
	{ 0x8D54 , 1 ,12 ,12 ,24 ,(char *) uc2_8D54 },
	{ 0x8D55 , 1 ,12 ,12 ,24 ,(char *) uc2_8D55 },
	{ 0x8D56 , 1 ,12 ,12 ,24 ,(char *) uc2_8D56 },
	{ 0x8D58 , 1 ,12 ,12 ,24 ,(char *) uc2_8D58 },
	{ 0x8D59 , 1 ,12 ,12 ,24 ,(char *) uc2_8D59 },
	{ 0x8D5A , 1 ,12 ,12 ,24 ,(char *) uc2_8D5A },
	{ 0x8D5B , 1 ,12 ,12 ,24 ,(char *) uc2_8D5B },
	{ 0x8D5C , 1 ,12 ,12 ,24 ,(char *) uc2_8D5C },
	{ 0x8D5D , 1 ,12 ,12 ,24 ,(char *) uc2_8D5D },
	{ 0x8D5E , 1 ,12 ,12 ,24 ,(char *) uc2_8D5E },
	{ 0x8D60 , 1 ,12 ,12 ,24 ,(char *) uc2_8D60 },
	{ 0x8D61 , 1 ,12 ,12 ,24 ,(char *) uc2_8D61 },
	{ 0x8D62 , 1 ,12 ,12 ,24 ,(char *) uc2_8D62 },
	{ 0x8D63 , 1 ,12 ,12 ,24 ,(char *) uc2_8D63 },
	{ 0x8D64 , 1 ,12 ,12 ,24 ,(char *) uc2_8D64 },
	{ 0x8D66 , 1 ,12 ,12 ,24 ,(char *) uc2_8D66 },
	{ 0x8D67 , 1 ,12 ,12 ,24 ,(char *) uc2_8D67 },
	{ 0x8D6B , 1 ,12 ,12 ,24 ,(char *) uc2_8D6B },
	{ 0x8D6D , 1 ,12 ,12 ,24 ,(char *) uc2_8D6D },
	{ 0x8D70 , 1 ,12 ,12 ,24 ,(char *) uc2_8D70 },
	{ 0x8D73 , 1 ,12 ,12 ,24 ,(char *) uc2_8D73 },
	{ 0x8D74 , 1 ,12 ,12 ,24 ,(char *) uc2_8D74 },
	{ 0x8D75 , 1 ,12 ,12 ,24 ,(char *) uc2_8D75 },
	{ 0x8D76 , 1 ,12 ,12 ,24 ,(char *) uc2_8D76 },
	{ 0x8D77 , 1 ,12 ,12 ,24 ,(char *) uc2_8D77 },
	{ 0x8D81 , 1 ,12 ,12 ,24 ,(char *) uc2_8D81 },
	{ 0x8D84 , 1 ,12 ,12 ,24 ,(char *) uc2_8D84 },
	{ 0x8D85 , 1 ,12 ,12 ,24 ,(char *) uc2_8D85 },
	{ 0x8D8A , 1 ,12 ,12 ,24 ,(char *) uc2_8D8A },
	{ 0x8D8B , 1 ,12 ,12 ,24 ,(char *) uc2_8D8B },
	{ 0x8D91 , 1 ,12 ,12 ,24 ,(char *) uc2_8D91 },
	{ 0x8D94 , 1 ,12 ,12 ,24 ,(char *) uc2_8D94 },
	{ 0x8D9F , 1 ,12 ,12 ,24 ,(char *) uc2_8D9F },
	{ 0x8DA3 , 1 ,12 ,12 ,24 ,(char *) uc2_8DA3 },
	{ 0x8DB1 , 1 ,12 ,12 ,24 ,(char *) uc2_8DB1 },
	{ 0x8DB3 , 1 ,12 ,12 ,24 ,(char *) uc2_8DB3 },
	{ 0x8DB4 , 1 ,12 ,12 ,24 ,(char *) uc2_8DB4 },
	{ 0x8DB5 , 1 ,12 ,12 ,24 ,(char *) uc2_8DB5 },
	{ 0x8DB8 , 1 ,12 ,12 ,24 ,(char *) uc2_8DB8 },
	{ 0x8DBA , 1 ,12 ,12 ,24 ,(char *) uc2_8DBA },
	{ 0x8DBC , 1 ,12 ,12 ,24 ,(char *) uc2_8DBC },
	{ 0x8DBE , 1 ,12 ,12 ,24 ,(char *) uc2_8DBE },
	{ 0x8DBF , 1 ,12 ,12 ,24 ,(char *) uc2_8DBF },
	{ 0x8DC3 , 1 ,12 ,12 ,24 ,(char *) uc2_8DC3 },
	{ 0x8DC4 , 1 ,12 ,12 ,24 ,(char *) uc2_8DC4 },
	{ 0x8DC6 , 1 ,12 ,12 ,24 ,(char *) uc2_8DC6 },
	{ 0x8DCB , 1 ,12 ,12 ,24 ,(char *) uc2_8DCB },
	{ 0x8DCC , 1 ,12 ,12 ,24 ,(char *) uc2_8DCC },
	{ 0x8DCE , 1 ,12 ,12 ,24 ,(char *) uc2_8DCE },
	{ 0x8DCF , 1 ,12 ,12 ,24 ,(char *) uc2_8DCF },
	{ 0x8DD1 , 1 ,12 ,12 ,24 ,(char *) uc2_8DD1 },
	{ 0x8DD6 , 1 ,12 ,12 ,24 ,(char *) uc2_8DD6 },
	{ 0x8DD7 , 1 ,12 ,12 ,24 ,(char *) uc2_8DD7 },
	{ 0x8DDA , 1 ,12 ,12 ,24 ,(char *) uc2_8DDA },
	{ 0x8DDB , 1 ,12 ,12 ,24 ,(char *) uc2_8DDB },
	{ 0x8DDD , 1 ,12 ,12 ,24 ,(char *) uc2_8DDD },
	{ 0x8DDE , 1 ,12 ,12 ,24 ,(char *) uc2_8DDE },
	{ 0x8DDF , 1 ,12 ,12 ,24 ,(char *) uc2_8DDF },
	{ 0x8DE3 , 1 ,12 ,12 ,24 ,(char *) uc2_8DE3 },
	{ 0x8DE4 , 1 ,12 ,12 ,24 ,(char *) uc2_8DE4 },
	{ 0x8DE8 , 1 ,12 ,12 ,24 ,(char *) uc2_8DE8 },
	{ 0x8DEA , 1 ,12 ,12 ,24 ,(char *) uc2_8DEA },
	{ 0x8DEB , 1 ,12 ,12 ,24 ,(char *) uc2_8DEB },
	{ 0x8DEC , 1 ,12 ,12 ,24 ,(char *) uc2_8DEC },
	{ 0x8DEF , 1 ,12 ,12 ,24 ,(char *) uc2_8DEF },
	{ 0x8DF3 , 1 ,12 ,12 ,24 ,(char *) uc2_8DF3 },
	{ 0x8DF5 , 1 ,12 ,12 ,24 ,(char *) uc2_8DF5 },
	{ 0x8DF7 , 1 ,12 ,12 ,24 ,(char *) uc2_8DF7 },
	{ 0x8DF8 , 1 ,12 ,12 ,24 ,(char *) uc2_8DF8 },
	{ 0x8DF9 , 1 ,12 ,12 ,24 ,(char *) uc2_8DF9 },
	{ 0x8DFA , 1 ,12 ,12 ,24 ,(char *) uc2_8DFA },
	{ 0x8DFB , 1 ,12 ,12 ,24 ,(char *) uc2_8DFB },
	{ 0x8DFD , 1 ,12 ,12 ,24 ,(char *) uc2_8DFD },
	{ 0x8DFF , 1 ,12 ,12 ,24 ,(char *) uc2_8DFF },
	{ 0x8E05 , 1 ,12 ,12 ,24 ,(char *) uc2_8E05 },
	{ 0x8E09 , 1 ,12 ,12 ,24 ,(char *) uc2_8E09 },
	{ 0x8E0A , 1 ,12 ,12 ,24 ,(char *) uc2_8E0A },
	{ 0x8E0C , 1 ,12 ,12 ,24 ,(char *) uc2_8E0C },
	{ 0x8E0F , 1 ,12 ,12 ,24 ,(char *) uc2_8E0F },
	{ 0x8E14 , 1 ,12 ,12 ,24 ,(char *) uc2_8E14 },
	{ 0x8E1D , 1 ,12 ,12 ,24 ,(char *) uc2_8E1D },
	{ 0x8E1E , 1 ,12 ,12 ,24 ,(char *) uc2_8E1E },
	{ 0x8E1F , 1 ,12 ,12 ,24 ,(char *) uc2_8E1F },
	{ 0x8E22 , 1 ,12 ,12 ,24 ,(char *) uc2_8E22 },
	{ 0x8E23 , 1 ,12 ,12 ,24 ,(char *) uc2_8E23 },
	{ 0x8E29 , 1 ,12 ,12 ,24 ,(char *) uc2_8E29 },
	{ 0x8E2A , 1 ,12 ,12 ,24 ,(char *) uc2_8E2A },
	{ 0x8E2C , 1 ,12 ,12 ,24 ,(char *) uc2_8E2C },
	{ 0x8E2E , 1 ,12 ,12 ,24 ,(char *) uc2_8E2E },
	{ 0x8E2F , 1 ,12 ,12 ,24 ,(char *) uc2_8E2F },
	{ 0x8E31 , 1 ,12 ,12 ,24 ,(char *) uc2_8E31 },
	{ 0x8E35 , 1 ,12 ,12 ,24 ,(char *) uc2_8E35 },
	{ 0x8E39 , 1 ,12 ,12 ,24 ,(char *) uc2_8E39 },
	{ 0x8E3A , 1 ,12 ,12 ,24 ,(char *) uc2_8E3A },
	{ 0x8E3D , 1 ,12 ,12 ,24 ,(char *) uc2_8E3D },
	{ 0x8E40 , 1 ,12 ,12 ,24 ,(char *) uc2_8E40 },
	{ 0x8E41 , 1 ,12 ,12 ,24 ,(char *) uc2_8E41 },
	{ 0x8E42 , 1 ,12 ,12 ,24 ,(char *) uc2_8E42 },
	{ 0x8E44 , 1 ,12 ,12 ,24 ,(char *) uc2_8E44 },
	{ 0x8E47 , 1 ,12 ,12 ,24 ,(char *) uc2_8E47 },
	{ 0x8E48 , 1 ,12 ,12 ,24 ,(char *) uc2_8E48 },
	{ 0x8E49 , 1 ,12 ,12 ,24 ,(char *) uc2_8E49 },
	{ 0x8E4A , 1 ,12 ,12 ,24 ,(char *) uc2_8E4A },
	{ 0x8E4B , 1 ,12 ,12 ,24 ,(char *) uc2_8E4B },
	{ 0x8E51 , 1 ,12 ,12 ,24 ,(char *) uc2_8E51 },
	{ 0x8E52 , 1 ,12 ,12 ,24 ,(char *) uc2_8E52 },
	{ 0x8E59 , 1 ,12 ,12 ,24 ,(char *) uc2_8E59 },
	{ 0x8E66 , 1 ,12 ,12 ,24 ,(char *) uc2_8E66 },
	{ 0x8E69 , 1 ,12 ,12 ,24 ,(char *) uc2_8E69 },
	{ 0x8E6C , 1 ,12 ,12 ,24 ,(char *) uc2_8E6C },
	{ 0x8E6D , 1 ,12 ,12 ,24 ,(char *) uc2_8E6D },
	{ 0x8E6F , 1 ,12 ,12 ,24 ,(char *) uc2_8E6F },
	{ 0x8E70 , 1 ,12 ,12 ,24 ,(char *) uc2_8E70 },
	{ 0x8E72 , 1 ,12 ,12 ,24 ,(char *) uc2_8E72 },
	{ 0x8E74 , 1 ,12 ,12 ,24 ,(char *) uc2_8E74 },
	{ 0x8E76 , 1 ,12 ,12 ,24 ,(char *) uc2_8E76 },
	{ 0x8E7C , 1 ,12 ,12 ,24 ,(char *) uc2_8E7C },
	{ 0x8E7F , 1 ,12 ,12 ,24 ,(char *) uc2_8E7F },
	{ 0x8E81 , 1 ,12 ,12 ,24 ,(char *) uc2_8E81 },
	{ 0x8E85 , 1 ,12 ,12 ,24 ,(char *) uc2_8E85 },
	{ 0x8E87 , 1 ,12 ,12 ,24 ,(char *) uc2_8E87 },
	{ 0x8E8F , 1 ,12 ,12 ,24 ,(char *) uc2_8E8F },
	{ 0x8E90 , 1 ,12 ,12 ,24 ,(char *) uc2_8E90 },
	{ 0x8E94 , 1 ,12 ,12 ,24 ,(char *) uc2_8E94 },
	{ 0x8E9C , 1 ,12 ,12 ,24 ,(char *) uc2_8E9C },
	{ 0x8E9E , 1 ,12 ,12 ,24 ,(char *) uc2_8E9E },
	{ 0x8EAB , 1 ,12 ,12 ,24 ,(char *) uc2_8EAB },
	{ 0x8EAC , 1 ,12 ,12 ,24 ,(char *) uc2_8EAC },
	{ 0x8EAF , 1 ,12 ,12 ,24 ,(char *) uc2_8EAF },
	{ 0x8EB2 , 1 ,12 ,12 ,24 ,(char *) uc2_8EB2 },
	{ 0x8EBA , 1 ,12 ,12 ,24 ,(char *) uc2_8EBA },
	{ 0x8ECE , 1 ,12 ,12 ,24 ,(char *) uc2_8ECE },
	{ 0x8F66 , 1 ,12 ,12 ,24 ,(char *) uc2_8F66 },
	{ 0x8F67 , 1 ,12 ,12 ,24 ,(char *) uc2_8F67 },
	{ 0x8F68 , 1 ,12 ,12 ,24 ,(char *) uc2_8F68 },
	{ 0x8F69 , 1 ,12 ,12 ,24 ,(char *) uc2_8F69 },
	{ 0x8F6B , 1 ,12 ,12 ,24 ,(char *) uc2_8F6B },
	{ 0x8F6C , 1 ,12 ,12 ,24 ,(char *) uc2_8F6C },
	{ 0x8F6D , 1 ,12 ,12 ,24 ,(char *) uc2_8F6D },
	{ 0x8F6E , 1 ,12 ,12 ,24 ,(char *) uc2_8F6E },
	{ 0x8F6F , 1 ,12 ,12 ,24 ,(char *) uc2_8F6F },
	{ 0x8F70 , 1 ,12 ,12 ,24 ,(char *) uc2_8F70 },
	{ 0x8F71 , 1 ,12 ,12 ,24 ,(char *) uc2_8F71 },
	{ 0x8F72 , 1 ,12 ,12 ,24 ,(char *) uc2_8F72 },
	{ 0x8F73 , 1 ,12 ,12 ,24 ,(char *) uc2_8F73 },
	{ 0x8F74 , 1 ,12 ,12 ,24 ,(char *) uc2_8F74 },
	{ 0x8F75 , 1 ,12 ,12 ,24 ,(char *) uc2_8F75 },
	{ 0x8F76 , 1 ,12 ,12 ,24 ,(char *) uc2_8F76 },
	{ 0x8F77 , 1 ,12 ,12 ,24 ,(char *) uc2_8F77 },
	{ 0x8F78 , 1 ,12 ,12 ,24 ,(char *) uc2_8F78 },
	{ 0x8F79 , 1 ,12 ,12 ,24 ,(char *) uc2_8F79 },
	{ 0x8F7A , 1 ,12 ,12 ,24 ,(char *) uc2_8F7A },
	{ 0x8F7B , 1 ,12 ,12 ,24 ,(char *) uc2_8F7B },
	{ 0x8F7C , 1 ,12 ,12 ,24 ,(char *) uc2_8F7C },
	{ 0x8F7D , 1 ,12 ,12 ,24 ,(char *) uc2_8F7D },
	{ 0x8F7E , 1 ,12 ,12 ,24 ,(char *) uc2_8F7E },
	{ 0x8F7F , 1 ,12 ,12 ,24 ,(char *) uc2_8F7F },
	{ 0x8F81 , 1 ,12 ,12 ,24 ,(char *) uc2_8F81 },
	{ 0x8F82 , 1 ,12 ,12 ,24 ,(char *) uc2_8F82 },
	{ 0x8F83 , 1 ,12 ,12 ,24 ,(char *) uc2_8F83 },
	{ 0x8F84 , 1 ,12 ,12 ,24 ,(char *) uc2_8F84 },
	{ 0x8F85 , 1 ,12 ,12 ,24 ,(char *) uc2_8F85 },
	{ 0x8F86 , 1 ,12 ,12 ,24 ,(char *) uc2_8F86 },
	{ 0x8F87 , 1 ,12 ,12 ,24 ,(char *) uc2_8F87 },
	{ 0x8F88 , 1 ,12 ,12 ,24 ,(char *) uc2_8F88 },
	{ 0x8F89 , 1 ,12 ,12 ,24 ,(char *) uc2_8F89 },
	{ 0x8F8A , 1 ,12 ,12 ,24 ,(char *) uc2_8F8A },
	{ 0x8F8B , 1 ,12 ,12 ,24 ,(char *) uc2_8F8B },
	{ 0x8F8D , 1 ,12 ,12 ,24 ,(char *) uc2_8F8D },
	{ 0x8F8E , 1 ,12 ,12 ,24 ,(char *) uc2_8F8E },
	{ 0x8F8F , 1 ,12 ,12 ,24 ,(char *) uc2_8F8F },
	{ 0x8F90 , 1 ,12 ,12 ,24 ,(char *) uc2_8F90 },
	{ 0x8F91 , 1 ,12 ,12 ,24 ,(char *) uc2_8F91 },
	{ 0x8F93 , 1 ,12 ,12 ,24 ,(char *) uc2_8F93 },
	{ 0x8F94 , 1 ,12 ,12 ,24 ,(char *) uc2_8F94 },
	{ 0x8F95 , 1 ,12 ,12 ,24 ,(char *) uc2_8F95 },
	{ 0x8F96 , 1 ,12 ,12 ,24 ,(char *) uc2_8F96 },
	{ 0x8F97 , 1 ,12 ,12 ,24 ,(char *) uc2_8F97 },
	{ 0x8F98 , 1 ,12 ,12 ,24 ,(char *) uc2_8F98 },
	{ 0x8F99 , 1 ,12 ,12 ,24 ,(char *) uc2_8F99 },
	{ 0x8F9A , 1 ,12 ,12 ,24 ,(char *) uc2_8F9A },
	{ 0x8F9B , 1 ,12 ,12 ,24 ,(char *) uc2_8F9B },
	{ 0x8F9C , 1 ,12 ,12 ,24 ,(char *) uc2_8F9C },
	{ 0x8F9E , 1 ,12 ,12 ,24 ,(char *) uc2_8F9E },
	{ 0x8F9F , 1 ,12 ,12 ,24 ,(char *) uc2_8F9F },
	{ 0x8FA3 , 1 ,12 ,12 ,24 ,(char *) uc2_8FA3 },
	{ 0x8FA8 , 1 ,12 ,12 ,24 ,(char *) uc2_8FA8 },
	{ 0x8FA9 , 1 ,12 ,12 ,24 ,(char *) uc2_8FA9 },
	{ 0x8FAB , 1 ,12 ,12 ,24 ,(char *) uc2_8FAB },
	{ 0x8FB0 , 1 ,12 ,12 ,24 ,(char *) uc2_8FB0 },
	{ 0x8FB1 , 1 ,12 ,12 ,24 ,(char *) uc2_8FB1 },
	{ 0x8FB9 , 1 ,12 ,12 ,24 ,(char *) uc2_8FB9 },
	{ 0x8FBD , 1 ,12 ,12 ,24 ,(char *) uc2_8FBD },
	{ 0x8FBE , 1 ,12 ,12 ,24 ,(char *) uc2_8FBE },
	{ 0x8FC1 , 1 ,12 ,12 ,24 ,(char *) uc2_8FC1 },
	{ 0x8FC2 , 1 ,12 ,12 ,24 ,(char *) uc2_8FC2 },
	{ 0x8FC4 , 1 ,12 ,12 ,24 ,(char *) uc2_8FC4 },
	{ 0x8FC5 , 1 ,12 ,12 ,24 ,(char *) uc2_8FC5 },
	{ 0x8FC7 , 1 ,12 ,12 ,24 ,(char *) uc2_8FC7 },
	{ 0x8FC8 , 1 ,12 ,12 ,24 ,(char *) uc2_8FC8 },
	{ 0x8FCE , 1 ,12 ,12 ,24 ,(char *) uc2_8FCE },
	{ 0x8FD0 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD0 },
	{ 0x8FD1 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD1 },
	{ 0x8FD3 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD3 },
	{ 0x8FD4 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD4 },
	{ 0x8FD5 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD5 },
	{ 0x8FD8 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD8 },
	{ 0x8FD9 , 1 ,12 ,12 ,24 ,(char *) uc2_8FD9 },
	{ 0x8FDB , 1 ,12 ,12 ,24 ,(char *) uc2_8FDB },
	{ 0x8FDC , 1 ,12 ,12 ,24 ,(char *) uc2_8FDC },
	{ 0x8FDD , 1 ,12 ,12 ,24 ,(char *) uc2_8FDD },
	{ 0x8FDE , 1 ,12 ,12 ,24 ,(char *) uc2_8FDE },
	{ 0x8FDF , 1 ,12 ,12 ,24 ,(char *) uc2_8FDF },
	{ 0x8FE2 , 1 ,12 ,12 ,24 ,(char *) uc2_8FE2 },
	{ 0x8FE4 , 1 ,12 ,12 ,24 ,(char *) uc2_8FE4 },
	{ 0x8FE5 , 1 ,12 ,12 ,24 ,(char *) uc2_8FE5 },
	{ 0x8FE6 , 1 ,12 ,12 ,24 ,(char *) uc2_8FE6 },
	{ 0x8FE8 , 1 ,12 ,12 ,24 ,(char *) uc2_8FE8 },
	{ 0x8FE9 , 1 ,12 ,12 ,24 ,(char *) uc2_8FE9 },
	{ 0x8FEA , 1 ,12 ,12 ,24 ,(char *) uc2_8FEA },
	{ 0x8FEB , 1 ,12 ,12 ,24 ,(char *) uc2_8FEB },
	{ 0x8FED , 1 ,12 ,12 ,24 ,(char *) uc2_8FED },
	{ 0x8FEE , 1 ,12 ,12 ,24 ,(char *) uc2_8FEE },
	{ 0x8FF0 , 1 ,12 ,12 ,24 ,(char *) uc2_8FF0 },
	{ 0x8FF3 , 1 ,12 ,12 ,24 ,(char *) uc2_8FF3 },
	{ 0x8FF7 , 1 ,12 ,12 ,24 ,(char *) uc2_8FF7 },
	{ 0x8FF8 , 1 ,12 ,12 ,24 ,(char *) uc2_8FF8 },
	{ 0x8FF9 , 1 ,12 ,12 ,24 ,(char *) uc2_8FF9 },
	{ 0x8FFD , 1 ,12 ,12 ,24 ,(char *) uc2_8FFD },
	{ 0x9000 , 1 ,12 ,12 ,24 ,(char *) uc2_9000 },
	{ 0x9001 , 1 ,12 ,12 ,24 ,(char *) uc2_9001 },
	{ 0x9002 , 1 ,12 ,12 ,24 ,(char *) uc2_9002 },
	{ 0x9003 , 1 ,12 ,12 ,24 ,(char *) uc2_9003 },
	{ 0x9004 , 1 ,12 ,12 ,24 ,(char *) uc2_9004 },
	{ 0x9005 , 1 ,12 ,12 ,24 ,(char *) uc2_9005 },
	{ 0x9006 , 1 ,12 ,12 ,24 ,(char *) uc2_9006 },
	{ 0x9009 , 1 ,12 ,12 ,24 ,(char *) uc2_9009 },
	{ 0x900A , 1 ,12 ,12 ,24 ,(char *) uc2_900A },
	{ 0x900B , 1 ,12 ,12 ,24 ,(char *) uc2_900B },
	{ 0x900D , 1 ,12 ,12 ,24 ,(char *) uc2_900D },
	{ 0x900F , 1 ,12 ,12 ,24 ,(char *) uc2_900F },
	{ 0x9010 , 1 ,12 ,12 ,24 ,(char *) uc2_9010 },
	{ 0x9011 , 1 ,12 ,12 ,24 ,(char *) uc2_9011 },
	{ 0x9012 , 1 ,12 ,12 ,24 ,(char *) uc2_9012 },
	{ 0x9014 , 1 ,12 ,12 ,24 ,(char *) uc2_9014 },
	{ 0x9016 , 1 ,12 ,12 ,24 ,(char *) uc2_9016 },
	{ 0x9017 , 1 ,12 ,12 ,24 ,(char *) uc2_9017 },
	{ 0x901A , 1 ,12 ,12 ,24 ,(char *) uc2_901A },
	{ 0x901B , 1 ,12 ,12 ,24 ,(char *) uc2_901B },
	{ 0x901D , 1 ,12 ,12 ,24 ,(char *) uc2_901D },
	{ 0x901E , 1 ,12 ,12 ,24 ,(char *) uc2_901E },
	{ 0x901F , 1 ,12 ,12 ,24 ,(char *) uc2_901F },
	{ 0x9020 , 1 ,12 ,12 ,24 ,(char *) uc2_9020 },
	{ 0x9021 , 1 ,12 ,12 ,24 ,(char *) uc2_9021 },
	{ 0x9022 , 1 ,12 ,12 ,24 ,(char *) uc2_9022 },
	{ 0x9026 , 1 ,12 ,12 ,24 ,(char *) uc2_9026 },
	{ 0x902D , 1 ,12 ,12 ,24 ,(char *) uc2_902D },
	{ 0x902E , 1 ,12 ,12 ,24 ,(char *) uc2_902E },
	{ 0x902F , 1 ,12 ,12 ,24 ,(char *) uc2_902F },
	{ 0x9035 , 1 ,12 ,12 ,24 ,(char *) uc2_9035 },
	{ 0x9036 , 1 ,12 ,12 ,24 ,(char *) uc2_9036 },
	{ 0x9038 , 1 ,12 ,12 ,24 ,(char *) uc2_9038 },
	{ 0x903B , 1 ,12 ,12 ,24 ,(char *) uc2_903B },
	{ 0x903C , 1 ,12 ,12 ,24 ,(char *) uc2_903C },
	{ 0x903E , 1 ,12 ,12 ,24 ,(char *) uc2_903E },
	{ 0x9041 , 1 ,12 ,12 ,24 ,(char *) uc2_9041 },
	{ 0x9042 , 1 ,12 ,12 ,24 ,(char *) uc2_9042 },
	{ 0x9044 , 1 ,12 ,12 ,24 ,(char *) uc2_9044 },
	{ 0x9047 , 1 ,12 ,12 ,24 ,(char *) uc2_9047 },
	{ 0x904D , 1 ,12 ,12 ,24 ,(char *) uc2_904D },
	{ 0x904F , 1 ,12 ,12 ,24 ,(char *) uc2_904F },
	{ 0x9050 , 1 ,12 ,12 ,24 ,(char *) uc2_9050 },
	{ 0x9051 , 1 ,12 ,12 ,24 ,(char *) uc2_9051 },
	{ 0x9052 , 1 ,12 ,12 ,24 ,(char *) uc2_9052 },
	{ 0x9053 , 1 ,12 ,12 ,24 ,(char *) uc2_9053 },
	{ 0x9057 , 1 ,12 ,12 ,24 ,(char *) uc2_9057 },
	{ 0x9058 , 1 ,12 ,12 ,24 ,(char *) uc2_9058 },
	{ 0x905B , 1 ,12 ,12 ,24 ,(char *) uc2_905B },
	{ 0x9062 , 1 ,12 ,12 ,24 ,(char *) uc2_9062 },
	{ 0x9063 , 1 ,12 ,12 ,24 ,(char *) uc2_9063 },
	{ 0x9065 , 1 ,12 ,12 ,24 ,(char *) uc2_9065 },
	{ 0x9068 , 1 ,12 ,12 ,24 ,(char *) uc2_9068 },
	{ 0x906D , 1 ,12 ,12 ,24 ,(char *) uc2_906D },
	{ 0x906E , 1 ,12 ,12 ,24 ,(char *) uc2_906E },
	{ 0x9074 , 1 ,12 ,12 ,24 ,(char *) uc2_9074 },
	{ 0x9075 , 1 ,12 ,12 ,24 ,(char *) uc2_9075 },
	{ 0x907D , 1 ,12 ,12 ,24 ,(char *) uc2_907D },
	{ 0x907F , 1 ,12 ,12 ,24 ,(char *) uc2_907F },
	{ 0x9080 , 1 ,12 ,12 ,24 ,(char *) uc2_9080 },
	{ 0x9082 , 1 ,12 ,12 ,24 ,(char *) uc2_9082 },
	{ 0x9083 , 1 ,12 ,12 ,24 ,(char *) uc2_9083 },
	{ 0x9088 , 1 ,12 ,12 ,24 ,(char *) uc2_9088 },
	{ 0x908B , 1 ,12 ,12 ,24 ,(char *) uc2_908B },
	{ 0x9091 , 1 ,12 ,12 ,24 ,(char *) uc2_9091 },
	{ 0x9093 , 1 ,12 ,12 ,24 ,(char *) uc2_9093 },
	{ 0x9095 , 1 ,12 ,12 ,24 ,(char *) uc2_9095 },
	{ 0x9097 , 1 ,12 ,12 ,24 ,(char *) uc2_9097 },
	{ 0x9099 , 1 ,12 ,12 ,24 ,(char *) uc2_9099 },
	{ 0x909B , 1 ,12 ,12 ,24 ,(char *) uc2_909B },
	{ 0x909D , 1 ,12 ,12 ,24 ,(char *) uc2_909D },
	{ 0x90A1 , 1 ,12 ,12 ,24 ,(char *) uc2_90A1 },
	{ 0x90A2 , 1 ,12 ,12 ,24 ,(char *) uc2_90A2 },
	{ 0x90A3 , 1 ,12 ,12 ,24 ,(char *) uc2_90A3 },
	{ 0x90A6 , 1 ,12 ,12 ,24 ,(char *) uc2_90A6 },
	{ 0x90AA , 1 ,12 ,12 ,24 ,(char *) uc2_90AA },
	{ 0x90AC , 1 ,12 ,12 ,24 ,(char *) uc2_90AC },
	{ 0x90AE , 1 ,12 ,12 ,24 ,(char *) uc2_90AE },
	{ 0x90AF , 1 ,12 ,12 ,24 ,(char *) uc2_90AF },
	{ 0x90B0 , 1 ,12 ,12 ,24 ,(char *) uc2_90B0 },
	{ 0x90B1 , 1 ,12 ,12 ,24 ,(char *) uc2_90B1 },
	{ 0x90B3 , 1 ,12 ,12 ,24 ,(char *) uc2_90B3 },
	{ 0x90B4 , 1 ,12 ,12 ,24 ,(char *) uc2_90B4 },
	{ 0x90B5 , 1 ,12 ,12 ,24 ,(char *) uc2_90B5 },
	{ 0x90B6 , 1 ,12 ,12 ,24 ,(char *) uc2_90B6 },
	{ 0x90B8 , 1 ,12 ,12 ,24 ,(char *) uc2_90B8 },
	{ 0x90B9 , 1 ,12 ,12 ,24 ,(char *) uc2_90B9 },
	{ 0x90BA , 1 ,12 ,12 ,24 ,(char *) uc2_90BA },
	{ 0x90BB , 1 ,12 ,12 ,24 ,(char *) uc2_90BB },
	{ 0x90BE , 1 ,12 ,12 ,24 ,(char *) uc2_90BE },
	{ 0x90C1 , 1 ,12 ,12 ,24 ,(char *) uc2_90C1 },
	{ 0x90C4 , 1 ,12 ,12 ,24 ,(char *) uc2_90C4 },
	{ 0x90C5 , 1 ,12 ,12 ,24 ,(char *) uc2_90C5 },
	{ 0x90C7 , 1 ,12 ,12 ,24 ,(char *) uc2_90C7 },
	{ 0x90CA , 1 ,12 ,12 ,24 ,(char *) uc2_90CA },
	{ 0x90CE , 1 ,12 ,12 ,24 ,(char *) uc2_90CE },
	{ 0x90CF , 1 ,12 ,12 ,24 ,(char *) uc2_90CF },
	{ 0x90D0 , 1 ,12 ,12 ,24 ,(char *) uc2_90D0 },
	{ 0x90D1 , 1 ,12 ,12 ,24 ,(char *) uc2_90D1 },
	{ 0x90D3 , 1 ,12 ,12 ,24 ,(char *) uc2_90D3 },
	{ 0x90D7 , 1 ,12 ,12 ,24 ,(char *) uc2_90D7 },
	{ 0x90DB , 1 ,12 ,12 ,24 ,(char *) uc2_90DB },
	{ 0x90DC , 1 ,12 ,12 ,24 ,(char *) uc2_90DC },
	{ 0x90DD , 1 ,12 ,12 ,24 ,(char *) uc2_90DD },
	{ 0x90E1 , 1 ,12 ,12 ,24 ,(char *) uc2_90E1 },
	{ 0x90E2 , 1 ,12 ,12 ,24 ,(char *) uc2_90E2 },
	{ 0x90E6 , 1 ,12 ,12 ,24 ,(char *) uc2_90E6 },
	{ 0x90E7 , 1 ,12 ,12 ,24 ,(char *) uc2_90E7 },
	{ 0x90E8 , 1 ,12 ,12 ,24 ,(char *) uc2_90E8 },
	{ 0x90EB , 1 ,12 ,12 ,24 ,(char *) uc2_90EB },
	{ 0x90ED , 1 ,12 ,12 ,24 ,(char *) uc2_90ED },
	{ 0x90EF , 1 ,12 ,12 ,24 ,(char *) uc2_90EF },
	{ 0x90F4 , 1 ,12 ,12 ,24 ,(char *) uc2_90F4 },
	{ 0x90F8 , 1 ,12 ,12 ,24 ,(char *) uc2_90F8 },
	{ 0x90FD , 1 ,12 ,12 ,24 ,(char *) uc2_90FD },
	{ 0x90FE , 1 ,12 ,12 ,24 ,(char *) uc2_90FE },
	{ 0x9102 , 1 ,12 ,12 ,24 ,(char *) uc2_9102 },
	{ 0x9104 , 1 ,12 ,12 ,24 ,(char *) uc2_9104 },
	{ 0x9119 , 1 ,12 ,12 ,24 ,(char *) uc2_9119 },
	{ 0x911E , 1 ,12 ,12 ,24 ,(char *) uc2_911E },
	{ 0x9122 , 1 ,12 ,12 ,24 ,(char *) uc2_9122 },
	{ 0x9123 , 1 ,12 ,12 ,24 ,(char *) uc2_9123 },
	{ 0x912F , 1 ,12 ,12 ,24 ,(char *) uc2_912F },
	{ 0x9131 , 1 ,12 ,12 ,24 ,(char *) uc2_9131 },
	{ 0x9139 , 1 ,12 ,12 ,24 ,(char *) uc2_9139 },
	{ 0x9143 , 1 ,12 ,12 ,24 ,(char *) uc2_9143 },
	{ 0x9146 , 1 ,12 ,12 ,24 ,(char *) uc2_9146 },
	{ 0x9149 , 1 ,12 ,12 ,24 ,(char *) uc2_9149 },
	{ 0x914A , 1 ,12 ,12 ,24 ,(char *) uc2_914A },
	{ 0x914B , 1 ,12 ,12 ,24 ,(char *) uc2_914B },
	{ 0x914C , 1 ,12 ,12 ,24 ,(char *) uc2_914C },
	{ 0x914D , 1 ,12 ,12 ,24 ,(char *) uc2_914D },
	{ 0x914E , 1 ,12 ,12 ,24 ,(char *) uc2_914E },
	{ 0x914F , 1 ,12 ,12 ,24 ,(char *) uc2_914F },
	{ 0x9150 , 1 ,12 ,12 ,24 ,(char *) uc2_9150 },
	{ 0x9152 , 1 ,12 ,12 ,24 ,(char *) uc2_9152 },
	{ 0x9157 , 1 ,12 ,12 ,24 ,(char *) uc2_9157 },
	{ 0x915A , 1 ,12 ,12 ,24 ,(char *) uc2_915A },
	{ 0x915D , 1 ,12 ,12 ,24 ,(char *) uc2_915D },
	{ 0x915E , 1 ,12 ,12 ,24 ,(char *) uc2_915E },
	{ 0x9161 , 1 ,12 ,12 ,24 ,(char *) uc2_9161 },
	{ 0x9162 , 1 ,12 ,12 ,24 ,(char *) uc2_9162 },
	{ 0x9163 , 1 ,12 ,12 ,24 ,(char *) uc2_9163 },
	{ 0x9164 , 1 ,12 ,12 ,24 ,(char *) uc2_9164 },
	{ 0x9165 , 1 ,12 ,12 ,24 ,(char *) uc2_9165 },
	{ 0x9169 , 1 ,12 ,12 ,24 ,(char *) uc2_9169 },
	{ 0x916A , 1 ,12 ,12 ,24 ,(char *) uc2_916A },
	{ 0x916C , 1 ,12 ,12 ,24 ,(char *) uc2_916C },
	{ 0x916E , 1 ,12 ,12 ,24 ,(char *) uc2_916E },
	{ 0x916F , 1 ,12 ,12 ,24 ,(char *) uc2_916F },
	{ 0x9170 , 1 ,12 ,12 ,24 ,(char *) uc2_9170 },
	{ 0x9171 , 1 ,12 ,12 ,24 ,(char *) uc2_9171 },
	{ 0x9172 , 1 ,12 ,12 ,24 ,(char *) uc2_9172 },
	{ 0x9174 , 1 ,12 ,12 ,24 ,(char *) uc2_9174 },
	{ 0x9175 , 1 ,12 ,12 ,24 ,(char *) uc2_9175 },
	{ 0x9176 , 1 ,12 ,12 ,24 ,(char *) uc2_9176 },
	{ 0x9177 , 1 ,12 ,12 ,24 ,(char *) uc2_9177 },
	{ 0x9178 , 1 ,12 ,12 ,24 ,(char *) uc2_9178 },
	{ 0x9179 , 1 ,12 ,12 ,24 ,(char *) uc2_9179 },
	{ 0x917D , 1 ,12 ,12 ,24 ,(char *) uc2_917D },
	{ 0x917E , 1 ,12 ,12 ,24 ,(char *) uc2_917E },
	{ 0x917F , 1 ,12 ,12 ,24 ,(char *) uc2_917F },
	{ 0x9185 , 1 ,12 ,12 ,24 ,(char *) uc2_9185 },
	{ 0x9187 , 1 ,12 ,12 ,24 ,(char *) uc2_9187 },
	{ 0x9189 , 1 ,12 ,12 ,24 ,(char *) uc2_9189 },
	{ 0x918B , 1 ,12 ,12 ,24 ,(char *) uc2_918B },
	{ 0x918C , 1 ,12 ,12 ,24 ,(char *) uc2_918C },
	{ 0x918D , 1 ,12 ,12 ,24 ,(char *) uc2_918D },
	{ 0x9190 , 1 ,12 ,12 ,24 ,(char *) uc2_9190 },
	{ 0x9191 , 1 ,12 ,12 ,24 ,(char *) uc2_9191 },
	{ 0x9192 , 1 ,12 ,12 ,24 ,(char *) uc2_9192 },
	{ 0x919A , 1 ,12 ,12 ,24 ,(char *) uc2_919A },
	{ 0x919B , 1 ,12 ,12 ,24 ,(char *) uc2_919B },
	{ 0x91A2 , 1 ,12 ,12 ,24 ,(char *) uc2_91A2 },
	{ 0x91A3 , 1 ,12 ,12 ,24 ,(char *) uc2_91A3 },
	{ 0x91AA , 1 ,12 ,12 ,24 ,(char *) uc2_91AA },
	{ 0x91AD , 1 ,12 ,12 ,24 ,(char *) uc2_91AD },
	{ 0x91AE , 1 ,12 ,12 ,24 ,(char *) uc2_91AE },
	{ 0x91AF , 1 ,12 ,12 ,24 ,(char *) uc2_91AF },
	{ 0x91B4 , 1 ,12 ,12 ,24 ,(char *) uc2_91B4 },
	{ 0x91B5 , 1 ,12 ,12 ,24 ,(char *) uc2_91B5 },
	{ 0x91BA , 1 ,12 ,12 ,24 ,(char *) uc2_91BA },
	{ 0x91C7 , 1 ,12 ,12 ,24 ,(char *) uc2_91C7 },
	{ 0x91C9 , 1 ,12 ,12 ,24 ,(char *) uc2_91C9 },
	{ 0x91CA , 1 ,12 ,12 ,24 ,(char *) uc2_91CA },
	{ 0x91CC , 1 ,12 ,12 ,24 ,(char *) uc2_91CC },
	{ 0x91CD , 1 ,12 ,12 ,24 ,(char *) uc2_91CD },
	{ 0x91CE , 1 ,12 ,12 ,24 ,(char *) uc2_91CE },
	{ 0x91CF , 1 ,12 ,12 ,24 ,(char *) uc2_91CF },
	{ 0x91D1 , 1 ,12 ,12 ,24 ,(char *) uc2_91D1 },
	{ 0x91DC , 1 ,12 ,12 ,24 ,(char *) uc2_91DC },
	{ 0x9274 , 1 ,12 ,12 ,24 ,(char *) uc2_9274 },
	{ 0x928E , 1 ,12 ,12 ,24 ,(char *) uc2_928E },
	{ 0x92AE , 1 ,12 ,12 ,24 ,(char *) uc2_92AE },
	{ 0x92C8 , 1 ,12 ,12 ,24 ,(char *) uc2_92C8 },
	{ 0x933E , 1 ,12 ,12 ,24 ,(char *) uc2_933E },
	{ 0x936A , 1 ,12 ,12 ,24 ,(char *) uc2_936A },
	{ 0x938F , 1 ,12 ,12 ,24 ,(char *) uc2_938F },
	{ 0x93CA , 1 ,12 ,12 ,24 ,(char *) uc2_93CA },
	{ 0x93D6 , 1 ,12 ,12 ,24 ,(char *) uc2_93D6 },
	{ 0x943E , 1 ,12 ,12 ,24 ,(char *) uc2_943E },
	{ 0x946B , 1 ,12 ,12 ,24 ,(char *) uc2_946B },
	{ 0x9486 , 1 ,12 ,12 ,24 ,(char *) uc2_9486 },
	{ 0x9487 , 1 ,12 ,12 ,24 ,(char *) uc2_9487 },
	{ 0x9488 , 1 ,12 ,12 ,24 ,(char *) uc2_9488 },
	{ 0x9489 , 1 ,12 ,12 ,24 ,(char *) uc2_9489 },
	{ 0x948A , 1 ,12 ,12 ,24 ,(char *) uc2_948A },
	{ 0x948B , 1 ,12 ,12 ,24 ,(char *) uc2_948B },
	{ 0x948C , 1 ,12 ,12 ,24 ,(char *) uc2_948C },
	{ 0x948D , 1 ,12 ,12 ,24 ,(char *) uc2_948D },
	{ 0x948E , 1 ,12 ,12 ,24 ,(char *) uc2_948E },
	{ 0x948F , 1 ,12 ,12 ,24 ,(char *) uc2_948F },
	{ 0x9490 , 1 ,12 ,12 ,24 ,(char *) uc2_9490 },
	{ 0x9492 , 1 ,12 ,12 ,24 ,(char *) uc2_9492 },
	{ 0x9493 , 1 ,12 ,12 ,24 ,(char *) uc2_9493 },
	{ 0x9494 , 1 ,12 ,12 ,24 ,(char *) uc2_9494 },
	{ 0x9495 , 1 ,12 ,12 ,24 ,(char *) uc2_9495 },
	{ 0x9497 , 1 ,12 ,12 ,24 ,(char *) uc2_9497 },
	{ 0x9499 , 1 ,12 ,12 ,24 ,(char *) uc2_9499 },
	{ 0x949A , 1 ,12 ,12 ,24 ,(char *) uc2_949A },
	{ 0x949B , 1 ,12 ,12 ,24 ,(char *) uc2_949B },
	{ 0x949C , 1 ,12 ,12 ,24 ,(char *) uc2_949C },
	{ 0x949D , 1 ,12 ,12 ,24 ,(char *) uc2_949D },
	{ 0x949E , 1 ,12 ,12 ,24 ,(char *) uc2_949E },
	{ 0x949F , 1 ,12 ,12 ,24 ,(char *) uc2_949F },
	{ 0x94A0 , 1 ,12 ,12 ,24 ,(char *) uc2_94A0 },
	{ 0x94A1 , 1 ,12 ,12 ,24 ,(char *) uc2_94A1 },
	{ 0x94A2 , 1 ,12 ,12 ,24 ,(char *) uc2_94A2 },
	{ 0x94A3 , 1 ,12 ,12 ,24 ,(char *) uc2_94A3 },
	{ 0x94A4 , 1 ,12 ,12 ,24 ,(char *) uc2_94A4 },
	{ 0x94A5 , 1 ,12 ,12 ,24 ,(char *) uc2_94A5 },
	{ 0x94A6 , 1 ,12 ,12 ,24 ,(char *) uc2_94A6 },
	{ 0x94A7 , 1 ,12 ,12 ,24 ,(char *) uc2_94A7 },
	{ 0x94A8 , 1 ,12 ,12 ,24 ,(char *) uc2_94A8 },
	{ 0x94A9 , 1 ,12 ,12 ,24 ,(char *) uc2_94A9 },
	{ 0x94AA , 1 ,12 ,12 ,24 ,(char *) uc2_94AA },
	{ 0x94AB , 1 ,12 ,12 ,24 ,(char *) uc2_94AB },
	{ 0x94AC , 1 ,12 ,12 ,24 ,(char *) uc2_94AC },
	{ 0x94AD , 1 ,12 ,12 ,24 ,(char *) uc2_94AD },
	{ 0x94AE , 1 ,12 ,12 ,24 ,(char *) uc2_94AE },
	{ 0x94AF , 1 ,12 ,12 ,24 ,(char *) uc2_94AF },
	{ 0x94B0 , 1 ,12 ,12 ,24 ,(char *) uc2_94B0 },
	{ 0x94B1 , 1 ,12 ,12 ,24 ,(char *) uc2_94B1 },
	{ 0x94B2 , 1 ,12 ,12 ,24 ,(char *) uc2_94B2 },
	{ 0x94B3 , 1 ,12 ,12 ,24 ,(char *) uc2_94B3 },
	{ 0x94B4 , 1 ,12 ,12 ,24 ,(char *) uc2_94B4 },
	{ 0x94B5 , 1 ,12 ,12 ,24 ,(char *) uc2_94B5 },
	{ 0x94B6 , 1 ,12 ,12 ,24 ,(char *) uc2_94B6 },
	{ 0x94B7 , 1 ,12 ,12 ,24 ,(char *) uc2_94B7 },
	{ 0x94B8 , 1 ,12 ,12 ,24 ,(char *) uc2_94B8 },
	{ 0x94B9 , 1 ,12 ,12 ,24 ,(char *) uc2_94B9 },
	{ 0x94BA , 1 ,12 ,12 ,24 ,(char *) uc2_94BA },
	{ 0x94BB , 1 ,12 ,12 ,24 ,(char *) uc2_94BB },
	{ 0x94BC , 1 ,12 ,12 ,24 ,(char *) uc2_94BC },
	{ 0x94BD , 1 ,12 ,12 ,24 ,(char *) uc2_94BD },
	{ 0x94BE , 1 ,12 ,12 ,24 ,(char *) uc2_94BE },
	{ 0x94BF , 1 ,12 ,12 ,24 ,(char *) uc2_94BF },
	{ 0x94C0 , 1 ,12 ,12 ,24 ,(char *) uc2_94C0 },
	{ 0x94C1 , 1 ,12 ,12 ,24 ,(char *) uc2_94C1 },
	{ 0x94C2 , 1 ,12 ,12 ,24 ,(char *) uc2_94C2 },
	{ 0x94C3 , 1 ,12 ,12 ,24 ,(char *) uc2_94C3 },
	{ 0x94C4 , 1 ,12 ,12 ,24 ,(char *) uc2_94C4 },
	{ 0x94C5 , 1 ,12 ,12 ,24 ,(char *) uc2_94C5 },
	{ 0x94C6 , 1 ,12 ,12 ,24 ,(char *) uc2_94C6 },
	{ 0x94C8 , 1 ,12 ,12 ,24 ,(char *) uc2_94C8 },
	{ 0x94C9 , 1 ,12 ,12 ,24 ,(char *) uc2_94C9 },
	{ 0x94CA , 1 ,12 ,12 ,24 ,(char *) uc2_94CA },
	{ 0x94CB , 1 ,12 ,12 ,24 ,(char *) uc2_94CB },
	{ 0x94CC , 1 ,12 ,12 ,24 ,(char *) uc2_94CC },
	{ 0x94CD , 1 ,12 ,12 ,24 ,(char *) uc2_94CD },
	{ 0x94CE , 1 ,12 ,12 ,24 ,(char *) uc2_94CE },
	{ 0x94D0 , 1 ,12 ,12 ,24 ,(char *) uc2_94D0 },
	{ 0x94D1 , 1 ,12 ,12 ,24 ,(char *) uc2_94D1 },
	{ 0x94D2 , 1 ,12 ,12 ,24 ,(char *) uc2_94D2 },
	{ 0x94D5 , 1 ,12 ,12 ,24 ,(char *) uc2_94D5 },
	{ 0x94D6 , 1 ,12 ,12 ,24 ,(char *) uc2_94D6 },
	{ 0x94D7 , 1 ,12 ,12 ,24 ,(char *) uc2_94D7 },
	{ 0x94D8 , 1 ,12 ,12 ,24 ,(char *) uc2_94D8 },
	{ 0x94D9 , 1 ,12 ,12 ,24 ,(char *) uc2_94D9 },
	{ 0x94DB , 1 ,12 ,12 ,24 ,(char *) uc2_94DB },
	{ 0x94DC , 1 ,12 ,12 ,24 ,(char *) uc2_94DC },
	{ 0x94DD , 1 ,12 ,12 ,24 ,(char *) uc2_94DD },
	{ 0x94DE , 1 ,12 ,12 ,24 ,(char *) uc2_94DE },
	{ 0x94DF , 1 ,12 ,12 ,24 ,(char *) uc2_94DF },
	{ 0x94E0 , 1 ,12 ,12 ,24 ,(char *) uc2_94E0 },
	{ 0x94E1 , 1 ,12 ,12 ,24 ,(char *) uc2_94E1 },
	{ 0x94E2 , 1 ,12 ,12 ,24 ,(char *) uc2_94E2 },
	{ 0x94E3 , 1 ,12 ,12 ,24 ,(char *) uc2_94E3 },
	{ 0x94E4 , 1 ,12 ,12 ,24 ,(char *) uc2_94E4 },
	{ 0x94E5 , 1 ,12 ,12 ,24 ,(char *) uc2_94E5 },
	{ 0x94E7 , 1 ,12 ,12 ,24 ,(char *) uc2_94E7 },
	{ 0x94E8 , 1 ,12 ,12 ,24 ,(char *) uc2_94E8 },
	{ 0x94E9 , 1 ,12 ,12 ,24 ,(char *) uc2_94E9 },
	{ 0x94EA , 1 ,12 ,12 ,24 ,(char *) uc2_94EA },
	{ 0x94EB , 1 ,12 ,12 ,24 ,(char *) uc2_94EB },
	{ 0x94EC , 1 ,12 ,12 ,24 ,(char *) uc2_94EC },
	{ 0x94ED , 1 ,12 ,12 ,24 ,(char *) uc2_94ED },
	{ 0x94EE , 1 ,12 ,12 ,24 ,(char *) uc2_94EE },
	{ 0x94EF , 1 ,12 ,12 ,24 ,(char *) uc2_94EF },
	{ 0x94F0 , 1 ,12 ,12 ,24 ,(char *) uc2_94F0 },
	{ 0x94F1 , 1 ,12 ,12 ,24 ,(char *) uc2_94F1 },
	{ 0x94F2 , 1 ,12 ,12 ,24 ,(char *) uc2_94F2 },
	{ 0x94F3 , 1 ,12 ,12 ,24 ,(char *) uc2_94F3 },
	{ 0x94F4 , 1 ,12 ,12 ,24 ,(char *) uc2_94F4 },
	{ 0x94F5 , 1 ,12 ,12 ,24 ,(char *) uc2_94F5 },
	{ 0x94F6 , 1 ,12 ,12 ,24 ,(char *) uc2_94F6 },
	{ 0x94F7 , 1 ,12 ,12 ,24 ,(char *) uc2_94F7 },
	{ 0x94F8 , 1 ,12 ,12 ,24 ,(char *) uc2_94F8 },
	{ 0x94F9 , 1 ,12 ,12 ,24 ,(char *) uc2_94F9 },
	{ 0x94FA , 1 ,12 ,12 ,24 ,(char *) uc2_94FA },
	{ 0x94FC , 1 ,12 ,12 ,24 ,(char *) uc2_94FC },
	{ 0x94FD , 1 ,12 ,12 ,24 ,(char *) uc2_94FD },
	{ 0x94FE , 1 ,12 ,12 ,24 ,(char *) uc2_94FE },
	{ 0x94FF , 1 ,12 ,12 ,24 ,(char *) uc2_94FF },
	{ 0x9500 , 1 ,12 ,12 ,24 ,(char *) uc2_9500 },
	{ 0x9501 , 1 ,12 ,12 ,24 ,(char *) uc2_9501 },
	{ 0x9502 , 1 ,12 ,12 ,24 ,(char *) uc2_9502 },
	{ 0x9503 , 1 ,12 ,12 ,24 ,(char *) uc2_9503 },
	{ 0x9504 , 1 ,12 ,12 ,24 ,(char *) uc2_9504 },
	{ 0x9505 , 1 ,12 ,12 ,24 ,(char *) uc2_9505 },
	{ 0x9506 , 1 ,12 ,12 ,24 ,(char *) uc2_9506 },
	{ 0x9507 , 1 ,12 ,12 ,24 ,(char *) uc2_9507 },
	{ 0x9508 , 1 ,12 ,12 ,24 ,(char *) uc2_9508 },
	{ 0x9509 , 1 ,12 ,12 ,24 ,(char *) uc2_9509 },
	{ 0x950A , 1 ,12 ,12 ,24 ,(char *) uc2_950A },
	{ 0x950B , 1 ,12 ,12 ,24 ,(char *) uc2_950B },
	{ 0x950C , 1 ,12 ,12 ,24 ,(char *) uc2_950C },
	{ 0x950D , 1 ,12 ,12 ,24 ,(char *) uc2_950D },
	{ 0x950E , 1 ,12 ,12 ,24 ,(char *) uc2_950E },
	{ 0x950F , 1 ,12 ,12 ,24 ,(char *) uc2_950F },
	{ 0x9510 , 1 ,12 ,12 ,24 ,(char *) uc2_9510 },
	{ 0x9511 , 1 ,12 ,12 ,24 ,(char *) uc2_9511 },
	{ 0x9512 , 1 ,12 ,12 ,24 ,(char *) uc2_9512 },
	{ 0x9513 , 1 ,12 ,12 ,24 ,(char *) uc2_9513 },
	{ 0x9514 , 1 ,12 ,12 ,24 ,(char *) uc2_9514 },
	{ 0x9515 , 1 ,12 ,12 ,24 ,(char *) uc2_9515 },
	{ 0x9516 , 1 ,12 ,12 ,24 ,(char *) uc2_9516 },
	{ 0x9517 , 1 ,12 ,12 ,24 ,(char *) uc2_9517 },
	{ 0x9518 , 1 ,12 ,12 ,24 ,(char *) uc2_9518 },
	{ 0x9519 , 1 ,12 ,12 ,24 ,(char *) uc2_9519 },
	{ 0x951A , 1 ,12 ,12 ,24 ,(char *) uc2_951A },
	{ 0x951B , 1 ,12 ,12 ,24 ,(char *) uc2_951B },
	{ 0x951D , 1 ,12 ,12 ,24 ,(char *) uc2_951D },
	{ 0x951E , 1 ,12 ,12 ,24 ,(char *) uc2_951E },
	{ 0x951F , 1 ,12 ,12 ,24 ,(char *) uc2_951F },
	{ 0x9521 , 1 ,12 ,12 ,24 ,(char *) uc2_9521 },
	{ 0x9522 , 1 ,12 ,12 ,24 ,(char *) uc2_9522 },
	{ 0x9523 , 1 ,12 ,12 ,24 ,(char *) uc2_9523 },
	{ 0x9524 , 1 ,12 ,12 ,24 ,(char *) uc2_9524 },
	{ 0x9525 , 1 ,12 ,12 ,24 ,(char *) uc2_9525 },
	{ 0x9526 , 1 ,12 ,12 ,24 ,(char *) uc2_9526 },
	{ 0x9528 , 1 ,12 ,12 ,24 ,(char *) uc2_9528 },
	{ 0x9529 , 1 ,12 ,12 ,24 ,(char *) uc2_9529 },
	{ 0x952A , 1 ,12 ,12 ,24 ,(char *) uc2_952A },
	{ 0x952B , 1 ,12 ,12 ,24 ,(char *) uc2_952B },
	{ 0x952C , 1 ,12 ,12 ,24 ,(char *) uc2_952C },
	{ 0x952D , 1 ,12 ,12 ,24 ,(char *) uc2_952D },
	{ 0x952E , 1 ,12 ,12 ,24 ,(char *) uc2_952E },
	{ 0x952F , 1 ,12 ,12 ,24 ,(char *) uc2_952F },
	{ 0x9530 , 1 ,12 ,12 ,24 ,(char *) uc2_9530 },
	{ 0x9531 , 1 ,12 ,12 ,24 ,(char *) uc2_9531 },
	{ 0x9532 , 1 ,12 ,12 ,24 ,(char *) uc2_9532 },
	{ 0x9534 , 1 ,12 ,12 ,24 ,(char *) uc2_9534 },
	{ 0x9535 , 1 ,12 ,12 ,24 ,(char *) uc2_9535 },
	{ 0x9536 , 1 ,12 ,12 ,24 ,(char *) uc2_9536 },
	{ 0x9537 , 1 ,12 ,12 ,24 ,(char *) uc2_9537 },
	{ 0x9538 , 1 ,12 ,12 ,24 ,(char *) uc2_9538 },
	{ 0x9539 , 1 ,12 ,12 ,24 ,(char *) uc2_9539 },
	{ 0x953A , 1 ,12 ,12 ,24 ,(char *) uc2_953A },
	{ 0x953B , 1 ,12 ,12 ,24 ,(char *) uc2_953B },
	{ 0x953C , 1 ,12 ,12 ,24 ,(char *) uc2_953C },
	{ 0x953E , 1 ,12 ,12 ,24 ,(char *) uc2_953E },
	{ 0x953F , 1 ,12 ,12 ,24 ,(char *) uc2_953F },
	{ 0x9540 , 1 ,12 ,12 ,24 ,(char *) uc2_9540 },
	{ 0x9541 , 1 ,12 ,12 ,24 ,(char *) uc2_9541 },
	{ 0x9542 , 1 ,12 ,12 ,24 ,(char *) uc2_9542 },
	{ 0x9544 , 1 ,12 ,12 ,24 ,(char *) uc2_9544 },
	{ 0x9545 , 1 ,12 ,12 ,24 ,(char *) uc2_9545 },
	{ 0x9546 , 1 ,12 ,12 ,24 ,(char *) uc2_9546 },
	{ 0x9547 , 1 ,12 ,12 ,24 ,(char *) uc2_9547 },
	{ 0x9549 , 1 ,12 ,12 ,24 ,(char *) uc2_9549 },
	{ 0x954A , 1 ,12 ,12 ,24 ,(char *) uc2_954A },
	{ 0x954C , 1 ,12 ,12 ,24 ,(char *) uc2_954C },
	{ 0x954D , 1 ,12 ,12 ,24 ,(char *) uc2_954D },
	{ 0x954E , 1 ,12 ,12 ,24 ,(char *) uc2_954E },
	{ 0x954F , 1 ,12 ,12 ,24 ,(char *) uc2_954F },
	{ 0x9550 , 1 ,12 ,12 ,24 ,(char *) uc2_9550 },
	{ 0x9551 , 1 ,12 ,12 ,24 ,(char *) uc2_9551 },
	{ 0x9552 , 1 ,12 ,12 ,24 ,(char *) uc2_9552 },
	{ 0x9553 , 1 ,12 ,12 ,24 ,(char *) uc2_9553 },
	{ 0x9554 , 1 ,12 ,12 ,24 ,(char *) uc2_9554 },
	{ 0x9555 , 1 ,12 ,12 ,24 ,(char *) uc2_9555 },
	{ 0x9556 , 1 ,12 ,12 ,24 ,(char *) uc2_9556 },
	{ 0x9557 , 1 ,12 ,12 ,24 ,(char *) uc2_9557 },
	{ 0x9558 , 1 ,12 ,12 ,24 ,(char *) uc2_9558 },
	{ 0x9559 , 1 ,12 ,12 ,24 ,(char *) uc2_9559 },
	{ 0x955B , 1 ,12 ,12 ,24 ,(char *) uc2_955B },
	{ 0x955C , 1 ,12 ,12 ,24 ,(char *) uc2_955C },
	{ 0x955D , 1 ,12 ,12 ,24 ,(char *) uc2_955D },
	{ 0x955E , 1 ,12 ,12 ,24 ,(char *) uc2_955E },
	{ 0x955F , 1 ,12 ,12 ,24 ,(char *) uc2_955F },
	{ 0x9561 , 1 ,12 ,12 ,24 ,(char *) uc2_9561 },
	{ 0x9562 , 1 ,12 ,12 ,24 ,(char *) uc2_9562 },
	{ 0x9563 , 1 ,12 ,12 ,24 ,(char *) uc2_9563 },
	{ 0x9564 , 1 ,12 ,12 ,24 ,(char *) uc2_9564 },
	{ 0x9565 , 1 ,12 ,12 ,24 ,(char *) uc2_9565 },
	{ 0x9566 , 1 ,12 ,12 ,24 ,(char *) uc2_9566 },
	{ 0x9567 , 1 ,12 ,12 ,24 ,(char *) uc2_9567 },
	{ 0x9568 , 1 ,12 ,12 ,24 ,(char *) uc2_9568 },
	{ 0x9569 , 1 ,12 ,12 ,24 ,(char *) uc2_9569 },
	{ 0x956A , 1 ,12 ,12 ,24 ,(char *) uc2_956A },
	{ 0x956B , 1 ,12 ,12 ,24 ,(char *) uc2_956B },
	{ 0x956C , 1 ,12 ,12 ,24 ,(char *) uc2_956C },
	{ 0x956D , 1 ,12 ,12 ,24 ,(char *) uc2_956D },
	{ 0x956F , 1 ,12 ,12 ,24 ,(char *) uc2_956F },
	{ 0x9570 , 1 ,12 ,12 ,24 ,(char *) uc2_9570 },
	{ 0x9571 , 1 ,12 ,12 ,24 ,(char *) uc2_9571 },
	{ 0x9572 , 1 ,12 ,12 ,24 ,(char *) uc2_9572 },
	{ 0x9573 , 1 ,12 ,12 ,24 ,(char *) uc2_9573 },
	{ 0x9576 , 1 ,12 ,12 ,24 ,(char *) uc2_9576 },
	{ 0x957F , 1 ,12 ,12 ,24 ,(char *) uc2_957F },
	{ 0x95E8 , 1 ,12 ,12 ,24 ,(char *) uc2_95E8 },
	{ 0x95E9 , 1 ,12 ,12 ,24 ,(char *) uc2_95E9 },
	{ 0x95EA , 1 ,12 ,12 ,24 ,(char *) uc2_95EA },
	{ 0x95EB , 1 ,12 ,12 ,24 ,(char *) uc2_95EB },
	{ 0x95ED , 1 ,12 ,12 ,24 ,(char *) uc2_95ED },
	{ 0x95EE , 1 ,12 ,12 ,24 ,(char *) uc2_95EE },
	{ 0x95EF , 1 ,12 ,12 ,24 ,(char *) uc2_95EF },
	{ 0x95F0 , 1 ,12 ,12 ,24 ,(char *) uc2_95F0 },
	{ 0x95F1 , 1 ,12 ,12 ,24 ,(char *) uc2_95F1 },
	{ 0x95F2 , 1 ,12 ,12 ,24 ,(char *) uc2_95F2 },
	{ 0x95F3 , 1 ,12 ,12 ,24 ,(char *) uc2_95F3 },
	{ 0x95F4 , 1 ,12 ,12 ,24 ,(char *) uc2_95F4 },
	{ 0x95F5 , 1 ,12 ,12 ,24 ,(char *) uc2_95F5 },
	{ 0x95F6 , 1 ,12 ,12 ,24 ,(char *) uc2_95F6 },
	{ 0x95F7 , 1 ,12 ,12 ,24 ,(char *) uc2_95F7 },
	{ 0x95F8 , 1 ,12 ,12 ,24 ,(char *) uc2_95F8 },
	{ 0x95F9 , 1 ,12 ,12 ,24 ,(char *) uc2_95F9 },
	{ 0x95FA , 1 ,12 ,12 ,24 ,(char *) uc2_95FA },
	{ 0x95FB , 1 ,12 ,12 ,24 ,(char *) uc2_95FB },
	{ 0x95FC , 1 ,12 ,12 ,24 ,(char *) uc2_95FC },
	{ 0x95FD , 1 ,12 ,12 ,24 ,(char *) uc2_95FD },
	{ 0x95FE , 1 ,12 ,12 ,24 ,(char *) uc2_95FE },
	{ 0x9600 , 1 ,12 ,12 ,24 ,(char *) uc2_9600 },
	{ 0x9601 , 1 ,12 ,12 ,24 ,(char *) uc2_9601 },
	{ 0x9602 , 1 ,12 ,12 ,24 ,(char *) uc2_9602 },
	{ 0x9603 , 1 ,12 ,12 ,24 ,(char *) uc2_9603 },
	{ 0x9604 , 1 ,12 ,12 ,24 ,(char *) uc2_9604 },
	{ 0x9605 , 1 ,12 ,12 ,24 ,(char *) uc2_9605 },
	{ 0x9606 , 1 ,12 ,12 ,24 ,(char *) uc2_9606 },
	{ 0x9608 , 1 ,12 ,12 ,24 ,(char *) uc2_9608 },
	{ 0x9609 , 1 ,12 ,12 ,24 ,(char *) uc2_9609 },
	{ 0x960A , 1 ,12 ,12 ,24 ,(char *) uc2_960A },
	{ 0x960B , 1 ,12 ,12 ,24 ,(char *) uc2_960B },
	{ 0x960C , 1 ,12 ,12 ,24 ,(char *) uc2_960C },
	{ 0x960D , 1 ,12 ,12 ,24 ,(char *) uc2_960D },
	{ 0x960E , 1 ,12 ,12 ,24 ,(char *) uc2_960E },
	{ 0x960F , 1 ,12 ,12 ,24 ,(char *) uc2_960F },
	{ 0x9610 , 1 ,12 ,12 ,24 ,(char *) uc2_9610 },
	{ 0x9611 , 1 ,12 ,12 ,24 ,(char *) uc2_9611 },
	{ 0x9612 , 1 ,12 ,12 ,24 ,(char *) uc2_9612 },
	{ 0x9614 , 1 ,12 ,12 ,24 ,(char *) uc2_9614 },
	{ 0x9615 , 1 ,12 ,12 ,24 ,(char *) uc2_9615 },
	{ 0x9616 , 1 ,12 ,12 ,24 ,(char *) uc2_9616 },
	{ 0x9617 , 1 ,12 ,12 ,24 ,(char *) uc2_9617 },
	{ 0x9619 , 1 ,12 ,12 ,24 ,(char *) uc2_9619 },
	{ 0x961A , 1 ,12 ,12 ,24 ,(char *) uc2_961A },
	{ 0x961C , 1 ,12 ,12 ,24 ,(char *) uc2_961C },
	{ 0x961D , 1 ,12 ,12 ,24 ,(char *) uc2_961D }, /*API*/
	{ 0x961F , 1 ,12 ,12 ,24 ,(char *) uc2_961F },
	{ 0x9621 , 1 ,12 ,12 ,24 ,(char *) uc2_9621 },
	{ 0x9622 , 1 ,12 ,12 ,24 ,(char *) uc2_9622 },
	{ 0x962A , 1 ,12 ,12 ,24 ,(char *) uc2_962A },
	{ 0x962E , 1 ,12 ,12 ,24 ,(char *) uc2_962E },
	{ 0x9631 , 1 ,12 ,12 ,24 ,(char *) uc2_9631 },
	{ 0x9632 , 1 ,12 ,12 ,24 ,(char *) uc2_9632 },
	{ 0x9633 , 1 ,12 ,12 ,24 ,(char *) uc2_9633 },
	{ 0x9634 , 1 ,12 ,12 ,24 ,(char *) uc2_9634 },
	{ 0x9635 , 1 ,12 ,12 ,24 ,(char *) uc2_9635 },
	{ 0x9636 , 1 ,12 ,12 ,24 ,(char *) uc2_9636 },
	{ 0x963B , 1 ,12 ,12 ,24 ,(char *) uc2_963B },
	{ 0x963C , 1 ,12 ,12 ,24 ,(char *) uc2_963C },
	{ 0x963D , 1 ,12 ,12 ,24 ,(char *) uc2_963D },
	{ 0x963F , 1 ,12 ,12 ,24 ,(char *) uc2_963F },
	{ 0x9640 , 1 ,12 ,12 ,24 ,(char *) uc2_9640 },
	{ 0x9642 , 1 ,12 ,12 ,24 ,(char *) uc2_9642 },
	{ 0x9644 , 1 ,12 ,12 ,24 ,(char *) uc2_9644 },
	{ 0x9645 , 1 ,12 ,12 ,24 ,(char *) uc2_9645 },
	{ 0x9646 , 1 ,12 ,12 ,24 ,(char *) uc2_9646 },
	{ 0x9647 , 1 ,12 ,12 ,24 ,(char *) uc2_9647 },
	{ 0x9648 , 1 ,12 ,12 ,24 ,(char *) uc2_9648 },
	{ 0x9649 , 1 ,12 ,12 ,24 ,(char *) uc2_9649 },
	{ 0x964B , 1 ,12 ,12 ,24 ,(char *) uc2_964B },
	{ 0x964C , 1 ,12 ,12 ,24 ,(char *) uc2_964C },
	{ 0x964D , 1 ,12 ,12 ,24 ,(char *) uc2_964D },
	{ 0x9650 , 1 ,12 ,12 ,24 ,(char *) uc2_9650 },
	{ 0x9654 , 1 ,12 ,12 ,24 ,(char *) uc2_9654 },
	{ 0x9655 , 1 ,12 ,12 ,24 ,(char *) uc2_9655 },
	{ 0x965B , 1 ,12 ,12 ,24 ,(char *) uc2_965B },
	{ 0x965F , 1 ,12 ,12 ,24 ,(char *) uc2_965F },
	{ 0x9661 , 1 ,12 ,12 ,24 ,(char *) uc2_9661 },
	{ 0x9662 , 1 ,12 ,12 ,24 ,(char *) uc2_9662 },
	{ 0x9664 , 1 ,12 ,12 ,24 ,(char *) uc2_9664 },
	{ 0x9667 , 1 ,12 ,12 ,24 ,(char *) uc2_9667 },
	{ 0x9668 , 1 ,12 ,12 ,24 ,(char *) uc2_9668 },
	{ 0x9669 , 1 ,12 ,12 ,24 ,(char *) uc2_9669 },
	{ 0x966A , 1 ,12 ,12 ,24 ,(char *) uc2_966A },
	{ 0x966C , 1 ,12 ,12 ,24 ,(char *) uc2_966C },
	{ 0x9672 , 1 ,12 ,12 ,24 ,(char *) uc2_9672 },
	{ 0x9674 , 1 ,12 ,12 ,24 ,(char *) uc2_9674 },
	{ 0x9675 , 1 ,12 ,12 ,24 ,(char *) uc2_9675 },
	{ 0x9676 , 1 ,12 ,12 ,24 ,(char *) uc2_9676 },
	{ 0x9677 , 1 ,12 ,12 ,24 ,(char *) uc2_9677 },
	{ 0x9685 , 1 ,12 ,12 ,24 ,(char *) uc2_9685 },
	{ 0x9686 , 1 ,12 ,12 ,24 ,(char *) uc2_9686 },
	{ 0x9688 , 1 ,12 ,12 ,24 ,(char *) uc2_9688 },
	{ 0x968B , 1 ,12 ,12 ,24 ,(char *) uc2_968B },
	{ 0x968D , 1 ,12 ,12 ,24 ,(char *) uc2_968D },
	{ 0x968F , 1 ,12 ,12 ,24 ,(char *) uc2_968F },
	{ 0x9690 , 1 ,12 ,12 ,24 ,(char *) uc2_9690 },
	{ 0x9694 , 1 ,12 ,12 ,24 ,(char *) uc2_9694 },
	{ 0x9697 , 1 ,12 ,12 ,24 ,(char *) uc2_9697 },
	{ 0x9698 , 1 ,12 ,12 ,24 ,(char *) uc2_9698 },
	{ 0x9699 , 1 ,12 ,12 ,24 ,(char *) uc2_9699 },
	{ 0x969C , 1 ,12 ,12 ,24 ,(char *) uc2_969C },
	{ 0x96A7 , 1 ,12 ,12 ,24 ,(char *) uc2_96A7 },
	{ 0x96B0 , 1 ,12 ,12 ,24 ,(char *) uc2_96B0 },
	{ 0x96B3 , 1 ,12 ,12 ,24 ,(char *) uc2_96B3 },
	{ 0x96B6 , 1 ,12 ,12 ,24 ,(char *) uc2_96B6 },
	{ 0x96B9 , 1 ,12 ,12 ,24 ,(char *) uc2_96B9 },
	{ 0x96BC , 1 ,12 ,12 ,24 ,(char *) uc2_96BC },
	{ 0x96BD , 1 ,12 ,12 ,24 ,(char *) uc2_96BD },
	{ 0x96BE , 1 ,12 ,12 ,24 ,(char *) uc2_96BE },
	{ 0x96C0 , 1 ,12 ,12 ,24 ,(char *) uc2_96C0 },
	{ 0x96C1 , 1 ,12 ,12 ,24 ,(char *) uc2_96C1 },
	{ 0x96C4 , 1 ,12 ,12 ,24 ,(char *) uc2_96C4 },
	{ 0x96C5 , 1 ,12 ,12 ,24 ,(char *) uc2_96C5 },
	{ 0x96C6 , 1 ,12 ,12 ,24 ,(char *) uc2_96C6 },
	{ 0x96C7 , 1 ,12 ,12 ,24 ,(char *) uc2_96C7 },
	{ 0x96C9 , 1 ,12 ,12 ,24 ,(char *) uc2_96C9 },
	{ 0x96CC , 1 ,12 ,12 ,24 ,(char *) uc2_96CC },
	{ 0x96CD , 1 ,12 ,12 ,24 ,(char *) uc2_96CD },
	{ 0x96CE , 1 ,12 ,12 ,24 ,(char *) uc2_96CE },
	{ 0x96CF , 1 ,12 ,12 ,24 ,(char *) uc2_96CF },
	{ 0x96D2 , 1 ,12 ,12 ,24 ,(char *) uc2_96D2 },
	{ 0x96D5 , 1 ,12 ,12 ,24 ,(char *) uc2_96D5 },
	{ 0x96E0 , 1 ,12 ,12 ,24 ,(char *) uc2_96E0 },
	{ 0x96E8 , 1 ,12 ,12 ,24 ,(char *) uc2_96E8 },
	{ 0x96E9 , 1 ,12 ,12 ,24 ,(char *) uc2_96E9 },
	{ 0x96EA , 1 ,12 ,12 ,24 ,(char *) uc2_96EA },
	{ 0x96EF , 1 ,12 ,12 ,24 ,(char *) uc2_96EF },
	{ 0x96F3 , 1 ,12 ,12 ,24 ,(char *) uc2_96F3 },
	{ 0x96F6 , 1 ,12 ,12 ,24 ,(char *) uc2_96F6 },
	{ 0x96F7 , 1 ,12 ,12 ,24 ,(char *) uc2_96F7 },
	{ 0x96F9 , 1 ,12 ,12 ,24 ,(char *) uc2_96F9 },
	{ 0x96FE , 1 ,12 ,12 ,24 ,(char *) uc2_96FE },
	{ 0x9700 , 1 ,12 ,12 ,24 ,(char *) uc2_9700 },
	{ 0x9701 , 1 ,12 ,12 ,24 ,(char *) uc2_9701 },
	{ 0x9704 , 1 ,12 ,12 ,24 ,(char *) uc2_9704 },
	{ 0x9706 , 1 ,12 ,12 ,24 ,(char *) uc2_9706 },
	{ 0x9707 , 1 ,12 ,12 ,24 ,(char *) uc2_9707 },
	{ 0x9708 , 1 ,12 ,12 ,24 ,(char *) uc2_9708 },
	{ 0x9709 , 1 ,12 ,12 ,24 ,(char *) uc2_9709 },
	{ 0x970D , 1 ,12 ,12 ,24 ,(char *) uc2_970D },
	{ 0x970E , 1 ,12 ,12 ,24 ,(char *) uc2_970E },
	{ 0x970F , 1 ,12 ,12 ,24 ,(char *) uc2_970F },
	{ 0x9713 , 1 ,12 ,12 ,24 ,(char *) uc2_9713 },
	{ 0x9716 , 1 ,12 ,12 ,24 ,(char *) uc2_9716 },
	{ 0x971C , 1 ,12 ,12 ,24 ,(char *) uc2_971C },
	{ 0x971E , 1 ,12 ,12 ,24 ,(char *) uc2_971E },
	{ 0x972A , 1 ,12 ,12 ,24 ,(char *) uc2_972A },
	{ 0x972D , 1 ,12 ,12 ,24 ,(char *) uc2_972D },
	{ 0x9730 , 1 ,12 ,12 ,24 ,(char *) uc2_9730 },
	{ 0x9732 , 1 ,12 ,12 ,24 ,(char *) uc2_9732 },
	{ 0x9738 , 1 ,12 ,12 ,24 ,(char *) uc2_9738 },
	{ 0x9739 , 1 ,12 ,12 ,24 ,(char *) uc2_9739 },
	{ 0x973E , 1 ,12 ,12 ,24 ,(char *) uc2_973E },
	{ 0x9752 , 1 ,12 ,12 ,24 ,(char *) uc2_9752 },
	{ 0x9753 , 1 ,12 ,12 ,24 ,(char *) uc2_9753 },
	{ 0x9756 , 1 ,12 ,12 ,24 ,(char *) uc2_9756 },
	{ 0x9759 , 1 ,12 ,12 ,24 ,(char *) uc2_9759 },
	{ 0x975B , 1 ,12 ,12 ,24 ,(char *) uc2_975B },
	{ 0x975E , 1 ,12 ,12 ,24 ,(char *) uc2_975E },
	{ 0x9760 , 1 ,12 ,12 ,24 ,(char *) uc2_9760 },
	{ 0x9761 , 1 ,12 ,12 ,24 ,(char *) uc2_9761 },
	{ 0x9762 , 1 ,12 ,12 ,24 ,(char *) uc2_9762 },
	{ 0x9765 , 1 ,12 ,12 ,24 ,(char *) uc2_9765 },
	{ 0x9769 , 1 ,12 ,12 ,24 ,(char *) uc2_9769 },
	{ 0x9773 , 1 ,12 ,12 ,24 ,(char *) uc2_9773 },
	{ 0x9774 , 1 ,12 ,12 ,24 ,(char *) uc2_9774 },
	{ 0x9776 , 1 ,12 ,12 ,24 ,(char *) uc2_9776 },
	{ 0x977C , 1 ,12 ,12 ,24 ,(char *) uc2_977C },
	{ 0x9785 , 1 ,12 ,12 ,24 ,(char *) uc2_9785 },
	{ 0x978B , 1 ,12 ,12 ,24 ,(char *) uc2_978B },
	{ 0x978D , 1 ,12 ,12 ,24 ,(char *) uc2_978D },
	{ 0x9791 , 1 ,12 ,12 ,24 ,(char *) uc2_9791 },
	{ 0x9792 , 1 ,12 ,12 ,24 ,(char *) uc2_9792 },
	{ 0x9794 , 1 ,12 ,12 ,24 ,(char *) uc2_9794 },
	{ 0x9798 , 1 ,12 ,12 ,24 ,(char *) uc2_9798 },
	{ 0x97A0 , 1 ,12 ,12 ,24 ,(char *) uc2_97A0 },
	{ 0x97A3 , 1 ,12 ,12 ,24 ,(char *) uc2_97A3 },
	{ 0x97AB , 1 ,12 ,12 ,24 ,(char *) uc2_97AB },
	{ 0x97AD , 1 ,12 ,12 ,24 ,(char *) uc2_97AD },
	{ 0x97AF , 1 ,12 ,12 ,24 ,(char *) uc2_97AF },
	{ 0x97B2 , 1 ,12 ,12 ,24 ,(char *) uc2_97B2 },
	{ 0x97B4 , 1 ,12 ,12 ,24 ,(char *) uc2_97B4 },
	{ 0x97E6 , 1 ,12 ,12 ,24 ,(char *) uc2_97E6 },
	{ 0x97E7 , 1 ,12 ,12 ,24 ,(char *) uc2_97E7 },
	{ 0x97E9 , 1 ,12 ,12 ,24 ,(char *) uc2_97E9 },
	{ 0x97EA , 1 ,12 ,12 ,24 ,(char *) uc2_97EA },
	{ 0x97EB , 1 ,12 ,12 ,24 ,(char *) uc2_97EB },
	{ 0x97EC , 1 ,12 ,12 ,24 ,(char *) uc2_97EC },
	{ 0x97ED , 1 ,12 ,12 ,24 ,(char *) uc2_97ED },
	{ 0x97F3 , 1 ,12 ,12 ,24 ,(char *) uc2_97F3 },
	{ 0x97F5 , 1 ,12 ,12 ,24 ,(char *) uc2_97F5 },
	{ 0x97F6 , 1 ,12 ,12 ,24 ,(char *) uc2_97F6 },
	{ 0x9875 , 1 ,12 ,12 ,24 ,(char *) uc2_9875 },
	{ 0x9876 , 1 ,12 ,12 ,24 ,(char *) uc2_9876 },
	{ 0x9877 , 1 ,12 ,12 ,24 ,(char *) uc2_9877 },
	{ 0x9878 , 1 ,12 ,12 ,24 ,(char *) uc2_9878 },
	{ 0x9879 , 1 ,12 ,12 ,24 ,(char *) uc2_9879 },
	{ 0x987A , 1 ,12 ,12 ,24 ,(char *) uc2_987A },
	{ 0x987B , 1 ,12 ,12 ,24 ,(char *) uc2_987B },
	{ 0x987C , 1 ,12 ,12 ,24 ,(char *) uc2_987C },
	{ 0x987D , 1 ,12 ,12 ,24 ,(char *) uc2_987D },
	{ 0x987E , 1 ,12 ,12 ,24 ,(char *) uc2_987E },
	{ 0x987F , 1 ,12 ,12 ,24 ,(char *) uc2_987F },
	{ 0x9880 , 1 ,12 ,12 ,24 ,(char *) uc2_9880 },
	{ 0x9881 , 1 ,12 ,12 ,24 ,(char *) uc2_9881 },
	{ 0x9882 , 1 ,12 ,12 ,24 ,(char *) uc2_9882 },
	{ 0x9883 , 1 ,12 ,12 ,24 ,(char *) uc2_9883 },
	{ 0x9884 , 1 ,12 ,12 ,24 ,(char *) uc2_9884 },
	{ 0x9885 , 1 ,12 ,12 ,24 ,(char *) uc2_9885 },
	{ 0x9886 , 1 ,12 ,12 ,24 ,(char *) uc2_9886 },
	{ 0x9887 , 1 ,12 ,12 ,24 ,(char *) uc2_9887 },
	{ 0x9888 , 1 ,12 ,12 ,24 ,(char *) uc2_9888 },
	{ 0x9889 , 1 ,12 ,12 ,24 ,(char *) uc2_9889 },
	{ 0x988A , 1 ,12 ,12 ,24 ,(char *) uc2_988A },
	{ 0x988C , 1 ,12 ,12 ,24 ,(char *) uc2_988C },
	{ 0x988D , 1 ,12 ,12 ,24 ,(char *) uc2_988D },
	{ 0x988F , 1 ,12 ,12 ,24 ,(char *) uc2_988F },
	{ 0x9890 , 1 ,12 ,12 ,24 ,(char *) uc2_9890 },
	{ 0x9891 , 1 ,12 ,12 ,24 ,(char *) uc2_9891 },
	{ 0x9893 , 1 ,12 ,12 ,24 ,(char *) uc2_9893 },
	{ 0x9894 , 1 ,12 ,12 ,24 ,(char *) uc2_9894 },
	{ 0x9896 , 1 ,12 ,12 ,24 ,(char *) uc2_9896 },
	{ 0x9897 , 1 ,12 ,12 ,24 ,(char *) uc2_9897 },
	{ 0x9898 , 1 ,12 ,12 ,24 ,(char *) uc2_9898 },
	{ 0x989A , 1 ,12 ,12 ,24 ,(char *) uc2_989A },
	{ 0x989B , 1 ,12 ,12 ,24 ,(char *) uc2_989B },
	{ 0x989C , 1 ,12 ,12 ,24 ,(char *) uc2_989C },
	{ 0x989D , 1 ,12 ,12 ,24 ,(char *) uc2_989D },
	{ 0x989E , 1 ,12 ,12 ,24 ,(char *) uc2_989E },
	{ 0x989F , 1 ,12 ,12 ,24 ,(char *) uc2_989F },
	{ 0x98A0 , 1 ,12 ,12 ,24 ,(char *) uc2_98A0 },
	{ 0x98A1 , 1 ,12 ,12 ,24 ,(char *) uc2_98A1 },
	{ 0x98A2 , 1 ,12 ,12 ,24 ,(char *) uc2_98A2 },
	{ 0x98A4 , 1 ,12 ,12 ,24 ,(char *) uc2_98A4 },
	{ 0x98A5 , 1 ,12 ,12 ,24 ,(char *) uc2_98A5 },
	{ 0x98A6 , 1 ,12 ,12 ,24 ,(char *) uc2_98A6 },
	{ 0x98A7 , 1 ,12 ,12 ,24 ,(char *) uc2_98A7 },
	{ 0x98CE , 1 ,12 ,12 ,24 ,(char *) uc2_98CE },
	{ 0x98D1 , 1 ,12 ,12 ,24 ,(char *) uc2_98D1 },
	{ 0x98D2 , 1 ,12 ,12 ,24 ,(char *) uc2_98D2 },
	{ 0x98D3 , 1 ,12 ,12 ,24 ,(char *) uc2_98D3 },
	{ 0x98D5 , 1 ,12 ,12 ,24 ,(char *) uc2_98D5 },
	{ 0x98D8 , 1 ,12 ,12 ,24 ,(char *) uc2_98D8 },
	{ 0x98D9 , 1 ,12 ,12 ,24 ,(char *) uc2_98D9 },
	{ 0x98DA , 1 ,12 ,12 ,24 ,(char *) uc2_98DA },
	{ 0x98DE , 1 ,12 ,12 ,24 ,(char *) uc2_98DE },
	{ 0x98DF , 1 ,12 ,12 ,24 ,(char *) uc2_98DF },
	{ 0x98E7 , 1 ,12 ,12 ,24 ,(char *) uc2_98E7 },
	{ 0x98E8 , 1 ,12 ,12 ,24 ,(char *) uc2_98E8 },
	{ 0x990D , 1 ,12 ,12 ,24 ,(char *) uc2_990D },
	{ 0x9910 , 1 ,12 ,12 ,24 ,(char *) uc2_9910 },
	{ 0x992E , 1 ,12 ,12 ,24 ,(char *) uc2_992E },
	{ 0x9954 , 1 ,12 ,12 ,24 ,(char *) uc2_9954 },
	{ 0x9955 , 1 ,12 ,12 ,24 ,(char *) uc2_9955 },
	{ 0x9965 , 1 ,12 ,12 ,24 ,(char *) uc2_9965 },
	{ 0x9967 , 1 ,12 ,12 ,24 ,(char *) uc2_9967 },
	{ 0x9968 , 1 ,12 ,12 ,24 ,(char *) uc2_9968 },
	{ 0x9969 , 1 ,12 ,12 ,24 ,(char *) uc2_9969 },
	{ 0x996A , 1 ,12 ,12 ,24 ,(char *) uc2_996A },
	{ 0x996B , 1 ,12 ,12 ,24 ,(char *) uc2_996B },
	{ 0x996C , 1 ,12 ,12 ,24 ,(char *) uc2_996C },
	{ 0x996D , 1 ,12 ,12 ,24 ,(char *) uc2_996D },
	{ 0x996E , 1 ,12 ,12 ,24 ,(char *) uc2_996E },
	{ 0x996F , 1 ,12 ,12 ,24 ,(char *) uc2_996F },
	{ 0x9970 , 1 ,12 ,12 ,24 ,(char *) uc2_9970 },
	{ 0x9971 , 1 ,12 ,12 ,24 ,(char *) uc2_9971 },
	{ 0x9972 , 1 ,12 ,12 ,24 ,(char *) uc2_9972 },
	{ 0x9974 , 1 ,12 ,12 ,24 ,(char *) uc2_9974 },
	{ 0x9975 , 1 ,12 ,12 ,24 ,(char *) uc2_9975 },
	{ 0x9976 , 1 ,12 ,12 ,24 ,(char *) uc2_9976 },
	{ 0x9977 , 1 ,12 ,12 ,24 ,(char *) uc2_9977 },
	{ 0x997A , 1 ,12 ,12 ,24 ,(char *) uc2_997A },
	{ 0x997C , 1 ,12 ,12 ,24 ,(char *) uc2_997C },
	{ 0x997D , 1 ,12 ,12 ,24 ,(char *) uc2_997D },
	{ 0x997F , 1 ,12 ,12 ,24 ,(char *) uc2_997F },
	{ 0x9980 , 1 ,12 ,12 ,24 ,(char *) uc2_9980 },
	{ 0x9981 , 1 ,12 ,12 ,24 ,(char *) uc2_9981 },
	{ 0x9984 , 1 ,12 ,12 ,24 ,(char *) uc2_9984 },
	{ 0x9985 , 1 ,12 ,12 ,24 ,(char *) uc2_9985 },
	{ 0x9986 , 1 ,12 ,12 ,24 ,(char *) uc2_9986 },
	{ 0x9987 , 1 ,12 ,12 ,24 ,(char *) uc2_9987 },
	{ 0x9988 , 1 ,12 ,12 ,24 ,(char *) uc2_9988 },
	{ 0x998A , 1 ,12 ,12 ,24 ,(char *) uc2_998A },
	{ 0x998B , 1 ,12 ,12 ,24 ,(char *) uc2_998B },
	{ 0x998D , 1 ,12 ,12 ,24 ,(char *) uc2_998D },
	{ 0x998F , 1 ,12 ,12 ,24 ,(char *) uc2_998F },
	{ 0x9990 , 1 ,12 ,12 ,24 ,(char *) uc2_9990 },
	{ 0x9991 , 1 ,12 ,12 ,24 ,(char *) uc2_9991 },
	{ 0x9992 , 1 ,12 ,12 ,24 ,(char *) uc2_9992 },
	{ 0x9993 , 1 ,12 ,12 ,24 ,(char *) uc2_9993 },
	{ 0x9994 , 1 ,12 ,12 ,24 ,(char *) uc2_9994 },
	{ 0x9995 , 1 ,12 ,12 ,24 ,(char *) uc2_9995 },
	{ 0x9996 , 1 ,12 ,12 ,24 ,(char *) uc2_9996 },
	{ 0x9997 , 1 ,12 ,12 ,24 ,(char *) uc2_9997 },
	{ 0x9998 , 1 ,12 ,12 ,24 ,(char *) uc2_9998 },
	{ 0x9999 , 1 ,12 ,12 ,24 ,(char *) uc2_9999 },
	{ 0x99A5 , 1 ,12 ,12 ,24 ,(char *) uc2_99A5 },
	{ 0x99A8 , 1 ,12 ,12 ,24 ,(char *) uc2_99A8 },
	{ 0x9A6C , 1 ,12 ,12 ,24 ,(char *) uc2_9A6C },
	{ 0x9A6D , 1 ,12 ,12 ,24 ,(char *) uc2_9A6D },
	{ 0x9A6E , 1 ,12 ,12 ,24 ,(char *) uc2_9A6E },
	{ 0x9A6F , 1 ,12 ,12 ,24 ,(char *) uc2_9A6F },
	{ 0x9A70 , 1 ,12 ,12 ,24 ,(char *) uc2_9A70 },
	{ 0x9A71 , 1 ,12 ,12 ,24 ,(char *) uc2_9A71 },
	{ 0x9A73 , 1 ,12 ,12 ,24 ,(char *) uc2_9A73 },
	{ 0x9A74 , 1 ,12 ,12 ,24 ,(char *) uc2_9A74 },
	{ 0x9A75 , 1 ,12 ,12 ,24 ,(char *) uc2_9A75 },
	{ 0x9A76 , 1 ,12 ,12 ,24 ,(char *) uc2_9A76 },
	{ 0x9A77 , 1 ,12 ,12 ,24 ,(char *) uc2_9A77 },
	{ 0x9A78 , 1 ,12 ,12 ,24 ,(char *) uc2_9A78 },
	{ 0x9A79 , 1 ,12 ,12 ,24 ,(char *) uc2_9A79 },
	{ 0x9A7A , 1 ,12 ,12 ,24 ,(char *) uc2_9A7A },
	{ 0x9A7B , 1 ,12 ,12 ,24 ,(char *) uc2_9A7B },
	{ 0x9A7C , 1 ,12 ,12 ,24 ,(char *) uc2_9A7C },
	{ 0x9A7D , 1 ,12 ,12 ,24 ,(char *) uc2_9A7D },
	{ 0x9A7E , 1 ,12 ,12 ,24 ,(char *) uc2_9A7E },
	{ 0x9A7F , 1 ,12 ,12 ,24 ,(char *) uc2_9A7F },
	{ 0x9A80 , 1 ,12 ,12 ,24 ,(char *) uc2_9A80 },
	{ 0x9A81 , 1 ,12 ,12 ,24 ,(char *) uc2_9A81 },
	{ 0x9A82 , 1 ,12 ,12 ,24 ,(char *) uc2_9A82 },
	{ 0x9A84 , 1 ,12 ,12 ,24 ,(char *) uc2_9A84 },
	{ 0x9A85 , 1 ,12 ,12 ,24 ,(char *) uc2_9A85 },
	{ 0x9A86 , 1 ,12 ,12 ,24 ,(char *) uc2_9A86 },
	{ 0x9A87 , 1 ,12 ,12 ,24 ,(char *) uc2_9A87 },
	{ 0x9A88 , 1 ,12 ,12 ,24 ,(char *) uc2_9A88 },
	{ 0x9A8A , 1 ,12 ,12 ,24 ,(char *) uc2_9A8A },
	{ 0x9A8B , 1 ,12 ,12 ,24 ,(char *) uc2_9A8B },
	{ 0x9A8C , 1 ,12 ,12 ,24 ,(char *) uc2_9A8C },
	{ 0x9A8F , 1 ,12 ,12 ,24 ,(char *) uc2_9A8F },
	{ 0x9A90 , 1 ,12 ,12 ,24 ,(char *) uc2_9A90 },
	{ 0x9A91 , 1 ,12 ,12 ,24 ,(char *) uc2_9A91 },
	{ 0x9A92 , 1 ,12 ,12 ,24 ,(char *) uc2_9A92 },
	{ 0x9A93 , 1 ,12 ,12 ,24 ,(char *) uc2_9A93 },
	{ 0x9A96 , 1 ,12 ,12 ,24 ,(char *) uc2_9A96 },
	{ 0x9A97 , 1 ,12 ,12 ,24 ,(char *) uc2_9A97 },
	{ 0x9A98 , 1 ,12 ,12 ,24 ,(char *) uc2_9A98 },
	{ 0x9A9A , 1 ,12 ,12 ,24 ,(char *) uc2_9A9A },
	{ 0x9A9B , 1 ,12 ,12 ,24 ,(char *) uc2_9A9B },
	{ 0x9A9C , 1 ,12 ,12 ,24 ,(char *) uc2_9A9C },
	{ 0x9A9D , 1 ,12 ,12 ,24 ,(char *) uc2_9A9D },
	{ 0x9A9E , 1 ,12 ,12 ,24 ,(char *) uc2_9A9E },
	{ 0x9A9F , 1 ,12 ,12 ,24 ,(char *) uc2_9A9F },
	{ 0x9AA0 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA0 },
	{ 0x9AA1 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA1 },
	{ 0x9AA2 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA2 },
	{ 0x9AA3 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA3 },
	{ 0x9AA4 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA4 },
	{ 0x9AA5 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA5 },
	{ 0x9AA7 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA7 },
	{ 0x9AA8 , 1 ,12 ,12 ,24 ,(char *) uc2_9AA8 },
	{ 0x9AB0 , 1 ,12 ,12 ,24 ,(char *) uc2_9AB0 },
	{ 0x9AB1 , 1 ,12 ,12 ,24 ,(char *) uc2_9AB1 },
	{ 0x9AB6 , 1 ,12 ,12 ,24 ,(char *) uc2_9AB6 },
	{ 0x9AB7 , 1 ,12 ,12 ,24 ,(char *) uc2_9AB7 },
	{ 0x9AB8 , 1 ,12 ,12 ,24 ,(char *) uc2_9AB8 },
	{ 0x9ABA , 1 ,12 ,12 ,24 ,(char *) uc2_9ABA },
	{ 0x9ABC , 1 ,12 ,12 ,24 ,(char *) uc2_9ABC },
	{ 0x9AC0 , 1 ,12 ,12 ,24 ,(char *) uc2_9AC0 },
	{ 0x9AC1 , 1 ,12 ,12 ,24 ,(char *) uc2_9AC1 },
	{ 0x9AC2 , 1 ,12 ,12 ,24 ,(char *) uc2_9AC2 },
	{ 0x9AC5 , 1 ,12 ,12 ,24 ,(char *) uc2_9AC5 },
	{ 0x9ACB , 1 ,12 ,12 ,24 ,(char *) uc2_9ACB },
	{ 0x9ACC , 1 ,12 ,12 ,24 ,(char *) uc2_9ACC },
	{ 0x9AD1 , 1 ,12 ,12 ,24 ,(char *) uc2_9AD1 },
	{ 0x9AD3 , 1 ,12 ,12 ,24 ,(char *) uc2_9AD3 },
	{ 0x9AD8 , 1 ,12 ,12 ,24 ,(char *) uc2_9AD8 },
	{ 0x9ADF , 1 ,12 ,12 ,24 ,(char *) uc2_9ADF },
	{ 0x9AE1 , 1 ,12 ,12 ,24 ,(char *) uc2_9AE1 },
	{ 0x9AE6 , 1 ,12 ,12 ,24 ,(char *) uc2_9AE6 },
	{ 0x9AEB , 1 ,12 ,12 ,24 ,(char *) uc2_9AEB },
	{ 0x9AED , 1 ,12 ,12 ,24 ,(char *) uc2_9AED },
	{ 0x9AEF , 1 ,12 ,12 ,24 ,(char *) uc2_9AEF },
	{ 0x9AF9 , 1 ,12 ,12 ,24 ,(char *) uc2_9AF9 },
	{ 0x9AFB , 1 ,12 ,12 ,24 ,(char *) uc2_9AFB },
	{ 0x9B03 , 1 ,12 ,12 ,24 ,(char *) uc2_9B03 },
	{ 0x9B08 , 1 ,12 ,12 ,24 ,(char *) uc2_9B08 },
	{ 0x9B0F , 1 ,12 ,12 ,24 ,(char *) uc2_9B0F },
	{ 0x9B13 , 1 ,12 ,12 ,24 ,(char *) uc2_9B13 },
	{ 0x9B1F , 1 ,12 ,12 ,24 ,(char *) uc2_9B1F },
	{ 0x9B23 , 1 ,12 ,12 ,24 ,(char *) uc2_9B23 },
	{ 0x9B2F , 1 ,12 ,12 ,24 ,(char *) uc2_9B2F },
	{ 0x9B32 , 1 ,12 ,12 ,24 ,(char *) uc2_9B32 },
	{ 0x9B3B , 1 ,12 ,12 ,24 ,(char *) uc2_9B3B },
	{ 0x9B3C , 1 ,12 ,12 ,24 ,(char *) uc2_9B3C },
	{ 0x9B41 , 1 ,12 ,12 ,24 ,(char *) uc2_9B41 },
	{ 0x9B42 , 1 ,12 ,12 ,24 ,(char *) uc2_9B42 },
	{ 0x9B43 , 1 ,12 ,12 ,24 ,(char *) uc2_9B43 },
	{ 0x9B44 , 1 ,12 ,12 ,24 ,(char *) uc2_9B44 },
	{ 0x9B45 , 1 ,12 ,12 ,24 ,(char *) uc2_9B45 },
	{ 0x9B47 , 1 ,12 ,12 ,24 ,(char *) uc2_9B47 },
	{ 0x9B48 , 1 ,12 ,12 ,24 ,(char *) uc2_9B48 },
	{ 0x9B49 , 1 ,12 ,12 ,24 ,(char *) uc2_9B49 },
	{ 0x9B4D , 1 ,12 ,12 ,24 ,(char *) uc2_9B4D },
	{ 0x9B4F , 1 ,12 ,12 ,24 ,(char *) uc2_9B4F },
	{ 0x9B51 , 1 ,12 ,12 ,24 ,(char *) uc2_9B51 },
	{ 0x9B54 , 1 ,12 ,12 ,24 ,(char *) uc2_9B54 },
	{ 0x9C7C , 1 ,12 ,12 ,24 ,(char *) uc2_9C7C },
	{ 0x9C7F , 1 ,12 ,12 ,24 ,(char *) uc2_9C7F },
	{ 0x9C81 , 1 ,12 ,12 ,24 ,(char *) uc2_9C81 },
	{ 0x9C82 , 1 ,12 ,12 ,24 ,(char *) uc2_9C82 },
	{ 0x9C85 , 1 ,12 ,12 ,24 ,(char *) uc2_9C85 },
	{ 0x9C86 , 1 ,12 ,12 ,24 ,(char *) uc2_9C86 },
	{ 0x9C87 , 1 ,12 ,12 ,24 ,(char *) uc2_9C87 },
	{ 0x9C88 , 1 ,12 ,12 ,24 ,(char *) uc2_9C88 },
	{ 0x9C8B , 1 ,12 ,12 ,24 ,(char *) uc2_9C8B },
	{ 0x9C8D , 1 ,12 ,12 ,24 ,(char *) uc2_9C8D },
	{ 0x9C8E , 1 ,12 ,12 ,24 ,(char *) uc2_9C8E },
	{ 0x9C90 , 1 ,12 ,12 ,24 ,(char *) uc2_9C90 },
	{ 0x9C91 , 1 ,12 ,12 ,24 ,(char *) uc2_9C91 },
	{ 0x9C92 , 1 ,12 ,12 ,24 ,(char *) uc2_9C92 },
	{ 0x9C94 , 1 ,12 ,12 ,24 ,(char *) uc2_9C94 },
	{ 0x9C95 , 1 ,12 ,12 ,24 ,(char *) uc2_9C95 },
	{ 0x9C9A , 1 ,12 ,12 ,24 ,(char *) uc2_9C9A },
	{ 0x9C9B , 1 ,12 ,12 ,24 ,(char *) uc2_9C9B },
	{ 0x9C9C , 1 ,12 ,12 ,24 ,(char *) uc2_9C9C },
	{ 0x9C9E , 1 ,12 ,12 ,24 ,(char *) uc2_9C9E },
	{ 0x9C9F , 1 ,12 ,12 ,24 ,(char *) uc2_9C9F },
	{ 0x9CA0 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA0 },
	{ 0x9CA1 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA1 },
	{ 0x9CA2 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA2 },
	{ 0x9CA3 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA3 },
	{ 0x9CA4 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA4 },
	{ 0x9CA5 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA5 },
	{ 0x9CA6 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA6 },
	{ 0x9CA7 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA7 },
	{ 0x9CA8 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA8 },
	{ 0x9CA9 , 1 ,12 ,12 ,24 ,(char *) uc2_9CA9 },
	{ 0x9CAB , 1 ,12 ,12 ,24 ,(char *) uc2_9CAB },
	{ 0x9CAC , 1 ,12 ,12 ,24 ,(char *) uc2_9CAC },
	{ 0x9CAD , 1 ,12 ,12 ,24 ,(char *) uc2_9CAD },
	{ 0x9CAE , 1 ,12 ,12 ,24 ,(char *) uc2_9CAE },
	{ 0x9CB0 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB0 },
	{ 0x9CB1 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB1 },
	{ 0x9CB2 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB2 },
	{ 0x9CB3 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB3 },
	{ 0x9CB4 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB4 },
	{ 0x9CB5 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB5 },
	{ 0x9CB6 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB6 },
	{ 0x9CB7 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB7 },
	{ 0x9CB8 , 1 ,12 ,12 ,24 ,(char *) uc2_9CB8 },
	{ 0x9CBA , 1 ,12 ,12 ,24 ,(char *) uc2_9CBA },
	{ 0x9CBB , 1 ,12 ,12 ,24 ,(char *) uc2_9CBB },
	{ 0x9CBC , 1 ,12 ,12 ,24 ,(char *) uc2_9CBC },
	{ 0x9CBD , 1 ,12 ,12 ,24 ,(char *) uc2_9CBD },
	{ 0x9CC3 , 1 ,12 ,12 ,24 ,(char *) uc2_9CC3 },
	{ 0x9CC4 , 1 ,12 ,12 ,24 ,(char *) uc2_9CC4 },
	{ 0x9CC5 , 1 ,12 ,12 ,24 ,(char *) uc2_9CC5 },
	{ 0x9CC6 , 1 ,12 ,12 ,24 ,(char *) uc2_9CC6 },
	{ 0x9CC7 , 1 ,12 ,12 ,24 ,(char *) uc2_9CC7 },
	{ 0x9CCA , 1 ,12 ,12 ,24 ,(char *) uc2_9CCA },
	{ 0x9CCB , 1 ,12 ,12 ,24 ,(char *) uc2_9CCB },
	{ 0x9CCC , 1 ,12 ,12 ,24 ,(char *) uc2_9CCC },
	{ 0x9CCD , 1 ,12 ,12 ,24 ,(char *) uc2_9CCD },
	{ 0x9CCE , 1 ,12 ,12 ,24 ,(char *) uc2_9CCE },
	{ 0x9CCF , 1 ,12 ,12 ,24 ,(char *) uc2_9CCF },
	{ 0x9CD0 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD0 },
	{ 0x9CD3 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD3 },
	{ 0x9CD4 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD4 },
	{ 0x9CD5 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD5 },
	{ 0x9CD6 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD6 },
	{ 0x9CD7 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD7 },
	{ 0x9CD8 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD8 },
	{ 0x9CD9 , 1 ,12 ,12 ,24 ,(char *) uc2_9CD9 },
	{ 0x9CDC , 1 ,12 ,12 ,24 ,(char *) uc2_9CDC },
	{ 0x9CDD , 1 ,12 ,12 ,24 ,(char *) uc2_9CDD },
	{ 0x9CDE , 1 ,12 ,12 ,24 ,(char *) uc2_9CDE },
	{ 0x9CDF , 1 ,12 ,12 ,24 ,(char *) uc2_9CDF },
	{ 0x9CE2 , 1 ,12 ,12 ,24 ,(char *) uc2_9CE2 },
	{ 0x9E1F , 1 ,12 ,12 ,24 ,(char *) uc2_9E1F },
	{ 0x9E20 , 1 ,12 ,12 ,24 ,(char *) uc2_9E20 },
	{ 0x9E21 , 1 ,12 ,12 ,24 ,(char *) uc2_9E21 },
	{ 0x9E22 , 1 ,12 ,12 ,24 ,(char *) uc2_9E22 },
	{ 0x9E23 , 1 ,12 ,12 ,24 ,(char *) uc2_9E23 },
	{ 0x9E25 , 1 ,12 ,12 ,24 ,(char *) uc2_9E25 },
	{ 0x9E26 , 1 ,12 ,12 ,24 ,(char *) uc2_9E26 },
	{ 0x9E28 , 1 ,12 ,12 ,24 ,(char *) uc2_9E28 },
	{ 0x9E29 , 1 ,12 ,12 ,24 ,(char *) uc2_9E29 },
	{ 0x9E2A , 1 ,12 ,12 ,24 ,(char *) uc2_9E2A },
	{ 0x9E2B , 1 ,12 ,12 ,24 ,(char *) uc2_9E2B },
	{ 0x9E2C , 1 ,12 ,12 ,24 ,(char *) uc2_9E2C },
	{ 0x9E2D , 1 ,12 ,12 ,24 ,(char *) uc2_9E2D },
	{ 0x9E2F , 1 ,12 ,12 ,24 ,(char *) uc2_9E2F },
	{ 0x9E31 , 1 ,12 ,12 ,24 ,(char *) uc2_9E31 },
	{ 0x9E32 , 1 ,12 ,12 ,24 ,(char *) uc2_9E32 },
	{ 0x9E33 , 1 ,12 ,12 ,24 ,(char *) uc2_9E33 },
	{ 0x9E35 , 1 ,12 ,12 ,24 ,(char *) uc2_9E35 },
	{ 0x9E36 , 1 ,12 ,12 ,24 ,(char *) uc2_9E36 },
	{ 0x9E37 , 1 ,12 ,12 ,24 ,(char *) uc2_9E37 },
	{ 0x9E38 , 1 ,12 ,12 ,24 ,(char *) uc2_9E38 },
	{ 0x9E39 , 1 ,12 ,12 ,24 ,(char *) uc2_9E39 },
	{ 0x9E3A , 1 ,12 ,12 ,24 ,(char *) uc2_9E3A },
	{ 0x9E3D , 1 ,12 ,12 ,24 ,(char *) uc2_9E3D },
	{ 0x9E3E , 1 ,12 ,12 ,24 ,(char *) uc2_9E3E },
	{ 0x9E3F , 1 ,12 ,12 ,24 ,(char *) uc2_9E3F },
	{ 0x9E41 , 1 ,12 ,12 ,24 ,(char *) uc2_9E41 },
	{ 0x9E42 , 1 ,12 ,12 ,24 ,(char *) uc2_9E42 },
	{ 0x9E43 , 1 ,12 ,12 ,24 ,(char *) uc2_9E43 },
	{ 0x9E44 , 1 ,12 ,12 ,24 ,(char *) uc2_9E44 },
	{ 0x9E45 , 1 ,12 ,12 ,24 ,(char *) uc2_9E45 },
	{ 0x9E46 , 1 ,12 ,12 ,24 ,(char *) uc2_9E46 },
	{ 0x9E47 , 1 ,12 ,12 ,24 ,(char *) uc2_9E47 },
	{ 0x9E48 , 1 ,12 ,12 ,24 ,(char *) uc2_9E48 },
	{ 0x9E49 , 1 ,12 ,12 ,24 ,(char *) uc2_9E49 },
	{ 0x9E4A , 1 ,12 ,12 ,24 ,(char *) uc2_9E4A },
	{ 0x9E4B , 1 ,12 ,12 ,24 ,(char *) uc2_9E4B },
	{ 0x9E4C , 1 ,12 ,12 ,24 ,(char *) uc2_9E4C },
	{ 0x9E4E , 1 ,12 ,12 ,24 ,(char *) uc2_9E4E },
	{ 0x9E4F , 1 ,12 ,12 ,24 ,(char *) uc2_9E4F },
	{ 0x9E51 , 1 ,12 ,12 ,24 ,(char *) uc2_9E51 },
	{ 0x9E55 , 1 ,12 ,12 ,24 ,(char *) uc2_9E55 },
	{ 0x9E57 , 1 ,12 ,12 ,24 ,(char *) uc2_9E57 },
	{ 0x9E58 , 1 ,12 ,12 ,24 ,(char *) uc2_9E58 },
	{ 0x9E5A , 1 ,12 ,12 ,24 ,(char *) uc2_9E5A },
	{ 0x9E5B , 1 ,12 ,12 ,24 ,(char *) uc2_9E5B },
	{ 0x9E5C , 1 ,12 ,12 ,24 ,(char *) uc2_9E5C },
	{ 0x9E5E , 1 ,12 ,12 ,24 ,(char *) uc2_9E5E },
	{ 0x9E63 , 1 ,12 ,12 ,24 ,(char *) uc2_9E63 },
	{ 0x9E64 , 1 ,12 ,12 ,24 ,(char *) uc2_9E64 },
	{ 0x9E66 , 1 ,12 ,12 ,24 ,(char *) uc2_9E66 },
	{ 0x9E67 , 1 ,12 ,12 ,24 ,(char *) uc2_9E67 },
	{ 0x9E68 , 1 ,12 ,12 ,24 ,(char *) uc2_9E68 },
	{ 0x9E69 , 1 ,12 ,12 ,24 ,(char *) uc2_9E69 },
	{ 0x9E6A , 1 ,12 ,12 ,24 ,(char *) uc2_9E6A },
	{ 0x9E6B , 1 ,12 ,12 ,24 ,(char *) uc2_9E6B },
	{ 0x9E6C , 1 ,12 ,12 ,24 ,(char *) uc2_9E6C },
	{ 0x9E6D , 1 ,12 ,12 ,24 ,(char *) uc2_9E6D },
	{ 0x9E70 , 1 ,12 ,12 ,24 ,(char *) uc2_9E70 },
	{ 0x9E71 , 1 ,12 ,12 ,24 ,(char *) uc2_9E71 },
	{ 0x9E73 , 1 ,12 ,12 ,24 ,(char *) uc2_9E73 },
	{ 0x9E7E , 1 ,12 ,12 ,24 ,(char *) uc2_9E7E },
	{ 0x9E7F , 1 ,12 ,12 ,24 ,(char *) uc2_9E7F },
	{ 0x9E82 , 1 ,12 ,12 ,24 ,(char *) uc2_9E82 },
	{ 0x9E87 , 1 ,12 ,12 ,24 ,(char *) uc2_9E87 },
	{ 0x9E88 , 1 ,12 ,12 ,24 ,(char *) uc2_9E88 },
	{ 0x9E8B , 1 ,12 ,12 ,24 ,(char *) uc2_9E8B },
	{ 0x9E92 , 1 ,12 ,12 ,24 ,(char *) uc2_9E92 },
	{ 0x9E93 , 1 ,12 ,12 ,24 ,(char *) uc2_9E93 },
	{ 0x9E9D , 1 ,12 ,12 ,24 ,(char *) uc2_9E9D },
	{ 0x9E9F , 1 ,12 ,12 ,24 ,(char *) uc2_9E9F },
	{ 0x9EA6 , 1 ,12 ,12 ,24 ,(char *) uc2_9EA6 },
	{ 0x9EB4 , 1 ,12 ,12 ,24 ,(char *) uc2_9EB4 },
	{ 0x9EB8 , 1 ,12 ,12 ,24 ,(char *) uc2_9EB8 },
	{ 0x9EBB , 1 ,12 ,12 ,24 ,(char *) uc2_9EBB },
	{ 0x9EBD , 1 ,12 ,12 ,24 ,(char *) uc2_9EBD },
	{ 0x9EBE , 1 ,12 ,12 ,24 ,(char *) uc2_9EBE },
	{ 0x9EC4 , 1 ,12 ,12 ,24 ,(char *) uc2_9EC4 },
	{ 0x9EC9 , 1 ,12 ,12 ,24 ,(char *) uc2_9EC9 },
	{ 0x9ECD , 1 ,12 ,12 ,24 ,(char *) uc2_9ECD },
	{ 0x9ECE , 1 ,12 ,12 ,24 ,(char *) uc2_9ECE },
	{ 0x9ECF , 1 ,12 ,12 ,24 ,(char *) uc2_9ECF },
	{ 0x9ED1 , 1 ,12 ,12 ,24 ,(char *) uc2_9ED1 },
	{ 0x9ED4 , 1 ,12 ,12 ,24 ,(char *) uc2_9ED4 },
	{ 0x9ED8 , 1 ,12 ,12 ,24 ,(char *) uc2_9ED8 },
	{ 0x9EDB , 1 ,12 ,12 ,24 ,(char *) uc2_9EDB },
	{ 0x9EDC , 1 ,12 ,12 ,24 ,(char *) uc2_9EDC },
	{ 0x9EDD , 1 ,12 ,12 ,24 ,(char *) uc2_9EDD },
	{ 0x9EDF , 1 ,12 ,12 ,24 ,(char *) uc2_9EDF },
	{ 0x9EE0 , 1 ,12 ,12 ,24 ,(char *) uc2_9EE0 },
	{ 0x9EE2 , 1 ,12 ,12 ,24 ,(char *) uc2_9EE2 },
	{ 0x9EE5 , 1 ,12 ,12 ,24 ,(char *) uc2_9EE5 },
	{ 0x9EE7 , 1 ,12 ,12 ,24 ,(char *) uc2_9EE7 },
	{ 0x9EE9 , 1 ,12 ,12 ,24 ,(char *) uc2_9EE9 },
	{ 0x9EEA , 1 ,12 ,12 ,24 ,(char *) uc2_9EEA },
	{ 0x9EEF , 1 ,12 ,12 ,24 ,(char *) uc2_9EEF },
	{ 0x9EF9 , 1 ,12 ,12 ,24 ,(char *) uc2_9EF9 },
	{ 0x9EFB , 1 ,12 ,12 ,24 ,(char *) uc2_9EFB },
	{ 0x9EFC , 1 ,12 ,12 ,24 ,(char *) uc2_9EFC },
	{ 0x9EFE , 1 ,12 ,12 ,24 ,(char *) uc2_9EFE },
	{ 0x9F0B , 1 ,12 ,12 ,24 ,(char *) uc2_9F0B },
	{ 0x9F0D , 1 ,12 ,12 ,24 ,(char *) uc2_9F0D },
	{ 0x9F0E , 1 ,12 ,12 ,24 ,(char *) uc2_9F0E },
	{ 0x9F10 , 1 ,12 ,12 ,24 ,(char *) uc2_9F10 },
	{ 0x9F13 , 1 ,12 ,12 ,24 ,(char *) uc2_9F13 },
	{ 0x9F17 , 1 ,12 ,12 ,24 ,(char *) uc2_9F17 },
	{ 0x9F19 , 1 ,12 ,12 ,24 ,(char *) uc2_9F19 },
	{ 0x9F20 , 1 ,12 ,12 ,24 ,(char *) uc2_9F20 },
	{ 0x9F22 , 1 ,12 ,12 ,24 ,(char *) uc2_9F22 },
	{ 0x9F2C , 1 ,12 ,12 ,24 ,(char *) uc2_9F2C },
	{ 0x9F2F , 1 ,12 ,12 ,24 ,(char *) uc2_9F2F },
	{ 0x9F37 , 1 ,12 ,12 ,24 ,(char *) uc2_9F37 },
	{ 0x9F39 , 1 ,12 ,12 ,24 ,(char *) uc2_9F39 },
	{ 0x9F3B , 1 ,12 ,12 ,24 ,(char *) uc2_9F3B },
	{ 0x9F3D , 1 ,12 ,12 ,24 ,(char *) uc2_9F3D },
	{ 0x9F3E , 1 ,12 ,12 ,24 ,(char *) uc2_9F3E },
	{ 0x9F44 , 1 ,12 ,12 ,24 ,(char *) uc2_9F44 },
	{ 0x9F50 , 1 ,12 ,12 ,24 ,(char *) uc2_9F50 },
	{ 0x9F51 , 1 ,12 ,12 ,24 ,(char *) uc2_9F51 },
	{ 0x9F7F , 1 ,12 ,12 ,24 ,(char *) uc2_9F7F },
	{ 0x9F80 , 1 ,12 ,12 ,24 ,(char *) uc2_9F80 },
	{ 0x9F83 , 1 ,12 ,12 ,24 ,(char *) uc2_9F83 },
	{ 0x9F84 , 1 ,12 ,12 ,24 ,(char *) uc2_9F84 },
	{ 0x9F85 , 1 ,12 ,12 ,24 ,(char *) uc2_9F85 },
	{ 0x9F86 , 1 ,12 ,12 ,24 ,(char *) uc2_9F86 },
	{ 0x9F87 , 1 ,12 ,12 ,24 ,(char *) uc2_9F87 },
	{ 0x9F88 , 1 ,12 ,12 ,24 ,(char *) uc2_9F88 },
	{ 0x9F89 , 1 ,12 ,12 ,24 ,(char *) uc2_9F89 },
	{ 0x9F8A , 1 ,12 ,12 ,24 ,(char *) uc2_9F8A },
	{ 0x9F8B , 1 ,12 ,12 ,24 ,(char *) uc2_9F8B },
	{ 0x9F8C , 1 ,12 ,12 ,24 ,(char *) uc2_9F8C },
	{ 0x9F99 , 1 ,12 ,12 ,24 ,(char *) uc2_9F99 },
	{ 0x9F9A , 1 ,12 ,12 ,24 ,(char *) uc2_9F9A },
	{ 0x9F9B , 1 ,12 ,12 ,24 ,(char *) uc2_9F9B },
	{ 0x9F9F , 1 ,12 ,12 ,24 ,(char *) uc2_9F9F },
	{ 0x9FA0 , 1 ,12 ,12 ,24 ,(char *) uc2_9FA0 },
	{ 0xBEE1 , 1 ,12 ,12 ,24 ,(char *) uc2_BEE1 },
	{ 0xCF5C , 1 ,12 ,12 ,24 ,(char *) uc2_CF5C },
	{ 0xCF5D , 1 ,12 ,12 ,24 ,(char *) uc2_CF5D },
	{ 0xCF5E , 1 ,12 ,12 ,24 ,(char *) uc2_CF5E },
	{0xF000, 1, 12, 12, 24, (char *) uc2_F000}, 
	{0xF001, 1, 12, 12, 24, (char *) uc2_F001}, 
	{0xF002, 1, 12, 12, 24, (char *) uc2_F002}, 
	{0xF003, 1, 12, 12, 24, (char *) uc2_F003}, 
	{0xF004, 1, 12, 12, 24, (char *) uc2_F004}, 
	{0xF005, 1, 12, 12, 24, (char *) uc2_F005}, 
	{0xF006, 1, 12, 12, 24, (char *) uc2_F006}, 
	{0xF007, 1, 12, 12, 24, (char *) uc2_F007}, 
	{0xF008, 1, 12, 12, 24, (char *) uc2_F008}, 
	{0xF009, 1, 12, 12, 24, (char *) uc2_F009}, 
	{0xF011, 1, 12, 12, 24, (char *) uc2_F011}, 
	{0xF013, 1, 12, 12, 24, (char *) uc2_F013}, 
	{0xF016, 1, 12, 12, 24, (char *) uc2_F016}, 
	{0xF019, 1, 12, 12, 24, (char *) uc2_F019}, 
	{0xF01E, 1, 12, 12, 24, (char *) uc2_F01E}, 
	{0xF021, 1, 12, 12, 24, (char *) uc2_F021}, 
	{0xF022, 1, 12, 12, 24, (char *) uc2_F022}, 
	{0xF023, 1, 12, 12, 24, (char *) uc2_F023}, 
	{0xF024, 1, 12, 12, 24, (char *) uc2_F024}, 
	{0xF025, 1, 12, 12, 24, (char *) uc2_F025}, 
	{0xF026, 1, 12, 12, 24, (char *) uc2_F026}, 
	{0xF027, 1, 12, 12, 24, (char *) uc2_F027}, 
	{0xF028, 1, 12, 12, 24, (char *) uc2_F028}, 
	{0xF02A, 1, 12, 12, 24, (char *) uc2_F02A}, 
	{0xF02C, 1, 12, 12, 24, (char *) uc2_F02C}, 
	{0xF02E, 1, 12, 12, 24, (char *) uc2_F02E}, 
	{0xF032, 1, 12, 12, 24, (char *) uc2_F032}, 
	{0xF033, 1, 12, 12, 24, (char *) uc2_F033}, 
	{0xF034, 1, 12, 12, 24, (char *) uc2_F034}, 
	{0xF035, 1, 12, 12, 24, (char *) uc2_F035}, 
	{0xF036, 1, 12, 12, 24, (char *) uc2_F036}, 
	{0xF03C, 1, 12, 12, 24, (char *) uc2_F03C}, 
	{0xF03D, 1, 12, 12, 24, (char *) uc2_F03D}, 
	{0xF03E, 1, 12, 12, 24, (char *) uc2_F03E}, 
	{0xF03F, 1, 12, 12, 24, (char *) uc2_F03F}, 
	{0xF042, 1, 12, 12, 24, (char *) uc2_F042}, 
	{0xF043, 1, 12, 12, 24, (char *) uc2_F043}, 
	{0xF044, 1, 12, 12, 24, (char *) uc2_F044}, 
	{0xF045, 1, 12, 12, 24, (char *) uc2_F045}, 
	{0xF046, 1, 12, 12, 24, (char *) uc2_F046}, 
	{0xF04B, 1, 12, 12, 24, (char *) uc2_F04B}, 
	{0xF050, 1, 12, 12, 24, (char *) uc2_F050}, 
	{0xF054, 1, 12, 12, 24, (char *) uc2_F054}, 
	{0xF055, 1, 12, 12, 24, (char *) uc2_F055}, 
	{0xF056, 1, 12, 12, 24, (char *) uc2_F056}, 
	{0xF05A, 1, 12, 12, 24, (char *) uc2_F05A}, 
	{0xF05D, 1, 12, 12, 24, (char *) uc2_F05D}, 
	{0xF05F, 1, 12, 12, 24, (char *) uc2_F05F}, 
	{0xF060, 1, 12, 12, 24, (char *) uc2_F060}, 
	{0xF062, 1, 12, 12, 24, (char *) uc2_F062}, 
	{0xF067, 1, 12, 12, 24, (char *) uc2_F067}, 
	{0xF069, 1, 12, 12, 24, (char *) uc2_F069}, 
	{0xF06A, 1, 12, 12, 24, (char *) uc2_F06A}, 
	{0xF06B, 1, 12, 12, 24, (char *) uc2_F06B}, 
	{0xF06D, 1, 12, 12, 24, (char *) uc2_F06D}, 
	{0xF06F, 1, 12, 12, 24, (char *) uc2_F06F}, 
	{0xF070, 1, 12, 12, 24, (char *) uc2_F070}, 
	{0xF071, 1, 12, 12, 24, (char *) uc2_F071}, 
	{0xF072, 1, 12, 12, 24, (char *) uc2_F072}, 
	{0xF074, 1, 12, 12, 24, (char *) uc2_F074}, 
	{0xF077, 1, 12, 12, 24, (char *) uc2_F077}, 
	{0xF078, 1, 12, 12, 24, (char *) uc2_F078}, 
	{0xF07A, 1, 12, 12, 24, (char *) uc2_F07A}, 
	{0xF07B, 1, 12, 12, 24, (char *) uc2_F07B}, 
	{0xF07C, 1, 12, 12, 24, (char *) uc2_F07C}, 
	{0xF07D, 1, 12, 12, 24, (char *) uc2_F07D}, 
	{0xF07E, 1, 12, 12, 24, (char *) uc2_F07E}, 
	{0xF07F, 1, 12, 12, 24, (char *) uc2_F07F}, 
	{0xF080, 1, 12, 12, 24, (char *) uc2_F080}, 
	{0xF081, 1, 12, 12, 24, (char *) uc2_F081}, 
	{0xF082, 1, 12, 12, 24, (char *) uc2_F082}, 
	{0xF083, 1, 12, 12, 24, (char *) uc2_F083}, 
	{0xF084, 1, 12, 12, 24, (char *) uc2_F084}, 
	{0xF089, 1, 12, 12, 24, (char *) uc2_F089}, 
	{0xF08E, 1, 12, 12, 24, (char *) uc2_F08E}, 
	{0xF08F, 1, 12, 12, 24, (char *) uc2_F08F}, 
	{0xF090, 1, 12, 12, 24, (char *) uc2_F090}, 
	{0xF091, 1, 12, 12, 24, (char *) uc2_F091}, 
	{0xF092, 1, 12, 12, 24, (char *) uc2_F092}, 
	{0xF094, 1, 12, 12, 24, (char *) uc2_F094}, 
	{0xF095, 1, 12, 12, 24, (char *) uc2_F095}, 
	{0xF098, 1, 12, 12, 24, (char *) uc2_F098}, 
	{0xF0A3, 1, 12, 12, 24, (char *) uc2_F0A3}, 
	{0xF0A5, 1, 12, 12, 24, (char *) uc2_F0A5}, 
	{0xF0A7, 1, 12, 12, 24, (char *) uc2_F0A7}, 
	{0xF0A8, 1, 12, 12, 24, (char *) uc2_F0A8}, 
	{0xF0AA, 1, 12, 12, 24, (char *) uc2_F0AA}, 
	{0xF0AD, 1, 12, 12, 24, (char *) uc2_F0AD}, 
	{0xF0AE, 1, 12, 12, 24, (char *) uc2_F0AE}, 
	{0xF0B4, 1, 12, 12, 24, (char *) uc2_F0B4}, 
	{0xF0B5, 1, 12, 12, 24, (char *) uc2_F0B5}, 
//	{0xF0b5, 1, 12, 12, 24, (char *) uc2_F0b5}, 
	{0xF0B9, 1, 12, 12, 24, (char *) uc2_F0B9}, 
	{0xF0BB, 1, 12, 12, 24, (char *) uc2_F0BB}, 
	{0xF0BD, 1, 12, 12, 24, (char *) uc2_F0BD}, 
	{0xF0BF, 1, 12, 12, 24, (char *) uc2_F0BF}, 
	{0xF0C0, 1, 12, 12, 24, (char *) uc2_F0C0}, 
	{0xF0C6, 1, 12, 12, 24, (char *) uc2_F0C6}, 
	{0xF0C7, 1, 12, 12, 24, (char *) uc2_F0C7}, 
	{0xF0C8, 1, 12, 12, 24, (char *) uc2_F0C8}, 
	{0xF0CA, 1, 12, 12, 24, (char *) uc2_F0CA}, 
	{0xF0CD, 1, 12, 12, 24, (char *) uc2_F0CD}, 
	{0xF0D7, 1, 12, 12, 24, (char *) uc2_F0D7}, 
	{0xF0D9, 1, 12, 12, 24, (char *) uc2_F0D9}, 
	{0xF0DE, 1, 12, 12, 24, (char *) uc2_F0DE}, 
	{0xF0DF, 1, 12, 12, 24, (char *) uc2_F0DF}, 
	{0xF0E3, 1, 12, 12, 24, (char *) uc2_F0E3}, 
	{0xF0E5, 1, 12, 12, 24, (char *) uc2_F0E5}, 
	{0xF0E7, 1, 12, 12, 24, (char *) uc2_F0E7}, 
	{0xF0E8, 1, 12, 12, 24, (char *) uc2_F0E8}, 
	{0xF0ED, 1, 12, 12, 24, (char *) uc2_F0ED}, 
	{0xF0F7, 1, 12, 12, 24, (char *) uc2_F0F7}, 
	{0xF0FB, 1, 12, 12, 24, (char *) uc2_F0FB}, 
	{0xF0FE, 1, 12, 12, 24, (char *) uc2_F0FE}, 
	{0xF0FF, 1, 12, 12, 24, (char *) uc2_F0FF}, 
	{0xF100, 1, 12, 12, 24, (char *) uc2_F100}, 
	{0xF101, 1, 12, 12, 24, (char *) uc2_F101}, 
	{0xF105, 1, 12, 12, 24, (char *) uc2_F105}, 
	{0xF108, 1, 12, 12, 24, (char *) uc2_F108}, 
	{0xF10A, 1, 12, 12, 24, (char *) uc2_F10A}, 
	{0xF10C, 1, 12, 12, 24, (char *) uc2_F10C}, 
	{0xF112, 1, 12, 12, 24, (char *) uc2_F112}, 
	{0xF115, 1, 12, 12, 24, (char *) uc2_F115}, 
	{0xF11A, 1, 12, 12, 24, (char *) uc2_F11A}, 
	{0xF11B, 1, 12, 12, 24, (char *) uc2_F11B}, 
	{0xF11C, 1, 12, 12, 24, (char *) uc2_F11C}, 
	{0xF120, 1, 12, 12, 24, (char *) uc2_F120}, 
	{0xF122, 1, 12, 12, 24, (char *) uc2_F122}, 
	{0xF125, 1, 12, 12, 24, (char *) uc2_F125}, 
	{0xF127, 1, 12, 12, 24, (char *) uc2_F127}, 
	{0xF128, 1, 12, 12, 24, (char *) uc2_F128}, 
	{0xF12A, 1, 12, 12, 24, (char *) uc2_F12A}, 
	{0xF12B, 1, 12, 12, 24, (char *) uc2_F12B}, 
	{0xF12C, 1, 12, 12, 24, (char *) uc2_F12C}, 
	{0xF12F, 1, 12, 12, 24, (char *) uc2_F12F}, 
	{0xF138, 1, 12, 12, 24, (char *) uc2_F138}, 
	{0xF139, 1, 12, 12, 24, (char *) uc2_F139}, 
	{0xF13A, 1, 12, 12, 24, (char *) uc2_F13A}, 
	{0xF140, 1, 12, 12, 24, (char *) uc2_F140}, 
	{0xF147, 1, 12, 12, 24, (char *) uc2_F147}, 
	{0xF148, 1, 12, 12, 24, (char *) uc2_F148}, 
	{0xF149, 1, 12, 12, 24, (char *) uc2_F149}, 
	{0xF14A, 1, 12, 12, 24, (char *) uc2_F14A}, 
	{0xF14B, 1, 12, 12, 24, (char *) uc2_F14B}, 
	{0xF155, 1, 12, 12, 24, (char *) uc2_F155}, 
	{0xF15A, 1, 12, 12, 24, (char *) uc2_F15A}, 
	{0xF15D, 1, 12, 12, 24, (char *) uc2_F15D}, 
	{0xF15F, 1, 12, 12, 24, (char *) uc2_F15F}, 
	{0xF162, 1, 12, 12, 24, (char *) uc2_F162}, 
	{0xF164, 1, 12, 12, 24, (char *) uc2_F164}, 
	{0xF166, 1, 12, 12, 24, (char *) uc2_F166}, 
	{0xF168, 1, 12, 12, 24, (char *) uc2_F168}, 
	{0xF16B, 1, 12, 12, 24, (char *) uc2_F16B}, 
	{0xF16E, 1, 12, 12, 24, (char *) uc2_F16E}, 
	{0xF16F, 1, 12, 12, 24, (char *) uc2_F16F}, 
	{0xF171, 1, 12, 12, 24, (char *) uc2_F171}, 
	{0xF172, 1, 12, 12, 24, (char *) uc2_F172}, 
	{0xF173, 1, 12, 12, 24, (char *) uc2_F173}, 
	{0xF175, 1, 12, 12, 24, (char *) uc2_F175}, 
	{0xF17C, 1, 12, 12, 24, (char *) uc2_F17C}, 
	{0xF17E, 1, 12, 12, 24, (char *) uc2_F17E}, 
	{0xF180, 1, 12, 12, 24, (char *) uc2_F180}, 
	{0xF186, 1, 12, 12, 24, (char *) uc2_F186}, 
	{0xF187, 1, 12, 12, 24, (char *) uc2_F187}, 
	{0xF18A, 1, 12, 12, 24, (char *) uc2_F18A}, 
	{0xF18B, 1, 12, 12, 24, (char *) uc2_F18B}, 
	{0xF18D, 1, 12, 12, 24, (char *) uc2_F18D}, 
	{0xF192, 1, 12, 12, 24, (char *) uc2_F192}, 
	{0xF193, 1, 12, 12, 24, (char *) uc2_F193}, 
	{0xF195, 1, 12, 12, 24, (char *) uc2_F195}, 
	{0xF196, 1, 12, 12, 24, (char *) uc2_F196}, 
	{0xF19A, 1, 12, 12, 24, (char *) uc2_F19A}, 
	{0xF19D, 1, 12, 12, 24, (char *) uc2_F19D}, 
	{0xF1A5, 1, 12, 12, 24, (char *) uc2_F1A5}, 
	{0xF1A6, 1, 12, 12, 24, (char *) uc2_F1A6}, 
	{0xF1A9, 1, 12, 12, 24, (char *) uc2_F1A9}, 
	{0xF1AA, 1, 12, 12, 24, (char *) uc2_F1AA}, 
	{0xF1FF, 1, 12, 12, 24, (char *) uc2_F1FF}, 
	{0xF20C, 1, 12, 12, 24, (char *) uc2_F20C}, 
	{0xF20D, 1, 12, 12, 24, (char *) uc2_F20D}, 
	{0xF211, 1, 12, 12, 24, (char *) uc2_F211}, 
	{0xF238, 1, 12, 12, 24, (char *) uc2_F238}, 
	{0xF244, 1, 12, 12, 24, (char *) uc2_F244}, 
	{0xF249, 1, 12, 12, 24, (char *) uc2_F249}, 
	{0xF24B, 1, 12, 12, 24, (char *) uc2_F24B}, 
	{0xF25B, 1, 12, 12, 24, (char *) uc2_F25B}, 
	{0xF263, 1, 12, 12, 24, (char *) uc2_F263}, 
	{0xF278, 1, 12, 12, 24, (char *) uc2_F278}, 
	{0xF27F, 1, 12, 12, 24, (char *) uc2_F27F}, 
	{0xF28C, 1, 12, 12, 24, (char *) uc2_F28C}, 
	{0xF29A, 1, 12, 12, 24, (char *) uc2_F29A}, 
	{0xF2B6, 1, 12, 12, 24, (char *) uc2_F2B6}, 
	{0xF2E6, 1, 12, 12, 24, (char *) uc2_F2E6}, 
	{0xF2EA, 1, 12, 12, 24, (char *) uc2_F2EA}, 
	{0xF311, 1, 12, 12, 24, (char *) uc2_F311}, 
	{0xF325, 1, 12, 12, 24, (char *) uc2_F325}, 
	{0xF32B, 1, 12, 12, 24, (char *) uc2_F32B}, 
	{0xF38A, 1, 12, 12, 24, (char *) uc2_F38A}, 
	{0xF38F, 1, 12, 12, 24, (char *) uc2_F38F}, 
	{0xF405, 1, 12, 12, 24, (char *) uc2_F405}, 
	{0xF406, 1, 12, 12, 24, (char *) uc2_F406}, 
	{0xF407, 1, 12, 12, 24, (char *) uc2_F407}, 
	{0xF408, 1, 12, 12, 24, (char *) uc2_F408}, 
	{0xF409, 1, 12, 12, 24, (char *) uc2_F409}, 
	{0xF40A, 1, 12, 12, 24, (char *) uc2_F40A}, 
	{0xF40B, 1, 12, 12, 24, (char *) uc2_F40B}, 
	{0xF40C, 1, 12, 12, 24, (char *) uc2_F40C}, 
	{0xF40D, 1, 12, 12, 24, (char *) uc2_F40D}, 
	{0xF40E, 1, 12, 12, 24, (char *) uc2_F40E}, 
	{0xF40F, 1, 12, 12, 24, (char *) uc2_F40F}, 
	{0xF410, 1, 12, 12, 24, (char *) uc2_F410}, 
	{0xF411, 1, 12, 12, 24, (char *) uc2_F411}, 
	{0xF412, 1, 12, 12, 24, (char *) uc2_F412}, 
	{0xF413, 1, 12, 12, 24, (char *) uc2_F413}, 
	{0xF414, 1, 12, 12, 24, (char *) uc2_F414}, 
	{0xF415, 1, 12, 12, 24, (char *) uc2_F415}, 
	{0xF416, 1, 12, 12, 24, (char *) uc2_F416}, 
	{0xF417, 1, 12, 12, 24, (char *) uc2_F417}, 
	{0xF418, 1, 12, 12, 24, (char *) uc2_F418}, 
	{0xF419, 1, 12, 12, 24, (char *) uc2_F419}, 
	{0xF41A, 1, 12, 12, 24, (char *) uc2_F41A}, 
	{0xF41B, 1, 12, 12, 24, (char *) uc2_F41B}, 
	{0xF41C, 1, 12, 12, 24, (char *) uc2_F41C}, 
	{0xF41D, 1, 12, 12, 24, (char *) uc2_F41D}, 
	{0xF41E, 1, 12, 12, 24, (char *) uc2_F41E}, 
	{0xF41F, 1, 12, 12, 24, (char *) uc2_F41F}, 
	{0xF420, 1, 12, 12, 24, (char *) uc2_F420}, 
	{0xF421, 1, 12, 12, 24, (char *) uc2_F421}, 
	{0xF422, 1, 12, 12, 24, (char *) uc2_F422}, 
	{0xF423, 1, 12, 12, 24, (char *) uc2_F423}, 
	{0xF424, 1, 12, 12, 24, (char *) uc2_F424}, 
	{0xF425, 1, 12, 12, 24, (char *) uc2_F425}, 
	{0xF426, 1, 12, 12, 24, (char *) uc2_F426}, 
	{0xF427, 1, 12, 12, 24, (char *) uc2_F427}, 
	{0xF428, 1, 12, 12, 24, (char *) uc2_F428}, 
	{0xF429, 1, 12, 12, 24, (char *) uc2_F429}, 
	{0xF431, 1, 12, 12, 24, (char *) uc2_F431}, 
	{0xF432, 1, 12, 12, 24, (char *) uc2_F432}, 
	{0xF433, 1, 12, 12, 24, (char *) uc2_F433}, 
	{0xF434, 1, 12, 12, 24, (char *) uc2_F434}, 
	{0xF435, 1, 12, 12, 24, (char *) uc2_F435}, 
	{0xF461, 1, 12, 12, 24, (char *) uc2_F461}, 
	{0xF462, 1, 12, 12, 24, (char *) uc2_F462}, 
	{0xF463, 1, 12, 12, 24, (char *) uc2_F463}, 
	{0xF464, 1, 12, 12, 24, (char *) uc2_F464}, 
	{0xF465, 1, 12, 12, 24, (char *) uc2_F465}, 
	{0xF466, 1, 12, 12, 24, (char *) uc2_F466}, 
	{0xF467, 1, 12, 12, 24, (char *) uc2_F467}, 
	{0xF468, 1, 12, 12, 24, (char *) uc2_F468}, 
	{0xF469, 1, 12, 12, 24, (char *) uc2_F469}, 
	{0xF46A, 1, 12, 12, 24, (char *) uc2_F46A}, 
	{0xF46B, 1, 12, 12, 24, (char *) uc2_F46B}, 
	{0xF46C, 1, 12, 12, 24, (char *) uc2_F46C}, 
	{0xF46D, 1, 12, 12, 24, (char *) uc2_F46D}, 
	{0xF46E, 1, 12, 12, 24, (char *) uc2_F46E}, 
	{0xF46F, 1, 12, 12, 24, (char *) uc2_F46F}, 
	{0xF470, 1, 12, 12, 24, (char *) uc2_F470}, 
	{0xF471, 1, 12, 12, 24, (char *) uc2_F471}, 
	{0xF472, 1, 12, 12, 24, (char *) uc2_F472}, 
	{0xF473, 1, 12, 12, 24, (char *) uc2_F473}, 
	{0xF474, 1, 12, 12, 24, (char *) uc2_F474}, 
	{0xF475, 1, 12, 12, 24, (char *) uc2_F475}, 
	{0xF476, 1, 12, 12, 24, (char *) uc2_F476}, 
	{0xF477, 1, 12, 12, 24, (char *) uc2_F477}, 
	{0xF478, 1, 12, 12, 24, (char *) uc2_F478}, 
	{0xF479, 1, 12, 12, 24, (char *) uc2_F479}, 
	{0xF47A, 1, 12, 12, 24, (char *) uc2_F47A}, 
	{0xFFFF, 1, 12, 12, 24, (char *) uc2_rubbish}

 };
#endif

#ifdef LSCREEN

#if 0 //Using Arial-type may be problematic - disable
const unsigned char BMP_Arial_000[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_001[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_002[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_003[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_004[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_005[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_006[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_007[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_008[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_009[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_010[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_011[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_012[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_013[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_014[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_015[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_016[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_017[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_018[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_019[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_020[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_021[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_022[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_023[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_024[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_025[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_026[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_027[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_028[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_029[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x19,0x98};
const unsigned char BMP_Arial_030[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_031[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_032[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_033[] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_034[] = {0xA0,0xA0,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_035[] = {0x12,0x00,0x12,0x00,0x12,0x00,0xFF,0x00,0x24,0x00,0x24,0x00,0x24,0x00,0xFF,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_036[] = {0x3C,0x56,0x92,0x90,0x50,0x38,0x14,0x12,0x92,0x54,0x38,0x10,0x00,0x00,};
const unsigned char BMP_Arial_037[] = {0x60,0x80,0x91,0x00,0x91,0x00,0x92,0x00,0x92,0x00,0x64,0xC0,0x09,0x20,0x09,0x20,0x11,0x20,0x11,0x20,0x20,0xC0,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_038[] = {0x38,0x00,0x44,0x00,0x44,0x00,0x44,0x00,0x28,0x00,0x70,0x00,0x89,0x00,0x89,0x00,0x86,0x00,0x87,0x00,0x79,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_039[] = {0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_040[] = {0x20,0x40,0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xC0,0x40,0x40,0x20};
const unsigned char BMP_Arial_041[] = {0x80,0x40,0x40,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x60,0x40,0x40,0x80};
const unsigned char BMP_Arial_042[] = {0x20,0xF8,0x20,0x50,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C};
const unsigned char BMP_Arial_043[] = {0x00,0x00,0x10,0x10,0x10,0xFE,0x10,0x10,0x10,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_044[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0x00};
const unsigned char BMP_Arial_045[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_046[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_047[] = {0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x40,0x40,0x80,0x80,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_048[] = {0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_049[] = {0x20,0x60,0xA0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00};
const unsigned char BMP_Arial_050[] = {0x78,0x84,0x84,0x04,0x04,0x08,0x08,0x10,0x20,0x40,0xFC,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_051[] = {0x78,0x84,0x84,0x04,0x04,0x38,0x04,0x04,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_052[] = {0x04,0x0C,0x14,0x24,0x24,0x44,0x84,0xFE,0x04,0x04,0x04,0x00,0x00,0x00,};
const unsigned char BMP_Arial_053[] = {0x7C,0x40,0x40,0x80,0xF8,0x84,0x04,0x04,0x84,0x88,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_054[] = {0x78,0x84,0x84,0x80,0xB8,0xC4,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_055[] = {0xFC,0x04,0x08,0x08,0x10,0x10,0x10,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_056[] = {0x78,0x84,0x84,0x84,0x84,0x78,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_057[] = {0x78,0x84,0x84,0x84,0x84,0x8C,0x74,0x04,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_058[] = {0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_059[] = {0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0x00};
const unsigned char BMP_Arial_060[] = {0x00,0x00,0x02,0x1C,0x60,0x80,0x60,0x1C,0x02,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_061[] = {0x00,0x00,0x00,0xFE,0x00,0x00,0x00,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_062[] = {0x00,0x00,0x80,0x70,0x0C,0x02,0x0C,0x70,0x80,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_063[] = {0x78,0x84,0x84,0x04,0x08,0x10,0x20,0x20,0x20,0x00,0x20,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_064[] = {0x07,0xC0,0x18,0x30,0x20,0x08,0x43,0xAC,0x4C,0x64,0x88,0x24,0x90,0x44,0x90,0x44,0x90,0x48,0x88,0xC8,0x47,0x70,0x40,0x04,0x30,0x18,0x0F,0xE0,0x03,0x32};
const unsigned char BMP_Arial_065[] = {0x08,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_066[] = {0xFE,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x82,0x00,0xFE,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_067[] = {0x1E,0x00,0x61,0x00,0x40,0x80,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x40,0x80,0x61,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_068[] = {0xFE,0x00,0x81,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x81,0x00,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_069[] = {0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_070[] = {0xFE,0x80,0x80,0x80,0x80,0xFC,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,};
const unsigned char BMP_Arial_071[] = {0x3E,0x00,0x41,0x00,0x80,0x80,0x80,0x00,0x80,0x00,0x87,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_072[] = {0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0xFF,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_073[] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_074[] = {0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_075[] = {0x81,0x00,0x82,0x00,0x84,0x00,0x88,0x00,0x90,0x00,0xA8,0x00,0xC4,0x00,0x84,0x00,0x82,0x00,0x81,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_076[] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_077[] = {0x80,0x80,0xC1,0x80,0xC1,0x80,0xA2,0x80,0xA2,0x80,0xA2,0x80,0x94,0x80,0x94,0x80,0x94,0x80,0x88,0x80,0x88,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_078[] = {0x81,0x00,0xC1,0x00,0xA1,0x00,0xA1,0x00,0x91,0x00,0x91,0x00,0x89,0x00,0x85,0x00,0x85,0x00,0x83,0x00,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_079[] = {0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x40,0x80,0x61,0x80,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x20};
const unsigned char BMP_Arial_080[] = {0xFE,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0xFE,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_081[] = {0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x46,0x80,0x61,0x80,0x1E,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x20};
const unsigned char BMP_Arial_082[] = {0xFF,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xFF,0x00,0x84,0x00,0x82,0x00,0x82,0x00,0x81,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_083[] = {0x3C,0x00,0x42,0x00,0x81,0x00,0x80,0x00,0xF0,0x00,0x0E,0x00,0x01,0x00,0x01,0x00,0x81,0x00,0xC2,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_084[] = {0xFF,0x80,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_085[] = {0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_086[] = {0x80,0x80,0x80,0x80,0x41,0x00,0x41,0x00,0x22,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_087[] = {0x81,0x02,0x82,0x82,0x42,0x84,0x42,0x84,0x44,0x44,0x44,0x44,0x24,0x48,0x28,0x28,0x28,0x28,0x10,0x10,0x10,0x10,0x00,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_088[] = {0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_089[] = {0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_090[] = {0x7F,0x00,0x02,0x00,0x04,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x10,0x00,0x20,0x00,0x20,0x00,0x40,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_091[] = {0xE0,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xE0};
const unsigned char BMP_Arial_092[] = {0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x20,0x20,0x10,0x10,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_093[] = {0xE0,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xE0};
const unsigned char BMP_Arial_094[] = {0x20,0x50,0x50,0x50,0x88,0x88,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C};
const unsigned char BMP_Arial_095[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x33,0x00};
const unsigned char BMP_Arial_096[] = {0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_097[] = {0x00,0x00,0x00,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_098[] = {0x80,0x80,0x80,0xB8,0xC4,0x84,0x84,0x84,0x84,0xC4,0xB8,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_099[] = {0x00,0x00,0x00,0x78,0x84,0x80,0x80,0x80,0x80,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_100[] = {0x04,0x04,0x04,0x74,0x8C,0x84,0x84,0x84,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_101[] = {0x00,0x00,0x00,0x78,0x84,0x84,0xFC,0x80,0x80,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_102[] = {0x30,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_103[] = {0x00,0x00,0x00,0x74,0x8C,0x84,0x84,0x84,0x84,0x8C,0x74,0x04,0x84,0x78,0x02};
const unsigned char BMP_Arial_104[] = {0x80,0x80,0x80,0xB8,0xC4,0x84,0x84,0x84,0x84,0x84,0x84,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_105[] = {0x80,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_106[] = {0x20,0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xC0};
const unsigned char BMP_Arial_107[] = {0x80,0x80,0x80,0x84,0x88,0x90,0xA0,0xD0,0x88,0x88,0x84,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_108[] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_109[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xB9,0xC0,0xC6,0x20,0x84,0x20,0x84,0x20,0x84,0x20,0x84,0x20,0x84,0x20,0x84,0x20,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_110[] = {0x00,0x00,0x00,0xB8,0xC4,0x84,0x84,0x84,0x84,0x84,0x84,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_111[] = {0x00,0x00,0x00,0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_112[] = {0x00,0x00,0x00,0xB8,0xC4,0x84,0x84,0x84,0x84,0xC4,0xB8,0x80,0x80,0x80,0x02};
const unsigned char BMP_Arial_113[] = {0x00,0x00,0x00,0x74,0x8C,0x84,0x84,0x84,0x84,0x8C,0x74,0x04,0x04,0x04,0x02};
const unsigned char BMP_Arial_114[] = {0x00,0x00,0x00,0xB0,0xC0,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_115[] = {0x00,0x00,0x00,0x78,0x84,0x80,0x60,0x18,0x04,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_116[] = {0x00,0x40,0x40,0xF0,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_117[] = {0x00,0x00,0x00,0x84,0x84,0x84,0x84,0x84,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_118[] = {0x00,0x00,0x00,0x82,0x82,0x44,0x44,0x28,0x28,0x10,0x10,0x00,0x00,0x00,};
const unsigned char BMP_Arial_119[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x84,0x20,0x8A,0x20,0x4A,0x40,0x4A,0x40,0x51,0x40,0x51,0x40,0x20,0x80,0x20,0x80,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_120[] = {0x00,0x00,0x00,0x82,0x44,0x28,0x10,0x10,0x28,0x44,0x82,0x00,0x00,0x00,};
const unsigned char BMP_Arial_121[] = {0x00,0x00,0x00,0x82,0x82,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x60,};
const unsigned char BMP_Arial_122[] = {0x00,0x00,0x00,0xFC,0x08,0x10,0x10,0x20,0x20,0x40,0xFC,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_123[] = {0x18,0x20,0x20,0x20,0x20,0x20,0x20,0xC0,0x20,0x20,0x20,0x20,0x20,0x18,0x0C};
const unsigned char BMP_Arial_124[] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00};
const unsigned char BMP_Arial_125[] = {0xC0,0x20,0x20,0x20,0x20,0x20,0x20,0x18,0x20,0x20,0x20,0x20,0x20,0xC0,0x0C};
const unsigned char BMP_Arial_126[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0x00,0x8E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_127[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_128[] = {0x1E,0x20,0x40,0x40,0xFE,0x40,0xFE,0x40,0x40,0x20,0x1E,0x00,0x00,0x00,};
const unsigned char BMP_Arial_129[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_130[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0x00};
const unsigned char BMP_Arial_131[] = {0x0E,0x08,0x08,0x3C,0x10,0x10,0x10,0x10,0x10,0x20,0x20,0x20,0x20,0xE0,};
const unsigned char BMP_Arial_132[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA0,0xA0,0xA0,0x00};
const unsigned char BMP_Arial_133[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x88,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_134[] = {0x10,0x10,0x10,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,};
const unsigned char BMP_Arial_135[] = {0x10,0x10,0x10,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,0xFE,0x10,0x10,0x10,};
const unsigned char BMP_Arial_136[] = {0x60,0x90,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_137[] = {0x62,0x00,0x94,0x00,0x94,0x00,0x94,0x00,0x98,0x00,0x6B,0x18,0x0C,0xA4,0x14,0xA4,0x14,0xA4,0x14,0xA4,0x23,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32};
const unsigned char BMP_Arial_138[] = {0x3C,0x00,0x42,0x00,0x81,0x00,0x80,0x00,0xF0,0x00,0x0E,0x00,0x01,0x00,0x01,0x00,0x81,0x00,0xC2,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x48,0x00,0x33,0x00};
const unsigned char BMP_Arial_139[] = {0x00,0x00,0x00,0x20,0x40,0x40,0x80,0x40,0x40,0x20,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_140[] = {0x3D,0xF8,0x43,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0xF8,0x81,0x00,0x81,0x00,0x81,0x00,0x43,0x00,0x3D,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xCC};
const unsigned char BMP_Arial_141[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_142[] = {0x7F,0x00,0x02,0x00,0x04,0x00,0x04,0x00,0x08,0x00,0x10,0x00,0x10,0x00,0x20,0x00,0x20,0x00,0x40,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x24,0x00,0x33,0x00};
const unsigned char BMP_Arial_143[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_144[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_145[] = {0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_146[] = {0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_147[] = {0xA0,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_148[] = {0xA0,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_149[] = {0x00,0x00,0x00,0x00,0x60,0xF0,0xF0,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_150[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_151[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_152[] = {0x50,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_153[] = {0xFB,0x18,0x23,0x18,0x22,0xA8,0x22,0xA8,0x22,0xA8,0x22,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xCC};
const unsigned char BMP_Arial_154[] = {0x48,0x30,0x00,0x78,0x84,0x80,0x60,0x18,0x04,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_155[] = {0x00,0x00,0x00,0x80,0x40,0x40,0x20,0x40,0x40,0x80,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_156[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x79,0xC0,0x86,0x20,0x84,0x10,0x87,0xF0,0x84,0x00,0x84,0x10,0x86,0x20,0x79,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x30};
const unsigned char BMP_Arial_157[] = {0x00,0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_158[] = {0x48,0x30,0x00,0xFC,0x08,0x10,0x10,0x20,0x20,0x40,0xFC,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_159[] = {0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_160[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_161[] = {0x00,0x00,0x00,0x80,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00};
const unsigned char BMP_Arial_162[] = {0x08,0x08,0x08,0x38,0x54,0x90,0x90,0xA0,0xA4,0xEC,0x38,0x40,0x40,0x40,0x02};
const unsigned char BMP_Arial_163[] = {0x3C,0x42,0x40,0x40,0x40,0xF8,0x20,0x20,0x40,0x70,0x8E,0x00,0x00,0x00,};
const unsigned char BMP_Arial_164[] = {0x00,0x00,0x00,0xB4,0x48,0x84,0x84,0x48,0xB4,0x00,0x00,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_165[] = {0x82,0x44,0x44,0x28,0x28,0xFE,0x10,0xFE,0x10,0x10,0x10,0x00,0x00,0x00,};
const unsigned char BMP_Arial_166[] = {0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00};
const unsigned char BMP_Arial_167[] = {0x38,0x44,0x44,0x60,0x70,0x9C,0x86,0xC2,0x72,0x1C,0x0C,0x84,0xC4,0x78};
const unsigned char BMP_Arial_168[] = {0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_169[] = {0x3F,0x80,0x40,0x40,0x8E,0x20,0x91,0x20,0x90,0x20,0x90,0x20,0x91,0x20,0x8E,0x20,0x80,0x20,0x40,0x40,0x3F,0x80,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_170[] = {0x70,0x88,0x38,0xC8,0x88,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C};
const unsigned char BMP_Arial_171[] = {0x00,0x00,0x00,0x24,0x48,0x48,0x90,0x48,0x48,0x24,0x00,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_172[] = {0x00,0x00,0x00,0x00,0xFE,0x02,0x02,0x02,0x00,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_173[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_174[] = {0x3F,0x80,0x40,0x40,0x9E,0x20,0x91,0x20,0x91,0x20,0x9E,0x20,0x92,0x20,0x91,0x20,0x80,0x20,0x40,0x40,0x3F,0x80,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_175[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_176[] = {0x60,0x90,0x90,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_177[] = {0x00,0x00,0x10,0x10,0x10,0xFE,0x10,0x10,0x10,0x00,0xFE,0x00,0x00,0x00,};
const unsigned char BMP_Arial_178[] = {0x70,0x88,0x08,0x30,0x40,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C};
const unsigned char BMP_Arial_179[] = {0x78,0x88,0x10,0x08,0x88,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C};
const unsigned char BMP_Arial_180[] = {0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_181[] = {0x00,0x00,0x00,0x84,0x84,0x84,0x84,0x84,0x84,0xCC,0xB4,0x80,0x80,0x80,0x02};
const unsigned char BMP_Arial_182[] = {0x7F,0x00,0xF2,0x00,0xF2,0x00,0xF2,0x00,0xF2,0x00,0x72,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x33,0x00};
const unsigned char BMP_Arial_183[] = {0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_184[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x20,0xE0};
const unsigned char BMP_Arial_185[] = {0x60,0xA0,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_186[] = {0x70,0x88,0x88,0x88,0x88,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C};
const unsigned char BMP_Arial_187[] = {0x00,0x00,0x00,0x90,0x48,0x48,0x24,0x48,0x48,0x90,0x00,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_188[] = {0x60,0x40,0xA0,0x80,0x20,0x80,0x21,0x00,0x22,0x00,0x24,0x20,0x0C,0x60,0x08,0xA0,0x11,0x20,0x21,0xF0,0x40,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x30};
const unsigned char BMP_Arial_189[] = {0x60,0x40,0xA0,0x80,0x21,0x00,0x22,0x00,0x22,0x00,0x24,0x70,0x08,0x90,0x10,0x10,0x10,0x20,0x20,0x40,0x40,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x30};
const unsigned char BMP_Arial_190[] = {0x70,0x20,0x90,0x40,0x20,0x80,0x10,0x80,0x91,0x00,0x62,0x10,0x04,0x30,0x04,0x50,0x08,0x90,0x10,0xF8,0x20,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xCC};
const unsigned char BMP_Arial_191[] = {0x00,0x00,0x00,0x10,0x00,0x10,0x10,0x10,0x20,0x40,0x80,0x82,0x86,0x7C,};
const unsigned char BMP_Arial_192[] = {0x08,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x20,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_193[] = {0x08,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x08,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_194[] = {0x08,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x18,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_195[] = {0x08,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x14,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_196[] = {0x22, 0x00, 0x08,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};/*SPR 1508*/
const unsigned char BMP_Arial_197[] = {0x08,0x00,0x14,0x00,0x08,0x00,0x1C,0x00,0x22,0x00,0x22,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_198[] = {0x07,0xFC,0x09,0x00,0x09,0x00,0x11,0x00,0x11,0x00,0x21,0xFC,0x21,0x00,0x7F,0x00,0x41,0x00,0x81,0x00,0x81,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x32};
const unsigned char BMP_Arial_199[] = {0x1E,0x00,0x61,0x00,0x40,0x80,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x40,0x80,0x61,0x00,0x1E,0x00,0x08,0x00,0x04,0x00,0x1C,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_200[] = {0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x33,0x00};
const unsigned char BMP_Arial_201[] = {0x0c, 0x00, 0x10, 0x00, 0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x33,0x00};/*SPR 1508*/
const unsigned char BMP_Arial_202[] = {0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x33,0x00};
const unsigned char BMP_Arial_203[] = {0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_204[] = {0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_205[] = {0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x80,0x00,0x00};
const unsigned char BMP_Arial_206[] = {0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0xC0,0x30};
const unsigned char BMP_Arial_207[] = {0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00};
const unsigned char BMP_Arial_208[] = {0x7F,0x00,0x40,0x80,0x40,0x40,0x40,0x40,0x40,0x40,0xFC,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x80,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x20};
const unsigned char BMP_Arial_209[] = {0x14, 0x00, 0x28, 0x00, 0x81,0x00,0xC1,0x00,0xA1,0x00,0x91,0x00,0x91,0x00,0x89,0x00,0x85,0x00,0x83,0x00,0x81,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};/*SPR 1508*/
const unsigned char BMP_Arial_210[] = {0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x40,0x80,0x61,0x80,0x1E,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x03,0x20};
const unsigned char BMP_Arial_211[] = {0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x40,0x80,0x61,0x80,0x1E,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x03,0x20};
const unsigned char BMP_Arial_212[] = {0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x40,0x80,0x61,0x80,0x1E,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x03,0x20};
const unsigned char BMP_Arial_213[] = {0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x80,0x40,0x40,0x80,0x61,0x80,0x1E,0x00,0x00,0x00,0x00,0x00,0x14,0x00,0x03,0x20};
const unsigned char BMP_Arial_214[] = {0x22, 0x00, 0x00, 0x00, 0x1E,0x00,0x61,0x80,0x40,0x80,0x80,0x40,0x80,0x40,0x80,0x40,0x40,0x80,0x61,0x80,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x20};/*SPR 1508*/
const unsigned char BMP_Arial_215[] = {0x00,0x00,0x82,0x44,0x38,0x10,0x38,0x44,0x82,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_216[] = {0x1E,0x40,0x61,0x80,0x41,0x80,0x82,0x40,0x84,0x40,0x88,0x40,0x88,0x40,0x90,0x40,0x60,0x80,0x61,0x80,0x9E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x20};
const unsigned char BMP_Arial_217[] = {0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x33,0x00};
const unsigned char BMP_Arial_218[] = {0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x33,0x00};
const unsigned char BMP_Arial_219[] = {0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x33,0x00};
const unsigned char BMP_Arial_220[] = {0x24, 0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x42,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};/*SPR 1508*/
const unsigned char BMP_Arial_221[] = {0x80,0x80,0x41,0x00,0x22,0x00,0x22,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x0C,0xC0};
const unsigned char BMP_Arial_222[] = {0x80,0x00,0x80,0x00,0xFE,0x00,0x83,0x00,0x81,0x00,0x81,0x00,0x81,0x00,0x82,0x00,0xFC,0x00,0x80,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x00};
const unsigned char BMP_Arial_223[] = {0x30,0x48,0x88,0x88,0x90,0x90,0x8C,0x82,0x82,0xA2,0x9C,0x00,0x00,0x00,};
const unsigned char BMP_Arial_224[] = {0x20,0x10,0x00,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_225[] = {0x10,0x20,0x00,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_226[] = {0x30,0x48,0x00,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_227[] = {0x28,0x50,0x00,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_228[] = {0x00,0x28,0x00,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_229[] = {0x08,0x14,0x08,0x78,0x84,0x04,0x3C,0x44,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_230[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x79,0xC0,0x86,0x20,0x04,0x10,0x1F,0xF0,0x64,0x00,0x84,0x10,0x8E,0x20,0x71,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x30};
const unsigned char BMP_Arial_231[] = {0x00,0x00,0x00,0x78,0x84,0x80,0x80,0x80,0x80,0x84,0x78,0x20,0x10,0x70,0x02};
const unsigned char BMP_Arial_232[] = {0x20,0x10,0x00,0x78,0x84,0x84,0xFC,0x80,0x80,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_233[] = {0x10,0x20,0x00,0x78,0x84,0x84,0xFC,0x80,0x80,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_234[] = {0x30,0x48,0x00,0x78,0x84,0x84,0xFC,0x80,0x80,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_235[] = {0x00,0x28,0x00,0x78,0x84,0x84,0xFC,0x80,0x80,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_236[] = {0x80,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_237[] = {0x40,0x80,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Arial_238[] = {0x60,0x90,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00,0x30};
const unsigned char BMP_Arial_239[] = {0x00,0xA0,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x00,0x00};
const unsigned char BMP_Arial_240[] = {0x28,0x30,0x48,0x38,0x4C,0x84,0x84,0x84,0x84,0x48,0x30,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_241[] = {0x28,0x50,0x00,0xB8,0xC4,0x84,0x84,0x84,0x84,0x84,0x84,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_242[] = {0x20,0x10,0x00,0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_243[] = {0x10,0x20,0x00,0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_244[] = {0x30,0x48,0x00,0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_245[] = {0x28,0x50,0x00,0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_246[] = {0x00,0x28,0x00,0x78,0x84,0x84,0x84,0x84,0x84,0x84,0x78,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_247[] = {0x00,0x00,0x00,0x10,0x00,0xFE,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,};
const unsigned char BMP_Arial_248[] = {0x00,0x00,0x00,0x34,0x48,0x94,0x94,0xA4,0xA4,0x48,0xF0,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_249[] = {0x20,0x10,0x00,0x84,0x84,0x84,0x84,0x84,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_250[] = {0x08,0x10,0x00,0x84,0x84,0x84,0x84,0x84,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_251[] = {0x30,0x48,0x00,0x84,0x84,0x84,0x84,0x84,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_252[] = {0x00,0x50,0x00,0x84,0x84,0x84,0x84,0x84,0x84,0x8C,0x74,0x00,0x00,0x00,0x02};
const unsigned char BMP_Arial_253[] = {0x08,0x10,0x00,0x82,0x82,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x60,};
const unsigned char BMP_Arial_254[] = {0x80,0x80,0x80,0xB0,0xC8,0x84,0x84,0x84,0x84,0xC8,0xB0,0x80,0x80,0x80,0x02};
const unsigned char BMP_Arial_255[] = {0x00,0x28,0x00,0x82,0x82,0x44,0x44,0x28,0x28,0x28,0x10,0x10,0x10,0x60,};
#endif
/* Marcus: 2002/12/10: Added bitmaps for the Greek characters required for the GSM charset */
const unsigned char BMP_Delta[]  = {0x10,0x10,0x10,0x28,0x28,0x28,0x44,0x44,0x44,0x82,0xFE,0xFE,0x00,0x00,}; /* uc2_0394 */
const unsigned char BMP_Phi[]    = {0x10,0x38,0x38,0x54,0x54,0x54,0x54,0x54,0x54,0x38,0x38,0x10,0x00,0x00,}; /* uc2_03A6 */
const unsigned char BMP_Gamma[]  = {0xFE,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,}; /* uc2_0393 */
const unsigned char BMP_Lambda[] = {0x10,0x10,0x10,0x28,0x28,0x28,0x44,0x44,0x44,0x82,0x82,0x82,0x00,0x00,}; /* uc2_039B */
const unsigned char BMP_Omega[]  = {0x10,0x38,0x28,0x44,0x44,0x44,0x44,0x44,0x44,0x28,0x6C,0x44,0x00,0x00,}; /* uc2_03A9 */
const unsigned char BMP_Pi[]     = {0xFE,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x82,0x00,0x00,}; /* uc2_03A0 */
const unsigned char BMP_Psi[]    = {0x92,0x92,0x92,0x92,0xD6,0x54,0x7C,0x31,0x10,0x10,0x10,0x10,0x00,0x00,}; /* uc2_03A8 */
const unsigned char BMP_Sigma[]  = {0xFE,0x80,0x40,0x20,0x10,0x08,0x08,0x10,0x20,0x40,0x80,0xFE,0x00,0x00,}; /* uc2_03A3 */
const unsigned char BMP_Theta[]  = {0x38,0x44,0x82,0x82,0x82,0xBA,0xBA,0x82,0x82,0x82,0x44,0x38,0x00,0x00,}; /* uc2_0398 */
const unsigned char BMP_Xi[]     = {0xFE,0xFE,0x00,0x00,0x00,0x7C,0x7C,0x00,0x00,0x00,0xFE,0xFE,0x00,0x00,}; /* uc2_039E */

#if 0
#define NUM_BITMAPS_FONT1 /*257*/267
static const t_font_bitmap database1[NUM_BITMAPS_FONT1] ={
{ 0,1,14,15,255,(char*)BMP_Arial_000},
{ 1,1,14,15,255,(char*)BMP_Arial_001},
{ 2,1,14,15,255,(char*)BMP_Arial_002},
{ 3,1,14,15,255,(char*)BMP_Arial_003},
{ 4,1,14,15,255,(char*)BMP_Arial_004},
{ 5,1,14,15,255,(char*)BMP_Arial_005},
{ 6,1,14,15,255,(char*)BMP_Arial_006},
{ 7,1,14,15,255,(char*)BMP_Arial_007},
{ 8,1,14,15,255,(char*)BMP_Arial_008},
{ 9,1,14,15,255,(char*)BMP_Arial_009},
{ 10,1,14,15,255,(char*)BMP_Arial_010},
{ 11,1,14,15,255,(char*)BMP_Arial_011},
{ 12,1,14,15,255,(char*)BMP_Arial_012},
{ 13,1,14,15,255,(char*)BMP_Arial_013},
{ 14,1,14,15,255,(char*)BMP_Arial_014},
{ 15,1,14,15,255,(char*)BMP_Arial_015},
{ 16,1,14,15,255,(char*)BMP_Arial_016},
{ 17,1,14,15,255,(char*)BMP_Arial_017},
{ 18,1,14,15,255,(char*)BMP_Arial_018},
{ 19,1,14,15,255,(char*)BMP_Arial_019},
{ 20,1,14,15,255,(char*)BMP_Arial_020},
{ 21,1,14,15,255,(char*)BMP_Arial_021},
{ 22,1,14,15,255,(char*)BMP_Arial_022},
{ 23,1,14,15,255,(char*)BMP_Arial_023},
{ 24,1,14,15,255,(char*)BMP_Arial_024},
{ 25,1,14,15,255,(char*)BMP_Arial_025},
{ 26,1,14,15,255,(char*)BMP_Arial_026},
{ 27,1,14,15,255,(char*)BMP_Arial_027},
{ 28,1,14,15,255,(char*)BMP_Arial_028},
{ 29,1,14,15,255,(char*)BMP_Arial_029},
{ 30,1,14, 8,255,(char*)BMP_Arial_030},
{ 31,1,14, 8,255,(char*)BMP_Arial_031},
{ 32,1,14, 2,255,(char*)BMP_Arial_032},
{ 33,1,14, 2,255,(char*)BMP_Arial_033},
{ 34,1,14, 4,255,(char*)BMP_Arial_034},
{ 35,1,14, 9,255,(char*)BMP_Arial_035},
{ 36,1,14, 8,255,(char*)BMP_Arial_036},
{ 37,1,14,12,255,(char*)BMP_Arial_037},
{ 38,1,14,10,255,(char*)BMP_Arial_038},
{ 39,1,14, 2,255,(char*)BMP_Arial_039},
{ 40,1,14, 4,255,(char*)BMP_Arial_040},
{ 41,1,14, 4,255,(char*)BMP_Arial_041},
{ 42,1,14, 6,255,(char*)BMP_Arial_042},
{ 43,1,14, 8,255,(char*)BMP_Arial_043},
{ 44,1,14, 2,255,(char*)BMP_Arial_044},
{ 45,1,14, 5,255,(char*)BMP_Arial_045},
{ 46,1,14, 2,255,(char*)BMP_Arial_046},
{ 47,1,14, 5,255,(char*)BMP_Arial_047},
{ 48,1,14, 7,255,(char*)BMP_Arial_048},
{ 49,1,14, 4,255,(char*)BMP_Arial_049},
{ 50,1,14, 7,255,(char*)BMP_Arial_050},
{ 51,1,14, 7,255,(char*)BMP_Arial_051},
{ 52,1,14, 8,255,(char*)BMP_Arial_052},
{ 53,1,14, 7,255,(char*)BMP_Arial_053},
{ 54,1,14, 7,255,(char*)BMP_Arial_054},
{ 55,1,14, 7,255,(char*)BMP_Arial_055},
{ 56,1,14, 7,255,(char*)BMP_Arial_056},
{ 57,1,14, 7,255,(char*)BMP_Arial_057},
{ 58,1,14, 2,255,(char*)BMP_Arial_058},
{ 59,1,14, 2,255,(char*)BMP_Arial_059},
{ 60,1,14, 8,255,(char*)BMP_Arial_060},
{ 61,1,14, 8,255,(char*)BMP_Arial_061},
{ 62,1,14, 8,255,(char*)BMP_Arial_062},
{ 63,1,14, 7,255,(char*)BMP_Arial_063},
{ 64,1,14,15,255,(char*)BMP_Arial_064},
{ 65,1,14,10,255,(char*)BMP_Arial_065},
{ 66,1,14, 9,255,(char*)BMP_Arial_066},
{ 67,1,14,10,255,(char*)BMP_Arial_067},
{ 68,1,14,10,255,(char*)BMP_Arial_068},
{ 69,1,14, 9,255,(char*)BMP_Arial_069},
{ 70,1,14, 8,255,(char*)BMP_Arial_070},
{ 71,1,14,10,255,(char*)BMP_Arial_071},
{ 72,1,14, 9,255,(char*)BMP_Arial_072},
{ 73,1,14, 2,255,(char*)BMP_Arial_073},
{ 74,1,14, 7,255,(char*)BMP_Arial_074},
{ 75,1,14,10,255,(char*)BMP_Arial_075},
{ 76,1,14, 8,255,(char*)BMP_Arial_076},
{ 77,1,14,10,255,(char*)BMP_Arial_077},
{ 78,1,14, 9,255,(char*)BMP_Arial_078},
{ 79,1,14,11,255,(char*)BMP_Arial_079},
{ 80,1,14, 9,255,(char*)BMP_Arial_080},
{ 81,1,14,11,255,(char*)BMP_Arial_081},
{ 82,1,14,10,255,(char*)BMP_Arial_082},
{ 83,1,14, 9,255,(char*)BMP_Arial_083},
{ 84,1,14,10,255,(char*)BMP_Arial_084},
{ 85,1,14, 9,255,(char*)BMP_Arial_085},
{ 86,1,14,10,255,(char*)BMP_Arial_086},
{ 87,1,14,16,255,(char*)BMP_Arial_087},
{ 88,1,14,10,255,(char*)BMP_Arial_088},
{ 89,1,14,10,255,(char*)BMP_Arial_089},
{ 90,1,14, 9,255,(char*)BMP_Arial_090},
{ 91,1,14, 4,255,(char*)BMP_Arial_091},
{ 92,1,14, 5,255,(char*)BMP_Arial_092},
{ 93,1,14, 4,255,(char*)BMP_Arial_093},
{ 94,1,14, 6,255,(char*)BMP_Arial_094},
{ 95,1,14, 9,255,(char*)BMP_Arial_095},
{ 96,1,14, 3,255,(char*)BMP_Arial_096},
{ 97,1,14, 7,255,(char*)BMP_Arial_097},
{ 98,1,14, 7,255,(char*)BMP_Arial_098},
{ 99,1,14, 7,255,(char*)BMP_Arial_099},
{ 100,1,14, 7,255,(char*)BMP_Arial_100},
{ 101,1,14, 7,255,(char*)BMP_Arial_101},
{ 102,1,14, 5,255,(char*)BMP_Arial_102},
{ 103,1,14, 7,255,(char*)BMP_Arial_103},
{ 104,1,14, 7,255,(char*)BMP_Arial_104},
{ 105,1,14, 2,255,(char*)BMP_Arial_105},
{ 106,1,14, 4,255,(char*)BMP_Arial_106},
{ 107,1,14, 7,255,(char*)BMP_Arial_107},
{ 108,1,14, 2,255,(char*)BMP_Arial_108},
{ 109,1,14,12,255,(char*)BMP_Arial_109},
{ 110,1,14, 7,255,(char*)BMP_Arial_110},
{ 111,1,14, 7,255,(char*)BMP_Arial_111},
{ 112,1,14, 7,255,(char*)BMP_Arial_112},
{ 113,1,14, 7,255,(char*)BMP_Arial_113},
{ 114,1,14, 5,255,(char*)BMP_Arial_114},
{ 115,1,14, 7,255,(char*)BMP_Arial_115},
{ 116,1,14, 5,255,(char*)BMP_Arial_116},
{ 117,1,14, 7,255,(char*)BMP_Arial_117},
{ 118,1,14, 8,255,(char*)BMP_Arial_118},
{ 119,1,14,12,255,(char*)BMP_Arial_119},
{ 120,1,14, 8,255,(char*)BMP_Arial_120},
{ 121,1,14, 8,255,(char*)BMP_Arial_121},
{ 122,1,14, 7,255,(char*)BMP_Arial_122},
{ 123,1,14, 6,255,(char*)BMP_Arial_123},
{ 124,1,14, 2,255,(char*)BMP_Arial_124},
{ 125,1,14, 6,255,(char*)BMP_Arial_125},
{ 126,1,14, 9,255,(char*)BMP_Arial_126},
{ 127,1,14, 8,255,(char*)BMP_Arial_127},
/* Marcus: 2002/12/12: Start removed for Greek characters
{ 128,1,14, 8,255,(char*)BMP_Arial_128},
{ 129,1,14, 8,255,(char*)BMP_Arial_129},
{ 130,1,14, 2,255,(char*)BMP_Arial_130},
{ 131,1,14, 8,255,(char*)BMP_Arial_131},
{ 132,1,14, 4,255,(char*)BMP_Arial_132},
{ 133,1,14,10,255,(char*)BMP_Arial_133},
{ 134,1,14, 8,255,(char*)BMP_Arial_134},
{ 135,1,14, 8,255,(char*)BMP_Arial_135},
{ 136,1,14, 5,255,(char*)BMP_Arial_136},
{ 137,1,14,15,255,(char*)BMP_Arial_137},
* Marcus: 2002/12/12: End removed for Greek characters */
/* Marcus: 2002/12/12: Start Greek characters */
{ 128,1,14, 8,255,(char*)BMP_Delta},
{ 129,1,14, 8,255,(char*)BMP_Phi},
{ 130,1,14, 8,255,(char*)BMP_Gamma},
{ 131,1,14, 8,255,(char*)BMP_Lambda},
{ 132,1,14, 7,255,(char*)BMP_Omega},
{ 133,1,14, 7,255,(char*)BMP_Pi},
{ 134,1,14, 8,255,(char*)BMP_Psi},
{ 135,1,14, 8,255,(char*)BMP_Sigma},
{ 136,1,14, 5,255,(char*)BMP_Theta},
{ 137,1,14, 8,255,(char*)BMP_Xi},
/* Marcus: 2002/12/12: End Greek characters */
{ 138,1,14, 9,255,(char*)BMP_Arial_138},
{ 139,1,14, 4,255,(char*)BMP_Arial_139},
{ 140,1,14,14,255,(char*)BMP_Arial_140},
{ 141,1,14, 8,255,(char*)BMP_Arial_141},
{ 142,1,14, 9,255,(char*)BMP_Arial_142},
{ 143,1,14, 8,255,(char*)BMP_Arial_143},
{ 144,1,14, 8,255,(char*)BMP_Arial_144},
{ 145,1,14, 2,255,(char*)BMP_Arial_145},
{ 146,1,14, 2,255,(char*)BMP_Arial_146},
{ 147,1,14, 4,255,(char*)BMP_Arial_147},
{ 148,1,14, 4,255,(char*)BMP_Arial_148},
{ 149,1,14, 5,255,(char*)BMP_Arial_149},
{ 150,1,14, 9,255,(char*)BMP_Arial_150},
{ 151,1,14,16,255,(char*)BMP_Arial_151},
{ 152,1,14, 5,255,(char*)BMP_Arial_152},
{ 153,1,14,14,255,(char*)BMP_Arial_153},
{ 154,1,14, 7,255,(char*)BMP_Arial_154},
{ 155,1,14, 4,255,(char*)BMP_Arial_155},
{ 156,1,14,13,255,(char*)BMP_Arial_156},
{ 157,1,14, 8,255,(char*)BMP_Arial_157},
{ 158,1,14, 7,255,(char*)BMP_Arial_158},
{ 159,1,14,10,255,(char*)BMP_Arial_159},
{ 160,1,14, 2,255,(char*)BMP_Arial_160},
{ 161,1,14, 2,255,(char*)BMP_Arial_161},
{ 162,1,14, 7,255,(char*)BMP_Arial_162},
{ 163,1,14, 8,255,(char*)BMP_Arial_163},
{ 164,1,14, 7,255,(char*)BMP_Arial_164},
{ 165,1,14, 8,255,(char*)BMP_Arial_165},
{ 166,1,14, 2,255,(char*)BMP_Arial_166},
{ 167,1,14, 8,255,(char*)BMP_Arial_167},
{ 168,1,14, 4,255,(char*)BMP_Arial_168},
{ 169,1,14,12,255,(char*)BMP_Arial_169},
{ 170,1,14, 6,255,(char*)BMP_Arial_170},
{ 171,1,14, 7,255,(char*)BMP_Arial_171},
{ 172,1,14, 8,255,(char*)BMP_Arial_172},
{ 173,1,14, 5,255,(char*)BMP_Arial_173},
{ 174,1,14,12,255,(char*)BMP_Arial_174},
{ 175,1,14, 9,255,(char*)BMP_Arial_175},
{ 176,1,14, 5,255,(char*)BMP_Arial_176},
{ 177,1,14, 8,255,(char*)BMP_Arial_177},
{ 178,1,14, 6,255,(char*)BMP_Arial_178},
{ 179,1,14, 6,255,(char*)BMP_Arial_179},
{ 180,1,14, 3,255,(char*)BMP_Arial_180},
{ 181,1,14, 7,255,(char*)BMP_Arial_181},
{ 182,1,14, 9,255,(char*)BMP_Arial_182},
{ 183,1,14, 2,255,(char*)BMP_Arial_183},
{ 184,1,14, 4,255,(char*)BMP_Arial_184},
{ 185,1,14, 4,255,(char*)BMP_Arial_185},
{ 186,1,14, 6,255,(char*)BMP_Arial_186},
{ 187,1,14, 7,255,(char*)BMP_Arial_187},
{ 188,1,14,13,255,(char*)BMP_Arial_188},
{ 189,1,14,13,255,(char*)BMP_Arial_189},
{ 190,1,14,14,255,(char*)BMP_Arial_190},
{ 191,1,14, 8,255,(char*)BMP_Arial_191},
{ 192,1,14,10,255,(char*)BMP_Arial_192},
{ 193,1,14,10,255,(char*)BMP_Arial_193},
{ 194,1,14,10,255,(char*)BMP_Arial_194},
{ 195,1,14,10,255,(char*)BMP_Arial_195},
{ 196,1,14,10,255,(char*)BMP_Arial_196},
{ 197,1,14,10,255,(char*)BMP_Arial_197},
{ 198,1,14,15,255,(char*)BMP_Arial_198},
{ 199,1,14,10,255,(char*)BMP_Arial_199},
{ 200,1,14, 9,255,(char*)BMP_Arial_200},
{ 201,1,14, 9,255,(char*)BMP_Arial_201},
{ 202,1,14, 9,255,(char*)BMP_Arial_202},
{ 203,1,14, 9,255,(char*)BMP_Arial_203},
{ 204,1,14, 3,255,(char*)BMP_Arial_204},
{ 205,1,14, 3,255,(char*)BMP_Arial_205},
{ 206,1,14, 5,255,(char*)BMP_Arial_206},
{ 207,1,14, 4,255,(char*)BMP_Arial_207},
{ 208,1,14,11,255,(char*)BMP_Arial_208},
{ 209,1,14, 9,255,(char*)BMP_Arial_209},
{ 210,1,14,11,255,(char*)BMP_Arial_210},
{ 211,1,14,11,255,(char*)BMP_Arial_211},
{ 212,1,14,11,255,(char*)BMP_Arial_212},
{ 213,1,14,11,255,(char*)BMP_Arial_213},
{ 214,1,14,11,255,(char*)BMP_Arial_214},
{ 215,1,14, 8,255,(char*)BMP_Arial_215},
{ 216,1,14,11,255,(char*)BMP_Arial_216},
{ 217,1,14, 9,255,(char*)BMP_Arial_217},
{ 218,1,14, 9,255,(char*)BMP_Arial_218},
{ 219,1,14, 9,255,(char*)BMP_Arial_219},
{ 220,1,14, 9,255,(char*)BMP_Arial_220},
{ 221,1,14,10,255,(char*)BMP_Arial_221},
{ 222,1,14, 9,255,(char*)BMP_Arial_222},
{ 223,1,14, 8,255,(char*)BMP_Arial_223},
{ 224,1,14, 7,255,(char*)BMP_Arial_224},
{ 225,1,14, 7,255,(char*)BMP_Arial_225},
{ 226,1,14, 7,255,(char*)BMP_Arial_226},
{ 227,1,14, 7,255,(char*)BMP_Arial_227},
{ 228,1,14, 7,255,(char*)BMP_Arial_228},
{ 229,1,14, 7,255,(char*)BMP_Arial_229},
{ 230,1,14,13,255,(char*)BMP_Arial_230},
{ 231,1,14, 7,255,(char*)BMP_Arial_231},
{ 232,1,14, 7,255,(char*)BMP_Arial_232},
{ 233,1,14, 7,255,(char*)BMP_Arial_233},
{ 234,1,14, 7,255,(char*)BMP_Arial_234},
{ 235,1,14, 7,255,(char*)BMP_Arial_235},
{ 236,1,14, 3,255,(char*)BMP_Arial_236},
{ 237,1,14, 3,255,(char*)BMP_Arial_237},
{ 238,1,14, 5,255,(char*)BMP_Arial_238},
{ 239,1,14, 4,255,(char*)BMP_Arial_239},
{ 240,1,14, 7,255,(char*)BMP_Arial_240},
{ 241,1,14, 7,255,(char*)BMP_Arial_241},
{ 242,1,14, 7,255,(char*)BMP_Arial_242},
{ 243,1,14, 7,255,(char*)BMP_Arial_243},
{ 244,1,14, 7,255,(char*)BMP_Arial_244},
{ 245,1,14, 7,255,(char*)BMP_Arial_245},
{ 246,1,14, 7,255,(char*)BMP_Arial_246},
{ 247,1,14, 8,255,(char*)BMP_Arial_247},
{ 248,1,14, 7,255,(char*)BMP_Arial_248},
{ 249,1,14, 7,255,(char*)BMP_Arial_249},
{ 250,1,14, 7,255,(char*)BMP_Arial_250},
{ 251,1,14, 7,255,(char*)BMP_Arial_251},
{ 252,1,14, 7,255,(char*)BMP_Arial_252},
{ 253,1,14, 8,255,(char*)BMP_Arial_253},
{ 254,1,14, 7,255,(char*)BMP_Arial_254},
{ 255,1,14, 8,255,(char*)BMP_Arial_255},
/* SPR1212 Start: Greek characters */
	{0x0393,1,14, 8,255,(char*)BMP_Gamma},    /* Gamma */
	{0x0394,1,14, 8,255,(char*) BMP_Delta},    /* Delta */
	{0x0398,1,14, 8,255,(char*) BMP_Theta},    /* Theta */
	{0x039B,1,14, 8,255,(char*) BMP_Lambda},    /* Lambda */
	{0x039e,1,14, 8,255,(char*) BMP_Xi},    /* Xi */
	{0x03A0,1,14, 7,255,(char*) BMP_Pi},    /* Pi */
	{0x03a3,1,14, 8,255,(char*) BMP_Sigma},    /* Sigma */
	{0x03A6,1,14, 8,255,(char*) BMP_Phi},    /* Phi */
	{0x03A8,1,14, 8,255,(char*) BMP_Psi},    /* Psi */
	{0x03A9,1,14, 7,255,(char*) BMP_Omega},    /* Omega */
{0xFFFF,1,12,12,24, (char *) uc2_rubbish} };
#endif
/* x0pleela 09 Nov, 2006 ER:OMAPS00099966
 * use Endurance Pro 17 Bold fonts.
 */
#ifdef FF_ENDURANCE_FONT

/* Glyph data */
const unsigned char UC2_0020[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0021[]={ 0x00, 0x00, 0x00, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0x00, 0x00, 0xE0, 0xE0, 0x00, 0x00, };
const unsigned char UC2_0022[]={ 0x00, 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0023[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x19, 0x80, 0x19, 0x80, 0x19, 0x80, 0x7F, 0xC0, 0x7F, 0xC0, 0x33, 0x00, 0x33, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x66, 0x00, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0024[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x7F, 0x00, 0xFF, 0x80, 0xCD, 0x80, 0xCC, 0x00, 0xFC, 0x00, 0x7F, 0x00, 0x0F, 0x80, 0x0D, 0x80, 0x0D, 0x80, 0xCD, 0x80, 0xFF, 0x80, 0x7F, 0x00, 0x0C, 0x00, 0x00, 0x00, };
const unsigned char UC2_0025[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x30, 0xFC, 0x20, 0xCC, 0x60, 0xCC, 0xC0, 0xCC, 0xBC, 0xCD, 0xFE, 0xFF, 0x66, 0x7A, 0x66, 0x06, 0x66, 0x0C, 0x66, 0x08, 0x7E, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0026[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1E, 0x00, 0x3F, 0x00, 0x33, 0x00, 0x33, 0x00, 0x36, 0x00, 0x3C, 0x00, 0x6C, 0xC0, 0xCD, 0x80, 0xC7, 0x80, 0xC7, 0x00, 0x7F, 0xE0, 0x3D, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0027[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0028[]={ 0x00, 0x00, 0x00, 0x38, 0x70, 0x60, 0x60, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x60, 0x60, 0x70, 0x38, };
const unsigned char UC2_0029[]={ 0x00, 0x00, 0x00, 0xE0, 0x70, 0x30, 0x30, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x30, 0x30, 0x70, 0xE0, };
const unsigned char UC2_002A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0xDB, 0x00, 0xFF, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_002B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_002C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0xC0, };
const unsigned char UC2_002D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_002E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_002F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x06, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x18, 0x00, 0x30, 0x00, 0x30, 0x00, 0x60, 0x00, 0x60, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0030[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE7, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0031[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x00, 0x78, 0x00, 0xF8, 0x00, 0xD8, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0032[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xC7, 0x00, 0x03, 0x00, 0x03, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0033[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xC3, 0x00, 0x03, 0x00, 0x03, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x03, 0x00, 0x03, 0x00, 0xC3, 0x00, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0034[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1E, 0x00, 0x36, 0x00, 0x66, 0x00, 0x66, 0x00, 0xC6, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x06, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0035[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xDC, 0x00, 0xFE, 0x00, 0xE7, 0x00, 0x03, 0x00, 0x03, 0x00, 0xC7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0036[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xDC, 0x00, 0xFE, 0x00, 0xE7, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0037[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0038[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0x7E, 0x00, 0x7E, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0039[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE7, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7F, 0x00, 0x3B, 0x00, 0x03, 0x00, 0xC7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_003A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_003B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0xC0, };
const unsigned char UC2_003C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x0F, 0x80, 0x3E, 0x00, 0xF0, 0x00, 0xC0, 0x00, 0xF0, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_003D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_003E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xF8, 0x00, 0x3E, 0x00, 0x07, 0x80, 0x01, 0x80, 0x07, 0x80, 0x3E, 0x00, 0xF8, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_003F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x00, 0x43, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0040[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xE0, 0x1F, 0xF8, 0x38, 0x1C, 0x73, 0xEC, 0x67, 0xE6, 0xCC, 0x66, 0xCC, 0x66, 0xCC, 0x66, 0xCC, 0x6C, 0xCF, 0xFC, 0x67, 0xB8, 0x70, 0x00, 0x3F, 0xF8, 0x0F, 0xF0, };
const unsigned char UC2_0041[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0042[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0xFF, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0043[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0044[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC1, 0xC0, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0045[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0046[]={ 0x00, 0x00, 0x00, 0xFE, 0xFE, 0xC0, 0xC0, 0xC0, 0xFE, 0xFE, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0047[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC7, 0xC0, 0xC7, 0xC0, 0xC0, 0xC0, 0x60, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0048[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xFF, 0xE0, 0xFF, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0049[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_004A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x0F, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x43, 0x00, 0xE3, 0x00, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_004B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF0, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_004C[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xFE, 0xFE, 0x00, 0x00, };
const unsigned char UC2_004D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x1C, 0xF0, 0x3C, 0xF0, 0x3C, 0xF0, 0x3C, 0xD8, 0x6C, 0xD8, 0x6C, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xC7, 0x8C, 0xC7, 0x8C, 0xC3, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_004E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_004F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0050[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0051[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x07, 0xC0, 0x03, 0xC0, };
const unsigned char UC2_0052[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0053[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0054[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0055[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0056[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x60, 0xC0, 0x60, 0x60, 0xC0, 0x60, 0xC0, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0057[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0xC1, 0x80, 0xC1, 0xC1, 0x80, 0x61, 0xC3, 0x00, 0x63, 0x63, 0x00, 0x63, 0x63, 0x00, 0x33, 0x66, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0058[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x30, 0x60, 0x60, 0x30, 0xC0, 0x19, 0x80, 0x0F, 0x00, 0x06, 0x00, 0x06, 0x00, 0x0F, 0x00, 0x19, 0x80, 0x30, 0xC0, 0x60, 0x60, 0xC0, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0059[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_005A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xC0, 0x7F, 0xC0, 0x01, 0x80, 0x03, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_005B[]={ 0x00, 0x00, 0x00, 0xF8, 0xF8, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xF8, 0xF8, };
const unsigned char UC2_005C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x60, 0x00, 0x60, 0x00, 0x30, 0x00, 0x30, 0x00, 0x18, 0x00, 0x18, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x06, 0x00, 0x06, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_005D[]={ 0x00, 0x00, 0x00, 0xF8, 0xF8, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xF8, 0xF8, };
const unsigned char UC2_005E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x1E, 0x00, 0x33, 0x00, 0x33, 0x00, 0x61, 0x80, 0x61, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_005F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, };
const unsigned char UC2_0060[]={ 0x00, 0x00, 0x00, 0xE0, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0061[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0062[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0xFF, 0x00, 0xDE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0063[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0064[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0065[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0066[]={ 0x00, 0x00, 0x00, 0x38, 0x78, 0x60, 0xF8, 0xF8, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, };
const unsigned char UC2_0067[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0068[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0069[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_006A[]={ 0x00, 0x30, 0x30, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0xF0, 0xE0, 0x00, 0x00, };
const unsigned char UC2_006B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_006C[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_006D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDC, 0x70, 0xFE, 0xF8, 0xE7, 0x9C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_006E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_006F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0070[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0xFF, 0x00, 0xDE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0071[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x01, 0x80, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0072[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xD8, 0xF8, 0xE0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0073[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x00, 0x00, };
const unsigned char UC2_0074[]={ 0x00, 0x00, 0x00, 0x00, 0x20, 0x60, 0xF8, 0xF8, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x38, 0x00, 0x00, };
const unsigned char UC2_0075[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0076[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0077[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0x61, 0x86, 0x00, 0x63, 0xC6, 0x00, 0x63, 0xC6, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x1C, 0x38, 0x00, 0x1C, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0078[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x1E, 0x00, 0x33, 0x00, 0x61, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0079[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_007A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_007B[]={ 0x00, 0x00, 0x00, 0x1C, 0x3C, 0x30, 0x30, 0x30, 0x30, 0xE0, 0xE0, 0x30, 0x30, 0x30, 0x30, 0x3C, 0x1C, };
const unsigned char UC2_007C[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, };
const unsigned char UC2_007D[]={ 0x00, 0x00, 0x00, 0xE0, 0xF0, 0x30, 0x30, 0x30, 0x30, 0x1C, 0x1C, 0x30, 0x30, 0x30, 0x30, 0xF0, 0xE0, };
const unsigned char UC2_007E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x80, 0xFF, 0x80, 0x8F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00FF[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, };
const unsigned char UC2_00AD[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0xE0, 0x00, 0x00, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, };
const unsigned char UC2_00BD[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x30, 0xF0, 0x60, 0xB0, 0xC0, 0x30, 0x80, 0x31, 0xF0, 0x33, 0xF8, 0xFE, 0x18, 0xFE, 0x18, 0x04, 0x60, 0x0C, 0xC0, 0x19, 0xF8, 0x31, 0xF8, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0153[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x78, 0x7E, 0xFC, 0xE7, 0x8E, 0xC3, 0x06, 0xC3, 0xFE, 0xC3, 0x00, 0xE7, 0x86, 0x7E, 0xFC, 0x3C, 0x78, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00CF[]={ 0xCC, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_00BE[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x18, 0xFC, 0x30, 0x0C, 0x60, 0x38, 0x40, 0x3C, 0xCC, 0xCD, 0x9C, 0xFD, 0x9C, 0x7B, 0x2C, 0x02, 0x2C, 0x06, 0x7E, 0x0C, 0x7E, 0x18, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00DD[]={ 0x07, 0x00, 0x0C, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F9[]={ 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x18, 0x00, 0x04, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B8[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xC0, };
const unsigned char UC2_00A6[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, };
const unsigned char UC2_00AE[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x30, 0xC0, 0x4F, 0x20, 0x4F, 0xA0, 0x8D, 0x90, 0x8D, 0x90, 0x8F, 0x10, 0x8D, 0x90, 0x4D, 0xA0, 0x4D, 0xA0, 0x30, 0xC0, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00AA[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0x06, 0x00, 0x7E, 0x00, 0xC6, 0x00, 0xFF, 0x00, 0x77, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F0[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x72, 0x00, 0x1E, 0x00, 0x7C, 0x00, 0x46, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A9[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x30, 0xC0, 0x47, 0x20, 0x4F, 0xA0, 0x98, 0xD0, 0x98, 0x10, 0x98, 0x10, 0x98, 0xD0, 0x4F, 0xA0, 0x47, 0x20, 0x30, 0x40, 0x0F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00EE[]={ 0x00, 0x00, 0x00, 0x70, 0xD8, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_00F8[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x80, 0x7F, 0x00, 0xE3, 0x80, 0xC5, 0x80, 0xC9, 0x80, 0xD1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0xBE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F1[]={ 0x00, 0x00, 0x00, 0x00, 0x31, 0x00, 0x7F, 0x00, 0x4E, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00FD[]={ 0x00, 0x00, 0x00, 0x00, 0x03, 0x80, 0x06, 0x00, 0x08, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, };
const unsigned char UC2_00FC[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7F, 0x00, 0x3B, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00EF[]={ 0x00, 0x00, 0x00, 0xCC, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_00E6[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xF8, 0xFF, 0xFC, 0x03, 0x8E, 0x7F, 0x06, 0xFF, 0xFE, 0xC3, 0x00, 0xC7, 0x86, 0xFD, 0xFC, 0x78, 0xF8, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00FA[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00FB[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC0, 0x00, 0x78, 0x00, 0xFE, 0x00, 0xC7, 0x00, 0xE3, 0x00, 0x7F, 0x00, 0x1E, 0x00, 0x03, 0x00, 0xC3, 0x00, 0xFF, 0x00, 0x7E, 0x00, };
const unsigned char UC2_00AF[]={ 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00AC[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00AB[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1C, 0xE0, 0x39, 0xC0, 0x73, 0x80, 0xE7, 0x00, 0x73, 0x80, 0x39, 0xC0, 0x1C, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F3[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A8[]={ 0xCC, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B5[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0xFF, 0xE0, 0xDC, 0xE0, 0xC0, 0x00, 0xC0, 0x00, };
const unsigned char UC2_00B6[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x80, 0xFF, 0x80, 0xFB, 0x00, 0xFB, 0x00, 0xFB, 0x00, 0x7B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, };
const unsigned char UC2_00C7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x0C, 0x00, 0x18, 0x00, };
const unsigned char UC2_2019[]={ 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x60, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_20AC[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0x60, 0x80, 0xFC, 0x00, 0x60, 0x00, 0xFC, 0x00, 0x60, 0x00, 0x60, 0x80, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D4[]={ 0x0F, 0x00, 0x19, 0x80, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D2[]={ 0x38, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D3[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00DE[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D6[]={ 0x19, 0x80, 0x19, 0x80, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x00, 0xE3, 0x80, 0x77, 0x00, 0x3E, 0x00, 0x1C, 0x00, 0x3E, 0x00, 0x77, 0x00, 0xE3, 0x80, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D8[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x60, 0x3F, 0xC0, 0x71, 0xC0, 0xE3, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xCC, 0x60, 0xCC, 0x60, 0xD8, 0xE0, 0x71, 0xC0, 0x7F, 0x80, 0xDF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D1[]={ 0x0C, 0x40, 0x1F, 0xC0, 0x13, 0x80, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A5[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x7F, 0x80, 0x0C, 0x00, 0x7F, 0x80, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E3[]={ 0x00, 0x00, 0x00, 0x00, 0x31, 0x00, 0x7F, 0x00, 0x4E, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E0[]={ 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x18, 0x00, 0x04, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E2[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E5[]={ 0x00, 0x00, 0x18, 0x00, 0x24, 0x00, 0x24, 0x00, 0x18, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2122[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x30, 0xFF, 0x30, 0x33, 0xF0, 0x32, 0xD0, 0x32, 0xD0, 0x32, 0xD0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00EB[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E9[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00EA[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0161[]={ 0x00, 0x00, 0x00, 0x66, 0x3C, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x00, 0x00, };
const unsigned char UC2_00ED[]={ 0x00, 0x00, 0x38, 0x60, 0x80, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, };
const unsigned char UC2_00E8[]={ 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x18, 0x00, 0x04, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E1[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2026[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC6, 0x60, 0xC6, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0192[]={ 0x00, 0x00, 0x00, 0x1E, 0x3E, 0x30, 0x30, 0xFC, 0xFC, 0x60, 0x60, 0x60, 0x60, 0xC0, 0xC0, 0xC0, 0xC0, };
const unsigned char UC2_00C6[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xFF, 0x00, 0x07, 0xFF, 0x00, 0x06, 0xC0, 0x00, 0x0C, 0xC0, 0x00, 0x0C, 0xC0, 0x00, 0x18, 0xFE, 0x00, 0x18, 0xFE, 0x00, 0x3F, 0xC0, 0x00, 0x3F, 0xC0, 0x00, 0x60, 0xC0, 0x00, 0x60, 0xFF, 0x00, 0xC0, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_201E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0xCC, };
const unsigned char UC2_2020[]={ 0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0xFC, 0xFC, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, };
const unsigned char UC2_2018[]={ 0x00, 0x00, 0x00, 0x60, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2021[]={ 0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0xFC, 0xFC, 0x30, 0x30, 0x30, 0x30, 0xFC, 0xFC, 0x30, 0x30, 0x30, };
const unsigned char UC2_0160[]={ 0x19, 0x80, 0x0F, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_201A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0xC0, };
const unsigned char UC2_02C6[]={ 0x00, 0x00, 0x78, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2030[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x71, 0x80, 0x00, 0xF9, 0x00, 0x00, 0xDB, 0x00, 0x00, 0xDA, 0x00, 0x00, 0xDD, 0xC7, 0x00, 0xDF, 0xEF, 0x80, 0xFF, 0x6D, 0x80, 0x77, 0x6D, 0x80, 0x0B, 0x6D, 0x80, 0x1B, 0x6D, 0x80, 0x13, 0xEF, 0x80, 0x31, 0xC7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A1[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0xE0, 0x00, 0x00, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, 0xE0, };
const unsigned char UC2_0152[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xFE, 0x7F, 0xFE, 0x61, 0x80, 0xE1, 0x80, 0xC1, 0x80, 0xC1, 0xFC, 0xC1, 0xFC, 0xC1, 0x80, 0xE1, 0x80, 0x71, 0x80, 0x3F, 0xFE, 0x1F, 0xFE, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2039[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1C, 0x38, 0x70, 0xE0, 0x70, 0x38, 0x1C, 0x00, 0x00, 0x00, };
const unsigned char UC2_00D0[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x80, 0x7F, 0xC0, 0x60, 0xE0, 0x60, 0x70, 0x60, 0x30, 0xF8, 0x30, 0xF8, 0x30, 0x60, 0x30, 0x60, 0x70, 0x60, 0xE0, 0x7F, 0xC0, 0x7F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A4[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x6D, 0x80, 0x3F, 0x00, 0x33, 0x00, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x3F, 0x00, 0x6D, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2022[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xF8, 0xF8, 0xF8, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A2[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, };
const unsigned char UC2_201C[]={ 0x00, 0x00, 0x00, 0x66, 0xCC, 0xCC, 0xCC, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00E4[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x33, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_201D[]={ 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F6[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_203A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x70, 0x38, 0x1C, 0x38, 0x70, 0xE0, 0x00, 0x00, 0x00, };
const unsigned char UC2_2014[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x80, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00A3[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x31, 0x80, 0x30, 0x00, 0x30, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0x30, 0x00, 0x30, 0x00, 0x60, 0xC0, 0xFF, 0xC0, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2013[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00EC[]={ 0x00, 0x00, 0x00, 0xC0, 0x70, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_00E7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x30, 0x00, };
const unsigned char UC2_02DC[]={ 0x00, 0x62, 0xFE, 0x9C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0100[]={ 0x1F, 0x80, 0x1F, 0x80, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0101[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0102[]={ 0x31, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0103[]={ 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0104[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0xC0, 0x00, 0x60, };
const unsigned char UC2_0105[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x03, 0x00, 0x01, 0x80, };
const unsigned char UC2_0106[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0107[]={ 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x18, 0x00, 0x20, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0108[]={ 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0109[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_010A[]={ 0x06, 0x00, 0x06, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_010B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_010C[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_010D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_010E[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC1, 0xC0, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_010F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xB0, 0x01, 0xB0, 0x01, 0x90, 0x3D, 0xA0, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0110[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0xE0, 0x60, 0x60, 0xF8, 0x60, 0xF8, 0x60, 0x60, 0x60, 0x60, 0xE0, 0x61, 0xC0, 0x7F, 0x80, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0111[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x07, 0xC0, 0x01, 0x80, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0112[]={ 0x7E, 0x00, 0x7E, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0113[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0114[]={ 0x66, 0x00, 0x3C, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0115[]={ 0x00, 0x00, 0x00, 0x00, 0x63, 0x00, 0x3E, 0x00, 0x1C, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0116[]={ 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0117[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0118[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x06, 0x00, 0x03, 0x00, };
const unsigned char UC2_0119[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x0C, 0x00, 0x06, 0x00, };
const unsigned char UC2_011A[]={ 0x66, 0x00, 0x3C, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_011B[]={ 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_011C[]={ 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC7, 0xC0, 0xC7, 0xC0, 0xC0, 0xC0, 0x60, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_011D[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0x7E, 0x00, };
const unsigned char UC2_011E[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC7, 0xC0, 0xC7, 0xC0, 0xC0, 0xC0, 0x60, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_011F[]={ 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x00, 0x00, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0x7E, 0x00, };
const unsigned char UC2_0120[]={ 0x06, 0x00, 0x06, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC7, 0xC0, 0xC7, 0xC0, 0xC0, 0xC0, 0x60, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0121[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0x7E, 0x00, };
const unsigned char UC2_0122[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC7, 0xC0, 0xC7, 0xC0, 0xC0, 0xC0, 0x60, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0123[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x3D, 0x80, 0x7F, 0x80, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0x7E, 0x00, };
const unsigned char UC2_0124[]={ 0x0F, 0x00, 0x19, 0x80, 0x00, 0x00, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xFF, 0xE0, 0xFF, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0125[]={ 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0126[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x60, 0xFF, 0xF0, 0xFF, 0xF0, 0x60, 0x60, 0x7F, 0xE0, 0x7F, 0xE0, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0127[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0xF8, 0x00, 0x60, 0x00, 0x6F, 0x00, 0x7F, 0x80, 0x71, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0128[]={ 0x62, 0xFE, 0x9C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_0129[]={ 0x00, 0x00, 0x64, 0xFC, 0xB8, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_012A[]={ 0xFC, 0xFC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_012B[]={ 0x00, 0x00, 0x00, 0xF8, 0xF8, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_012C[]={ 0xCC, 0x78, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_012D[]={ 0x00, 0x00, 0xCC, 0x78, 0x30, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_012E[]={ 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0xC0, 0x60, };
const unsigned char UC2_012F[]={ 0x00, 0x00, 0x00, 0x60, 0x60, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0xC0, 0x60, };
const unsigned char UC2_0130[]={ 0xC0, 0xC0, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_00D5[]={ 0x0C, 0x40, 0x1F, 0xC0, 0x13, 0x80, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0132[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x78, 0xC0, 0x78, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xC2, 0x18, 0xC7, 0x18, 0xC3, 0xF8, 0xC1, 0xF0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0133[]={ 0x00, 0x00, 0x00, 0xC6, 0xC6, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0x1E, 0x1C, };
const unsigned char UC2_0134[]={ 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x0F, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x43, 0x00, 0xE3, 0x00, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0135[]={ 0x00, 0x00, 0x30, 0x78, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0xF0, 0xE0, };
const unsigned char UC2_0136[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF0, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0137[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0x00, 0x00, 0x30, 0x00, };
const unsigned char UC2_0138[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0139[]={ 0x38, 0x60, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xFE, 0xFE, 0x00, 0x00, };
const unsigned char UC2_013A[]={ 0x70, 0xC0, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_013B[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xFE, 0xFE, 0x00, 0x30, };
const unsigned char UC2_013C[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0xC0, };
const unsigned char UC2_013D[]={ 0x00, 0x00, 0x00, 0xC6, 0xC6, 0xC2, 0xC4, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xFE, 0xFE, 0x00, 0x00, };
const unsigned char UC2_013E[]={ 0x00, 0x00, 0x00, 0xD8, 0xD8, 0xC8, 0xD0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_013F[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC6, 0xC6, 0xC0, 0xC0, 0xC0, 0xFE, 0xFE, 0x00, 0x00, };
const unsigned char UC2_0140[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xCC, 0xCC, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0141[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x32, 0x00, 0x36, 0x00, 0x3C, 0x00, 0x38, 0x00, 0x70, 0x00, 0xF0, 0x00, 0xB0, 0x00, 0x3F, 0x80, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0142[]={ 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x60, 0x70, 0x70, 0xE0, 0xE0, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, };
const unsigned char UC2_0143[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0144[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0145[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0xE0, 0x00, 0x00, 0x06, 0x00, };
const unsigned char UC2_0146[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0147[]={ 0x19, 0x80, 0x0F, 0x00, 0x00, 0x00, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0148[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0149[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x60, 0x00, 0x60, 0x00, 0x6D, 0xE0, 0xEF, 0xF0, 0xCE, 0x38, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_014A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0x60, 0x03, 0xE0, 0x03, 0xC0, };
const unsigned char UC2_014B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x07, 0x80, 0x07, 0x00, };
const unsigned char UC2_014C[]={ 0x1F, 0x80, 0x1F, 0x80, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_014D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_014E[]={ 0x19, 0x80, 0x0F, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_014F[]={ 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0150[]={ 0x0E, 0xE0, 0x19, 0x80, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0151[]={ 0x00, 0x00, 0x00, 0x00, 0x3B, 0x80, 0x66, 0x00, 0x44, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0154[]={ 0x07, 0x00, 0x0C, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0155[]={ 0x00, 0x00, 0x38, 0x60, 0x80, 0x00, 0xD8, 0xF8, 0xE0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0156[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0157[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6C, 0x7C, 0x70, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0xC0, };
const unsigned char UC2_0158[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0159[]={ 0x00, 0x00, 0xCC, 0x78, 0x30, 0x00, 0x6C, 0x7C, 0x70, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, };
const unsigned char UC2_015A[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_015B[]={ 0x00, 0x00, 0x0E, 0x18, 0x20, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x00, 0x00, };
const unsigned char UC2_015C[]={ 0x0F, 0x00, 0x19, 0x80, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_015D[]={ 0x00, 0x00, 0x18, 0x3C, 0x66, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x00, 0x00, };
const unsigned char UC2_015E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x06, 0x00, 0x0C, 0x00, };
const unsigned char UC2_015F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x18, 0x30, };
const unsigned char UC2_0162[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0163[]={ 0x00, 0x00, 0x00, 0x00, 0x20, 0x60, 0xF8, 0xF8, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x38, 0x00, 0x60, };
const unsigned char UC2_0164[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0165[]={ 0x00, 0x00, 0x06, 0x06, 0x22, 0x64, 0xF8, 0xF8, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x38, 0x00, 0x00, };
const unsigned char UC2_0166[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x7F, 0x80, 0x7F, 0x80, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0167[]={ 0x00, 0x00, 0x00, 0x00, 0x20, 0x60, 0xF8, 0xF8, 0x60, 0x60, 0xF8, 0xF8, 0x60, 0x78, 0x38, 0x00, 0x00, };
const unsigned char UC2_0168[]={ 0x18, 0x80, 0x3F, 0x80, 0x27, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0169[]={ 0x00, 0x00, 0x00, 0x00, 0x31, 0x00, 0x7F, 0x00, 0x4E, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_016A[]={ 0x1F, 0x80, 0x1F, 0x80, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_016B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x3E, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_016C[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_016D[]={ 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_016E[]={ 0x0C, 0x00, 0x12, 0x00, 0x12, 0x00, 0xCC, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_016F[]={ 0x00, 0x00, 0x18, 0x00, 0x24, 0x00, 0x24, 0x00, 0x18, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0170[]={ 0x0D, 0xC0, 0x3B, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0171[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1B, 0x80, 0x76, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0172[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x0C, 0x00, 0x06, 0x00, };
const unsigned char UC2_0173[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x80, 0x3D, 0x80, 0x03, 0x00, 0x01, 0x80, };
const unsigned char UC2_0174[]={ 0x01, 0xE0, 0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x00, 0xC1, 0xC1, 0x80, 0xC1, 0xC1, 0x80, 0x61, 0xC3, 0x00, 0x63, 0x63, 0x00, 0x63, 0x63, 0x00, 0x33, 0x66, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0175[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x03, 0xC0, 0x00, 0x06, 0x60, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0x61, 0x86, 0x00, 0x63, 0xC6, 0x00, 0x63, 0xC6, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x1C, 0x38, 0x00, 0x1C, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0176[]={ 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0177[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, };
const unsigned char UC2_0178[]={ 0x33, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x3F, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0179[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0x7F, 0xC0, 0x7F, 0xC0, 0x01, 0x80, 0x03, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_017A[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_017B[]={ 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x7F, 0xC0, 0x7F, 0xC0, 0x01, 0x80, 0x03, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_017C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_017D[]={ 0x33, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x7F, 0xC0, 0x7F, 0xC0, 0x01, 0x80, 0x03, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_017E[]={ 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_017F[]={ 0x00, 0x00, 0x00, 0x70, 0xF0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_01FA[]={ 0x03, 0x00, 0x06, 0x00, 0x09, 0x00, 0x09, 0x00, 0x06, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x3F, 0x80, 0x3F, 0x80, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_01FB[]={ 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x24, 0x00, 0x18, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_01FC[]={ 0x00, 0x1C, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0x03, 0xFF, 0x00, 0x07, 0xFF, 0x00, 0x06, 0xC0, 0x00, 0x0C, 0xC0, 0x00, 0x0C, 0xC0, 0x00, 0x18, 0xFE, 0x00, 0x18, 0xFE, 0x00, 0x3F, 0xC0, 0x00, 0x3F, 0xC0, 0x00, 0x60, 0xC0, 0x00, 0x60, 0xFF, 0x00, 0xC0, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_01FD[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x01, 0x80, 0x02, 0x00, 0x00, 0x00, 0x7C, 0xF8, 0xFF, 0xFC, 0x03, 0x8E, 0x7F, 0x06, 0xFF, 0xFE, 0xC3, 0x00, 0xC7, 0x86, 0xFD, 0xFC, 0x78, 0xF8, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_01FE[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0x1F, 0x60, 0x3F, 0xC0, 0x71, 0xC0, 0xE3, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xCC, 0x60, 0xCC, 0x60, 0xD8, 0xE0, 0x71, 0xC0, 0x7F, 0x80, 0xDF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_01FF[]={ 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x00, 0x00, 0x3E, 0x80, 0x7F, 0x00, 0xE3, 0x80, 0xC5, 0x80, 0xC9, 0x80, 0xD1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0xBE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0218[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x06, 0x00, };
const unsigned char UC2_0219[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x00, 0x30, };
const unsigned char UC2_02C7[]={ 0x00, 0x00, 0x00, 0xCC, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_02C9[]={ 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_02D8[]={ 0x00, 0x00, 0x00, 0xD8, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_02D9[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_02DA[]={ 0x60, 0x90, 0x90, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_02DB[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x60, };
const unsigned char UC2_02DD[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x37, 0x00, 0xEC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_037E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0xC0, };
const unsigned char UC2_0384[]={ 0x00, 0x00, 0x00, 0xC0, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0385[]={ 0x00, 0x00, 0x18, 0xD6, 0xD6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0386[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC7, 0x00, 0x87, 0x00, 0x8D, 0x80, 0x0D, 0x80, 0x0D, 0x80, 0x18, 0xC0, 0x18, 0xC0, 0x1F, 0xC0, 0x3F, 0xE0, 0x30, 0x60, 0x30, 0x60, 0x60, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0387[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0388[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDF, 0xE0, 0x9F, 0xE0, 0x98, 0x00, 0x18, 0x00, 0x18, 0x00, 0x1F, 0xC0, 0x1F, 0xC0, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x1F, 0xE0, 0x1F, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0389[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xD8, 0x0C, 0x98, 0x0C, 0x98, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x1F, 0xFC, 0x1F, 0xFC, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x18, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_038A[]={ 0x00, 0x00, 0x00, 0xD8, 0x98, 0x98, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, };
const unsigned char UC2_038C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC7, 0xC0, 0x8F, 0xE0, 0x9C, 0x70, 0x38, 0x38, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x38, 0x38, 0x1C, 0x70, 0x0F, 0xE0, 0x07, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_038E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xCC, 0x0C, 0x86, 0x18, 0x86, 0x18, 0x03, 0x30, 0x03, 0x30, 0x01, 0xE0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_038F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC7, 0xC0, 0x9F, 0xF0, 0x98, 0x30, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x18, 0x30, 0x18, 0x30, 0x0C, 0x60, 0x3C, 0x78, 0x3C, 0x78, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0390[]={ 0x00, 0x00, 0x18, 0xD6, 0xD6, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x38, 0x00, 0x00, };
const unsigned char UC2_0391[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0392[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0xFF, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0393[]={ 0x00, 0x00, 0x00, 0xFE, 0xFE, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0394[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x60, 0xC0, 0x60, 0xC0, 0xFF, 0xE0, 0xFF, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0395[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0396[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xC0, 0x7F, 0xC0, 0x01, 0x80, 0x03, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0397[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xFF, 0xE0, 0xFF, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0398[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xDF, 0x60, 0xDF, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0399[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_039A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF0, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_039B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_039C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x1C, 0xF0, 0x3C, 0xF0, 0x3C, 0xF0, 0x3C, 0xD8, 0x6C, 0xD8, 0x6C, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xC7, 0x8C, 0xC7, 0x8C, 0xC3, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_039D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xD8, 0x60, 0xD8, 0x60, 0xCC, 0x60, 0xC6, 0x60, 0xC6, 0x60, 0xC3, 0x60, 0xC1, 0xE0, 0xC1, 0xE0, 0xC0, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_039E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_039F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A0[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A1[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A3[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x60, 0x00, 0x30, 0x00, 0x18, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A4[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A5[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A6[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x1F, 0x80, 0x7F, 0xE0, 0x66, 0x60, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0x66, 0x60, 0x7F, 0xE0, 0x1F, 0x80, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x30, 0x60, 0x60, 0x30, 0xC0, 0x19, 0x80, 0x0F, 0x00, 0x06, 0x00, 0x06, 0x00, 0x0F, 0x00, 0x19, 0x80, 0x30, 0xC0, 0x60, 0x60, 0xC0, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A8[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0x63, 0x18, 0x7F, 0xF8, 0x1F, 0xE0, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03A9[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x7F, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0x60, 0xC0, 0x60, 0xC0, 0x31, 0x80, 0xF1, 0xE0, 0xF1, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03AA[]={ 0xCC, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_03AB[]={ 0x33, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03AC[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x08, 0x00, 0x00, 0x00, 0x3C, 0x60, 0x7E, 0xC0, 0xE6, 0xC0, 0xC3, 0x80, 0xC3, 0x80, 0xC3, 0x80, 0xE6, 0xC0, 0x7E, 0xC0, 0x3C, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03AD[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x08, 0x00, 0x00, 0x00, 0x7C, 0x00, 0xFE, 0x00, 0xC3, 0x00, 0xC0, 0x00, 0x78, 0x00, 0xC0, 0x00, 0xC3, 0x00, 0xFE, 0x00, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03AE[]={ 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0xE7, 0x00, 0xFF, 0x80, 0x39, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x00, 0xC0, 0x00, 0xC0, };
const unsigned char UC2_03AF[]={ 0x00, 0x00, 0x60, 0x40, 0x40, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xF0, 0x70, 0x00, 0x00, };
const unsigned char UC2_03B0[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x6B, 0x00, 0x6B, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03B1[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x60, 0x7E, 0xC0, 0xE6, 0xC0, 0xC3, 0x80, 0xC3, 0x80, 0xC3, 0x80, 0xE6, 0xC0, 0x7E, 0xC0, 0x3C, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03B2[]={ 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xC6, 0xC6, 0xD8, 0xDC, 0xC6, 0xC6, 0xC6, 0xFE, 0xFC, 0xC0, 0xC0, };
const unsigned char UC2_03B3[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0x61, 0x80, 0x63, 0x00, 0x33, 0x00, 0x32, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x18, 0x00, };
const unsigned char UC2_03B4[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0x7F, 0x00, 0x18, 0x00, 0x0C, 0x00, 0x3E, 0x00, 0x7E, 0x00, 0xE7, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03B5[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0x00, 0xFE, 0x00, 0xC3, 0x00, 0xC0, 0x00, 0x78, 0x00, 0xC0, 0x00, 0xC3, 0x00, 0xFE, 0x00, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03B6[]={ 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x0C, 0x18, 0x30, 0x60, 0x60, 0xC0, 0xC0, 0xC0, 0xFC, 0x7E, 0x06, 0x0C, };
const unsigned char UC2_03B7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE7, 0x00, 0xFF, 0x80, 0x39, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x00, 0xC0, 0x00, 0xC0, };
const unsigned char UC2_03B8[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0x63, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xFF, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x63, 0x00, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03B9[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xF0, 0x70, 0x00, 0x00, };
const unsigned char UC2_03BA[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03BB[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x7C, 0x00, 0x0C, 0x00, 0x06, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x33, 0x00, 0x31, 0x80, 0x61, 0x80, 0x60, 0xE0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03BC[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0xFF, 0xE0, 0xDC, 0xE0, 0xC0, 0x00, 0xC0, 0x00, };
const unsigned char UC2_03BD[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xE1, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x36, 0x00, 0x1E, 0x00, 0x1C, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03BE[]={ 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x30, 0x60, 0x70, 0x3E, 0x7E, 0xE0, 0xC0, 0xC0, 0xFC, 0x7E, 0x06, 0x0C, };
const unsigned char UC2_03BF[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03C0[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xE0, 0xFF, 0xE0, 0xB1, 0x80, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x71, 0xE0, 0x61, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03C1[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xDE, 0x00, 0xC0, 0x00, 0xC0, 0x00, };
const unsigned char UC2_03C2[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0xE6, 0xC0, 0xC0, 0xC0, 0xC0, 0xFC, 0x7E, 0x06, 0x0C, };
const unsigned char UC2_03C3[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xC0, 0x7F, 0xC0, 0xE3, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03C4[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0x98, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03C5[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03C6[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0xC0, 0x77, 0xE0, 0xE6, 0x70, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xE6, 0x70, 0x7F, 0xE0, 0x3F, 0xC0, 0x06, 0x00, 0x06, 0x00, };
const unsigned char UC2_03C7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0x66, 0x00, 0x66, 0x00, 0x3C, 0x00, 0x18, 0x00, 0x18, 0x00, 0x38, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x66, 0x00, 0xC3, 0x00, };
const unsigned char UC2_03C8[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x06, 0x00, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xE6, 0x70, 0x7F, 0xE0, 0x3F, 0xC0, 0x06, 0x00, 0x06, 0x00, };
const unsigned char UC2_03C9[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0xC0, 0x30, 0xC0, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xE6, 0x70, 0x7F, 0xE0, 0x39, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03CA[]={ 0x00, 0x00, 0x00, 0xCC, 0xCC, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x38, 0x00, 0x00, };
const unsigned char UC2_03CB[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03CC[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x08, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03CD[]={ 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x08, 0x00, 0x08, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_03CE[]={ 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00, 0x60, 0x60, 0xC0, 0x30, 0xC0, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0xE6, 0x70, 0x7F, 0xE0, 0x39, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0401[]={ 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0402[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x18, 0x00, 0x18, 0x00, 0x1F, 0xC0, 0x1F, 0xE0, 0x18, 0x70, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x19, 0xF0, 0x19, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0403[]={ 0x1C, 0x30, 0x00, 0xFE, 0xFE, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0404[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xFC, 0x00, 0xFC, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0405[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0x60, 0x80, 0x70, 0x00, 0x3E, 0x00, 0x0F, 0x80, 0x01, 0xC0, 0x40, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0406[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0407[]={ 0xCC, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_0408[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x0F, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x43, 0x00, 0xE3, 0x00, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0409[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x00, 0x1F, 0xC0, 0x00, 0x18, 0xC0, 0x00, 0x18, 0xC0, 0x00, 0x18, 0xC0, 0x00, 0x18, 0xFC, 0x00, 0x18, 0xFE, 0x00, 0x18, 0xC3, 0x00, 0x30, 0xC3, 0x00, 0x30, 0xC3, 0x00, 0xF0, 0xFE, 0x00, 0xE0, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_040A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0xF8, 0xFF, 0xFC, 0xC1, 0x86, 0xC1, 0x86, 0xC1, 0x86, 0xC1, 0xFC, 0xC1, 0xF8, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_040B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x1F, 0xC0, 0x1F, 0xE0, 0x18, 0x70, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_040C[]={ 0x07, 0x00, 0x0C, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF0, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_040E[]={ 0x63, 0x00, 0x3E, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x1C, 0x00, 0xF8, 0x00, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_040F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0410[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0411[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0412[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0xFF, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0413[]={ 0x00, 0x00, 0x00, 0xFE, 0xFE, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0414[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xF0, 0x1F, 0xF0, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0xFF, 0xFC, 0xFF, 0xFC, 0xC0, 0x0C, 0xC0, 0x0C, };
const unsigned char UC2_0415[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0416[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0x61, 0x86, 0x00, 0x61, 0x86, 0x00, 0x31, 0x8C, 0x00, 0x19, 0x98, 0x00, 0x0F, 0xF0, 0x00, 0x1F, 0xF8, 0x00, 0x31, 0x8C, 0x00, 0x31, 0x8C, 0x00, 0x61, 0x86, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0417[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0xC1, 0x80, 0x01, 0x80, 0x01, 0x80, 0x0F, 0x00, 0x0F, 0x00, 0x01, 0x80, 0x01, 0x80, 0xC1, 0x80, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0418[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xC1, 0xE0, 0xC1, 0xE0, 0xC3, 0x60, 0xC3, 0x60, 0xC6, 0x60, 0xCC, 0x60, 0xCC, 0x60, 0xD8, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xE0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0419[]={ 0x31, 0x80, 0x1F, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xC1, 0xE0, 0xC1, 0xE0, 0xC3, 0x60, 0xC3, 0x60, 0xC6, 0x60, 0xCC, 0x60, 0xCC, 0x60, 0xD8, 0x60, 0xF0, 0x60, 0xF0, 0x60, 0xE0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_041A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xD8, 0x00, 0xF0, 0x00, 0xF8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0xC1, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_041B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xF0, 0x1F, 0xF0, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x30, 0x30, 0x30, 0x30, 0xF0, 0x30, 0xE0, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_041C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x1C, 0xF0, 0x3C, 0xF0, 0x3C, 0xF0, 0x3C, 0xD8, 0x6C, 0xD8, 0x6C, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xC7, 0x8C, 0xC7, 0x8C, 0xC3, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_041D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xFF, 0xE0, 0xFF, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_041E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x3F, 0x80, 0x71, 0xC0, 0xE0, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xE0, 0xE0, 0x71, 0xC0, 0x3F, 0x80, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_041F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0420[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC3, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0421[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0x61, 0xC0, 0xC0, 0x80, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x80, 0x61, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0422[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0423[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x1C, 0x00, 0xF8, 0x00, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0425[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x30, 0x60, 0x60, 0x30, 0xC0, 0x19, 0x80, 0x0F, 0x00, 0x06, 0x00, 0x06, 0x00, 0x0F, 0x00, 0x19, 0x80, 0x30, 0xC0, 0x60, 0x60, 0xC0, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0426[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xFF, 0xF0, 0xFF, 0xF0, 0x00, 0x30, 0x00, 0x30, };
const unsigned char UC2_0427[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE0, 0xC0, 0x7F, 0xC0, 0x3E, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0428[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0429[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xFF, 0xFF, 0x80, 0xFF, 0xFF, 0x80, 0x00, 0x01, 0x80, 0x00, 0x01, 0x80, };
const unsigned char UC2_042A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x1F, 0xC0, 0x1F, 0xE0, 0x18, 0x30, 0x18, 0x30, 0x18, 0x30, 0x1F, 0xE0, 0x1F, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_042B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x18, 0xFE, 0x18, 0xFF, 0x18, 0xC1, 0x98, 0xC1, 0x98, 0xC1, 0x98, 0xFF, 0x18, 0xFE, 0x18, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_042C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_042D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x80, 0xE1, 0xC0, 0x40, 0xC0, 0x00, 0x60, 0x0F, 0xE0, 0x0F, 0xE0, 0x00, 0x60, 0x40, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_042E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0xF8, 0x00, 0xC3, 0xFC, 0x00, 0xC7, 0x0E, 0x00, 0xCE, 0x07, 0x00, 0xCC, 0x03, 0x00, 0xFC, 0x03, 0x00, 0xFC, 0x03, 0x00, 0xCC, 0x03, 0x00, 0xCE, 0x07, 0x00, 0xC7, 0x0E, 0x00, 0xC3, 0xFC, 0x00, 0xC1, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_042F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xC0, 0x3F, 0xC0, 0x70, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x70, 0xC0, 0x3F, 0xC0, 0x1F, 0xC0, 0x18, 0xC0, 0x30, 0xC0, 0x60, 0xC0, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0430[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0x03, 0x00, 0x7F, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x80, 0x79, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0431[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x7F, 0x00, 0x70, 0x00, 0xC0, 0x00, 0xDC, 0x00, 0xFE, 0x00, 0xE7, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0432[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xFE, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xFF, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0433[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0xF8, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0434[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x80, 0x3F, 0x80, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x61, 0x80, 0x61, 0x80, 0xFF, 0xC0, 0xFF, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, };
const unsigned char UC2_0435[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0436[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x0C, 0x63, 0x18, 0x33, 0x30, 0x1F, 0xE0, 0x0F, 0xC0, 0x1B, 0x60, 0x33, 0x30, 0x63, 0x18, 0xC3, 0x0C, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0437[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0x03, 0x00, 0x1E, 0x00, 0x03, 0x00, 0xC3, 0x00, 0xFF, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0438[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x80, 0xC7, 0x80, 0xCF, 0x80, 0xDD, 0x80, 0xF9, 0x80, 0xF1, 0x80, 0xE1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0439[]={ 0x00, 0x00, 0x00, 0x00, 0x63, 0x00, 0x3E, 0x00, 0x1C, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC3, 0x80, 0xC7, 0x80, 0xCF, 0x80, 0xDD, 0x80, 0xF9, 0x80, 0xF1, 0x80, 0xE1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_043A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xF8, 0x00, 0xF0, 0x00, 0xD8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_043B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x80, 0x3F, 0x80, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0xF1, 0x80, 0xE1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_043C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x70, 0xF0, 0xF0, 0xF0, 0xF0, 0xD9, 0xB0, 0xD9, 0xB0, 0xCF, 0x30, 0xCF, 0x30, 0xC6, 0x30, 0xC6, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_043D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xFF, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_043E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_043F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0440[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0xFF, 0x00, 0xDE, 0x00, 0xC0, 0x00, 0xC0, 0x00, };
const unsigned char UC2_0441[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE3, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xE3, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0442[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0443[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, };
const unsigned char UC2_0444[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x01, 0x80, 0x00, 0x01, 0x80, 0x00, 0x3D, 0xBC, 0x00, 0x7F, 0xFE, 0x00, 0xE3, 0xC7, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xC1, 0x83, 0x00, 0xE3, 0xC7, 0x00, 0x7F, 0xFE, 0x00, 0x3D, 0xBC, 0x00, 0x01, 0x80, 0x00, 0x01, 0x80, 0x00, };
const unsigned char UC2_0445[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x1E, 0x00, 0x33, 0x00, 0x61, 0x80, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0446[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0xC0, 0xFF, 0xC0, 0x00, 0xC0, 0x00, 0xC0, };
const unsigned char UC2_0447[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC7, 0x00, 0xFF, 0x00, 0x7B, 0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0448[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xFF, 0xFC, 0xFF, 0xFC, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0449[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0x0C, 0xFF, 0xFE, 0xFF, 0xFE, 0x00, 0x06, 0x00, 0x06, };
const unsigned char UC2_044A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0x18, 0x00, 0x1F, 0x80, 0x1F, 0xC0, 0x18, 0xC0, 0x18, 0xC0, 0x1F, 0xC0, 0x1F, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_044B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xFE, 0x30, 0xFF, 0x30, 0xC3, 0x30, 0xC3, 0x30, 0xFF, 0x30, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_044C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFF, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xFF, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_044D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE7, 0x00, 0x03, 0x00, 0x1F, 0x00, 0x03, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_044E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0xE0, 0xC7, 0xF0, 0xCE, 0x38, 0xFC, 0x18, 0xFC, 0x18, 0xCC, 0x18, 0xCE, 0x38, 0xC7, 0xF0, 0xC3, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_044F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x7F, 0x00, 0x63, 0x00, 0x63, 0x00, 0x3F, 0x00, 0x1F, 0x00, 0x33, 0x00, 0x63, 0x00, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0451[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xE1, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0452[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0xF8, 0x00, 0x60, 0x00, 0x6F, 0x00, 0x7F, 0x80, 0x71, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x03, 0xC0, 0x03, 0x80, };
const unsigned char UC2_0453[]={ 0x00, 0x00, 0x38, 0x60, 0x80, 0x00, 0xF8, 0xF8, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0454[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x00, 0x7E, 0x00, 0xE7, 0x00, 0xC0, 0x00, 0xF8, 0x00, 0xC0, 0x00, 0xE7, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0455[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xF0, 0x7C, 0x0E, 0xC6, 0xFE, 0x7C, 0x00, 0x00, };
const unsigned char UC2_0456[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0457[]={ 0x00, 0x00, 0x00, 0xCC, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_0458[]={ 0x00, 0x00, 0x00, 0x30, 0x30, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0xF0, 0xE0, };
const unsigned char UC2_0459[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x80, 0x1F, 0x80, 0x31, 0x80, 0x31, 0xF8, 0x31, 0xFC, 0x31, 0x8C, 0x71, 0x8C, 0xE1, 0xFC, 0xC1, 0xF8, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_045A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xC3, 0x00, 0xFF, 0xF8, 0xFF, 0xFC, 0xC3, 0x0C, 0xC3, 0x0C, 0xC3, 0xFC, 0xC3, 0xF8, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_045B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0xF8, 0x00, 0x60, 0x00, 0x6F, 0x00, 0x7F, 0x80, 0x71, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_045C[]={ 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x18, 0x00, 0x20, 0x00, 0x00, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xF8, 0x00, 0xF0, 0x00, 0xD8, 0x00, 0xCC, 0x00, 0xC6, 0x00, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_045E[]={ 0x00, 0x00, 0x00, 0x00, 0x31, 0x80, 0x1F, 0x00, 0x0E, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, };
const unsigned char UC2_045F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xFF, 0x80, 0xFF, 0x80, 0x0C, 0x00, 0x0C, 0x00, };
const unsigned char UC2_0490[]={ 0x06, 0x06, 0x06, 0xFE, 0xFE, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_0491[]={ 0x00, 0x00, 0x00, 0x0C, 0x0C, 0x0C, 0xFC, 0xFC, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_1E80[]={ 0x07, 0x00, 0x00, 0x01, 0xC0, 0x00, 0x00, 0x00, 0x00, 0xC1, 0xC1, 0x80, 0xC1, 0xC1, 0x80, 0x61, 0xC3, 0x00, 0x63, 0x63, 0x00, 0x63, 0x63, 0x00, 0x33, 0x66, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1E81[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0x61, 0x86, 0x00, 0x63, 0xC6, 0x00, 0x63, 0xC6, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x1C, 0x38, 0x00, 0x1C, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1E82[]={ 0x00, 0x70, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0xC1, 0xC1, 0x80, 0xC1, 0xC1, 0x80, 0x61, 0xC3, 0x00, 0x63, 0x63, 0x00, 0x63, 0x63, 0x00, 0x33, 0x66, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1E83[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x00, 0x01, 0x80, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0x61, 0x86, 0x00, 0x63, 0xC6, 0x00, 0x63, 0xC6, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x1C, 0x38, 0x00, 0x1C, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1E84[]={ 0x03, 0x30, 0x00, 0x03, 0x30, 0x00, 0x00, 0x00, 0x00, 0xC1, 0xC1, 0x80, 0xC1, 0xC1, 0x80, 0x61, 0xC3, 0x00, 0x63, 0x63, 0x00, 0x63, 0x63, 0x00, 0x33, 0x66, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x36, 0x36, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x1C, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1E85[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x60, 0x00, 0x06, 0x60, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x83, 0x00, 0x61, 0x86, 0x00, 0x63, 0xC6, 0x00, 0x63, 0xC6, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x36, 0x6C, 0x00, 0x1C, 0x38, 0x00, 0x1C, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1EF2[]={ 0x70, 0x00, 0x1C, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_1EF3[]={ 0x00, 0x00, 0x00, 0x00, 0x38, 0x00, 0x0C, 0x00, 0x02, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0x61, 0x80, 0x61, 0x80, 0x33, 0x00, 0x33, 0x00, 0x1E, 0x00, 0x1E, 0x00, 0x0C, 0x00, 0x7C, 0x00, 0x78, 0x00, };
const unsigned char UC2_2015[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x80, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F2[]={ 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x18, 0x00, 0x04, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_201B[]={ 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xE0, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2032[]={ 0x00, 0x00, 0x00, 0x60, 0x60, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2033[]={ 0x00, 0x00, 0x00, 0x66, 0x66, 0xCC, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_203C[]={ 0x00, 0x00, 0x00, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0x00, 0x00, 0xEE, 0xEE, 0x00, 0x00, };
const unsigned char UC2_203E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2044[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x01, 0x80, 0x03, 0x00, 0x02, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x10, 0x00, 0x30, 0x00, 0x60, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2070[]={ 0x00, 0x00, 0x00, 0x78, 0xFC, 0xCC, 0xCC, 0xCC, 0xCC, 0xFC, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2074[]={ 0x00, 0x00, 0x00, 0x18, 0x38, 0x38, 0x58, 0x58, 0xFC, 0xFC, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2075[]={ 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xC0, 0xF8, 0x0C, 0xCC, 0xFC, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2076[]={ 0x00, 0x00, 0x00, 0x38, 0x7C, 0xC0, 0xFC, 0xC6, 0xC6, 0xFE, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2077[]={ 0x00, 0x00, 0x00, 0xFC, 0xF8, 0x18, 0x30, 0x30, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2078[]={ 0x00, 0x00, 0x00, 0x78, 0xFC, 0xCC, 0x78, 0xFC, 0xCC, 0xFC, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2079[]={ 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xC6, 0x7E, 0x06, 0x7C, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_207F[]={ 0x00, 0x00, 0x00, 0xF8, 0xFC, 0xCC, 0xCC, 0xCC, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_20A3[]={ 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x60, 0xFC, 0xFC, 0x60, 0x60, 0x00, 0x00, };
const unsigned char UC2_20A4[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1E, 0x00, 0x3F, 0x00, 0x31, 0x80, 0x30, 0x00, 0x7C, 0x00, 0x30, 0x00, 0x7C, 0x00, 0x30, 0x00, 0x30, 0x00, 0x60, 0xC0, 0xFF, 0xC0, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_20A7[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x00, 0x00, 0xFC, 0x00, 0x00, 0xC6, 0x00, 0x00, 0xC6, 0xC0, 0x00, 0xC6, 0xC0, 0x00, 0xC7, 0xE7, 0x00, 0xFD, 0xEF, 0x80, 0xF8, 0xCC, 0x00, 0xC0, 0xC7, 0x00, 0xC0, 0xC1, 0x80, 0xC0, 0xEF, 0x80, 0xC0, 0x67, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2105[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x30, 0x00, 0xFC, 0x20, 0x00, 0xCC, 0x60, 0x00, 0xC0, 0xC0, 0x00, 0xCC, 0x80, 0x00, 0xFD, 0xBE, 0x00, 0x7B, 0x7F, 0x00, 0x02, 0x63, 0x00, 0x06, 0x63, 0x00, 0x0C, 0x63, 0x00, 0x08, 0x7F, 0x00, 0x18, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2113[]={ 0x00, 0x00, 0x00, 0x18, 0x38, 0x28, 0x28, 0x30, 0x30, 0x20, 0x20, 0x60, 0xA0, 0x24, 0x3C, 0x18, 0x00, };
const unsigned char UC2_2116[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC1, 0x80, 0x00, 0xE1, 0x80, 0x00, 0xF1, 0x8F, 0x00, 0xF1, 0x9F, 0x80, 0xF9, 0x99, 0x80, 0xDD, 0x99, 0x80, 0xDD, 0x99, 0x80, 0xCF, 0x9F, 0x80, 0xC7, 0x8F, 0x00, 0xC7, 0x80, 0x00, 0xC3, 0x9F, 0x80, 0xC1, 0x9F, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2126[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x7F, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0x60, 0xC0, 0x60, 0xC0, 0x31, 0x80, 0xF1, 0xE0, 0xF1, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_212E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x63, 0x00, 0xC1, 0x00, 0xC1, 0x80, 0xFF, 0x80, 0xC0, 0x00, 0xC1, 0x00, 0x42, 0x00, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_215B[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x30, 0xF0, 0x60, 0xB0, 0xC0, 0x30, 0x80, 0x31, 0x80, 0x33, 0x3C, 0xFF, 0x7E, 0xFE, 0x66, 0x04, 0x3C, 0x0C, 0x7E, 0x18, 0x66, 0x10, 0x7E, 0x20, 0x3C, 0x00, 0x00, };
const unsigned char UC2_215C[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x18, 0x00, 0xFC, 0x30, 0x00, 0x0C, 0x60, 0x00, 0x38, 0x40, 0x00, 0x3C, 0xC0, 0x00, 0xCD, 0x9E, 0x00, 0xFD, 0xBF, 0x00, 0x7B, 0x33, 0x00, 0x02, 0x1E, 0x00, 0x06, 0x3F, 0x00, 0x0C, 0x33, 0x00, 0x08, 0x3F, 0x00, 0x10, 0x1E, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_215D[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x18, 0x00, 0xFC, 0x30, 0x00, 0xC0, 0x60, 0x00, 0xF8, 0x40, 0x00, 0x0C, 0xC0, 0x00, 0xCD, 0x9E, 0x00, 0xFD, 0xBF, 0x00, 0x7B, 0x33, 0x00, 0x02, 0x1E, 0x00, 0x06, 0x3F, 0x00, 0x0C, 0x33, 0x00, 0x08, 0x3F, 0x00, 0x10, 0x1E, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_215E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x60, 0xF8, 0xC0, 0x19, 0x80, 0x19, 0x00, 0x33, 0x00, 0x36, 0x3C, 0x66, 0x7E, 0x6C, 0x66, 0x08, 0x3C, 0x18, 0x7E, 0x30, 0x66, 0x20, 0x7E, 0x40, 0x3C, 0x00, 0x00, };
const unsigned char UC2_2202[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x3F, 0x00, 0x43, 0x80, 0x01, 0x80, 0x3D, 0x80, 0x7F, 0x80, 0x63, 0x80, 0xC1, 0x80, 0xC3, 0x00, 0xC7, 0x00, 0xFE, 0x00, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2206[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x31, 0x80, 0x60, 0xC0, 0x60, 0xC0, 0xFF, 0xE0, 0xFF, 0xE0, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_220F[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xE0, 0xFF, 0xE0, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0x60, };
const unsigned char UC2_2211[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x60, 0x00, 0x30, 0x00, 0x18, 0x00, 0x0C, 0x00, 0x06, 0x00, 0x06, 0x00, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xFF, 0xC0, 0xFF, 0xC0, };
const unsigned char UC2_2212[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_221A[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x01, 0x80, 0x01, 0x80, 0x01, 0x00, 0x03, 0x00, 0x03, 0x00, 0xE2, 0x00, 0x26, 0x00, 0x36, 0x00, 0x36, 0x00, 0x1C, 0x00, 0x1C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_221E[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x70, 0x7C, 0xF8, 0xC7, 0x8C, 0xC3, 0x0C, 0xC7, 0x8C, 0x7C, 0xF8, 0x38, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_222B[]={ 0x00, 0x00, 0x00, 0x1C, 0x3C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0xF0, 0xE0, };
const unsigned char UC2_2248[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x80, 0xFF, 0x80, 0x8F, 0x00, 0x00, 0x00, 0x70, 0x80, 0xFF, 0x80, 0x8F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2260[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x06, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x0C, 0x00, 0x18, 0x00, 0x30, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x60, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2264[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x07, 0x80, 0x3F, 0x00, 0xF8, 0x00, 0xC0, 0x00, 0xF8, 0x00, 0x3F, 0x00, 0x07, 0x80, 0x00, 0x80, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_2265[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0xF0, 0x00, 0x7E, 0x00, 0x0F, 0x80, 0x01, 0x80, 0x0F, 0x80, 0x7E, 0x00, 0xF0, 0x00, 0x80, 0x00, 0xFF, 0x80, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_25CA[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x1C, 0x00, 0x36, 0x00, 0x63, 0x00, 0x63, 0x00, 0xC1, 0x80, 0xC1, 0x80, 0x63, 0x00, 0x63, 0x00, 0x36, 0x00, 0x1C, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_FB01[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x39, 0x80, 0x79, 0x80, 0x60, 0x00, 0xF9, 0x80, 0xF9, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_FB02[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x39, 0x80, 0x79, 0x80, 0x61, 0x80, 0xF9, 0x80, 0xF9, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x61, 0x80, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_0237[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0xF0, 0xE0, };
const unsigned char UC2_2080[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xFC, 0xCC, 0xCC, 0xCC, 0xCC, 0xFC, 0x78, 0x00, };
const unsigned char UC2_2081[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xF0, 0xB0, 0x30, 0x30, 0x30, 0xFC, 0xFC, 0x00, };
const unsigned char UC2_2082[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xFC, 0x0C, 0x0C, 0x30, 0x60, 0xFC, 0xFC, 0x00, };
const unsigned char UC2_2083[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xFC, 0x0C, 0x38, 0x3C, 0xCC, 0xFC, 0x78, 0x00, };
const unsigned char UC2_2084[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x38, 0x38, 0x58, 0x58, 0xFC, 0xFC, 0x18, 0x00, };
const unsigned char UC2_2085[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFC, 0xC0, 0xF8, 0x0C, 0xCC, 0xFC, 0x78, 0x00, };
const unsigned char UC2_2086[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x7C, 0xC0, 0xFC, 0xC6, 0xC6, 0xFE, 0x7C, 0x00, };
const unsigned char UC2_2087[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xF8, 0x18, 0x30, 0x30, 0x60, 0x60, 0x60, 0x00, };
const unsigned char UC2_2088[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0xFC, 0xCC, 0x78, 0xFC, 0xCC, 0xFC, 0x78, 0x00, };
const unsigned char UC2_2089[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xC6, 0x7E, 0x06, 0x7C, 0x38, 0x00, };
const unsigned char UC2_00B0[]={ 0x00, 0x00, 0x00, 0x78, 0xFC, 0xCC, 0xCC, 0xFC, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B1[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x18, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B2[]={ 0x00, 0x00, 0x00, 0x78, 0xFC, 0x0C, 0x0C, 0x30, 0x60, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B3[]={ 0x00, 0x00, 0x00, 0x78, 0xFC, 0x0C, 0x38, 0x3C, 0xCC, 0xFC, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00B9[]={ 0x00, 0x00, 0x00, 0x70, 0xF0, 0xB0, 0x30, 0x30, 0x30, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00BA[]={ 0x00, 0x00, 0x00, 0x7C, 0xFE, 0xC6, 0xC6, 0xC6, 0xFE, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00BB[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE7, 0x00, 0x73, 0x80, 0x39, 0xC0, 0x1C, 0xE0, 0x39, 0xC0, 0x73, 0x80, 0xE7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00BC[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x30, 0xF0, 0x60, 0xB0, 0xC0, 0x30, 0x80, 0x31, 0x98, 0x33, 0x38, 0xFF, 0x38, 0xFE, 0x58, 0x04, 0x58, 0x0C, 0xFC, 0x18, 0xFC, 0x30, 0x18, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00BF[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x38, 0x00, 0x70, 0x00, 0xC1, 0x00, 0xC3, 0x80, 0xFF, 0x00, 0x7E, 0x00, };
const unsigned char UC2_00C0[]={ 0x38, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C1[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C2[]={ 0x0F, 0x00, 0x19, 0x80, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C3[]={ 0x18, 0x80, 0x3F, 0x80, 0x27, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C5[]={ 0x0E, 0x00, 0x11, 0x00, 0x11, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C4[]={ 0x19, 0x80, 0x19, 0x80, 0x00, 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x1B, 0x00, 0x31, 0x80, 0x31, 0x80, 0x3F, 0x80, 0x7F, 0xC0, 0x60, 0xC0, 0x60, 0xC0, 0xC0, 0x60, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C8[]={ 0xE0, 0x00, 0x38, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00C9[]={ 0x0E, 0x00, 0x18, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00CA[]={ 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00CB[]={ 0x66, 0x00, 0x66, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFE, 0x00, 0xFE, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00CC[]={ 0xE0, 0x38, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_00CD[]={ 0x70, 0xC0, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0x00, 0x00, };
const unsigned char UC2_00CE[]={ 0x78, 0xCC, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, };
const unsigned char UC2_00D9[]={ 0x38, 0x00, 0x0E, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00DA[]={ 0x03, 0x80, 0x06, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00DB[]={ 0x1E, 0x00, 0x33, 0x00, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00DC[]={ 0x19, 0x80, 0x19, 0x80, 0x00, 0x00, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xC0, 0x7F, 0x80, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00DF[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x00, 0xC3, 0x00, 0xC6, 0x00, 0xCC, 0x00, 0xCE, 0x00, 0xC7, 0x00, 0xC1, 0x80, 0xD9, 0x80, 0xDF, 0x80, 0xCF, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F4[]={ 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x3C, 0x00, 0x66, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00F5[]={ 0x00, 0x00, 0x00, 0x00, 0x31, 0x00, 0x7F, 0x00, 0x4E, 0x00, 0x00, 0x00, 0x3E, 0x00, 0x7F, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0x7F, 0x00, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, };
const unsigned char UC2_00FE[]={ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0x00, 0xDE, 0x00, 0xFF, 0x00, 0xE3, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xC1, 0x80, 0xE3, 0x80, 0xFF, 0x00, 0xDE, 0x00, 0xC0, 0x00, 0xC0, 0x00, };
const unsigned char UC2_00B4[]={ 0x38, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };

//x0pleela 10 Nov, 2006  ER: OMAPs00099966
//supporting cyrilic along with Endurance fonts
#if !defined MMI_LITE && defined CHINESE_MMI

const unsigned char cyrillic_0400[] = {0x20, 0x10, 0x08, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_0401[] = {0x24, 0x24, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_0402[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x10, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x16, 0x00, 0x00};
const unsigned char cyrillic_0403[] = {0x0c, 0x30, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0404[] = {0x00, 0x00, 0x00, 0x00, 0x1c, 0x22, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x22, 0x1c, 0x00, 0x00};
const unsigned char cyrillic_0405[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x30, 0x0c, 0x02, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0406[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0407[] = {0x24, 0x24, 0x00, 0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0408[] = {0x00, 0x00, 0x00, 0x00, 0x0e, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x44, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_0409[] = {0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x49, 0x8e, 0x00, 0x00};
const unsigned char cyrillic_040a[] = {0x00, 0x00, 0x00, 0x00, 0x48, 0x48, 0x48, 0x48, 0x7e, 0x49, 0x49, 0x49, 0x49, 0x4e, 0x00, 0x00};
const unsigned char cyrillic_040b[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x10, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x11, 0x00, 0x00};
const unsigned char cyrillic_040c[] = {0x0c, 0x30, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_040d[] = {0x30, 0x0c, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_040e[] = {0x42, 0x42, 0x3c, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_040f[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x7f, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0410[] = {0x00, 0x00, 0x00, 0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0411[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_0412[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_0413[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0414[] = {0x00, 0x00, 0x00, 0x00, 0x0e, 0x12, 0x12, 0x12, 0x22, 0x22, 0x22, 0x42, 0x42, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_0415[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_0416[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0417[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0418[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0419[] = {0x42, 0x42, 0x3c, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041a[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041b[] = {0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041c[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041d[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041e[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_041f[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0420[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0421[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x40, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0422[] = {0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0423[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_0424[] = {0x00, 0x00, 0x00, 0x08, 0x08, 0x3e, 0x49, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0425[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x24, 0x24, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0426[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_0427[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_0428[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x00, 0x00};
const unsigned char cyrillic_0429[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_042a[] = {0x00, 0x00, 0x00, 0x00, 0x70, 0x10, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_042b[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
const unsigned char cyrillic_042c[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_042d[] = {0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x02, 0x02, 0x3e, 0x02, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_042e[] = {0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x52, 0x72, 0x52, 0x52, 0x52, 0x52, 0x4c, 0x00, 0x00};
const unsigned char cyrillic_042f[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x42, 0x42, 0x42, 0x3e, 0x12, 0x22, 0x22, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0430[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3e, 0x42, 0x42, 0x46, 0x3a, 0x00, 0x00};
const unsigned char cyrillic_0431[] = {0x00, 0x00, 0x02, 0x1c, 0x20, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0432[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_0433[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0434[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x22, 0x22, 0x42, 0x42, 0x42, 0x7f, 0x01, 0x00};
const unsigned char cyrillic_0435[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0436[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0437[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0438[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_0439[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_043a[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043c[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043e[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_043f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0440[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5c, 0x62, 0x42, 0x42, 0x42, 0x42, 0x62, 0x5c, 0x40, 0x40};
const unsigned char cyrillic_0441[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x40, 0x40, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0442[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0443[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_0444[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x3e, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08, 0x00};
const unsigned char cyrillic_0445[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x18, 0x18, 0x24, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0446[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_0447[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_0448[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x00, 0x00};
const unsigned char cyrillic_0449[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_044a[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_044b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
const unsigned char cyrillic_044c[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_044d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x02, 0x3e, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_044e[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x72, 0x52, 0x52, 0x52, 0x4c, 0x00, 0x00};
const unsigned char cyrillic_044f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x42, 0x42, 0x42, 0x3e, 0x12, 0x22, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0450[] = {0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0451[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0452[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x3c, 0x22, 0x22, 0x22, 0x22, 0x0c, 0x00};
const unsigned char cyrillic_0453[] = {0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0454[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1c, 0x22, 0x40, 0x7c, 0x40, 0x40, 0x22, 0x1c, 0x00, 0x00};
const unsigned char cyrillic_0455[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x40, 0x30, 0x0c, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0456[] = {0x00, 0x00, 0x00, 0x08, 0x08, 0x00, 0x18, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0457[] = {0x00, 0x00, 0x00, 0x24, 0x24, 0x00, 0x18, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0458[] = {0x00, 0x00, 0x00, 0x04, 0x04, 0x00, 0x0c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x48, 0x30};
const unsigned char cyrillic_0459[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x8e, 0x00, 0x00};
const unsigned char cyrillic_045a[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x48, 0x48, 0x7e, 0x49, 0x49, 0x49, 0x4e, 0x00, 0x00};
const unsigned char cyrillic_045b[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x2c, 0x32, 0x22, 0x22, 0x22, 0x00, 0x00};
const unsigned char cyrillic_045c[] = {0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_045d[] = {0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_045e[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_045f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x3e, 0x08, 0x08, 0x08};
const unsigned char cyrillic_0460[] = {0x00, 0x00, 0x00, 0x00, 0x36, 0x41, 0x41, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_0461[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_0462[] = {0x00, 0x00, 0x00, 0x00, 0x10, 0x7c, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_0463[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x3c, 0x22, 0x22, 0x22, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0464[] = {0x00, 0x00, 0x00, 0x00, 0x46, 0x49, 0x50, 0x50, 0x7e, 0x50, 0x50, 0x50, 0x49, 0x46, 0x00, 0x00};
const unsigned char cyrillic_0465[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x49, 0x50, 0x7e, 0x50, 0x50, 0x49, 0x46, 0x00, 0x00};
const unsigned char cyrillic_0466[] = {0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x14, 0x14, 0x22, 0x36, 0x2a, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0467[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x14, 0x14, 0x22, 0x36, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0468[] = {0x00, 0x00, 0x00, 0x00, 0x48, 0x48, 0x54, 0x54, 0x52, 0x76, 0x6a, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0469[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x54, 0x54, 0x52, 0x76, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_046a[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x22, 0x22, 0x14, 0x08, 0x1c, 0x2a, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_046b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x22, 0x14, 0x08, 0x3e, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_046c[] = {0x00, 0x00, 0x00, 0x00, 0x5f, 0x51, 0x51, 0x4a, 0x74, 0x4e, 0x55, 0x55, 0x55, 0x55, 0x00, 0x00};
const unsigned char cyrillic_046d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5f, 0x51, 0x4a, 0x74, 0x4e, 0x55, 0x55, 0x55, 0x00, 0x00};
const unsigned char cyrillic_046e[] = {0x00, 0x00, 0x24, 0x18, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x02, 0x3c, 0x40, 0x40};
const unsigned char cyrillic_046f[] = {0x00, 0x00, 0x00, 0x24, 0x18, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x3c, 0x40, 0x40};
const unsigned char cyrillic_0470[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0471[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08};
const unsigned char cyrillic_0472[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0473[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0474[] = {0x00, 0x00, 0x00, 0x00, 0x43, 0x44, 0x44, 0x44, 0x28, 0x28, 0x28, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0475[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x48, 0x28, 0x28, 0x28, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0476[] = {0x66, 0x11, 0x00, 0x00, 0x43, 0x44, 0x44, 0x44, 0x28, 0x28, 0x28, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0477[] = {0x00, 0x00, 0x66, 0x11, 0x00, 0x00, 0x46, 0x48, 0x48, 0x28, 0x28, 0x28, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0478[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x50, 0x59, 0x59, 0x59, 0x55, 0x56, 0x54, 0x54, 0x24, 0x08, 0x08};
const unsigned char cyrillic_0479[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x59, 0x59, 0x55, 0x56, 0x54, 0x54, 0x24, 0x08, 0x08};
const unsigned char cyrillic_047a[] = {0x00, 0x00, 0x00, 0x08, 0x3e, 0x49, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x49, 0x3e, 0x08, 0x00};
const unsigned char cyrillic_047b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x3e, 0x49, 0x41, 0x41, 0x41, 0x41, 0x49, 0x3e, 0x08, 0x00};
const unsigned char cyrillic_047c[] = {0x3c, 0x43, 0x18, 0x00, 0x36, 0x41, 0x41, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_047d[] = {0x00, 0x00, 0x3c, 0x43, 0x18, 0x00, 0x22, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_047e[] = {0x7f, 0x08, 0x00, 0x00, 0x36, 0x41, 0x41, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_047f[] = {0x00, 0x00, 0x7f, 0x08, 0x00, 0x00, 0x22, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_0480[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x40, 0x40, 0x3c, 0x04, 0x04, 0x04};
const unsigned char cyrillic_0481[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x3c, 0x04, 0x04, 0x04};
const unsigned char cyrillic_0482[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x0c, 0x44, 0x2a, 0x11, 0x18, 0x24, 0x00, 0x00, 0x00};
const unsigned char cyrillic_048a[] = {0x42, 0x42, 0x3c, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x04, 0x08};
const unsigned char cyrillic_048b[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x04, 0x08};
const unsigned char cyrillic_048c[] = {0x00, 0x00, 0x00, 0x00, 0x10, 0x7c, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_048d[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x3c, 0x22, 0x22, 0x22, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_048e[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x52, 0x5c, 0x44, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_048f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x52, 0x5c, 0x44, 0x40, 0x40, 0x40};
const unsigned char cyrillic_0490[] = {0x00, 0x00, 0x02, 0x02, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0491[] = {0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0492[] = {0x00, 0x00, 0x00, 0x00, 0x1f, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0493[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0494[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x0c, 0x00};
const unsigned char cyrillic_0495[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x0c, 0x00};
const unsigned char cyrillic_0496[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x01, 0x01};
const unsigned char cyrillic_0497[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x01, 0x01};
const unsigned char cyrillic_0498[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x42, 0x3c, 0x08, 0x30};
const unsigned char cyrillic_0499[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x42, 0x3c, 0x08, 0x30};
const unsigned char cyrillic_049a[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x60, 0x50, 0x48, 0x44, 0x42, 0x02, 0x02};
const unsigned char cyrillic_049b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x42, 0x02, 0x02};
const unsigned char cyrillic_049c[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x43, 0x54, 0x54, 0x78, 0x54, 0x54, 0x54, 0x42, 0x41, 0x00, 0x00};
const unsigned char cyrillic_049d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x43, 0x54, 0x54, 0x78, 0x54, 0x54, 0x42, 0x41, 0x00, 0x00};
const unsigned char cyrillic_049e[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x73, 0x24, 0x28, 0x30, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_049f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0x74, 0x28, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_04a0[] = {0x00, 0x00, 0x00, 0x00, 0xe0, 0x23, 0x24, 0x28, 0x30, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_04a1[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x24, 0x28, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_04a2[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04a3[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04a4[] = {0x00, 0x00, 0x00, 0x00, 0x47, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x44, 0x44, 0x00, 0x00};
const unsigned char cyrillic_04a5[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x47, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x44, 0x00, 0x00};
const unsigned char cyrillic_04a6[] = {0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x49, 0x01, 0x06};
const unsigned char cyrillic_04a7[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x01, 0x06};
const unsigned char cyrillic_04a8[] = {0x00, 0x00, 0x00, 0x00, 0x1c, 0x20, 0x40, 0x4c, 0x52, 0x52, 0x52, 0x52, 0x2c, 0x18, 0x06, 0x00};
const unsigned char cyrillic_04a9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1c, 0x20, 0x4c, 0x52, 0x52, 0x52, 0x2c, 0x18, 0x06, 0x00};
const unsigned char cyrillic_04aa[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x40, 0x42, 0x42, 0x3c, 0x10, 0x0c};
const unsigned char cyrillic_04ab[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x42, 0x42, 0x3c, 0x10, 0x0c};
const unsigned char cyrillic_04ac[] = {0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x0c, 0x04, 0x04};
const unsigned char cyrillic_04ad[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x0c, 0x04, 0x04};
const unsigned char cyrillic_04ae[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_04af[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x08, 0x08, 0x08};
const unsigned char cyrillic_04b0[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x08, 0x08, 0x3e, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_04b1[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x14, 0x08, 0x08, 0x3e, 0x08, 0x00, 0x00};
const unsigned char cyrillic_04b2[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x24, 0x24, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04b3[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x18, 0x18, 0x24, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04b4[] = {0x00, 0x00, 0x00, 0x00, 0xfa, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x3f, 0x01, 0x01};
const unsigned char cyrillic_04b5[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfa, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x3f, 0x01, 0x01};
const unsigned char cyrillic_04b6[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x03, 0x01, 0x01};
const unsigned char cyrillic_04b7[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x03, 0x01, 0x01};
const unsigned char cyrillic_04b8[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x52, 0x56, 0x3a, 0x12, 0x12, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04b9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x52, 0x56, 0x3a, 0x12, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04ba[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x5c, 0x62, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04bb[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x5c, 0x62, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04bc[] = {0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x12, 0x0c, 0x00, 0x00};
const unsigned char cyrillic_04bd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x0c, 0x00, 0x00};
const unsigned char cyrillic_04be[] = {0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x12, 0x0c, 0x08, 0x06};
const unsigned char cyrillic_04bf[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x0c, 0x08, 0x06};
const unsigned char cyrillic_04c0[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_04c1[] = {0x41, 0x41, 0x3e, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04c2[] = {0x00, 0x22, 0x22, 0x1c, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04c3[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c4[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x7c, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c5[] = {0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04c6[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04c7[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c8[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c9[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04ca[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04cb[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x06, 0x04, 0x04};
const unsigned char cyrillic_04cc[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x06, 0x04, 0x04};
const unsigned char cyrillic_04cd[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04ce[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04d0[] = {0x42, 0x42, 0x3c, 0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04d1[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3e, 0x42, 0x42, 0x46, 0x3a, 0x00, 0x00};
const unsigned char cyrillic_04d2[] = {0x24, 0x24, 0x00, 0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04d3[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3e, 0x42, 0x42, 0x46, 0x3a, 0x00, 0x00};
const unsigned char cyrillic_04d4[] = {0x00, 0x00, 0x00, 0x00, 0x1f, 0x28, 0x48, 0x48, 0x7f, 0x48, 0x48, 0x48, 0x48, 0x4f, 0x00, 0x00};
const unsigned char cyrillic_04d5[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x49, 0x09, 0x3f, 0x48, 0x48, 0x49, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_04d6[] = {0x42, 0x42, 0x3c, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_04d7[] = {0x00, 0x00, 0x42, 0x42, 0x3c, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04d8[] = {0x00, 0x00, 0x00, 0x00, 0x18, 0x24, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00};
const unsigned char cyrillic_04d9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04da[] = {0x24, 0x24, 0x00, 0x00, 0x18, 0x24, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00};
const unsigned char cyrillic_04db[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04dc[] = {0x24, 0x24, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04dd[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04de[] = {0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04df[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e0[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x04, 0x08, 0x10, 0x1c, 0x02, 0x02, 0x02, 0x46, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e1[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x04, 0x08, 0x10, 0x1c, 0x02, 0x02, 0x02, 0x42, 0x3c};
const unsigned char cyrillic_04e2[] = {0x00, 0x3c, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04e3[] = {0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_04e4[] = {0x24, 0x24, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04e5[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_04e6[] = {0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e7[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e8[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04ea[] = {0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04eb[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04ec[] = {0x24, 0x24, 0x00, 0x00, 0x38, 0x44, 0x02, 0x02, 0x3e, 0x02, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_04ed[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x38, 0x44, 0x02, 0x3e, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_04ee[] = {0x00, 0x3e, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_04ef[] = {0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_04f0[] = {0x24, 0x24, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_04f1[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_04f2[] = {0x33, 0x44, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_04f3[] = {0x00, 0x00, 0x33, 0x44, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_04f4[] = {0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04f5[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04f6[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x60, 0x20, 0x20};
const unsigned char cyrillic_04f7[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x60, 0x20, 0x20};
const unsigned char cyrillic_04f8[] = {0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
const unsigned char cyrillic_04f9[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
#endif /* !defined MMI_LITE && defined CHINESE_MMI */

#if !defined MMI_LITE && defined CHINESE_MMI
#define NUM_BITMAPS_FONT3 (822)
#else
#define NUM_BITMAPS_FONT3 (580)
#endif

/* Font database */
static const t_font_bitmap database3[NUM_BITMAPS_FONT3] ={
    { 0x0020, 1, 17, 8, 17, (char*) UC2_0020 },
	{ 0x0021, 1, 17, 4, 17, (char*) UC2_0021 },
	{ 0x0022, 1, 17, 7, 17, (char*) UC2_0022 },
	{ 0x0023, 1, 17, 11, 34, (char*) UC2_0023 },
	{ 0x0024, 1, 17, 10, 34, (char*) UC2_0024 },
	{ 0x0025, 1, 17, 16, 34, (char*) UC2_0025 },
	{ 0x0026, 1, 17, 12, 34, (char*) UC2_0026 },
	{ 0x0027, 1, 17, 3, 17, (char*) UC2_0027 },
	{ 0x0028, 1, 17, 6, 17, (char*) UC2_0028 },
	{ 0x0029, 1, 17, 6, 17, (char*) UC2_0029 },
	{ 0x002A, 1, 17, 9, 34, (char*) UC2_002A },
	{ 0x002B, 1, 17, 9, 34, (char*) UC2_002B },
	{ 0x002C, 1, 17, 4, 17, (char*) UC2_002C },
	{ 0x002D, 1, 17, 5, 17, (char*) UC2_002D },
	{ 0x002E, 1, 17, 3, 17, (char*) UC2_002E },
	{ 0x002F, 1, 17, 9, 34, (char*) UC2_002F },
	{ 0x0030, 1, 17, 9, 34, (char*) UC2_0030 },
	{ 0x0031, 1, 17, 9, 34, (char*) UC2_0031 },
	{ 0x0032, 1, 17, 9, 34, (char*) UC2_0032 },
	{ 0x0033, 1, 17, 9, 34, (char*) UC2_0033 },
	{ 0x0034, 1, 17, 10, 34, (char*) UC2_0034 },
	{ 0x0035, 1, 17, 9, 34, (char*) UC2_0035 },
	{ 0x0036, 1, 17, 9, 34, (char*) UC2_0036 },
	{ 0x0037, 1, 17, 9, 34, (char*) UC2_0037 },
	{ 0x0038, 1, 17, 9, 34, (char*) UC2_0038 },
	{ 0x0039, 1, 17, 9, 34, (char*) UC2_0039 },
	{ 0x003A, 1, 17, 3, 17, (char*) UC2_003A },
	{ 0x003B, 1, 17, 4, 17, (char*) UC2_003B },
	{ 0x003C, 1, 17, 10, 34, (char*) UC2_003C },
	{ 0x003D, 1, 17, 10, 34, (char*) UC2_003D },
	{ 0x003E, 1, 17, 10, 34, (char*) UC2_003E },
	{ 0x003F, 1, 17, 9, 34, (char*) UC2_003F },
	{ 0x0040, 1, 17, 16, 34, (char*) UC2_0040 },
	{ 0x0041, 1, 17, 12, 34, (char*) UC2_0041 },
	{ 0x0042, 1, 17, 10, 34, (char*) UC2_0042 },
	{ 0x0043, 1, 17, 11, 34, (char*) UC2_0043 },
	{ 0x0044, 1, 17, 11, 34, (char*) UC2_0044 },
	{ 0x0045, 1, 17, 9, 34, (char*) UC2_0045 },
	{ 0x0046, 1, 17, 8, 17, (char*) UC2_0046 },
	{ 0x0047, 1, 17, 11, 34, (char*) UC2_0047 },
	{ 0x0048, 1, 17, 12, 34, (char*) UC2_0048 },
	{ 0x0049, 1, 17, 3, 17, (char*) UC2_0049 },
	{ 0x004A, 1, 17, 9, 34, (char*) UC2_004A },
	{ 0x004B, 1, 17, 11, 34, (char*) UC2_004B },
	{ 0x004C, 1, 17, 8, 17, (char*) UC2_004C },
	{ 0x004D, 1, 17, 15, 34, (char*) UC2_004D },
	{ 0x004E, 1, 17, 12, 34, (char*) UC2_004E },
	{ 0x004F, 1, 17, 12, 34, (char*) UC2_004F },
	{ 0x0050, 1, 17, 10, 34, (char*) UC2_0050 },
	{ 0x0051, 1, 17, 12, 34, (char*) UC2_0051 },
	{ 0x0052, 1, 17, 11, 34, (char*) UC2_0052 },
	{ 0x0053, 1, 17, 11, 34, (char*) UC2_0053 },
	{ 0x0054, 1, 17, 11, 34, (char*) UC2_0054 },
	{ 0x0055, 1, 17, 11, 34, (char*) UC2_0055 },
	{ 0x0056, 1, 17, 12, 34, (char*) UC2_0056 },
	{ 0x0057, 1, 17, 18, 51, (char*) UC2_0057 },
	{ 0x0058, 1, 17, 13, 34, (char*) UC2_0058 },
	{ 0x0059, 1, 17, 11, 34, (char*) UC2_0059 },
	{ 0x005A, 1, 17, 11, 34, (char*) UC2_005A },
	{ 0x005B, 1, 17, 6, 17, (char*) UC2_005B },
	{ 0x005C, 1, 17, 9, 34, (char*) UC2_005C },
	{ 0x005D, 1, 17, 6, 17, (char*) UC2_005D },
	{ 0x005E, 1, 17, 11, 34, (char*) UC2_005E },
	{ 0x005F, 1, 17, 10, 34, (char*) UC2_005F },
	{ 0x0060, 1, 17, 6, 17, (char*) UC2_0060 },
	{ 0x0061, 1, 17, 10, 34, (char*) UC2_0061 },
	{ 0x0062, 1, 17, 10, 34, (char*) UC2_0062 },
	{ 0x0063, 1, 17, 9, 34, (char*) UC2_0063 },
	{ 0x0064, 1, 17, 10, 34, (char*) UC2_0064 },
	{ 0x0065, 1, 17, 10, 34, (char*) UC2_0065 },
	{ 0x0066, 1, 17, 6, 17, (char*) UC2_0066 },
	{ 0x0067, 1, 17, 10, 34, (char*) UC2_0067 },
	{ 0x0068, 1, 17, 10, 34, (char*) UC2_0068 },
	{ 0x0069, 1, 17, 3, 17, (char*) UC2_0069 },
	{ 0x006A, 1, 17, 5, 17, (char*) UC2_006A },
	{ 0x006B, 1, 17, 10, 34, (char*) UC2_006B },
	{ 0x006C, 1, 17, 3, 17, (char*) UC2_006C },
	{ 0x006D, 1, 17, 15, 34, (char*) UC2_006D },
	{ 0x006E, 1, 17, 10, 34, (char*) UC2_006E },
	{ 0x006F, 1, 17, 10, 34, (char*) UC2_006F },
	{ 0x0070, 1, 17, 10, 34, (char*) UC2_0070 },
	{ 0x0071, 1, 17, 10, 34, (char*) UC2_0071 },
	{ 0x0072, 1, 17, 6, 17, (char*) UC2_0072 },
	{ 0x0073, 1, 17, 8, 17, (char*) UC2_0073 },
	{ 0x0074, 1, 17, 6, 17, (char*) UC2_0074 },
	{ 0x0075, 1, 17, 10, 34, (char*) UC2_0075 },
	{ 0x0076, 1, 17, 11, 34, (char*) UC2_0076 },
	{ 0x0077, 1, 17, 17, 51, (char*) UC2_0077 },
	{ 0x0078, 1, 17, 11, 34, (char*) UC2_0078 },
	{ 0x0079, 1, 17, 11, 34, (char*) UC2_0079 },
	{ 0x007A, 1, 17, 9, 34, (char*) UC2_007A },
	{ 0x007B, 1, 17, 7, 17, (char*) UC2_007B },
	{ 0x007C, 1, 17, 3, 17, (char*) UC2_007C },
	{ 0x007D, 1, 17, 7, 17, (char*) UC2_007D },
	{ 0x007E, 1, 17, 10, 34, (char*) UC2_007E },
	{ 0x00A1, 1, 17, 4, 17, (char*) UC2_00A1 },
	{ 0x00A2, 1, 17, 9, 34, (char*) UC2_00A2 },
	{ 0x00A3, 1, 17, 11, 34, (char*) UC2_00A3 },
	{ 0x00A4, 1, 17, 11, 34, (char*) UC2_00A4 },
	{ 0x00A5, 1, 17, 11, 34, (char*) UC2_00A5 },//100
	{ 0x00A6, 1, 17, 3, 17, (char*) UC2_00A6 },
	{ 0x00A7, 1, 17, 9, 34, (char*) UC2_00A7 },
	{ 0x00A8, 1, 17, 7, 17, (char*) UC2_00A8 },
	{ 0x00A9, 1, 17, 13, 34, (char*) UC2_00A9 },
	{ 0x00AA, 1, 17, 9, 34, (char*) UC2_00AA },
	{ 0x00AB, 1, 17, 12, 34, (char*) UC2_00AB },
	{ 0x00AC, 1, 17, 10, 34, (char*) UC2_00AC },
	{ 0x00AD, 1, 17, 4, 17, (char*) UC2_00AD },
	{ 0x00AE, 1, 17, 13, 34, (char*) UC2_00AE },
	{ 0x00AF, 1, 17, 7, 17, (char*) UC2_00AF },
	{ 0x00B0, 1, 17, 7, 17, (char*) UC2_00B0 },
	{ 0x00B1, 1, 17, 9, 34, (char*) UC2_00B1 },
	{ 0x00B2, 1, 17, 7, 17, (char*) UC2_00B2 },
	{ 0x00B3, 1, 17, 7, 17, (char*) UC2_00B3 },
	{ 0x00B4, 1, 17, 6, 17, (char*) UC2_00B4 },
	{ 0x00B5, 1, 17, 12, 34, (char*) UC2_00B5 },
	{ 0x00B6, 1, 17, 10, 34, (char*) UC2_00B6 },
	{ 0x00B7, 1, 17, 3, 17, (char*) UC2_00B7 },
	{ 0x00B8, 1, 17, 4, 17, (char*) UC2_00B8 },
	{ 0x00B9, 1, 17, 7, 17, (char*) UC2_00B9 },
	{ 0x00BA, 1, 17, 8, 17, (char*) UC2_00BA },
	{ 0x00BB, 1, 17, 12, 34, (char*) UC2_00BB },
	{ 0x00BC, 1, 17, 15, 34, (char*) UC2_00BC },
	{ 0x00BD, 1, 17, 14, 34, (char*) UC2_00BD },
	{ 0x00BE, 1, 17, 16, 34, (char*) UC2_00BE },
	{ 0x00BF, 1, 17, 10, 34, (char*) UC2_00BF },
	{ 0x00C0, 1, 17, 12, 34, (char*) UC2_00C0 },
	{ 0x00C1, 1, 17, 12, 34, (char*) UC2_00C1 },
	{ 0x00C2, 1, 17, 12, 34, (char*) UC2_00C2 },
	{ 0x00C3, 1, 17, 12, 34, (char*) UC2_00C3 },
	{ 0x00C4, 1, 17, 12, 34, (char*) UC2_00C4 },
	{ 0x00C5, 1, 17, 12, 34, (char*) UC2_00C5 },
	{ 0x00C6, 1, 17, 17, 51, (char*) UC2_00C6 },
	{ 0x00C7, 1, 17, 11, 34, (char*) UC2_00C7 },
	{ 0x00C8, 1, 17, 9, 34, (char*) UC2_00C8 },
	{ 0x00C9, 1, 17, 9, 34, (char*) UC2_00C9 },
	{ 0x00CA, 1, 17, 9, 34, (char*) UC2_00CA },
	{ 0x00CB, 1, 17, 9, 34, (char*) UC2_00CB },
	{ 0x00CC, 1, 17, 6, 17, (char*) UC2_00CC },
	{ 0x00CD, 1, 17, 5, 17, (char*) UC2_00CD },
	{ 0x00CE, 1, 17, 7, 17, (char*) UC2_00CE },
	{ 0x00CF, 1, 17, 7, 17, (char*) UC2_00CF },
	{ 0x00D0, 1, 17, 13, 34, (char*) UC2_00D0 },
	{ 0x00D1, 1, 17, 12, 34, (char*) UC2_00D1 },
	{ 0x00D2, 1, 17, 12, 34, (char*) UC2_00D2 },
	{ 0x00D3, 1, 17, 12, 34, (char*) UC2_00D3 },
	{ 0x00D4, 1, 17, 12, 34, (char*) UC2_00D4 },
	{ 0x00D5, 1, 17, 12, 34, (char*) UC2_00D5 },
	{ 0x00D6, 1, 17, 12, 34, (char*) UC2_00D6 },
	{ 0x00D7, 1, 17, 10, 34, (char*) UC2_00D7 },
	{ 0x00D8, 1, 17, 12, 34, (char*) UC2_00D8 },
	{ 0x00D9, 1, 17, 11, 34, (char*) UC2_00D9 },
	{ 0x00DA, 1, 17, 11, 34, (char*) UC2_00DA },
	{ 0x00DB, 1, 17, 11, 34, (char*) UC2_00DB },
	{ 0x00DC, 1, 17, 11, 34, (char*) UC2_00DC },
	{ 0x00DD, 1, 17, 11, 34, (char*) UC2_00DD },
	{ 0x00DE, 1, 17, 10, 34, (char*) UC2_00DE },
	{ 0x00DF, 1, 17, 10, 34, (char*) UC2_00DF },
	{ 0x00E0, 1, 17, 10, 34, (char*) UC2_00E0 },
	{ 0x00E1, 1, 17, 10, 34, (char*) UC2_00E1 },
	{ 0x00E2, 1, 17, 10, 34, (char*) UC2_00E2 },
	{ 0x00E3, 1, 17, 10, 34, (char*) UC2_00E3 },
	{ 0x00E4, 1, 17, 10, 34, (char*) UC2_00E4 },
	{ 0x00E5, 1, 17, 10, 34, (char*) UC2_00E5 },
	{ 0x00E6, 1, 17, 16, 34, (char*) UC2_00E6 },
	{ 0x00E7, 1, 17, 9, 34, (char*) UC2_00E7 },
	{ 0x00E8, 1, 17, 10, 34, (char*) UC2_00E8 },
	{ 0x00E9, 1, 17, 10, 34, (char*) UC2_00E9 },
	{ 0x00EA, 1, 17, 10, 34, (char*) UC2_00EA },
	{ 0x00EB, 1, 17, 10, 34, (char*) UC2_00EB },
	{ 0x00EC, 1, 17, 5, 17, (char*) UC2_00EC },
	{ 0x00ED, 1, 17, 6, 17, (char*) UC2_00ED },
	{ 0x00EE, 1, 17, 6, 17, (char*) UC2_00EE },
	{ 0x00EF, 1, 17, 7, 17, (char*) UC2_00EF },
	{ 0x00F0, 1, 17, 9, 34, (char*) UC2_00F0 },
	{ 0x00F1, 1, 17, 10, 34, (char*) UC2_00F1 },
	{ 0x00F2, 1, 17, 10, 34, (char*) UC2_00F2 },
	{ 0x00F3, 1, 17, 10, 34, (char*) UC2_00F3 },
	{ 0x00F4, 1, 17, 10, 34, (char*) UC2_00F4 },
	{ 0x00F5, 1, 17, 10, 34, (char*) UC2_00F5 },
	{ 0x00F6, 1, 17, 10, 34, (char*) UC2_00F6 },
	{ 0x00F7, 1, 17, 9, 34, (char*) UC2_00F7 },
	{ 0x00F8, 1, 17, 10, 34, (char*) UC2_00F8 },
	{ 0x00F9, 1, 17, 10, 34, (char*) UC2_00F9 },
	{ 0x00FA, 1, 17, 10, 34, (char*) UC2_00FA },
	{ 0x00FB, 1, 17, 10, 34, (char*) UC2_00FB },
	{ 0x00FC, 1, 17, 9, 34, (char*) UC2_00FC },
	{ 0x00FD, 1, 17, 11, 34, (char*) UC2_00FD },
	{ 0x00FE, 1, 17, 10, 34, (char*) UC2_00FE },
	{ 0x00FF, 1, 17, 11, 34, (char*) UC2_00FF },
	{ 0x0100, 1, 17, 12, 34, (char*) UC2_0100 },
	{ 0x0101, 1, 17, 10, 34, (char*) UC2_0101 },
	{ 0x0102, 1, 17, 12, 34, (char*) UC2_0102 },
	{ 0x0103, 1, 17, 10, 34, (char*) UC2_0103 },
	{ 0x0104, 1, 17, 12, 34, (char*) UC2_0104 },
	{ 0x0105, 1, 17, 10, 34, (char*) UC2_0105 },
	{ 0x0106, 1, 17, 11, 34, (char*) UC2_0106 },
	{ 0x0107, 1, 17, 9, 34, (char*) UC2_0107 },
	{ 0x0108, 1, 17, 11, 34, (char*) UC2_0108 },
	{ 0x0109, 1, 17, 9, 34, (char*) UC2_0109 },//200
	{ 0x010A, 1, 17, 11, 34, (char*) UC2_010A },
	{ 0x010B, 1, 17, 9, 34, (char*) UC2_010B },
	{ 0x010C, 1, 17, 11, 34, (char*) UC2_010C },
	{ 0x010D, 1, 17, 9, 34, (char*) UC2_010D },
	{ 0x010E, 1, 17, 11, 34, (char*) UC2_010E },
	{ 0x010F, 1, 17, 13, 34, (char*) UC2_010F },
	{ 0x0110, 1, 17, 12, 34, (char*) UC2_0110 },
	{ 0x0111, 1, 17, 11, 34, (char*) UC2_0111 },
	{ 0x0112, 1, 17, 9, 34, (char*) UC2_0112 },
	{ 0x0113, 1, 17, 10, 34, (char*) UC2_0113 },
	{ 0x0114, 1, 17, 9, 34, (char*) UC2_0114 },
	{ 0x0115, 1, 17, 10, 34, (char*) UC2_0115 },
	{ 0x0116, 1, 17, 9, 34, (char*) UC2_0116 },
	{ 0x0117, 1, 17, 10, 34, (char*) UC2_0117 },
	{ 0x0118, 1, 17, 9, 34, (char*) UC2_0118 },
	{ 0x0119, 1, 17, 10, 34, (char*) UC2_0119 },
	{ 0x011A, 1, 17, 9, 34, (char*) UC2_011A },
	{ 0x011B, 1, 17, 10, 34, (char*) UC2_011B },
	{ 0x011C, 1, 17, 11, 34, (char*) UC2_011C },
	{ 0x011D, 1, 17, 10, 34, (char*) UC2_011D },
	{ 0x011E, 1, 17, 11, 34, (char*) UC2_011E },
	{ 0x011F, 1, 17, 10, 34, (char*) UC2_011F },
	{ 0x0120, 1, 17, 11, 34, (char*) UC2_0120 },
	{ 0x0121, 1, 17, 10, 34, (char*) UC2_0121 },
	{ 0x0122, 1, 17, 11, 34, (char*) UC2_0122 },
	{ 0x0123, 1, 17, 10, 34, (char*) UC2_0123 },
	{ 0x0124, 1, 17, 12, 34, (char*) UC2_0124 },
	{ 0x0125, 1, 17, 10, 34, (char*) UC2_0125 },
	{ 0x0126, 1, 17, 13, 34, (char*) UC2_0126 },
	{ 0x0127, 1, 17, 11, 34, (char*) UC2_0127 },
	{ 0x0128, 1, 17, 8, 17, (char*) UC2_0128 },
	{ 0x0129, 1, 17, 7, 17, (char*) UC2_0129 },
	{ 0x012A, 1, 17, 7, 17, (char*) UC2_012A },
	{ 0x012B, 1, 17, 6, 17, (char*) UC2_012B },
	{ 0x012C, 1, 17, 7, 17, (char*) UC2_012C },
	{ 0x012D, 1, 17, 7, 17, (char*) UC2_012D },
	{ 0x012E, 1, 17, 4, 17, (char*) UC2_012E },
	{ 0x012F, 1, 17, 4, 17, (char*) UC2_012F },
	{ 0x0130, 1, 17, 3, 17, (char*) UC2_0130 },
	{ 0x0132, 1, 17, 14, 34, (char*) UC2_0132 },
	{ 0x0133, 1, 17, 8, 17, (char*) UC2_0133 },
	{ 0x0134, 1, 17, 9, 34, (char*) UC2_0134 },
	{ 0x0135, 1, 17, 7, 17, (char*) UC2_0135 },
	{ 0x0136, 1, 17, 11, 34, (char*) UC2_0136 },
	{ 0x0137, 1, 17, 10, 34, (char*) UC2_0137 },
	{ 0x0138, 1, 17, 10, 34, (char*) UC2_0138 },
	{ 0x0139, 1, 17, 8, 17, (char*) UC2_0139 },
	{ 0x013A, 1, 17, 5, 17, (char*) UC2_013A },
	{ 0x013B, 1, 17, 8, 17, (char*) UC2_013B },
	{ 0x013C, 1, 17, 3, 17, (char*) UC2_013C },
	{ 0x013D, 1, 17, 8, 17, (char*) UC2_013D },
	{ 0x013E, 1, 17, 6, 17, (char*) UC2_013E },
	{ 0x013F, 1, 17, 8, 17, (char*) UC2_013F },
	{ 0x0140, 1, 17, 7, 17, (char*) UC2_0140 },
	{ 0x0141, 1, 17, 10, 34, (char*) UC2_0141 },
	{ 0x0142, 1, 17, 5, 17, (char*) UC2_0142 },
	{ 0x0143, 1, 17, 12, 34, (char*) UC2_0143 },
	{ 0x0144, 1, 17, 10, 34, (char*) UC2_0144 },
	{ 0x0145, 1, 17, 12, 34, (char*) UC2_0145 },
	{ 0x0146, 1, 17, 10, 34, (char*) UC2_0146 },
	{ 0x0147, 1, 17, 12, 34, (char*) UC2_0147 },
	{ 0x0148, 1, 17, 10, 34, (char*) UC2_0148 },
	{ 0x0149, 1, 17, 14, 34, (char*) UC2_0149 },
	{ 0x014A, 1, 17, 12, 34, (char*) UC2_014A },
	{ 0x014B, 1, 17, 10, 34, (char*) UC2_014B },
	{ 0x014C, 1, 17, 12, 34, (char*) UC2_014C },
	{ 0x014D, 1, 17, 10, 34, (char*) UC2_014D },
	{ 0x014E, 1, 17, 12, 34, (char*) UC2_014E },
	{ 0x014F, 1, 17, 10, 34, (char*) UC2_014F },
	{ 0x0150, 1, 17, 12, 34, (char*) UC2_0150 },
	{ 0x0151, 1, 17, 10, 34, (char*) UC2_0151 },
	{ 0x0152, 1, 17, 16, 34, (char*) UC2_0152 },
	{ 0x0153, 1, 17, 16, 34, (char*) UC2_0153 },
	{ 0x0154, 1, 17, 11, 34, (char*) UC2_0154 },
	{ 0x0155, 1, 17, 6, 17, (char*) UC2_0155 },
	{ 0x0156, 1, 17, 11, 34, (char*) UC2_0156 },
	{ 0x0157, 1, 17, 7, 17, (char*) UC2_0157 },
	{ 0x0158, 1, 17, 11, 34, (char*) UC2_0158 },
	{ 0x0159, 1, 17, 7, 17, (char*) UC2_0159 },
	{ 0x015A, 1, 17, 11, 34, (char*) UC2_015A },
	{ 0x015B, 1, 17, 8, 17, (char*) UC2_015B },
	{ 0x015C, 1, 17, 11, 34, (char*) UC2_015C },
	{ 0x015D, 1, 17, 8, 17, (char*) UC2_015D },
	{ 0x015E, 1, 17, 11, 34, (char*) UC2_015E },
	{ 0x015F, 1, 17, 8, 17, (char*) UC2_015F },
	{ 0x0160, 1, 17, 11, 34, (char*) UC2_0160 },
	{ 0x0161, 1, 17, 8, 17, (char*) UC2_0161 },
	{ 0x0162, 1, 17, 11, 34, (char*) UC2_0162 },
	{ 0x0163, 1, 17, 6, 17, (char*) UC2_0163 },
	{ 0x0164, 1, 17, 11, 34, (char*) UC2_0164 },
	{ 0x0165, 1, 17, 8, 17, (char*) UC2_0165 },
	{ 0x0166, 1, 17, 11, 34, (char*) UC2_0166 },
	{ 0x0167, 1, 17, 6, 17, (char*) UC2_0167 },
	{ 0x0168, 1, 17, 11, 34, (char*) UC2_0168 },
	{ 0x0169, 1, 17, 10, 34, (char*) UC2_0169 },
	{ 0x016A, 1, 17, 11, 34, (char*) UC2_016A },
	{ 0x016B, 1, 17, 10, 34, (char*) UC2_016B },
	{ 0x016C, 1, 17, 11, 34, (char*) UC2_016C },
	{ 0x016D, 1, 17, 10, 34, (char*) UC2_016D },
	{ 0x016E, 1, 17, 11, 34, (char*) UC2_016E },//300
	{ 0x016F, 1, 17, 10, 34, (char*) UC2_016F },
	{ 0x0170, 1, 17, 11, 34, (char*) UC2_0170 },
	{ 0x0171, 1, 17, 10, 34, (char*) UC2_0171 },
	{ 0x0172, 1, 17, 11, 34, (char*) UC2_0172 },
	{ 0x0173, 1, 17, 10, 34, (char*) UC2_0173 },
	{ 0x0174, 1, 17, 18, 51, (char*) UC2_0174 },
	{ 0x0175, 1, 17, 17, 51, (char*) UC2_0175 },
	{ 0x0176, 1, 17, 11, 34, (char*) UC2_0176 },
	{ 0x0177, 1, 17, 11, 34, (char*) UC2_0177 },
	{ 0x0178, 1, 17, 11, 34, (char*) UC2_0178 },
	{ 0x0179, 1, 17, 11, 34, (char*) UC2_0179 },
	{ 0x017A, 1, 17, 9, 34, (char*) UC2_017A },
	{ 0x017B, 1, 17, 11, 34, (char*) UC2_017B },
	{ 0x017C, 1, 17, 9, 34, (char*) UC2_017C },
	{ 0x017D, 1, 17, 11, 34, (char*) UC2_017D },
	{ 0x017E, 1, 17, 9, 34, (char*) UC2_017E },
	{ 0x017F, 1, 17, 5, 17, (char*) UC2_017F },
	{ 0x0192, 1, 17, 8, 17, (char*) UC2_0192 },
	{ 0x01FA, 1, 17, 12, 34, (char*) UC2_01FA },
	{ 0x01FB, 1, 17, 10, 34, (char*) UC2_01FB },
	{ 0x01FC, 1, 17, 17, 51, (char*) UC2_01FC },
	{ 0x01FD, 1, 17, 16, 34, (char*) UC2_01FD },
	{ 0x01FE, 1, 17, 12, 34, (char*) UC2_01FE },
	{ 0x01FF, 1, 17, 10, 34, (char*) UC2_01FF },
	{ 0x0218, 1, 17, 11, 34, (char*) UC2_0218 },
	{ 0x0219, 1, 17, 8, 17, (char*) UC2_0219 },
	{ 0x0237, 1, 17, 5, 17, (char*) UC2_0237 },
	{ 0x02C6, 1, 17, 7, 17, (char*) UC2_02C6 },
	{ 0x02C7, 1, 17, 7, 17, (char*) UC2_02C7 },
	{ 0x02C9, 1, 17, 7, 17, (char*) UC2_02C9 },
	{ 0x02D8, 1, 17, 6, 17, (char*) UC2_02D8 },
	{ 0x02D9, 1, 17, 3, 17, (char*) UC2_02D9 },
	{ 0x02DA, 1, 17, 5, 17, (char*) UC2_02DA },
	{ 0x02DB, 1, 17, 4, 17, (char*) UC2_02DB },
	{ 0x02DC, 1, 17, 8, 17, (char*) UC2_02DC },
	{ 0x02DD, 1, 17, 9, 34, (char*) UC2_02DD },
	{ 0x037E, 1, 17, 4, 17, (char*) UC2_037E },
	{ 0x0384, 1, 17, 3, 17, (char*) UC2_0384 },
	{ 0x0385, 1, 17, 8, 17, (char*) UC2_0385 },
	{ 0x0386, 1, 17, 13, 34, (char*) UC2_0386 },
	{ 0x0387, 1, 17, 3, 17, (char*) UC2_0387 },
	{ 0x0388, 1, 17, 12, 34, (char*) UC2_0388 },
	{ 0x0389, 1, 17, 15, 34, (char*) UC2_0389 },
	{ 0x038A, 1, 17, 6, 17, (char*) UC2_038A },
	{ 0x038C, 1, 17, 14, 34, (char*) UC2_038C },
	{ 0x038E, 1, 17, 15, 34, (char*) UC2_038E },
	{ 0x038F, 1, 17, 14, 34, (char*) UC2_038F },
	{ 0x0390, 1, 17, 8, 17, (char*) UC2_0390 },
	{ 0x0391, 1, 17, 12, 34, (char*) UC2_0391 },
	{ 0x0392, 1, 17, 10, 34, (char*) UC2_0392 },
	{ 0x0393, 1, 17, 8, 17, (char*) UC2_0393 },
	{ 0x0394, 1, 17, 12, 34, (char*) UC2_0394 },
	{ 0x0395, 1, 17, 9, 34, (char*) UC2_0395 },
	{ 0x0396, 1, 17, 11, 34, (char*) UC2_0396 },
	{ 0x0397, 1, 17, 12, 34, (char*) UC2_0397 },
	{ 0x0398, 1, 17, 12, 34, (char*) UC2_0398 },
	{ 0x0399, 1, 17, 3, 17, (char*) UC2_0399 },
	{ 0x039A, 1, 17, 11, 34, (char*) UC2_039A },
	{ 0x039B, 1, 17, 12, 34, (char*) UC2_039B },
	{ 0x039C, 1, 17, 15, 34, (char*) UC2_039C },
	{ 0x039D, 1, 17, 12, 34, (char*) UC2_039D },
	{ 0x039E, 1, 17, 10, 34, (char*) UC2_039E },
	{ 0x039F, 1, 17, 12, 34, (char*) UC2_039F },
	{ 0x03A0, 1, 17, 11, 34, (char*) UC2_03A0 },
	{ 0x03A1, 1, 17, 10, 34, (char*) UC2_03A1 },
	{ 0x03A3, 1, 17, 10, 34, (char*) UC2_03A3 },
	{ 0x03A4, 1, 17, 11, 34, (char*) UC2_03A4 },
	{ 0x03A5, 1, 17, 11, 34, (char*) UC2_03A5 },
	{ 0x03A6, 1, 17, 13, 34, (char*) UC2_03A6 },
	{ 0x03A7, 1, 17, 13, 34, (char*) UC2_03A7 },
	{ 0x03A8, 1, 17, 15, 34, (char*) UC2_03A8 },
	{ 0x03A9, 1, 17, 12, 34, (char*) UC2_03A9 },
	{ 0x03AA, 1, 17, 7, 17, (char*) UC2_03AA },
	{ 0x03AB, 1, 17, 11, 34, (char*) UC2_03AB },
	{ 0x03AC, 1, 17, 12, 34, (char*) UC2_03AC },
	{ 0x03AD, 1, 17, 9, 34, (char*) UC2_03AD },
	{ 0x03AE, 1, 17, 11, 34, (char*) UC2_03AE },
	{ 0x03AF, 1, 17, 5, 17, (char*) UC2_03AF },
	{ 0x03B0, 1, 17, 10, 34, (char*) UC2_03B0 },
	{ 0x03B1, 1, 17, 12, 34, (char*) UC2_03B1 },
	{ 0x03B2, 1, 17, 8, 17, (char*) UC2_03B2 },
	{ 0x03B3, 1, 17, 10, 34, (char*) UC2_03B3 },
	{ 0x03B4, 1, 17, 9, 34, (char*) UC2_03B4 },
	{ 0x03B5, 1, 17, 9, 34, (char*) UC2_03B5 },
	{ 0x03B6, 1, 17, 8, 17, (char*) UC2_03B6 },
	{ 0x03B7, 1, 17, 11, 34, (char*) UC2_03B7 },
	{ 0x03B8, 1, 17, 10, 34, (char*) UC2_03B8 },
	{ 0x03B9, 1, 17, 5, 17, (char*) UC2_03B9 },
	{ 0x03BA, 1, 17, 10, 34, (char*) UC2_03BA },
	{ 0x03BB, 1, 17, 12, 34, (char*) UC2_03BB },
	{ 0x03BC, 1, 17, 12, 34, (char*) UC2_03BC },
	{ 0x03BD, 1, 17, 10, 34, (char*) UC2_03BD },
	{ 0x03BE, 1, 17, 8, 17, (char*) UC2_03BE },
	{ 0x03BF, 1, 17, 10, 34, (char*) UC2_03BF },
	{ 0x03C0, 1, 17, 12, 34, (char*) UC2_03C0 },
	{ 0x03C1, 1, 17, 10, 34, (char*) UC2_03C1 },
	{ 0x03C2, 1, 17, 8, 17, (char*) UC2_03C2 },
	{ 0x03C3, 1, 17, 11, 34, (char*) UC2_03C3 },
	{ 0x03C4, 1, 17, 9, 34, (char*) UC2_03C4 },
	{ 0x03C5, 1, 17, 10, 34, (char*) UC2_03C5 },//400
	{ 0x03C6, 1, 17, 13, 34, (char*) UC2_03C6 },
	{ 0x03C7, 1, 17, 9, 34, (char*) UC2_03C7 },
	{ 0x03C8, 1, 17, 13, 34, (char*) UC2_03C8 },
	{ 0x03C9, 1, 17, 13, 34, (char*) UC2_03C9 },
	{ 0x03CA, 1, 17, 7, 17, (char*) UC2_03CA },
	{ 0x03CB, 1, 17, 10, 34, (char*) UC2_03CB },
	{ 0x03CC, 1, 17, 10, 34, (char*) UC2_03CC },
	{ 0x03CD, 1, 17, 10, 34, (char*) UC2_03CD },
	{ 0x03CE, 1, 17, 13, 34, (char*) UC2_03CE },
	{ 0x0401, 1, 17, 9, 34, (char*) UC2_0401 },
	{ 0x0402, 1, 17, 13, 34, (char*) UC2_0402 },
	{ 0x0403, 1, 17, 8, 17, (char*) UC2_0403 },
	{ 0x0404, 1, 17, 11, 34, (char*) UC2_0404 },
	{ 0x0405, 1, 17, 11, 34, (char*) UC2_0405 },
	{ 0x0406, 1, 17, 3, 17, (char*) UC2_0406 },
	{ 0x0407, 1, 17, 7, 17, (char*) UC2_0407 },
	{ 0x0408, 1, 17, 9, 34, (char*) UC2_0408 },
	{ 0x0409, 1, 17, 17, 51, (char*) UC2_0409 },
	{ 0x040A, 1, 17, 16, 34, (char*) UC2_040A },
	{ 0x040B, 1, 17, 13, 34, (char*) UC2_040B },
	{ 0x040C, 1, 17, 11, 34, (char*) UC2_040C },
	{ 0x040E, 1, 17, 11, 34, (char*) UC2_040E },
	{ 0x040F, 1, 17, 11, 34, (char*) UC2_040F },
	{ 0x0410, 1, 17, 12, 34, (char*) UC2_0410 },
	{ 0x0411, 1, 17, 10, 34, (char*) UC2_0411 },
	{ 0x0412, 1, 17, 10, 34, (char*) UC2_0412 },
	{ 0x0413, 1, 17, 8, 17, (char*) UC2_0413 },
	{ 0x0414, 1, 17, 15, 34, (char*) UC2_0414 },
	{ 0x0415, 1, 17, 9, 34, (char*) UC2_0415 },
	{ 0x0416, 1, 17, 17, 51, (char*) UC2_0416 },
	{ 0x0417, 1, 17, 10, 34, (char*) UC2_0417 },
	{ 0x0418, 1, 17, 12, 34, (char*) UC2_0418 },
	{ 0x0419, 1, 17, 12, 34, (char*) UC2_0419 },
	{ 0x041A, 1, 17, 11, 34, (char*) UC2_041A },
	{ 0x041B, 1, 17, 13, 34, (char*) UC2_041B },
	{ 0x041C, 1, 17, 15, 34, (char*) UC2_041C },
	{ 0x041D, 1, 17, 12, 34, (char*) UC2_041D },
	{ 0x041E, 1, 17, 12, 34, (char*) UC2_041E },
	{ 0x041F, 1, 17, 11, 34, (char*) UC2_041F },
	{ 0x0420, 1, 17, 10, 34, (char*) UC2_0420 },
	{ 0x0421, 1, 17, 11, 34, (char*) UC2_0421 },
	{ 0x0422, 1, 17, 11, 34, (char*) UC2_0422 },
	{ 0x0423, 1, 17, 11, 34, (char*) UC2_0423 },
	{ 0x0425, 1, 17, 13, 34, (char*) UC2_0425 },
	{ 0x0426, 1, 17, 13, 34, (char*) UC2_0426 },
	{ 0x0427, 1, 17, 11, 34, (char*) UC2_0427 },
	{ 0x0428, 1, 17, 17, 51, (char*) UC2_0428 },
	{ 0x0429, 1, 17, 18, 51, (char*) UC2_0429 },
	{ 0x042A, 1, 17, 13, 34, (char*) UC2_042A },
	{ 0x042B, 1, 17, 14, 34, (char*) UC2_042B },
	{ 0x042C, 1, 17, 10, 34, (char*) UC2_042C },
	{ 0x042D, 1, 17, 12, 34, (char*) UC2_042D },
	{ 0x042E, 1, 17, 17, 51, (char*) UC2_042E },
	{ 0x042F, 1, 17, 11, 34, (char*) UC2_042F },
	{ 0x0430, 1, 17, 10, 34, (char*) UC2_0430 },
	{ 0x0431, 1, 17, 9, 34, (char*) UC2_0431 },
	{ 0x0432, 1, 17, 9, 34, (char*) UC2_0432 },
	{ 0x0433, 1, 17, 6, 17, (char*) UC2_0433 },
	{ 0x0434, 1, 17, 11, 34, (char*) UC2_0434 },
	{ 0x0435, 1, 17, 10, 34, (char*) UC2_0435 },
	{ 0x0436, 1, 17, 15, 34, (char*) UC2_0436 },
	{ 0x0437, 1, 17, 9, 34, (char*) UC2_0437 },
	{ 0x0438, 1, 17, 10, 34, (char*) UC2_0438 },
	{ 0x0439, 1, 17, 10, 34, (char*) UC2_0439 },
	{ 0x043A, 1, 17, 9, 34, (char*) UC2_043A },
	{ 0x043B, 1, 17, 10, 34, (char*) UC2_043B },
	{ 0x043C, 1, 17, 13, 34, (char*) UC2_043C },
	{ 0x043D, 1, 17, 10, 34, (char*) UC2_043D },
	{ 0x043E, 1, 17, 10, 34, (char*) UC2_043E },
	{ 0x043F, 1, 17, 10, 34, (char*) UC2_043F },
	{ 0x0440, 1, 17, 10, 34, (char*) UC2_0440 },
	{ 0x0441, 1, 17, 9, 34, (char*) UC2_0441 },
	{ 0x0442, 1, 17, 9, 34, (char*) UC2_0442 },
	{ 0x0443, 1, 17, 11, 34, (char*) UC2_0443 },
	{ 0x0444, 1, 17, 17, 51, (char*) UC2_0444 },
	{ 0x0445, 1, 17, 11, 34, (char*) UC2_0445 },
	{ 0x0446, 1, 17, 11, 34, (char*) UC2_0446 },
	{ 0x0447, 1, 17, 9, 34, (char*) UC2_0447 },
	{ 0x0448, 1, 17, 15, 34, (char*) UC2_0448 },
	{ 0x0449, 1, 17, 16, 34, (char*) UC2_0449 },
	{ 0x044A, 1, 17, 11, 34, (char*) UC2_044A },
	{ 0x044B, 1, 17, 13, 34, (char*) UC2_044B },
	{ 0x044C, 1, 17, 9, 34, (char*) UC2_044C },
	{ 0x044D, 1, 17, 9, 34, (char*) UC2_044D },
	{ 0x044E, 1, 17, 14, 34, (char*) UC2_044E },
	{ 0x044F, 1, 17, 9, 34, (char*) UC2_044F },
	{ 0x0451, 1, 17, 10, 34, (char*) UC2_0451 },
	{ 0x0452, 1, 17, 11, 34, (char*) UC2_0452 },
	{ 0x0453, 1, 17, 6, 17, (char*) UC2_0453 },
	{ 0x0454, 1, 17, 9, 34, (char*) UC2_0454 },
	{ 0x0455, 1, 17, 8, 17, (char*) UC2_0455 },
	{ 0x0456, 1, 17, 3, 17, (char*) UC2_0456 },
	{ 0x0457, 1, 17, 7, 17, (char*) UC2_0457 },
	{ 0x0458, 1, 17, 5, 17, (char*) UC2_0458 },
	{ 0x0459, 1, 17, 15, 34, (char*) UC2_0459 },
	{ 0x045A, 1, 17, 15, 34, (char*) UC2_045A },
	{ 0x045B, 1, 17, 11, 34, (char*) UC2_045B },
	{ 0x045C, 1, 17, 9, 34, (char*) UC2_045C },
	{ 0x045E, 1, 17, 11, 34, (char*) UC2_045E },
	{ 0x045F, 1, 17, 10, 34, (char*) UC2_045F },
	{ 0x0490, 1, 17, 8, 17, (char*) UC2_0490 },//500
	{ 0x0491, 1, 17, 7, 17, (char*) UC2_0491 },
	{ 0x1E80, 1, 17, 18, 51, (char*) UC2_1E80 },
	{ 0x1E81, 1, 17, 17, 51, (char*) UC2_1E81 },
	{ 0x1E82, 1, 17, 18, 51, (char*) UC2_1E82 },
	{ 0x1E83, 1, 17, 17, 51, (char*) UC2_1E83 },
	{ 0x1E84, 1, 17, 18, 51, (char*) UC2_1E84 },
	{ 0x1E85, 1, 17, 17, 51, (char*) UC2_1E85 },
	{ 0x1EF2, 1, 17, 11, 34, (char*) UC2_1EF2 },
	{ 0x1EF3, 1, 17, 11, 34, (char*) UC2_1EF3 },
	{ 0x2013, 1, 17, 9, 34, (char*) UC2_2013 },
	{ 0x2014, 1, 17, 18, 51, (char*) UC2_2014 },
	{ 0x2015, 1, 17, 18, 51, (char*) UC2_2015 },
	{ 0x2018, 1, 17, 4, 17, (char*) UC2_2018 },
	{ 0x2019, 1, 17, 4, 17, (char*) UC2_2019 },
	{ 0x201A, 1, 17, 4, 17, (char*) UC2_201A },
	{ 0x201B, 1, 17, 4, 17, (char*) UC2_201B },
	{ 0x201C, 1, 17, 8, 17, (char*) UC2_201C },
	{ 0x201D, 1, 17, 8, 17, (char*) UC2_201D },
	{ 0x201E, 1, 17, 8, 17, (char*) UC2_201E },
	{ 0x2020, 1, 17, 7, 17, (char*) UC2_2020 },
	{ 0x2021, 1, 17, 7, 17, (char*) UC2_2021 },
	{ 0x2022, 1, 17, 6, 17, (char*) UC2_2022 },
	{ 0x2026, 1, 17, 12, 34, (char*) UC2_2026 },
	{ 0x2030, 1, 17, 18, 51, (char*) UC2_2030 },
	{ 0x2032, 1, 17, 4, 17, (char*) UC2_2032 },
	{ 0x2033, 1, 17, 8, 17, (char*) UC2_2033 },
	{ 0x2039, 1, 17, 7, 17, (char*) UC2_2039 },
	{ 0x203A, 1, 17, 7, 17, (char*) UC2_203A },
	{ 0x203C, 1, 17, 8, 17, (char*) UC2_203C },
	{ 0x203E, 1, 17, 10, 34, (char*) UC2_203E },
	{ 0x2044, 1, 17, 11, 34, (char*) UC2_2044 },
	{ 0x2070, 1, 17, 7, 17, (char*) UC2_2070 },
	{ 0x2074, 1, 17, 7, 17, (char*) UC2_2074 },
	{ 0x2075, 1, 17, 7, 17, (char*) UC2_2075 },
	{ 0x2076, 1, 17, 8, 17, (char*) UC2_2076 },
	{ 0x2077, 1, 17, 7, 17, (char*) UC2_2077 },
	{ 0x2078, 1, 17, 7, 17, (char*) UC2_2078 },
	{ 0x2079, 1, 17, 8, 17, (char*) UC2_2079 },
	{ 0x207F, 1, 17, 7, 17, (char*) UC2_207F },
	{ 0x2080, 1, 17, 7, 17, (char*) UC2_2080 },
	{ 0x2081, 1, 17, 7, 17, (char*) UC2_2081 },
	{ 0x2082, 1, 17, 7, 17, (char*) UC2_2082 },
	{ 0x2083, 1, 17, 7, 17, (char*) UC2_2083 },
	{ 0x2084, 1, 17, 7, 17, (char*) UC2_2084 },
	{ 0x2085, 1, 17, 7, 17, (char*) UC2_2085 },
	{ 0x2086, 1, 17, 8, 17, (char*) UC2_2086 },
	{ 0x2087, 1, 17, 7, 17, (char*) UC2_2087 },
	{ 0x2088, 1, 17, 7, 17, (char*) UC2_2088 },
	{ 0x2089, 1, 17, 8, 17, (char*) UC2_2089 },
	{ 0x20A3, 1, 17, 8, 17, (char*) UC2_20A3 },
	{ 0x20A4, 1, 17, 11, 34, (char*) UC2_20A4 },
	{ 0x20A7, 1, 17, 18, 51, (char*) UC2_20A7 },
	{ 0x20AC, 1, 17, 11, 34, (char*) UC2_20AC },
	{ 0x2105, 1, 17, 17, 51, (char*) UC2_2105 },
	{ 0x2113, 1, 17, 7, 17, (char*) UC2_2113 },
	{ 0x2116, 1, 17, 18, 51, (char*) UC2_2116 },
	{ 0x2122, 1, 17, 13, 34, (char*) UC2_2122 },
	{ 0x2126, 1, 17, 12, 34, (char*) UC2_2126 },
	{ 0x212E, 1, 17, 10, 34, (char*) UC2_212E },
	{ 0x215B, 1, 17, 16, 34, (char*) UC2_215B },
	{ 0x215C, 1, 17, 17, 51, (char*) UC2_215C },
	{ 0x215D, 1, 17, 17, 51, (char*) UC2_215D },
	{ 0x215E, 1, 17, 16, 34, (char*) UC2_215E },
	{ 0x2202, 1, 17, 10, 34, (char*) UC2_2202 },
	{ 0x2206, 1, 17, 12, 34, (char*) UC2_2206 },
	{ 0x220F, 1, 17, 12, 34, (char*) UC2_220F },
	{ 0x2211, 1, 17, 11, 34, (char*) UC2_2211 },
	{ 0x2212, 1, 17, 10, 34, (char*) UC2_2212 },
	{ 0x221A, 1, 17, 11, 34, (char*) UC2_221A },
	{ 0x221E, 1, 17, 15, 34, (char*) UC2_221E },
	{ 0x222B, 1, 17, 7, 17, (char*) UC2_222B },
	{ 0x2248, 1, 17, 10, 34, (char*) UC2_2248 },
	{ 0x2260, 1, 17, 10, 34, (char*) UC2_2260 },
	{ 0x2264, 1, 17, 10, 34, (char*) UC2_2264 },
	{ 0x2265, 1, 17, 10, 34, (char*) UC2_2265 },
	{ 0x25CA, 1, 17, 10, 34, (char*) UC2_25CA },
	{ 0xFB01, 1, 17, 10, 34, (char*) UC2_FB01 },
	{ 0xFB02, 1, 17, 10, 34, (char*) UC2_FB02 },
	
#if !defined MMI_LITE && defined CHINESE_MMI
	{ 0x0400, 1,16, 8,127,(char*)cyrillic_0400},
	{ 0x0401, 1,16, 8,127,(char*)cyrillic_0401},
	{ 0x0402, 1,16, 8,127,(char*)cyrillic_0402},
	{ 0x0403, 1,16, 8,127,(char*)cyrillic_0403},
	{ 0x0404, 1,16, 8,127,(char*)cyrillic_0404},
	{ 0x0405, 1,16, 8,127,(char*)cyrillic_0405},
	{ 0x0406, 1,16, 8,127,(char*)cyrillic_0406},
	{ 0x0407, 1,16, 8,127,(char*)cyrillic_0407},
	{ 0x0408, 1,16, 8,127,(char*)cyrillic_0408},
	{ 0x0409, 1,16, 8,127,(char*)cyrillic_0409},
	{ 0x040a, 1,16, 8,127,(char*)cyrillic_040a},
	{ 0x040b, 1,16, 8,127,(char*)cyrillic_040b},
	{ 0x040c, 1,16, 8,127,(char*)cyrillic_040c},
	{ 0x040d, 1,16, 8,127,(char*)cyrillic_040d},
	{ 0x040e, 1,16, 8,127,(char*)cyrillic_040e},
	{ 0x040f, 1,16, 8,127,(char*)cyrillic_040f},
	{ 0x0410, 1,16, 8,127,(char*)cyrillic_0410},
	{ 0x0411, 1,16, 8,127,(char*)cyrillic_0411},
	{ 0x0412, 1,16, 8,127,(char*)cyrillic_0412},
	{ 0x0413, 1,16, 8,127,(char*)cyrillic_0413},
	{ 0x0414, 1,16, 8,127,(char*)cyrillic_0414},
	{ 0x0415, 1,16, 8,127,(char*)cyrillic_0415},
	{ 0x0416, 1,16, 8,127,(char*)cyrillic_0416},
	{ 0x0417, 1,16, 8,127,(char*)cyrillic_0417},
	{ 0x0418, 1,16, 8,127,(char*)cyrillic_0418},
	{ 0x0419, 1,16, 8,127,(char*)cyrillic_0419},
	{ 0x041a, 1,16, 8,127,(char*)cyrillic_041a},
	{ 0x041b, 1,16, 8,127,(char*)cyrillic_041b},
	{ 0x041c, 1,16, 8,127,(char*)cyrillic_041c},
	{ 0x041d, 1,16, 8,127,(char*)cyrillic_041d},
	{ 0x041e, 1,16, 8,127,(char*)cyrillic_041e},
	{ 0x041f, 1,16, 8,127,(char*)cyrillic_041f},
	{ 0x0420, 1,16, 8,127,(char*)cyrillic_0420},
	{ 0x0421, 1,16, 8,127,(char*)cyrillic_0421},
	{ 0x0422, 1,16, 8,127,(char*)cyrillic_0422},
	{ 0x0423, 1,16, 8,127,(char*)cyrillic_0423},
	{ 0x0424, 1,16, 8,127,(char*)cyrillic_0424},
	{ 0x0425, 1,16, 8,127,(char*)cyrillic_0425},
	{ 0x0426, 1,16, 8,127,(char*)cyrillic_0426},
	{ 0x0427, 1,16, 8,127,(char*)cyrillic_0427},
	{ 0x0428, 1,16, 8,127,(char*)cyrillic_0428},
	{ 0x0429, 1,16, 8,127,(char*)cyrillic_0429},
	{ 0x042a, 1,16, 8,127,(char*)cyrillic_042a},
	{ 0x042b, 1,16, 8,127,(char*)cyrillic_042b},
	{ 0x042c, 1,16, 8,127,(char*)cyrillic_042c},
	{ 0x042d, 1,16, 8,127,(char*)cyrillic_042d},
	{ 0x042e, 1,16, 8,127,(char*)cyrillic_042e},
	{ 0x042f, 1,16, 8,127,(char*)cyrillic_042f},
	{ 0x0430, 1,16, 8,127,(char*)cyrillic_0430},
	{ 0x0431, 1,16, 8,127,(char*)cyrillic_0431},
	{ 0x0432, 1,16, 8,127,(char*)cyrillic_0432},
	{ 0x0433, 1,16, 8,127,(char*)cyrillic_0433},
	{ 0x0434, 1,16, 8,127,(char*)cyrillic_0434},
	{ 0x0435, 1,16, 8,127,(char*)cyrillic_0435},
	{ 0x0436, 1,16, 8,127,(char*)cyrillic_0436},
	{ 0x0437, 1,16, 8,127,(char*)cyrillic_0437},
	{ 0x0438, 1,16, 8,127,(char*)cyrillic_0438},
	{ 0x0439, 1,16, 8,127,(char*)cyrillic_0439},
	{ 0x043a, 1,16, 8,127,(char*)cyrillic_043a},
	{ 0x043b, 1,16, 8,127,(char*)cyrillic_043b},
	{ 0x043c, 1,16, 8,127,(char*)cyrillic_043c},
	{ 0x043d, 1,16, 8,127,(char*)cyrillic_043d},
	{ 0x043e, 1,16, 8,127,(char*)cyrillic_043e},
	{ 0x043f, 1,16, 8,127,(char*)cyrillic_043f},
	{ 0x0440, 1,16, 8,127,(char*)cyrillic_0440},
	{ 0x0441, 1,16, 8,127,(char*)cyrillic_0441},
	{ 0x0442, 1,16, 8,127,(char*)cyrillic_0442},
	{ 0x0443, 1,16, 8,127,(char*)cyrillic_0443},
	{ 0x0444, 1,16, 8,127,(char*)cyrillic_0444},
	{ 0x0445, 1,16, 8,127,(char*)cyrillic_0445},
	{ 0x0446, 1,16, 8,127,(char*)cyrillic_0446},
	{ 0x0447, 1,16, 8,127,(char*)cyrillic_0447},
	{ 0x0448, 1,16, 8,127,(char*)cyrillic_0448},
	{ 0x0449, 1,16, 8,127,(char*)cyrillic_0449},
	{ 0x044a, 1,16, 8,127,(char*)cyrillic_044a},
	{ 0x044b, 1,16, 8,127,(char*)cyrillic_044b},
	{ 0x044c, 1,16, 8,127,(char*)cyrillic_044c},
	{ 0x044d, 1,16, 8,127,(char*)cyrillic_044d},
	{ 0x044e, 1,16, 8,127,(char*)cyrillic_044e},
	{ 0x044f, 1,16, 8,127,(char*)cyrillic_044f},
	{ 0x0450, 1,16, 8,127,(char*)cyrillic_0450},
	{ 0x0451, 1,16, 8,127,(char*)cyrillic_0451},
	{ 0x0452, 1,16, 8,127,(char*)cyrillic_0452},
	{ 0x0453, 1,16, 8,127,(char*)cyrillic_0453},
	{ 0x0454, 1,16, 8,127,(char*)cyrillic_0454},
	{ 0x0455, 1,16, 8,127,(char*)cyrillic_0455},
	{ 0x0456, 1,16, 8,127,(char*)cyrillic_0456},
	{ 0x0457, 1,16, 8,127,(char*)cyrillic_0457},
	{ 0x0458, 1,16, 8,127,(char*)cyrillic_0458},
	{ 0x0459, 1,16, 8,127,(char*)cyrillic_0459},
	{ 0x045a, 1,16, 8,127,(char*)cyrillic_045a},
	{ 0x045b, 1,16, 8,127,(char*)cyrillic_045b},
	{ 0x045c, 1,16, 8,127,(char*)cyrillic_045c},
	{ 0x045d, 1,16, 8,127,(char*)cyrillic_045d},
	{ 0x045e, 1,16, 8,127,(char*)cyrillic_045e},
	{ 0x045f, 1,16, 8,127,(char*)cyrillic_045f},
	{ 0x0460, 1,16, 8,127,(char*)cyrillic_0460},
	{ 0x0461, 1,16, 8,127,(char*)cyrillic_0461},
	{ 0x0462, 1,16, 8,127,(char*)cyrillic_0462},
	{ 0x0463, 1,16, 8,127,(char*)cyrillic_0463},
	{ 0x0464, 1,16, 8,127,(char*)cyrillic_0464},
	{ 0x0465, 1,16, 8,127,(char*)cyrillic_0465},
	{ 0x0466, 1,16, 8,127,(char*)cyrillic_0466},
	{ 0x0467, 1,16, 8,127,(char*)cyrillic_0467},
	{ 0x0468, 1,16, 8,127,(char*)cyrillic_0468},
	{ 0x0469, 1,16, 8,127,(char*)cyrillic_0469},
	{ 0x046a, 1,16, 8,127,(char*)cyrillic_046a},
	{ 0x046b, 1,16, 8,127,(char*)cyrillic_046b},
	{ 0x046c, 1,16, 8,127,(char*)cyrillic_046c},
	{ 0x046d, 1,16, 8,127,(char*)cyrillic_046d},
	{ 0x046e, 1,16, 8,127,(char*)cyrillic_046e},
	{ 0x046f, 1,16, 8,127,(char*)cyrillic_046f},
	{ 0x0470, 1,16, 8,127,(char*)cyrillic_0470},
	{ 0x0471, 1,16, 8,127,(char*)cyrillic_0471},
	{ 0x0472, 1,16, 8,127,(char*)cyrillic_0472},
	{ 0x0473, 1,16, 8,127,(char*)cyrillic_0473},
	{ 0x0474, 1,16, 8,127,(char*)cyrillic_0474},
	{ 0x0475, 1,16, 8,127,(char*)cyrillic_0475},
	{ 0x0476, 1,16, 8,127,(char*)cyrillic_0476},
	{ 0x0477, 1,16, 8,127,(char*)cyrillic_0477},
	{ 0x0478, 1,16, 8,127,(char*)cyrillic_0478},
	{ 0x0479, 1,16, 8,127,(char*)cyrillic_0479},
	{ 0x047a, 1,16, 8,127,(char*)cyrillic_047a},
	{ 0x047b, 1,16, 8,127,(char*)cyrillic_047b},
	{ 0x047c, 1,16, 8,127,(char*)cyrillic_047c},
	{ 0x047d, 1,16, 8,127,(char*)cyrillic_047d},
	{ 0x047e, 1,16, 8,127,(char*)cyrillic_047e},
	{ 0x047f, 1,16, 8,127,(char*)cyrillic_047f},
	{ 0x0480, 1,16, 8,127,(char*)cyrillic_0480},
	{ 0x0481, 1,16, 8,127,(char*)cyrillic_0481},
	{ 0x0482, 1,16, 8,127,(char*)cyrillic_0482},
	{ 0x048a, 1,16, 8,127,(char*)cyrillic_048a},
	{ 0x048b, 1,16, 8,127,(char*)cyrillic_048b},
	{ 0x048c, 1,16, 8,127,(char*)cyrillic_048c},
	{ 0x048d, 1,16, 8,127,(char*)cyrillic_048d},
	{ 0x048e, 1,16, 8,127,(char*)cyrillic_048e},
	{ 0x048f, 1,16, 8,127,(char*)cyrillic_048f},
	{ 0x0490, 1,16, 8,127,(char*)cyrillic_0490},
	{ 0x0491, 1,16, 8,127,(char*)cyrillic_0491},
	{ 0x0492, 1,16, 8,127,(char*)cyrillic_0492},
	{ 0x0493, 1,16, 8,127,(char*)cyrillic_0493},
	{ 0x0494, 1,16, 8,127,(char*)cyrillic_0494},
	{ 0x0495, 1,16, 8,127,(char*)cyrillic_0495},
	{ 0x0496, 1,16, 8,127,(char*)cyrillic_0496},
	{ 0x0497, 1,16, 8,127,(char*)cyrillic_0497},
	{ 0x0498, 1,16, 8,127,(char*)cyrillic_0498},
	{ 0x0499, 1,16, 8,127,(char*)cyrillic_0499},
	{ 0x049a, 1,16, 8,127,(char*)cyrillic_049a},
	{ 0x049b, 1,16, 8,127,(char*)cyrillic_049b},
	{ 0x049c, 1,16, 8,127,(char*)cyrillic_049c},
	{ 0x049d, 1,16, 8,127,(char*)cyrillic_049d},
	{ 0x049e, 1,16, 8,127,(char*)cyrillic_049e},
	{ 0x049f, 1,16, 8,127,(char*)cyrillic_049f},
	{ 0x04a0, 1,16, 8,127,(char*)cyrillic_04a0},
	{ 0x04a1, 1,16, 8,127,(char*)cyrillic_04a1},
	{ 0x04a2, 1,16, 8,127,(char*)cyrillic_04a2},
	{ 0x04a3, 1,16, 8,127,(char*)cyrillic_04a3},
	{ 0x04a4, 1,16, 8,127,(char*)cyrillic_04a4},
	{ 0x04a5, 1,16, 8,127,(char*)cyrillic_04a5},
	{ 0x04a6, 1,16, 8,127,(char*)cyrillic_04a6},
	{ 0x04a7, 1,16, 8,127,(char*)cyrillic_04a7},
	{ 0x04a8, 1,16, 8,127,(char*)cyrillic_04a8},
	{ 0x04a9, 1,16, 8,127,(char*)cyrillic_04a9},
	{ 0x04aa, 1,16, 8,127,(char*)cyrillic_04aa},
	{ 0x04ab, 1,16, 8,127,(char*)cyrillic_04ab},
	{ 0x04ac, 1,16, 8,127,(char*)cyrillic_04ac},
	{ 0x04ad, 1,16, 8,127,(char*)cyrillic_04ad},
	{ 0x04ae, 1,16, 8,127,(char*)cyrillic_04ae},
	{ 0x04af, 1,16, 8,127,(char*)cyrillic_04af},
	{ 0x04b0, 1,16, 8,127,(char*)cyrillic_04b0},
	{ 0x04b1, 1,16, 8,127,(char*)cyrillic_04b1},
	{ 0x04b2, 1,16, 8,127,(char*)cyrillic_04b2},
	{ 0x04b3, 1,16, 8,127,(char*)cyrillic_04b3},
	{ 0x04b4, 1,16, 8,127,(char*)cyrillic_04b4},
	{ 0x04b5, 1,16, 8,127,(char*)cyrillic_04b5},
	{ 0x04b6, 1,16, 8,127,(char*)cyrillic_04b6},
	{ 0x04b7, 1,16, 8,127,(char*)cyrillic_04b7},
	{ 0x04b8, 1,16, 8,127,(char*)cyrillic_04b8},
	{ 0x04b9, 1,16, 8,127,(char*)cyrillic_04b9},
	{ 0x04ba, 1,16, 8,127,(char*)cyrillic_04ba},
	{ 0x04bb, 1,16, 8,127,(char*)cyrillic_04bb},
	{ 0x04bc, 1,16, 8,127,(char*)cyrillic_04bc},
	{ 0x04bd, 1,16, 8,127,(char*)cyrillic_04bd},
	{ 0x04be, 1,16, 8,127,(char*)cyrillic_04be},
	{ 0x04bf, 1,16, 8,127,(char*)cyrillic_04bf},
	{ 0x04c0, 1,16, 8,127,(char*)cyrillic_04c0},
	{ 0x04c1, 1,16, 8,127,(char*)cyrillic_04c1},
	{ 0x04c2, 1,16, 8,127,(char*)cyrillic_04c2},
	{ 0x04c3, 1,16, 8,127,(char*)cyrillic_04c3},
	{ 0x04c4, 1,16, 8,127,(char*)cyrillic_04c4},
	{ 0x04c5, 1,16, 8,127,(char*)cyrillic_04c5},
	{ 0x04c6, 1,16, 8,127,(char*)cyrillic_04c6},
	{ 0x04c7, 1,16, 8,127,(char*)cyrillic_04c7},
	{ 0x04c8, 1,16, 8,127,(char*)cyrillic_04c8},
	{ 0x04c9, 1,16, 8,127,(char*)cyrillic_04c9},
	{ 0x04ca, 1,16, 8,127,(char*)cyrillic_04ca},
	{ 0x04cb, 1,16, 8,127,(char*)cyrillic_04cb},
	{ 0x04cc, 1,16, 8,127,(char*)cyrillic_04cc},
	{ 0x04cd, 1,16, 8,127,(char*)cyrillic_04cd},
	{ 0x04ce, 1,16, 8,127,(char*)cyrillic_04ce},
	{ 0x04d0, 1,16, 8,127,(char*)cyrillic_04d0},
	{ 0x04d1, 1,16, 8,127,(char*)cyrillic_04d1},
	{ 0x04d2, 1,16, 8,127,(char*)cyrillic_04d2},
	{ 0x04d3, 1,16, 8,127,(char*)cyrillic_04d3},
	{ 0x04d4, 1,16, 8,127,(char*)cyrillic_04d4},
	{ 0x04d5, 1,16, 8,127,(char*)cyrillic_04d5},
	{ 0x04d6, 1,16, 8,127,(char*)cyrillic_04d6},
	{ 0x04d7, 1,16, 8,127,(char*)cyrillic_04d7},
	{ 0x04d8, 1,16, 8,127,(char*)cyrillic_04d8},
	{ 0x04d9, 1,16, 8,127,(char*)cyrillic_04d9},
	{ 0x04da, 1,16, 8,127,(char*)cyrillic_04da},
	{ 0x04db, 1,16, 8,127,(char*)cyrillic_04db},
	{ 0x04dc, 1,16, 8,127,(char*)cyrillic_04dc},
	{ 0x04dd, 1,16, 8,127,(char*)cyrillic_04dd},
	{ 0x04de, 1,16, 8,127,(char*)cyrillic_04de},
	{ 0x04df, 1,16, 8,127,(char*)cyrillic_04df},
	{ 0x04e0, 1,16, 8,127,(char*)cyrillic_04e0},
	{ 0x04e1, 1,16, 8,127,(char*)cyrillic_04e1},
	{ 0x04e2, 1,16, 8,127,(char*)cyrillic_04e2},
	{ 0x04e3, 1,16, 8,127,(char*)cyrillic_04e3},
	{ 0x04e4, 1,16, 8,127,(char*)cyrillic_04e4},
	{ 0x04e5, 1,16, 8,127,(char*)cyrillic_04e5},
	{ 0x04e6, 1,16, 8,127,(char*)cyrillic_04e6},
	{ 0x04e7, 1,16, 8,127,(char*)cyrillic_04e7},
	{ 0x04e8, 1,16, 8,127,(char*)cyrillic_04e8},
	{ 0x04e9, 1,16, 8,127,(char*)cyrillic_04e9},
	{ 0x04ea, 1,16, 8,127,(char*)cyrillic_04ea},
	{ 0x04eb, 1,16, 8,127,(char*)cyrillic_04eb},
	{ 0x04ec, 1,16, 8,127,(char*)cyrillic_04ec},
	{ 0x04ed, 1,16, 8,127,(char*)cyrillic_04ed},
	{ 0x04ee, 1,16, 8,127,(char*)cyrillic_04ee},
	{ 0x04ef, 1,16, 8,127,(char*)cyrillic_04ef},
	{ 0x04f0, 1,16, 8,127,(char*)cyrillic_04f0},
	{ 0x04f1, 1,16, 8,127,(char*)cyrillic_04f1},
	{ 0x04f2, 1,16, 8,127,(char*)cyrillic_04f2},
	{ 0x04f3, 1,16, 8,127,(char*)cyrillic_04f3},
	{ 0x04f4, 1,16, 8,127,(char*)cyrillic_04f4},
	{ 0x04f5, 1,16, 8,127,(char*)cyrillic_04f5},
	{ 0x04f6, 1,16, 8,127,(char*)cyrillic_04f6},
	{ 0x04f7, 1,16, 8,127,(char*)cyrillic_04f7},
	{ 0x04f8, 1,16, 8,127,(char*)cyrillic_04f8},
	{ 0x04f9, 1,16, 8,127,(char*)cyrillic_04f9},
#endif /* !defined MMI_LITE && defined CHINESE_MMI */
	
    { 0xFFFF, 1, 12, 12, 24, (char *) uc2_rubbish}
};

#else /*FF_ENDURANCE_FONT*/ //x0pleela 09 Nov, 2006 ER: OMAPS00099966

/*  Nov 24, 2006 Ref OMAPS00092906, x0039928(sumanth)
     Fix: A new bitmap  is added for Esc characters          */
const unsigned char BMP_Chant_027[] = {0x00,0x00,0x00,0x08,0x24,0x62,0x22,0x22,0x22,0x72,0x04,0x08,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_030[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_031[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_032[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_033[] = {0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_034[] = {0x00,0x00,0x00,0x00,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_035[] = {0x00,0x00,0x00,0x48,0x48,0xFC,0x48,0x48,0xFC,0x48,0x48,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_036[] = {0x00,0x00,0x20,0x70,0xA8,0xA0,0x60,0x30,0x28,0xA8,0x70,0x20,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_037[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_038[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x48,0x00,0x48,0x00,0x77,0x00,0x72,0x00,0x9A,0x00,0x8C,0x00,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_039[] = {0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_040[] = {0x00,0x00,0x00,0x20,0x20,0x40,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x40,0x40,0x20,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_041[] = {0x00,0x00,0x80,0x40,0x60,0x20,0x20,0x20,0x30,0x20,0x20,0x20,0x40,0x40,0x80,0x00,0x00,0x00};
const unsigned char BMP_Chant_042[] = {0x00,0x00,0xA0,0xE0,0x40,0xE0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_043[] = {0x00,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_044[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_045[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_046[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_047[] = {0x00,0x00,0x10,0x10,0x10,0x10,0x20,0x20,0x20,0x40,0x40,0x40,0x80,0x80,0x00,0x00};
const unsigned char BMP_Chant_048[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0xD8,0x88,0xD8,0x70,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_049[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_050[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x90,0x20,0x40,0xF0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_051[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x90,0x10,0x30,0x08,0x08,0x98,0x60,0x00,0x00};
const unsigned char BMP_Chant_052[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x30,0x50,0x90,0xFC,0x10,0x10,0x10,0x00,0x00};
const unsigned char BMP_Chant_053[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x20,0x20,0x30,0x08,0x08,0x98,0x60,0x00,0x00};
const unsigned char BMP_Chant_054[] = {0x00,0x00,0x00,0x18,0x20,0x40,0x40,0xF8,0x88,0x88,0x70,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_055[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x08,0x08,0x10,0x10,0x30,0x20,0xC0,0x00,0x00};
const unsigned char BMP_Chant_056[] = {0x00,0x00,0x00,0x30,0x48,0x48,0x30,0x58,0x88,0x88,0x70,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_057[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x48,0x48,0x48,0x38,0x08,0x10,0xE0,0x00,0x00};
const unsigned char BMP_Chant_058[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_059[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x40,0xC0,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_060[] = {0x00,0x00,0x00,0x00,0x04,0x08,0x30,0xE0,0x10,0x0C,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_061[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_062[] = {0x00,0x00,0x00,0x00,0x80,0x60,0x10,0x0C,0x30,0xC0,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_063[] = {0x00,0x00,0x00,0x60,0x90,0x20,0x40,0x40,0x40,0x00,0x40,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_064[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x00,0x40,0x80,0x9E,0x80,0x92,0x80,0xB2,0x80,0xBF,0x00,0x80,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_065[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x18,0x00,0x24,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_066[] = {0x00,0x00,0x00,0xF8,0x44,0x44,0x7C,0x46,0x42,0x46,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_067[] = {0x00,0x00,0x00,0x3E,0x42,0xC0,0x80,0x80,0xC0,0x42,0x3E,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_068[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xFE,0x00,0x41,0x00,0x41,0x80,0x40,0x80,0x40,0x80,0x41,0x80,0x41,0x00,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_069[] = {0x00,0x00,0x00,0xFC,0x44,0x48,0x78,0x48,0x40,0x44,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_070[] = {0x00,0x00,0x00,0xFC,0x44,0x48,0x78,0x48,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_071[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x42,0x00,0xC0,0x00,0x80,0x00,0x83,0x80,0xC1,0x00,0x41,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_072[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE3,0x80,0x41,0x00,0x41,0x00,0x7F,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_073[] = {0x00,0x00,0x00,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_074[] = {0x00,0x00,0x00,0x38,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0xE0,0x00,0x00,0x00};
const unsigned char BMP_Chant_075[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xEE,0x00,0x48,0x00,0x50,0x00,0x60,0x00,0x50,0x00,0x58,0x00,0x4C,0x00,0xE7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_076[] = {0x00,0x00,0x00,0xE0,0x40,0x40,0x40,0x40,0x40,0x44,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_077[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0xE0,0x20,0x80,0x51,0x40,0x52,0x40,0x4A,0x40,0x4A,0x40,0x44,0x40,0xE4,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_078[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE1,0xC0,0x30,0x80,0x28,0x80,0x24,0x80,0x26,0x80,0x23,0x80,0x21,0x80,0x70,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_079[] = {0x00,0x00,0x00,0x00,0x08,0x00,0x77,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xC1,0x80,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_080[] = {0x00,0x00,0x00,0xF8,0x44,0x44,0x44,0x68,0x50,0x40,0xE0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_081[] = {0x00,0x00,0x00,0x00,0x08,0x00,0x76,0x00,0x41,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xC1,0x00,0x41,0x00,0x32,0x00,0x0F,0x00,0x01,0xF0,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_082[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00,0x44,0x00,0x44,0x00,0x7C,0x00,0x48,0x00,0x48,0x00,0x44,0x00,0xE3,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_083[] = {0x00,0x00,0x00,0x78,0x80,0x80,0xF0,0x18,0x04,0x84,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_084[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xFE,0x00,0x92,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_085[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE3,0x80,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_086[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF1,0xE0,0x20,0x80,0x10,0x80,0x11,0x00,0x09,0x00,0x0A,0x00,0x06,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_087[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE1,0x1C,0x21,0x10,0x23,0x90,0x14,0x90,0x14,0xD0,0x1C,0x60,0x08,0x60,0x08,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_088[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF3,0x80,0x22,0x00,0x14,0x00,0x08,0x00,0x1C,0x00,0x26,0x00,0x43,0x00,0xC1,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_089[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE3,0x80,0x36,0x00,0x14,0x00,0x1C,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_090[] = {0x00,0x00,0x00,0xFE,0x84,0x08,0x18,0x30,0x20,0x42,0xFE,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_091[] = {0x00,0x00,0x00,0x70,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x70,0x00,0x00,0x00,0x00}; /* SPR#2034 - SH - Added open square bracket */
const unsigned char BMP_Chant_092[] = {0x00,0x00,0x80,0x80,0x40,0x40,0x40,0x20,0x20,0x20,0x10,0x10,0x10,0x18,0x00,0x00};
const unsigned char BMP_Chant_093[] = {0x00,0x00,0x00,0x70,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x10,0x70,0x00,0x00,0x00,0x00}; /* SPR#2034 - SH - Added close square bracket */
const unsigned char BMP_Chant_094[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_095[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFE,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_096[] = {0x80,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_097[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x90,0x70,0x90,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_098[] = {0x00,0x00,0x00,0xC0,0x40,0x40,0x78,0x44,0x44,0x44,0x38,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_099[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x88,0x80,0x88,0x70,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_100[] = {0x00,0x00,0x00,0x18,0x08,0x08,0x78,0x88,0x88,0x88,0x7C,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_101[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x88,0xF0,0x80,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_102[] = {0x00,0x00,0x00,0x78,0x48,0x40,0xE0,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_103[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x90,0x90,0x70,0x80,0xF0,0x88,0x88,0x70,0x00};
const unsigned char BMP_Chant_104[] = {0x00,0x00,0x00,0xC0,0x40,0x40,0x78,0x44,0x44,0x44,0xEE,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_105[] = {0x00,0x00,0x00,0x00,0x40,0x00,0xC0,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_106[] = {0x00,0x00,0x00,0x00,0x40,0x00,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0xC0,0x00,0x00};
const unsigned char BMP_Chant_107[] = {0x00,0x00,0x00,0xC0,0x40,0x40,0x5C,0x50,0x70,0x58,0xCE,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_108[] = {0x00,0x00,0x00,0xC0,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_109[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xDB,0x00,0x6C,0x80,0x48,0x80,0x48,0x80,0xED,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_110[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x44,0x44,0x44,0xEE,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_111[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xCC,0x84,0xCC,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_112[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0xE0,0x00};
const unsigned char BMP_Chant_113[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x88,0x88,0x88,0x78,0x08,0x08,0x08,0x1C,0x00};
const unsigned char BMP_Chant_114[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_115[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x80,0xE0,0x30,0xE0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_116[] = {0x00,0x00,0x00,0x00,0x40,0x40,0xF0,0x40,0x40,0x50,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_117[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xCC,0x44,0x44,0x44,0x3E,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_118[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xCC,0x48,0x30,0x30,0x10,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_119[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xDD,0x80,0x55,0x00,0x36,0x00,0x36,0x00,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_120[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xEC,0x30,0x20,0x50,0xDC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_121[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xEC,0x48,0x50,0x30,0x20,0x20,0x20,0xC0,0x00,0x00};
const unsigned char BMP_Chant_122[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x90,0x20,0x48,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_123[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_124[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_125[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_126[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_127[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

const unsigned char BMP_Chant_161[] = {0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_162[] = {0x00,0x00,0x20,0x20,0x78,0xA0,0xA0,0xA8,0x70,0x20,0x20,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_163[] = {0x00,0x00,0x00,0x38,0x44,0x44,0x20,0x78,0x20,0x24,0x7C,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_164[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x21,0x00,0x60,0x00,0xFE,0x00,0x60,0x00,0xFE,0x00,0x61,0x00,0x3F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_165[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xF3,0x80,0x32,0x00,0x1C,0x00,0x3E,0x00,0x08,0x00,0x3E,0x00,0x08,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

const unsigned char BMP_Chant_167[] = {0x38,0x44,0x44,0x60,0x70,0x9C,0x86,0xC2,0x72,0x1C,0x0C,0x84,0xC4,0x78,0x00,0x00};
const unsigned char BMP_Chant_168[] = {0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_169[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_170[] = {0x00,0x00,0x00,0xC0,0xC0,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_171[] = {0x00,0x00,0x00,0x00,0x00,0x60,0xA0,0xC0,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_180[] = {0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_184[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_186[] = {0x00,0x00,0x00,0xE0,0xA0,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_187[] = {0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0xA0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_191[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x20,0x20,0x40,0x80,0x80,0x70,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_192[] = {0x00,0x00,0x30,0x00,0x10,0x00,0x08,0x00,0x18,0x00,0x2C,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_193[] = {0x00,0x00,0x04,0x00,0x08,0x00,0x08,0x00,0x18,0x00,0x2C,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_194[] = {0x00,0x00,0x10,0x00,0x18,0x00,0x0C,0x00,0x18,0x00,0x2C,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_195[] = {0x00,0x00,0x00,0x00,0x1C,0x00,0x08,0x00,0x18,0x00,0x2C,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_196[] = {0x00,0x00,0x24,0x00,0x00,0x00,0x18,0x00,0x2C,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_197[] = {0x18,0x00,0x18,0x00,0x08,0x00,0x08,0x00,0x18,0x00,0x2C,0x00,0x24,0x00,0x3E,0x00,0x42,0x00,0x42,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_198[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xE0,0x0A,0x00,0x12,0x20,0x0F,0xE0,0x32,0x20,0x22,0x00,0x42,0x20,0xE7,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_199[] = {0x00,0x00,0x00,0x3E,0x42,0xC0,0x80,0x80,0xC0,0x42,0x3E,0x10,0x18,0x00,0x00,0x00};
const unsigned char BMP_Chant_200[] = {0x00,0x60,0x10,0xFC,0x40,0x48,0x78,0x48,0x40,0x44,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_201[] = {0x00,0x18,0x20,0xFC,0x40,0x48,0x78,0x48,0x40,0x44,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_202[] = {0x00,0x20,0x50,0xFC,0x40,0x48,0x78,0x48,0x40,0x44,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_203[] = {0x00,0x00,0x30,0xFC,0x40,0x48,0x78,0x48,0x40,0x44,0xFC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_204[] = {0x00,0x80,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_205[] = {0x00,0x30,0x40,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_206[] = {0x00,0x40,0xA0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_207[] = {0x00,0x00,0xE0,0x40,0x40,0x40,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_208[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xFE,0x00,0x41,0x00,0x41,0x80,0xF0,0x80,0x40,0x80,0x41,0x80,0x41,0x00,0xFE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_209[] = {0x19,0x00,0x26,0x00,0x00,0x00,0xE1,0xC0,0x30,0x80,0x28,0x80,0x24,0x80,0x26,0x80,0x23,0x80,0x21,0x80,0x70,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_211[] = {0x04,0x00,0x0C,0x00,0x08,0x00,0x76,0x00,0x41,0x00,0x81,0x80,0x81,0x80,0x80,0x80,0xC1,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_212[] = {0x00,0x00,0x08,0x00,0x1C,0x00,0x62,0x00,0x41,0x00,0x81,0x80,0x81,0x80,0x80,0x80,0xC1,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_213[] = {0x00,0x00,0x1C,0x00,0x08,0x00,0x76,0x00,0x41,0x00,0x81,0x80,0x81,0x80,0x80,0x80,0xC1,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_214[] = {0x00,0x00,0x24,0x00,0x00,0x00,0x7E,0x00,0x41,0x00,0x81,0x80,0x81,0x80,0x80,0x80,0xC1,0x00,0x41,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_216[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x80,0x43,0x00,0x85,0x00,0x89,0x80,0x90,0x80,0xE1,0x00,0x41,0x00,0xBE,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_217[] = {0x00,0x00,0x10,0x00,0x08,0x00,0xE3,0x80,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_218[] = {0x00,0x00,0x06,0x00,0x08,0x00,0xE3,0x80,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_219[] = {0x00,0x00,0x08,0x00,0x14,0x00,0xE3,0x80,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_220[] = {0x00,0x00,0x12,0x00,0x00,0x00,0xE3,0x80,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x41,0x00,0x63,0x00,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_222[] = {0x00,0x00,0x00,0xE0,0x78,0x44,0x44,0x44,0x68,0x50,0xE0,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_223[] = {0x00,0x00,0x00,0x78,0x48,0x48,0xD0,0x50,0x4C,0x64,0xDC,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_224[] = {0x00,0x00,0x00,0x00,0xC0,0x40,0x70,0x90,0x30,0xD0,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_225[] = {0x00,0x00,0x00,0x00,0x10,0x20,0x70,0x90,0x30,0xD0,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_226[] = {0x00,0x00,0x00,0x00,0x40,0xA0,0x70,0x90,0x30,0xD0,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_227[] = {0x00,0x00,0x00,0x00,0x00,0xF0,0x70,0x90,0x30,0xD0,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_228[] = {0x00,0x00,0x00,0x00,0x90,0x00,0x70,0x90,0x30,0xD0,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_229[] = {0x00,0x00,0x00,0x00,0xE0,0x60,0x70,0x90,0x30,0xD0,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_230[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xEE,0x00,0x92,0x00,0x3D,0x00,0xD0,0x00,0xEF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_231[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x70,0x88,0x80,0x80,0x78,0x40,0x60,0x00,0x00,0x00};
const unsigned char BMP_Chant_232[] = {0x00,0x00,0x00,0x00,0x40,0x20,0x50,0x88,0xF0,0x80,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_233[] = {0x00,0x00,0x00,0x00,0x18,0x20,0x50,0x88,0xF0,0x80,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_234[] = {0x00,0x00,0x00,0x00,0x20,0x50,0x70,0x88,0xF0,0x80,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_235[] = {0x00,0x00,0x00,0x00,0x00,0x50,0x70,0x88,0xF0,0x80,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_236[] = {0x00,0x00,0x00,0x00,0xC0,0x40,0x20,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_237[] = {0x00,0x00,0x00,0x00,0x20,0x40,0xC0,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_238[] = {0x00,0x00,0x00,0x00,0x40,0x60,0xB0,0x20,0x20,0x20,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_239[] = {0x00,0x00,0x00,0x00,0x00,0xC0,0x40,0x40,0x40,0x40,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_240[] = {0x00,0x00,0x00,0x78,0x08,0x08,0x7C,0x84,0x84,0xCC,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_241[] = {0x00,0x00,0x00,0x64,0x98,0x00,0xF8,0x44,0x44,0x44,0xEE,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_242[] = {0x00,0x00,0x00,0x00,0x60,0x20,0x58,0x8C,0x84,0xCC,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_243[] = {0x00,0x00,0x00,0x00,0x18,0x20,0x58,0x8C,0x84,0xCC,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_244[] = {0x00,0x00,0x00,0x00,0x20,0x50,0x78,0x8C,0x84,0xC8,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_245[] = {0x00,0x00,0x00,0x00,0x00,0x70,0x58,0x8C,0x84,0xCC,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_246[] = {0x00,0x00,0x00,0x00,0x48,0x00,0x78,0x8C,0x84,0xCC,0x78,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_248[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x9C,0xA4,0xC4,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_249[] = {0x00,0x00,0x00,0x00,0x60,0x30,0xCC,0x44,0x44,0x44,0x3E,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_250[] = {0x00,0x00,0x00,0x00,0x08,0x10,0xCC,0x44,0x44,0x44,0x3E,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_251[] = {0x00,0x00,0x00,0x00,0x20,0x50,0xCC,0x44,0x44,0x44,0x3E,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_252[] = {0x00,0x00,0x00,0x00,0x48,0x00,0xCC,0x44,0x44,0x44,0x3E,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_254[] = {0x00,0x00,0x00,0xC0,0x40,0x40,0x78,0x44,0x44,0x44,0x78,0x40,0x40,0x40,0xE0,0x00};
const unsigned char BMP_Chant_255[] = {0x00,0x00,0x00,0x00,0x00,0x30,0xCC,0x48,0x30,0x30,0x20,0x20,0x20,0xC0,0x00,0x00};
const unsigned char BMP_Chant_338[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x42,0x00,0x82,0x40,0x83,0xC0,0xC2,0x40,0x42,0x00,0x62,0x30,0x3F,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_339[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7F,0x00,0x8C,0x80,0x8B,0x00,0x8C,0x00,0x7F,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_352[] = {0x00,0x50,0x20,0x58,0x80,0xC0,0xF0,0x18,0x0C,0x88,0xF8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_353[] = {0x00,0x00,0x00,0x00,0xA0,0x40,0xA0,0x80,0xE0,0xB0,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_376[] = {0x00,0x00,0x00,0x00,0x0C,0x00,0xF3,0x80,0x32,0x00,0x14,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x08,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_710[] = {0x00,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_732[] = {0x00,0x40,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8211[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8212[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8216[] = {0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8217[] = {0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8218[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8220[] = {0x00,0x00,0x00,0xE0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8221[] = {0x00,0x00,0x00,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8222[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x50,0xF0,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8226[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8230[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xA8,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8249[] = {0x00,0x00,0x00,0x00,0x00,0x40,0x80,0x80,0x40,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_8250[] = {0x00,0x00,0x00,0x00,0x00,0x80,0x80,0xC0,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

const unsigned char BMP_Chant_037a[] = {0x00,0x00,0x00,0x90,0x90,0x20,0x20,0x40,0x40,0x90,0x90,0x00,0x00,0x00,0x00};
const unsigned char BMP_Chant_167a[] = {0x38,0x44,0x44,0x60,0x70,0x9C,0x86,0xC2,0x72,0x1C,0x0C,0x84,0xC4,0x78,0x00};
const unsigned char BMP_Chant_164a[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xA8,0x50,0x88,0x50,0xA8,0x00,0x00,0x00,0x00}; 

/*   10 Jul 2006, Ref OMAPS00077654, R.Prabakar(a0393213)
   Description : Cyrillic character support in MMI to pass GCF/PTCRB  UCS2 TC (SATK)
   Solution     : As part of the implementation, cyrillic characters are added in this file*/
//May 12, 2006 DR:OMAPS00075405 x0035544
//Added unicode for Cyrillic character set(UCS2 support).
#if !defined MMI_LITE && defined CHINESE_MMI

const unsigned char cyrillic_0400[] = {0x20, 0x10, 0x08, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_0401[] = {0x24, 0x24, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_0402[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x10, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x16, 0x00, 0x00};
const unsigned char cyrillic_0403[] = {0x0c, 0x30, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0404[] = {0x00, 0x00, 0x00, 0x00, 0x1c, 0x22, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x22, 0x1c, 0x00, 0x00};
const unsigned char cyrillic_0405[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x30, 0x0c, 0x02, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0406[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0407[] = {0x24, 0x24, 0x00, 0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0408[] = {0x00, 0x00, 0x00, 0x00, 0x0e, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x44, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_0409[] = {0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x49, 0x8e, 0x00, 0x00};
const unsigned char cyrillic_040a[] = {0x00, 0x00, 0x00, 0x00, 0x48, 0x48, 0x48, 0x48, 0x7e, 0x49, 0x49, 0x49, 0x49, 0x4e, 0x00, 0x00};
const unsigned char cyrillic_040b[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x10, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x11, 0x00, 0x00};
const unsigned char cyrillic_040c[] = {0x0c, 0x30, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_040d[] = {0x30, 0x0c, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_040e[] = {0x42, 0x42, 0x3c, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_040f[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x7f, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0410[] = {0x00, 0x00, 0x00, 0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0411[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_0412[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_0413[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0414[] = {0x00, 0x00, 0x00, 0x00, 0x0e, 0x12, 0x12, 0x12, 0x22, 0x22, 0x22, 0x42, 0x42, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_0415[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_0416[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0417[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0418[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0419[] = {0x42, 0x42, 0x3c, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041a[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041b[] = {0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041c[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041d[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_041e[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_041f[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0420[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0421[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x40, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0422[] = {0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0423[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_0424[] = {0x00, 0x00, 0x00, 0x08, 0x08, 0x3e, 0x49, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0425[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x24, 0x24, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0426[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_0427[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_0428[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x00, 0x00};
const unsigned char cyrillic_0429[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_042a[] = {0x00, 0x00, 0x00, 0x00, 0x70, 0x10, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_042b[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
const unsigned char cyrillic_042c[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_042d[] = {0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x02, 0x02, 0x3e, 0x02, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_042e[] = {0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x52, 0x72, 0x52, 0x52, 0x52, 0x52, 0x4c, 0x00, 0x00};
const unsigned char cyrillic_042f[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x42, 0x42, 0x42, 0x3e, 0x12, 0x22, 0x22, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0430[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3e, 0x42, 0x42, 0x46, 0x3a, 0x00, 0x00};
const unsigned char cyrillic_0431[] = {0x00, 0x00, 0x02, 0x1c, 0x20, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0432[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_0433[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0434[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x22, 0x22, 0x42, 0x42, 0x42, 0x7f, 0x01, 0x00};
const unsigned char cyrillic_0435[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0436[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0437[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0438[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_0439[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_043a[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043c[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_043e[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_043f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0440[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5c, 0x62, 0x42, 0x42, 0x42, 0x42, 0x62, 0x5c, 0x40, 0x40};
const unsigned char cyrillic_0441[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x40, 0x40, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0442[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0443[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_0444[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x3e, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08, 0x00};
const unsigned char cyrillic_0445[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x18, 0x18, 0x24, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0446[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_0447[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_0448[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x00, 0x00};
const unsigned char cyrillic_0449[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x7f, 0x01, 0x01};
const unsigned char cyrillic_044a[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_044b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
const unsigned char cyrillic_044c[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x00, 0x00};
const unsigned char cyrillic_044d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x02, 0x3e, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_044e[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x72, 0x52, 0x52, 0x52, 0x4c, 0x00, 0x00};
const unsigned char cyrillic_044f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x42, 0x42, 0x42, 0x3e, 0x12, 0x22, 0x42, 0x00, 0x00};
const unsigned char cyrillic_0450[] = {0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0451[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0452[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x3c, 0x22, 0x22, 0x22, 0x22, 0x0c, 0x00};
const unsigned char cyrillic_0453[] = {0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0454[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1c, 0x22, 0x40, 0x7c, 0x40, 0x40, 0x22, 0x1c, 0x00, 0x00};
const unsigned char cyrillic_0455[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x40, 0x30, 0x0c, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0456[] = {0x00, 0x00, 0x00, 0x08, 0x08, 0x00, 0x18, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0457[] = {0x00, 0x00, 0x00, 0x24, 0x24, 0x00, 0x18, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_0458[] = {0x00, 0x00, 0x00, 0x04, 0x04, 0x00, 0x0c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x48, 0x30};
const unsigned char cyrillic_0459[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x8e, 0x00, 0x00};
const unsigned char cyrillic_045a[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x48, 0x48, 0x7e, 0x49, 0x49, 0x49, 0x4e, 0x00, 0x00};
const unsigned char cyrillic_045b[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x2c, 0x32, 0x22, 0x22, 0x22, 0x00, 0x00};
const unsigned char cyrillic_045c[] = {0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00};
const unsigned char cyrillic_045d[] = {0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_045e[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_045f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x3e, 0x08, 0x08, 0x08};
const unsigned char cyrillic_0460[] = {0x00, 0x00, 0x00, 0x00, 0x36, 0x41, 0x41, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_0461[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_0462[] = {0x00, 0x00, 0x00, 0x00, 0x10, 0x7c, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_0463[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x3c, 0x22, 0x22, 0x22, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0464[] = {0x00, 0x00, 0x00, 0x00, 0x46, 0x49, 0x50, 0x50, 0x7e, 0x50, 0x50, 0x50, 0x49, 0x46, 0x00, 0x00};
const unsigned char cyrillic_0465[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x49, 0x50, 0x7e, 0x50, 0x50, 0x49, 0x46, 0x00, 0x00};
const unsigned char cyrillic_0466[] = {0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x14, 0x14, 0x22, 0x36, 0x2a, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0467[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x14, 0x14, 0x22, 0x36, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0468[] = {0x00, 0x00, 0x00, 0x00, 0x48, 0x48, 0x54, 0x54, 0x52, 0x76, 0x6a, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_0469[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x54, 0x54, 0x52, 0x76, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_046a[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x22, 0x22, 0x14, 0x08, 0x1c, 0x2a, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_046b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x22, 0x14, 0x08, 0x3e, 0x49, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_046c[] = {0x00, 0x00, 0x00, 0x00, 0x5f, 0x51, 0x51, 0x4a, 0x74, 0x4e, 0x55, 0x55, 0x55, 0x55, 0x00, 0x00};
const unsigned char cyrillic_046d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5f, 0x51, 0x4a, 0x74, 0x4e, 0x55, 0x55, 0x55, 0x00, 0x00};
const unsigned char cyrillic_046e[] = {0x00, 0x00, 0x24, 0x18, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x02, 0x3c, 0x40, 0x40};
const unsigned char cyrillic_046f[] = {0x00, 0x00, 0x00, 0x24, 0x18, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x3c, 0x40, 0x40};
const unsigned char cyrillic_0470[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_0471[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x49, 0x49, 0x49, 0x3e, 0x08, 0x08};
const unsigned char cyrillic_0472[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0473[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_0474[] = {0x00, 0x00, 0x00, 0x00, 0x43, 0x44, 0x44, 0x44, 0x28, 0x28, 0x28, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0475[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x48, 0x28, 0x28, 0x28, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0476[] = {0x66, 0x11, 0x00, 0x00, 0x43, 0x44, 0x44, 0x44, 0x28, 0x28, 0x28, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0477[] = {0x00, 0x00, 0x66, 0x11, 0x00, 0x00, 0x46, 0x48, 0x48, 0x28, 0x28, 0x28, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0478[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x50, 0x59, 0x59, 0x59, 0x55, 0x56, 0x54, 0x54, 0x24, 0x08, 0x08};
const unsigned char cyrillic_0479[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0x59, 0x59, 0x55, 0x56, 0x54, 0x54, 0x24, 0x08, 0x08};
const unsigned char cyrillic_047a[] = {0x00, 0x00, 0x00, 0x08, 0x3e, 0x49, 0x41, 0x41, 0x41, 0x41, 0x41, 0x41, 0x49, 0x3e, 0x08, 0x00};
const unsigned char cyrillic_047b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x3e, 0x49, 0x41, 0x41, 0x41, 0x41, 0x49, 0x3e, 0x08, 0x00};
const unsigned char cyrillic_047c[] = {0x3c, 0x43, 0x18, 0x00, 0x36, 0x41, 0x41, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_047d[] = {0x00, 0x00, 0x3c, 0x43, 0x18, 0x00, 0x22, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_047e[] = {0x7f, 0x08, 0x00, 0x00, 0x36, 0x41, 0x41, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_047f[] = {0x00, 0x00, 0x7f, 0x08, 0x00, 0x00, 0x22, 0x41, 0x41, 0x49, 0x49, 0x49, 0x49, 0x36, 0x00, 0x00};
const unsigned char cyrillic_0480[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x40, 0x40, 0x3c, 0x04, 0x04, 0x04};
const unsigned char cyrillic_0481[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x3c, 0x04, 0x04, 0x04};
const unsigned char cyrillic_0482[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x0c, 0x44, 0x2a, 0x11, 0x18, 0x24, 0x00, 0x00, 0x00};
const unsigned char cyrillic_048a[] = {0x42, 0x42, 0x3c, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x04, 0x08};
const unsigned char cyrillic_048b[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x04, 0x08};
const unsigned char cyrillic_048c[] = {0x00, 0x00, 0x00, 0x00, 0x10, 0x7c, 0x10, 0x10, 0x1e, 0x11, 0x11, 0x11, 0x11, 0x1e, 0x00, 0x00};
const unsigned char cyrillic_048d[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x78, 0x20, 0x20, 0x3c, 0x22, 0x22, 0x22, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_048e[] = {0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x42, 0x52, 0x5c, 0x44, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_048f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x42, 0x52, 0x5c, 0x44, 0x40, 0x40, 0x40};
const unsigned char cyrillic_0490[] = {0x00, 0x00, 0x02, 0x02, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0491[] = {0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x00};
const unsigned char cyrillic_0492[] = {0x00, 0x00, 0x00, 0x00, 0x1f, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0493[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x00, 0x00};
const unsigned char cyrillic_0494[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x0c, 0x00};
const unsigned char cyrillic_0495[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x0c, 0x00};
const unsigned char cyrillic_0496[] = {0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x01, 0x01};
const unsigned char cyrillic_0497[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x01, 0x01};
const unsigned char cyrillic_0498[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x42, 0x3c, 0x08, 0x30};
const unsigned char cyrillic_0499[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x42, 0x3c, 0x08, 0x30};
const unsigned char cyrillic_049a[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x60, 0x50, 0x48, 0x44, 0x42, 0x02, 0x02};
const unsigned char cyrillic_049b[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0x42, 0x02, 0x02};
const unsigned char cyrillic_049c[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x43, 0x54, 0x54, 0x78, 0x54, 0x54, 0x54, 0x42, 0x41, 0x00, 0x00};
const unsigned char cyrillic_049d[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x43, 0x54, 0x54, 0x78, 0x54, 0x54, 0x42, 0x41, 0x00, 0x00};
const unsigned char cyrillic_049e[] = {0x00, 0x00, 0x00, 0x00, 0x20, 0x73, 0x24, 0x28, 0x30, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_049f[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0x74, 0x28, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_04a0[] = {0x00, 0x00, 0x00, 0x00, 0xe0, 0x23, 0x24, 0x28, 0x30, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_04a1[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x24, 0x28, 0x30, 0x28, 0x24, 0x22, 0x21, 0x00, 0x00};
const unsigned char cyrillic_04a2[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04a3[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04a4[] = {0x00, 0x00, 0x00, 0x00, 0x47, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x44, 0x44, 0x00, 0x00};
const unsigned char cyrillic_04a5[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x47, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x44, 0x00, 0x00};
const unsigned char cyrillic_04a6[] = {0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x49, 0x01, 0x06};
const unsigned char cyrillic_04a7[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x48, 0x48, 0x48, 0x4e, 0x49, 0x49, 0x49, 0x01, 0x06};
const unsigned char cyrillic_04a8[] = {0x00, 0x00, 0x00, 0x00, 0x1c, 0x20, 0x40, 0x4c, 0x52, 0x52, 0x52, 0x52, 0x2c, 0x18, 0x06, 0x00};
const unsigned char cyrillic_04a9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1c, 0x20, 0x4c, 0x52, 0x52, 0x52, 0x2c, 0x18, 0x06, 0x00};
const unsigned char cyrillic_04aa[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x40, 0x40, 0x42, 0x42, 0x3c, 0x10, 0x0c};
const unsigned char cyrillic_04ab[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x40, 0x40, 0x42, 0x42, 0x3c, 0x10, 0x0c};
const unsigned char cyrillic_04ac[] = {0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x0c, 0x04, 0x04};
const unsigned char cyrillic_04ad[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x0c, 0x04, 0x04};
const unsigned char cyrillic_04ae[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_04af[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x08, 0x08, 0x08};
const unsigned char cyrillic_04b0[] = {0x00, 0x00, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x08, 0x08, 0x3e, 0x08, 0x08, 0x00, 0x00};
const unsigned char cyrillic_04b1[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x22, 0x22, 0x14, 0x08, 0x08, 0x3e, 0x08, 0x00, 0x00};
const unsigned char cyrillic_04b2[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x24, 0x24, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04b3[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x24, 0x18, 0x18, 0x24, 0x42, 0x43, 0x01, 0x01};
const unsigned char cyrillic_04b4[] = {0x00, 0x00, 0x00, 0x00, 0xfa, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x3f, 0x01, 0x01};
const unsigned char cyrillic_04b5[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfa, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x3f, 0x01, 0x01};
const unsigned char cyrillic_04b6[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x03, 0x01, 0x01};
const unsigned char cyrillic_04b7[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x03, 0x01, 0x01};
const unsigned char cyrillic_04b8[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x52, 0x56, 0x3a, 0x12, 0x12, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04b9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x52, 0x56, 0x3a, 0x12, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04ba[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x5c, 0x62, 0x42, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04bb[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x5c, 0x62, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04bc[] = {0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x12, 0x0c, 0x00, 0x00};
const unsigned char cyrillic_04bd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x0c, 0x00, 0x00};
const unsigned char cyrillic_04be[] = {0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x12, 0x0c, 0x08, 0x06};
const unsigned char cyrillic_04bf[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x52, 0x52, 0x3e, 0x10, 0x10, 0x12, 0x0c, 0x08, 0x06};
const unsigned char cyrillic_04c0[] = {0x00, 0x00, 0x00, 0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_04c1[] = {0x41, 0x41, 0x3e, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04c2[] = {0x00, 0x22, 0x22, 0x1c, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04c3[] = {0x00, 0x00, 0x00, 0x00, 0x40, 0x46, 0x48, 0x50, 0x60, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c4[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x48, 0x50, 0x60, 0x7c, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c5[] = {0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04c6[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x12, 0x12, 0x12, 0x12, 0x22, 0x22, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04c7[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c8[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x02, 0x0c};
const unsigned char cyrillic_04c9[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04ca[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04cb[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x06, 0x04, 0x04};
const unsigned char cyrillic_04cc[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x06, 0x04, 0x04};
const unsigned char cyrillic_04cd[] = {0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04ce[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x42, 0x66, 0x66, 0x5a, 0x5a, 0x42, 0x42, 0x43, 0x04, 0x08};
const unsigned char cyrillic_04d0[] = {0x42, 0x42, 0x3c, 0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04d1[] = {0x00, 0x42, 0x42, 0x3c, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3e, 0x42, 0x42, 0x46, 0x3a, 0x00, 0x00};
const unsigned char cyrillic_04d2[] = {0x24, 0x24, 0x00, 0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04d3[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3e, 0x42, 0x42, 0x46, 0x3a, 0x00, 0x00};
const unsigned char cyrillic_04d4[] = {0x00, 0x00, 0x00, 0x00, 0x1f, 0x28, 0x48, 0x48, 0x7f, 0x48, 0x48, 0x48, 0x48, 0x4f, 0x00, 0x00};
const unsigned char cyrillic_04d5[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x49, 0x09, 0x3f, 0x48, 0x48, 0x49, 0x3e, 0x00, 0x00};
const unsigned char cyrillic_04d6[] = {0x42, 0x42, 0x3c, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00, 0x00};
const unsigned char cyrillic_04d7[] = {0x00, 0x00, 0x42, 0x42, 0x3c, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x40, 0x40, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04d8[] = {0x00, 0x00, 0x00, 0x00, 0x18, 0x24, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00};
const unsigned char cyrillic_04d9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04da[] = {0x24, 0x24, 0x00, 0x00, 0x18, 0x24, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00};
const unsigned char cyrillic_04db[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x7e, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04dc[] = {0x24, 0x24, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x2a, 0x1c, 0x1c, 0x2a, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04dd[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x49, 0x49, 0x2a, 0x1c, 0x1c, 0x2a, 0x49, 0x49, 0x00, 0x00};
const unsigned char cyrillic_04de[] = {0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x02, 0x3c, 0x04, 0x02, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04df[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x02, 0x3c, 0x04, 0x02, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e0[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x04, 0x08, 0x10, 0x1c, 0x02, 0x02, 0x02, 0x46, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e1[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x04, 0x08, 0x10, 0x1c, 0x02, 0x02, 0x02, 0x42, 0x3c};
const unsigned char cyrillic_04e2[] = {0x00, 0x3c, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04e3[] = {0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_04e4[] = {0x24, 0x24, 0x00, 0x00, 0x42, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x42, 0x00, 0x00};
const unsigned char cyrillic_04e5[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x46, 0x46, 0x4a, 0x4a, 0x52, 0x52, 0x62, 0x62, 0x00, 0x00};
const unsigned char cyrillic_04e6[] = {0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e7[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e8[] = {0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04e9[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04ea[] = {0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04eb[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x3c, 0x00, 0x00};
const unsigned char cyrillic_04ec[] = {0x24, 0x24, 0x00, 0x00, 0x38, 0x44, 0x02, 0x02, 0x3e, 0x02, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_04ed[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x38, 0x44, 0x02, 0x3e, 0x02, 0x02, 0x44, 0x38, 0x00, 0x00};
const unsigned char cyrillic_04ee[] = {0x00, 0x3e, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_04ef[] = {0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_04f0[] = {0x24, 0x24, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_04f1[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_04f2[] = {0x33, 0x44, 0x00, 0x00, 0x41, 0x41, 0x22, 0x22, 0x14, 0x14, 0x08, 0x08, 0x10, 0x30, 0x00, 0x00};
const unsigned char cyrillic_04f3[] = {0x00, 0x00, 0x33, 0x44, 0x00, 0x00, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x20, 0x60};
const unsigned char cyrillic_04f4[] = {0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04f5[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3a, 0x02, 0x02, 0x00, 0x00};
const unsigned char cyrillic_04f6[] = {0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x60, 0x20, 0x20};
const unsigned char cyrillic_04f7[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x60, 0x20, 0x20};
const unsigned char cyrillic_04f8[] = {0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
const unsigned char cyrillic_04f9[] = {0x00, 0x00, 0x24, 0x24, 0x00, 0x00, 0x42, 0x42, 0x42, 0x72, 0x4a, 0x4a, 0x4a, 0x72, 0x00, 0x00};
#endif /* !defined MMI_LITE && defined CHINESE_MMI */

/*   10 Jul 2006, Ref OMAPS00077654, R.Prabakar(a0393213)
   Description : Cyrillic character support in MMI to pass GCF/PTCRB  UCS2 TC (SATK)
   Solution     : As part of the implementation, cyrillic characters are added in this file*/
   
/*  Nov 24, 2006 Ref OMAPS00092906, x0039928(sumanth)
     Fix: A new bitmap  is added for Esc characters        */
     
#if !defined MMI_LITE && defined CHINESE_MMI
#define NUM_BITMAPS_FONT3 (444)
#else
#define NUM_BITMAPS_FONT3 (202)
#endif

static const t_font_bitmap database3[NUM_BITMAPS_FONT3] ={
{ 27, 1,15, 8,255,(char*)BMP_Chant_027},
{ 30, 1,15,16,255,(char*)BMP_Chant_030},
{ 31, 1,15,16,255,(char*)BMP_Chant_031},
{ 32, 1,15, 4,255,(char*)BMP_Chant_032},
{ 33, 1,15, 2,255,(char*)BMP_Chant_033},
{ 34, 1,15, 4,255,(char*)BMP_Chant_034},
{ 35, 1,15, 7,255,(char*)BMP_Chant_035},
{ 36, 1,15, 6,255,(char*)BMP_Chant_036},
{ 37, 1,15, 5,255,(char*)BMP_Chant_037a},
{ 38, 1,15, 9,255,(char*)BMP_Chant_038},
{ 39, 1,15, 2,255,(char*)BMP_Chant_039},
{ 40, 1,15, 4,255,(char*)BMP_Chant_040},
{ 41, 1,15, 5,255,(char*)BMP_Chant_041},
{ 42, 1,15, 4,255,(char*)BMP_Chant_042},
{ 43, 1,15, 6,255,(char*)BMP_Chant_043},
{ 44, 1,15, 3,255,(char*)BMP_Chant_044},
{ 45, 1,15, 3,255,(char*)BMP_Chant_045},
{ 46, 1,15, 2,255,(char*)BMP_Chant_046},
{ 47, 1,15, 6,255,(char*)BMP_Chant_047},
{ 48, 1,15, 6,255,(char*)BMP_Chant_048},
{ 49, 1,15, 4,255,(char*)BMP_Chant_049},
{ 50, 1,15, 5,255,(char*)BMP_Chant_050},
{ 51, 1,15, 6,255,(char*)BMP_Chant_051},
{ 52, 1,15, 7,255,(char*)BMP_Chant_052},
{ 53, 1,15, 7,255,(char*)BMP_Chant_053},
{ 54, 1,15, 6,255,(char*)BMP_Chant_054},
{ 55, 1,15, 6,255,(char*)BMP_Chant_055},
{ 56, 1,15, 6,255,(char*)BMP_Chant_056},
{ 57, 1,15, 6,255,(char*)BMP_Chant_057},
{ 58, 1,15, 2,255,(char*)BMP_Chant_058},
{ 59, 1,15, 4,255,(char*)BMP_Chant_059},
{ 60, 1,15, 7,255,(char*)BMP_Chant_060},
{ 61, 1,15, 6,255,(char*)BMP_Chant_061},
{ 62, 1,15, 7,255,(char*)BMP_Chant_062},
{ 63, 1,15, 5,255,(char*)BMP_Chant_063},
{ 64, 1,15,10,255,(char*)BMP_Chant_064},
{ 65, 1,15,10,255,(char*)BMP_Chant_065},
{ 66, 1,15, 8,255,(char*)BMP_Chant_066},
{ 67, 1,15, 8,255,(char*)BMP_Chant_067},
{ 68, 1,15,10,255,(char*)BMP_Chant_068},
{ 69, 1,15, 7,255,(char*)BMP_Chant_069},
{ 70, 1,15, 7,255,(char*)BMP_Chant_070},
{ 71, 1,15,10,255,(char*)BMP_Chant_071},
{ 72, 1,15,10,255,(char*)BMP_Chant_072},
{ 73, 1,15, 4,255,(char*)BMP_Chant_073},
{ 74, 1,15, 6,255,(char*)BMP_Chant_074},
{ 75, 1,15, 9,255,(char*)BMP_Chant_075},
{ 76, 1,15, 7,255,(char*)BMP_Chant_076},
{ 77, 1,15,12,255,(char*)BMP_Chant_077},
{ 78, 1,15,11,255,(char*)BMP_Chant_078},
{ 79, 1,15,10,255,(char*)BMP_Chant_079},
{ 80, 1,15, 7,255,(char*)BMP_Chant_080},
{ 81, 1,15,13,255,(char*)BMP_Chant_081},
{ 82, 1,15, 9,255,(char*)BMP_Chant_082},
{ 83, 1,15, 7,255,(char*)BMP_Chant_083},
{ 84, 1,15, 9,255,(char*)BMP_Chant_084},
{ 85, 1,15,10,255,(char*)BMP_Chant_085},
{ 86, 1,15,12,255,(char*)BMP_Chant_086},
{ 87, 1,15,15,255,(char*)BMP_Chant_087},
{ 88, 1,15,11,255,(char*)BMP_Chant_088},
{ 89, 1,15,10,255,(char*)BMP_Chant_089},
{ 90, 1,15, 8,255,(char*)BMP_Chant_090},
{ 91, 1,15, 4,255,(char*)BMP_Chant_091}, /* SPR#2034 - SH - Open square bracket */
{ 92, 1,15, 6,255,(char*)BMP_Chant_092},
{ 93, 1,15, 5,255,(char*)BMP_Chant_093}, /* SPR#2034 - SH - Close square bracket */
{ 94, 1,15,16,255,(char*)BMP_Chant_094},
{ 95, 1,15, 8,255,(char*)BMP_Chant_095},
{ 96, 1,15, 3,255,(char*)BMP_Chant_096},
{ 97, 1,15, 6,255,(char*)BMP_Chant_097},
{ 98, 1,15, 7,255,(char*)BMP_Chant_098},
{ 99, 1,15, 6,255,(char*)BMP_Chant_099},
{ 100, 1,15, 7,255,(char*)BMP_Chant_100},
{ 101, 1,15, 6,255,(char*)BMP_Chant_101},
{ 102, 1,15, 6,255,(char*)BMP_Chant_102},
{ 103, 1,15, 6,255,(char*)BMP_Chant_103},
{ 104, 1,15, 8,255,(char*)BMP_Chant_104},
{ 105, 1,15, 4,255,(char*)BMP_Chant_105},
{ 106, 1,15, 3,255,(char*)BMP_Chant_106},
{ 107, 1,15, 8,255,(char*)BMP_Chant_107},
{ 108, 1,15, 4,255,(char*)BMP_Chant_108},
{ 109, 1,15,11,255,(char*)BMP_Chant_109},
{ 110, 1,15, 8,255,(char*)BMP_Chant_110},
{ 111, 1,15, 7,255,(char*)BMP_Chant_111},
{ 112, 1,15, 7,255,(char*)BMP_Chant_112},
{ 113, 1,15, 7,255,(char*)BMP_Chant_113},
{ 114, 1,15, 5,255,(char*)BMP_Chant_114},
{ 115, 1,15, 5,255,(char*)BMP_Chant_115},
{ 116, 1,15, 5,255,(char*)BMP_Chant_116},
{ 117, 1,15, 8,255,(char*)BMP_Chant_117},
{ 118, 1,15, 7,255,(char*)BMP_Chant_118},
{ 119, 1,15,10,255,(char*)BMP_Chant_119},
{ 120, 1,15, 7,255,(char*)BMP_Chant_120},
{ 121, 1,15, 7,255,(char*)BMP_Chant_121},
{ 122, 1,15, 6,255,(char*)BMP_Chant_122},
{ 123, 1,15,16,255,(char*)BMP_Chant_123},
{ 124, 1,15,16,255,(char*)BMP_Chant_124},
{ 125, 1,15,16,255,(char*)BMP_Chant_125},
{ 126, 1,15,16,255,(char*)BMP_Chant_126},
{ 127, 1,15,16,255,(char*)BMP_Chant_127},
{ 161, 1,15, 2,255,(char*)BMP_Chant_161},
{ 162, 1,15, 6,255,(char*)BMP_Chant_162},
{ 163, 1,15, 7,255,(char*)BMP_Chant_163},
/* { 164, 1,15, 9,255,(char*)BMP_Chant_164}, */
{ 164, 1,15, 7,255,(char*)BMP_Chant_164a},
{ 165, 1,15,10,255,(char*)BMP_Chant_165},
{ 167, 1,15, 8,255,(char*)BMP_Chant_167a},
{ 168, 1,15, 3,255,(char*)BMP_Chant_168},
{ 170, 1,15, 4,255,(char*)BMP_Chant_170},
{ 171, 1,15, 4,255,(char*)BMP_Chant_171},
{ 180, 1,15, 4,255,(char*)BMP_Chant_180},
{ 184, 1,15, 3,255,(char*)BMP_Chant_184},
{ 186, 1,15, 4,255,(char*)BMP_Chant_186},
{ 187, 1,15, 4,255,(char*)BMP_Chant_187},
{ 191, 1,15, 5,255,(char*)BMP_Chant_191},
{ 192, 1,15,10,255,(char*)BMP_Chant_192},
{ 193, 1,15,10,255,(char*)BMP_Chant_193},
{ 194, 1,15,10,255,(char*)BMP_Chant_194},
{ 195, 1,15,10,255,(char*)BMP_Chant_195},
{ 196, 1,15,10,255,(char*)BMP_Chant_196},
{ 197, 1,15,10,255,(char*)BMP_Chant_197},
{ 198, 1,15,12,255,(char*)BMP_Chant_198},
{ 199, 1,15, 8,255,(char*)BMP_Chant_199},
{ 200, 1,15, 7,255,(char*)BMP_Chant_200},
{ 201, 1,15, 7,255,(char*)BMP_Chant_201},
{ 202, 1,15, 7,255,(char*)BMP_Chant_202},
{ 203, 1,15, 7,255,(char*)BMP_Chant_203},
{ 204, 1,15, 4,255,(char*)BMP_Chant_204},
{ 205, 1,15, 5,255,(char*)BMP_Chant_205},
{ 206, 1,15, 4,255,(char*)BMP_Chant_206},
{ 207, 1,15, 4,255,(char*)BMP_Chant_207},
{ 208, 1,15,10,255,(char*)BMP_Chant_208},
{ 209, 1,15,11,255,(char*)BMP_Chant_209},
{ 211, 1,15,10,255,(char*)BMP_Chant_211},
{ 212, 1,15,10,255,(char*)BMP_Chant_212},
{ 213, 1,15,10,255,(char*)BMP_Chant_213},
{ 214, 1,15,10,255,(char*)BMP_Chant_214},
{ 216, 1,15,10,255,(char*)BMP_Chant_216},
{ 217, 1,15,10,255,(char*)BMP_Chant_217},
{ 218, 1,15,10,255,(char*)BMP_Chant_218},
{ 219, 1,15,10,255,(char*)BMP_Chant_219},
{ 220, 1,15,10,255,(char*)BMP_Chant_220},
{ 222, 1,15, 7,255,(char*)BMP_Chant_222},
{ 223, 1,15, 7,255,(char*)BMP_Chant_223},
{ 224, 1,15, 6,255,(char*)BMP_Chant_224},
{ 225, 1,15, 6,255,(char*)BMP_Chant_225},
{ 226, 1,15, 6,255,(char*)BMP_Chant_226},
{ 227, 1,15, 6,255,(char*)BMP_Chant_227},
{ 228, 1,15, 6,255,(char*)BMP_Chant_228},
{ 229, 1,15, 6,255,(char*)BMP_Chant_229},
{ 230, 1,15, 9,255,(char*)BMP_Chant_230},
{ 231, 1,15, 6,255,(char*)BMP_Chant_231},
{ 232, 1,15, 6,255,(char*)BMP_Chant_232},
{ 233, 1,15, 6,255,(char*)BMP_Chant_233},
{ 234, 1,15, 6,255,(char*)BMP_Chant_234},
{ 235, 1,15, 6,255,(char*)BMP_Chant_235},
{ 236, 1,15, 5,255,(char*)BMP_Chant_236},
{ 237, 1,15, 4,255,(char*)BMP_Chant_237},
{ 238, 1,15, 5,255,(char*)BMP_Chant_238},
{ 239, 1,15, 4,255,(char*)BMP_Chant_239},
{ 240, 1,15, 7,255,(char*)BMP_Chant_240},
{ 241, 1,15, 8,255,(char*)BMP_Chant_241},
{ 242, 1,15, 7,255,(char*)BMP_Chant_242},
{ 243, 1,15, 7,255,(char*)BMP_Chant_243},
{ 244, 1,15, 7,255,(char*)BMP_Chant_244},
{ 245, 1,15, 7,255,(char*)BMP_Chant_245},
{ 246, 1,15, 7,255,(char*)BMP_Chant_246},
{ 248, 1,15, 7,255,(char*)BMP_Chant_248},
{ 249, 1,15, 8,255,(char*)BMP_Chant_249},
{ 250, 1,15, 8,255,(char*)BMP_Chant_250},
{ 251, 1,15, 8,255,(char*)BMP_Chant_251},
{ 252, 1,15, 8,255,(char*)BMP_Chant_252},
{ 254, 1,15, 7,255,(char*)BMP_Chant_254},
{ 255, 1,15, 7,255,(char*)BMP_Chant_255},

{ 0x0152, 1,15,13,255,(char*)BMP_Chant_338},
{ 0x0153, 1,15,10,255,(char*)BMP_Chant_339},
{ 0x0160, 1,15, 7,255,(char*)BMP_Chant_352},
{ 0x0161, 1,15, 5,255,(char*)BMP_Chant_353},
{ 0x0178, 1,15,10,255,(char*)BMP_Chant_376},
{ 0x02C6, 1,15, 4,255,(char*)BMP_Chant_710},
{ 0x02DC, 1,15, 4,255,(char*)BMP_Chant_732},

{0x0393,1,14, 8,255,(char*)BMP_Gamma},    /* Gamma */
{0x0394,1,14, 8,255,(char*) BMP_Delta},    /* Delta */
{0x0398,1,14, 8,255,(char*) BMP_Theta},    /* Theta */
{0x039B,1,14, 8,255,(char*) BMP_Lambda},    /* Lambda */
{0x039e,1,14, 8,255,(char*) BMP_Xi},    /* Xi */
{0x03A0,1,14, 7,255,(char*) BMP_Pi},    /* Pi */
{0x03a3,1,14, 8,255,(char*) BMP_Sigma},    /* Sigma */
{0x03A6,1,14, 8,255,(char*) BMP_Phi},    /* Phi */
{0x03A8,1,14, 8,255,(char*) BMP_Psi},    /* Psi */
{0x03A9,1,14, 7,255,(char*) BMP_Omega},    /* Omega */

/*   10 Jul 2006, Ref OMAPS00077654, R.Prabakar(a0393213)
   Description : Cyrillic character support in MMI to pass GCF/PTCRB  UCS2 TC (SATK)
   Solution     : As part of the implementation, cyrillic characters are added in this file*/
//May 12, 2006 DR:OMAPS00075405 x0035544
//Added unicode for Cyrillic character set. 
#if !defined MMI_LITE && defined CHINESE_MMI
{ 0x0400, 1,16, 8,127,(char*)cyrillic_0400},
{ 0x0401, 1,16, 8,127,(char*)cyrillic_0401},
{ 0x0402, 1,16, 8,127,(char*)cyrillic_0402},
{ 0x0403, 1,16, 8,127,(char*)cyrillic_0403},
{ 0x0404, 1,16, 8,127,(char*)cyrillic_0404},
{ 0x0405, 1,16, 8,127,(char*)cyrillic_0405},
{ 0x0406, 1,16, 8,127,(char*)cyrillic_0406},
{ 0x0407, 1,16, 8,127,(char*)cyrillic_0407},
{ 0x0408, 1,16, 8,127,(char*)cyrillic_0408},
{ 0x0409, 1,16, 8,127,(char*)cyrillic_0409},
{ 0x040a, 1,16, 8,127,(char*)cyrillic_040a},
{ 0x040b, 1,16, 8,127,(char*)cyrillic_040b},
{ 0x040c, 1,16, 8,127,(char*)cyrillic_040c},
{ 0x040d, 1,16, 8,127,(char*)cyrillic_040d},
{ 0x040e, 1,16, 8,127,(char*)cyrillic_040e},
{ 0x040f, 1,16, 8,127,(char*)cyrillic_040f},
{ 0x0410, 1,16, 8,127,(char*)cyrillic_0410},
{ 0x0411, 1,16, 8,127,(char*)cyrillic_0411},
{ 0x0412, 1,16, 8,127,(char*)cyrillic_0412},
{ 0x0413, 1,16, 8,127,(char*)cyrillic_0413},
{ 0x0414, 1,16, 8,127,(char*)cyrillic_0414},
{ 0x0415, 1,16, 8,127,(char*)cyrillic_0415},
{ 0x0416, 1,16, 8,127,(char*)cyrillic_0416},
{ 0x0417, 1,16, 8,127,(char*)cyrillic_0417},
{ 0x0418, 1,16, 8,127,(char*)cyrillic_0418},
{ 0x0419, 1,16, 8,127,(char*)cyrillic_0419},
{ 0x041a, 1,16, 8,127,(char*)cyrillic_041a},
{ 0x041b, 1,16, 8,127,(char*)cyrillic_041b},
{ 0x041c, 1,16, 8,127,(char*)cyrillic_041c},
{ 0x041d, 1,16, 8,127,(char*)cyrillic_041d},
{ 0x041e, 1,16, 8,127,(char*)cyrillic_041e},
{ 0x041f, 1,16, 8,127,(char*)cyrillic_041f},
{ 0x0420, 1,16, 8,127,(char*)cyrillic_0420},
{ 0x0421, 1,16, 8,127,(char*)cyrillic_0421},
{ 0x0422, 1,16, 8,127,(char*)cyrillic_0422},
{ 0x0423, 1,16, 8,127,(char*)cyrillic_0423},
{ 0x0424, 1,16, 8,127,(char*)cyrillic_0424},
{ 0x0425, 1,16, 8,127,(char*)cyrillic_0425},
{ 0x0426, 1,16, 8,127,(char*)cyrillic_0426},
{ 0x0427, 1,16, 8,127,(char*)cyrillic_0427},
{ 0x0428, 1,16, 8,127,(char*)cyrillic_0428},
{ 0x0429, 1,16, 8,127,(char*)cyrillic_0429},
{ 0x042a, 1,16, 8,127,(char*)cyrillic_042a},
{ 0x042b, 1,16, 8,127,(char*)cyrillic_042b},
{ 0x042c, 1,16, 8,127,(char*)cyrillic_042c},
{ 0x042d, 1,16, 8,127,(char*)cyrillic_042d},
{ 0x042e, 1,16, 8,127,(char*)cyrillic_042e},
{ 0x042f, 1,16, 8,127,(char*)cyrillic_042f},
{ 0x0430, 1,16, 8,127,(char*)cyrillic_0430},
{ 0x0431, 1,16, 8,127,(char*)cyrillic_0431},
{ 0x0432, 1,16, 8,127,(char*)cyrillic_0432},
{ 0x0433, 1,16, 8,127,(char*)cyrillic_0433},
{ 0x0434, 1,16, 8,127,(char*)cyrillic_0434},
{ 0x0435, 1,16, 8,127,(char*)cyrillic_0435},
{ 0x0436, 1,16, 8,127,(char*)cyrillic_0436},
{ 0x0437, 1,16, 8,127,(char*)cyrillic_0437},
{ 0x0438, 1,16, 8,127,(char*)cyrillic_0438},
{ 0x0439, 1,16, 8,127,(char*)cyrillic_0439},
{ 0x043a, 1,16, 8,127,(char*)cyrillic_043a},
{ 0x043b, 1,16, 8,127,(char*)cyrillic_043b},
{ 0x043c, 1,16, 8,127,(char*)cyrillic_043c},
{ 0x043d, 1,16, 8,127,(char*)cyrillic_043d},
{ 0x043e, 1,16, 8,127,(char*)cyrillic_043e},
{ 0x043f, 1,16, 8,127,(char*)cyrillic_043f},
{ 0x0440, 1,16, 8,127,(char*)cyrillic_0440},
{ 0x0441, 1,16, 8,127,(char*)cyrillic_0441},
{ 0x0442, 1,16, 8,127,(char*)cyrillic_0442},
{ 0x0443, 1,16, 8,127,(char*)cyrillic_0443},
{ 0x0444, 1,16, 8,127,(char*)cyrillic_0444},
{ 0x0445, 1,16, 8,127,(char*)cyrillic_0445},
{ 0x0446, 1,16, 8,127,(char*)cyrillic_0446},
{ 0x0447, 1,16, 8,127,(char*)cyrillic_0447},
{ 0x0448, 1,16, 8,127,(char*)cyrillic_0448},
{ 0x0449, 1,16, 8,127,(char*)cyrillic_0449},
{ 0x044a, 1,16, 8,127,(char*)cyrillic_044a},
{ 0x044b, 1,16, 8,127,(char*)cyrillic_044b},
{ 0x044c, 1,16, 8,127,(char*)cyrillic_044c},
{ 0x044d, 1,16, 8,127,(char*)cyrillic_044d},
{ 0x044e, 1,16, 8,127,(char*)cyrillic_044e},
{ 0x044f, 1,16, 8,127,(char*)cyrillic_044f},
{ 0x0450, 1,16, 8,127,(char*)cyrillic_0450},
{ 0x0451, 1,16, 8,127,(char*)cyrillic_0451},
{ 0x0452, 1,16, 8,127,(char*)cyrillic_0452},
{ 0x0453, 1,16, 8,127,(char*)cyrillic_0453},
{ 0x0454, 1,16, 8,127,(char*)cyrillic_0454},
{ 0x0455, 1,16, 8,127,(char*)cyrillic_0455},
{ 0x0456, 1,16, 8,127,(char*)cyrillic_0456},
{ 0x0457, 1,16, 8,127,(char*)cyrillic_0457},
{ 0x0458, 1,16, 8,127,(char*)cyrillic_0458},
{ 0x0459, 1,16, 8,127,(char*)cyrillic_0459},
{ 0x045a, 1,16, 8,127,(char*)cyrillic_045a},
{ 0x045b, 1,16, 8,127,(char*)cyrillic_045b},
{ 0x045c, 1,16, 8,127,(char*)cyrillic_045c},
{ 0x045d, 1,16, 8,127,(char*)cyrillic_045d},
{ 0x045e, 1,16, 8,127,(char*)cyrillic_045e},
{ 0x045f, 1,16, 8,127,(char*)cyrillic_045f},
{ 0x0460, 1,16, 8,127,(char*)cyrillic_0460},
{ 0x0461, 1,16, 8,127,(char*)cyrillic_0461},
{ 0x0462, 1,16, 8,127,(char*)cyrillic_0462},
{ 0x0463, 1,16, 8,127,(char*)cyrillic_0463},
{ 0x0464, 1,16, 8,127,(char*)cyrillic_0464},
{ 0x0465, 1,16, 8,127,(char*)cyrillic_0465},
{ 0x0466, 1,16, 8,127,(char*)cyrillic_0466},
{ 0x0467, 1,16, 8,127,(char*)cyrillic_0467},
{ 0x0468, 1,16, 8,127,(char*)cyrillic_0468},
{ 0x0469, 1,16, 8,127,(char*)cyrillic_0469},
{ 0x046a, 1,16, 8,127,(char*)cyrillic_046a},
{ 0x046b, 1,16, 8,127,(char*)cyrillic_046b},
{ 0x046c, 1,16, 8,127,(char*)cyrillic_046c},
{ 0x046d, 1,16, 8,127,(char*)cyrillic_046d},
{ 0x046e, 1,16, 8,127,(char*)cyrillic_046e},
{ 0x046f, 1,16, 8,127,(char*)cyrillic_046f},
{ 0x0470, 1,16, 8,127,(char*)cyrillic_0470},
{ 0x0471, 1,16, 8,127,(char*)cyrillic_0471},
{ 0x0472, 1,16, 8,127,(char*)cyrillic_0472},
{ 0x0473, 1,16, 8,127,(char*)cyrillic_0473},
{ 0x0474, 1,16, 8,127,(char*)cyrillic_0474},
{ 0x0475, 1,16, 8,127,(char*)cyrillic_0475},
{ 0x0476, 1,16, 8,127,(char*)cyrillic_0476},
{ 0x0477, 1,16, 8,127,(char*)cyrillic_0477},
{ 0x0478, 1,16, 8,127,(char*)cyrillic_0478},
{ 0x0479, 1,16, 8,127,(char*)cyrillic_0479},
{ 0x047a, 1,16, 8,127,(char*)cyrillic_047a},
{ 0x047b, 1,16, 8,127,(char*)cyrillic_047b},
{ 0x047c, 1,16, 8,127,(char*)cyrillic_047c},
{ 0x047d, 1,16, 8,127,(char*)cyrillic_047d},
{ 0x047e, 1,16, 8,127,(char*)cyrillic_047e},
{ 0x047f, 1,16, 8,127,(char*)cyrillic_047f},
{ 0x0480, 1,16, 8,127,(char*)cyrillic_0480},
{ 0x0481, 1,16, 8,127,(char*)cyrillic_0481},
{ 0x0482, 1,16, 8,127,(char*)cyrillic_0482},
{ 0x048a, 1,16, 8,127,(char*)cyrillic_048a},
{ 0x048b, 1,16, 8,127,(char*)cyrillic_048b},
{ 0x048c, 1,16, 8,127,(char*)cyrillic_048c},
{ 0x048d, 1,16, 8,127,(char*)cyrillic_048d},
{ 0x048e, 1,16, 8,127,(char*)cyrillic_048e},
{ 0x048f, 1,16, 8,127,(char*)cyrillic_048f},
{ 0x0490, 1,16, 8,127,(char*)cyrillic_0490},
{ 0x0491, 1,16, 8,127,(char*)cyrillic_0491},
{ 0x0492, 1,16, 8,127,(char*)cyrillic_0492},
{ 0x0493, 1,16, 8,127,(char*)cyrillic_0493},
{ 0x0494, 1,16, 8,127,(char*)cyrillic_0494},
{ 0x0495, 1,16, 8,127,(char*)cyrillic_0495},
{ 0x0496, 1,16, 8,127,(char*)cyrillic_0496},
{ 0x0497, 1,16, 8,127,(char*)cyrillic_0497},
{ 0x0498, 1,16, 8,127,(char*)cyrillic_0498},
{ 0x0499, 1,16, 8,127,(char*)cyrillic_0499},
{ 0x049a, 1,16, 8,127,(char*)cyrillic_049a},
{ 0x049b, 1,16, 8,127,(char*)cyrillic_049b},
{ 0x049c, 1,16, 8,127,(char*)cyrillic_049c},
{ 0x049d, 1,16, 8,127,(char*)cyrillic_049d},
{ 0x049e, 1,16, 8,127,(char*)cyrillic_049e},
{ 0x049f, 1,16, 8,127,(char*)cyrillic_049f},
{ 0x04a0, 1,16, 8,127,(char*)cyrillic_04a0},
{ 0x04a1, 1,16, 8,127,(char*)cyrillic_04a1},
{ 0x04a2, 1,16, 8,127,(char*)cyrillic_04a2},
{ 0x04a3, 1,16, 8,127,(char*)cyrillic_04a3},
{ 0x04a4, 1,16, 8,127,(char*)cyrillic_04a4},
{ 0x04a5, 1,16, 8,127,(char*)cyrillic_04a5},
{ 0x04a6, 1,16, 8,127,(char*)cyrillic_04a6},
{ 0x04a7, 1,16, 8,127,(char*)cyrillic_04a7},
{ 0x04a8, 1,16, 8,127,(char*)cyrillic_04a8},
{ 0x04a9, 1,16, 8,127,(char*)cyrillic_04a9},
{ 0x04aa, 1,16, 8,127,(char*)cyrillic_04aa},
{ 0x04ab, 1,16, 8,127,(char*)cyrillic_04ab},
{ 0x04ac, 1,16, 8,127,(char*)cyrillic_04ac},
{ 0x04ad, 1,16, 8,127,(char*)cyrillic_04ad},
{ 0x04ae, 1,16, 8,127,(char*)cyrillic_04ae},
{ 0x04af, 1,16, 8,127,(char*)cyrillic_04af},
{ 0x04b0, 1,16, 8,127,(char*)cyrillic_04b0},
{ 0x04b1, 1,16, 8,127,(char*)cyrillic_04b1},
{ 0x04b2, 1,16, 8,127,(char*)cyrillic_04b2},
{ 0x04b3, 1,16, 8,127,(char*)cyrillic_04b3},
{ 0x04b4, 1,16, 8,127,(char*)cyrillic_04b4},
{ 0x04b5, 1,16, 8,127,(char*)cyrillic_04b5},
{ 0x04b6, 1,16, 8,127,(char*)cyrillic_04b6},
{ 0x04b7, 1,16, 8,127,(char*)cyrillic_04b7},
{ 0x04b8, 1,16, 8,127,(char*)cyrillic_04b8},
{ 0x04b9, 1,16, 8,127,(char*)cyrillic_04b9},
{ 0x04ba, 1,16, 8,127,(char*)cyrillic_04ba},
{ 0x04bb, 1,16, 8,127,(char*)cyrillic_04bb},
{ 0x04bc, 1,16, 8,127,(char*)cyrillic_04bc},
{ 0x04bd, 1,16, 8,127,(char*)cyrillic_04bd},
{ 0x04be, 1,16, 8,127,(char*)cyrillic_04be},
{ 0x04bf, 1,16, 8,127,(char*)cyrillic_04bf},
{ 0x04c0, 1,16, 8,127,(char*)cyrillic_04c0},
{ 0x04c1, 1,16, 8,127,(char*)cyrillic_04c1},
{ 0x04c2, 1,16, 8,127,(char*)cyrillic_04c2},
{ 0x04c3, 1,16, 8,127,(char*)cyrillic_04c3},
{ 0x04c4, 1,16, 8,127,(char*)cyrillic_04c4},
{ 0x04c5, 1,16, 8,127,(char*)cyrillic_04c5},
{ 0x04c6, 1,16, 8,127,(char*)cyrillic_04c6},
{ 0x04c7, 1,16, 8,127,(char*)cyrillic_04c7},
{ 0x04c8, 1,16, 8,127,(char*)cyrillic_04c8},
{ 0x04c9, 1,16, 8,127,(char*)cyrillic_04c9},
{ 0x04ca, 1,16, 8,127,(char*)cyrillic_04ca},
{ 0x04cb, 1,16, 8,127,(char*)cyrillic_04cb},
{ 0x04cc, 1,16, 8,127,(char*)cyrillic_04cc},
{ 0x04cd, 1,16, 8,127,(char*)cyrillic_04cd},
{ 0x04ce, 1,16, 8,127,(char*)cyrillic_04ce},
{ 0x04d0, 1,16, 8,127,(char*)cyrillic_04d0},
{ 0x04d1, 1,16, 8,127,(char*)cyrillic_04d1},
{ 0x04d2, 1,16, 8,127,(char*)cyrillic_04d2},
{ 0x04d3, 1,16, 8,127,(char*)cyrillic_04d3},
{ 0x04d4, 1,16, 8,127,(char*)cyrillic_04d4},
{ 0x04d5, 1,16, 8,127,(char*)cyrillic_04d5},
{ 0x04d6, 1,16, 8,127,(char*)cyrillic_04d6},
{ 0x04d7, 1,16, 8,127,(char*)cyrillic_04d7},
{ 0x04d8, 1,16, 8,127,(char*)cyrillic_04d8},
{ 0x04d9, 1,16, 8,127,(char*)cyrillic_04d9},
{ 0x04da, 1,16, 8,127,(char*)cyrillic_04da},
{ 0x04db, 1,16, 8,127,(char*)cyrillic_04db},
{ 0x04dc, 1,16, 8,127,(char*)cyrillic_04dc},
{ 0x04dd, 1,16, 8,127,(char*)cyrillic_04dd},
{ 0x04de, 1,16, 8,127,(char*)cyrillic_04de},
{ 0x04df, 1,16, 8,127,(char*)cyrillic_04df},
{ 0x04e0, 1,16, 8,127,(char*)cyrillic_04e0},
{ 0x04e1, 1,16, 8,127,(char*)cyrillic_04e1},
{ 0x04e2, 1,16, 8,127,(char*)cyrillic_04e2},
{ 0x04e3, 1,16, 8,127,(char*)cyrillic_04e3},
{ 0x04e4, 1,16, 8,127,(char*)cyrillic_04e4},
{ 0x04e5, 1,16, 8,127,(char*)cyrillic_04e5},
{ 0x04e6, 1,16, 8,127,(char*)cyrillic_04e6},
{ 0x04e7, 1,16, 8,127,(char*)cyrillic_04e7},
{ 0x04e8, 1,16, 8,127,(char*)cyrillic_04e8},
{ 0x04e9, 1,16, 8,127,(char*)cyrillic_04e9},
{ 0x04ea, 1,16, 8,127,(char*)cyrillic_04ea},
{ 0x04eb, 1,16, 8,127,(char*)cyrillic_04eb},
{ 0x04ec, 1,16, 8,127,(char*)cyrillic_04ec},
{ 0x04ed, 1,16, 8,127,(char*)cyrillic_04ed},
{ 0x04ee, 1,16, 8,127,(char*)cyrillic_04ee},
{ 0x04ef, 1,16, 8,127,(char*)cyrillic_04ef},
{ 0x04f0, 1,16, 8,127,(char*)cyrillic_04f0},
{ 0x04f1, 1,16, 8,127,(char*)cyrillic_04f1},
{ 0x04f2, 1,16, 8,127,(char*)cyrillic_04f2},
{ 0x04f3, 1,16, 8,127,(char*)cyrillic_04f3},
{ 0x04f4, 1,16, 8,127,(char*)cyrillic_04f4},
{ 0x04f5, 1,16, 8,127,(char*)cyrillic_04f5},
{ 0x04f6, 1,16, 8,127,(char*)cyrillic_04f6},
{ 0x04f7, 1,16, 8,127,(char*)cyrillic_04f7},
{ 0x04f8, 1,16, 8,127,(char*)cyrillic_04f8},
{ 0x04f9, 1,16, 8,127,(char*)cyrillic_04f9},
#endif /* !defined MMI_LITE && defined CHINESE_MMI */
//May 12, 2006 DR:OMAPS00075405 end

{ 0x2013, 1,15, 7,255,(char*)BMP_Chant_8211},
{ 0x2014, 1,15,14,255,(char*)BMP_Chant_8212},
{ 0x2018, 1,15, 2,255,(char*)BMP_Chant_8216},
{ 0x2019, 1,15, 2,255,(char*)BMP_Chant_8217},
{ 0x201A, 1,15, 3,255,(char*)BMP_Chant_8218},
{ 0x201C, 1,15, 4,255,(char*)BMP_Chant_8220},
{ 0x201D, 1,15, 4,255,(char*)BMP_Chant_8221},
{ 0x201E, 1,15, 5,255,(char*)BMP_Chant_8222},
{ 0x2022, 1,15, 3,255,(char*)BMP_Chant_8226},
{ 0x2026, 1,15, 6,255,(char*)BMP_Chant_8230},
{ 0x2039, 1,15, 3,255,(char*)BMP_Chant_8249},
{ 0x203A, 1,15, 3,255,(char*)BMP_Chant_8250},

{0xFFFF,1,12,12,24, (char *) uc2_rubbish} };
#endif /*FF_ENDURANCE_FONT*/ //x0pleela 09 Nov, 2006 ER: OMAPS00099966
#endif

static int currentFont=0;
USHORT font_setFont( USHORT fontId )
{
	USHORT oldFont = currentFont;
	currentFont = fontId;
	return (oldFont);
}
USHORT font_getFont( void )
{
	return (currentFont);
}


#ifndef LSCREEN
static t_font_bitmap* get_bitmap_font0(USHORT selected_code)
{
	USHORT offset = NUM_BITMAPS_FONT0/2;
	USHORT position;
	USHORT high;
	int low=0;

	high = NUM_BITMAPS_FONT0-1;
	if ((selected_code <256) && (selected_code<NUM_BITMAPS_FONT0))
		position = selected_code;
	else
		position = NUM_BITMAPS_FONT0/2 + low;
	while ((high-low)>1)
	{
		if (selected_code == database0[position].code)
			return (t_font_bitmap*)&database0[position];
		else
		{
			if (selected_code > database0[position].code)
			{
				low = position;
				position = (high+low)/2;
			}
			else
			{
				high = position;
				position = (high-low)/2;
			}
		}
	}
	if (selected_code == database0[high].code)
		return (t_font_bitmap*)&database0[high];
	else if (selected_code == database0[low].code)
		return (t_font_bitmap*)&database0[low];
	else
		return NULL;
}

#else /*LSCREEN defined*/

#if 0 //Using Arial-type may be problematic - disable

static t_font_bitmap* get_bitmap_font_arial(USHORT selected_code)
{
	USHORT offset = NUM_BITMAPS_FONT1/2;
	USHORT position;
	USHORT high;
	int low=0;

	high = NUM_BITMAPS_FONT1-1;
	if ((selected_code <256) && (selected_code<NUM_BITMAPS_FONT1))
		position = selected_code;
	else
		position = NUM_BITMAPS_FONT1/2 + low;
	while ((high-low)>1)
	{
		if (selected_code == database1[position].code)
			return (t_font_bitmap*)&database1[position];
		else
		{
			if (selected_code > database1[position].code)
			{
				low = position;
				position = (high+low)/2;
			}
			else
			{
				high = position;
				position = (high-low)/2;
			}
		}
	}
	if (selected_code == database1[high].code)
		return (t_font_bitmap*)&database1[high];
	else if (selected_code == database1[low].code)
		return (t_font_bitmap*)&database1[low];
	else
		return NULL;
}
#endif 
static t_font_bitmap* get_bitmap_font_chanticle(USHORT selected_code)
{
	
	USHORT position;
	USHORT high;
	int low=0;

	high = NUM_BITMAPS_FONT3-1;
	if ((selected_code <256) && (selected_code<NUM_BITMAPS_FONT3))
		position = selected_code;
	else
		position = NUM_BITMAPS_FONT3/2 + low;
	while ((high-low)>1)
	{
		if (selected_code == database3[position].code)
			return (t_font_bitmap*)&database3[position];
		else
		{
			if (selected_code > database3[position].code)
			{
				low = position;
				position = (high+low)/2;
			}
			else
			{
				high = position;
				position = (high-low)/2;
			}
		}
	}
	if (selected_code == database3[high].code)
		return (t_font_bitmap*)&database3[high];
	else if (selected_code == database3[low].code)
		return (t_font_bitmap*)&database3[low];
	else
		return NULL;
}
#endif

#ifdef CHINESE_MMI

/* 
GW - Added procedure to allow us to automatically check that font data is in the right order
	and the correct number of definitions are present. Procedure returns 0 if data is correct.
*/
int check_chinese_order( void )
{
	int i;
	unsigned int lastCode=chinese_chars[0].code;
	//Are any out of order?
	for (i=1;i<NUM_BITMAPS_CHINESE_FONT;i++)
	{
		if (lastCode >= chinese_chars[i].code)
			return (lastCode);
		lastCode = chinese_chars[i].code;
	}
	//Have we the right number of bitmaps?
	if (chinese_chars[NUM_BITMAPS_CHINESE_FONT-1].code != 0xFFFF)
		return (-1);
	return (0);
}

/*MC, SPR 1319, added function to retrieve chinese bitmaps*/

static t_font_bitmap* get_chinese_bitmap(USHORT selected_code)
{
	
	USHORT position;
	USHORT high;
	int low=0;

	high =  NUM_BITMAPS_CHINESE_FONT-1;
	
		position =  NUM_BITMAPS_CHINESE_FONT/2 + low;
	while ((high-low)>1)
	{
		if (selected_code == chinese_chars[position].code)
			return (t_font_bitmap*)&chinese_chars[position];
		else
		{
			if (selected_code > chinese_chars[position].code)
			{
				low = position;
				position = (high+low)/2;
			}
			else
			{
				high = position;
				position = (high-low)/2;
			}
		}
	}
	if (selected_code == chinese_chars[high].code)
		return (t_font_bitmap*)&chinese_chars[high];
	else if (selected_code == chinese_chars[low].code)
		return (t_font_bitmap*)&chinese_chars[low];
//	if ((selected_code>0x4E00) && (selected_code<0x9FFF))
//		return (t_font_bitmap*)&chinese_chars[NUM_BITMAPS_CHINESE_FONT-1];	
	else
		return NULL;
}
#endif

t_font_bitmap* get_bitmap(USHORT selected_code)
{
	USHORT font;
	font = font_getFont();
#ifdef CHINESE_MMI
	/*MC SPR 1508, check if chinese char*/
	if (selected_code >= 0x4E00)
	{
		{	//get chinese font bitmap
			return(get_chinese_bitmap(selected_code));
		}
	
	}
#endif	
	switch (font)
	{
#ifndef LSCREEN
case DEFAULT_8x6:
default:
		return(get_bitmap_font0(selected_code));
		break;
#else
case CHANTICLE_PROP15:/*a0393213 warnings removal-case statement put before default statement*/
default:	
		return(get_bitmap_font_chanticle(selected_code));
		/*break;*/
#if 0 //Using Arial-type may be problematic - disable
case ARIAL_PROP15:
		return(get_bitmap_font_arial(selected_code));
		break;
#endif
#endif
	}
	
}

USHORT font_getCharWidth(USHORT selected_code)
{ /*we should get the width each time, but for speed..*/
t_font_bitmap* chrbitmap;
	if (selected_code >= 0x4E00)
		return (12);
#ifndef LSCREEN
	else if (font_getFont()==DEFAULT_8x6)
		return (6);
#endif
	chrbitmap = get_bitmap(selected_code);
	/* SPR#2135 - SH - Return 12 if character unknown */
	if (chrbitmap)
	{
		return (chrbitmap->width); 
	}
	else
	{
		return 12;
	}
}

void font_initFont(int defaultFont)
{
	font_setFont(defaultFont);
}

/* SPR#1983 - SH - Get list of all ascii font widths in array */

void font_getAllAsciiWidths(UBYTE *width)
{
	USHORT charIndex;
	
	for (charIndex = 0; charIndex<256; charIndex++)
	{
		width[charIndex] = (UBYTE)font_getCharWidth(charIndex);
	}

	return;
}


